//===- TableGen'erated file -------------------------------------*- C++ -*-===//
//
// DAG Instruction Selector for the X86 target
//
// Automatically generated file, do not edit!
//
//===----------------------------------------------------------------------===//

// *** NOTE: This file is #included into the middle of the target
// *** instruction selector class.  These functions are really methods.


// Predicate functions.
inline bool Predicate_alignedload(SDNode *N) const {

  return cast<LoadSDNode>(N)->getAlignment() >= 16;

}
inline bool Predicate_alignednontemporalstore(SDNode *N) const {

  if (StoreSDNode *ST = dyn_cast<StoreSDNode>(N))
    return ST->isNonTemporal() && !ST->isTruncatingStore() &&
           ST->getAddressingMode() == ISD::UNINDEXED &&
           ST->getAlignment() >= 16;
  return false;

}
inline bool Predicate_alignedstore(SDNode *N) const {

  return cast<StoreSDNode>(N)->getAlignment() >= 16;

}
inline bool Predicate_and_su(SDNode *N) const {

  return N->hasOneUse();

}
inline bool Predicate_atomic_cmp_swap_16(SDNode *N) const {

  return cast<AtomicSDNode>(N)->getMemoryVT() == MVT::i16;

}
inline bool Predicate_atomic_cmp_swap_32(SDNode *N) const {

  return cast<AtomicSDNode>(N)->getMemoryVT() == MVT::i32;

}
inline bool Predicate_atomic_cmp_swap_64(SDNode *N) const {

  return cast<AtomicSDNode>(N)->getMemoryVT() == MVT::i64;

}
inline bool Predicate_atomic_cmp_swap_8(SDNode *N) const {

  return cast<AtomicSDNode>(N)->getMemoryVT() == MVT::i8;

}
inline bool Predicate_atomic_load_add_16(SDNode *N) const {

    return cast<AtomicSDNode>(N)->getMemoryVT() == MVT::i16;
  
}
inline bool Predicate_atomic_load_add_32(SDNode *N) const {

    return cast<AtomicSDNode>(N)->getMemoryVT() == MVT::i32;
  
}
inline bool Predicate_atomic_load_add_64(SDNode *N) const {

    return cast<AtomicSDNode>(N)->getMemoryVT() == MVT::i64;
  
}
inline bool Predicate_atomic_load_add_8(SDNode *N) const {

    return cast<AtomicSDNode>(N)->getMemoryVT() == MVT::i8;
  
}
inline bool Predicate_atomic_load_and_16(SDNode *N) const {

    return cast<AtomicSDNode>(N)->getMemoryVT() == MVT::i16;
  
}
inline bool Predicate_atomic_load_and_32(SDNode *N) const {

    return cast<AtomicSDNode>(N)->getMemoryVT() == MVT::i32;
  
}
inline bool Predicate_atomic_load_and_64(SDNode *N) const {

    return cast<AtomicSDNode>(N)->getMemoryVT() == MVT::i64;
  
}
inline bool Predicate_atomic_load_and_8(SDNode *N) const {

    return cast<AtomicSDNode>(N)->getMemoryVT() == MVT::i8;
  
}
inline bool Predicate_atomic_load_max_16(SDNode *N) const {

    return cast<AtomicSDNode>(N)->getMemoryVT() == MVT::i16;
  
}
inline bool Predicate_atomic_load_max_32(SDNode *N) const {

    return cast<AtomicSDNode>(N)->getMemoryVT() == MVT::i32;
  
}
inline bool Predicate_atomic_load_max_64(SDNode *N) const {

    return cast<AtomicSDNode>(N)->getMemoryVT() == MVT::i64;
  
}
inline bool Predicate_atomic_load_max_8(SDNode *N) const {

    return cast<AtomicSDNode>(N)->getMemoryVT() == MVT::i8;
  
}
inline bool Predicate_atomic_load_min_16(SDNode *N) const {

    return cast<AtomicSDNode>(N)->getMemoryVT() == MVT::i16;
  
}
inline bool Predicate_atomic_load_min_32(SDNode *N) const {

    return cast<AtomicSDNode>(N)->getMemoryVT() == MVT::i32;
  
}
inline bool Predicate_atomic_load_min_64(SDNode *N) const {

    return cast<AtomicSDNode>(N)->getMemoryVT() == MVT::i64;
  
}
inline bool Predicate_atomic_load_min_8(SDNode *N) const {

    return cast<AtomicSDNode>(N)->getMemoryVT() == MVT::i8;
  
}
inline bool Predicate_atomic_load_nand_16(SDNode *N) const {

    return cast<AtomicSDNode>(N)->getMemoryVT() == MVT::i16;
  
}
inline bool Predicate_atomic_load_nand_32(SDNode *N) const {

    return cast<AtomicSDNode>(N)->getMemoryVT() == MVT::i32;
  
}
inline bool Predicate_atomic_load_nand_64(SDNode *N) const {

    return cast<AtomicSDNode>(N)->getMemoryVT() == MVT::i64;
  
}
inline bool Predicate_atomic_load_nand_8(SDNode *N) const {

    return cast<AtomicSDNode>(N)->getMemoryVT() == MVT::i8;
  
}
inline bool Predicate_atomic_load_or_16(SDNode *N) const {

    return cast<AtomicSDNode>(N)->getMemoryVT() == MVT::i16;
  
}
inline bool Predicate_atomic_load_or_32(SDNode *N) const {

    return cast<AtomicSDNode>(N)->getMemoryVT() == MVT::i32;
  
}
inline bool Predicate_atomic_load_or_64(SDNode *N) const {

    return cast<AtomicSDNode>(N)->getMemoryVT() == MVT::i64;
  
}
inline bool Predicate_atomic_load_or_8(SDNode *N) const {

    return cast<AtomicSDNode>(N)->getMemoryVT() == MVT::i8;
  
}
inline bool Predicate_atomic_load_sub_16(SDNode *N) const {

    return cast<AtomicSDNode>(N)->getMemoryVT() == MVT::i16;
  
}
inline bool Predicate_atomic_load_sub_32(SDNode *N) const {

    return cast<AtomicSDNode>(N)->getMemoryVT() == MVT::i32;
  
}
inline bool Predicate_atomic_load_sub_64(SDNode *N) const {

    return cast<AtomicSDNode>(N)->getMemoryVT() == MVT::i64;
  
}
inline bool Predicate_atomic_load_sub_8(SDNode *N) const {

    return cast<AtomicSDNode>(N)->getMemoryVT() == MVT::i8;
  
}
inline bool Predicate_atomic_load_umax_16(SDNode *N) const {

    return cast<AtomicSDNode>(N)->getMemoryVT() == MVT::i16;
  
}
inline bool Predicate_atomic_load_umax_32(SDNode *N) const {

    return cast<AtomicSDNode>(N)->getMemoryVT() == MVT::i32;
  
}
inline bool Predicate_atomic_load_umax_64(SDNode *N) const {

    return cast<AtomicSDNode>(N)->getMemoryVT() == MVT::i64;
  
}
inline bool Predicate_atomic_load_umax_8(SDNode *N) const {

    return cast<AtomicSDNode>(N)->getMemoryVT() == MVT::i8;
  
}
inline bool Predicate_atomic_load_umin_16(SDNode *N) const {

    return cast<AtomicSDNode>(N)->getMemoryVT() == MVT::i16;
  
}
inline bool Predicate_atomic_load_umin_32(SDNode *N) const {

    return cast<AtomicSDNode>(N)->getMemoryVT() == MVT::i32;
  
}
inline bool Predicate_atomic_load_umin_64(SDNode *N) const {

    return cast<AtomicSDNode>(N)->getMemoryVT() == MVT::i64;
  
}
inline bool Predicate_atomic_load_umin_8(SDNode *N) const {

    return cast<AtomicSDNode>(N)->getMemoryVT() == MVT::i8;
  
}
inline bool Predicate_atomic_load_xor_16(SDNode *N) const {

    return cast<AtomicSDNode>(N)->getMemoryVT() == MVT::i16;
  
}
inline bool Predicate_atomic_load_xor_32(SDNode *N) const {

    return cast<AtomicSDNode>(N)->getMemoryVT() == MVT::i32;
  
}
inline bool Predicate_atomic_load_xor_64(SDNode *N) const {

    return cast<AtomicSDNode>(N)->getMemoryVT() == MVT::i64;
  
}
inline bool Predicate_atomic_load_xor_8(SDNode *N) const {

    return cast<AtomicSDNode>(N)->getMemoryVT() == MVT::i8;
  
}
inline bool Predicate_atomic_swap_16(SDNode *N) const {

    return cast<AtomicSDNode>(N)->getMemoryVT() == MVT::i16;
  
}
inline bool Predicate_atomic_swap_32(SDNode *N) const {

    return cast<AtomicSDNode>(N)->getMemoryVT() == MVT::i32;
  
}
inline bool Predicate_atomic_swap_64(SDNode *N) const {

    return cast<AtomicSDNode>(N)->getMemoryVT() == MVT::i64;
  
}
inline bool Predicate_atomic_swap_8(SDNode *N) const {

    return cast<AtomicSDNode>(N)->getMemoryVT() == MVT::i8;
  
}
inline bool Predicate_cvtff(SDNode *N) const {

       return cast<CvtRndSatSDNode>(N)->getCvtCode() == ISD::CVT_FF;
    
}
inline bool Predicate_cvtfs(SDNode *N) const {

       return cast<CvtRndSatSDNode>(N)->getCvtCode() == ISD::CVT_FS;
    
}
inline bool Predicate_cvtfu(SDNode *N) const {

       return cast<CvtRndSatSDNode>(N)->getCvtCode() == ISD::CVT_FU;
    
}
inline bool Predicate_cvtsf(SDNode *N) const {

       return cast<CvtRndSatSDNode>(N)->getCvtCode() == ISD::CVT_SF;
    
}
inline bool Predicate_cvtss(SDNode *N) const {

       return cast<CvtRndSatSDNode>(N)->getCvtCode() == ISD::CVT_SS;
    
}
inline bool Predicate_cvtsu(SDNode *N) const {

       return cast<CvtRndSatSDNode>(N)->getCvtCode() == ISD::CVT_SU;
    
}
inline bool Predicate_cvtuf(SDNode *N) const {

       return cast<CvtRndSatSDNode>(N)->getCvtCode() == ISD::CVT_UF;
    
}
inline bool Predicate_cvtus(SDNode *N) const {

       return cast<CvtRndSatSDNode>(N)->getCvtCode() == ISD::CVT_US;
    
}
inline bool Predicate_cvtuu(SDNode *N) const {

       return cast<CvtRndSatSDNode>(N)->getCvtCode() == ISD::CVT_UU;
    
}
inline bool Predicate_def32(SDNode *N) const {

  return N->getOpcode() != ISD::TRUNCATE &&
         N->getOpcode() != TargetOpcode::EXTRACT_SUBREG &&
         N->getOpcode() != ISD::CopyFromReg &&
         N->getOpcode() != X86ISD::CMOV;

}
inline bool Predicate_dsload(SDNode *N) const {

  if (const Value *Src = cast<LoadSDNode>(N)->getSrcValue())
    if (const PointerType *PT = dyn_cast<PointerType>(Src->getType()))
      if (PT->getAddressSpace() > 255)
        return false;
  return true;

}
inline bool Predicate_extload(SDNode *N) const {

  return cast<LoadSDNode>(N)->getExtensionType() == ISD::EXTLOAD;

}
inline bool Predicate_extloadf32(SDNode *N) const {

  return cast<LoadSDNode>(N)->getMemoryVT() == MVT::f32;

}
inline bool Predicate_extloadf64(SDNode *N) const {

  return cast<LoadSDNode>(N)->getMemoryVT() == MVT::f64;

}
inline bool Predicate_extloadi1(SDNode *N) const {

  return cast<LoadSDNode>(N)->getMemoryVT() == MVT::i1;

}
inline bool Predicate_extloadi16(SDNode *N) const {

  return cast<LoadSDNode>(N)->getMemoryVT() == MVT::i16;

}
inline bool Predicate_extloadi32(SDNode *N) const {

  return cast<LoadSDNode>(N)->getMemoryVT() == MVT::i32;

}
inline bool Predicate_extloadi8(SDNode *N) const {

  return cast<LoadSDNode>(N)->getMemoryVT() == MVT::i8;

}
inline bool Predicate_fp32imm0(SDNode *inN) const {
  ConstantFPSDNode *N = cast<ConstantFPSDNode>(inN);

  return N->isExactlyValue(+0.0);

}
inline bool Predicate_fpimm0(SDNode *inN) const {
  ConstantFPSDNode *N = cast<ConstantFPSDNode>(inN);

  return N->isExactlyValue(+0.0);

}
inline bool Predicate_fpimm1(SDNode *inN) const {
  ConstantFPSDNode *N = cast<ConstantFPSDNode>(inN);

  return N->isExactlyValue(+1.0);

}
inline bool Predicate_fpimmneg0(SDNode *inN) const {
  ConstantFPSDNode *N = cast<ConstantFPSDNode>(inN);

  return N->isExactlyValue(-0.0);

}
inline bool Predicate_fpimmneg1(SDNode *inN) const {
  ConstantFPSDNode *N = cast<ConstantFPSDNode>(inN);

  return N->isExactlyValue(-1.0);

}
inline bool Predicate_fsload(SDNode *N) const {

  if (const Value *Src = cast<LoadSDNode>(N)->getSrcValue())
    if (const PointerType *PT = dyn_cast<PointerType>(Src->getType()))
      return PT->getAddressSpace() == 257;
  return false;

}
inline bool Predicate_gsload(SDNode *N) const {

  if (const Value *Src = cast<LoadSDNode>(N)->getSrcValue())
    if (const PointerType *PT = dyn_cast<PointerType>(Src->getType()))
      return PT->getAddressSpace() == 256;
  return false;

}
inline bool Predicate_i64immSExt32(SDNode *inN) const {
  ConstantSDNode *N = cast<ConstantSDNode>(inN);

  // i64immSExt32 predicate - True if the 64-bit immediate fits in a 32-bit
  // sign extended field.
  return (int64_t)N->getZExtValue() == (int32_t)N->getZExtValue();

}
inline bool Predicate_i64immZExt32(SDNode *inN) const {
  ConstantSDNode *N = cast<ConstantSDNode>(inN);

  // i64immZExt32 predicate - True if the 64-bit immediate fits in a 32-bit
  // unsignedsign extended field.
  return (uint64_t)N->getZExtValue() == (uint32_t)N->getZExtValue();

}
inline bool Predicate_immAllOnesV(SDNode *N) const {

  return ISD::isBuildVectorAllOnes(N);

}
inline bool Predicate_immAllOnesV_bc(SDNode *N) const {

  return ISD::isBuildVectorAllOnes(N);

}
inline bool Predicate_immAllZerosV(SDNode *N) const {

  return ISD::isBuildVectorAllZeros(N);

}
inline bool Predicate_immAllZerosV_bc(SDNode *N) const {

  return ISD::isBuildVectorAllZeros(N);

}
inline bool Predicate_immSext8(SDNode *inN) const {
  ConstantSDNode *N = cast<ConstantSDNode>(inN);

  return N->getSExtValue() == (int8_t)N->getSExtValue();

}
inline bool Predicate_istore(SDNode *N) const {

  return !cast<StoreSDNode>(N)->isTruncatingStore();

}
inline bool Predicate_itruncstore(SDNode *N) const {

  return cast<StoreSDNode>(N)->isTruncatingStore();

}
inline bool Predicate_load(SDNode *N) const {

  return cast<LoadSDNode>(N)->getExtensionType() == ISD::NON_EXTLOAD;

}
inline bool Predicate_loadi16(SDNode *N) const {

  LoadSDNode *LD = cast<LoadSDNode>(N);
  if (const Value *Src = LD->getSrcValue())
    if (const PointerType *PT = dyn_cast<PointerType>(Src->getType()))
      if (PT->getAddressSpace() > 255)
        return false;
  ISD::LoadExtType ExtType = LD->getExtensionType();
  if (ExtType == ISD::NON_EXTLOAD)
    return true;
  if (ExtType == ISD::EXTLOAD)
    return LD->getAlignment() >= 2 && !LD->isVolatile();
  return false;

}
inline bool Predicate_loadi16_anyext(SDNode *N) const {

  LoadSDNode *LD = cast<LoadSDNode>(N);
  if (const Value *Src = LD->getSrcValue())
    if (const PointerType *PT = dyn_cast<PointerType>(Src->getType()))
      if (PT->getAddressSpace() > 255)
        return false;
  ISD::LoadExtType ExtType = LD->getExtensionType();
  if (ExtType == ISD::EXTLOAD)
    return LD->getAlignment() >= 2 && !LD->isVolatile();
  return false;

}
inline bool Predicate_loadi32(SDNode *N) const {

  LoadSDNode *LD = cast<LoadSDNode>(N);
  if (const Value *Src = LD->getSrcValue())
    if (const PointerType *PT = dyn_cast<PointerType>(Src->getType()))
      if (PT->getAddressSpace() > 255)
        return false;
  ISD::LoadExtType ExtType = LD->getExtensionType();
  if (ExtType == ISD::NON_EXTLOAD)
    return true;
  if (ExtType == ISD::EXTLOAD)
    return LD->getAlignment() >= 4 && !LD->isVolatile();
  return false;

}
inline bool Predicate_memop(SDNode *N) const {

  return    Subtarget->hasVectorUAMem()
         || cast<LoadSDNode>(N)->getAlignment() >= 16;

}
inline bool Predicate_memop64(SDNode *N) const {

  return cast<LoadSDNode>(N)->getAlignment() >= 8;

}
inline bool Predicate_mmx_pshufw(SDNode *N) const {

  return X86::isPSHUFDMask(cast<ShuffleVectorSDNode>(N));

}
inline bool Predicate_mmx_unpckh(SDNode *N) const {

  return X86::isUNPCKHMask(cast<ShuffleVectorSDNode>(N));

}
inline bool Predicate_mmx_unpckh_undef(SDNode *N) const {

  return X86::isUNPCKH_v_undef_Mask(cast<ShuffleVectorSDNode>(N));

}
inline bool Predicate_mmx_unpckl(SDNode *N) const {

  return X86::isUNPCKLMask(cast<ShuffleVectorSDNode>(N));

}
inline bool Predicate_mmx_unpckl_undef(SDNode *N) const {

  return X86::isUNPCKL_v_undef_Mask(cast<ShuffleVectorSDNode>(N));

}
inline bool Predicate_movddup(SDNode *N) const {

  return X86::isMOVDDUPMask(cast<ShuffleVectorSDNode>(N));

}
inline bool Predicate_movhlps(SDNode *N) const {

  return X86::isMOVHLPSMask(cast<ShuffleVectorSDNode>(N));

}
inline bool Predicate_movhlps_undef(SDNode *N) const {

  return X86::isMOVHLPS_v_undef_Mask(cast<ShuffleVectorSDNode>(N));

}
inline bool Predicate_movl(SDNode *N) const {

  return X86::isMOVLMask(cast<ShuffleVectorSDNode>(N));

}
inline bool Predicate_movlhps(SDNode *N) const {

  return X86::isMOVLHPSMask(cast<ShuffleVectorSDNode>(N));

}
inline bool Predicate_movlp(SDNode *N) const {

  return X86::isMOVLPMask(cast<ShuffleVectorSDNode>(N));

}
inline bool Predicate_movshdup(SDNode *N) const {

  return X86::isMOVSHDUPMask(cast<ShuffleVectorSDNode>(N));

}
inline bool Predicate_movsldup(SDNode *N) const {

  return X86::isMOVSLDUPMask(cast<ShuffleVectorSDNode>(N));

}
inline bool Predicate_nontemporalstore(SDNode *N) const {

  if (StoreSDNode *ST = dyn_cast<StoreSDNode>(N))
    return ST->isNonTemporal();
  return false;

}
inline bool Predicate_or_is_add(SDNode *N) const {

  if (ConstantSDNode *CN = dyn_cast<ConstantSDNode>(N->getOperand(1)))
    return CurDAG->MaskedValueIsZero(N->getOperand(0), CN->getAPIntValue());
  else {
    unsigned BitWidth = N->getValueType(0).getScalarType().getSizeInBits();
    APInt Mask = APInt::getAllOnesValue(BitWidth);
    APInt KnownZero0, KnownOne0;
    CurDAG->ComputeMaskedBits(N->getOperand(0), Mask, KnownZero0, KnownOne0, 0);
    APInt KnownZero1, KnownOne1;
    CurDAG->ComputeMaskedBits(N->getOperand(1), Mask, KnownZero1, KnownOne1, 0);
    return (~KnownZero0 & ~KnownZero1) == 0;
  }

}
inline bool Predicate_palign(SDNode *N) const {

  return X86::isPALIGNRMask(cast<ShuffleVectorSDNode>(N));

}
inline bool Predicate_post_store(SDNode *N) const {

  ISD::MemIndexedMode AM = cast<StoreSDNode>(N)->getAddressingMode();
  return AM == ISD::POST_INC || AM == ISD::POST_DEC;

}
inline bool Predicate_post_truncst(SDNode *N) const {

  ISD::MemIndexedMode AM = cast<StoreSDNode>(N)->getAddressingMode();
  return AM == ISD::POST_INC || AM == ISD::POST_DEC;

}
inline bool Predicate_post_truncstf32(SDNode *N) const {

  return cast<StoreSDNode>(N)->getMemoryVT() == MVT::f32;

}
inline bool Predicate_post_truncsti1(SDNode *N) const {

  return cast<StoreSDNode>(N)->getMemoryVT() == MVT::i1;

}
inline bool Predicate_post_truncsti16(SDNode *N) const {

  return cast<StoreSDNode>(N)->getMemoryVT() == MVT::i16;

}
inline bool Predicate_post_truncsti32(SDNode *N) const {

  return cast<StoreSDNode>(N)->getMemoryVT() == MVT::i32;

}
inline bool Predicate_post_truncsti8(SDNode *N) const {

  return cast<StoreSDNode>(N)->getMemoryVT() == MVT::i8;

}
inline bool Predicate_pre_store(SDNode *N) const {

  ISD::MemIndexedMode AM = cast<StoreSDNode>(N)->getAddressingMode();
  return AM == ISD::PRE_INC || AM == ISD::PRE_DEC;

}
inline bool Predicate_pre_truncst(SDNode *N) const {

  ISD::MemIndexedMode AM = cast<StoreSDNode>(N)->getAddressingMode();
  return AM == ISD::PRE_INC || AM == ISD::PRE_DEC;

}
inline bool Predicate_pre_truncstf32(SDNode *N) const {

  return cast<StoreSDNode>(N)->getMemoryVT() == MVT::f32;

}
inline bool Predicate_pre_truncsti1(SDNode *N) const {

  return cast<StoreSDNode>(N)->getMemoryVT() == MVT::i1;

}
inline bool Predicate_pre_truncsti16(SDNode *N) const {

  return cast<StoreSDNode>(N)->getMemoryVT() == MVT::i16;

}
inline bool Predicate_pre_truncsti32(SDNode *N) const {

  return cast<StoreSDNode>(N)->getMemoryVT() == MVT::i32;

}
inline bool Predicate_pre_truncsti8(SDNode *N) const {

  return cast<StoreSDNode>(N)->getMemoryVT() == MVT::i8;

}
inline bool Predicate_pshufd(SDNode *N) const {

  return X86::isPSHUFDMask(cast<ShuffleVectorSDNode>(N));

}
inline bool Predicate_pshufhw(SDNode *N) const {

  return X86::isPSHUFHWMask(cast<ShuffleVectorSDNode>(N));

}
inline bool Predicate_pshuflw(SDNode *N) const {

  return X86::isPSHUFLWMask(cast<ShuffleVectorSDNode>(N));

}
inline bool Predicate_sextload(SDNode *N) const {

  return cast<LoadSDNode>(N)->getExtensionType() == ISD::SEXTLOAD;

}
inline bool Predicate_sextloadi1(SDNode *N) const {

  return cast<LoadSDNode>(N)->getMemoryVT() == MVT::i1;

}
inline bool Predicate_sextloadi16(SDNode *N) const {

  return cast<LoadSDNode>(N)->getMemoryVT() == MVT::i16;

}
inline bool Predicate_sextloadi32(SDNode *N) const {

  return cast<LoadSDNode>(N)->getMemoryVT() == MVT::i32;

}
inline bool Predicate_sextloadi8(SDNode *N) const {

  return cast<LoadSDNode>(N)->getMemoryVT() == MVT::i8;

}
inline bool Predicate_shld(SDNode *N) const {

  assert(N->getOpcode() == ISD::OR);
  return N->getOperand(0).getOpcode() == ISD::SHL &&
         N->getOperand(1).getOpcode() == ISD::SRL &&
         isa<ConstantSDNode>(N->getOperand(0).getOperand(1)) &&
         isa<ConstantSDNode>(N->getOperand(1).getOperand(1)) &&
         N->getOperand(0).getConstantOperandVal(1) ==
         N->getValueSizeInBits(0) - N->getOperand(1).getConstantOperandVal(1);

}
inline bool Predicate_shrd(SDNode *N) const {

  assert(N->getOpcode() == ISD::OR);
  return N->getOperand(0).getOpcode() == ISD::SRL &&
         N->getOperand(1).getOpcode() == ISD::SHL &&
         isa<ConstantSDNode>(N->getOperand(0).getOperand(1)) &&
         isa<ConstantSDNode>(N->getOperand(1).getOperand(1)) &&
         N->getOperand(0).getConstantOperandVal(1) ==
         N->getValueSizeInBits(0) - N->getOperand(1).getConstantOperandVal(1);

}
inline bool Predicate_shufp(SDNode *N) const {

  return X86::isSHUFPMask(cast<ShuffleVectorSDNode>(N));

}
inline bool Predicate_splat_lo(SDNode *N) const {

  ShuffleVectorSDNode *SVOp = cast<ShuffleVectorSDNode>(N);
  return SVOp->isSplat() && SVOp->getSplatIndex() == 0;

}
inline bool Predicate_srl_su(SDNode *N) const {

  return N->hasOneUse();

}
inline bool Predicate_store(SDNode *N) const {

  return !cast<StoreSDNode>(N)->isTruncatingStore();

}
inline bool Predicate_trunc_su(SDNode *N) const {

  return N->hasOneUse();

}
inline bool Predicate_truncstore(SDNode *N) const {

  return cast<StoreSDNode>(N)->isTruncatingStore();

}
inline bool Predicate_truncstoref32(SDNode *N) const {

  return cast<StoreSDNode>(N)->getMemoryVT() == MVT::f32;

}
inline bool Predicate_truncstoref64(SDNode *N) const {

  return cast<StoreSDNode>(N)->getMemoryVT() == MVT::f64;

}
inline bool Predicate_truncstorei16(SDNode *N) const {

  return cast<StoreSDNode>(N)->getMemoryVT() == MVT::i16;

}
inline bool Predicate_truncstorei32(SDNode *N) const {

  return cast<StoreSDNode>(N)->getMemoryVT() == MVT::i32;

}
inline bool Predicate_truncstorei8(SDNode *N) const {

  return cast<StoreSDNode>(N)->getMemoryVT() == MVT::i8;

}
inline bool Predicate_unalignednontemporalstore(SDNode *N) const {

  if (StoreSDNode *ST = dyn_cast<StoreSDNode>(N))
    return ST->isNonTemporal() &&
           ST->getAlignment() < 16;
  return false;

}
inline bool Predicate_unindexedload(SDNode *N) const {

  return cast<LoadSDNode>(N)->getAddressingMode() == ISD::UNINDEXED;

}
inline bool Predicate_unindexedstore(SDNode *N) const {

  return cast<StoreSDNode>(N)->getAddressingMode() == ISD::UNINDEXED;

}
inline bool Predicate_unpckh(SDNode *N) const {

  return X86::isUNPCKHMask(cast<ShuffleVectorSDNode>(N));

}
inline bool Predicate_unpckh_undef(SDNode *N) const {

  return X86::isUNPCKH_v_undef_Mask(cast<ShuffleVectorSDNode>(N));

}
inline bool Predicate_unpckl(SDNode *N) const {

  return X86::isUNPCKLMask(cast<ShuffleVectorSDNode>(N));

}
inline bool Predicate_unpckl_undef(SDNode *N) const {

  return X86::isUNPCKL_v_undef_Mask(cast<ShuffleVectorSDNode>(N));

}
inline bool Predicate_vtFP(SDNode *inN) const {
  VTSDNode *N = cast<VTSDNode>(inN);
 return N->getVT().isFloatingPoint(); 
}
inline bool Predicate_vtInt(SDNode *inN) const {
  VTSDNode *N = cast<VTSDNode>(inN);
 return N->getVT().isInteger(); 
}
inline bool Predicate_zextload(SDNode *N) const {

  return cast<LoadSDNode>(N)->getExtensionType() == ISD::ZEXTLOAD;

}
inline bool Predicate_zextloadi1(SDNode *N) const {

  return cast<LoadSDNode>(N)->getMemoryVT() == MVT::i1;

}
inline bool Predicate_zextloadi16(SDNode *N) const {

  return cast<LoadSDNode>(N)->getMemoryVT() == MVT::i16;

}
inline bool Predicate_zextloadi32(SDNode *N) const {

  return cast<LoadSDNode>(N)->getMemoryVT() == MVT::i32;

}
inline bool Predicate_zextloadi8(SDNode *N) const {

  return cast<LoadSDNode>(N)->getMemoryVT() == MVT::i8;

}


// The main instruction selector code.
SDNode *SelectCode(SDNode *N) {
  // Opcodes are emitted as 2 bytes, TARGET_OPCODE handles this.
  #define TARGET_OPCODE(X) X & 255, unsigned(X) >> 8
  static const unsigned char MatcherTable[] = {
/*0*/     OPC_SwitchOpcode /*139 cases */, 117|128,6|128,1/*17269*/,  ISD::STORE,// ->17274
/*5*/       OPC_RecordMemRef,
/*6*/       OPC_RecordNode,   // #0 = 'st' chained node
/*7*/       OPC_Scope, 43|128,1/*171*/, /*->181*/ // 7 children in Scope
/*10*/        OPC_RecordChild1, // #1 = $src
/*11*/        OPC_Scope, 49, /*->62*/ // 5 children in Scope
/*13*/          OPC_CheckChild1Type, MVT::v4f32,
/*15*/          OPC_RecordChild2, // #2 = $dst
/*16*/          OPC_CheckPredicate, 0, // Predicate_alignednontemporalstore
/*18*/          OPC_Scope, 20, /*->40*/ // 2 children in Scope
/*20*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasSSE1())
/*22*/            OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #3 #4 #5 #6 #7
/*25*/            OPC_EmitMergeInputChains, 1, 0, 
/*28*/            OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVNTPSmr), 0|OPFL_Chain|OPFL_MemRefs,
                      0/*#VTs*/, 6/*#Ops*/, 3, 4, 5, 6, 7, 1, 
                  // Src: (st:isVoid VR128:v4f32:$src, addr:iPTR:$dst)<<P:Predicate_alignednontemporalstore>>
                  // Dst: (MOVNTPSmr:isVoid addr:iPTR:$dst, VR128:v4f32:$src)
/*40*/          /*Scope*/ 20, /*->61*/
/*41*/            OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*43*/            OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #3 #4 #5 #6 #7
/*46*/            OPC_EmitMergeInputChains, 1, 0, 
/*49*/            OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVNTDQmr), 0|OPFL_Chain|OPFL_MemRefs,
                      0/*#VTs*/, 6/*#Ops*/, 3, 4, 5, 6, 7, 1, 
                  // Src: (st:isVoid VR128:v4f32:$src, addr:iPTR:$dst)<<P:Predicate_alignednontemporalstore>>
                  // Dst: (MOVNTDQmr:isVoid addr:iPTR:$dst, VR128:v4f32:$src)
/*61*/          0, /*End of Scope*/
/*62*/        /*Scope*/ 41, /*->104*/
/*63*/          OPC_CheckChild1Type, MVT::v2f64,
/*65*/          OPC_RecordChild2, // #2 = $dst
/*66*/          OPC_CheckPredicate, 0, // Predicate_alignednontemporalstore
/*68*/          OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*70*/          OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #3 #4 #5 #6 #7
/*73*/          OPC_EmitMergeInputChains, 1, 0, 
/*76*/          OPC_Scope, 12, /*->90*/ // 2 children in Scope
/*78*/            OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVNTDQ_64mr), 0|OPFL_Chain|OPFL_MemRefs,
                      0/*#VTs*/, 6/*#Ops*/, 3, 4, 5, 6, 7, 1, 
                  // Src: (st:isVoid VR128:v2f64:$src, addr:iPTR:$dst)<<P:Predicate_alignednontemporalstore>>
                  // Dst: (MOVNTDQ_64mr:isVoid addr:iPTR:$dst, VR128:v2f64:$src)
/*90*/          /*Scope*/ 12, /*->103*/
/*91*/            OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVNTPDmr), 0|OPFL_Chain|OPFL_MemRefs,
                      0/*#VTs*/, 6/*#Ops*/, 3, 4, 5, 6, 7, 1, 
                  // Src: (st:isVoid VR128:v2f64:$src, addr:iPTR:$dst)<<P:Predicate_alignednontemporalstore>>
                  // Dst: (MOVNTPDmr:isVoid addr:iPTR:$dst, VR128:v2f64:$src)
/*103*/         0, /*End of Scope*/
/*104*/       /*Scope*/ 25, /*->130*/
/*105*/         OPC_CheckChild1Type, MVT::i32,
/*107*/         OPC_RecordChild2, // #2 = $dst
/*108*/         OPC_CheckPredicate, 1, // Predicate_nontemporalstore
/*110*/         OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*112*/         OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #3 #4 #5 #6 #7
/*115*/         OPC_EmitMergeInputChains, 1, 0, 
/*118*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVNTImr), 0|OPFL_Chain|OPFL_MemRefs,
                    0/*#VTs*/, 6/*#Ops*/, 3, 4, 5, 6, 7, 1, 
                // Src: (st:isVoid GR32:i32:$src, addr:iPTR:$dst)<<P:Predicate_nontemporalstore>>
                // Dst: (MOVNTImr:isVoid addr:iPTR:$dst, GR32:i32:$src)
/*130*/       /*Scope*/ 25, /*->156*/
/*131*/         OPC_CheckChild1Type, MVT::i64,
/*133*/         OPC_RecordChild2, // #2 = $dst
/*134*/         OPC_CheckPredicate, 1, // Predicate_nontemporalstore
/*136*/         OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*138*/         OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #3 #4 #5 #6 #7
/*141*/         OPC_EmitMergeInputChains, 1, 0, 
/*144*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVNTI_64mr), 0|OPFL_Chain|OPFL_MemRefs,
                    0/*#VTs*/, 6/*#Ops*/, 3, 4, 5, 6, 7, 1, 
                // Src: (st:isVoid GR64:i64:$src, addr:iPTR:$dst)<<P:Predicate_nontemporalstore>>
                // Dst: (MOVNTI_64mr:isVoid addr:iPTR:$dst, GR64:i64:$src)
/*156*/       /*Scope*/ 23, /*->180*/
/*157*/         OPC_CheckChild1Type, MVT::v4i32,
/*159*/         OPC_RecordChild2, // #2 = $dst
/*160*/         OPC_CheckPredicate, 0, // Predicate_alignednontemporalstore
/*162*/         OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #3 #4 #5 #6 #7
/*165*/         OPC_EmitMergeInputChains, 1, 0, 
/*168*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVNTDQmr), 0|OPFL_Chain|OPFL_MemRefs,
                    0/*#VTs*/, 6/*#Ops*/, 1, 3, 4, 5, 6, 7, 
                // Src: (st:isVoid VR128:v4i32:$src, addr:iPTR:$dst)<<P:Predicate_alignednontemporalstore>>
                // Dst: (MOVNTDQmr:isVoid VR128:v16i8:$src, addr:v16i8:$dst)
/*180*/       0, /*End of Scope*/
/*181*/     /*Scope*/ 104|128,124/*15976*/, /*->16159*/
/*183*/       OPC_MoveChild, 1,
/*185*/       OPC_SwitchOpcode /*27 cases */, 68|128,20/*2628*/,  ISD::OR,// ->2817
/*189*/         OPC_Scope, 46|128,19/*2478*/, /*->2670*/ // 2 children in Scope
/*192*/           OPC_MoveChild, 0,
/*194*/           OPC_SwitchOpcode /*3 cases */, 118|128,7/*1014*/,  ISD::SRL,// ->1212
/*198*/             OPC_Scope, 44|128,1/*172*/, /*->373*/ // 6 children in Scope
/*201*/               OPC_MoveChild, 0,
/*203*/               OPC_CheckOpcode, ISD::LOAD,
/*205*/               OPC_RecordMemRef,
/*206*/               OPC_RecordNode, // #1 = 'ld' chained node
/*207*/               OPC_CheckFoldableChainNode,
/*208*/               OPC_RecordChild1, // #2 = $dst
/*209*/               OPC_CheckPredicate, 2, // Predicate_unindexedload
/*211*/               OPC_Scope, 79, /*->292*/ // 2 children in Scope
/*213*/                 OPC_CheckPredicate, 3, // Predicate_loadi32
/*215*/                 OPC_MoveParent,
/*216*/                 OPC_MoveChild, 1,
/*218*/                 OPC_CheckOpcode, ISD::TRUNCATE,
/*220*/                 OPC_RecordChild0, // #3 = $amt
/*221*/                 OPC_RecordChild0, // #4 = physreg input ECX
/*222*/                 OPC_CheckChild0Type, MVT::i32,
/*224*/                 OPC_CheckType, MVT::i8,
/*226*/                 OPC_MoveParent,
/*227*/                 OPC_MoveParent,
/*228*/                 OPC_MoveChild, 1,
/*230*/                 OPC_CheckOpcode, ISD::SHL,
/*232*/                 OPC_RecordChild0, // #5 = $src2
/*233*/                 OPC_MoveChild, 1,
/*235*/                 OPC_CheckOpcode, ISD::TRUNCATE,
/*237*/                 OPC_MoveChild, 0,
/*239*/                 OPC_CheckOpcode, ISD::SUB,
/*241*/                 OPC_MoveChild, 0,
/*243*/                 OPC_CheckInteger, 32, 
/*245*/                 OPC_MoveParent,
/*246*/                 OPC_MoveChild, 1,
/*248*/                 OPC_CheckSame, 3,
/*250*/                 OPC_MoveParent,
/*251*/                 OPC_CheckType, MVT::i32,
/*253*/                 OPC_MoveParent,
/*254*/                 OPC_CheckType, MVT::i8,
/*256*/                 OPC_MoveParent,
/*257*/                 OPC_MoveParent,
/*258*/                 OPC_CheckType, MVT::i32,
/*260*/                 OPC_MoveParent,
/*261*/                 OPC_MoveChild, 2,
/*263*/                 OPC_CheckSame, 2,
/*265*/                 OPC_MoveParent,
/*266*/                 OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*268*/                 OPC_CheckPredicate, 5, // Predicate_store
/*270*/                 OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #6 #7 #8 #9 #10
/*273*/                 OPC_EmitMergeInputChains, 2, 0, 1, 
/*277*/                 OPC_EmitCopyToReg, 4, X86::ECX,
/*280*/                 OPC_MorphNodeTo, TARGET_OPCODE(X86::SHRD32mrCL), 0|OPFL_Chain|OPFL_FlagInput|OPFL_MemRefs,
                            0/*#VTs*/, 6/*#Ops*/, 6, 7, 8, 9, 10, 5, 
                        // Src: (st:isVoid (or:i32 (srl:i32 (ld:i32 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, (trunc:i8 ECX:i32:$amt)), (shl:i32 GR32:i32:$src2, (trunc:i8 (sub:i32 32:i32, ECX:i32:$amt)))), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                        // Dst: (SHRD32mrCL:isVoid addr:iPTR:$dst, GR32:i32:$src2)
/*292*/               /*Scope*/ 79, /*->372*/
/*293*/                 OPC_CheckPredicate, 6, // Predicate_loadi16
/*295*/                 OPC_MoveParent,
/*296*/                 OPC_MoveChild, 1,
/*298*/                 OPC_CheckOpcode, ISD::TRUNCATE,
/*300*/                 OPC_RecordChild0, // #3 = $amt
/*301*/                 OPC_RecordChild0, // #4 = physreg input CX
/*302*/                 OPC_CheckChild0Type, MVT::i16,
/*304*/                 OPC_CheckType, MVT::i8,
/*306*/                 OPC_MoveParent,
/*307*/                 OPC_MoveParent,
/*308*/                 OPC_MoveChild, 1,
/*310*/                 OPC_CheckOpcode, ISD::SHL,
/*312*/                 OPC_RecordChild0, // #5 = $src2
/*313*/                 OPC_MoveChild, 1,
/*315*/                 OPC_CheckOpcode, ISD::TRUNCATE,
/*317*/                 OPC_MoveChild, 0,
/*319*/                 OPC_CheckOpcode, ISD::SUB,
/*321*/                 OPC_MoveChild, 0,
/*323*/                 OPC_CheckInteger, 16, 
/*325*/                 OPC_MoveParent,
/*326*/                 OPC_MoveChild, 1,
/*328*/                 OPC_CheckSame, 3,
/*330*/                 OPC_MoveParent,
/*331*/                 OPC_CheckType, MVT::i16,
/*333*/                 OPC_MoveParent,
/*334*/                 OPC_CheckType, MVT::i8,
/*336*/                 OPC_MoveParent,
/*337*/                 OPC_MoveParent,
/*338*/                 OPC_CheckType, MVT::i16,
/*340*/                 OPC_MoveParent,
/*341*/                 OPC_MoveChild, 2,
/*343*/                 OPC_CheckSame, 2,
/*345*/                 OPC_MoveParent,
/*346*/                 OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*348*/                 OPC_CheckPredicate, 5, // Predicate_store
/*350*/                 OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #6 #7 #8 #9 #10
/*353*/                 OPC_EmitMergeInputChains, 2, 0, 1, 
/*357*/                 OPC_EmitCopyToReg, 4, X86::CX,
/*360*/                 OPC_MorphNodeTo, TARGET_OPCODE(X86::SHRD16mrCL), 0|OPFL_Chain|OPFL_FlagInput|OPFL_MemRefs,
                            0/*#VTs*/, 6/*#Ops*/, 6, 7, 8, 9, 10, 5, 
                        // Src: (st:isVoid (or:i16 (srl:i16 (ld:i16 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, (trunc:i8 CX:i16:$amt)), (shl:i16 GR16:i16:$src2, (trunc:i8 (sub:i16 16:i16, CX:i16:$amt)))), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                        // Dst: (SHRD16mrCL:isVoid addr:iPTR:$dst, GR16:i16:$src2)
/*372*/               0, /*End of Scope*/
/*373*/             /*Scope*/ 39|128,1/*167*/, /*->542*/
/*375*/               OPC_RecordChild0, // #1 = $src2
/*376*/               OPC_MoveChild, 1,
/*378*/               OPC_CheckOpcode, ISD::TRUNCATE,
/*380*/               OPC_MoveChild, 0,
/*382*/               OPC_CheckOpcode, ISD::SUB,
/*384*/               OPC_MoveChild, 0,
/*386*/               OPC_Scope, 76, /*->464*/ // 2 children in Scope
/*388*/                 OPC_CheckInteger, 32, 
/*390*/                 OPC_MoveParent,
/*391*/                 OPC_RecordChild1, // #2 = $amt
/*392*/                 OPC_RecordChild1, // #3 = physreg input ECX
/*393*/                 OPC_CheckType, MVT::i32,
/*395*/                 OPC_MoveParent,
/*396*/                 OPC_CheckType, MVT::i8,
/*398*/                 OPC_MoveParent,
/*399*/                 OPC_MoveParent,
/*400*/                 OPC_MoveChild, 1,
/*402*/                 OPC_CheckOpcode, ISD::SHL,
/*404*/                 OPC_MoveChild, 0,
/*406*/                 OPC_CheckOpcode, ISD::LOAD,
/*408*/                 OPC_RecordMemRef,
/*409*/                 OPC_RecordNode, // #4 = 'ld' chained node
/*410*/                 OPC_CheckFoldableChainNode,
/*411*/                 OPC_RecordChild1, // #5 = $dst
/*412*/                 OPC_CheckPredicate, 2, // Predicate_unindexedload
/*414*/                 OPC_CheckPredicate, 3, // Predicate_loadi32
/*416*/                 OPC_MoveParent,
/*417*/                 OPC_MoveChild, 1,
/*419*/                 OPC_CheckOpcode, ISD::TRUNCATE,
/*421*/                 OPC_MoveChild, 0,
/*423*/                 OPC_CheckSame, 2,
/*425*/                 OPC_MoveParent,
/*426*/                 OPC_CheckType, MVT::i8,
/*428*/                 OPC_MoveParent,
/*429*/                 OPC_MoveParent,
/*430*/                 OPC_CheckType, MVT::i32,
/*432*/                 OPC_MoveParent,
/*433*/                 OPC_MoveChild, 2,
/*435*/                 OPC_CheckSame, 5,
/*437*/                 OPC_MoveParent,
/*438*/                 OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*440*/                 OPC_CheckPredicate, 5, // Predicate_store
/*442*/                 OPC_CheckComplexPat, /*CP*/0, /*#*/5, // SelectAddr:$dst #6 #7 #8 #9 #10
/*445*/                 OPC_EmitMergeInputChains, 2, 0, 4, 
/*449*/                 OPC_EmitCopyToReg, 3, X86::ECX,
/*452*/                 OPC_MorphNodeTo, TARGET_OPCODE(X86::SHLD32mrCL), 0|OPFL_Chain|OPFL_FlagInput|OPFL_MemRefs,
                            0/*#VTs*/, 6/*#Ops*/, 6, 7, 8, 9, 10, 1, 
                        // Src: (st:isVoid (or:i32 (srl:i32 GR32:i32:$src2, (trunc:i8 (sub:i32 32:i32, ECX:i32:$amt))), (shl:i32 (ld:i32 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, (trunc:i8 ECX:i32:$amt))), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                        // Dst: (SHLD32mrCL:isVoid addr:iPTR:$dst, GR32:i32:$src2)
/*464*/               /*Scope*/ 76, /*->541*/
/*465*/                 OPC_CheckInteger, 16, 
/*467*/                 OPC_MoveParent,
/*468*/                 OPC_RecordChild1, // #2 = $amt
/*469*/                 OPC_RecordChild1, // #3 = physreg input CX
/*470*/                 OPC_CheckType, MVT::i16,
/*472*/                 OPC_MoveParent,
/*473*/                 OPC_CheckType, MVT::i8,
/*475*/                 OPC_MoveParent,
/*476*/                 OPC_MoveParent,
/*477*/                 OPC_MoveChild, 1,
/*479*/                 OPC_CheckOpcode, ISD::SHL,
/*481*/                 OPC_MoveChild, 0,
/*483*/                 OPC_CheckOpcode, ISD::LOAD,
/*485*/                 OPC_RecordMemRef,
/*486*/                 OPC_RecordNode, // #4 = 'ld' chained node
/*487*/                 OPC_CheckFoldableChainNode,
/*488*/                 OPC_RecordChild1, // #5 = $dst
/*489*/                 OPC_CheckPredicate, 2, // Predicate_unindexedload
/*491*/                 OPC_CheckPredicate, 6, // Predicate_loadi16
/*493*/                 OPC_MoveParent,
/*494*/                 OPC_MoveChild, 1,
/*496*/                 OPC_CheckOpcode, ISD::TRUNCATE,
/*498*/                 OPC_MoveChild, 0,
/*500*/                 OPC_CheckSame, 2,
/*502*/                 OPC_MoveParent,
/*503*/                 OPC_CheckType, MVT::i8,
/*505*/                 OPC_MoveParent,
/*506*/                 OPC_MoveParent,
/*507*/                 OPC_CheckType, MVT::i16,
/*509*/                 OPC_MoveParent,
/*510*/                 OPC_MoveChild, 2,
/*512*/                 OPC_CheckSame, 5,
/*514*/                 OPC_MoveParent,
/*515*/                 OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*517*/                 OPC_CheckPredicate, 5, // Predicate_store
/*519*/                 OPC_CheckComplexPat, /*CP*/0, /*#*/5, // SelectAddr:$dst #6 #7 #8 #9 #10
/*522*/                 OPC_EmitMergeInputChains, 2, 0, 4, 
/*526*/                 OPC_EmitCopyToReg, 3, X86::CX,
/*529*/                 OPC_MorphNodeTo, TARGET_OPCODE(X86::SHLD16mrCL), 0|OPFL_Chain|OPFL_FlagInput|OPFL_MemRefs,
                            0/*#VTs*/, 6/*#Ops*/, 6, 7, 8, 9, 10, 1, 
                        // Src: (st:isVoid (or:i16 (srl:i16 GR16:i16:$src2, (trunc:i8 (sub:i16 16:i16, CX:i16:$amt))), (shl:i16 (ld:i16 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, (trunc:i8 CX:i16:$amt))), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                        // Dst: (SHLD16mrCL:isVoid addr:iPTR:$dst, GR16:i16:$src2)
/*541*/               0, /*End of Scope*/
/*542*/             /*Scope*/ 16|128,1/*144*/, /*->688*/
/*544*/               OPC_MoveChild, 0,
/*546*/               OPC_CheckOpcode, ISD::LOAD,
/*548*/               OPC_RecordMemRef,
/*549*/               OPC_RecordNode, // #1 = 'ld' chained node
/*550*/               OPC_CheckFoldableChainNode,
/*551*/               OPC_RecordChild1, // #2 = $dst
/*552*/               OPC_CheckPredicate, 2, // Predicate_unindexedload
/*554*/               OPC_Scope, 65, /*->621*/ // 2 children in Scope
/*556*/                 OPC_CheckPredicate, 3, // Predicate_loadi32
/*558*/                 OPC_MoveParent,
/*559*/                 OPC_RecordChild1, // #3 = $amt
/*560*/                 OPC_RecordChild1, // #4 = physreg input CL
/*561*/                 OPC_CheckChild1Type, MVT::i8,
/*563*/                 OPC_MoveParent,
/*564*/                 OPC_MoveChild, 1,
/*566*/                 OPC_CheckOpcode, ISD::SHL,
/*568*/                 OPC_RecordChild0, // #5 = $src2
/*569*/                 OPC_MoveChild, 1,
/*571*/                 OPC_CheckOpcode, ISD::SUB,
/*573*/                 OPC_MoveChild, 0,
/*575*/                 OPC_CheckInteger, 32, 
/*577*/                 OPC_MoveParent,
/*578*/                 OPC_MoveChild, 1,
/*580*/                 OPC_CheckSame, 3,
/*582*/                 OPC_MoveParent,
/*583*/                 OPC_CheckType, MVT::i8,
/*585*/                 OPC_MoveParent,
/*586*/                 OPC_MoveParent,
/*587*/                 OPC_CheckType, MVT::i32,
/*589*/                 OPC_MoveParent,
/*590*/                 OPC_MoveChild, 2,
/*592*/                 OPC_CheckSame, 2,
/*594*/                 OPC_MoveParent,
/*595*/                 OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*597*/                 OPC_CheckPredicate, 5, // Predicate_store
/*599*/                 OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #6 #7 #8 #9 #10
/*602*/                 OPC_EmitMergeInputChains, 2, 0, 1, 
/*606*/                 OPC_EmitCopyToReg, 4, X86::CL,
/*609*/                 OPC_MorphNodeTo, TARGET_OPCODE(X86::SHRD32mrCL), 0|OPFL_Chain|OPFL_FlagInput|OPFL_MemRefs,
                            0/*#VTs*/, 6/*#Ops*/, 6, 7, 8, 9, 10, 5, 
                        // Src: (st:isVoid (or:i32 (srl:i32 (ld:i32 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, CL:i8:$amt), (shl:i32 GR32:i32:$src2, (sub:i8 32:i8, CL:i8:$amt))), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                        // Dst: (SHRD32mrCL:isVoid addr:iPTR:$dst, GR32:i32:$src2)
/*621*/               /*Scope*/ 65, /*->687*/
/*622*/                 OPC_CheckPredicate, 6, // Predicate_loadi16
/*624*/                 OPC_MoveParent,
/*625*/                 OPC_RecordChild1, // #3 = $amt
/*626*/                 OPC_RecordChild1, // #4 = physreg input CL
/*627*/                 OPC_CheckChild1Type, MVT::i8,
/*629*/                 OPC_MoveParent,
/*630*/                 OPC_MoveChild, 1,
/*632*/                 OPC_CheckOpcode, ISD::SHL,
/*634*/                 OPC_RecordChild0, // #5 = $src2
/*635*/                 OPC_MoveChild, 1,
/*637*/                 OPC_CheckOpcode, ISD::SUB,
/*639*/                 OPC_MoveChild, 0,
/*641*/                 OPC_CheckInteger, 16, 
/*643*/                 OPC_MoveParent,
/*644*/                 OPC_MoveChild, 1,
/*646*/                 OPC_CheckSame, 3,
/*648*/                 OPC_MoveParent,
/*649*/                 OPC_CheckType, MVT::i8,
/*651*/                 OPC_MoveParent,
/*652*/                 OPC_MoveParent,
/*653*/                 OPC_CheckType, MVT::i16,
/*655*/                 OPC_MoveParent,
/*656*/                 OPC_MoveChild, 2,
/*658*/                 OPC_CheckSame, 2,
/*660*/                 OPC_MoveParent,
/*661*/                 OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*663*/                 OPC_CheckPredicate, 5, // Predicate_store
/*665*/                 OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #6 #7 #8 #9 #10
/*668*/                 OPC_EmitMergeInputChains, 2, 0, 1, 
/*672*/                 OPC_EmitCopyToReg, 4, X86::CL,
/*675*/                 OPC_MorphNodeTo, TARGET_OPCODE(X86::SHRD16mrCL), 0|OPFL_Chain|OPFL_FlagInput|OPFL_MemRefs,
                            0/*#VTs*/, 6/*#Ops*/, 6, 7, 8, 9, 10, 5, 
                        // Src: (st:isVoid (or:i16 (srl:i16 (ld:i16 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, CL:i8:$amt), (shl:i16 GR16:i16:$src2, (sub:i8 16:i8, CL:i8:$amt))), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                        // Dst: (SHRD16mrCL:isVoid addr:iPTR:$dst, GR16:i16:$src2)
/*687*/               0, /*End of Scope*/
/*688*/             /*Scope*/ 15|128,1/*143*/, /*->833*/
/*690*/               OPC_RecordChild0, // #1 = $src2
/*691*/               OPC_MoveChild, 1,
/*693*/               OPC_CheckOpcode, ISD::SUB,
/*695*/               OPC_MoveChild, 0,
/*697*/               OPC_Scope, 66, /*->765*/ // 2 children in Scope
/*699*/                 OPC_CheckInteger, 32, 
/*701*/                 OPC_MoveParent,
/*702*/                 OPC_RecordChild1, // #2 = $amt
/*703*/                 OPC_RecordChild1, // #3 = physreg input CL
/*704*/                 OPC_CheckType, MVT::i8,
/*706*/                 OPC_MoveParent,
/*707*/                 OPC_MoveParent,
/*708*/                 OPC_MoveChild, 1,
/*710*/                 OPC_CheckOpcode, ISD::SHL,
/*712*/                 OPC_MoveChild, 0,
/*714*/                 OPC_CheckOpcode, ISD::LOAD,
/*716*/                 OPC_RecordMemRef,
/*717*/                 OPC_RecordNode, // #4 = 'ld' chained node
/*718*/                 OPC_CheckFoldableChainNode,
/*719*/                 OPC_RecordChild1, // #5 = $dst
/*720*/                 OPC_CheckPredicate, 2, // Predicate_unindexedload
/*722*/                 OPC_CheckPredicate, 3, // Predicate_loadi32
/*724*/                 OPC_MoveParent,
/*725*/                 OPC_MoveChild, 1,
/*727*/                 OPC_CheckSame, 2,
/*729*/                 OPC_MoveParent,
/*730*/                 OPC_MoveParent,
/*731*/                 OPC_CheckType, MVT::i32,
/*733*/                 OPC_MoveParent,
/*734*/                 OPC_MoveChild, 2,
/*736*/                 OPC_CheckSame, 5,
/*738*/                 OPC_MoveParent,
/*739*/                 OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*741*/                 OPC_CheckPredicate, 5, // Predicate_store
/*743*/                 OPC_CheckComplexPat, /*CP*/0, /*#*/5, // SelectAddr:$dst #6 #7 #8 #9 #10
/*746*/                 OPC_EmitMergeInputChains, 2, 0, 4, 
/*750*/                 OPC_EmitCopyToReg, 3, X86::CL,
/*753*/                 OPC_MorphNodeTo, TARGET_OPCODE(X86::SHLD32mrCL), 0|OPFL_Chain|OPFL_FlagInput|OPFL_MemRefs,
                            0/*#VTs*/, 6/*#Ops*/, 6, 7, 8, 9, 10, 1, 
                        // Src: (st:isVoid (or:i32 (srl:i32 GR32:i32:$src2, (sub:i8 32:i8, CL:i8:$amt)), (shl:i32 (ld:i32 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, CL:i8:$amt)), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                        // Dst: (SHLD32mrCL:isVoid addr:iPTR:$dst, GR32:i32:$src2)
/*765*/               /*Scope*/ 66, /*->832*/
/*766*/                 OPC_CheckInteger, 16, 
/*768*/                 OPC_MoveParent,
/*769*/                 OPC_RecordChild1, // #2 = $amt
/*770*/                 OPC_RecordChild1, // #3 = physreg input CL
/*771*/                 OPC_CheckType, MVT::i8,
/*773*/                 OPC_MoveParent,
/*774*/                 OPC_MoveParent,
/*775*/                 OPC_MoveChild, 1,
/*777*/                 OPC_CheckOpcode, ISD::SHL,
/*779*/                 OPC_MoveChild, 0,
/*781*/                 OPC_CheckOpcode, ISD::LOAD,
/*783*/                 OPC_RecordMemRef,
/*784*/                 OPC_RecordNode, // #4 = 'ld' chained node
/*785*/                 OPC_CheckFoldableChainNode,
/*786*/                 OPC_RecordChild1, // #5 = $dst
/*787*/                 OPC_CheckPredicate, 2, // Predicate_unindexedload
/*789*/                 OPC_CheckPredicate, 6, // Predicate_loadi16
/*791*/                 OPC_MoveParent,
/*792*/                 OPC_MoveChild, 1,
/*794*/                 OPC_CheckSame, 2,
/*796*/                 OPC_MoveParent,
/*797*/                 OPC_MoveParent,
/*798*/                 OPC_CheckType, MVT::i16,
/*800*/                 OPC_MoveParent,
/*801*/                 OPC_MoveChild, 2,
/*803*/                 OPC_CheckSame, 5,
/*805*/                 OPC_MoveParent,
/*806*/                 OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*808*/                 OPC_CheckPredicate, 5, // Predicate_store
/*810*/                 OPC_CheckComplexPat, /*CP*/0, /*#*/5, // SelectAddr:$dst #6 #7 #8 #9 #10
/*813*/                 OPC_EmitMergeInputChains, 2, 0, 4, 
/*817*/                 OPC_EmitCopyToReg, 3, X86::CL,
/*820*/                 OPC_MorphNodeTo, TARGET_OPCODE(X86::SHLD16mrCL), 0|OPFL_Chain|OPFL_FlagInput|OPFL_MemRefs,
                            0/*#VTs*/, 6/*#Ops*/, 6, 7, 8, 9, 10, 1, 
                        // Src: (st:isVoid (or:i16 (srl:i16 GR16:i16:$src2, (sub:i8 16:i8, CL:i8:$amt)), (shl:i16 (ld:i16 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, CL:i8:$amt)), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                        // Dst: (SHLD16mrCL:isVoid addr:iPTR:$dst, GR16:i16:$src2)
/*832*/               0, /*End of Scope*/
/*833*/             /*Scope*/ 72|128,1/*200*/, /*->1035*/
/*835*/               OPC_MoveChild, 0,
/*837*/               OPC_CheckOpcode, ISD::LOAD,
/*839*/               OPC_RecordMemRef,
/*840*/               OPC_RecordNode, // #1 = 'ld' chained node
/*841*/               OPC_CheckFoldableChainNode,
/*842*/               OPC_RecordChild1, // #2 = $dst
/*843*/               OPC_CheckPredicate, 2, // Predicate_unindexedload
/*845*/               OPC_Scope, 61, /*->908*/ // 3 children in Scope
/*847*/                 OPC_CheckPredicate, 3, // Predicate_loadi32
/*849*/                 OPC_MoveParent,
/*850*/                 OPC_RecordChild1, // #3 = $amt1
/*851*/                 OPC_MoveChild, 1,
/*853*/                 OPC_CheckOpcode, ISD::Constant,
/*855*/                 OPC_CheckType, MVT::i8,
/*857*/                 OPC_MoveParent,
/*858*/                 OPC_MoveParent,
/*859*/                 OPC_MoveChild, 1,
/*861*/                 OPC_CheckOpcode, ISD::SHL,
/*863*/                 OPC_RecordChild0, // #4 = $src2
/*864*/                 OPC_MoveChild, 1,
/*866*/                 OPC_CheckOpcode, ISD::Constant,
/*868*/                 OPC_CheckType, MVT::i8,
/*870*/                 OPC_MoveParent,
/*871*/                 OPC_MoveParent,
/*872*/                 OPC_CheckPredicate, 7, // Predicate_shrd
/*874*/                 OPC_CheckType, MVT::i32,
/*876*/                 OPC_MoveParent,
/*877*/                 OPC_MoveChild, 2,
/*879*/                 OPC_CheckSame, 2,
/*881*/                 OPC_MoveParent,
/*882*/                 OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*884*/                 OPC_CheckPredicate, 5, // Predicate_store
/*886*/                 OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #5 #6 #7 #8 #9
/*889*/                 OPC_EmitMergeInputChains, 2, 0, 1, 
/*893*/                 OPC_EmitConvertToTarget, 3,
/*895*/                 OPC_MorphNodeTo, TARGET_OPCODE(X86::SHRD32mri8), 0|OPFL_Chain|OPFL_MemRefs,
                            0/*#VTs*/, 7/*#Ops*/, 5, 6, 7, 8, 9, 4, 10, 
                        // Src: (st:isVoid (or:i32 (srl:i32 (ld:i32 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, (imm:i8):$amt1), (shl:i32 GR32:i32:$src2, (imm:i8)))<<P:Predicate_shrd>>, addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                        // Dst: (SHRD32mri8:isVoid addr:iPTR:$dst, GR32:i32:$src2, (imm:i8):$amt1)
/*908*/               /*Scope*/ 61, /*->970*/
/*909*/                 OPC_CheckPredicate, 6, // Predicate_loadi16
/*911*/                 OPC_MoveParent,
/*912*/                 OPC_RecordChild1, // #3 = $amt1
/*913*/                 OPC_MoveChild, 1,
/*915*/                 OPC_CheckOpcode, ISD::Constant,
/*917*/                 OPC_CheckType, MVT::i8,
/*919*/                 OPC_MoveParent,
/*920*/                 OPC_MoveParent,
/*921*/                 OPC_MoveChild, 1,
/*923*/                 OPC_CheckOpcode, ISD::SHL,
/*925*/                 OPC_RecordChild0, // #4 = $src2
/*926*/                 OPC_MoveChild, 1,
/*928*/                 OPC_CheckOpcode, ISD::Constant,
/*930*/                 OPC_CheckType, MVT::i8,
/*932*/                 OPC_MoveParent,
/*933*/                 OPC_MoveParent,
/*934*/                 OPC_CheckPredicate, 7, // Predicate_shrd
/*936*/                 OPC_CheckType, MVT::i16,
/*938*/                 OPC_MoveParent,
/*939*/                 OPC_MoveChild, 2,
/*941*/                 OPC_CheckSame, 2,
/*943*/                 OPC_MoveParent,
/*944*/                 OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*946*/                 OPC_CheckPredicate, 5, // Predicate_store
/*948*/                 OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #5 #6 #7 #8 #9
/*951*/                 OPC_EmitMergeInputChains, 2, 0, 1, 
/*955*/                 OPC_EmitConvertToTarget, 3,
/*957*/                 OPC_MorphNodeTo, TARGET_OPCODE(X86::SHRD16mri8), 0|OPFL_Chain|OPFL_MemRefs,
                            0/*#VTs*/, 7/*#Ops*/, 5, 6, 7, 8, 9, 4, 10, 
                        // Src: (st:isVoid (or:i16 (srl:i16 (ld:i16 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, (imm:i8):$amt1), (shl:i16 GR16:i16:$src2, (imm:i8)))<<P:Predicate_shrd>>, addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                        // Dst: (SHRD16mri8:isVoid addr:iPTR:$dst, GR16:i16:$src2, (imm:i8):$amt1)
/*970*/               /*Scope*/ 63, /*->1034*/
/*971*/                 OPC_CheckPredicate, 8, // Predicate_load
/*973*/                 OPC_CheckPredicate, 9, // Predicate_dsload
/*975*/                 OPC_MoveParent,
/*976*/                 OPC_RecordChild1, // #3 = $amt1
/*977*/                 OPC_MoveChild, 1,
/*979*/                 OPC_CheckOpcode, ISD::Constant,
/*981*/                 OPC_CheckType, MVT::i8,
/*983*/                 OPC_MoveParent,
/*984*/                 OPC_MoveParent,
/*985*/                 OPC_MoveChild, 1,
/*987*/                 OPC_CheckOpcode, ISD::SHL,
/*989*/                 OPC_RecordChild0, // #4 = $src2
/*990*/                 OPC_MoveChild, 1,
/*992*/                 OPC_CheckOpcode, ISD::Constant,
/*994*/                 OPC_CheckType, MVT::i8,
/*996*/                 OPC_MoveParent,
/*997*/                 OPC_MoveParent,
/*998*/                 OPC_CheckPredicate, 7, // Predicate_shrd
/*1000*/                OPC_CheckType, MVT::i64,
/*1002*/                OPC_MoveParent,
/*1003*/                OPC_MoveChild, 2,
/*1005*/                OPC_CheckSame, 2,
/*1007*/                OPC_MoveParent,
/*1008*/                OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*1010*/                OPC_CheckPredicate, 5, // Predicate_store
/*1012*/                OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #5 #6 #7 #8 #9
/*1015*/                OPC_EmitMergeInputChains, 2, 0, 1, 
/*1019*/                OPC_EmitConvertToTarget, 3,
/*1021*/                OPC_MorphNodeTo, TARGET_OPCODE(X86::SHRD64mri8), 0|OPFL_Chain|OPFL_MemRefs,
                            0/*#VTs*/, 7/*#Ops*/, 5, 6, 7, 8, 9, 4, 10, 
                        // Src: (st:isVoid (or:i64 (srl:i64 (ld:i64 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>, (imm:i8):$amt1), (shl:i64 GR64:i64:$src2, (imm:i8)))<<P:Predicate_shrd>>, addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                        // Dst: (SHRD64mri8:isVoid addr:iPTR:$dst, GR64:i64:$src2, (imm:i8):$amt1)
/*1034*/              0, /*End of Scope*/
/*1035*/            /*Scope*/ 46|128,1/*174*/, /*->1211*/
/*1037*/              OPC_RecordChild0, // #1 = $src2
/*1038*/              OPC_MoveChild, 1,
/*1040*/              OPC_CheckOpcode, ISD::Constant,
/*1042*/              OPC_CheckType, MVT::i8,
/*1044*/              OPC_MoveParent,
/*1045*/              OPC_MoveParent,
/*1046*/              OPC_MoveChild, 1,
/*1048*/              OPC_CheckOpcode, ISD::SHL,
/*1050*/              OPC_MoveChild, 0,
/*1052*/              OPC_CheckOpcode, ISD::LOAD,
/*1054*/              OPC_RecordMemRef,
/*1055*/              OPC_RecordNode, // #2 = 'ld' chained node
/*1056*/              OPC_CheckFoldableChainNode,
/*1057*/              OPC_RecordChild1, // #3 = $dst
/*1058*/              OPC_CheckPredicate, 2, // Predicate_unindexedload
/*1060*/              OPC_Scope, 48, /*->1110*/ // 3 children in Scope
/*1062*/                OPC_CheckPredicate, 3, // Predicate_loadi32
/*1064*/                OPC_MoveParent,
/*1065*/                OPC_RecordChild1, // #4 = $amt1
/*1066*/                OPC_MoveChild, 1,
/*1068*/                OPC_CheckOpcode, ISD::Constant,
/*1070*/                OPC_CheckType, MVT::i8,
/*1072*/                OPC_MoveParent,
/*1073*/                OPC_MoveParent,
/*1074*/                OPC_CheckPredicate, 10, // Predicate_shld
/*1076*/                OPC_CheckType, MVT::i32,
/*1078*/                OPC_MoveParent,
/*1079*/                OPC_MoveChild, 2,
/*1081*/                OPC_CheckSame, 3,
/*1083*/                OPC_MoveParent,
/*1084*/                OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*1086*/                OPC_CheckPredicate, 5, // Predicate_store
/*1088*/                OPC_CheckComplexPat, /*CP*/0, /*#*/3, // SelectAddr:$dst #5 #6 #7 #8 #9
/*1091*/                OPC_EmitMergeInputChains, 2, 0, 2, 
/*1095*/                OPC_EmitConvertToTarget, 4,
/*1097*/                OPC_MorphNodeTo, TARGET_OPCODE(X86::SHLD32mri8), 0|OPFL_Chain|OPFL_MemRefs,
                            0/*#VTs*/, 7/*#Ops*/, 5, 6, 7, 8, 9, 1, 10, 
                        // Src: (st:isVoid (or:i32 (srl:i32 GR32:i32:$src2, (imm:i8)), (shl:i32 (ld:i32 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, (imm:i8):$amt1))<<P:Predicate_shld>>, addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                        // Dst: (SHLD32mri8:isVoid addr:iPTR:$dst, GR32:i32:$src2, (imm:i8):$amt1)
/*1110*/              /*Scope*/ 48, /*->1159*/
/*1111*/                OPC_CheckPredicate, 6, // Predicate_loadi16
/*1113*/                OPC_MoveParent,
/*1114*/                OPC_RecordChild1, // #4 = $amt1
/*1115*/                OPC_MoveChild, 1,
/*1117*/                OPC_CheckOpcode, ISD::Constant,
/*1119*/                OPC_CheckType, MVT::i8,
/*1121*/                OPC_MoveParent,
/*1122*/                OPC_MoveParent,
/*1123*/                OPC_CheckPredicate, 10, // Predicate_shld
/*1125*/                OPC_CheckType, MVT::i16,
/*1127*/                OPC_MoveParent,
/*1128*/                OPC_MoveChild, 2,
/*1130*/                OPC_CheckSame, 3,
/*1132*/                OPC_MoveParent,
/*1133*/                OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*1135*/                OPC_CheckPredicate, 5, // Predicate_store
/*1137*/                OPC_CheckComplexPat, /*CP*/0, /*#*/3, // SelectAddr:$dst #5 #6 #7 #8 #9
/*1140*/                OPC_EmitMergeInputChains, 2, 0, 2, 
/*1144*/                OPC_EmitConvertToTarget, 4,
/*1146*/                OPC_MorphNodeTo, TARGET_OPCODE(X86::SHLD16mri8), 0|OPFL_Chain|OPFL_MemRefs,
                            0/*#VTs*/, 7/*#Ops*/, 5, 6, 7, 8, 9, 1, 10, 
                        // Src: (st:isVoid (or:i16 (srl:i16 GR16:i16:$src2, (imm:i8)), (shl:i16 (ld:i16 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, (imm:i8):$amt1))<<P:Predicate_shld>>, addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                        // Dst: (SHLD16mri8:isVoid addr:iPTR:$dst, GR16:i16:$src2, (imm:i8):$amt1)
/*1159*/              /*Scope*/ 50, /*->1210*/
/*1160*/                OPC_CheckPredicate, 8, // Predicate_load
/*1162*/                OPC_CheckPredicate, 9, // Predicate_dsload
/*1164*/                OPC_MoveParent,
/*1165*/                OPC_RecordChild1, // #4 = $amt1
/*1166*/                OPC_MoveChild, 1,
/*1168*/                OPC_CheckOpcode, ISD::Constant,
/*1170*/                OPC_CheckType, MVT::i8,
/*1172*/                OPC_MoveParent,
/*1173*/                OPC_MoveParent,
/*1174*/                OPC_CheckPredicate, 10, // Predicate_shld
/*1176*/                OPC_CheckType, MVT::i64,
/*1178*/                OPC_MoveParent,
/*1179*/                OPC_MoveChild, 2,
/*1181*/                OPC_CheckSame, 3,
/*1183*/                OPC_MoveParent,
/*1184*/                OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*1186*/                OPC_CheckPredicate, 5, // Predicate_store
/*1188*/                OPC_CheckComplexPat, /*CP*/0, /*#*/3, // SelectAddr:$dst #5 #6 #7 #8 #9
/*1191*/                OPC_EmitMergeInputChains, 2, 0, 2, 
/*1195*/                OPC_EmitConvertToTarget, 4,
/*1197*/                OPC_MorphNodeTo, TARGET_OPCODE(X86::SHLD64mri8), 0|OPFL_Chain|OPFL_MemRefs,
                            0/*#VTs*/, 7/*#Ops*/, 5, 6, 7, 8, 9, 1, 10, 
                        // Src: (st:isVoid (or:i64 (srl:i64 GR64:i64:$src2, (imm:i8)), (shl:i64 (ld:i64 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>, (imm:i8):$amt1))<<P:Predicate_shld>>, addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                        // Dst: (SHLD64mri8:isVoid addr:iPTR:$dst, GR64:i64:$src2, (imm:i8):$amt1)
/*1210*/              0, /*End of Scope*/
/*1211*/            0, /*End of Scope*/
                  /*SwitchOpcode*/ 118|128,7/*1014*/,  ISD::SHL,// ->2229
/*1215*/            OPC_Scope, 44|128,1/*172*/, /*->1390*/ // 6 children in Scope
/*1218*/              OPC_MoveChild, 0,
/*1220*/              OPC_CheckOpcode, ISD::LOAD,
/*1222*/              OPC_RecordMemRef,
/*1223*/              OPC_RecordNode, // #1 = 'ld' chained node
/*1224*/              OPC_CheckFoldableChainNode,
/*1225*/              OPC_RecordChild1, // #2 = $dst
/*1226*/              OPC_CheckPredicate, 2, // Predicate_unindexedload
/*1228*/              OPC_Scope, 79, /*->1309*/ // 2 children in Scope
/*1230*/                OPC_CheckPredicate, 3, // Predicate_loadi32
/*1232*/                OPC_MoveParent,
/*1233*/                OPC_MoveChild, 1,
/*1235*/                OPC_CheckOpcode, ISD::TRUNCATE,
/*1237*/                OPC_RecordChild0, // #3 = $amt
/*1238*/                OPC_RecordChild0, // #4 = physreg input ECX
/*1239*/                OPC_CheckChild0Type, MVT::i32,
/*1241*/                OPC_CheckType, MVT::i8,
/*1243*/                OPC_MoveParent,
/*1244*/                OPC_MoveParent,
/*1245*/                OPC_MoveChild, 1,
/*1247*/                OPC_CheckOpcode, ISD::SRL,
/*1249*/                OPC_RecordChild0, // #5 = $src2
/*1250*/                OPC_MoveChild, 1,
/*1252*/                OPC_CheckOpcode, ISD::TRUNCATE,
/*1254*/                OPC_MoveChild, 0,
/*1256*/                OPC_CheckOpcode, ISD::SUB,
/*1258*/                OPC_MoveChild, 0,
/*1260*/                OPC_CheckInteger, 32, 
/*1262*/                OPC_MoveParent,
/*1263*/                OPC_MoveChild, 1,
/*1265*/                OPC_CheckSame, 3,
/*1267*/                OPC_MoveParent,
/*1268*/                OPC_CheckType, MVT::i32,
/*1270*/                OPC_MoveParent,
/*1271*/                OPC_CheckType, MVT::i8,
/*1273*/                OPC_MoveParent,
/*1274*/                OPC_MoveParent,
/*1275*/                OPC_CheckType, MVT::i32,
/*1277*/                OPC_MoveParent,
/*1278*/                OPC_MoveChild, 2,
/*1280*/                OPC_CheckSame, 2,
/*1282*/                OPC_MoveParent,
/*1283*/                OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*1285*/                OPC_CheckPredicate, 5, // Predicate_store
/*1287*/                OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #6 #7 #8 #9 #10
/*1290*/                OPC_EmitMergeInputChains, 2, 0, 1, 
/*1294*/                OPC_EmitCopyToReg, 4, X86::ECX,
/*1297*/                OPC_MorphNodeTo, TARGET_OPCODE(X86::SHLD32mrCL), 0|OPFL_Chain|OPFL_FlagInput|OPFL_MemRefs,
                            0/*#VTs*/, 6/*#Ops*/, 6, 7, 8, 9, 10, 5, 
                        // Src: (st:isVoid (or:i32 (shl:i32 (ld:i32 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, (trunc:i8 ECX:i32:$amt)), (srl:i32 GR32:i32:$src2, (trunc:i8 (sub:i32 32:i32, ECX:i32:$amt)))), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                        // Dst: (SHLD32mrCL:isVoid addr:iPTR:$dst, GR32:i32:$src2)
/*1309*/              /*Scope*/ 79, /*->1389*/
/*1310*/                OPC_CheckPredicate, 6, // Predicate_loadi16
/*1312*/                OPC_MoveParent,
/*1313*/                OPC_MoveChild, 1,
/*1315*/                OPC_CheckOpcode, ISD::TRUNCATE,
/*1317*/                OPC_RecordChild0, // #3 = $amt
/*1318*/                OPC_RecordChild0, // #4 = physreg input CX
/*1319*/                OPC_CheckChild0Type, MVT::i16,
/*1321*/                OPC_CheckType, MVT::i8,
/*1323*/                OPC_MoveParent,
/*1324*/                OPC_MoveParent,
/*1325*/                OPC_MoveChild, 1,
/*1327*/                OPC_CheckOpcode, ISD::SRL,
/*1329*/                OPC_RecordChild0, // #5 = $src2
/*1330*/                OPC_MoveChild, 1,
/*1332*/                OPC_CheckOpcode, ISD::TRUNCATE,
/*1334*/                OPC_MoveChild, 0,
/*1336*/                OPC_CheckOpcode, ISD::SUB,
/*1338*/                OPC_MoveChild, 0,
/*1340*/                OPC_CheckInteger, 16, 
/*1342*/                OPC_MoveParent,
/*1343*/                OPC_MoveChild, 1,
/*1345*/                OPC_CheckSame, 3,
/*1347*/                OPC_MoveParent,
/*1348*/                OPC_CheckType, MVT::i16,
/*1350*/                OPC_MoveParent,
/*1351*/                OPC_CheckType, MVT::i8,
/*1353*/                OPC_MoveParent,
/*1354*/                OPC_MoveParent,
/*1355*/                OPC_CheckType, MVT::i16,
/*1357*/                OPC_MoveParent,
/*1358*/                OPC_MoveChild, 2,
/*1360*/                OPC_CheckSame, 2,
/*1362*/                OPC_MoveParent,
/*1363*/                OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*1365*/                OPC_CheckPredicate, 5, // Predicate_store
/*1367*/                OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #6 #7 #8 #9 #10
/*1370*/                OPC_EmitMergeInputChains, 2, 0, 1, 
/*1374*/                OPC_EmitCopyToReg, 4, X86::CX,
/*1377*/                OPC_MorphNodeTo, TARGET_OPCODE(X86::SHLD16mrCL), 0|OPFL_Chain|OPFL_FlagInput|OPFL_MemRefs,
                            0/*#VTs*/, 6/*#Ops*/, 6, 7, 8, 9, 10, 5, 
                        // Src: (st:isVoid (or:i16 (shl:i16 (ld:i16 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, (trunc:i8 CX:i16:$amt)), (srl:i16 GR16:i16:$src2, (trunc:i8 (sub:i16 16:i16, CX:i16:$amt)))), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                        // Dst: (SHLD16mrCL:isVoid addr:iPTR:$dst, GR16:i16:$src2)
/*1389*/              0, /*End of Scope*/
/*1390*/            /*Scope*/ 39|128,1/*167*/, /*->1559*/
/*1392*/              OPC_RecordChild0, // #1 = $src2
/*1393*/              OPC_MoveChild, 1,
/*1395*/              OPC_CheckOpcode, ISD::TRUNCATE,
/*1397*/              OPC_MoveChild, 0,
/*1399*/              OPC_CheckOpcode, ISD::SUB,
/*1401*/              OPC_MoveChild, 0,
/*1403*/              OPC_Scope, 76, /*->1481*/ // 2 children in Scope
/*1405*/                OPC_CheckInteger, 32, 
/*1407*/                OPC_MoveParent,
/*1408*/                OPC_RecordChild1, // #2 = $amt
/*1409*/                OPC_RecordChild1, // #3 = physreg input ECX
/*1410*/                OPC_CheckType, MVT::i32,
/*1412*/                OPC_MoveParent,
/*1413*/                OPC_CheckType, MVT::i8,
/*1415*/                OPC_MoveParent,
/*1416*/                OPC_MoveParent,
/*1417*/                OPC_MoveChild, 1,
/*1419*/                OPC_CheckOpcode, ISD::SRL,
/*1421*/                OPC_MoveChild, 0,
/*1423*/                OPC_CheckOpcode, ISD::LOAD,
/*1425*/                OPC_RecordMemRef,
/*1426*/                OPC_RecordNode, // #4 = 'ld' chained node
/*1427*/                OPC_CheckFoldableChainNode,
/*1428*/                OPC_RecordChild1, // #5 = $dst
/*1429*/                OPC_CheckPredicate, 2, // Predicate_unindexedload
/*1431*/                OPC_CheckPredicate, 3, // Predicate_loadi32
/*1433*/                OPC_MoveParent,
/*1434*/                OPC_MoveChild, 1,
/*1436*/                OPC_CheckOpcode, ISD::TRUNCATE,
/*1438*/                OPC_MoveChild, 0,
/*1440*/                OPC_CheckSame, 2,
/*1442*/                OPC_MoveParent,
/*1443*/                OPC_CheckType, MVT::i8,
/*1445*/                OPC_MoveParent,
/*1446*/                OPC_MoveParent,
/*1447*/                OPC_CheckType, MVT::i32,
/*1449*/                OPC_MoveParent,
/*1450*/                OPC_MoveChild, 2,
/*1452*/                OPC_CheckSame, 5,
/*1454*/                OPC_MoveParent,
/*1455*/                OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*1457*/                OPC_CheckPredicate, 5, // Predicate_store
/*1459*/                OPC_CheckComplexPat, /*CP*/0, /*#*/5, // SelectAddr:$dst #6 #7 #8 #9 #10
/*1462*/                OPC_EmitMergeInputChains, 2, 0, 4, 
/*1466*/                OPC_EmitCopyToReg, 3, X86::ECX,
/*1469*/                OPC_MorphNodeTo, TARGET_OPCODE(X86::SHRD32mrCL), 0|OPFL_Chain|OPFL_FlagInput|OPFL_MemRefs,
                            0/*#VTs*/, 6/*#Ops*/, 6, 7, 8, 9, 10, 1, 
                        // Src: (st:isVoid (or:i32 (shl:i32 GR32:i32:$src2, (trunc:i8 (sub:i32 32:i32, ECX:i32:$amt))), (srl:i32 (ld:i32 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, (trunc:i8 ECX:i32:$amt))), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                        // Dst: (SHRD32mrCL:isVoid addr:iPTR:$dst, GR32:i32:$src2)
/*1481*/              /*Scope*/ 76, /*->1558*/
/*1482*/                OPC_CheckInteger, 16, 
/*1484*/                OPC_MoveParent,
/*1485*/                OPC_RecordChild1, // #2 = $amt
/*1486*/                OPC_RecordChild1, // #3 = physreg input CX
/*1487*/                OPC_CheckType, MVT::i16,
/*1489*/                OPC_MoveParent,
/*1490*/                OPC_CheckType, MVT::i8,
/*1492*/                OPC_MoveParent,
/*1493*/                OPC_MoveParent,
/*1494*/                OPC_MoveChild, 1,
/*1496*/                OPC_CheckOpcode, ISD::SRL,
/*1498*/                OPC_MoveChild, 0,
/*1500*/                OPC_CheckOpcode, ISD::LOAD,
/*1502*/                OPC_RecordMemRef,
/*1503*/                OPC_RecordNode, // #4 = 'ld' chained node
/*1504*/                OPC_CheckFoldableChainNode,
/*1505*/                OPC_RecordChild1, // #5 = $dst
/*1506*/                OPC_CheckPredicate, 2, // Predicate_unindexedload
/*1508*/                OPC_CheckPredicate, 6, // Predicate_loadi16
/*1510*/                OPC_MoveParent,
/*1511*/                OPC_MoveChild, 1,
/*1513*/                OPC_CheckOpcode, ISD::TRUNCATE,
/*1515*/                OPC_MoveChild, 0,
/*1517*/                OPC_CheckSame, 2,
/*1519*/                OPC_MoveParent,
/*1520*/                OPC_CheckType, MVT::i8,
/*1522*/                OPC_MoveParent,
/*1523*/                OPC_MoveParent,
/*1524*/                OPC_CheckType, MVT::i16,
/*1526*/                OPC_MoveParent,
/*1527*/                OPC_MoveChild, 2,
/*1529*/                OPC_CheckSame, 5,
/*1531*/                OPC_MoveParent,
/*1532*/                OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*1534*/                OPC_CheckPredicate, 5, // Predicate_store
/*1536*/                OPC_CheckComplexPat, /*CP*/0, /*#*/5, // SelectAddr:$dst #6 #7 #8 #9 #10
/*1539*/                OPC_EmitMergeInputChains, 2, 0, 4, 
/*1543*/                OPC_EmitCopyToReg, 3, X86::CX,
/*1546*/                OPC_MorphNodeTo, TARGET_OPCODE(X86::SHRD16mrCL), 0|OPFL_Chain|OPFL_FlagInput|OPFL_MemRefs,
                            0/*#VTs*/, 6/*#Ops*/, 6, 7, 8, 9, 10, 1, 
                        // Src: (st:isVoid (or:i16 (shl:i16 GR16:i16:$src2, (trunc:i8 (sub:i16 16:i16, CX:i16:$amt))), (srl:i16 (ld:i16 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, (trunc:i8 CX:i16:$amt))), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                        // Dst: (SHRD16mrCL:isVoid addr:iPTR:$dst, GR16:i16:$src2)
/*1558*/              0, /*End of Scope*/
/*1559*/            /*Scope*/ 16|128,1/*144*/, /*->1705*/
/*1561*/              OPC_MoveChild, 0,
/*1563*/              OPC_CheckOpcode, ISD::LOAD,
/*1565*/              OPC_RecordMemRef,
/*1566*/              OPC_RecordNode, // #1 = 'ld' chained node
/*1567*/              OPC_CheckFoldableChainNode,
/*1568*/              OPC_RecordChild1, // #2 = $dst
/*1569*/              OPC_CheckPredicate, 2, // Predicate_unindexedload
/*1571*/              OPC_Scope, 65, /*->1638*/ // 2 children in Scope
/*1573*/                OPC_CheckPredicate, 3, // Predicate_loadi32
/*1575*/                OPC_MoveParent,
/*1576*/                OPC_RecordChild1, // #3 = $amt
/*1577*/                OPC_RecordChild1, // #4 = physreg input CL
/*1578*/                OPC_CheckChild1Type, MVT::i8,
/*1580*/                OPC_MoveParent,
/*1581*/                OPC_MoveChild, 1,
/*1583*/                OPC_CheckOpcode, ISD::SRL,
/*1585*/                OPC_RecordChild0, // #5 = $src2
/*1586*/                OPC_MoveChild, 1,
/*1588*/                OPC_CheckOpcode, ISD::SUB,
/*1590*/                OPC_MoveChild, 0,
/*1592*/                OPC_CheckInteger, 32, 
/*1594*/                OPC_MoveParent,
/*1595*/                OPC_MoveChild, 1,
/*1597*/                OPC_CheckSame, 3,
/*1599*/                OPC_MoveParent,
/*1600*/                OPC_CheckType, MVT::i8,
/*1602*/                OPC_MoveParent,
/*1603*/                OPC_MoveParent,
/*1604*/                OPC_CheckType, MVT::i32,
/*1606*/                OPC_MoveParent,
/*1607*/                OPC_MoveChild, 2,
/*1609*/                OPC_CheckSame, 2,
/*1611*/                OPC_MoveParent,
/*1612*/                OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*1614*/                OPC_CheckPredicate, 5, // Predicate_store
/*1616*/                OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #6 #7 #8 #9 #10
/*1619*/                OPC_EmitMergeInputChains, 2, 0, 1, 
/*1623*/                OPC_EmitCopyToReg, 4, X86::CL,
/*1626*/                OPC_MorphNodeTo, TARGET_OPCODE(X86::SHLD32mrCL), 0|OPFL_Chain|OPFL_FlagInput|OPFL_MemRefs,
                            0/*#VTs*/, 6/*#Ops*/, 6, 7, 8, 9, 10, 5, 
                        // Src: (st:isVoid (or:i32 (shl:i32 (ld:i32 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, CL:i8:$amt), (srl:i32 GR32:i32:$src2, (sub:i8 32:i8, CL:i8:$amt))), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                        // Dst: (SHLD32mrCL:isVoid addr:iPTR:$dst, GR32:i32:$src2)
/*1638*/              /*Scope*/ 65, /*->1704*/
/*1639*/                OPC_CheckPredicate, 6, // Predicate_loadi16
/*1641*/                OPC_MoveParent,
/*1642*/                OPC_RecordChild1, // #3 = $amt
/*1643*/                OPC_RecordChild1, // #4 = physreg input CL
/*1644*/                OPC_CheckChild1Type, MVT::i8,
/*1646*/                OPC_MoveParent,
/*1647*/                OPC_MoveChild, 1,
/*1649*/                OPC_CheckOpcode, ISD::SRL,
/*1651*/                OPC_RecordChild0, // #5 = $src2
/*1652*/                OPC_MoveChild, 1,
/*1654*/                OPC_CheckOpcode, ISD::SUB,
/*1656*/                OPC_MoveChild, 0,
/*1658*/                OPC_CheckInteger, 16, 
/*1660*/                OPC_MoveParent,
/*1661*/                OPC_MoveChild, 1,
/*1663*/                OPC_CheckSame, 3,
/*1665*/                OPC_MoveParent,
/*1666*/                OPC_CheckType, MVT::i8,
/*1668*/                OPC_MoveParent,
/*1669*/                OPC_MoveParent,
/*1670*/                OPC_CheckType, MVT::i16,
/*1672*/                OPC_MoveParent,
/*1673*/                OPC_MoveChild, 2,
/*1675*/                OPC_CheckSame, 2,
/*1677*/                OPC_MoveParent,
/*1678*/                OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*1680*/                OPC_CheckPredicate, 5, // Predicate_store
/*1682*/                OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #6 #7 #8 #9 #10
/*1685*/                OPC_EmitMergeInputChains, 2, 0, 1, 
/*1689*/                OPC_EmitCopyToReg, 4, X86::CL,
/*1692*/                OPC_MorphNodeTo, TARGET_OPCODE(X86::SHLD16mrCL), 0|OPFL_Chain|OPFL_FlagInput|OPFL_MemRefs,
                            0/*#VTs*/, 6/*#Ops*/, 6, 7, 8, 9, 10, 5, 
                        // Src: (st:isVoid (or:i16 (shl:i16 (ld:i16 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, CL:i8:$amt), (srl:i16 GR16:i16:$src2, (sub:i8 16:i8, CL:i8:$amt))), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                        // Dst: (SHLD16mrCL:isVoid addr:iPTR:$dst, GR16:i16:$src2)
/*1704*/              0, /*End of Scope*/
/*1705*/            /*Scope*/ 15|128,1/*143*/, /*->1850*/
/*1707*/              OPC_RecordChild0, // #1 = $src2
/*1708*/              OPC_MoveChild, 1,
/*1710*/              OPC_CheckOpcode, ISD::SUB,
/*1712*/              OPC_MoveChild, 0,
/*1714*/              OPC_Scope, 66, /*->1782*/ // 2 children in Scope
/*1716*/                OPC_CheckInteger, 32, 
/*1718*/                OPC_MoveParent,
/*1719*/                OPC_RecordChild1, // #2 = $amt
/*1720*/                OPC_RecordChild1, // #3 = physreg input CL
/*1721*/                OPC_CheckType, MVT::i8,
/*1723*/                OPC_MoveParent,
/*1724*/                OPC_MoveParent,
/*1725*/                OPC_MoveChild, 1,
/*1727*/                OPC_CheckOpcode, ISD::SRL,
/*1729*/                OPC_MoveChild, 0,
/*1731*/                OPC_CheckOpcode, ISD::LOAD,
/*1733*/                OPC_RecordMemRef,
/*1734*/                OPC_RecordNode, // #4 = 'ld' chained node
/*1735*/                OPC_CheckFoldableChainNode,
/*1736*/                OPC_RecordChild1, // #5 = $dst
/*1737*/                OPC_CheckPredicate, 2, // Predicate_unindexedload
/*1739*/                OPC_CheckPredicate, 3, // Predicate_loadi32
/*1741*/                OPC_MoveParent,
/*1742*/                OPC_MoveChild, 1,
/*1744*/                OPC_CheckSame, 2,
/*1746*/                OPC_MoveParent,
/*1747*/                OPC_MoveParent,
/*1748*/                OPC_CheckType, MVT::i32,
/*1750*/                OPC_MoveParent,
/*1751*/                OPC_MoveChild, 2,
/*1753*/                OPC_CheckSame, 5,
/*1755*/                OPC_MoveParent,
/*1756*/                OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*1758*/                OPC_CheckPredicate, 5, // Predicate_store
/*1760*/                OPC_CheckComplexPat, /*CP*/0, /*#*/5, // SelectAddr:$dst #6 #7 #8 #9 #10
/*1763*/                OPC_EmitMergeInputChains, 2, 0, 4, 
/*1767*/                OPC_EmitCopyToReg, 3, X86::CL,
/*1770*/                OPC_MorphNodeTo, TARGET_OPCODE(X86::SHRD32mrCL), 0|OPFL_Chain|OPFL_FlagInput|OPFL_MemRefs,
                            0/*#VTs*/, 6/*#Ops*/, 6, 7, 8, 9, 10, 1, 
                        // Src: (st:isVoid (or:i32 (shl:i32 GR32:i32:$src2, (sub:i8 32:i8, CL:i8:$amt)), (srl:i32 (ld:i32 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, CL:i8:$amt)), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                        // Dst: (SHRD32mrCL:isVoid addr:iPTR:$dst, GR32:i32:$src2)
/*1782*/              /*Scope*/ 66, /*->1849*/
/*1783*/                OPC_CheckInteger, 16, 
/*1785*/                OPC_MoveParent,
/*1786*/                OPC_RecordChild1, // #2 = $amt
/*1787*/                OPC_RecordChild1, // #3 = physreg input CL
/*1788*/                OPC_CheckType, MVT::i8,
/*1790*/                OPC_MoveParent,
/*1791*/                OPC_MoveParent,
/*1792*/                OPC_MoveChild, 1,
/*1794*/                OPC_CheckOpcode, ISD::SRL,
/*1796*/                OPC_MoveChild, 0,
/*1798*/                OPC_CheckOpcode, ISD::LOAD,
/*1800*/                OPC_RecordMemRef,
/*1801*/                OPC_RecordNode, // #4 = 'ld' chained node
/*1802*/                OPC_CheckFoldableChainNode,
/*1803*/                OPC_RecordChild1, // #5 = $dst
/*1804*/                OPC_CheckPredicate, 2, // Predicate_unindexedload
/*1806*/                OPC_CheckPredicate, 6, // Predicate_loadi16
/*1808*/                OPC_MoveParent,
/*1809*/                OPC_MoveChild, 1,
/*1811*/                OPC_CheckSame, 2,
/*1813*/                OPC_MoveParent,
/*1814*/                OPC_MoveParent,
/*1815*/                OPC_CheckType, MVT::i16,
/*1817*/                OPC_MoveParent,
/*1818*/                OPC_MoveChild, 2,
/*1820*/                OPC_CheckSame, 5,
/*1822*/                OPC_MoveParent,
/*1823*/                OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*1825*/                OPC_CheckPredicate, 5, // Predicate_store
/*1827*/                OPC_CheckComplexPat, /*CP*/0, /*#*/5, // SelectAddr:$dst #6 #7 #8 #9 #10
/*1830*/                OPC_EmitMergeInputChains, 2, 0, 4, 
/*1834*/                OPC_EmitCopyToReg, 3, X86::CL,
/*1837*/                OPC_MorphNodeTo, TARGET_OPCODE(X86::SHRD16mrCL), 0|OPFL_Chain|OPFL_FlagInput|OPFL_MemRefs,
                            0/*#VTs*/, 6/*#Ops*/, 6, 7, 8, 9, 10, 1, 
                        // Src: (st:isVoid (or:i16 (shl:i16 GR16:i16:$src2, (sub:i8 16:i8, CL:i8:$amt)), (srl:i16 (ld:i16 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, CL:i8:$amt)), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                        // Dst: (SHRD16mrCL:isVoid addr:iPTR:$dst, GR16:i16:$src2)
/*1849*/              0, /*End of Scope*/
/*1850*/            /*Scope*/ 72|128,1/*200*/, /*->2052*/
/*1852*/              OPC_MoveChild, 0,
/*1854*/              OPC_CheckOpcode, ISD::LOAD,
/*1856*/              OPC_RecordMemRef,
/*1857*/              OPC_RecordNode, // #1 = 'ld' chained node
/*1858*/              OPC_CheckFoldableChainNode,
/*1859*/              OPC_RecordChild1, // #2 = $dst
/*1860*/              OPC_CheckPredicate, 2, // Predicate_unindexedload
/*1862*/              OPC_Scope, 61, /*->1925*/ // 3 children in Scope
/*1864*/                OPC_CheckPredicate, 3, // Predicate_loadi32
/*1866*/                OPC_MoveParent,
/*1867*/                OPC_RecordChild1, // #3 = $amt1
/*1868*/                OPC_MoveChild, 1,
/*1870*/                OPC_CheckOpcode, ISD::Constant,
/*1872*/                OPC_CheckType, MVT::i8,
/*1874*/                OPC_MoveParent,
/*1875*/                OPC_MoveParent,
/*1876*/                OPC_MoveChild, 1,
/*1878*/                OPC_CheckOpcode, ISD::SRL,
/*1880*/                OPC_RecordChild0, // #4 = $src2
/*1881*/                OPC_MoveChild, 1,
/*1883*/                OPC_CheckOpcode, ISD::Constant,
/*1885*/                OPC_CheckType, MVT::i8,
/*1887*/                OPC_MoveParent,
/*1888*/                OPC_MoveParent,
/*1889*/                OPC_CheckPredicate, 10, // Predicate_shld
/*1891*/                OPC_CheckType, MVT::i32,
/*1893*/                OPC_MoveParent,
/*1894*/                OPC_MoveChild, 2,
/*1896*/                OPC_CheckSame, 2,
/*1898*/                OPC_MoveParent,
/*1899*/                OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*1901*/                OPC_CheckPredicate, 5, // Predicate_store
/*1903*/                OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #5 #6 #7 #8 #9
/*1906*/                OPC_EmitMergeInputChains, 2, 0, 1, 
/*1910*/                OPC_EmitConvertToTarget, 3,
/*1912*/                OPC_MorphNodeTo, TARGET_OPCODE(X86::SHLD32mri8), 0|OPFL_Chain|OPFL_MemRefs,
                            0/*#VTs*/, 7/*#Ops*/, 5, 6, 7, 8, 9, 4, 10, 
                        // Src: (st:isVoid (or:i32 (shl:i32 (ld:i32 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, (imm:i8):$amt1), (srl:i32 GR32:i32:$src2, (imm:i8)))<<P:Predicate_shld>>, addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                        // Dst: (SHLD32mri8:isVoid addr:iPTR:$dst, GR32:i32:$src2, (imm:i8):$amt1)
/*1925*/              /*Scope*/ 61, /*->1987*/
/*1926*/                OPC_CheckPredicate, 6, // Predicate_loadi16
/*1928*/                OPC_MoveParent,
/*1929*/                OPC_RecordChild1, // #3 = $amt1
/*1930*/                OPC_MoveChild, 1,
/*1932*/                OPC_CheckOpcode, ISD::Constant,
/*1934*/                OPC_CheckType, MVT::i8,
/*1936*/                OPC_MoveParent,
/*1937*/                OPC_MoveParent,
/*1938*/                OPC_MoveChild, 1,
/*1940*/                OPC_CheckOpcode, ISD::SRL,
/*1942*/                OPC_RecordChild0, // #4 = $src2
/*1943*/                OPC_MoveChild, 1,
/*1945*/                OPC_CheckOpcode, ISD::Constant,
/*1947*/                OPC_CheckType, MVT::i8,
/*1949*/                OPC_MoveParent,
/*1950*/                OPC_MoveParent,
/*1951*/                OPC_CheckPredicate, 10, // Predicate_shld
/*1953*/                OPC_CheckType, MVT::i16,
/*1955*/                OPC_MoveParent,
/*1956*/                OPC_MoveChild, 2,
/*1958*/                OPC_CheckSame, 2,
/*1960*/                OPC_MoveParent,
/*1961*/                OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*1963*/                OPC_CheckPredicate, 5, // Predicate_store
/*1965*/                OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #5 #6 #7 #8 #9
/*1968*/                OPC_EmitMergeInputChains, 2, 0, 1, 
/*1972*/                OPC_EmitConvertToTarget, 3,
/*1974*/                OPC_MorphNodeTo, TARGET_OPCODE(X86::SHLD16mri8), 0|OPFL_Chain|OPFL_MemRefs,
                            0/*#VTs*/, 7/*#Ops*/, 5, 6, 7, 8, 9, 4, 10, 
                        // Src: (st:isVoid (or:i16 (shl:i16 (ld:i16 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, (imm:i8):$amt1), (srl:i16 GR16:i16:$src2, (imm:i8)))<<P:Predicate_shld>>, addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                        // Dst: (SHLD16mri8:isVoid addr:iPTR:$dst, GR16:i16:$src2, (imm:i8):$amt1)
/*1987*/              /*Scope*/ 63, /*->2051*/
/*1988*/                OPC_CheckPredicate, 8, // Predicate_load
/*1990*/                OPC_CheckPredicate, 9, // Predicate_dsload
/*1992*/                OPC_MoveParent,
/*1993*/                OPC_RecordChild1, // #3 = $amt1
/*1994*/                OPC_MoveChild, 1,
/*1996*/                OPC_CheckOpcode, ISD::Constant,
/*1998*/                OPC_CheckType, MVT::i8,
/*2000*/                OPC_MoveParent,
/*2001*/                OPC_MoveParent,
/*2002*/                OPC_MoveChild, 1,
/*2004*/                OPC_CheckOpcode, ISD::SRL,
/*2006*/                OPC_RecordChild0, // #4 = $src2
/*2007*/                OPC_MoveChild, 1,
/*2009*/                OPC_CheckOpcode, ISD::Constant,
/*2011*/                OPC_CheckType, MVT::i8,
/*2013*/                OPC_MoveParent,
/*2014*/                OPC_MoveParent,
/*2015*/                OPC_CheckPredicate, 10, // Predicate_shld
/*2017*/                OPC_CheckType, MVT::i64,
/*2019*/                OPC_MoveParent,
/*2020*/                OPC_MoveChild, 2,
/*2022*/                OPC_CheckSame, 2,
/*2024*/                OPC_MoveParent,
/*2025*/                OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*2027*/                OPC_CheckPredicate, 5, // Predicate_store
/*2029*/                OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #5 #6 #7 #8 #9
/*2032*/                OPC_EmitMergeInputChains, 2, 0, 1, 
/*2036*/                OPC_EmitConvertToTarget, 3,
/*2038*/                OPC_MorphNodeTo, TARGET_OPCODE(X86::SHLD64mri8), 0|OPFL_Chain|OPFL_MemRefs,
                            0/*#VTs*/, 7/*#Ops*/, 5, 6, 7, 8, 9, 4, 10, 
                        // Src: (st:isVoid (or:i64 (shl:i64 (ld:i64 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>, (imm:i8):$amt1), (srl:i64 GR64:i64:$src2, (imm:i8)))<<P:Predicate_shld>>, addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                        // Dst: (SHLD64mri8:isVoid addr:iPTR:$dst, GR64:i64:$src2, (imm:i8):$amt1)
/*2051*/              0, /*End of Scope*/
/*2052*/            /*Scope*/ 46|128,1/*174*/, /*->2228*/
/*2054*/              OPC_RecordChild0, // #1 = $src2
/*2055*/              OPC_MoveChild, 1,
/*2057*/              OPC_CheckOpcode, ISD::Constant,
/*2059*/              OPC_CheckType, MVT::i8,
/*2061*/              OPC_MoveParent,
/*2062*/              OPC_MoveParent,
/*2063*/              OPC_MoveChild, 1,
/*2065*/              OPC_CheckOpcode, ISD::SRL,
/*2067*/              OPC_MoveChild, 0,
/*2069*/              OPC_CheckOpcode, ISD::LOAD,
/*2071*/              OPC_RecordMemRef,
/*2072*/              OPC_RecordNode, // #2 = 'ld' chained node
/*2073*/              OPC_CheckFoldableChainNode,
/*2074*/              OPC_RecordChild1, // #3 = $dst
/*2075*/              OPC_CheckPredicate, 2, // Predicate_unindexedload
/*2077*/              OPC_Scope, 48, /*->2127*/ // 3 children in Scope
/*2079*/                OPC_CheckPredicate, 3, // Predicate_loadi32
/*2081*/                OPC_MoveParent,
/*2082*/                OPC_RecordChild1, // #4 = $amt1
/*2083*/                OPC_MoveChild, 1,
/*2085*/                OPC_CheckOpcode, ISD::Constant,
/*2087*/                OPC_CheckType, MVT::i8,
/*2089*/                OPC_MoveParent,
/*2090*/                OPC_MoveParent,
/*2091*/                OPC_CheckPredicate, 7, // Predicate_shrd
/*2093*/                OPC_CheckType, MVT::i32,
/*2095*/                OPC_MoveParent,
/*2096*/                OPC_MoveChild, 2,
/*2098*/                OPC_CheckSame, 3,
/*2100*/                OPC_MoveParent,
/*2101*/                OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*2103*/                OPC_CheckPredicate, 5, // Predicate_store
/*2105*/                OPC_CheckComplexPat, /*CP*/0, /*#*/3, // SelectAddr:$dst #5 #6 #7 #8 #9
/*2108*/                OPC_EmitMergeInputChains, 2, 0, 2, 
/*2112*/                OPC_EmitConvertToTarget, 4,
/*2114*/                OPC_MorphNodeTo, TARGET_OPCODE(X86::SHRD32mri8), 0|OPFL_Chain|OPFL_MemRefs,
                            0/*#VTs*/, 7/*#Ops*/, 5, 6, 7, 8, 9, 1, 10, 
                        // Src: (st:isVoid (or:i32 (shl:i32 GR32:i32:$src2, (imm:i8)), (srl:i32 (ld:i32 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, (imm:i8):$amt1))<<P:Predicate_shrd>>, addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                        // Dst: (SHRD32mri8:isVoid addr:iPTR:$dst, GR32:i32:$src2, (imm:i8):$amt1)
/*2127*/              /*Scope*/ 48, /*->2176*/
/*2128*/                OPC_CheckPredicate, 6, // Predicate_loadi16
/*2130*/                OPC_MoveParent,
/*2131*/                OPC_RecordChild1, // #4 = $amt1
/*2132*/                OPC_MoveChild, 1,
/*2134*/                OPC_CheckOpcode, ISD::Constant,
/*2136*/                OPC_CheckType, MVT::i8,
/*2138*/                OPC_MoveParent,
/*2139*/                OPC_MoveParent,
/*2140*/                OPC_CheckPredicate, 7, // Predicate_shrd
/*2142*/                OPC_CheckType, MVT::i16,
/*2144*/                OPC_MoveParent,
/*2145*/                OPC_MoveChild, 2,
/*2147*/                OPC_CheckSame, 3,
/*2149*/                OPC_MoveParent,
/*2150*/                OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*2152*/                OPC_CheckPredicate, 5, // Predicate_store
/*2154*/                OPC_CheckComplexPat, /*CP*/0, /*#*/3, // SelectAddr:$dst #5 #6 #7 #8 #9
/*2157*/                OPC_EmitMergeInputChains, 2, 0, 2, 
/*2161*/                OPC_EmitConvertToTarget, 4,
/*2163*/                OPC_MorphNodeTo, TARGET_OPCODE(X86::SHRD16mri8), 0|OPFL_Chain|OPFL_MemRefs,
                            0/*#VTs*/, 7/*#Ops*/, 5, 6, 7, 8, 9, 1, 10, 
                        // Src: (st:isVoid (or:i16 (shl:i16 GR16:i16:$src2, (imm:i8)), (srl:i16 (ld:i16 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, (imm:i8):$amt1))<<P:Predicate_shrd>>, addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                        // Dst: (SHRD16mri8:isVoid addr:iPTR:$dst, GR16:i16:$src2, (imm:i8):$amt1)
/*2176*/              /*Scope*/ 50, /*->2227*/
/*2177*/                OPC_CheckPredicate, 8, // Predicate_load
/*2179*/                OPC_CheckPredicate, 9, // Predicate_dsload
/*2181*/                OPC_MoveParent,
/*2182*/                OPC_RecordChild1, // #4 = $amt1
/*2183*/                OPC_MoveChild, 1,
/*2185*/                OPC_CheckOpcode, ISD::Constant,
/*2187*/                OPC_CheckType, MVT::i8,
/*2189*/                OPC_MoveParent,
/*2190*/                OPC_MoveParent,
/*2191*/                OPC_CheckPredicate, 7, // Predicate_shrd
/*2193*/                OPC_CheckType, MVT::i64,
/*2195*/                OPC_MoveParent,
/*2196*/                OPC_MoveChild, 2,
/*2198*/                OPC_CheckSame, 3,
/*2200*/                OPC_MoveParent,
/*2201*/                OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*2203*/                OPC_CheckPredicate, 5, // Predicate_store
/*2205*/                OPC_CheckComplexPat, /*CP*/0, /*#*/3, // SelectAddr:$dst #5 #6 #7 #8 #9
/*2208*/                OPC_EmitMergeInputChains, 2, 0, 2, 
/*2212*/                OPC_EmitConvertToTarget, 4,
/*2214*/                OPC_MorphNodeTo, TARGET_OPCODE(X86::SHRD64mri8), 0|OPFL_Chain|OPFL_MemRefs,
                            0/*#VTs*/, 7/*#Ops*/, 5, 6, 7, 8, 9, 1, 10, 
                        // Src: (st:isVoid (or:i64 (shl:i64 GR64:i64:$src2, (imm:i8)), (srl:i64 (ld:i64 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>, (imm:i8):$amt1))<<P:Predicate_shrd>>, addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                        // Dst: (SHRD64mri8:isVoid addr:iPTR:$dst, GR64:i64:$src2, (imm:i8):$amt1)
/*2227*/              0, /*End of Scope*/
/*2228*/            0, /*End of Scope*/
                  /*SwitchOpcode*/ 53|128,3/*437*/,  ISD::LOAD,// ->2669
/*2232*/            OPC_RecordMemRef,
/*2233*/            OPC_RecordNode, // #1 = 'ld' chained node
/*2234*/            OPC_CheckFoldableChainNode,
/*2235*/            OPC_RecordChild1, // #2 = $dst
/*2236*/            OPC_CheckPredicate, 2, // Predicate_unindexedload
/*2238*/            OPC_Scope, 75|128,1/*203*/, /*->2444*/ // 4 children in Scope
/*2241*/              OPC_CheckPredicate, 8, // Predicate_load
/*2243*/              OPC_Scope, 113, /*->2358*/ // 2 children in Scope
/*2245*/                OPC_MoveParent,
/*2246*/                OPC_RecordChild1, // #3 = $src
/*2247*/                OPC_MoveChild, 1,
/*2249*/                OPC_CheckOpcode, ISD::Constant,
/*2251*/                OPC_CheckPredicate, 11, // Predicate_immSext8
/*2253*/                OPC_MoveParent,
/*2254*/                OPC_SwitchType /*3 cases */, 32,  MVT::i16,// ->2289
/*2257*/                  OPC_MoveParent,
/*2258*/                  OPC_MoveChild, 2,
/*2260*/                  OPC_CheckSame, 2,
/*2262*/                  OPC_MoveParent,
/*2263*/                  OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*2265*/                  OPC_CheckPredicate, 5, // Predicate_store
/*2267*/                  OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #4 #5 #6 #7 #8
/*2270*/                  OPC_EmitMergeInputChains, 2, 0, 1, 
/*2274*/                  OPC_EmitConvertToTarget, 3,
/*2276*/                  OPC_MorphNodeTo, TARGET_OPCODE(X86::OR16mi8), 0|OPFL_Chain|OPFL_MemRefs,
                              1/*#VTs*/, MVT::i32, 6/*#Ops*/, 4, 5, 6, 7, 8, 9, 
                          // Src: (st:isVoid (or:i16 (ld:i16 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:i16)<<P:Predicate_immSext8>>:$src), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                          // Dst: (OR16mi8:isVoid addr:iPTR:$dst, (imm:i16):$src)
                        /*SwitchType*/ 32,  MVT::i32,// ->2323
/*2291*/                  OPC_MoveParent,
/*2292*/                  OPC_MoveChild, 2,
/*2294*/                  OPC_CheckSame, 2,
/*2296*/                  OPC_MoveParent,
/*2297*/                  OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*2299*/                  OPC_CheckPredicate, 5, // Predicate_store
/*2301*/                  OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #4 #5 #6 #7 #8
/*2304*/                  OPC_EmitMergeInputChains, 2, 0, 1, 
/*2308*/                  OPC_EmitConvertToTarget, 3,
/*2310*/                  OPC_MorphNodeTo, TARGET_OPCODE(X86::OR32mi8), 0|OPFL_Chain|OPFL_MemRefs,
                              1/*#VTs*/, MVT::i32, 6/*#Ops*/, 4, 5, 6, 7, 8, 9, 
                          // Src: (st:isVoid (or:i32 (ld:i32 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:i32)<<P:Predicate_immSext8>>:$src), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                          // Dst: (OR32mi8:isVoid addr:iPTR:$dst, (imm:i32):$src)
                        /*SwitchType*/ 32,  MVT::i64,// ->2357
/*2325*/                  OPC_MoveParent,
/*2326*/                  OPC_MoveChild, 2,
/*2328*/                  OPC_CheckSame, 2,
/*2330*/                  OPC_MoveParent,
/*2331*/                  OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*2333*/                  OPC_CheckPredicate, 5, // Predicate_store
/*2335*/                  OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #4 #5 #6 #7 #8
/*2338*/                  OPC_EmitMergeInputChains, 2, 0, 1, 
/*2342*/                  OPC_EmitConvertToTarget, 3,
/*2344*/                  OPC_MorphNodeTo, TARGET_OPCODE(X86::OR64mi8), 0|OPFL_Chain|OPFL_MemRefs,
                              1/*#VTs*/, MVT::i32, 6/*#Ops*/, 4, 5, 6, 7, 8, 9, 
                          // Src: (st:isVoid (or:i64 (ld:i64 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:i64)<<P:Predicate_immSext8>>:$src), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                          // Dst: (OR64mi8:isVoid addr:iPTR:$dst, (imm:i64):$src)
                        0, // EndSwitchType
/*2358*/              /*Scope*/ 84, /*->2443*/
/*2359*/                OPC_CheckPredicate, 9, // Predicate_dsload
/*2361*/                OPC_MoveParent,
/*2362*/                OPC_RecordChild1, // #3 = $src
/*2363*/                OPC_MoveChild, 1,
/*2365*/                OPC_CheckOpcode, ISD::Constant,
/*2367*/                OPC_Scope, 37, /*->2406*/ // 2 children in Scope
/*2369*/                  OPC_CheckPredicate, 12, // Predicate_i64immSExt32
/*2371*/                  OPC_MoveParent,
/*2372*/                  OPC_CheckType, MVT::i64,
/*2374*/                  OPC_MoveParent,
/*2375*/                  OPC_MoveChild, 2,
/*2377*/                  OPC_CheckSame, 2,
/*2379*/                  OPC_MoveParent,
/*2380*/                  OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*2382*/                  OPC_CheckPredicate, 5, // Predicate_store
/*2384*/                  OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #4 #5 #6 #7 #8
/*2387*/                  OPC_EmitMergeInputChains, 2, 0, 1, 
/*2391*/                  OPC_EmitConvertToTarget, 3,
/*2393*/                  OPC_MorphNodeTo, TARGET_OPCODE(X86::OR64mi32), 0|OPFL_Chain|OPFL_MemRefs,
                              1/*#VTs*/, MVT::i32, 6/*#Ops*/, 4, 5, 6, 7, 8, 9, 
                          // Src: (st:isVoid (or:i64 (ld:i64 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>, (imm:i64)<<P:Predicate_i64immSExt32>>:$src), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                          // Dst: (OR64mi32:isVoid addr:iPTR:$dst, (imm:i64):$src)
/*2406*/                /*Scope*/ 35, /*->2442*/
/*2407*/                  OPC_MoveParent,
/*2408*/                  OPC_CheckType, MVT::i8,
/*2410*/                  OPC_MoveParent,
/*2411*/                  OPC_MoveChild, 2,
/*2413*/                  OPC_CheckSame, 2,
/*2415*/                  OPC_MoveParent,
/*2416*/                  OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*2418*/                  OPC_CheckPredicate, 5, // Predicate_store
/*2420*/                  OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #4 #5 #6 #7 #8
/*2423*/                  OPC_EmitMergeInputChains, 2, 0, 1, 
/*2427*/                  OPC_EmitConvertToTarget, 3,
/*2429*/                  OPC_MorphNodeTo, TARGET_OPCODE(X86::OR8mi), 0|OPFL_Chain|OPFL_MemRefs,
                              1/*#VTs*/, MVT::i32, 6/*#Ops*/, 4, 5, 6, 7, 8, 9, 
                          // Src: (st:isVoid (or:i8 (ld:i8 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>, (imm:i8):$src), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                          // Dst: (OR8mi:isVoid addr:iPTR:$dst, (imm:i8):$src)
/*2442*/                0, /*End of Scope*/
/*2443*/              0, /*End of Scope*/
/*2444*/            /*Scope*/ 43, /*->2488*/
/*2445*/              OPC_CheckPredicate, 6, // Predicate_loadi16
/*2447*/              OPC_MoveParent,
/*2448*/              OPC_RecordChild1, // #3 = $src
/*2449*/              OPC_MoveChild, 1,
/*2451*/              OPC_CheckOpcode, ISD::Constant,
/*2453*/              OPC_MoveParent,
/*2454*/              OPC_CheckType, MVT::i16,
/*2456*/              OPC_MoveParent,
/*2457*/              OPC_MoveChild, 2,
/*2459*/              OPC_CheckSame, 2,
/*2461*/              OPC_MoveParent,
/*2462*/              OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*2464*/              OPC_CheckPredicate, 5, // Predicate_store
/*2466*/              OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #4 #5 #6 #7 #8
/*2469*/              OPC_EmitMergeInputChains, 2, 0, 1, 
/*2473*/              OPC_EmitConvertToTarget, 3,
/*2475*/              OPC_MorphNodeTo, TARGET_OPCODE(X86::OR16mi), 0|OPFL_Chain|OPFL_MemRefs,
                          1/*#VTs*/, MVT::i32, 6/*#Ops*/, 4, 5, 6, 7, 8, 9, 
                      // Src: (st:isVoid (or:i16 (ld:i16 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, (imm:i16):$src), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                      // Dst: (OR16mi:isVoid addr:iPTR:$dst, (imm:i16):$src)
/*2488*/            /*Scope*/ 43, /*->2532*/
/*2489*/              OPC_CheckPredicate, 3, // Predicate_loadi32
/*2491*/              OPC_MoveParent,
/*2492*/              OPC_RecordChild1, // #3 = $src
/*2493*/              OPC_MoveChild, 1,
/*2495*/              OPC_CheckOpcode, ISD::Constant,
/*2497*/              OPC_MoveParent,
/*2498*/              OPC_CheckType, MVT::i32,
/*2500*/              OPC_MoveParent,
/*2501*/              OPC_MoveChild, 2,
/*2503*/              OPC_CheckSame, 2,
/*2505*/              OPC_MoveParent,
/*2506*/              OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*2508*/              OPC_CheckPredicate, 5, // Predicate_store
/*2510*/              OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #4 #5 #6 #7 #8
/*2513*/              OPC_EmitMergeInputChains, 2, 0, 1, 
/*2517*/              OPC_EmitConvertToTarget, 3,
/*2519*/              OPC_MorphNodeTo, TARGET_OPCODE(X86::OR32mi), 0|OPFL_Chain|OPFL_MemRefs,
                          1/*#VTs*/, MVT::i32, 6/*#Ops*/, 4, 5, 6, 7, 8, 9, 
                      // Src: (st:isVoid (or:i32 (ld:i32 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, (imm:i32):$src), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                      // Dst: (OR32mi:isVoid addr:iPTR:$dst, (imm:i32):$src)
/*2532*/            /*Scope*/ 6|128,1/*134*/, /*->2668*/
/*2534*/              OPC_CheckPredicate, 8, // Predicate_load
/*2536*/              OPC_MoveParent,
/*2537*/              OPC_RecordChild1, // #3 = $src
/*2538*/              OPC_SwitchType /*4 cases */, 30,  MVT::i8,// ->2571
/*2541*/                OPC_MoveParent,
/*2542*/                OPC_MoveChild, 2,
/*2544*/                OPC_CheckSame, 2,
/*2546*/                OPC_MoveParent,
/*2547*/                OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*2549*/                OPC_CheckPredicate, 5, // Predicate_store
/*2551*/                OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #4 #5 #6 #7 #8
/*2554*/                OPC_EmitMergeInputChains, 2, 0, 1, 
/*2558*/                OPC_MorphNodeTo, TARGET_OPCODE(X86::OR8mr), 0|OPFL_Chain|OPFL_MemRefs,
                            1/*#VTs*/, MVT::i32, 6/*#Ops*/, 4, 5, 6, 7, 8, 3, 
                        // Src: (st:isVoid (or:i8 (ld:i8 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR8:i8:$src), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                        // Dst: (OR8mr:isVoid addr:iPTR:$dst, GR8:i8:$src)
                      /*SwitchType*/ 30,  MVT::i16,// ->2603
/*2573*/                OPC_MoveParent,
/*2574*/                OPC_MoveChild, 2,
/*2576*/                OPC_CheckSame, 2,
/*2578*/                OPC_MoveParent,
/*2579*/                OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*2581*/                OPC_CheckPredicate, 5, // Predicate_store
/*2583*/                OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #4 #5 #6 #7 #8
/*2586*/                OPC_EmitMergeInputChains, 2, 0, 1, 
/*2590*/                OPC_MorphNodeTo, TARGET_OPCODE(X86::OR16mr), 0|OPFL_Chain|OPFL_MemRefs,
                            1/*#VTs*/, MVT::i32, 6/*#Ops*/, 4, 5, 6, 7, 8, 3, 
                        // Src: (st:isVoid (or:i16 (ld:i16 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR16:i16:$src), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                        // Dst: (OR16mr:isVoid addr:iPTR:$dst, GR16:i16:$src)
                      /*SwitchType*/ 30,  MVT::i32,// ->2635
/*2605*/                OPC_MoveParent,
/*2606*/                OPC_MoveChild, 2,
/*2608*/                OPC_CheckSame, 2,
/*2610*/                OPC_MoveParent,
/*2611*/                OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*2613*/                OPC_CheckPredicate, 5, // Predicate_store
/*2615*/                OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #4 #5 #6 #7 #8
/*2618*/                OPC_EmitMergeInputChains, 2, 0, 1, 
/*2622*/                OPC_MorphNodeTo, TARGET_OPCODE(X86::OR32mr), 0|OPFL_Chain|OPFL_MemRefs,
                            1/*#VTs*/, MVT::i32, 6/*#Ops*/, 4, 5, 6, 7, 8, 3, 
                        // Src: (st:isVoid (or:i32 (ld:i32 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR32:i32:$src), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                        // Dst: (OR32mr:isVoid addr:iPTR:$dst, GR32:i32:$src)
                      /*SwitchType*/ 30,  MVT::i64,// ->2667
/*2637*/                OPC_MoveParent,
/*2638*/                OPC_MoveChild, 2,
/*2640*/                OPC_CheckSame, 2,
/*2642*/                OPC_MoveParent,
/*2643*/                OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*2645*/                OPC_CheckPredicate, 5, // Predicate_store
/*2647*/                OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #4 #5 #6 #7 #8
/*2650*/                OPC_EmitMergeInputChains, 2, 0, 1, 
/*2654*/                OPC_MorphNodeTo, TARGET_OPCODE(X86::OR64mr), 0|OPFL_Chain|OPFL_MemRefs,
                            1/*#VTs*/, MVT::i32, 6/*#Ops*/, 4, 5, 6, 7, 8, 3, 
                        // Src: (st:isVoid (or:i64 (ld:i64 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR64:i64:$src), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                        // Dst: (OR64mr:isVoid addr:iPTR:$dst, GR64:i64:$src)
                      0, // EndSwitchType
/*2668*/            0, /*End of Scope*/
                  0, // EndSwitchOpcode
/*2670*/        /*Scope*/ 16|128,1/*144*/, /*->2816*/
/*2672*/          OPC_RecordChild0, // #1 = $src
/*2673*/          OPC_MoveChild, 1,
/*2675*/          OPC_CheckOpcode, ISD::LOAD,
/*2677*/          OPC_RecordMemRef,
/*2678*/          OPC_RecordNode, // #2 = 'ld' chained node
/*2679*/          OPC_CheckFoldableChainNode,
/*2680*/          OPC_RecordChild1, // #3 = $dst
/*2681*/          OPC_CheckPredicate, 2, // Predicate_unindexedload
/*2683*/          OPC_CheckPredicate, 8, // Predicate_load
/*2685*/          OPC_MoveParent,
/*2686*/          OPC_SwitchType /*4 cases */, 30,  MVT::i8,// ->2719
/*2689*/            OPC_MoveParent,
/*2690*/            OPC_MoveChild, 2,
/*2692*/            OPC_CheckSame, 3,
/*2694*/            OPC_MoveParent,
/*2695*/            OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*2697*/            OPC_CheckPredicate, 5, // Predicate_store
/*2699*/            OPC_CheckComplexPat, /*CP*/0, /*#*/3, // SelectAddr:$dst #4 #5 #6 #7 #8
/*2702*/            OPC_EmitMergeInputChains, 2, 0, 2, 
/*2706*/            OPC_MorphNodeTo, TARGET_OPCODE(X86::OR8mr), 0|OPFL_Chain|OPFL_MemRefs,
                        1/*#VTs*/, MVT::i32, 6/*#Ops*/, 4, 5, 6, 7, 8, 1, 
                    // Src: (st:isVoid (or:i8 GR8:i8:$src, (ld:i8 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>>), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                    // Dst: (OR8mr:isVoid addr:iPTR:$dst, GR8:i8:$src)
                  /*SwitchType*/ 30,  MVT::i16,// ->2751
/*2721*/            OPC_MoveParent,
/*2722*/            OPC_MoveChild, 2,
/*2724*/            OPC_CheckSame, 3,
/*2726*/            OPC_MoveParent,
/*2727*/            OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*2729*/            OPC_CheckPredicate, 5, // Predicate_store
/*2731*/            OPC_CheckComplexPat, /*CP*/0, /*#*/3, // SelectAddr:$dst #4 #5 #6 #7 #8
/*2734*/            OPC_EmitMergeInputChains, 2, 0, 2, 
/*2738*/            OPC_MorphNodeTo, TARGET_OPCODE(X86::OR16mr), 0|OPFL_Chain|OPFL_MemRefs,
                        1/*#VTs*/, MVT::i32, 6/*#Ops*/, 4, 5, 6, 7, 8, 1, 
                    // Src: (st:isVoid (or:i16 GR16:i16:$src, (ld:i16 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>>), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                    // Dst: (OR16mr:isVoid addr:iPTR:$dst, GR16:i16:$src)
                  /*SwitchType*/ 30,  MVT::i32,// ->2783
/*2753*/            OPC_MoveParent,
/*2754*/            OPC_MoveChild, 2,
/*2756*/            OPC_CheckSame, 3,
/*2758*/            OPC_MoveParent,
/*2759*/            OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*2761*/            OPC_CheckPredicate, 5, // Predicate_store
/*2763*/            OPC_CheckComplexPat, /*CP*/0, /*#*/3, // SelectAddr:$dst #4 #5 #6 #7 #8
/*2766*/            OPC_EmitMergeInputChains, 2, 0, 2, 
/*2770*/            OPC_MorphNodeTo, TARGET_OPCODE(X86::OR32mr), 0|OPFL_Chain|OPFL_MemRefs,
                        1/*#VTs*/, MVT::i32, 6/*#Ops*/, 4, 5, 6, 7, 8, 1, 
                    // Src: (st:isVoid (or:i32 GR32:i32:$src, (ld:i32 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>>), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                    // Dst: (OR32mr:isVoid addr:iPTR:$dst, GR32:i32:$src)
                  /*SwitchType*/ 30,  MVT::i64,// ->2815
/*2785*/            OPC_MoveParent,
/*2786*/            OPC_MoveChild, 2,
/*2788*/            OPC_CheckSame, 3,
/*2790*/            OPC_MoveParent,
/*2791*/            OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*2793*/            OPC_CheckPredicate, 5, // Predicate_store
/*2795*/            OPC_CheckComplexPat, /*CP*/0, /*#*/3, // SelectAddr:$dst #4 #5 #6 #7 #8
/*2798*/            OPC_EmitMergeInputChains, 2, 0, 2, 
/*2802*/            OPC_MorphNodeTo, TARGET_OPCODE(X86::OR64mr), 0|OPFL_Chain|OPFL_MemRefs,
                        1/*#VTs*/, MVT::i32, 6/*#Ops*/, 4, 5, 6, 7, 8, 1, 
                    // Src: (st:isVoid (or:i64 GR64:i64:$src, (ld:i64 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>>), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                    // Dst: (OR64mr:isVoid addr:iPTR:$dst, GR64:i64:$src)
                  0, // EndSwitchType
/*2816*/        0, /*End of Scope*/
              /*SwitchOpcode*/ 61|128,5/*701*/,  ISD::SHL,// ->3521
/*2820*/        OPC_MoveChild, 0,
/*2822*/        OPC_CheckOpcode, ISD::LOAD,
/*2824*/        OPC_RecordMemRef,
/*2825*/        OPC_RecordNode, // #1 = 'ld' chained node
/*2826*/        OPC_CheckFoldableChainNode,
/*2827*/        OPC_RecordChild1, // #2 = $dst
/*2828*/        OPC_CheckPredicate, 2, // Predicate_unindexedload
/*2830*/        OPC_Scope, 46, /*->2878*/ // 13 children in Scope
/*2832*/          OPC_CheckPredicate, 8, // Predicate_load
/*2834*/          OPC_CheckPredicate, 9, // Predicate_dsload
/*2836*/          OPC_MoveParent,
/*2837*/          OPC_MoveChild, 1,
/*2839*/          OPC_CheckAndImm, 31, 
/*2841*/          OPC_RecordChild0, // #3 = physreg input CL
/*2842*/          OPC_CheckType, MVT::i8,
/*2844*/          OPC_MoveParent,
/*2845*/          OPC_CheckType, MVT::i8,
/*2847*/          OPC_MoveParent,
/*2848*/          OPC_MoveChild, 2,
/*2850*/          OPC_CheckSame, 2,
/*2852*/          OPC_MoveParent,
/*2853*/          OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*2855*/          OPC_CheckPredicate, 5, // Predicate_store
/*2857*/          OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #4 #5 #6 #7 #8
/*2860*/          OPC_EmitMergeInputChains, 2, 0, 1, 
/*2864*/          OPC_EmitCopyToReg, 3, X86::CL,
/*2867*/          OPC_MorphNodeTo, TARGET_OPCODE(X86::SHL8mCL), 0|OPFL_Chain|OPFL_FlagInput|OPFL_MemRefs,
                      0/*#VTs*/, 5/*#Ops*/, 4, 5, 6, 7, 8, 
                  // Src: (st:isVoid (shl:i8 (ld:i8 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>, (and:i8 CL:i8, 31:i8)), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                  // Dst: (SHL8mCL:isVoid addr:iPTR:$dst)
/*2878*/        /*Scope*/ 44, /*->2923*/
/*2879*/          OPC_CheckPredicate, 6, // Predicate_loadi16
/*2881*/          OPC_MoveParent,
/*2882*/          OPC_MoveChild, 1,
/*2884*/          OPC_CheckAndImm, 31, 
/*2886*/          OPC_RecordChild0, // #3 = physreg input CL
/*2887*/          OPC_CheckType, MVT::i8,
/*2889*/          OPC_MoveParent,
/*2890*/          OPC_CheckType, MVT::i16,
/*2892*/          OPC_MoveParent,
/*2893*/          OPC_MoveChild, 2,
/*2895*/          OPC_CheckSame, 2,
/*2897*/          OPC_MoveParent,
/*2898*/          OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*2900*/          OPC_CheckPredicate, 5, // Predicate_store
/*2902*/          OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #4 #5 #6 #7 #8
/*2905*/          OPC_EmitMergeInputChains, 2, 0, 1, 
/*2909*/          OPC_EmitCopyToReg, 3, X86::CL,
/*2912*/          OPC_MorphNodeTo, TARGET_OPCODE(X86::SHL16mCL), 0|OPFL_Chain|OPFL_FlagInput|OPFL_MemRefs,
                      0/*#VTs*/, 5/*#Ops*/, 4, 5, 6, 7, 8, 
                  // Src: (st:isVoid (shl:i16 (ld:i16 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, (and:i8 CL:i8, 31:i8)), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                  // Dst: (SHL16mCL:isVoid addr:iPTR:$dst)
/*2923*/        /*Scope*/ 44, /*->2968*/
/*2924*/          OPC_CheckPredicate, 3, // Predicate_loadi32
/*2926*/          OPC_MoveParent,
/*2927*/          OPC_MoveChild, 1,
/*2929*/          OPC_CheckAndImm, 31, 
/*2931*/          OPC_RecordChild0, // #3 = physreg input CL
/*2932*/          OPC_CheckType, MVT::i8,
/*2934*/          OPC_MoveParent,
/*2935*/          OPC_CheckType, MVT::i32,
/*2937*/          OPC_MoveParent,
/*2938*/          OPC_MoveChild, 2,
/*2940*/          OPC_CheckSame, 2,
/*2942*/          OPC_MoveParent,
/*2943*/          OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*2945*/          OPC_CheckPredicate, 5, // Predicate_store
/*2947*/          OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #4 #5 #6 #7 #8
/*2950*/          OPC_EmitMergeInputChains, 2, 0, 1, 
/*2954*/          OPC_EmitCopyToReg, 3, X86::CL,
/*2957*/          OPC_MorphNodeTo, TARGET_OPCODE(X86::SHL32mCL), 0|OPFL_Chain|OPFL_FlagInput|OPFL_MemRefs,
                      0/*#VTs*/, 5/*#Ops*/, 4, 5, 6, 7, 8, 
                  // Src: (st:isVoid (shl:i32 (ld:i32 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, (and:i8 CL:i8, 31:i8)), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                  // Dst: (SHL32mCL:isVoid addr:iPTR:$dst)
/*2968*/        /*Scope*/ 83, /*->3052*/
/*2969*/          OPC_CheckPredicate, 8, // Predicate_load
/*2971*/          OPC_CheckPredicate, 9, // Predicate_dsload
/*2973*/          OPC_MoveParent,
/*2974*/          OPC_MoveChild, 1,
/*2976*/          OPC_CheckType, MVT::i8,
/*2978*/          OPC_Scope, 37, /*->3017*/ // 2 children in Scope
/*2980*/            OPC_CheckAndImm, 63, 
/*2982*/            OPC_RecordChild0, // #3 = physreg input CL
/*2983*/            OPC_MoveParent,
/*2984*/            OPC_CheckType, MVT::i64,
/*2986*/            OPC_MoveParent,
/*2987*/            OPC_MoveChild, 2,
/*2989*/            OPC_CheckSame, 2,
/*2991*/            OPC_MoveParent,
/*2992*/            OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*2994*/            OPC_CheckPredicate, 5, // Predicate_store
/*2996*/            OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #4 #5 #6 #7 #8
/*2999*/            OPC_EmitMergeInputChains, 2, 0, 1, 
/*3003*/            OPC_EmitCopyToReg, 3, X86::CL,
/*3006*/            OPC_MorphNodeTo, TARGET_OPCODE(X86::SHL64mCL), 0|OPFL_Chain|OPFL_FlagInput|OPFL_MemRefs,
                        0/*#VTs*/, 5/*#Ops*/, 4, 5, 6, 7, 8, 
                    // Src: (st:isVoid (shl:i64 (ld:i64 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>, (and:i8 CL:i8, 63:i8)), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                    // Dst: (SHL64mCL:isVoid addr:iPTR:$dst)
/*3017*/          /*Scope*/ 33, /*->3051*/
/*3018*/            OPC_CheckInteger, 1, 
/*3020*/            OPC_MoveParent,
/*3021*/            OPC_CheckType, MVT::i8,
/*3023*/            OPC_MoveParent,
/*3024*/            OPC_MoveChild, 2,
/*3026*/            OPC_CheckSame, 2,
/*3028*/            OPC_MoveParent,
/*3029*/            OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*3031*/            OPC_CheckPredicate, 5, // Predicate_store
/*3033*/            OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #3 #4 #5 #6 #7
/*3036*/            OPC_EmitMergeInputChains, 2, 0, 1, 
/*3040*/            OPC_MorphNodeTo, TARGET_OPCODE(X86::SHL8m1), 0|OPFL_Chain|OPFL_MemRefs,
                        0/*#VTs*/, 5/*#Ops*/, 3, 4, 5, 6, 7, 
                    // Src: (st:isVoid (shl:i8 (ld:i8 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>, 1:i8), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                    // Dst: (SHL8m1:isVoid addr:iPTR:$dst)
/*3051*/          0, /*End of Scope*/
/*3052*/        /*Scope*/ 40, /*->3093*/
/*3053*/          OPC_CheckPredicate, 6, // Predicate_loadi16
/*3055*/          OPC_MoveParent,
/*3056*/          OPC_MoveChild, 1,
/*3058*/          OPC_CheckInteger, 1, 
/*3060*/          OPC_CheckType, MVT::i8,
/*3062*/          OPC_MoveParent,
/*3063*/          OPC_CheckType, MVT::i16,
/*3065*/          OPC_MoveParent,
/*3066*/          OPC_MoveChild, 2,
/*3068*/          OPC_CheckSame, 2,
/*3070*/          OPC_MoveParent,
/*3071*/          OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*3073*/          OPC_CheckPredicate, 5, // Predicate_store
/*3075*/          OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #3 #4 #5 #6 #7
/*3078*/          OPC_EmitMergeInputChains, 2, 0, 1, 
/*3082*/          OPC_MorphNodeTo, TARGET_OPCODE(X86::SHL16m1), 0|OPFL_Chain|OPFL_MemRefs,
                      0/*#VTs*/, 5/*#Ops*/, 3, 4, 5, 6, 7, 
                  // Src: (st:isVoid (shl:i16 (ld:i16 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, 1:i8), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                  // Dst: (SHL16m1:isVoid addr:iPTR:$dst)
/*3093*/        /*Scope*/ 40, /*->3134*/
/*3094*/          OPC_CheckPredicate, 3, // Predicate_loadi32
/*3096*/          OPC_MoveParent,
/*3097*/          OPC_MoveChild, 1,
/*3099*/          OPC_CheckInteger, 1, 
/*3101*/          OPC_CheckType, MVT::i8,
/*3103*/          OPC_MoveParent,
/*3104*/          OPC_CheckType, MVT::i32,
/*3106*/          OPC_MoveParent,
/*3107*/          OPC_MoveChild, 2,
/*3109*/          OPC_CheckSame, 2,
/*3111*/          OPC_MoveParent,
/*3112*/          OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*3114*/          OPC_CheckPredicate, 5, // Predicate_store
/*3116*/          OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #3 #4 #5 #6 #7
/*3119*/          OPC_EmitMergeInputChains, 2, 0, 1, 
/*3123*/          OPC_MorphNodeTo, TARGET_OPCODE(X86::SHL32m1), 0|OPFL_Chain|OPFL_MemRefs,
                      0/*#VTs*/, 5/*#Ops*/, 3, 4, 5, 6, 7, 
                  // Src: (st:isVoid (shl:i32 (ld:i32 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, 1:i8), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                  // Dst: (SHL32m1:isVoid addr:iPTR:$dst)
/*3134*/        /*Scope*/ 87, /*->3222*/
/*3135*/          OPC_CheckPredicate, 8, // Predicate_load
/*3137*/          OPC_CheckPredicate, 9, // Predicate_dsload
/*3139*/          OPC_MoveParent,
/*3140*/          OPC_Scope, 37, /*->3179*/ // 2 children in Scope
/*3142*/            OPC_MoveChild, 1,
/*3144*/            OPC_CheckInteger, 1, 
/*3146*/            OPC_CheckType, MVT::i8,
/*3148*/            OPC_MoveParent,
/*3149*/            OPC_CheckType, MVT::i64,
/*3151*/            OPC_MoveParent,
/*3152*/            OPC_MoveChild, 2,
/*3154*/            OPC_CheckSame, 2,
/*3156*/            OPC_MoveParent,
/*3157*/            OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*3159*/            OPC_CheckPredicate, 5, // Predicate_store
/*3161*/            OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #3 #4 #5 #6 #7
/*3164*/            OPC_EmitMergeInputChains, 2, 0, 1, 
/*3168*/            OPC_MorphNodeTo, TARGET_OPCODE(X86::SHL64m1), 0|OPFL_Chain|OPFL_MemRefs,
                        0/*#VTs*/, 5/*#Ops*/, 3, 4, 5, 6, 7, 
                    // Src: (st:isVoid (shl:i64 (ld:i64 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>, 1:i8), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                    // Dst: (SHL64m1:isVoid addr:iPTR:$dst)
/*3179*/          /*Scope*/ 41, /*->3221*/
/*3180*/            OPC_RecordChild1, // #3 = $src
/*3181*/            OPC_MoveChild, 1,
/*3183*/            OPC_CheckOpcode, ISD::Constant,
/*3185*/            OPC_CheckType, MVT::i8,
/*3187*/            OPC_MoveParent,
/*3188*/            OPC_CheckType, MVT::i8,
/*3190*/            OPC_MoveParent,
/*3191*/            OPC_MoveChild, 2,
/*3193*/            OPC_CheckSame, 2,
/*3195*/            OPC_MoveParent,
/*3196*/            OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*3198*/            OPC_CheckPredicate, 5, // Predicate_store
/*3200*/            OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #4 #5 #6 #7 #8
/*3203*/            OPC_EmitMergeInputChains, 2, 0, 1, 
/*3207*/            OPC_EmitConvertToTarget, 3,
/*3209*/            OPC_MorphNodeTo, TARGET_OPCODE(X86::SHL8mi), 0|OPFL_Chain|OPFL_MemRefs,
                        0/*#VTs*/, 6/*#Ops*/, 4, 5, 6, 7, 8, 9, 
                    // Src: (st:isVoid (shl:i8 (ld:i8 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>, (imm:i8):$src), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                    // Dst: (SHL8mi:isVoid addr:iPTR:$dst, (imm:i8):$src)
/*3221*/          0, /*End of Scope*/
/*3222*/        /*Scope*/ 44, /*->3267*/
/*3223*/          OPC_CheckPredicate, 6, // Predicate_loadi16
/*3225*/          OPC_MoveParent,
/*3226*/          OPC_RecordChild1, // #3 = $src
/*3227*/          OPC_MoveChild, 1,
/*3229*/          OPC_CheckOpcode, ISD::Constant,
/*3231*/          OPC_CheckType, MVT::i8,
/*3233*/          OPC_MoveParent,
/*3234*/          OPC_CheckType, MVT::i16,
/*3236*/          OPC_MoveParent,
/*3237*/          OPC_MoveChild, 2,
/*3239*/          OPC_CheckSame, 2,
/*3241*/          OPC_MoveParent,
/*3242*/          OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*3244*/          OPC_CheckPredicate, 5, // Predicate_store
/*3246*/          OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #4 #5 #6 #7 #8
/*3249*/          OPC_EmitMergeInputChains, 2, 0, 1, 
/*3253*/          OPC_EmitConvertToTarget, 3,
/*3255*/          OPC_MorphNodeTo, TARGET_OPCODE(X86::SHL16mi), 0|OPFL_Chain|OPFL_MemRefs,
                      0/*#VTs*/, 6/*#Ops*/, 4, 5, 6, 7, 8, 9, 
                  // Src: (st:isVoid (shl:i16 (ld:i16 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, (imm:i8):$src), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                  // Dst: (SHL16mi:isVoid addr:iPTR:$dst, (imm:i8):$src)
/*3267*/        /*Scope*/ 44, /*->3312*/
/*3268*/          OPC_CheckPredicate, 3, // Predicate_loadi32
/*3270*/          OPC_MoveParent,
/*3271*/          OPC_RecordChild1, // #3 = $src
/*3272*/          OPC_MoveChild, 1,
/*3274*/          OPC_CheckOpcode, ISD::Constant,
/*3276*/          OPC_CheckType, MVT::i8,
/*3278*/          OPC_MoveParent,
/*3279*/          OPC_CheckType, MVT::i32,
/*3281*/          OPC_MoveParent,
/*3282*/          OPC_MoveChild, 2,
/*3284*/          OPC_CheckSame, 2,
/*3286*/          OPC_MoveParent,
/*3287*/          OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*3289*/          OPC_CheckPredicate, 5, // Predicate_store
/*3291*/          OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #4 #5 #6 #7 #8
/*3294*/          OPC_EmitMergeInputChains, 2, 0, 1, 
/*3298*/          OPC_EmitConvertToTarget, 3,
/*3300*/          OPC_MorphNodeTo, TARGET_OPCODE(X86::SHL32mi), 0|OPFL_Chain|OPFL_MemRefs,
                      0/*#VTs*/, 6/*#Ops*/, 4, 5, 6, 7, 8, 9, 
                  // Src: (st:isVoid (shl:i32 (ld:i32 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, (imm:i8):$src), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                  // Dst: (SHL32mi:isVoid addr:iPTR:$dst, (imm:i8):$src)
/*3312*/        /*Scope*/ 85, /*->3398*/
/*3313*/          OPC_CheckPredicate, 8, // Predicate_load
/*3315*/          OPC_CheckPredicate, 9, // Predicate_dsload
/*3317*/          OPC_MoveParent,
/*3318*/          OPC_RecordChild1, // #3 = $src
/*3319*/          OPC_Scope, 40, /*->3361*/ // 2 children in Scope
/*3321*/            OPC_MoveChild, 1,
/*3323*/            OPC_CheckOpcode, ISD::Constant,
/*3325*/            OPC_CheckType, MVT::i8,
/*3327*/            OPC_MoveParent,
/*3328*/            OPC_CheckType, MVT::i64,
/*3330*/            OPC_MoveParent,
/*3331*/            OPC_MoveChild, 2,
/*3333*/            OPC_CheckSame, 2,
/*3335*/            OPC_MoveParent,
/*3336*/            OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*3338*/            OPC_CheckPredicate, 5, // Predicate_store
/*3340*/            OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #4 #5 #6 #7 #8
/*3343*/            OPC_EmitMergeInputChains, 2, 0, 1, 
/*3347*/            OPC_EmitConvertToTarget, 3,
/*3349*/            OPC_MorphNodeTo, TARGET_OPCODE(X86::SHL64mi), 0|OPFL_Chain|OPFL_MemRefs,
                        0/*#VTs*/, 6/*#Ops*/, 4, 5, 6, 7, 8, 9, 
                    // Src: (st:isVoid (shl:i64 (ld:i64 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>, (imm:i8):$src), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                    // Dst: (SHL64mi:isVoid addr:iPTR:$dst, (imm:i8):$src)
/*3361*/          /*Scope*/ 35, /*->3397*/
/*3362*/            OPC_CheckChild1Type, MVT::i8,
/*3364*/            OPC_CheckType, MVT::i8,
/*3366*/            OPC_MoveParent,
/*3367*/            OPC_MoveChild, 2,
/*3369*/            OPC_CheckSame, 2,
/*3371*/            OPC_MoveParent,
/*3372*/            OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*3374*/            OPC_CheckPredicate, 5, // Predicate_store
/*3376*/            OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #4 #5 #6 #7 #8
/*3379*/            OPC_EmitMergeInputChains, 2, 0, 1, 
/*3383*/            OPC_EmitCopyToReg, 3, X86::CL,
/*3386*/            OPC_MorphNodeTo, TARGET_OPCODE(X86::SHL8mCL), 0|OPFL_Chain|OPFL_FlagInput|OPFL_MemRefs,
                        0/*#VTs*/, 5/*#Ops*/, 4, 5, 6, 7, 8, 
                    // Src: (st:isVoid (shl:i8 (ld:i8 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>, CL:i8), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                    // Dst: (SHL8mCL:isVoid addr:iPTR:$dst)
/*3397*/          0, /*End of Scope*/
/*3398*/        /*Scope*/ 39, /*->3438*/
/*3399*/          OPC_CheckPredicate, 6, // Predicate_loadi16
/*3401*/          OPC_MoveParent,
/*3402*/          OPC_RecordChild1, // #3 = physreg input CL
/*3403*/          OPC_CheckChild1Type, MVT::i8,
/*3405*/          OPC_CheckType, MVT::i16,
/*3407*/          OPC_MoveParent,
/*3408*/          OPC_MoveChild, 2,
/*3410*/          OPC_CheckSame, 2,
/*3412*/          OPC_MoveParent,
/*3413*/          OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*3415*/          OPC_CheckPredicate, 5, // Predicate_store
/*3417*/          OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #4 #5 #6 #7 #8
/*3420*/          OPC_EmitMergeInputChains, 2, 0, 1, 
/*3424*/          OPC_EmitCopyToReg, 3, X86::CL,
/*3427*/          OPC_MorphNodeTo, TARGET_OPCODE(X86::SHL16mCL), 0|OPFL_Chain|OPFL_FlagInput|OPFL_MemRefs,
                      0/*#VTs*/, 5/*#Ops*/, 4, 5, 6, 7, 8, 
                  // Src: (st:isVoid (shl:i16 (ld:i16 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, CL:i8), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                  // Dst: (SHL16mCL:isVoid addr:iPTR:$dst)
/*3438*/        /*Scope*/ 39, /*->3478*/
/*3439*/          OPC_CheckPredicate, 3, // Predicate_loadi32
/*3441*/          OPC_MoveParent,
/*3442*/          OPC_RecordChild1, // #3 = physreg input CL
/*3443*/          OPC_CheckChild1Type, MVT::i8,
/*3445*/          OPC_CheckType, MVT::i32,
/*3447*/          OPC_MoveParent,
/*3448*/          OPC_MoveChild, 2,
/*3450*/          OPC_CheckSame, 2,
/*3452*/          OPC_MoveParent,
/*3453*/          OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*3455*/          OPC_CheckPredicate, 5, // Predicate_store
/*3457*/          OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #4 #5 #6 #7 #8
/*3460*/          OPC_EmitMergeInputChains, 2, 0, 1, 
/*3464*/          OPC_EmitCopyToReg, 3, X86::CL,
/*3467*/          OPC_MorphNodeTo, TARGET_OPCODE(X86::SHL32mCL), 0|OPFL_Chain|OPFL_FlagInput|OPFL_MemRefs,
                      0/*#VTs*/, 5/*#Ops*/, 4, 5, 6, 7, 8, 
                  // Src: (st:isVoid (shl:i32 (ld:i32 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, CL:i8), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                  // Dst: (SHL32mCL:isVoid addr:iPTR:$dst)
/*3478*/        /*Scope*/ 41, /*->3520*/
/*3479*/          OPC_CheckPredicate, 8, // Predicate_load
/*3481*/          OPC_CheckPredicate, 9, // Predicate_dsload
/*3483*/          OPC_MoveParent,
/*3484*/          OPC_RecordChild1, // #3 = physreg input CL
/*3485*/          OPC_CheckChild1Type, MVT::i8,
/*3487*/          OPC_CheckType, MVT::i64,
/*3489*/          OPC_MoveParent,
/*3490*/          OPC_MoveChild, 2,
/*3492*/          OPC_CheckSame, 2,
/*3494*/          OPC_MoveParent,
/*3495*/          OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*3497*/          OPC_CheckPredicate, 5, // Predicate_store
/*3499*/          OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #4 #5 #6 #7 #8
/*3502*/          OPC_EmitMergeInputChains, 2, 0, 1, 
/*3506*/          OPC_EmitCopyToReg, 3, X86::CL,
/*3509*/          OPC_MorphNodeTo, TARGET_OPCODE(X86::SHL64mCL), 0|OPFL_Chain|OPFL_FlagInput|OPFL_MemRefs,
                      0/*#VTs*/, 5/*#Ops*/, 4, 5, 6, 7, 8, 
                  // Src: (st:isVoid (shl:i64 (ld:i64 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>, CL:i8), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                  // Dst: (SHL64mCL:isVoid addr:iPTR:$dst)
/*3520*/        0, /*End of Scope*/
              /*SwitchOpcode*/ 61|128,5/*701*/,  ISD::SRL,// ->4225
/*3524*/        OPC_MoveChild, 0,
/*3526*/        OPC_CheckOpcode, ISD::LOAD,
/*3528*/        OPC_RecordMemRef,
/*3529*/        OPC_RecordNode, // #1 = 'ld' chained node
/*3530*/        OPC_CheckFoldableChainNode,
/*3531*/        OPC_RecordChild1, // #2 = $dst
/*3532*/        OPC_CheckPredicate, 2, // Predicate_unindexedload
/*3534*/        OPC_Scope, 46, /*->3582*/ // 13 children in Scope
/*3536*/          OPC_CheckPredicate, 8, // Predicate_load
/*3538*/          OPC_CheckPredicate, 9, // Predicate_dsload
/*3540*/          OPC_MoveParent,
/*3541*/          OPC_MoveChild, 1,
/*3543*/          OPC_CheckAndImm, 31, 
/*3545*/          OPC_RecordChild0, // #3 = physreg input CL
/*3546*/          OPC_CheckType, MVT::i8,
/*3548*/          OPC_MoveParent,
/*3549*/          OPC_CheckType, MVT::i8,
/*3551*/          OPC_MoveParent,
/*3552*/          OPC_MoveChild, 2,
/*3554*/          OPC_CheckSame, 2,
/*3556*/          OPC_MoveParent,
/*3557*/          OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*3559*/          OPC_CheckPredicate, 5, // Predicate_store
/*3561*/          OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #4 #5 #6 #7 #8
/*3564*/          OPC_EmitMergeInputChains, 2, 0, 1, 
/*3568*/          OPC_EmitCopyToReg, 3, X86::CL,
/*3571*/          OPC_MorphNodeTo, TARGET_OPCODE(X86::SHR8mCL), 0|OPFL_Chain|OPFL_FlagInput|OPFL_MemRefs,
                      0/*#VTs*/, 5/*#Ops*/, 4, 5, 6, 7, 8, 
                  // Src: (st:isVoid (srl:i8 (ld:i8 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>, (and:i8 CL:i8, 31:i8)), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                  // Dst: (SHR8mCL:isVoid addr:iPTR:$dst)
/*3582*/        /*Scope*/ 44, /*->3627*/
/*3583*/          OPC_CheckPredicate, 6, // Predicate_loadi16
/*3585*/          OPC_MoveParent,
/*3586*/          OPC_MoveChild, 1,
/*3588*/          OPC_CheckAndImm, 31, 
/*3590*/          OPC_RecordChild0, // #3 = physreg input CL
/*3591*/          OPC_CheckType, MVT::i8,
/*3593*/          OPC_MoveParent,
/*3594*/          OPC_CheckType, MVT::i16,
/*3596*/          OPC_MoveParent,
/*3597*/          OPC_MoveChild, 2,
/*3599*/          OPC_CheckSame, 2,
/*3601*/          OPC_MoveParent,
/*3602*/          OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*3604*/          OPC_CheckPredicate, 5, // Predicate_store
/*3606*/          OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #4 #5 #6 #7 #8
/*3609*/          OPC_EmitMergeInputChains, 2, 0, 1, 
/*3613*/          OPC_EmitCopyToReg, 3, X86::CL,
/*3616*/          OPC_MorphNodeTo, TARGET_OPCODE(X86::SHR16mCL), 0|OPFL_Chain|OPFL_FlagInput|OPFL_MemRefs,
                      0/*#VTs*/, 5/*#Ops*/, 4, 5, 6, 7, 8, 
                  // Src: (st:isVoid (srl:i16 (ld:i16 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, (and:i8 CL:i8, 31:i8)), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                  // Dst: (SHR16mCL:isVoid addr:iPTR:$dst)
/*3627*/        /*Scope*/ 44, /*->3672*/
/*3628*/          OPC_CheckPredicate, 3, // Predicate_loadi32
/*3630*/          OPC_MoveParent,
/*3631*/          OPC_MoveChild, 1,
/*3633*/          OPC_CheckAndImm, 31, 
/*3635*/          OPC_RecordChild0, // #3 = physreg input CL
/*3636*/          OPC_CheckType, MVT::i8,
/*3638*/          OPC_MoveParent,
/*3639*/          OPC_CheckType, MVT::i32,
/*3641*/          OPC_MoveParent,
/*3642*/          OPC_MoveChild, 2,
/*3644*/          OPC_CheckSame, 2,
/*3646*/          OPC_MoveParent,
/*3647*/          OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*3649*/          OPC_CheckPredicate, 5, // Predicate_store
/*3651*/          OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #4 #5 #6 #7 #8
/*3654*/          OPC_EmitMergeInputChains, 2, 0, 1, 
/*3658*/          OPC_EmitCopyToReg, 3, X86::CL,
/*3661*/          OPC_MorphNodeTo, TARGET_OPCODE(X86::SHR32mCL), 0|OPFL_Chain|OPFL_FlagInput|OPFL_MemRefs,
                      0/*#VTs*/, 5/*#Ops*/, 4, 5, 6, 7, 8, 
                  // Src: (st:isVoid (srl:i32 (ld:i32 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, (and:i8 CL:i8, 31:i8)), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                  // Dst: (SHR32mCL:isVoid addr:iPTR:$dst)
/*3672*/        /*Scope*/ 83, /*->3756*/
/*3673*/          OPC_CheckPredicate, 8, // Predicate_load
/*3675*/          OPC_CheckPredicate, 9, // Predicate_dsload
/*3677*/          OPC_MoveParent,
/*3678*/          OPC_MoveChild, 1,
/*3680*/          OPC_CheckType, MVT::i8,
/*3682*/          OPC_Scope, 37, /*->3721*/ // 2 children in Scope
/*3684*/            OPC_CheckAndImm, 63, 
/*3686*/            OPC_RecordChild0, // #3 = physreg input CL
/*3687*/            OPC_MoveParent,
/*3688*/            OPC_CheckType, MVT::i64,
/*3690*/            OPC_MoveParent,
/*3691*/            OPC_MoveChild, 2,
/*3693*/            OPC_CheckSame, 2,
/*3695*/            OPC_MoveParent,
/*3696*/            OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*3698*/            OPC_CheckPredicate, 5, // Predicate_store
/*3700*/            OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #4 #5 #6 #7 #8
/*3703*/            OPC_EmitMergeInputChains, 2, 0, 1, 
/*3707*/            OPC_EmitCopyToReg, 3, X86::CL,
/*3710*/            OPC_MorphNodeTo, TARGET_OPCODE(X86::SHR64mCL), 0|OPFL_Chain|OPFL_FlagInput|OPFL_MemRefs,
                        0/*#VTs*/, 5/*#Ops*/, 4, 5, 6, 7, 8, 
                    // Src: (st:isVoid (srl:i64 (ld:i64 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>, (and:i8 CL:i8, 63:i8)), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                    // Dst: (SHR64mCL:isVoid addr:iPTR:$dst)
/*3721*/          /*Scope*/ 33, /*->3755*/
/*3722*/            OPC_CheckInteger, 1, 
/*3724*/            OPC_MoveParent,
/*3725*/            OPC_CheckType, MVT::i8,
/*3727*/            OPC_MoveParent,
/*3728*/            OPC_MoveChild, 2,
/*3730*/            OPC_CheckSame, 2,
/*3732*/            OPC_MoveParent,
/*3733*/            OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*3735*/            OPC_CheckPredicate, 5, // Predicate_store
/*3737*/            OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #3 #4 #5 #6 #7
/*3740*/            OPC_EmitMergeInputChains, 2, 0, 1, 
/*3744*/            OPC_MorphNodeTo, TARGET_OPCODE(X86::SHR8m1), 0|OPFL_Chain|OPFL_MemRefs,
                        0/*#VTs*/, 5/*#Ops*/, 3, 4, 5, 6, 7, 
                    // Src: (st:isVoid (srl:i8 (ld:i8 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>, 1:i8), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                    // Dst: (SHR8m1:isVoid addr:iPTR:$dst)
/*3755*/          0, /*End of Scope*/
/*3756*/        /*Scope*/ 40, /*->3797*/
/*3757*/          OPC_CheckPredicate, 6, // Predicate_loadi16
/*3759*/          OPC_MoveParent,
/*3760*/          OPC_MoveChild, 1,
/*3762*/          OPC_CheckInteger, 1, 
/*3764*/          OPC_CheckType, MVT::i8,
/*3766*/          OPC_MoveParent,
/*3767*/          OPC_CheckType, MVT::i16,
/*3769*/          OPC_MoveParent,
/*3770*/          OPC_MoveChild, 2,
/*3772*/          OPC_CheckSame, 2,
/*3774*/          OPC_MoveParent,
/*3775*/          OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*3777*/          OPC_CheckPredicate, 5, // Predicate_store
/*3779*/          OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #3 #4 #5 #6 #7
/*3782*/          OPC_EmitMergeInputChains, 2, 0, 1, 
/*3786*/          OPC_MorphNodeTo, TARGET_OPCODE(X86::SHR16m1), 0|OPFL_Chain|OPFL_MemRefs,
                      0/*#VTs*/, 5/*#Ops*/, 3, 4, 5, 6, 7, 
                  // Src: (st:isVoid (srl:i16 (ld:i16 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, 1:i8), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                  // Dst: (SHR16m1:isVoid addr:iPTR:$dst)
/*3797*/        /*Scope*/ 40, /*->3838*/
/*3798*/          OPC_CheckPredicate, 3, // Predicate_loadi32
/*3800*/          OPC_MoveParent,
/*3801*/          OPC_MoveChild, 1,
/*3803*/          OPC_CheckInteger, 1, 
/*3805*/          OPC_CheckType, MVT::i8,
/*3807*/          OPC_MoveParent,
/*3808*/          OPC_CheckType, MVT::i32,
/*3810*/          OPC_MoveParent,
/*3811*/          OPC_MoveChild, 2,
/*3813*/          OPC_CheckSame, 2,
/*3815*/          OPC_MoveParent,
/*3816*/          OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*3818*/          OPC_CheckPredicate, 5, // Predicate_store
/*3820*/          OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #3 #4 #5 #6 #7
/*3823*/          OPC_EmitMergeInputChains, 2, 0, 1, 
/*3827*/          OPC_MorphNodeTo, TARGET_OPCODE(X86::SHR32m1), 0|OPFL_Chain|OPFL_MemRefs,
                      0/*#VTs*/, 5/*#Ops*/, 3, 4, 5, 6, 7, 
                  // Src: (st:isVoid (srl:i32 (ld:i32 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, 1:i8), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                  // Dst: (SHR32m1:isVoid addr:iPTR:$dst)
/*3838*/        /*Scope*/ 87, /*->3926*/
/*3839*/          OPC_CheckPredicate, 8, // Predicate_load
/*3841*/          OPC_CheckPredicate, 9, // Predicate_dsload
/*3843*/          OPC_MoveParent,
/*3844*/          OPC_Scope, 37, /*->3883*/ // 2 children in Scope
/*3846*/            OPC_MoveChild, 1,
/*3848*/            OPC_CheckInteger, 1, 
/*3850*/            OPC_CheckType, MVT::i8,
/*3852*/            OPC_MoveParent,
/*3853*/            OPC_CheckType, MVT::i64,
/*3855*/            OPC_MoveParent,
/*3856*/            OPC_MoveChild, 2,
/*3858*/            OPC_CheckSame, 2,
/*3860*/            OPC_MoveParent,
/*3861*/            OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*3863*/            OPC_CheckPredicate, 5, // Predicate_store
/*3865*/            OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #3 #4 #5 #6 #7
/*3868*/            OPC_EmitMergeInputChains, 2, 0, 1, 
/*3872*/            OPC_MorphNodeTo, TARGET_OPCODE(X86::SHR64m1), 0|OPFL_Chain|OPFL_MemRefs,
                        0/*#VTs*/, 5/*#Ops*/, 3, 4, 5, 6, 7, 
                    // Src: (st:isVoid (srl:i64 (ld:i64 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>, 1:i8), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                    // Dst: (SHR64m1:isVoid addr:iPTR:$dst)
/*3883*/          /*Scope*/ 41, /*->3925*/
/*3884*/            OPC_RecordChild1, // #3 = $src
/*3885*/            OPC_MoveChild, 1,
/*3887*/            OPC_CheckOpcode, ISD::Constant,
/*3889*/            OPC_CheckType, MVT::i8,
/*3891*/            OPC_MoveParent,
/*3892*/            OPC_CheckType, MVT::i8,
/*3894*/            OPC_MoveParent,
/*3895*/            OPC_MoveChild, 2,
/*3897*/            OPC_CheckSame, 2,
/*3899*/            OPC_MoveParent,
/*3900*/            OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*3902*/            OPC_CheckPredicate, 5, // Predicate_store
/*3904*/            OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #4 #5 #6 #7 #8
/*3907*/            OPC_EmitMergeInputChains, 2, 0, 1, 
/*3911*/            OPC_EmitConvertToTarget, 3,
/*3913*/            OPC_MorphNodeTo, TARGET_OPCODE(X86::SHR8mi), 0|OPFL_Chain|OPFL_MemRefs,
                        0/*#VTs*/, 6/*#Ops*/, 4, 5, 6, 7, 8, 9, 
                    // Src: (st:isVoid (srl:i8 (ld:i8 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>, (imm:i8):$src), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                    // Dst: (SHR8mi:isVoid addr:iPTR:$dst, (imm:i8):$src)
/*3925*/          0, /*End of Scope*/
/*3926*/        /*Scope*/ 44, /*->3971*/
/*3927*/          OPC_CheckPredicate, 6, // Predicate_loadi16
/*3929*/          OPC_MoveParent,
/*3930*/          OPC_RecordChild1, // #3 = $src
/*3931*/          OPC_MoveChild, 1,
/*3933*/          OPC_CheckOpcode, ISD::Constant,
/*3935*/          OPC_CheckType, MVT::i8,
/*3937*/          OPC_MoveParent,
/*3938*/          OPC_CheckType, MVT::i16,
/*3940*/          OPC_MoveParent,
/*3941*/          OPC_MoveChild, 2,
/*3943*/          OPC_CheckSame, 2,
/*3945*/          OPC_MoveParent,
/*3946*/          OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*3948*/          OPC_CheckPredicate, 5, // Predicate_store
/*3950*/          OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #4 #5 #6 #7 #8
/*3953*/          OPC_EmitMergeInputChains, 2, 0, 1, 
/*3957*/          OPC_EmitConvertToTarget, 3,
/*3959*/          OPC_MorphNodeTo, TARGET_OPCODE(X86::SHR16mi), 0|OPFL_Chain|OPFL_MemRefs,
                      0/*#VTs*/, 6/*#Ops*/, 4, 5, 6, 7, 8, 9, 
                  // Src: (st:isVoid (srl:i16 (ld:i16 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, (imm:i8):$src), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                  // Dst: (SHR16mi:isVoid addr:iPTR:$dst, (imm:i8):$src)
/*3971*/        /*Scope*/ 44, /*->4016*/
/*3972*/          OPC_CheckPredicate, 3, // Predicate_loadi32
/*3974*/          OPC_MoveParent,
/*3975*/          OPC_RecordChild1, // #3 = $src
/*3976*/          OPC_MoveChild, 1,
/*3978*/          OPC_CheckOpcode, ISD::Constant,
/*3980*/          OPC_CheckType, MVT::i8,
/*3982*/          OPC_MoveParent,
/*3983*/          OPC_CheckType, MVT::i32,
/*3985*/          OPC_MoveParent,
/*3986*/          OPC_MoveChild, 2,
/*3988*/          OPC_CheckSame, 2,
/*3990*/          OPC_MoveParent,
/*3991*/          OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*3993*/          OPC_CheckPredicate, 5, // Predicate_store
/*3995*/          OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #4 #5 #6 #7 #8
/*3998*/          OPC_EmitMergeInputChains, 2, 0, 1, 
/*4002*/          OPC_EmitConvertToTarget, 3,
/*4004*/          OPC_MorphNodeTo, TARGET_OPCODE(X86::SHR32mi), 0|OPFL_Chain|OPFL_MemRefs,
                      0/*#VTs*/, 6/*#Ops*/, 4, 5, 6, 7, 8, 9, 
                  // Src: (st:isVoid (srl:i32 (ld:i32 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, (imm:i8):$src), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                  // Dst: (SHR32mi:isVoid addr:iPTR:$dst, (imm:i8):$src)
/*4016*/        /*Scope*/ 85, /*->4102*/
/*4017*/          OPC_CheckPredicate, 8, // Predicate_load
/*4019*/          OPC_CheckPredicate, 9, // Predicate_dsload
/*4021*/          OPC_MoveParent,
/*4022*/          OPC_RecordChild1, // #3 = $src
/*4023*/          OPC_Scope, 40, /*->4065*/ // 2 children in Scope
/*4025*/            OPC_MoveChild, 1,
/*4027*/            OPC_CheckOpcode, ISD::Constant,
/*4029*/            OPC_CheckType, MVT::i8,
/*4031*/            OPC_MoveParent,
/*4032*/            OPC_CheckType, MVT::i64,
/*4034*/            OPC_MoveParent,
/*4035*/            OPC_MoveChild, 2,
/*4037*/            OPC_CheckSame, 2,
/*4039*/            OPC_MoveParent,
/*4040*/            OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*4042*/            OPC_CheckPredicate, 5, // Predicate_store
/*4044*/            OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #4 #5 #6 #7 #8
/*4047*/            OPC_EmitMergeInputChains, 2, 0, 1, 
/*4051*/            OPC_EmitConvertToTarget, 3,
/*4053*/            OPC_MorphNodeTo, TARGET_OPCODE(X86::SHR64mi), 0|OPFL_Chain|OPFL_MemRefs,
                        0/*#VTs*/, 6/*#Ops*/, 4, 5, 6, 7, 8, 9, 
                    // Src: (st:isVoid (srl:i64 (ld:i64 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>, (imm:i8):$src), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                    // Dst: (SHR64mi:isVoid addr:iPTR:$dst, (imm:i8):$src)
/*4065*/          /*Scope*/ 35, /*->4101*/
/*4066*/            OPC_CheckChild1Type, MVT::i8,
/*4068*/            OPC_CheckType, MVT::i8,
/*4070*/            OPC_MoveParent,
/*4071*/            OPC_MoveChild, 2,
/*4073*/            OPC_CheckSame, 2,
/*4075*/            OPC_MoveParent,
/*4076*/            OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*4078*/            OPC_CheckPredicate, 5, // Predicate_store
/*4080*/            OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #4 #5 #6 #7 #8
/*4083*/            OPC_EmitMergeInputChains, 2, 0, 1, 
/*4087*/            OPC_EmitCopyToReg, 3, X86::CL,
/*4090*/            OPC_MorphNodeTo, TARGET_OPCODE(X86::SHR8mCL), 0|OPFL_Chain|OPFL_FlagInput|OPFL_MemRefs,
                        0/*#VTs*/, 5/*#Ops*/, 4, 5, 6, 7, 8, 
                    // Src: (st:isVoid (srl:i8 (ld:i8 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>, CL:i8), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                    // Dst: (SHR8mCL:isVoid addr:iPTR:$dst)
/*4101*/          0, /*End of Scope*/
/*4102*/        /*Scope*/ 39, /*->4142*/
/*4103*/          OPC_CheckPredicate, 6, // Predicate_loadi16
/*4105*/          OPC_MoveParent,
/*4106*/          OPC_RecordChild1, // #3 = physreg input CL
/*4107*/          OPC_CheckChild1Type, MVT::i8,
/*4109*/          OPC_CheckType, MVT::i16,
/*4111*/          OPC_MoveParent,
/*4112*/          OPC_MoveChild, 2,
/*4114*/          OPC_CheckSame, 2,
/*4116*/          OPC_MoveParent,
/*4117*/          OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*4119*/          OPC_CheckPredicate, 5, // Predicate_store
/*4121*/          OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #4 #5 #6 #7 #8
/*4124*/          OPC_EmitMergeInputChains, 2, 0, 1, 
/*4128*/          OPC_EmitCopyToReg, 3, X86::CL,
/*4131*/          OPC_MorphNodeTo, TARGET_OPCODE(X86::SHR16mCL), 0|OPFL_Chain|OPFL_FlagInput|OPFL_MemRefs,
                      0/*#VTs*/, 5/*#Ops*/, 4, 5, 6, 7, 8, 
                  // Src: (st:isVoid (srl:i16 (ld:i16 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, CL:i8), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                  // Dst: (SHR16mCL:isVoid addr:iPTR:$dst)
/*4142*/        /*Scope*/ 39, /*->4182*/
/*4143*/          OPC_CheckPredicate, 3, // Predicate_loadi32
/*4145*/          OPC_MoveParent,
/*4146*/          OPC_RecordChild1, // #3 = physreg input CL
/*4147*/          OPC_CheckChild1Type, MVT::i8,
/*4149*/          OPC_CheckType, MVT::i32,
/*4151*/          OPC_MoveParent,
/*4152*/          OPC_MoveChild, 2,
/*4154*/          OPC_CheckSame, 2,
/*4156*/          OPC_MoveParent,
/*4157*/          OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*4159*/          OPC_CheckPredicate, 5, // Predicate_store
/*4161*/          OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #4 #5 #6 #7 #8
/*4164*/          OPC_EmitMergeInputChains, 2, 0, 1, 
/*4168*/          OPC_EmitCopyToReg, 3, X86::CL,
/*4171*/          OPC_MorphNodeTo, TARGET_OPCODE(X86::SHR32mCL), 0|OPFL_Chain|OPFL_FlagInput|OPFL_MemRefs,
                      0/*#VTs*/, 5/*#Ops*/, 4, 5, 6, 7, 8, 
                  // Src: (st:isVoid (srl:i32 (ld:i32 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, CL:i8), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                  // Dst: (SHR32mCL:isVoid addr:iPTR:$dst)
/*4182*/        /*Scope*/ 41, /*->4224*/
/*4183*/          OPC_CheckPredicate, 8, // Predicate_load
/*4185*/          OPC_CheckPredicate, 9, // Predicate_dsload
/*4187*/          OPC_MoveParent,
/*4188*/          OPC_RecordChild1, // #3 = physreg input CL
/*4189*/          OPC_CheckChild1Type, MVT::i8,
/*4191*/          OPC_CheckType, MVT::i64,
/*4193*/          OPC_MoveParent,
/*4194*/          OPC_MoveChild, 2,
/*4196*/          OPC_CheckSame, 2,
/*4198*/          OPC_MoveParent,
/*4199*/          OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*4201*/          OPC_CheckPredicate, 5, // Predicate_store
/*4203*/          OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #4 #5 #6 #7 #8
/*4206*/          OPC_EmitMergeInputChains, 2, 0, 1, 
/*4210*/          OPC_EmitCopyToReg, 3, X86::CL,
/*4213*/          OPC_MorphNodeTo, TARGET_OPCODE(X86::SHR64mCL), 0|OPFL_Chain|OPFL_FlagInput|OPFL_MemRefs,
                      0/*#VTs*/, 5/*#Ops*/, 4, 5, 6, 7, 8, 
                  // Src: (st:isVoid (srl:i64 (ld:i64 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>, CL:i8), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                  // Dst: (SHR64mCL:isVoid addr:iPTR:$dst)
/*4224*/        0, /*End of Scope*/
              /*SwitchOpcode*/ 61|128,5/*701*/,  ISD::SRA,// ->4929
/*4228*/        OPC_MoveChild, 0,
/*4230*/        OPC_CheckOpcode, ISD::LOAD,
/*4232*/        OPC_RecordMemRef,
/*4233*/        OPC_RecordNode, // #1 = 'ld' chained node
/*4234*/        OPC_CheckFoldableChainNode,
/*4235*/        OPC_RecordChild1, // #2 = $dst
/*4236*/        OPC_CheckPredicate, 2, // Predicate_unindexedload
/*4238*/        OPC_Scope, 46, /*->4286*/ // 13 children in Scope
/*4240*/          OPC_CheckPredicate, 8, // Predicate_load
/*4242*/          OPC_CheckPredicate, 9, // Predicate_dsload
/*4244*/          OPC_MoveParent,
/*4245*/          OPC_MoveChild, 1,
/*4247*/          OPC_CheckAndImm, 31, 
/*4249*/          OPC_RecordChild0, // #3 = physreg input CL
/*4250*/          OPC_CheckType, MVT::i8,
/*4252*/          OPC_MoveParent,
/*4253*/          OPC_CheckType, MVT::i8,
/*4255*/          OPC_MoveParent,
/*4256*/          OPC_MoveChild, 2,
/*4258*/          OPC_CheckSame, 2,
/*4260*/          OPC_MoveParent,
/*4261*/          OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*4263*/          OPC_CheckPredicate, 5, // Predicate_store
/*4265*/          OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #4 #5 #6 #7 #8
/*4268*/          OPC_EmitMergeInputChains, 2, 0, 1, 
/*4272*/          OPC_EmitCopyToReg, 3, X86::CL,
/*4275*/          OPC_MorphNodeTo, TARGET_OPCODE(X86::SAR8mCL), 0|OPFL_Chain|OPFL_FlagInput|OPFL_MemRefs,
                      0/*#VTs*/, 5/*#Ops*/, 4, 5, 6, 7, 8, 
                  // Src: (st:isVoid (sra:i8 (ld:i8 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>, (and:i8 CL:i8, 31:i8)), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                  // Dst: (SAR8mCL:isVoid addr:iPTR:$dst)
/*4286*/        /*Scope*/ 44, /*->4331*/
/*4287*/          OPC_CheckPredicate, 6, // Predicate_loadi16
/*4289*/          OPC_MoveParent,
/*4290*/          OPC_MoveChild, 1,
/*4292*/          OPC_CheckAndImm, 31, 
/*4294*/          OPC_RecordChild0, // #3 = physreg input CL
/*4295*/          OPC_CheckType, MVT::i8,
/*4297*/          OPC_MoveParent,
/*4298*/          OPC_CheckType, MVT::i16,
/*4300*/          OPC_MoveParent,
/*4301*/          OPC_MoveChild, 2,
/*4303*/          OPC_CheckSame, 2,
/*4305*/          OPC_MoveParent,
/*4306*/          OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*4308*/          OPC_CheckPredicate, 5, // Predicate_store
/*4310*/          OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #4 #5 #6 #7 #8
/*4313*/          OPC_EmitMergeInputChains, 2, 0, 1, 
/*4317*/          OPC_EmitCopyToReg, 3, X86::CL,
/*4320*/          OPC_MorphNodeTo, TARGET_OPCODE(X86::SAR16mCL), 0|OPFL_Chain|OPFL_FlagInput|OPFL_MemRefs,
                      0/*#VTs*/, 5/*#Ops*/, 4, 5, 6, 7, 8, 
                  // Src: (st:isVoid (sra:i16 (ld:i16 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, (and:i8 CL:i8, 31:i8)), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                  // Dst: (SAR16mCL:isVoid addr:iPTR:$dst)
/*4331*/        /*Scope*/ 44, /*->4376*/
/*4332*/          OPC_CheckPredicate, 3, // Predicate_loadi32
/*4334*/          OPC_MoveParent,
/*4335*/          OPC_MoveChild, 1,
/*4337*/          OPC_CheckAndImm, 31, 
/*4339*/          OPC_RecordChild0, // #3 = physreg input CL
/*4340*/          OPC_CheckType, MVT::i8,
/*4342*/          OPC_MoveParent,
/*4343*/          OPC_CheckType, MVT::i32,
/*4345*/          OPC_MoveParent,
/*4346*/          OPC_MoveChild, 2,
/*4348*/          OPC_CheckSame, 2,
/*4350*/          OPC_MoveParent,
/*4351*/          OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*4353*/          OPC_CheckPredicate, 5, // Predicate_store
/*4355*/          OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #4 #5 #6 #7 #8
/*4358*/          OPC_EmitMergeInputChains, 2, 0, 1, 
/*4362*/          OPC_EmitCopyToReg, 3, X86::CL,
/*4365*/          OPC_MorphNodeTo, TARGET_OPCODE(X86::SAR32mCL), 0|OPFL_Chain|OPFL_FlagInput|OPFL_MemRefs,
                      0/*#VTs*/, 5/*#Ops*/, 4, 5, 6, 7, 8, 
                  // Src: (st:isVoid (sra:i32 (ld:i32 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, (and:i8 CL:i8, 31:i8)), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                  // Dst: (SAR32mCL:isVoid addr:iPTR:$dst)
/*4376*/        /*Scope*/ 83, /*->4460*/
/*4377*/          OPC_CheckPredicate, 8, // Predicate_load
/*4379*/          OPC_CheckPredicate, 9, // Predicate_dsload
/*4381*/          OPC_MoveParent,
/*4382*/          OPC_MoveChild, 1,
/*4384*/          OPC_CheckType, MVT::i8,
/*4386*/          OPC_Scope, 37, /*->4425*/ // 2 children in Scope
/*4388*/            OPC_CheckAndImm, 63, 
/*4390*/            OPC_RecordChild0, // #3 = physreg input CL
/*4391*/            OPC_MoveParent,
/*4392*/            OPC_CheckType, MVT::i64,
/*4394*/            OPC_MoveParent,
/*4395*/            OPC_MoveChild, 2,
/*4397*/            OPC_CheckSame, 2,
/*4399*/            OPC_MoveParent,
/*4400*/            OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*4402*/            OPC_CheckPredicate, 5, // Predicate_store
/*4404*/            OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #4 #5 #6 #7 #8
/*4407*/            OPC_EmitMergeInputChains, 2, 0, 1, 
/*4411*/            OPC_EmitCopyToReg, 3, X86::CL,
/*4414*/            OPC_MorphNodeTo, TARGET_OPCODE(X86::SAR64mCL), 0|OPFL_Chain|OPFL_FlagInput|OPFL_MemRefs,
                        0/*#VTs*/, 5/*#Ops*/, 4, 5, 6, 7, 8, 
                    // Src: (st:isVoid (sra:i64 (ld:i64 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>, (and:i8 CL:i8, 63:i8)), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                    // Dst: (SAR64mCL:isVoid addr:iPTR:$dst)
/*4425*/          /*Scope*/ 33, /*->4459*/
/*4426*/            OPC_CheckInteger, 1, 
/*4428*/            OPC_MoveParent,
/*4429*/            OPC_CheckType, MVT::i8,
/*4431*/            OPC_MoveParent,
/*4432*/            OPC_MoveChild, 2,
/*4434*/            OPC_CheckSame, 2,
/*4436*/            OPC_MoveParent,
/*4437*/            OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*4439*/            OPC_CheckPredicate, 5, // Predicate_store
/*4441*/            OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #3 #4 #5 #6 #7
/*4444*/            OPC_EmitMergeInputChains, 2, 0, 1, 
/*4448*/            OPC_MorphNodeTo, TARGET_OPCODE(X86::SAR8m1), 0|OPFL_Chain|OPFL_MemRefs,
                        0/*#VTs*/, 5/*#Ops*/, 3, 4, 5, 6, 7, 
                    // Src: (st:isVoid (sra:i8 (ld:i8 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>, 1:i8), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                    // Dst: (SAR8m1:isVoid addr:iPTR:$dst)
/*4459*/          0, /*End of Scope*/
/*4460*/        /*Scope*/ 40, /*->4501*/
/*4461*/          OPC_CheckPredicate, 6, // Predicate_loadi16
/*4463*/          OPC_MoveParent,
/*4464*/          OPC_MoveChild, 1,
/*4466*/          OPC_CheckInteger, 1, 
/*4468*/          OPC_CheckType, MVT::i8,
/*4470*/          OPC_MoveParent,
/*4471*/          OPC_CheckType, MVT::i16,
/*4473*/          OPC_MoveParent,
/*4474*/          OPC_MoveChild, 2,
/*4476*/          OPC_CheckSame, 2,
/*4478*/          OPC_MoveParent,
/*4479*/          OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*4481*/          OPC_CheckPredicate, 5, // Predicate_store
/*4483*/          OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #3 #4 #5 #6 #7
/*4486*/          OPC_EmitMergeInputChains, 2, 0, 1, 
/*4490*/          OPC_MorphNodeTo, TARGET_OPCODE(X86::SAR16m1), 0|OPFL_Chain|OPFL_MemRefs,
                      0/*#VTs*/, 5/*#Ops*/, 3, 4, 5, 6, 7, 
                  // Src: (st:isVoid (sra:i16 (ld:i16 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, 1:i8), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                  // Dst: (SAR16m1:isVoid addr:iPTR:$dst)
/*4501*/        /*Scope*/ 40, /*->4542*/
/*4502*/          OPC_CheckPredicate, 3, // Predicate_loadi32
/*4504*/          OPC_MoveParent,
/*4505*/          OPC_MoveChild, 1,
/*4507*/          OPC_CheckInteger, 1, 
/*4509*/          OPC_CheckType, MVT::i8,
/*4511*/          OPC_MoveParent,
/*4512*/          OPC_CheckType, MVT::i32,
/*4514*/          OPC_MoveParent,
/*4515*/          OPC_MoveChild, 2,
/*4517*/          OPC_CheckSame, 2,
/*4519*/          OPC_MoveParent,
/*4520*/          OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*4522*/          OPC_CheckPredicate, 5, // Predicate_store
/*4524*/          OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #3 #4 #5 #6 #7
/*4527*/          OPC_EmitMergeInputChains, 2, 0, 1, 
/*4531*/          OPC_MorphNodeTo, TARGET_OPCODE(X86::SAR32m1), 0|OPFL_Chain|OPFL_MemRefs,
                      0/*#VTs*/, 5/*#Ops*/, 3, 4, 5, 6, 7, 
                  // Src: (st:isVoid (sra:i32 (ld:i32 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, 1:i8), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                  // Dst: (SAR32m1:isVoid addr:iPTR:$dst)
/*4542*/        /*Scope*/ 87, /*->4630*/
/*4543*/          OPC_CheckPredicate, 8, // Predicate_load
/*4545*/          OPC_CheckPredicate, 9, // Predicate_dsload
/*4547*/          OPC_MoveParent,
/*4548*/          OPC_Scope, 37, /*->4587*/ // 2 children in Scope
/*4550*/            OPC_MoveChild, 1,
/*4552*/            OPC_CheckInteger, 1, 
/*4554*/            OPC_CheckType, MVT::i8,
/*4556*/            OPC_MoveParent,
/*4557*/            OPC_CheckType, MVT::i64,
/*4559*/            OPC_MoveParent,
/*4560*/            OPC_MoveChild, 2,
/*4562*/            OPC_CheckSame, 2,
/*4564*/            OPC_MoveParent,
/*4565*/            OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*4567*/            OPC_CheckPredicate, 5, // Predicate_store
/*4569*/            OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #3 #4 #5 #6 #7
/*4572*/            OPC_EmitMergeInputChains, 2, 0, 1, 
/*4576*/            OPC_MorphNodeTo, TARGET_OPCODE(X86::SAR64m1), 0|OPFL_Chain|OPFL_MemRefs,
                        0/*#VTs*/, 5/*#Ops*/, 3, 4, 5, 6, 7, 
                    // Src: (st:isVoid (sra:i64 (ld:i64 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>, 1:i8), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                    // Dst: (SAR64m1:isVoid addr:iPTR:$dst)
/*4587*/          /*Scope*/ 41, /*->4629*/
/*4588*/            OPC_RecordChild1, // #3 = $src
/*4589*/            OPC_MoveChild, 1,
/*4591*/            OPC_CheckOpcode, ISD::Constant,
/*4593*/            OPC_CheckType, MVT::i8,
/*4595*/            OPC_MoveParent,
/*4596*/            OPC_CheckType, MVT::i8,
/*4598*/            OPC_MoveParent,
/*4599*/            OPC_MoveChild, 2,
/*4601*/            OPC_CheckSame, 2,
/*4603*/            OPC_MoveParent,
/*4604*/            OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*4606*/            OPC_CheckPredicate, 5, // Predicate_store
/*4608*/            OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #4 #5 #6 #7 #8
/*4611*/            OPC_EmitMergeInputChains, 2, 0, 1, 
/*4615*/            OPC_EmitConvertToTarget, 3,
/*4617*/            OPC_MorphNodeTo, TARGET_OPCODE(X86::SAR8mi), 0|OPFL_Chain|OPFL_MemRefs,
                        0/*#VTs*/, 6/*#Ops*/, 4, 5, 6, 7, 8, 9, 
                    // Src: (st:isVoid (sra:i8 (ld:i8 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>, (imm:i8):$src), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                    // Dst: (SAR8mi:isVoid addr:iPTR:$dst, (imm:i8):$src)
/*4629*/          0, /*End of Scope*/
/*4630*/        /*Scope*/ 44, /*->4675*/
/*4631*/          OPC_CheckPredicate, 6, // Predicate_loadi16
/*4633*/          OPC_MoveParent,
/*4634*/          OPC_RecordChild1, // #3 = $src
/*4635*/          OPC_MoveChild, 1,
/*4637*/          OPC_CheckOpcode, ISD::Constant,
/*4639*/          OPC_CheckType, MVT::i8,
/*4641*/          OPC_MoveParent,
/*4642*/          OPC_CheckType, MVT::i16,
/*4644*/          OPC_MoveParent,
/*4645*/          OPC_MoveChild, 2,
/*4647*/          OPC_CheckSame, 2,
/*4649*/          OPC_MoveParent,
/*4650*/          OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*4652*/          OPC_CheckPredicate, 5, // Predicate_store
/*4654*/          OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #4 #5 #6 #7 #8
/*4657*/          OPC_EmitMergeInputChains, 2, 0, 1, 
/*4661*/          OPC_EmitConvertToTarget, 3,
/*4663*/          OPC_MorphNodeTo, TARGET_OPCODE(X86::SAR16mi), 0|OPFL_Chain|OPFL_MemRefs,
                      0/*#VTs*/, 6/*#Ops*/, 4, 5, 6, 7, 8, 9, 
                  // Src: (st:isVoid (sra:i16 (ld:i16 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, (imm:i8):$src), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                  // Dst: (SAR16mi:isVoid addr:iPTR:$dst, (imm:i8):$src)
/*4675*/        /*Scope*/ 44, /*->4720*/
/*4676*/          OPC_CheckPredicate, 3, // Predicate_loadi32
/*4678*/          OPC_MoveParent,
/*4679*/          OPC_RecordChild1, // #3 = $src
/*4680*/          OPC_MoveChild, 1,
/*4682*/          OPC_CheckOpcode, ISD::Constant,
/*4684*/          OPC_CheckType, MVT::i8,
/*4686*/          OPC_MoveParent,
/*4687*/          OPC_CheckType, MVT::i32,
/*4689*/          OPC_MoveParent,
/*4690*/          OPC_MoveChild, 2,
/*4692*/          OPC_CheckSame, 2,
/*4694*/          OPC_MoveParent,
/*4695*/          OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*4697*/          OPC_CheckPredicate, 5, // Predicate_store
/*4699*/          OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #4 #5 #6 #7 #8
/*4702*/          OPC_EmitMergeInputChains, 2, 0, 1, 
/*4706*/          OPC_EmitConvertToTarget, 3,
/*4708*/          OPC_MorphNodeTo, TARGET_OPCODE(X86::SAR32mi), 0|OPFL_Chain|OPFL_MemRefs,
                      0/*#VTs*/, 6/*#Ops*/, 4, 5, 6, 7, 8, 9, 
                  // Src: (st:isVoid (sra:i32 (ld:i32 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, (imm:i8):$src), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                  // Dst: (SAR32mi:isVoid addr:iPTR:$dst, (imm:i8):$src)
/*4720*/        /*Scope*/ 85, /*->4806*/
/*4721*/          OPC_CheckPredicate, 8, // Predicate_load
/*4723*/          OPC_CheckPredicate, 9, // Predicate_dsload
/*4725*/          OPC_MoveParent,
/*4726*/          OPC_RecordChild1, // #3 = $src
/*4727*/          OPC_Scope, 40, /*->4769*/ // 2 children in Scope
/*4729*/            OPC_MoveChild, 1,
/*4731*/            OPC_CheckOpcode, ISD::Constant,
/*4733*/            OPC_CheckType, MVT::i8,
/*4735*/            OPC_MoveParent,
/*4736*/            OPC_CheckType, MVT::i64,
/*4738*/            OPC_MoveParent,
/*4739*/            OPC_MoveChild, 2,
/*4741*/            OPC_CheckSame, 2,
/*4743*/            OPC_MoveParent,
/*4744*/            OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*4746*/            OPC_CheckPredicate, 5, // Predicate_store
/*4748*/            OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #4 #5 #6 #7 #8
/*4751*/            OPC_EmitMergeInputChains, 2, 0, 1, 
/*4755*/            OPC_EmitConvertToTarget, 3,
/*4757*/            OPC_MorphNodeTo, TARGET_OPCODE(X86::SAR64mi), 0|OPFL_Chain|OPFL_MemRefs,
                        0/*#VTs*/, 6/*#Ops*/, 4, 5, 6, 7, 8, 9, 
                    // Src: (st:isVoid (sra:i64 (ld:i64 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>, (imm:i8):$src), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                    // Dst: (SAR64mi:isVoid addr:iPTR:$dst, (imm:i8):$src)
/*4769*/          /*Scope*/ 35, /*->4805*/
/*4770*/            OPC_CheckChild1Type, MVT::i8,
/*4772*/            OPC_CheckType, MVT::i8,
/*4774*/            OPC_MoveParent,
/*4775*/            OPC_MoveChild, 2,
/*4777*/            OPC_CheckSame, 2,
/*4779*/            OPC_MoveParent,
/*4780*/            OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*4782*/            OPC_CheckPredicate, 5, // Predicate_store
/*4784*/            OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #4 #5 #6 #7 #8
/*4787*/            OPC_EmitMergeInputChains, 2, 0, 1, 
/*4791*/            OPC_EmitCopyToReg, 3, X86::CL,
/*4794*/            OPC_MorphNodeTo, TARGET_OPCODE(X86::SAR8mCL), 0|OPFL_Chain|OPFL_FlagInput|OPFL_MemRefs,
                        0/*#VTs*/, 5/*#Ops*/, 4, 5, 6, 7, 8, 
                    // Src: (st:isVoid (sra:i8 (ld:i8 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>, CL:i8), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                    // Dst: (SAR8mCL:isVoid addr:iPTR:$dst)
/*4805*/          0, /*End of Scope*/
/*4806*/        /*Scope*/ 39, /*->4846*/
/*4807*/          OPC_CheckPredicate, 6, // Predicate_loadi16
/*4809*/          OPC_MoveParent,
/*4810*/          OPC_RecordChild1, // #3 = physreg input CL
/*4811*/          OPC_CheckChild1Type, MVT::i8,
/*4813*/          OPC_CheckType, MVT::i16,
/*4815*/          OPC_MoveParent,
/*4816*/          OPC_MoveChild, 2,
/*4818*/          OPC_CheckSame, 2,
/*4820*/          OPC_MoveParent,
/*4821*/          OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*4823*/          OPC_CheckPredicate, 5, // Predicate_store
/*4825*/          OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #4 #5 #6 #7 #8
/*4828*/          OPC_EmitMergeInputChains, 2, 0, 1, 
/*4832*/          OPC_EmitCopyToReg, 3, X86::CL,
/*4835*/          OPC_MorphNodeTo, TARGET_OPCODE(X86::SAR16mCL), 0|OPFL_Chain|OPFL_FlagInput|OPFL_MemRefs,
                      0/*#VTs*/, 5/*#Ops*/, 4, 5, 6, 7, 8, 
                  // Src: (st:isVoid (sra:i16 (ld:i16 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, CL:i8), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                  // Dst: (SAR16mCL:isVoid addr:iPTR:$dst)
/*4846*/        /*Scope*/ 39, /*->4886*/
/*4847*/          OPC_CheckPredicate, 3, // Predicate_loadi32
/*4849*/          OPC_MoveParent,
/*4850*/          OPC_RecordChild1, // #3 = physreg input CL
/*4851*/          OPC_CheckChild1Type, MVT::i8,
/*4853*/          OPC_CheckType, MVT::i32,
/*4855*/          OPC_MoveParent,
/*4856*/          OPC_MoveChild, 2,
/*4858*/          OPC_CheckSame, 2,
/*4860*/          OPC_MoveParent,
/*4861*/          OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*4863*/          OPC_CheckPredicate, 5, // Predicate_store
/*4865*/          OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #4 #5 #6 #7 #8
/*4868*/          OPC_EmitMergeInputChains, 2, 0, 1, 
/*4872*/          OPC_EmitCopyToReg, 3, X86::CL,
/*4875*/          OPC_MorphNodeTo, TARGET_OPCODE(X86::SAR32mCL), 0|OPFL_Chain|OPFL_FlagInput|OPFL_MemRefs,
                      0/*#VTs*/, 5/*#Ops*/, 4, 5, 6, 7, 8, 
                  // Src: (st:isVoid (sra:i32 (ld:i32 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, CL:i8), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                  // Dst: (SAR32mCL:isVoid addr:iPTR:$dst)
/*4886*/        /*Scope*/ 41, /*->4928*/
/*4887*/          OPC_CheckPredicate, 8, // Predicate_load
/*4889*/          OPC_CheckPredicate, 9, // Predicate_dsload
/*4891*/          OPC_MoveParent,
/*4892*/          OPC_RecordChild1, // #3 = physreg input CL
/*4893*/          OPC_CheckChild1Type, MVT::i8,
/*4895*/          OPC_CheckType, MVT::i64,
/*4897*/          OPC_MoveParent,
/*4898*/          OPC_MoveChild, 2,
/*4900*/          OPC_CheckSame, 2,
/*4902*/          OPC_MoveParent,
/*4903*/          OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*4905*/          OPC_CheckPredicate, 5, // Predicate_store
/*4907*/          OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #4 #5 #6 #7 #8
/*4910*/          OPC_EmitMergeInputChains, 2, 0, 1, 
/*4914*/          OPC_EmitCopyToReg, 3, X86::CL,
/*4917*/          OPC_MorphNodeTo, TARGET_OPCODE(X86::SAR64mCL), 0|OPFL_Chain|OPFL_FlagInput|OPFL_MemRefs,
                      0/*#VTs*/, 5/*#Ops*/, 4, 5, 6, 7, 8, 
                  // Src: (st:isVoid (sra:i64 (ld:i64 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>, CL:i8), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                  // Dst: (SAR64mCL:isVoid addr:iPTR:$dst)
/*4928*/        0, /*End of Scope*/
              /*SwitchOpcode*/ 95|128,4/*607*/,  ISD::SUB,// ->5539
/*4932*/        OPC_MoveChild, 0,
/*4934*/        OPC_Scope, 31|128,1/*159*/, /*->5096*/ // 2 children in Scope
/*4937*/          OPC_CheckInteger, 0, 
/*4939*/          OPC_MoveParent,
/*4940*/          OPC_MoveChild, 1,
/*4942*/          OPC_CheckOpcode, ISD::LOAD,
/*4944*/          OPC_RecordMemRef,
/*4945*/          OPC_RecordNode, // #1 = 'ld' chained node
/*4946*/          OPC_CheckFoldableChainNode,
/*4947*/          OPC_RecordChild1, // #2 = $dst
/*4948*/          OPC_CheckPredicate, 2, // Predicate_unindexedload
/*4950*/          OPC_Scope, 36, /*->4988*/ // 4 children in Scope
/*4952*/            OPC_CheckPredicate, 8, // Predicate_load
/*4954*/            OPC_CheckPredicate, 9, // Predicate_dsload
/*4956*/            OPC_MoveParent,
/*4957*/            OPC_CheckType, MVT::i8,
/*4959*/            OPC_MoveParent,
/*4960*/            OPC_MoveChild, 2,
/*4962*/            OPC_CheckSame, 2,
/*4964*/            OPC_MoveParent,
/*4965*/            OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*4967*/            OPC_CheckPredicate, 5, // Predicate_store
/*4969*/            OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #3 #4 #5 #6 #7
/*4972*/            OPC_EmitMergeInputChains, 2, 0, 1, 
/*4976*/            OPC_MorphNodeTo, TARGET_OPCODE(X86::NEG8m), 0|OPFL_Chain|OPFL_MemRefs,
                        1/*#VTs*/, MVT::i32, 5/*#Ops*/, 3, 4, 5, 6, 7, 
                    // Src: (st:isVoid (sub:i8 0:i8, (ld:i8 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                    // Dst: (NEG8m:isVoid addr:iPTR:$dst)
/*4988*/          /*Scope*/ 34, /*->5023*/
/*4989*/            OPC_CheckPredicate, 6, // Predicate_loadi16
/*4991*/            OPC_MoveParent,
/*4992*/            OPC_CheckType, MVT::i16,
/*4994*/            OPC_MoveParent,
/*4995*/            OPC_MoveChild, 2,
/*4997*/            OPC_CheckSame, 2,
/*4999*/            OPC_MoveParent,
/*5000*/            OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*5002*/            OPC_CheckPredicate, 5, // Predicate_store
/*5004*/            OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #3 #4 #5 #6 #7
/*5007*/            OPC_EmitMergeInputChains, 2, 0, 1, 
/*5011*/            OPC_MorphNodeTo, TARGET_OPCODE(X86::NEG16m), 0|OPFL_Chain|OPFL_MemRefs,
                        1/*#VTs*/, MVT::i32, 5/*#Ops*/, 3, 4, 5, 6, 7, 
                    // Src: (st:isVoid (sub:i16 0:i16, (ld:i16 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                    // Dst: (NEG16m:isVoid addr:iPTR:$dst)
/*5023*/          /*Scope*/ 34, /*->5058*/
/*5024*/            OPC_CheckPredicate, 3, // Predicate_loadi32
/*5026*/            OPC_MoveParent,
/*5027*/            OPC_CheckType, MVT::i32,
/*5029*/            OPC_MoveParent,
/*5030*/            OPC_MoveChild, 2,
/*5032*/            OPC_CheckSame, 2,
/*5034*/            OPC_MoveParent,
/*5035*/            OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*5037*/            OPC_CheckPredicate, 5, // Predicate_store
/*5039*/            OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #3 #4 #5 #6 #7
/*5042*/            OPC_EmitMergeInputChains, 2, 0, 1, 
/*5046*/            OPC_MorphNodeTo, TARGET_OPCODE(X86::NEG32m), 0|OPFL_Chain|OPFL_MemRefs,
                        1/*#VTs*/, MVT::i32, 5/*#Ops*/, 3, 4, 5, 6, 7, 
                    // Src: (st:isVoid (sub:i32 0:i32, (ld:i32 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                    // Dst: (NEG32m:isVoid addr:iPTR:$dst)
/*5058*/          /*Scope*/ 36, /*->5095*/
/*5059*/            OPC_CheckPredicate, 8, // Predicate_load
/*5061*/            OPC_CheckPredicate, 9, // Predicate_dsload
/*5063*/            OPC_MoveParent,
/*5064*/            OPC_CheckType, MVT::i64,
/*5066*/            OPC_MoveParent,
/*5067*/            OPC_MoveChild, 2,
/*5069*/            OPC_CheckSame, 2,
/*5071*/            OPC_MoveParent,
/*5072*/            OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*5074*/            OPC_CheckPredicate, 5, // Predicate_store
/*5076*/            OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #3 #4 #5 #6 #7
/*5079*/            OPC_EmitMergeInputChains, 2, 0, 1, 
/*5083*/            OPC_MorphNodeTo, TARGET_OPCODE(X86::NEG64m), 0|OPFL_Chain|OPFL_MemRefs,
                        1/*#VTs*/, MVT::i32, 5/*#Ops*/, 3, 4, 5, 6, 7, 
                    // Src: (st:isVoid (sub:i64 0:i64, (ld:i64 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                    // Dst: (NEG64m:isVoid addr:iPTR:$dst)
/*5095*/          0, /*End of Scope*/
/*5096*/        /*Scope*/ 56|128,3/*440*/, /*->5538*/
/*5098*/          OPC_CheckOpcode, ISD::LOAD,
/*5100*/          OPC_RecordMemRef,
/*5101*/          OPC_RecordNode, // #1 = 'ld' chained node
/*5102*/          OPC_CheckFoldableChainNode,
/*5103*/          OPC_RecordChild1, // #2 = $dst
/*5104*/          OPC_CheckPredicate, 2, // Predicate_unindexedload
/*5106*/          OPC_Scope, 76|128,1/*204*/, /*->5313*/ // 4 children in Scope
/*5109*/            OPC_CheckPredicate, 8, // Predicate_load
/*5111*/            OPC_Scope, 26|128,1/*154*/, /*->5268*/ // 2 children in Scope
/*5114*/              OPC_MoveParent,
/*5115*/              OPC_RecordChild1, // #3 = $src2
/*5116*/              OPC_MoveChild, 1,
/*5118*/              OPC_CheckOpcode, ISD::Constant,
/*5120*/              OPC_Scope, 107, /*->5229*/ // 2 children in Scope
/*5122*/                OPC_CheckPredicate, 11, // Predicate_immSext8
/*5124*/                OPC_MoveParent,
/*5125*/                OPC_SwitchType /*3 cases */, 32,  MVT::i16,// ->5160
/*5128*/                  OPC_MoveParent,
/*5129*/                  OPC_MoveChild, 2,
/*5131*/                  OPC_CheckSame, 2,
/*5133*/                  OPC_MoveParent,
/*5134*/                  OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*5136*/                  OPC_CheckPredicate, 5, // Predicate_store
/*5138*/                  OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #4 #5 #6 #7 #8
/*5141*/                  OPC_EmitMergeInputChains, 2, 0, 1, 
/*5145*/                  OPC_EmitConvertToTarget, 3,
/*5147*/                  OPC_MorphNodeTo, TARGET_OPCODE(X86::SUB16mi8), 0|OPFL_Chain|OPFL_MemRefs,
                              1/*#VTs*/, MVT::i32, 6/*#Ops*/, 4, 5, 6, 7, 8, 9, 
                          // Src: (st:isVoid (sub:i16 (ld:i16 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:i16)<<P:Predicate_immSext8>>:$src2), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                          // Dst: (SUB16mi8:isVoid addr:iPTR:$dst, (imm:i16):$src2)
                        /*SwitchType*/ 32,  MVT::i32,// ->5194
/*5162*/                  OPC_MoveParent,
/*5163*/                  OPC_MoveChild, 2,
/*5165*/                  OPC_CheckSame, 2,
/*5167*/                  OPC_MoveParent,
/*5168*/                  OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*5170*/                  OPC_CheckPredicate, 5, // Predicate_store
/*5172*/                  OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #4 #5 #6 #7 #8
/*5175*/                  OPC_EmitMergeInputChains, 2, 0, 1, 
/*5179*/                  OPC_EmitConvertToTarget, 3,
/*5181*/                  OPC_MorphNodeTo, TARGET_OPCODE(X86::SUB32mi8), 0|OPFL_Chain|OPFL_MemRefs,
                              1/*#VTs*/, MVT::i32, 6/*#Ops*/, 4, 5, 6, 7, 8, 9, 
                          // Src: (st:isVoid (sub:i32 (ld:i32 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:i32)<<P:Predicate_immSext8>>:$src2), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                          // Dst: (SUB32mi8:isVoid addr:iPTR:$dst, (imm:i32):$src2)
                        /*SwitchType*/ 32,  MVT::i64,// ->5228
/*5196*/                  OPC_MoveParent,
/*5197*/                  OPC_MoveChild, 2,
/*5199*/                  OPC_CheckSame, 2,
/*5201*/                  OPC_MoveParent,
/*5202*/                  OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*5204*/                  OPC_CheckPredicate, 5, // Predicate_store
/*5206*/                  OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #4 #5 #6 #7 #8
/*5209*/                  OPC_EmitMergeInputChains, 2, 0, 1, 
/*5213*/                  OPC_EmitConvertToTarget, 3,
/*5215*/                  OPC_MorphNodeTo, TARGET_OPCODE(X86::SUB64mi8), 0|OPFL_Chain|OPFL_MemRefs,
                              1/*#VTs*/, MVT::i32, 6/*#Ops*/, 4, 5, 6, 7, 8, 9, 
                          // Src: (st:isVoid (sub:i64 (ld:i64 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:i64)<<P:Predicate_immSext8>>:$src2), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                          // Dst: (SUB64mi8:isVoid addr:iPTR:$dst, (imm:i64):$src2)
                        0, // EndSwitchType
/*5229*/              /*Scope*/ 37, /*->5267*/
/*5230*/                OPC_CheckPredicate, 12, // Predicate_i64immSExt32
/*5232*/                OPC_MoveParent,
/*5233*/                OPC_CheckType, MVT::i64,
/*5235*/                OPC_MoveParent,
/*5236*/                OPC_MoveChild, 2,
/*5238*/                OPC_CheckSame, 2,
/*5240*/                OPC_MoveParent,
/*5241*/                OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*5243*/                OPC_CheckPredicate, 5, // Predicate_store
/*5245*/                OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #4 #5 #6 #7 #8
/*5248*/                OPC_EmitMergeInputChains, 2, 0, 1, 
/*5252*/                OPC_EmitConvertToTarget, 3,
/*5254*/                OPC_MorphNodeTo, TARGET_OPCODE(X86::SUB64mi32), 0|OPFL_Chain|OPFL_MemRefs,
                            1/*#VTs*/, MVT::i32, 6/*#Ops*/, 4, 5, 6, 7, 8, 9, 
                        // Src: (st:isVoid (sub:i64 (ld:i64 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:i64)<<P:Predicate_i64immSExt32>>:$src2), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                        // Dst: (SUB64mi32:isVoid addr:iPTR:$dst, (imm:i64):$src2)
/*5267*/              0, /*End of Scope*/
/*5268*/            /*Scope*/ 43, /*->5312*/
/*5269*/              OPC_CheckPredicate, 9, // Predicate_dsload
/*5271*/              OPC_MoveParent,
/*5272*/              OPC_RecordChild1, // #3 = $src2
/*5273*/              OPC_MoveChild, 1,
/*5275*/              OPC_CheckOpcode, ISD::Constant,
/*5277*/              OPC_MoveParent,
/*5278*/              OPC_CheckType, MVT::i8,
/*5280*/              OPC_MoveParent,
/*5281*/              OPC_MoveChild, 2,
/*5283*/              OPC_CheckSame, 2,
/*5285*/              OPC_MoveParent,
/*5286*/              OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*5288*/              OPC_CheckPredicate, 5, // Predicate_store
/*5290*/              OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #4 #5 #6 #7 #8
/*5293*/              OPC_EmitMergeInputChains, 2, 0, 1, 
/*5297*/              OPC_EmitConvertToTarget, 3,
/*5299*/              OPC_MorphNodeTo, TARGET_OPCODE(X86::SUB8mi), 0|OPFL_Chain|OPFL_MemRefs,
                          1/*#VTs*/, MVT::i32, 6/*#Ops*/, 4, 5, 6, 7, 8, 9, 
                      // Src: (st:isVoid (sub:i8 (ld:i8 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>, (imm:i8):$src2), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                      // Dst: (SUB8mi:isVoid addr:iPTR:$dst, (imm:i8):$src2)
/*5312*/            0, /*End of Scope*/
/*5313*/          /*Scope*/ 43, /*->5357*/
/*5314*/            OPC_CheckPredicate, 6, // Predicate_loadi16
/*5316*/            OPC_MoveParent,
/*5317*/            OPC_RecordChild1, // #3 = $src2
/*5318*/            OPC_MoveChild, 1,
/*5320*/            OPC_CheckOpcode, ISD::Constant,
/*5322*/            OPC_MoveParent,
/*5323*/            OPC_CheckType, MVT::i16,
/*5325*/            OPC_MoveParent,
/*5326*/            OPC_MoveChild, 2,
/*5328*/            OPC_CheckSame, 2,
/*5330*/            OPC_MoveParent,
/*5331*/            OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*5333*/            OPC_CheckPredicate, 5, // Predicate_store
/*5335*/            OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #4 #5 #6 #7 #8
/*5338*/            OPC_EmitMergeInputChains, 2, 0, 1, 
/*5342*/            OPC_EmitConvertToTarget, 3,
/*5344*/            OPC_MorphNodeTo, TARGET_OPCODE(X86::SUB16mi), 0|OPFL_Chain|OPFL_MemRefs,
                        1/*#VTs*/, MVT::i32, 6/*#Ops*/, 4, 5, 6, 7, 8, 9, 
                    // Src: (st:isVoid (sub:i16 (ld:i16 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, (imm:i16):$src2), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                    // Dst: (SUB16mi:isVoid addr:iPTR:$dst, (imm:i16):$src2)
/*5357*/          /*Scope*/ 43, /*->5401*/
/*5358*/            OPC_CheckPredicate, 3, // Predicate_loadi32
/*5360*/            OPC_MoveParent,
/*5361*/            OPC_RecordChild1, // #3 = $src2
/*5362*/            OPC_MoveChild, 1,
/*5364*/            OPC_CheckOpcode, ISD::Constant,
/*5366*/            OPC_MoveParent,
/*5367*/            OPC_CheckType, MVT::i32,
/*5369*/            OPC_MoveParent,
/*5370*/            OPC_MoveChild, 2,
/*5372*/            OPC_CheckSame, 2,
/*5374*/            OPC_MoveParent,
/*5375*/            OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*5377*/            OPC_CheckPredicate, 5, // Predicate_store
/*5379*/            OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #4 #5 #6 #7 #8
/*5382*/            OPC_EmitMergeInputChains, 2, 0, 1, 
/*5386*/            OPC_EmitConvertToTarget, 3,
/*5388*/            OPC_MorphNodeTo, TARGET_OPCODE(X86::SUB32mi), 0|OPFL_Chain|OPFL_MemRefs,
                        1/*#VTs*/, MVT::i32, 6/*#Ops*/, 4, 5, 6, 7, 8, 9, 
                    // Src: (st:isVoid (sub:i32 (ld:i32 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, (imm:i32):$src2), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                    // Dst: (SUB32mi:isVoid addr:iPTR:$dst, (imm:i32):$src2)
/*5401*/          /*Scope*/ 6|128,1/*134*/, /*->5537*/
/*5403*/            OPC_CheckPredicate, 8, // Predicate_load
/*5405*/            OPC_MoveParent,
/*5406*/            OPC_RecordChild1, // #3 = $src2
/*5407*/            OPC_SwitchType /*4 cases */, 30,  MVT::i8,// ->5440
/*5410*/              OPC_MoveParent,
/*5411*/              OPC_MoveChild, 2,
/*5413*/              OPC_CheckSame, 2,
/*5415*/              OPC_MoveParent,
/*5416*/              OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*5418*/              OPC_CheckPredicate, 5, // Predicate_store
/*5420*/              OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #4 #5 #6 #7 #8
/*5423*/              OPC_EmitMergeInputChains, 2, 0, 1, 
/*5427*/              OPC_MorphNodeTo, TARGET_OPCODE(X86::SUB8mr), 0|OPFL_Chain|OPFL_MemRefs,
                          1/*#VTs*/, MVT::i32, 6/*#Ops*/, 4, 5, 6, 7, 8, 3, 
                      // Src: (st:isVoid (sub:i8 (ld:i8 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR8:i8:$src2), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                      // Dst: (SUB8mr:isVoid addr:iPTR:$dst, GR8:i8:$src2)
                    /*SwitchType*/ 30,  MVT::i16,// ->5472
/*5442*/              OPC_MoveParent,
/*5443*/              OPC_MoveChild, 2,
/*5445*/              OPC_CheckSame, 2,
/*5447*/              OPC_MoveParent,
/*5448*/              OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*5450*/              OPC_CheckPredicate, 5, // Predicate_store
/*5452*/              OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #4 #5 #6 #7 #8
/*5455*/              OPC_EmitMergeInputChains, 2, 0, 1, 
/*5459*/              OPC_MorphNodeTo, TARGET_OPCODE(X86::SUB16mr), 0|OPFL_Chain|OPFL_MemRefs,
                          1/*#VTs*/, MVT::i32, 6/*#Ops*/, 4, 5, 6, 7, 8, 3, 
                      // Src: (st:isVoid (sub:i16 (ld:i16 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR16:i16:$src2), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                      // Dst: (SUB16mr:isVoid addr:iPTR:$dst, GR16:i16:$src2)
                    /*SwitchType*/ 30,  MVT::i32,// ->5504
/*5474*/              OPC_MoveParent,
/*5475*/              OPC_MoveChild, 2,
/*5477*/              OPC_CheckSame, 2,
/*5479*/              OPC_MoveParent,
/*5480*/              OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*5482*/              OPC_CheckPredicate, 5, // Predicate_store
/*5484*/              OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #4 #5 #6 #7 #8
/*5487*/              OPC_EmitMergeInputChains, 2, 0, 1, 
/*5491*/              OPC_MorphNodeTo, TARGET_OPCODE(X86::SUB32mr), 0|OPFL_Chain|OPFL_MemRefs,
                          1/*#VTs*/, MVT::i32, 6/*#Ops*/, 4, 5, 6, 7, 8, 3, 
                      // Src: (st:isVoid (sub:i32 (ld:i32 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR32:i32:$src2), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                      // Dst: (SUB32mr:isVoid addr:iPTR:$dst, GR32:i32:$src2)
                    /*SwitchType*/ 30,  MVT::i64,// ->5536
/*5506*/              OPC_MoveParent,
/*5507*/              OPC_MoveChild, 2,
/*5509*/              OPC_CheckSame, 2,
/*5511*/              OPC_MoveParent,
/*5512*/              OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*5514*/              OPC_CheckPredicate, 5, // Predicate_store
/*5516*/              OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #4 #5 #6 #7 #8
/*5519*/              OPC_EmitMergeInputChains, 2, 0, 1, 
/*5523*/              OPC_MorphNodeTo, TARGET_OPCODE(X86::SUB64mr), 0|OPFL_Chain|OPFL_MemRefs,
                          1/*#VTs*/, MVT::i32, 6/*#Ops*/, 4, 5, 6, 7, 8, 3, 
                      // Src: (st:isVoid (sub:i64 (ld:i64 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR64:i64:$src2), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                      // Dst: (SUB64mr:isVoid addr:iPTR:$dst, GR64:i64:$src2)
                    0, // EndSwitchType
/*5537*/          0, /*End of Scope*/
/*5538*/        0, /*End of Scope*/
              /*SwitchOpcode*/ 17|128,6/*785*/,  ISD::XOR,// ->6327
/*5542*/        OPC_Scope, 123|128,4/*635*/, /*->6180*/ // 2 children in Scope
/*5545*/          OPC_MoveChild, 0,
/*5547*/          OPC_CheckOpcode, ISD::LOAD,
/*5549*/          OPC_RecordMemRef,
/*5550*/          OPC_RecordNode, // #1 = 'ld' chained node
/*5551*/          OPC_CheckFoldableChainNode,
/*5552*/          OPC_RecordChild1, // #2 = $dst
/*5553*/          OPC_CheckPredicate, 2, // Predicate_unindexedload
/*5555*/          OPC_Scope, 49, /*->5606*/ // 7 children in Scope
/*5557*/            OPC_CheckPredicate, 8, // Predicate_load
/*5559*/            OPC_CheckPredicate, 9, // Predicate_dsload
/*5561*/            OPC_MoveParent,
/*5562*/            OPC_MoveChild, 1,
/*5564*/            OPC_CheckInteger, 127|128,127|128,127|128,127|128,127|128,127|128,127|128,127|128,127|128,1/*18446744073709551615*/, 
/*5575*/            OPC_MoveParent,
/*5576*/            OPC_CheckType, MVT::i8,
/*5578*/            OPC_MoveParent,
/*5579*/            OPC_MoveChild, 2,
/*5581*/            OPC_CheckSame, 2,
/*5583*/            OPC_MoveParent,
/*5584*/            OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*5586*/            OPC_CheckPredicate, 5, // Predicate_store
/*5588*/            OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #3 #4 #5 #6 #7
/*5591*/            OPC_EmitMergeInputChains, 2, 0, 1, 
/*5595*/            OPC_MorphNodeTo, TARGET_OPCODE(X86::NOT8m), 0|OPFL_Chain|OPFL_MemRefs,
                        0/*#VTs*/, 5/*#Ops*/, 3, 4, 5, 6, 7, 
                    // Src: (st:isVoid (xor:i8 (ld:i8 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>, -1:i8), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                    // Dst: (NOT8m:isVoid addr:iPTR:$dst)
/*5606*/          /*Scope*/ 47, /*->5654*/
/*5607*/            OPC_CheckPredicate, 6, // Predicate_loadi16
/*5609*/            OPC_MoveParent,
/*5610*/            OPC_MoveChild, 1,
/*5612*/            OPC_CheckInteger, 127|128,127|128,127|128,127|128,127|128,127|128,127|128,127|128,127|128,1/*18446744073709551615*/, 
/*5623*/            OPC_MoveParent,
/*5624*/            OPC_CheckType, MVT::i16,
/*5626*/            OPC_MoveParent,
/*5627*/            OPC_MoveChild, 2,
/*5629*/            OPC_CheckSame, 2,
/*5631*/            OPC_MoveParent,
/*5632*/            OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*5634*/            OPC_CheckPredicate, 5, // Predicate_store
/*5636*/            OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #3 #4 #5 #6 #7
/*5639*/            OPC_EmitMergeInputChains, 2, 0, 1, 
/*5643*/            OPC_MorphNodeTo, TARGET_OPCODE(X86::NOT16m), 0|OPFL_Chain|OPFL_MemRefs,
                        0/*#VTs*/, 5/*#Ops*/, 3, 4, 5, 6, 7, 
                    // Src: (st:isVoid (xor:i16 (ld:i16 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, -1:i16), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                    // Dst: (NOT16m:isVoid addr:iPTR:$dst)
/*5654*/          /*Scope*/ 47, /*->5702*/
/*5655*/            OPC_CheckPredicate, 3, // Predicate_loadi32
/*5657*/            OPC_MoveParent,
/*5658*/            OPC_MoveChild, 1,
/*5660*/            OPC_CheckInteger, 127|128,127|128,127|128,127|128,127|128,127|128,127|128,127|128,127|128,1/*18446744073709551615*/, 
/*5671*/            OPC_MoveParent,
/*5672*/            OPC_CheckType, MVT::i32,
/*5674*/            OPC_MoveParent,
/*5675*/            OPC_MoveChild, 2,
/*5677*/            OPC_CheckSame, 2,
/*5679*/            OPC_MoveParent,
/*5680*/            OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*5682*/            OPC_CheckPredicate, 5, // Predicate_store
/*5684*/            OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #3 #4 #5 #6 #7
/*5687*/            OPC_EmitMergeInputChains, 2, 0, 1, 
/*5691*/            OPC_MorphNodeTo, TARGET_OPCODE(X86::NOT32m), 0|OPFL_Chain|OPFL_MemRefs,
                        0/*#VTs*/, 5/*#Ops*/, 3, 4, 5, 6, 7, 
                    // Src: (st:isVoid (xor:i32 (ld:i32 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, -1:i32), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                    // Dst: (NOT32m:isVoid addr:iPTR:$dst)
/*5702*/          /*Scope*/ 123|128,1/*251*/, /*->5955*/
/*5704*/            OPC_CheckPredicate, 8, // Predicate_load
/*5706*/            OPC_Scope, 47, /*->5755*/ // 3 children in Scope
/*5708*/              OPC_CheckPredicate, 9, // Predicate_dsload
/*5710*/              OPC_MoveParent,
/*5711*/              OPC_MoveChild, 1,
/*5713*/              OPC_CheckInteger, 127|128,127|128,127|128,127|128,127|128,127|128,127|128,127|128,127|128,1/*18446744073709551615*/, 
/*5724*/              OPC_MoveParent,
/*5725*/              OPC_CheckType, MVT::i64,
/*5727*/              OPC_MoveParent,
/*5728*/              OPC_MoveChild, 2,
/*5730*/              OPC_CheckSame, 2,
/*5732*/              OPC_MoveParent,
/*5733*/              OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*5735*/              OPC_CheckPredicate, 5, // Predicate_store
/*5737*/              OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #3 #4 #5 #6 #7
/*5740*/              OPC_EmitMergeInputChains, 2, 0, 1, 
/*5744*/              OPC_MorphNodeTo, TARGET_OPCODE(X86::NOT64m), 0|OPFL_Chain|OPFL_MemRefs,
                          0/*#VTs*/, 5/*#Ops*/, 3, 4, 5, 6, 7, 
                      // Src: (st:isVoid (xor:i64 (ld:i64 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>, -1:i64), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                      // Dst: (NOT64m:isVoid addr:iPTR:$dst)
/*5755*/            /*Scope*/ 113, /*->5869*/
/*5756*/              OPC_MoveParent,
/*5757*/              OPC_RecordChild1, // #3 = $src
/*5758*/              OPC_MoveChild, 1,
/*5760*/              OPC_CheckOpcode, ISD::Constant,
/*5762*/              OPC_CheckPredicate, 11, // Predicate_immSext8
/*5764*/              OPC_MoveParent,
/*5765*/              OPC_SwitchType /*3 cases */, 32,  MVT::i16,// ->5800
/*5768*/                OPC_MoveParent,
/*5769*/                OPC_MoveChild, 2,
/*5771*/                OPC_CheckSame, 2,
/*5773*/                OPC_MoveParent,
/*5774*/                OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*5776*/                OPC_CheckPredicate, 5, // Predicate_store
/*5778*/                OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #4 #5 #6 #7 #8
/*5781*/                OPC_EmitMergeInputChains, 2, 0, 1, 
/*5785*/                OPC_EmitConvertToTarget, 3,
/*5787*/                OPC_MorphNodeTo, TARGET_OPCODE(X86::XOR16mi8), 0|OPFL_Chain|OPFL_MemRefs,
                            1/*#VTs*/, MVT::i32, 6/*#Ops*/, 4, 5, 6, 7, 8, 9, 
                        // Src: (st:isVoid (xor:i16 (ld:i16 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:i16)<<P:Predicate_immSext8>>:$src), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                        // Dst: (XOR16mi8:isVoid addr:iPTR:$dst, (imm:i16):$src)
                      /*SwitchType*/ 32,  MVT::i32,// ->5834
/*5802*/                OPC_MoveParent,
/*5803*/                OPC_MoveChild, 2,
/*5805*/                OPC_CheckSame, 2,
/*5807*/                OPC_MoveParent,
/*5808*/                OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*5810*/                OPC_CheckPredicate, 5, // Predicate_store
/*5812*/                OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #4 #5 #6 #7 #8
/*5815*/                OPC_EmitMergeInputChains, 2, 0, 1, 
/*5819*/                OPC_EmitConvertToTarget, 3,
/*5821*/                OPC_MorphNodeTo, TARGET_OPCODE(X86::XOR32mi8), 0|OPFL_Chain|OPFL_MemRefs,
                            1/*#VTs*/, MVT::i32, 6/*#Ops*/, 4, 5, 6, 7, 8, 9, 
                        // Src: (st:isVoid (xor:i32 (ld:i32 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:i32)<<P:Predicate_immSext8>>:$src), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                        // Dst: (XOR32mi8:isVoid addr:iPTR:$dst, (imm:i32):$src)
                      /*SwitchType*/ 32,  MVT::i64,// ->5868
/*5836*/                OPC_MoveParent,
/*5837*/                OPC_MoveChild, 2,
/*5839*/                OPC_CheckSame, 2,
/*5841*/                OPC_MoveParent,
/*5842*/                OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*5844*/                OPC_CheckPredicate, 5, // Predicate_store
/*5846*/                OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #4 #5 #6 #7 #8
/*5849*/                OPC_EmitMergeInputChains, 2, 0, 1, 
/*5853*/                OPC_EmitConvertToTarget, 3,
/*5855*/                OPC_MorphNodeTo, TARGET_OPCODE(X86::XOR64mi8), 0|OPFL_Chain|OPFL_MemRefs,
                            1/*#VTs*/, MVT::i32, 6/*#Ops*/, 4, 5, 6, 7, 8, 9, 
                        // Src: (st:isVoid (xor:i64 (ld:i64 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:i64)<<P:Predicate_immSext8>>:$src), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                        // Dst: (XOR64mi8:isVoid addr:iPTR:$dst, (imm:i64):$src)
                      0, // EndSwitchType
/*5869*/            /*Scope*/ 84, /*->5954*/
/*5870*/              OPC_CheckPredicate, 9, // Predicate_dsload
/*5872*/              OPC_MoveParent,
/*5873*/              OPC_RecordChild1, // #3 = $src
/*5874*/              OPC_MoveChild, 1,
/*5876*/              OPC_CheckOpcode, ISD::Constant,
/*5878*/              OPC_Scope, 37, /*->5917*/ // 2 children in Scope
/*5880*/                OPC_CheckPredicate, 12, // Predicate_i64immSExt32
/*5882*/                OPC_MoveParent,
/*5883*/                OPC_CheckType, MVT::i64,
/*5885*/                OPC_MoveParent,
/*5886*/                OPC_MoveChild, 2,
/*5888*/                OPC_CheckSame, 2,
/*5890*/                OPC_MoveParent,
/*5891*/                OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*5893*/                OPC_CheckPredicate, 5, // Predicate_store
/*5895*/                OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #4 #5 #6 #7 #8
/*5898*/                OPC_EmitMergeInputChains, 2, 0, 1, 
/*5902*/                OPC_EmitConvertToTarget, 3,
/*5904*/                OPC_MorphNodeTo, TARGET_OPCODE(X86::XOR64mi32), 0|OPFL_Chain|OPFL_MemRefs,
                            1/*#VTs*/, MVT::i32, 6/*#Ops*/, 4, 5, 6, 7, 8, 9, 
                        // Src: (st:isVoid (xor:i64 (ld:i64 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>, (imm:i64)<<P:Predicate_i64immSExt32>>:$src), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                        // Dst: (XOR64mi32:isVoid addr:iPTR:$dst, (imm:i64):$src)
/*5917*/              /*Scope*/ 35, /*->5953*/
/*5918*/                OPC_MoveParent,
/*5919*/                OPC_CheckType, MVT::i8,
/*5921*/                OPC_MoveParent,
/*5922*/                OPC_MoveChild, 2,
/*5924*/                OPC_CheckSame, 2,
/*5926*/                OPC_MoveParent,
/*5927*/                OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*5929*/                OPC_CheckPredicate, 5, // Predicate_store
/*5931*/                OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #4 #5 #6 #7 #8
/*5934*/                OPC_EmitMergeInputChains, 2, 0, 1, 
/*5938*/                OPC_EmitConvertToTarget, 3,
/*5940*/                OPC_MorphNodeTo, TARGET_OPCODE(X86::XOR8mi), 0|OPFL_Chain|OPFL_MemRefs,
                            1/*#VTs*/, MVT::i32, 6/*#Ops*/, 4, 5, 6, 7, 8, 9, 
                        // Src: (st:isVoid (xor:i8 (ld:i8 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>, (imm:i8):$src), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                        // Dst: (XOR8mi:isVoid addr:iPTR:$dst, (imm:i8):$src)
/*5953*/              0, /*End of Scope*/
/*5954*/            0, /*End of Scope*/
/*5955*/          /*Scope*/ 43, /*->5999*/
/*5956*/            OPC_CheckPredicate, 6, // Predicate_loadi16
/*5958*/            OPC_MoveParent,
/*5959*/            OPC_RecordChild1, // #3 = $src
/*5960*/            OPC_MoveChild, 1,
/*5962*/            OPC_CheckOpcode, ISD::Constant,
/*5964*/            OPC_MoveParent,
/*5965*/            OPC_CheckType, MVT::i16,
/*5967*/            OPC_MoveParent,
/*5968*/            OPC_MoveChild, 2,
/*5970*/            OPC_CheckSame, 2,
/*5972*/            OPC_MoveParent,
/*5973*/            OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*5975*/            OPC_CheckPredicate, 5, // Predicate_store
/*5977*/            OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #4 #5 #6 #7 #8
/*5980*/            OPC_EmitMergeInputChains, 2, 0, 1, 
/*5984*/            OPC_EmitConvertToTarget, 3,
/*5986*/            OPC_MorphNodeTo, TARGET_OPCODE(X86::XOR16mi), 0|OPFL_Chain|OPFL_MemRefs,
                        1/*#VTs*/, MVT::i32, 6/*#Ops*/, 4, 5, 6, 7, 8, 9, 
                    // Src: (st:isVoid (xor:i16 (ld:i16 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, (imm:i16):$src), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                    // Dst: (XOR16mi:isVoid addr:iPTR:$dst, (imm:i16):$src)
/*5999*/          /*Scope*/ 43, /*->6043*/
/*6000*/            OPC_CheckPredicate, 3, // Predicate_loadi32
/*6002*/            OPC_MoveParent,
/*6003*/            OPC_RecordChild1, // #3 = $src
/*6004*/            OPC_MoveChild, 1,
/*6006*/            OPC_CheckOpcode, ISD::Constant,
/*6008*/            OPC_MoveParent,
/*6009*/            OPC_CheckType, MVT::i32,
/*6011*/            OPC_MoveParent,
/*6012*/            OPC_MoveChild, 2,
/*6014*/            OPC_CheckSame, 2,
/*6016*/            OPC_MoveParent,
/*6017*/            OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*6019*/            OPC_CheckPredicate, 5, // Predicate_store
/*6021*/            OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #4 #5 #6 #7 #8
/*6024*/            OPC_EmitMergeInputChains, 2, 0, 1, 
/*6028*/            OPC_EmitConvertToTarget, 3,
/*6030*/            OPC_MorphNodeTo, TARGET_OPCODE(X86::XOR32mi), 0|OPFL_Chain|OPFL_MemRefs,
                        1/*#VTs*/, MVT::i32, 6/*#Ops*/, 4, 5, 6, 7, 8, 9, 
                    // Src: (st:isVoid (xor:i32 (ld:i32 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, (imm:i32):$src), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                    // Dst: (XOR32mi:isVoid addr:iPTR:$dst, (imm:i32):$src)
/*6043*/          /*Scope*/ 6|128,1/*134*/, /*->6179*/
/*6045*/            OPC_CheckPredicate, 8, // Predicate_load
/*6047*/            OPC_MoveParent,
/*6048*/            OPC_RecordChild1, // #3 = $src
/*6049*/            OPC_SwitchType /*4 cases */, 30,  MVT::i8,// ->6082
/*6052*/              OPC_MoveParent,
/*6053*/              OPC_MoveChild, 2,
/*6055*/              OPC_CheckSame, 2,
/*6057*/              OPC_MoveParent,
/*6058*/              OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*6060*/              OPC_CheckPredicate, 5, // Predicate_store
/*6062*/              OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #4 #5 #6 #7 #8
/*6065*/              OPC_EmitMergeInputChains, 2, 0, 1, 
/*6069*/              OPC_MorphNodeTo, TARGET_OPCODE(X86::XOR8mr), 0|OPFL_Chain|OPFL_MemRefs,
                          1/*#VTs*/, MVT::i32, 6/*#Ops*/, 4, 5, 6, 7, 8, 3, 
                      // Src: (st:isVoid (xor:i8 (ld:i8 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR8:i8:$src), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                      // Dst: (XOR8mr:isVoid addr:iPTR:$dst, GR8:i8:$src)
                    /*SwitchType*/ 30,  MVT::i16,// ->6114
/*6084*/              OPC_MoveParent,
/*6085*/              OPC_MoveChild, 2,
/*6087*/              OPC_CheckSame, 2,
/*6089*/              OPC_MoveParent,
/*6090*/              OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*6092*/              OPC_CheckPredicate, 5, // Predicate_store
/*6094*/              OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #4 #5 #6 #7 #8
/*6097*/              OPC_EmitMergeInputChains, 2, 0, 1, 
/*6101*/              OPC_MorphNodeTo, TARGET_OPCODE(X86::XOR16mr), 0|OPFL_Chain|OPFL_MemRefs,
                          1/*#VTs*/, MVT::i32, 6/*#Ops*/, 4, 5, 6, 7, 8, 3, 
                      // Src: (st:isVoid (xor:i16 (ld:i16 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR16:i16:$src), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                      // Dst: (XOR16mr:isVoid addr:iPTR:$dst, GR16:i16:$src)
                    /*SwitchType*/ 30,  MVT::i32,// ->6146
/*6116*/              OPC_MoveParent,
/*6117*/              OPC_MoveChild, 2,
/*6119*/              OPC_CheckSame, 2,
/*6121*/              OPC_MoveParent,
/*6122*/              OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*6124*/              OPC_CheckPredicate, 5, // Predicate_store
/*6126*/              OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #4 #5 #6 #7 #8
/*6129*/              OPC_EmitMergeInputChains, 2, 0, 1, 
/*6133*/              OPC_MorphNodeTo, TARGET_OPCODE(X86::XOR32mr), 0|OPFL_Chain|OPFL_MemRefs,
                          1/*#VTs*/, MVT::i32, 6/*#Ops*/, 4, 5, 6, 7, 8, 3, 
                      // Src: (st:isVoid (xor:i32 (ld:i32 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR32:i32:$src), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                      // Dst: (XOR32mr:isVoid addr:iPTR:$dst, GR32:i32:$src)
                    /*SwitchType*/ 30,  MVT::i64,// ->6178
/*6148*/              OPC_MoveParent,
/*6149*/              OPC_MoveChild, 2,
/*6151*/              OPC_CheckSame, 2,
/*6153*/              OPC_MoveParent,
/*6154*/              OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*6156*/              OPC_CheckPredicate, 5, // Predicate_store
/*6158*/              OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #4 #5 #6 #7 #8
/*6161*/              OPC_EmitMergeInputChains, 2, 0, 1, 
/*6165*/              OPC_MorphNodeTo, TARGET_OPCODE(X86::XOR64mr), 0|OPFL_Chain|OPFL_MemRefs,
                          1/*#VTs*/, MVT::i32, 6/*#Ops*/, 4, 5, 6, 7, 8, 3, 
                      // Src: (st:isVoid (xor:i64 (ld:i64 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR64:i64:$src), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                      // Dst: (XOR64mr:isVoid addr:iPTR:$dst, GR64:i64:$src)
                    0, // EndSwitchType
/*6179*/          0, /*End of Scope*/
/*6180*/        /*Scope*/ 16|128,1/*144*/, /*->6326*/
/*6182*/          OPC_RecordChild0, // #1 = $src
/*6183*/          OPC_MoveChild, 1,
/*6185*/          OPC_CheckOpcode, ISD::LOAD,
/*6187*/          OPC_RecordMemRef,
/*6188*/          OPC_RecordNode, // #2 = 'ld' chained node
/*6189*/          OPC_CheckFoldableChainNode,
/*6190*/          OPC_RecordChild1, // #3 = $dst
/*6191*/          OPC_CheckPredicate, 2, // Predicate_unindexedload
/*6193*/          OPC_CheckPredicate, 8, // Predicate_load
/*6195*/          OPC_MoveParent,
/*6196*/          OPC_SwitchType /*4 cases */, 30,  MVT::i8,// ->6229
/*6199*/            OPC_MoveParent,
/*6200*/            OPC_MoveChild, 2,
/*6202*/            OPC_CheckSame, 3,
/*6204*/            OPC_MoveParent,
/*6205*/            OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*6207*/            OPC_CheckPredicate, 5, // Predicate_store
/*6209*/            OPC_CheckComplexPat, /*CP*/0, /*#*/3, // SelectAddr:$dst #4 #5 #6 #7 #8
/*6212*/            OPC_EmitMergeInputChains, 2, 0, 2, 
/*6216*/            OPC_MorphNodeTo, TARGET_OPCODE(X86::XOR8mr), 0|OPFL_Chain|OPFL_MemRefs,
                        1/*#VTs*/, MVT::i32, 6/*#Ops*/, 4, 5, 6, 7, 8, 1, 
                    // Src: (st:isVoid (xor:i8 GR8:i8:$src, (ld:i8 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>>), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                    // Dst: (XOR8mr:isVoid addr:iPTR:$dst, GR8:i8:$src)
                  /*SwitchType*/ 30,  MVT::i16,// ->6261
/*6231*/            OPC_MoveParent,
/*6232*/            OPC_MoveChild, 2,
/*6234*/            OPC_CheckSame, 3,
/*6236*/            OPC_MoveParent,
/*6237*/            OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*6239*/            OPC_CheckPredicate, 5, // Predicate_store
/*6241*/            OPC_CheckComplexPat, /*CP*/0, /*#*/3, // SelectAddr:$dst #4 #5 #6 #7 #8
/*6244*/            OPC_EmitMergeInputChains, 2, 0, 2, 
/*6248*/            OPC_MorphNodeTo, TARGET_OPCODE(X86::XOR16mr), 0|OPFL_Chain|OPFL_MemRefs,
                        1/*#VTs*/, MVT::i32, 6/*#Ops*/, 4, 5, 6, 7, 8, 1, 
                    // Src: (st:isVoid (xor:i16 GR16:i16:$src, (ld:i16 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>>), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                    // Dst: (XOR16mr:isVoid addr:iPTR:$dst, GR16:i16:$src)
                  /*SwitchType*/ 30,  MVT::i32,// ->6293
/*6263*/            OPC_MoveParent,
/*6264*/            OPC_MoveChild, 2,
/*6266*/            OPC_CheckSame, 3,
/*6268*/            OPC_MoveParent,
/*6269*/            OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*6271*/            OPC_CheckPredicate, 5, // Predicate_store
/*6273*/            OPC_CheckComplexPat, /*CP*/0, /*#*/3, // SelectAddr:$dst #4 #5 #6 #7 #8
/*6276*/            OPC_EmitMergeInputChains, 2, 0, 2, 
/*6280*/            OPC_MorphNodeTo, TARGET_OPCODE(X86::XOR32mr), 0|OPFL_Chain|OPFL_MemRefs,
                        1/*#VTs*/, MVT::i32, 6/*#Ops*/, 4, 5, 6, 7, 8, 1, 
                    // Src: (st:isVoid (xor:i32 GR32:i32:$src, (ld:i32 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>>), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                    // Dst: (XOR32mr:isVoid addr:iPTR:$dst, GR32:i32:$src)
                  /*SwitchType*/ 30,  MVT::i64,// ->6325
/*6295*/            OPC_MoveParent,
/*6296*/            OPC_MoveChild, 2,
/*6298*/            OPC_CheckSame, 3,
/*6300*/            OPC_MoveParent,
/*6301*/            OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*6303*/            OPC_CheckPredicate, 5, // Predicate_store
/*6305*/            OPC_CheckComplexPat, /*CP*/0, /*#*/3, // SelectAddr:$dst #4 #5 #6 #7 #8
/*6308*/            OPC_EmitMergeInputChains, 2, 0, 2, 
/*6312*/            OPC_MorphNodeTo, TARGET_OPCODE(X86::XOR64mr), 0|OPFL_Chain|OPFL_MemRefs,
                        1/*#VTs*/, MVT::i32, 6/*#Ops*/, 4, 5, 6, 7, 8, 1, 
                    // Src: (st:isVoid (xor:i64 GR64:i64:$src, (ld:i64 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>>), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                    // Dst: (XOR64mr:isVoid addr:iPTR:$dst, GR64:i64:$src)
                  0, // EndSwitchType
/*6326*/        0, /*End of Scope*/
              /*SwitchOpcode*/ 80|128,10/*1360*/,  ISD::ADD,// ->7690
/*6330*/        OPC_Scope, 58|128,9/*1210*/, /*->7543*/ // 2 children in Scope
/*6333*/          OPC_MoveChild, 0,
/*6335*/          OPC_CheckOpcode, ISD::LOAD,
/*6337*/          OPC_RecordMemRef,
/*6338*/          OPC_RecordNode, // #1 = 'ld' chained node
/*6339*/          OPC_CheckFoldableChainNode,
/*6340*/          OPC_RecordChild1, // #2 = $dst
/*6341*/          OPC_CheckPredicate, 2, // Predicate_unindexedload
/*6343*/          OPC_Scope, 41, /*->6386*/ // 17 children in Scope
/*6345*/            OPC_CheckPredicate, 8, // Predicate_load
/*6347*/            OPC_CheckPredicate, 9, // Predicate_dsload
/*6349*/            OPC_MoveParent,
/*6350*/            OPC_MoveChild, 1,
/*6352*/            OPC_CheckInteger, 1, 
/*6354*/            OPC_MoveParent,
/*6355*/            OPC_CheckType, MVT::i8,
/*6357*/            OPC_MoveParent,
/*6358*/            OPC_MoveChild, 2,
/*6360*/            OPC_CheckSame, 2,
/*6362*/            OPC_MoveParent,
/*6363*/            OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*6365*/            OPC_CheckPredicate, 5, // Predicate_store
/*6367*/            OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #3 #4 #5 #6 #7
/*6370*/            OPC_EmitMergeInputChains, 2, 0, 1, 
/*6374*/            OPC_MorphNodeTo, TARGET_OPCODE(X86::INC8m), 0|OPFL_Chain|OPFL_MemRefs,
                        1/*#VTs*/, MVT::i32, 5/*#Ops*/, 3, 4, 5, 6, 7, 
                    // Src: (st:isVoid (add:i8 (ld:i8 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>, 1:i8), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                    // Dst: (INC8m:isVoid addr:iPTR:$dst)
/*6386*/          /*Scope*/ 41, /*->6428*/
/*6387*/            OPC_CheckPredicate, 6, // Predicate_loadi16
/*6389*/            OPC_MoveParent,
/*6390*/            OPC_MoveChild, 1,
/*6392*/            OPC_CheckInteger, 1, 
/*6394*/            OPC_MoveParent,
/*6395*/            OPC_CheckType, MVT::i16,
/*6397*/            OPC_MoveParent,
/*6398*/            OPC_MoveChild, 2,
/*6400*/            OPC_CheckSame, 2,
/*6402*/            OPC_MoveParent,
/*6403*/            OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*6405*/            OPC_CheckPredicate, 5, // Predicate_store
/*6407*/            OPC_CheckPatternPredicate, 2, // (!Subtarget->is64Bit())
/*6409*/            OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #3 #4 #5 #6 #7
/*6412*/            OPC_EmitMergeInputChains, 2, 0, 1, 
/*6416*/            OPC_MorphNodeTo, TARGET_OPCODE(X86::INC16m), 0|OPFL_Chain|OPFL_MemRefs,
                        1/*#VTs*/, MVT::i32, 5/*#Ops*/, 3, 4, 5, 6, 7, 
                    // Src: (st:isVoid (add:i16 (ld:i16 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, 1:i16), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                    // Dst: (INC16m:isVoid addr:iPTR:$dst)
/*6428*/          /*Scope*/ 41, /*->6470*/
/*6429*/            OPC_CheckPredicate, 3, // Predicate_loadi32
/*6431*/            OPC_MoveParent,
/*6432*/            OPC_MoveChild, 1,
/*6434*/            OPC_CheckInteger, 1, 
/*6436*/            OPC_MoveParent,
/*6437*/            OPC_CheckType, MVT::i32,
/*6439*/            OPC_MoveParent,
/*6440*/            OPC_MoveChild, 2,
/*6442*/            OPC_CheckSame, 2,
/*6444*/            OPC_MoveParent,
/*6445*/            OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*6447*/            OPC_CheckPredicate, 5, // Predicate_store
/*6449*/            OPC_CheckPatternPredicate, 2, // (!Subtarget->is64Bit())
/*6451*/            OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #3 #4 #5 #6 #7
/*6454*/            OPC_EmitMergeInputChains, 2, 0, 1, 
/*6458*/            OPC_MorphNodeTo, TARGET_OPCODE(X86::INC32m), 0|OPFL_Chain|OPFL_MemRefs,
                        1/*#VTs*/, MVT::i32, 5/*#Ops*/, 3, 4, 5, 6, 7, 
                    // Src: (st:isVoid (add:i32 (ld:i32 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, 1:i32), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                    // Dst: (INC32m:isVoid addr:iPTR:$dst)
/*6470*/          /*Scope*/ 50, /*->6521*/
/*6471*/            OPC_CheckPredicate, 8, // Predicate_load
/*6473*/            OPC_CheckPredicate, 9, // Predicate_dsload
/*6475*/            OPC_MoveParent,
/*6476*/            OPC_MoveChild, 1,
/*6478*/            OPC_CheckInteger, 127|128,127|128,127|128,127|128,127|128,127|128,127|128,127|128,127|128,1/*18446744073709551615*/, 
/*6489*/            OPC_MoveParent,
/*6490*/            OPC_CheckType, MVT::i8,
/*6492*/            OPC_MoveParent,
/*6493*/            OPC_MoveChild, 2,
/*6495*/            OPC_CheckSame, 2,
/*6497*/            OPC_MoveParent,
/*6498*/            OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*6500*/            OPC_CheckPredicate, 5, // Predicate_store
/*6502*/            OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #3 #4 #5 #6 #7
/*6505*/            OPC_EmitMergeInputChains, 2, 0, 1, 
/*6509*/            OPC_MorphNodeTo, TARGET_OPCODE(X86::DEC8m), 0|OPFL_Chain|OPFL_MemRefs,
                        1/*#VTs*/, MVT::i32, 5/*#Ops*/, 3, 4, 5, 6, 7, 
                    // Src: (st:isVoid (add:i8 (ld:i8 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>, -1:i8), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                    // Dst: (DEC8m:isVoid addr:iPTR:$dst)
/*6521*/          /*Scope*/ 50, /*->6572*/
/*6522*/            OPC_CheckPredicate, 6, // Predicate_loadi16
/*6524*/            OPC_MoveParent,
/*6525*/            OPC_MoveChild, 1,
/*6527*/            OPC_CheckInteger, 127|128,127|128,127|128,127|128,127|128,127|128,127|128,127|128,127|128,1/*18446744073709551615*/, 
/*6538*/            OPC_MoveParent,
/*6539*/            OPC_CheckType, MVT::i16,
/*6541*/            OPC_MoveParent,
/*6542*/            OPC_MoveChild, 2,
/*6544*/            OPC_CheckSame, 2,
/*6546*/            OPC_MoveParent,
/*6547*/            OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*6549*/            OPC_CheckPredicate, 5, // Predicate_store
/*6551*/            OPC_CheckPatternPredicate, 2, // (!Subtarget->is64Bit())
/*6553*/            OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #3 #4 #5 #6 #7
/*6556*/            OPC_EmitMergeInputChains, 2, 0, 1, 
/*6560*/            OPC_MorphNodeTo, TARGET_OPCODE(X86::DEC16m), 0|OPFL_Chain|OPFL_MemRefs,
                        1/*#VTs*/, MVT::i32, 5/*#Ops*/, 3, 4, 5, 6, 7, 
                    // Src: (st:isVoid (add:i16 (ld:i16 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, -1:i16), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                    // Dst: (DEC16m:isVoid addr:iPTR:$dst)
/*6572*/          /*Scope*/ 50, /*->6623*/
/*6573*/            OPC_CheckPredicate, 3, // Predicate_loadi32
/*6575*/            OPC_MoveParent,
/*6576*/            OPC_MoveChild, 1,
/*6578*/            OPC_CheckInteger, 127|128,127|128,127|128,127|128,127|128,127|128,127|128,127|128,127|128,1/*18446744073709551615*/, 
/*6589*/            OPC_MoveParent,
/*6590*/            OPC_CheckType, MVT::i32,
/*6592*/            OPC_MoveParent,
/*6593*/            OPC_MoveChild, 2,
/*6595*/            OPC_CheckSame, 2,
/*6597*/            OPC_MoveParent,
/*6598*/            OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*6600*/            OPC_CheckPredicate, 5, // Predicate_store
/*6602*/            OPC_CheckPatternPredicate, 2, // (!Subtarget->is64Bit())
/*6604*/            OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #3 #4 #5 #6 #7
/*6607*/            OPC_EmitMergeInputChains, 2, 0, 1, 
/*6611*/            OPC_MorphNodeTo, TARGET_OPCODE(X86::DEC32m), 0|OPFL_Chain|OPFL_MemRefs,
                        1/*#VTs*/, MVT::i32, 5/*#Ops*/, 3, 4, 5, 6, 7, 
                    // Src: (st:isVoid (add:i32 (ld:i32 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, -1:i32), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                    // Dst: (DEC32m:isVoid addr:iPTR:$dst)
/*6623*/          /*Scope*/ 88, /*->6712*/
/*6624*/            OPC_CheckPredicate, 8, // Predicate_load
/*6626*/            OPC_CheckPredicate, 9, // Predicate_dsload
/*6628*/            OPC_MoveParent,
/*6629*/            OPC_MoveChild, 1,
/*6631*/            OPC_Scope, 34, /*->6667*/ // 2 children in Scope
/*6633*/              OPC_CheckInteger, 1, 
/*6635*/              OPC_MoveParent,
/*6636*/              OPC_CheckType, MVT::i64,
/*6638*/              OPC_MoveParent,
/*6639*/              OPC_MoveChild, 2,
/*6641*/              OPC_CheckSame, 2,
/*6643*/              OPC_MoveParent,
/*6644*/              OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*6646*/              OPC_CheckPredicate, 5, // Predicate_store
/*6648*/              OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #3 #4 #5 #6 #7
/*6651*/              OPC_EmitMergeInputChains, 2, 0, 1, 
/*6655*/              OPC_MorphNodeTo, TARGET_OPCODE(X86::INC64m), 0|OPFL_Chain|OPFL_MemRefs,
                          1/*#VTs*/, MVT::i32, 5/*#Ops*/, 3, 4, 5, 6, 7, 
                      // Src: (st:isVoid (add:i64 (ld:i64 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>, 1:i64), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                      // Dst: (INC64m:isVoid addr:iPTR:$dst)
/*6667*/            /*Scope*/ 43, /*->6711*/
/*6668*/              OPC_CheckInteger, 127|128,127|128,127|128,127|128,127|128,127|128,127|128,127|128,127|128,1/*18446744073709551615*/, 
/*6679*/              OPC_MoveParent,
/*6680*/              OPC_CheckType, MVT::i64,
/*6682*/              OPC_MoveParent,
/*6683*/              OPC_MoveChild, 2,
/*6685*/              OPC_CheckSame, 2,
/*6687*/              OPC_MoveParent,
/*6688*/              OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*6690*/              OPC_CheckPredicate, 5, // Predicate_store
/*6692*/              OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #3 #4 #5 #6 #7
/*6695*/              OPC_EmitMergeInputChains, 2, 0, 1, 
/*6699*/              OPC_MorphNodeTo, TARGET_OPCODE(X86::DEC64m), 0|OPFL_Chain|OPFL_MemRefs,
                          1/*#VTs*/, MVT::i32, 5/*#Ops*/, 3, 4, 5, 6, 7, 
                      // Src: (st:isVoid (add:i64 (ld:i64 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>, -1:i64), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                      // Dst: (DEC64m:isVoid addr:iPTR:$dst)
/*6711*/            0, /*End of Scope*/
/*6712*/          /*Scope*/ 41, /*->6754*/
/*6713*/            OPC_CheckPredicate, 6, // Predicate_loadi16
/*6715*/            OPC_MoveParent,
/*6716*/            OPC_MoveChild, 1,
/*6718*/            OPC_CheckInteger, 1, 
/*6720*/            OPC_MoveParent,
/*6721*/            OPC_CheckType, MVT::i16,
/*6723*/            OPC_MoveParent,
/*6724*/            OPC_MoveChild, 2,
/*6726*/            OPC_CheckSame, 2,
/*6728*/            OPC_MoveParent,
/*6729*/            OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*6731*/            OPC_CheckPredicate, 5, // Predicate_store
/*6733*/            OPC_CheckPatternPredicate, 3, // (Subtarget->is64Bit())
/*6735*/            OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #3 #4 #5 #6 #7
/*6738*/            OPC_EmitMergeInputChains, 2, 0, 1, 
/*6742*/            OPC_MorphNodeTo, TARGET_OPCODE(X86::INC64_16m), 0|OPFL_Chain|OPFL_MemRefs,
                        1/*#VTs*/, MVT::i32, 5/*#Ops*/, 3, 4, 5, 6, 7, 
                    // Src: (st:isVoid (add:i16 (ld:i16 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, 1:i16), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                    // Dst: (INC64_16m:isVoid addr:iPTR:$dst)
/*6754*/          /*Scope*/ 41, /*->6796*/
/*6755*/            OPC_CheckPredicate, 3, // Predicate_loadi32
/*6757*/            OPC_MoveParent,
/*6758*/            OPC_MoveChild, 1,
/*6760*/            OPC_CheckInteger, 1, 
/*6762*/            OPC_MoveParent,
/*6763*/            OPC_CheckType, MVT::i32,
/*6765*/            OPC_MoveParent,
/*6766*/            OPC_MoveChild, 2,
/*6768*/            OPC_CheckSame, 2,
/*6770*/            OPC_MoveParent,
/*6771*/            OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*6773*/            OPC_CheckPredicate, 5, // Predicate_store
/*6775*/            OPC_CheckPatternPredicate, 3, // (Subtarget->is64Bit())
/*6777*/            OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #3 #4 #5 #6 #7
/*6780*/            OPC_EmitMergeInputChains, 2, 0, 1, 
/*6784*/            OPC_MorphNodeTo, TARGET_OPCODE(X86::INC64_32m), 0|OPFL_Chain|OPFL_MemRefs,
                        1/*#VTs*/, MVT::i32, 5/*#Ops*/, 3, 4, 5, 6, 7, 
                    // Src: (st:isVoid (add:i32 (ld:i32 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, 1:i32), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                    // Dst: (INC64_32m:isVoid addr:iPTR:$dst)
/*6796*/          /*Scope*/ 50, /*->6847*/
/*6797*/            OPC_CheckPredicate, 6, // Predicate_loadi16
/*6799*/            OPC_MoveParent,
/*6800*/            OPC_MoveChild, 1,
/*6802*/            OPC_CheckInteger, 127|128,127|128,127|128,127|128,127|128,127|128,127|128,127|128,127|128,1/*18446744073709551615*/, 
/*6813*/            OPC_MoveParent,
/*6814*/            OPC_CheckType, MVT::i16,
/*6816*/            OPC_MoveParent,
/*6817*/            OPC_MoveChild, 2,
/*6819*/            OPC_CheckSame, 2,
/*6821*/            OPC_MoveParent,
/*6822*/            OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*6824*/            OPC_CheckPredicate, 5, // Predicate_store
/*6826*/            OPC_CheckPatternPredicate, 3, // (Subtarget->is64Bit())
/*6828*/            OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #3 #4 #5 #6 #7
/*6831*/            OPC_EmitMergeInputChains, 2, 0, 1, 
/*6835*/            OPC_MorphNodeTo, TARGET_OPCODE(X86::DEC64_16m), 0|OPFL_Chain|OPFL_MemRefs,
                        1/*#VTs*/, MVT::i32, 5/*#Ops*/, 3, 4, 5, 6, 7, 
                    // Src: (st:isVoid (add:i16 (ld:i16 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, -1:i16), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                    // Dst: (DEC64_16m:isVoid addr:iPTR:$dst)
/*6847*/          /*Scope*/ 50, /*->6898*/
/*6848*/            OPC_CheckPredicate, 3, // Predicate_loadi32
/*6850*/            OPC_MoveParent,
/*6851*/            OPC_MoveChild, 1,
/*6853*/            OPC_CheckInteger, 127|128,127|128,127|128,127|128,127|128,127|128,127|128,127|128,127|128,1/*18446744073709551615*/, 
/*6864*/            OPC_MoveParent,
/*6865*/            OPC_CheckType, MVT::i32,
/*6867*/            OPC_MoveParent,
/*6868*/            OPC_MoveChild, 2,
/*6870*/            OPC_CheckSame, 2,
/*6872*/            OPC_MoveParent,
/*6873*/            OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*6875*/            OPC_CheckPredicate, 5, // Predicate_store
/*6877*/            OPC_CheckPatternPredicate, 3, // (Subtarget->is64Bit())
/*6879*/            OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #3 #4 #5 #6 #7
/*6882*/            OPC_EmitMergeInputChains, 2, 0, 1, 
/*6886*/            OPC_MorphNodeTo, TARGET_OPCODE(X86::DEC64_32m), 0|OPFL_Chain|OPFL_MemRefs,
                        1/*#VTs*/, MVT::i32, 5/*#Ops*/, 3, 4, 5, 6, 7, 
                    // Src: (st:isVoid (add:i32 (ld:i32 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, -1:i32), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                    // Dst: (DEC64_32m:isVoid addr:iPTR:$dst)
/*6898*/          /*Scope*/ 52, /*->6951*/
/*6899*/            OPC_CheckPredicate, 6, // Predicate_loadi16
/*6901*/            OPC_MoveParent,
/*6902*/            OPC_MoveChild, 1,
/*6904*/            OPC_CheckInteger, 0|128,1/*128*/, 
/*6907*/            OPC_MoveParent,
/*6908*/            OPC_CheckType, MVT::i16,
/*6910*/            OPC_MoveParent,
/*6911*/            OPC_MoveChild, 2,
/*6913*/            OPC_CheckSame, 2,
/*6915*/            OPC_MoveParent,
/*6916*/            OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*6918*/            OPC_CheckPredicate, 5, // Predicate_store
/*6920*/            OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #3 #4 #5 #6 #7
/*6923*/            OPC_EmitMergeInputChains, 2, 0, 1, 
/*6927*/            OPC_EmitInteger, MVT::i16, 0|128,127|128,127|128,127|128,127|128,127|128,127|128,127|128,127|128,1/*18446744073709551488*/, 
/*6939*/            OPC_MorphNodeTo, TARGET_OPCODE(X86::SUB16mi8), 0|OPFL_Chain|OPFL_MemRefs,
                        0/*#VTs*/, 6/*#Ops*/, 3, 4, 5, 6, 7, 8, 
                    // Src: (st:isVoid (add:i16 (ld:i16 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, 128:i16), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                    // Dst: (SUB16mi8:isVoid addr:iPTR:$dst, -128:i16)
/*6951*/          /*Scope*/ 52, /*->7004*/
/*6952*/            OPC_CheckPredicate, 3, // Predicate_loadi32
/*6954*/            OPC_MoveParent,
/*6955*/            OPC_MoveChild, 1,
/*6957*/            OPC_CheckInteger, 0|128,1/*128*/, 
/*6960*/            OPC_MoveParent,
/*6961*/            OPC_CheckType, MVT::i32,
/*6963*/            OPC_MoveParent,
/*6964*/            OPC_MoveChild, 2,
/*6966*/            OPC_CheckSame, 2,
/*6968*/            OPC_MoveParent,
/*6969*/            OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*6971*/            OPC_CheckPredicate, 5, // Predicate_store
/*6973*/            OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #3 #4 #5 #6 #7
/*6976*/            OPC_EmitMergeInputChains, 2, 0, 1, 
/*6980*/            OPC_EmitInteger, MVT::i32, 0|128,127|128,127|128,127|128,127|128,127|128,127|128,127|128,127|128,1/*18446744073709551488*/, 
/*6992*/            OPC_MorphNodeTo, TARGET_OPCODE(X86::SUB32mi8), 0|OPFL_Chain|OPFL_MemRefs,
                        0/*#VTs*/, 6/*#Ops*/, 3, 4, 5, 6, 7, 8, 
                    // Src: (st:isVoid (add:i32 (ld:i32 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, 128:i32), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                    // Dst: (SUB32mi8:isVoid addr:iPTR:$dst, -128:i32)
/*7004*/          /*Scope*/ 56|128,2/*312*/, /*->7318*/
/*7006*/            OPC_CheckPredicate, 8, // Predicate_load
/*7008*/            OPC_Scope, 107, /*->7117*/ // 3 children in Scope
/*7010*/              OPC_CheckPredicate, 9, // Predicate_dsload
/*7012*/              OPC_MoveParent,
/*7013*/              OPC_MoveChild, 1,
/*7015*/              OPC_Scope, 47, /*->7064*/ // 2 children in Scope
/*7017*/                OPC_CheckInteger, 0|128,1/*128*/, 
/*7020*/                OPC_MoveParent,
/*7021*/                OPC_CheckType, MVT::i64,
/*7023*/                OPC_MoveParent,
/*7024*/                OPC_MoveChild, 2,
/*7026*/                OPC_CheckSame, 2,
/*7028*/                OPC_MoveParent,
/*7029*/                OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*7031*/                OPC_CheckPredicate, 5, // Predicate_store
/*7033*/                OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #3 #4 #5 #6 #7
/*7036*/                OPC_EmitMergeInputChains, 2, 0, 1, 
/*7040*/                OPC_EmitInteger, MVT::i64, 0|128,127|128,127|128,127|128,127|128,127|128,127|128,127|128,127|128,1/*18446744073709551488*/, 
/*7052*/                OPC_MorphNodeTo, TARGET_OPCODE(X86::SUB64mi8), 0|OPFL_Chain|OPFL_MemRefs,
                            0/*#VTs*/, 6/*#Ops*/, 3, 4, 5, 6, 7, 8, 
                        // Src: (st:isVoid (add:i64 (ld:i64 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>, 128:i64), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                        // Dst: (SUB64mi8:isVoid addr:iPTR:$dst, -128:i64)
/*7064*/              /*Scope*/ 51, /*->7116*/
/*7065*/                OPC_CheckInteger, 0|128,0|128,0|128,0|128,0|128,1/*34359738368*/, 
/*7072*/                OPC_MoveParent,
/*7073*/                OPC_CheckType, MVT::i64,
/*7075*/                OPC_MoveParent,
/*7076*/                OPC_MoveChild, 2,
/*7078*/                OPC_CheckSame, 2,
/*7080*/                OPC_MoveParent,
/*7081*/                OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*7083*/                OPC_CheckPredicate, 5, // Predicate_store
/*7085*/                OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #3 #4 #5 #6 #7
/*7088*/                OPC_EmitMergeInputChains, 2, 0, 1, 
/*7092*/                OPC_EmitInteger, MVT::i64, 0|128,0|128,0|128,0|128,120|128,127|128,127|128,127|128,127|128,1/*18446744071562067968*/, 
/*7104*/                OPC_MorphNodeTo, TARGET_OPCODE(X86::SUB64mi32), 0|OPFL_Chain|OPFL_MemRefs,
                            0/*#VTs*/, 6/*#Ops*/, 3, 4, 5, 6, 7, 8, 
                        // Src: (st:isVoid (add:i64 (ld:i64 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>, 34359738368:i64), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                        // Dst: (SUB64mi32:isVoid addr:iPTR:$dst, -2147483648:i64)
/*7116*/              0, /*End of Scope*/
/*7117*/            /*Scope*/ 26|128,1/*154*/, /*->7273*/
/*7119*/              OPC_MoveParent,
/*7120*/              OPC_RecordChild1, // #3 = $src2
/*7121*/              OPC_MoveChild, 1,
/*7123*/              OPC_CheckOpcode, ISD::Constant,
/*7125*/              OPC_Scope, 107, /*->7234*/ // 2 children in Scope
/*7127*/                OPC_CheckPredicate, 11, // Predicate_immSext8
/*7129*/                OPC_MoveParent,
/*7130*/                OPC_SwitchType /*3 cases */, 32,  MVT::i16,// ->7165
/*7133*/                  OPC_MoveParent,
/*7134*/                  OPC_MoveChild, 2,
/*7136*/                  OPC_CheckSame, 2,
/*7138*/                  OPC_MoveParent,
/*7139*/                  OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*7141*/                  OPC_CheckPredicate, 5, // Predicate_store
/*7143*/                  OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #4 #5 #6 #7 #8
/*7146*/                  OPC_EmitMergeInputChains, 2, 0, 1, 
/*7150*/                  OPC_EmitConvertToTarget, 3,
/*7152*/                  OPC_MorphNodeTo, TARGET_OPCODE(X86::ADD16mi8), 0|OPFL_Chain|OPFL_MemRefs,
                              1/*#VTs*/, MVT::i32, 6/*#Ops*/, 4, 5, 6, 7, 8, 9, 
                          // Src: (st:isVoid (add:i16 (ld:i16 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:i16)<<P:Predicate_immSext8>>:$src2), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                          // Dst: (ADD16mi8:isVoid addr:iPTR:$dst, (imm:i16):$src2)
                        /*SwitchType*/ 32,  MVT::i32,// ->7199
/*7167*/                  OPC_MoveParent,
/*7168*/                  OPC_MoveChild, 2,
/*7170*/                  OPC_CheckSame, 2,
/*7172*/                  OPC_MoveParent,
/*7173*/                  OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*7175*/                  OPC_CheckPredicate, 5, // Predicate_store
/*7177*/                  OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #4 #5 #6 #7 #8
/*7180*/                  OPC_EmitMergeInputChains, 2, 0, 1, 
/*7184*/                  OPC_EmitConvertToTarget, 3,
/*7186*/                  OPC_MorphNodeTo, TARGET_OPCODE(X86::ADD32mi8), 0|OPFL_Chain|OPFL_MemRefs,
                              1/*#VTs*/, MVT::i32, 6/*#Ops*/, 4, 5, 6, 7, 8, 9, 
                          // Src: (st:isVoid (add:i32 (ld:i32 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:i32)<<P:Predicate_immSext8>>:$src2), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                          // Dst: (ADD32mi8:isVoid addr:iPTR:$dst, (imm:i32):$src2)
                        /*SwitchType*/ 32,  MVT::i64,// ->7233
/*7201*/                  OPC_MoveParent,
/*7202*/                  OPC_MoveChild, 2,
/*7204*/                  OPC_CheckSame, 2,
/*7206*/                  OPC_MoveParent,
/*7207*/                  OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*7209*/                  OPC_CheckPredicate, 5, // Predicate_store
/*7211*/                  OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #4 #5 #6 #7 #8
/*7214*/                  OPC_EmitMergeInputChains, 2, 0, 1, 
/*7218*/                  OPC_EmitConvertToTarget, 3,
/*7220*/                  OPC_MorphNodeTo, TARGET_OPCODE(X86::ADD64mi8), 0|OPFL_Chain|OPFL_MemRefs,
                              1/*#VTs*/, MVT::i32, 6/*#Ops*/, 4, 5, 6, 7, 8, 9, 
                          // Src: (st:isVoid (add:i64 (ld:i64 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:i64)<<P:Predicate_immSext8>>:$src2), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                          // Dst: (ADD64mi8:isVoid addr:iPTR:$dst, (imm:i64):$src2)
                        0, // EndSwitchType
/*7234*/              /*Scope*/ 37, /*->7272*/
/*7235*/                OPC_CheckPredicate, 12, // Predicate_i64immSExt32
/*7237*/                OPC_MoveParent,
/*7238*/                OPC_CheckType, MVT::i64,
/*7240*/                OPC_MoveParent,
/*7241*/                OPC_MoveChild, 2,
/*7243*/                OPC_CheckSame, 2,
/*7245*/                OPC_MoveParent,
/*7246*/                OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*7248*/                OPC_CheckPredicate, 5, // Predicate_store
/*7250*/                OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #4 #5 #6 #7 #8
/*7253*/                OPC_EmitMergeInputChains, 2, 0, 1, 
/*7257*/                OPC_EmitConvertToTarget, 3,
/*7259*/                OPC_MorphNodeTo, TARGET_OPCODE(X86::ADD64mi32), 0|OPFL_Chain|OPFL_MemRefs,
                            1/*#VTs*/, MVT::i32, 6/*#Ops*/, 4, 5, 6, 7, 8, 9, 
                        // Src: (st:isVoid (add:i64 (ld:i64 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:i64)<<P:Predicate_i64immSExt32>>:$src2), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                        // Dst: (ADD64mi32:isVoid addr:iPTR:$dst, (imm:i64):$src2)
/*7272*/              0, /*End of Scope*/
/*7273*/            /*Scope*/ 43, /*->7317*/
/*7274*/              OPC_CheckPredicate, 9, // Predicate_dsload
/*7276*/              OPC_MoveParent,
/*7277*/              OPC_RecordChild1, // #3 = $src2
/*7278*/              OPC_MoveChild, 1,
/*7280*/              OPC_CheckOpcode, ISD::Constant,
/*7282*/              OPC_MoveParent,
/*7283*/              OPC_CheckType, MVT::i8,
/*7285*/              OPC_MoveParent,
/*7286*/              OPC_MoveChild, 2,
/*7288*/              OPC_CheckSame, 2,
/*7290*/              OPC_MoveParent,
/*7291*/              OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*7293*/              OPC_CheckPredicate, 5, // Predicate_store
/*7295*/              OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #4 #5 #6 #7 #8
/*7298*/              OPC_EmitMergeInputChains, 2, 0, 1, 
/*7302*/              OPC_EmitConvertToTarget, 3,
/*7304*/              OPC_MorphNodeTo, TARGET_OPCODE(X86::ADD8mi), 0|OPFL_Chain|OPFL_MemRefs,
                          1/*#VTs*/, MVT::i32, 6/*#Ops*/, 4, 5, 6, 7, 8, 9, 
                      // Src: (st:isVoid (add:i8 (ld:i8 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>, (imm:i8):$src2), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                      // Dst: (ADD8mi:isVoid addr:iPTR:$dst, (imm:i8):$src2)
/*7317*/            0, /*End of Scope*/
/*7318*/          /*Scope*/ 43, /*->7362*/
/*7319*/            OPC_CheckPredicate, 6, // Predicate_loadi16
/*7321*/            OPC_MoveParent,
/*7322*/            OPC_RecordChild1, // #3 = $src2
/*7323*/            OPC_MoveChild, 1,
/*7325*/            OPC_CheckOpcode, ISD::Constant,
/*7327*/            OPC_MoveParent,
/*7328*/            OPC_CheckType, MVT::i16,
/*7330*/            OPC_MoveParent,
/*7331*/            OPC_MoveChild, 2,
/*7333*/            OPC_CheckSame, 2,
/*7335*/            OPC_MoveParent,
/*7336*/            OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*7338*/            OPC_CheckPredicate, 5, // Predicate_store
/*7340*/            OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #4 #5 #6 #7 #8
/*7343*/            OPC_EmitMergeInputChains, 2, 0, 1, 
/*7347*/            OPC_EmitConvertToTarget, 3,
/*7349*/            OPC_MorphNodeTo, TARGET_OPCODE(X86::ADD16mi), 0|OPFL_Chain|OPFL_MemRefs,
                        1/*#VTs*/, MVT::i32, 6/*#Ops*/, 4, 5, 6, 7, 8, 9, 
                    // Src: (st:isVoid (add:i16 (ld:i16 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, (imm:i16):$src2), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                    // Dst: (ADD16mi:isVoid addr:iPTR:$dst, (imm:i16):$src2)
/*7362*/          /*Scope*/ 43, /*->7406*/
/*7363*/            OPC_CheckPredicate, 3, // Predicate_loadi32
/*7365*/            OPC_MoveParent,
/*7366*/            OPC_RecordChild1, // #3 = $src2
/*7367*/            OPC_MoveChild, 1,
/*7369*/            OPC_CheckOpcode, ISD::Constant,
/*7371*/            OPC_MoveParent,
/*7372*/            OPC_CheckType, MVT::i32,
/*7374*/            OPC_MoveParent,
/*7375*/            OPC_MoveChild, 2,
/*7377*/            OPC_CheckSame, 2,
/*7379*/            OPC_MoveParent,
/*7380*/            OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*7382*/            OPC_CheckPredicate, 5, // Predicate_store
/*7384*/            OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #4 #5 #6 #7 #8
/*7387*/            OPC_EmitMergeInputChains, 2, 0, 1, 
/*7391*/            OPC_EmitConvertToTarget, 3,
/*7393*/            OPC_MorphNodeTo, TARGET_OPCODE(X86::ADD32mi), 0|OPFL_Chain|OPFL_MemRefs,
                        1/*#VTs*/, MVT::i32, 6/*#Ops*/, 4, 5, 6, 7, 8, 9, 
                    // Src: (st:isVoid (add:i32 (ld:i32 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, (imm:i32):$src2), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                    // Dst: (ADD32mi:isVoid addr:iPTR:$dst, (imm:i32):$src2)
/*7406*/          /*Scope*/ 6|128,1/*134*/, /*->7542*/
/*7408*/            OPC_CheckPredicate, 8, // Predicate_load
/*7410*/            OPC_MoveParent,
/*7411*/            OPC_RecordChild1, // #3 = $src2
/*7412*/            OPC_SwitchType /*4 cases */, 30,  MVT::i8,// ->7445
/*7415*/              OPC_MoveParent,
/*7416*/              OPC_MoveChild, 2,
/*7418*/              OPC_CheckSame, 2,
/*7420*/              OPC_MoveParent,
/*7421*/              OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*7423*/              OPC_CheckPredicate, 5, // Predicate_store
/*7425*/              OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #4 #5 #6 #7 #8
/*7428*/              OPC_EmitMergeInputChains, 2, 0, 1, 
/*7432*/              OPC_MorphNodeTo, TARGET_OPCODE(X86::ADD8mr), 0|OPFL_Chain|OPFL_MemRefs,
                          1/*#VTs*/, MVT::i32, 6/*#Ops*/, 4, 5, 6, 7, 8, 3, 
                      // Src: (st:isVoid (add:i8 (ld:i8 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR8:i8:$src2), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                      // Dst: (ADD8mr:isVoid addr:iPTR:$dst, GR8:i8:$src2)
                    /*SwitchType*/ 30,  MVT::i16,// ->7477
/*7447*/              OPC_MoveParent,
/*7448*/              OPC_MoveChild, 2,
/*7450*/              OPC_CheckSame, 2,
/*7452*/              OPC_MoveParent,
/*7453*/              OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*7455*/              OPC_CheckPredicate, 5, // Predicate_store
/*7457*/              OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #4 #5 #6 #7 #8
/*7460*/              OPC_EmitMergeInputChains, 2, 0, 1, 
/*7464*/              OPC_MorphNodeTo, TARGET_OPCODE(X86::ADD16mr), 0|OPFL_Chain|OPFL_MemRefs,
                          1/*#VTs*/, MVT::i32, 6/*#Ops*/, 4, 5, 6, 7, 8, 3, 
                      // Src: (st:isVoid (add:i16 (ld:i16 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR16:i16:$src2), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                      // Dst: (ADD16mr:isVoid addr:iPTR:$dst, GR16:i16:$src2)
                    /*SwitchType*/ 30,  MVT::i32,// ->7509
/*7479*/              OPC_MoveParent,
/*7480*/              OPC_MoveChild, 2,
/*7482*/              OPC_CheckSame, 2,
/*7484*/              OPC_MoveParent,
/*7485*/              OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*7487*/              OPC_CheckPredicate, 5, // Predicate_store
/*7489*/              OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #4 #5 #6 #7 #8
/*7492*/              OPC_EmitMergeInputChains, 2, 0, 1, 
/*7496*/              OPC_MorphNodeTo, TARGET_OPCODE(X86::ADD32mr), 0|OPFL_Chain|OPFL_MemRefs,
                          1/*#VTs*/, MVT::i32, 6/*#Ops*/, 4, 5, 6, 7, 8, 3, 
                      // Src: (st:isVoid (add:i32 (ld:i32 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR32:i32:$src2), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                      // Dst: (ADD32mr:isVoid addr:iPTR:$dst, GR32:i32:$src2)
                    /*SwitchType*/ 30,  MVT::i64,// ->7541
/*7511*/              OPC_MoveParent,
/*7512*/              OPC_MoveChild, 2,
/*7514*/              OPC_CheckSame, 2,
/*7516*/              OPC_MoveParent,
/*7517*/              OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*7519*/              OPC_CheckPredicate, 5, // Predicate_store
/*7521*/              OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #4 #5 #6 #7 #8
/*7524*/              OPC_EmitMergeInputChains, 2, 0, 1, 
/*7528*/              OPC_MorphNodeTo, TARGET_OPCODE(X86::ADD64mr), 0|OPFL_Chain|OPFL_MemRefs,
                          1/*#VTs*/, MVT::i32, 6/*#Ops*/, 4, 5, 6, 7, 8, 3, 
                      // Src: (st:isVoid (add:i64 (ld:i64 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR64:i64:$src2), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                      // Dst: (ADD64mr:isVoid addr:iPTR:$dst, GR64:i64:$src2)
                    0, // EndSwitchType
/*7542*/          0, /*End of Scope*/
/*7543*/        /*Scope*/ 16|128,1/*144*/, /*->7689*/
/*7545*/          OPC_RecordChild0, // #1 = $src2
/*7546*/          OPC_MoveChild, 1,
/*7548*/          OPC_CheckOpcode, ISD::LOAD,
/*7550*/          OPC_RecordMemRef,
/*7551*/          OPC_RecordNode, // #2 = 'ld' chained node
/*7552*/          OPC_CheckFoldableChainNode,
/*7553*/          OPC_RecordChild1, // #3 = $dst
/*7554*/          OPC_CheckPredicate, 2, // Predicate_unindexedload
/*7556*/          OPC_CheckPredicate, 8, // Predicate_load
/*7558*/          OPC_MoveParent,
/*7559*/          OPC_SwitchType /*4 cases */, 30,  MVT::i8,// ->7592
/*7562*/            OPC_MoveParent,
/*7563*/            OPC_MoveChild, 2,
/*7565*/            OPC_CheckSame, 3,
/*7567*/            OPC_MoveParent,
/*7568*/            OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*7570*/            OPC_CheckPredicate, 5, // Predicate_store
/*7572*/            OPC_CheckComplexPat, /*CP*/0, /*#*/3, // SelectAddr:$dst #4 #5 #6 #7 #8
/*7575*/            OPC_EmitMergeInputChains, 2, 0, 2, 
/*7579*/            OPC_MorphNodeTo, TARGET_OPCODE(X86::ADD8mr), 0|OPFL_Chain|OPFL_MemRefs,
                        1/*#VTs*/, MVT::i32, 6/*#Ops*/, 4, 5, 6, 7, 8, 1, 
                    // Src: (st:isVoid (add:i8 GR8:i8:$src2, (ld:i8 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>>), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                    // Dst: (ADD8mr:isVoid addr:iPTR:$dst, GR8:i8:$src2)
                  /*SwitchType*/ 30,  MVT::i16,// ->7624
/*7594*/            OPC_MoveParent,
/*7595*/            OPC_MoveChild, 2,
/*7597*/            OPC_CheckSame, 3,
/*7599*/            OPC_MoveParent,
/*7600*/            OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*7602*/            OPC_CheckPredicate, 5, // Predicate_store
/*7604*/            OPC_CheckComplexPat, /*CP*/0, /*#*/3, // SelectAddr:$dst #4 #5 #6 #7 #8
/*7607*/            OPC_EmitMergeInputChains, 2, 0, 2, 
/*7611*/            OPC_MorphNodeTo, TARGET_OPCODE(X86::ADD16mr), 0|OPFL_Chain|OPFL_MemRefs,
                        1/*#VTs*/, MVT::i32, 6/*#Ops*/, 4, 5, 6, 7, 8, 1, 
                    // Src: (st:isVoid (add:i16 GR16:i16:$src2, (ld:i16 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>>), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                    // Dst: (ADD16mr:isVoid addr:iPTR:$dst, GR16:i16:$src2)
                  /*SwitchType*/ 30,  MVT::i32,// ->7656
/*7626*/            OPC_MoveParent,
/*7627*/            OPC_MoveChild, 2,
/*7629*/            OPC_CheckSame, 3,
/*7631*/            OPC_MoveParent,
/*7632*/            OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*7634*/            OPC_CheckPredicate, 5, // Predicate_store
/*7636*/            OPC_CheckComplexPat, /*CP*/0, /*#*/3, // SelectAddr:$dst #4 #5 #6 #7 #8
/*7639*/            OPC_EmitMergeInputChains, 2, 0, 2, 
/*7643*/            OPC_MorphNodeTo, TARGET_OPCODE(X86::ADD32mr), 0|OPFL_Chain|OPFL_MemRefs,
                        1/*#VTs*/, MVT::i32, 6/*#Ops*/, 4, 5, 6, 7, 8, 1, 
                    // Src: (st:isVoid (add:i32 GR32:i32:$src2, (ld:i32 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>>), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                    // Dst: (ADD32mr:isVoid addr:iPTR:$dst, GR32:i32:$src2)
                  /*SwitchType*/ 30,  MVT::i64,// ->7688
/*7658*/            OPC_MoveParent,
/*7659*/            OPC_MoveChild, 2,
/*7661*/            OPC_CheckSame, 3,
/*7663*/            OPC_MoveParent,
/*7664*/            OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*7666*/            OPC_CheckPredicate, 5, // Predicate_store
/*7668*/            OPC_CheckComplexPat, /*CP*/0, /*#*/3, // SelectAddr:$dst #4 #5 #6 #7 #8
/*7671*/            OPC_EmitMergeInputChains, 2, 0, 2, 
/*7675*/            OPC_MorphNodeTo, TARGET_OPCODE(X86::ADD64mr), 0|OPFL_Chain|OPFL_MemRefs,
                        1/*#VTs*/, MVT::i32, 6/*#Ops*/, 4, 5, 6, 7, 8, 1, 
                    // Src: (st:isVoid (add:i64 GR64:i64:$src2, (ld:i64 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>>), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                    // Dst: (ADD64mr:isVoid addr:iPTR:$dst, GR64:i64:$src2)
                  0, // EndSwitchType
/*7689*/        0, /*End of Scope*/
              /*SwitchOpcode*/ 11|128,4/*523*/,  ISD::ROTL,// ->8216
/*7693*/        OPC_MoveChild, 0,
/*7695*/        OPC_CheckOpcode, ISD::LOAD,
/*7697*/        OPC_RecordMemRef,
/*7698*/        OPC_RecordNode, // #1 = 'ld' chained node
/*7699*/        OPC_CheckFoldableChainNode,
/*7700*/        OPC_RecordChild1, // #2 = $dst
/*7701*/        OPC_CheckPredicate, 2, // Predicate_unindexedload
/*7703*/        OPC_Scope, 42, /*->7747*/ // 10 children in Scope
/*7705*/          OPC_CheckPredicate, 8, // Predicate_load
/*7707*/          OPC_CheckPredicate, 9, // Predicate_dsload
/*7709*/          OPC_MoveParent,
/*7710*/          OPC_MoveChild, 1,
/*7712*/          OPC_CheckInteger, 1, 
/*7714*/          OPC_CheckType, MVT::i8,
/*7716*/          OPC_MoveParent,
/*7717*/          OPC_CheckType, MVT::i8,
/*7719*/          OPC_MoveParent,
/*7720*/          OPC_MoveChild, 2,
/*7722*/          OPC_CheckSame, 2,
/*7724*/          OPC_MoveParent,
/*7725*/          OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*7727*/          OPC_CheckPredicate, 5, // Predicate_store
/*7729*/          OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #3 #4 #5 #6 #7
/*7732*/          OPC_EmitMergeInputChains, 2, 0, 1, 
/*7736*/          OPC_MorphNodeTo, TARGET_OPCODE(X86::ROL8m1), 0|OPFL_Chain|OPFL_MemRefs,
                      0/*#VTs*/, 5/*#Ops*/, 3, 4, 5, 6, 7, 
                  // Src: (st:isVoid (rotl:i8 (ld:i8 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>, 1:i8), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                  // Dst: (ROL8m1:isVoid addr:iPTR:$dst)
/*7747*/        /*Scope*/ 40, /*->7788*/
/*7748*/          OPC_CheckPredicate, 6, // Predicate_loadi16
/*7750*/          OPC_MoveParent,
/*7751*/          OPC_MoveChild, 1,
/*7753*/          OPC_CheckInteger, 1, 
/*7755*/          OPC_CheckType, MVT::i8,
/*7757*/          OPC_MoveParent,
/*7758*/          OPC_CheckType, MVT::i16,
/*7760*/          OPC_MoveParent,
/*7761*/          OPC_MoveChild, 2,
/*7763*/          OPC_CheckSame, 2,
/*7765*/          OPC_MoveParent,
/*7766*/          OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*7768*/          OPC_CheckPredicate, 5, // Predicate_store
/*7770*/          OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #3 #4 #5 #6 #7
/*7773*/          OPC_EmitMergeInputChains, 2, 0, 1, 
/*7777*/          OPC_MorphNodeTo, TARGET_OPCODE(X86::ROL16m1), 0|OPFL_Chain|OPFL_MemRefs,
                      0/*#VTs*/, 5/*#Ops*/, 3, 4, 5, 6, 7, 
                  // Src: (st:isVoid (rotl:i16 (ld:i16 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, 1:i8), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                  // Dst: (ROL16m1:isVoid addr:iPTR:$dst)
/*7788*/        /*Scope*/ 40, /*->7829*/
/*7789*/          OPC_CheckPredicate, 3, // Predicate_loadi32
/*7791*/          OPC_MoveParent,
/*7792*/          OPC_MoveChild, 1,
/*7794*/          OPC_CheckInteger, 1, 
/*7796*/          OPC_CheckType, MVT::i8,
/*7798*/          OPC_MoveParent,
/*7799*/          OPC_CheckType, MVT::i32,
/*7801*/          OPC_MoveParent,
/*7802*/          OPC_MoveChild, 2,
/*7804*/          OPC_CheckSame, 2,
/*7806*/          OPC_MoveParent,
/*7807*/          OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*7809*/          OPC_CheckPredicate, 5, // Predicate_store
/*7811*/          OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #3 #4 #5 #6 #7
/*7814*/          OPC_EmitMergeInputChains, 2, 0, 1, 
/*7818*/          OPC_MorphNodeTo, TARGET_OPCODE(X86::ROL32m1), 0|OPFL_Chain|OPFL_MemRefs,
                      0/*#VTs*/, 5/*#Ops*/, 3, 4, 5, 6, 7, 
                  // Src: (st:isVoid (rotl:i32 (ld:i32 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, 1:i8), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                  // Dst: (ROL32m1:isVoid addr:iPTR:$dst)
/*7829*/        /*Scope*/ 87, /*->7917*/
/*7830*/          OPC_CheckPredicate, 8, // Predicate_load
/*7832*/          OPC_CheckPredicate, 9, // Predicate_dsload
/*7834*/          OPC_MoveParent,
/*7835*/          OPC_Scope, 37, /*->7874*/ // 2 children in Scope
/*7837*/            OPC_MoveChild, 1,
/*7839*/            OPC_CheckInteger, 1, 
/*7841*/            OPC_CheckType, MVT::i8,
/*7843*/            OPC_MoveParent,
/*7844*/            OPC_CheckType, MVT::i64,
/*7846*/            OPC_MoveParent,
/*7847*/            OPC_MoveChild, 2,
/*7849*/            OPC_CheckSame, 2,
/*7851*/            OPC_MoveParent,
/*7852*/            OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*7854*/            OPC_CheckPredicate, 5, // Predicate_store
/*7856*/            OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #3 #4 #5 #6 #7
/*7859*/            OPC_EmitMergeInputChains, 2, 0, 1, 
/*7863*/            OPC_MorphNodeTo, TARGET_OPCODE(X86::ROL64m1), 0|OPFL_Chain|OPFL_MemRefs,
                        0/*#VTs*/, 5/*#Ops*/, 3, 4, 5, 6, 7, 
                    // Src: (st:isVoid (rotl:i64 (ld:i64 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>, 1:i8), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                    // Dst: (ROL64m1:isVoid addr:iPTR:$dst)
/*7874*/          /*Scope*/ 41, /*->7916*/
/*7875*/            OPC_RecordChild1, // #3 = $src
/*7876*/            OPC_MoveChild, 1,
/*7878*/            OPC_CheckOpcode, ISD::Constant,
/*7880*/            OPC_CheckType, MVT::i8,
/*7882*/            OPC_MoveParent,
/*7883*/            OPC_CheckType, MVT::i8,
/*7885*/            OPC_MoveParent,
/*7886*/            OPC_MoveChild, 2,
/*7888*/            OPC_CheckSame, 2,
/*7890*/            OPC_MoveParent,
/*7891*/            OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*7893*/            OPC_CheckPredicate, 5, // Predicate_store
/*7895*/            OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #4 #5 #6 #7 #8
/*7898*/            OPC_EmitMergeInputChains, 2, 0, 1, 
/*7902*/            OPC_EmitConvertToTarget, 3,
/*7904*/            OPC_MorphNodeTo, TARGET_OPCODE(X86::ROL8mi), 0|OPFL_Chain|OPFL_MemRefs,
                        0/*#VTs*/, 6/*#Ops*/, 4, 5, 6, 7, 8, 9, 
                    // Src: (st:isVoid (rotl:i8 (ld:i8 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>, (imm:i8):$src), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                    // Dst: (ROL8mi:isVoid addr:iPTR:$dst, (imm:i8):$src)
/*7916*/          0, /*End of Scope*/
/*7917*/        /*Scope*/ 44, /*->7962*/
/*7918*/          OPC_CheckPredicate, 6, // Predicate_loadi16
/*7920*/          OPC_MoveParent,
/*7921*/          OPC_RecordChild1, // #3 = $src
/*7922*/          OPC_MoveChild, 1,
/*7924*/          OPC_CheckOpcode, ISD::Constant,
/*7926*/          OPC_CheckType, MVT::i8,
/*7928*/          OPC_MoveParent,
/*7929*/          OPC_CheckType, MVT::i16,
/*7931*/          OPC_MoveParent,
/*7932*/          OPC_MoveChild, 2,
/*7934*/          OPC_CheckSame, 2,
/*7936*/          OPC_MoveParent,
/*7937*/          OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*7939*/          OPC_CheckPredicate, 5, // Predicate_store
/*7941*/          OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #4 #5 #6 #7 #8
/*7944*/          OPC_EmitMergeInputChains, 2, 0, 1, 
/*7948*/          OPC_EmitConvertToTarget, 3,
/*7950*/          OPC_MorphNodeTo, TARGET_OPCODE(X86::ROL16mi), 0|OPFL_Chain|OPFL_MemRefs,
                      0/*#VTs*/, 6/*#Ops*/, 4, 5, 6, 7, 8, 9, 
                  // Src: (st:isVoid (rotl:i16 (ld:i16 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, (imm:i8):$src), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                  // Dst: (ROL16mi:isVoid addr:iPTR:$dst, (imm:i8):$src)
/*7962*/        /*Scope*/ 44, /*->8007*/
/*7963*/          OPC_CheckPredicate, 3, // Predicate_loadi32
/*7965*/          OPC_MoveParent,
/*7966*/          OPC_RecordChild1, // #3 = $src
/*7967*/          OPC_MoveChild, 1,
/*7969*/          OPC_CheckOpcode, ISD::Constant,
/*7971*/          OPC_CheckType, MVT::i8,
/*7973*/          OPC_MoveParent,
/*7974*/          OPC_CheckType, MVT::i32,
/*7976*/          OPC_MoveParent,
/*7977*/          OPC_MoveChild, 2,
/*7979*/          OPC_CheckSame, 2,
/*7981*/          OPC_MoveParent,
/*7982*/          OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*7984*/          OPC_CheckPredicate, 5, // Predicate_store
/*7986*/          OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #4 #5 #6 #7 #8
/*7989*/          OPC_EmitMergeInputChains, 2, 0, 1, 
/*7993*/          OPC_EmitConvertToTarget, 3,
/*7995*/          OPC_MorphNodeTo, TARGET_OPCODE(X86::ROL32mi), 0|OPFL_Chain|OPFL_MemRefs,
                      0/*#VTs*/, 6/*#Ops*/, 4, 5, 6, 7, 8, 9, 
                  // Src: (st:isVoid (rotl:i32 (ld:i32 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, (imm:i8):$src), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                  // Dst: (ROL32mi:isVoid addr:iPTR:$dst, (imm:i8):$src)
/*8007*/        /*Scope*/ 85, /*->8093*/
/*8008*/          OPC_CheckPredicate, 8, // Predicate_load
/*8010*/          OPC_CheckPredicate, 9, // Predicate_dsload
/*8012*/          OPC_MoveParent,
/*8013*/          OPC_RecordChild1, // #3 = $src
/*8014*/          OPC_Scope, 40, /*->8056*/ // 2 children in Scope
/*8016*/            OPC_MoveChild, 1,
/*8018*/            OPC_CheckOpcode, ISD::Constant,
/*8020*/            OPC_CheckType, MVT::i8,
/*8022*/            OPC_MoveParent,
/*8023*/            OPC_CheckType, MVT::i64,
/*8025*/            OPC_MoveParent,
/*8026*/            OPC_MoveChild, 2,
/*8028*/            OPC_CheckSame, 2,
/*8030*/            OPC_MoveParent,
/*8031*/            OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*8033*/            OPC_CheckPredicate, 5, // Predicate_store
/*8035*/            OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #4 #5 #6 #7 #8
/*8038*/            OPC_EmitMergeInputChains, 2, 0, 1, 
/*8042*/            OPC_EmitConvertToTarget, 3,
/*8044*/            OPC_MorphNodeTo, TARGET_OPCODE(X86::ROL64mi), 0|OPFL_Chain|OPFL_MemRefs,
                        0/*#VTs*/, 6/*#Ops*/, 4, 5, 6, 7, 8, 9, 
                    // Src: (st:isVoid (rotl:i64 (ld:i64 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>, (imm:i8):$src), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                    // Dst: (ROL64mi:isVoid addr:iPTR:$dst, (imm:i8):$src)
/*8056*/          /*Scope*/ 35, /*->8092*/
/*8057*/            OPC_CheckChild1Type, MVT::i8,
/*8059*/            OPC_CheckType, MVT::i8,
/*8061*/            OPC_MoveParent,
/*8062*/            OPC_MoveChild, 2,
/*8064*/            OPC_CheckSame, 2,
/*8066*/            OPC_MoveParent,
/*8067*/            OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*8069*/            OPC_CheckPredicate, 5, // Predicate_store
/*8071*/            OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #4 #5 #6 #7 #8
/*8074*/            OPC_EmitMergeInputChains, 2, 0, 1, 
/*8078*/            OPC_EmitCopyToReg, 3, X86::CL,
/*8081*/            OPC_MorphNodeTo, TARGET_OPCODE(X86::ROL8mCL), 0|OPFL_Chain|OPFL_FlagInput|OPFL_MemRefs,
                        0/*#VTs*/, 5/*#Ops*/, 4, 5, 6, 7, 8, 
                    // Src: (st:isVoid (rotl:i8 (ld:i8 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>, CL:i8), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                    // Dst: (ROL8mCL:isVoid addr:iPTR:$dst)
/*8092*/          0, /*End of Scope*/
/*8093*/        /*Scope*/ 39, /*->8133*/
/*8094*/          OPC_CheckPredicate, 6, // Predicate_loadi16
/*8096*/          OPC_MoveParent,
/*8097*/          OPC_RecordChild1, // #3 = physreg input CL
/*8098*/          OPC_CheckChild1Type, MVT::i8,
/*8100*/          OPC_CheckType, MVT::i16,
/*8102*/          OPC_MoveParent,
/*8103*/          OPC_MoveChild, 2,
/*8105*/          OPC_CheckSame, 2,
/*8107*/          OPC_MoveParent,
/*8108*/          OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*8110*/          OPC_CheckPredicate, 5, // Predicate_store
/*8112*/          OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #4 #5 #6 #7 #8
/*8115*/          OPC_EmitMergeInputChains, 2, 0, 1, 
/*8119*/          OPC_EmitCopyToReg, 3, X86::CL,
/*8122*/          OPC_MorphNodeTo, TARGET_OPCODE(X86::ROL16mCL), 0|OPFL_Chain|OPFL_FlagInput|OPFL_MemRefs,
                      0/*#VTs*/, 5/*#Ops*/, 4, 5, 6, 7, 8, 
                  // Src: (st:isVoid (rotl:i16 (ld:i16 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, CL:i8), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                  // Dst: (ROL16mCL:isVoid addr:iPTR:$dst)
/*8133*/        /*Scope*/ 39, /*->8173*/
/*8134*/          OPC_CheckPredicate, 3, // Predicate_loadi32
/*8136*/          OPC_MoveParent,
/*8137*/          OPC_RecordChild1, // #3 = physreg input CL
/*8138*/          OPC_CheckChild1Type, MVT::i8,
/*8140*/          OPC_CheckType, MVT::i32,
/*8142*/          OPC_MoveParent,
/*8143*/          OPC_MoveChild, 2,
/*8145*/          OPC_CheckSame, 2,
/*8147*/          OPC_MoveParent,
/*8148*/          OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*8150*/          OPC_CheckPredicate, 5, // Predicate_store
/*8152*/          OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #4 #5 #6 #7 #8
/*8155*/          OPC_EmitMergeInputChains, 2, 0, 1, 
/*8159*/          OPC_EmitCopyToReg, 3, X86::CL,
/*8162*/          OPC_MorphNodeTo, TARGET_OPCODE(X86::ROL32mCL), 0|OPFL_Chain|OPFL_FlagInput|OPFL_MemRefs,
                      0/*#VTs*/, 5/*#Ops*/, 4, 5, 6, 7, 8, 
                  // Src: (st:isVoid (rotl:i32 (ld:i32 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, CL:i8), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                  // Dst: (ROL32mCL:isVoid addr:iPTR:$dst)
/*8173*/        /*Scope*/ 41, /*->8215*/
/*8174*/          OPC_CheckPredicate, 8, // Predicate_load
/*8176*/          OPC_CheckPredicate, 9, // Predicate_dsload
/*8178*/          OPC_MoveParent,
/*8179*/          OPC_RecordChild1, // #3 = physreg input CL
/*8180*/          OPC_CheckChild1Type, MVT::i8,
/*8182*/          OPC_CheckType, MVT::i64,
/*8184*/          OPC_MoveParent,
/*8185*/          OPC_MoveChild, 2,
/*8187*/          OPC_CheckSame, 2,
/*8189*/          OPC_MoveParent,
/*8190*/          OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*8192*/          OPC_CheckPredicate, 5, // Predicate_store
/*8194*/          OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #4 #5 #6 #7 #8
/*8197*/          OPC_EmitMergeInputChains, 2, 0, 1, 
/*8201*/          OPC_EmitCopyToReg, 3, X86::CL,
/*8204*/          OPC_MorphNodeTo, TARGET_OPCODE(X86::ROL64mCL), 0|OPFL_Chain|OPFL_FlagInput|OPFL_MemRefs,
                      0/*#VTs*/, 5/*#Ops*/, 4, 5, 6, 7, 8, 
                  // Src: (st:isVoid (rotl:i64 (ld:i64 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>, CL:i8), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                  // Dst: (ROL64mCL:isVoid addr:iPTR:$dst)
/*8215*/        0, /*End of Scope*/
              /*SwitchOpcode*/ 11|128,4/*523*/,  ISD::ROTR,// ->8742
/*8219*/        OPC_MoveChild, 0,
/*8221*/        OPC_CheckOpcode, ISD::LOAD,
/*8223*/        OPC_RecordMemRef,
/*8224*/        OPC_RecordNode, // #1 = 'ld' chained node
/*8225*/        OPC_CheckFoldableChainNode,
/*8226*/        OPC_RecordChild1, // #2 = $dst
/*8227*/        OPC_CheckPredicate, 2, // Predicate_unindexedload
/*8229*/        OPC_Scope, 42, /*->8273*/ // 10 children in Scope
/*8231*/          OPC_CheckPredicate, 8, // Predicate_load
/*8233*/          OPC_CheckPredicate, 9, // Predicate_dsload
/*8235*/          OPC_MoveParent,
/*8236*/          OPC_MoveChild, 1,
/*8238*/          OPC_CheckInteger, 1, 
/*8240*/          OPC_CheckType, MVT::i8,
/*8242*/          OPC_MoveParent,
/*8243*/          OPC_CheckType, MVT::i8,
/*8245*/          OPC_MoveParent,
/*8246*/          OPC_MoveChild, 2,
/*8248*/          OPC_CheckSame, 2,
/*8250*/          OPC_MoveParent,
/*8251*/          OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*8253*/          OPC_CheckPredicate, 5, // Predicate_store
/*8255*/          OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #3 #4 #5 #6 #7
/*8258*/          OPC_EmitMergeInputChains, 2, 0, 1, 
/*8262*/          OPC_MorphNodeTo, TARGET_OPCODE(X86::ROR8m1), 0|OPFL_Chain|OPFL_MemRefs,
                      0/*#VTs*/, 5/*#Ops*/, 3, 4, 5, 6, 7, 
                  // Src: (st:isVoid (rotr:i8 (ld:i8 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>, 1:i8), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                  // Dst: (ROR8m1:isVoid addr:iPTR:$dst)
/*8273*/        /*Scope*/ 40, /*->8314*/
/*8274*/          OPC_CheckPredicate, 6, // Predicate_loadi16
/*8276*/          OPC_MoveParent,
/*8277*/          OPC_MoveChild, 1,
/*8279*/          OPC_CheckInteger, 1, 
/*8281*/          OPC_CheckType, MVT::i8,
/*8283*/          OPC_MoveParent,
/*8284*/          OPC_CheckType, MVT::i16,
/*8286*/          OPC_MoveParent,
/*8287*/          OPC_MoveChild, 2,
/*8289*/          OPC_CheckSame, 2,
/*8291*/          OPC_MoveParent,
/*8292*/          OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*8294*/          OPC_CheckPredicate, 5, // Predicate_store
/*8296*/          OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #3 #4 #5 #6 #7
/*8299*/          OPC_EmitMergeInputChains, 2, 0, 1, 
/*8303*/          OPC_MorphNodeTo, TARGET_OPCODE(X86::ROR16m1), 0|OPFL_Chain|OPFL_MemRefs,
                      0/*#VTs*/, 5/*#Ops*/, 3, 4, 5, 6, 7, 
                  // Src: (st:isVoid (rotr:i16 (ld:i16 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, 1:i8), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                  // Dst: (ROR16m1:isVoid addr:iPTR:$dst)
/*8314*/        /*Scope*/ 40, /*->8355*/
/*8315*/          OPC_CheckPredicate, 3, // Predicate_loadi32
/*8317*/          OPC_MoveParent,
/*8318*/          OPC_MoveChild, 1,
/*8320*/          OPC_CheckInteger, 1, 
/*8322*/          OPC_CheckType, MVT::i8,
/*8324*/          OPC_MoveParent,
/*8325*/          OPC_CheckType, MVT::i32,
/*8327*/          OPC_MoveParent,
/*8328*/          OPC_MoveChild, 2,
/*8330*/          OPC_CheckSame, 2,
/*8332*/          OPC_MoveParent,
/*8333*/          OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*8335*/          OPC_CheckPredicate, 5, // Predicate_store
/*8337*/          OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #3 #4 #5 #6 #7
/*8340*/          OPC_EmitMergeInputChains, 2, 0, 1, 
/*8344*/          OPC_MorphNodeTo, TARGET_OPCODE(X86::ROR32m1), 0|OPFL_Chain|OPFL_MemRefs,
                      0/*#VTs*/, 5/*#Ops*/, 3, 4, 5, 6, 7, 
                  // Src: (st:isVoid (rotr:i32 (ld:i32 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, 1:i8), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                  // Dst: (ROR32m1:isVoid addr:iPTR:$dst)
/*8355*/        /*Scope*/ 87, /*->8443*/
/*8356*/          OPC_CheckPredicate, 8, // Predicate_load
/*8358*/          OPC_CheckPredicate, 9, // Predicate_dsload
/*8360*/          OPC_MoveParent,
/*8361*/          OPC_Scope, 37, /*->8400*/ // 2 children in Scope
/*8363*/            OPC_MoveChild, 1,
/*8365*/            OPC_CheckInteger, 1, 
/*8367*/            OPC_CheckType, MVT::i8,
/*8369*/            OPC_MoveParent,
/*8370*/            OPC_CheckType, MVT::i64,
/*8372*/            OPC_MoveParent,
/*8373*/            OPC_MoveChild, 2,
/*8375*/            OPC_CheckSame, 2,
/*8377*/            OPC_MoveParent,
/*8378*/            OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*8380*/            OPC_CheckPredicate, 5, // Predicate_store
/*8382*/            OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #3 #4 #5 #6 #7
/*8385*/            OPC_EmitMergeInputChains, 2, 0, 1, 
/*8389*/            OPC_MorphNodeTo, TARGET_OPCODE(X86::ROR64m1), 0|OPFL_Chain|OPFL_MemRefs,
                        0/*#VTs*/, 5/*#Ops*/, 3, 4, 5, 6, 7, 
                    // Src: (st:isVoid (rotr:i64 (ld:i64 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>, 1:i8), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                    // Dst: (ROR64m1:isVoid addr:iPTR:$dst)
/*8400*/          /*Scope*/ 41, /*->8442*/
/*8401*/            OPC_RecordChild1, // #3 = $src
/*8402*/            OPC_MoveChild, 1,
/*8404*/            OPC_CheckOpcode, ISD::Constant,
/*8406*/            OPC_CheckType, MVT::i8,
/*8408*/            OPC_MoveParent,
/*8409*/            OPC_CheckType, MVT::i8,
/*8411*/            OPC_MoveParent,
/*8412*/            OPC_MoveChild, 2,
/*8414*/            OPC_CheckSame, 2,
/*8416*/            OPC_MoveParent,
/*8417*/            OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*8419*/            OPC_CheckPredicate, 5, // Predicate_store
/*8421*/            OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #4 #5 #6 #7 #8
/*8424*/            OPC_EmitMergeInputChains, 2, 0, 1, 
/*8428*/            OPC_EmitConvertToTarget, 3,
/*8430*/            OPC_MorphNodeTo, TARGET_OPCODE(X86::ROR8mi), 0|OPFL_Chain|OPFL_MemRefs,
                        0/*#VTs*/, 6/*#Ops*/, 4, 5, 6, 7, 8, 9, 
                    // Src: (st:isVoid (rotr:i8 (ld:i8 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>, (imm:i8):$src), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                    // Dst: (ROR8mi:isVoid addr:iPTR:$dst, (imm:i8):$src)
/*8442*/          0, /*End of Scope*/
/*8443*/        /*Scope*/ 44, /*->8488*/
/*8444*/          OPC_CheckPredicate, 6, // Predicate_loadi16
/*8446*/          OPC_MoveParent,
/*8447*/          OPC_RecordChild1, // #3 = $src
/*8448*/          OPC_MoveChild, 1,
/*8450*/          OPC_CheckOpcode, ISD::Constant,
/*8452*/          OPC_CheckType, MVT::i8,
/*8454*/          OPC_MoveParent,
/*8455*/          OPC_CheckType, MVT::i16,
/*8457*/          OPC_MoveParent,
/*8458*/          OPC_MoveChild, 2,
/*8460*/          OPC_CheckSame, 2,
/*8462*/          OPC_MoveParent,
/*8463*/          OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*8465*/          OPC_CheckPredicate, 5, // Predicate_store
/*8467*/          OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #4 #5 #6 #7 #8
/*8470*/          OPC_EmitMergeInputChains, 2, 0, 1, 
/*8474*/          OPC_EmitConvertToTarget, 3,
/*8476*/          OPC_MorphNodeTo, TARGET_OPCODE(X86::ROR16mi), 0|OPFL_Chain|OPFL_MemRefs,
                      0/*#VTs*/, 6/*#Ops*/, 4, 5, 6, 7, 8, 9, 
                  // Src: (st:isVoid (rotr:i16 (ld:i16 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, (imm:i8):$src), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                  // Dst: (ROR16mi:isVoid addr:iPTR:$dst, (imm:i8):$src)
/*8488*/        /*Scope*/ 44, /*->8533*/
/*8489*/          OPC_CheckPredicate, 3, // Predicate_loadi32
/*8491*/          OPC_MoveParent,
/*8492*/          OPC_RecordChild1, // #3 = $src
/*8493*/          OPC_MoveChild, 1,
/*8495*/          OPC_CheckOpcode, ISD::Constant,
/*8497*/          OPC_CheckType, MVT::i8,
/*8499*/          OPC_MoveParent,
/*8500*/          OPC_CheckType, MVT::i32,
/*8502*/          OPC_MoveParent,
/*8503*/          OPC_MoveChild, 2,
/*8505*/          OPC_CheckSame, 2,
/*8507*/          OPC_MoveParent,
/*8508*/          OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*8510*/          OPC_CheckPredicate, 5, // Predicate_store
/*8512*/          OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #4 #5 #6 #7 #8
/*8515*/          OPC_EmitMergeInputChains, 2, 0, 1, 
/*8519*/          OPC_EmitConvertToTarget, 3,
/*8521*/          OPC_MorphNodeTo, TARGET_OPCODE(X86::ROR32mi), 0|OPFL_Chain|OPFL_MemRefs,
                      0/*#VTs*/, 6/*#Ops*/, 4, 5, 6, 7, 8, 9, 
                  // Src: (st:isVoid (rotr:i32 (ld:i32 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, (imm:i8):$src), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                  // Dst: (ROR32mi:isVoid addr:iPTR:$dst, (imm:i8):$src)
/*8533*/        /*Scope*/ 85, /*->8619*/
/*8534*/          OPC_CheckPredicate, 8, // Predicate_load
/*8536*/          OPC_CheckPredicate, 9, // Predicate_dsload
/*8538*/          OPC_MoveParent,
/*8539*/          OPC_RecordChild1, // #3 = $src
/*8540*/          OPC_Scope, 40, /*->8582*/ // 2 children in Scope
/*8542*/            OPC_MoveChild, 1,
/*8544*/            OPC_CheckOpcode, ISD::Constant,
/*8546*/            OPC_CheckType, MVT::i8,
/*8548*/            OPC_MoveParent,
/*8549*/            OPC_CheckType, MVT::i64,
/*8551*/            OPC_MoveParent,
/*8552*/            OPC_MoveChild, 2,
/*8554*/            OPC_CheckSame, 2,
/*8556*/            OPC_MoveParent,
/*8557*/            OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*8559*/            OPC_CheckPredicate, 5, // Predicate_store
/*8561*/            OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #4 #5 #6 #7 #8
/*8564*/            OPC_EmitMergeInputChains, 2, 0, 1, 
/*8568*/            OPC_EmitConvertToTarget, 3,
/*8570*/            OPC_MorphNodeTo, TARGET_OPCODE(X86::ROR64mi), 0|OPFL_Chain|OPFL_MemRefs,
                        0/*#VTs*/, 6/*#Ops*/, 4, 5, 6, 7, 8, 9, 
                    // Src: (st:isVoid (rotr:i64 (ld:i64 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>, (imm:i8):$src), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                    // Dst: (ROR64mi:isVoid addr:iPTR:$dst, (imm:i8):$src)
/*8582*/          /*Scope*/ 35, /*->8618*/
/*8583*/            OPC_CheckChild1Type, MVT::i8,
/*8585*/            OPC_CheckType, MVT::i8,
/*8587*/            OPC_MoveParent,
/*8588*/            OPC_MoveChild, 2,
/*8590*/            OPC_CheckSame, 2,
/*8592*/            OPC_MoveParent,
/*8593*/            OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*8595*/            OPC_CheckPredicate, 5, // Predicate_store
/*8597*/            OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #4 #5 #6 #7 #8
/*8600*/            OPC_EmitMergeInputChains, 2, 0, 1, 
/*8604*/            OPC_EmitCopyToReg, 3, X86::CL,
/*8607*/            OPC_MorphNodeTo, TARGET_OPCODE(X86::ROR8mCL), 0|OPFL_Chain|OPFL_FlagInput|OPFL_MemRefs,
                        0/*#VTs*/, 5/*#Ops*/, 4, 5, 6, 7, 8, 
                    // Src: (st:isVoid (rotr:i8 (ld:i8 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>, CL:i8), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                    // Dst: (ROR8mCL:isVoid addr:iPTR:$dst)
/*8618*/          0, /*End of Scope*/
/*8619*/        /*Scope*/ 39, /*->8659*/
/*8620*/          OPC_CheckPredicate, 6, // Predicate_loadi16
/*8622*/          OPC_MoveParent,
/*8623*/          OPC_RecordChild1, // #3 = physreg input CL
/*8624*/          OPC_CheckChild1Type, MVT::i8,
/*8626*/          OPC_CheckType, MVT::i16,
/*8628*/          OPC_MoveParent,
/*8629*/          OPC_MoveChild, 2,
/*8631*/          OPC_CheckSame, 2,
/*8633*/          OPC_MoveParent,
/*8634*/          OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*8636*/          OPC_CheckPredicate, 5, // Predicate_store
/*8638*/          OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #4 #5 #6 #7 #8
/*8641*/          OPC_EmitMergeInputChains, 2, 0, 1, 
/*8645*/          OPC_EmitCopyToReg, 3, X86::CL,
/*8648*/          OPC_MorphNodeTo, TARGET_OPCODE(X86::ROR16mCL), 0|OPFL_Chain|OPFL_FlagInput|OPFL_MemRefs,
                      0/*#VTs*/, 5/*#Ops*/, 4, 5, 6, 7, 8, 
                  // Src: (st:isVoid (rotr:i16 (ld:i16 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, CL:i8), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                  // Dst: (ROR16mCL:isVoid addr:iPTR:$dst)
/*8659*/        /*Scope*/ 39, /*->8699*/
/*8660*/          OPC_CheckPredicate, 3, // Predicate_loadi32
/*8662*/          OPC_MoveParent,
/*8663*/          OPC_RecordChild1, // #3 = physreg input CL
/*8664*/          OPC_CheckChild1Type, MVT::i8,
/*8666*/          OPC_CheckType, MVT::i32,
/*8668*/          OPC_MoveParent,
/*8669*/          OPC_MoveChild, 2,
/*8671*/          OPC_CheckSame, 2,
/*8673*/          OPC_MoveParent,
/*8674*/          OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*8676*/          OPC_CheckPredicate, 5, // Predicate_store
/*8678*/          OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #4 #5 #6 #7 #8
/*8681*/          OPC_EmitMergeInputChains, 2, 0, 1, 
/*8685*/          OPC_EmitCopyToReg, 3, X86::CL,
/*8688*/          OPC_MorphNodeTo, TARGET_OPCODE(X86::ROR32mCL), 0|OPFL_Chain|OPFL_FlagInput|OPFL_MemRefs,
                      0/*#VTs*/, 5/*#Ops*/, 4, 5, 6, 7, 8, 
                  // Src: (st:isVoid (rotr:i32 (ld:i32 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, CL:i8), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                  // Dst: (ROR32mCL:isVoid addr:iPTR:$dst)
/*8699*/        /*Scope*/ 41, /*->8741*/
/*8700*/          OPC_CheckPredicate, 8, // Predicate_load
/*8702*/          OPC_CheckPredicate, 9, // Predicate_dsload
/*8704*/          OPC_MoveParent,
/*8705*/          OPC_RecordChild1, // #3 = physreg input CL
/*8706*/          OPC_CheckChild1Type, MVT::i8,
/*8708*/          OPC_CheckType, MVT::i64,
/*8710*/          OPC_MoveParent,
/*8711*/          OPC_MoveChild, 2,
/*8713*/          OPC_CheckSame, 2,
/*8715*/          OPC_MoveParent,
/*8716*/          OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*8718*/          OPC_CheckPredicate, 5, // Predicate_store
/*8720*/          OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #4 #5 #6 #7 #8
/*8723*/          OPC_EmitMergeInputChains, 2, 0, 1, 
/*8727*/          OPC_EmitCopyToReg, 3, X86::CL,
/*8730*/          OPC_MorphNodeTo, TARGET_OPCODE(X86::ROR64mCL), 0|OPFL_Chain|OPFL_FlagInput|OPFL_MemRefs,
                      0/*#VTs*/, 5/*#Ops*/, 4, 5, 6, 7, 8, 
                  // Src: (st:isVoid (rotr:i64 (ld:i64 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>, CL:i8), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                  // Dst: (ROR64mCL:isVoid addr:iPTR:$dst)
/*8741*/        0, /*End of Scope*/
              /*SwitchOpcode*/ 79|128,4/*591*/,  ISD::AND,// ->9336
/*8745*/        OPC_Scope, 57|128,3/*441*/, /*->9189*/ // 2 children in Scope
/*8748*/          OPC_MoveChild, 0,
/*8750*/          OPC_CheckOpcode, ISD::LOAD,
/*8752*/          OPC_RecordMemRef,
/*8753*/          OPC_RecordNode, // #1 = 'ld' chained node
/*8754*/          OPC_CheckFoldableChainNode,
/*8755*/          OPC_RecordChild1, // #2 = $dst
/*8756*/          OPC_CheckPredicate, 2, // Predicate_unindexedload
/*8758*/          OPC_Scope, 75|128,1/*203*/, /*->8964*/ // 4 children in Scope
/*8761*/            OPC_CheckPredicate, 8, // Predicate_load
/*8763*/            OPC_Scope, 113, /*->8878*/ // 2 children in Scope
/*8765*/              OPC_MoveParent,
/*8766*/              OPC_RecordChild1, // #3 = $src
/*8767*/              OPC_MoveChild, 1,
/*8769*/              OPC_CheckOpcode, ISD::Constant,
/*8771*/              OPC_CheckPredicate, 11, // Predicate_immSext8
/*8773*/              OPC_MoveParent,
/*8774*/              OPC_SwitchType /*3 cases */, 32,  MVT::i16,// ->8809
/*8777*/                OPC_MoveParent,
/*8778*/                OPC_MoveChild, 2,
/*8780*/                OPC_CheckSame, 2,
/*8782*/                OPC_MoveParent,
/*8783*/                OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*8785*/                OPC_CheckPredicate, 5, // Predicate_store
/*8787*/                OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #4 #5 #6 #7 #8
/*8790*/                OPC_EmitMergeInputChains, 2, 0, 1, 
/*8794*/                OPC_EmitConvertToTarget, 3,
/*8796*/                OPC_MorphNodeTo, TARGET_OPCODE(X86::AND16mi8), 0|OPFL_Chain|OPFL_MemRefs,
                            1/*#VTs*/, MVT::i32, 6/*#Ops*/, 4, 5, 6, 7, 8, 9, 
                        // Src: (st:isVoid (and:i16 (ld:i16 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:i16)<<P:Predicate_immSext8>>:$src), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                        // Dst: (AND16mi8:isVoid addr:iPTR:$dst, (imm:i16):$src)
                      /*SwitchType*/ 32,  MVT::i32,// ->8843
/*8811*/                OPC_MoveParent,
/*8812*/                OPC_MoveChild, 2,
/*8814*/                OPC_CheckSame, 2,
/*8816*/                OPC_MoveParent,
/*8817*/                OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*8819*/                OPC_CheckPredicate, 5, // Predicate_store
/*8821*/                OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #4 #5 #6 #7 #8
/*8824*/                OPC_EmitMergeInputChains, 2, 0, 1, 
/*8828*/                OPC_EmitConvertToTarget, 3,
/*8830*/                OPC_MorphNodeTo, TARGET_OPCODE(X86::AND32mi8), 0|OPFL_Chain|OPFL_MemRefs,
                            1/*#VTs*/, MVT::i32, 6/*#Ops*/, 4, 5, 6, 7, 8, 9, 
                        // Src: (st:isVoid (and:i32 (ld:i32 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:i32)<<P:Predicate_immSext8>>:$src), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                        // Dst: (AND32mi8:isVoid addr:iPTR:$dst, (imm:i32):$src)
                      /*SwitchType*/ 32,  MVT::i64,// ->8877
/*8845*/                OPC_MoveParent,
/*8846*/                OPC_MoveChild, 2,
/*8848*/                OPC_CheckSame, 2,
/*8850*/                OPC_MoveParent,
/*8851*/                OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*8853*/                OPC_CheckPredicate, 5, // Predicate_store
/*8855*/                OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #4 #5 #6 #7 #8
/*8858*/                OPC_EmitMergeInputChains, 2, 0, 1, 
/*8862*/                OPC_EmitConvertToTarget, 3,
/*8864*/                OPC_MorphNodeTo, TARGET_OPCODE(X86::AND64mi8), 0|OPFL_Chain|OPFL_MemRefs,
                            1/*#VTs*/, MVT::i32, 6/*#Ops*/, 4, 5, 6, 7, 8, 9, 
                        // Src: (st:isVoid (and:i64 (ld:i64 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:i64)<<P:Predicate_immSext8>>:$src), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                        // Dst: (AND64mi8:isVoid addr:iPTR:$dst, (imm:i64):$src)
                      0, // EndSwitchType
/*8878*/            /*Scope*/ 84, /*->8963*/
/*8879*/              OPC_CheckPredicate, 9, // Predicate_dsload
/*8881*/              OPC_MoveParent,
/*8882*/              OPC_RecordChild1, // #3 = $src
/*8883*/              OPC_MoveChild, 1,
/*8885*/              OPC_CheckOpcode, ISD::Constant,
/*8887*/              OPC_Scope, 37, /*->8926*/ // 2 children in Scope
/*8889*/                OPC_CheckPredicate, 12, // Predicate_i64immSExt32
/*8891*/                OPC_MoveParent,
/*8892*/                OPC_CheckType, MVT::i64,
/*8894*/                OPC_MoveParent,
/*8895*/                OPC_MoveChild, 2,
/*8897*/                OPC_CheckSame, 2,
/*8899*/                OPC_MoveParent,
/*8900*/                OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*8902*/                OPC_CheckPredicate, 5, // Predicate_store
/*8904*/                OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #4 #5 #6 #7 #8
/*8907*/                OPC_EmitMergeInputChains, 2, 0, 1, 
/*8911*/                OPC_EmitConvertToTarget, 3,
/*8913*/                OPC_MorphNodeTo, TARGET_OPCODE(X86::AND64mi32), 0|OPFL_Chain|OPFL_MemRefs,
                            1/*#VTs*/, MVT::i32, 6/*#Ops*/, 4, 5, 6, 7, 8, 9, 
                        // Src: (st:isVoid (and:i64 (ld:i64 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>, (imm:i64)<<P:Predicate_i64immSExt32>>:$src), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                        // Dst: (AND64mi32:isVoid addr:iPTR:$dst, (imm:i64):$src)
/*8926*/              /*Scope*/ 35, /*->8962*/
/*8927*/                OPC_MoveParent,
/*8928*/                OPC_CheckType, MVT::i8,
/*8930*/                OPC_MoveParent,
/*8931*/                OPC_MoveChild, 2,
/*8933*/                OPC_CheckSame, 2,
/*8935*/                OPC_MoveParent,
/*8936*/                OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*8938*/                OPC_CheckPredicate, 5, // Predicate_store
/*8940*/                OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #4 #5 #6 #7 #8
/*8943*/                OPC_EmitMergeInputChains, 2, 0, 1, 
/*8947*/                OPC_EmitConvertToTarget, 3,
/*8949*/                OPC_MorphNodeTo, TARGET_OPCODE(X86::AND8mi), 0|OPFL_Chain|OPFL_MemRefs,
                            1/*#VTs*/, MVT::i32, 6/*#Ops*/, 4, 5, 6, 7, 8, 9, 
                        // Src: (st:isVoid (and:i8 (ld:i8 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>, (imm:i8):$src), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                        // Dst: (AND8mi:isVoid addr:iPTR:$dst, (imm:i8):$src)
/*8962*/              0, /*End of Scope*/
/*8963*/            0, /*End of Scope*/
/*8964*/          /*Scope*/ 43, /*->9008*/
/*8965*/            OPC_CheckPredicate, 6, // Predicate_loadi16
/*8967*/            OPC_MoveParent,
/*8968*/            OPC_RecordChild1, // #3 = $src
/*8969*/            OPC_MoveChild, 1,
/*8971*/            OPC_CheckOpcode, ISD::Constant,
/*8973*/            OPC_MoveParent,
/*8974*/            OPC_CheckType, MVT::i16,
/*8976*/            OPC_MoveParent,
/*8977*/            OPC_MoveChild, 2,
/*8979*/            OPC_CheckSame, 2,
/*8981*/            OPC_MoveParent,
/*8982*/            OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*8984*/            OPC_CheckPredicate, 5, // Predicate_store
/*8986*/            OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #4 #5 #6 #7 #8
/*8989*/            OPC_EmitMergeInputChains, 2, 0, 1, 
/*8993*/            OPC_EmitConvertToTarget, 3,
/*8995*/            OPC_MorphNodeTo, TARGET_OPCODE(X86::AND16mi), 0|OPFL_Chain|OPFL_MemRefs,
                        1/*#VTs*/, MVT::i32, 6/*#Ops*/, 4, 5, 6, 7, 8, 9, 
                    // Src: (st:isVoid (and:i16 (ld:i16 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, (imm:i16):$src), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                    // Dst: (AND16mi:isVoid addr:iPTR:$dst, (imm:i16):$src)
/*9008*/          /*Scope*/ 43, /*->9052*/
/*9009*/            OPC_CheckPredicate, 3, // Predicate_loadi32
/*9011*/            OPC_MoveParent,
/*9012*/            OPC_RecordChild1, // #3 = $src
/*9013*/            OPC_MoveChild, 1,
/*9015*/            OPC_CheckOpcode, ISD::Constant,
/*9017*/            OPC_MoveParent,
/*9018*/            OPC_CheckType, MVT::i32,
/*9020*/            OPC_MoveParent,
/*9021*/            OPC_MoveChild, 2,
/*9023*/            OPC_CheckSame, 2,
/*9025*/            OPC_MoveParent,
/*9026*/            OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*9028*/            OPC_CheckPredicate, 5, // Predicate_store
/*9030*/            OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #4 #5 #6 #7 #8
/*9033*/            OPC_EmitMergeInputChains, 2, 0, 1, 
/*9037*/            OPC_EmitConvertToTarget, 3,
/*9039*/            OPC_MorphNodeTo, TARGET_OPCODE(X86::AND32mi), 0|OPFL_Chain|OPFL_MemRefs,
                        1/*#VTs*/, MVT::i32, 6/*#Ops*/, 4, 5, 6, 7, 8, 9, 
                    // Src: (st:isVoid (and:i32 (ld:i32 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, (imm:i32):$src), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                    // Dst: (AND32mi:isVoid addr:iPTR:$dst, (imm:i32):$src)
/*9052*/          /*Scope*/ 6|128,1/*134*/, /*->9188*/
/*9054*/            OPC_CheckPredicate, 8, // Predicate_load
/*9056*/            OPC_MoveParent,
/*9057*/            OPC_RecordChild1, // #3 = $src
/*9058*/            OPC_SwitchType /*4 cases */, 30,  MVT::i8,// ->9091
/*9061*/              OPC_MoveParent,
/*9062*/              OPC_MoveChild, 2,
/*9064*/              OPC_CheckSame, 2,
/*9066*/              OPC_MoveParent,
/*9067*/              OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*9069*/              OPC_CheckPredicate, 5, // Predicate_store
/*9071*/              OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #4 #5 #6 #7 #8
/*9074*/              OPC_EmitMergeInputChains, 2, 0, 1, 
/*9078*/              OPC_MorphNodeTo, TARGET_OPCODE(X86::AND8mr), 0|OPFL_Chain|OPFL_MemRefs,
                          1/*#VTs*/, MVT::i32, 6/*#Ops*/, 4, 5, 6, 7, 8, 3, 
                      // Src: (st:isVoid (and:i8 (ld:i8 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR8:i8:$src), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                      // Dst: (AND8mr:isVoid addr:iPTR:$dst, GR8:i8:$src)
                    /*SwitchType*/ 30,  MVT::i16,// ->9123
/*9093*/              OPC_MoveParent,
/*9094*/              OPC_MoveChild, 2,
/*9096*/              OPC_CheckSame, 2,
/*9098*/              OPC_MoveParent,
/*9099*/              OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*9101*/              OPC_CheckPredicate, 5, // Predicate_store
/*9103*/              OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #4 #5 #6 #7 #8
/*9106*/              OPC_EmitMergeInputChains, 2, 0, 1, 
/*9110*/              OPC_MorphNodeTo, TARGET_OPCODE(X86::AND16mr), 0|OPFL_Chain|OPFL_MemRefs,
                          1/*#VTs*/, MVT::i32, 6/*#Ops*/, 4, 5, 6, 7, 8, 3, 
                      // Src: (st:isVoid (and:i16 (ld:i16 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR16:i16:$src), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                      // Dst: (AND16mr:isVoid addr:iPTR:$dst, GR16:i16:$src)
                    /*SwitchType*/ 30,  MVT::i32,// ->9155
/*9125*/              OPC_MoveParent,
/*9126*/              OPC_MoveChild, 2,
/*9128*/              OPC_CheckSame, 2,
/*9130*/              OPC_MoveParent,
/*9131*/              OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*9133*/              OPC_CheckPredicate, 5, // Predicate_store
/*9135*/              OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #4 #5 #6 #7 #8
/*9138*/              OPC_EmitMergeInputChains, 2, 0, 1, 
/*9142*/              OPC_MorphNodeTo, TARGET_OPCODE(X86::AND32mr), 0|OPFL_Chain|OPFL_MemRefs,
                          1/*#VTs*/, MVT::i32, 6/*#Ops*/, 4, 5, 6, 7, 8, 3, 
                      // Src: (st:isVoid (and:i32 (ld:i32 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR32:i32:$src), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                      // Dst: (AND32mr:isVoid addr:iPTR:$dst, GR32:i32:$src)
                    /*SwitchType*/ 30,  MVT::i64,// ->9187
/*9157*/              OPC_MoveParent,
/*9158*/              OPC_MoveChild, 2,
/*9160*/              OPC_CheckSame, 2,
/*9162*/              OPC_MoveParent,
/*9163*/              OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*9165*/              OPC_CheckPredicate, 5, // Predicate_store
/*9167*/              OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #4 #5 #6 #7 #8
/*9170*/              OPC_EmitMergeInputChains, 2, 0, 1, 
/*9174*/              OPC_MorphNodeTo, TARGET_OPCODE(X86::AND64mr), 0|OPFL_Chain|OPFL_MemRefs,
                          1/*#VTs*/, MVT::i32, 6/*#Ops*/, 4, 5, 6, 7, 8, 3, 
                      // Src: (st:isVoid (and:i64 (ld:i64 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR64:i64:$src), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                      // Dst: (AND64mr:isVoid addr:iPTR:$dst, GR64:i64:$src)
                    0, // EndSwitchType
/*9188*/          0, /*End of Scope*/
/*9189*/        /*Scope*/ 16|128,1/*144*/, /*->9335*/
/*9191*/          OPC_RecordChild0, // #1 = $src
/*9192*/          OPC_MoveChild, 1,
/*9194*/          OPC_CheckOpcode, ISD::LOAD,
/*9196*/          OPC_RecordMemRef,
/*9197*/          OPC_RecordNode, // #2 = 'ld' chained node
/*9198*/          OPC_CheckFoldableChainNode,
/*9199*/          OPC_RecordChild1, // #3 = $dst
/*9200*/          OPC_CheckPredicate, 2, // Predicate_unindexedload
/*9202*/          OPC_CheckPredicate, 8, // Predicate_load
/*9204*/          OPC_MoveParent,
/*9205*/          OPC_SwitchType /*4 cases */, 30,  MVT::i8,// ->9238
/*9208*/            OPC_MoveParent,
/*9209*/            OPC_MoveChild, 2,
/*9211*/            OPC_CheckSame, 3,
/*9213*/            OPC_MoveParent,
/*9214*/            OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*9216*/            OPC_CheckPredicate, 5, // Predicate_store
/*9218*/            OPC_CheckComplexPat, /*CP*/0, /*#*/3, // SelectAddr:$dst #4 #5 #6 #7 #8
/*9221*/            OPC_EmitMergeInputChains, 2, 0, 2, 
/*9225*/            OPC_MorphNodeTo, TARGET_OPCODE(X86::AND8mr), 0|OPFL_Chain|OPFL_MemRefs,
                        1/*#VTs*/, MVT::i32, 6/*#Ops*/, 4, 5, 6, 7, 8, 1, 
                    // Src: (st:isVoid (and:i8 GR8:i8:$src, (ld:i8 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>>), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                    // Dst: (AND8mr:isVoid addr:iPTR:$dst, GR8:i8:$src)
                  /*SwitchType*/ 30,  MVT::i16,// ->9270
/*9240*/            OPC_MoveParent,
/*9241*/            OPC_MoveChild, 2,
/*9243*/            OPC_CheckSame, 3,
/*9245*/            OPC_MoveParent,
/*9246*/            OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*9248*/            OPC_CheckPredicate, 5, // Predicate_store
/*9250*/            OPC_CheckComplexPat, /*CP*/0, /*#*/3, // SelectAddr:$dst #4 #5 #6 #7 #8
/*9253*/            OPC_EmitMergeInputChains, 2, 0, 2, 
/*9257*/            OPC_MorphNodeTo, TARGET_OPCODE(X86::AND16mr), 0|OPFL_Chain|OPFL_MemRefs,
                        1/*#VTs*/, MVT::i32, 6/*#Ops*/, 4, 5, 6, 7, 8, 1, 
                    // Src: (st:isVoid (and:i16 GR16:i16:$src, (ld:i16 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>>), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                    // Dst: (AND16mr:isVoid addr:iPTR:$dst, GR16:i16:$src)
                  /*SwitchType*/ 30,  MVT::i32,// ->9302
/*9272*/            OPC_MoveParent,
/*9273*/            OPC_MoveChild, 2,
/*9275*/            OPC_CheckSame, 3,
/*9277*/            OPC_MoveParent,
/*9278*/            OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*9280*/            OPC_CheckPredicate, 5, // Predicate_store
/*9282*/            OPC_CheckComplexPat, /*CP*/0, /*#*/3, // SelectAddr:$dst #4 #5 #6 #7 #8
/*9285*/            OPC_EmitMergeInputChains, 2, 0, 2, 
/*9289*/            OPC_MorphNodeTo, TARGET_OPCODE(X86::AND32mr), 0|OPFL_Chain|OPFL_MemRefs,
                        1/*#VTs*/, MVT::i32, 6/*#Ops*/, 4, 5, 6, 7, 8, 1, 
                    // Src: (st:isVoid (and:i32 GR32:i32:$src, (ld:i32 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>>), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                    // Dst: (AND32mr:isVoid addr:iPTR:$dst, GR32:i32:$src)
                  /*SwitchType*/ 30,  MVT::i64,// ->9334
/*9304*/            OPC_MoveParent,
/*9305*/            OPC_MoveChild, 2,
/*9307*/            OPC_CheckSame, 3,
/*9309*/            OPC_MoveParent,
/*9310*/            OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*9312*/            OPC_CheckPredicate, 5, // Predicate_store
/*9314*/            OPC_CheckComplexPat, /*CP*/0, /*#*/3, // SelectAddr:$dst #4 #5 #6 #7 #8
/*9317*/            OPC_EmitMergeInputChains, 2, 0, 2, 
/*9321*/            OPC_MorphNodeTo, TARGET_OPCODE(X86::AND64mr), 0|OPFL_Chain|OPFL_MemRefs,
                        1/*#VTs*/, MVT::i32, 6/*#Ops*/, 4, 5, 6, 7, 8, 1, 
                    // Src: (st:isVoid (and:i64 GR64:i64:$src, (ld:i64 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>>), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                    // Dst: (AND64mr:isVoid addr:iPTR:$dst, GR64:i64:$src)
                  0, // EndSwitchType
/*9335*/        0, /*End of Scope*/
              /*SwitchOpcode*/ 112|128,4/*624*/,  ISD::ADDE,// ->9963
/*9339*/        OPC_RecordNode, // #1 = 'adde' flag output node
/*9340*/        OPC_CaptureFlagInput,
/*9341*/        OPC_Scope, 80|128,3/*464*/, /*->9808*/ // 2 children in Scope
/*9344*/          OPC_MoveChild, 0,
/*9346*/          OPC_CheckOpcode, ISD::LOAD,
/*9348*/          OPC_RecordMemRef,
/*9349*/          OPC_RecordNode, // #2 = 'ld' chained node
/*9350*/          OPC_CheckFoldableChainNode,
/*9351*/          OPC_RecordChild1, // #3 = $dst
/*9352*/          OPC_CheckPredicate, 2, // Predicate_unindexedload
/*9354*/          OPC_Scope, 86|128,1/*214*/, /*->9571*/ // 4 children in Scope
/*9357*/            OPC_CheckPredicate, 8, // Predicate_load
/*9359*/            OPC_Scope, 34|128,1/*162*/, /*->9524*/ // 2 children in Scope
/*9362*/              OPC_MoveParent,
/*9363*/              OPC_RecordChild1, // #4 = $src2
/*9364*/              OPC_MoveChild, 1,
/*9366*/              OPC_CheckOpcode, ISD::Constant,
/*9368*/              OPC_Scope, 113, /*->9483*/ // 2 children in Scope
/*9370*/                OPC_CheckPredicate, 11, // Predicate_immSext8
/*9372*/                OPC_MoveParent,
/*9373*/                OPC_SwitchType /*3 cases */, 34,  MVT::i16,// ->9410
/*9376*/                  OPC_MoveParent,
/*9377*/                  OPC_MoveChild, 2,
/*9379*/                  OPC_CheckSame, 3,
/*9381*/                  OPC_MoveParent,
/*9382*/                  OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*9384*/                  OPC_CheckPredicate, 5, // Predicate_store
/*9386*/                  OPC_CheckComplexPat, /*CP*/0, /*#*/3, // SelectAddr:$dst #5 #6 #7 #8 #9
/*9389*/                  OPC_EmitMergeInputChains, 2, 0, 2, 
/*9393*/                  OPC_EmitConvertToTarget, 4,
/*9395*/                  OPC_MarkFlagResults, 1, 1, 
/*9398*/                  OPC_MorphNodeTo, TARGET_OPCODE(X86::ADC16mi8), 0|OPFL_Chain|OPFL_FlagInput|OPFL_FlagOutput|OPFL_MemRefs,
                              0/*#VTs*/, 6/*#Ops*/, 5, 6, 7, 8, 9, 10, 
                          // Src: (st:isVoid (adde:i16 (ld:i16 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:i16)<<P:Predicate_immSext8>>:$src2), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                          // Dst: (ADC16mi8:isVoid addr:iPTR:$dst, (imm:i16):$src2)
                        /*SwitchType*/ 34,  MVT::i32,// ->9446
/*9412*/                  OPC_MoveParent,
/*9413*/                  OPC_MoveChild, 2,
/*9415*/                  OPC_CheckSame, 3,
/*9417*/                  OPC_MoveParent,
/*9418*/                  OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*9420*/                  OPC_CheckPredicate, 5, // Predicate_store
/*9422*/                  OPC_CheckComplexPat, /*CP*/0, /*#*/3, // SelectAddr:$dst #5 #6 #7 #8 #9
/*9425*/                  OPC_EmitMergeInputChains, 2, 0, 2, 
/*9429*/                  OPC_EmitConvertToTarget, 4,
/*9431*/                  OPC_MarkFlagResults, 1, 1, 
/*9434*/                  OPC_MorphNodeTo, TARGET_OPCODE(X86::ADC32mi8), 0|OPFL_Chain|OPFL_FlagInput|OPFL_FlagOutput|OPFL_MemRefs,
                              0/*#VTs*/, 6/*#Ops*/, 5, 6, 7, 8, 9, 10, 
                          // Src: (st:isVoid (adde:i32 (ld:i32 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:i32)<<P:Predicate_immSext8>>:$src2), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                          // Dst: (ADC32mi8:isVoid addr:iPTR:$dst, (imm:i32):$src2)
                        /*SwitchType*/ 34,  MVT::i64,// ->9482
/*9448*/                  OPC_MoveParent,
/*9449*/                  OPC_MoveChild, 2,
/*9451*/                  OPC_CheckSame, 3,
/*9453*/                  OPC_MoveParent,
/*9454*/                  OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*9456*/                  OPC_CheckPredicate, 5, // Predicate_store
/*9458*/                  OPC_CheckComplexPat, /*CP*/0, /*#*/3, // SelectAddr:$dst #5 #6 #7 #8 #9
/*9461*/                  OPC_EmitMergeInputChains, 2, 0, 2, 
/*9465*/                  OPC_EmitConvertToTarget, 4,
/*9467*/                  OPC_MarkFlagResults, 1, 1, 
/*9470*/                  OPC_MorphNodeTo, TARGET_OPCODE(X86::ADC64mi8), 0|OPFL_Chain|OPFL_FlagInput|OPFL_FlagOutput|OPFL_MemRefs,
                              0/*#VTs*/, 6/*#Ops*/, 5, 6, 7, 8, 9, 10, 
                          // Src: (st:isVoid (adde:i64 (ld:i64 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:i64)<<P:Predicate_immSext8>>:$src2), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                          // Dst: (ADC64mi8:isVoid addr:iPTR:$dst, (imm:i64):$src2)
                        0, // EndSwitchType
/*9483*/              /*Scope*/ 39, /*->9523*/
/*9484*/                OPC_CheckPredicate, 12, // Predicate_i64immSExt32
/*9486*/                OPC_MoveParent,
/*9487*/                OPC_CheckType, MVT::i64,
/*9489*/                OPC_MoveParent,
/*9490*/                OPC_MoveChild, 2,
/*9492*/                OPC_CheckSame, 3,
/*9494*/                OPC_MoveParent,
/*9495*/                OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*9497*/                OPC_CheckPredicate, 5, // Predicate_store
/*9499*/                OPC_CheckComplexPat, /*CP*/0, /*#*/3, // SelectAddr:$dst #5 #6 #7 #8 #9
/*9502*/                OPC_EmitMergeInputChains, 2, 0, 2, 
/*9506*/                OPC_EmitConvertToTarget, 4,
/*9508*/                OPC_MarkFlagResults, 1, 1, 
/*9511*/                OPC_MorphNodeTo, TARGET_OPCODE(X86::ADC64mi32), 0|OPFL_Chain|OPFL_FlagInput|OPFL_FlagOutput|OPFL_MemRefs,
                            0/*#VTs*/, 6/*#Ops*/, 5, 6, 7, 8, 9, 10, 
                        // Src: (st:isVoid (adde:i64 (ld:i64 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:i64)<<P:Predicate_i64immSExt32>>:$src2), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                        // Dst: (ADC64mi32:isVoid addr:iPTR:$dst, (imm:i64):$src2)
/*9523*/              0, /*End of Scope*/
/*9524*/            /*Scope*/ 45, /*->9570*/
/*9525*/              OPC_CheckPredicate, 9, // Predicate_dsload
/*9527*/              OPC_MoveParent,
/*9528*/              OPC_RecordChild1, // #4 = $src2
/*9529*/              OPC_MoveChild, 1,
/*9531*/              OPC_CheckOpcode, ISD::Constant,
/*9533*/              OPC_MoveParent,
/*9534*/              OPC_CheckType, MVT::i8,
/*9536*/              OPC_MoveParent,
/*9537*/              OPC_MoveChild, 2,
/*9539*/              OPC_CheckSame, 3,
/*9541*/              OPC_MoveParent,
/*9542*/              OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*9544*/              OPC_CheckPredicate, 5, // Predicate_store
/*9546*/              OPC_CheckComplexPat, /*CP*/0, /*#*/3, // SelectAddr:$dst #5 #6 #7 #8 #9
/*9549*/              OPC_EmitMergeInputChains, 2, 0, 2, 
/*9553*/              OPC_EmitConvertToTarget, 4,
/*9555*/              OPC_MarkFlagResults, 1, 1, 
/*9558*/              OPC_MorphNodeTo, TARGET_OPCODE(X86::ADC8mi), 0|OPFL_Chain|OPFL_FlagInput|OPFL_FlagOutput|OPFL_MemRefs,
                          0/*#VTs*/, 6/*#Ops*/, 5, 6, 7, 8, 9, 10, 
                      // Src: (st:isVoid (adde:i8 (ld:i8 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>, (imm:i8):$src2), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                      // Dst: (ADC8mi:isVoid addr:iPTR:$dst, (imm:i8):$src2)
/*9570*/            0, /*End of Scope*/
/*9571*/          /*Scope*/ 45, /*->9617*/
/*9572*/            OPC_CheckPredicate, 6, // Predicate_loadi16
/*9574*/            OPC_MoveParent,
/*9575*/            OPC_RecordChild1, // #4 = $src2
/*9576*/            OPC_MoveChild, 1,
/*9578*/            OPC_CheckOpcode, ISD::Constant,
/*9580*/            OPC_MoveParent,
/*9581*/            OPC_CheckType, MVT::i16,
/*9583*/            OPC_MoveParent,
/*9584*/            OPC_MoveChild, 2,
/*9586*/            OPC_CheckSame, 3,
/*9588*/            OPC_MoveParent,
/*9589*/            OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*9591*/            OPC_CheckPredicate, 5, // Predicate_store
/*9593*/            OPC_CheckComplexPat, /*CP*/0, /*#*/3, // SelectAddr:$dst #5 #6 #7 #8 #9
/*9596*/            OPC_EmitMergeInputChains, 2, 0, 2, 
/*9600*/            OPC_EmitConvertToTarget, 4,
/*9602*/            OPC_MarkFlagResults, 1, 1, 
/*9605*/            OPC_MorphNodeTo, TARGET_OPCODE(X86::ADC16mi), 0|OPFL_Chain|OPFL_FlagInput|OPFL_FlagOutput|OPFL_MemRefs,
                        0/*#VTs*/, 6/*#Ops*/, 5, 6, 7, 8, 9, 10, 
                    // Src: (st:isVoid (adde:i16 (ld:i16 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, (imm:i16):$src2), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                    // Dst: (ADC16mi:isVoid addr:iPTR:$dst, (imm:i16):$src2)
/*9617*/          /*Scope*/ 45, /*->9663*/
/*9618*/            OPC_CheckPredicate, 3, // Predicate_loadi32
/*9620*/            OPC_MoveParent,
/*9621*/            OPC_RecordChild1, // #4 = $src2
/*9622*/            OPC_MoveChild, 1,
/*9624*/            OPC_CheckOpcode, ISD::Constant,
/*9626*/            OPC_MoveParent,
/*9627*/            OPC_CheckType, MVT::i32,
/*9629*/            OPC_MoveParent,
/*9630*/            OPC_MoveChild, 2,
/*9632*/            OPC_CheckSame, 3,
/*9634*/            OPC_MoveParent,
/*9635*/            OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*9637*/            OPC_CheckPredicate, 5, // Predicate_store
/*9639*/            OPC_CheckComplexPat, /*CP*/0, /*#*/3, // SelectAddr:$dst #5 #6 #7 #8 #9
/*9642*/            OPC_EmitMergeInputChains, 2, 0, 2, 
/*9646*/            OPC_EmitConvertToTarget, 4,
/*9648*/            OPC_MarkFlagResults, 1, 1, 
/*9651*/            OPC_MorphNodeTo, TARGET_OPCODE(X86::ADC32mi), 0|OPFL_Chain|OPFL_FlagInput|OPFL_FlagOutput|OPFL_MemRefs,
                        0/*#VTs*/, 6/*#Ops*/, 5, 6, 7, 8, 9, 10, 
                    // Src: (st:isVoid (adde:i32 (ld:i32 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, (imm:i32):$src2), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                    // Dst: (ADC32mi:isVoid addr:iPTR:$dst, (imm:i32):$src2)
/*9663*/          /*Scope*/ 14|128,1/*142*/, /*->9807*/
/*9665*/            OPC_CheckPredicate, 8, // Predicate_load
/*9667*/            OPC_MoveParent,
/*9668*/            OPC_RecordChild1, // #4 = $src2
/*9669*/            OPC_SwitchType /*4 cases */, 32,  MVT::i8,// ->9704
/*9672*/              OPC_MoveParent,
/*9673*/              OPC_MoveChild, 2,
/*9675*/              OPC_CheckSame, 3,
/*9677*/              OPC_MoveParent,
/*9678*/              OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*9680*/              OPC_CheckPredicate, 5, // Predicate_store
/*9682*/              OPC_CheckComplexPat, /*CP*/0, /*#*/3, // SelectAddr:$dst #5 #6 #7 #8 #9
/*9685*/              OPC_EmitMergeInputChains, 2, 0, 2, 
/*9689*/              OPC_MarkFlagResults, 1, 1, 
/*9692*/              OPC_MorphNodeTo, TARGET_OPCODE(X86::ADC8mr), 0|OPFL_Chain|OPFL_FlagInput|OPFL_FlagOutput|OPFL_MemRefs,
                          0/*#VTs*/, 6/*#Ops*/, 5, 6, 7, 8, 9, 4, 
                      // Src: (st:isVoid (adde:i8 (ld:i8 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR8:i8:$src2), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                      // Dst: (ADC8mr:isVoid addr:iPTR:$dst, GR8:i8:$src2)
                    /*SwitchType*/ 32,  MVT::i16,// ->9738
/*9706*/              OPC_MoveParent,
/*9707*/              OPC_MoveChild, 2,
/*9709*/              OPC_CheckSame, 3,
/*9711*/              OPC_MoveParent,
/*9712*/              OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*9714*/              OPC_CheckPredicate, 5, // Predicate_store
/*9716*/              OPC_CheckComplexPat, /*CP*/0, /*#*/3, // SelectAddr:$dst #5 #6 #7 #8 #9
/*9719*/              OPC_EmitMergeInputChains, 2, 0, 2, 
/*9723*/              OPC_MarkFlagResults, 1, 1, 
/*9726*/              OPC_MorphNodeTo, TARGET_OPCODE(X86::ADC16mr), 0|OPFL_Chain|OPFL_FlagInput|OPFL_FlagOutput|OPFL_MemRefs,
                          0/*#VTs*/, 6/*#Ops*/, 5, 6, 7, 8, 9, 4, 
                      // Src: (st:isVoid (adde:i16 (ld:i16 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR16:i16:$src2), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                      // Dst: (ADC16mr:isVoid addr:iPTR:$dst, GR16:i16:$src2)
                    /*SwitchType*/ 32,  MVT::i32,// ->9772
/*9740*/              OPC_MoveParent,
/*9741*/              OPC_MoveChild, 2,
/*9743*/              OPC_CheckSame, 3,
/*9745*/              OPC_MoveParent,
/*9746*/              OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*9748*/              OPC_CheckPredicate, 5, // Predicate_store
/*9750*/              OPC_CheckComplexPat, /*CP*/0, /*#*/3, // SelectAddr:$dst #5 #6 #7 #8 #9
/*9753*/              OPC_EmitMergeInputChains, 2, 0, 2, 
/*9757*/              OPC_MarkFlagResults, 1, 1, 
/*9760*/              OPC_MorphNodeTo, TARGET_OPCODE(X86::ADC32mr), 0|OPFL_Chain|OPFL_FlagInput|OPFL_FlagOutput|OPFL_MemRefs,
                          0/*#VTs*/, 6/*#Ops*/, 5, 6, 7, 8, 9, 4, 
                      // Src: (st:isVoid (adde:i32 (ld:i32 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR32:i32:$src2), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                      // Dst: (ADC32mr:isVoid addr:iPTR:$dst, GR32:i32:$src2)
                    /*SwitchType*/ 32,  MVT::i64,// ->9806
/*9774*/              OPC_MoveParent,
/*9775*/              OPC_MoveChild, 2,
/*9777*/              OPC_CheckSame, 3,
/*9779*/              OPC_MoveParent,
/*9780*/              OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*9782*/              OPC_CheckPredicate, 5, // Predicate_store
/*9784*/              OPC_CheckComplexPat, /*CP*/0, /*#*/3, // SelectAddr:$dst #5 #6 #7 #8 #9
/*9787*/              OPC_EmitMergeInputChains, 2, 0, 2, 
/*9791*/              OPC_MarkFlagResults, 1, 1, 
/*9794*/              OPC_MorphNodeTo, TARGET_OPCODE(X86::ADC64mr), 0|OPFL_Chain|OPFL_FlagInput|OPFL_FlagOutput|OPFL_MemRefs,
                          0/*#VTs*/, 6/*#Ops*/, 5, 6, 7, 8, 9, 4, 
                      // Src: (st:isVoid (adde:i64 (ld:i64 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR64:i64:$src2), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                      // Dst: (ADC64mr:isVoid addr:iPTR:$dst, GR64:i64:$src2)
                    0, // EndSwitchType
/*9807*/          0, /*End of Scope*/
/*9808*/        /*Scope*/ 24|128,1/*152*/, /*->9962*/
/*9810*/          OPC_RecordChild0, // #2 = $src2
/*9811*/          OPC_MoveChild, 1,
/*9813*/          OPC_CheckOpcode, ISD::LOAD,
/*9815*/          OPC_RecordMemRef,
/*9816*/          OPC_RecordNode, // #3 = 'ld' chained node
/*9817*/          OPC_CheckFoldableChainNode,
/*9818*/          OPC_RecordChild1, // #4 = $dst
/*9819*/          OPC_CheckPredicate, 2, // Predicate_unindexedload
/*9821*/          OPC_CheckPredicate, 8, // Predicate_load
/*9823*/          OPC_MoveParent,
/*9824*/          OPC_SwitchType /*4 cases */, 32,  MVT::i8,// ->9859
/*9827*/            OPC_MoveParent,
/*9828*/            OPC_MoveChild, 2,
/*9830*/            OPC_CheckSame, 4,
/*9832*/            OPC_MoveParent,
/*9833*/            OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*9835*/            OPC_CheckPredicate, 5, // Predicate_store
/*9837*/            OPC_CheckComplexPat, /*CP*/0, /*#*/4, // SelectAddr:$dst #5 #6 #7 #8 #9
/*9840*/            OPC_EmitMergeInputChains, 2, 0, 3, 
/*9844*/            OPC_MarkFlagResults, 1, 1, 
/*9847*/            OPC_MorphNodeTo, TARGET_OPCODE(X86::ADC8mr), 0|OPFL_Chain|OPFL_FlagInput|OPFL_FlagOutput|OPFL_MemRefs,
                        0/*#VTs*/, 6/*#Ops*/, 5, 6, 7, 8, 9, 2, 
                    // Src: (st:isVoid (adde:i8 GR8:i8:$src2, (ld:i8 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>>), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                    // Dst: (ADC8mr:isVoid addr:iPTR:$dst, GR8:i8:$src2)
                  /*SwitchType*/ 32,  MVT::i16,// ->9893
/*9861*/            OPC_MoveParent,
/*9862*/            OPC_MoveChild, 2,
/*9864*/            OPC_CheckSame, 4,
/*9866*/            OPC_MoveParent,
/*9867*/            OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*9869*/            OPC_CheckPredicate, 5, // Predicate_store
/*9871*/            OPC_CheckComplexPat, /*CP*/0, /*#*/4, // SelectAddr:$dst #5 #6 #7 #8 #9
/*9874*/            OPC_EmitMergeInputChains, 2, 0, 3, 
/*9878*/            OPC_MarkFlagResults, 1, 1, 
/*9881*/            OPC_MorphNodeTo, TARGET_OPCODE(X86::ADC16mr), 0|OPFL_Chain|OPFL_FlagInput|OPFL_FlagOutput|OPFL_MemRefs,
                        0/*#VTs*/, 6/*#Ops*/, 5, 6, 7, 8, 9, 2, 
                    // Src: (st:isVoid (adde:i16 GR16:i16:$src2, (ld:i16 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>>), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                    // Dst: (ADC16mr:isVoid addr:iPTR:$dst, GR16:i16:$src2)
                  /*SwitchType*/ 32,  MVT::i32,// ->9927
/*9895*/            OPC_MoveParent,
/*9896*/            OPC_MoveChild, 2,
/*9898*/            OPC_CheckSame, 4,
/*9900*/            OPC_MoveParent,
/*9901*/            OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*9903*/            OPC_CheckPredicate, 5, // Predicate_store
/*9905*/            OPC_CheckComplexPat, /*CP*/0, /*#*/4, // SelectAddr:$dst #5 #6 #7 #8 #9
/*9908*/            OPC_EmitMergeInputChains, 2, 0, 3, 
/*9912*/            OPC_MarkFlagResults, 1, 1, 
/*9915*/            OPC_MorphNodeTo, TARGET_OPCODE(X86::ADC32mr), 0|OPFL_Chain|OPFL_FlagInput|OPFL_FlagOutput|OPFL_MemRefs,
                        0/*#VTs*/, 6/*#Ops*/, 5, 6, 7, 8, 9, 2, 
                    // Src: (st:isVoid (adde:i32 GR32:i32:$src2, (ld:i32 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>>), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                    // Dst: (ADC32mr:isVoid addr:iPTR:$dst, GR32:i32:$src2)
                  /*SwitchType*/ 32,  MVT::i64,// ->9961
/*9929*/            OPC_MoveParent,
/*9930*/            OPC_MoveChild, 2,
/*9932*/            OPC_CheckSame, 4,
/*9934*/            OPC_MoveParent,
/*9935*/            OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*9937*/            OPC_CheckPredicate, 5, // Predicate_store
/*9939*/            OPC_CheckComplexPat, /*CP*/0, /*#*/4, // SelectAddr:$dst #5 #6 #7 #8 #9
/*9942*/            OPC_EmitMergeInputChains, 2, 0, 3, 
/*9946*/            OPC_MarkFlagResults, 1, 1, 
/*9949*/            OPC_MorphNodeTo, TARGET_OPCODE(X86::ADC64mr), 0|OPFL_Chain|OPFL_FlagInput|OPFL_FlagOutput|OPFL_MemRefs,
                        0/*#VTs*/, 6/*#Ops*/, 5, 6, 7, 8, 9, 2, 
                    // Src: (st:isVoid (adde:i64 GR64:i64:$src2, (ld:i64 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>>), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                    // Dst: (ADC64mr:isVoid addr:iPTR:$dst, GR64:i64:$src2)
                  0, // EndSwitchType
/*9962*/        0, /*End of Scope*/
              /*SwitchOpcode*/ 82|128,3/*466*/,  ISD::SUBE,// ->10432
/*9966*/        OPC_RecordNode, // #1 = 'sube' flag output node
/*9967*/        OPC_CaptureFlagInput,
/*9968*/        OPC_MoveChild, 0,
/*9970*/        OPC_CheckOpcode, ISD::LOAD,
/*9972*/        OPC_RecordMemRef,
/*9973*/        OPC_RecordNode, // #2 = 'ld' chained node
/*9974*/        OPC_CheckFoldableChainNode,
/*9975*/        OPC_RecordChild1, // #3 = $dst
/*9976*/        OPC_CheckPredicate, 2, // Predicate_unindexedload
/*9978*/        OPC_Scope, 86|128,1/*214*/, /*->10195*/ // 4 children in Scope
/*9981*/          OPC_CheckPredicate, 8, // Predicate_load
/*9983*/          OPC_Scope, 34|128,1/*162*/, /*->10148*/ // 2 children in Scope
/*9986*/            OPC_MoveParent,
/*9987*/            OPC_RecordChild1, // #4 = $src2
/*9988*/            OPC_MoveChild, 1,
/*9990*/            OPC_CheckOpcode, ISD::Constant,
/*9992*/            OPC_Scope, 113, /*->10107*/ // 2 children in Scope
/*9994*/              OPC_CheckPredicate, 11, // Predicate_immSext8
/*9996*/              OPC_MoveParent,
/*9997*/              OPC_SwitchType /*3 cases */, 34,  MVT::i16,// ->10034
/*10000*/               OPC_MoveParent,
/*10001*/               OPC_MoveChild, 2,
/*10003*/               OPC_CheckSame, 3,
/*10005*/               OPC_MoveParent,
/*10006*/               OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*10008*/               OPC_CheckPredicate, 5, // Predicate_store
/*10010*/               OPC_CheckComplexPat, /*CP*/0, /*#*/3, // SelectAddr:$dst #5 #6 #7 #8 #9
/*10013*/               OPC_EmitMergeInputChains, 2, 0, 2, 
/*10017*/               OPC_EmitConvertToTarget, 4,
/*10019*/               OPC_MarkFlagResults, 1, 1, 
/*10022*/               OPC_MorphNodeTo, TARGET_OPCODE(X86::SBB16mi8), 0|OPFL_Chain|OPFL_FlagInput|OPFL_FlagOutput|OPFL_MemRefs,
                            0/*#VTs*/, 6/*#Ops*/, 5, 6, 7, 8, 9, 10, 
                        // Src: (st:isVoid (sube:i16 (ld:i16 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:i16)<<P:Predicate_immSext8>>:$src2), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                        // Dst: (SBB16mi8:isVoid addr:iPTR:$dst, (imm:i16):$src2)
                      /*SwitchType*/ 34,  MVT::i32,// ->10070
/*10036*/               OPC_MoveParent,
/*10037*/               OPC_MoveChild, 2,
/*10039*/               OPC_CheckSame, 3,
/*10041*/               OPC_MoveParent,
/*10042*/               OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*10044*/               OPC_CheckPredicate, 5, // Predicate_store
/*10046*/               OPC_CheckComplexPat, /*CP*/0, /*#*/3, // SelectAddr:$dst #5 #6 #7 #8 #9
/*10049*/               OPC_EmitMergeInputChains, 2, 0, 2, 
/*10053*/               OPC_EmitConvertToTarget, 4,
/*10055*/               OPC_MarkFlagResults, 1, 1, 
/*10058*/               OPC_MorphNodeTo, TARGET_OPCODE(X86::SBB32mi8), 0|OPFL_Chain|OPFL_FlagInput|OPFL_FlagOutput|OPFL_MemRefs,
                            0/*#VTs*/, 6/*#Ops*/, 5, 6, 7, 8, 9, 10, 
                        // Src: (st:isVoid (sube:i32 (ld:i32 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:i32)<<P:Predicate_immSext8>>:$src2), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                        // Dst: (SBB32mi8:isVoid addr:iPTR:$dst, (imm:i32):$src2)
                      /*SwitchType*/ 34,  MVT::i64,// ->10106
/*10072*/               OPC_MoveParent,
/*10073*/               OPC_MoveChild, 2,
/*10075*/               OPC_CheckSame, 3,
/*10077*/               OPC_MoveParent,
/*10078*/               OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*10080*/               OPC_CheckPredicate, 5, // Predicate_store
/*10082*/               OPC_CheckComplexPat, /*CP*/0, /*#*/3, // SelectAddr:$dst #5 #6 #7 #8 #9
/*10085*/               OPC_EmitMergeInputChains, 2, 0, 2, 
/*10089*/               OPC_EmitConvertToTarget, 4,
/*10091*/               OPC_MarkFlagResults, 1, 1, 
/*10094*/               OPC_MorphNodeTo, TARGET_OPCODE(X86::SBB64mi8), 0|OPFL_Chain|OPFL_FlagInput|OPFL_FlagOutput|OPFL_MemRefs,
                            0/*#VTs*/, 6/*#Ops*/, 5, 6, 7, 8, 9, 10, 
                        // Src: (st:isVoid (sube:i64 (ld:i64 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:i64)<<P:Predicate_immSext8>>:$src2), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                        // Dst: (SBB64mi8:isVoid addr:iPTR:$dst, (imm:i64):$src2)
                      0, // EndSwitchType
/*10107*/           /*Scope*/ 39, /*->10147*/
/*10108*/             OPC_CheckPredicate, 12, // Predicate_i64immSExt32
/*10110*/             OPC_MoveParent,
/*10111*/             OPC_CheckType, MVT::i64,
/*10113*/             OPC_MoveParent,
/*10114*/             OPC_MoveChild, 2,
/*10116*/             OPC_CheckSame, 3,
/*10118*/             OPC_MoveParent,
/*10119*/             OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*10121*/             OPC_CheckPredicate, 5, // Predicate_store
/*10123*/             OPC_CheckComplexPat, /*CP*/0, /*#*/3, // SelectAddr:$dst #5 #6 #7 #8 #9
/*10126*/             OPC_EmitMergeInputChains, 2, 0, 2, 
/*10130*/             OPC_EmitConvertToTarget, 4,
/*10132*/             OPC_MarkFlagResults, 1, 1, 
/*10135*/             OPC_MorphNodeTo, TARGET_OPCODE(X86::SBB64mi32), 0|OPFL_Chain|OPFL_FlagInput|OPFL_FlagOutput|OPFL_MemRefs,
                          0/*#VTs*/, 6/*#Ops*/, 5, 6, 7, 8, 9, 10, 
                      // Src: (st:isVoid (sube:i64 (ld:i64 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:i64)<<P:Predicate_i64immSExt32>>:$src2), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                      // Dst: (SBB64mi32:isVoid addr:iPTR:$dst, (imm:i64):$src2)
/*10147*/           0, /*End of Scope*/
/*10148*/         /*Scope*/ 45, /*->10194*/
/*10149*/           OPC_CheckPredicate, 9, // Predicate_dsload
/*10151*/           OPC_MoveParent,
/*10152*/           OPC_RecordChild1, // #4 = $src2
/*10153*/           OPC_MoveChild, 1,
/*10155*/           OPC_CheckOpcode, ISD::Constant,
/*10157*/           OPC_MoveParent,
/*10158*/           OPC_CheckType, MVT::i8,
/*10160*/           OPC_MoveParent,
/*10161*/           OPC_MoveChild, 2,
/*10163*/           OPC_CheckSame, 3,
/*10165*/           OPC_MoveParent,
/*10166*/           OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*10168*/           OPC_CheckPredicate, 5, // Predicate_store
/*10170*/           OPC_CheckComplexPat, /*CP*/0, /*#*/3, // SelectAddr:$dst #5 #6 #7 #8 #9
/*10173*/           OPC_EmitMergeInputChains, 2, 0, 2, 
/*10177*/           OPC_EmitConvertToTarget, 4,
/*10179*/           OPC_MarkFlagResults, 1, 1, 
/*10182*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::SBB8mi), 0|OPFL_Chain|OPFL_FlagInput|OPFL_FlagOutput|OPFL_MemRefs,
                        0/*#VTs*/, 6/*#Ops*/, 5, 6, 7, 8, 9, 10, 
                    // Src: (st:isVoid (sube:i8 (ld:i8 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>, (imm:i8):$src2), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                    // Dst: (SBB8mi:isVoid addr:iPTR:$dst, (imm:i8):$src2)
/*10194*/         0, /*End of Scope*/
/*10195*/       /*Scope*/ 45, /*->10241*/
/*10196*/         OPC_CheckPredicate, 6, // Predicate_loadi16
/*10198*/         OPC_MoveParent,
/*10199*/         OPC_RecordChild1, // #4 = $src2
/*10200*/         OPC_MoveChild, 1,
/*10202*/         OPC_CheckOpcode, ISD::Constant,
/*10204*/         OPC_MoveParent,
/*10205*/         OPC_CheckType, MVT::i16,
/*10207*/         OPC_MoveParent,
/*10208*/         OPC_MoveChild, 2,
/*10210*/         OPC_CheckSame, 3,
/*10212*/         OPC_MoveParent,
/*10213*/         OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*10215*/         OPC_CheckPredicate, 5, // Predicate_store
/*10217*/         OPC_CheckComplexPat, /*CP*/0, /*#*/3, // SelectAddr:$dst #5 #6 #7 #8 #9
/*10220*/         OPC_EmitMergeInputChains, 2, 0, 2, 
/*10224*/         OPC_EmitConvertToTarget, 4,
/*10226*/         OPC_MarkFlagResults, 1, 1, 
/*10229*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::SBB16mi), 0|OPFL_Chain|OPFL_FlagInput|OPFL_FlagOutput|OPFL_MemRefs,
                      0/*#VTs*/, 6/*#Ops*/, 5, 6, 7, 8, 9, 10, 
                  // Src: (st:isVoid (sube:i16 (ld:i16 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, (imm:i16):$src2), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                  // Dst: (SBB16mi:isVoid addr:iPTR:$dst, (imm:i16):$src2)
/*10241*/       /*Scope*/ 45, /*->10287*/
/*10242*/         OPC_CheckPredicate, 3, // Predicate_loadi32
/*10244*/         OPC_MoveParent,
/*10245*/         OPC_RecordChild1, // #4 = $src2
/*10246*/         OPC_MoveChild, 1,
/*10248*/         OPC_CheckOpcode, ISD::Constant,
/*10250*/         OPC_MoveParent,
/*10251*/         OPC_CheckType, MVT::i32,
/*10253*/         OPC_MoveParent,
/*10254*/         OPC_MoveChild, 2,
/*10256*/         OPC_CheckSame, 3,
/*10258*/         OPC_MoveParent,
/*10259*/         OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*10261*/         OPC_CheckPredicate, 5, // Predicate_store
/*10263*/         OPC_CheckComplexPat, /*CP*/0, /*#*/3, // SelectAddr:$dst #5 #6 #7 #8 #9
/*10266*/         OPC_EmitMergeInputChains, 2, 0, 2, 
/*10270*/         OPC_EmitConvertToTarget, 4,
/*10272*/         OPC_MarkFlagResults, 1, 1, 
/*10275*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::SBB32mi), 0|OPFL_Chain|OPFL_FlagInput|OPFL_FlagOutput|OPFL_MemRefs,
                      0/*#VTs*/, 6/*#Ops*/, 5, 6, 7, 8, 9, 10, 
                  // Src: (st:isVoid (sube:i32 (ld:i32 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, (imm:i32):$src2), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                  // Dst: (SBB32mi:isVoid addr:iPTR:$dst, (imm:i32):$src2)
/*10287*/       /*Scope*/ 14|128,1/*142*/, /*->10431*/
/*10289*/         OPC_CheckPredicate, 8, // Predicate_load
/*10291*/         OPC_MoveParent,
/*10292*/         OPC_RecordChild1, // #4 = $src2
/*10293*/         OPC_SwitchType /*4 cases */, 32,  MVT::i8,// ->10328
/*10296*/           OPC_MoveParent,
/*10297*/           OPC_MoveChild, 2,
/*10299*/           OPC_CheckSame, 3,
/*10301*/           OPC_MoveParent,
/*10302*/           OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*10304*/           OPC_CheckPredicate, 5, // Predicate_store
/*10306*/           OPC_CheckComplexPat, /*CP*/0, /*#*/3, // SelectAddr:$dst #5 #6 #7 #8 #9
/*10309*/           OPC_EmitMergeInputChains, 2, 0, 2, 
/*10313*/           OPC_MarkFlagResults, 1, 1, 
/*10316*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::SBB8mr), 0|OPFL_Chain|OPFL_FlagInput|OPFL_FlagOutput|OPFL_MemRefs,
                        0/*#VTs*/, 6/*#Ops*/, 5, 6, 7, 8, 9, 4, 
                    // Src: (st:isVoid (sube:i8 (ld:i8 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR8:i8:$src2), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                    // Dst: (SBB8mr:isVoid addr:iPTR:$dst, GR8:i8:$src2)
                  /*SwitchType*/ 32,  MVT::i16,// ->10362
/*10330*/           OPC_MoveParent,
/*10331*/           OPC_MoveChild, 2,
/*10333*/           OPC_CheckSame, 3,
/*10335*/           OPC_MoveParent,
/*10336*/           OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*10338*/           OPC_CheckPredicate, 5, // Predicate_store
/*10340*/           OPC_CheckComplexPat, /*CP*/0, /*#*/3, // SelectAddr:$dst #5 #6 #7 #8 #9
/*10343*/           OPC_EmitMergeInputChains, 2, 0, 2, 
/*10347*/           OPC_MarkFlagResults, 1, 1, 
/*10350*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::SBB16mr), 0|OPFL_Chain|OPFL_FlagInput|OPFL_FlagOutput|OPFL_MemRefs,
                        0/*#VTs*/, 6/*#Ops*/, 5, 6, 7, 8, 9, 4, 
                    // Src: (st:isVoid (sube:i16 (ld:i16 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR16:i16:$src2), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                    // Dst: (SBB16mr:isVoid addr:iPTR:$dst, GR16:i16:$src2)
                  /*SwitchType*/ 32,  MVT::i32,// ->10396
/*10364*/           OPC_MoveParent,
/*10365*/           OPC_MoveChild, 2,
/*10367*/           OPC_CheckSame, 3,
/*10369*/           OPC_MoveParent,
/*10370*/           OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*10372*/           OPC_CheckPredicate, 5, // Predicate_store
/*10374*/           OPC_CheckComplexPat, /*CP*/0, /*#*/3, // SelectAddr:$dst #5 #6 #7 #8 #9
/*10377*/           OPC_EmitMergeInputChains, 2, 0, 2, 
/*10381*/           OPC_MarkFlagResults, 1, 1, 
/*10384*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::SBB32mr), 0|OPFL_Chain|OPFL_FlagInput|OPFL_FlagOutput|OPFL_MemRefs,
                        0/*#VTs*/, 6/*#Ops*/, 5, 6, 7, 8, 9, 4, 
                    // Src: (st:isVoid (sube:i32 (ld:i32 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR32:i32:$src2), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                    // Dst: (SBB32mr:isVoid addr:iPTR:$dst, GR32:i32:$src2)
                  /*SwitchType*/ 32,  MVT::i64,// ->10430
/*10398*/           OPC_MoveParent,
/*10399*/           OPC_MoveChild, 2,
/*10401*/           OPC_CheckSame, 3,
/*10403*/           OPC_MoveParent,
/*10404*/           OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*10406*/           OPC_CheckPredicate, 5, // Predicate_store
/*10408*/           OPC_CheckComplexPat, /*CP*/0, /*#*/3, // SelectAddr:$dst #5 #6 #7 #8 #9
/*10411*/           OPC_EmitMergeInputChains, 2, 0, 2, 
/*10415*/           OPC_MarkFlagResults, 1, 1, 
/*10418*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::SBB64mr), 0|OPFL_Chain|OPFL_FlagInput|OPFL_FlagOutput|OPFL_MemRefs,
                        0/*#VTs*/, 6/*#Ops*/, 5, 6, 7, 8, 9, 4, 
                    // Src: (st:isVoid (sube:i64 (ld:i64 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR64:i64:$src2), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                    // Dst: (SBB64mr:isVoid addr:iPTR:$dst, GR64:i64:$src2)
                  0, // EndSwitchType
/*10431*/       0, /*End of Scope*/
              /*SwitchOpcode*/ 124|128,4/*636*/,  X86ISD::ADD,// ->11071
/*10435*/       OPC_Scope, 85|128,3/*469*/, /*->10907*/ // 2 children in Scope
/*10438*/         OPC_MoveChild, 0,
/*10440*/         OPC_CheckOpcode, ISD::LOAD,
/*10442*/         OPC_RecordMemRef,
/*10443*/         OPC_RecordNode, // #1 = 'ld' chained node
/*10444*/         OPC_CheckFoldableChainNode,
/*10445*/         OPC_RecordChild1, // #2 = $dst
/*10446*/         OPC_CheckPredicate, 2, // Predicate_unindexedload
/*10448*/         OPC_Scope, 45, /*->10495*/ // 9 children in Scope
/*10450*/           OPC_CheckPredicate, 6, // Predicate_loadi16
/*10452*/           OPC_MoveParent,
/*10453*/           OPC_RecordChild1, // #3 = $src2
/*10454*/           OPC_MoveChild, 1,
/*10456*/           OPC_CheckOpcode, ISD::Constant,
/*10458*/           OPC_CheckPredicate, 11, // Predicate_immSext8
/*10460*/           OPC_MoveParent,
/*10461*/           OPC_CheckType, MVT::i16,
/*10463*/           OPC_MoveParent,
/*10464*/           OPC_MoveChild, 2,
/*10466*/           OPC_CheckSame, 2,
/*10468*/           OPC_MoveParent,
/*10469*/           OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*10471*/           OPC_CheckPredicate, 5, // Predicate_store
/*10473*/           OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #4 #5 #6 #7 #8
/*10476*/           OPC_EmitMergeInputChains, 2, 0, 1, 
/*10480*/           OPC_EmitConvertToTarget, 3,
/*10482*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::ADD16mi8), 0|OPFL_Chain|OPFL_MemRefs,
                        1/*#VTs*/, MVT::i32, 6/*#Ops*/, 4, 5, 6, 7, 8, 9, 
                    // Src: (st:isVoid (X86add_flag:i16 (ld:i16 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, (imm:i16)<<P:Predicate_immSext8>>:$src2), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                    // Dst: (ADD16mi8:isVoid addr:iPTR:$dst, (imm:i16)<<P:Predicate_immSext8>>:$src2)
/*10495*/         /*Scope*/ 45, /*->10541*/
/*10496*/           OPC_CheckPredicate, 3, // Predicate_loadi32
/*10498*/           OPC_MoveParent,
/*10499*/           OPC_RecordChild1, // #3 = $src2
/*10500*/           OPC_MoveChild, 1,
/*10502*/           OPC_CheckOpcode, ISD::Constant,
/*10504*/           OPC_CheckPredicate, 11, // Predicate_immSext8
/*10506*/           OPC_MoveParent,
/*10507*/           OPC_CheckType, MVT::i32,
/*10509*/           OPC_MoveParent,
/*10510*/           OPC_MoveChild, 2,
/*10512*/           OPC_CheckSame, 2,
/*10514*/           OPC_MoveParent,
/*10515*/           OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*10517*/           OPC_CheckPredicate, 5, // Predicate_store
/*10519*/           OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #4 #5 #6 #7 #8
/*10522*/           OPC_EmitMergeInputChains, 2, 0, 1, 
/*10526*/           OPC_EmitConvertToTarget, 3,
/*10528*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::ADD32mi8), 0|OPFL_Chain|OPFL_MemRefs,
                        1/*#VTs*/, MVT::i32, 6/*#Ops*/, 4, 5, 6, 7, 8, 9, 
                    // Src: (st:isVoid (X86add_flag:i32 (ld:i32 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, (imm:i32)<<P:Predicate_immSext8>>:$src2), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                    // Dst: (ADD32mi8:isVoid addr:iPTR:$dst, (imm:i32)<<P:Predicate_immSext8>>:$src2)
/*10541*/         /*Scope*/ 124, /*->10666*/
/*10542*/           OPC_CheckPredicate, 8, // Predicate_load
/*10544*/           OPC_CheckPredicate, 9, // Predicate_dsload
/*10546*/           OPC_MoveParent,
/*10547*/           OPC_RecordChild1, // #3 = $src2
/*10548*/           OPC_MoveChild, 1,
/*10550*/           OPC_CheckOpcode, ISD::Constant,
/*10552*/           OPC_Scope, 37, /*->10591*/ // 3 children in Scope
/*10554*/             OPC_CheckPredicate, 11, // Predicate_immSext8
/*10556*/             OPC_MoveParent,
/*10557*/             OPC_CheckType, MVT::i64,
/*10559*/             OPC_MoveParent,
/*10560*/             OPC_MoveChild, 2,
/*10562*/             OPC_CheckSame, 2,
/*10564*/             OPC_MoveParent,
/*10565*/             OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*10567*/             OPC_CheckPredicate, 5, // Predicate_store
/*10569*/             OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #4 #5 #6 #7 #8
/*10572*/             OPC_EmitMergeInputChains, 2, 0, 1, 
/*10576*/             OPC_EmitConvertToTarget, 3,
/*10578*/             OPC_MorphNodeTo, TARGET_OPCODE(X86::ADD64mi8), 0|OPFL_Chain|OPFL_MemRefs,
                          1/*#VTs*/, MVT::i32, 6/*#Ops*/, 4, 5, 6, 7, 8, 9, 
                      // Src: (st:isVoid (X86add_flag:i64 (ld:i64 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>, (imm:i64)<<P:Predicate_immSext8>>:$src2), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                      // Dst: (ADD64mi8:isVoid addr:iPTR:$dst, (imm:i64)<<P:Predicate_immSext8>>:$src2)
/*10591*/           /*Scope*/ 37, /*->10629*/
/*10592*/             OPC_CheckPredicate, 12, // Predicate_i64immSExt32
/*10594*/             OPC_MoveParent,
/*10595*/             OPC_CheckType, MVT::i64,
/*10597*/             OPC_MoveParent,
/*10598*/             OPC_MoveChild, 2,
/*10600*/             OPC_CheckSame, 2,
/*10602*/             OPC_MoveParent,
/*10603*/             OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*10605*/             OPC_CheckPredicate, 5, // Predicate_store
/*10607*/             OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #4 #5 #6 #7 #8
/*10610*/             OPC_EmitMergeInputChains, 2, 0, 1, 
/*10614*/             OPC_EmitConvertToTarget, 3,
/*10616*/             OPC_MorphNodeTo, TARGET_OPCODE(X86::ADD64mi32), 0|OPFL_Chain|OPFL_MemRefs,
                          1/*#VTs*/, MVT::i32, 6/*#Ops*/, 4, 5, 6, 7, 8, 9, 
                      // Src: (st:isVoid (X86add_flag:i64 (ld:i64 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>, (imm:i64)<<P:Predicate_i64immSExt32>>:$src2), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                      // Dst: (ADD64mi32:isVoid addr:iPTR:$dst, (imm:i64)<<P:Predicate_i64immSExt32>>:$src2)
/*10629*/           /*Scope*/ 35, /*->10665*/
/*10630*/             OPC_MoveParent,
/*10631*/             OPC_CheckType, MVT::i8,
/*10633*/             OPC_MoveParent,
/*10634*/             OPC_MoveChild, 2,
/*10636*/             OPC_CheckSame, 2,
/*10638*/             OPC_MoveParent,
/*10639*/             OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*10641*/             OPC_CheckPredicate, 5, // Predicate_store
/*10643*/             OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #4 #5 #6 #7 #8
/*10646*/             OPC_EmitMergeInputChains, 2, 0, 1, 
/*10650*/             OPC_EmitConvertToTarget, 3,
/*10652*/             OPC_MorphNodeTo, TARGET_OPCODE(X86::ADD8mi), 0|OPFL_Chain|OPFL_MemRefs,
                          1/*#VTs*/, MVT::i32, 6/*#Ops*/, 4, 5, 6, 7, 8, 9, 
                      // Src: (st:isVoid (X86add_flag:i8 (ld:i8 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>, (imm:i8):$src2), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                      // Dst: (ADD8mi:isVoid addr:iPTR:$dst, (imm:i8):$src2)
/*10665*/           0, /*End of Scope*/
/*10666*/         /*Scope*/ 43, /*->10710*/
/*10667*/           OPC_CheckPredicate, 6, // Predicate_loadi16
/*10669*/           OPC_MoveParent,
/*10670*/           OPC_RecordChild1, // #3 = $src2
/*10671*/           OPC_MoveChild, 1,
/*10673*/           OPC_CheckOpcode, ISD::Constant,
/*10675*/           OPC_MoveParent,
/*10676*/           OPC_CheckType, MVT::i16,
/*10678*/           OPC_MoveParent,
/*10679*/           OPC_MoveChild, 2,
/*10681*/           OPC_CheckSame, 2,
/*10683*/           OPC_MoveParent,
/*10684*/           OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*10686*/           OPC_CheckPredicate, 5, // Predicate_store
/*10688*/           OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #4 #5 #6 #7 #8
/*10691*/           OPC_EmitMergeInputChains, 2, 0, 1, 
/*10695*/           OPC_EmitConvertToTarget, 3,
/*10697*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::ADD16mi), 0|OPFL_Chain|OPFL_MemRefs,
                        1/*#VTs*/, MVT::i32, 6/*#Ops*/, 4, 5, 6, 7, 8, 9, 
                    // Src: (st:isVoid (X86add_flag:i16 (ld:i16 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, (imm:i16):$src2), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                    // Dst: (ADD16mi:isVoid addr:iPTR:$dst, (imm:i16):$src2)
/*10710*/         /*Scope*/ 43, /*->10754*/
/*10711*/           OPC_CheckPredicate, 3, // Predicate_loadi32
/*10713*/           OPC_MoveParent,
/*10714*/           OPC_RecordChild1, // #3 = $src2
/*10715*/           OPC_MoveChild, 1,
/*10717*/           OPC_CheckOpcode, ISD::Constant,
/*10719*/           OPC_MoveParent,
/*10720*/           OPC_CheckType, MVT::i32,
/*10722*/           OPC_MoveParent,
/*10723*/           OPC_MoveChild, 2,
/*10725*/           OPC_CheckSame, 2,
/*10727*/           OPC_MoveParent,
/*10728*/           OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*10730*/           OPC_CheckPredicate, 5, // Predicate_store
/*10732*/           OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #4 #5 #6 #7 #8
/*10735*/           OPC_EmitMergeInputChains, 2, 0, 1, 
/*10739*/           OPC_EmitConvertToTarget, 3,
/*10741*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::ADD32mi), 0|OPFL_Chain|OPFL_MemRefs,
                        1/*#VTs*/, MVT::i32, 6/*#Ops*/, 4, 5, 6, 7, 8, 9, 
                    // Src: (st:isVoid (X86add_flag:i32 (ld:i32 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, (imm:i32):$src2), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                    // Dst: (ADD32mi:isVoid addr:iPTR:$dst, (imm:i32):$src2)
/*10754*/         /*Scope*/ 38, /*->10793*/
/*10755*/           OPC_CheckPredicate, 8, // Predicate_load
/*10757*/           OPC_CheckPredicate, 9, // Predicate_dsload
/*10759*/           OPC_MoveParent,
/*10760*/           OPC_RecordChild1, // #3 = $src2
/*10761*/           OPC_CheckType, MVT::i8,
/*10763*/           OPC_MoveParent,
/*10764*/           OPC_MoveChild, 2,
/*10766*/           OPC_CheckSame, 2,
/*10768*/           OPC_MoveParent,
/*10769*/           OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*10771*/           OPC_CheckPredicate, 5, // Predicate_store
/*10773*/           OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #4 #5 #6 #7 #8
/*10776*/           OPC_EmitMergeInputChains, 2, 0, 1, 
/*10780*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::ADD8mr), 0|OPFL_Chain|OPFL_MemRefs,
                        1/*#VTs*/, MVT::i32, 6/*#Ops*/, 4, 5, 6, 7, 8, 3, 
                    // Src: (st:isVoid (X86add_flag:i8 (ld:i8 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>, GR8:i8:$src2), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                    // Dst: (ADD8mr:isVoid addr:iPTR:$dst, GR8:i8:$src2)
/*10793*/         /*Scope*/ 36, /*->10830*/
/*10794*/           OPC_CheckPredicate, 6, // Predicate_loadi16
/*10796*/           OPC_MoveParent,
/*10797*/           OPC_RecordChild1, // #3 = $src2
/*10798*/           OPC_CheckType, MVT::i16,
/*10800*/           OPC_MoveParent,
/*10801*/           OPC_MoveChild, 2,
/*10803*/           OPC_CheckSame, 2,
/*10805*/           OPC_MoveParent,
/*10806*/           OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*10808*/           OPC_CheckPredicate, 5, // Predicate_store
/*10810*/           OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #4 #5 #6 #7 #8
/*10813*/           OPC_EmitMergeInputChains, 2, 0, 1, 
/*10817*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::ADD16mr), 0|OPFL_Chain|OPFL_MemRefs,
                        1/*#VTs*/, MVT::i32, 6/*#Ops*/, 4, 5, 6, 7, 8, 3, 
                    // Src: (st:isVoid (X86add_flag:i16 (ld:i16 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, GR16:i16:$src2), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                    // Dst: (ADD16mr:isVoid addr:iPTR:$dst, GR16:i16:$src2)
/*10830*/         /*Scope*/ 36, /*->10867*/
/*10831*/           OPC_CheckPredicate, 3, // Predicate_loadi32
/*10833*/           OPC_MoveParent,
/*10834*/           OPC_RecordChild1, // #3 = $src2
/*10835*/           OPC_CheckType, MVT::i32,
/*10837*/           OPC_MoveParent,
/*10838*/           OPC_MoveChild, 2,
/*10840*/           OPC_CheckSame, 2,
/*10842*/           OPC_MoveParent,
/*10843*/           OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*10845*/           OPC_CheckPredicate, 5, // Predicate_store
/*10847*/           OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #4 #5 #6 #7 #8
/*10850*/           OPC_EmitMergeInputChains, 2, 0, 1, 
/*10854*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::ADD32mr), 0|OPFL_Chain|OPFL_MemRefs,
                        1/*#VTs*/, MVT::i32, 6/*#Ops*/, 4, 5, 6, 7, 8, 3, 
                    // Src: (st:isVoid (X86add_flag:i32 (ld:i32 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, GR32:i32:$src2), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                    // Dst: (ADD32mr:isVoid addr:iPTR:$dst, GR32:i32:$src2)
/*10867*/         /*Scope*/ 38, /*->10906*/
/*10868*/           OPC_CheckPredicate, 8, // Predicate_load
/*10870*/           OPC_CheckPredicate, 9, // Predicate_dsload
/*10872*/           OPC_MoveParent,
/*10873*/           OPC_RecordChild1, // #3 = $src2
/*10874*/           OPC_CheckType, MVT::i64,
/*10876*/           OPC_MoveParent,
/*10877*/           OPC_MoveChild, 2,
/*10879*/           OPC_CheckSame, 2,
/*10881*/           OPC_MoveParent,
/*10882*/           OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*10884*/           OPC_CheckPredicate, 5, // Predicate_store
/*10886*/           OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #4 #5 #6 #7 #8
/*10889*/           OPC_EmitMergeInputChains, 2, 0, 1, 
/*10893*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::ADD64mr), 0|OPFL_Chain|OPFL_MemRefs,
                        1/*#VTs*/, MVT::i32, 6/*#Ops*/, 4, 5, 6, 7, 8, 3, 
                    // Src: (st:isVoid (X86add_flag:i64 (ld:i64 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>, GR64:i64:$src2), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                    // Dst: (ADD64mr:isVoid addr:iPTR:$dst, GR64:i64:$src2)
/*10906*/         0, /*End of Scope*/
/*10907*/       /*Scope*/ 33|128,1/*161*/, /*->11070*/
/*10909*/         OPC_RecordChild0, // #1 = $src2
/*10910*/         OPC_MoveChild, 1,
/*10912*/         OPC_CheckOpcode, ISD::LOAD,
/*10914*/         OPC_RecordMemRef,
/*10915*/         OPC_RecordNode, // #2 = 'ld' chained node
/*10916*/         OPC_CheckFoldableChainNode,
/*10917*/         OPC_RecordChild1, // #3 = $dst
/*10918*/         OPC_CheckPredicate, 2, // Predicate_unindexedload
/*10920*/         OPC_Scope, 37, /*->10959*/ // 4 children in Scope
/*10922*/           OPC_CheckPredicate, 8, // Predicate_load
/*10924*/           OPC_CheckPredicate, 9, // Predicate_dsload
/*10926*/           OPC_MoveParent,
/*10927*/           OPC_CheckType, MVT::i8,
/*10929*/           OPC_MoveParent,
/*10930*/           OPC_MoveChild, 2,
/*10932*/           OPC_CheckSame, 3,
/*10934*/           OPC_MoveParent,
/*10935*/           OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*10937*/           OPC_CheckPredicate, 5, // Predicate_store
/*10939*/           OPC_CheckComplexPat, /*CP*/0, /*#*/3, // SelectAddr:$dst #4 #5 #6 #7 #8
/*10942*/           OPC_EmitMergeInputChains, 2, 0, 2, 
/*10946*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::ADD8mr), 0|OPFL_Chain|OPFL_MemRefs,
                        1/*#VTs*/, MVT::i32, 6/*#Ops*/, 4, 5, 6, 7, 8, 1, 
                    // Src: (st:isVoid (X86add_flag:i8 GR8:i8:$src2, (ld:i8 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                    // Dst: (ADD8mr:isVoid addr:iPTR:$dst, GR8:i8:$src2)
/*10959*/         /*Scope*/ 35, /*->10995*/
/*10960*/           OPC_CheckPredicate, 6, // Predicate_loadi16
/*10962*/           OPC_MoveParent,
/*10963*/           OPC_CheckType, MVT::i16,
/*10965*/           OPC_MoveParent,
/*10966*/           OPC_MoveChild, 2,
/*10968*/           OPC_CheckSame, 3,
/*10970*/           OPC_MoveParent,
/*10971*/           OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*10973*/           OPC_CheckPredicate, 5, // Predicate_store
/*10975*/           OPC_CheckComplexPat, /*CP*/0, /*#*/3, // SelectAddr:$dst #4 #5 #6 #7 #8
/*10978*/           OPC_EmitMergeInputChains, 2, 0, 2, 
/*10982*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::ADD16mr), 0|OPFL_Chain|OPFL_MemRefs,
                        1/*#VTs*/, MVT::i32, 6/*#Ops*/, 4, 5, 6, 7, 8, 1, 
                    // Src: (st:isVoid (X86add_flag:i16 GR16:i16:$src2, (ld:i16 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                    // Dst: (ADD16mr:isVoid addr:iPTR:$dst, GR16:i16:$src2)
/*10995*/         /*Scope*/ 35, /*->11031*/
/*10996*/           OPC_CheckPredicate, 3, // Predicate_loadi32
/*10998*/           OPC_MoveParent,
/*10999*/           OPC_CheckType, MVT::i32,
/*11001*/           OPC_MoveParent,
/*11002*/           OPC_MoveChild, 2,
/*11004*/           OPC_CheckSame, 3,
/*11006*/           OPC_MoveParent,
/*11007*/           OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*11009*/           OPC_CheckPredicate, 5, // Predicate_store
/*11011*/           OPC_CheckComplexPat, /*CP*/0, /*#*/3, // SelectAddr:$dst #4 #5 #6 #7 #8
/*11014*/           OPC_EmitMergeInputChains, 2, 0, 2, 
/*11018*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::ADD32mr), 0|OPFL_Chain|OPFL_MemRefs,
                        1/*#VTs*/, MVT::i32, 6/*#Ops*/, 4, 5, 6, 7, 8, 1, 
                    // Src: (st:isVoid (X86add_flag:i32 GR32:i32:$src2, (ld:i32 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                    // Dst: (ADD32mr:isVoid addr:iPTR:$dst, GR32:i32:$src2)
/*11031*/         /*Scope*/ 37, /*->11069*/
/*11032*/           OPC_CheckPredicate, 8, // Predicate_load
/*11034*/           OPC_CheckPredicate, 9, // Predicate_dsload
/*11036*/           OPC_MoveParent,
/*11037*/           OPC_CheckType, MVT::i64,
/*11039*/           OPC_MoveParent,
/*11040*/           OPC_MoveChild, 2,
/*11042*/           OPC_CheckSame, 3,
/*11044*/           OPC_MoveParent,
/*11045*/           OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*11047*/           OPC_CheckPredicate, 5, // Predicate_store
/*11049*/           OPC_CheckComplexPat, /*CP*/0, /*#*/3, // SelectAddr:$dst #4 #5 #6 #7 #8
/*11052*/           OPC_EmitMergeInputChains, 2, 0, 2, 
/*11056*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::ADD64mr), 0|OPFL_Chain|OPFL_MemRefs,
                        1/*#VTs*/, MVT::i32, 6/*#Ops*/, 4, 5, 6, 7, 8, 1, 
                    // Src: (st:isVoid (X86add_flag:i64 GR64:i64:$src2, (ld:i64 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                    // Dst: (ADD64mr:isVoid addr:iPTR:$dst, GR64:i64:$src2)
/*11069*/         0, /*End of Scope*/
/*11070*/       0, /*End of Scope*/
              /*SwitchOpcode*/ 85|128,3/*469*/,  X86ISD::SUB,// ->11543
/*11074*/       OPC_MoveChild, 0,
/*11076*/       OPC_CheckOpcode, ISD::LOAD,
/*11078*/       OPC_RecordMemRef,
/*11079*/       OPC_RecordNode, // #1 = 'ld' chained node
/*11080*/       OPC_CheckFoldableChainNode,
/*11081*/       OPC_RecordChild1, // #2 = $dst
/*11082*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*11084*/       OPC_Scope, 45, /*->11131*/ // 9 children in Scope
/*11086*/         OPC_CheckPredicate, 6, // Predicate_loadi16
/*11088*/         OPC_MoveParent,
/*11089*/         OPC_RecordChild1, // #3 = $src2
/*11090*/         OPC_MoveChild, 1,
/*11092*/         OPC_CheckOpcode, ISD::Constant,
/*11094*/         OPC_CheckPredicate, 11, // Predicate_immSext8
/*11096*/         OPC_MoveParent,
/*11097*/         OPC_CheckType, MVT::i16,
/*11099*/         OPC_MoveParent,
/*11100*/         OPC_MoveChild, 2,
/*11102*/         OPC_CheckSame, 2,
/*11104*/         OPC_MoveParent,
/*11105*/         OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*11107*/         OPC_CheckPredicate, 5, // Predicate_store
/*11109*/         OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #4 #5 #6 #7 #8
/*11112*/         OPC_EmitMergeInputChains, 2, 0, 1, 
/*11116*/         OPC_EmitConvertToTarget, 3,
/*11118*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::SUB16mi8), 0|OPFL_Chain|OPFL_MemRefs,
                      1/*#VTs*/, MVT::i32, 6/*#Ops*/, 4, 5, 6, 7, 8, 9, 
                  // Src: (st:isVoid (X86sub_flag:i16 (ld:i16 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, (imm:i16)<<P:Predicate_immSext8>>:$src2), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                  // Dst: (SUB16mi8:isVoid addr:iPTR:$dst, (imm:i16)<<P:Predicate_immSext8>>:$src2)
/*11131*/       /*Scope*/ 45, /*->11177*/
/*11132*/         OPC_CheckPredicate, 3, // Predicate_loadi32
/*11134*/         OPC_MoveParent,
/*11135*/         OPC_RecordChild1, // #3 = $src2
/*11136*/         OPC_MoveChild, 1,
/*11138*/         OPC_CheckOpcode, ISD::Constant,
/*11140*/         OPC_CheckPredicate, 11, // Predicate_immSext8
/*11142*/         OPC_MoveParent,
/*11143*/         OPC_CheckType, MVT::i32,
/*11145*/         OPC_MoveParent,
/*11146*/         OPC_MoveChild, 2,
/*11148*/         OPC_CheckSame, 2,
/*11150*/         OPC_MoveParent,
/*11151*/         OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*11153*/         OPC_CheckPredicate, 5, // Predicate_store
/*11155*/         OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #4 #5 #6 #7 #8
/*11158*/         OPC_EmitMergeInputChains, 2, 0, 1, 
/*11162*/         OPC_EmitConvertToTarget, 3,
/*11164*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::SUB32mi8), 0|OPFL_Chain|OPFL_MemRefs,
                      1/*#VTs*/, MVT::i32, 6/*#Ops*/, 4, 5, 6, 7, 8, 9, 
                  // Src: (st:isVoid (X86sub_flag:i32 (ld:i32 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, (imm:i32)<<P:Predicate_immSext8>>:$src2), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                  // Dst: (SUB32mi8:isVoid addr:iPTR:$dst, (imm:i32)<<P:Predicate_immSext8>>:$src2)
/*11177*/       /*Scope*/ 124, /*->11302*/
/*11178*/         OPC_CheckPredicate, 8, // Predicate_load
/*11180*/         OPC_CheckPredicate, 9, // Predicate_dsload
/*11182*/         OPC_MoveParent,
/*11183*/         OPC_RecordChild1, // #3 = $src2
/*11184*/         OPC_MoveChild, 1,
/*11186*/         OPC_CheckOpcode, ISD::Constant,
/*11188*/         OPC_Scope, 37, /*->11227*/ // 3 children in Scope
/*11190*/           OPC_CheckPredicate, 11, // Predicate_immSext8
/*11192*/           OPC_MoveParent,
/*11193*/           OPC_CheckType, MVT::i64,
/*11195*/           OPC_MoveParent,
/*11196*/           OPC_MoveChild, 2,
/*11198*/           OPC_CheckSame, 2,
/*11200*/           OPC_MoveParent,
/*11201*/           OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*11203*/           OPC_CheckPredicate, 5, // Predicate_store
/*11205*/           OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #4 #5 #6 #7 #8
/*11208*/           OPC_EmitMergeInputChains, 2, 0, 1, 
/*11212*/           OPC_EmitConvertToTarget, 3,
/*11214*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::SUB64mi8), 0|OPFL_Chain|OPFL_MemRefs,
                        1/*#VTs*/, MVT::i32, 6/*#Ops*/, 4, 5, 6, 7, 8, 9, 
                    // Src: (st:isVoid (X86sub_flag:i64 (ld:i64 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>, (imm:i64)<<P:Predicate_immSext8>>:$src2), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                    // Dst: (SUB64mi8:isVoid addr:iPTR:$dst, (imm:i64)<<P:Predicate_immSext8>>:$src2)
/*11227*/         /*Scope*/ 37, /*->11265*/
/*11228*/           OPC_CheckPredicate, 12, // Predicate_i64immSExt32
/*11230*/           OPC_MoveParent,
/*11231*/           OPC_CheckType, MVT::i64,
/*11233*/           OPC_MoveParent,
/*11234*/           OPC_MoveChild, 2,
/*11236*/           OPC_CheckSame, 2,
/*11238*/           OPC_MoveParent,
/*11239*/           OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*11241*/           OPC_CheckPredicate, 5, // Predicate_store
/*11243*/           OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #4 #5 #6 #7 #8
/*11246*/           OPC_EmitMergeInputChains, 2, 0, 1, 
/*11250*/           OPC_EmitConvertToTarget, 3,
/*11252*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::SUB64mi32), 0|OPFL_Chain|OPFL_MemRefs,
                        1/*#VTs*/, MVT::i32, 6/*#Ops*/, 4, 5, 6, 7, 8, 9, 
                    // Src: (st:isVoid (X86sub_flag:i64 (ld:i64 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>, (imm:i64)<<P:Predicate_i64immSExt32>>:$src2), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                    // Dst: (SUB64mi32:isVoid addr:iPTR:$dst, (imm:i64)<<P:Predicate_i64immSExt32>>:$src2)
/*11265*/         /*Scope*/ 35, /*->11301*/
/*11266*/           OPC_MoveParent,
/*11267*/           OPC_CheckType, MVT::i8,
/*11269*/           OPC_MoveParent,
/*11270*/           OPC_MoveChild, 2,
/*11272*/           OPC_CheckSame, 2,
/*11274*/           OPC_MoveParent,
/*11275*/           OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*11277*/           OPC_CheckPredicate, 5, // Predicate_store
/*11279*/           OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #4 #5 #6 #7 #8
/*11282*/           OPC_EmitMergeInputChains, 2, 0, 1, 
/*11286*/           OPC_EmitConvertToTarget, 3,
/*11288*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::SUB8mi), 0|OPFL_Chain|OPFL_MemRefs,
                        1/*#VTs*/, MVT::i32, 6/*#Ops*/, 4, 5, 6, 7, 8, 9, 
                    // Src: (st:isVoid (X86sub_flag:i8 (ld:i8 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>, (imm:i8):$src2), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                    // Dst: (SUB8mi:isVoid addr:iPTR:$dst, (imm:i8):$src2)
/*11301*/         0, /*End of Scope*/
/*11302*/       /*Scope*/ 43, /*->11346*/
/*11303*/         OPC_CheckPredicate, 6, // Predicate_loadi16
/*11305*/         OPC_MoveParent,
/*11306*/         OPC_RecordChild1, // #3 = $src2
/*11307*/         OPC_MoveChild, 1,
/*11309*/         OPC_CheckOpcode, ISD::Constant,
/*11311*/         OPC_MoveParent,
/*11312*/         OPC_CheckType, MVT::i16,
/*11314*/         OPC_MoveParent,
/*11315*/         OPC_MoveChild, 2,
/*11317*/         OPC_CheckSame, 2,
/*11319*/         OPC_MoveParent,
/*11320*/         OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*11322*/         OPC_CheckPredicate, 5, // Predicate_store
/*11324*/         OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #4 #5 #6 #7 #8
/*11327*/         OPC_EmitMergeInputChains, 2, 0, 1, 
/*11331*/         OPC_EmitConvertToTarget, 3,
/*11333*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::SUB16mi), 0|OPFL_Chain|OPFL_MemRefs,
                      1/*#VTs*/, MVT::i32, 6/*#Ops*/, 4, 5, 6, 7, 8, 9, 
                  // Src: (st:isVoid (X86sub_flag:i16 (ld:i16 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, (imm:i16):$src2), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                  // Dst: (SUB16mi:isVoid addr:iPTR:$dst, (imm:i16):$src2)
/*11346*/       /*Scope*/ 43, /*->11390*/
/*11347*/         OPC_CheckPredicate, 3, // Predicate_loadi32
/*11349*/         OPC_MoveParent,
/*11350*/         OPC_RecordChild1, // #3 = $src2
/*11351*/         OPC_MoveChild, 1,
/*11353*/         OPC_CheckOpcode, ISD::Constant,
/*11355*/         OPC_MoveParent,
/*11356*/         OPC_CheckType, MVT::i32,
/*11358*/         OPC_MoveParent,
/*11359*/         OPC_MoveChild, 2,
/*11361*/         OPC_CheckSame, 2,
/*11363*/         OPC_MoveParent,
/*11364*/         OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*11366*/         OPC_CheckPredicate, 5, // Predicate_store
/*11368*/         OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #4 #5 #6 #7 #8
/*11371*/         OPC_EmitMergeInputChains, 2, 0, 1, 
/*11375*/         OPC_EmitConvertToTarget, 3,
/*11377*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::SUB32mi), 0|OPFL_Chain|OPFL_MemRefs,
                      1/*#VTs*/, MVT::i32, 6/*#Ops*/, 4, 5, 6, 7, 8, 9, 
                  // Src: (st:isVoid (X86sub_flag:i32 (ld:i32 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, (imm:i32):$src2), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                  // Dst: (SUB32mi:isVoid addr:iPTR:$dst, (imm:i32):$src2)
/*11390*/       /*Scope*/ 38, /*->11429*/
/*11391*/         OPC_CheckPredicate, 8, // Predicate_load
/*11393*/         OPC_CheckPredicate, 9, // Predicate_dsload
/*11395*/         OPC_MoveParent,
/*11396*/         OPC_RecordChild1, // #3 = $src2
/*11397*/         OPC_CheckType, MVT::i8,
/*11399*/         OPC_MoveParent,
/*11400*/         OPC_MoveChild, 2,
/*11402*/         OPC_CheckSame, 2,
/*11404*/         OPC_MoveParent,
/*11405*/         OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*11407*/         OPC_CheckPredicate, 5, // Predicate_store
/*11409*/         OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #4 #5 #6 #7 #8
/*11412*/         OPC_EmitMergeInputChains, 2, 0, 1, 
/*11416*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::SUB8mr), 0|OPFL_Chain|OPFL_MemRefs,
                      1/*#VTs*/, MVT::i32, 6/*#Ops*/, 4, 5, 6, 7, 8, 3, 
                  // Src: (st:isVoid (X86sub_flag:i8 (ld:i8 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>, GR8:i8:$src2), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                  // Dst: (SUB8mr:isVoid addr:iPTR:$dst, GR8:i8:$src2)
/*11429*/       /*Scope*/ 36, /*->11466*/
/*11430*/         OPC_CheckPredicate, 6, // Predicate_loadi16
/*11432*/         OPC_MoveParent,
/*11433*/         OPC_RecordChild1, // #3 = $src2
/*11434*/         OPC_CheckType, MVT::i16,
/*11436*/         OPC_MoveParent,
/*11437*/         OPC_MoveChild, 2,
/*11439*/         OPC_CheckSame, 2,
/*11441*/         OPC_MoveParent,
/*11442*/         OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*11444*/         OPC_CheckPredicate, 5, // Predicate_store
/*11446*/         OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #4 #5 #6 #7 #8
/*11449*/         OPC_EmitMergeInputChains, 2, 0, 1, 
/*11453*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::SUB16mr), 0|OPFL_Chain|OPFL_MemRefs,
                      1/*#VTs*/, MVT::i32, 6/*#Ops*/, 4, 5, 6, 7, 8, 3, 
                  // Src: (st:isVoid (X86sub_flag:i16 (ld:i16 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, GR16:i16:$src2), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                  // Dst: (SUB16mr:isVoid addr:iPTR:$dst, GR16:i16:$src2)
/*11466*/       /*Scope*/ 36, /*->11503*/
/*11467*/         OPC_CheckPredicate, 3, // Predicate_loadi32
/*11469*/         OPC_MoveParent,
/*11470*/         OPC_RecordChild1, // #3 = $src2
/*11471*/         OPC_CheckType, MVT::i32,
/*11473*/         OPC_MoveParent,
/*11474*/         OPC_MoveChild, 2,
/*11476*/         OPC_CheckSame, 2,
/*11478*/         OPC_MoveParent,
/*11479*/         OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*11481*/         OPC_CheckPredicate, 5, // Predicate_store
/*11483*/         OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #4 #5 #6 #7 #8
/*11486*/         OPC_EmitMergeInputChains, 2, 0, 1, 
/*11490*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::SUB32mr), 0|OPFL_Chain|OPFL_MemRefs,
                      1/*#VTs*/, MVT::i32, 6/*#Ops*/, 4, 5, 6, 7, 8, 3, 
                  // Src: (st:isVoid (X86sub_flag:i32 (ld:i32 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, GR32:i32:$src2), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                  // Dst: (SUB32mr:isVoid addr:iPTR:$dst, GR32:i32:$src2)
/*11503*/       /*Scope*/ 38, /*->11542*/
/*11504*/         OPC_CheckPredicate, 8, // Predicate_load
/*11506*/         OPC_CheckPredicate, 9, // Predicate_dsload
/*11508*/         OPC_MoveParent,
/*11509*/         OPC_RecordChild1, // #3 = $src2
/*11510*/         OPC_CheckType, MVT::i64,
/*11512*/         OPC_MoveParent,
/*11513*/         OPC_MoveChild, 2,
/*11515*/         OPC_CheckSame, 2,
/*11517*/         OPC_MoveParent,
/*11518*/         OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*11520*/         OPC_CheckPredicate, 5, // Predicate_store
/*11522*/         OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #4 #5 #6 #7 #8
/*11525*/         OPC_EmitMergeInputChains, 2, 0, 1, 
/*11529*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::SUB64mr), 0|OPFL_Chain|OPFL_MemRefs,
                      1/*#VTs*/, MVT::i32, 6/*#Ops*/, 4, 5, 6, 7, 8, 3, 
                  // Src: (st:isVoid (X86sub_flag:i64 (ld:i64 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>, GR64:i64:$src2), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                  // Dst: (SUB64mr:isVoid addr:iPTR:$dst, GR64:i64:$src2)
/*11542*/       0, /*End of Scope*/
              /*SwitchOpcode*/ 124|128,4/*636*/,  X86ISD::OR,// ->12182
/*11546*/       OPC_Scope, 85|128,3/*469*/, /*->12018*/ // 2 children in Scope
/*11549*/         OPC_MoveChild, 0,
/*11551*/         OPC_CheckOpcode, ISD::LOAD,
/*11553*/         OPC_RecordMemRef,
/*11554*/         OPC_RecordNode, // #1 = 'ld' chained node
/*11555*/         OPC_CheckFoldableChainNode,
/*11556*/         OPC_RecordChild1, // #2 = $dst
/*11557*/         OPC_CheckPredicate, 2, // Predicate_unindexedload
/*11559*/         OPC_Scope, 45, /*->11606*/ // 9 children in Scope
/*11561*/           OPC_CheckPredicate, 6, // Predicate_loadi16
/*11563*/           OPC_MoveParent,
/*11564*/           OPC_RecordChild1, // #3 = $src2
/*11565*/           OPC_MoveChild, 1,
/*11567*/           OPC_CheckOpcode, ISD::Constant,
/*11569*/           OPC_CheckPredicate, 11, // Predicate_immSext8
/*11571*/           OPC_MoveParent,
/*11572*/           OPC_CheckType, MVT::i16,
/*11574*/           OPC_MoveParent,
/*11575*/           OPC_MoveChild, 2,
/*11577*/           OPC_CheckSame, 2,
/*11579*/           OPC_MoveParent,
/*11580*/           OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*11582*/           OPC_CheckPredicate, 5, // Predicate_store
/*11584*/           OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #4 #5 #6 #7 #8
/*11587*/           OPC_EmitMergeInputChains, 2, 0, 1, 
/*11591*/           OPC_EmitConvertToTarget, 3,
/*11593*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::OR16mi8), 0|OPFL_Chain|OPFL_MemRefs,
                        1/*#VTs*/, MVT::i32, 6/*#Ops*/, 4, 5, 6, 7, 8, 9, 
                    // Src: (st:isVoid (X86or_flag:i16 (ld:i16 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, (imm:i16)<<P:Predicate_immSext8>>:$src2), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                    // Dst: (OR16mi8:isVoid addr:iPTR:$dst, (imm:i16)<<P:Predicate_immSext8>>:$src2)
/*11606*/         /*Scope*/ 45, /*->11652*/
/*11607*/           OPC_CheckPredicate, 3, // Predicate_loadi32
/*11609*/           OPC_MoveParent,
/*11610*/           OPC_RecordChild1, // #3 = $src2
/*11611*/           OPC_MoveChild, 1,
/*11613*/           OPC_CheckOpcode, ISD::Constant,
/*11615*/           OPC_CheckPredicate, 11, // Predicate_immSext8
/*11617*/           OPC_MoveParent,
/*11618*/           OPC_CheckType, MVT::i32,
/*11620*/           OPC_MoveParent,
/*11621*/           OPC_MoveChild, 2,
/*11623*/           OPC_CheckSame, 2,
/*11625*/           OPC_MoveParent,
/*11626*/           OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*11628*/           OPC_CheckPredicate, 5, // Predicate_store
/*11630*/           OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #4 #5 #6 #7 #8
/*11633*/           OPC_EmitMergeInputChains, 2, 0, 1, 
/*11637*/           OPC_EmitConvertToTarget, 3,
/*11639*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::OR32mi8), 0|OPFL_Chain|OPFL_MemRefs,
                        1/*#VTs*/, MVT::i32, 6/*#Ops*/, 4, 5, 6, 7, 8, 9, 
                    // Src: (st:isVoid (X86or_flag:i32 (ld:i32 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, (imm:i32)<<P:Predicate_immSext8>>:$src2), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                    // Dst: (OR32mi8:isVoid addr:iPTR:$dst, (imm:i32)<<P:Predicate_immSext8>>:$src2)
/*11652*/         /*Scope*/ 124, /*->11777*/
/*11653*/           OPC_CheckPredicate, 8, // Predicate_load
/*11655*/           OPC_CheckPredicate, 9, // Predicate_dsload
/*11657*/           OPC_MoveParent,
/*11658*/           OPC_RecordChild1, // #3 = $src2
/*11659*/           OPC_MoveChild, 1,
/*11661*/           OPC_CheckOpcode, ISD::Constant,
/*11663*/           OPC_Scope, 37, /*->11702*/ // 3 children in Scope
/*11665*/             OPC_CheckPredicate, 11, // Predicate_immSext8
/*11667*/             OPC_MoveParent,
/*11668*/             OPC_CheckType, MVT::i64,
/*11670*/             OPC_MoveParent,
/*11671*/             OPC_MoveChild, 2,
/*11673*/             OPC_CheckSame, 2,
/*11675*/             OPC_MoveParent,
/*11676*/             OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*11678*/             OPC_CheckPredicate, 5, // Predicate_store
/*11680*/             OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #4 #5 #6 #7 #8
/*11683*/             OPC_EmitMergeInputChains, 2, 0, 1, 
/*11687*/             OPC_EmitConvertToTarget, 3,
/*11689*/             OPC_MorphNodeTo, TARGET_OPCODE(X86::OR64mi8), 0|OPFL_Chain|OPFL_MemRefs,
                          1/*#VTs*/, MVT::i32, 6/*#Ops*/, 4, 5, 6, 7, 8, 9, 
                      // Src: (st:isVoid (X86or_flag:i64 (ld:i64 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>, (imm:i64)<<P:Predicate_immSext8>>:$src2), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                      // Dst: (OR64mi8:isVoid addr:iPTR:$dst, (imm:i64)<<P:Predicate_immSext8>>:$src2)
/*11702*/           /*Scope*/ 37, /*->11740*/
/*11703*/             OPC_CheckPredicate, 12, // Predicate_i64immSExt32
/*11705*/             OPC_MoveParent,
/*11706*/             OPC_CheckType, MVT::i64,
/*11708*/             OPC_MoveParent,
/*11709*/             OPC_MoveChild, 2,
/*11711*/             OPC_CheckSame, 2,
/*11713*/             OPC_MoveParent,
/*11714*/             OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*11716*/             OPC_CheckPredicate, 5, // Predicate_store
/*11718*/             OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #4 #5 #6 #7 #8
/*11721*/             OPC_EmitMergeInputChains, 2, 0, 1, 
/*11725*/             OPC_EmitConvertToTarget, 3,
/*11727*/             OPC_MorphNodeTo, TARGET_OPCODE(X86::OR64mi32), 0|OPFL_Chain|OPFL_MemRefs,
                          1/*#VTs*/, MVT::i32, 6/*#Ops*/, 4, 5, 6, 7, 8, 9, 
                      // Src: (st:isVoid (X86or_flag:i64 (ld:i64 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>, (imm:i64)<<P:Predicate_i64immSExt32>>:$src2), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                      // Dst: (OR64mi32:isVoid addr:iPTR:$dst, (imm:i64)<<P:Predicate_i64immSExt32>>:$src2)
/*11740*/           /*Scope*/ 35, /*->11776*/
/*11741*/             OPC_MoveParent,
/*11742*/             OPC_CheckType, MVT::i8,
/*11744*/             OPC_MoveParent,
/*11745*/             OPC_MoveChild, 2,
/*11747*/             OPC_CheckSame, 2,
/*11749*/             OPC_MoveParent,
/*11750*/             OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*11752*/             OPC_CheckPredicate, 5, // Predicate_store
/*11754*/             OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #4 #5 #6 #7 #8
/*11757*/             OPC_EmitMergeInputChains, 2, 0, 1, 
/*11761*/             OPC_EmitConvertToTarget, 3,
/*11763*/             OPC_MorphNodeTo, TARGET_OPCODE(X86::OR8mi), 0|OPFL_Chain|OPFL_MemRefs,
                          1/*#VTs*/, MVT::i32, 6/*#Ops*/, 4, 5, 6, 7, 8, 9, 
                      // Src: (st:isVoid (X86or_flag:i8 (ld:i8 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>, (imm:i8):$src2), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                      // Dst: (OR8mi:isVoid addr:iPTR:$dst, (imm:i8):$src2)
/*11776*/           0, /*End of Scope*/
/*11777*/         /*Scope*/ 43, /*->11821*/
/*11778*/           OPC_CheckPredicate, 6, // Predicate_loadi16
/*11780*/           OPC_MoveParent,
/*11781*/           OPC_RecordChild1, // #3 = $src2
/*11782*/           OPC_MoveChild, 1,
/*11784*/           OPC_CheckOpcode, ISD::Constant,
/*11786*/           OPC_MoveParent,
/*11787*/           OPC_CheckType, MVT::i16,
/*11789*/           OPC_MoveParent,
/*11790*/           OPC_MoveChild, 2,
/*11792*/           OPC_CheckSame, 2,
/*11794*/           OPC_MoveParent,
/*11795*/           OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*11797*/           OPC_CheckPredicate, 5, // Predicate_store
/*11799*/           OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #4 #5 #6 #7 #8
/*11802*/           OPC_EmitMergeInputChains, 2, 0, 1, 
/*11806*/           OPC_EmitConvertToTarget, 3,
/*11808*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::OR16mi), 0|OPFL_Chain|OPFL_MemRefs,
                        1/*#VTs*/, MVT::i32, 6/*#Ops*/, 4, 5, 6, 7, 8, 9, 
                    // Src: (st:isVoid (X86or_flag:i16 (ld:i16 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, (imm:i16):$src2), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                    // Dst: (OR16mi:isVoid addr:iPTR:$dst, (imm:i16):$src2)
/*11821*/         /*Scope*/ 43, /*->11865*/
/*11822*/           OPC_CheckPredicate, 3, // Predicate_loadi32
/*11824*/           OPC_MoveParent,
/*11825*/           OPC_RecordChild1, // #3 = $src2
/*11826*/           OPC_MoveChild, 1,
/*11828*/           OPC_CheckOpcode, ISD::Constant,
/*11830*/           OPC_MoveParent,
/*11831*/           OPC_CheckType, MVT::i32,
/*11833*/           OPC_MoveParent,
/*11834*/           OPC_MoveChild, 2,
/*11836*/           OPC_CheckSame, 2,
/*11838*/           OPC_MoveParent,
/*11839*/           OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*11841*/           OPC_CheckPredicate, 5, // Predicate_store
/*11843*/           OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #4 #5 #6 #7 #8
/*11846*/           OPC_EmitMergeInputChains, 2, 0, 1, 
/*11850*/           OPC_EmitConvertToTarget, 3,
/*11852*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::OR32mi), 0|OPFL_Chain|OPFL_MemRefs,
                        1/*#VTs*/, MVT::i32, 6/*#Ops*/, 4, 5, 6, 7, 8, 9, 
                    // Src: (st:isVoid (X86or_flag:i32 (ld:i32 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, (imm:i32):$src2), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                    // Dst: (OR32mi:isVoid addr:iPTR:$dst, (imm:i32):$src2)
/*11865*/         /*Scope*/ 38, /*->11904*/
/*11866*/           OPC_CheckPredicate, 8, // Predicate_load
/*11868*/           OPC_CheckPredicate, 9, // Predicate_dsload
/*11870*/           OPC_MoveParent,
/*11871*/           OPC_RecordChild1, // #3 = $src2
/*11872*/           OPC_CheckType, MVT::i8,
/*11874*/           OPC_MoveParent,
/*11875*/           OPC_MoveChild, 2,
/*11877*/           OPC_CheckSame, 2,
/*11879*/           OPC_MoveParent,
/*11880*/           OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*11882*/           OPC_CheckPredicate, 5, // Predicate_store
/*11884*/           OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #4 #5 #6 #7 #8
/*11887*/           OPC_EmitMergeInputChains, 2, 0, 1, 
/*11891*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::OR8mr), 0|OPFL_Chain|OPFL_MemRefs,
                        1/*#VTs*/, MVT::i32, 6/*#Ops*/, 4, 5, 6, 7, 8, 3, 
                    // Src: (st:isVoid (X86or_flag:i8 (ld:i8 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>, GR8:i8:$src2), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                    // Dst: (OR8mr:isVoid addr:iPTR:$dst, GR8:i8:$src2)
/*11904*/         /*Scope*/ 36, /*->11941*/
/*11905*/           OPC_CheckPredicate, 6, // Predicate_loadi16
/*11907*/           OPC_MoveParent,
/*11908*/           OPC_RecordChild1, // #3 = $src2
/*11909*/           OPC_CheckType, MVT::i16,
/*11911*/           OPC_MoveParent,
/*11912*/           OPC_MoveChild, 2,
/*11914*/           OPC_CheckSame, 2,
/*11916*/           OPC_MoveParent,
/*11917*/           OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*11919*/           OPC_CheckPredicate, 5, // Predicate_store
/*11921*/           OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #4 #5 #6 #7 #8
/*11924*/           OPC_EmitMergeInputChains, 2, 0, 1, 
/*11928*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::OR16mr), 0|OPFL_Chain|OPFL_MemRefs,
                        1/*#VTs*/, MVT::i32, 6/*#Ops*/, 4, 5, 6, 7, 8, 3, 
                    // Src: (st:isVoid (X86or_flag:i16 (ld:i16 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, GR16:i16:$src2), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                    // Dst: (OR16mr:isVoid addr:iPTR:$dst, GR16:i16:$src2)
/*11941*/         /*Scope*/ 36, /*->11978*/
/*11942*/           OPC_CheckPredicate, 3, // Predicate_loadi32
/*11944*/           OPC_MoveParent,
/*11945*/           OPC_RecordChild1, // #3 = $src2
/*11946*/           OPC_CheckType, MVT::i32,
/*11948*/           OPC_MoveParent,
/*11949*/           OPC_MoveChild, 2,
/*11951*/           OPC_CheckSame, 2,
/*11953*/           OPC_MoveParent,
/*11954*/           OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*11956*/           OPC_CheckPredicate, 5, // Predicate_store
/*11958*/           OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #4 #5 #6 #7 #8
/*11961*/           OPC_EmitMergeInputChains, 2, 0, 1, 
/*11965*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::OR32mr), 0|OPFL_Chain|OPFL_MemRefs,
                        1/*#VTs*/, MVT::i32, 6/*#Ops*/, 4, 5, 6, 7, 8, 3, 
                    // Src: (st:isVoid (X86or_flag:i32 (ld:i32 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, GR32:i32:$src2), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                    // Dst: (OR32mr:isVoid addr:iPTR:$dst, GR32:i32:$src2)
/*11978*/         /*Scope*/ 38, /*->12017*/
/*11979*/           OPC_CheckPredicate, 8, // Predicate_load
/*11981*/           OPC_CheckPredicate, 9, // Predicate_dsload
/*11983*/           OPC_MoveParent,
/*11984*/           OPC_RecordChild1, // #3 = $src2
/*11985*/           OPC_CheckType, MVT::i64,
/*11987*/           OPC_MoveParent,
/*11988*/           OPC_MoveChild, 2,
/*11990*/           OPC_CheckSame, 2,
/*11992*/           OPC_MoveParent,
/*11993*/           OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*11995*/           OPC_CheckPredicate, 5, // Predicate_store
/*11997*/           OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #4 #5 #6 #7 #8
/*12000*/           OPC_EmitMergeInputChains, 2, 0, 1, 
/*12004*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::OR64mr), 0|OPFL_Chain|OPFL_MemRefs,
                        1/*#VTs*/, MVT::i32, 6/*#Ops*/, 4, 5, 6, 7, 8, 3, 
                    // Src: (st:isVoid (X86or_flag:i64 (ld:i64 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>, GR64:i64:$src2), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                    // Dst: (OR64mr:isVoid addr:iPTR:$dst, GR64:i64:$src2)
/*12017*/         0, /*End of Scope*/
/*12018*/       /*Scope*/ 33|128,1/*161*/, /*->12181*/
/*12020*/         OPC_RecordChild0, // #1 = $src2
/*12021*/         OPC_MoveChild, 1,
/*12023*/         OPC_CheckOpcode, ISD::LOAD,
/*12025*/         OPC_RecordMemRef,
/*12026*/         OPC_RecordNode, // #2 = 'ld' chained node
/*12027*/         OPC_CheckFoldableChainNode,
/*12028*/         OPC_RecordChild1, // #3 = $dst
/*12029*/         OPC_CheckPredicate, 2, // Predicate_unindexedload
/*12031*/         OPC_Scope, 37, /*->12070*/ // 4 children in Scope
/*12033*/           OPC_CheckPredicate, 8, // Predicate_load
/*12035*/           OPC_CheckPredicate, 9, // Predicate_dsload
/*12037*/           OPC_MoveParent,
/*12038*/           OPC_CheckType, MVT::i8,
/*12040*/           OPC_MoveParent,
/*12041*/           OPC_MoveChild, 2,
/*12043*/           OPC_CheckSame, 3,
/*12045*/           OPC_MoveParent,
/*12046*/           OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*12048*/           OPC_CheckPredicate, 5, // Predicate_store
/*12050*/           OPC_CheckComplexPat, /*CP*/0, /*#*/3, // SelectAddr:$dst #4 #5 #6 #7 #8
/*12053*/           OPC_EmitMergeInputChains, 2, 0, 2, 
/*12057*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::OR8mr), 0|OPFL_Chain|OPFL_MemRefs,
                        1/*#VTs*/, MVT::i32, 6/*#Ops*/, 4, 5, 6, 7, 8, 1, 
                    // Src: (st:isVoid (X86or_flag:i8 GR8:i8:$src2, (ld:i8 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                    // Dst: (OR8mr:isVoid addr:iPTR:$dst, GR8:i8:$src2)
/*12070*/         /*Scope*/ 35, /*->12106*/
/*12071*/           OPC_CheckPredicate, 6, // Predicate_loadi16
/*12073*/           OPC_MoveParent,
/*12074*/           OPC_CheckType, MVT::i16,
/*12076*/           OPC_MoveParent,
/*12077*/           OPC_MoveChild, 2,
/*12079*/           OPC_CheckSame, 3,
/*12081*/           OPC_MoveParent,
/*12082*/           OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*12084*/           OPC_CheckPredicate, 5, // Predicate_store
/*12086*/           OPC_CheckComplexPat, /*CP*/0, /*#*/3, // SelectAddr:$dst #4 #5 #6 #7 #8
/*12089*/           OPC_EmitMergeInputChains, 2, 0, 2, 
/*12093*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::OR16mr), 0|OPFL_Chain|OPFL_MemRefs,
                        1/*#VTs*/, MVT::i32, 6/*#Ops*/, 4, 5, 6, 7, 8, 1, 
                    // Src: (st:isVoid (X86or_flag:i16 GR16:i16:$src2, (ld:i16 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                    // Dst: (OR16mr:isVoid addr:iPTR:$dst, GR16:i16:$src2)
/*12106*/         /*Scope*/ 35, /*->12142*/
/*12107*/           OPC_CheckPredicate, 3, // Predicate_loadi32
/*12109*/           OPC_MoveParent,
/*12110*/           OPC_CheckType, MVT::i32,
/*12112*/           OPC_MoveParent,
/*12113*/           OPC_MoveChild, 2,
/*12115*/           OPC_CheckSame, 3,
/*12117*/           OPC_MoveParent,
/*12118*/           OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*12120*/           OPC_CheckPredicate, 5, // Predicate_store
/*12122*/           OPC_CheckComplexPat, /*CP*/0, /*#*/3, // SelectAddr:$dst #4 #5 #6 #7 #8
/*12125*/           OPC_EmitMergeInputChains, 2, 0, 2, 
/*12129*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::OR32mr), 0|OPFL_Chain|OPFL_MemRefs,
                        1/*#VTs*/, MVT::i32, 6/*#Ops*/, 4, 5, 6, 7, 8, 1, 
                    // Src: (st:isVoid (X86or_flag:i32 GR32:i32:$src2, (ld:i32 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                    // Dst: (OR32mr:isVoid addr:iPTR:$dst, GR32:i32:$src2)
/*12142*/         /*Scope*/ 37, /*->12180*/
/*12143*/           OPC_CheckPredicate, 8, // Predicate_load
/*12145*/           OPC_CheckPredicate, 9, // Predicate_dsload
/*12147*/           OPC_MoveParent,
/*12148*/           OPC_CheckType, MVT::i64,
/*12150*/           OPC_MoveParent,
/*12151*/           OPC_MoveChild, 2,
/*12153*/           OPC_CheckSame, 3,
/*12155*/           OPC_MoveParent,
/*12156*/           OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*12158*/           OPC_CheckPredicate, 5, // Predicate_store
/*12160*/           OPC_CheckComplexPat, /*CP*/0, /*#*/3, // SelectAddr:$dst #4 #5 #6 #7 #8
/*12163*/           OPC_EmitMergeInputChains, 2, 0, 2, 
/*12167*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::OR64mr), 0|OPFL_Chain|OPFL_MemRefs,
                        1/*#VTs*/, MVT::i32, 6/*#Ops*/, 4, 5, 6, 7, 8, 1, 
                    // Src: (st:isVoid (X86or_flag:i64 GR64:i64:$src2, (ld:i64 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                    // Dst: (OR64mr:isVoid addr:iPTR:$dst, GR64:i64:$src2)
/*12180*/         0, /*End of Scope*/
/*12181*/       0, /*End of Scope*/
              /*SwitchOpcode*/ 124|128,4/*636*/,  X86ISD::XOR,// ->12821
/*12185*/       OPC_Scope, 85|128,3/*469*/, /*->12657*/ // 2 children in Scope
/*12188*/         OPC_MoveChild, 0,
/*12190*/         OPC_CheckOpcode, ISD::LOAD,
/*12192*/         OPC_RecordMemRef,
/*12193*/         OPC_RecordNode, // #1 = 'ld' chained node
/*12194*/         OPC_CheckFoldableChainNode,
/*12195*/         OPC_RecordChild1, // #2 = $dst
/*12196*/         OPC_CheckPredicate, 2, // Predicate_unindexedload
/*12198*/         OPC_Scope, 45, /*->12245*/ // 9 children in Scope
/*12200*/           OPC_CheckPredicate, 6, // Predicate_loadi16
/*12202*/           OPC_MoveParent,
/*12203*/           OPC_RecordChild1, // #3 = $src2
/*12204*/           OPC_MoveChild, 1,
/*12206*/           OPC_CheckOpcode, ISD::Constant,
/*12208*/           OPC_CheckPredicate, 11, // Predicate_immSext8
/*12210*/           OPC_MoveParent,
/*12211*/           OPC_CheckType, MVT::i16,
/*12213*/           OPC_MoveParent,
/*12214*/           OPC_MoveChild, 2,
/*12216*/           OPC_CheckSame, 2,
/*12218*/           OPC_MoveParent,
/*12219*/           OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*12221*/           OPC_CheckPredicate, 5, // Predicate_store
/*12223*/           OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #4 #5 #6 #7 #8
/*12226*/           OPC_EmitMergeInputChains, 2, 0, 1, 
/*12230*/           OPC_EmitConvertToTarget, 3,
/*12232*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::XOR16mi8), 0|OPFL_Chain|OPFL_MemRefs,
                        1/*#VTs*/, MVT::i32, 6/*#Ops*/, 4, 5, 6, 7, 8, 9, 
                    // Src: (st:isVoid (X86xor_flag:i16 (ld:i16 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, (imm:i16)<<P:Predicate_immSext8>>:$src2), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                    // Dst: (XOR16mi8:isVoid addr:iPTR:$dst, (imm:i16)<<P:Predicate_immSext8>>:$src2)
/*12245*/         /*Scope*/ 45, /*->12291*/
/*12246*/           OPC_CheckPredicate, 3, // Predicate_loadi32
/*12248*/           OPC_MoveParent,
/*12249*/           OPC_RecordChild1, // #3 = $src2
/*12250*/           OPC_MoveChild, 1,
/*12252*/           OPC_CheckOpcode, ISD::Constant,
/*12254*/           OPC_CheckPredicate, 11, // Predicate_immSext8
/*12256*/           OPC_MoveParent,
/*12257*/           OPC_CheckType, MVT::i32,
/*12259*/           OPC_MoveParent,
/*12260*/           OPC_MoveChild, 2,
/*12262*/           OPC_CheckSame, 2,
/*12264*/           OPC_MoveParent,
/*12265*/           OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*12267*/           OPC_CheckPredicate, 5, // Predicate_store
/*12269*/           OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #4 #5 #6 #7 #8
/*12272*/           OPC_EmitMergeInputChains, 2, 0, 1, 
/*12276*/           OPC_EmitConvertToTarget, 3,
/*12278*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::XOR32mi8), 0|OPFL_Chain|OPFL_MemRefs,
                        1/*#VTs*/, MVT::i32, 6/*#Ops*/, 4, 5, 6, 7, 8, 9, 
                    // Src: (st:isVoid (X86xor_flag:i32 (ld:i32 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, (imm:i32)<<P:Predicate_immSext8>>:$src2), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                    // Dst: (XOR32mi8:isVoid addr:iPTR:$dst, (imm:i32)<<P:Predicate_immSext8>>:$src2)
/*12291*/         /*Scope*/ 124, /*->12416*/
/*12292*/           OPC_CheckPredicate, 8, // Predicate_load
/*12294*/           OPC_CheckPredicate, 9, // Predicate_dsload
/*12296*/           OPC_MoveParent,
/*12297*/           OPC_RecordChild1, // #3 = $src2
/*12298*/           OPC_MoveChild, 1,
/*12300*/           OPC_CheckOpcode, ISD::Constant,
/*12302*/           OPC_Scope, 37, /*->12341*/ // 3 children in Scope
/*12304*/             OPC_CheckPredicate, 11, // Predicate_immSext8
/*12306*/             OPC_MoveParent,
/*12307*/             OPC_CheckType, MVT::i64,
/*12309*/             OPC_MoveParent,
/*12310*/             OPC_MoveChild, 2,
/*12312*/             OPC_CheckSame, 2,
/*12314*/             OPC_MoveParent,
/*12315*/             OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*12317*/             OPC_CheckPredicate, 5, // Predicate_store
/*12319*/             OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #4 #5 #6 #7 #8
/*12322*/             OPC_EmitMergeInputChains, 2, 0, 1, 
/*12326*/             OPC_EmitConvertToTarget, 3,
/*12328*/             OPC_MorphNodeTo, TARGET_OPCODE(X86::XOR64mi8), 0|OPFL_Chain|OPFL_MemRefs,
                          1/*#VTs*/, MVT::i32, 6/*#Ops*/, 4, 5, 6, 7, 8, 9, 
                      // Src: (st:isVoid (X86xor_flag:i64 (ld:i64 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>, (imm:i64)<<P:Predicate_immSext8>>:$src2), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                      // Dst: (XOR64mi8:isVoid addr:iPTR:$dst, (imm:i64)<<P:Predicate_immSext8>>:$src2)
/*12341*/           /*Scope*/ 37, /*->12379*/
/*12342*/             OPC_CheckPredicate, 12, // Predicate_i64immSExt32
/*12344*/             OPC_MoveParent,
/*12345*/             OPC_CheckType, MVT::i64,
/*12347*/             OPC_MoveParent,
/*12348*/             OPC_MoveChild, 2,
/*12350*/             OPC_CheckSame, 2,
/*12352*/             OPC_MoveParent,
/*12353*/             OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*12355*/             OPC_CheckPredicate, 5, // Predicate_store
/*12357*/             OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #4 #5 #6 #7 #8
/*12360*/             OPC_EmitMergeInputChains, 2, 0, 1, 
/*12364*/             OPC_EmitConvertToTarget, 3,
/*12366*/             OPC_MorphNodeTo, TARGET_OPCODE(X86::XOR64mi32), 0|OPFL_Chain|OPFL_MemRefs,
                          1/*#VTs*/, MVT::i32, 6/*#Ops*/, 4, 5, 6, 7, 8, 9, 
                      // Src: (st:isVoid (X86xor_flag:i64 (ld:i64 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>, (imm:i64)<<P:Predicate_i64immSExt32>>:$src2), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                      // Dst: (XOR64mi32:isVoid addr:iPTR:$dst, (imm:i64)<<P:Predicate_i64immSExt32>>:$src2)
/*12379*/           /*Scope*/ 35, /*->12415*/
/*12380*/             OPC_MoveParent,
/*12381*/             OPC_CheckType, MVT::i8,
/*12383*/             OPC_MoveParent,
/*12384*/             OPC_MoveChild, 2,
/*12386*/             OPC_CheckSame, 2,
/*12388*/             OPC_MoveParent,
/*12389*/             OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*12391*/             OPC_CheckPredicate, 5, // Predicate_store
/*12393*/             OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #4 #5 #6 #7 #8
/*12396*/             OPC_EmitMergeInputChains, 2, 0, 1, 
/*12400*/             OPC_EmitConvertToTarget, 3,
/*12402*/             OPC_MorphNodeTo, TARGET_OPCODE(X86::XOR8mi), 0|OPFL_Chain|OPFL_MemRefs,
                          1/*#VTs*/, MVT::i32, 6/*#Ops*/, 4, 5, 6, 7, 8, 9, 
                      // Src: (st:isVoid (X86xor_flag:i8 (ld:i8 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>, (imm:i8):$src2), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                      // Dst: (XOR8mi:isVoid addr:iPTR:$dst, (imm:i8):$src2)
/*12415*/           0, /*End of Scope*/
/*12416*/         /*Scope*/ 43, /*->12460*/
/*12417*/           OPC_CheckPredicate, 6, // Predicate_loadi16
/*12419*/           OPC_MoveParent,
/*12420*/           OPC_RecordChild1, // #3 = $src2
/*12421*/           OPC_MoveChild, 1,
/*12423*/           OPC_CheckOpcode, ISD::Constant,
/*12425*/           OPC_MoveParent,
/*12426*/           OPC_CheckType, MVT::i16,
/*12428*/           OPC_MoveParent,
/*12429*/           OPC_MoveChild, 2,
/*12431*/           OPC_CheckSame, 2,
/*12433*/           OPC_MoveParent,
/*12434*/           OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*12436*/           OPC_CheckPredicate, 5, // Predicate_store
/*12438*/           OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #4 #5 #6 #7 #8
/*12441*/           OPC_EmitMergeInputChains, 2, 0, 1, 
/*12445*/           OPC_EmitConvertToTarget, 3,
/*12447*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::XOR16mi), 0|OPFL_Chain|OPFL_MemRefs,
                        1/*#VTs*/, MVT::i32, 6/*#Ops*/, 4, 5, 6, 7, 8, 9, 
                    // Src: (st:isVoid (X86xor_flag:i16 (ld:i16 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, (imm:i16):$src2), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                    // Dst: (XOR16mi:isVoid addr:iPTR:$dst, (imm:i16):$src2)
/*12460*/         /*Scope*/ 43, /*->12504*/
/*12461*/           OPC_CheckPredicate, 3, // Predicate_loadi32
/*12463*/           OPC_MoveParent,
/*12464*/           OPC_RecordChild1, // #3 = $src2
/*12465*/           OPC_MoveChild, 1,
/*12467*/           OPC_CheckOpcode, ISD::Constant,
/*12469*/           OPC_MoveParent,
/*12470*/           OPC_CheckType, MVT::i32,
/*12472*/           OPC_MoveParent,
/*12473*/           OPC_MoveChild, 2,
/*12475*/           OPC_CheckSame, 2,
/*12477*/           OPC_MoveParent,
/*12478*/           OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*12480*/           OPC_CheckPredicate, 5, // Predicate_store
/*12482*/           OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #4 #5 #6 #7 #8
/*12485*/           OPC_EmitMergeInputChains, 2, 0, 1, 
/*12489*/           OPC_EmitConvertToTarget, 3,
/*12491*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::XOR32mi), 0|OPFL_Chain|OPFL_MemRefs,
                        1/*#VTs*/, MVT::i32, 6/*#Ops*/, 4, 5, 6, 7, 8, 9, 
                    // Src: (st:isVoid (X86xor_flag:i32 (ld:i32 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, (imm:i32):$src2), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                    // Dst: (XOR32mi:isVoid addr:iPTR:$dst, (imm:i32):$src2)
/*12504*/         /*Scope*/ 38, /*->12543*/
/*12505*/           OPC_CheckPredicate, 8, // Predicate_load
/*12507*/           OPC_CheckPredicate, 9, // Predicate_dsload
/*12509*/           OPC_MoveParent,
/*12510*/           OPC_RecordChild1, // #3 = $src2
/*12511*/           OPC_CheckType, MVT::i8,
/*12513*/           OPC_MoveParent,
/*12514*/           OPC_MoveChild, 2,
/*12516*/           OPC_CheckSame, 2,
/*12518*/           OPC_MoveParent,
/*12519*/           OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*12521*/           OPC_CheckPredicate, 5, // Predicate_store
/*12523*/           OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #4 #5 #6 #7 #8
/*12526*/           OPC_EmitMergeInputChains, 2, 0, 1, 
/*12530*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::XOR8mr), 0|OPFL_Chain|OPFL_MemRefs,
                        1/*#VTs*/, MVT::i32, 6/*#Ops*/, 4, 5, 6, 7, 8, 3, 
                    // Src: (st:isVoid (X86xor_flag:i8 (ld:i8 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>, GR8:i8:$src2), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                    // Dst: (XOR8mr:isVoid addr:iPTR:$dst, GR8:i8:$src2)
/*12543*/         /*Scope*/ 36, /*->12580*/
/*12544*/           OPC_CheckPredicate, 6, // Predicate_loadi16
/*12546*/           OPC_MoveParent,
/*12547*/           OPC_RecordChild1, // #3 = $src2
/*12548*/           OPC_CheckType, MVT::i16,
/*12550*/           OPC_MoveParent,
/*12551*/           OPC_MoveChild, 2,
/*12553*/           OPC_CheckSame, 2,
/*12555*/           OPC_MoveParent,
/*12556*/           OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*12558*/           OPC_CheckPredicate, 5, // Predicate_store
/*12560*/           OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #4 #5 #6 #7 #8
/*12563*/           OPC_EmitMergeInputChains, 2, 0, 1, 
/*12567*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::XOR16mr), 0|OPFL_Chain|OPFL_MemRefs,
                        1/*#VTs*/, MVT::i32, 6/*#Ops*/, 4, 5, 6, 7, 8, 3, 
                    // Src: (st:isVoid (X86xor_flag:i16 (ld:i16 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, GR16:i16:$src2), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                    // Dst: (XOR16mr:isVoid addr:iPTR:$dst, GR16:i16:$src2)
/*12580*/         /*Scope*/ 36, /*->12617*/
/*12581*/           OPC_CheckPredicate, 3, // Predicate_loadi32
/*12583*/           OPC_MoveParent,
/*12584*/           OPC_RecordChild1, // #3 = $src2
/*12585*/           OPC_CheckType, MVT::i32,
/*12587*/           OPC_MoveParent,
/*12588*/           OPC_MoveChild, 2,
/*12590*/           OPC_CheckSame, 2,
/*12592*/           OPC_MoveParent,
/*12593*/           OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*12595*/           OPC_CheckPredicate, 5, // Predicate_store
/*12597*/           OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #4 #5 #6 #7 #8
/*12600*/           OPC_EmitMergeInputChains, 2, 0, 1, 
/*12604*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::XOR32mr), 0|OPFL_Chain|OPFL_MemRefs,
                        1/*#VTs*/, MVT::i32, 6/*#Ops*/, 4, 5, 6, 7, 8, 3, 
                    // Src: (st:isVoid (X86xor_flag:i32 (ld:i32 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, GR32:i32:$src2), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                    // Dst: (XOR32mr:isVoid addr:iPTR:$dst, GR32:i32:$src2)
/*12617*/         /*Scope*/ 38, /*->12656*/
/*12618*/           OPC_CheckPredicate, 8, // Predicate_load
/*12620*/           OPC_CheckPredicate, 9, // Predicate_dsload
/*12622*/           OPC_MoveParent,
/*12623*/           OPC_RecordChild1, // #3 = $src2
/*12624*/           OPC_CheckType, MVT::i64,
/*12626*/           OPC_MoveParent,
/*12627*/           OPC_MoveChild, 2,
/*12629*/           OPC_CheckSame, 2,
/*12631*/           OPC_MoveParent,
/*12632*/           OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*12634*/           OPC_CheckPredicate, 5, // Predicate_store
/*12636*/           OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #4 #5 #6 #7 #8
/*12639*/           OPC_EmitMergeInputChains, 2, 0, 1, 
/*12643*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::XOR64mr), 0|OPFL_Chain|OPFL_MemRefs,
                        1/*#VTs*/, MVT::i32, 6/*#Ops*/, 4, 5, 6, 7, 8, 3, 
                    // Src: (st:isVoid (X86xor_flag:i64 (ld:i64 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>, GR64:i64:$src2), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                    // Dst: (XOR64mr:isVoid addr:iPTR:$dst, GR64:i64:$src2)
/*12656*/         0, /*End of Scope*/
/*12657*/       /*Scope*/ 33|128,1/*161*/, /*->12820*/
/*12659*/         OPC_RecordChild0, // #1 = $src2
/*12660*/         OPC_MoveChild, 1,
/*12662*/         OPC_CheckOpcode, ISD::LOAD,
/*12664*/         OPC_RecordMemRef,
/*12665*/         OPC_RecordNode, // #2 = 'ld' chained node
/*12666*/         OPC_CheckFoldableChainNode,
/*12667*/         OPC_RecordChild1, // #3 = $dst
/*12668*/         OPC_CheckPredicate, 2, // Predicate_unindexedload
/*12670*/         OPC_Scope, 37, /*->12709*/ // 4 children in Scope
/*12672*/           OPC_CheckPredicate, 8, // Predicate_load
/*12674*/           OPC_CheckPredicate, 9, // Predicate_dsload
/*12676*/           OPC_MoveParent,
/*12677*/           OPC_CheckType, MVT::i8,
/*12679*/           OPC_MoveParent,
/*12680*/           OPC_MoveChild, 2,
/*12682*/           OPC_CheckSame, 3,
/*12684*/           OPC_MoveParent,
/*12685*/           OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*12687*/           OPC_CheckPredicate, 5, // Predicate_store
/*12689*/           OPC_CheckComplexPat, /*CP*/0, /*#*/3, // SelectAddr:$dst #4 #5 #6 #7 #8
/*12692*/           OPC_EmitMergeInputChains, 2, 0, 2, 
/*12696*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::XOR8mr), 0|OPFL_Chain|OPFL_MemRefs,
                        1/*#VTs*/, MVT::i32, 6/*#Ops*/, 4, 5, 6, 7, 8, 1, 
                    // Src: (st:isVoid (X86xor_flag:i8 GR8:i8:$src2, (ld:i8 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                    // Dst: (XOR8mr:isVoid addr:iPTR:$dst, GR8:i8:$src2)
/*12709*/         /*Scope*/ 35, /*->12745*/
/*12710*/           OPC_CheckPredicate, 6, // Predicate_loadi16
/*12712*/           OPC_MoveParent,
/*12713*/           OPC_CheckType, MVT::i16,
/*12715*/           OPC_MoveParent,
/*12716*/           OPC_MoveChild, 2,
/*12718*/           OPC_CheckSame, 3,
/*12720*/           OPC_MoveParent,
/*12721*/           OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*12723*/           OPC_CheckPredicate, 5, // Predicate_store
/*12725*/           OPC_CheckComplexPat, /*CP*/0, /*#*/3, // SelectAddr:$dst #4 #5 #6 #7 #8
/*12728*/           OPC_EmitMergeInputChains, 2, 0, 2, 
/*12732*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::XOR16mr), 0|OPFL_Chain|OPFL_MemRefs,
                        1/*#VTs*/, MVT::i32, 6/*#Ops*/, 4, 5, 6, 7, 8, 1, 
                    // Src: (st:isVoid (X86xor_flag:i16 GR16:i16:$src2, (ld:i16 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                    // Dst: (XOR16mr:isVoid addr:iPTR:$dst, GR16:i16:$src2)
/*12745*/         /*Scope*/ 35, /*->12781*/
/*12746*/           OPC_CheckPredicate, 3, // Predicate_loadi32
/*12748*/           OPC_MoveParent,
/*12749*/           OPC_CheckType, MVT::i32,
/*12751*/           OPC_MoveParent,
/*12752*/           OPC_MoveChild, 2,
/*12754*/           OPC_CheckSame, 3,
/*12756*/           OPC_MoveParent,
/*12757*/           OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*12759*/           OPC_CheckPredicate, 5, // Predicate_store
/*12761*/           OPC_CheckComplexPat, /*CP*/0, /*#*/3, // SelectAddr:$dst #4 #5 #6 #7 #8
/*12764*/           OPC_EmitMergeInputChains, 2, 0, 2, 
/*12768*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::XOR32mr), 0|OPFL_Chain|OPFL_MemRefs,
                        1/*#VTs*/, MVT::i32, 6/*#Ops*/, 4, 5, 6, 7, 8, 1, 
                    // Src: (st:isVoid (X86xor_flag:i32 GR32:i32:$src2, (ld:i32 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                    // Dst: (XOR32mr:isVoid addr:iPTR:$dst, GR32:i32:$src2)
/*12781*/         /*Scope*/ 37, /*->12819*/
/*12782*/           OPC_CheckPredicate, 8, // Predicate_load
/*12784*/           OPC_CheckPredicate, 9, // Predicate_dsload
/*12786*/           OPC_MoveParent,
/*12787*/           OPC_CheckType, MVT::i64,
/*12789*/           OPC_MoveParent,
/*12790*/           OPC_MoveChild, 2,
/*12792*/           OPC_CheckSame, 3,
/*12794*/           OPC_MoveParent,
/*12795*/           OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*12797*/           OPC_CheckPredicate, 5, // Predicate_store
/*12799*/           OPC_CheckComplexPat, /*CP*/0, /*#*/3, // SelectAddr:$dst #4 #5 #6 #7 #8
/*12802*/           OPC_EmitMergeInputChains, 2, 0, 2, 
/*12806*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::XOR64mr), 0|OPFL_Chain|OPFL_MemRefs,
                        1/*#VTs*/, MVT::i32, 6/*#Ops*/, 4, 5, 6, 7, 8, 1, 
                    // Src: (st:isVoid (X86xor_flag:i64 GR64:i64:$src2, (ld:i64 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                    // Dst: (XOR64mr:isVoid addr:iPTR:$dst, GR64:i64:$src2)
/*12819*/         0, /*End of Scope*/
/*12820*/       0, /*End of Scope*/
              /*SwitchOpcode*/ 124|128,4/*636*/,  X86ISD::AND,// ->13460
/*12824*/       OPC_Scope, 85|128,3/*469*/, /*->13296*/ // 2 children in Scope
/*12827*/         OPC_MoveChild, 0,
/*12829*/         OPC_CheckOpcode, ISD::LOAD,
/*12831*/         OPC_RecordMemRef,
/*12832*/         OPC_RecordNode, // #1 = 'ld' chained node
/*12833*/         OPC_CheckFoldableChainNode,
/*12834*/         OPC_RecordChild1, // #2 = $dst
/*12835*/         OPC_CheckPredicate, 2, // Predicate_unindexedload
/*12837*/         OPC_Scope, 45, /*->12884*/ // 9 children in Scope
/*12839*/           OPC_CheckPredicate, 6, // Predicate_loadi16
/*12841*/           OPC_MoveParent,
/*12842*/           OPC_RecordChild1, // #3 = $src2
/*12843*/           OPC_MoveChild, 1,
/*12845*/           OPC_CheckOpcode, ISD::Constant,
/*12847*/           OPC_CheckPredicate, 11, // Predicate_immSext8
/*12849*/           OPC_MoveParent,
/*12850*/           OPC_CheckType, MVT::i16,
/*12852*/           OPC_MoveParent,
/*12853*/           OPC_MoveChild, 2,
/*12855*/           OPC_CheckSame, 2,
/*12857*/           OPC_MoveParent,
/*12858*/           OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*12860*/           OPC_CheckPredicate, 5, // Predicate_store
/*12862*/           OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #4 #5 #6 #7 #8
/*12865*/           OPC_EmitMergeInputChains, 2, 0, 1, 
/*12869*/           OPC_EmitConvertToTarget, 3,
/*12871*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::AND16mi8), 0|OPFL_Chain|OPFL_MemRefs,
                        1/*#VTs*/, MVT::i32, 6/*#Ops*/, 4, 5, 6, 7, 8, 9, 
                    // Src: (st:isVoid (X86and_flag:i16 (ld:i16 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, (imm:i16)<<P:Predicate_immSext8>>:$src2), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                    // Dst: (AND16mi8:isVoid addr:iPTR:$dst, (imm:i16)<<P:Predicate_immSext8>>:$src2)
/*12884*/         /*Scope*/ 45, /*->12930*/
/*12885*/           OPC_CheckPredicate, 3, // Predicate_loadi32
/*12887*/           OPC_MoveParent,
/*12888*/           OPC_RecordChild1, // #3 = $src2
/*12889*/           OPC_MoveChild, 1,
/*12891*/           OPC_CheckOpcode, ISD::Constant,
/*12893*/           OPC_CheckPredicate, 11, // Predicate_immSext8
/*12895*/           OPC_MoveParent,
/*12896*/           OPC_CheckType, MVT::i32,
/*12898*/           OPC_MoveParent,
/*12899*/           OPC_MoveChild, 2,
/*12901*/           OPC_CheckSame, 2,
/*12903*/           OPC_MoveParent,
/*12904*/           OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*12906*/           OPC_CheckPredicate, 5, // Predicate_store
/*12908*/           OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #4 #5 #6 #7 #8
/*12911*/           OPC_EmitMergeInputChains, 2, 0, 1, 
/*12915*/           OPC_EmitConvertToTarget, 3,
/*12917*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::AND32mi8), 0|OPFL_Chain|OPFL_MemRefs,
                        1/*#VTs*/, MVT::i32, 6/*#Ops*/, 4, 5, 6, 7, 8, 9, 
                    // Src: (st:isVoid (X86and_flag:i32 (ld:i32 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, (imm:i32)<<P:Predicate_immSext8>>:$src2), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                    // Dst: (AND32mi8:isVoid addr:iPTR:$dst, (imm:i32)<<P:Predicate_immSext8>>:$src2)
/*12930*/         /*Scope*/ 124, /*->13055*/
/*12931*/           OPC_CheckPredicate, 8, // Predicate_load
/*12933*/           OPC_CheckPredicate, 9, // Predicate_dsload
/*12935*/           OPC_MoveParent,
/*12936*/           OPC_RecordChild1, // #3 = $src2
/*12937*/           OPC_MoveChild, 1,
/*12939*/           OPC_CheckOpcode, ISD::Constant,
/*12941*/           OPC_Scope, 37, /*->12980*/ // 3 children in Scope
/*12943*/             OPC_CheckPredicate, 11, // Predicate_immSext8
/*12945*/             OPC_MoveParent,
/*12946*/             OPC_CheckType, MVT::i64,
/*12948*/             OPC_MoveParent,
/*12949*/             OPC_MoveChild, 2,
/*12951*/             OPC_CheckSame, 2,
/*12953*/             OPC_MoveParent,
/*12954*/             OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*12956*/             OPC_CheckPredicate, 5, // Predicate_store
/*12958*/             OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #4 #5 #6 #7 #8
/*12961*/             OPC_EmitMergeInputChains, 2, 0, 1, 
/*12965*/             OPC_EmitConvertToTarget, 3,
/*12967*/             OPC_MorphNodeTo, TARGET_OPCODE(X86::AND64mi8), 0|OPFL_Chain|OPFL_MemRefs,
                          1/*#VTs*/, MVT::i32, 6/*#Ops*/, 4, 5, 6, 7, 8, 9, 
                      // Src: (st:isVoid (X86and_flag:i64 (ld:i64 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>, (imm:i64)<<P:Predicate_immSext8>>:$src2), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                      // Dst: (AND64mi8:isVoid addr:iPTR:$dst, (imm:i64)<<P:Predicate_immSext8>>:$src2)
/*12980*/           /*Scope*/ 37, /*->13018*/
/*12981*/             OPC_CheckPredicate, 12, // Predicate_i64immSExt32
/*12983*/             OPC_MoveParent,
/*12984*/             OPC_CheckType, MVT::i64,
/*12986*/             OPC_MoveParent,
/*12987*/             OPC_MoveChild, 2,
/*12989*/             OPC_CheckSame, 2,
/*12991*/             OPC_MoveParent,
/*12992*/             OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*12994*/             OPC_CheckPredicate, 5, // Predicate_store
/*12996*/             OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #4 #5 #6 #7 #8
/*12999*/             OPC_EmitMergeInputChains, 2, 0, 1, 
/*13003*/             OPC_EmitConvertToTarget, 3,
/*13005*/             OPC_MorphNodeTo, TARGET_OPCODE(X86::AND64mi32), 0|OPFL_Chain|OPFL_MemRefs,
                          1/*#VTs*/, MVT::i32, 6/*#Ops*/, 4, 5, 6, 7, 8, 9, 
                      // Src: (st:isVoid (X86and_flag:i64 (ld:i64 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>, (imm:i64)<<P:Predicate_i64immSExt32>>:$src2), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                      // Dst: (AND64mi32:isVoid addr:iPTR:$dst, (imm:i64)<<P:Predicate_i64immSExt32>>:$src2)
/*13018*/           /*Scope*/ 35, /*->13054*/
/*13019*/             OPC_MoveParent,
/*13020*/             OPC_CheckType, MVT::i8,
/*13022*/             OPC_MoveParent,
/*13023*/             OPC_MoveChild, 2,
/*13025*/             OPC_CheckSame, 2,
/*13027*/             OPC_MoveParent,
/*13028*/             OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*13030*/             OPC_CheckPredicate, 5, // Predicate_store
/*13032*/             OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #4 #5 #6 #7 #8
/*13035*/             OPC_EmitMergeInputChains, 2, 0, 1, 
/*13039*/             OPC_EmitConvertToTarget, 3,
/*13041*/             OPC_MorphNodeTo, TARGET_OPCODE(X86::AND8mi), 0|OPFL_Chain|OPFL_MemRefs,
                          1/*#VTs*/, MVT::i32, 6/*#Ops*/, 4, 5, 6, 7, 8, 9, 
                      // Src: (st:isVoid (X86and_flag:i8 (ld:i8 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>, (imm:i8):$src2), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                      // Dst: (AND8mi:isVoid addr:iPTR:$dst, (imm:i8):$src2)
/*13054*/           0, /*End of Scope*/
/*13055*/         /*Scope*/ 43, /*->13099*/
/*13056*/           OPC_CheckPredicate, 6, // Predicate_loadi16
/*13058*/           OPC_MoveParent,
/*13059*/           OPC_RecordChild1, // #3 = $src2
/*13060*/           OPC_MoveChild, 1,
/*13062*/           OPC_CheckOpcode, ISD::Constant,
/*13064*/           OPC_MoveParent,
/*13065*/           OPC_CheckType, MVT::i16,
/*13067*/           OPC_MoveParent,
/*13068*/           OPC_MoveChild, 2,
/*13070*/           OPC_CheckSame, 2,
/*13072*/           OPC_MoveParent,
/*13073*/           OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*13075*/           OPC_CheckPredicate, 5, // Predicate_store
/*13077*/           OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #4 #5 #6 #7 #8
/*13080*/           OPC_EmitMergeInputChains, 2, 0, 1, 
/*13084*/           OPC_EmitConvertToTarget, 3,
/*13086*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::AND16mi), 0|OPFL_Chain|OPFL_MemRefs,
                        1/*#VTs*/, MVT::i32, 6/*#Ops*/, 4, 5, 6, 7, 8, 9, 
                    // Src: (st:isVoid (X86and_flag:i16 (ld:i16 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, (imm:i16):$src2), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                    // Dst: (AND16mi:isVoid addr:iPTR:$dst, (imm:i16):$src2)
/*13099*/         /*Scope*/ 43, /*->13143*/
/*13100*/           OPC_CheckPredicate, 3, // Predicate_loadi32
/*13102*/           OPC_MoveParent,
/*13103*/           OPC_RecordChild1, // #3 = $src2
/*13104*/           OPC_MoveChild, 1,
/*13106*/           OPC_CheckOpcode, ISD::Constant,
/*13108*/           OPC_MoveParent,
/*13109*/           OPC_CheckType, MVT::i32,
/*13111*/           OPC_MoveParent,
/*13112*/           OPC_MoveChild, 2,
/*13114*/           OPC_CheckSame, 2,
/*13116*/           OPC_MoveParent,
/*13117*/           OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*13119*/           OPC_CheckPredicate, 5, // Predicate_store
/*13121*/           OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #4 #5 #6 #7 #8
/*13124*/           OPC_EmitMergeInputChains, 2, 0, 1, 
/*13128*/           OPC_EmitConvertToTarget, 3,
/*13130*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::AND32mi), 0|OPFL_Chain|OPFL_MemRefs,
                        1/*#VTs*/, MVT::i32, 6/*#Ops*/, 4, 5, 6, 7, 8, 9, 
                    // Src: (st:isVoid (X86and_flag:i32 (ld:i32 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, (imm:i32):$src2), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                    // Dst: (AND32mi:isVoid addr:iPTR:$dst, (imm:i32):$src2)
/*13143*/         /*Scope*/ 38, /*->13182*/
/*13144*/           OPC_CheckPredicate, 8, // Predicate_load
/*13146*/           OPC_CheckPredicate, 9, // Predicate_dsload
/*13148*/           OPC_MoveParent,
/*13149*/           OPC_RecordChild1, // #3 = $src2
/*13150*/           OPC_CheckType, MVT::i8,
/*13152*/           OPC_MoveParent,
/*13153*/           OPC_MoveChild, 2,
/*13155*/           OPC_CheckSame, 2,
/*13157*/           OPC_MoveParent,
/*13158*/           OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*13160*/           OPC_CheckPredicate, 5, // Predicate_store
/*13162*/           OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #4 #5 #6 #7 #8
/*13165*/           OPC_EmitMergeInputChains, 2, 0, 1, 
/*13169*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::AND8mr), 0|OPFL_Chain|OPFL_MemRefs,
                        1/*#VTs*/, MVT::i32, 6/*#Ops*/, 4, 5, 6, 7, 8, 3, 
                    // Src: (st:isVoid (X86and_flag:i8 (ld:i8 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>, GR8:i8:$src2), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                    // Dst: (AND8mr:isVoid addr:iPTR:$dst, GR8:i8:$src2)
/*13182*/         /*Scope*/ 36, /*->13219*/
/*13183*/           OPC_CheckPredicate, 6, // Predicate_loadi16
/*13185*/           OPC_MoveParent,
/*13186*/           OPC_RecordChild1, // #3 = $src2
/*13187*/           OPC_CheckType, MVT::i16,
/*13189*/           OPC_MoveParent,
/*13190*/           OPC_MoveChild, 2,
/*13192*/           OPC_CheckSame, 2,
/*13194*/           OPC_MoveParent,
/*13195*/           OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*13197*/           OPC_CheckPredicate, 5, // Predicate_store
/*13199*/           OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #4 #5 #6 #7 #8
/*13202*/           OPC_EmitMergeInputChains, 2, 0, 1, 
/*13206*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::AND16mr), 0|OPFL_Chain|OPFL_MemRefs,
                        1/*#VTs*/, MVT::i32, 6/*#Ops*/, 4, 5, 6, 7, 8, 3, 
                    // Src: (st:isVoid (X86and_flag:i16 (ld:i16 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, GR16:i16:$src2), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                    // Dst: (AND16mr:isVoid addr:iPTR:$dst, GR16:i16:$src2)
/*13219*/         /*Scope*/ 36, /*->13256*/
/*13220*/           OPC_CheckPredicate, 3, // Predicate_loadi32
/*13222*/           OPC_MoveParent,
/*13223*/           OPC_RecordChild1, // #3 = $src2
/*13224*/           OPC_CheckType, MVT::i32,
/*13226*/           OPC_MoveParent,
/*13227*/           OPC_MoveChild, 2,
/*13229*/           OPC_CheckSame, 2,
/*13231*/           OPC_MoveParent,
/*13232*/           OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*13234*/           OPC_CheckPredicate, 5, // Predicate_store
/*13236*/           OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #4 #5 #6 #7 #8
/*13239*/           OPC_EmitMergeInputChains, 2, 0, 1, 
/*13243*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::AND32mr), 0|OPFL_Chain|OPFL_MemRefs,
                        1/*#VTs*/, MVT::i32, 6/*#Ops*/, 4, 5, 6, 7, 8, 3, 
                    // Src: (st:isVoid (X86and_flag:i32 (ld:i32 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, GR32:i32:$src2), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                    // Dst: (AND32mr:isVoid addr:iPTR:$dst, GR32:i32:$src2)
/*13256*/         /*Scope*/ 38, /*->13295*/
/*13257*/           OPC_CheckPredicate, 8, // Predicate_load
/*13259*/           OPC_CheckPredicate, 9, // Predicate_dsload
/*13261*/           OPC_MoveParent,
/*13262*/           OPC_RecordChild1, // #3 = $src2
/*13263*/           OPC_CheckType, MVT::i64,
/*13265*/           OPC_MoveParent,
/*13266*/           OPC_MoveChild, 2,
/*13268*/           OPC_CheckSame, 2,
/*13270*/           OPC_MoveParent,
/*13271*/           OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*13273*/           OPC_CheckPredicate, 5, // Predicate_store
/*13275*/           OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #4 #5 #6 #7 #8
/*13278*/           OPC_EmitMergeInputChains, 2, 0, 1, 
/*13282*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::AND64mr), 0|OPFL_Chain|OPFL_MemRefs,
                        1/*#VTs*/, MVT::i32, 6/*#Ops*/, 4, 5, 6, 7, 8, 3, 
                    // Src: (st:isVoid (X86and_flag:i64 (ld:i64 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>, GR64:i64:$src2), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                    // Dst: (AND64mr:isVoid addr:iPTR:$dst, GR64:i64:$src2)
/*13295*/         0, /*End of Scope*/
/*13296*/       /*Scope*/ 33|128,1/*161*/, /*->13459*/
/*13298*/         OPC_RecordChild0, // #1 = $src2
/*13299*/         OPC_MoveChild, 1,
/*13301*/         OPC_CheckOpcode, ISD::LOAD,
/*13303*/         OPC_RecordMemRef,
/*13304*/         OPC_RecordNode, // #2 = 'ld' chained node
/*13305*/         OPC_CheckFoldableChainNode,
/*13306*/         OPC_RecordChild1, // #3 = $dst
/*13307*/         OPC_CheckPredicate, 2, // Predicate_unindexedload
/*13309*/         OPC_Scope, 37, /*->13348*/ // 4 children in Scope
/*13311*/           OPC_CheckPredicate, 8, // Predicate_load
/*13313*/           OPC_CheckPredicate, 9, // Predicate_dsload
/*13315*/           OPC_MoveParent,
/*13316*/           OPC_CheckType, MVT::i8,
/*13318*/           OPC_MoveParent,
/*13319*/           OPC_MoveChild, 2,
/*13321*/           OPC_CheckSame, 3,
/*13323*/           OPC_MoveParent,
/*13324*/           OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*13326*/           OPC_CheckPredicate, 5, // Predicate_store
/*13328*/           OPC_CheckComplexPat, /*CP*/0, /*#*/3, // SelectAddr:$dst #4 #5 #6 #7 #8
/*13331*/           OPC_EmitMergeInputChains, 2, 0, 2, 
/*13335*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::AND8mr), 0|OPFL_Chain|OPFL_MemRefs,
                        1/*#VTs*/, MVT::i32, 6/*#Ops*/, 4, 5, 6, 7, 8, 1, 
                    // Src: (st:isVoid (X86and_flag:i8 GR8:i8:$src2, (ld:i8 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                    // Dst: (AND8mr:isVoid addr:iPTR:$dst, GR8:i8:$src2)
/*13348*/         /*Scope*/ 35, /*->13384*/
/*13349*/           OPC_CheckPredicate, 6, // Predicate_loadi16
/*13351*/           OPC_MoveParent,
/*13352*/           OPC_CheckType, MVT::i16,
/*13354*/           OPC_MoveParent,
/*13355*/           OPC_MoveChild, 2,
/*13357*/           OPC_CheckSame, 3,
/*13359*/           OPC_MoveParent,
/*13360*/           OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*13362*/           OPC_CheckPredicate, 5, // Predicate_store
/*13364*/           OPC_CheckComplexPat, /*CP*/0, /*#*/3, // SelectAddr:$dst #4 #5 #6 #7 #8
/*13367*/           OPC_EmitMergeInputChains, 2, 0, 2, 
/*13371*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::AND16mr), 0|OPFL_Chain|OPFL_MemRefs,
                        1/*#VTs*/, MVT::i32, 6/*#Ops*/, 4, 5, 6, 7, 8, 1, 
                    // Src: (st:isVoid (X86and_flag:i16 GR16:i16:$src2, (ld:i16 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                    // Dst: (AND16mr:isVoid addr:iPTR:$dst, GR16:i16:$src2)
/*13384*/         /*Scope*/ 35, /*->13420*/
/*13385*/           OPC_CheckPredicate, 3, // Predicate_loadi32
/*13387*/           OPC_MoveParent,
/*13388*/           OPC_CheckType, MVT::i32,
/*13390*/           OPC_MoveParent,
/*13391*/           OPC_MoveChild, 2,
/*13393*/           OPC_CheckSame, 3,
/*13395*/           OPC_MoveParent,
/*13396*/           OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*13398*/           OPC_CheckPredicate, 5, // Predicate_store
/*13400*/           OPC_CheckComplexPat, /*CP*/0, /*#*/3, // SelectAddr:$dst #4 #5 #6 #7 #8
/*13403*/           OPC_EmitMergeInputChains, 2, 0, 2, 
/*13407*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::AND32mr), 0|OPFL_Chain|OPFL_MemRefs,
                        1/*#VTs*/, MVT::i32, 6/*#Ops*/, 4, 5, 6, 7, 8, 1, 
                    // Src: (st:isVoid (X86and_flag:i32 GR32:i32:$src2, (ld:i32 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                    // Dst: (AND32mr:isVoid addr:iPTR:$dst, GR32:i32:$src2)
/*13420*/         /*Scope*/ 37, /*->13458*/
/*13421*/           OPC_CheckPredicate, 8, // Predicate_load
/*13423*/           OPC_CheckPredicate, 9, // Predicate_dsload
/*13425*/           OPC_MoveParent,
/*13426*/           OPC_CheckType, MVT::i64,
/*13428*/           OPC_MoveParent,
/*13429*/           OPC_MoveChild, 2,
/*13431*/           OPC_CheckSame, 3,
/*13433*/           OPC_MoveParent,
/*13434*/           OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*13436*/           OPC_CheckPredicate, 5, // Predicate_store
/*13438*/           OPC_CheckComplexPat, /*CP*/0, /*#*/3, // SelectAddr:$dst #4 #5 #6 #7 #8
/*13441*/           OPC_EmitMergeInputChains, 2, 0, 2, 
/*13445*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::AND64mr), 0|OPFL_Chain|OPFL_MemRefs,
                        1/*#VTs*/, MVT::i32, 6/*#Ops*/, 4, 5, 6, 7, 8, 1, 
                    // Src: (st:isVoid (X86and_flag:i64 GR64:i64:$src2, (ld:i64 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                    // Dst: (AND64mr:isVoid addr:iPTR:$dst, GR64:i64:$src2)
/*13458*/         0, /*End of Scope*/
/*13459*/       0, /*End of Scope*/
              /*SwitchOpcode*/ 37|128,1/*165*/,  ISD::VECTOR_SHUFFLE,// ->13628
/*13463*/       OPC_MoveChild, 0,
/*13465*/       OPC_SwitchOpcode /*2 cases */, 50,  ISD::BIT_CONVERT,// ->13518
/*13468*/         OPC_MoveChild, 0,
/*13470*/         OPC_CheckOpcode, ISD::LOAD,
/*13472*/         OPC_RecordMemRef,
/*13473*/         OPC_RecordNode, // #1 = 'ld' chained node
/*13474*/         OPC_CheckFoldableChainNode,
/*13475*/         OPC_RecordChild1, // #2 = $src1
/*13476*/         OPC_CheckPredicate, 2, // Predicate_unindexedload
/*13478*/         OPC_CheckPredicate, 8, // Predicate_load
/*13480*/         OPC_CheckType, MVT::v2i64,
/*13482*/         OPC_MoveParent,
/*13483*/         OPC_MoveParent,
/*13484*/         OPC_RecordChild1, // #3 = $src2
/*13485*/         OPC_CheckPredicate, 13, // Predicate_movlp
/*13487*/         OPC_CheckType, MVT::v4i32,
/*13489*/         OPC_MoveParent,
/*13490*/         OPC_MoveChild, 2,
/*13492*/         OPC_CheckSame, 2,
/*13494*/         OPC_MoveParent,
/*13495*/         OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*13497*/         OPC_CheckPredicate, 5, // Predicate_store
/*13499*/         OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src1 #4 #5 #6 #7 #8
/*13502*/         OPC_EmitMergeInputChains, 2, 0, 1, 
/*13506*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVLPSmr), 0|OPFL_Chain|OPFL_MemRefs,
                      0/*#VTs*/, 6/*#Ops*/, 4, 5, 6, 7, 8, 3, 
                  // Src: (st:isVoid (vector_shuffle:v4i32 (bitconvert:v4i32 (ld:v2i64 addr:iPTR:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>), VR128:v4i32:$src2)<<P:Predicate_movlp>>, addr:iPTR:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                  // Dst: (MOVLPSmr:isVoid addr:iPTR:$src1, VR128:v16i8:$src2)
                /*SwitchOpcode*/ 107,  ISD::LOAD,// ->13627
/*13520*/         OPC_RecordMemRef,
/*13521*/         OPC_RecordNode, // #1 = 'ld' chained node
/*13522*/         OPC_CheckFoldableChainNode,
/*13523*/         OPC_RecordChild1, // #2 = $src1
/*13524*/         OPC_CheckPredicate, 2, // Predicate_unindexedload
/*13526*/         OPC_CheckPredicate, 8, // Predicate_load
/*13528*/         OPC_MoveParent,
/*13529*/         OPC_RecordChild1, // #3 = $src2
/*13530*/         OPC_CheckPredicate, 13, // Predicate_movlp
/*13532*/         OPC_SwitchType /*3 cases */, 29,  MVT::v4f32,// ->13564
/*13535*/           OPC_MoveParent,
/*13536*/           OPC_MoveChild, 2,
/*13538*/           OPC_CheckSame, 2,
/*13540*/           OPC_MoveParent,
/*13541*/           OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*13543*/           OPC_CheckPredicate, 5, // Predicate_store
/*13545*/           OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src1 #4 #5 #6 #7 #8
/*13548*/           OPC_EmitMergeInputChains, 2, 0, 1, 
/*13552*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVLPSmr), 0|OPFL_Chain|OPFL_MemRefs,
                        0/*#VTs*/, 6/*#Ops*/, 4, 5, 6, 7, 8, 3, 
                    // Src: (st:isVoid (vector_shuffle:v4f32 (ld:v4f32 addr:iPTR:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:v4f32:$src2)<<P:Predicate_movlp>>, addr:iPTR:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                    // Dst: (MOVLPSmr:isVoid addr:iPTR:$src1, VR128:v16i8:$src2)
                  /*SwitchType*/ 29,  MVT::v2f64,// ->13595
/*13566*/           OPC_MoveParent,
/*13567*/           OPC_MoveChild, 2,
/*13569*/           OPC_CheckSame, 2,
/*13571*/           OPC_MoveParent,
/*13572*/           OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*13574*/           OPC_CheckPredicate, 5, // Predicate_store
/*13576*/           OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src1 #4 #5 #6 #7 #8
/*13579*/           OPC_EmitMergeInputChains, 2, 0, 1, 
/*13583*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVLPDmr), 0|OPFL_Chain|OPFL_MemRefs,
                        0/*#VTs*/, 6/*#Ops*/, 4, 5, 6, 7, 8, 3, 
                    // Src: (st:isVoid (vector_shuffle:v2f64 (ld:v2f64 addr:iPTR:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:v2f64:$src2)<<P:Predicate_movlp>>, addr:iPTR:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                    // Dst: (MOVLPDmr:isVoid addr:iPTR:$src1, VR128:v16i8:$src2)
                  /*SwitchType*/ 29,  MVT::v2i64,// ->13626
/*13597*/           OPC_MoveParent,
/*13598*/           OPC_MoveChild, 2,
/*13600*/           OPC_CheckSame, 2,
/*13602*/           OPC_MoveParent,
/*13603*/           OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*13605*/           OPC_CheckPredicate, 5, // Predicate_store
/*13607*/           OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src1 #4 #5 #6 #7 #8
/*13610*/           OPC_EmitMergeInputChains, 2, 0, 1, 
/*13614*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVLPDmr), 0|OPFL_Chain|OPFL_MemRefs,
                        0/*#VTs*/, 6/*#Ops*/, 4, 5, 6, 7, 8, 3, 
                    // Src: (st:isVoid (vector_shuffle:v2i64 (ld:v2i64 addr:iPTR:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:v2i64:$src2)<<P:Predicate_movlp>>, addr:iPTR:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                    // Dst: (MOVLPDmr:isVoid addr:iPTR:$src1, VR128:v16i8:$src2)
                  0, // EndSwitchType
                0, // EndSwitchOpcode
              /*SwitchOpcode*/ 27|128,2/*283*/,  X86ISD::SHLD,// ->13914
/*13631*/       OPC_MoveChild, 0,
/*13633*/       OPC_CheckOpcode, ISD::LOAD,
/*13635*/       OPC_RecordMemRef,
/*13636*/       OPC_RecordNode, // #1 = 'ld' chained node
/*13637*/       OPC_CheckFoldableChainNode,
/*13638*/       OPC_RecordChild1, // #2 = $dst
/*13639*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*13641*/       OPC_Scope, 46, /*->13689*/ // 6 children in Scope
/*13643*/         OPC_CheckPredicate, 3, // Predicate_loadi32
/*13645*/         OPC_MoveParent,
/*13646*/         OPC_RecordChild1, // #3 = $src2
/*13647*/         OPC_RecordChild2, // #4 = $src3
/*13648*/         OPC_MoveChild, 2,
/*13650*/         OPC_CheckOpcode, ISD::Constant,
/*13652*/         OPC_CheckType, MVT::i8,
/*13654*/         OPC_MoveParent,
/*13655*/         OPC_CheckType, MVT::i32,
/*13657*/         OPC_MoveParent,
/*13658*/         OPC_MoveChild, 2,
/*13660*/         OPC_CheckSame, 2,
/*13662*/         OPC_MoveParent,
/*13663*/         OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*13665*/         OPC_CheckPredicate, 5, // Predicate_store
/*13667*/         OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #5 #6 #7 #8 #9
/*13670*/         OPC_EmitMergeInputChains, 2, 0, 1, 
/*13674*/         OPC_EmitConvertToTarget, 4,
/*13676*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::SHLD32mri8), 0|OPFL_Chain|OPFL_MemRefs,
                      0/*#VTs*/, 7/*#Ops*/, 5, 6, 7, 8, 9, 3, 10, 
                  // Src: (st:isVoid (X86shld:i32 (ld:i32 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, GR32:i32:$src2, (imm:i8):$src3), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                  // Dst: (SHLD32mri8:isVoid addr:iPTR:$dst, GR32:i32:$src2, (imm:i8):$src3)
/*13689*/       /*Scope*/ 46, /*->13736*/
/*13690*/         OPC_CheckPredicate, 6, // Predicate_loadi16
/*13692*/         OPC_MoveParent,
/*13693*/         OPC_RecordChild1, // #3 = $src2
/*13694*/         OPC_RecordChild2, // #4 = $src3
/*13695*/         OPC_MoveChild, 2,
/*13697*/         OPC_CheckOpcode, ISD::Constant,
/*13699*/         OPC_CheckType, MVT::i8,
/*13701*/         OPC_MoveParent,
/*13702*/         OPC_CheckType, MVT::i16,
/*13704*/         OPC_MoveParent,
/*13705*/         OPC_MoveChild, 2,
/*13707*/         OPC_CheckSame, 2,
/*13709*/         OPC_MoveParent,
/*13710*/         OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*13712*/         OPC_CheckPredicate, 5, // Predicate_store
/*13714*/         OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #5 #6 #7 #8 #9
/*13717*/         OPC_EmitMergeInputChains, 2, 0, 1, 
/*13721*/         OPC_EmitConvertToTarget, 4,
/*13723*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::SHLD16mri8), 0|OPFL_Chain|OPFL_MemRefs,
                      0/*#VTs*/, 7/*#Ops*/, 5, 6, 7, 8, 9, 3, 10, 
                  // Src: (st:isVoid (X86shld:i16 (ld:i16 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, GR16:i16:$src2, (imm:i8):$src3), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                  // Dst: (SHLD16mri8:isVoid addr:iPTR:$dst, GR16:i16:$src2, (imm:i8):$src3)
/*13736*/       /*Scope*/ 48, /*->13785*/
/*13737*/         OPC_CheckPredicate, 8, // Predicate_load
/*13739*/         OPC_CheckPredicate, 9, // Predicate_dsload
/*13741*/         OPC_MoveParent,
/*13742*/         OPC_RecordChild1, // #3 = $src2
/*13743*/         OPC_RecordChild2, // #4 = $src3
/*13744*/         OPC_MoveChild, 2,
/*13746*/         OPC_CheckOpcode, ISD::Constant,
/*13748*/         OPC_CheckType, MVT::i8,
/*13750*/         OPC_MoveParent,
/*13751*/         OPC_CheckType, MVT::i64,
/*13753*/         OPC_MoveParent,
/*13754*/         OPC_MoveChild, 2,
/*13756*/         OPC_CheckSame, 2,
/*13758*/         OPC_MoveParent,
/*13759*/         OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*13761*/         OPC_CheckPredicate, 5, // Predicate_store
/*13763*/         OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #5 #6 #7 #8 #9
/*13766*/         OPC_EmitMergeInputChains, 2, 0, 1, 
/*13770*/         OPC_EmitConvertToTarget, 4,
/*13772*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::SHLD64mri8), 0|OPFL_Chain|OPFL_MemRefs,
                      0/*#VTs*/, 7/*#Ops*/, 5, 6, 7, 8, 9, 3, 10, 
                  // Src: (st:isVoid (X86shld:i64 (ld:i64 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>, GR64:i64:$src2, (imm:i8):$src3), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                  // Dst: (SHLD64mri8:isVoid addr:iPTR:$dst, GR64:i64:$src2, (imm:i8):$src3)
/*13785*/       /*Scope*/ 41, /*->13827*/
/*13786*/         OPC_CheckPredicate, 3, // Predicate_loadi32
/*13788*/         OPC_MoveParent,
/*13789*/         OPC_RecordChild1, // #3 = $src2
/*13790*/         OPC_RecordChild2, // #4 = physreg input CL
/*13791*/         OPC_CheckChild2Type, MVT::i8,
/*13793*/         OPC_CheckType, MVT::i32,
/*13795*/         OPC_MoveParent,
/*13796*/         OPC_MoveChild, 2,
/*13798*/         OPC_CheckSame, 2,
/*13800*/         OPC_MoveParent,
/*13801*/         OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*13803*/         OPC_CheckPredicate, 5, // Predicate_store
/*13805*/         OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #5 #6 #7 #8 #9
/*13808*/         OPC_EmitMergeInputChains, 2, 0, 1, 
/*13812*/         OPC_EmitCopyToReg, 4, X86::CL,
/*13815*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::SHLD32mrCL), 0|OPFL_Chain|OPFL_FlagInput|OPFL_MemRefs,
                      0/*#VTs*/, 6/*#Ops*/, 5, 6, 7, 8, 9, 3, 
                  // Src: (st:isVoid (X86shld:i32 (ld:i32 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, GR32:i32:$src2, CL:i8), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                  // Dst: (SHLD32mrCL:isVoid addr:iPTR:$dst, GR32:i32:$src2)
/*13827*/       /*Scope*/ 41, /*->13869*/
/*13828*/         OPC_CheckPredicate, 6, // Predicate_loadi16
/*13830*/         OPC_MoveParent,
/*13831*/         OPC_RecordChild1, // #3 = $src2
/*13832*/         OPC_RecordChild2, // #4 = physreg input CL
/*13833*/         OPC_CheckChild2Type, MVT::i8,
/*13835*/         OPC_CheckType, MVT::i16,
/*13837*/         OPC_MoveParent,
/*13838*/         OPC_MoveChild, 2,
/*13840*/         OPC_CheckSame, 2,
/*13842*/         OPC_MoveParent,
/*13843*/         OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*13845*/         OPC_CheckPredicate, 5, // Predicate_store
/*13847*/         OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #5 #6 #7 #8 #9
/*13850*/         OPC_EmitMergeInputChains, 2, 0, 1, 
/*13854*/         OPC_EmitCopyToReg, 4, X86::CL,
/*13857*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::SHLD16mrCL), 0|OPFL_Chain|OPFL_FlagInput|OPFL_MemRefs,
                      0/*#VTs*/, 6/*#Ops*/, 5, 6, 7, 8, 9, 3, 
                  // Src: (st:isVoid (X86shld:i16 (ld:i16 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, GR16:i16:$src2, CL:i8), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                  // Dst: (SHLD16mrCL:isVoid addr:iPTR:$dst, GR16:i16:$src2)
/*13869*/       /*Scope*/ 43, /*->13913*/
/*13870*/         OPC_CheckPredicate, 8, // Predicate_load
/*13872*/         OPC_CheckPredicate, 9, // Predicate_dsload
/*13874*/         OPC_MoveParent,
/*13875*/         OPC_RecordChild1, // #3 = $src2
/*13876*/         OPC_RecordChild2, // #4 = physreg input CL
/*13877*/         OPC_CheckChild2Type, MVT::i8,
/*13879*/         OPC_CheckType, MVT::i64,
/*13881*/         OPC_MoveParent,
/*13882*/         OPC_MoveChild, 2,
/*13884*/         OPC_CheckSame, 2,
/*13886*/         OPC_MoveParent,
/*13887*/         OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*13889*/         OPC_CheckPredicate, 5, // Predicate_store
/*13891*/         OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #5 #6 #7 #8 #9
/*13894*/         OPC_EmitMergeInputChains, 2, 0, 1, 
/*13898*/         OPC_EmitCopyToReg, 4, X86::CL,
/*13901*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::SHLD64mrCL), 0|OPFL_Chain|OPFL_FlagInput|OPFL_MemRefs,
                      0/*#VTs*/, 6/*#Ops*/, 5, 6, 7, 8, 9, 3, 
                  // Src: (st:isVoid (X86shld:i64 (ld:i64 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>, GR64:i64:$src2, CL:i8), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                  // Dst: (SHLD64mrCL:isVoid addr:iPTR:$dst, GR64:i64:$src2)
/*13913*/       0, /*End of Scope*/
              /*SwitchOpcode*/ 27|128,2/*283*/,  X86ISD::SHRD,// ->14200
/*13917*/       OPC_MoveChild, 0,
/*13919*/       OPC_CheckOpcode, ISD::LOAD,
/*13921*/       OPC_RecordMemRef,
/*13922*/       OPC_RecordNode, // #1 = 'ld' chained node
/*13923*/       OPC_CheckFoldableChainNode,
/*13924*/       OPC_RecordChild1, // #2 = $dst
/*13925*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*13927*/       OPC_Scope, 46, /*->13975*/ // 6 children in Scope
/*13929*/         OPC_CheckPredicate, 3, // Predicate_loadi32
/*13931*/         OPC_MoveParent,
/*13932*/         OPC_RecordChild1, // #3 = $src2
/*13933*/         OPC_RecordChild2, // #4 = $src3
/*13934*/         OPC_MoveChild, 2,
/*13936*/         OPC_CheckOpcode, ISD::Constant,
/*13938*/         OPC_CheckType, MVT::i8,
/*13940*/         OPC_MoveParent,
/*13941*/         OPC_CheckType, MVT::i32,
/*13943*/         OPC_MoveParent,
/*13944*/         OPC_MoveChild, 2,
/*13946*/         OPC_CheckSame, 2,
/*13948*/         OPC_MoveParent,
/*13949*/         OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*13951*/         OPC_CheckPredicate, 5, // Predicate_store
/*13953*/         OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #5 #6 #7 #8 #9
/*13956*/         OPC_EmitMergeInputChains, 2, 0, 1, 
/*13960*/         OPC_EmitConvertToTarget, 4,
/*13962*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::SHRD32mri8), 0|OPFL_Chain|OPFL_MemRefs,
                      0/*#VTs*/, 7/*#Ops*/, 5, 6, 7, 8, 9, 3, 10, 
                  // Src: (st:isVoid (X86shrd:i32 (ld:i32 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, GR32:i32:$src2, (imm:i8):$src3), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                  // Dst: (SHRD32mri8:isVoid addr:iPTR:$dst, GR32:i32:$src2, (imm:i8):$src3)
/*13975*/       /*Scope*/ 46, /*->14022*/
/*13976*/         OPC_CheckPredicate, 6, // Predicate_loadi16
/*13978*/         OPC_MoveParent,
/*13979*/         OPC_RecordChild1, // #3 = $src2
/*13980*/         OPC_RecordChild2, // #4 = $src3
/*13981*/         OPC_MoveChild, 2,
/*13983*/         OPC_CheckOpcode, ISD::Constant,
/*13985*/         OPC_CheckType, MVT::i8,
/*13987*/         OPC_MoveParent,
/*13988*/         OPC_CheckType, MVT::i16,
/*13990*/         OPC_MoveParent,
/*13991*/         OPC_MoveChild, 2,
/*13993*/         OPC_CheckSame, 2,
/*13995*/         OPC_MoveParent,
/*13996*/         OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*13998*/         OPC_CheckPredicate, 5, // Predicate_store
/*14000*/         OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #5 #6 #7 #8 #9
/*14003*/         OPC_EmitMergeInputChains, 2, 0, 1, 
/*14007*/         OPC_EmitConvertToTarget, 4,
/*14009*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::SHRD16mri8), 0|OPFL_Chain|OPFL_MemRefs,
                      0/*#VTs*/, 7/*#Ops*/, 5, 6, 7, 8, 9, 3, 10, 
                  // Src: (st:isVoid (X86shrd:i16 (ld:i16 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, GR16:i16:$src2, (imm:i8):$src3), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                  // Dst: (SHRD16mri8:isVoid addr:iPTR:$dst, GR16:i16:$src2, (imm:i8):$src3)
/*14022*/       /*Scope*/ 48, /*->14071*/
/*14023*/         OPC_CheckPredicate, 8, // Predicate_load
/*14025*/         OPC_CheckPredicate, 9, // Predicate_dsload
/*14027*/         OPC_MoveParent,
/*14028*/         OPC_RecordChild1, // #3 = $src2
/*14029*/         OPC_RecordChild2, // #4 = $src3
/*14030*/         OPC_MoveChild, 2,
/*14032*/         OPC_CheckOpcode, ISD::Constant,
/*14034*/         OPC_CheckType, MVT::i8,
/*14036*/         OPC_MoveParent,
/*14037*/         OPC_CheckType, MVT::i64,
/*14039*/         OPC_MoveParent,
/*14040*/         OPC_MoveChild, 2,
/*14042*/         OPC_CheckSame, 2,
/*14044*/         OPC_MoveParent,
/*14045*/         OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*14047*/         OPC_CheckPredicate, 5, // Predicate_store
/*14049*/         OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #5 #6 #7 #8 #9
/*14052*/         OPC_EmitMergeInputChains, 2, 0, 1, 
/*14056*/         OPC_EmitConvertToTarget, 4,
/*14058*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::SHRD64mri8), 0|OPFL_Chain|OPFL_MemRefs,
                      0/*#VTs*/, 7/*#Ops*/, 5, 6, 7, 8, 9, 3, 10, 
                  // Src: (st:isVoid (X86shrd:i64 (ld:i64 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>, GR64:i64:$src2, (imm:i8):$src3), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                  // Dst: (SHRD64mri8:isVoid addr:iPTR:$dst, GR64:i64:$src2, (imm:i8):$src3)
/*14071*/       /*Scope*/ 41, /*->14113*/
/*14072*/         OPC_CheckPredicate, 3, // Predicate_loadi32
/*14074*/         OPC_MoveParent,
/*14075*/         OPC_RecordChild1, // #3 = $src2
/*14076*/         OPC_RecordChild2, // #4 = physreg input CL
/*14077*/         OPC_CheckChild2Type, MVT::i8,
/*14079*/         OPC_CheckType, MVT::i32,
/*14081*/         OPC_MoveParent,
/*14082*/         OPC_MoveChild, 2,
/*14084*/         OPC_CheckSame, 2,
/*14086*/         OPC_MoveParent,
/*14087*/         OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*14089*/         OPC_CheckPredicate, 5, // Predicate_store
/*14091*/         OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #5 #6 #7 #8 #9
/*14094*/         OPC_EmitMergeInputChains, 2, 0, 1, 
/*14098*/         OPC_EmitCopyToReg, 4, X86::CL,
/*14101*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::SHRD32mrCL), 0|OPFL_Chain|OPFL_FlagInput|OPFL_MemRefs,
                      0/*#VTs*/, 6/*#Ops*/, 5, 6, 7, 8, 9, 3, 
                  // Src: (st:isVoid (X86shrd:i32 (ld:i32 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, GR32:i32:$src2, CL:i8), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                  // Dst: (SHRD32mrCL:isVoid addr:iPTR:$dst, GR32:i32:$src2)
/*14113*/       /*Scope*/ 41, /*->14155*/
/*14114*/         OPC_CheckPredicate, 6, // Predicate_loadi16
/*14116*/         OPC_MoveParent,
/*14117*/         OPC_RecordChild1, // #3 = $src2
/*14118*/         OPC_RecordChild2, // #4 = physreg input CL
/*14119*/         OPC_CheckChild2Type, MVT::i8,
/*14121*/         OPC_CheckType, MVT::i16,
/*14123*/         OPC_MoveParent,
/*14124*/         OPC_MoveChild, 2,
/*14126*/         OPC_CheckSame, 2,
/*14128*/         OPC_MoveParent,
/*14129*/         OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*14131*/         OPC_CheckPredicate, 5, // Predicate_store
/*14133*/         OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #5 #6 #7 #8 #9
/*14136*/         OPC_EmitMergeInputChains, 2, 0, 1, 
/*14140*/         OPC_EmitCopyToReg, 4, X86::CL,
/*14143*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::SHRD16mrCL), 0|OPFL_Chain|OPFL_FlagInput|OPFL_MemRefs,
                      0/*#VTs*/, 6/*#Ops*/, 5, 6, 7, 8, 9, 3, 
                  // Src: (st:isVoid (X86shrd:i16 (ld:i16 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, GR16:i16:$src2, CL:i8), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                  // Dst: (SHRD16mrCL:isVoid addr:iPTR:$dst, GR16:i16:$src2)
/*14155*/       /*Scope*/ 43, /*->14199*/
/*14156*/         OPC_CheckPredicate, 8, // Predicate_load
/*14158*/         OPC_CheckPredicate, 9, // Predicate_dsload
/*14160*/         OPC_MoveParent,
/*14161*/         OPC_RecordChild1, // #3 = $src2
/*14162*/         OPC_RecordChild2, // #4 = physreg input CL
/*14163*/         OPC_CheckChild2Type, MVT::i8,
/*14165*/         OPC_CheckType, MVT::i64,
/*14167*/         OPC_MoveParent,
/*14168*/         OPC_MoveChild, 2,
/*14170*/         OPC_CheckSame, 2,
/*14172*/         OPC_MoveParent,
/*14173*/         OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*14175*/         OPC_CheckPredicate, 5, // Predicate_store
/*14177*/         OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #5 #6 #7 #8 #9
/*14180*/         OPC_EmitMergeInputChains, 2, 0, 1, 
/*14184*/         OPC_EmitCopyToReg, 4, X86::CL,
/*14187*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::SHRD64mrCL), 0|OPFL_Chain|OPFL_FlagInput|OPFL_MemRefs,
                      0/*#VTs*/, 6/*#Ops*/, 5, 6, 7, 8, 9, 3, 
                  // Src: (st:isVoid (X86shrd:i64 (ld:i64 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>, GR64:i64:$src2, CL:i8), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                  // Dst: (SHRD64mrCL:isVoid addr:iPTR:$dst, GR64:i64:$src2)
/*14199*/       0, /*End of Scope*/
              /*SwitchOpcode*/ 116|128,1/*244*/,  X86ISD::INC,// ->14447
/*14203*/       OPC_MoveChild, 0,
/*14205*/       OPC_CheckOpcode, ISD::LOAD,
/*14207*/       OPC_RecordMemRef,
/*14208*/       OPC_RecordNode, // #1 = 'ld' chained node
/*14209*/       OPC_CheckFoldableChainNode,
/*14210*/       OPC_RecordChild1, // #2 = $dst
/*14211*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*14213*/       OPC_SwitchType /*4 cases */, 36,  MVT::i8,// ->14252
/*14216*/         OPC_CheckPredicate, 8, // Predicate_load
/*14218*/         OPC_CheckPredicate, 9, // Predicate_dsload
/*14220*/         OPC_MoveParent,
/*14221*/         OPC_CheckType, MVT::i8,
/*14223*/         OPC_MoveParent,
/*14224*/         OPC_MoveChild, 2,
/*14226*/         OPC_CheckSame, 2,
/*14228*/         OPC_MoveParent,
/*14229*/         OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*14231*/         OPC_CheckPredicate, 5, // Predicate_store
/*14233*/         OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #3 #4 #5 #6 #7
/*14236*/         OPC_EmitMergeInputChains, 2, 0, 1, 
/*14240*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::INC8m), 0|OPFL_Chain|OPFL_MemRefs,
                      1/*#VTs*/, MVT::i32, 5/*#Ops*/, 3, 4, 5, 6, 7, 
                  // Src: (st:isVoid (X86inc_flag:i8 (ld:i8 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                  // Dst: (INC8m:isVoid addr:iPTR:$dst)
                /*SwitchType*/ 76,  MVT::i16,// ->14330
/*14254*/         OPC_Scope, 36, /*->14292*/ // 2 children in Scope
/*14256*/           OPC_CheckPredicate, 6, // Predicate_loadi16
/*14258*/           OPC_MoveParent,
/*14259*/           OPC_CheckType, MVT::i16,
/*14261*/           OPC_MoveParent,
/*14262*/           OPC_MoveChild, 2,
/*14264*/           OPC_CheckSame, 2,
/*14266*/           OPC_MoveParent,
/*14267*/           OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*14269*/           OPC_CheckPredicate, 5, // Predicate_store
/*14271*/           OPC_CheckPatternPredicate, 2, // (!Subtarget->is64Bit())
/*14273*/           OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #3 #4 #5 #6 #7
/*14276*/           OPC_EmitMergeInputChains, 2, 0, 1, 
/*14280*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::INC16m), 0|OPFL_Chain|OPFL_MemRefs,
                        1/*#VTs*/, MVT::i32, 5/*#Ops*/, 3, 4, 5, 6, 7, 
                    // Src: (st:isVoid (X86inc_flag:i16 (ld:i16 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                    // Dst: (INC16m:isVoid addr:iPTR:$dst)
/*14292*/         /*Scope*/ 36, /*->14329*/
/*14293*/           OPC_CheckPredicate, 6, // Predicate_loadi16
/*14295*/           OPC_MoveParent,
/*14296*/           OPC_CheckType, MVT::i16,
/*14298*/           OPC_MoveParent,
/*14299*/           OPC_MoveChild, 2,
/*14301*/           OPC_CheckSame, 2,
/*14303*/           OPC_MoveParent,
/*14304*/           OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*14306*/           OPC_CheckPredicate, 5, // Predicate_store
/*14308*/           OPC_CheckPatternPredicate, 3, // (Subtarget->is64Bit())
/*14310*/           OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #3 #4 #5 #6 #7
/*14313*/           OPC_EmitMergeInputChains, 2, 0, 1, 
/*14317*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::INC64_16m), 0|OPFL_Chain|OPFL_MemRefs,
                        1/*#VTs*/, MVT::i32, 5/*#Ops*/, 3, 4, 5, 6, 7, 
                    // Src: (st:isVoid (X86inc_flag:i16 (ld:i16 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                    // Dst: (INC64_16m:isVoid addr:iPTR:$dst)
/*14329*/         0, /*End of Scope*/
                /*SwitchType*/ 76,  MVT::i32,// ->14408
/*14332*/         OPC_Scope, 36, /*->14370*/ // 2 children in Scope
/*14334*/           OPC_CheckPredicate, 3, // Predicate_loadi32
/*14336*/           OPC_MoveParent,
/*14337*/           OPC_CheckType, MVT::i32,
/*14339*/           OPC_MoveParent,
/*14340*/           OPC_MoveChild, 2,
/*14342*/           OPC_CheckSame, 2,
/*14344*/           OPC_MoveParent,
/*14345*/           OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*14347*/           OPC_CheckPredicate, 5, // Predicate_store
/*14349*/           OPC_CheckPatternPredicate, 2, // (!Subtarget->is64Bit())
/*14351*/           OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #3 #4 #5 #6 #7
/*14354*/           OPC_EmitMergeInputChains, 2, 0, 1, 
/*14358*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::INC32m), 0|OPFL_Chain|OPFL_MemRefs,
                        1/*#VTs*/, MVT::i32, 5/*#Ops*/, 3, 4, 5, 6, 7, 
                    // Src: (st:isVoid (X86inc_flag:i32 (ld:i32 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                    // Dst: (INC32m:isVoid addr:iPTR:$dst)
/*14370*/         /*Scope*/ 36, /*->14407*/
/*14371*/           OPC_CheckPredicate, 3, // Predicate_loadi32
/*14373*/           OPC_MoveParent,
/*14374*/           OPC_CheckType, MVT::i32,
/*14376*/           OPC_MoveParent,
/*14377*/           OPC_MoveChild, 2,
/*14379*/           OPC_CheckSame, 2,
/*14381*/           OPC_MoveParent,
/*14382*/           OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*14384*/           OPC_CheckPredicate, 5, // Predicate_store
/*14386*/           OPC_CheckPatternPredicate, 3, // (Subtarget->is64Bit())
/*14388*/           OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #3 #4 #5 #6 #7
/*14391*/           OPC_EmitMergeInputChains, 2, 0, 1, 
/*14395*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::INC64_32m), 0|OPFL_Chain|OPFL_MemRefs,
                        1/*#VTs*/, MVT::i32, 5/*#Ops*/, 3, 4, 5, 6, 7, 
                    // Src: (st:isVoid (X86inc_flag:i32 (ld:i32 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                    // Dst: (INC64_32m:isVoid addr:iPTR:$dst)
/*14407*/         0, /*End of Scope*/
                /*SwitchType*/ 36,  MVT::i64,// ->14446
/*14410*/         OPC_CheckPredicate, 8, // Predicate_load
/*14412*/         OPC_CheckPredicate, 9, // Predicate_dsload
/*14414*/         OPC_MoveParent,
/*14415*/         OPC_CheckType, MVT::i64,
/*14417*/         OPC_MoveParent,
/*14418*/         OPC_MoveChild, 2,
/*14420*/         OPC_CheckSame, 2,
/*14422*/         OPC_MoveParent,
/*14423*/         OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*14425*/         OPC_CheckPredicate, 5, // Predicate_store
/*14427*/         OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #3 #4 #5 #6 #7
/*14430*/         OPC_EmitMergeInputChains, 2, 0, 1, 
/*14434*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::INC64m), 0|OPFL_Chain|OPFL_MemRefs,
                      1/*#VTs*/, MVT::i32, 5/*#Ops*/, 3, 4, 5, 6, 7, 
                  // Src: (st:isVoid (X86inc_flag:i64 (ld:i64 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                  // Dst: (INC64m:isVoid addr:iPTR:$dst)
                0, // EndSwitchType
              /*SwitchOpcode*/ 116|128,1/*244*/,  X86ISD::DEC,// ->14694
/*14450*/       OPC_MoveChild, 0,
/*14452*/       OPC_CheckOpcode, ISD::LOAD,
/*14454*/       OPC_RecordMemRef,
/*14455*/       OPC_RecordNode, // #1 = 'ld' chained node
/*14456*/       OPC_CheckFoldableChainNode,
/*14457*/       OPC_RecordChild1, // #2 = $dst
/*14458*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*14460*/       OPC_SwitchType /*4 cases */, 36,  MVT::i8,// ->14499
/*14463*/         OPC_CheckPredicate, 8, // Predicate_load
/*14465*/         OPC_CheckPredicate, 9, // Predicate_dsload
/*14467*/         OPC_MoveParent,
/*14468*/         OPC_CheckType, MVT::i8,
/*14470*/         OPC_MoveParent,
/*14471*/         OPC_MoveChild, 2,
/*14473*/         OPC_CheckSame, 2,
/*14475*/         OPC_MoveParent,
/*14476*/         OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*14478*/         OPC_CheckPredicate, 5, // Predicate_store
/*14480*/         OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #3 #4 #5 #6 #7
/*14483*/         OPC_EmitMergeInputChains, 2, 0, 1, 
/*14487*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::DEC8m), 0|OPFL_Chain|OPFL_MemRefs,
                      1/*#VTs*/, MVT::i32, 5/*#Ops*/, 3, 4, 5, 6, 7, 
                  // Src: (st:isVoid (X86dec_flag:i8 (ld:i8 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                  // Dst: (DEC8m:isVoid addr:iPTR:$dst)
                /*SwitchType*/ 76,  MVT::i16,// ->14577
/*14501*/         OPC_Scope, 36, /*->14539*/ // 2 children in Scope
/*14503*/           OPC_CheckPredicate, 6, // Predicate_loadi16
/*14505*/           OPC_MoveParent,
/*14506*/           OPC_CheckType, MVT::i16,
/*14508*/           OPC_MoveParent,
/*14509*/           OPC_MoveChild, 2,
/*14511*/           OPC_CheckSame, 2,
/*14513*/           OPC_MoveParent,
/*14514*/           OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*14516*/           OPC_CheckPredicate, 5, // Predicate_store
/*14518*/           OPC_CheckPatternPredicate, 2, // (!Subtarget->is64Bit())
/*14520*/           OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #3 #4 #5 #6 #7
/*14523*/           OPC_EmitMergeInputChains, 2, 0, 1, 
/*14527*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::DEC16m), 0|OPFL_Chain|OPFL_MemRefs,
                        1/*#VTs*/, MVT::i32, 5/*#Ops*/, 3, 4, 5, 6, 7, 
                    // Src: (st:isVoid (X86dec_flag:i16 (ld:i16 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                    // Dst: (DEC16m:isVoid addr:iPTR:$dst)
/*14539*/         /*Scope*/ 36, /*->14576*/
/*14540*/           OPC_CheckPredicate, 6, // Predicate_loadi16
/*14542*/           OPC_MoveParent,
/*14543*/           OPC_CheckType, MVT::i16,
/*14545*/           OPC_MoveParent,
/*14546*/           OPC_MoveChild, 2,
/*14548*/           OPC_CheckSame, 2,
/*14550*/           OPC_MoveParent,
/*14551*/           OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*14553*/           OPC_CheckPredicate, 5, // Predicate_store
/*14555*/           OPC_CheckPatternPredicate, 3, // (Subtarget->is64Bit())
/*14557*/           OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #3 #4 #5 #6 #7
/*14560*/           OPC_EmitMergeInputChains, 2, 0, 1, 
/*14564*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::DEC64_16m), 0|OPFL_Chain|OPFL_MemRefs,
                        1/*#VTs*/, MVT::i32, 5/*#Ops*/, 3, 4, 5, 6, 7, 
                    // Src: (st:isVoid (X86dec_flag:i16 (ld:i16 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                    // Dst: (DEC64_16m:isVoid addr:iPTR:$dst)
/*14576*/         0, /*End of Scope*/
                /*SwitchType*/ 76,  MVT::i32,// ->14655
/*14579*/         OPC_Scope, 36, /*->14617*/ // 2 children in Scope
/*14581*/           OPC_CheckPredicate, 3, // Predicate_loadi32
/*14583*/           OPC_MoveParent,
/*14584*/           OPC_CheckType, MVT::i32,
/*14586*/           OPC_MoveParent,
/*14587*/           OPC_MoveChild, 2,
/*14589*/           OPC_CheckSame, 2,
/*14591*/           OPC_MoveParent,
/*14592*/           OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*14594*/           OPC_CheckPredicate, 5, // Predicate_store
/*14596*/           OPC_CheckPatternPredicate, 2, // (!Subtarget->is64Bit())
/*14598*/           OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #3 #4 #5 #6 #7
/*14601*/           OPC_EmitMergeInputChains, 2, 0, 1, 
/*14605*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::DEC32m), 0|OPFL_Chain|OPFL_MemRefs,
                        1/*#VTs*/, MVT::i32, 5/*#Ops*/, 3, 4, 5, 6, 7, 
                    // Src: (st:isVoid (X86dec_flag:i32 (ld:i32 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                    // Dst: (DEC32m:isVoid addr:iPTR:$dst)
/*14617*/         /*Scope*/ 36, /*->14654*/
/*14618*/           OPC_CheckPredicate, 3, // Predicate_loadi32
/*14620*/           OPC_MoveParent,
/*14621*/           OPC_CheckType, MVT::i32,
/*14623*/           OPC_MoveParent,
/*14624*/           OPC_MoveChild, 2,
/*14626*/           OPC_CheckSame, 2,
/*14628*/           OPC_MoveParent,
/*14629*/           OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*14631*/           OPC_CheckPredicate, 5, // Predicate_store
/*14633*/           OPC_CheckPatternPredicate, 3, // (Subtarget->is64Bit())
/*14635*/           OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #3 #4 #5 #6 #7
/*14638*/           OPC_EmitMergeInputChains, 2, 0, 1, 
/*14642*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::DEC64_32m), 0|OPFL_Chain|OPFL_MemRefs,
                        1/*#VTs*/, MVT::i32, 5/*#Ops*/, 3, 4, 5, 6, 7, 
                    // Src: (st:isVoid (X86dec_flag:i32 (ld:i32 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                    // Dst: (DEC64_32m:isVoid addr:iPTR:$dst)
/*14654*/         0, /*End of Scope*/
                /*SwitchType*/ 36,  MVT::i64,// ->14693
/*14657*/         OPC_CheckPredicate, 8, // Predicate_load
/*14659*/         OPC_CheckPredicate, 9, // Predicate_dsload
/*14661*/         OPC_MoveParent,
/*14662*/         OPC_CheckType, MVT::i64,
/*14664*/         OPC_MoveParent,
/*14665*/         OPC_MoveChild, 2,
/*14667*/         OPC_CheckSame, 2,
/*14669*/         OPC_MoveParent,
/*14670*/         OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*14672*/         OPC_CheckPredicate, 5, // Predicate_store
/*14674*/         OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #3 #4 #5 #6 #7
/*14677*/         OPC_EmitMergeInputChains, 2, 0, 1, 
/*14681*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::DEC64m), 0|OPFL_Chain|OPFL_MemRefs,
                      1/*#VTs*/, MVT::i32, 5/*#Ops*/, 3, 4, 5, 6, 7, 
                  // Src: (st:isVoid (X86dec_flag:i64 (ld:i64 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                  // Dst: (DEC64m:isVoid addr:iPTR:$dst)
                0, // EndSwitchType
              /*SwitchOpcode*/ 83|128,3/*467*/,  ISD::EXTRACT_VECTOR_ELT,// ->15164
/*14697*/       OPC_Scope, 60|128,1/*188*/, /*->14888*/ // 2 children in Scope
/*14700*/         OPC_MoveChild, 0,
/*14702*/         OPC_SwitchOpcode /*2 cases */, 99,  ISD::VECTOR_SHUFFLE,// ->14804
/*14705*/           OPC_Scope, 51, /*->14758*/ // 2 children in Scope
/*14707*/             OPC_MoveChild, 0,
/*14709*/             OPC_CheckOpcode, ISD::BIT_CONVERT,
/*14711*/             OPC_RecordChild0, // #1 = $src
/*14712*/             OPC_CheckChild0Type, MVT::v4f32,
/*14714*/             OPC_MoveParent,
/*14715*/             OPC_MoveChild, 1,
/*14717*/             OPC_CheckOpcode, ISD::UNDEF,
/*14719*/             OPC_MoveParent,
/*14720*/             OPC_CheckPredicate, 14, // Predicate_unpckh
/*14722*/             OPC_CheckType, MVT::v2f64,
/*14724*/             OPC_MoveParent,
/*14725*/             OPC_MoveChild, 1,
/*14727*/             OPC_CheckInteger, 0, 
/*14729*/             OPC_MoveParent,
/*14730*/             OPC_CheckType, MVT::f64,
/*14732*/             OPC_MoveParent,
/*14733*/             OPC_RecordChild2, // #2 = $dst
/*14734*/             OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*14736*/             OPC_CheckPredicate, 5, // Predicate_store
/*14738*/             OPC_CheckPatternPredicate, 0, // (Subtarget->hasSSE1())
/*14740*/             OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #3 #4 #5 #6 #7
/*14743*/             OPC_EmitMergeInputChains, 1, 0, 
/*14746*/             OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVHPSmr), 0|OPFL_Chain|OPFL_MemRefs,
                          0/*#VTs*/, 6/*#Ops*/, 3, 4, 5, 6, 7, 1, 
                      // Src: (st:isVoid (vector_extract:f64 (vector_shuffle:v2f64 (bitconvert:v2f64 VR128:v4f32:$src), (undef:v2f64))<<P:Predicate_unpckh>>, 0:iPTR), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                      // Dst: (MOVHPSmr:isVoid addr:iPTR:$dst, VR128:v4f32:$src)
/*14758*/           /*Scope*/ 44, /*->14803*/
/*14759*/             OPC_RecordChild0, // #1 = $src
/*14760*/             OPC_MoveChild, 1,
/*14762*/             OPC_CheckOpcode, ISD::UNDEF,
/*14764*/             OPC_MoveParent,
/*14765*/             OPC_CheckPredicate, 14, // Predicate_unpckh
/*14767*/             OPC_CheckType, MVT::v2f64,
/*14769*/             OPC_MoveParent,
/*14770*/             OPC_MoveChild, 1,
/*14772*/             OPC_CheckInteger, 0, 
/*14774*/             OPC_MoveParent,
/*14775*/             OPC_CheckType, MVT::f64,
/*14777*/             OPC_MoveParent,
/*14778*/             OPC_RecordChild2, // #2 = $dst
/*14779*/             OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*14781*/             OPC_CheckPredicate, 5, // Predicate_store
/*14783*/             OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*14785*/             OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #3 #4 #5 #6 #7
/*14788*/             OPC_EmitMergeInputChains, 1, 0, 
/*14791*/             OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVHPDmr), 0|OPFL_Chain|OPFL_MemRefs,
                          0/*#VTs*/, 6/*#Ops*/, 3, 4, 5, 6, 7, 1, 
                      // Src: (st:isVoid (vector_extract:f64 (vector_shuffle:v2f64 VR128:v2f64:$src, (undef:v2f64))<<P:Predicate_unpckh>>, 0:iPTR), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                      // Dst: (MOVHPDmr:isVoid addr:iPTR:$dst, VR128:v2f64:$src)
/*14803*/           0, /*End of Scope*/
                  /*SwitchOpcode*/ 81,  ISD::BIT_CONVERT,// ->14887
/*14806*/           OPC_RecordChild0, // #1 = $src
/*14807*/           OPC_CheckChild0Type, MVT::v4f32,
/*14809*/           OPC_SwitchType /*2 cases */, 34,  MVT::v2f64,// ->14846
/*14812*/             OPC_MoveParent,
/*14813*/             OPC_MoveChild, 1,
/*14815*/             OPC_CheckInteger, 0, 
/*14817*/             OPC_MoveParent,
/*14818*/             OPC_CheckType, MVT::f64,
/*14820*/             OPC_MoveParent,
/*14821*/             OPC_RecordChild2, // #2 = $dst
/*14822*/             OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*14824*/             OPC_CheckPredicate, 5, // Predicate_store
/*14826*/             OPC_CheckPatternPredicate, 0, // (Subtarget->hasSSE1())
/*14828*/             OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #3 #4 #5 #6 #7
/*14831*/             OPC_EmitMergeInputChains, 1, 0, 
/*14834*/             OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVLPSmr), 0|OPFL_Chain|OPFL_MemRefs,
                          0/*#VTs*/, 6/*#Ops*/, 3, 4, 5, 6, 7, 1, 
                      // Src: (st:isVoid (vector_extract:f64 (bitconvert:v2f64 VR128:v4f32:$src), 0:iPTR), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                      // Dst: (MOVLPSmr:isVoid addr:iPTR:$dst, VR128:v4f32:$src)
                    /*SwitchType*/ 38,  MVT::v4i32,// ->14886
/*14848*/             OPC_MoveParent,
/*14849*/             OPC_RecordChild1, // #2 = $src2
/*14850*/             OPC_MoveChild, 1,
/*14852*/             OPC_CheckOpcode, ISD::Constant,
/*14854*/             OPC_MoveParent,
/*14855*/             OPC_CheckType, MVT::i32,
/*14857*/             OPC_MoveParent,
/*14858*/             OPC_RecordChild2, // #3 = $dst
/*14859*/             OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*14861*/             OPC_CheckPredicate, 5, // Predicate_store
/*14863*/             OPC_CheckPatternPredicate, 4, // (Subtarget->hasSSE41())
/*14865*/             OPC_CheckComplexPat, /*CP*/0, /*#*/3, // SelectAddr:$dst #4 #5 #6 #7 #8
/*14868*/             OPC_EmitMergeInputChains, 1, 0, 
/*14871*/             OPC_EmitConvertToTarget, 2,
/*14873*/             OPC_MorphNodeTo, TARGET_OPCODE(X86::EXTRACTPSmr), 0|OPFL_Chain|OPFL_MemRefs,
                          0/*#VTs*/, 7/*#Ops*/, 4, 5, 6, 7, 8, 1, 9, 
                      // Src: (st:isVoid (extractelt:i32 (bitconvert:v4i32 VR128:v4f32:$src1), (imm:iPTR):$src2), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                      // Dst: (EXTRACTPSmr:isVoid addr:iPTR:$dst, VR128:v4f32:$src1, (imm:i32):$src2)
                    0, // EndSwitchType
                  0, // EndSwitchOpcode
/*14888*/       /*Scope*/ 17|128,2/*273*/, /*->15163*/
/*14890*/         OPC_RecordChild0, // #1 = $src
/*14891*/         OPC_Scope, 69, /*->14962*/ // 4 children in Scope
/*14893*/           OPC_CheckChild0Type, MVT::v2f64,
/*14895*/           OPC_MoveChild, 1,
/*14897*/           OPC_CheckInteger, 0, 
/*14899*/           OPC_MoveParent,
/*14900*/           OPC_CheckType, MVT::f64,
/*14902*/           OPC_MoveParent,
/*14903*/           OPC_RecordChild2, // #2 = $dst
/*14904*/           OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*14906*/           OPC_CheckPredicate, 5, // Predicate_store
/*14908*/           OPC_Scope, 20, /*->14930*/ // 2 children in Scope
/*14910*/             OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*14912*/             OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #3 #4 #5 #6 #7
/*14915*/             OPC_EmitMergeInputChains, 1, 0, 
/*14918*/             OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVLPDmr), 0|OPFL_Chain|OPFL_MemRefs,
                          0/*#VTs*/, 6/*#Ops*/, 3, 4, 5, 6, 7, 1, 
                      // Src: (st:isVoid (vector_extract:f64 VR128:v2f64:$src, 0:iPTR), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                      // Dst: (MOVLPDmr:isVoid addr:iPTR:$dst, VR128:v2f64:$src)
/*14930*/           /*Scope*/ 30, /*->14961*/
/*14931*/             OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #3 #4 #5 #6 #7
/*14934*/             OPC_EmitMergeInputChains, 1, 0, 
/*14937*/             OPC_EmitInteger, MVT::i32, 2, 
/*14940*/             OPC_EmitNode, TARGET_OPCODE(TargetOpcode::EXTRACT_SUBREG), 0,
                          1/*#VTs*/, MVT::f64, 2/*#Ops*/, 1, 8,  // Results = #9 
/*14949*/             OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVSDmr), 0|OPFL_Chain|OPFL_MemRefs,
                          0/*#VTs*/, 6/*#Ops*/, 3, 4, 5, 6, 7, 9, 
                      // Src: (st:isVoid (vector_extract:f64 VR128:v2f64:$src, 0:iPTR), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                      // Dst: (MOVSDmr:isVoid addr:iPTR:$dst, (EXTRACT_SUBREG:f64 VR128:v2f64:$src, 2:i32))
/*14961*/           0, /*End of Scope*/
/*14962*/         /*Scope*/ 76, /*->15039*/
/*14963*/           OPC_CheckChild0Type, MVT::v2i64,
/*14965*/           OPC_Scope, 33, /*->15000*/ // 2 children in Scope
/*14967*/             OPC_MoveChild, 1,
/*14969*/             OPC_CheckInteger, 0, 
/*14971*/             OPC_MoveParent,
/*14972*/             OPC_CheckType, MVT::i64,
/*14974*/             OPC_MoveParent,
/*14975*/             OPC_RecordChild2, // #2 = $dst
/*14976*/             OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*14978*/             OPC_CheckPredicate, 5, // Predicate_store
/*14980*/             OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*14982*/             OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #3 #4 #5 #6 #7
/*14985*/             OPC_EmitMergeInputChains, 1, 0, 
/*14988*/             OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVPQI2QImr), 0|OPFL_Chain|OPFL_MemRefs,
                          0/*#VTs*/, 6/*#Ops*/, 3, 4, 5, 6, 7, 1, 
                      // Src: (st:isVoid (vector_extract:i64 VR128:v2i64:$src, 0:iPTR), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                      // Dst: (MOVPQI2QImr:isVoid addr:iPTR:$dst, VR128:v2i64:$src)
/*15000*/           /*Scope*/ 37, /*->15038*/
/*15001*/             OPC_RecordChild1, // #2 = $src2
/*15002*/             OPC_MoveChild, 1,
/*15004*/             OPC_CheckOpcode, ISD::Constant,
/*15006*/             OPC_MoveParent,
/*15007*/             OPC_CheckType, MVT::i64,
/*15009*/             OPC_MoveParent,
/*15010*/             OPC_RecordChild2, // #3 = $dst
/*15011*/             OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*15013*/             OPC_CheckPredicate, 5, // Predicate_store
/*15015*/             OPC_CheckPatternPredicate, 4, // (Subtarget->hasSSE41())
/*15017*/             OPC_CheckComplexPat, /*CP*/0, /*#*/3, // SelectAddr:$dst #4 #5 #6 #7 #8
/*15020*/             OPC_EmitMergeInputChains, 1, 0, 
/*15023*/             OPC_EmitConvertToTarget, 2,
/*15025*/             OPC_MorphNodeTo, TARGET_OPCODE(X86::PEXTRQmr), 0|OPFL_Chain|OPFL_MemRefs,
                          0/*#VTs*/, 7/*#Ops*/, 4, 5, 6, 7, 8, 1, 9, 
                      // Src: (st:isVoid (extractelt:i64 VR128:v2i64:$src1, (imm:iPTR):$src2), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                      // Dst: (PEXTRQmr:isVoid addr:iPTR:$dst, VR128:v2i64:$src1, (imm:i32):$src2)
/*15038*/           0, /*End of Scope*/
/*15039*/         /*Scope*/ 76, /*->15116*/
/*15040*/           OPC_CheckChild0Type, MVT::v4i32,
/*15042*/           OPC_Scope, 33, /*->15077*/ // 2 children in Scope
/*15044*/             OPC_MoveChild, 1,
/*15046*/             OPC_CheckInteger, 0, 
/*15048*/             OPC_MoveParent,
/*15049*/             OPC_CheckType, MVT::i32,
/*15051*/             OPC_MoveParent,
/*15052*/             OPC_RecordChild2, // #2 = $dst
/*15053*/             OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*15055*/             OPC_CheckPredicate, 5, // Predicate_store
/*15057*/             OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*15059*/             OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #3 #4 #5 #6 #7
/*15062*/             OPC_EmitMergeInputChains, 1, 0, 
/*15065*/             OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVPDI2DImr), 0|OPFL_Chain|OPFL_MemRefs,
                          0/*#VTs*/, 6/*#Ops*/, 3, 4, 5, 6, 7, 1, 
                      // Src: (st:isVoid (vector_extract:i32 VR128:v4i32:$src, 0:iPTR), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                      // Dst: (MOVPDI2DImr:isVoid addr:iPTR:$dst, VR128:v4i32:$src)
/*15077*/           /*Scope*/ 37, /*->15115*/
/*15078*/             OPC_RecordChild1, // #2 = $src2
/*15079*/             OPC_MoveChild, 1,
/*15081*/             OPC_CheckOpcode, ISD::Constant,
/*15083*/             OPC_MoveParent,
/*15084*/             OPC_CheckType, MVT::i32,
/*15086*/             OPC_MoveParent,
/*15087*/             OPC_RecordChild2, // #3 = $dst
/*15088*/             OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*15090*/             OPC_CheckPredicate, 5, // Predicate_store
/*15092*/             OPC_CheckPatternPredicate, 4, // (Subtarget->hasSSE41())
/*15094*/             OPC_CheckComplexPat, /*CP*/0, /*#*/3, // SelectAddr:$dst #4 #5 #6 #7 #8
/*15097*/             OPC_EmitMergeInputChains, 1, 0, 
/*15100*/             OPC_EmitConvertToTarget, 2,
/*15102*/             OPC_MorphNodeTo, TARGET_OPCODE(X86::PEXTRDmr), 0|OPFL_Chain|OPFL_MemRefs,
                          0/*#VTs*/, 7/*#Ops*/, 4, 5, 6, 7, 8, 1, 9, 
                      // Src: (st:isVoid (extractelt:i32 VR128:v4i32:$src1, (imm:iPTR):$src2), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                      // Dst: (PEXTRDmr:isVoid addr:iPTR:$dst, VR128:v4i32:$src1, (imm:i32):$src2)
/*15115*/           0, /*End of Scope*/
/*15116*/         /*Scope*/ 45, /*->15162*/
/*15117*/           OPC_CheckChild0Type, MVT::v4f32,
/*15119*/           OPC_MoveChild, 1,
/*15121*/           OPC_CheckInteger, 0, 
/*15123*/           OPC_MoveParent,
/*15124*/           OPC_CheckType, MVT::f32,
/*15126*/           OPC_MoveParent,
/*15127*/           OPC_RecordChild2, // #2 = $dst
/*15128*/           OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*15130*/           OPC_CheckPredicate, 5, // Predicate_store
/*15132*/           OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #3 #4 #5 #6 #7
/*15135*/           OPC_EmitMergeInputChains, 1, 0, 
/*15138*/           OPC_EmitInteger, MVT::i32, 1, 
/*15141*/           OPC_EmitNode, TARGET_OPCODE(TargetOpcode::EXTRACT_SUBREG), 0,
                        1/*#VTs*/, MVT::f32, 2/*#Ops*/, 1, 8,  // Results = #9 
/*15150*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVSSmr), 0|OPFL_Chain|OPFL_MemRefs,
                        0/*#VTs*/, 6/*#Ops*/, 3, 4, 5, 6, 7, 9, 
                    // Src: (st:isVoid (vector_extract:f32 VR128:v4f32:$src, 0:iPTR), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                    // Dst: (MOVSSmr:isVoid addr:iPTR:$dst, (EXTRACT_SUBREG:f32 VR128:v4f32:$src, 1:i32))
/*15162*/         0, /*End of Scope*/
/*15163*/       0, /*End of Scope*/
              /*SwitchOpcode*/ 57|128,1/*185*/,  ISD::TRUNCATE,// ->15352
/*15167*/       OPC_MoveChild, 0,
/*15169*/       OPC_CheckOpcode, ISD::SRL,
/*15171*/       OPC_RecordChild0, // #1 = $src
/*15172*/       OPC_MoveChild, 1,
/*15174*/       OPC_CheckInteger, 8, 
/*15176*/       OPC_CheckType, MVT::i8,
/*15178*/       OPC_MoveParent,
/*15179*/       OPC_CheckPredicate, 15, // Predicate_srl_su
/*15181*/       OPC_SwitchType /*3 cases */, 53,  MVT::i64,// ->15237
/*15184*/         OPC_MoveParent,
/*15185*/         OPC_CheckPredicate, 16, // Predicate_trunc_su
/*15187*/         OPC_CheckType, MVT::i8,
/*15189*/         OPC_MoveParent,
/*15190*/         OPC_RecordChild2, // #2 = $dst
/*15191*/         OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*15193*/         OPC_CheckPredicate, 5, // Predicate_store
/*15195*/         OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #3 #4 #5 #6 #7
/*15198*/         OPC_EmitMergeInputChains, 1, 0, 
/*15201*/         OPC_EmitInteger, MVT::i32, X86::GR64_ABCDRegClassID,
/*15204*/         OPC_EmitNode, TARGET_OPCODE(TargetOpcode::COPY_TO_REGCLASS), 0,
                      1/*#VTs*/, MVT::i64, 2/*#Ops*/, 1, 8,  // Results = #9 
/*15213*/         OPC_EmitInteger, MVT::i32, 2, 
/*15216*/         OPC_EmitNode, TARGET_OPCODE(TargetOpcode::EXTRACT_SUBREG), 0,
                      1/*#VTs*/, MVT::i8, 2/*#Ops*/, 9, 10,  // Results = #11 
/*15225*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::MOV8mr_NOREX), 0|OPFL_Chain|OPFL_MemRefs,
                      0/*#VTs*/, 6/*#Ops*/, 3, 4, 5, 6, 7, 11, 
                  // Src: (st:isVoid (trunc:i8 (srl:i64 GR64:i64:$src, 8:i8)<<P:Predicate_srl_su>>)<<P:Predicate_trunc_su>>, addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                  // Dst: (MOV8mr_NOREX:isVoid addr:i64:$dst, (EXTRACT_SUBREG:i8 (COPY_TO_REGCLASS:i64 GR64:i64:$src, GR64_ABCD:i64), 2:i32))
                /*SwitchType*/ 55,  MVT::i32,// ->15294
/*15239*/         OPC_MoveParent,
/*15240*/         OPC_CheckPredicate, 16, // Predicate_trunc_su
/*15242*/         OPC_CheckType, MVT::i8,
/*15244*/         OPC_MoveParent,
/*15245*/         OPC_RecordChild2, // #2 = $dst
/*15246*/         OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*15248*/         OPC_CheckPredicate, 5, // Predicate_store
/*15250*/         OPC_CheckPatternPredicate, 3, // (Subtarget->is64Bit())
/*15252*/         OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #3 #4 #5 #6 #7
/*15255*/         OPC_EmitMergeInputChains, 1, 0, 
/*15258*/         OPC_EmitInteger, MVT::i32, X86::GR32_ABCDRegClassID,
/*15261*/         OPC_EmitNode, TARGET_OPCODE(TargetOpcode::COPY_TO_REGCLASS), 0,
                      1/*#VTs*/, MVT::i32, 2/*#Ops*/, 1, 8,  // Results = #9 
/*15270*/         OPC_EmitInteger, MVT::i32, 2, 
/*15273*/         OPC_EmitNode, TARGET_OPCODE(TargetOpcode::EXTRACT_SUBREG), 0,
                      1/*#VTs*/, MVT::i8, 2/*#Ops*/, 9, 10,  // Results = #11 
/*15282*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::MOV8mr_NOREX), 0|OPFL_Chain|OPFL_MemRefs,
                      0/*#VTs*/, 6/*#Ops*/, 3, 4, 5, 6, 7, 11, 
                  // Src: (st:isVoid (trunc:i8 (srl:i32 GR32:i32:$src, 8:i8)<<P:Predicate_srl_su>>)<<P:Predicate_trunc_su>>, addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                  // Dst: (MOV8mr_NOREX:isVoid addr:i64:$dst, (EXTRACT_SUBREG:i8 (COPY_TO_REGCLASS:i32 GR32:i32:$src, GR32_ABCD:i32), 2:i32))
                /*SwitchType*/ 55,  MVT::i16,// ->15351
/*15296*/         OPC_MoveParent,
/*15297*/         OPC_CheckPredicate, 16, // Predicate_trunc_su
/*15299*/         OPC_CheckType, MVT::i8,
/*15301*/         OPC_MoveParent,
/*15302*/         OPC_RecordChild2, // #2 = $dst
/*15303*/         OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*15305*/         OPC_CheckPredicate, 5, // Predicate_store
/*15307*/         OPC_CheckPatternPredicate, 3, // (Subtarget->is64Bit())
/*15309*/         OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #3 #4 #5 #6 #7
/*15312*/         OPC_EmitMergeInputChains, 1, 0, 
/*15315*/         OPC_EmitInteger, MVT::i32, X86::GR16_ABCDRegClassID,
/*15318*/         OPC_EmitNode, TARGET_OPCODE(TargetOpcode::COPY_TO_REGCLASS), 0,
                      1/*#VTs*/, MVT::i16, 2/*#Ops*/, 1, 8,  // Results = #9 
/*15327*/         OPC_EmitInteger, MVT::i32, 2, 
/*15330*/         OPC_EmitNode, TARGET_OPCODE(TargetOpcode::EXTRACT_SUBREG), 0,
                      1/*#VTs*/, MVT::i8, 2/*#Ops*/, 9, 10,  // Results = #11 
/*15339*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::MOV8mr_NOREX), 0|OPFL_Chain|OPFL_MemRefs,
                      0/*#VTs*/, 6/*#Ops*/, 3, 4, 5, 6, 7, 11, 
                  // Src: (st:isVoid (trunc:i8 (srl:i16 GR16:i16:$src, 8:i8)<<P:Predicate_srl_su>>)<<P:Predicate_trunc_su>>, addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                  // Dst: (MOV8mr_NOREX:isVoid addr:i64:$dst, (EXTRACT_SUBREG:i8 (COPY_TO_REGCLASS:i16 GR16:i16:$src, GR16_ABCD:i16), 2:i32))
                0, // EndSwitchType
              /*SwitchOpcode*/ 54,  ISD::BIT_CONVERT,// ->15408
/*15354*/       OPC_MoveChild, 0,
/*15356*/       OPC_CheckOpcode, ISD::EXTRACT_VECTOR_ELT,
/*15358*/       OPC_MoveChild, 0,
/*15360*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*15362*/       OPC_RecordChild0, // #1 = $src1
/*15363*/       OPC_CheckChild0Type, MVT::v4f32,
/*15365*/       OPC_CheckType, MVT::v4i32,
/*15367*/       OPC_MoveParent,
/*15368*/       OPC_RecordChild1, // #2 = $src2
/*15369*/       OPC_MoveChild, 1,
/*15371*/       OPC_CheckOpcode, ISD::Constant,
/*15373*/       OPC_MoveParent,
/*15374*/       OPC_CheckType, MVT::i32,
/*15376*/       OPC_MoveParent,
/*15377*/       OPC_CheckType, MVT::f32,
/*15379*/       OPC_MoveParent,
/*15380*/       OPC_RecordChild2, // #3 = $dst
/*15381*/       OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*15383*/       OPC_CheckPredicate, 5, // Predicate_store
/*15385*/       OPC_CheckPatternPredicate, 4, // (Subtarget->hasSSE41())
/*15387*/       OPC_CheckComplexPat, /*CP*/0, /*#*/3, // SelectAddr:$dst #4 #5 #6 #7 #8
/*15390*/       OPC_EmitMergeInputChains, 1, 0, 
/*15393*/       OPC_EmitConvertToTarget, 2,
/*15395*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::EXTRACTPSmr), 0|OPFL_Chain|OPFL_MemRefs,
                    0/*#VTs*/, 7/*#Ops*/, 4, 5, 6, 7, 8, 1, 9, 
                // Src: (st:isVoid (bitconvert:f32 (extractelt:i32 (bitconvert:v4i32 VR128:v4f32:$src1), (imm:iPTR):$src2)), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                // Dst: (EXTRACTPSmr:isVoid addr:iPTR:$dst, VR128:v16i8:$src1, (imm:i32):$src2)
              /*SwitchOpcode*/ 116|128,3/*500*/,  X86ISD::SETCC,// ->15911
/*15411*/       OPC_MoveChild, 0,
/*15413*/       OPC_Scope, 30, /*->15445*/ // 16 children in Scope
/*15415*/         OPC_CheckInteger, 4, 
/*15417*/         OPC_MoveParent,
/*15418*/         OPC_RecordChild1, // #1 = physreg input EFLAGS
/*15419*/         OPC_MoveParent,
/*15420*/         OPC_RecordChild2, // #2 = $dst
/*15421*/         OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*15423*/         OPC_CheckPredicate, 5, // Predicate_store
/*15425*/         OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #3 #4 #5 #6 #7
/*15428*/         OPC_EmitMergeInputChains, 1, 0, 
/*15431*/         OPC_EmitCopyToReg, 1, X86::EFLAGS,
/*15434*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::SETEm), 0|OPFL_Chain|OPFL_FlagInput|OPFL_MemRefs,
                      0/*#VTs*/, 5/*#Ops*/, 3, 4, 5, 6, 7, 
                  // Src: (st:isVoid (X86setcc:i8 4:i8, EFLAGS:i32), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                  // Dst: (SETEm:isVoid addr:iPTR:$dst)
/*15445*/       /*Scope*/ 30, /*->15476*/
/*15446*/         OPC_CheckInteger, 9, 
/*15448*/         OPC_MoveParent,
/*15449*/         OPC_RecordChild1, // #1 = physreg input EFLAGS
/*15450*/         OPC_MoveParent,
/*15451*/         OPC_RecordChild2, // #2 = $dst
/*15452*/         OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*15454*/         OPC_CheckPredicate, 5, // Predicate_store
/*15456*/         OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #3 #4 #5 #6 #7
/*15459*/         OPC_EmitMergeInputChains, 1, 0, 
/*15462*/         OPC_EmitCopyToReg, 1, X86::EFLAGS,
/*15465*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::SETNEm), 0|OPFL_Chain|OPFL_FlagInput|OPFL_MemRefs,
                      0/*#VTs*/, 5/*#Ops*/, 3, 4, 5, 6, 7, 
                  // Src: (st:isVoid (X86setcc:i8 9:i8, EFLAGS:i32), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                  // Dst: (SETNEm:isVoid addr:iPTR:$dst)
/*15476*/       /*Scope*/ 30, /*->15507*/
/*15477*/         OPC_CheckInteger, 7, 
/*15479*/         OPC_MoveParent,
/*15480*/         OPC_RecordChild1, // #1 = physreg input EFLAGS
/*15481*/         OPC_MoveParent,
/*15482*/         OPC_RecordChild2, // #2 = $dst
/*15483*/         OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*15485*/         OPC_CheckPredicate, 5, // Predicate_store
/*15487*/         OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #3 #4 #5 #6 #7
/*15490*/         OPC_EmitMergeInputChains, 1, 0, 
/*15493*/         OPC_EmitCopyToReg, 1, X86::EFLAGS,
/*15496*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::SETLm), 0|OPFL_Chain|OPFL_FlagInput|OPFL_MemRefs,
                      0/*#VTs*/, 5/*#Ops*/, 3, 4, 5, 6, 7, 
                  // Src: (st:isVoid (X86setcc:i8 7:i8, EFLAGS:i32), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                  // Dst: (SETLm:isVoid addr:iPTR:$dst)
/*15507*/       /*Scope*/ 30, /*->15538*/
/*15508*/         OPC_CheckInteger, 6, 
/*15510*/         OPC_MoveParent,
/*15511*/         OPC_RecordChild1, // #1 = physreg input EFLAGS
/*15512*/         OPC_MoveParent,
/*15513*/         OPC_RecordChild2, // #2 = $dst
/*15514*/         OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*15516*/         OPC_CheckPredicate, 5, // Predicate_store
/*15518*/         OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #3 #4 #5 #6 #7
/*15521*/         OPC_EmitMergeInputChains, 1, 0, 
/*15524*/         OPC_EmitCopyToReg, 1, X86::EFLAGS,
/*15527*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::SETGEm), 0|OPFL_Chain|OPFL_FlagInput|OPFL_MemRefs,
                      0/*#VTs*/, 5/*#Ops*/, 3, 4, 5, 6, 7, 
                  // Src: (st:isVoid (X86setcc:i8 6:i8, EFLAGS:i32), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                  // Dst: (SETGEm:isVoid addr:iPTR:$dst)
/*15538*/       /*Scope*/ 30, /*->15569*/
/*15539*/         OPC_CheckInteger, 8, 
/*15541*/         OPC_MoveParent,
/*15542*/         OPC_RecordChild1, // #1 = physreg input EFLAGS
/*15543*/         OPC_MoveParent,
/*15544*/         OPC_RecordChild2, // #2 = $dst
/*15545*/         OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*15547*/         OPC_CheckPredicate, 5, // Predicate_store
/*15549*/         OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #3 #4 #5 #6 #7
/*15552*/         OPC_EmitMergeInputChains, 1, 0, 
/*15555*/         OPC_EmitCopyToReg, 1, X86::EFLAGS,
/*15558*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::SETLEm), 0|OPFL_Chain|OPFL_FlagInput|OPFL_MemRefs,
                      0/*#VTs*/, 5/*#Ops*/, 3, 4, 5, 6, 7, 
                  // Src: (st:isVoid (X86setcc:i8 8:i8, EFLAGS:i32), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                  // Dst: (SETLEm:isVoid addr:iPTR:$dst)
/*15569*/       /*Scope*/ 30, /*->15600*/
/*15570*/         OPC_CheckInteger, 5, 
/*15572*/         OPC_MoveParent,
/*15573*/         OPC_RecordChild1, // #1 = physreg input EFLAGS
/*15574*/         OPC_MoveParent,
/*15575*/         OPC_RecordChild2, // #2 = $dst
/*15576*/         OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*15578*/         OPC_CheckPredicate, 5, // Predicate_store
/*15580*/         OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #3 #4 #5 #6 #7
/*15583*/         OPC_EmitMergeInputChains, 1, 0, 
/*15586*/         OPC_EmitCopyToReg, 1, X86::EFLAGS,
/*15589*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::SETGm), 0|OPFL_Chain|OPFL_FlagInput|OPFL_MemRefs,
                      0/*#VTs*/, 5/*#Ops*/, 3, 4, 5, 6, 7, 
                  // Src: (st:isVoid (X86setcc:i8 5:i8, EFLAGS:i32), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                  // Dst: (SETGm:isVoid addr:iPTR:$dst)
/*15600*/       /*Scope*/ 30, /*->15631*/
/*15601*/         OPC_CheckInteger, 2, 
/*15603*/         OPC_MoveParent,
/*15604*/         OPC_RecordChild1, // #1 = physreg input EFLAGS
/*15605*/         OPC_MoveParent,
/*15606*/         OPC_RecordChild2, // #2 = $dst
/*15607*/         OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*15609*/         OPC_CheckPredicate, 5, // Predicate_store
/*15611*/         OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #3 #4 #5 #6 #7
/*15614*/         OPC_EmitMergeInputChains, 1, 0, 
/*15617*/         OPC_EmitCopyToReg, 1, X86::EFLAGS,
/*15620*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::SETBm), 0|OPFL_Chain|OPFL_FlagInput|OPFL_MemRefs,
                      0/*#VTs*/, 5/*#Ops*/, 3, 4, 5, 6, 7, 
                  // Src: (st:isVoid (X86setcc:i8 2:i8, EFLAGS:i32), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                  // Dst: (SETBm:isVoid addr:iPTR:$dst)
/*15631*/       /*Scope*/ 30, /*->15662*/
/*15632*/         OPC_CheckInteger, 1, 
/*15634*/         OPC_MoveParent,
/*15635*/         OPC_RecordChild1, // #1 = physreg input EFLAGS
/*15636*/         OPC_MoveParent,
/*15637*/         OPC_RecordChild2, // #2 = $dst
/*15638*/         OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*15640*/         OPC_CheckPredicate, 5, // Predicate_store
/*15642*/         OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #3 #4 #5 #6 #7
/*15645*/         OPC_EmitMergeInputChains, 1, 0, 
/*15648*/         OPC_EmitCopyToReg, 1, X86::EFLAGS,
/*15651*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::SETAEm), 0|OPFL_Chain|OPFL_FlagInput|OPFL_MemRefs,
                      0/*#VTs*/, 5/*#Ops*/, 3, 4, 5, 6, 7, 
                  // Src: (st:isVoid (X86setcc:i8 1:i8, EFLAGS:i32), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                  // Dst: (SETAEm:isVoid addr:iPTR:$dst)
/*15662*/       /*Scope*/ 30, /*->15693*/
/*15663*/         OPC_CheckInteger, 3, 
/*15665*/         OPC_MoveParent,
/*15666*/         OPC_RecordChild1, // #1 = physreg input EFLAGS
/*15667*/         OPC_MoveParent,
/*15668*/         OPC_RecordChild2, // #2 = $dst
/*15669*/         OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*15671*/         OPC_CheckPredicate, 5, // Predicate_store
/*15673*/         OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #3 #4 #5 #6 #7
/*15676*/         OPC_EmitMergeInputChains, 1, 0, 
/*15679*/         OPC_EmitCopyToReg, 1, X86::EFLAGS,
/*15682*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::SETBEm), 0|OPFL_Chain|OPFL_FlagInput|OPFL_MemRefs,
                      0/*#VTs*/, 5/*#Ops*/, 3, 4, 5, 6, 7, 
                  // Src: (st:isVoid (X86setcc:i8 3:i8, EFLAGS:i32), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                  // Dst: (SETBEm:isVoid addr:iPTR:$dst)
/*15693*/       /*Scope*/ 30, /*->15724*/
/*15694*/         OPC_CheckInteger, 0, 
/*15696*/         OPC_MoveParent,
/*15697*/         OPC_RecordChild1, // #1 = physreg input EFLAGS
/*15698*/         OPC_MoveParent,
/*15699*/         OPC_RecordChild2, // #2 = $dst
/*15700*/         OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*15702*/         OPC_CheckPredicate, 5, // Predicate_store
/*15704*/         OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #3 #4 #5 #6 #7
/*15707*/         OPC_EmitMergeInputChains, 1, 0, 
/*15710*/         OPC_EmitCopyToReg, 1, X86::EFLAGS,
/*15713*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::SETAm), 0|OPFL_Chain|OPFL_FlagInput|OPFL_MemRefs,
                      0/*#VTs*/, 5/*#Ops*/, 3, 4, 5, 6, 7, 
                  // Src: (st:isVoid (X86setcc:i8 0:i8, EFLAGS:i32), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                  // Dst: (SETAm:isVoid addr:iPTR:$dst)
/*15724*/       /*Scope*/ 30, /*->15755*/
/*15725*/         OPC_CheckInteger, 15, 
/*15727*/         OPC_MoveParent,
/*15728*/         OPC_RecordChild1, // #1 = physreg input EFLAGS
/*15729*/         OPC_MoveParent,
/*15730*/         OPC_RecordChild2, // #2 = $dst
/*15731*/         OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*15733*/         OPC_CheckPredicate, 5, // Predicate_store
/*15735*/         OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #3 #4 #5 #6 #7
/*15738*/         OPC_EmitMergeInputChains, 1, 0, 
/*15741*/         OPC_EmitCopyToReg, 1, X86::EFLAGS,
/*15744*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::SETSm), 0|OPFL_Chain|OPFL_FlagInput|OPFL_MemRefs,
                      0/*#VTs*/, 5/*#Ops*/, 3, 4, 5, 6, 7, 
                  // Src: (st:isVoid (X86setcc:i8 15:i8, EFLAGS:i32), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                  // Dst: (SETSm:isVoid addr:iPTR:$dst)
/*15755*/       /*Scope*/ 30, /*->15786*/
/*15756*/         OPC_CheckInteger, 12, 
/*15758*/         OPC_MoveParent,
/*15759*/         OPC_RecordChild1, // #1 = physreg input EFLAGS
/*15760*/         OPC_MoveParent,
/*15761*/         OPC_RecordChild2, // #2 = $dst
/*15762*/         OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*15764*/         OPC_CheckPredicate, 5, // Predicate_store
/*15766*/         OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #3 #4 #5 #6 #7
/*15769*/         OPC_EmitMergeInputChains, 1, 0, 
/*15772*/         OPC_EmitCopyToReg, 1, X86::EFLAGS,
/*15775*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::SETNSm), 0|OPFL_Chain|OPFL_FlagInput|OPFL_MemRefs,
                      0/*#VTs*/, 5/*#Ops*/, 3, 4, 5, 6, 7, 
                  // Src: (st:isVoid (X86setcc:i8 12:i8, EFLAGS:i32), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                  // Dst: (SETNSm:isVoid addr:iPTR:$dst)
/*15786*/       /*Scope*/ 30, /*->15817*/
/*15787*/         OPC_CheckInteger, 14, 
/*15789*/         OPC_MoveParent,
/*15790*/         OPC_RecordChild1, // #1 = physreg input EFLAGS
/*15791*/         OPC_MoveParent,
/*15792*/         OPC_RecordChild2, // #2 = $dst
/*15793*/         OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*15795*/         OPC_CheckPredicate, 5, // Predicate_store
/*15797*/         OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #3 #4 #5 #6 #7
/*15800*/         OPC_EmitMergeInputChains, 1, 0, 
/*15803*/         OPC_EmitCopyToReg, 1, X86::EFLAGS,
/*15806*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::SETPm), 0|OPFL_Chain|OPFL_FlagInput|OPFL_MemRefs,
                      0/*#VTs*/, 5/*#Ops*/, 3, 4, 5, 6, 7, 
                  // Src: (st:isVoid (X86setcc:i8 14:i8, EFLAGS:i32), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                  // Dst: (SETPm:isVoid addr:iPTR:$dst)
/*15817*/       /*Scope*/ 30, /*->15848*/
/*15818*/         OPC_CheckInteger, 11, 
/*15820*/         OPC_MoveParent,
/*15821*/         OPC_RecordChild1, // #1 = physreg input EFLAGS
/*15822*/         OPC_MoveParent,
/*15823*/         OPC_RecordChild2, // #2 = $dst
/*15824*/         OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*15826*/         OPC_CheckPredicate, 5, // Predicate_store
/*15828*/         OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #3 #4 #5 #6 #7
/*15831*/         OPC_EmitMergeInputChains, 1, 0, 
/*15834*/         OPC_EmitCopyToReg, 1, X86::EFLAGS,
/*15837*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::SETNPm), 0|OPFL_Chain|OPFL_FlagInput|OPFL_MemRefs,
                      0/*#VTs*/, 5/*#Ops*/, 3, 4, 5, 6, 7, 
                  // Src: (st:isVoid (X86setcc:i8 11:i8, EFLAGS:i32), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                  // Dst: (SETNPm:isVoid addr:iPTR:$dst)
/*15848*/       /*Scope*/ 30, /*->15879*/
/*15849*/         OPC_CheckInteger, 13, 
/*15851*/         OPC_MoveParent,
/*15852*/         OPC_RecordChild1, // #1 = physreg input EFLAGS
/*15853*/         OPC_MoveParent,
/*15854*/         OPC_RecordChild2, // #2 = $dst
/*15855*/         OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*15857*/         OPC_CheckPredicate, 5, // Predicate_store
/*15859*/         OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #3 #4 #5 #6 #7
/*15862*/         OPC_EmitMergeInputChains, 1, 0, 
/*15865*/         OPC_EmitCopyToReg, 1, X86::EFLAGS,
/*15868*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::SETOm), 0|OPFL_Chain|OPFL_FlagInput|OPFL_MemRefs,
                      0/*#VTs*/, 5/*#Ops*/, 3, 4, 5, 6, 7, 
                  // Src: (st:isVoid (X86setcc:i8 13:i8, EFLAGS:i32), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                  // Dst: (SETOm:isVoid addr:iPTR:$dst)
/*15879*/       /*Scope*/ 30, /*->15910*/
/*15880*/         OPC_CheckInteger, 10, 
/*15882*/         OPC_MoveParent,
/*15883*/         OPC_RecordChild1, // #1 = physreg input EFLAGS
/*15884*/         OPC_MoveParent,
/*15885*/         OPC_RecordChild2, // #2 = $dst
/*15886*/         OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*15888*/         OPC_CheckPredicate, 5, // Predicate_store
/*15890*/         OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #3 #4 #5 #6 #7
/*15893*/         OPC_EmitMergeInputChains, 1, 0, 
/*15896*/         OPC_EmitCopyToReg, 1, X86::EFLAGS,
/*15899*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::SETNOm), 0|OPFL_Chain|OPFL_FlagInput|OPFL_MemRefs,
                      0/*#VTs*/, 5/*#Ops*/, 3, 4, 5, 6, 7, 
                  // Src: (st:isVoid (X86setcc:i8 10:i8, EFLAGS:i32), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                  // Dst: (SETNOm:isVoid addr:iPTR:$dst)
/*15910*/       0, /*End of Scope*/
              /*SwitchOpcode*/ 116|128,1/*244*/,  X86ISD::Wrapper,// ->16158
/*15914*/       OPC_RecordChild0, // #1 = $src
/*15915*/       OPC_MoveChild, 0,
/*15917*/       OPC_SwitchOpcode /*5 cases */, 57,  ISD::TargetGlobalAddress,// ->15977
/*15920*/         OPC_MoveParent,
/*15921*/         OPC_SwitchType /*2 cases */, 24,  MVT::i32,// ->15948
/*15924*/           OPC_MoveParent,
/*15925*/           OPC_RecordChild2, // #2 = $dst
/*15926*/           OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*15928*/           OPC_CheckPredicate, 5, // Predicate_store
/*15930*/           OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #3 #4 #5 #6 #7
/*15933*/           OPC_EmitMergeInputChains, 1, 0, 
/*15936*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::MOV32mi), 0|OPFL_Chain|OPFL_MemRefs,
                        0/*#VTs*/, 6/*#Ops*/, 3, 4, 5, 6, 7, 1, 
                    // Src: (st:isVoid (X86Wrapper:i32 (tglobaladdr:i32):$src), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                    // Dst: (MOV32mi:isVoid addr:iPTR:$dst, (tglobaladdr:i32):$src)
                  /*SwitchType*/ 26,  MVT::i64,// ->15976
/*15950*/           OPC_MoveParent,
/*15951*/           OPC_RecordChild2, // #2 = $dst
/*15952*/           OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*15954*/           OPC_CheckPredicate, 5, // Predicate_store
/*15956*/           OPC_CheckPatternPredicate, 5, // (TM.getCodeModel() == CodeModel::Small ||TM.getCodeModel() == CodeModel::Kernel) && (TM.getRelocationModel() == Reloc::Static)
/*15958*/           OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #3 #4 #5 #6 #7
/*15961*/           OPC_EmitMergeInputChains, 1, 0, 
/*15964*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::MOV64mi32), 0|OPFL_Chain|OPFL_MemRefs,
                        0/*#VTs*/, 6/*#Ops*/, 3, 4, 5, 6, 7, 1, 
                    // Src: (st:isVoid (X86Wrapper:i64 (tglobaladdr:i64):$src), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                    // Dst: (MOV64mi32:isVoid addr:iPTR:$dst, (tglobaladdr:i64):$src)
                  0, // EndSwitchType
                /*SwitchOpcode*/ 57,  ISD::TargetExternalSymbol,// ->16036
/*15979*/         OPC_MoveParent,
/*15980*/         OPC_SwitchType /*2 cases */, 24,  MVT::i32,// ->16007
/*15983*/           OPC_MoveParent,
/*15984*/           OPC_RecordChild2, // #2 = $dst
/*15985*/           OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*15987*/           OPC_CheckPredicate, 5, // Predicate_store
/*15989*/           OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #3 #4 #5 #6 #7
/*15992*/           OPC_EmitMergeInputChains, 1, 0, 
/*15995*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::MOV32mi), 0|OPFL_Chain|OPFL_MemRefs,
                        0/*#VTs*/, 6/*#Ops*/, 3, 4, 5, 6, 7, 1, 
                    // Src: (st:isVoid (X86Wrapper:i32 (texternalsym:i32):$src), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                    // Dst: (MOV32mi:isVoid addr:iPTR:$dst, (texternalsym:i32):$src)
                  /*SwitchType*/ 26,  MVT::i64,// ->16035
/*16009*/           OPC_MoveParent,
/*16010*/           OPC_RecordChild2, // #2 = $dst
/*16011*/           OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*16013*/           OPC_CheckPredicate, 5, // Predicate_store
/*16015*/           OPC_CheckPatternPredicate, 5, // (TM.getCodeModel() == CodeModel::Small ||TM.getCodeModel() == CodeModel::Kernel) && (TM.getRelocationModel() == Reloc::Static)
/*16017*/           OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #3 #4 #5 #6 #7
/*16020*/           OPC_EmitMergeInputChains, 1, 0, 
/*16023*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::MOV64mi32), 0|OPFL_Chain|OPFL_MemRefs,
                        0/*#VTs*/, 6/*#Ops*/, 3, 4, 5, 6, 7, 1, 
                    // Src: (st:isVoid (X86Wrapper:i64 (texternalsym:i64):$src), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                    // Dst: (MOV64mi32:isVoid addr:iPTR:$dst, (texternalsym:i64):$src)
                  0, // EndSwitchType
                /*SwitchOpcode*/ 57,  ISD::TargetBlockAddress,// ->16095
/*16038*/         OPC_MoveParent,
/*16039*/         OPC_SwitchType /*2 cases */, 24,  MVT::i32,// ->16066
/*16042*/           OPC_MoveParent,
/*16043*/           OPC_RecordChild2, // #2 = $dst
/*16044*/           OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*16046*/           OPC_CheckPredicate, 5, // Predicate_store
/*16048*/           OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #3 #4 #5 #6 #7
/*16051*/           OPC_EmitMergeInputChains, 1, 0, 
/*16054*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::MOV32mi), 0|OPFL_Chain|OPFL_MemRefs,
                        0/*#VTs*/, 6/*#Ops*/, 3, 4, 5, 6, 7, 1, 
                    // Src: (st:isVoid (X86Wrapper:i32 (tblockaddress:i32):$src), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                    // Dst: (MOV32mi:isVoid addr:iPTR:$dst, (tblockaddress:i32):$src)
                  /*SwitchType*/ 26,  MVT::i64,// ->16094
/*16068*/           OPC_MoveParent,
/*16069*/           OPC_RecordChild2, // #2 = $dst
/*16070*/           OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*16072*/           OPC_CheckPredicate, 5, // Predicate_store
/*16074*/           OPC_CheckPatternPredicate, 5, // (TM.getCodeModel() == CodeModel::Small ||TM.getCodeModel() == CodeModel::Kernel) && (TM.getRelocationModel() == Reloc::Static)
/*16076*/           OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #3 #4 #5 #6 #7
/*16079*/           OPC_EmitMergeInputChains, 1, 0, 
/*16082*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::MOV64mi32), 0|OPFL_Chain|OPFL_MemRefs,
                        0/*#VTs*/, 6/*#Ops*/, 3, 4, 5, 6, 7, 1, 
                    // Src: (st:isVoid (X86Wrapper:i64 (tblockaddress:i64):$src), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                    // Dst: (MOV64mi32:isVoid addr:iPTR:$dst, (tblockaddress:i64):$src)
                  0, // EndSwitchType
                /*SwitchOpcode*/ 29,  ISD::TargetConstantPool,// ->16126
/*16097*/         OPC_MoveParent,
/*16098*/         OPC_CheckType, MVT::i64,
/*16100*/         OPC_MoveParent,
/*16101*/         OPC_RecordChild2, // #2 = $dst
/*16102*/         OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*16104*/         OPC_CheckPredicate, 5, // Predicate_store
/*16106*/         OPC_CheckPatternPredicate, 5, // (TM.getCodeModel() == CodeModel::Small ||TM.getCodeModel() == CodeModel::Kernel) && (TM.getRelocationModel() == Reloc::Static)
/*16108*/         OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #3 #4 #5 #6 #7
/*16111*/         OPC_EmitMergeInputChains, 1, 0, 
/*16114*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::MOV64mi32), 0|OPFL_Chain|OPFL_MemRefs,
                      0/*#VTs*/, 6/*#Ops*/, 3, 4, 5, 6, 7, 1, 
                  // Src: (st:isVoid (X86Wrapper:i64 (tconstpool:i64):$src), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                  // Dst: (MOV64mi32:isVoid addr:iPTR:$dst, (tconstpool:i64):$src)
                /*SwitchOpcode*/ 29,  ISD::TargetJumpTable,// ->16157
/*16128*/         OPC_MoveParent,
/*16129*/         OPC_CheckType, MVT::i64,
/*16131*/         OPC_MoveParent,
/*16132*/         OPC_RecordChild2, // #2 = $dst
/*16133*/         OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*16135*/         OPC_CheckPredicate, 5, // Predicate_store
/*16137*/         OPC_CheckPatternPredicate, 5, // (TM.getCodeModel() == CodeModel::Small ||TM.getCodeModel() == CodeModel::Kernel) && (TM.getRelocationModel() == Reloc::Static)
/*16139*/         OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #3 #4 #5 #6 #7
/*16142*/         OPC_EmitMergeInputChains, 1, 0, 
/*16145*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::MOV64mi32), 0|OPFL_Chain|OPFL_MemRefs,
                      0/*#VTs*/, 6/*#Ops*/, 3, 4, 5, 6, 7, 1, 
                  // Src: (st:isVoid (X86Wrapper:i64 (tjumptable:i64):$src), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                  // Dst: (MOV64mi32:isVoid addr:iPTR:$dst, (tjumptable:i64):$src)
                0, // EndSwitchOpcode
              0, // EndSwitchOpcode
/*16159*/   /*Scope*/ 21|128,1/*149*/, /*->16310*/
/*16161*/     OPC_RecordChild1, // #1 = $src
/*16162*/     OPC_MoveChild, 1,
/*16164*/     OPC_CheckOpcode, ISD::Constant,
/*16166*/     OPC_SwitchType /*4 cases */, 28,  MVT::i64,// ->16197
/*16169*/       OPC_CheckPredicate, 12, // Predicate_i64immSExt32
/*16171*/       OPC_MoveParent,
/*16172*/       OPC_RecordChild2, // #2 = $dst
/*16173*/       OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*16175*/       OPC_CheckPredicate, 5, // Predicate_store
/*16177*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #3 #4 #5 #6 #7
/*16180*/       OPC_EmitMergeInputChains, 1, 0, 
/*16183*/       OPC_EmitConvertToTarget, 1,
/*16185*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MOV64mi32), 0|OPFL_Chain|OPFL_MemRefs,
                    0/*#VTs*/, 6/*#Ops*/, 3, 4, 5, 6, 7, 8, 
                // Src: (st:isVoid (imm:i64)<<P:Predicate_i64immSExt32>>:$src, addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                // Dst: (MOV64mi32:isVoid addr:iPTR:$dst, (imm:i64):$src)
              /*SwitchType*/ 26,  MVT::i8,// ->16225
/*16199*/       OPC_MoveParent,
/*16200*/       OPC_RecordChild2, // #2 = $dst
/*16201*/       OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*16203*/       OPC_CheckPredicate, 5, // Predicate_store
/*16205*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #3 #4 #5 #6 #7
/*16208*/       OPC_EmitMergeInputChains, 1, 0, 
/*16211*/       OPC_EmitConvertToTarget, 1,
/*16213*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MOV8mi), 0|OPFL_Chain|OPFL_MemRefs,
                    0/*#VTs*/, 6/*#Ops*/, 3, 4, 5, 6, 7, 8, 
                // Src: (st:isVoid (imm:i8):$src, addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                // Dst: (MOV8mi:isVoid addr:iPTR:$dst, (imm:i8):$src)
              /*SwitchType*/ 26,  MVT::i16,// ->16253
/*16227*/       OPC_MoveParent,
/*16228*/       OPC_RecordChild2, // #2 = $dst
/*16229*/       OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*16231*/       OPC_CheckPredicate, 5, // Predicate_store
/*16233*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #3 #4 #5 #6 #7
/*16236*/       OPC_EmitMergeInputChains, 1, 0, 
/*16239*/       OPC_EmitConvertToTarget, 1,
/*16241*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MOV16mi), 0|OPFL_Chain|OPFL_MemRefs,
                    0/*#VTs*/, 6/*#Ops*/, 3, 4, 5, 6, 7, 8, 
                // Src: (st:isVoid (imm:i16):$src, addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                // Dst: (MOV16mi:isVoid addr:iPTR:$dst, (imm:i16):$src)
              /*SwitchType*/ 54,  MVT::i32,// ->16309
/*16255*/       OPC_MoveParent,
/*16256*/       OPC_RecordChild2, // #2 = $dst
/*16257*/       OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*16259*/       OPC_Scope, 22, /*->16283*/ // 2 children in Scope
/*16261*/         OPC_CheckPredicate, 5, // Predicate_store
/*16263*/         OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #3 #4 #5 #6 #7
/*16266*/         OPC_EmitMergeInputChains, 1, 0, 
/*16269*/         OPC_EmitConvertToTarget, 1,
/*16271*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::MOV32mi), 0|OPFL_Chain|OPFL_MemRefs,
                      0/*#VTs*/, 6/*#Ops*/, 3, 4, 5, 6, 7, 8, 
                  // Src: (st:isVoid (imm:i32):$src, addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                  // Dst: (MOV32mi:isVoid addr:iPTR:$dst, (imm:i32):$src)
/*16283*/       /*Scope*/ 24, /*->16308*/
/*16284*/         OPC_CheckPredicate, 17, // Predicate_truncstore
/*16286*/         OPC_CheckPredicate, 18, // Predicate_truncstorei16
/*16288*/         OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #3 #4 #5 #6 #7
/*16291*/         OPC_EmitMergeInputChains, 1, 0, 
/*16294*/         OPC_EmitConvertToTarget, 1,
/*16296*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::MOV16mi), 0|OPFL_Chain|OPFL_MemRefs,
                      0/*#VTs*/, 6/*#Ops*/, 3, 4, 5, 6, 7, 8, 
                  // Src: (st:isVoid (imm:i32):$src, addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>
                  // Dst: (MOV16mi:isVoid addr:iPTR:$dst, (imm:i16):$src)
/*16308*/       0, /*End of Scope*/
              0, // EndSwitchType
/*16310*/   /*Scope*/ 35, /*->16346*/
/*16311*/     OPC_MoveChild, 1,
/*16313*/     OPC_CheckOpcode, ISD::BIT_CONVERT,
/*16315*/     OPC_RecordChild0, // #1 = $src
/*16316*/     OPC_CheckChild0Type, MVT::f64,
/*16318*/     OPC_CheckType, MVT::i64,
/*16320*/     OPC_MoveParent,
/*16321*/     OPC_RecordChild2, // #2 = $dst
/*16322*/     OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*16324*/     OPC_CheckPredicate, 5, // Predicate_store
/*16326*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*16328*/     OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #3 #4 #5 #6 #7
/*16331*/     OPC_EmitMergeInputChains, 1, 0, 
/*16334*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVSDto64mr), 0|OPFL_Chain|OPFL_MemRefs,
                  0/*#VTs*/, 6/*#Ops*/, 3, 4, 5, 6, 7, 1, 
              // Src: (st:isVoid (bitconvert:i64 FR64:f64:$src), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
              // Dst: (MOVSDto64mr:isVoid addr:iPTR:$dst, FR64:f64:$src)
/*16346*/   /*Scope*/ 35, /*->16382*/
/*16347*/     OPC_RecordChild1, // #1 = $src
/*16348*/     OPC_MoveChild, 1,
/*16350*/     OPC_CheckOpcode, ISD::Constant,
/*16352*/     OPC_CheckType, MVT::i64,
/*16354*/     OPC_MoveParent,
/*16355*/     OPC_RecordChild2, // #2 = $dst
/*16356*/     OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*16358*/     OPC_CheckPredicate, 17, // Predicate_truncstore
/*16360*/     OPC_CheckPredicate, 18, // Predicate_truncstorei16
/*16362*/     OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #3 #4 #5 #6 #7
/*16365*/     OPC_EmitMergeInputChains, 1, 0, 
/*16368*/     OPC_EmitConvertToTarget, 1,
/*16370*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::MOV16mi), 0|OPFL_Chain|OPFL_MemRefs,
                  0/*#VTs*/, 6/*#Ops*/, 3, 4, 5, 6, 7, 8, 
              // Src: (st:isVoid (imm:i64):$src, addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>
              // Dst: (MOV16mi:isVoid addr:iPTR:$dst, (imm:i16):$src)
/*16382*/   /*Scope*/ 35, /*->16418*/
/*16383*/     OPC_MoveChild, 1,
/*16385*/     OPC_CheckOpcode, ISD::BIT_CONVERT,
/*16387*/     OPC_RecordChild0, // #1 = $src
/*16388*/     OPC_CheckChild0Type, MVT::f32,
/*16390*/     OPC_CheckType, MVT::i32,
/*16392*/     OPC_MoveParent,
/*16393*/     OPC_RecordChild2, // #2 = $dst
/*16394*/     OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*16396*/     OPC_CheckPredicate, 5, // Predicate_store
/*16398*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*16400*/     OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #3 #4 #5 #6 #7
/*16403*/     OPC_EmitMergeInputChains, 1, 0, 
/*16406*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVSS2DImr), 0|OPFL_Chain|OPFL_MemRefs,
                  0/*#VTs*/, 6/*#Ops*/, 3, 4, 5, 6, 7, 1, 
              // Src: (st:isVoid (bitconvert:i32 FR32:f32:$src), addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
              // Dst: (MOVSS2DImr:isVoid addr:iPTR:$dst, FR32:f32:$src)
/*16418*/   /*Scope*/ 85|128,6/*853*/, /*->17273*/
/*16420*/     OPC_RecordChild1, // #1 = $src
/*16421*/     OPC_Scope, 51, /*->16474*/ // 18 children in Scope
/*16423*/       OPC_CheckChild1Type, MVT::f32,
/*16425*/       OPC_RecordChild2, // #2 = $op
/*16426*/       OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*16428*/       OPC_CheckPredicate, 5, // Predicate_store
/*16430*/       OPC_Scope, 20, /*->16452*/ // 2 children in Scope
/*16432*/         OPC_CheckPatternPredicate, 6, // (!Subtarget->hasSSE1())
/*16434*/         OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$op #3 #4 #5 #6 #7
/*16437*/         OPC_EmitMergeInputChains, 1, 0, 
/*16440*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::ST_Fp32m), 0|OPFL_Chain|OPFL_MemRefs,
                      0/*#VTs*/, 6/*#Ops*/, 3, 4, 5, 6, 7, 1, 
                  // Src: (st:isVoid RFP32:f32:$src, addr:iPTR:$op)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                  // Dst: (ST_Fp32m:isVoid addr:iPTR:$op, RFP32:f32:$src)
/*16452*/       /*Scope*/ 20, /*->16473*/
/*16453*/         OPC_CheckPatternPredicate, 0, // (Subtarget->hasSSE1())
/*16455*/         OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #3 #4 #5 #6 #7
/*16458*/         OPC_EmitMergeInputChains, 1, 0, 
/*16461*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVSSmr), 0|OPFL_Chain|OPFL_MemRefs,
                      0/*#VTs*/, 6/*#Ops*/, 3, 4, 5, 6, 7, 1, 
                  // Src: (st:isVoid FR32:f32:$src, addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                  // Dst: (MOVSSmr:isVoid addr:iPTR:$dst, FR32:f32:$src)
/*16473*/       0, /*End of Scope*/
/*16474*/     /*Scope*/ 79, /*->16554*/
/*16475*/       OPC_CheckChild1Type, MVT::f64,
/*16477*/       OPC_RecordChild2, // #2 = $op
/*16478*/       OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*16480*/       OPC_Scope, 24, /*->16506*/ // 2 children in Scope
/*16482*/         OPC_CheckPredicate, 17, // Predicate_truncstore
/*16484*/         OPC_CheckPredicate, 19, // Predicate_truncstoref32
/*16486*/         OPC_CheckPatternPredicate, 7, // (!Subtarget->hasSSE2())
/*16488*/         OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$op #3 #4 #5 #6 #7
/*16491*/         OPC_EmitMergeInputChains, 1, 0, 
/*16494*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::ST_Fp64m32), 0|OPFL_Chain|OPFL_MemRefs,
                      0/*#VTs*/, 6/*#Ops*/, 3, 4, 5, 6, 7, 1, 
                  // Src: (st:isVoid RFP64:f64:$src, addr:iPTR:$op)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstoref32>>
                  // Dst: (ST_Fp64m32:isVoid addr:iPTR:$op, RFP64:f64:$src)
/*16506*/       /*Scope*/ 46, /*->16553*/
/*16507*/         OPC_CheckPredicate, 5, // Predicate_store
/*16509*/         OPC_Scope, 20, /*->16531*/ // 2 children in Scope
/*16511*/           OPC_CheckPatternPredicate, 7, // (!Subtarget->hasSSE2())
/*16513*/           OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$op #3 #4 #5 #6 #7
/*16516*/           OPC_EmitMergeInputChains, 1, 0, 
/*16519*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::ST_Fp64m), 0|OPFL_Chain|OPFL_MemRefs,
                        0/*#VTs*/, 6/*#Ops*/, 3, 4, 5, 6, 7, 1, 
                    // Src: (st:isVoid RFP64:f64:$src, addr:iPTR:$op)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                    // Dst: (ST_Fp64m:isVoid addr:iPTR:$op, RFP64:f64:$src)
/*16531*/         /*Scope*/ 20, /*->16552*/
/*16532*/           OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*16534*/           OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #3 #4 #5 #6 #7
/*16537*/           OPC_EmitMergeInputChains, 1, 0, 
/*16540*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVSDmr), 0|OPFL_Chain|OPFL_MemRefs,
                        0/*#VTs*/, 6/*#Ops*/, 3, 4, 5, 6, 7, 1, 
                    // Src: (st:isVoid FR64:f64:$src, addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                    // Dst: (MOVSDmr:isVoid addr:iPTR:$dst, FR64:f64:$src)
/*16552*/         0, /*End of Scope*/
/*16553*/       0, /*End of Scope*/
/*16554*/     /*Scope*/ 75, /*->16630*/
/*16555*/       OPC_CheckChild1Type, MVT::f80,
/*16557*/       OPC_RecordChild2, // #2 = $op
/*16558*/       OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*16560*/       OPC_Scope, 46, /*->16608*/ // 2 children in Scope
/*16562*/         OPC_CheckPredicate, 17, // Predicate_truncstore
/*16564*/         OPC_Scope, 20, /*->16586*/ // 2 children in Scope
/*16566*/           OPC_CheckPredicate, 19, // Predicate_truncstoref32
/*16568*/           OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$op #3 #4 #5 #6 #7
/*16571*/           OPC_EmitMergeInputChains, 1, 0, 
/*16574*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::ST_Fp80m32), 0|OPFL_Chain|OPFL_MemRefs,
                        0/*#VTs*/, 6/*#Ops*/, 3, 4, 5, 6, 7, 1, 
                    // Src: (st:isVoid RFP80:f80:$src, addr:iPTR:$op)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstoref32>>
                    // Dst: (ST_Fp80m32:isVoid addr:iPTR:$op, RFP80:f80:$src)
/*16586*/         /*Scope*/ 20, /*->16607*/
/*16587*/           OPC_CheckPredicate, 20, // Predicate_truncstoref64
/*16589*/           OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$op #3 #4 #5 #6 #7
/*16592*/           OPC_EmitMergeInputChains, 1, 0, 
/*16595*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::ST_Fp80m64), 0|OPFL_Chain|OPFL_MemRefs,
                        0/*#VTs*/, 6/*#Ops*/, 3, 4, 5, 6, 7, 1, 
                    // Src: (st:isVoid RFP80:f80:$src, addr:iPTR:$op)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstoref64>>
                    // Dst: (ST_Fp80m64:isVoid addr:iPTR:$op, RFP80:f80:$src)
/*16607*/         0, /*End of Scope*/
/*16608*/       /*Scope*/ 20, /*->16629*/
/*16609*/         OPC_CheckPredicate, 5, // Predicate_store
/*16611*/         OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$op #3 #4 #5 #6 #7
/*16614*/         OPC_EmitMergeInputChains, 1, 0, 
/*16617*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::ST_FpP80m), 0|OPFL_Chain|OPFL_MemRefs,
                      0/*#VTs*/, 6/*#Ops*/, 3, 4, 5, 6, 7, 1, 
                  // Src: (st:isVoid RFP80:f80:$src, addr:iPTR:$op)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                  // Dst: (ST_FpP80m:isVoid addr:iPTR:$op, RFP80:f80:$src)
/*16629*/       0, /*End of Scope*/
/*16630*/     /*Scope*/ 25, /*->16656*/
/*16631*/       OPC_CheckChild1Type, MVT::i8,
/*16633*/       OPC_RecordChild2, // #2 = $dst
/*16634*/       OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*16636*/       OPC_CheckPredicate, 5, // Predicate_store
/*16638*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #3 #4 #5 #6 #7
/*16641*/       OPC_EmitMergeInputChains, 1, 0, 
/*16644*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MOV8mr), 0|OPFL_Chain|OPFL_MemRefs,
                    0/*#VTs*/, 6/*#Ops*/, 3, 4, 5, 6, 7, 1, 
                // Src: (st:isVoid GR8:i8:$src, addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                // Dst: (MOV8mr:isVoid addr:iPTR:$dst, GR8:i8:$src)
/*16656*/     /*Scope*/ 25, /*->16682*/
/*16657*/       OPC_CheckChild1Type, MVT::i16,
/*16659*/       OPC_RecordChild2, // #2 = $dst
/*16660*/       OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*16662*/       OPC_CheckPredicate, 5, // Predicate_store
/*16664*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #3 #4 #5 #6 #7
/*16667*/       OPC_EmitMergeInputChains, 1, 0, 
/*16670*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MOV16mr), 0|OPFL_Chain|OPFL_MemRefs,
                    0/*#VTs*/, 6/*#Ops*/, 3, 4, 5, 6, 7, 1, 
                // Src: (st:isVoid GR16:i16:$src, addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                // Dst: (MOV16mr:isVoid addr:iPTR:$dst, GR16:i16:$src)
/*16682*/     /*Scope*/ 63, /*->16746*/
/*16683*/       OPC_CheckChild1Type, MVT::i32,
/*16685*/       OPC_RecordChild2, // #2 = $dst
/*16686*/       OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*16688*/       OPC_Scope, 20, /*->16710*/ // 2 children in Scope
/*16690*/         OPC_CheckPredicate, 5, // Predicate_store
/*16692*/         OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #3 #4 #5 #6 #7
/*16695*/         OPC_EmitMergeInputChains, 1, 0, 
/*16698*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::MOV32mr), 0|OPFL_Chain|OPFL_MemRefs,
                      0/*#VTs*/, 6/*#Ops*/, 3, 4, 5, 6, 7, 1, 
                  // Src: (st:isVoid GR32:i32:$src, addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                  // Dst: (MOV32mr:isVoid addr:iPTR:$dst, GR32:i32:$src)
/*16710*/       /*Scope*/ 34, /*->16745*/
/*16711*/         OPC_CheckPredicate, 17, // Predicate_truncstore
/*16713*/         OPC_CheckPredicate, 18, // Predicate_truncstorei16
/*16715*/         OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #3 #4 #5 #6 #7
/*16718*/         OPC_EmitMergeInputChains, 1, 0, 
/*16721*/         OPC_EmitInteger, MVT::i32, 3, 
/*16724*/         OPC_EmitNode, TARGET_OPCODE(TargetOpcode::EXTRACT_SUBREG), 0,
                      1/*#VTs*/, MVT::i16, 2/*#Ops*/, 1, 8,  // Results = #9 
/*16733*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::MOV16mr), 0|OPFL_Chain|OPFL_MemRefs,
                      0/*#VTs*/, 6/*#Ops*/, 3, 4, 5, 6, 7, 9, 
                  // Src: (st:isVoid GR32:i32:$src, addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>
                  // Dst: (MOV16mr:isVoid addr:iPTR:$dst, (EXTRACT_SUBREG:i16 GR32:i32:$src, 3:i32))
/*16745*/       0, /*End of Scope*/
/*16746*/     /*Scope*/ 63, /*->16810*/
/*16747*/       OPC_CheckChild1Type, MVT::i64,
/*16749*/       OPC_RecordChild2, // #2 = $dst
/*16750*/       OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*16752*/       OPC_Scope, 20, /*->16774*/ // 2 children in Scope
/*16754*/         OPC_CheckPredicate, 5, // Predicate_store
/*16756*/         OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #3 #4 #5 #6 #7
/*16759*/         OPC_EmitMergeInputChains, 1, 0, 
/*16762*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::MOV64mr), 0|OPFL_Chain|OPFL_MemRefs,
                      0/*#VTs*/, 6/*#Ops*/, 3, 4, 5, 6, 7, 1, 
                  // Src: (st:isVoid GR64:i64:$src, addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                  // Dst: (MOV64mr:isVoid addr:iPTR:$dst, GR64:i64:$src)
/*16774*/       /*Scope*/ 34, /*->16809*/
/*16775*/         OPC_CheckPredicate, 17, // Predicate_truncstore
/*16777*/         OPC_CheckPredicate, 18, // Predicate_truncstorei16
/*16779*/         OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #3 #4 #5 #6 #7
/*16782*/         OPC_EmitMergeInputChains, 1, 0, 
/*16785*/         OPC_EmitInteger, MVT::i32, 3, 
/*16788*/         OPC_EmitNode, TARGET_OPCODE(TargetOpcode::EXTRACT_SUBREG), 0,
                      1/*#VTs*/, MVT::i16, 2/*#Ops*/, 1, 8,  // Results = #9 
/*16797*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::MOV16mr), 0|OPFL_Chain|OPFL_MemRefs,
                      0/*#VTs*/, 6/*#Ops*/, 3, 4, 5, 6, 7, 9, 
                  // Src: (st:isVoid GR64:i64:$src, addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>
                  // Dst: (MOV16mr:isVoid addr:iPTR:$dst, (EXTRACT_SUBREG:i16 GR64:i64:$src, 3:i32))
/*16809*/       0, /*End of Scope*/
/*16810*/     /*Scope*/ 53, /*->16864*/
/*16811*/       OPC_CheckChild1Type, MVT::v4f32,
/*16813*/       OPC_RecordChild2, // #2 = $dst
/*16814*/       OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*16816*/       OPC_CheckPredicate, 5, // Predicate_store
/*16818*/       OPC_Scope, 22, /*->16842*/ // 2 children in Scope
/*16820*/         OPC_CheckPredicate, 21, // Predicate_alignedstore
/*16822*/         OPC_CheckPatternPredicate, 0, // (Subtarget->hasSSE1())
/*16824*/         OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #3 #4 #5 #6 #7
/*16827*/         OPC_EmitMergeInputChains, 1, 0, 
/*16830*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVAPSmr), 0|OPFL_Chain|OPFL_MemRefs,
                      0/*#VTs*/, 6/*#Ops*/, 3, 4, 5, 6, 7, 1, 
                  // Src: (st:isVoid VR128:v4f32:$src, addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>
                  // Dst: (MOVAPSmr:isVoid addr:iPTR:$dst, VR128:v4f32:$src)
/*16842*/       /*Scope*/ 20, /*->16863*/
/*16843*/         OPC_CheckPatternPredicate, 0, // (Subtarget->hasSSE1())
/*16845*/         OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #3 #4 #5 #6 #7
/*16848*/         OPC_EmitMergeInputChains, 1, 0, 
/*16851*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVUPSmr), 0|OPFL_Chain|OPFL_MemRefs,
                      0/*#VTs*/, 6/*#Ops*/, 3, 4, 5, 6, 7, 1, 
                  // Src: (st:isVoid VR128:v4f32:$src, addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                  // Dst: (MOVUPSmr:isVoid addr:iPTR:$dst, VR128:v4f32:$src)
/*16863*/       0, /*End of Scope*/
/*16864*/     /*Scope*/ 53, /*->16918*/
/*16865*/       OPC_CheckChild1Type, MVT::v2f64,
/*16867*/       OPC_RecordChild2, // #2 = $dst
/*16868*/       OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*16870*/       OPC_CheckPredicate, 5, // Predicate_store
/*16872*/       OPC_Scope, 22, /*->16896*/ // 2 children in Scope
/*16874*/         OPC_CheckPredicate, 21, // Predicate_alignedstore
/*16876*/         OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*16878*/         OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #3 #4 #5 #6 #7
/*16881*/         OPC_EmitMergeInputChains, 1, 0, 
/*16884*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVAPDmr), 0|OPFL_Chain|OPFL_MemRefs,
                      0/*#VTs*/, 6/*#Ops*/, 3, 4, 5, 6, 7, 1, 
                  // Src: (st:isVoid VR128:v2f64:$src, addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>
                  // Dst: (MOVAPDmr:isVoid addr:iPTR:$dst, VR128:v2f64:$src)
/*16896*/       /*Scope*/ 20, /*->16917*/
/*16897*/         OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*16899*/         OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #3 #4 #5 #6 #7
/*16902*/         OPC_EmitMergeInputChains, 1, 0, 
/*16905*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVUPDmr), 0|OPFL_Chain|OPFL_MemRefs,
                      0/*#VTs*/, 6/*#Ops*/, 3, 4, 5, 6, 7, 1, 
                  // Src: (st:isVoid VR128:v2f64:$src, addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                  // Dst: (MOVUPDmr:isVoid addr:iPTR:$dst, VR128:v2f64:$src)
/*16917*/       0, /*End of Scope*/
/*16918*/     /*Scope*/ 49, /*->16968*/
/*16919*/       OPC_CheckChild1Type, MVT::v2i64,
/*16921*/       OPC_RecordChild2, // #2 = $dst
/*16922*/       OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*16924*/       OPC_CheckPredicate, 5, // Predicate_store
/*16926*/       OPC_Scope, 20, /*->16948*/ // 2 children in Scope
/*16928*/         OPC_CheckPredicate, 21, // Predicate_alignedstore
/*16930*/         OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #3 #4 #5 #6 #7
/*16933*/         OPC_EmitMergeInputChains, 1, 0, 
/*16936*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVAPSmr), 0|OPFL_Chain|OPFL_MemRefs,
                      0/*#VTs*/, 6/*#Ops*/, 3, 4, 5, 6, 7, 1, 
                  // Src: (st:isVoid VR128:v2i64:$src, addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>
                  // Dst: (MOVAPSmr:isVoid addr:iPTR:$dst, VR128:v16i8:$src)
/*16948*/       /*Scope*/ 18, /*->16967*/
/*16949*/         OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #3 #4 #5 #6 #7
/*16952*/         OPC_EmitMergeInputChains, 1, 0, 
/*16955*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVUPSmr), 0|OPFL_Chain|OPFL_MemRefs,
                      0/*#VTs*/, 6/*#Ops*/, 3, 4, 5, 6, 7, 1, 
                  // Src: (st:isVoid VR128:v2i64:$src, addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                  // Dst: (MOVUPSmr:isVoid addr:iPTR:$dst, VR128:v16i8:$src)
/*16967*/       0, /*End of Scope*/
/*16968*/     /*Scope*/ 49, /*->17018*/
/*16969*/       OPC_CheckChild1Type, MVT::v4i32,
/*16971*/       OPC_RecordChild2, // #2 = $dst
/*16972*/       OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*16974*/       OPC_CheckPredicate, 5, // Predicate_store
/*16976*/       OPC_Scope, 20, /*->16998*/ // 2 children in Scope
/*16978*/         OPC_CheckPredicate, 21, // Predicate_alignedstore
/*16980*/         OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #3 #4 #5 #6 #7
/*16983*/         OPC_EmitMergeInputChains, 1, 0, 
/*16986*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVAPSmr), 0|OPFL_Chain|OPFL_MemRefs,
                      0/*#VTs*/, 6/*#Ops*/, 3, 4, 5, 6, 7, 1, 
                  // Src: (st:isVoid VR128:v4i32:$src, addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>
                  // Dst: (MOVAPSmr:isVoid addr:iPTR:$dst, VR128:v16i8:$src)
/*16998*/       /*Scope*/ 18, /*->17017*/
/*16999*/         OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #3 #4 #5 #6 #7
/*17002*/         OPC_EmitMergeInputChains, 1, 0, 
/*17005*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVUPSmr), 0|OPFL_Chain|OPFL_MemRefs,
                      0/*#VTs*/, 6/*#Ops*/, 3, 4, 5, 6, 7, 1, 
                  // Src: (st:isVoid VR128:v4i32:$src, addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                  // Dst: (MOVUPSmr:isVoid addr:iPTR:$dst, VR128:v16i8:$src)
/*17017*/       0, /*End of Scope*/
/*17018*/     /*Scope*/ 49, /*->17068*/
/*17019*/       OPC_CheckChild1Type, MVT::v8i16,
/*17021*/       OPC_RecordChild2, // #2 = $dst
/*17022*/       OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*17024*/       OPC_CheckPredicate, 5, // Predicate_store
/*17026*/       OPC_Scope, 20, /*->17048*/ // 2 children in Scope
/*17028*/         OPC_CheckPredicate, 21, // Predicate_alignedstore
/*17030*/         OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #3 #4 #5 #6 #7
/*17033*/         OPC_EmitMergeInputChains, 1, 0, 
/*17036*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVAPSmr), 0|OPFL_Chain|OPFL_MemRefs,
                      0/*#VTs*/, 6/*#Ops*/, 3, 4, 5, 6, 7, 1, 
                  // Src: (st:isVoid VR128:v8i16:$src, addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>
                  // Dst: (MOVAPSmr:isVoid addr:iPTR:$dst, VR128:v16i8:$src)
/*17048*/       /*Scope*/ 18, /*->17067*/
/*17049*/         OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #3 #4 #5 #6 #7
/*17052*/         OPC_EmitMergeInputChains, 1, 0, 
/*17055*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVUPSmr), 0|OPFL_Chain|OPFL_MemRefs,
                      0/*#VTs*/, 6/*#Ops*/, 3, 4, 5, 6, 7, 1, 
                  // Src: (st:isVoid VR128:v8i16:$src, addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                  // Dst: (MOVUPSmr:isVoid addr:iPTR:$dst, VR128:v16i8:$src)
/*17067*/       0, /*End of Scope*/
/*17068*/     /*Scope*/ 49, /*->17118*/
/*17069*/       OPC_CheckChild1Type, MVT::v16i8,
/*17071*/       OPC_RecordChild2, // #2 = $dst
/*17072*/       OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*17074*/       OPC_CheckPredicate, 5, // Predicate_store
/*17076*/       OPC_Scope, 20, /*->17098*/ // 2 children in Scope
/*17078*/         OPC_CheckPredicate, 21, // Predicate_alignedstore
/*17080*/         OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #3 #4 #5 #6 #7
/*17083*/         OPC_EmitMergeInputChains, 1, 0, 
/*17086*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVAPSmr), 0|OPFL_Chain|OPFL_MemRefs,
                      0/*#VTs*/, 6/*#Ops*/, 3, 4, 5, 6, 7, 1, 
                  // Src: (st:isVoid VR128:v16i8:$src, addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>
                  // Dst: (MOVAPSmr:isVoid addr:iPTR:$dst, VR128:v16i8:$src)
/*17098*/       /*Scope*/ 18, /*->17117*/
/*17099*/         OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #3 #4 #5 #6 #7
/*17102*/         OPC_EmitMergeInputChains, 1, 0, 
/*17105*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVUPSmr), 0|OPFL_Chain|OPFL_MemRefs,
                      0/*#VTs*/, 6/*#Ops*/, 3, 4, 5, 6, 7, 1, 
                  // Src: (st:isVoid VR128:v16i8:$src, addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                  // Dst: (MOVUPSmr:isVoid addr:iPTR:$dst, VR128:v16i8:$src)
/*17117*/       0, /*End of Scope*/
/*17118*/     /*Scope*/ 49, /*->17168*/
/*17119*/       OPC_CheckChild1Type, MVT::v1i64,
/*17121*/       OPC_RecordChild2, // #2 = $dst
/*17122*/       OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*17124*/       OPC_CheckPredicate, 5, // Predicate_store
/*17126*/       OPC_Scope, 20, /*->17148*/ // 2 children in Scope
/*17128*/         OPC_CheckPatternPredicate, 8, // (Subtarget->hasMMX())
/*17130*/         OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #3 #4 #5 #6 #7
/*17133*/         OPC_EmitMergeInputChains, 1, 0, 
/*17136*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_MOVQ64mr), 0|OPFL_Chain|OPFL_MemRefs,
                      0/*#VTs*/, 6/*#Ops*/, 3, 4, 5, 6, 7, 1, 
                  // Src: (st:isVoid VR64:v1i64:$src, addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                  // Dst: (MMX_MOVQ64mr:isVoid addr:iPTR:$dst, VR64:v1i64:$src)
/*17148*/       /*Scope*/ 18, /*->17167*/
/*17149*/         OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #3 #4 #5 #6 #7
/*17152*/         OPC_EmitMergeInputChains, 1, 0, 
/*17155*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_MOVQ64mr), 0|OPFL_Chain|OPFL_MemRefs,
                      0/*#VTs*/, 6/*#Ops*/, 3, 4, 5, 6, 7, 1, 
                  // Src: (st:isVoid VR64:v1i64:$src, addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                  // Dst: (MMX_MOVQ64mr:isVoid addr:iPTR:$dst, VR64:v8i8:$src)
/*17167*/       0, /*End of Scope*/
/*17168*/     /*Scope*/ 25, /*->17194*/
/*17169*/       OPC_CheckChild1Type, MVT::v8i8,
/*17171*/       OPC_RecordChild2, // #2 = $dst
/*17172*/       OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*17174*/       OPC_CheckPredicate, 5, // Predicate_store
/*17176*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #3 #4 #5 #6 #7
/*17179*/       OPC_EmitMergeInputChains, 1, 0, 
/*17182*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_MOVQ64mr), 0|OPFL_Chain|OPFL_MemRefs,
                    0/*#VTs*/, 6/*#Ops*/, 3, 4, 5, 6, 7, 1, 
                // Src: (st:isVoid VR64:v8i8:$src, addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                // Dst: (MMX_MOVQ64mr:isVoid addr:iPTR:$dst, VR64:v8i8:$src)
/*17194*/     /*Scope*/ 25, /*->17220*/
/*17195*/       OPC_CheckChild1Type, MVT::v4i16,
/*17197*/       OPC_RecordChild2, // #2 = $dst
/*17198*/       OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*17200*/       OPC_CheckPredicate, 5, // Predicate_store
/*17202*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #3 #4 #5 #6 #7
/*17205*/       OPC_EmitMergeInputChains, 1, 0, 
/*17208*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_MOVQ64mr), 0|OPFL_Chain|OPFL_MemRefs,
                    0/*#VTs*/, 6/*#Ops*/, 3, 4, 5, 6, 7, 1, 
                // Src: (st:isVoid VR64:v4i16:$src, addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                // Dst: (MMX_MOVQ64mr:isVoid addr:iPTR:$dst, VR64:v8i8:$src)
/*17220*/     /*Scope*/ 25, /*->17246*/
/*17221*/       OPC_CheckChild1Type, MVT::v2i32,
/*17223*/       OPC_RecordChild2, // #2 = $dst
/*17224*/       OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*17226*/       OPC_CheckPredicate, 5, // Predicate_store
/*17228*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #3 #4 #5 #6 #7
/*17231*/       OPC_EmitMergeInputChains, 1, 0, 
/*17234*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_MOVQ64mr), 0|OPFL_Chain|OPFL_MemRefs,
                    0/*#VTs*/, 6/*#Ops*/, 3, 4, 5, 6, 7, 1, 
                // Src: (st:isVoid VR64:v2i32:$src, addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                // Dst: (MMX_MOVQ64mr:isVoid addr:iPTR:$dst, VR64:v8i8:$src)
/*17246*/     /*Scope*/ 25, /*->17272*/
/*17247*/       OPC_CheckChild1Type, MVT::v2f32,
/*17249*/       OPC_RecordChild2, // #2 = $dst
/*17250*/       OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*17252*/       OPC_CheckPredicate, 5, // Predicate_store
/*17254*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #3 #4 #5 #6 #7
/*17257*/       OPC_EmitMergeInputChains, 1, 0, 
/*17260*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_MOVQ64mr), 0|OPFL_Chain|OPFL_MemRefs,
                    0/*#VTs*/, 6/*#Ops*/, 3, 4, 5, 6, 7, 1, 
                // Src: (st:isVoid VR64:v2f32:$src, addr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>
                // Dst: (MMX_MOVQ64mr:isVoid addr:iPTR:$dst, VR64:v8i8:$src)
/*17272*/     0, /*End of Scope*/
/*17273*/   0, /*End of Scope*/
          /*SwitchOpcode*/ 7|128,24/*3079*/,  ISD::VECTOR_SHUFFLE,// ->20356
/*17277*/   OPC_Scope, 82, /*->17361*/ // 29 children in Scope
/*17279*/     OPC_RecordChild0, // #0 = $src1
/*17280*/     OPC_MoveChild, 1,
/*17282*/     OPC_CheckOpcode, ISD::BIT_CONVERT,
/*17284*/     OPC_MoveChild, 0,
/*17286*/     OPC_CheckOpcode, ISD::SCALAR_TO_VECTOR,
/*17288*/     OPC_MoveChild, 0,
/*17290*/     OPC_CheckOpcode, ISD::LOAD,
/*17292*/     OPC_RecordMemRef,
/*17293*/     OPC_RecordNode, // #1 = 'ld' chained node
/*17294*/     OPC_CheckFoldableChainNode,
/*17295*/     OPC_RecordChild1, // #2 = $src2
/*17296*/     OPC_CheckPredicate, 2, // Predicate_unindexedload
/*17298*/     OPC_CheckPredicate, 8, // Predicate_load
/*17300*/     OPC_CheckPredicate, 9, // Predicate_dsload
/*17302*/     OPC_CheckType, MVT::f64,
/*17304*/     OPC_MoveParent,
/*17305*/     OPC_CheckType, MVT::v2f64,
/*17307*/     OPC_MoveParent,
/*17308*/     OPC_MoveParent,
/*17309*/     OPC_CheckType, MVT::v4f32,
/*17311*/     OPC_Scope, 23, /*->17336*/ // 2 children in Scope
/*17313*/       OPC_CheckPredicate, 13, // Predicate_movlp
/*17315*/       OPC_CheckPatternPredicate, 0, // (Subtarget->hasSSE1())
/*17317*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*17320*/       OPC_EmitMergeInputChains, 1, 1, 
/*17323*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVLPSrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v4f32, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (vector_shuffle:v4f32 VR128:v4f32:$src1, (bitconvert:v4f32 (scalar_to_vector:v2f64 (ld:f64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>)))<<P:Predicate_movlp>>
                // Dst: (MOVLPSrm:v4f32 VR128:v4f32:$src1, addr:iPTR:$src2)
/*17336*/     /*Scope*/ 23, /*->17360*/
/*17337*/       OPC_CheckPredicate, 22, // Predicate_movlhps
/*17339*/       OPC_CheckPatternPredicate, 0, // (Subtarget->hasSSE1())
/*17341*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*17344*/       OPC_EmitMergeInputChains, 1, 1, 
/*17347*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVHPSrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v4f32, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (vector_shuffle:v4f32 VR128:v4f32:$src1, (bitconvert:v4f32 (scalar_to_vector:v2f64 (ld:f64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>)))<<P:Predicate_movlhps>>
                // Dst: (MOVHPSrm:v4f32 VR128:v4f32:$src1, addr:iPTR:$src2)
/*17360*/     0, /*End of Scope*/
/*17361*/   /*Scope*/ 77, /*->17439*/
/*17362*/     OPC_MoveChild, 0,
/*17364*/     OPC_CheckOpcode, ISD::BIT_CONVERT,
/*17366*/     OPC_MoveChild, 0,
/*17368*/     OPC_CheckOpcode, ISD::LOAD,
/*17370*/     OPC_RecordMemRef,
/*17371*/     OPC_RecordNode, // #0 = 'ld' chained node
/*17372*/     OPC_CheckFoldableChainNode,
/*17373*/     OPC_RecordChild1, // #1 = $src
/*17374*/     OPC_CheckPredicate, 2, // Predicate_unindexedload
/*17376*/     OPC_CheckPredicate, 8, // Predicate_load
/*17378*/     OPC_CheckPredicate, 23, // Predicate_memop
/*17380*/     OPC_CheckType, MVT::v2i64,
/*17382*/     OPC_MoveParent,
/*17383*/     OPC_MoveParent,
/*17384*/     OPC_MoveChild, 1,
/*17386*/     OPC_CheckOpcode, ISD::UNDEF,
/*17388*/     OPC_MoveParent,
/*17389*/     OPC_CheckType, MVT::v4i32,
/*17391*/     OPC_Scope, 22, /*->17415*/ // 2 children in Scope
/*17393*/       OPC_CheckPredicate, 24, // Predicate_movshdup
/*17395*/       OPC_CheckPatternPredicate, 9, // (Subtarget->hasSSE3())
/*17397*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*17400*/       OPC_EmitMergeInputChains, 1, 0, 
/*17403*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVSHDUPrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v4i32, 5/*#Ops*/, 2, 3, 4, 5, 6, 
                // Src: (vector_shuffle:v4i32 (bitconvert:v4i32 (ld:v2i64 addr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>), (undef:v4i32))<<P:Predicate_movshdup>>
                // Dst: (MOVSHDUPrm:v4i32 addr:iPTR:$src)
/*17415*/     /*Scope*/ 22, /*->17438*/
/*17416*/       OPC_CheckPredicate, 25, // Predicate_movsldup
/*17418*/       OPC_CheckPatternPredicate, 9, // (Subtarget->hasSSE3())
/*17420*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*17423*/       OPC_EmitMergeInputChains, 1, 0, 
/*17426*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVSLDUPrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v4i32, 5/*#Ops*/, 2, 3, 4, 5, 6, 
                // Src: (vector_shuffle:v4i32 (bitconvert:v4i32 (ld:v2i64 addr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>), (undef:v4i32))<<P:Predicate_movsldup>>
                // Dst: (MOVSLDUPrm:v4i32 addr:iPTR:$src)
/*17438*/     0, /*End of Scope*/
/*17439*/   /*Scope*/ 48|128,1/*176*/, /*->17617*/
/*17441*/     OPC_RecordChild0, // #0 = $src1
/*17442*/     OPC_MoveChild, 1,
/*17444*/     OPC_SwitchOpcode /*2 cases */, 70,  ISD::SCALAR_TO_VECTOR,// ->17517
/*17447*/       OPC_MoveChild, 0,
/*17449*/       OPC_CheckOpcode, ISD::LOAD,
/*17451*/       OPC_RecordMemRef,
/*17452*/       OPC_RecordNode, // #1 = 'ld' chained node
/*17453*/       OPC_CheckFoldableChainNode,
/*17454*/       OPC_RecordChild1, // #2 = $src2
/*17455*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*17457*/       OPC_CheckPredicate, 8, // Predicate_load
/*17459*/       OPC_CheckPredicate, 9, // Predicate_dsload
/*17461*/       OPC_CheckType, MVT::f64,
/*17463*/       OPC_MoveParent,
/*17464*/       OPC_MoveParent,
/*17465*/       OPC_CheckType, MVT::v2f64,
/*17467*/       OPC_Scope, 23, /*->17492*/ // 2 children in Scope
/*17469*/         OPC_CheckPredicate, 13, // Predicate_movlp
/*17471*/         OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*17473*/         OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*17476*/         OPC_EmitMergeInputChains, 1, 1, 
/*17479*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVLPDrm), 0|OPFL_Chain|OPFL_MemRefs,
                      1/*#VTs*/, MVT::v2f64, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                  // Src: (vector_shuffle:v2f64 VR128:v2f64:$src1, (scalar_to_vector:v2f64 (ld:f64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>))<<P:Predicate_movlp>>
                  // Dst: (MOVLPDrm:v2f64 VR128:v2f64:$src1, addr:iPTR:$src2)
/*17492*/       /*Scope*/ 23, /*->17516*/
/*17493*/         OPC_CheckPredicate, 22, // Predicate_movlhps
/*17495*/         OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*17497*/         OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*17500*/         OPC_EmitMergeInputChains, 1, 1, 
/*17503*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVHPDrm), 0|OPFL_Chain|OPFL_MemRefs,
                      1/*#VTs*/, MVT::v2f64, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                  // Src: (vector_shuffle:v2f64 VR128:v2f64:$src1, (scalar_to_vector:v2f64 (ld:f64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>))<<P:Predicate_movlhps>>
                  // Dst: (MOVHPDrm:v2f64 VR128:v2f64:$src1, addr:iPTR:$src2)
/*17516*/       0, /*End of Scope*/
              /*SwitchOpcode*/ 97,  ISD::LOAD,// ->17616
/*17519*/       OPC_RecordMemRef,
/*17520*/       OPC_RecordNode, // #1 = 'ld' chained node
/*17521*/       OPC_CheckFoldableChainNode,
/*17522*/       OPC_RecordChild1, // #2 = $src2
/*17523*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*17525*/       OPC_CheckPredicate, 8, // Predicate_load
/*17527*/       OPC_MoveParent,
/*17528*/       OPC_CheckPredicate, 13, // Predicate_movlp
/*17530*/       OPC_SwitchType /*4 cases */, 19,  MVT::v4f32,// ->17552
/*17533*/         OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*17536*/         OPC_EmitMergeInputChains, 1, 1, 
/*17539*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVLPSrm), 0|OPFL_Chain|OPFL_MemRefs,
                      1/*#VTs*/, MVT::v4f32, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                  // Src: (vector_shuffle:v4f32 VR128:v4f32:$src1, (ld:v4f32 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)<<P:Predicate_movlp>>
                  // Dst: (MOVLPSrm:v4f32 VR128:v16i8:$src1, addr:iPTR:$src2)
                /*SwitchType*/ 19,  MVT::v2f64,// ->17573
/*17554*/         OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*17557*/         OPC_EmitMergeInputChains, 1, 1, 
/*17560*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVLPDrm), 0|OPFL_Chain|OPFL_MemRefs,
                      1/*#VTs*/, MVT::v2f64, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                  // Src: (vector_shuffle:v2f64 VR128:v2f64:$src1, (ld:v2f64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)<<P:Predicate_movlp>>
                  // Dst: (MOVLPDrm:v2f64 VR128:v16i8:$src1, addr:iPTR:$src2)
                /*SwitchType*/ 19,  MVT::v4i32,// ->17594
/*17575*/         OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*17578*/         OPC_EmitMergeInputChains, 1, 1, 
/*17581*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVLPSrm), 0|OPFL_Chain|OPFL_MemRefs,
                      1/*#VTs*/, MVT::v4i32, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                  // Src: (vector_shuffle:v4i32 VR128:v4i32:$src1, (ld:v4i32 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)<<P:Predicate_movlp>>
                  // Dst: (MOVLPSrm:v4i32 VR128:v16i8:$src1, addr:iPTR:$src2)
                /*SwitchType*/ 19,  MVT::v2i64,// ->17615
/*17596*/         OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*17599*/         OPC_EmitMergeInputChains, 1, 1, 
/*17602*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVLPDrm), 0|OPFL_Chain|OPFL_MemRefs,
                      1/*#VTs*/, MVT::v2i64, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                  // Src: (vector_shuffle:v2i64 VR128:v2i64:$src1, (ld:v2i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)<<P:Predicate_movlp>>
                  // Dst: (MOVLPDrm:v2i64 VR128:v16i8:$src1, addr:iPTR:$src2)
                0, // EndSwitchType
              0, // EndSwitchOpcode
/*17617*/   /*Scope*/ 56, /*->17674*/
/*17618*/     OPC_RecordNode, // #0 = $src2
/*17619*/     OPC_MoveChild, 0,
/*17621*/     OPC_CheckOpcode, ISD::BIT_CONVERT,
/*17623*/     OPC_MoveChild, 0,
/*17625*/     OPC_CheckOpcode, ISD::LOAD,
/*17627*/     OPC_RecordMemRef,
/*17628*/     OPC_RecordNode, // #1 = 'ld' chained node
/*17629*/     OPC_CheckFoldableChainNode,
/*17630*/     OPC_RecordChild1, // #2 = $src1
/*17631*/     OPC_CheckPredicate, 2, // Predicate_unindexedload
/*17633*/     OPC_CheckPredicate, 8, // Predicate_load
/*17635*/     OPC_CheckPredicate, 23, // Predicate_memop
/*17637*/     OPC_CheckType, MVT::v2i64,
/*17639*/     OPC_MoveParent,
/*17640*/     OPC_MoveParent,
/*17641*/     OPC_MoveChild, 1,
/*17643*/     OPC_CheckOpcode, ISD::UNDEF,
/*17645*/     OPC_MoveParent,
/*17646*/     OPC_CheckPredicate, 26, // Predicate_pshufd
/*17648*/     OPC_CheckType, MVT::v4i32,
/*17650*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*17652*/     OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src1 #3 #4 #5 #6 #7
/*17655*/     OPC_EmitMergeInputChains, 1, 1, 
/*17658*/     OPC_EmitNodeXForm, 0, 0, // SHUFFLE_get_shuf_imm
/*17661*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::PSHUFDmi), 0|OPFL_Chain|OPFL_MemRefs,
                  1/*#VTs*/, MVT::v4i32, 6/*#Ops*/, 3, 4, 5, 6, 7, 8, 
              // Src: (vector_shuffle:v4i32 (bitconvert:v4i32 (ld:v2i64 addr:iPTR:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>), (undef:v4i32))<<P:Predicate_pshufd>><<X:SHUFFLE_get_shuf_imm>>:$src2
              // Dst: (PSHUFDmi:v4i32 addr:iPTR:$src1, (SHUFFLE_get_shuf_imm:i8 (vector_shuffle:v4i32 (bitconvert:v4i32 (ld:v2i64 addr:iPTR:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>), (undef:v4i32)):$src2))
/*17674*/   /*Scope*/ 86, /*->17761*/
/*17675*/     OPC_MoveChild, 0,
/*17677*/     OPC_CheckOpcode, ISD::BIT_CONVERT,
/*17679*/     OPC_MoveChild, 0,
/*17681*/     OPC_CheckOpcode, ISD::LOAD,
/*17683*/     OPC_RecordMemRef,
/*17684*/     OPC_RecordNode, // #0 = 'ld' chained node
/*17685*/     OPC_CheckFoldableChainNode,
/*17686*/     OPC_RecordChild1, // #1 = $src
/*17687*/     OPC_CheckPredicate, 2, // Predicate_unindexedload
/*17689*/     OPC_CheckPredicate, 8, // Predicate_load
/*17691*/     OPC_CheckPredicate, 23, // Predicate_memop
/*17693*/     OPC_SwitchType /*2 cases */, 31,  MVT::v2f64,// ->17727
/*17696*/       OPC_MoveParent,
/*17697*/       OPC_MoveParent,
/*17698*/       OPC_MoveChild, 1,
/*17700*/       OPC_CheckOpcode, ISD::UNDEF,
/*17702*/       OPC_MoveParent,
/*17703*/       OPC_CheckPredicate, 27, // Predicate_movddup
/*17705*/       OPC_CheckType, MVT::v4f32,
/*17707*/       OPC_CheckPatternPredicate, 9, // (Subtarget->hasSSE3())
/*17709*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*17712*/       OPC_EmitMergeInputChains, 1, 0, 
/*17715*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVDDUPrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v4f32, 5/*#Ops*/, 2, 3, 4, 5, 6, 
                // Src: (vector_shuffle:v4f32 (bitconvert:v4f32 (ld:v2f64 addr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>), (undef:v4f32))<<P:Predicate_movddup>>
                // Dst: (MOVDDUPrm:v4f32 addr:iPTR:$src)
              /*SwitchType*/ 31,  MVT::v2i64,// ->17760
/*17729*/       OPC_MoveParent,
/*17730*/       OPC_MoveParent,
/*17731*/       OPC_MoveChild, 1,
/*17733*/       OPC_CheckOpcode, ISD::UNDEF,
/*17735*/       OPC_MoveParent,
/*17736*/       OPC_CheckPredicate, 27, // Predicate_movddup
/*17738*/       OPC_CheckType, MVT::v4i32,
/*17740*/       OPC_CheckPatternPredicate, 9, // (Subtarget->hasSSE3())
/*17742*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*17745*/       OPC_EmitMergeInputChains, 1, 0, 
/*17748*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVDDUPrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v4i32, 5/*#Ops*/, 2, 3, 4, 5, 6, 
                // Src: (vector_shuffle:v4i32 (bitconvert:v4i32 (ld:v2i64 addr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>), (undef:v4i32))<<P:Predicate_movddup>>
                // Dst: (MOVDDUPrm:v4i32 addr:iPTR:$src)
              0, // EndSwitchType
/*17761*/   /*Scope*/ 122, /*->17884*/
/*17762*/     OPC_RecordChild0, // #0 = $src1
/*17763*/     OPC_MoveChild, 1,
/*17765*/     OPC_CheckOpcode, ISD::LOAD,
/*17767*/     OPC_RecordMemRef,
/*17768*/     OPC_RecordNode, // #1 = 'ld' chained node
/*17769*/     OPC_CheckFoldableChainNode,
/*17770*/     OPC_RecordChild1, // #2 = $src2
/*17771*/     OPC_CheckPredicate, 2, // Predicate_unindexedload
/*17773*/     OPC_CheckPredicate, 8, // Predicate_load
/*17775*/     OPC_CheckPredicate, 23, // Predicate_memop
/*17777*/     OPC_MoveParent,
/*17778*/     OPC_SwitchType /*2 cases */, 50,  MVT::v4f32,// ->17831
/*17781*/       OPC_Scope, 23, /*->17806*/ // 2 children in Scope
/*17783*/         OPC_CheckPredicate, 14, // Predicate_unpckh
/*17785*/         OPC_CheckPatternPredicate, 0, // (Subtarget->hasSSE1())
/*17787*/         OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*17790*/         OPC_EmitMergeInputChains, 1, 1, 
/*17793*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::UNPCKHPSrm), 0|OPFL_Chain|OPFL_MemRefs,
                      1/*#VTs*/, MVT::v4f32, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                  // Src: (vector_shuffle:v4f32 VR128:v4f32:$src1, (ld:v4f32 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>)<<P:Predicate_unpckh>>
                  // Dst: (UNPCKHPSrm:v4f32 VR128:v4f32:$src1, addr:iPTR:$src2)
/*17806*/       /*Scope*/ 23, /*->17830*/
/*17807*/         OPC_CheckPredicate, 28, // Predicate_unpckl
/*17809*/         OPC_CheckPatternPredicate, 0, // (Subtarget->hasSSE1())
/*17811*/         OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*17814*/         OPC_EmitMergeInputChains, 1, 1, 
/*17817*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::UNPCKLPSrm), 0|OPFL_Chain|OPFL_MemRefs,
                      1/*#VTs*/, MVT::v4f32, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                  // Src: (vector_shuffle:v4f32 VR128:v4f32:$src1, (ld:v4f32 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>)<<P:Predicate_unpckl>>
                  // Dst: (UNPCKLPSrm:v4f32 VR128:v4f32:$src1, addr:iPTR:$src2)
/*17830*/       0, /*End of Scope*/
              /*SwitchType*/ 50,  MVT::v2f64,// ->17883
/*17833*/       OPC_Scope, 23, /*->17858*/ // 2 children in Scope
/*17835*/         OPC_CheckPredicate, 14, // Predicate_unpckh
/*17837*/         OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*17839*/         OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*17842*/         OPC_EmitMergeInputChains, 1, 1, 
/*17845*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::UNPCKHPDrm), 0|OPFL_Chain|OPFL_MemRefs,
                      1/*#VTs*/, MVT::v2f64, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                  // Src: (vector_shuffle:v2f64 VR128:v2f64:$src1, (ld:v2f64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>)<<P:Predicate_unpckh>>
                  // Dst: (UNPCKHPDrm:v2f64 VR128:v2f64:$src1, addr:iPTR:$src2)
/*17858*/       /*Scope*/ 23, /*->17882*/
/*17859*/         OPC_CheckPredicate, 28, // Predicate_unpckl
/*17861*/         OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*17863*/         OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*17866*/         OPC_EmitMergeInputChains, 1, 1, 
/*17869*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::UNPCKLPDrm), 0|OPFL_Chain|OPFL_MemRefs,
                      1/*#VTs*/, MVT::v2f64, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                  // Src: (vector_shuffle:v2f64 VR128:v2f64:$src1, (ld:v2f64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>)<<P:Predicate_unpckl>>
                  // Dst: (UNPCKLPDrm:v2f64 VR128:v2f64:$src1, addr:iPTR:$src2)
/*17882*/       0, /*End of Scope*/
              0, // EndSwitchType
/*17884*/   /*Scope*/ 126, /*->18011*/
/*17885*/     OPC_MoveChild, 0,
/*17887*/     OPC_SwitchOpcode /*2 cases */, 54,  ISD::BIT_CONVERT,// ->17944
/*17890*/       OPC_MoveChild, 0,
/*17892*/       OPC_CheckOpcode, ISD::SCALAR_TO_VECTOR,
/*17894*/       OPC_MoveChild, 0,
/*17896*/       OPC_CheckOpcode, ISD::LOAD,
/*17898*/       OPC_RecordMemRef,
/*17899*/       OPC_RecordNode, // #0 = 'ld' chained node
/*17900*/       OPC_CheckFoldableChainNode,
/*17901*/       OPC_RecordChild1, // #1 = $src
/*17902*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*17904*/       OPC_CheckPredicate, 8, // Predicate_load
/*17906*/       OPC_CheckPredicate, 9, // Predicate_dsload
/*17908*/       OPC_CheckType, MVT::i64,
/*17910*/       OPC_MoveParent,
/*17911*/       OPC_CheckType, MVT::v2i64,
/*17913*/       OPC_MoveParent,
/*17914*/       OPC_MoveParent,
/*17915*/       OPC_MoveChild, 1,
/*17917*/       OPC_CheckOpcode, ISD::UNDEF,
/*17919*/       OPC_MoveParent,
/*17920*/       OPC_CheckPredicate, 27, // Predicate_movddup
/*17922*/       OPC_CheckType, MVT::v2f64,
/*17924*/       OPC_CheckPatternPredicate, 9, // (Subtarget->hasSSE3())
/*17926*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*17929*/       OPC_EmitMergeInputChains, 1, 0, 
/*17932*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVDDUPrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v2f64, 5/*#Ops*/, 2, 3, 4, 5, 6, 
                // Src: (vector_shuffle:v2f64 (bitconvert:v2f64 (scalar_to_vector:v2i64 (ld:i64 addr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>)), (undef:v2f64))<<P:Predicate_movddup>>
                // Dst: (MOVDDUPrm:v2f64 addr:iPTR:$src)
              /*SwitchOpcode*/ 64,  ISD::LOAD,// ->18010
/*17946*/       OPC_RecordMemRef,
/*17947*/       OPC_RecordNode, // #0 = 'ld' chained node
/*17948*/       OPC_CheckFoldableChainNode,
/*17949*/       OPC_RecordChild1, // #1 = $src
/*17950*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*17952*/       OPC_CheckPredicate, 8, // Predicate_load
/*17954*/       OPC_CheckPredicate, 23, // Predicate_memop
/*17956*/       OPC_MoveParent,
/*17957*/       OPC_MoveChild, 1,
/*17959*/       OPC_CheckOpcode, ISD::UNDEF,
/*17961*/       OPC_MoveParent,
/*17962*/       OPC_CheckPredicate, 27, // Predicate_movddup
/*17964*/       OPC_SwitchType /*2 cases */, 20,  MVT::v2f64,// ->17987
/*17967*/         OPC_CheckPatternPredicate, 9, // (Subtarget->hasSSE3())
/*17969*/         OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*17972*/         OPC_EmitMergeInputChains, 1, 0, 
/*17975*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVDDUPrm), 0|OPFL_Chain|OPFL_MemRefs,
                      1/*#VTs*/, MVT::v2f64, 5/*#Ops*/, 2, 3, 4, 5, 6, 
                  // Src: (vector_shuffle:v2f64 (ld:v2f64 addr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>, (undef:v2f64))<<P:Predicate_movddup>>
                  // Dst: (MOVDDUPrm:v2f64 addr:iPTR:$src)
                /*SwitchType*/ 20,  MVT::v2i64,// ->18009
/*17989*/         OPC_CheckPatternPredicate, 9, // (Subtarget->hasSSE3())
/*17991*/         OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*17994*/         OPC_EmitMergeInputChains, 1, 0, 
/*17997*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVDDUPrm), 0|OPFL_Chain|OPFL_MemRefs,
                      1/*#VTs*/, MVT::v2i64, 5/*#Ops*/, 2, 3, 4, 5, 6, 
                  // Src: (vector_shuffle:v2i64 (ld:v2i64 addr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>, (undef:v2i64))<<P:Predicate_movddup>>
                  // Dst: (MOVDDUPrm:v2i64 addr:iPTR:$src)
                0, // EndSwitchType
              0, // EndSwitchOpcode
/*18011*/   /*Scope*/ 86, /*->18098*/
/*18012*/     OPC_RecordNode, // #0 = $src2
/*18013*/     OPC_MoveChild, 0,
/*18015*/     OPC_CheckOpcode, ISD::BIT_CONVERT,
/*18017*/     OPC_MoveChild, 0,
/*18019*/     OPC_CheckOpcode, ISD::LOAD,
/*18021*/     OPC_RecordMemRef,
/*18022*/     OPC_RecordNode, // #1 = 'ld' chained node
/*18023*/     OPC_CheckFoldableChainNode,
/*18024*/     OPC_RecordChild1, // #2 = $src1
/*18025*/     OPC_CheckPredicate, 2, // Predicate_unindexedload
/*18027*/     OPC_CheckPredicate, 8, // Predicate_load
/*18029*/     OPC_CheckPredicate, 23, // Predicate_memop
/*18031*/     OPC_CheckType, MVT::v2i64,
/*18033*/     OPC_MoveParent,
/*18034*/     OPC_MoveParent,
/*18035*/     OPC_MoveChild, 1,
/*18037*/     OPC_CheckOpcode, ISD::UNDEF,
/*18039*/     OPC_MoveParent,
/*18040*/     OPC_CheckType, MVT::v8i16,
/*18042*/     OPC_Scope, 26, /*->18070*/ // 2 children in Scope
/*18044*/       OPC_CheckPredicate, 29, // Predicate_pshufhw
/*18046*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*18048*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src1 #3 #4 #5 #6 #7
/*18051*/       OPC_EmitMergeInputChains, 1, 1, 
/*18054*/       OPC_EmitNodeXForm, 1, 0, // SHUFFLE_get_pshufhw_imm
/*18057*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PSHUFHWmi), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v8i16, 6/*#Ops*/, 3, 4, 5, 6, 7, 8, 
                // Src: (vector_shuffle:v8i16 (bitconvert:v8i16 (ld:v2i64 addr:iPTR:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>), (undef:v8i16))<<P:Predicate_pshufhw>><<X:SHUFFLE_get_pshufhw_imm>>:$src2
                // Dst: (PSHUFHWmi:v8i16 addr:iPTR:$src1, (SHUFFLE_get_pshufhw_imm:i8 (vector_shuffle:v8i16 (bitconvert:v8i16 (ld:v2i64 addr:iPTR:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>), (undef:v8i16)):$src2))
/*18070*/     /*Scope*/ 26, /*->18097*/
/*18071*/       OPC_CheckPredicate, 30, // Predicate_pshuflw
/*18073*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*18075*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src1 #3 #4 #5 #6 #7
/*18078*/       OPC_EmitMergeInputChains, 1, 1, 
/*18081*/       OPC_EmitNodeXForm, 2, 0, // SHUFFLE_get_pshuflw_imm
/*18084*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PSHUFLWmi), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v8i16, 6/*#Ops*/, 3, 4, 5, 6, 7, 8, 
                // Src: (vector_shuffle:v8i16 (bitconvert:v8i16 (ld:v2i64 addr:iPTR:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>), (undef:v8i16))<<P:Predicate_pshuflw>><<X:SHUFFLE_get_pshuflw_imm>>:$src2
                // Dst: (PSHUFLWmi:v8i16 addr:iPTR:$src1, (SHUFFLE_get_pshuflw_imm:i8 (vector_shuffle:v8i16 (bitconvert:v8i16 (ld:v2i64 addr:iPTR:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>), (undef:v8i16)):$src2))
/*18097*/     0, /*End of Scope*/
/*18098*/   /*Scope*/ 51, /*->18150*/
/*18099*/     OPC_MoveChild, 0,
/*18101*/     OPC_CheckOpcode, ISD::SCALAR_TO_VECTOR,
/*18103*/     OPC_MoveChild, 0,
/*18105*/     OPC_CheckOpcode, ISD::LOAD,
/*18107*/     OPC_RecordMemRef,
/*18108*/     OPC_RecordNode, // #0 = 'ld' chained node
/*18109*/     OPC_CheckFoldableChainNode,
/*18110*/     OPC_RecordChild1, // #1 = $src
/*18111*/     OPC_CheckPredicate, 2, // Predicate_unindexedload
/*18113*/     OPC_CheckPredicate, 8, // Predicate_load
/*18115*/     OPC_CheckPredicate, 9, // Predicate_dsload
/*18117*/     OPC_CheckType, MVT::f64,
/*18119*/     OPC_MoveParent,
/*18120*/     OPC_MoveParent,
/*18121*/     OPC_MoveChild, 1,
/*18123*/     OPC_CheckOpcode, ISD::UNDEF,
/*18125*/     OPC_MoveParent,
/*18126*/     OPC_CheckPredicate, 27, // Predicate_movddup
/*18128*/     OPC_CheckType, MVT::v2f64,
/*18130*/     OPC_CheckPatternPredicate, 9, // (Subtarget->hasSSE3())
/*18132*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*18135*/     OPC_EmitMergeInputChains, 1, 0, 
/*18138*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVDDUPrm), 0|OPFL_Chain|OPFL_MemRefs,
                  1/*#VTs*/, MVT::v2f64, 5/*#Ops*/, 2, 3, 4, 5, 6, 
              // Src: (vector_shuffle:v2f64 (scalar_to_vector:v2f64 (ld:f64 addr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>), (undef:v2f64))<<P:Predicate_movddup>>
              // Dst: (MOVDDUPrm:v2f64 addr:iPTR:$src)
/*18150*/   /*Scope*/ 95, /*->18246*/
/*18151*/     OPC_RecordNode, // #0 = $src2
/*18152*/     OPC_MoveChild, 0,
/*18154*/     OPC_CheckOpcode, ISD::BIT_CONVERT,
/*18156*/     OPC_MoveChild, 0,
/*18158*/     OPC_CheckOpcode, ISD::LOAD,
/*18160*/     OPC_RecordMemRef,
/*18161*/     OPC_RecordNode, // #1 = 'ld' chained node
/*18162*/     OPC_CheckFoldableChainNode,
/*18163*/     OPC_RecordChild1, // #2 = $src1
/*18164*/     OPC_CheckPredicate, 2, // Predicate_unindexedload
/*18166*/     OPC_CheckPredicate, 8, // Predicate_load
/*18168*/     OPC_SwitchType /*2 cases */, 37,  MVT::v4f32,// ->18208
/*18171*/       OPC_CheckPredicate, 23, // Predicate_memop
/*18173*/       OPC_MoveParent,
/*18174*/       OPC_MoveParent,
/*18175*/       OPC_MoveChild, 1,
/*18177*/       OPC_CheckOpcode, ISD::UNDEF,
/*18179*/       OPC_MoveParent,
/*18180*/       OPC_CheckPredicate, 26, // Predicate_pshufd
/*18182*/       OPC_CheckType, MVT::v4i32,
/*18184*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*18186*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src1 #3 #4 #5 #6 #7
/*18189*/       OPC_EmitMergeInputChains, 1, 1, 
/*18192*/       OPC_EmitNodeXForm, 0, 0, // SHUFFLE_get_shuf_imm
/*18195*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PSHUFDmi), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v4i32, 6/*#Ops*/, 3, 4, 5, 6, 7, 8, 
                // Src: (vector_shuffle:v4i32 (bitconvert:v4i32 (ld:v4f32 addr:iPTR:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>), (undef:v4i32))<<P:Predicate_pshufd>><<X:SHUFFLE_get_shuf_imm>>:$src2
                // Dst: (PSHUFDmi:v4i32 addr:iPTR:$src1, (SHUFFLE_get_shuf_imm:i8 VR128:i8:$src2))
              /*SwitchType*/ 35,  MVT::v1i64,// ->18245
/*18210*/       OPC_MoveParent,
/*18211*/       OPC_MoveParent,
/*18212*/       OPC_MoveChild, 1,
/*18214*/       OPC_CheckOpcode, ISD::UNDEF,
/*18216*/       OPC_MoveParent,
/*18217*/       OPC_CheckPredicate, 31, // Predicate_mmx_pshufw
/*18219*/       OPC_CheckType, MVT::v4i16,
/*18221*/       OPC_CheckPatternPredicate, 8, // (Subtarget->hasMMX())
/*18223*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src1 #3 #4 #5 #6 #7
/*18226*/       OPC_EmitMergeInputChains, 1, 1, 
/*18229*/       OPC_EmitNodeXForm, 3, 0, // MMX_SHUFFLE_get_shuf_imm
/*18232*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PSHUFWmi), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v4i16, 6/*#Ops*/, 3, 4, 5, 6, 7, 8, 
                // Src: (vector_shuffle:v4i16 (bitconvert:v4i16 (ld:v1i64 addr:iPTR:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>), (undef:v4i16))<<P:Predicate_mmx_pshufw>><<X:MMX_SHUFFLE_get_shuf_imm>>:$src2
                // Dst: (MMX_PSHUFWmi:v4i16 addr:iPTR:$src1, (MMX_SHUFFLE_get_shuf_imm:i8 (vector_shuffle:v4i16 (bitconvert:v4i16 (ld:v1i64 addr:iPTR:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>), (undef:v4i16)):$src2))
              0, // EndSwitchType
/*18246*/   /*Scope*/ 45|128,1/*173*/, /*->18421*/
/*18248*/     OPC_RecordChild0, // #0 = $src1
/*18249*/     OPC_MoveChild, 1,
/*18251*/     OPC_CheckOpcode, ISD::BIT_CONVERT,
/*18253*/     OPC_MoveChild, 0,
/*18255*/     OPC_CheckOpcode, ISD::LOAD,
/*18257*/     OPC_RecordMemRef,
/*18258*/     OPC_RecordNode, // #1 = 'ld' chained node
/*18259*/     OPC_CheckFoldableChainNode,
/*18260*/     OPC_RecordChild1, // #2 = $src2
/*18261*/     OPC_CheckPredicate, 2, // Predicate_unindexedload
/*18263*/     OPC_CheckPredicate, 8, // Predicate_load
/*18265*/     OPC_CheckPredicate, 23, // Predicate_memop
/*18267*/     OPC_CheckType, MVT::v2i64,
/*18269*/     OPC_MoveParent,
/*18270*/     OPC_MoveParent,
/*18271*/     OPC_Scope, 73, /*->18346*/ // 2 children in Scope
/*18273*/       OPC_CheckPredicate, 28, // Predicate_unpckl
/*18275*/       OPC_SwitchType /*3 cases */, 21,  MVT::v16i8,// ->18299
/*18278*/         OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*18280*/         OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*18283*/         OPC_EmitMergeInputChains, 1, 1, 
/*18286*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::PUNPCKLBWrm), 0|OPFL_Chain|OPFL_MemRefs,
                      1/*#VTs*/, MVT::v16i8, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                  // Src: (vector_shuffle:v16i8 VR128:v16i8:$src1, (bitconvert:v16i8 (ld:v2i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>))<<P:Predicate_unpckl>>
                  // Dst: (PUNPCKLBWrm:v16i8 VR128:v16i8:$src1, addr:iPTR:$src2)
                /*SwitchType*/ 21,  MVT::v8i16,// ->18322
/*18301*/         OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*18303*/         OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*18306*/         OPC_EmitMergeInputChains, 1, 1, 
/*18309*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::PUNPCKLWDrm), 0|OPFL_Chain|OPFL_MemRefs,
                      1/*#VTs*/, MVT::v8i16, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                  // Src: (vector_shuffle:v8i16 VR128:v8i16:$src1, (bitconvert:v8i16 (ld:v2i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>))<<P:Predicate_unpckl>>
                  // Dst: (PUNPCKLWDrm:v8i16 VR128:v8i16:$src1, addr:iPTR:$src2)
                /*SwitchType*/ 21,  MVT::v4i32,// ->18345
/*18324*/         OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*18326*/         OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*18329*/         OPC_EmitMergeInputChains, 1, 1, 
/*18332*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::PUNPCKLDQrm), 0|OPFL_Chain|OPFL_MemRefs,
                      1/*#VTs*/, MVT::v4i32, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                  // Src: (vector_shuffle:v4i32 VR128:v4i32:$src1, (bitconvert:v4i32 (ld:v2i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>))<<P:Predicate_unpckl>>
                  // Dst: (PUNPCKLDQrm:v4i32 VR128:v4i32:$src1, addr:iPTR:$src2)
                0, // EndSwitchType
/*18346*/     /*Scope*/ 73, /*->18420*/
/*18347*/       OPC_CheckPredicate, 14, // Predicate_unpckh
/*18349*/       OPC_SwitchType /*3 cases */, 21,  MVT::v16i8,// ->18373
/*18352*/         OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*18354*/         OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*18357*/         OPC_EmitMergeInputChains, 1, 1, 
/*18360*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::PUNPCKHBWrm), 0|OPFL_Chain|OPFL_MemRefs,
                      1/*#VTs*/, MVT::v16i8, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                  // Src: (vector_shuffle:v16i8 VR128:v16i8:$src1, (bitconvert:v16i8 (ld:v2i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>))<<P:Predicate_unpckh>>
                  // Dst: (PUNPCKHBWrm:v16i8 VR128:v16i8:$src1, addr:iPTR:$src2)
                /*SwitchType*/ 21,  MVT::v8i16,// ->18396
/*18375*/         OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*18377*/         OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*18380*/         OPC_EmitMergeInputChains, 1, 1, 
/*18383*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::PUNPCKHWDrm), 0|OPFL_Chain|OPFL_MemRefs,
                      1/*#VTs*/, MVT::v8i16, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                  // Src: (vector_shuffle:v8i16 VR128:v8i16:$src1, (bitconvert:v8i16 (ld:v2i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>))<<P:Predicate_unpckh>>
                  // Dst: (PUNPCKHWDrm:v8i16 VR128:v8i16:$src1, addr:iPTR:$src2)
                /*SwitchType*/ 21,  MVT::v4i32,// ->18419
/*18398*/         OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*18400*/         OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*18403*/         OPC_EmitMergeInputChains, 1, 1, 
/*18406*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::PUNPCKHDQrm), 0|OPFL_Chain|OPFL_MemRefs,
                      1/*#VTs*/, MVT::v4i32, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                  // Src: (vector_shuffle:v4i32 VR128:v4i32:$src1, (bitconvert:v4i32 (ld:v2i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>))<<P:Predicate_unpckh>>
                  // Dst: (PUNPCKHDQrm:v4i32 VR128:v4i32:$src1, addr:iPTR:$src2)
                0, // EndSwitchType
/*18420*/     0, /*End of Scope*/
/*18421*/   /*Scope*/ 70, /*->18492*/
/*18422*/     OPC_MoveChild, 0,
/*18424*/     OPC_CheckOpcode, ISD::LOAD,
/*18426*/     OPC_RecordMemRef,
/*18427*/     OPC_RecordNode, // #0 = 'ld' chained node
/*18428*/     OPC_CheckFoldableChainNode,
/*18429*/     OPC_RecordChild1, // #1 = $src
/*18430*/     OPC_CheckPredicate, 2, // Predicate_unindexedload
/*18432*/     OPC_CheckPredicate, 8, // Predicate_load
/*18434*/     OPC_CheckPredicate, 23, // Predicate_memop
/*18436*/     OPC_MoveParent,
/*18437*/     OPC_MoveChild, 1,
/*18439*/     OPC_CheckOpcode, ISD::UNDEF,
/*18441*/     OPC_MoveParent,
/*18442*/     OPC_CheckType, MVT::v4f32,
/*18444*/     OPC_Scope, 22, /*->18468*/ // 2 children in Scope
/*18446*/       OPC_CheckPredicate, 24, // Predicate_movshdup
/*18448*/       OPC_CheckPatternPredicate, 9, // (Subtarget->hasSSE3())
/*18450*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*18453*/       OPC_EmitMergeInputChains, 1, 0, 
/*18456*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVSHDUPrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v4f32, 5/*#Ops*/, 2, 3, 4, 5, 6, 
                // Src: (vector_shuffle:v4f32 (ld:v4f32 addr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>, (undef:v4f32))<<P:Predicate_movshdup>>
                // Dst: (MOVSHDUPrm:v4f32 addr:iPTR:$src)
/*18468*/     /*Scope*/ 22, /*->18491*/
/*18469*/       OPC_CheckPredicate, 25, // Predicate_movsldup
/*18471*/       OPC_CheckPatternPredicate, 9, // (Subtarget->hasSSE3())
/*18473*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*18476*/       OPC_EmitMergeInputChains, 1, 0, 
/*18479*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVSLDUPrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v4f32, 5/*#Ops*/, 2, 3, 4, 5, 6, 
                // Src: (vector_shuffle:v4f32 (ld:v4f32 addr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>, (undef:v4f32))<<P:Predicate_movsldup>>
                // Dst: (MOVSLDUPrm:v4f32 addr:iPTR:$src)
/*18491*/     0, /*End of Scope*/
/*18492*/   /*Scope*/ 53, /*->18546*/
/*18493*/     OPC_RecordNode, // #0 = $src3
/*18494*/     OPC_RecordChild0, // #1 = $src1
/*18495*/     OPC_MoveChild, 1,
/*18497*/     OPC_CheckOpcode, ISD::BIT_CONVERT,
/*18499*/     OPC_MoveChild, 0,
/*18501*/     OPC_CheckOpcode, ISD::LOAD,
/*18503*/     OPC_RecordMemRef,
/*18504*/     OPC_RecordNode, // #2 = 'ld' chained node
/*18505*/     OPC_CheckFoldableChainNode,
/*18506*/     OPC_RecordChild1, // #3 = $src2
/*18507*/     OPC_CheckPredicate, 2, // Predicate_unindexedload
/*18509*/     OPC_CheckPredicate, 8, // Predicate_load
/*18511*/     OPC_CheckPredicate, 23, // Predicate_memop
/*18513*/     OPC_CheckType, MVT::v2i64,
/*18515*/     OPC_MoveParent,
/*18516*/     OPC_MoveParent,
/*18517*/     OPC_CheckPredicate, 32, // Predicate_shufp
/*18519*/     OPC_CheckType, MVT::v4i32,
/*18521*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*18523*/     OPC_CheckComplexPat, /*CP*/0, /*#*/3, // SelectAddr:$src2 #4 #5 #6 #7 #8
/*18526*/     OPC_EmitMergeInputChains, 1, 2, 
/*18529*/     OPC_EmitNodeXForm, 0, 0, // SHUFFLE_get_shuf_imm
/*18532*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::SHUFPSrmi), 0|OPFL_Chain|OPFL_MemRefs,
                  1/*#VTs*/, MVT::v4i32, 7/*#Ops*/, 1, 4, 5, 6, 7, 8, 9, 
              // Src: (vector_shuffle:v4i32 VR128:v4i32:$src1, (bitconvert:v4i32 (ld:v2i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>))<<P:Predicate_shufp>><<X:SHUFFLE_get_shuf_imm>>:$src3
              // Dst: (SHUFPSrmi:v4i32 VR128:v16i8:$src1, addr:iPTR:$src2, (SHUFFLE_get_shuf_imm:i8 VR128:i8:$src3))
/*18546*/   /*Scope*/ 12|128,2/*268*/, /*->18816*/
/*18548*/     OPC_RecordChild0, // #0 = $src1
/*18549*/     OPC_MoveChild, 1,
/*18551*/     OPC_SwitchOpcode /*2 cases */, 73|128,1/*201*/,  ISD::BIT_CONVERT,// ->18756
/*18555*/       OPC_MoveChild, 0,
/*18557*/       OPC_SwitchOpcode /*2 cases */, 34|128,1/*162*/,  ISD::LOAD,// ->18723
/*18561*/         OPC_RecordMemRef,
/*18562*/         OPC_RecordNode, // #1 = 'ld' chained node
/*18563*/         OPC_CheckFoldableChainNode,
/*18564*/         OPC_RecordChild1, // #2 = $src2
/*18565*/         OPC_CheckPredicate, 2, // Predicate_unindexedload
/*18567*/         OPC_CheckPredicate, 8, // Predicate_load
/*18569*/         OPC_CheckType, MVT::v1i64,
/*18571*/         OPC_MoveParent,
/*18572*/         OPC_MoveParent,
/*18573*/         OPC_Scope, 73, /*->18648*/ // 2 children in Scope
/*18575*/           OPC_CheckPredicate, 33, // Predicate_mmx_unpckh
/*18577*/           OPC_SwitchType /*3 cases */, 21,  MVT::v8i8,// ->18601
/*18580*/             OPC_CheckPatternPredicate, 8, // (Subtarget->hasMMX())
/*18582*/             OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*18585*/             OPC_EmitMergeInputChains, 1, 1, 
/*18588*/             OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PUNPCKHBWrm), 0|OPFL_Chain|OPFL_MemRefs,
                          1/*#VTs*/, MVT::v8i8, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                      // Src: (vector_shuffle:v8i8 VR64:v8i8:$src1, (bitconvert:v8i8 (ld:v1i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>))<<P:Predicate_mmx_unpckh>>
                      // Dst: (MMX_PUNPCKHBWrm:v8i8 VR64:v8i8:$src1, addr:iPTR:$src2)
                    /*SwitchType*/ 21,  MVT::v4i16,// ->18624
/*18603*/             OPC_CheckPatternPredicate, 8, // (Subtarget->hasMMX())
/*18605*/             OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*18608*/             OPC_EmitMergeInputChains, 1, 1, 
/*18611*/             OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PUNPCKHWDrm), 0|OPFL_Chain|OPFL_MemRefs,
                          1/*#VTs*/, MVT::v4i16, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                      // Src: (vector_shuffle:v4i16 VR64:v4i16:$src1, (bitconvert:v4i16 (ld:v1i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>))<<P:Predicate_mmx_unpckh>>
                      // Dst: (MMX_PUNPCKHWDrm:v4i16 VR64:v4i16:$src1, addr:iPTR:$src2)
                    /*SwitchType*/ 21,  MVT::v2i32,// ->18647
/*18626*/             OPC_CheckPatternPredicate, 8, // (Subtarget->hasMMX())
/*18628*/             OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*18631*/             OPC_EmitMergeInputChains, 1, 1, 
/*18634*/             OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PUNPCKHDQrm), 0|OPFL_Chain|OPFL_MemRefs,
                          1/*#VTs*/, MVT::v2i32, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                      // Src: (vector_shuffle:v2i32 VR64:v2i32:$src1, (bitconvert:v2i32 (ld:v1i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>))<<P:Predicate_mmx_unpckh>>
                      // Dst: (MMX_PUNPCKHDQrm:v2i32 VR64:v2i32:$src1, addr:iPTR:$src2)
                    0, // EndSwitchType
/*18648*/         /*Scope*/ 73, /*->18722*/
/*18649*/           OPC_CheckPredicate, 34, // Predicate_mmx_unpckl
/*18651*/           OPC_SwitchType /*3 cases */, 21,  MVT::v8i8,// ->18675
/*18654*/             OPC_CheckPatternPredicate, 8, // (Subtarget->hasMMX())
/*18656*/             OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*18659*/             OPC_EmitMergeInputChains, 1, 1, 
/*18662*/             OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PUNPCKLBWrm), 0|OPFL_Chain|OPFL_MemRefs,
                          1/*#VTs*/, MVT::v8i8, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                      // Src: (vector_shuffle:v8i8 VR64:v8i8:$src1, (bitconvert:v8i8 (ld:v1i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>))<<P:Predicate_mmx_unpckl>>
                      // Dst: (MMX_PUNPCKLBWrm:v8i8 VR64:v8i8:$src1, addr:iPTR:$src2)
                    /*SwitchType*/ 21,  MVT::v4i16,// ->18698
/*18677*/             OPC_CheckPatternPredicate, 8, // (Subtarget->hasMMX())
/*18679*/             OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*18682*/             OPC_EmitMergeInputChains, 1, 1, 
/*18685*/             OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PUNPCKLWDrm), 0|OPFL_Chain|OPFL_MemRefs,
                          1/*#VTs*/, MVT::v4i16, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                      // Src: (vector_shuffle:v4i16 VR64:v4i16:$src1, (bitconvert:v4i16 (ld:v1i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>))<<P:Predicate_mmx_unpckl>>
                      // Dst: (MMX_PUNPCKLWDrm:v4i16 VR64:v4i16:$src1, addr:iPTR:$src2)
                    /*SwitchType*/ 21,  MVT::v2i32,// ->18721
/*18700*/             OPC_CheckPatternPredicate, 8, // (Subtarget->hasMMX())
/*18702*/             OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*18705*/             OPC_EmitMergeInputChains, 1, 1, 
/*18708*/             OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PUNPCKLDQrm), 0|OPFL_Chain|OPFL_MemRefs,
                          1/*#VTs*/, MVT::v2i32, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                      // Src: (vector_shuffle:v2i32 VR64:v2i32:$src1, (bitconvert:v2i32 (ld:v1i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>))<<P:Predicate_mmx_unpckl>>
                      // Dst: (MMX_PUNPCKLDQrm:v2i32 VR64:v2i32:$src1, addr:iPTR:$src2)
                    0, // EndSwitchType
/*18722*/         0, /*End of Scope*/
                /*SwitchOpcode*/ 30,  X86ISD::VZEXT_LOAD,// ->18755
/*18725*/         OPC_RecordNode, // #1 = 'X86vzload' chained node
/*18726*/         OPC_CheckFoldableChainNode,
/*18727*/         OPC_RecordChild1, // #2 = $src2
/*18728*/         OPC_CheckType, MVT::v2i64,
/*18730*/         OPC_MoveParent,
/*18731*/         OPC_MoveParent,
/*18732*/         OPC_CheckPredicate, 22, // Predicate_movlhps
/*18734*/         OPC_CheckType, MVT::v4i32,
/*18736*/         OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*18739*/         OPC_EmitMergeInputChains, 1, 1, 
/*18742*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVHPSrm), 0|OPFL_Chain,
                      1/*#VTs*/, MVT::v4i32, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                  // Src: (vector_shuffle:v4i32 VR128:v4i32:$src1, (bitconvert:v4i32 (X86vzload:v2i64 addr:iPTR:$src2)))<<P:Predicate_movlhps>>
                  // Dst: (MOVHPSrm:v4i32 VR128:v16i8:$src1, addr:iPTR:$src2)
                0, // EndSwitchOpcode
              /*SwitchOpcode*/ 57,  ISD::UNDEF,// ->18815
/*18758*/       OPC_MoveParent,
/*18759*/       OPC_Scope, 26, /*->18787*/ // 2 children in Scope
/*18761*/         OPC_CheckPredicate, 27, // Predicate_movddup
/*18763*/         OPC_SwitchType /*2 cases */, 9,  MVT::v4f32,// ->18775
/*18766*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVLHPSrr), 0,
                        1/*#VTs*/, MVT::v4f32, 2/*#Ops*/, 0, 0, 
                    // Src: (vector_shuffle:v4f32 VR128:v4f32:$src, (undef:v4f32))<<P:Predicate_movddup>>
                    // Dst: (MOVLHPSrr:v4f32 VR128:v16i8:$src, VR128:v16i8:$src)
                  /*SwitchType*/ 9,  MVT::v2i64,// ->18786
/*18777*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVLHPSrr), 0,
                        1/*#VTs*/, MVT::v2i64, 2/*#Ops*/, 0, 0, 
                    // Src: (vector_shuffle:v2i64 VR128:v2i64:$src, (undef:v2i64))<<P:Predicate_movddup>>
                    // Dst: (MOVLHPSrr:v2i64 VR128:v16i8:$src, VR128:v16i8:$src)
                  0, // EndSwitchType
/*18787*/       /*Scope*/ 26, /*->18814*/
/*18788*/         OPC_CheckPredicate, 35, // Predicate_movhlps_undef
/*18790*/         OPC_SwitchType /*2 cases */, 9,  MVT::v4f32,// ->18802
/*18793*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVHLPSrr), 0,
                        1/*#VTs*/, MVT::v4f32, 2/*#Ops*/, 0, 0, 
                    // Src: (vector_shuffle:v4f32 VR128:v4f32:$src1, (undef:v4f32))<<P:Predicate_movhlps_undef>>
                    // Dst: (MOVHLPSrr:v4f32 VR128:v16i8:$src1, VR128:v16i8:$src1)
                  /*SwitchType*/ 9,  MVT::v4i32,// ->18813
/*18804*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVHLPSrr), 0,
                        1/*#VTs*/, MVT::v4i32, 2/*#Ops*/, 0, 0, 
                    // Src: (vector_shuffle:v4i32 VR128:v4i32:$src1, (undef:v4i32))<<P:Predicate_movhlps_undef>>
                    // Dst: (MOVHLPSrr:v4i32 VR128:v16i8:$src1, VR128:v16i8:$src1)
                  0, // EndSwitchType
/*18814*/       0, /*End of Scope*/
              0, // EndSwitchOpcode
/*18816*/   /*Scope*/ 75, /*->18892*/
/*18817*/     OPC_RecordNode, // #0 = $src3
/*18818*/     OPC_RecordChild0, // #1 = $src1
/*18819*/     OPC_MoveChild, 1,
/*18821*/     OPC_CheckOpcode, ISD::LOAD,
/*18823*/     OPC_RecordMemRef,
/*18824*/     OPC_RecordNode, // #2 = 'ld' chained node
/*18825*/     OPC_CheckFoldableChainNode,
/*18826*/     OPC_RecordChild1, // #3 = $src2
/*18827*/     OPC_CheckPredicate, 2, // Predicate_unindexedload
/*18829*/     OPC_CheckPredicate, 8, // Predicate_load
/*18831*/     OPC_CheckPredicate, 23, // Predicate_memop
/*18833*/     OPC_MoveParent,
/*18834*/     OPC_CheckPredicate, 32, // Predicate_shufp
/*18836*/     OPC_SwitchType /*2 cases */, 25,  MVT::v4f32,// ->18864
/*18839*/       OPC_CheckPatternPredicate, 0, // (Subtarget->hasSSE1())
/*18841*/       OPC_CheckComplexPat, /*CP*/0, /*#*/3, // SelectAddr:$src2 #4 #5 #6 #7 #8
/*18844*/       OPC_EmitMergeInputChains, 1, 2, 
/*18847*/       OPC_EmitNodeXForm, 0, 0, // SHUFFLE_get_shuf_imm
/*18850*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::SHUFPSrmi), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v4f32, 7/*#Ops*/, 1, 4, 5, 6, 7, 8, 9, 
                // Src: (vector_shuffle:v4f32 VR128:v4f32:$src1, (ld:v4f32 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>)<<P:Predicate_shufp>><<X:SHUFFLE_get_shuf_imm>>:$src3
                // Dst: (SHUFPSrmi:v4f32 VR128:v4f32:$src1, addr:iPTR:$src2, (SHUFFLE_get_shuf_imm:i8 (vector_shuffle:v4f32 VR128:v4f32:$src1, (ld:v4f32 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>):$src3))
              /*SwitchType*/ 25,  MVT::v2f64,// ->18891
/*18866*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*18868*/       OPC_CheckComplexPat, /*CP*/0, /*#*/3, // SelectAddr:$src2 #4 #5 #6 #7 #8
/*18871*/       OPC_EmitMergeInputChains, 1, 2, 
/*18874*/       OPC_EmitNodeXForm, 0, 0, // SHUFFLE_get_shuf_imm
/*18877*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::SHUFPDrmi), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v2f64, 7/*#Ops*/, 1, 4, 5, 6, 7, 8, 9, 
                // Src: (vector_shuffle:v2f64 VR128:v2f64:$src1, (ld:v2f64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>)<<P:Predicate_shufp>><<X:SHUFFLE_get_shuf_imm>>:$src3
                // Dst: (SHUFPDrmi:v2f64 VR128:v2f64:$src1, addr:iPTR:$src2, (SHUFFLE_get_shuf_imm:i8 (vector_shuffle:v2f64 VR128:v2f64:$src1, (ld:v2f64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>):$src3))
              0, // EndSwitchType
/*18892*/   /*Scope*/ 7|128,1/*135*/, /*->19029*/
/*18894*/     OPC_RecordChild0, // #0 = $src1
/*18895*/     OPC_Scope, 67, /*->18964*/ // 2 children in Scope
/*18897*/       OPC_MoveChild, 1,
/*18899*/       OPC_CheckOpcode, ISD::LOAD,
/*18901*/       OPC_RecordMemRef,
/*18902*/       OPC_RecordNode, // #1 = 'ld' chained node
/*18903*/       OPC_CheckFoldableChainNode,
/*18904*/       OPC_RecordChild1, // #2 = $src2
/*18905*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*18907*/       OPC_CheckPredicate, 8, // Predicate_load
/*18909*/       OPC_CheckPredicate, 23, // Predicate_memop
/*18911*/       OPC_MoveParent,
/*18912*/       OPC_CheckType, MVT::v2i64,
/*18914*/       OPC_Scope, 23, /*->18939*/ // 2 children in Scope
/*18916*/         OPC_CheckPredicate, 28, // Predicate_unpckl
/*18918*/         OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*18920*/         OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*18923*/         OPC_EmitMergeInputChains, 1, 1, 
/*18926*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::PUNPCKLQDQrm), 0|OPFL_Chain|OPFL_MemRefs,
                      1/*#VTs*/, MVT::v2i64, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                  // Src: (vector_shuffle:v2i64 VR128:v2i64:$src1, (ld:v2i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>)<<P:Predicate_unpckl>>
                  // Dst: (PUNPCKLQDQrm:v2i64 VR128:v2i64:$src1, addr:iPTR:$src2)
/*18939*/       /*Scope*/ 23, /*->18963*/
/*18940*/         OPC_CheckPredicate, 14, // Predicate_unpckh
/*18942*/         OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*18944*/         OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*18947*/         OPC_EmitMergeInputChains, 1, 1, 
/*18950*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::PUNPCKHQDQrm), 0|OPFL_Chain|OPFL_MemRefs,
                      1/*#VTs*/, MVT::v2i64, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                  // Src: (vector_shuffle:v2i64 VR128:v2i64:$src1, (ld:v2i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>)<<P:Predicate_unpckh>>
                  // Dst: (PUNPCKHQDQrm:v2i64 VR128:v2i64:$src1, addr:iPTR:$src2)
/*18963*/       0, /*End of Scope*/
/*18964*/     /*Scope*/ 63, /*->19028*/
/*18965*/       OPC_RecordChild1, // #1 = $src2
/*18966*/       OPC_SwitchType /*2 cases */, 30,  MVT::v4f32,// ->18999
/*18969*/         OPC_Scope, 13, /*->18984*/ // 2 children in Scope
/*18971*/           OPC_CheckPredicate, 22, // Predicate_movlhps
/*18973*/           OPC_CheckPatternPredicate, 0, // (Subtarget->hasSSE1())
/*18975*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVLHPSrr), 0,
                        1/*#VTs*/, MVT::v4f32, 2/*#Ops*/, 0, 1, 
                    // Src: (vector_shuffle:v4f32 VR128:v4f32:$src1, VR128:v4f32:$src2)<<P:Predicate_movlhps>>
                    // Dst: (MOVLHPSrr:v4f32 VR128:v4f32:$src1, VR128:v4f32:$src2)
/*18984*/         /*Scope*/ 13, /*->18998*/
/*18985*/           OPC_CheckPredicate, 36, // Predicate_movhlps
/*18987*/           OPC_CheckPatternPredicate, 0, // (Subtarget->hasSSE1())
/*18989*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVHLPSrr), 0,
                        1/*#VTs*/, MVT::v4f32, 2/*#Ops*/, 0, 1, 
                    // Src: (vector_shuffle:v4f32 VR128:v4f32:$src1, VR128:v4f32:$src2)<<P:Predicate_movhlps>>
                    // Dst: (MOVHLPSrr:v4f32 VR128:v4f32:$src1, VR128:v4f32:$src2)
/*18998*/         0, /*End of Scope*/
                /*SwitchType*/ 26,  MVT::v4i32,// ->19027
/*19001*/         OPC_Scope, 11, /*->19014*/ // 2 children in Scope
/*19003*/           OPC_CheckPredicate, 22, // Predicate_movlhps
/*19005*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVLHPSrr), 0,
                        1/*#VTs*/, MVT::v4i32, 2/*#Ops*/, 0, 1, 
                    // Src: (vector_shuffle:v4i32 VR128:v4i32:$src1, VR128:v4i32:$src2)<<P:Predicate_movlhps>>
                    // Dst: (MOVLHPSrr:v4i32 VR128:v16i8:$src1, VR128:v16i8:$src2)
/*19014*/         /*Scope*/ 11, /*->19026*/
/*19015*/           OPC_CheckPredicate, 36, // Predicate_movhlps
/*19017*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVHLPSrr), 0,
                        1/*#VTs*/, MVT::v4i32, 2/*#Ops*/, 0, 1, 
                    // Src: (vector_shuffle:v4i32 VR128:v4i32:$src1, VR128:v4i32:$src2)<<P:Predicate_movhlps>>
                    // Dst: (MOVHLPSrr:v4i32 VR128:v16i8:$src1, VR128:v16i8:$src2)
/*19026*/         0, /*End of Scope*/
                0, // EndSwitchType
/*19028*/     0, /*End of Scope*/
/*19029*/   /*Scope*/ 22, /*->19052*/
/*19030*/     OPC_MoveChild, 0,
/*19032*/     OPC_CheckOpcode, ISD::BIT_CONVERT,
/*19034*/     OPC_CheckPredicate, 37, // Predicate_immAllZerosV_bc
/*19036*/     OPC_MoveParent,
/*19037*/     OPC_RecordChild1, // #0 = $src
/*19038*/     OPC_CheckPredicate, 38, // Predicate_movl
/*19040*/     OPC_CheckType, MVT::v2f64,
/*19042*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*19044*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVZPQILo2PQIrr), 0,
                  1/*#VTs*/, MVT::v2f64, 1/*#Ops*/, 0, 
              // Src: (vector_shuffle:v2f64 (bitconvert:v2f64)<<P:Predicate_immAllZerosV_bc>>, VR128:v2f64:$src)<<P:Predicate_movl>>
              // Dst: (MOVZPQILo2PQIrr:v2f64 VR128:v16i8:$src)
/*19052*/   /*Scope*/ 36, /*->19089*/
/*19053*/     OPC_RecordChild0, // #0 = $src
/*19054*/     OPC_MoveChild, 1,
/*19056*/     OPC_CheckOpcode, ISD::UNDEF,
/*19058*/     OPC_MoveParent,
/*19059*/     OPC_CheckType, MVT::v4i32,
/*19061*/     OPC_Scope, 12, /*->19075*/ // 2 children in Scope
/*19063*/       OPC_CheckPredicate, 24, // Predicate_movshdup
/*19065*/       OPC_CheckPatternPredicate, 9, // (Subtarget->hasSSE3())
/*19067*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVSHDUPrr), 0,
                    1/*#VTs*/, MVT::v4i32, 1/*#Ops*/, 0, 
                // Src: (vector_shuffle:v4i32 VR128:v4i32:$src, (undef:v4i32))<<P:Predicate_movshdup>>
                // Dst: (MOVSHDUPrr:v4i32 VR128:v16i8:$src)
/*19075*/     /*Scope*/ 12, /*->19088*/
/*19076*/       OPC_CheckPredicate, 25, // Predicate_movsldup
/*19078*/       OPC_CheckPatternPredicate, 9, // (Subtarget->hasSSE3())
/*19080*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVSLDUPrr), 0,
                    1/*#VTs*/, MVT::v4i32, 1/*#Ops*/, 0, 
                // Src: (vector_shuffle:v4i32 VR128:v4i32:$src, (undef:v4i32))<<P:Predicate_movsldup>>
                // Dst: (MOVSLDUPrr:v4i32 VR128:v16i8:$src)
/*19088*/     0, /*End of Scope*/
/*19089*/   /*Scope*/ 83, /*->19173*/
/*19090*/     OPC_RecordNode, // #0 = $src2
/*19091*/     OPC_RecordChild0, // #1 = $src
/*19092*/     OPC_MoveChild, 1,
/*19094*/     OPC_CheckOpcode, ISD::UNDEF,
/*19096*/     OPC_MoveParent,
/*19097*/     OPC_Scope, 36, /*->19135*/ // 2 children in Scope
/*19099*/       OPC_CheckPredicate, 39, // Predicate_unpckl_undef
/*19101*/       OPC_SwitchType /*2 cases */, 14,  MVT::v4i32,// ->19118
/*19104*/         OPC_CheckPatternPredicate, 10, // (!OptForSize) && (Subtarget->hasSSE2())
/*19106*/         OPC_EmitNodeXForm, 0, 0, // SHUFFLE_get_shuf_imm
/*19109*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::PSHUFDri), 0,
                      1/*#VTs*/, MVT::v4i32, 2/*#Ops*/, 1, 2, 
                  // Src: (vector_shuffle:v4i32 VR128:v4i32:$src, (undef:v4i32))<<P:Predicate_unpckl_undef>>:$src2
                  // Dst: (PSHUFDri:v4i32 VR128:v16i8:$src, (SHUFFLE_get_shuf_imm:i8 VR128:i8:$src2))
                /*SwitchType*/ 14,  MVT::v4f32,// ->19134
/*19120*/         OPC_CheckPatternPredicate, 10, // (!OptForSize) && (Subtarget->hasSSE2())
/*19122*/         OPC_EmitNodeXForm, 0, 0, // SHUFFLE_get_shuf_imm
/*19125*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::PSHUFDri), 0,
                      1/*#VTs*/, MVT::v4f32, 2/*#Ops*/, 1, 2, 
                  // Src: (vector_shuffle:v4f32 VR128:v4f32:$src, (undef:v4f32))<<P:Predicate_unpckl_undef>>:$src2
                  // Dst: (PSHUFDri:v4f32 VR128:v16i8:$src, (SHUFFLE_get_shuf_imm:i8 VR128:i8:$src2))
                0, // EndSwitchType
/*19135*/     /*Scope*/ 36, /*->19172*/
/*19136*/       OPC_CheckPredicate, 40, // Predicate_unpckh_undef
/*19138*/       OPC_SwitchType /*2 cases */, 14,  MVT::v4i32,// ->19155
/*19141*/         OPC_CheckPatternPredicate, 10, // (!OptForSize) && (Subtarget->hasSSE2())
/*19143*/         OPC_EmitNodeXForm, 0, 0, // SHUFFLE_get_shuf_imm
/*19146*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::PSHUFDri), 0,
                      1/*#VTs*/, MVT::v4i32, 2/*#Ops*/, 1, 2, 
                  // Src: (vector_shuffle:v4i32 VR128:v4i32:$src, (undef:v4i32))<<P:Predicate_unpckh_undef>>:$src2
                  // Dst: (PSHUFDri:v4i32 VR128:v16i8:$src, (SHUFFLE_get_shuf_imm:i8 VR128:i8:$src2))
                /*SwitchType*/ 14,  MVT::v4f32,// ->19171
/*19157*/         OPC_CheckPatternPredicate, 10, // (!OptForSize) && (Subtarget->hasSSE2())
/*19159*/         OPC_EmitNodeXForm, 0, 0, // SHUFFLE_get_shuf_imm
/*19162*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::PSHUFDri), 0,
                      1/*#VTs*/, MVT::v4f32, 2/*#Ops*/, 1, 2, 
                  // Src: (vector_shuffle:v4f32 VR128:v4f32:$src, (undef:v4f32))<<P:Predicate_unpckh_undef>>:$src2
                  // Dst: (PSHUFDri:v4f32 VR128:v16i8:$src, (SHUFFLE_get_shuf_imm:i8 VR128:i8:$src2))
                0, // EndSwitchType
/*19172*/     0, /*End of Scope*/
/*19173*/   /*Scope*/ 91|128,3/*475*/, /*->19650*/
/*19175*/     OPC_RecordChild0, // #0 = $src1
/*19176*/     OPC_Scope, 27|128,1/*155*/, /*->19334*/ // 3 children in Scope
/*19179*/       OPC_RecordChild1, // #1 = $src2
/*19180*/       OPC_Scope, 96, /*->19278*/ // 2 children in Scope
/*19182*/         OPC_CheckPredicate, 38, // Predicate_movl
/*19184*/         OPC_SwitchType /*4 cases */, 21,  MVT::v4f32,// ->19208
/*19187*/           OPC_EmitInteger, MVT::i32, 1, 
/*19190*/           OPC_EmitNode, TARGET_OPCODE(TargetOpcode::EXTRACT_SUBREG), 0,
                        1/*#VTs*/, MVT::f32, 2/*#Ops*/, 1, 2,  // Results = #3 
/*19199*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVSSrr), 0,
                        1/*#VTs*/, MVT::v4f32, 2/*#Ops*/, 0, 3, 
                    // Src: (vector_shuffle:v4f32 VR128:v4f32:$src1, VR128:v4f32:$src2)<<P:Predicate_movl>>
                    // Dst: (MOVSSrr:v4f32 VR128:v16i8:$src1, (EXTRACT_SUBREG:f32 VR128:v4f32:$src2, 1:i32))
                  /*SwitchType*/ 21,  MVT::v2f64,// ->19231
/*19210*/           OPC_EmitInteger, MVT::i32, 2, 
/*19213*/           OPC_EmitNode, TARGET_OPCODE(TargetOpcode::EXTRACT_SUBREG), 0,
                        1/*#VTs*/, MVT::f64, 2/*#Ops*/, 1, 2,  // Results = #3 
/*19222*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVSDrr), 0,
                        1/*#VTs*/, MVT::v2f64, 2/*#Ops*/, 0, 3, 
                    // Src: (vector_shuffle:v2f64 VR128:v2f64:$src1, VR128:v2f64:$src2)<<P:Predicate_movl>>
                    // Dst: (MOVSDrr:v2f64 VR128:v16i8:$src1, (EXTRACT_SUBREG:f64 VR128:v2f64:$src2, 2:i32))
                  /*SwitchType*/ 21,  MVT::v4i32,// ->19254
/*19233*/           OPC_EmitInteger, MVT::i32, 1, 
/*19236*/           OPC_EmitNode, TARGET_OPCODE(TargetOpcode::EXTRACT_SUBREG), 0,
                        1/*#VTs*/, MVT::f32, 2/*#Ops*/, 1, 2,  // Results = #3 
/*19245*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVSSrr), 0,
                        1/*#VTs*/, MVT::v4i32, 2/*#Ops*/, 0, 3, 
                    // Src: (vector_shuffle:v4i32 VR128:v4i32:$src1, VR128:v4i32:$src2)<<P:Predicate_movl>>
                    // Dst: (MOVSSrr:v4i32 VR128:v4i32:$src1, (EXTRACT_SUBREG:f32 VR128:v4i32:$src2, 1:i32))
                  /*SwitchType*/ 21,  MVT::v2i64,// ->19277
/*19256*/           OPC_EmitInteger, MVT::i32, 2, 
/*19259*/           OPC_EmitNode, TARGET_OPCODE(TargetOpcode::EXTRACT_SUBREG), 0,
                        1/*#VTs*/, MVT::f64, 2/*#Ops*/, 1, 2,  // Results = #3 
/*19268*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVSDrr), 0,
                        1/*#VTs*/, MVT::v2i64, 2/*#Ops*/, 0, 3, 
                    // Src: (vector_shuffle:v2i64 VR128:v2i64:$src1, VR128:v2i64:$src2)<<P:Predicate_movl>>
                    // Dst: (MOVSDrr:v2i64 VR128:v2i64:$src1, (EXTRACT_SUBREG:f64 VR128:v2i64:$src2, 2:i32))
                  0, // EndSwitchType
/*19278*/       /*Scope*/ 54, /*->19333*/
/*19279*/         OPC_CheckPredicate, 13, // Predicate_movlp
/*19281*/         OPC_SwitchType /*2 cases */, 23,  MVT::v4f32,// ->19307
/*19284*/           OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*19286*/           OPC_EmitInteger, MVT::i32, 2, 
/*19289*/           OPC_EmitNode, TARGET_OPCODE(TargetOpcode::EXTRACT_SUBREG), 0,
                        1/*#VTs*/, MVT::f64, 2/*#Ops*/, 1, 2,  // Results = #3 
/*19298*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVSDrr), 0,
                        1/*#VTs*/, MVT::v4f32, 2/*#Ops*/, 0, 3, 
                    // Src: (vector_shuffle:v4f32 VR128:v4f32:$src1, VR128:v4f32:$src2)<<P:Predicate_movlp>>
                    // Dst: (MOVSDrr:v4f32 VR128:v16i8:$src1, (EXTRACT_SUBREG:f64 VR128:v16i8:$src2, 2:i32))
                  /*SwitchType*/ 23,  MVT::v4i32,// ->19332
/*19309*/           OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*19311*/           OPC_EmitInteger, MVT::i32, 2, 
/*19314*/           OPC_EmitNode, TARGET_OPCODE(TargetOpcode::EXTRACT_SUBREG), 0,
                        1/*#VTs*/, MVT::f64, 2/*#Ops*/, 1, 2,  // Results = #3 
/*19323*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVSDrr), 0,
                        1/*#VTs*/, MVT::v4i32, 2/*#Ops*/, 0, 3, 
                    // Src: (vector_shuffle:v4i32 VR128:v4i32:$src1, VR128:v4i32:$src2)<<P:Predicate_movlp>>
                    // Dst: (MOVSDrr:v4i32 VR128:v16i8:$src1, (EXTRACT_SUBREG:f64 VR128:v16i8:$src2, 2:i32))
                  0, // EndSwitchType
/*19333*/       0, /*End of Scope*/
/*19334*/     /*Scope*/ 117|128,1/*245*/, /*->19581*/
/*19336*/       OPC_MoveChild, 1,
/*19338*/       OPC_CheckOpcode, ISD::UNDEF,
/*19340*/       OPC_MoveParent,
/*19341*/       OPC_Scope, 15, /*->19358*/ // 8 children in Scope
/*19343*/         OPC_CheckPredicate, 41, // Predicate_splat_lo
/*19345*/         OPC_CheckType, MVT::v2f64,
/*19347*/         OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*19349*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::UNPCKLPDrr), 0,
                      1/*#VTs*/, MVT::v2f64, 2/*#Ops*/, 0, 0, 
                  // Src: (vector_shuffle:v2f64 VR128:v2f64:$src, (undef:v2f64))<<P:Predicate_splat_lo>>
                  // Dst: (UNPCKLPDrr:v2f64 VR128:v16i8:$src, VR128:v16i8:$src)
/*19358*/       /*Scope*/ 15, /*->19374*/
/*19359*/         OPC_CheckPredicate, 14, // Predicate_unpckh
/*19361*/         OPC_CheckType, MVT::v2f64,
/*19363*/         OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*19365*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::UNPCKHPDrr), 0,
                      1/*#VTs*/, MVT::v2f64, 2/*#Ops*/, 0, 0, 
                  // Src: (vector_shuffle:v2f64 VR128:v2f64:$src, (undef:v2f64))<<P:Predicate_unpckh>>
                  // Dst: (UNPCKHPDrr:v2f64 VR128:v16i8:$src, VR128:v16i8:$src)
/*19374*/       /*Scope*/ 15, /*->19390*/
/*19375*/         OPC_CheckPredicate, 41, // Predicate_splat_lo
/*19377*/         OPC_CheckType, MVT::v2i64,
/*19379*/         OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*19381*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::PUNPCKLQDQrr), 0,
                      1/*#VTs*/, MVT::v2i64, 2/*#Ops*/, 0, 0, 
                  // Src: (vector_shuffle:v2i64 VR128:v2i64:$src, (undef:v2i64))<<P:Predicate_splat_lo>>
                  // Dst: (PUNPCKLQDQrr:v2i64 VR128:v16i8:$src, VR128:v16i8:$src)
/*19390*/       /*Scope*/ 15, /*->19406*/
/*19391*/         OPC_CheckPredicate, 14, // Predicate_unpckh
/*19393*/         OPC_CheckType, MVT::v2i64,
/*19395*/         OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*19397*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::PUNPCKHQDQrr), 0,
                      1/*#VTs*/, MVT::v2i64, 2/*#Ops*/, 0, 0, 
                  // Src: (vector_shuffle:v2i64 VR128:v2i64:$src, (undef:v2i64))<<P:Predicate_unpckh>>
                  // Dst: (PUNPCKHQDQrr:v2i64 VR128:v16i8:$src, VR128:v16i8:$src)
/*19406*/       /*Scope*/ 48, /*->19455*/
/*19407*/         OPC_CheckPredicate, 39, // Predicate_unpckl_undef
/*19409*/         OPC_SwitchType /*4 cases */, 9,  MVT::v4f32,// ->19421
/*19412*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::UNPCKLPSrr), 0,
                        1/*#VTs*/, MVT::v4f32, 2/*#Ops*/, 0, 0, 
                    // Src: (vector_shuffle:v4f32 VR128:v4f32:$src, (undef:v4f32))<<P:Predicate_unpckl_undef>>
                    // Dst: (UNPCKLPSrr:v4f32 VR128:v16i8:$src, VR128:v16i8:$src)
                  /*SwitchType*/ 9,  MVT::v16i8,// ->19432
/*19423*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::PUNPCKLBWrr), 0,
                        1/*#VTs*/, MVT::v16i8, 2/*#Ops*/, 0, 0, 
                    // Src: (vector_shuffle:v16i8 VR128:v16i8:$src, (undef:v16i8))<<P:Predicate_unpckl_undef>>
                    // Dst: (PUNPCKLBWrr:v16i8 VR128:v16i8:$src, VR128:v16i8:$src)
                  /*SwitchType*/ 9,  MVT::v8i16,// ->19443
/*19434*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::PUNPCKLWDrr), 0,
                        1/*#VTs*/, MVT::v8i16, 2/*#Ops*/, 0, 0, 
                    // Src: (vector_shuffle:v8i16 VR128:v8i16:$src, (undef:v8i16))<<P:Predicate_unpckl_undef>>
                    // Dst: (PUNPCKLWDrr:v8i16 VR128:v16i8:$src, VR128:v16i8:$src)
                  /*SwitchType*/ 9,  MVT::v4i32,// ->19454
/*19445*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::PUNPCKLDQrr), 0,
                        1/*#VTs*/, MVT::v4i32, 2/*#Ops*/, 0, 0, 
                    // Src: (vector_shuffle:v4i32 VR128:v4i32:$src, (undef:v4i32))<<P:Predicate_unpckl_undef>>
                    // Dst: (PUNPCKLDQrr:v4i32 VR128:v16i8:$src, VR128:v16i8:$src)
                  0, // EndSwitchType
/*19455*/       /*Scope*/ 48, /*->19504*/
/*19456*/         OPC_CheckPredicate, 40, // Predicate_unpckh_undef
/*19458*/         OPC_SwitchType /*4 cases */, 9,  MVT::v4f32,// ->19470
/*19461*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::UNPCKHPSrr), 0,
                        1/*#VTs*/, MVT::v4f32, 2/*#Ops*/, 0, 0, 
                    // Src: (vector_shuffle:v4f32 VR128:v4f32:$src, (undef:v4f32))<<P:Predicate_unpckh_undef>>
                    // Dst: (UNPCKHPSrr:v4f32 VR128:v16i8:$src, VR128:v16i8:$src)
                  /*SwitchType*/ 9,  MVT::v16i8,// ->19481
/*19472*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::PUNPCKHBWrr), 0,
                        1/*#VTs*/, MVT::v16i8, 2/*#Ops*/, 0, 0, 
                    // Src: (vector_shuffle:v16i8 VR128:v16i8:$src, (undef:v16i8))<<P:Predicate_unpckh_undef>>
                    // Dst: (PUNPCKHBWrr:v16i8 VR128:v16i8:$src, VR128:v16i8:$src)
                  /*SwitchType*/ 9,  MVT::v8i16,// ->19492
/*19483*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::PUNPCKHWDrr), 0,
                        1/*#VTs*/, MVT::v8i16, 2/*#Ops*/, 0, 0, 
                    // Src: (vector_shuffle:v8i16 VR128:v8i16:$src, (undef:v8i16))<<P:Predicate_unpckh_undef>>
                    // Dst: (PUNPCKHWDrr:v8i16 VR128:v16i8:$src, VR128:v16i8:$src)
                  /*SwitchType*/ 9,  MVT::v4i32,// ->19503
/*19494*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::PUNPCKHDQrr), 0,
                        1/*#VTs*/, MVT::v4i32, 2/*#Ops*/, 0, 0, 
                    // Src: (vector_shuffle:v4i32 VR128:v4i32:$src, (undef:v4i32))<<P:Predicate_unpckh_undef>>
                    // Dst: (PUNPCKHDQrr:v4i32 VR128:v16i8:$src, VR128:v16i8:$src)
                  0, // EndSwitchType
/*19504*/       /*Scope*/ 37, /*->19542*/
/*19505*/         OPC_CheckPredicate, 42, // Predicate_mmx_unpckl_undef
/*19507*/         OPC_SwitchType /*3 cases */, 9,  MVT::v8i8,// ->19519
/*19510*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PUNPCKLBWrr), 0,
                        1/*#VTs*/, MVT::v8i8, 2/*#Ops*/, 0, 0, 
                    // Src: (vector_shuffle:v8i8 VR64:v8i8:$src, (undef:v8i8))<<P:Predicate_mmx_unpckl_undef>>
                    // Dst: (MMX_PUNPCKLBWrr:v8i8 VR64:v8i8:$src, VR64:v8i8:$src)
                  /*SwitchType*/ 9,  MVT::v4i16,// ->19530
/*19521*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PUNPCKLWDrr), 0,
                        1/*#VTs*/, MVT::v4i16, 2/*#Ops*/, 0, 0, 
                    // Src: (vector_shuffle:v4i16 VR64:v4i16:$src, (undef:v4i16))<<P:Predicate_mmx_unpckl_undef>>
                    // Dst: (MMX_PUNPCKLWDrr:v4i16 VR64:v8i8:$src, VR64:v8i8:$src)
                  /*SwitchType*/ 9,  MVT::v2i32,// ->19541
/*19532*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PUNPCKLDQrr), 0,
                        1/*#VTs*/, MVT::v2i32, 2/*#Ops*/, 0, 0, 
                    // Src: (vector_shuffle:v2i32 VR64:v2i32:$src, (undef:v2i32))<<P:Predicate_mmx_unpckl_undef>>
                    // Dst: (MMX_PUNPCKLDQrr:v2i32 VR64:v8i8:$src, VR64:v8i8:$src)
                  0, // EndSwitchType
/*19542*/       /*Scope*/ 37, /*->19580*/
/*19543*/         OPC_CheckPredicate, 43, // Predicate_mmx_unpckh_undef
/*19545*/         OPC_SwitchType /*3 cases */, 9,  MVT::v8i8,// ->19557
/*19548*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PUNPCKHBWrr), 0,
                        1/*#VTs*/, MVT::v8i8, 2/*#Ops*/, 0, 0, 
                    // Src: (vector_shuffle:v8i8 VR64:v8i8:$src, (undef:v8i8))<<P:Predicate_mmx_unpckh_undef>>
                    // Dst: (MMX_PUNPCKHBWrr:v8i8 VR64:v8i8:$src, VR64:v8i8:$src)
                  /*SwitchType*/ 9,  MVT::v4i16,// ->19568
/*19559*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PUNPCKHWDrr), 0,
                        1/*#VTs*/, MVT::v4i16, 2/*#Ops*/, 0, 0, 
                    // Src: (vector_shuffle:v4i16 VR64:v4i16:$src, (undef:v4i16))<<P:Predicate_mmx_unpckh_undef>>
                    // Dst: (MMX_PUNPCKHWDrr:v4i16 VR64:v8i8:$src, VR64:v8i8:$src)
                  /*SwitchType*/ 9,  MVT::v2i32,// ->19579
/*19570*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PUNPCKHDQrr), 0,
                        1/*#VTs*/, MVT::v2i32, 2/*#Ops*/, 0, 0, 
                    // Src: (vector_shuffle:v2i32 VR64:v2i32:$src, (undef:v2i32))<<P:Predicate_mmx_unpckh_undef>>
                    // Dst: (MMX_PUNPCKHDQrr:v2i32 VR64:v8i8:$src, VR64:v8i8:$src)
                  0, // EndSwitchType
/*19580*/       0, /*End of Scope*/
/*19581*/     /*Scope*/ 67, /*->19649*/
/*19582*/       OPC_RecordChild1, // #1 = $src2
/*19583*/       OPC_SwitchType /*2 cases */, 30,  MVT::v4f32,// ->19616
/*19586*/         OPC_Scope, 13, /*->19601*/ // 2 children in Scope
/*19588*/           OPC_CheckPredicate, 14, // Predicate_unpckh
/*19590*/           OPC_CheckPatternPredicate, 0, // (Subtarget->hasSSE1())
/*19592*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::UNPCKHPSrr), 0,
                        1/*#VTs*/, MVT::v4f32, 2/*#Ops*/, 0, 1, 
                    // Src: (vector_shuffle:v4f32 VR128:v4f32:$src1, VR128:v4f32:$src2)<<P:Predicate_unpckh>>
                    // Dst: (UNPCKHPSrr:v4f32 VR128:v4f32:$src1, VR128:v4f32:$src2)
/*19601*/         /*Scope*/ 13, /*->19615*/
/*19602*/           OPC_CheckPredicate, 28, // Predicate_unpckl
/*19604*/           OPC_CheckPatternPredicate, 0, // (Subtarget->hasSSE1())
/*19606*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::UNPCKLPSrr), 0,
                        1/*#VTs*/, MVT::v4f32, 2/*#Ops*/, 0, 1, 
                    // Src: (vector_shuffle:v4f32 VR128:v4f32:$src1, VR128:v4f32:$src2)<<P:Predicate_unpckl>>
                    // Dst: (UNPCKLPSrr:v4f32 VR128:v4f32:$src1, VR128:v4f32:$src2)
/*19615*/         0, /*End of Scope*/
                /*SwitchType*/ 30,  MVT::v2f64,// ->19648
/*19618*/         OPC_Scope, 13, /*->19633*/ // 2 children in Scope
/*19620*/           OPC_CheckPredicate, 14, // Predicate_unpckh
/*19622*/           OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*19624*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::UNPCKHPDrr), 0,
                        1/*#VTs*/, MVT::v2f64, 2/*#Ops*/, 0, 1, 
                    // Src: (vector_shuffle:v2f64 VR128:v2f64:$src1, VR128:v2f64:$src2)<<P:Predicate_unpckh>>
                    // Dst: (UNPCKHPDrr:v2f64 VR128:v2f64:$src1, VR128:v2f64:$src2)
/*19633*/         /*Scope*/ 13, /*->19647*/
/*19634*/           OPC_CheckPredicate, 28, // Predicate_unpckl
/*19636*/           OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*19638*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::UNPCKLPDrr), 0,
                        1/*#VTs*/, MVT::v2f64, 2/*#Ops*/, 0, 1, 
                    // Src: (vector_shuffle:v2f64 VR128:v2f64:$src1, VR128:v2f64:$src2)<<P:Predicate_unpckl>>
                    // Dst: (UNPCKLPDrr:v2f64 VR128:v2f64:$src1, VR128:v2f64:$src2)
/*19647*/         0, /*End of Scope*/
                0, // EndSwitchType
/*19649*/     0, /*End of Scope*/
/*19650*/   /*Scope*/ 36, /*->19687*/
/*19651*/     OPC_MoveChild, 0,
/*19653*/     OPC_CheckOpcode, ISD::BUILD_VECTOR,
/*19655*/     OPC_CheckPredicate, 44, // Predicate_immAllZerosV
/*19657*/     OPC_MoveParent,
/*19658*/     OPC_MoveChild, 1,
/*19660*/     OPC_CheckOpcode, ISD::SCALAR_TO_VECTOR,
/*19662*/     OPC_MoveChild, 0,
/*19664*/     OPC_CheckOpcode, ISD::BIT_CONVERT,
/*19666*/     OPC_RecordChild0, // #0 = $src
/*19667*/     OPC_CheckChild0Type, MVT::v8i8,
/*19669*/     OPC_CheckType, MVT::i64,
/*19671*/     OPC_MoveParent,
/*19672*/     OPC_MoveParent,
/*19673*/     OPC_CheckPredicate, 38, // Predicate_movl
/*19675*/     OPC_CheckType, MVT::v2i64,
/*19677*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*19679*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_MOVQ2DQrr), 0,
                  1/*#VTs*/, MVT::v2i64, 1/*#Ops*/, 0, 
              // Src: (vector_shuffle:v2i64 (build_vector:v2i64)<<P:Predicate_immAllZerosV>>, (scalar_to_vector:v2i64 (bitconvert:i64 VR64:v8i8:$src)))<<P:Predicate_movl>>
              // Dst: (MMX_MOVQ2DQrr:v2i64 VR64:v8i8:$src)
/*19687*/   /*Scope*/ 120, /*->19808*/
/*19688*/     OPC_RecordNode, // #0 = $src2
/*19689*/     OPC_RecordChild0, // #1 = $src1
/*19690*/     OPC_Scope, 41, /*->19733*/ // 2 children in Scope
/*19692*/       OPC_MoveChild, 1,
/*19694*/       OPC_CheckOpcode, ISD::UNDEF,
/*19696*/       OPC_MoveParent,
/*19697*/       OPC_CheckPredicate, 26, // Predicate_pshufd
/*19699*/       OPC_SwitchType /*2 cases */, 14,  MVT::v4i32,// ->19716
/*19702*/         OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*19704*/         OPC_EmitNodeXForm, 0, 0, // SHUFFLE_get_shuf_imm
/*19707*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::PSHUFDri), 0,
                      1/*#VTs*/, MVT::v4i32, 2/*#Ops*/, 1, 2, 
                  // Src: (vector_shuffle:v4i32 VR128:v4i32:$src1, (undef:v4i32))<<P:Predicate_pshufd>><<X:SHUFFLE_get_shuf_imm>>:$src2
                  // Dst: (PSHUFDri:v4i32 VR128:v4i32:$src1, (SHUFFLE_get_shuf_imm:i8 (vector_shuffle:v4i32 VR128:v4i32:$src1, (undef:v4i32)):$src2))
                /*SwitchType*/ 14,  MVT::v4f32,// ->19732
/*19718*/         OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*19720*/         OPC_EmitNodeXForm, 0, 0, // SHUFFLE_get_shuf_imm
/*19723*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::PSHUFDri), 0,
                      1/*#VTs*/, MVT::v4f32, 2/*#Ops*/, 1, 2, 
                  // Src: (vector_shuffle:v4f32 VR128:v4f32:$src1, (undef:v4f32))<<P:Predicate_pshufd>><<X:SHUFFLE_get_shuf_imm>>:$src2
                  // Dst: (PSHUFDri:v4f32 VR128:v16i8:$src1, (SHUFFLE_get_shuf_imm:i8 VR128:i8:$src2))
                0, // EndSwitchType
/*19733*/     /*Scope*/ 73, /*->19807*/
/*19734*/       OPC_RecordChild1, // #2 = $src2
/*19735*/       OPC_CheckPredicate, 45, // Predicate_palign
/*19737*/       OPC_SwitchType /*4 cases */, 15,  MVT::v4i32,// ->19755
/*19740*/         OPC_CheckPatternPredicate, 11, // (Subtarget->hasSSSE3())
/*19742*/         OPC_EmitNodeXForm, 4, 0, // SHUFFLE_get_palign_imm
/*19745*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::PALIGNR128rr), 0,
                      1/*#VTs*/, MVT::v4i32, 3/*#Ops*/, 2, 1, 3, 
                  // Src: (vector_shuffle:v4i32 VR128:v4i32:$src1, VR128:v4i32:$src2)<<P:Predicate_palign>><<X:SHUFFLE_get_palign_imm>>:$src3
                  // Dst: (PALIGNR128rr:v4i32 VR128:v16i8:$src2, VR128:v16i8:$src1, (SHUFFLE_get_palign_imm:i8 VR128:i8:$src3))
                /*SwitchType*/ 15,  MVT::v4f32,// ->19772
/*19757*/         OPC_CheckPatternPredicate, 11, // (Subtarget->hasSSSE3())
/*19759*/         OPC_EmitNodeXForm, 4, 0, // SHUFFLE_get_palign_imm
/*19762*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::PALIGNR128rr), 0,
                      1/*#VTs*/, MVT::v4f32, 3/*#Ops*/, 2, 1, 3, 
                  // Src: (vector_shuffle:v4f32 VR128:v4f32:$src1, VR128:v4f32:$src2)<<P:Predicate_palign>><<X:SHUFFLE_get_palign_imm>>:$src3
                  // Dst: (PALIGNR128rr:v4f32 VR128:v16i8:$src2, VR128:v16i8:$src1, (SHUFFLE_get_palign_imm:i8 VR128:i8:$src3))
                /*SwitchType*/ 15,  MVT::v8i16,// ->19789
/*19774*/         OPC_CheckPatternPredicate, 11, // (Subtarget->hasSSSE3())
/*19776*/         OPC_EmitNodeXForm, 4, 0, // SHUFFLE_get_palign_imm
/*19779*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::PALIGNR128rr), 0,
                      1/*#VTs*/, MVT::v8i16, 3/*#Ops*/, 2, 1, 3, 
                  // Src: (vector_shuffle:v8i16 VR128:v8i16:$src1, VR128:v8i16:$src2)<<P:Predicate_palign>><<X:SHUFFLE_get_palign_imm>>:$src3
                  // Dst: (PALIGNR128rr:v8i16 VR128:v16i8:$src2, VR128:v16i8:$src1, (SHUFFLE_get_palign_imm:i8 VR128:i8:$src3))
                /*SwitchType*/ 15,  MVT::v16i8,// ->19806
/*19791*/         OPC_CheckPatternPredicate, 11, // (Subtarget->hasSSSE3())
/*19793*/         OPC_EmitNodeXForm, 4, 0, // SHUFFLE_get_palign_imm
/*19796*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::PALIGNR128rr), 0,
                      1/*#VTs*/, MVT::v16i8, 3/*#Ops*/, 2, 1, 3, 
                  // Src: (vector_shuffle:v16i8 VR128:v16i8:$src1, VR128:v16i8:$src2)<<P:Predicate_palign>><<X:SHUFFLE_get_palign_imm>>:$src3
                  // Dst: (PALIGNR128rr:v16i8 VR128:v16i8:$src2, VR128:v16i8:$src1, (SHUFFLE_get_palign_imm:i8 VR128:i8:$src3))
                0, // EndSwitchType
/*19807*/     0, /*End of Scope*/
/*19808*/   /*Scope*/ 46, /*->19855*/
/*19809*/     OPC_RecordChild0, // #0 = $src1
/*19810*/     OPC_MoveChild, 1,
/*19812*/     OPC_CheckOpcode, ISD::SCALAR_TO_VECTOR,
/*19814*/     OPC_RecordChild0, // #1 = $src2
/*19815*/     OPC_Scope, 18, /*->19835*/ // 2 children in Scope
/*19817*/       OPC_CheckChild0Type, MVT::f32,
/*19819*/       OPC_MoveParent,
/*19820*/       OPC_CheckPredicate, 38, // Predicate_movl
/*19822*/       OPC_CheckType, MVT::v16i8,
/*19824*/       OPC_CheckPatternPredicate, 0, // (Subtarget->hasSSE1())
/*19826*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVSSrr), 0,
                    1/*#VTs*/, MVT::v16i8, 2/*#Ops*/, 0, 1, 
                // Src: (vector_shuffle:v16i8 VR128:v16i8:$src1, (scalar_to_vector:v16i8 FR32:f32:$src2))<<P:Predicate_movl>>
                // Dst: (MOVSSrr:v16i8 VR128:v16i8:$src1, FR32:f32:$src2)
/*19835*/     /*Scope*/ 18, /*->19854*/
/*19836*/       OPC_CheckChild0Type, MVT::f64,
/*19838*/       OPC_MoveParent,
/*19839*/       OPC_CheckPredicate, 38, // Predicate_movl
/*19841*/       OPC_CheckType, MVT::v16i8,
/*19843*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*19845*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVSDrr), 0,
                    1/*#VTs*/, MVT::v16i8, 2/*#Ops*/, 0, 1, 
                // Src: (vector_shuffle:v16i8 VR128:v16i8:$src1, (scalar_to_vector:v16i8 FR64:f64:$src2))<<P:Predicate_movl>>
                // Dst: (MOVSDrr:v16i8 VR128:v16i8:$src1, FR64:f64:$src2)
/*19854*/     0, /*End of Scope*/
/*19855*/   /*Scope*/ 45, /*->19901*/
/*19856*/     OPC_RecordNode, // #0 = $src2
/*19857*/     OPC_RecordChild0, // #1 = $src1
/*19858*/     OPC_MoveChild, 1,
/*19860*/     OPC_CheckOpcode, ISD::UNDEF,
/*19862*/     OPC_MoveParent,
/*19863*/     OPC_CheckType, MVT::v8i16,
/*19865*/     OPC_Scope, 16, /*->19883*/ // 2 children in Scope
/*19867*/       OPC_CheckPredicate, 29, // Predicate_pshufhw
/*19869*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*19871*/       OPC_EmitNodeXForm, 1, 0, // SHUFFLE_get_pshufhw_imm
/*19874*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PSHUFHWri), 0,
                    1/*#VTs*/, MVT::v8i16, 2/*#Ops*/, 1, 2, 
                // Src: (vector_shuffle:v8i16 VR128:v8i16:$src1, (undef:v8i16))<<P:Predicate_pshufhw>><<X:SHUFFLE_get_pshufhw_imm>>:$src2
                // Dst: (PSHUFHWri:v8i16 VR128:v8i16:$src1, (SHUFFLE_get_pshufhw_imm:i8 (vector_shuffle:v8i16 VR128:v8i16:$src1, (undef:v8i16)):$src2))
/*19883*/     /*Scope*/ 16, /*->19900*/
/*19884*/       OPC_CheckPredicate, 30, // Predicate_pshuflw
/*19886*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*19888*/       OPC_EmitNodeXForm, 2, 0, // SHUFFLE_get_pshuflw_imm
/*19891*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PSHUFLWri), 0,
                    1/*#VTs*/, MVT::v8i16, 2/*#Ops*/, 1, 2, 
                // Src: (vector_shuffle:v8i16 VR128:v8i16:$src1, (undef:v8i16))<<P:Predicate_pshuflw>><<X:SHUFFLE_get_pshuflw_imm>>:$src2
                // Dst: (PSHUFLWri:v8i16 VR128:v8i16:$src1, (SHUFFLE_get_pshuflw_imm:i8 (vector_shuffle:v8i16 VR128:v8i16:$src1, (undef:v8i16)):$src2))
/*19900*/     0, /*End of Scope*/
/*19901*/   /*Scope*/ 52, /*->19954*/
/*19902*/     OPC_RecordChild0, // #0 = $src
/*19903*/     OPC_MoveChild, 1,
/*19905*/     OPC_CheckOpcode, ISD::UNDEF,
/*19907*/     OPC_MoveParent,
/*19908*/     OPC_SwitchType /*2 cases */, 28,  MVT::v4f32,// ->19939
/*19911*/       OPC_Scope, 12, /*->19925*/ // 2 children in Scope
/*19913*/         OPC_CheckPredicate, 24, // Predicate_movshdup
/*19915*/         OPC_CheckPatternPredicate, 9, // (Subtarget->hasSSE3())
/*19917*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVSHDUPrr), 0,
                      1/*#VTs*/, MVT::v4f32, 1/*#Ops*/, 0, 
                  // Src: (vector_shuffle:v4f32 VR128:v4f32:$src, (undef:v4f32))<<P:Predicate_movshdup>>
                  // Dst: (MOVSHDUPrr:v4f32 VR128:v4f32:$src)
/*19925*/       /*Scope*/ 12, /*->19938*/
/*19926*/         OPC_CheckPredicate, 25, // Predicate_movsldup
/*19928*/         OPC_CheckPatternPredicate, 9, // (Subtarget->hasSSE3())
/*19930*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVSLDUPrr), 0,
                      1/*#VTs*/, MVT::v4f32, 1/*#Ops*/, 0, 
                  // Src: (vector_shuffle:v4f32 VR128:v4f32:$src, (undef:v4f32))<<P:Predicate_movsldup>>
                  // Dst: (MOVSLDUPrr:v4f32 VR128:v4f32:$src)
/*19938*/       0, /*End of Scope*/
              /*SwitchType*/ 12,  MVT::v2f64,// ->19953
/*19941*/       OPC_CheckPredicate, 27, // Predicate_movddup
/*19943*/       OPC_CheckPatternPredicate, 9, // (Subtarget->hasSSE3())
/*19945*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVDDUPrr), 0,
                    1/*#VTs*/, MVT::v2f64, 1/*#Ops*/, 0, 
                // Src: (vector_shuffle:v2f64 VR128:v2f64:$src, (undef:v2f64))<<P:Predicate_movddup>>
                // Dst: (MOVDDUPrr:v2f64 VR128:v2f64:$src)
              0, // EndSwitchType
/*19954*/   /*Scope*/ 125, /*->20080*/
/*19955*/     OPC_RecordNode, // #0 = $src3
/*19956*/     OPC_RecordChild0, // #1 = $src1
/*19957*/     OPC_Scope, 80, /*->20039*/ // 2 children in Scope
/*19959*/       OPC_MoveChild, 1,
/*19961*/       OPC_CheckOpcode, ISD::UNDEF,
/*19963*/       OPC_MoveParent,
/*19964*/       OPC_Scope, 53, /*->20019*/ // 2 children in Scope
/*19966*/         OPC_CheckPredicate, 26, // Predicate_pshufd
/*19968*/         OPC_SwitchType /*3 cases */, 13,  MVT::v4f32,// ->19984
/*19971*/           OPC_EmitNodeXForm, 0, 0, // SHUFFLE_get_shuf_imm
/*19974*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::SHUFPSrri), 0,
                        1/*#VTs*/, MVT::v4f32, 3/*#Ops*/, 1, 1, 2, 
                    // Src: (vector_shuffle:v4f32 VR128:v4f32:$src1, (undef:v4f32))<<P:Predicate_pshufd>><<X:SHUFFLE_get_shuf_imm>>:$src3
                    // Dst: (SHUFPSrri:v4f32 VR128:v16i8:$src1, VR128:v16i8:$src1, (SHUFFLE_get_shuf_imm:i8 VR128:i8:$src3))
                  /*SwitchType*/ 15,  MVT::v2i64,// ->20001
/*19986*/           OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*19988*/           OPC_EmitNodeXForm, 0, 0, // SHUFFLE_get_shuf_imm
/*19991*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::SHUFPDrri), 0,
                        1/*#VTs*/, MVT::v2i64, 3/*#Ops*/, 1, 1, 2, 
                    // Src: (vector_shuffle:v2i64 VR128:v2i64:$src1, (undef:v2i64))<<P:Predicate_pshufd>><<X:SHUFFLE_get_shuf_imm>>:$src3
                    // Dst: (SHUFPDrri:v2i64 VR128:v16i8:$src1, VR128:v16i8:$src1, (SHUFFLE_get_shuf_imm:i8 VR128:i8:$src3))
                  /*SwitchType*/ 15,  MVT::v2f64,// ->20018
/*20003*/           OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*20005*/           OPC_EmitNodeXForm, 0, 0, // SHUFFLE_get_shuf_imm
/*20008*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::SHUFPDrri), 0,
                        1/*#VTs*/, MVT::v2f64, 3/*#Ops*/, 1, 1, 2, 
                    // Src: (vector_shuffle:v2f64 VR128:v2f64:$src1, (undef:v2f64))<<P:Predicate_pshufd>><<X:SHUFFLE_get_shuf_imm>>:$src3
                    // Dst: (SHUFPDrri:v2f64 VR128:v16i8:$src1, VR128:v16i8:$src1, (SHUFFLE_get_shuf_imm:i8 VR128:i8:$src3))
                  0, // EndSwitchType
/*20019*/       /*Scope*/ 18, /*->20038*/
/*20020*/         OPC_CheckPredicate, 31, // Predicate_mmx_pshufw
/*20022*/         OPC_CheckType, MVT::v4i16,
/*20024*/         OPC_CheckPatternPredicate, 8, // (Subtarget->hasMMX())
/*20026*/         OPC_EmitNodeXForm, 3, 0, // MMX_SHUFFLE_get_shuf_imm
/*20029*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PSHUFWri), 0,
                      1/*#VTs*/, MVT::v4i16, 2/*#Ops*/, 1, 2, 
                  // Src: (vector_shuffle:v4i16 VR64:v4i16:$src1, (undef:v4i16))<<P:Predicate_mmx_pshufw>><<X:MMX_SHUFFLE_get_shuf_imm>>:$src2
                  // Dst: (MMX_PSHUFWri:v4i16 VR64:v4i16:$src1, (MMX_SHUFFLE_get_shuf_imm:i8 (vector_shuffle:v4i16 VR64:v4i16:$src1, (undef:v4i16)):$src2))
/*20038*/       0, /*End of Scope*/
/*20039*/     /*Scope*/ 39, /*->20079*/
/*20040*/       OPC_RecordChild1, // #2 = $src2
/*20041*/       OPC_CheckPredicate, 32, // Predicate_shufp
/*20043*/       OPC_SwitchType /*2 cases */, 15,  MVT::v4f32,// ->20061
/*20046*/         OPC_CheckPatternPredicate, 0, // (Subtarget->hasSSE1())
/*20048*/         OPC_EmitNodeXForm, 0, 0, // SHUFFLE_get_shuf_imm
/*20051*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::SHUFPSrri), 0,
                      1/*#VTs*/, MVT::v4f32, 3/*#Ops*/, 1, 2, 3, 
                  // Src: (vector_shuffle:v4f32 VR128:v4f32:$src1, VR128:v4f32:$src2)<<P:Predicate_shufp>><<X:SHUFFLE_get_shuf_imm>>:$src3
                  // Dst: (SHUFPSrri:v4f32 VR128:v4f32:$src1, VR128:v4f32:$src2, (SHUFFLE_get_shuf_imm:i8 (vector_shuffle:v4f32 VR128:v4f32:$src1, VR128:v4f32:$src2):$src3))
                /*SwitchType*/ 15,  MVT::v2f64,// ->20078
/*20063*/         OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*20065*/         OPC_EmitNodeXForm, 0, 0, // SHUFFLE_get_shuf_imm
/*20068*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::SHUFPDrri), 0,
                      1/*#VTs*/, MVT::v2f64, 3/*#Ops*/, 1, 2, 3, 
                  // Src: (vector_shuffle:v2f64 VR128:v2f64:$src1, VR128:v2f64:$src2)<<P:Predicate_shufp>><<X:SHUFFLE_get_shuf_imm>>:$src3
                  // Dst: (SHUFPDrri:v2f64 VR128:v2f64:$src1, VR128:v2f64:$src2, (SHUFFLE_get_shuf_imm:i8 (vector_shuffle:v2f64 VR128:v2f64:$src1, VR128:v2f64:$src2):$src3))
                0, // EndSwitchType
/*20079*/     0, /*End of Scope*/
/*20080*/   /*Scope*/ 118, /*->20199*/
/*20081*/     OPC_RecordChild0, // #0 = $src1
/*20082*/     OPC_RecordChild1, // #1 = $src2
/*20083*/     OPC_Scope, 56, /*->20141*/ // 2 children in Scope
/*20085*/       OPC_CheckPredicate, 28, // Predicate_unpckl
/*20087*/       OPC_SwitchType /*4 cases */, 11,  MVT::v16i8,// ->20101
/*20090*/         OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*20092*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::PUNPCKLBWrr), 0,
                      1/*#VTs*/, MVT::v16i8, 2/*#Ops*/, 0, 1, 
                  // Src: (vector_shuffle:v16i8 VR128:v16i8:$src1, VR128:v16i8:$src2)<<P:Predicate_unpckl>>
                  // Dst: (PUNPCKLBWrr:v16i8 VR128:v16i8:$src1, VR128:v16i8:$src2)
                /*SwitchType*/ 11,  MVT::v8i16,// ->20114
/*20103*/         OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*20105*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::PUNPCKLWDrr), 0,
                      1/*#VTs*/, MVT::v8i16, 2/*#Ops*/, 0, 1, 
                  // Src: (vector_shuffle:v8i16 VR128:v8i16:$src1, VR128:v8i16:$src2)<<P:Predicate_unpckl>>
                  // Dst: (PUNPCKLWDrr:v8i16 VR128:v8i16:$src1, VR128:v8i16:$src2)
                /*SwitchType*/ 11,  MVT::v4i32,// ->20127
/*20116*/         OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*20118*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::PUNPCKLDQrr), 0,
                      1/*#VTs*/, MVT::v4i32, 2/*#Ops*/, 0, 1, 
                  // Src: (vector_shuffle:v4i32 VR128:v4i32:$src1, VR128:v4i32:$src2)<<P:Predicate_unpckl>>
                  // Dst: (PUNPCKLDQrr:v4i32 VR128:v4i32:$src1, VR128:v4i32:$src2)
                /*SwitchType*/ 11,  MVT::v2i64,// ->20140
/*20129*/         OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*20131*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::PUNPCKLQDQrr), 0,
                      1/*#VTs*/, MVT::v2i64, 2/*#Ops*/, 0, 1, 
                  // Src: (vector_shuffle:v2i64 VR128:v2i64:$src1, VR128:v2i64:$src2)<<P:Predicate_unpckl>>
                  // Dst: (PUNPCKLQDQrr:v2i64 VR128:v2i64:$src1, VR128:v2i64:$src2)
                0, // EndSwitchType
/*20141*/     /*Scope*/ 56, /*->20198*/
/*20142*/       OPC_CheckPredicate, 14, // Predicate_unpckh
/*20144*/       OPC_SwitchType /*4 cases */, 11,  MVT::v16i8,// ->20158
/*20147*/         OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*20149*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::PUNPCKHBWrr), 0,
                      1/*#VTs*/, MVT::v16i8, 2/*#Ops*/, 0, 1, 
                  // Src: (vector_shuffle:v16i8 VR128:v16i8:$src1, VR128:v16i8:$src2)<<P:Predicate_unpckh>>
                  // Dst: (PUNPCKHBWrr:v16i8 VR128:v16i8:$src1, VR128:v16i8:$src2)
                /*SwitchType*/ 11,  MVT::v8i16,// ->20171
/*20160*/         OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*20162*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::PUNPCKHWDrr), 0,
                      1/*#VTs*/, MVT::v8i16, 2/*#Ops*/, 0, 1, 
                  // Src: (vector_shuffle:v8i16 VR128:v8i16:$src1, VR128:v8i16:$src2)<<P:Predicate_unpckh>>
                  // Dst: (PUNPCKHWDrr:v8i16 VR128:v8i16:$src1, VR128:v8i16:$src2)
                /*SwitchType*/ 11,  MVT::v4i32,// ->20184
/*20173*/         OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*20175*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::PUNPCKHDQrr), 0,
                      1/*#VTs*/, MVT::v4i32, 2/*#Ops*/, 0, 1, 
                  // Src: (vector_shuffle:v4i32 VR128:v4i32:$src1, VR128:v4i32:$src2)<<P:Predicate_unpckh>>
                  // Dst: (PUNPCKHDQrr:v4i32 VR128:v4i32:$src1, VR128:v4i32:$src2)
                /*SwitchType*/ 11,  MVT::v2i64,// ->20197
/*20186*/         OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*20188*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::PUNPCKHQDQrr), 0,
                      1/*#VTs*/, MVT::v2i64, 2/*#Ops*/, 0, 1, 
                  // Src: (vector_shuffle:v2i64 VR128:v2i64:$src1, VR128:v2i64:$src2)<<P:Predicate_unpckh>>
                  // Dst: (PUNPCKHQDQrr:v2i64 VR128:v2i64:$src1, VR128:v2i64:$src2)
                0, // EndSwitchType
/*20198*/     0, /*End of Scope*/
/*20199*/   /*Scope*/ 62, /*->20262*/
/*20200*/     OPC_RecordNode, // #0 = $src3
/*20201*/     OPC_RecordChild0, // #1 = $src1
/*20202*/     OPC_RecordChild1, // #2 = $src2
/*20203*/     OPC_Scope, 38, /*->20243*/ // 2 children in Scope
/*20205*/       OPC_CheckPredicate, 32, // Predicate_shufp
/*20207*/       OPC_SwitchType /*2 cases */, 15,  MVT::v4i32,// ->20225
/*20210*/         OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*20212*/         OPC_EmitNodeXForm, 0, 0, // SHUFFLE_get_shuf_imm
/*20215*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::SHUFPSrri), 0,
                      1/*#VTs*/, MVT::v4i32, 3/*#Ops*/, 1, 2, 3, 
                  // Src: (vector_shuffle:v4i32 VR128:v4i32:$src1, VR128:v4i32:$src2)<<P:Predicate_shufp>><<X:SHUFFLE_get_shuf_imm>>:$src3
                  // Dst: (SHUFPSrri:v4i32 VR128:v16i8:$src1, VR128:v16i8:$src2, (SHUFFLE_get_shuf_imm:i8 VR128:i8:$src3))
                /*SwitchType*/ 15,  MVT::v2i64,// ->20242
/*20227*/         OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*20229*/         OPC_EmitNodeXForm, 0, 0, // SHUFFLE_get_shuf_imm
/*20232*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::SHUFPDrri), 0,
                      1/*#VTs*/, MVT::v2i64, 3/*#Ops*/, 1, 2, 3, 
                  // Src: (vector_shuffle:v2i64 VR128:v2i64:$src1, VR128:v2i64:$src2)<<P:Predicate_shufp>><<X:SHUFFLE_get_shuf_imm>>:$src3
                  // Dst: (SHUFPDrri:v2i64 VR128:v16i8:$src1, VR128:v16i8:$src2, (SHUFFLE_get_shuf_imm:i8 VR128:i8:$src3))
                0, // EndSwitchType
/*20243*/     /*Scope*/ 17, /*->20261*/
/*20244*/       OPC_CheckPredicate, 13, // Predicate_movlp
/*20246*/       OPC_CheckType, MVT::v4f32,
/*20248*/       OPC_EmitNodeXForm, 0, 0, // SHUFFLE_get_shuf_imm
/*20251*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::SHUFPSrri), 0,
                    1/*#VTs*/, MVT::v4f32, 3/*#Ops*/, 2, 1, 3, 
                // Src: (vector_shuffle:v4f32 VR128:v4f32:$src1, VR128:v4f32:$src2)<<P:Predicate_movlp>>:$src3
                // Dst: (SHUFPSrri:v4f32 VR128:v16i8:$src2, VR128:v16i8:$src1, (SHUFFLE_get_shuf_imm:i8 VR128:i8:$src3))
/*20261*/     0, /*End of Scope*/
/*20262*/   /*Scope*/ 92, /*->20355*/
/*20263*/     OPC_RecordChild0, // #0 = $src1
/*20264*/     OPC_RecordChild1, // #1 = $src2
/*20265*/     OPC_Scope, 43, /*->20310*/ // 2 children in Scope
/*20267*/       OPC_CheckPredicate, 33, // Predicate_mmx_unpckh
/*20269*/       OPC_SwitchType /*3 cases */, 11,  MVT::v8i8,// ->20283
/*20272*/         OPC_CheckPatternPredicate, 8, // (Subtarget->hasMMX())
/*20274*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PUNPCKHBWrr), 0,
                      1/*#VTs*/, MVT::v8i8, 2/*#Ops*/, 0, 1, 
                  // Src: (vector_shuffle:v8i8 VR64:v8i8:$src1, VR64:v8i8:$src2)<<P:Predicate_mmx_unpckh>>
                  // Dst: (MMX_PUNPCKHBWrr:v8i8 VR64:v8i8:$src1, VR64:v8i8:$src2)
                /*SwitchType*/ 11,  MVT::v4i16,// ->20296
/*20285*/         OPC_CheckPatternPredicate, 8, // (Subtarget->hasMMX())
/*20287*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PUNPCKHWDrr), 0,
                      1/*#VTs*/, MVT::v4i16, 2/*#Ops*/, 0, 1, 
                  // Src: (vector_shuffle:v4i16 VR64:v4i16:$src1, VR64:v4i16:$src2)<<P:Predicate_mmx_unpckh>>
                  // Dst: (MMX_PUNPCKHWDrr:v4i16 VR64:v4i16:$src1, VR64:v4i16:$src2)
                /*SwitchType*/ 11,  MVT::v2i32,// ->20309
/*20298*/         OPC_CheckPatternPredicate, 8, // (Subtarget->hasMMX())
/*20300*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PUNPCKHDQrr), 0,
                      1/*#VTs*/, MVT::v2i32, 2/*#Ops*/, 0, 1, 
                  // Src: (vector_shuffle:v2i32 VR64:v2i32:$src1, VR64:v2i32:$src2)<<P:Predicate_mmx_unpckh>>
                  // Dst: (MMX_PUNPCKHDQrr:v2i32 VR64:v2i32:$src1, VR64:v2i32:$src2)
                0, // EndSwitchType
/*20310*/     /*Scope*/ 43, /*->20354*/
/*20311*/       OPC_CheckPredicate, 34, // Predicate_mmx_unpckl
/*20313*/       OPC_SwitchType /*3 cases */, 11,  MVT::v8i8,// ->20327
/*20316*/         OPC_CheckPatternPredicate, 8, // (Subtarget->hasMMX())
/*20318*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PUNPCKLBWrr), 0,
                      1/*#VTs*/, MVT::v8i8, 2/*#Ops*/, 0, 1, 
                  // Src: (vector_shuffle:v8i8 VR64:v8i8:$src1, VR64:v8i8:$src2)<<P:Predicate_mmx_unpckl>>
                  // Dst: (MMX_PUNPCKLBWrr:v8i8 VR64:v8i8:$src1, VR64:v8i8:$src2)
                /*SwitchType*/ 11,  MVT::v4i16,// ->20340
/*20329*/         OPC_CheckPatternPredicate, 8, // (Subtarget->hasMMX())
/*20331*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PUNPCKLWDrr), 0,
                      1/*#VTs*/, MVT::v4i16, 2/*#Ops*/, 0, 1, 
                  // Src: (vector_shuffle:v4i16 VR64:v4i16:$src1, VR64:v4i16:$src2)<<P:Predicate_mmx_unpckl>>
                  // Dst: (MMX_PUNPCKLWDrr:v4i16 VR64:v4i16:$src1, VR64:v4i16:$src2)
                /*SwitchType*/ 11,  MVT::v2i32,// ->20353
/*20342*/         OPC_CheckPatternPredicate, 8, // (Subtarget->hasMMX())
/*20344*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PUNPCKLDQrr), 0,
                      1/*#VTs*/, MVT::v2i32, 2/*#Ops*/, 0, 1, 
                  // Src: (vector_shuffle:v2i32 VR64:v2i32:$src1, VR64:v2i32:$src2)<<P:Predicate_mmx_unpckl>>
                  // Dst: (MMX_PUNPCKLDQrr:v2i32 VR64:v2i32:$src1, VR64:v2i32:$src2)
                0, // EndSwitchType
/*20354*/     0, /*End of Scope*/
/*20355*/   0, /*End of Scope*/
          /*SwitchOpcode*/ 83|128,5/*723*/,  X86ISD::VZEXT_MOVL,// ->21082
/*20359*/   OPC_Scope, 101|128,4/*613*/, /*->20975*/ // 2 children in Scope
/*20362*/     OPC_MoveChild, 0,
/*20364*/     OPC_SwitchOpcode /*3 cases */, 30|128,2/*286*/,  ISD::SCALAR_TO_VECTOR,// ->20654
/*20368*/       OPC_Scope, 60|128,1/*188*/, /*->20559*/ // 2 children in Scope
/*20371*/         OPC_MoveChild, 0,
/*20373*/         OPC_CheckOpcode, ISD::LOAD,
/*20375*/         OPC_RecordMemRef,
/*20376*/         OPC_RecordNode, // #0 = 'ld' chained node
/*20377*/         OPC_CheckFoldableChainNode,
/*20378*/         OPC_RecordChild1, // #1 = $src
/*20379*/         OPC_CheckPredicate, 2, // Predicate_unindexedload
/*20381*/         OPC_Scope, 28, /*->20411*/ // 4 children in Scope
/*20383*/           OPC_CheckPredicate, 3, // Predicate_loadi32
/*20385*/           OPC_CheckType, MVT::i32,
/*20387*/           OPC_MoveParent,
/*20388*/           OPC_MoveParent,
/*20389*/           OPC_CheckType, MVT::v4i32,
/*20391*/           OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*20393*/           OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*20396*/           OPC_EmitMergeInputChains, 1, 0, 
/*20399*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVZDI2PDIrm), 0|OPFL_Chain|OPFL_MemRefs,
                        1/*#VTs*/, MVT::v4i32, 5/*#Ops*/, 2, 3, 4, 5, 6, 
                    // Src: (X86vzmovl:v4i32 (scalar_to_vector:v4i32 (ld:i32 addr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>))
                    // Dst: (MOVZDI2PDIrm:v4i32 addr:iPTR:$src)
/*20411*/         /*Scope*/ 30, /*->20442*/
/*20412*/           OPC_CheckPredicate, 8, // Predicate_load
/*20414*/           OPC_CheckPredicate, 9, // Predicate_dsload
/*20416*/           OPC_CheckType, MVT::i64,
/*20418*/           OPC_MoveParent,
/*20419*/           OPC_MoveParent,
/*20420*/           OPC_CheckType, MVT::v2i64,
/*20422*/           OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*20424*/           OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*20427*/           OPC_EmitMergeInputChains, 1, 0, 
/*20430*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVZQI2PQIrm), 0|OPFL_Chain|OPFL_MemRefs,
                        1/*#VTs*/, MVT::v2i64, 5/*#Ops*/, 2, 3, 4, 5, 6, 
                    // Src: (X86vzmovl:v2i64 (scalar_to_vector:v2i64 (ld:i64 addr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>))
                    // Dst: (MOVZQI2PQIrm:v2i64 addr:iPTR:$src)
/*20442*/         /*Scope*/ 28, /*->20471*/
/*20443*/           OPC_CheckPredicate, 3, // Predicate_loadi32
/*20445*/           OPC_CheckType, MVT::i32,
/*20447*/           OPC_MoveParent,
/*20448*/           OPC_MoveParent,
/*20449*/           OPC_CheckType, MVT::v2i32,
/*20451*/           OPC_CheckPatternPredicate, 8, // (Subtarget->hasMMX())
/*20453*/           OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*20456*/           OPC_EmitMergeInputChains, 1, 0, 
/*20459*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_MOVZDI2PDIrm), 0|OPFL_Chain|OPFL_MemRefs,
                        1/*#VTs*/, MVT::v2i32, 5/*#Ops*/, 2, 3, 4, 5, 6, 
                    // Src: (X86vzmovl:v2i32 (scalar_to_vector:v2i32 (ld:i32 addr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>))
                    // Dst: (MMX_MOVZDI2PDIrm:v2i32 addr:iPTR:$src)
/*20471*/         /*Scope*/ 86, /*->20558*/
/*20472*/           OPC_CheckPredicate, 8, // Predicate_load
/*20474*/           OPC_CheckPredicate, 9, // Predicate_dsload
/*20476*/           OPC_SwitchType /*2 cases */, 38,  MVT::f32,// ->20517
/*20479*/             OPC_MoveParent,
/*20480*/             OPC_MoveParent,
/*20481*/             OPC_CheckType, MVT::v4f32,
/*20483*/             OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*20486*/             OPC_EmitMergeInputChains, 1, 0, 
/*20489*/             OPC_EmitInteger, MVT::i32, 0, 
/*20492*/             OPC_EmitNode, TARGET_OPCODE(X86::MOVSSrm), 0|OPFL_Chain,
                          1/*#VTs*/, MVT::f32, 5/*#Ops*/, 2, 3, 4, 5, 6,  // Results = #8 
/*20504*/             OPC_EmitInteger, MVT::i32, 1, 
/*20507*/             OPC_MorphNodeTo, TARGET_OPCODE(TargetOpcode::SUBREG_TO_REG), 0|OPFL_Chain|OPFL_MemRefs,
                          1/*#VTs*/, MVT::v4f32, 3/*#Ops*/, 7, 8, 9, 
                      // Src: (X86vzmovl:v4f32 (scalar_to_vector:v4f32 (ld:f32 addr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>))
                      // Dst: (SUBREG_TO_REG:v4f32 0:i32, (MOVSSrm:f32 addr:iPTR:$src), 1:i32)
                    /*SwitchType*/ 38,  MVT::f64,// ->20557
/*20519*/             OPC_MoveParent,
/*20520*/             OPC_MoveParent,
/*20521*/             OPC_CheckType, MVT::v2f64,
/*20523*/             OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*20526*/             OPC_EmitMergeInputChains, 1, 0, 
/*20529*/             OPC_EmitInteger, MVT::i64, 0, 
/*20532*/             OPC_EmitNode, TARGET_OPCODE(X86::MOVSDrm), 0|OPFL_Chain,
                          1/*#VTs*/, MVT::f64, 5/*#Ops*/, 2, 3, 4, 5, 6,  // Results = #8 
/*20544*/             OPC_EmitInteger, MVT::i32, 2, 
/*20547*/             OPC_MorphNodeTo, TARGET_OPCODE(TargetOpcode::SUBREG_TO_REG), 0|OPFL_Chain|OPFL_MemRefs,
                          1/*#VTs*/, MVT::v2f64, 3/*#Ops*/, 7, 8, 9, 
                      // Src: (X86vzmovl:v2f64 (scalar_to_vector:v2f64 (ld:f64 addr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>))
                      // Dst: (SUBREG_TO_REG:v2f64 0:i64, (MOVSDrm:f64 addr:iPTR:$src), 2:i32)
                    0, // EndSwitchType
/*20558*/         0, /*End of Scope*/
/*20559*/       /*Scope*/ 93, /*->20653*/
/*20560*/         OPC_RecordChild0, // #0 = $src
/*20561*/         OPC_Scope, 29, /*->20592*/ // 4 children in Scope
/*20563*/           OPC_CheckChild0Type, MVT::i32,
/*20565*/           OPC_MoveParent,
/*20566*/           OPC_SwitchType /*2 cases */, 10,  MVT::v4i32,// ->20579
/*20569*/             OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*20571*/             OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVZDI2PDIrr), 0,
                          1/*#VTs*/, MVT::v4i32, 1/*#Ops*/, 0, 
                      // Src: (X86vzmovl:v4i32 (scalar_to_vector:v4i32 GR32:i32:$src))
                      // Dst: (MOVZDI2PDIrr:v4i32 GR32:i32:$src)
                    /*SwitchType*/ 10,  MVT::v2i32,// ->20591
/*20581*/             OPC_CheckPatternPredicate, 8, // (Subtarget->hasMMX())
/*20583*/             OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_MOVZDI2PDIrr), 0,
                          1/*#VTs*/, MVT::v2i32, 1/*#Ops*/, 0, 
                      // Src: (X86vzmovl:v2i32 (scalar_to_vector:v2i32 GR32:i32:$src))
                      // Dst: (MMX_MOVZDI2PDIrr:v2i32 GR32:i32:$src)
                    0, // EndSwitchType
/*20592*/         /*Scope*/ 15, /*->20608*/
/*20593*/           OPC_CheckChild0Type, MVT::i64,
/*20595*/           OPC_MoveParent,
/*20596*/           OPC_CheckType, MVT::v2i64,
/*20598*/           OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*20600*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVZQI2PQIrr), 0,
                        1/*#VTs*/, MVT::v2i64, 1/*#Ops*/, 0, 
                    // Src: (X86vzmovl:v2i64 (scalar_to_vector:v2i64 GR64:i64:$src))
                    // Dst: (MOVZQI2PQIrr:v2i64 GR64:i64:$src)
/*20608*/         /*Scope*/ 21, /*->20630*/
/*20609*/           OPC_CheckChild0Type, MVT::f64,
/*20611*/           OPC_MoveParent,
/*20612*/           OPC_CheckType, MVT::v2f64,
/*20614*/           OPC_EmitNode, TARGET_OPCODE(X86::V_SET0), 0,
                        1/*#VTs*/, MVT::v2f64, 0/*#Ops*/,  // Results = #1 
/*20621*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVSDrr), 0,
                        1/*#VTs*/, MVT::v2f64, 2/*#Ops*/, 1, 0, 
                    // Src: (X86vzmovl:v2f64 (scalar_to_vector:v2f64 FR64:f64:$src))
                    // Dst: (MOVSDrr:v2f64 (V_SET0:v2f64), FR64:f64:$src)
/*20630*/         /*Scope*/ 21, /*->20652*/
/*20631*/           OPC_CheckChild0Type, MVT::f32,
/*20633*/           OPC_MoveParent,
/*20634*/           OPC_CheckType, MVT::v4f32,
/*20636*/           OPC_EmitNode, TARGET_OPCODE(X86::V_SET0), 0,
                        1/*#VTs*/, MVT::v4f32, 0/*#Ops*/,  // Results = #1 
/*20643*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVSSrr), 0,
                        1/*#VTs*/, MVT::v4f32, 2/*#Ops*/, 1, 0, 
                    // Src: (X86vzmovl:v4f32 (scalar_to_vector:v4f32 FR32:f32:$src))
                    // Dst: (MOVSSrr:v4f32 (V_SET0:v4f32), FR32:f32:$src)
/*20652*/         0, /*End of Scope*/
/*20653*/       0, /*End of Scope*/
              /*SwitchOpcode*/ 40|128,1/*168*/,  ISD::BIT_CONVERT,// ->20825
/*20657*/       OPC_MoveChild, 0,
/*20659*/       OPC_CheckOpcode, ISD::LOAD,
/*20661*/       OPC_RecordMemRef,
/*20662*/       OPC_RecordNode, // #0 = 'ld' chained node
/*20663*/       OPC_CheckFoldableChainNode,
/*20664*/       OPC_RecordChild1, // #1 = $src
/*20665*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*20667*/       OPC_CheckPredicate, 8, // Predicate_load
/*20669*/       OPC_SwitchType /*4 cases */, 80,  MVT::v4f32,// ->20752
/*20672*/         OPC_MoveParent,
/*20673*/         OPC_MoveParent,
/*20674*/         OPC_SwitchType /*3 cases */, 18,  MVT::v4i32,// ->20695
/*20677*/           OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*20680*/           OPC_EmitMergeInputChains, 1, 0, 
/*20683*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVZDI2PDIrm), 0|OPFL_Chain|OPFL_MemRefs,
                        1/*#VTs*/, MVT::v4i32, 5/*#Ops*/, 2, 3, 4, 5, 6, 
                    // Src: (X86vzmovl:v4i32 (bitconvert:v4i32 (ld:v4f32 addr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>))
                    // Dst: (MOVZDI2PDIrm:v4i32 addr:iPTR:$src)
                  /*SwitchType*/ 18,  MVT::v2i64,// ->20715
/*20697*/           OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*20700*/           OPC_EmitMergeInputChains, 1, 0, 
/*20703*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVZQI2PQIrm), 0|OPFL_Chain|OPFL_MemRefs,
                        1/*#VTs*/, MVT::v2i64, 5/*#Ops*/, 2, 3, 4, 5, 6, 
                    // Src: (X86vzmovl:v2i64 (bitconvert:v2i64 (ld:v4f32 addr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>))
                    // Dst: (MOVZQI2PQIrm:v2i64 addr:iPTR:$src)
                  /*SwitchType*/ 34,  MVT::v2f64,// ->20751
/*20717*/           OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*20720*/           OPC_EmitMergeInputChains, 1, 0, 
/*20723*/           OPC_EmitInteger, MVT::i64, 0, 
/*20726*/           OPC_EmitNode, TARGET_OPCODE(X86::MOVSDrm), 0|OPFL_Chain,
                        1/*#VTs*/, MVT::f64, 5/*#Ops*/, 2, 3, 4, 5, 6,  // Results = #8 
/*20738*/           OPC_EmitInteger, MVT::i32, 2, 
/*20741*/           OPC_MorphNodeTo, TARGET_OPCODE(TargetOpcode::SUBREG_TO_REG), 0|OPFL_Chain|OPFL_MemRefs,
                        1/*#VTs*/, MVT::v2f64, 3/*#Ops*/, 7, 8, 9, 
                    // Src: (X86vzmovl:v2f64 (bitconvert:v2f64 (ld:v4f32 addr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>))
                    // Dst: (SUBREG_TO_REG:v2f64 0:i64, (MOVSDrm:f64 addr:iPTR:$src), 2:i32)
                  0, // EndSwitchType
                /*SwitchType*/ 22,  MVT::v2i64,// ->20776
/*20754*/         OPC_MoveParent,
/*20755*/         OPC_MoveParent,
/*20756*/         OPC_CheckType, MVT::v4i32,
/*20758*/         OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*20761*/         OPC_EmitMergeInputChains, 1, 0, 
/*20764*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVZDI2PDIrm), 0|OPFL_Chain|OPFL_MemRefs,
                      1/*#VTs*/, MVT::v4i32, 5/*#Ops*/, 2, 3, 4, 5, 6, 
                  // Src: (X86vzmovl:v4i32 (bitconvert:v4i32 (ld:v2i64 addr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>))
                  // Dst: (MOVZDI2PDIrm:v4i32 addr:iPTR:$src)
                /*SwitchType*/ 22,  MVT::v4i32,// ->20800
/*20778*/         OPC_MoveParent,
/*20779*/         OPC_MoveParent,
/*20780*/         OPC_CheckType, MVT::v2i64,
/*20782*/         OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*20785*/         OPC_EmitMergeInputChains, 1, 0, 
/*20788*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVZPQILo2PQIrm), 0|OPFL_Chain|OPFL_MemRefs,
                      1/*#VTs*/, MVT::v2i64, 5/*#Ops*/, 2, 3, 4, 5, 6, 
                  // Src: (X86vzmovl:v2i64 (bitconvert:v2i64 (ld:v4i32 addr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>))
                  // Dst: (MOVZPQILo2PQIrm:v2i64 addr:iPTR:$src)
                /*SwitchType*/ 22,  MVT::v1i64,// ->20824
/*20802*/         OPC_MoveParent,
/*20803*/         OPC_MoveParent,
/*20804*/         OPC_CheckType, MVT::v2i32,
/*20806*/         OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*20809*/         OPC_EmitMergeInputChains, 1, 0, 
/*20812*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_MOVZDI2PDIrm), 0|OPFL_Chain|OPFL_MemRefs,
                      1/*#VTs*/, MVT::v2i32, 5/*#Ops*/, 2, 3, 4, 5, 6, 
                  // Src: (X86vzmovl:v2i32 (bitconvert:v2i32 (ld:v1i64 addr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>))
                  // Dst: (MMX_MOVZDI2PDIrm:v2i32 addr:iPTR:$src)
                0, // EndSwitchType
              /*SwitchOpcode*/ 18|128,1/*146*/,  ISD::LOAD,// ->20974
/*20828*/       OPC_RecordMemRef,
/*20829*/       OPC_RecordNode, // #0 = 'ld' chained node
/*20830*/       OPC_RecordChild1, // #1 = $src
/*20831*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*20833*/       OPC_CheckPredicate, 8, // Predicate_load
/*20835*/       OPC_MoveParent,
/*20836*/       OPC_SwitchType /*4 cases */, 18,  MVT::v4i32,// ->20857
/*20839*/         OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*20842*/         OPC_EmitMergeInputChains, 1, 0, 
/*20845*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVZDI2PDIrm), 0|OPFL_Chain|OPFL_MemRefs,
                      1/*#VTs*/, MVT::v4i32, 5/*#Ops*/, 2, 3, 4, 5, 6, 
                  // Src: (X86vzmovl:v4i32 (ld:v4i32 addr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)
                  // Dst: (MOVZDI2PDIrm:v4i32 addr:iPTR:$src)
                /*SwitchType*/ 42,  MVT::v2i64,// ->20901
/*20859*/         OPC_Scope, 18, /*->20879*/ // 2 children in Scope
/*20861*/           OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*20864*/           OPC_EmitMergeInputChains, 1, 0, 
/*20867*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVZQI2PQIrm), 0|OPFL_Chain|OPFL_MemRefs,
                        1/*#VTs*/, MVT::v2i64, 5/*#Ops*/, 2, 3, 4, 5, 6, 
                    // Src: (X86vzmovl:v2i64 (ld:v2i64 addr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)
                    // Dst: (MOVZQI2PQIrm:v2i64 addr:iPTR:$src)
/*20879*/         /*Scope*/ 20, /*->20900*/
/*20880*/           OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*20882*/           OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*20885*/           OPC_EmitMergeInputChains, 1, 0, 
/*20888*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVZPQILo2PQIrm), 0|OPFL_Chain|OPFL_MemRefs,
                        1/*#VTs*/, MVT::v2i64, 5/*#Ops*/, 2, 3, 4, 5, 6, 
                    // Src: (X86vzmovl:v2i64 (ld:v2i64 addr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)
                    // Dst: (MOVZPQILo2PQIrm:v2i64 addr:iPTR:$src)
/*20900*/         0, /*End of Scope*/
                /*SwitchType*/ 34,  MVT::v4f32,// ->20937
/*20903*/         OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*20906*/         OPC_EmitMergeInputChains, 1, 0, 
/*20909*/         OPC_EmitInteger, MVT::i32, 0, 
/*20912*/         OPC_EmitNode, TARGET_OPCODE(X86::MOVSSrm), 0|OPFL_Chain,
                      1/*#VTs*/, MVT::f32, 5/*#Ops*/, 2, 3, 4, 5, 6,  // Results = #8 
/*20924*/         OPC_EmitInteger, MVT::i32, 1, 
/*20927*/         OPC_MorphNodeTo, TARGET_OPCODE(TargetOpcode::SUBREG_TO_REG), 0|OPFL_Chain|OPFL_MemRefs,
                      1/*#VTs*/, MVT::v4f32, 3/*#Ops*/, 7, 8, 9, 
                  // Src: (X86vzmovl:v4f32 (ld:v4f32 addr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)
                  // Dst: (SUBREG_TO_REG:v4f32 0:i32, (MOVSSrm:f32 addr:iPTR:$src), 1:i32)
                /*SwitchType*/ 34,  MVT::v2f64,// ->20973
/*20939*/         OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*20942*/         OPC_EmitMergeInputChains, 1, 0, 
/*20945*/         OPC_EmitInteger, MVT::i64, 0, 
/*20948*/         OPC_EmitNode, TARGET_OPCODE(X86::MOVSDrm), 0|OPFL_Chain,
                      1/*#VTs*/, MVT::f64, 5/*#Ops*/, 2, 3, 4, 5, 6,  // Results = #8 
/*20960*/         OPC_EmitInteger, MVT::i32, 2, 
/*20963*/         OPC_MorphNodeTo, TARGET_OPCODE(TargetOpcode::SUBREG_TO_REG), 0|OPFL_Chain|OPFL_MemRefs,
                      1/*#VTs*/, MVT::v2f64, 3/*#Ops*/, 7, 8, 9, 
                  // Src: (X86vzmovl:v2f64 (ld:v2f64 addr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)
                  // Dst: (SUBREG_TO_REG:v2f64 0:i64, (MOVSDrm:f64 addr:iPTR:$src), 2:i32)
                0, // EndSwitchType
              0, // EndSwitchOpcode
/*20975*/   /*Scope*/ 105, /*->21081*/
/*20976*/     OPC_RecordChild0, // #0 = $src
/*20977*/     OPC_SwitchType /*5 cases */, 10,  MVT::v2i64,// ->20990
/*20980*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*20982*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVZPQILo2PQIrr), 0,
                    1/*#VTs*/, MVT::v2i64, 1/*#Ops*/, 0, 
                // Src: (X86vzmovl:v2i64 VR128:v2i64:$src)
                // Dst: (MOVZPQILo2PQIrr:v2i64 VR128:v2i64:$src)
              /*SwitchType*/ 16,  MVT::v2i32,// ->21008
/*20992*/       OPC_EmitNode, TARGET_OPCODE(X86::MMX_V_SET0), 0,
                    1/*#VTs*/, MVT::v8i8, 0/*#Ops*/,  // Results = #1 
/*20999*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PUNPCKLDQrr), 0,
                    1/*#VTs*/, MVT::v2i32, 2/*#Ops*/, 0, 1, 
                // Src: (X86vzmovl:v2i32 VR64:v2i32:$src)
                // Dst: (MMX_PUNPCKLDQrr:v2i32 VR64:v8i8:$src, (MMX_V_SET0:v8i8))
              /*SwitchType*/ 28,  MVT::v4f32,// ->21038
/*21010*/       OPC_EmitNode, TARGET_OPCODE(X86::V_SET0), 0,
                    1/*#VTs*/, MVT::v4f32, 0/*#Ops*/,  // Results = #1 
/*21017*/       OPC_EmitInteger, MVT::i32, 1, 
/*21020*/       OPC_EmitNode, TARGET_OPCODE(TargetOpcode::EXTRACT_SUBREG), 0,
                    1/*#VTs*/, MVT::f32, 2/*#Ops*/, 0, 2,  // Results = #3 
/*21029*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVSSrr), 0,
                    1/*#VTs*/, MVT::v4f32, 2/*#Ops*/, 1, 3, 
                // Src: (X86vzmovl:v4f32 VR128:v4f32:$src)
                // Dst: (MOVSSrr:v4f32 (V_SET0:v4f32), (EXTRACT_SUBREG:f32 VR128:v4f32:$src, 1:i32))
              /*SwitchType*/ 28,  MVT::v4i32,// ->21068
/*21040*/       OPC_EmitNode, TARGET_OPCODE(X86::V_SET0), 0,
                    1/*#VTs*/, MVT::v4i32, 0/*#Ops*/,  // Results = #1 
/*21047*/       OPC_EmitInteger, MVT::i32, 1, 
/*21050*/       OPC_EmitNode, TARGET_OPCODE(TargetOpcode::EXTRACT_SUBREG), 0,
                    1/*#VTs*/, MVT::f32, 2/*#Ops*/, 0, 2,  // Results = #3 
/*21059*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVSSrr), 0,
                    1/*#VTs*/, MVT::v4i32, 2/*#Ops*/, 1, 3, 
                // Src: (X86vzmovl:v4i32 VR128:v4i32:$src)
                // Dst: (MOVSSrr:v4i32 (V_SET0:v4i32), (EXTRACT_SUBREG:f32 VR128:v4i32:$src, 1:i32))
              /*SwitchType*/ 10,  MVT::v2f64,// ->21080
/*21070*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*21072*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVZPQILo2PQIrr), 0,
                    1/*#VTs*/, MVT::v2f64, 1/*#Ops*/, 0, 
                // Src: (X86vzmovl:v2f64 VR128:v2f64:$src)
                // Dst: (MOVZPQILo2PQIrr:v2f64 VR128:v16i8:$src)
              0, // EndSwitchType
/*21081*/   0, /*End of Scope*/
          /*SwitchOpcode*/ 108|128,2/*364*/,  ISD::SCALAR_TO_VECTOR,// ->21449
/*21085*/   OPC_Scope, 120|128,1/*248*/, /*->21336*/ // 2 children in Scope
/*21088*/     OPC_MoveChild, 0,
/*21090*/     OPC_SwitchOpcode /*2 cases */, 50|128,1/*178*/,  ISD::LOAD,// ->21272
/*21094*/       OPC_RecordMemRef,
/*21095*/       OPC_RecordNode, // #0 = 'ld' chained node
/*21096*/       OPC_RecordChild1, // #1 = $src
/*21097*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*21099*/       OPC_Scope, 84, /*->21185*/ // 4 children in Scope
/*21101*/         OPC_CheckPredicate, 8, // Predicate_load
/*21103*/         OPC_CheckPredicate, 9, // Predicate_dsload
/*21105*/         OPC_SwitchType /*2 cases */, 37,  MVT::f32,// ->21145
/*21108*/           OPC_MoveParent,
/*21109*/           OPC_CheckType, MVT::v4f32,
/*21111*/           OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*21114*/           OPC_EmitMergeInputChains, 1, 0, 
/*21117*/           OPC_EmitInteger, MVT::i32, 0, 
/*21120*/           OPC_EmitNode, TARGET_OPCODE(X86::MOVSSrm), 0|OPFL_Chain,
                        1/*#VTs*/, MVT::f32, 5/*#Ops*/, 2, 3, 4, 5, 6,  // Results = #8 
/*21132*/           OPC_EmitInteger, MVT::i32, 1, 
/*21135*/           OPC_MorphNodeTo, TARGET_OPCODE(TargetOpcode::SUBREG_TO_REG), 0|OPFL_Chain|OPFL_MemRefs,
                        1/*#VTs*/, MVT::v4f32, 3/*#Ops*/, 7, 8, 9, 
                    // Src: (scalar_to_vector:v4f32 (ld:f32 addr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>)
                    // Dst: (SUBREG_TO_REG:v4f32 0:i32, (MOVSSrm:f32 addr:iPTR:$src), 1:i32)
                  /*SwitchType*/ 37,  MVT::f64,// ->21184
/*21147*/           OPC_MoveParent,
/*21148*/           OPC_CheckType, MVT::v2f64,
/*21150*/           OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*21153*/           OPC_EmitMergeInputChains, 1, 0, 
/*21156*/           OPC_EmitInteger, MVT::i64, 0, 
/*21159*/           OPC_EmitNode, TARGET_OPCODE(X86::MOVSDrm), 0|OPFL_Chain,
                        1/*#VTs*/, MVT::f64, 5/*#Ops*/, 2, 3, 4, 5, 6,  // Results = #8 
/*21171*/           OPC_EmitInteger, MVT::i32, 2, 
/*21174*/           OPC_MorphNodeTo, TARGET_OPCODE(TargetOpcode::SUBREG_TO_REG), 0|OPFL_Chain|OPFL_MemRefs,
                        1/*#VTs*/, MVT::v2f64, 3/*#Ops*/, 7, 8, 9, 
                    // Src: (scalar_to_vector:v2f64 (ld:f64 addr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>)
                    // Dst: (SUBREG_TO_REG:v2f64 0:i64, (MOVSDrm:f64 addr:iPTR:$src), 2:i32)
                  0, // EndSwitchType
/*21185*/       /*Scope*/ 27, /*->21213*/
/*21186*/         OPC_CheckPredicate, 3, // Predicate_loadi32
/*21188*/         OPC_CheckType, MVT::i32,
/*21190*/         OPC_MoveParent,
/*21191*/         OPC_CheckType, MVT::v4i32,
/*21193*/         OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*21195*/         OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*21198*/         OPC_EmitMergeInputChains, 1, 0, 
/*21201*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVDI2PDIrm), 0|OPFL_Chain|OPFL_MemRefs,
                      1/*#VTs*/, MVT::v4i32, 5/*#Ops*/, 2, 3, 4, 5, 6, 
                  // Src: (scalar_to_vector:v4i32 (ld:i32 addr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)
                  // Dst: (MOVDI2PDIrm:v4i32 addr:iPTR:$src)
/*21213*/       /*Scope*/ 29, /*->21243*/
/*21214*/         OPC_CheckPredicate, 8, // Predicate_load
/*21216*/         OPC_CheckPredicate, 9, // Predicate_dsload
/*21218*/         OPC_CheckType, MVT::i64,
/*21220*/         OPC_MoveParent,
/*21221*/         OPC_CheckType, MVT::v2i64,
/*21223*/         OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*21225*/         OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*21228*/         OPC_EmitMergeInputChains, 1, 0, 
/*21231*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVQI2PQIrm), 0|OPFL_Chain|OPFL_MemRefs,
                      1/*#VTs*/, MVT::v2i64, 5/*#Ops*/, 2, 3, 4, 5, 6, 
                  // Src: (scalar_to_vector:v2i64 (ld:i64 addr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>)
                  // Dst: (MOVQI2PQIrm:v2i64 addr:iPTR:$src)
/*21243*/       /*Scope*/ 27, /*->21271*/
/*21244*/         OPC_CheckPredicate, 3, // Predicate_loadi32
/*21246*/         OPC_CheckType, MVT::i32,
/*21248*/         OPC_MoveParent,
/*21249*/         OPC_CheckType, MVT::v2i32,
/*21251*/         OPC_CheckPatternPredicate, 8, // (Subtarget->hasMMX())
/*21253*/         OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*21256*/         OPC_EmitMergeInputChains, 1, 0, 
/*21259*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_MOVD64rm), 0|OPFL_Chain|OPFL_MemRefs,
                      1/*#VTs*/, MVT::v2i32, 5/*#Ops*/, 2, 3, 4, 5, 6, 
                  // Src: (scalar_to_vector:v2i32 (ld:i32 addr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)
                  // Dst: (MMX_MOVD64rm:v2i32 addr:iPTR:$src)
/*21271*/       0, /*End of Scope*/
              /*SwitchOpcode*/ 61,  ISD::BIT_CONVERT,// ->21335
/*21274*/       OPC_RecordChild0, // #0 = $src
/*21275*/       OPC_CheckType, MVT::i64,
/*21277*/       OPC_Scope, 13, /*->21292*/ // 4 children in Scope
/*21279*/         OPC_CheckChild0Type, MVT::v8i8,
/*21281*/         OPC_MoveParent,
/*21282*/         OPC_CheckType, MVT::v2i64,
/*21284*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_MOVQ2DQrr), 0,
                      1/*#VTs*/, MVT::v2i64, 1/*#Ops*/, 0, 
                  // Src: (scalar_to_vector:v2i64 (bitconvert:i64 VR64:v8i8:$src))
                  // Dst: (MMX_MOVQ2DQrr:v2i64 VR64:v8i8:$src)
/*21292*/       /*Scope*/ 13, /*->21306*/
/*21293*/         OPC_CheckChild0Type, MVT::v4i16,
/*21295*/         OPC_MoveParent,
/*21296*/         OPC_CheckType, MVT::v2i64,
/*21298*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_MOVQ2DQrr), 0,
                      1/*#VTs*/, MVT::v2i64, 1/*#Ops*/, 0, 
                  // Src: (scalar_to_vector:v2i64 (bitconvert:i64 VR64:v4i16:$src))
                  // Dst: (MMX_MOVQ2DQrr:v2i64 VR64:v8i8:$src)
/*21306*/       /*Scope*/ 13, /*->21320*/
/*21307*/         OPC_CheckChild0Type, MVT::v2i32,
/*21309*/         OPC_MoveParent,
/*21310*/         OPC_CheckType, MVT::v2i64,
/*21312*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_MOVQ2DQrr), 0,
                      1/*#VTs*/, MVT::v2i64, 1/*#Ops*/, 0, 
                  // Src: (scalar_to_vector:v2i64 (bitconvert:i64 VR64:v2i32:$src))
                  // Dst: (MMX_MOVQ2DQrr:v2i64 VR64:v8i8:$src)
/*21320*/       /*Scope*/ 13, /*->21334*/
/*21321*/         OPC_CheckChild0Type, MVT::v1i64,
/*21323*/         OPC_MoveParent,
/*21324*/         OPC_CheckType, MVT::v2i64,
/*21326*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_MOVQ2DQrr), 0,
                      1/*#VTs*/, MVT::v2i64, 1/*#Ops*/, 0, 
                  // Src: (scalar_to_vector:v2i64 (bitconvert:i64 VR64:v1i64:$src))
                  // Dst: (MMX_MOVQ2DQrr:v2i64 VR64:v8i8:$src)
/*21334*/       0, /*End of Scope*/
              0, // EndSwitchOpcode
/*21336*/   /*Scope*/ 111, /*->21448*/
/*21337*/     OPC_RecordChild0, // #0 = $src
/*21338*/     OPC_Scope, 28, /*->21368*/ // 4 children in Scope
/*21340*/       OPC_CheckChild0Type, MVT::i64,
/*21342*/       OPC_SwitchType /*2 cases */, 10,  MVT::v2i64,// ->21355
/*21345*/         OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*21347*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::MOV64toPQIrr), 0,
                      1/*#VTs*/, MVT::v2i64, 1/*#Ops*/, 0, 
                  // Src: (scalar_to_vector:v2i64 GR64:i64:$src)
                  // Dst: (MOV64toPQIrr:v2i64 GR64:i64:$src)
                /*SwitchType*/ 10,  MVT::v1i64,// ->21367
/*21357*/         OPC_CheckPatternPredicate, 8, // (Subtarget->hasMMX())
/*21359*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_MOVD64rrv164), 0,
                      1/*#VTs*/, MVT::v1i64, 1/*#Ops*/, 0, 
                  // Src: (scalar_to_vector:v1i64 GR64:i64:$src)
                  // Dst: (MMX_MOVD64rrv164:v1i64 GR64:i64:$src)
                0, // EndSwitchType
/*21368*/     /*Scope*/ 28, /*->21397*/
/*21369*/       OPC_CheckChild0Type, MVT::i32,
/*21371*/       OPC_SwitchType /*2 cases */, 10,  MVT::v4i32,// ->21384
/*21374*/         OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*21376*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVDI2PDIrr), 0,
                      1/*#VTs*/, MVT::v4i32, 1/*#Ops*/, 0, 
                  // Src: (scalar_to_vector:v4i32 GR32:i32:$src)
                  // Dst: (MOVDI2PDIrr:v4i32 GR32:i32:$src)
                /*SwitchType*/ 10,  MVT::v2i32,// ->21396
/*21386*/         OPC_CheckPatternPredicate, 8, // (Subtarget->hasMMX())
/*21388*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_MOVD64rr), 0,
                      1/*#VTs*/, MVT::v2i32, 1/*#Ops*/, 0, 
                  // Src: (scalar_to_vector:v2i32 GR32:i32:$src)
                  // Dst: (MMX_MOVD64rr:v2i32 GR32:i32:$src)
                0, // EndSwitchType
/*21397*/     /*Scope*/ 24, /*->21422*/
/*21398*/       OPC_CheckChild0Type, MVT::f32,
/*21400*/       OPC_CheckType, MVT::v4f32,
/*21402*/       OPC_EmitNode, TARGET_OPCODE(TargetOpcode::IMPLICIT_DEF), 0,
                    1/*#VTs*/, MVT::v4f32, 0/*#Ops*/,  // Results = #1 
/*21409*/       OPC_EmitInteger, MVT::i32, 1, 
/*21412*/       OPC_MorphNodeTo, TARGET_OPCODE(TargetOpcode::INSERT_SUBREG), 0,
                    1/*#VTs*/, MVT::v4f32, 3/*#Ops*/, 1, 0, 2, 
                // Src: (scalar_to_vector:v4f32 FR32:f32:$src)
                // Dst: (INSERT_SUBREG:v4f32 (IMPLICIT_DEF:v4f32), FR32:f32:$src, 1:i32)
/*21422*/     /*Scope*/ 24, /*->21447*/
/*21423*/       OPC_CheckChild0Type, MVT::f64,
/*21425*/       OPC_CheckType, MVT::v2f64,
/*21427*/       OPC_EmitNode, TARGET_OPCODE(TargetOpcode::IMPLICIT_DEF), 0,
                    1/*#VTs*/, MVT::v2f64, 0/*#Ops*/,  // Results = #1 
/*21434*/       OPC_EmitInteger, MVT::i32, 2, 
/*21437*/       OPC_MorphNodeTo, TARGET_OPCODE(TargetOpcode::INSERT_SUBREG), 0,
                    1/*#VTs*/, MVT::v2f64, 3/*#Ops*/, 1, 0, 2, 
                // Src: (scalar_to_vector:v2f64 FR64:f64:$src)
                // Dst: (INSERT_SUBREG:v2f64 (IMPLICIT_DEF:v2f64), FR64:f64:$src, 2:i32)
/*21447*/     0, /*End of Scope*/
/*21448*/   0, /*End of Scope*/
          /*SwitchOpcode*/ 90|128,11/*1498*/,  ISD::LOAD,// ->22950
/*21452*/   OPC_RecordMemRef,
/*21453*/   OPC_RecordNode,   // #0 = 'ld' chained node
/*21454*/   OPC_RecordChild1, // #1 = $src
/*21455*/   OPC_CheckPredicate, 2, // Predicate_unindexedload
/*21457*/   OPC_Scope, 62|128,1/*190*/, /*->21650*/ // 22 children in Scope
/*21460*/     OPC_CheckPredicate, 8, // Predicate_load
/*21462*/     OPC_Scope, 24, /*->21488*/ // 6 children in Scope
/*21464*/       OPC_CheckPredicate, 9, // Predicate_dsload
/*21466*/       OPC_CheckType, MVT::f64,
/*21468*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*21470*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*21473*/       OPC_EmitMergeInputChains, 1, 0, 
/*21476*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVSDrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::f64, 5/*#Ops*/, 2, 3, 4, 5, 6, 
                // Src: (ld:f64 addr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>
                // Dst: (MOVSDrm:f64 addr:iPTR:$src)
/*21488*/     /*Scope*/ 22, /*->21511*/
/*21489*/       OPC_CheckPredicate, 46, // Predicate_gsload
/*21491*/       OPC_CheckType, MVT::i32,
/*21493*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*21496*/       OPC_EmitMergeInputChains, 1, 0, 
/*21499*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::GS_MOV32rm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::i32, 5/*#Ops*/, 2, 3, 4, 5, 6, 
                // Src: (ld:i32 addr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_gsload>>
                // Dst: (GS_MOV32rm:i32 addr:iPTR:$src)
/*21511*/     /*Scope*/ 22, /*->21534*/
/*21512*/       OPC_CheckPredicate, 47, // Predicate_fsload
/*21514*/       OPC_CheckType, MVT::i32,
/*21516*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*21519*/       OPC_EmitMergeInputChains, 1, 0, 
/*21522*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::FS_MOV32rm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::i32, 5/*#Ops*/, 2, 3, 4, 5, 6, 
                // Src: (ld:i32 addr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_fsload>>
                // Dst: (FS_MOV32rm:i32 addr:iPTR:$src)
/*21534*/     /*Scope*/ 22, /*->21557*/
/*21535*/       OPC_CheckPredicate, 46, // Predicate_gsload
/*21537*/       OPC_CheckType, MVT::i64,
/*21539*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*21542*/       OPC_EmitMergeInputChains, 1, 0, 
/*21545*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MOV64GSrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::i64, 5/*#Ops*/, 2, 3, 4, 5, 6, 
                // Src: (ld:i64 addr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_gsload>>
                // Dst: (MOV64GSrm:i64 addr:iPTR:$src)
/*21557*/     /*Scope*/ 22, /*->21580*/
/*21558*/       OPC_CheckPredicate, 47, // Predicate_fsload
/*21560*/       OPC_CheckType, MVT::i64,
/*21562*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*21565*/       OPC_EmitMergeInputChains, 1, 0, 
/*21568*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MOV64FSrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::i64, 5/*#Ops*/, 2, 3, 4, 5, 6, 
                // Src: (ld:i64 addr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_fsload>>
                // Dst: (MOV64FSrm:i64 addr:iPTR:$src)
/*21580*/     /*Scope*/ 68, /*->21649*/
/*21581*/       OPC_CheckPredicate, 9, // Predicate_dsload
/*21583*/       OPC_SwitchType /*3 cases */, 20,  MVT::f32,// ->21606
/*21586*/         OPC_CheckPatternPredicate, 6, // (!Subtarget->hasSSE1())
/*21588*/         OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*21591*/         OPC_EmitMergeInputChains, 1, 0, 
/*21594*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::LD_Fp32m), 0|OPFL_Chain|OPFL_MemRefs,
                      1/*#VTs*/, MVT::f32, 5/*#Ops*/, 2, 3, 4, 5, 6, 
                  // Src: (ld:f32 addr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>
                  // Dst: (LD_Fp32m:f32 addr:iPTR:$src)
                /*SwitchType*/ 20,  MVT::f64,// ->21628
/*21608*/         OPC_CheckPatternPredicate, 7, // (!Subtarget->hasSSE2())
/*21610*/         OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*21613*/         OPC_EmitMergeInputChains, 1, 0, 
/*21616*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::LD_Fp64m), 0|OPFL_Chain|OPFL_MemRefs,
                      1/*#VTs*/, MVT::f64, 5/*#Ops*/, 2, 3, 4, 5, 6, 
                  // Src: (ld:f64 addr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>
                  // Dst: (LD_Fp64m:f64 addr:iPTR:$src)
                /*SwitchType*/ 18,  MVT::f80,// ->21648
/*21630*/         OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*21633*/         OPC_EmitMergeInputChains, 1, 0, 
/*21636*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::LD_Fp80m), 0|OPFL_Chain|OPFL_MemRefs,
                      1/*#VTs*/, MVT::f80, 5/*#Ops*/, 2, 3, 4, 5, 6, 
                  // Src: (ld:f80 addr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>
                  // Dst: (LD_Fp80m:f80 addr:iPTR:$src)
                0, // EndSwitchType
/*21649*/     0, /*End of Scope*/
/*21650*/   /*Scope*/ 74, /*->21725*/
/*21651*/     OPC_CheckPredicate, 48, // Predicate_extload
/*21653*/     OPC_SwitchType /*2 cases */, 22,  MVT::f64,// ->21678
/*21656*/       OPC_CheckPredicate, 49, // Predicate_extloadf32
/*21658*/       OPC_CheckPatternPredicate, 7, // (!Subtarget->hasSSE2())
/*21660*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*21663*/       OPC_EmitMergeInputChains, 1, 0, 
/*21666*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::LD_Fp32m64), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::f64, 5/*#Ops*/, 2, 3, 4, 5, 6, 
                // Src: (ld:f64 addr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>
                // Dst: (LD_Fp32m64:f64 addr:iPTR:$src)
              /*SwitchType*/ 44,  MVT::f80,// ->21724
/*21680*/       OPC_Scope, 20, /*->21702*/ // 2 children in Scope
/*21682*/         OPC_CheckPredicate, 50, // Predicate_extloadf64
/*21684*/         OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*21687*/         OPC_EmitMergeInputChains, 1, 0, 
/*21690*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::LD_Fp64m80), 0|OPFL_Chain|OPFL_MemRefs,
                      1/*#VTs*/, MVT::f80, 5/*#Ops*/, 2, 3, 4, 5, 6, 
                  // Src: (ld:f80 addr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf64>>
                  // Dst: (LD_Fp64m80:f80 addr:iPTR:$src)
/*21702*/       /*Scope*/ 20, /*->21723*/
/*21703*/         OPC_CheckPredicate, 49, // Predicate_extloadf32
/*21705*/         OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*21708*/         OPC_EmitMergeInputChains, 1, 0, 
/*21711*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::LD_Fp32m80), 0|OPFL_Chain|OPFL_MemRefs,
                      1/*#VTs*/, MVT::f80, 5/*#Ops*/, 2, 3, 4, 5, 6, 
                  // Src: (ld:f80 addr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>
                  // Dst: (LD_Fp32m80:f80 addr:iPTR:$src)
/*21723*/       0, /*End of Scope*/
              0, // EndSwitchType
/*21725*/   /*Scope*/ 24, /*->21750*/
/*21726*/     OPC_CheckPredicate, 8, // Predicate_load
/*21728*/     OPC_CheckPredicate, 9, // Predicate_dsload
/*21730*/     OPC_CheckType, MVT::i8,
/*21732*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*21735*/     OPC_EmitMergeInputChains, 1, 0, 
/*21738*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::MOV8rm), 0|OPFL_Chain|OPFL_MemRefs,
                  1/*#VTs*/, MVT::i8, 5/*#Ops*/, 2, 3, 4, 5, 6, 
              // Src: (ld:i8 addr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>
              // Dst: (MOV8rm:i8 addr:iPTR:$src)
/*21750*/   /*Scope*/ 22, /*->21773*/
/*21751*/     OPC_CheckPredicate, 6, // Predicate_loadi16
/*21753*/     OPC_CheckType, MVT::i16,
/*21755*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*21758*/     OPC_EmitMergeInputChains, 1, 0, 
/*21761*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::MOV16rm), 0|OPFL_Chain|OPFL_MemRefs,
                  1/*#VTs*/, MVT::i16, 5/*#Ops*/, 2, 3, 4, 5, 6, 
              // Src: (ld:i16 addr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>
              // Dst: (MOV16rm:i16 addr:iPTR:$src)
/*21773*/   /*Scope*/ 22, /*->21796*/
/*21774*/     OPC_CheckPredicate, 3, // Predicate_loadi32
/*21776*/     OPC_CheckType, MVT::i32,
/*21778*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*21781*/     OPC_EmitMergeInputChains, 1, 0, 
/*21784*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::MOV32rm), 0|OPFL_Chain|OPFL_MemRefs,
                  1/*#VTs*/, MVT::i32, 5/*#Ops*/, 2, 3, 4, 5, 6, 
              // Src: (ld:i32 addr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>
              // Dst: (MOV32rm:i32 addr:iPTR:$src)
/*21796*/   /*Scope*/ 72, /*->21869*/
/*21797*/     OPC_CheckPredicate, 51, // Predicate_sextload
/*21799*/     OPC_Scope, 44, /*->21845*/ // 2 children in Scope
/*21801*/       OPC_CheckPredicate, 52, // Predicate_sextloadi8
/*21803*/       OPC_SwitchType /*2 cases */, 18,  MVT::i16,// ->21824
/*21806*/         OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*21809*/         OPC_EmitMergeInputChains, 1, 0, 
/*21812*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVSX16rm8), 0|OPFL_Chain|OPFL_MemRefs,
                      1/*#VTs*/, MVT::i16, 5/*#Ops*/, 2, 3, 4, 5, 6, 
                  // Src: (ld:i16 addr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>
                  // Dst: (MOVSX16rm8:i16 addr:iPTR:$src)
                /*SwitchType*/ 18,  MVT::i32,// ->21844
/*21826*/         OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*21829*/         OPC_EmitMergeInputChains, 1, 0, 
/*21832*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVSX32rm8), 0|OPFL_Chain|OPFL_MemRefs,
                      1/*#VTs*/, MVT::i32, 5/*#Ops*/, 2, 3, 4, 5, 6, 
                  // Src: (ld:i32 addr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>
                  // Dst: (MOVSX32rm8:i32 addr:iPTR:$src)
                0, // EndSwitchType
/*21845*/     /*Scope*/ 22, /*->21868*/
/*21846*/       OPC_CheckPredicate, 53, // Predicate_sextloadi16
/*21848*/       OPC_CheckType, MVT::i32,
/*21850*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*21853*/       OPC_EmitMergeInputChains, 1, 0, 
/*21856*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVSX32rm16), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::i32, 5/*#Ops*/, 2, 3, 4, 5, 6, 
                // Src: (ld:i32 addr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>
                // Dst: (MOVSX32rm16:i32 addr:iPTR:$src)
/*21868*/     0, /*End of Scope*/
/*21869*/   /*Scope*/ 9|128,1/*137*/, /*->22008*/
/*21871*/     OPC_CheckPredicate, 54, // Predicate_zextload
/*21873*/     OPC_Scope, 44, /*->21919*/ // 3 children in Scope
/*21875*/       OPC_CheckPredicate, 55, // Predicate_zextloadi8
/*21877*/       OPC_SwitchType /*2 cases */, 18,  MVT::i16,// ->21898
/*21880*/         OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*21883*/         OPC_EmitMergeInputChains, 1, 0, 
/*21886*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVZX16rm8), 0|OPFL_Chain|OPFL_MemRefs,
                      1/*#VTs*/, MVT::i16, 5/*#Ops*/, 2, 3, 4, 5, 6, 
                  // Src: (ld:i16 addr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>
                  // Dst: (MOVZX16rm8:i16 addr:iPTR:$src)
                /*SwitchType*/ 18,  MVT::i32,// ->21918
/*21900*/         OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*21903*/         OPC_EmitMergeInputChains, 1, 0, 
/*21906*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVZX32rm8), 0|OPFL_Chain|OPFL_MemRefs,
                      1/*#VTs*/, MVT::i32, 5/*#Ops*/, 2, 3, 4, 5, 6, 
                  // Src: (ld:i32 addr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>
                  // Dst: (MOVZX32rm8:i32 addr:iPTR:$src)
                0, // EndSwitchType
/*21919*/     /*Scope*/ 22, /*->21942*/
/*21920*/       OPC_CheckPredicate, 56, // Predicate_zextloadi16
/*21922*/       OPC_CheckType, MVT::i32,
/*21924*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*21927*/       OPC_EmitMergeInputChains, 1, 0, 
/*21930*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVZX32rm16), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::i32, 5/*#Ops*/, 2, 3, 4, 5, 6, 
                // Src: (ld:i32 addr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>
                // Dst: (MOVZX32rm16:i32 addr:iPTR:$src)
/*21942*/     /*Scope*/ 64, /*->22007*/
/*21943*/       OPC_CheckPredicate, 57, // Predicate_zextloadi1
/*21945*/       OPC_SwitchType /*3 cases */, 18,  MVT::i8,// ->21966
/*21948*/         OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*21951*/         OPC_EmitMergeInputChains, 1, 0, 
/*21954*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::MOV8rm), 0|OPFL_Chain|OPFL_MemRefs,
                      1/*#VTs*/, MVT::i8, 5/*#Ops*/, 2, 3, 4, 5, 6, 
                  // Src: (ld:i8 addr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>
                  // Dst: (MOV8rm:i8 addr:iPTR:$src)
                /*SwitchType*/ 18,  MVT::i16,// ->21986
/*21968*/         OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*21971*/         OPC_EmitMergeInputChains, 1, 0, 
/*21974*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVZX16rm8), 0|OPFL_Chain|OPFL_MemRefs,
                      1/*#VTs*/, MVT::i16, 5/*#Ops*/, 2, 3, 4, 5, 6, 
                  // Src: (ld:i16 addr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>
                  // Dst: (MOVZX16rm8:i16 addr:iPTR:$src)
                /*SwitchType*/ 18,  MVT::i32,// ->22006
/*21988*/         OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*21991*/         OPC_EmitMergeInputChains, 1, 0, 
/*21994*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVZX32rm8), 0|OPFL_Chain|OPFL_MemRefs,
                      1/*#VTs*/, MVT::i32, 5/*#Ops*/, 2, 3, 4, 5, 6, 
                  // Src: (ld:i32 addr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>
                  // Dst: (MOVZX32rm8:i32 addr:iPTR:$src)
                0, // EndSwitchType
/*22007*/     0, /*End of Scope*/
/*22008*/   /*Scope*/ 9|128,1/*137*/, /*->22147*/
/*22010*/     OPC_CheckPredicate, 48, // Predicate_extload
/*22012*/     OPC_Scope, 64, /*->22078*/ // 3 children in Scope
/*22014*/       OPC_CheckPredicate, 58, // Predicate_extloadi1
/*22016*/       OPC_SwitchType /*3 cases */, 18,  MVT::i8,// ->22037
/*22019*/         OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*22022*/         OPC_EmitMergeInputChains, 1, 0, 
/*22025*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::MOV8rm), 0|OPFL_Chain|OPFL_MemRefs,
                      1/*#VTs*/, MVT::i8, 5/*#Ops*/, 2, 3, 4, 5, 6, 
                  // Src: (ld:i8 addr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi1>>
                  // Dst: (MOV8rm:i8 addr:iPTR:$src)
                /*SwitchType*/ 18,  MVT::i16,// ->22057
/*22039*/         OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*22042*/         OPC_EmitMergeInputChains, 1, 0, 
/*22045*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVZX16rm8), 0|OPFL_Chain|OPFL_MemRefs,
                      1/*#VTs*/, MVT::i16, 5/*#Ops*/, 2, 3, 4, 5, 6, 
                  // Src: (ld:i16 addr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi1>>
                  // Dst: (MOVZX16rm8:i16 addr:iPTR:$src)
                /*SwitchType*/ 18,  MVT::i32,// ->22077
/*22059*/         OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*22062*/         OPC_EmitMergeInputChains, 1, 0, 
/*22065*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVZX32rm8), 0|OPFL_Chain|OPFL_MemRefs,
                      1/*#VTs*/, MVT::i32, 5/*#Ops*/, 2, 3, 4, 5, 6, 
                  // Src: (ld:i32 addr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi1>>
                  // Dst: (MOVZX32rm8:i32 addr:iPTR:$src)
                0, // EndSwitchType
/*22078*/     /*Scope*/ 44, /*->22123*/
/*22079*/       OPC_CheckPredicate, 59, // Predicate_extloadi8
/*22081*/       OPC_SwitchType /*2 cases */, 18,  MVT::i16,// ->22102
/*22084*/         OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*22087*/         OPC_EmitMergeInputChains, 1, 0, 
/*22090*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVZX16rm8), 0|OPFL_Chain|OPFL_MemRefs,
                      1/*#VTs*/, MVT::i16, 5/*#Ops*/, 2, 3, 4, 5, 6, 
                  // Src: (ld:i16 addr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>
                  // Dst: (MOVZX16rm8:i16 addr:iPTR:$src)
                /*SwitchType*/ 18,  MVT::i32,// ->22122
/*22104*/         OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*22107*/         OPC_EmitMergeInputChains, 1, 0, 
/*22110*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVZX32rm8), 0|OPFL_Chain|OPFL_MemRefs,
                      1/*#VTs*/, MVT::i32, 5/*#Ops*/, 2, 3, 4, 5, 6, 
                  // Src: (ld:i32 addr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>
                  // Dst: (MOVZX32rm8:i32 addr:iPTR:$src)
                0, // EndSwitchType
/*22123*/     /*Scope*/ 22, /*->22146*/
/*22124*/       OPC_CheckPredicate, 60, // Predicate_extloadi16
/*22126*/       OPC_CheckType, MVT::i32,
/*22128*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*22131*/       OPC_EmitMergeInputChains, 1, 0, 
/*22134*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVZX32rm16), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::i32, 5/*#Ops*/, 2, 3, 4, 5, 6, 
                // Src: (ld:i32 addr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>
                // Dst: (MOVZX32rm16:i32 addr:iPTR:$src)
/*22146*/     0, /*End of Scope*/
/*22147*/   /*Scope*/ 24, /*->22172*/
/*22148*/     OPC_CheckPredicate, 51, // Predicate_sextload
/*22150*/     OPC_CheckPredicate, 53, // Predicate_sextloadi16
/*22152*/     OPC_CheckType, MVT::i32,
/*22154*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$dst #2 #3 #4 #5 #6
/*22157*/     OPC_EmitMergeInputChains, 1, 0, 
/*22160*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVSX32rm16), 0|OPFL_Chain|OPFL_MemRefs,
                  1/*#VTs*/, MVT::i32, 5/*#Ops*/, 2, 3, 4, 5, 6, 
              // Src: (ld:i32 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>
              // Dst: (MOVSX32rm16:i32 addr:iPTR:$dst)
/*22172*/   /*Scope*/ 24, /*->22197*/
/*22173*/     OPC_CheckPredicate, 54, // Predicate_zextload
/*22175*/     OPC_CheckPredicate, 56, // Predicate_zextloadi16
/*22177*/     OPC_CheckType, MVT::i32,
/*22179*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$dst #2 #3 #4 #5 #6
/*22182*/     OPC_EmitMergeInputChains, 1, 0, 
/*22185*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVZX32rm16), 0|OPFL_Chain|OPFL_MemRefs,
                  1/*#VTs*/, MVT::i32, 5/*#Ops*/, 2, 3, 4, 5, 6, 
              // Src: (ld:i32 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>
              // Dst: (MOVZX32rm16:i32 addr:iPTR:$dst)
/*22197*/   /*Scope*/ 24, /*->22222*/
/*22198*/     OPC_CheckPredicate, 48, // Predicate_extload
/*22200*/     OPC_CheckPredicate, 60, // Predicate_extloadi16
/*22202*/     OPC_CheckType, MVT::i32,
/*22204*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$dst #2 #3 #4 #5 #6
/*22207*/     OPC_EmitMergeInputChains, 1, 0, 
/*22210*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVZX32rm16), 0|OPFL_Chain|OPFL_MemRefs,
                  1/*#VTs*/, MVT::i32, 5/*#Ops*/, 2, 3, 4, 5, 6, 
              // Src: (ld:i32 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>
              // Dst: (MOVZX32rm16:i32 addr:iPTR:$dst)
/*22222*/   /*Scope*/ 22, /*->22245*/
/*22223*/     OPC_CheckPredicate, 8, // Predicate_load
/*22225*/     OPC_CheckType, MVT::i64,
/*22227*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*22230*/     OPC_EmitMergeInputChains, 1, 0, 
/*22233*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::MOV64rm), 0|OPFL_Chain|OPFL_MemRefs,
                  1/*#VTs*/, MVT::i64, 5/*#Ops*/, 2, 3, 4, 5, 6, 
              // Src: (ld:i64 addr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>
              // Dst: (MOV64rm:i64 addr:iPTR:$src)
/*22245*/   /*Scope*/ 69, /*->22315*/
/*22246*/     OPC_CheckPredicate, 51, // Predicate_sextload
/*22248*/     OPC_CheckType, MVT::i64,
/*22250*/     OPC_Scope, 20, /*->22272*/ // 3 children in Scope
/*22252*/       OPC_CheckPredicate, 52, // Predicate_sextloadi8
/*22254*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*22257*/       OPC_EmitMergeInputChains, 1, 0, 
/*22260*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVSX64rm8), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::i64, 5/*#Ops*/, 2, 3, 4, 5, 6, 
                // Src: (ld:i64 addr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>
                // Dst: (MOVSX64rm8:i64 addr:iPTR:$src)
/*22272*/     /*Scope*/ 20, /*->22293*/
/*22273*/       OPC_CheckPredicate, 53, // Predicate_sextloadi16
/*22275*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*22278*/       OPC_EmitMergeInputChains, 1, 0, 
/*22281*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVSX64rm16), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::i64, 5/*#Ops*/, 2, 3, 4, 5, 6, 
                // Src: (ld:i64 addr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>
                // Dst: (MOVSX64rm16:i64 addr:iPTR:$src)
/*22293*/     /*Scope*/ 20, /*->22314*/
/*22294*/       OPC_CheckPredicate, 61, // Predicate_sextloadi32
/*22296*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*22299*/       OPC_EmitMergeInputChains, 1, 0, 
/*22302*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVSX64rm32), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::i64, 5/*#Ops*/, 2, 3, 4, 5, 6, 
                // Src: (ld:i64 addr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi32>>
                // Dst: (MOVSX64rm32:i64 addr:iPTR:$src)
/*22314*/     0, /*End of Scope*/
/*22315*/   /*Scope*/ 90, /*->22406*/
/*22316*/     OPC_CheckPredicate, 54, // Predicate_zextload
/*22318*/     OPC_CheckType, MVT::i64,
/*22320*/     OPC_Scope, 20, /*->22342*/ // 4 children in Scope
/*22322*/       OPC_CheckPredicate, 55, // Predicate_zextloadi8
/*22324*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*22327*/       OPC_EmitMergeInputChains, 1, 0, 
/*22330*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVZX64rm8), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::i64, 5/*#Ops*/, 2, 3, 4, 5, 6, 
                // Src: (ld:i64 addr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>
                // Dst: (MOVZX64rm8:i64 addr:iPTR:$src)
/*22342*/     /*Scope*/ 20, /*->22363*/
/*22343*/       OPC_CheckPredicate, 56, // Predicate_zextloadi16
/*22345*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*22348*/       OPC_EmitMergeInputChains, 1, 0, 
/*22351*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVZX64rm16), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::i64, 5/*#Ops*/, 2, 3, 4, 5, 6, 
                // Src: (ld:i64 addr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>
                // Dst: (MOVZX64rm16:i64 addr:iPTR:$src)
/*22363*/     /*Scope*/ 20, /*->22384*/
/*22364*/       OPC_CheckPredicate, 62, // Predicate_zextloadi32
/*22366*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*22369*/       OPC_EmitMergeInputChains, 1, 0, 
/*22372*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVZX64rm32), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::i64, 5/*#Ops*/, 2, 3, 4, 5, 6, 
                // Src: (ld:i64 addr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi32>>
                // Dst: (MOVZX64rm32:i64 addr:iPTR:$src)
/*22384*/     /*Scope*/ 20, /*->22405*/
/*22385*/       OPC_CheckPredicate, 57, // Predicate_zextloadi1
/*22387*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*22390*/       OPC_EmitMergeInputChains, 1, 0, 
/*22393*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVZX64rm8), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::i64, 5/*#Ops*/, 2, 3, 4, 5, 6, 
                // Src: (ld:i64 addr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>
                // Dst: (MOVZX64rm8:i64 addr:iPTR:$src)
/*22405*/     0, /*End of Scope*/
/*22406*/   /*Scope*/ 69, /*->22476*/
/*22407*/     OPC_CheckPredicate, 48, // Predicate_extload
/*22409*/     OPC_CheckType, MVT::i64,
/*22411*/     OPC_Scope, 20, /*->22433*/ // 3 children in Scope
/*22413*/       OPC_CheckPredicate, 58, // Predicate_extloadi1
/*22415*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*22418*/       OPC_EmitMergeInputChains, 1, 0, 
/*22421*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVZX64rm8), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::i64, 5/*#Ops*/, 2, 3, 4, 5, 6, 
                // Src: (ld:i64 addr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi1>>
                // Dst: (MOVZX64rm8:i64 addr:iPTR:$src)
/*22433*/     /*Scope*/ 20, /*->22454*/
/*22434*/       OPC_CheckPredicate, 59, // Predicate_extloadi8
/*22436*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*22439*/       OPC_EmitMergeInputChains, 1, 0, 
/*22442*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVZX64rm8), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::i64, 5/*#Ops*/, 2, 3, 4, 5, 6, 
                // Src: (ld:i64 addr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>
                // Dst: (MOVZX64rm8:i64 addr:iPTR:$src)
/*22454*/     /*Scope*/ 20, /*->22475*/
/*22455*/       OPC_CheckPredicate, 60, // Predicate_extloadi16
/*22457*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*22460*/       OPC_EmitMergeInputChains, 1, 0, 
/*22463*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVZX64rm16), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::i64, 5/*#Ops*/, 2, 3, 4, 5, 6, 
                // Src: (ld:i64 addr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>
                // Dst: (MOVZX64rm16:i64 addr:iPTR:$src)
/*22475*/     0, /*End of Scope*/
/*22476*/   /*Scope*/ 24, /*->22501*/
/*22477*/     OPC_CheckPredicate, 51, // Predicate_sextload
/*22479*/     OPC_CheckPredicate, 53, // Predicate_sextloadi16
/*22481*/     OPC_CheckType, MVT::i64,
/*22483*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$dst #2 #3 #4 #5 #6
/*22486*/     OPC_EmitMergeInputChains, 1, 0, 
/*22489*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVSX64rm16), 0|OPFL_Chain|OPFL_MemRefs,
                  1/*#VTs*/, MVT::i64, 5/*#Ops*/, 2, 3, 4, 5, 6, 
              // Src: (ld:i64 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>
              // Dst: (MOVSX64rm16:i64 addr:iPTR:$dst)
/*22501*/   /*Scope*/ 24, /*->22526*/
/*22502*/     OPC_CheckPredicate, 54, // Predicate_zextload
/*22504*/     OPC_CheckPredicate, 56, // Predicate_zextloadi16
/*22506*/     OPC_CheckType, MVT::i64,
/*22508*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$dst #2 #3 #4 #5 #6
/*22511*/     OPC_EmitMergeInputChains, 1, 0, 
/*22514*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVZX64rm16), 0|OPFL_Chain|OPFL_MemRefs,
                  1/*#VTs*/, MVT::i64, 5/*#Ops*/, 2, 3, 4, 5, 6, 
              // Src: (ld:i64 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>
              // Dst: (MOVZX64rm16:i64 addr:iPTR:$dst)
/*22526*/   /*Scope*/ 24, /*->22551*/
/*22527*/     OPC_CheckPredicate, 48, // Predicate_extload
/*22529*/     OPC_CheckPredicate, 60, // Predicate_extloadi16
/*22531*/     OPC_CheckType, MVT::i64,
/*22533*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$dst #2 #3 #4 #5 #6
/*22536*/     OPC_EmitMergeInputChains, 1, 0, 
/*22539*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVZX64rm16), 0|OPFL_Chain|OPFL_MemRefs,
                  1/*#VTs*/, MVT::i64, 5/*#Ops*/, 2, 3, 4, 5, 6, 
              // Src: (ld:i64 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>
              // Dst: (MOVZX64rm16:i64 addr:iPTR:$dst)
/*22551*/   /*Scope*/ 101, /*->22653*/
/*22552*/     OPC_CheckPredicate, 8, // Predicate_load
/*22554*/     OPC_Scope, 24, /*->22580*/ // 3 children in Scope
/*22556*/       OPC_CheckPredicate, 9, // Predicate_dsload
/*22558*/       OPC_CheckType, MVT::f32,
/*22560*/       OPC_CheckPatternPredicate, 0, // (Subtarget->hasSSE1())
/*22562*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*22565*/       OPC_EmitMergeInputChains, 1, 0, 
/*22568*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVSSrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::f32, 5/*#Ops*/, 2, 3, 4, 5, 6, 
                // Src: (ld:f32 addr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>
                // Dst: (MOVSSrm:f32 addr:iPTR:$src)
/*22580*/     /*Scope*/ 48, /*->22629*/
/*22581*/       OPC_CheckPredicate, 63, // Predicate_alignedload
/*22583*/       OPC_SwitchType /*2 cases */, 20,  MVT::f32,// ->22606
/*22586*/         OPC_CheckPatternPredicate, 0, // (Subtarget->hasSSE1())
/*22588*/         OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*22591*/         OPC_EmitMergeInputChains, 1, 0, 
/*22594*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::FsMOVAPSrm), 0|OPFL_Chain|OPFL_MemRefs,
                      1/*#VTs*/, MVT::f32, 5/*#Ops*/, 2, 3, 4, 5, 6, 
                  // Src: (ld:f32 addr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>
                  // Dst: (FsMOVAPSrm:f32 addr:iPTR:$src)
                /*SwitchType*/ 20,  MVT::v4f32,// ->22628
/*22608*/         OPC_CheckPatternPredicate, 0, // (Subtarget->hasSSE1())
/*22610*/         OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*22613*/         OPC_EmitMergeInputChains, 1, 0, 
/*22616*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVAPSrm), 0|OPFL_Chain|OPFL_MemRefs,
                      1/*#VTs*/, MVT::v4f32, 5/*#Ops*/, 2, 3, 4, 5, 6, 
                  // Src: (ld:v4f32 addr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>
                  // Dst: (MOVAPSrm:v4f32 addr:iPTR:$src)
                0, // EndSwitchType
/*22629*/     /*Scope*/ 22, /*->22652*/
/*22630*/       OPC_CheckType, MVT::v4f32,
/*22632*/       OPC_CheckPatternPredicate, 0, // (Subtarget->hasSSE1())
/*22634*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*22637*/       OPC_EmitMergeInputChains, 1, 0, 
/*22640*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVUPSrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v4f32, 5/*#Ops*/, 2, 3, 4, 5, 6, 
                // Src: (ld:v4f32 addr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>
                // Dst: (MOVUPSrm:v4f32 addr:iPTR:$src)
/*22652*/     0, /*End of Scope*/
/*22653*/   /*Scope*/ 26, /*->22680*/
/*22654*/     OPC_CheckPredicate, 48, // Predicate_extload
/*22656*/     OPC_CheckPredicate, 49, // Predicate_extloadf32
/*22658*/     OPC_CheckType, MVT::f64,
/*22660*/     OPC_CheckPatternPredicate, 12, // (Subtarget->hasSSE2()) && (OptForSize)
/*22662*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*22665*/     OPC_EmitMergeInputChains, 1, 0, 
/*22668*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::CVTSS2SDrm), 0|OPFL_Chain|OPFL_MemRefs,
                  1/*#VTs*/, MVT::f64, 5/*#Ops*/, 2, 3, 4, 5, 6, 
              // Src: (ld:f64 addr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>
              // Dst: (CVTSS2SDrm:f64 addr:iPTR:$src)
/*22680*/   /*Scope*/ 61|128,1/*189*/, /*->22871*/
/*22682*/     OPC_CheckPredicate, 8, // Predicate_load
/*22684*/     OPC_Scope, 48, /*->22734*/ // 5 children in Scope
/*22686*/       OPC_CheckPredicate, 63, // Predicate_alignedload
/*22688*/       OPC_SwitchType /*2 cases */, 20,  MVT::f64,// ->22711
/*22691*/         OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*22693*/         OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*22696*/         OPC_EmitMergeInputChains, 1, 0, 
/*22699*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::FsMOVAPDrm), 0|OPFL_Chain|OPFL_MemRefs,
                      1/*#VTs*/, MVT::f64, 5/*#Ops*/, 2, 3, 4, 5, 6, 
                  // Src: (ld:f64 addr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>
                  // Dst: (FsMOVAPDrm:f64 addr:iPTR:$src)
                /*SwitchType*/ 20,  MVT::v2f64,// ->22733
/*22713*/         OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*22715*/         OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*22718*/         OPC_EmitMergeInputChains, 1, 0, 
/*22721*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVAPDrm), 0|OPFL_Chain|OPFL_MemRefs,
                      1/*#VTs*/, MVT::v2f64, 5/*#Ops*/, 2, 3, 4, 5, 6, 
                  // Src: (ld:v2f64 addr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>
                  // Dst: (MOVAPDrm:v2f64 addr:iPTR:$src)
                0, // EndSwitchType
/*22734*/     /*Scope*/ 22, /*->22757*/
/*22735*/       OPC_CheckType, MVT::v2f64,
/*22737*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*22739*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*22742*/       OPC_EmitMergeInputChains, 1, 0, 
/*22745*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVUPDrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v2f64, 5/*#Ops*/, 2, 3, 4, 5, 6, 
                // Src: (ld:v2f64 addr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>
                // Dst: (MOVUPDrm:v2f64 addr:iPTR:$src)
/*22757*/     /*Scope*/ 44, /*->22802*/
/*22758*/       OPC_CheckType, MVT::v4i32,
/*22760*/       OPC_Scope, 20, /*->22782*/ // 2 children in Scope
/*22762*/         OPC_CheckPredicate, 63, // Predicate_alignedload
/*22764*/         OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*22767*/         OPC_EmitMergeInputChains, 1, 0, 
/*22770*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVAPSrm), 0|OPFL_Chain|OPFL_MemRefs,
                      1/*#VTs*/, MVT::v4i32, 5/*#Ops*/, 2, 3, 4, 5, 6, 
                  // Src: (ld:v4i32 addr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>
                  // Dst: (MOVAPSrm:v4i32 addr:iPTR:$src)
/*22782*/       /*Scope*/ 18, /*->22801*/
/*22783*/         OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*22786*/         OPC_EmitMergeInputChains, 1, 0, 
/*22789*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVUPSrm), 0|OPFL_Chain|OPFL_MemRefs,
                      1/*#VTs*/, MVT::v4i32, 5/*#Ops*/, 2, 3, 4, 5, 6, 
                  // Src: (ld:v4i32 addr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>
                  // Dst: (MOVUPSrm:v4i32 addr:iPTR:$src)
/*22801*/       0, /*End of Scope*/
/*22802*/     /*Scope*/ 44, /*->22847*/
/*22803*/       OPC_CheckType, MVT::v2i64,
/*22805*/       OPC_Scope, 20, /*->22827*/ // 2 children in Scope
/*22807*/         OPC_CheckPredicate, 63, // Predicate_alignedload
/*22809*/         OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*22812*/         OPC_EmitMergeInputChains, 1, 0, 
/*22815*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVAPSrm), 0|OPFL_Chain|OPFL_MemRefs,
                      1/*#VTs*/, MVT::v2i64, 5/*#Ops*/, 2, 3, 4, 5, 6, 
                  // Src: (ld:v2i64 addr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>
                  // Dst: (MOVAPSrm:v2i64 addr:iPTR:$src)
/*22827*/       /*Scope*/ 18, /*->22846*/
/*22828*/         OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*22831*/         OPC_EmitMergeInputChains, 1, 0, 
/*22834*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVUPSrm), 0|OPFL_Chain|OPFL_MemRefs,
                      1/*#VTs*/, MVT::v2i64, 5/*#Ops*/, 2, 3, 4, 5, 6, 
                  // Src: (ld:v2i64 addr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>
                  // Dst: (MOVUPSrm:v2i64 addr:iPTR:$src)
/*22846*/       0, /*End of Scope*/
/*22847*/     /*Scope*/ 22, /*->22870*/
/*22848*/       OPC_CheckType, MVT::v1i64,
/*22850*/       OPC_CheckPatternPredicate, 8, // (Subtarget->hasMMX())
/*22852*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*22855*/       OPC_EmitMergeInputChains, 1, 0, 
/*22858*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_MOVQ64rm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v1i64, 5/*#Ops*/, 2, 3, 4, 5, 6, 
                // Src: (ld:v1i64 addr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>
                // Dst: (MMX_MOVQ64rm:v1i64 addr:iPTR:$src)
/*22870*/     0, /*End of Scope*/
/*22871*/   /*Scope*/ 77, /*->22949*/
/*22872*/     OPC_CheckPredicate, 48, // Predicate_extload
/*22874*/     OPC_SwitchType /*2 cases */, 36,  MVT::i64,// ->22913
/*22877*/       OPC_CheckPredicate, 64, // Predicate_extloadi32
/*22879*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*22882*/       OPC_EmitMergeInputChains, 1, 0, 
/*22885*/       OPC_EmitInteger, MVT::i64, 0, 
/*22888*/       OPC_EmitNode, TARGET_OPCODE(X86::MOV32rm), 0|OPFL_Chain,
                    1/*#VTs*/, MVT::i32, 5/*#Ops*/, 2, 3, 4, 5, 6,  // Results = #8 
/*22900*/       OPC_EmitInteger, MVT::i32, 4, 
/*22903*/       OPC_MorphNodeTo, TARGET_OPCODE(TargetOpcode::SUBREG_TO_REG), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::i64, 3/*#Ops*/, 7, 8, 9, 
                // Src: (ld:i64 addr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi32>>
                // Dst: (SUBREG_TO_REG:i64 0:i64, (MOV32rm:i32 addr:iPTR:$src), 4:i32)
              /*SwitchType*/ 33,  MVT::f64,// ->22948
/*22915*/       OPC_CheckPredicate, 49, // Predicate_extloadf32
/*22917*/       OPC_CheckPatternPredicate, 13, // (Subtarget->hasSSE2()) && (!OptForSize)
/*22919*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*22922*/       OPC_EmitMergeInputChains, 1, 0, 
/*22925*/       OPC_EmitNode, TARGET_OPCODE(X86::MOVSSrm), 0|OPFL_Chain,
                    1/*#VTs*/, MVT::f32, 5/*#Ops*/, 2, 3, 4, 5, 6,  // Results = #7 
/*22937*/       OPC_EmitNode, TARGET_OPCODE(X86::CVTSS2SDrr), 0|OPFL_MemRefs,
                    1/*#VTs*/, MVT::f64, 1/*#Ops*/, 7,  // Results = #8 
/*22945*/       OPC_CompleteMatch, 1, 8, 
                // Src: (ld:f64 addr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>
                // Dst: (CVTSS2SDrr:f64 (MOVSSrm:f32 addr:iPTR:$src))
              0, // EndSwitchType
/*22949*/   0, /*End of Scope*/
          /*SwitchOpcode*/ 60,  X86ISD::VZEXT_LOAD,// ->23012
/*22952*/   OPC_RecordNode,   // #0 = 'X86vzload' chained node
/*22953*/   OPC_RecordChild1, // #1 = $src
/*22954*/   OPC_SwitchType /*2 cases */, 18,  MVT::v2i64,// ->22975
/*22957*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*22960*/     OPC_EmitMergeInputChains, 1, 0, 
/*22963*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVZQI2PQIrm), 0|OPFL_Chain,
                  1/*#VTs*/, MVT::v2i64, 5/*#Ops*/, 2, 3, 4, 5, 6, 
              // Src: (X86vzload:v2i64 addr:iPTR:$src)
              // Dst: (MOVZQI2PQIrm:v2i64 addr:iPTR:$src)
            /*SwitchType*/ 34,  MVT::v2f64,// ->23011
/*22977*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*22980*/     OPC_EmitMergeInputChains, 1, 0, 
/*22983*/     OPC_EmitInteger, MVT::i64, 0, 
/*22986*/     OPC_EmitNode, TARGET_OPCODE(X86::MOVSDrm), 0|OPFL_Chain,
                  1/*#VTs*/, MVT::f64, 5/*#Ops*/, 2, 3, 4, 5, 6,  // Results = #8 
/*22998*/     OPC_EmitInteger, MVT::i32, 2, 
/*23001*/     OPC_MorphNodeTo, TARGET_OPCODE(TargetOpcode::SUBREG_TO_REG), 0|OPFL_Chain,
                  1/*#VTs*/, MVT::v2f64, 3/*#Ops*/, 7, 8, 9, 
              // Src: (X86vzload:v2f64 addr:iPTR:$src)
              // Dst: (SUBREG_TO_REG:v2f64 0:i64, (MOVSDrm:f64 addr:iPTR:$src), 2:i32)
            0, // EndSwitchType
          /*SwitchOpcode*/ 9|128,9|128,1/*17545*/,  ISD::INTRINSIC_WO_CHAIN,// ->40561
/*23016*/   OPC_MoveChild, 0,
/*23018*/   OPC_Scope, 20|128,1/*148*/, /*->23169*/ // 248 children in Scope
/*23021*/     OPC_CheckInteger, 126|128,4/*638*/, 
/*23024*/     OPC_MoveParent,
/*23025*/     OPC_Scope, 0|128,1/*128*/, /*->23156*/ // 2 children in Scope
/*23028*/       OPC_MoveChild, 1,
/*23030*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*23032*/       OPC_MoveChild, 0,
/*23034*/       OPC_SwitchOpcode /*3 cases */, 46,  X86ISD::VZEXT_MOVL,// ->23083
/*23037*/         OPC_MoveChild, 0,
/*23039*/         OPC_CheckOpcode, ISD::SCALAR_TO_VECTOR,
/*23041*/         OPC_MoveChild, 0,
/*23043*/         OPC_CheckOpcode, ISD::LOAD,
/*23045*/         OPC_RecordMemRef,
/*23046*/         OPC_RecordNode, // #0 = 'ld' chained node
/*23047*/         OPC_CheckFoldableChainNode,
/*23048*/         OPC_RecordChild1, // #1 = $src
/*23049*/         OPC_CheckPredicate, 2, // Predicate_unindexedload
/*23051*/         OPC_CheckPredicate, 8, // Predicate_load
/*23053*/         OPC_CheckPredicate, 9, // Predicate_dsload
/*23055*/         OPC_CheckType, MVT::i64,
/*23057*/         OPC_MoveParent,
/*23058*/         OPC_MoveParent,
/*23059*/         OPC_CheckType, MVT::v2i64,
/*23061*/         OPC_MoveParent,
/*23062*/         OPC_MoveParent,
/*23063*/         OPC_CheckPatternPredicate, 4, // (Subtarget->hasSSE41())
/*23065*/         OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*23068*/         OPC_EmitMergeInputChains, 1, 0, 
/*23071*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::PMOVSXBWrm), 0|OPFL_Chain|OPFL_MemRefs,
                      1/*#VTs*/, MVT::v8i16, 5/*#Ops*/, 2, 3, 4, 5, 6, 
                  // Src: (intrinsic_wo_chain:v8i16 638:iPTR, (bitconvert:v16i8 (X86vzmovl:v2i64 (scalar_to_vector:v2i64 (ld:i64 addr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>))))
                  // Dst: (PMOVSXBWrm:v8i16 addr:iPTR:$src)
                /*SwitchOpcode*/ 41,  ISD::SCALAR_TO_VECTOR,// ->23126
/*23085*/         OPC_MoveChild, 0,
/*23087*/         OPC_CheckOpcode, ISD::LOAD,
/*23089*/         OPC_RecordMemRef,
/*23090*/         OPC_RecordNode, // #0 = 'ld' chained node
/*23091*/         OPC_CheckFoldableChainNode,
/*23092*/         OPC_RecordChild1, // #1 = $src
/*23093*/         OPC_CheckPredicate, 2, // Predicate_unindexedload
/*23095*/         OPC_CheckPredicate, 8, // Predicate_load
/*23097*/         OPC_CheckPredicate, 9, // Predicate_dsload
/*23099*/         OPC_CheckType, MVT::i64,
/*23101*/         OPC_MoveParent,
/*23102*/         OPC_CheckType, MVT::v2i64,
/*23104*/         OPC_MoveParent,
/*23105*/         OPC_MoveParent,
/*23106*/         OPC_CheckPatternPredicate, 4, // (Subtarget->hasSSE41())
/*23108*/         OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*23111*/         OPC_EmitMergeInputChains, 1, 0, 
/*23114*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::PMOVSXBWrm), 0|OPFL_Chain|OPFL_MemRefs,
                      1/*#VTs*/, MVT::v8i16, 5/*#Ops*/, 2, 3, 4, 5, 6, 
                  // Src: (intrinsic_wo_chain:v8i16 638:iPTR, (bitconvert:v16i8 (scalar_to_vector:v2i64 (ld:i64 addr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>)))
                  // Dst: (PMOVSXBWrm:v8i16 addr:iPTR:$src)
                /*SwitchOpcode*/ 27,  X86ISD::VZEXT_LOAD,// ->23155
/*23128*/         OPC_RecordNode, // #0 = 'X86vzload' chained node
/*23129*/         OPC_CheckFoldableChainNode,
/*23130*/         OPC_RecordChild1, // #1 = $src
/*23131*/         OPC_CheckType, MVT::v2i64,
/*23133*/         OPC_MoveParent,
/*23134*/         OPC_MoveParent,
/*23135*/         OPC_CheckPatternPredicate, 4, // (Subtarget->hasSSE41())
/*23137*/         OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*23140*/         OPC_EmitMergeInputChains, 1, 0, 
/*23143*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::PMOVSXBWrm), 0|OPFL_Chain,
                      1/*#VTs*/, MVT::v8i16, 5/*#Ops*/, 2, 3, 4, 5, 6, 
                  // Src: (intrinsic_wo_chain:v8i16 638:iPTR, (bitconvert:v16i8 (X86vzload:v2i64 addr:iPTR:$src)))
                  // Dst: (PMOVSXBWrm:v8i16 addr:iPTR:$src)
                0, // EndSwitchOpcode
/*23156*/     /*Scope*/ 11, /*->23168*/
/*23157*/       OPC_RecordChild1, // #0 = $src
/*23158*/       OPC_CheckPatternPredicate, 4, // (Subtarget->hasSSE41())
/*23160*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PMOVSXBWrr), 0,
                    1/*#VTs*/, MVT::v8i16, 1/*#Ops*/, 0, 
                // Src: (intrinsic_wo_chain:v8i16 638:iPTR, VR128:v16i8:$src)
                // Dst: (PMOVSXBWrr:v8i16 VR128:v16i8:$src)
/*23168*/     0, /*End of Scope*/
/*23169*/   /*Scope*/ 20|128,1/*148*/, /*->23319*/
/*23171*/     OPC_CheckInteger, 0|128,5/*640*/, 
/*23174*/     OPC_MoveParent,
/*23175*/     OPC_Scope, 0|128,1/*128*/, /*->23306*/ // 2 children in Scope
/*23178*/       OPC_MoveChild, 1,
/*23180*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*23182*/       OPC_MoveChild, 0,
/*23184*/       OPC_SwitchOpcode /*3 cases */, 46,  X86ISD::VZEXT_MOVL,// ->23233
/*23187*/         OPC_MoveChild, 0,
/*23189*/         OPC_CheckOpcode, ISD::SCALAR_TO_VECTOR,
/*23191*/         OPC_MoveChild, 0,
/*23193*/         OPC_CheckOpcode, ISD::LOAD,
/*23195*/         OPC_RecordMemRef,
/*23196*/         OPC_RecordNode, // #0 = 'ld' chained node
/*23197*/         OPC_CheckFoldableChainNode,
/*23198*/         OPC_RecordChild1, // #1 = $src
/*23199*/         OPC_CheckPredicate, 2, // Predicate_unindexedload
/*23201*/         OPC_CheckPredicate, 8, // Predicate_load
/*23203*/         OPC_CheckPredicate, 9, // Predicate_dsload
/*23205*/         OPC_CheckType, MVT::i64,
/*23207*/         OPC_MoveParent,
/*23208*/         OPC_MoveParent,
/*23209*/         OPC_CheckType, MVT::v2i64,
/*23211*/         OPC_MoveParent,
/*23212*/         OPC_MoveParent,
/*23213*/         OPC_CheckPatternPredicate, 4, // (Subtarget->hasSSE41())
/*23215*/         OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*23218*/         OPC_EmitMergeInputChains, 1, 0, 
/*23221*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::PMOVSXWDrm), 0|OPFL_Chain|OPFL_MemRefs,
                      1/*#VTs*/, MVT::v4i32, 5/*#Ops*/, 2, 3, 4, 5, 6, 
                  // Src: (intrinsic_wo_chain:v4i32 640:iPTR, (bitconvert:v8i16 (X86vzmovl:v2i64 (scalar_to_vector:v2i64 (ld:i64 addr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>))))
                  // Dst: (PMOVSXWDrm:v4i32 addr:iPTR:$src)
                /*SwitchOpcode*/ 41,  ISD::SCALAR_TO_VECTOR,// ->23276
/*23235*/         OPC_MoveChild, 0,
/*23237*/         OPC_CheckOpcode, ISD::LOAD,
/*23239*/         OPC_RecordMemRef,
/*23240*/         OPC_RecordNode, // #0 = 'ld' chained node
/*23241*/         OPC_CheckFoldableChainNode,
/*23242*/         OPC_RecordChild1, // #1 = $src
/*23243*/         OPC_CheckPredicate, 2, // Predicate_unindexedload
/*23245*/         OPC_CheckPredicate, 8, // Predicate_load
/*23247*/         OPC_CheckPredicate, 9, // Predicate_dsload
/*23249*/         OPC_CheckType, MVT::i64,
/*23251*/         OPC_MoveParent,
/*23252*/         OPC_CheckType, MVT::v2i64,
/*23254*/         OPC_MoveParent,
/*23255*/         OPC_MoveParent,
/*23256*/         OPC_CheckPatternPredicate, 4, // (Subtarget->hasSSE41())
/*23258*/         OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*23261*/         OPC_EmitMergeInputChains, 1, 0, 
/*23264*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::PMOVSXWDrm), 0|OPFL_Chain|OPFL_MemRefs,
                      1/*#VTs*/, MVT::v4i32, 5/*#Ops*/, 2, 3, 4, 5, 6, 
                  // Src: (intrinsic_wo_chain:v4i32 640:iPTR, (bitconvert:v8i16 (scalar_to_vector:v2i64 (ld:i64 addr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>)))
                  // Dst: (PMOVSXWDrm:v4i32 addr:iPTR:$src)
                /*SwitchOpcode*/ 27,  X86ISD::VZEXT_LOAD,// ->23305
/*23278*/         OPC_RecordNode, // #0 = 'X86vzload' chained node
/*23279*/         OPC_CheckFoldableChainNode,
/*23280*/         OPC_RecordChild1, // #1 = $src
/*23281*/         OPC_CheckType, MVT::v2i64,
/*23283*/         OPC_MoveParent,
/*23284*/         OPC_MoveParent,
/*23285*/         OPC_CheckPatternPredicate, 4, // (Subtarget->hasSSE41())
/*23287*/         OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*23290*/         OPC_EmitMergeInputChains, 1, 0, 
/*23293*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::PMOVSXWDrm), 0|OPFL_Chain,
                      1/*#VTs*/, MVT::v4i32, 5/*#Ops*/, 2, 3, 4, 5, 6, 
                  // Src: (intrinsic_wo_chain:v4i32 640:iPTR, (bitconvert:v8i16 (X86vzload:v2i64 addr:iPTR:$src)))
                  // Dst: (PMOVSXWDrm:v4i32 addr:iPTR:$src)
                0, // EndSwitchOpcode
/*23306*/     /*Scope*/ 11, /*->23318*/
/*23307*/       OPC_RecordChild1, // #0 = $src
/*23308*/       OPC_CheckPatternPredicate, 4, // (Subtarget->hasSSE41())
/*23310*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PMOVSXWDrr), 0,
                    1/*#VTs*/, MVT::v4i32, 1/*#Ops*/, 0, 
                // Src: (intrinsic_wo_chain:v4i32 640:iPTR, VR128:v8i16:$src)
                // Dst: (PMOVSXWDrr:v4i32 VR128:v8i16:$src)
/*23318*/     0, /*End of Scope*/
/*23319*/   /*Scope*/ 20|128,1/*148*/, /*->23469*/
/*23321*/     OPC_CheckInteger, 127|128,4/*639*/, 
/*23324*/     OPC_MoveParent,
/*23325*/     OPC_Scope, 0|128,1/*128*/, /*->23456*/ // 2 children in Scope
/*23328*/       OPC_MoveChild, 1,
/*23330*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*23332*/       OPC_MoveChild, 0,
/*23334*/       OPC_SwitchOpcode /*3 cases */, 46,  X86ISD::VZEXT_MOVL,// ->23383
/*23337*/         OPC_MoveChild, 0,
/*23339*/         OPC_CheckOpcode, ISD::SCALAR_TO_VECTOR,
/*23341*/         OPC_MoveChild, 0,
/*23343*/         OPC_CheckOpcode, ISD::LOAD,
/*23345*/         OPC_RecordMemRef,
/*23346*/         OPC_RecordNode, // #0 = 'ld' chained node
/*23347*/         OPC_CheckFoldableChainNode,
/*23348*/         OPC_RecordChild1, // #1 = $src
/*23349*/         OPC_CheckPredicate, 2, // Predicate_unindexedload
/*23351*/         OPC_CheckPredicate, 8, // Predicate_load
/*23353*/         OPC_CheckPredicate, 9, // Predicate_dsload
/*23355*/         OPC_CheckType, MVT::i64,
/*23357*/         OPC_MoveParent,
/*23358*/         OPC_MoveParent,
/*23359*/         OPC_CheckType, MVT::v2i64,
/*23361*/         OPC_MoveParent,
/*23362*/         OPC_MoveParent,
/*23363*/         OPC_CheckPatternPredicate, 4, // (Subtarget->hasSSE41())
/*23365*/         OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*23368*/         OPC_EmitMergeInputChains, 1, 0, 
/*23371*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::PMOVSXDQrm), 0|OPFL_Chain|OPFL_MemRefs,
                      1/*#VTs*/, MVT::v2i64, 5/*#Ops*/, 2, 3, 4, 5, 6, 
                  // Src: (intrinsic_wo_chain:v2i64 639:iPTR, (bitconvert:v4i32 (X86vzmovl:v2i64 (scalar_to_vector:v2i64 (ld:i64 addr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>))))
                  // Dst: (PMOVSXDQrm:v2i64 addr:iPTR:$src)
                /*SwitchOpcode*/ 41,  ISD::SCALAR_TO_VECTOR,// ->23426
/*23385*/         OPC_MoveChild, 0,
/*23387*/         OPC_CheckOpcode, ISD::LOAD,
/*23389*/         OPC_RecordMemRef,
/*23390*/         OPC_RecordNode, // #0 = 'ld' chained node
/*23391*/         OPC_CheckFoldableChainNode,
/*23392*/         OPC_RecordChild1, // #1 = $src
/*23393*/         OPC_CheckPredicate, 2, // Predicate_unindexedload
/*23395*/         OPC_CheckPredicate, 8, // Predicate_load
/*23397*/         OPC_CheckPredicate, 9, // Predicate_dsload
/*23399*/         OPC_CheckType, MVT::i64,
/*23401*/         OPC_MoveParent,
/*23402*/         OPC_CheckType, MVT::v2i64,
/*23404*/         OPC_MoveParent,
/*23405*/         OPC_MoveParent,
/*23406*/         OPC_CheckPatternPredicate, 4, // (Subtarget->hasSSE41())
/*23408*/         OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*23411*/         OPC_EmitMergeInputChains, 1, 0, 
/*23414*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::PMOVSXDQrm), 0|OPFL_Chain|OPFL_MemRefs,
                      1/*#VTs*/, MVT::v2i64, 5/*#Ops*/, 2, 3, 4, 5, 6, 
                  // Src: (intrinsic_wo_chain:v2i64 639:iPTR, (bitconvert:v4i32 (scalar_to_vector:v2i64 (ld:i64 addr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>)))
                  // Dst: (PMOVSXDQrm:v2i64 addr:iPTR:$src)
                /*SwitchOpcode*/ 27,  X86ISD::VZEXT_LOAD,// ->23455
/*23428*/         OPC_RecordNode, // #0 = 'X86vzload' chained node
/*23429*/         OPC_CheckFoldableChainNode,
/*23430*/         OPC_RecordChild1, // #1 = $src
/*23431*/         OPC_CheckType, MVT::v2i64,
/*23433*/         OPC_MoveParent,
/*23434*/         OPC_MoveParent,
/*23435*/         OPC_CheckPatternPredicate, 4, // (Subtarget->hasSSE41())
/*23437*/         OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*23440*/         OPC_EmitMergeInputChains, 1, 0, 
/*23443*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::PMOVSXDQrm), 0|OPFL_Chain,
                      1/*#VTs*/, MVT::v2i64, 5/*#Ops*/, 2, 3, 4, 5, 6, 
                  // Src: (intrinsic_wo_chain:v2i64 639:iPTR, (bitconvert:v4i32 (X86vzload:v2i64 addr:iPTR:$src)))
                  // Dst: (PMOVSXDQrm:v2i64 addr:iPTR:$src)
                0, // EndSwitchOpcode
/*23456*/     /*Scope*/ 11, /*->23468*/
/*23457*/       OPC_RecordChild1, // #0 = $src
/*23458*/       OPC_CheckPatternPredicate, 4, // (Subtarget->hasSSE41())
/*23460*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PMOVSXDQrr), 0,
                    1/*#VTs*/, MVT::v2i64, 1/*#Ops*/, 0, 
                // Src: (intrinsic_wo_chain:v2i64 639:iPTR, VR128:v4i32:$src)
                // Dst: (PMOVSXDQrr:v2i64 VR128:v4i32:$src)
/*23468*/     0, /*End of Scope*/
/*23469*/   /*Scope*/ 20|128,1/*148*/, /*->23619*/
/*23471*/     OPC_CheckInteger, 4|128,5/*644*/, 
/*23474*/     OPC_MoveParent,
/*23475*/     OPC_Scope, 0|128,1/*128*/, /*->23606*/ // 2 children in Scope
/*23478*/       OPC_MoveChild, 1,
/*23480*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*23482*/       OPC_MoveChild, 0,
/*23484*/       OPC_SwitchOpcode /*3 cases */, 46,  X86ISD::VZEXT_MOVL,// ->23533
/*23487*/         OPC_MoveChild, 0,
/*23489*/         OPC_CheckOpcode, ISD::SCALAR_TO_VECTOR,
/*23491*/         OPC_MoveChild, 0,
/*23493*/         OPC_CheckOpcode, ISD::LOAD,
/*23495*/         OPC_RecordMemRef,
/*23496*/         OPC_RecordNode, // #0 = 'ld' chained node
/*23497*/         OPC_CheckFoldableChainNode,
/*23498*/         OPC_RecordChild1, // #1 = $src
/*23499*/         OPC_CheckPredicate, 2, // Predicate_unindexedload
/*23501*/         OPC_CheckPredicate, 8, // Predicate_load
/*23503*/         OPC_CheckPredicate, 9, // Predicate_dsload
/*23505*/         OPC_CheckType, MVT::i64,
/*23507*/         OPC_MoveParent,
/*23508*/         OPC_MoveParent,
/*23509*/         OPC_CheckType, MVT::v2i64,
/*23511*/         OPC_MoveParent,
/*23512*/         OPC_MoveParent,
/*23513*/         OPC_CheckPatternPredicate, 4, // (Subtarget->hasSSE41())
/*23515*/         OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*23518*/         OPC_EmitMergeInputChains, 1, 0, 
/*23521*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::PMOVZXBWrm), 0|OPFL_Chain|OPFL_MemRefs,
                      1/*#VTs*/, MVT::v8i16, 5/*#Ops*/, 2, 3, 4, 5, 6, 
                  // Src: (intrinsic_wo_chain:v8i16 644:iPTR, (bitconvert:v16i8 (X86vzmovl:v2i64 (scalar_to_vector:v2i64 (ld:i64 addr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>))))
                  // Dst: (PMOVZXBWrm:v8i16 addr:iPTR:$src)
                /*SwitchOpcode*/ 41,  ISD::SCALAR_TO_VECTOR,// ->23576
/*23535*/         OPC_MoveChild, 0,
/*23537*/         OPC_CheckOpcode, ISD::LOAD,
/*23539*/         OPC_RecordMemRef,
/*23540*/         OPC_RecordNode, // #0 = 'ld' chained node
/*23541*/         OPC_CheckFoldableChainNode,
/*23542*/         OPC_RecordChild1, // #1 = $src
/*23543*/         OPC_CheckPredicate, 2, // Predicate_unindexedload
/*23545*/         OPC_CheckPredicate, 8, // Predicate_load
/*23547*/         OPC_CheckPredicate, 9, // Predicate_dsload
/*23549*/         OPC_CheckType, MVT::i64,
/*23551*/         OPC_MoveParent,
/*23552*/         OPC_CheckType, MVT::v2i64,
/*23554*/         OPC_MoveParent,
/*23555*/         OPC_MoveParent,
/*23556*/         OPC_CheckPatternPredicate, 4, // (Subtarget->hasSSE41())
/*23558*/         OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*23561*/         OPC_EmitMergeInputChains, 1, 0, 
/*23564*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::PMOVZXBWrm), 0|OPFL_Chain|OPFL_MemRefs,
                      1/*#VTs*/, MVT::v8i16, 5/*#Ops*/, 2, 3, 4, 5, 6, 
                  // Src: (intrinsic_wo_chain:v8i16 644:iPTR, (bitconvert:v16i8 (scalar_to_vector:v2i64 (ld:i64 addr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>)))
                  // Dst: (PMOVZXBWrm:v8i16 addr:iPTR:$src)
                /*SwitchOpcode*/ 27,  X86ISD::VZEXT_LOAD,// ->23605
/*23578*/         OPC_RecordNode, // #0 = 'X86vzload' chained node
/*23579*/         OPC_CheckFoldableChainNode,
/*23580*/         OPC_RecordChild1, // #1 = $src
/*23581*/         OPC_CheckType, MVT::v2i64,
/*23583*/         OPC_MoveParent,
/*23584*/         OPC_MoveParent,
/*23585*/         OPC_CheckPatternPredicate, 4, // (Subtarget->hasSSE41())
/*23587*/         OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*23590*/         OPC_EmitMergeInputChains, 1, 0, 
/*23593*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::PMOVZXBWrm), 0|OPFL_Chain,
                      1/*#VTs*/, MVT::v8i16, 5/*#Ops*/, 2, 3, 4, 5, 6, 
                  // Src: (intrinsic_wo_chain:v8i16 644:iPTR, (bitconvert:v16i8 (X86vzload:v2i64 addr:iPTR:$src)))
                  // Dst: (PMOVZXBWrm:v8i16 addr:iPTR:$src)
                0, // EndSwitchOpcode
/*23606*/     /*Scope*/ 11, /*->23618*/
/*23607*/       OPC_RecordChild1, // #0 = $src
/*23608*/       OPC_CheckPatternPredicate, 4, // (Subtarget->hasSSE41())
/*23610*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PMOVZXBWrr), 0,
                    1/*#VTs*/, MVT::v8i16, 1/*#Ops*/, 0, 
                // Src: (intrinsic_wo_chain:v8i16 644:iPTR, VR128:v16i8:$src)
                // Dst: (PMOVZXBWrr:v8i16 VR128:v16i8:$src)
/*23618*/     0, /*End of Scope*/
/*23619*/   /*Scope*/ 20|128,1/*148*/, /*->23769*/
/*23621*/     OPC_CheckInteger, 6|128,5/*646*/, 
/*23624*/     OPC_MoveParent,
/*23625*/     OPC_Scope, 0|128,1/*128*/, /*->23756*/ // 2 children in Scope
/*23628*/       OPC_MoveChild, 1,
/*23630*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*23632*/       OPC_MoveChild, 0,
/*23634*/       OPC_SwitchOpcode /*3 cases */, 46,  X86ISD::VZEXT_MOVL,// ->23683
/*23637*/         OPC_MoveChild, 0,
/*23639*/         OPC_CheckOpcode, ISD::SCALAR_TO_VECTOR,
/*23641*/         OPC_MoveChild, 0,
/*23643*/         OPC_CheckOpcode, ISD::LOAD,
/*23645*/         OPC_RecordMemRef,
/*23646*/         OPC_RecordNode, // #0 = 'ld' chained node
/*23647*/         OPC_CheckFoldableChainNode,
/*23648*/         OPC_RecordChild1, // #1 = $src
/*23649*/         OPC_CheckPredicate, 2, // Predicate_unindexedload
/*23651*/         OPC_CheckPredicate, 8, // Predicate_load
/*23653*/         OPC_CheckPredicate, 9, // Predicate_dsload
/*23655*/         OPC_CheckType, MVT::i64,
/*23657*/         OPC_MoveParent,
/*23658*/         OPC_MoveParent,
/*23659*/         OPC_CheckType, MVT::v2i64,
/*23661*/         OPC_MoveParent,
/*23662*/         OPC_MoveParent,
/*23663*/         OPC_CheckPatternPredicate, 4, // (Subtarget->hasSSE41())
/*23665*/         OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*23668*/         OPC_EmitMergeInputChains, 1, 0, 
/*23671*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::PMOVZXWDrm), 0|OPFL_Chain|OPFL_MemRefs,
                      1/*#VTs*/, MVT::v4i32, 5/*#Ops*/, 2, 3, 4, 5, 6, 
                  // Src: (intrinsic_wo_chain:v4i32 646:iPTR, (bitconvert:v8i16 (X86vzmovl:v2i64 (scalar_to_vector:v2i64 (ld:i64 addr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>))))
                  // Dst: (PMOVZXWDrm:v4i32 addr:iPTR:$src)
                /*SwitchOpcode*/ 41,  ISD::SCALAR_TO_VECTOR,// ->23726
/*23685*/         OPC_MoveChild, 0,
/*23687*/         OPC_CheckOpcode, ISD::LOAD,
/*23689*/         OPC_RecordMemRef,
/*23690*/         OPC_RecordNode, // #0 = 'ld' chained node
/*23691*/         OPC_CheckFoldableChainNode,
/*23692*/         OPC_RecordChild1, // #1 = $src
/*23693*/         OPC_CheckPredicate, 2, // Predicate_unindexedload
/*23695*/         OPC_CheckPredicate, 8, // Predicate_load
/*23697*/         OPC_CheckPredicate, 9, // Predicate_dsload
/*23699*/         OPC_CheckType, MVT::i64,
/*23701*/         OPC_MoveParent,
/*23702*/         OPC_CheckType, MVT::v2i64,
/*23704*/         OPC_MoveParent,
/*23705*/         OPC_MoveParent,
/*23706*/         OPC_CheckPatternPredicate, 4, // (Subtarget->hasSSE41())
/*23708*/         OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*23711*/         OPC_EmitMergeInputChains, 1, 0, 
/*23714*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::PMOVZXWDrm), 0|OPFL_Chain|OPFL_MemRefs,
                      1/*#VTs*/, MVT::v4i32, 5/*#Ops*/, 2, 3, 4, 5, 6, 
                  // Src: (intrinsic_wo_chain:v4i32 646:iPTR, (bitconvert:v8i16 (scalar_to_vector:v2i64 (ld:i64 addr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>)))
                  // Dst: (PMOVZXWDrm:v4i32 addr:iPTR:$src)
                /*SwitchOpcode*/ 27,  X86ISD::VZEXT_LOAD,// ->23755
/*23728*/         OPC_RecordNode, // #0 = 'X86vzload' chained node
/*23729*/         OPC_CheckFoldableChainNode,
/*23730*/         OPC_RecordChild1, // #1 = $src
/*23731*/         OPC_CheckType, MVT::v2i64,
/*23733*/         OPC_MoveParent,
/*23734*/         OPC_MoveParent,
/*23735*/         OPC_CheckPatternPredicate, 4, // (Subtarget->hasSSE41())
/*23737*/         OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*23740*/         OPC_EmitMergeInputChains, 1, 0, 
/*23743*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::PMOVZXWDrm), 0|OPFL_Chain,
                      1/*#VTs*/, MVT::v4i32, 5/*#Ops*/, 2, 3, 4, 5, 6, 
                  // Src: (intrinsic_wo_chain:v4i32 646:iPTR, (bitconvert:v8i16 (X86vzload:v2i64 addr:iPTR:$src)))
                  // Dst: (PMOVZXWDrm:v4i32 addr:iPTR:$src)
                0, // EndSwitchOpcode
/*23756*/     /*Scope*/ 11, /*->23768*/
/*23757*/       OPC_RecordChild1, // #0 = $src
/*23758*/       OPC_CheckPatternPredicate, 4, // (Subtarget->hasSSE41())
/*23760*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PMOVZXWDrr), 0,
                    1/*#VTs*/, MVT::v4i32, 1/*#Ops*/, 0, 
                // Src: (intrinsic_wo_chain:v4i32 646:iPTR, VR128:v8i16:$src)
                // Dst: (PMOVZXWDrr:v4i32 VR128:v8i16:$src)
/*23768*/     0, /*End of Scope*/
/*23769*/   /*Scope*/ 20|128,1/*148*/, /*->23919*/
/*23771*/     OPC_CheckInteger, 5|128,5/*645*/, 
/*23774*/     OPC_MoveParent,
/*23775*/     OPC_Scope, 0|128,1/*128*/, /*->23906*/ // 2 children in Scope
/*23778*/       OPC_MoveChild, 1,
/*23780*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*23782*/       OPC_MoveChild, 0,
/*23784*/       OPC_SwitchOpcode /*3 cases */, 46,  X86ISD::VZEXT_MOVL,// ->23833
/*23787*/         OPC_MoveChild, 0,
/*23789*/         OPC_CheckOpcode, ISD::SCALAR_TO_VECTOR,
/*23791*/         OPC_MoveChild, 0,
/*23793*/         OPC_CheckOpcode, ISD::LOAD,
/*23795*/         OPC_RecordMemRef,
/*23796*/         OPC_RecordNode, // #0 = 'ld' chained node
/*23797*/         OPC_CheckFoldableChainNode,
/*23798*/         OPC_RecordChild1, // #1 = $src
/*23799*/         OPC_CheckPredicate, 2, // Predicate_unindexedload
/*23801*/         OPC_CheckPredicate, 8, // Predicate_load
/*23803*/         OPC_CheckPredicate, 9, // Predicate_dsload
/*23805*/         OPC_CheckType, MVT::i64,
/*23807*/         OPC_MoveParent,
/*23808*/         OPC_MoveParent,
/*23809*/         OPC_CheckType, MVT::v2i64,
/*23811*/         OPC_MoveParent,
/*23812*/         OPC_MoveParent,
/*23813*/         OPC_CheckPatternPredicate, 4, // (Subtarget->hasSSE41())
/*23815*/         OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*23818*/         OPC_EmitMergeInputChains, 1, 0, 
/*23821*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::PMOVZXDQrm), 0|OPFL_Chain|OPFL_MemRefs,
                      1/*#VTs*/, MVT::v2i64, 5/*#Ops*/, 2, 3, 4, 5, 6, 
                  // Src: (intrinsic_wo_chain:v2i64 645:iPTR, (bitconvert:v4i32 (X86vzmovl:v2i64 (scalar_to_vector:v2i64 (ld:i64 addr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>))))
                  // Dst: (PMOVZXDQrm:v2i64 addr:iPTR:$src)
                /*SwitchOpcode*/ 41,  ISD::SCALAR_TO_VECTOR,// ->23876
/*23835*/         OPC_MoveChild, 0,
/*23837*/         OPC_CheckOpcode, ISD::LOAD,
/*23839*/         OPC_RecordMemRef,
/*23840*/         OPC_RecordNode, // #0 = 'ld' chained node
/*23841*/         OPC_CheckFoldableChainNode,
/*23842*/         OPC_RecordChild1, // #1 = $src
/*23843*/         OPC_CheckPredicate, 2, // Predicate_unindexedload
/*23845*/         OPC_CheckPredicate, 8, // Predicate_load
/*23847*/         OPC_CheckPredicate, 9, // Predicate_dsload
/*23849*/         OPC_CheckType, MVT::i64,
/*23851*/         OPC_MoveParent,
/*23852*/         OPC_CheckType, MVT::v2i64,
/*23854*/         OPC_MoveParent,
/*23855*/         OPC_MoveParent,
/*23856*/         OPC_CheckPatternPredicate, 4, // (Subtarget->hasSSE41())
/*23858*/         OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*23861*/         OPC_EmitMergeInputChains, 1, 0, 
/*23864*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::PMOVZXDQrm), 0|OPFL_Chain|OPFL_MemRefs,
                      1/*#VTs*/, MVT::v2i64, 5/*#Ops*/, 2, 3, 4, 5, 6, 
                  // Src: (intrinsic_wo_chain:v2i64 645:iPTR, (bitconvert:v4i32 (scalar_to_vector:v2i64 (ld:i64 addr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>)))
                  // Dst: (PMOVZXDQrm:v2i64 addr:iPTR:$src)
                /*SwitchOpcode*/ 27,  X86ISD::VZEXT_LOAD,// ->23905
/*23878*/         OPC_RecordNode, // #0 = 'X86vzload' chained node
/*23879*/         OPC_CheckFoldableChainNode,
/*23880*/         OPC_RecordChild1, // #1 = $src
/*23881*/         OPC_CheckType, MVT::v2i64,
/*23883*/         OPC_MoveParent,
/*23884*/         OPC_MoveParent,
/*23885*/         OPC_CheckPatternPredicate, 4, // (Subtarget->hasSSE41())
/*23887*/         OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*23890*/         OPC_EmitMergeInputChains, 1, 0, 
/*23893*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::PMOVZXDQrm), 0|OPFL_Chain,
                      1/*#VTs*/, MVT::v2i64, 5/*#Ops*/, 2, 3, 4, 5, 6, 
                  // Src: (intrinsic_wo_chain:v2i64 645:iPTR, (bitconvert:v4i32 (X86vzload:v2i64 addr:iPTR:$src)))
                  // Dst: (PMOVZXDQrm:v2i64 addr:iPTR:$src)
                0, // EndSwitchOpcode
/*23906*/     /*Scope*/ 11, /*->23918*/
/*23907*/       OPC_RecordChild1, // #0 = $src
/*23908*/       OPC_CheckPatternPredicate, 4, // (Subtarget->hasSSE41())
/*23910*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PMOVZXDQrr), 0,
                    1/*#VTs*/, MVT::v2i64, 1/*#Ops*/, 0, 
                // Src: (intrinsic_wo_chain:v2i64 645:iPTR, VR128:v4i32:$src)
                // Dst: (PMOVZXDQrr:v2i64 VR128:v4i32:$src)
/*23918*/     0, /*End of Scope*/
/*23919*/   /*Scope*/ 114, /*->24034*/
/*23920*/     OPC_CheckInteger, 124|128,4/*636*/, 
/*23923*/     OPC_MoveParent,
/*23924*/     OPC_Scope, 95, /*->24021*/ // 2 children in Scope
/*23926*/       OPC_MoveChild, 1,
/*23928*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*23930*/       OPC_MoveChild, 0,
/*23932*/       OPC_SwitchOpcode /*2 cases */, 44,  X86ISD::VZEXT_MOVL,// ->23979
/*23935*/         OPC_MoveChild, 0,
/*23937*/         OPC_CheckOpcode, ISD::SCALAR_TO_VECTOR,
/*23939*/         OPC_MoveChild, 0,
/*23941*/         OPC_CheckOpcode, ISD::LOAD,
/*23943*/         OPC_RecordMemRef,
/*23944*/         OPC_RecordNode, // #0 = 'ld' chained node
/*23945*/         OPC_CheckFoldableChainNode,
/*23946*/         OPC_RecordChild1, // #1 = $src
/*23947*/         OPC_CheckPredicate, 2, // Predicate_unindexedload
/*23949*/         OPC_CheckPredicate, 3, // Predicate_loadi32
/*23951*/         OPC_CheckType, MVT::i32,
/*23953*/         OPC_MoveParent,
/*23954*/         OPC_MoveParent,
/*23955*/         OPC_CheckType, MVT::v4i32,
/*23957*/         OPC_MoveParent,
/*23958*/         OPC_MoveParent,
/*23959*/         OPC_CheckPatternPredicate, 4, // (Subtarget->hasSSE41())
/*23961*/         OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*23964*/         OPC_EmitMergeInputChains, 1, 0, 
/*23967*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::PMOVSXBDrm), 0|OPFL_Chain|OPFL_MemRefs,
                      1/*#VTs*/, MVT::v4i32, 5/*#Ops*/, 2, 3, 4, 5, 6, 
                  // Src: (intrinsic_wo_chain:v4i32 636:iPTR, (bitconvert:v16i8 (X86vzmovl:v4i32 (scalar_to_vector:v4i32 (ld:i32 addr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>))))
                  // Dst: (PMOVSXBDrm:v4i32 addr:iPTR:$src)
                /*SwitchOpcode*/ 39,  ISD::SCALAR_TO_VECTOR,// ->24020
/*23981*/         OPC_MoveChild, 0,
/*23983*/         OPC_CheckOpcode, ISD::LOAD,
/*23985*/         OPC_RecordMemRef,
/*23986*/         OPC_RecordNode, // #0 = 'ld' chained node
/*23987*/         OPC_CheckFoldableChainNode,
/*23988*/         OPC_RecordChild1, // #1 = $src
/*23989*/         OPC_CheckPredicate, 2, // Predicate_unindexedload
/*23991*/         OPC_CheckPredicate, 3, // Predicate_loadi32
/*23993*/         OPC_CheckType, MVT::i32,
/*23995*/         OPC_MoveParent,
/*23996*/         OPC_CheckType, MVT::v4i32,
/*23998*/         OPC_MoveParent,
/*23999*/         OPC_MoveParent,
/*24000*/         OPC_CheckPatternPredicate, 4, // (Subtarget->hasSSE41())
/*24002*/         OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*24005*/         OPC_EmitMergeInputChains, 1, 0, 
/*24008*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::PMOVSXBDrm), 0|OPFL_Chain|OPFL_MemRefs,
                      1/*#VTs*/, MVT::v4i32, 5/*#Ops*/, 2, 3, 4, 5, 6, 
                  // Src: (intrinsic_wo_chain:v4i32 636:iPTR, (bitconvert:v16i8 (scalar_to_vector:v4i32 (ld:i32 addr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)))
                  // Dst: (PMOVSXBDrm:v4i32 addr:iPTR:$src)
                0, // EndSwitchOpcode
/*24021*/     /*Scope*/ 11, /*->24033*/
/*24022*/       OPC_RecordChild1, // #0 = $src
/*24023*/       OPC_CheckPatternPredicate, 4, // (Subtarget->hasSSE41())
/*24025*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PMOVSXBDrr), 0,
                    1/*#VTs*/, MVT::v4i32, 1/*#Ops*/, 0, 
                // Src: (intrinsic_wo_chain:v4i32 636:iPTR, VR128:v16i8:$src)
                // Dst: (PMOVSXBDrr:v4i32 VR128:v16i8:$src)
/*24033*/     0, /*End of Scope*/
/*24034*/   /*Scope*/ 114, /*->24149*/
/*24035*/     OPC_CheckInteger, 1|128,5/*641*/, 
/*24038*/     OPC_MoveParent,
/*24039*/     OPC_Scope, 95, /*->24136*/ // 2 children in Scope
/*24041*/       OPC_MoveChild, 1,
/*24043*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*24045*/       OPC_MoveChild, 0,
/*24047*/       OPC_SwitchOpcode /*2 cases */, 44,  X86ISD::VZEXT_MOVL,// ->24094
/*24050*/         OPC_MoveChild, 0,
/*24052*/         OPC_CheckOpcode, ISD::SCALAR_TO_VECTOR,
/*24054*/         OPC_MoveChild, 0,
/*24056*/         OPC_CheckOpcode, ISD::LOAD,
/*24058*/         OPC_RecordMemRef,
/*24059*/         OPC_RecordNode, // #0 = 'ld' chained node
/*24060*/         OPC_CheckFoldableChainNode,
/*24061*/         OPC_RecordChild1, // #1 = $src
/*24062*/         OPC_CheckPredicate, 2, // Predicate_unindexedload
/*24064*/         OPC_CheckPredicate, 3, // Predicate_loadi32
/*24066*/         OPC_CheckType, MVT::i32,
/*24068*/         OPC_MoveParent,
/*24069*/         OPC_MoveParent,
/*24070*/         OPC_CheckType, MVT::v4i32,
/*24072*/         OPC_MoveParent,
/*24073*/         OPC_MoveParent,
/*24074*/         OPC_CheckPatternPredicate, 4, // (Subtarget->hasSSE41())
/*24076*/         OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*24079*/         OPC_EmitMergeInputChains, 1, 0, 
/*24082*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::PMOVSXWQrm), 0|OPFL_Chain|OPFL_MemRefs,
                      1/*#VTs*/, MVT::v2i64, 5/*#Ops*/, 2, 3, 4, 5, 6, 
                  // Src: (intrinsic_wo_chain:v2i64 641:iPTR, (bitconvert:v8i16 (X86vzmovl:v4i32 (scalar_to_vector:v4i32 (ld:i32 addr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>))))
                  // Dst: (PMOVSXWQrm:v2i64 addr:iPTR:$src)
                /*SwitchOpcode*/ 39,  ISD::SCALAR_TO_VECTOR,// ->24135
/*24096*/         OPC_MoveChild, 0,
/*24098*/         OPC_CheckOpcode, ISD::LOAD,
/*24100*/         OPC_RecordMemRef,
/*24101*/         OPC_RecordNode, // #0 = 'ld' chained node
/*24102*/         OPC_CheckFoldableChainNode,
/*24103*/         OPC_RecordChild1, // #1 = $src
/*24104*/         OPC_CheckPredicate, 2, // Predicate_unindexedload
/*24106*/         OPC_CheckPredicate, 3, // Predicate_loadi32
/*24108*/         OPC_CheckType, MVT::i32,
/*24110*/         OPC_MoveParent,
/*24111*/         OPC_CheckType, MVT::v4i32,
/*24113*/         OPC_MoveParent,
/*24114*/         OPC_MoveParent,
/*24115*/         OPC_CheckPatternPredicate, 4, // (Subtarget->hasSSE41())
/*24117*/         OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*24120*/         OPC_EmitMergeInputChains, 1, 0, 
/*24123*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::PMOVSXWQrm), 0|OPFL_Chain|OPFL_MemRefs,
                      1/*#VTs*/, MVT::v2i64, 5/*#Ops*/, 2, 3, 4, 5, 6, 
                  // Src: (intrinsic_wo_chain:v2i64 641:iPTR, (bitconvert:v8i16 (scalar_to_vector:v4i32 (ld:i32 addr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)))
                  // Dst: (PMOVSXWQrm:v2i64 addr:iPTR:$src)
                0, // EndSwitchOpcode
/*24136*/     /*Scope*/ 11, /*->24148*/
/*24137*/       OPC_RecordChild1, // #0 = $src
/*24138*/       OPC_CheckPatternPredicate, 4, // (Subtarget->hasSSE41())
/*24140*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PMOVSXWQrr), 0,
                    1/*#VTs*/, MVT::v2i64, 1/*#Ops*/, 0, 
                // Src: (intrinsic_wo_chain:v2i64 641:iPTR, VR128:v8i16:$src)
                // Dst: (PMOVSXWQrr:v2i64 VR128:v8i16:$src)
/*24148*/     0, /*End of Scope*/
/*24149*/   /*Scope*/ 114, /*->24264*/
/*24150*/     OPC_CheckInteger, 2|128,5/*642*/, 
/*24153*/     OPC_MoveParent,
/*24154*/     OPC_Scope, 95, /*->24251*/ // 2 children in Scope
/*24156*/       OPC_MoveChild, 1,
/*24158*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*24160*/       OPC_MoveChild, 0,
/*24162*/       OPC_SwitchOpcode /*2 cases */, 44,  X86ISD::VZEXT_MOVL,// ->24209
/*24165*/         OPC_MoveChild, 0,
/*24167*/         OPC_CheckOpcode, ISD::SCALAR_TO_VECTOR,
/*24169*/         OPC_MoveChild, 0,
/*24171*/         OPC_CheckOpcode, ISD::LOAD,
/*24173*/         OPC_RecordMemRef,
/*24174*/         OPC_RecordNode, // #0 = 'ld' chained node
/*24175*/         OPC_CheckFoldableChainNode,
/*24176*/         OPC_RecordChild1, // #1 = $src
/*24177*/         OPC_CheckPredicate, 2, // Predicate_unindexedload
/*24179*/         OPC_CheckPredicate, 3, // Predicate_loadi32
/*24181*/         OPC_CheckType, MVT::i32,
/*24183*/         OPC_MoveParent,
/*24184*/         OPC_MoveParent,
/*24185*/         OPC_CheckType, MVT::v4i32,
/*24187*/         OPC_MoveParent,
/*24188*/         OPC_MoveParent,
/*24189*/         OPC_CheckPatternPredicate, 4, // (Subtarget->hasSSE41())
/*24191*/         OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*24194*/         OPC_EmitMergeInputChains, 1, 0, 
/*24197*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::PMOVZXBDrm), 0|OPFL_Chain|OPFL_MemRefs,
                      1/*#VTs*/, MVT::v4i32, 5/*#Ops*/, 2, 3, 4, 5, 6, 
                  // Src: (intrinsic_wo_chain:v4i32 642:iPTR, (bitconvert:v16i8 (X86vzmovl:v4i32 (scalar_to_vector:v4i32 (ld:i32 addr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>))))
                  // Dst: (PMOVZXBDrm:v4i32 addr:iPTR:$src)
                /*SwitchOpcode*/ 39,  ISD::SCALAR_TO_VECTOR,// ->24250
/*24211*/         OPC_MoveChild, 0,
/*24213*/         OPC_CheckOpcode, ISD::LOAD,
/*24215*/         OPC_RecordMemRef,
/*24216*/         OPC_RecordNode, // #0 = 'ld' chained node
/*24217*/         OPC_CheckFoldableChainNode,
/*24218*/         OPC_RecordChild1, // #1 = $src
/*24219*/         OPC_CheckPredicate, 2, // Predicate_unindexedload
/*24221*/         OPC_CheckPredicate, 3, // Predicate_loadi32
/*24223*/         OPC_CheckType, MVT::i32,
/*24225*/         OPC_MoveParent,
/*24226*/         OPC_CheckType, MVT::v4i32,
/*24228*/         OPC_MoveParent,
/*24229*/         OPC_MoveParent,
/*24230*/         OPC_CheckPatternPredicate, 4, // (Subtarget->hasSSE41())
/*24232*/         OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*24235*/         OPC_EmitMergeInputChains, 1, 0, 
/*24238*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::PMOVZXBDrm), 0|OPFL_Chain|OPFL_MemRefs,
                      1/*#VTs*/, MVT::v4i32, 5/*#Ops*/, 2, 3, 4, 5, 6, 
                  // Src: (intrinsic_wo_chain:v4i32 642:iPTR, (bitconvert:v16i8 (scalar_to_vector:v4i32 (ld:i32 addr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)))
                  // Dst: (PMOVZXBDrm:v4i32 addr:iPTR:$src)
                0, // EndSwitchOpcode
/*24251*/     /*Scope*/ 11, /*->24263*/
/*24252*/       OPC_RecordChild1, // #0 = $src
/*24253*/       OPC_CheckPatternPredicate, 4, // (Subtarget->hasSSE41())
/*24255*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PMOVZXBDrr), 0,
                    1/*#VTs*/, MVT::v4i32, 1/*#Ops*/, 0, 
                // Src: (intrinsic_wo_chain:v4i32 642:iPTR, VR128:v16i8:$src)
                // Dst: (PMOVZXBDrr:v4i32 VR128:v16i8:$src)
/*24263*/     0, /*End of Scope*/
/*24264*/   /*Scope*/ 114, /*->24379*/
/*24265*/     OPC_CheckInteger, 7|128,5/*647*/, 
/*24268*/     OPC_MoveParent,
/*24269*/     OPC_Scope, 95, /*->24366*/ // 2 children in Scope
/*24271*/       OPC_MoveChild, 1,
/*24273*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*24275*/       OPC_MoveChild, 0,
/*24277*/       OPC_SwitchOpcode /*2 cases */, 44,  X86ISD::VZEXT_MOVL,// ->24324
/*24280*/         OPC_MoveChild, 0,
/*24282*/         OPC_CheckOpcode, ISD::SCALAR_TO_VECTOR,
/*24284*/         OPC_MoveChild, 0,
/*24286*/         OPC_CheckOpcode, ISD::LOAD,
/*24288*/         OPC_RecordMemRef,
/*24289*/         OPC_RecordNode, // #0 = 'ld' chained node
/*24290*/         OPC_CheckFoldableChainNode,
/*24291*/         OPC_RecordChild1, // #1 = $src
/*24292*/         OPC_CheckPredicate, 2, // Predicate_unindexedload
/*24294*/         OPC_CheckPredicate, 3, // Predicate_loadi32
/*24296*/         OPC_CheckType, MVT::i32,
/*24298*/         OPC_MoveParent,
/*24299*/         OPC_MoveParent,
/*24300*/         OPC_CheckType, MVT::v4i32,
/*24302*/         OPC_MoveParent,
/*24303*/         OPC_MoveParent,
/*24304*/         OPC_CheckPatternPredicate, 4, // (Subtarget->hasSSE41())
/*24306*/         OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*24309*/         OPC_EmitMergeInputChains, 1, 0, 
/*24312*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::PMOVZXWQrm), 0|OPFL_Chain|OPFL_MemRefs,
                      1/*#VTs*/, MVT::v2i64, 5/*#Ops*/, 2, 3, 4, 5, 6, 
                  // Src: (intrinsic_wo_chain:v2i64 647:iPTR, (bitconvert:v8i16 (X86vzmovl:v4i32 (scalar_to_vector:v4i32 (ld:i32 addr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>))))
                  // Dst: (PMOVZXWQrm:v2i64 addr:iPTR:$src)
                /*SwitchOpcode*/ 39,  ISD::SCALAR_TO_VECTOR,// ->24365
/*24326*/         OPC_MoveChild, 0,
/*24328*/         OPC_CheckOpcode, ISD::LOAD,
/*24330*/         OPC_RecordMemRef,
/*24331*/         OPC_RecordNode, // #0 = 'ld' chained node
/*24332*/         OPC_CheckFoldableChainNode,
/*24333*/         OPC_RecordChild1, // #1 = $src
/*24334*/         OPC_CheckPredicate, 2, // Predicate_unindexedload
/*24336*/         OPC_CheckPredicate, 3, // Predicate_loadi32
/*24338*/         OPC_CheckType, MVT::i32,
/*24340*/         OPC_MoveParent,
/*24341*/         OPC_CheckType, MVT::v4i32,
/*24343*/         OPC_MoveParent,
/*24344*/         OPC_MoveParent,
/*24345*/         OPC_CheckPatternPredicate, 4, // (Subtarget->hasSSE41())
/*24347*/         OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*24350*/         OPC_EmitMergeInputChains, 1, 0, 
/*24353*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::PMOVZXWQrm), 0|OPFL_Chain|OPFL_MemRefs,
                      1/*#VTs*/, MVT::v2i64, 5/*#Ops*/, 2, 3, 4, 5, 6, 
                  // Src: (intrinsic_wo_chain:v2i64 647:iPTR, (bitconvert:v8i16 (scalar_to_vector:v4i32 (ld:i32 addr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)))
                  // Dst: (PMOVZXWQrm:v2i64 addr:iPTR:$src)
                0, // EndSwitchOpcode
/*24366*/     /*Scope*/ 11, /*->24378*/
/*24367*/       OPC_RecordChild1, // #0 = $src
/*24368*/       OPC_CheckPatternPredicate, 4, // (Subtarget->hasSSE41())
/*24370*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PMOVZXWQrr), 0,
                    1/*#VTs*/, MVT::v2i64, 1/*#Ops*/, 0, 
                // Src: (intrinsic_wo_chain:v2i64 647:iPTR, VR128:v8i16:$src)
                // Dst: (PMOVZXWQrr:v2i64 VR128:v8i16:$src)
/*24378*/     0, /*End of Scope*/
/*24379*/   /*Scope*/ 114, /*->24494*/
/*24380*/     OPC_CheckInteger, 125|128,4/*637*/, 
/*24383*/     OPC_MoveParent,
/*24384*/     OPC_Scope, 95, /*->24481*/ // 2 children in Scope
/*24386*/       OPC_MoveChild, 1,
/*24388*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*24390*/       OPC_MoveChild, 0,
/*24392*/       OPC_SwitchOpcode /*2 cases */, 44,  X86ISD::VZEXT_MOVL,// ->24439
/*24395*/         OPC_MoveChild, 0,
/*24397*/         OPC_CheckOpcode, ISD::SCALAR_TO_VECTOR,
/*24399*/         OPC_MoveChild, 0,
/*24401*/         OPC_CheckOpcode, ISD::LOAD,
/*24403*/         OPC_RecordMemRef,
/*24404*/         OPC_RecordNode, // #0 = 'ld' chained node
/*24405*/         OPC_CheckFoldableChainNode,
/*24406*/         OPC_RecordChild1, // #1 = $src
/*24407*/         OPC_CheckPredicate, 2, // Predicate_unindexedload
/*24409*/         OPC_CheckPredicate, 3, // Predicate_loadi32
/*24411*/         OPC_CheckType, MVT::i32,
/*24413*/         OPC_MoveParent,
/*24414*/         OPC_MoveParent,
/*24415*/         OPC_CheckType, MVT::v4i32,
/*24417*/         OPC_MoveParent,
/*24418*/         OPC_MoveParent,
/*24419*/         OPC_CheckPatternPredicate, 4, // (Subtarget->hasSSE41())
/*24421*/         OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*24424*/         OPC_EmitMergeInputChains, 1, 0, 
/*24427*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::PMOVSXBQrm), 0|OPFL_Chain|OPFL_MemRefs,
                      1/*#VTs*/, MVT::v2i64, 5/*#Ops*/, 2, 3, 4, 5, 6, 
                  // Src: (intrinsic_wo_chain:v2i64 637:iPTR, (bitconvert:v16i8 (X86vzmovl:v4i32 (scalar_to_vector:v4i32 (ld:i32 addr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>))))
                  // Dst: (PMOVSXBQrm:v2i64 addr:iPTR:$src)
                /*SwitchOpcode*/ 39,  ISD::SCALAR_TO_VECTOR,// ->24480
/*24441*/         OPC_MoveChild, 0,
/*24443*/         OPC_CheckOpcode, ISD::LOAD,
/*24445*/         OPC_RecordMemRef,
/*24446*/         OPC_RecordNode, // #0 = 'ld' chained node
/*24447*/         OPC_CheckFoldableChainNode,
/*24448*/         OPC_RecordChild1, // #1 = $src
/*24449*/         OPC_CheckPredicate, 2, // Predicate_unindexedload
/*24451*/         OPC_CheckPredicate, 65, // Predicate_loadi16_anyext
/*24453*/         OPC_CheckType, MVT::i32,
/*24455*/         OPC_MoveParent,
/*24456*/         OPC_CheckType, MVT::v4i32,
/*24458*/         OPC_MoveParent,
/*24459*/         OPC_MoveParent,
/*24460*/         OPC_CheckPatternPredicate, 4, // (Subtarget->hasSSE41())
/*24462*/         OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*24465*/         OPC_EmitMergeInputChains, 1, 0, 
/*24468*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::PMOVSXBQrm), 0|OPFL_Chain|OPFL_MemRefs,
                      1/*#VTs*/, MVT::v2i64, 5/*#Ops*/, 2, 3, 4, 5, 6, 
                  // Src: (intrinsic_wo_chain:v2i64 637:iPTR, (bitconvert:v16i8 (scalar_to_vector:v4i32 (ld:i32 addr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_loadi16_anyext>>)))
                  // Dst: (PMOVSXBQrm:v2i64 addr:iPTR:$src)
                0, // EndSwitchOpcode
/*24481*/     /*Scope*/ 11, /*->24493*/
/*24482*/       OPC_RecordChild1, // #0 = $src
/*24483*/       OPC_CheckPatternPredicate, 4, // (Subtarget->hasSSE41())
/*24485*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PMOVSXBQrr), 0,
                    1/*#VTs*/, MVT::v2i64, 1/*#Ops*/, 0, 
                // Src: (intrinsic_wo_chain:v2i64 637:iPTR, VR128:v16i8:$src)
                // Dst: (PMOVSXBQrr:v2i64 VR128:v16i8:$src)
/*24493*/     0, /*End of Scope*/
/*24494*/   /*Scope*/ 114, /*->24609*/
/*24495*/     OPC_CheckInteger, 3|128,5/*643*/, 
/*24498*/     OPC_MoveParent,
/*24499*/     OPC_Scope, 95, /*->24596*/ // 2 children in Scope
/*24501*/       OPC_MoveChild, 1,
/*24503*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*24505*/       OPC_MoveChild, 0,
/*24507*/       OPC_SwitchOpcode /*2 cases */, 44,  X86ISD::VZEXT_MOVL,// ->24554
/*24510*/         OPC_MoveChild, 0,
/*24512*/         OPC_CheckOpcode, ISD::SCALAR_TO_VECTOR,
/*24514*/         OPC_MoveChild, 0,
/*24516*/         OPC_CheckOpcode, ISD::LOAD,
/*24518*/         OPC_RecordMemRef,
/*24519*/         OPC_RecordNode, // #0 = 'ld' chained node
/*24520*/         OPC_CheckFoldableChainNode,
/*24521*/         OPC_RecordChild1, // #1 = $src
/*24522*/         OPC_CheckPredicate, 2, // Predicate_unindexedload
/*24524*/         OPC_CheckPredicate, 3, // Predicate_loadi32
/*24526*/         OPC_CheckType, MVT::i32,
/*24528*/         OPC_MoveParent,
/*24529*/         OPC_MoveParent,
/*24530*/         OPC_CheckType, MVT::v4i32,
/*24532*/         OPC_MoveParent,
/*24533*/         OPC_MoveParent,
/*24534*/         OPC_CheckPatternPredicate, 4, // (Subtarget->hasSSE41())
/*24536*/         OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*24539*/         OPC_EmitMergeInputChains, 1, 0, 
/*24542*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::PMOVZXBQrm), 0|OPFL_Chain|OPFL_MemRefs,
                      1/*#VTs*/, MVT::v2i64, 5/*#Ops*/, 2, 3, 4, 5, 6, 
                  // Src: (intrinsic_wo_chain:v2i64 643:iPTR, (bitconvert:v16i8 (X86vzmovl:v4i32 (scalar_to_vector:v4i32 (ld:i32 addr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>))))
                  // Dst: (PMOVZXBQrm:v2i64 addr:iPTR:$src)
                /*SwitchOpcode*/ 39,  ISD::SCALAR_TO_VECTOR,// ->24595
/*24556*/         OPC_MoveChild, 0,
/*24558*/         OPC_CheckOpcode, ISD::LOAD,
/*24560*/         OPC_RecordMemRef,
/*24561*/         OPC_RecordNode, // #0 = 'ld' chained node
/*24562*/         OPC_CheckFoldableChainNode,
/*24563*/         OPC_RecordChild1, // #1 = $src
/*24564*/         OPC_CheckPredicate, 2, // Predicate_unindexedload
/*24566*/         OPC_CheckPredicate, 65, // Predicate_loadi16_anyext
/*24568*/         OPC_CheckType, MVT::i32,
/*24570*/         OPC_MoveParent,
/*24571*/         OPC_CheckType, MVT::v4i32,
/*24573*/         OPC_MoveParent,
/*24574*/         OPC_MoveParent,
/*24575*/         OPC_CheckPatternPredicate, 4, // (Subtarget->hasSSE41())
/*24577*/         OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*24580*/         OPC_EmitMergeInputChains, 1, 0, 
/*24583*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::PMOVZXBQrm), 0|OPFL_Chain|OPFL_MemRefs,
                      1/*#VTs*/, MVT::v2i64, 5/*#Ops*/, 2, 3, 4, 5, 6, 
                  // Src: (intrinsic_wo_chain:v2i64 643:iPTR, (bitconvert:v16i8 (scalar_to_vector:v4i32 (ld:i32 addr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_loadi16_anyext>>)))
                  // Dst: (PMOVZXBQrm:v2i64 addr:iPTR:$src)
                0, // EndSwitchOpcode
/*24596*/     /*Scope*/ 11, /*->24608*/
/*24597*/       OPC_RecordChild1, // #0 = $src
/*24598*/       OPC_CheckPatternPredicate, 4, // (Subtarget->hasSSE41())
/*24600*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PMOVZXBQrr), 0,
                    1/*#VTs*/, MVT::v2i64, 1/*#Ops*/, 0, 
                // Src: (intrinsic_wo_chain:v2i64 643:iPTR, VR128:v16i8:$src)
                // Dst: (PMOVZXBQrr:v2i64 VR128:v16i8:$src)
/*24608*/     0, /*End of Scope*/
/*24609*/   /*Scope*/ 82, /*->24692*/
/*24610*/     OPC_CheckInteger, 99|128,4/*611*/, 
/*24613*/     OPC_MoveParent,
/*24614*/     OPC_RecordChild1, // #0 = $src1
/*24615*/     OPC_Scope, 52, /*->24669*/ // 2 children in Scope
/*24617*/       OPC_MoveChild, 2,
/*24619*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*24621*/       OPC_MoveChild, 0,
/*24623*/       OPC_CheckOpcode, ISD::LOAD,
/*24625*/       OPC_RecordMemRef,
/*24626*/       OPC_RecordNode, // #1 = 'ld' chained node
/*24627*/       OPC_CheckFoldableChainNode,
/*24628*/       OPC_RecordChild1, // #2 = $src2
/*24629*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*24631*/       OPC_CheckPredicate, 8, // Predicate_load
/*24633*/       OPC_CheckPredicate, 23, // Predicate_memop
/*24635*/       OPC_CheckType, MVT::v16i8,
/*24637*/       OPC_MoveParent,
/*24638*/       OPC_MoveParent,
/*24639*/       OPC_RecordChild3, // #3 = $src3
/*24640*/       OPC_MoveChild, 3,
/*24642*/       OPC_CheckOpcode, ISD::Constant,
/*24644*/       OPC_MoveParent,
/*24645*/       OPC_CheckPatternPredicate, 4, // (Subtarget->hasSSE41())
/*24647*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #4 #5 #6 #7 #8
/*24650*/       OPC_EmitMergeInputChains, 1, 1, 
/*24653*/       OPC_EmitConvertToTarget, 3,
/*24655*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::BLENDPSrmi), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v4f32, 7/*#Ops*/, 0, 4, 5, 6, 7, 8, 9, 
                // Src: (intrinsic_wo_chain:v4f32 611:iPTR, VR128:v4f32:$src1, (bitconvert:v4f32 (ld:v16i8 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>), (imm:i32):$src3)
                // Dst: (BLENDPSrmi:v4f32 VR128:v4f32:$src1, addr:iPTR:$src2, (imm:i32):$src3)
/*24669*/     /*Scope*/ 21, /*->24691*/
/*24670*/       OPC_RecordChild2, // #1 = $src2
/*24671*/       OPC_RecordChild3, // #2 = $src3
/*24672*/       OPC_MoveChild, 3,
/*24674*/       OPC_CheckOpcode, ISD::Constant,
/*24676*/       OPC_MoveParent,
/*24677*/       OPC_CheckPatternPredicate, 4, // (Subtarget->hasSSE41())
/*24679*/       OPC_EmitConvertToTarget, 2,
/*24681*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::BLENDPSrri), 0,
                    1/*#VTs*/, MVT::v4f32, 3/*#Ops*/, 0, 1, 3, 
                // Src: (intrinsic_wo_chain:v4f32 611:iPTR, VR128:v4f32:$src1, VR128:v4f32:$src2, (imm:i32):$src3)
                // Dst: (BLENDPSrri:v4f32 VR128:v4f32:$src1, VR128:v4f32:$src2, (imm:i32):$src3)
/*24691*/     0, /*End of Scope*/
/*24692*/   /*Scope*/ 82, /*->24775*/
/*24693*/     OPC_CheckInteger, 98|128,4/*610*/, 
/*24696*/     OPC_MoveParent,
/*24697*/     OPC_RecordChild1, // #0 = $src1
/*24698*/     OPC_Scope, 52, /*->24752*/ // 2 children in Scope
/*24700*/       OPC_MoveChild, 2,
/*24702*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*24704*/       OPC_MoveChild, 0,
/*24706*/       OPC_CheckOpcode, ISD::LOAD,
/*24708*/       OPC_RecordMemRef,
/*24709*/       OPC_RecordNode, // #1 = 'ld' chained node
/*24710*/       OPC_CheckFoldableChainNode,
/*24711*/       OPC_RecordChild1, // #2 = $src2
/*24712*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*24714*/       OPC_CheckPredicate, 8, // Predicate_load
/*24716*/       OPC_CheckPredicate, 23, // Predicate_memop
/*24718*/       OPC_CheckType, MVT::v16i8,
/*24720*/       OPC_MoveParent,
/*24721*/       OPC_MoveParent,
/*24722*/       OPC_RecordChild3, // #3 = $src3
/*24723*/       OPC_MoveChild, 3,
/*24725*/       OPC_CheckOpcode, ISD::Constant,
/*24727*/       OPC_MoveParent,
/*24728*/       OPC_CheckPatternPredicate, 4, // (Subtarget->hasSSE41())
/*24730*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #4 #5 #6 #7 #8
/*24733*/       OPC_EmitMergeInputChains, 1, 1, 
/*24736*/       OPC_EmitConvertToTarget, 3,
/*24738*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::BLENDPDrmi), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v2f64, 7/*#Ops*/, 0, 4, 5, 6, 7, 8, 9, 
                // Src: (intrinsic_wo_chain:v2f64 610:iPTR, VR128:v2f64:$src1, (bitconvert:v2f64 (ld:v16i8 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>), (imm:i32):$src3)
                // Dst: (BLENDPDrmi:v2f64 VR128:v2f64:$src1, addr:iPTR:$src2, (imm:i32):$src3)
/*24752*/     /*Scope*/ 21, /*->24774*/
/*24753*/       OPC_RecordChild2, // #1 = $src2
/*24754*/       OPC_RecordChild3, // #2 = $src3
/*24755*/       OPC_MoveChild, 3,
/*24757*/       OPC_CheckOpcode, ISD::Constant,
/*24759*/       OPC_MoveParent,
/*24760*/       OPC_CheckPatternPredicate, 4, // (Subtarget->hasSSE41())
/*24762*/       OPC_EmitConvertToTarget, 2,
/*24764*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::BLENDPDrri), 0,
                    1/*#VTs*/, MVT::v2f64, 3/*#Ops*/, 0, 1, 3, 
                // Src: (intrinsic_wo_chain:v2f64 610:iPTR, VR128:v2f64:$src1, VR128:v2f64:$src2, (imm:i32):$src3)
                // Dst: (BLENDPDrri:v2f64 VR128:v2f64:$src1, VR128:v2f64:$src2, (imm:i32):$src3)
/*24774*/     0, /*End of Scope*/
/*24775*/   /*Scope*/ 82, /*->24858*/
/*24776*/     OPC_CheckInteger, 110|128,4/*622*/, 
/*24779*/     OPC_MoveParent,
/*24780*/     OPC_RecordChild1, // #0 = $src1
/*24781*/     OPC_Scope, 52, /*->24835*/ // 2 children in Scope
/*24783*/       OPC_MoveChild, 2,
/*24785*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*24787*/       OPC_MoveChild, 0,
/*24789*/       OPC_CheckOpcode, ISD::LOAD,
/*24791*/       OPC_RecordMemRef,
/*24792*/       OPC_RecordNode, // #1 = 'ld' chained node
/*24793*/       OPC_CheckFoldableChainNode,
/*24794*/       OPC_RecordChild1, // #2 = $src2
/*24795*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*24797*/       OPC_CheckPredicate, 8, // Predicate_load
/*24799*/       OPC_CheckPredicate, 23, // Predicate_memop
/*24801*/       OPC_CheckType, MVT::v16i8,
/*24803*/       OPC_MoveParent,
/*24804*/       OPC_MoveParent,
/*24805*/       OPC_RecordChild3, // #3 = $src3
/*24806*/       OPC_MoveChild, 3,
/*24808*/       OPC_CheckOpcode, ISD::Constant,
/*24810*/       OPC_MoveParent,
/*24811*/       OPC_CheckPatternPredicate, 4, // (Subtarget->hasSSE41())
/*24813*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #4 #5 #6 #7 #8
/*24816*/       OPC_EmitMergeInputChains, 1, 1, 
/*24819*/       OPC_EmitConvertToTarget, 3,
/*24821*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PBLENDWrmi), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v8i16, 7/*#Ops*/, 0, 4, 5, 6, 7, 8, 9, 
                // Src: (intrinsic_wo_chain:v8i16 622:iPTR, VR128:v8i16:$src1, (bitconvert:v8i16 (ld:v16i8 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>), (imm:i32):$src3)
                // Dst: (PBLENDWrmi:v8i16 VR128:v8i16:$src1, addr:iPTR:$src2, (imm:i32):$src3)
/*24835*/     /*Scope*/ 21, /*->24857*/
/*24836*/       OPC_RecordChild2, // #1 = $src2
/*24837*/       OPC_RecordChild3, // #2 = $src3
/*24838*/       OPC_MoveChild, 3,
/*24840*/       OPC_CheckOpcode, ISD::Constant,
/*24842*/       OPC_MoveParent,
/*24843*/       OPC_CheckPatternPredicate, 4, // (Subtarget->hasSSE41())
/*24845*/       OPC_EmitConvertToTarget, 2,
/*24847*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PBLENDWrri), 0,
                    1/*#VTs*/, MVT::v8i16, 3/*#Ops*/, 0, 1, 3, 
                // Src: (intrinsic_wo_chain:v8i16 622:iPTR, VR128:v8i16:$src1, VR128:v8i16:$src2, (imm:i32):$src3)
                // Dst: (PBLENDWrri:v8i16 VR128:v8i16:$src1, VR128:v8i16:$src2, (imm:i32):$src3)
/*24857*/     0, /*End of Scope*/
/*24858*/   /*Scope*/ 9|128,1/*137*/, /*->24997*/
/*24860*/     OPC_CheckInteger, 103|128,4/*615*/, 
/*24863*/     OPC_MoveParent,
/*24864*/     OPC_Scope, 53, /*->24919*/ // 3 children in Scope
/*24866*/       OPC_RecordChild1, // #0 = $src1
/*24867*/       OPC_MoveChild, 2,
/*24869*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*24871*/       OPC_MoveChild, 0,
/*24873*/       OPC_CheckOpcode, ISD::LOAD,
/*24875*/       OPC_RecordMemRef,
/*24876*/       OPC_RecordNode, // #1 = 'ld' chained node
/*24877*/       OPC_CheckFoldableChainNode,
/*24878*/       OPC_RecordChild1, // #2 = $src2
/*24879*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*24881*/       OPC_CheckPredicate, 8, // Predicate_load
/*24883*/       OPC_CheckPredicate, 23, // Predicate_memop
/*24885*/       OPC_CheckType, MVT::v16i8,
/*24887*/       OPC_MoveParent,
/*24888*/       OPC_MoveParent,
/*24889*/       OPC_RecordChild3, // #3 = $src3
/*24890*/       OPC_MoveChild, 3,
/*24892*/       OPC_CheckOpcode, ISD::Constant,
/*24894*/       OPC_MoveParent,
/*24895*/       OPC_CheckPatternPredicate, 4, // (Subtarget->hasSSE41())
/*24897*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #4 #5 #6 #7 #8
/*24900*/       OPC_EmitMergeInputChains, 1, 1, 
/*24903*/       OPC_EmitConvertToTarget, 3,
/*24905*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::DPPSrmi), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v4f32, 7/*#Ops*/, 0, 4, 5, 6, 7, 8, 9, 
                // Src: (intrinsic_wo_chain:v4f32 615:iPTR, VR128:v4f32:$src1, (bitconvert:v4f32 (ld:v16i8 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>), (imm:i32):$src3)
                // Dst: (DPPSrmi:v4f32 VR128:v4f32:$src1, addr:iPTR:$src2, (imm:i32):$src3)
/*24919*/     /*Scope*/ 53, /*->24973*/
/*24920*/       OPC_MoveChild, 1,
/*24922*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*24924*/       OPC_MoveChild, 0,
/*24926*/       OPC_CheckOpcode, ISD::LOAD,
/*24928*/       OPC_RecordMemRef,
/*24929*/       OPC_RecordNode, // #0 = 'ld' chained node
/*24930*/       OPC_CheckFoldableChainNode,
/*24931*/       OPC_RecordChild1, // #1 = $src2
/*24932*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*24934*/       OPC_CheckPredicate, 8, // Predicate_load
/*24936*/       OPC_CheckPredicate, 23, // Predicate_memop
/*24938*/       OPC_CheckType, MVT::v16i8,
/*24940*/       OPC_MoveParent,
/*24941*/       OPC_MoveParent,
/*24942*/       OPC_RecordChild2, // #2 = $src1
/*24943*/       OPC_RecordChild3, // #3 = $src3
/*24944*/       OPC_MoveChild, 3,
/*24946*/       OPC_CheckOpcode, ISD::Constant,
/*24948*/       OPC_MoveParent,
/*24949*/       OPC_CheckPatternPredicate, 4, // (Subtarget->hasSSE41())
/*24951*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src2 #4 #5 #6 #7 #8
/*24954*/       OPC_EmitMergeInputChains, 1, 0, 
/*24957*/       OPC_EmitConvertToTarget, 3,
/*24959*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::DPPSrmi), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v4f32, 7/*#Ops*/, 2, 4, 5, 6, 7, 8, 9, 
                // Src: (intrinsic_wo_chain:v4f32 615:iPTR, (bitconvert:v4f32 (ld:v16i8 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>), VR128:v4f32:$src1, (imm:i32):$src3)
                // Dst: (DPPSrmi:v4f32 VR128:v4f32:$src1, addr:iPTR:$src2, (imm:i32):$src3)
/*24973*/     /*Scope*/ 22, /*->24996*/
/*24974*/       OPC_RecordChild1, // #0 = $src1
/*24975*/       OPC_RecordChild2, // #1 = $src2
/*24976*/       OPC_RecordChild3, // #2 = $src3
/*24977*/       OPC_MoveChild, 3,
/*24979*/       OPC_CheckOpcode, ISD::Constant,
/*24981*/       OPC_MoveParent,
/*24982*/       OPC_CheckPatternPredicate, 4, // (Subtarget->hasSSE41())
/*24984*/       OPC_EmitConvertToTarget, 2,
/*24986*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::DPPSrri), 0,
                    1/*#VTs*/, MVT::v4f32, 3/*#Ops*/, 0, 1, 3, 
                // Src: (intrinsic_wo_chain:v4f32 615:iPTR, VR128:v4f32:$src1, VR128:v4f32:$src2, (imm:i32):$src3)
                // Dst: (DPPSrri:v4f32 VR128:v4f32:$src1, VR128:v4f32:$src2, (imm:i32):$src3)
/*24996*/     0, /*End of Scope*/
/*24997*/   /*Scope*/ 9|128,1/*137*/, /*->25136*/
/*24999*/     OPC_CheckInteger, 102|128,4/*614*/, 
/*25002*/     OPC_MoveParent,
/*25003*/     OPC_Scope, 53, /*->25058*/ // 3 children in Scope
/*25005*/       OPC_RecordChild1, // #0 = $src1
/*25006*/       OPC_MoveChild, 2,
/*25008*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*25010*/       OPC_MoveChild, 0,
/*25012*/       OPC_CheckOpcode, ISD::LOAD,
/*25014*/       OPC_RecordMemRef,
/*25015*/       OPC_RecordNode, // #1 = 'ld' chained node
/*25016*/       OPC_CheckFoldableChainNode,
/*25017*/       OPC_RecordChild1, // #2 = $src2
/*25018*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*25020*/       OPC_CheckPredicate, 8, // Predicate_load
/*25022*/       OPC_CheckPredicate, 23, // Predicate_memop
/*25024*/       OPC_CheckType, MVT::v16i8,
/*25026*/       OPC_MoveParent,
/*25027*/       OPC_MoveParent,
/*25028*/       OPC_RecordChild3, // #3 = $src3
/*25029*/       OPC_MoveChild, 3,
/*25031*/       OPC_CheckOpcode, ISD::Constant,
/*25033*/       OPC_MoveParent,
/*25034*/       OPC_CheckPatternPredicate, 4, // (Subtarget->hasSSE41())
/*25036*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #4 #5 #6 #7 #8
/*25039*/       OPC_EmitMergeInputChains, 1, 1, 
/*25042*/       OPC_EmitConvertToTarget, 3,
/*25044*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::DPPDrmi), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v2f64, 7/*#Ops*/, 0, 4, 5, 6, 7, 8, 9, 
                // Src: (intrinsic_wo_chain:v2f64 614:iPTR, VR128:v2f64:$src1, (bitconvert:v2f64 (ld:v16i8 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>), (imm:i32):$src3)
                // Dst: (DPPDrmi:v2f64 VR128:v2f64:$src1, addr:iPTR:$src2, (imm:i32):$src3)
/*25058*/     /*Scope*/ 53, /*->25112*/
/*25059*/       OPC_MoveChild, 1,
/*25061*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*25063*/       OPC_MoveChild, 0,
/*25065*/       OPC_CheckOpcode, ISD::LOAD,
/*25067*/       OPC_RecordMemRef,
/*25068*/       OPC_RecordNode, // #0 = 'ld' chained node
/*25069*/       OPC_CheckFoldableChainNode,
/*25070*/       OPC_RecordChild1, // #1 = $src2
/*25071*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*25073*/       OPC_CheckPredicate, 8, // Predicate_load
/*25075*/       OPC_CheckPredicate, 23, // Predicate_memop
/*25077*/       OPC_CheckType, MVT::v16i8,
/*25079*/       OPC_MoveParent,
/*25080*/       OPC_MoveParent,
/*25081*/       OPC_RecordChild2, // #2 = $src1
/*25082*/       OPC_RecordChild3, // #3 = $src3
/*25083*/       OPC_MoveChild, 3,
/*25085*/       OPC_CheckOpcode, ISD::Constant,
/*25087*/       OPC_MoveParent,
/*25088*/       OPC_CheckPatternPredicate, 4, // (Subtarget->hasSSE41())
/*25090*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src2 #4 #5 #6 #7 #8
/*25093*/       OPC_EmitMergeInputChains, 1, 0, 
/*25096*/       OPC_EmitConvertToTarget, 3,
/*25098*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::DPPDrmi), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v2f64, 7/*#Ops*/, 2, 4, 5, 6, 7, 8, 9, 
                // Src: (intrinsic_wo_chain:v2f64 614:iPTR, (bitconvert:v2f64 (ld:v16i8 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>), VR128:v2f64:$src1, (imm:i32):$src3)
                // Dst: (DPPDrmi:v2f64 VR128:v2f64:$src1, addr:iPTR:$src2, (imm:i32):$src3)
/*25112*/     /*Scope*/ 22, /*->25135*/
/*25113*/       OPC_RecordChild1, // #0 = $src1
/*25114*/       OPC_RecordChild2, // #1 = $src2
/*25115*/       OPC_RecordChild3, // #2 = $src3
/*25116*/       OPC_MoveChild, 3,
/*25118*/       OPC_CheckOpcode, ISD::Constant,
/*25120*/       OPC_MoveParent,
/*25121*/       OPC_CheckPatternPredicate, 4, // (Subtarget->hasSSE41())
/*25123*/       OPC_EmitConvertToTarget, 2,
/*25125*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::DPPDrri), 0,
                    1/*#VTs*/, MVT::v2f64, 3/*#Ops*/, 0, 1, 3, 
                // Src: (intrinsic_wo_chain:v2f64 614:iPTR, VR128:v2f64:$src1, VR128:v2f64:$src2, (imm:i32):$src3)
                // Dst: (DPPDrri:v2f64 VR128:v2f64:$src1, VR128:v2f64:$src2, (imm:i32):$src3)
/*25135*/     0, /*End of Scope*/
/*25136*/   /*Scope*/ 9|128,1/*137*/, /*->25275*/
/*25138*/     OPC_CheckInteger, 107|128,4/*619*/, 
/*25141*/     OPC_MoveParent,
/*25142*/     OPC_Scope, 53, /*->25197*/ // 3 children in Scope
/*25144*/       OPC_RecordChild1, // #0 = $src1
/*25145*/       OPC_MoveChild, 2,
/*25147*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*25149*/       OPC_MoveChild, 0,
/*25151*/       OPC_CheckOpcode, ISD::LOAD,
/*25153*/       OPC_RecordMemRef,
/*25154*/       OPC_RecordNode, // #1 = 'ld' chained node
/*25155*/       OPC_CheckFoldableChainNode,
/*25156*/       OPC_RecordChild1, // #2 = $src2
/*25157*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*25159*/       OPC_CheckPredicate, 8, // Predicate_load
/*25161*/       OPC_CheckPredicate, 23, // Predicate_memop
/*25163*/       OPC_CheckType, MVT::v16i8,
/*25165*/       OPC_MoveParent,
/*25166*/       OPC_MoveParent,
/*25167*/       OPC_RecordChild3, // #3 = $src3
/*25168*/       OPC_MoveChild, 3,
/*25170*/       OPC_CheckOpcode, ISD::Constant,
/*25172*/       OPC_MoveParent,
/*25173*/       OPC_CheckPatternPredicate, 4, // (Subtarget->hasSSE41())
/*25175*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #4 #5 #6 #7 #8
/*25178*/       OPC_EmitMergeInputChains, 1, 1, 
/*25181*/       OPC_EmitConvertToTarget, 3,
/*25183*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MPSADBWrmi), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v16i8, 7/*#Ops*/, 0, 4, 5, 6, 7, 8, 9, 
                // Src: (intrinsic_wo_chain:v16i8 619:iPTR, VR128:v16i8:$src1, (bitconvert:v16i8 (ld:v16i8 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>), (imm:i32):$src3)
                // Dst: (MPSADBWrmi:v16i8 VR128:v16i8:$src1, addr:iPTR:$src2, (imm:i32):$src3)
/*25197*/     /*Scope*/ 53, /*->25251*/
/*25198*/       OPC_MoveChild, 1,
/*25200*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*25202*/       OPC_MoveChild, 0,
/*25204*/       OPC_CheckOpcode, ISD::LOAD,
/*25206*/       OPC_RecordMemRef,
/*25207*/       OPC_RecordNode, // #0 = 'ld' chained node
/*25208*/       OPC_CheckFoldableChainNode,
/*25209*/       OPC_RecordChild1, // #1 = $src2
/*25210*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*25212*/       OPC_CheckPredicate, 8, // Predicate_load
/*25214*/       OPC_CheckPredicate, 23, // Predicate_memop
/*25216*/       OPC_CheckType, MVT::v16i8,
/*25218*/       OPC_MoveParent,
/*25219*/       OPC_MoveParent,
/*25220*/       OPC_RecordChild2, // #2 = $src1
/*25221*/       OPC_RecordChild3, // #3 = $src3
/*25222*/       OPC_MoveChild, 3,
/*25224*/       OPC_CheckOpcode, ISD::Constant,
/*25226*/       OPC_MoveParent,
/*25227*/       OPC_CheckPatternPredicate, 4, // (Subtarget->hasSSE41())
/*25229*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src2 #4 #5 #6 #7 #8
/*25232*/       OPC_EmitMergeInputChains, 1, 0, 
/*25235*/       OPC_EmitConvertToTarget, 3,
/*25237*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MPSADBWrmi), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v16i8, 7/*#Ops*/, 2, 4, 5, 6, 7, 8, 9, 
                // Src: (intrinsic_wo_chain:v16i8 619:iPTR, (bitconvert:v16i8 (ld:v16i8 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>), VR128:v16i8:$src1, (imm:i32):$src3)
                // Dst: (MPSADBWrmi:v16i8 VR128:v16i8:$src1, addr:iPTR:$src2, (imm:i32):$src3)
/*25251*/     /*Scope*/ 22, /*->25274*/
/*25252*/       OPC_RecordChild1, // #0 = $src1
/*25253*/       OPC_RecordChild2, // #1 = $src2
/*25254*/       OPC_RecordChild3, // #2 = $src3
/*25255*/       OPC_MoveChild, 3,
/*25257*/       OPC_CheckOpcode, ISD::Constant,
/*25259*/       OPC_MoveParent,
/*25260*/       OPC_CheckPatternPredicate, 4, // (Subtarget->hasSSE41())
/*25262*/       OPC_EmitConvertToTarget, 2,
/*25264*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MPSADBWrri), 0,
                    1/*#VTs*/, MVT::v16i8, 3/*#Ops*/, 0, 1, 3, 
                // Src: (intrinsic_wo_chain:v16i8 619:iPTR, VR128:v16i8:$src1, VR128:v16i8:$src2, (imm:i32):$src3)
                // Dst: (MPSADBWrri:v16i8 VR128:v16i8:$src1, VR128:v16i8:$src2, (imm:i32):$src3)
/*25274*/     0, /*End of Scope*/
/*25275*/   /*Scope*/ 73, /*->25349*/
/*25276*/     OPC_CheckInteger, 38|128,5/*678*/, 
/*25279*/     OPC_MoveParent,
/*25280*/     OPC_RecordChild1, // #0 = $src1
/*25281*/     OPC_Scope, 43, /*->25326*/ // 2 children in Scope
/*25283*/       OPC_MoveChild, 2,
/*25285*/       OPC_CheckOpcode, ISD::LOAD,
/*25287*/       OPC_RecordMemRef,
/*25288*/       OPC_RecordNode, // #1 = 'ld' chained node
/*25289*/       OPC_CheckFoldableChainNode,
/*25290*/       OPC_RecordChild1, // #2 = $src
/*25291*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*25293*/       OPC_CheckPredicate, 8, // Predicate_load
/*25295*/       OPC_MoveParent,
/*25296*/       OPC_RecordChild3, // #3 = $cc
/*25297*/       OPC_MoveChild, 3,
/*25299*/       OPC_CheckOpcode, ISD::Constant,
/*25301*/       OPC_MoveParent,
/*25302*/       OPC_CheckPatternPredicate, 0, // (Subtarget->hasSSE1())
/*25304*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src #4 #5 #6 #7 #8
/*25307*/       OPC_EmitMergeInputChains, 1, 1, 
/*25310*/       OPC_EmitConvertToTarget, 3,
/*25312*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::Int_CMPSSrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v4f32, 7/*#Ops*/, 0, 4, 5, 6, 7, 8, 9, 
                // Src: (intrinsic_wo_chain:v4f32 678:iPTR, VR128:v4f32:$src1, (ld:v4f32 addr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:i8):$cc)
                // Dst: (Int_CMPSSrm:v4f32 VR128:v4f32:$src1, addr:iPTR:$src, (imm:i8):$cc)
/*25326*/     /*Scope*/ 21, /*->25348*/
/*25327*/       OPC_RecordChild2, // #1 = $src
/*25328*/       OPC_RecordChild3, // #2 = $cc
/*25329*/       OPC_MoveChild, 3,
/*25331*/       OPC_CheckOpcode, ISD::Constant,
/*25333*/       OPC_MoveParent,
/*25334*/       OPC_CheckPatternPredicate, 0, // (Subtarget->hasSSE1())
/*25336*/       OPC_EmitConvertToTarget, 2,
/*25338*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::Int_CMPSSrr), 0,
                    1/*#VTs*/, MVT::v4f32, 3/*#Ops*/, 0, 1, 3, 
                // Src: (intrinsic_wo_chain:v4f32 678:iPTR, VR128:v4f32:$src1, VR128:v4f32:$src, (imm:i8):$cc)
                // Dst: (Int_CMPSSrr:v4f32 VR128:v4f32:$src1, VR128:v4f32:$src, (imm:i8):$cc)
/*25348*/     0, /*End of Scope*/
/*25349*/   /*Scope*/ 75, /*->25425*/
/*25350*/     OPC_CheckInteger, 37|128,5/*677*/, 
/*25353*/     OPC_MoveParent,
/*25354*/     OPC_RecordChild1, // #0 = $src1
/*25355*/     OPC_Scope, 45, /*->25402*/ // 2 children in Scope
/*25357*/       OPC_MoveChild, 2,
/*25359*/       OPC_CheckOpcode, ISD::LOAD,
/*25361*/       OPC_RecordMemRef,
/*25362*/       OPC_RecordNode, // #1 = 'ld' chained node
/*25363*/       OPC_CheckFoldableChainNode,
/*25364*/       OPC_RecordChild1, // #2 = $src
/*25365*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*25367*/       OPC_CheckPredicate, 8, // Predicate_load
/*25369*/       OPC_CheckPredicate, 23, // Predicate_memop
/*25371*/       OPC_MoveParent,
/*25372*/       OPC_RecordChild3, // #3 = $cc
/*25373*/       OPC_MoveChild, 3,
/*25375*/       OPC_CheckOpcode, ISD::Constant,
/*25377*/       OPC_MoveParent,
/*25378*/       OPC_CheckPatternPredicate, 0, // (Subtarget->hasSSE1())
/*25380*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src #4 #5 #6 #7 #8
/*25383*/       OPC_EmitMergeInputChains, 1, 1, 
/*25386*/       OPC_EmitConvertToTarget, 3,
/*25388*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::CMPPSrmi), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v4f32, 7/*#Ops*/, 0, 4, 5, 6, 7, 8, 9, 
                // Src: (intrinsic_wo_chain:v4f32 677:iPTR, VR128:v4f32:$src1, (ld:v4f32 addr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>, (imm:i8):$cc)
                // Dst: (CMPPSrmi:v4f32 VR128:v4f32:$src1, addr:iPTR:$src, (imm:i8):$cc)
/*25402*/     /*Scope*/ 21, /*->25424*/
/*25403*/       OPC_RecordChild2, // #1 = $src
/*25404*/       OPC_RecordChild3, // #2 = $cc
/*25405*/       OPC_MoveChild, 3,
/*25407*/       OPC_CheckOpcode, ISD::Constant,
/*25409*/       OPC_MoveParent,
/*25410*/       OPC_CheckPatternPredicate, 0, // (Subtarget->hasSSE1())
/*25412*/       OPC_EmitConvertToTarget, 2,
/*25414*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::CMPPSrri), 0,
                    1/*#VTs*/, MVT::v4f32, 3/*#Ops*/, 0, 1, 3, 
                // Src: (intrinsic_wo_chain:v4f32 677:iPTR, VR128:v4f32:$src1, VR128:v4f32:$src, (imm:i8):$cc)
                // Dst: (CMPPSrri:v4f32 VR128:v4f32:$src1, VR128:v4f32:$src, (imm:i8):$cc)
/*25424*/     0, /*End of Scope*/
/*25425*/   /*Scope*/ 73, /*->25499*/
/*25426*/     OPC_CheckInteger, 118|128,3/*502*/, 
/*25429*/     OPC_MoveParent,
/*25430*/     OPC_RecordChild1, // #0 = $src1
/*25431*/     OPC_Scope, 43, /*->25476*/ // 2 children in Scope
/*25433*/       OPC_MoveChild, 2,
/*25435*/       OPC_CheckOpcode, ISD::LOAD,
/*25437*/       OPC_RecordMemRef,
/*25438*/       OPC_RecordNode, // #1 = 'ld' chained node
/*25439*/       OPC_CheckFoldableChainNode,
/*25440*/       OPC_RecordChild1, // #2 = $src
/*25441*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*25443*/       OPC_CheckPredicate, 8, // Predicate_load
/*25445*/       OPC_MoveParent,
/*25446*/       OPC_RecordChild3, // #3 = $cc
/*25447*/       OPC_MoveChild, 3,
/*25449*/       OPC_CheckOpcode, ISD::Constant,
/*25451*/       OPC_MoveParent,
/*25452*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*25454*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src #4 #5 #6 #7 #8
/*25457*/       OPC_EmitMergeInputChains, 1, 1, 
/*25460*/       OPC_EmitConvertToTarget, 3,
/*25462*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::Int_CMPSDrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v2f64, 7/*#Ops*/, 0, 4, 5, 6, 7, 8, 9, 
                // Src: (intrinsic_wo_chain:v2f64 502:iPTR, VR128:v2f64:$src1, (ld:v2f64 addr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:i8):$cc)
                // Dst: (Int_CMPSDrm:v2f64 VR128:v2f64:$src1, addr:iPTR:$src, (imm:i8):$cc)
/*25476*/     /*Scope*/ 21, /*->25498*/
/*25477*/       OPC_RecordChild2, // #1 = $src
/*25478*/       OPC_RecordChild3, // #2 = $cc
/*25479*/       OPC_MoveChild, 3,
/*25481*/       OPC_CheckOpcode, ISD::Constant,
/*25483*/       OPC_MoveParent,
/*25484*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*25486*/       OPC_EmitConvertToTarget, 2,
/*25488*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::Int_CMPSDrr), 0,
                    1/*#VTs*/, MVT::v2f64, 3/*#Ops*/, 0, 1, 3, 
                // Src: (intrinsic_wo_chain:v2f64 502:iPTR, VR128:v2f64:$src1, VR128:v2f64:$src, (imm:i8):$cc)
                // Dst: (Int_CMPSDrr:v2f64 VR128:v2f64:$src1, VR128:v2f64:$src, (imm:i8):$cc)
/*25498*/     0, /*End of Scope*/
/*25499*/   /*Scope*/ 61, /*->25561*/
/*25500*/     OPC_CheckInteger, 126|128,3/*510*/, 
/*25503*/     OPC_MoveParent,
/*25504*/     OPC_Scope, 42, /*->25548*/ // 2 children in Scope
/*25506*/       OPC_MoveChild, 1,
/*25508*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*25510*/       OPC_MoveChild, 0,
/*25512*/       OPC_CheckOpcode, ISD::LOAD,
/*25514*/       OPC_RecordMemRef,
/*25515*/       OPC_RecordNode, // #0 = 'ld' chained node
/*25516*/       OPC_CheckFoldableChainNode,
/*25517*/       OPC_RecordChild1, // #1 = $src
/*25518*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*25520*/       OPC_CheckPredicate, 8, // Predicate_load
/*25522*/       OPC_CheckPredicate, 23, // Predicate_memop
/*25524*/       OPC_CheckType, MVT::v2i64,
/*25526*/       OPC_MoveParent,
/*25527*/       OPC_MoveParent,
/*25528*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*25530*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*25533*/       OPC_EmitMergeInputChains, 1, 0, 
/*25536*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::Int_CVTDQ2PSrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v4f32, 5/*#Ops*/, 2, 3, 4, 5, 6, 
                // Src: (intrinsic_wo_chain:v4f32 510:iPTR, (bitconvert:v4i32 (ld:v2i64 addr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>))
                // Dst: (Int_CVTDQ2PSrm:v4f32 addr:iPTR:$src)
/*25548*/     /*Scope*/ 11, /*->25560*/
/*25549*/       OPC_RecordChild1, // #0 = $src
/*25550*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*25552*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::Int_CVTDQ2PSrr), 0,
                    1/*#VTs*/, MVT::v4f32, 1/*#Ops*/, 0, 
                // Src: (intrinsic_wo_chain:v4f32 510:iPTR, VR128:v4i32:$src)
                // Dst: (Int_CVTDQ2PSrr:v4f32 VR128:v4i32:$src)
/*25560*/     0, /*End of Scope*/
/*25561*/   /*Scope*/ 61, /*->25623*/
/*25562*/     OPC_CheckInteger, 125|128,3/*509*/, 
/*25565*/     OPC_MoveParent,
/*25566*/     OPC_Scope, 42, /*->25610*/ // 2 children in Scope
/*25568*/       OPC_MoveChild, 1,
/*25570*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*25572*/       OPC_MoveChild, 0,
/*25574*/       OPC_CheckOpcode, ISD::LOAD,
/*25576*/       OPC_RecordMemRef,
/*25577*/       OPC_RecordNode, // #0 = 'ld' chained node
/*25578*/       OPC_CheckFoldableChainNode,
/*25579*/       OPC_RecordChild1, // #1 = $src
/*25580*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*25582*/       OPC_CheckPredicate, 8, // Predicate_load
/*25584*/       OPC_CheckPredicate, 23, // Predicate_memop
/*25586*/       OPC_CheckType, MVT::v2i64,
/*25588*/       OPC_MoveParent,
/*25589*/       OPC_MoveParent,
/*25590*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*25592*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*25595*/       OPC_EmitMergeInputChains, 1, 0, 
/*25598*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::Int_CVTDQ2PDrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v2f64, 5/*#Ops*/, 2, 3, 4, 5, 6, 
                // Src: (intrinsic_wo_chain:v2f64 509:iPTR, (bitconvert:v4i32 (ld:v2i64 addr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>))
                // Dst: (Int_CVTDQ2PDrm:v2f64 addr:iPTR:$src)
/*25610*/     /*Scope*/ 11, /*->25622*/
/*25611*/       OPC_RecordChild1, // #0 = $src
/*25612*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*25614*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::Int_CVTDQ2PDrr), 0,
                    1/*#VTs*/, MVT::v2f64, 1/*#Ops*/, 0, 
                // Src: (intrinsic_wo_chain:v2f64 509:iPTR, VR128:v4i32:$src)
                // Dst: (Int_CVTDQ2PDrr:v2f64 VR128:v4i32:$src)
/*25622*/     0, /*End of Scope*/
/*25623*/   /*Scope*/ 75, /*->25699*/
/*25624*/     OPC_CheckInteger, 117|128,3/*501*/, 
/*25627*/     OPC_MoveParent,
/*25628*/     OPC_RecordChild1, // #0 = $src1
/*25629*/     OPC_Scope, 45, /*->25676*/ // 2 children in Scope
/*25631*/       OPC_MoveChild, 2,
/*25633*/       OPC_CheckOpcode, ISD::LOAD,
/*25635*/       OPC_RecordMemRef,
/*25636*/       OPC_RecordNode, // #1 = 'ld' chained node
/*25637*/       OPC_CheckFoldableChainNode,
/*25638*/       OPC_RecordChild1, // #2 = $src
/*25639*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*25641*/       OPC_CheckPredicate, 8, // Predicate_load
/*25643*/       OPC_CheckPredicate, 23, // Predicate_memop
/*25645*/       OPC_MoveParent,
/*25646*/       OPC_RecordChild3, // #3 = $cc
/*25647*/       OPC_MoveChild, 3,
/*25649*/       OPC_CheckOpcode, ISD::Constant,
/*25651*/       OPC_MoveParent,
/*25652*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*25654*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src #4 #5 #6 #7 #8
/*25657*/       OPC_EmitMergeInputChains, 1, 1, 
/*25660*/       OPC_EmitConvertToTarget, 3,
/*25662*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::CMPPDrmi), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v2f64, 7/*#Ops*/, 0, 4, 5, 6, 7, 8, 9, 
                // Src: (intrinsic_wo_chain:v2f64 501:iPTR, VR128:v2f64:$src1, (ld:v2f64 addr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>, (imm:i8):$cc)
                // Dst: (CMPPDrmi:v2f64 VR128:v2f64:$src1, addr:iPTR:$src, (imm:i8):$cc)
/*25676*/     /*Scope*/ 21, /*->25698*/
/*25677*/       OPC_RecordChild2, // #1 = $src
/*25678*/       OPC_RecordChild3, // #2 = $cc
/*25679*/       OPC_MoveChild, 3,
/*25681*/       OPC_CheckOpcode, ISD::Constant,
/*25683*/       OPC_MoveParent,
/*25684*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*25686*/       OPC_EmitConvertToTarget, 2,
/*25688*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::CMPPDrri), 0,
                    1/*#VTs*/, MVT::v2f64, 3/*#Ops*/, 0, 1, 3, 
                // Src: (intrinsic_wo_chain:v2f64 501:iPTR, VR128:v2f64:$src1, VR128:v2f64:$src, (imm:i8):$cc)
                // Dst: (CMPPDrri:v2f64 VR128:v2f64:$src1, VR128:v2f64:$src, (imm:i8):$cc)
/*25698*/     0, /*End of Scope*/
/*25699*/   /*Scope*/ 110, /*->25810*/
/*25700*/     OPC_CheckInteger, 31|128,4/*543*/, 
/*25703*/     OPC_MoveParent,
/*25704*/     OPC_Scope, 44, /*->25750*/ // 3 children in Scope
/*25706*/       OPC_RecordChild1, // #0 = $src1
/*25707*/       OPC_MoveChild, 2,
/*25709*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*25711*/       OPC_MoveChild, 0,
/*25713*/       OPC_CheckOpcode, ISD::LOAD,
/*25715*/       OPC_RecordMemRef,
/*25716*/       OPC_RecordNode, // #1 = 'ld' chained node
/*25717*/       OPC_CheckFoldableChainNode,
/*25718*/       OPC_RecordChild1, // #2 = $src2
/*25719*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*25721*/       OPC_CheckPredicate, 8, // Predicate_load
/*25723*/       OPC_CheckPredicate, 23, // Predicate_memop
/*25725*/       OPC_CheckType, MVT::v2i64,
/*25727*/       OPC_MoveParent,
/*25728*/       OPC_MoveParent,
/*25729*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*25731*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*25734*/       OPC_EmitMergeInputChains, 1, 1, 
/*25737*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PADDSBrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v16i8, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (intrinsic_wo_chain:v16i8 543:iPTR, VR128:v16i8:$src1, (bitconvert:v16i8 (ld:v2i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>))
                // Dst: (PADDSBrm:v16i8 VR128:v16i8:$src1, addr:iPTR:$src2)
/*25750*/     /*Scope*/ 44, /*->25795*/
/*25751*/       OPC_MoveChild, 1,
/*25753*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*25755*/       OPC_MoveChild, 0,
/*25757*/       OPC_CheckOpcode, ISD::LOAD,
/*25759*/       OPC_RecordMemRef,
/*25760*/       OPC_RecordNode, // #0 = 'ld' chained node
/*25761*/       OPC_CheckFoldableChainNode,
/*25762*/       OPC_RecordChild1, // #1 = $src2
/*25763*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*25765*/       OPC_CheckPredicate, 8, // Predicate_load
/*25767*/       OPC_CheckPredicate, 23, // Predicate_memop
/*25769*/       OPC_CheckType, MVT::v2i64,
/*25771*/       OPC_MoveParent,
/*25772*/       OPC_MoveParent,
/*25773*/       OPC_RecordChild2, // #2 = $src1
/*25774*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*25776*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*25779*/       OPC_EmitMergeInputChains, 1, 0, 
/*25782*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PADDSBrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v16i8, 6/*#Ops*/, 2, 3, 4, 5, 6, 7, 
                // Src: (intrinsic_wo_chain:v16i8 543:iPTR, (bitconvert:v16i8 (ld:v2i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>), VR128:v16i8:$src1)
                // Dst: (PADDSBrm:v16i8 VR128:v16i8:$src1, addr:iPTR:$src2)
/*25795*/     /*Scope*/ 13, /*->25809*/
/*25796*/       OPC_RecordChild1, // #0 = $src1
/*25797*/       OPC_RecordChild2, // #1 = $src2
/*25798*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*25800*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PADDSBrr), 0,
                    1/*#VTs*/, MVT::v16i8, 2/*#Ops*/, 0, 1, 
                // Src: (intrinsic_wo_chain:v16i8 543:iPTR, VR128:v16i8:$src1, VR128:v16i8:$src2)
                // Dst: (PADDSBrr:v16i8 VR128:v16i8:$src1, VR128:v16i8:$src2)
/*25809*/     0, /*End of Scope*/
/*25810*/   /*Scope*/ 110, /*->25921*/
/*25811*/     OPC_CheckInteger, 32|128,4/*544*/, 
/*25814*/     OPC_MoveParent,
/*25815*/     OPC_Scope, 44, /*->25861*/ // 3 children in Scope
/*25817*/       OPC_RecordChild1, // #0 = $src1
/*25818*/       OPC_MoveChild, 2,
/*25820*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*25822*/       OPC_MoveChild, 0,
/*25824*/       OPC_CheckOpcode, ISD::LOAD,
/*25826*/       OPC_RecordMemRef,
/*25827*/       OPC_RecordNode, // #1 = 'ld' chained node
/*25828*/       OPC_CheckFoldableChainNode,
/*25829*/       OPC_RecordChild1, // #2 = $src2
/*25830*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*25832*/       OPC_CheckPredicate, 8, // Predicate_load
/*25834*/       OPC_CheckPredicate, 23, // Predicate_memop
/*25836*/       OPC_CheckType, MVT::v2i64,
/*25838*/       OPC_MoveParent,
/*25839*/       OPC_MoveParent,
/*25840*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*25842*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*25845*/       OPC_EmitMergeInputChains, 1, 1, 
/*25848*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PADDSWrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v8i16, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (intrinsic_wo_chain:v8i16 544:iPTR, VR128:v8i16:$src1, (bitconvert:v8i16 (ld:v2i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>))
                // Dst: (PADDSWrm:v8i16 VR128:v8i16:$src1, addr:iPTR:$src2)
/*25861*/     /*Scope*/ 44, /*->25906*/
/*25862*/       OPC_MoveChild, 1,
/*25864*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*25866*/       OPC_MoveChild, 0,
/*25868*/       OPC_CheckOpcode, ISD::LOAD,
/*25870*/       OPC_RecordMemRef,
/*25871*/       OPC_RecordNode, // #0 = 'ld' chained node
/*25872*/       OPC_CheckFoldableChainNode,
/*25873*/       OPC_RecordChild1, // #1 = $src2
/*25874*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*25876*/       OPC_CheckPredicate, 8, // Predicate_load
/*25878*/       OPC_CheckPredicate, 23, // Predicate_memop
/*25880*/       OPC_CheckType, MVT::v2i64,
/*25882*/       OPC_MoveParent,
/*25883*/       OPC_MoveParent,
/*25884*/       OPC_RecordChild2, // #2 = $src1
/*25885*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*25887*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*25890*/       OPC_EmitMergeInputChains, 1, 0, 
/*25893*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PADDSWrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v8i16, 6/*#Ops*/, 2, 3, 4, 5, 6, 7, 
                // Src: (intrinsic_wo_chain:v8i16 544:iPTR, (bitconvert:v8i16 (ld:v2i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>), VR128:v8i16:$src1)
                // Dst: (PADDSWrm:v8i16 VR128:v8i16:$src1, addr:iPTR:$src2)
/*25906*/     /*Scope*/ 13, /*->25920*/
/*25907*/       OPC_RecordChild1, // #0 = $src1
/*25908*/       OPC_RecordChild2, // #1 = $src2
/*25909*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*25911*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PADDSWrr), 0,
                    1/*#VTs*/, MVT::v8i16, 2/*#Ops*/, 0, 1, 
                // Src: (intrinsic_wo_chain:v8i16 544:iPTR, VR128:v8i16:$src1, VR128:v8i16:$src2)
                // Dst: (PADDSWrr:v8i16 VR128:v8i16:$src1, VR128:v8i16:$src2)
/*25920*/     0, /*End of Scope*/
/*25921*/   /*Scope*/ 110, /*->26032*/
/*25922*/     OPC_CheckInteger, 33|128,4/*545*/, 
/*25925*/     OPC_MoveParent,
/*25926*/     OPC_Scope, 44, /*->25972*/ // 3 children in Scope
/*25928*/       OPC_RecordChild1, // #0 = $src1
/*25929*/       OPC_MoveChild, 2,
/*25931*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*25933*/       OPC_MoveChild, 0,
/*25935*/       OPC_CheckOpcode, ISD::LOAD,
/*25937*/       OPC_RecordMemRef,
/*25938*/       OPC_RecordNode, // #1 = 'ld' chained node
/*25939*/       OPC_CheckFoldableChainNode,
/*25940*/       OPC_RecordChild1, // #2 = $src2
/*25941*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*25943*/       OPC_CheckPredicate, 8, // Predicate_load
/*25945*/       OPC_CheckPredicate, 23, // Predicate_memop
/*25947*/       OPC_CheckType, MVT::v2i64,
/*25949*/       OPC_MoveParent,
/*25950*/       OPC_MoveParent,
/*25951*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*25953*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*25956*/       OPC_EmitMergeInputChains, 1, 1, 
/*25959*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PADDUSBrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v16i8, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (intrinsic_wo_chain:v16i8 545:iPTR, VR128:v16i8:$src1, (bitconvert:v16i8 (ld:v2i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>))
                // Dst: (PADDUSBrm:v16i8 VR128:v16i8:$src1, addr:iPTR:$src2)
/*25972*/     /*Scope*/ 44, /*->26017*/
/*25973*/       OPC_MoveChild, 1,
/*25975*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*25977*/       OPC_MoveChild, 0,
/*25979*/       OPC_CheckOpcode, ISD::LOAD,
/*25981*/       OPC_RecordMemRef,
/*25982*/       OPC_RecordNode, // #0 = 'ld' chained node
/*25983*/       OPC_CheckFoldableChainNode,
/*25984*/       OPC_RecordChild1, // #1 = $src2
/*25985*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*25987*/       OPC_CheckPredicate, 8, // Predicate_load
/*25989*/       OPC_CheckPredicate, 23, // Predicate_memop
/*25991*/       OPC_CheckType, MVT::v2i64,
/*25993*/       OPC_MoveParent,
/*25994*/       OPC_MoveParent,
/*25995*/       OPC_RecordChild2, // #2 = $src1
/*25996*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*25998*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*26001*/       OPC_EmitMergeInputChains, 1, 0, 
/*26004*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PADDUSBrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v16i8, 6/*#Ops*/, 2, 3, 4, 5, 6, 7, 
                // Src: (intrinsic_wo_chain:v16i8 545:iPTR, (bitconvert:v16i8 (ld:v2i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>), VR128:v16i8:$src1)
                // Dst: (PADDUSBrm:v16i8 VR128:v16i8:$src1, addr:iPTR:$src2)
/*26017*/     /*Scope*/ 13, /*->26031*/
/*26018*/       OPC_RecordChild1, // #0 = $src1
/*26019*/       OPC_RecordChild2, // #1 = $src2
/*26020*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*26022*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PADDUSBrr), 0,
                    1/*#VTs*/, MVT::v16i8, 2/*#Ops*/, 0, 1, 
                // Src: (intrinsic_wo_chain:v16i8 545:iPTR, VR128:v16i8:$src1, VR128:v16i8:$src2)
                // Dst: (PADDUSBrr:v16i8 VR128:v16i8:$src1, VR128:v16i8:$src2)
/*26031*/     0, /*End of Scope*/
/*26032*/   /*Scope*/ 110, /*->26143*/
/*26033*/     OPC_CheckInteger, 34|128,4/*546*/, 
/*26036*/     OPC_MoveParent,
/*26037*/     OPC_Scope, 44, /*->26083*/ // 3 children in Scope
/*26039*/       OPC_RecordChild1, // #0 = $src1
/*26040*/       OPC_MoveChild, 2,
/*26042*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*26044*/       OPC_MoveChild, 0,
/*26046*/       OPC_CheckOpcode, ISD::LOAD,
/*26048*/       OPC_RecordMemRef,
/*26049*/       OPC_RecordNode, // #1 = 'ld' chained node
/*26050*/       OPC_CheckFoldableChainNode,
/*26051*/       OPC_RecordChild1, // #2 = $src2
/*26052*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*26054*/       OPC_CheckPredicate, 8, // Predicate_load
/*26056*/       OPC_CheckPredicate, 23, // Predicate_memop
/*26058*/       OPC_CheckType, MVT::v2i64,
/*26060*/       OPC_MoveParent,
/*26061*/       OPC_MoveParent,
/*26062*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*26064*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*26067*/       OPC_EmitMergeInputChains, 1, 1, 
/*26070*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PADDUSWrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v8i16, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (intrinsic_wo_chain:v8i16 546:iPTR, VR128:v8i16:$src1, (bitconvert:v8i16 (ld:v2i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>))
                // Dst: (PADDUSWrm:v8i16 VR128:v8i16:$src1, addr:iPTR:$src2)
/*26083*/     /*Scope*/ 44, /*->26128*/
/*26084*/       OPC_MoveChild, 1,
/*26086*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*26088*/       OPC_MoveChild, 0,
/*26090*/       OPC_CheckOpcode, ISD::LOAD,
/*26092*/       OPC_RecordMemRef,
/*26093*/       OPC_RecordNode, // #0 = 'ld' chained node
/*26094*/       OPC_CheckFoldableChainNode,
/*26095*/       OPC_RecordChild1, // #1 = $src2
/*26096*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*26098*/       OPC_CheckPredicate, 8, // Predicate_load
/*26100*/       OPC_CheckPredicate, 23, // Predicate_memop
/*26102*/       OPC_CheckType, MVT::v2i64,
/*26104*/       OPC_MoveParent,
/*26105*/       OPC_MoveParent,
/*26106*/       OPC_RecordChild2, // #2 = $src1
/*26107*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*26109*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*26112*/       OPC_EmitMergeInputChains, 1, 0, 
/*26115*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PADDUSWrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v8i16, 6/*#Ops*/, 2, 3, 4, 5, 6, 7, 
                // Src: (intrinsic_wo_chain:v8i16 546:iPTR, (bitconvert:v8i16 (ld:v2i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>), VR128:v8i16:$src1)
                // Dst: (PADDUSWrm:v8i16 VR128:v8i16:$src1, addr:iPTR:$src2)
/*26128*/     /*Scope*/ 13, /*->26142*/
/*26129*/       OPC_RecordChild1, // #0 = $src1
/*26130*/       OPC_RecordChild2, // #1 = $src2
/*26131*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*26133*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PADDUSWrr), 0,
                    1/*#VTs*/, MVT::v8i16, 2/*#Ops*/, 0, 1, 
                // Src: (intrinsic_wo_chain:v8i16 546:iPTR, VR128:v8i16:$src1, VR128:v8i16:$src2)
                // Dst: (PADDUSWrr:v8i16 VR128:v8i16:$src1, VR128:v8i16:$src2)
/*26142*/     0, /*End of Scope*/
/*26143*/   /*Scope*/ 64, /*->26208*/
/*26144*/     OPC_CheckInteger, 73|128,4/*585*/, 
/*26147*/     OPC_MoveParent,
/*26148*/     OPC_RecordChild1, // #0 = $src1
/*26149*/     OPC_Scope, 43, /*->26194*/ // 2 children in Scope
/*26151*/       OPC_MoveChild, 2,
/*26153*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*26155*/       OPC_MoveChild, 0,
/*26157*/       OPC_CheckOpcode, ISD::LOAD,
/*26159*/       OPC_RecordMemRef,
/*26160*/       OPC_RecordNode, // #1 = 'ld' chained node
/*26161*/       OPC_CheckFoldableChainNode,
/*26162*/       OPC_RecordChild1, // #2 = $src2
/*26163*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*26165*/       OPC_CheckPredicate, 8, // Predicate_load
/*26167*/       OPC_CheckPredicate, 23, // Predicate_memop
/*26169*/       OPC_CheckType, MVT::v2i64,
/*26171*/       OPC_MoveParent,
/*26172*/       OPC_MoveParent,
/*26173*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*26175*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*26178*/       OPC_EmitMergeInputChains, 1, 1, 
/*26181*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PSUBSBrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v16i8, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (intrinsic_wo_chain:v16i8 585:iPTR, VR128:v16i8:$src1, (bitconvert:v16i8 (ld:v2i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>))
                // Dst: (PSUBSBrm:v16i8 VR128:v16i8:$src1, addr:iPTR:$src2)
/*26194*/     /*Scope*/ 12, /*->26207*/
/*26195*/       OPC_RecordChild2, // #1 = $src2
/*26196*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*26198*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PSUBSBrr), 0,
                    1/*#VTs*/, MVT::v16i8, 2/*#Ops*/, 0, 1, 
                // Src: (intrinsic_wo_chain:v16i8 585:iPTR, VR128:v16i8:$src1, VR128:v16i8:$src2)
                // Dst: (PSUBSBrr:v16i8 VR128:v16i8:$src1, VR128:v16i8:$src2)
/*26207*/     0, /*End of Scope*/
/*26208*/   /*Scope*/ 64, /*->26273*/
/*26209*/     OPC_CheckInteger, 74|128,4/*586*/, 
/*26212*/     OPC_MoveParent,
/*26213*/     OPC_RecordChild1, // #0 = $src1
/*26214*/     OPC_Scope, 43, /*->26259*/ // 2 children in Scope
/*26216*/       OPC_MoveChild, 2,
/*26218*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*26220*/       OPC_MoveChild, 0,
/*26222*/       OPC_CheckOpcode, ISD::LOAD,
/*26224*/       OPC_RecordMemRef,
/*26225*/       OPC_RecordNode, // #1 = 'ld' chained node
/*26226*/       OPC_CheckFoldableChainNode,
/*26227*/       OPC_RecordChild1, // #2 = $src2
/*26228*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*26230*/       OPC_CheckPredicate, 8, // Predicate_load
/*26232*/       OPC_CheckPredicate, 23, // Predicate_memop
/*26234*/       OPC_CheckType, MVT::v2i64,
/*26236*/       OPC_MoveParent,
/*26237*/       OPC_MoveParent,
/*26238*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*26240*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*26243*/       OPC_EmitMergeInputChains, 1, 1, 
/*26246*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PSUBSWrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v8i16, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (intrinsic_wo_chain:v8i16 586:iPTR, VR128:v8i16:$src1, (bitconvert:v8i16 (ld:v2i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>))
                // Dst: (PSUBSWrm:v8i16 VR128:v8i16:$src1, addr:iPTR:$src2)
/*26259*/     /*Scope*/ 12, /*->26272*/
/*26260*/       OPC_RecordChild2, // #1 = $src2
/*26261*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*26263*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PSUBSWrr), 0,
                    1/*#VTs*/, MVT::v8i16, 2/*#Ops*/, 0, 1, 
                // Src: (intrinsic_wo_chain:v8i16 586:iPTR, VR128:v8i16:$src1, VR128:v8i16:$src2)
                // Dst: (PSUBSWrr:v8i16 VR128:v8i16:$src1, VR128:v8i16:$src2)
/*26272*/     0, /*End of Scope*/
/*26273*/   /*Scope*/ 64, /*->26338*/
/*26274*/     OPC_CheckInteger, 75|128,4/*587*/, 
/*26277*/     OPC_MoveParent,
/*26278*/     OPC_RecordChild1, // #0 = $src1
/*26279*/     OPC_Scope, 43, /*->26324*/ // 2 children in Scope
/*26281*/       OPC_MoveChild, 2,
/*26283*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*26285*/       OPC_MoveChild, 0,
/*26287*/       OPC_CheckOpcode, ISD::LOAD,
/*26289*/       OPC_RecordMemRef,
/*26290*/       OPC_RecordNode, // #1 = 'ld' chained node
/*26291*/       OPC_CheckFoldableChainNode,
/*26292*/       OPC_RecordChild1, // #2 = $src2
/*26293*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*26295*/       OPC_CheckPredicate, 8, // Predicate_load
/*26297*/       OPC_CheckPredicate, 23, // Predicate_memop
/*26299*/       OPC_CheckType, MVT::v2i64,
/*26301*/       OPC_MoveParent,
/*26302*/       OPC_MoveParent,
/*26303*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*26305*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*26308*/       OPC_EmitMergeInputChains, 1, 1, 
/*26311*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PSUBUSBrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v16i8, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (intrinsic_wo_chain:v16i8 587:iPTR, VR128:v16i8:$src1, (bitconvert:v16i8 (ld:v2i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>))
                // Dst: (PSUBUSBrm:v16i8 VR128:v16i8:$src1, addr:iPTR:$src2)
/*26324*/     /*Scope*/ 12, /*->26337*/
/*26325*/       OPC_RecordChild2, // #1 = $src2
/*26326*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*26328*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PSUBUSBrr), 0,
                    1/*#VTs*/, MVT::v16i8, 2/*#Ops*/, 0, 1, 
                // Src: (intrinsic_wo_chain:v16i8 587:iPTR, VR128:v16i8:$src1, VR128:v16i8:$src2)
                // Dst: (PSUBUSBrr:v16i8 VR128:v16i8:$src1, VR128:v16i8:$src2)
/*26337*/     0, /*End of Scope*/
/*26338*/   /*Scope*/ 64, /*->26403*/
/*26339*/     OPC_CheckInteger, 76|128,4/*588*/, 
/*26342*/     OPC_MoveParent,
/*26343*/     OPC_RecordChild1, // #0 = $src1
/*26344*/     OPC_Scope, 43, /*->26389*/ // 2 children in Scope
/*26346*/       OPC_MoveChild, 2,
/*26348*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*26350*/       OPC_MoveChild, 0,
/*26352*/       OPC_CheckOpcode, ISD::LOAD,
/*26354*/       OPC_RecordMemRef,
/*26355*/       OPC_RecordNode, // #1 = 'ld' chained node
/*26356*/       OPC_CheckFoldableChainNode,
/*26357*/       OPC_RecordChild1, // #2 = $src2
/*26358*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*26360*/       OPC_CheckPredicate, 8, // Predicate_load
/*26362*/       OPC_CheckPredicate, 23, // Predicate_memop
/*26364*/       OPC_CheckType, MVT::v2i64,
/*26366*/       OPC_MoveParent,
/*26367*/       OPC_MoveParent,
/*26368*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*26370*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*26373*/       OPC_EmitMergeInputChains, 1, 1, 
/*26376*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PSUBUSWrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v8i16, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (intrinsic_wo_chain:v8i16 588:iPTR, VR128:v8i16:$src1, (bitconvert:v8i16 (ld:v2i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>))
                // Dst: (PSUBUSWrm:v8i16 VR128:v8i16:$src1, addr:iPTR:$src2)
/*26389*/     /*Scope*/ 12, /*->26402*/
/*26390*/       OPC_RecordChild2, // #1 = $src2
/*26391*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*26393*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PSUBUSWrr), 0,
                    1/*#VTs*/, MVT::v8i16, 2/*#Ops*/, 0, 1, 
                // Src: (intrinsic_wo_chain:v8i16 588:iPTR, VR128:v8i16:$src1, VR128:v8i16:$src2)
                // Dst: (PSUBUSWrr:v8i16 VR128:v8i16:$src1, VR128:v8i16:$src2)
/*26402*/     0, /*End of Scope*/
/*26403*/   /*Scope*/ 110, /*->26514*/
/*26404*/     OPC_CheckInteger, 50|128,4/*562*/, 
/*26407*/     OPC_MoveParent,
/*26408*/     OPC_Scope, 44, /*->26454*/ // 3 children in Scope
/*26410*/       OPC_RecordChild1, // #0 = $src1
/*26411*/       OPC_MoveChild, 2,
/*26413*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*26415*/       OPC_MoveChild, 0,
/*26417*/       OPC_CheckOpcode, ISD::LOAD,
/*26419*/       OPC_RecordMemRef,
/*26420*/       OPC_RecordNode, // #1 = 'ld' chained node
/*26421*/       OPC_CheckFoldableChainNode,
/*26422*/       OPC_RecordChild1, // #2 = $src2
/*26423*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*26425*/       OPC_CheckPredicate, 8, // Predicate_load
/*26427*/       OPC_CheckPredicate, 23, // Predicate_memop
/*26429*/       OPC_CheckType, MVT::v2i64,
/*26431*/       OPC_MoveParent,
/*26432*/       OPC_MoveParent,
/*26433*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*26435*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*26438*/       OPC_EmitMergeInputChains, 1, 1, 
/*26441*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PMULHUWrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v8i16, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (intrinsic_wo_chain:v8i16 562:iPTR, VR128:v8i16:$src1, (bitconvert:v8i16 (ld:v2i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>))
                // Dst: (PMULHUWrm:v8i16 VR128:v8i16:$src1, addr:iPTR:$src2)
/*26454*/     /*Scope*/ 44, /*->26499*/
/*26455*/       OPC_MoveChild, 1,
/*26457*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*26459*/       OPC_MoveChild, 0,
/*26461*/       OPC_CheckOpcode, ISD::LOAD,
/*26463*/       OPC_RecordMemRef,
/*26464*/       OPC_RecordNode, // #0 = 'ld' chained node
/*26465*/       OPC_CheckFoldableChainNode,
/*26466*/       OPC_RecordChild1, // #1 = $src2
/*26467*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*26469*/       OPC_CheckPredicate, 8, // Predicate_load
/*26471*/       OPC_CheckPredicate, 23, // Predicate_memop
/*26473*/       OPC_CheckType, MVT::v2i64,
/*26475*/       OPC_MoveParent,
/*26476*/       OPC_MoveParent,
/*26477*/       OPC_RecordChild2, // #2 = $src1
/*26478*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*26480*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*26483*/       OPC_EmitMergeInputChains, 1, 0, 
/*26486*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PMULHUWrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v8i16, 6/*#Ops*/, 2, 3, 4, 5, 6, 7, 
                // Src: (intrinsic_wo_chain:v8i16 562:iPTR, (bitconvert:v8i16 (ld:v2i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>), VR128:v8i16:$src1)
                // Dst: (PMULHUWrm:v8i16 VR128:v8i16:$src1, addr:iPTR:$src2)
/*26499*/     /*Scope*/ 13, /*->26513*/
/*26500*/       OPC_RecordChild1, // #0 = $src1
/*26501*/       OPC_RecordChild2, // #1 = $src2
/*26502*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*26504*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PMULHUWrr), 0,
                    1/*#VTs*/, MVT::v8i16, 2/*#Ops*/, 0, 1, 
                // Src: (intrinsic_wo_chain:v8i16 562:iPTR, VR128:v8i16:$src1, VR128:v8i16:$src2)
                // Dst: (PMULHUWrr:v8i16 VR128:v8i16:$src1, VR128:v8i16:$src2)
/*26513*/     0, /*End of Scope*/
/*26514*/   /*Scope*/ 110, /*->26625*/
/*26515*/     OPC_CheckInteger, 49|128,4/*561*/, 
/*26518*/     OPC_MoveParent,
/*26519*/     OPC_Scope, 44, /*->26565*/ // 3 children in Scope
/*26521*/       OPC_RecordChild1, // #0 = $src1
/*26522*/       OPC_MoveChild, 2,
/*26524*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*26526*/       OPC_MoveChild, 0,
/*26528*/       OPC_CheckOpcode, ISD::LOAD,
/*26530*/       OPC_RecordMemRef,
/*26531*/       OPC_RecordNode, // #1 = 'ld' chained node
/*26532*/       OPC_CheckFoldableChainNode,
/*26533*/       OPC_RecordChild1, // #2 = $src2
/*26534*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*26536*/       OPC_CheckPredicate, 8, // Predicate_load
/*26538*/       OPC_CheckPredicate, 23, // Predicate_memop
/*26540*/       OPC_CheckType, MVT::v2i64,
/*26542*/       OPC_MoveParent,
/*26543*/       OPC_MoveParent,
/*26544*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*26546*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*26549*/       OPC_EmitMergeInputChains, 1, 1, 
/*26552*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PMULHWrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v8i16, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (intrinsic_wo_chain:v8i16 561:iPTR, VR128:v8i16:$src1, (bitconvert:v8i16 (ld:v2i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>))
                // Dst: (PMULHWrm:v8i16 VR128:v8i16:$src1, addr:iPTR:$src2)
/*26565*/     /*Scope*/ 44, /*->26610*/
/*26566*/       OPC_MoveChild, 1,
/*26568*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*26570*/       OPC_MoveChild, 0,
/*26572*/       OPC_CheckOpcode, ISD::LOAD,
/*26574*/       OPC_RecordMemRef,
/*26575*/       OPC_RecordNode, // #0 = 'ld' chained node
/*26576*/       OPC_CheckFoldableChainNode,
/*26577*/       OPC_RecordChild1, // #1 = $src2
/*26578*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*26580*/       OPC_CheckPredicate, 8, // Predicate_load
/*26582*/       OPC_CheckPredicate, 23, // Predicate_memop
/*26584*/       OPC_CheckType, MVT::v2i64,
/*26586*/       OPC_MoveParent,
/*26587*/       OPC_MoveParent,
/*26588*/       OPC_RecordChild2, // #2 = $src1
/*26589*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*26591*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*26594*/       OPC_EmitMergeInputChains, 1, 0, 
/*26597*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PMULHWrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v8i16, 6/*#Ops*/, 2, 3, 4, 5, 6, 7, 
                // Src: (intrinsic_wo_chain:v8i16 561:iPTR, (bitconvert:v8i16 (ld:v2i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>), VR128:v8i16:$src1)
                // Dst: (PMULHWrm:v8i16 VR128:v8i16:$src1, addr:iPTR:$src2)
/*26610*/     /*Scope*/ 13, /*->26624*/
/*26611*/       OPC_RecordChild1, // #0 = $src1
/*26612*/       OPC_RecordChild2, // #1 = $src2
/*26613*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*26615*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PMULHWrr), 0,
                    1/*#VTs*/, MVT::v8i16, 2/*#Ops*/, 0, 1, 
                // Src: (intrinsic_wo_chain:v8i16 561:iPTR, VR128:v8i16:$src1, VR128:v8i16:$src2)
                // Dst: (PMULHWrr:v8i16 VR128:v8i16:$src1, VR128:v8i16:$src2)
/*26624*/     0, /*End of Scope*/
/*26625*/   /*Scope*/ 110, /*->26736*/
/*26626*/     OPC_CheckInteger, 51|128,4/*563*/, 
/*26629*/     OPC_MoveParent,
/*26630*/     OPC_Scope, 44, /*->26676*/ // 3 children in Scope
/*26632*/       OPC_RecordChild1, // #0 = $src1
/*26633*/       OPC_MoveChild, 2,
/*26635*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*26637*/       OPC_MoveChild, 0,
/*26639*/       OPC_CheckOpcode, ISD::LOAD,
/*26641*/       OPC_RecordMemRef,
/*26642*/       OPC_RecordNode, // #1 = 'ld' chained node
/*26643*/       OPC_CheckFoldableChainNode,
/*26644*/       OPC_RecordChild1, // #2 = $src2
/*26645*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*26647*/       OPC_CheckPredicate, 8, // Predicate_load
/*26649*/       OPC_CheckPredicate, 23, // Predicate_memop
/*26651*/       OPC_CheckType, MVT::v2i64,
/*26653*/       OPC_MoveParent,
/*26654*/       OPC_MoveParent,
/*26655*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*26657*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*26660*/       OPC_EmitMergeInputChains, 1, 1, 
/*26663*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PMULUDQrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v2i64, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (intrinsic_wo_chain:v2i64 563:iPTR, VR128:v4i32:$src1, (bitconvert:v4i32 (ld:v2i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>))
                // Dst: (PMULUDQrm:v2i64 VR128:v4i32:$src1, addr:iPTR:$src2)
/*26676*/     /*Scope*/ 44, /*->26721*/
/*26677*/       OPC_MoveChild, 1,
/*26679*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*26681*/       OPC_MoveChild, 0,
/*26683*/       OPC_CheckOpcode, ISD::LOAD,
/*26685*/       OPC_RecordMemRef,
/*26686*/       OPC_RecordNode, // #0 = 'ld' chained node
/*26687*/       OPC_CheckFoldableChainNode,
/*26688*/       OPC_RecordChild1, // #1 = $src2
/*26689*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*26691*/       OPC_CheckPredicate, 8, // Predicate_load
/*26693*/       OPC_CheckPredicate, 23, // Predicate_memop
/*26695*/       OPC_CheckType, MVT::v2i64,
/*26697*/       OPC_MoveParent,
/*26698*/       OPC_MoveParent,
/*26699*/       OPC_RecordChild2, // #2 = $src1
/*26700*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*26702*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*26705*/       OPC_EmitMergeInputChains, 1, 0, 
/*26708*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PMULUDQrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v2i64, 6/*#Ops*/, 2, 3, 4, 5, 6, 7, 
                // Src: (intrinsic_wo_chain:v2i64 563:iPTR, (bitconvert:v4i32 (ld:v2i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>), VR128:v4i32:$src1)
                // Dst: (PMULUDQrm:v2i64 VR128:v4i32:$src1, addr:iPTR:$src2)
/*26721*/     /*Scope*/ 13, /*->26735*/
/*26722*/       OPC_RecordChild1, // #0 = $src1
/*26723*/       OPC_RecordChild2, // #1 = $src2
/*26724*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*26726*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PMULUDQrr), 0,
                    1/*#VTs*/, MVT::v2i64, 2/*#Ops*/, 0, 1, 
                // Src: (intrinsic_wo_chain:v2i64 563:iPTR, VR128:v4i32:$src1, VR128:v4i32:$src2)
                // Dst: (PMULUDQrr:v2i64 VR128:v4i32:$src1, VR128:v4i32:$src2)
/*26735*/     0, /*End of Scope*/
/*26736*/   /*Scope*/ 110, /*->26847*/
/*26737*/     OPC_CheckInteger, 43|128,4/*555*/, 
/*26740*/     OPC_MoveParent,
/*26741*/     OPC_Scope, 44, /*->26787*/ // 3 children in Scope
/*26743*/       OPC_RecordChild1, // #0 = $src1
/*26744*/       OPC_MoveChild, 2,
/*26746*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*26748*/       OPC_MoveChild, 0,
/*26750*/       OPC_CheckOpcode, ISD::LOAD,
/*26752*/       OPC_RecordMemRef,
/*26753*/       OPC_RecordNode, // #1 = 'ld' chained node
/*26754*/       OPC_CheckFoldableChainNode,
/*26755*/       OPC_RecordChild1, // #2 = $src2
/*26756*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*26758*/       OPC_CheckPredicate, 8, // Predicate_load
/*26760*/       OPC_CheckPredicate, 23, // Predicate_memop
/*26762*/       OPC_CheckType, MVT::v2i64,
/*26764*/       OPC_MoveParent,
/*26765*/       OPC_MoveParent,
/*26766*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*26768*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*26771*/       OPC_EmitMergeInputChains, 1, 1, 
/*26774*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PMADDWDrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v4i32, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (intrinsic_wo_chain:v4i32 555:iPTR, VR128:v8i16:$src1, (bitconvert:v8i16 (ld:v2i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>))
                // Dst: (PMADDWDrm:v4i32 VR128:v8i16:$src1, addr:iPTR:$src2)
/*26787*/     /*Scope*/ 44, /*->26832*/
/*26788*/       OPC_MoveChild, 1,
/*26790*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*26792*/       OPC_MoveChild, 0,
/*26794*/       OPC_CheckOpcode, ISD::LOAD,
/*26796*/       OPC_RecordMemRef,
/*26797*/       OPC_RecordNode, // #0 = 'ld' chained node
/*26798*/       OPC_CheckFoldableChainNode,
/*26799*/       OPC_RecordChild1, // #1 = $src2
/*26800*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*26802*/       OPC_CheckPredicate, 8, // Predicate_load
/*26804*/       OPC_CheckPredicate, 23, // Predicate_memop
/*26806*/       OPC_CheckType, MVT::v2i64,
/*26808*/       OPC_MoveParent,
/*26809*/       OPC_MoveParent,
/*26810*/       OPC_RecordChild2, // #2 = $src1
/*26811*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*26813*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*26816*/       OPC_EmitMergeInputChains, 1, 0, 
/*26819*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PMADDWDrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v4i32, 6/*#Ops*/, 2, 3, 4, 5, 6, 7, 
                // Src: (intrinsic_wo_chain:v4i32 555:iPTR, (bitconvert:v8i16 (ld:v2i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>), VR128:v8i16:$src1)
                // Dst: (PMADDWDrm:v4i32 VR128:v8i16:$src1, addr:iPTR:$src2)
/*26832*/     /*Scope*/ 13, /*->26846*/
/*26833*/       OPC_RecordChild1, // #0 = $src1
/*26834*/       OPC_RecordChild2, // #1 = $src2
/*26835*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*26837*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PMADDWDrr), 0,
                    1/*#VTs*/, MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (intrinsic_wo_chain:v4i32 555:iPTR, VR128:v8i16:$src1, VR128:v8i16:$src2)
                // Dst: (PMADDWDrr:v4i32 VR128:v8i16:$src1, VR128:v8i16:$src2)
/*26846*/     0, /*End of Scope*/
/*26847*/   /*Scope*/ 110, /*->26958*/
/*26848*/     OPC_CheckInteger, 35|128,4/*547*/, 
/*26851*/     OPC_MoveParent,
/*26852*/     OPC_Scope, 44, /*->26898*/ // 3 children in Scope
/*26854*/       OPC_RecordChild1, // #0 = $src1
/*26855*/       OPC_MoveChild, 2,
/*26857*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*26859*/       OPC_MoveChild, 0,
/*26861*/       OPC_CheckOpcode, ISD::LOAD,
/*26863*/       OPC_RecordMemRef,
/*26864*/       OPC_RecordNode, // #1 = 'ld' chained node
/*26865*/       OPC_CheckFoldableChainNode,
/*26866*/       OPC_RecordChild1, // #2 = $src2
/*26867*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*26869*/       OPC_CheckPredicate, 8, // Predicate_load
/*26871*/       OPC_CheckPredicate, 23, // Predicate_memop
/*26873*/       OPC_CheckType, MVT::v2i64,
/*26875*/       OPC_MoveParent,
/*26876*/       OPC_MoveParent,
/*26877*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*26879*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*26882*/       OPC_EmitMergeInputChains, 1, 1, 
/*26885*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PAVGBrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v16i8, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (intrinsic_wo_chain:v16i8 547:iPTR, VR128:v16i8:$src1, (bitconvert:v16i8 (ld:v2i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>))
                // Dst: (PAVGBrm:v16i8 VR128:v16i8:$src1, addr:iPTR:$src2)
/*26898*/     /*Scope*/ 44, /*->26943*/
/*26899*/       OPC_MoveChild, 1,
/*26901*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*26903*/       OPC_MoveChild, 0,
/*26905*/       OPC_CheckOpcode, ISD::LOAD,
/*26907*/       OPC_RecordMemRef,
/*26908*/       OPC_RecordNode, // #0 = 'ld' chained node
/*26909*/       OPC_CheckFoldableChainNode,
/*26910*/       OPC_RecordChild1, // #1 = $src2
/*26911*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*26913*/       OPC_CheckPredicate, 8, // Predicate_load
/*26915*/       OPC_CheckPredicate, 23, // Predicate_memop
/*26917*/       OPC_CheckType, MVT::v2i64,
/*26919*/       OPC_MoveParent,
/*26920*/       OPC_MoveParent,
/*26921*/       OPC_RecordChild2, // #2 = $src1
/*26922*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*26924*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*26927*/       OPC_EmitMergeInputChains, 1, 0, 
/*26930*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PAVGBrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v16i8, 6/*#Ops*/, 2, 3, 4, 5, 6, 7, 
                // Src: (intrinsic_wo_chain:v16i8 547:iPTR, (bitconvert:v16i8 (ld:v2i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>), VR128:v16i8:$src1)
                // Dst: (PAVGBrm:v16i8 VR128:v16i8:$src1, addr:iPTR:$src2)
/*26943*/     /*Scope*/ 13, /*->26957*/
/*26944*/       OPC_RecordChild1, // #0 = $src1
/*26945*/       OPC_RecordChild2, // #1 = $src2
/*26946*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*26948*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PAVGBrr), 0,
                    1/*#VTs*/, MVT::v16i8, 2/*#Ops*/, 0, 1, 
                // Src: (intrinsic_wo_chain:v16i8 547:iPTR, VR128:v16i8:$src1, VR128:v16i8:$src2)
                // Dst: (PAVGBrr:v16i8 VR128:v16i8:$src1, VR128:v16i8:$src2)
/*26957*/     0, /*End of Scope*/
/*26958*/   /*Scope*/ 110, /*->27069*/
/*26959*/     OPC_CheckInteger, 36|128,4/*548*/, 
/*26962*/     OPC_MoveParent,
/*26963*/     OPC_Scope, 44, /*->27009*/ // 3 children in Scope
/*26965*/       OPC_RecordChild1, // #0 = $src1
/*26966*/       OPC_MoveChild, 2,
/*26968*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*26970*/       OPC_MoveChild, 0,
/*26972*/       OPC_CheckOpcode, ISD::LOAD,
/*26974*/       OPC_RecordMemRef,
/*26975*/       OPC_RecordNode, // #1 = 'ld' chained node
/*26976*/       OPC_CheckFoldableChainNode,
/*26977*/       OPC_RecordChild1, // #2 = $src2
/*26978*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*26980*/       OPC_CheckPredicate, 8, // Predicate_load
/*26982*/       OPC_CheckPredicate, 23, // Predicate_memop
/*26984*/       OPC_CheckType, MVT::v2i64,
/*26986*/       OPC_MoveParent,
/*26987*/       OPC_MoveParent,
/*26988*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*26990*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*26993*/       OPC_EmitMergeInputChains, 1, 1, 
/*26996*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PAVGWrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v8i16, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (intrinsic_wo_chain:v8i16 548:iPTR, VR128:v8i16:$src1, (bitconvert:v8i16 (ld:v2i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>))
                // Dst: (PAVGWrm:v8i16 VR128:v8i16:$src1, addr:iPTR:$src2)
/*27009*/     /*Scope*/ 44, /*->27054*/
/*27010*/       OPC_MoveChild, 1,
/*27012*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*27014*/       OPC_MoveChild, 0,
/*27016*/       OPC_CheckOpcode, ISD::LOAD,
/*27018*/       OPC_RecordMemRef,
/*27019*/       OPC_RecordNode, // #0 = 'ld' chained node
/*27020*/       OPC_CheckFoldableChainNode,
/*27021*/       OPC_RecordChild1, // #1 = $src2
/*27022*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*27024*/       OPC_CheckPredicate, 8, // Predicate_load
/*27026*/       OPC_CheckPredicate, 23, // Predicate_memop
/*27028*/       OPC_CheckType, MVT::v2i64,
/*27030*/       OPC_MoveParent,
/*27031*/       OPC_MoveParent,
/*27032*/       OPC_RecordChild2, // #2 = $src1
/*27033*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*27035*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*27038*/       OPC_EmitMergeInputChains, 1, 0, 
/*27041*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PAVGWrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v8i16, 6/*#Ops*/, 2, 3, 4, 5, 6, 7, 
                // Src: (intrinsic_wo_chain:v8i16 548:iPTR, (bitconvert:v8i16 (ld:v2i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>), VR128:v8i16:$src1)
                // Dst: (PAVGWrm:v8i16 VR128:v8i16:$src1, addr:iPTR:$src2)
/*27054*/     /*Scope*/ 13, /*->27068*/
/*27055*/       OPC_RecordChild1, // #0 = $src1
/*27056*/       OPC_RecordChild2, // #1 = $src2
/*27057*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*27059*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PAVGWrr), 0,
                    1/*#VTs*/, MVT::v8i16, 2/*#Ops*/, 0, 1, 
                // Src: (intrinsic_wo_chain:v8i16 548:iPTR, VR128:v8i16:$src1, VR128:v8i16:$src2)
                // Dst: (PAVGWrr:v8i16 VR128:v8i16:$src1, VR128:v8i16:$src2)
/*27068*/     0, /*End of Scope*/
/*27069*/   /*Scope*/ 110, /*->27180*/
/*27070*/     OPC_CheckInteger, 47|128,4/*559*/, 
/*27073*/     OPC_MoveParent,
/*27074*/     OPC_Scope, 44, /*->27120*/ // 3 children in Scope
/*27076*/       OPC_RecordChild1, // #0 = $src1
/*27077*/       OPC_MoveChild, 2,
/*27079*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*27081*/       OPC_MoveChild, 0,
/*27083*/       OPC_CheckOpcode, ISD::LOAD,
/*27085*/       OPC_RecordMemRef,
/*27086*/       OPC_RecordNode, // #1 = 'ld' chained node
/*27087*/       OPC_CheckFoldableChainNode,
/*27088*/       OPC_RecordChild1, // #2 = $src2
/*27089*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*27091*/       OPC_CheckPredicate, 8, // Predicate_load
/*27093*/       OPC_CheckPredicate, 23, // Predicate_memop
/*27095*/       OPC_CheckType, MVT::v2i64,
/*27097*/       OPC_MoveParent,
/*27098*/       OPC_MoveParent,
/*27099*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*27101*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*27104*/       OPC_EmitMergeInputChains, 1, 1, 
/*27107*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PMINUBrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v16i8, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (intrinsic_wo_chain:v16i8 559:iPTR, VR128:v16i8:$src1, (bitconvert:v16i8 (ld:v2i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>))
                // Dst: (PMINUBrm:v16i8 VR128:v16i8:$src1, addr:iPTR:$src2)
/*27120*/     /*Scope*/ 44, /*->27165*/
/*27121*/       OPC_MoveChild, 1,
/*27123*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*27125*/       OPC_MoveChild, 0,
/*27127*/       OPC_CheckOpcode, ISD::LOAD,
/*27129*/       OPC_RecordMemRef,
/*27130*/       OPC_RecordNode, // #0 = 'ld' chained node
/*27131*/       OPC_CheckFoldableChainNode,
/*27132*/       OPC_RecordChild1, // #1 = $src2
/*27133*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*27135*/       OPC_CheckPredicate, 8, // Predicate_load
/*27137*/       OPC_CheckPredicate, 23, // Predicate_memop
/*27139*/       OPC_CheckType, MVT::v2i64,
/*27141*/       OPC_MoveParent,
/*27142*/       OPC_MoveParent,
/*27143*/       OPC_RecordChild2, // #2 = $src1
/*27144*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*27146*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*27149*/       OPC_EmitMergeInputChains, 1, 0, 
/*27152*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PMINUBrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v16i8, 6/*#Ops*/, 2, 3, 4, 5, 6, 7, 
                // Src: (intrinsic_wo_chain:v16i8 559:iPTR, (bitconvert:v16i8 (ld:v2i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>), VR128:v16i8:$src1)
                // Dst: (PMINUBrm:v16i8 VR128:v16i8:$src1, addr:iPTR:$src2)
/*27165*/     /*Scope*/ 13, /*->27179*/
/*27166*/       OPC_RecordChild1, // #0 = $src1
/*27167*/       OPC_RecordChild2, // #1 = $src2
/*27168*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*27170*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PMINUBrr), 0,
                    1/*#VTs*/, MVT::v16i8, 2/*#Ops*/, 0, 1, 
                // Src: (intrinsic_wo_chain:v16i8 559:iPTR, VR128:v16i8:$src1, VR128:v16i8:$src2)
                // Dst: (PMINUBrr:v16i8 VR128:v16i8:$src1, VR128:v16i8:$src2)
/*27179*/     0, /*End of Scope*/
/*27180*/   /*Scope*/ 110, /*->27291*/
/*27181*/     OPC_CheckInteger, 46|128,4/*558*/, 
/*27184*/     OPC_MoveParent,
/*27185*/     OPC_Scope, 44, /*->27231*/ // 3 children in Scope
/*27187*/       OPC_RecordChild1, // #0 = $src1
/*27188*/       OPC_MoveChild, 2,
/*27190*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*27192*/       OPC_MoveChild, 0,
/*27194*/       OPC_CheckOpcode, ISD::LOAD,
/*27196*/       OPC_RecordMemRef,
/*27197*/       OPC_RecordNode, // #1 = 'ld' chained node
/*27198*/       OPC_CheckFoldableChainNode,
/*27199*/       OPC_RecordChild1, // #2 = $src2
/*27200*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*27202*/       OPC_CheckPredicate, 8, // Predicate_load
/*27204*/       OPC_CheckPredicate, 23, // Predicate_memop
/*27206*/       OPC_CheckType, MVT::v2i64,
/*27208*/       OPC_MoveParent,
/*27209*/       OPC_MoveParent,
/*27210*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*27212*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*27215*/       OPC_EmitMergeInputChains, 1, 1, 
/*27218*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PMINSWrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v8i16, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (intrinsic_wo_chain:v8i16 558:iPTR, VR128:v8i16:$src1, (bitconvert:v8i16 (ld:v2i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>))
                // Dst: (PMINSWrm:v8i16 VR128:v8i16:$src1, addr:iPTR:$src2)
/*27231*/     /*Scope*/ 44, /*->27276*/
/*27232*/       OPC_MoveChild, 1,
/*27234*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*27236*/       OPC_MoveChild, 0,
/*27238*/       OPC_CheckOpcode, ISD::LOAD,
/*27240*/       OPC_RecordMemRef,
/*27241*/       OPC_RecordNode, // #0 = 'ld' chained node
/*27242*/       OPC_CheckFoldableChainNode,
/*27243*/       OPC_RecordChild1, // #1 = $src2
/*27244*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*27246*/       OPC_CheckPredicate, 8, // Predicate_load
/*27248*/       OPC_CheckPredicate, 23, // Predicate_memop
/*27250*/       OPC_CheckType, MVT::v2i64,
/*27252*/       OPC_MoveParent,
/*27253*/       OPC_MoveParent,
/*27254*/       OPC_RecordChild2, // #2 = $src1
/*27255*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*27257*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*27260*/       OPC_EmitMergeInputChains, 1, 0, 
/*27263*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PMINSWrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v8i16, 6/*#Ops*/, 2, 3, 4, 5, 6, 7, 
                // Src: (intrinsic_wo_chain:v8i16 558:iPTR, (bitconvert:v8i16 (ld:v2i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>), VR128:v8i16:$src1)
                // Dst: (PMINSWrm:v8i16 VR128:v8i16:$src1, addr:iPTR:$src2)
/*27276*/     /*Scope*/ 13, /*->27290*/
/*27277*/       OPC_RecordChild1, // #0 = $src1
/*27278*/       OPC_RecordChild2, // #1 = $src2
/*27279*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*27281*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PMINSWrr), 0,
                    1/*#VTs*/, MVT::v8i16, 2/*#Ops*/, 0, 1, 
                // Src: (intrinsic_wo_chain:v8i16 558:iPTR, VR128:v8i16:$src1, VR128:v8i16:$src2)
                // Dst: (PMINSWrr:v8i16 VR128:v8i16:$src1, VR128:v8i16:$src2)
/*27290*/     0, /*End of Scope*/
/*27291*/   /*Scope*/ 110, /*->27402*/
/*27292*/     OPC_CheckInteger, 45|128,4/*557*/, 
/*27295*/     OPC_MoveParent,
/*27296*/     OPC_Scope, 44, /*->27342*/ // 3 children in Scope
/*27298*/       OPC_RecordChild1, // #0 = $src1
/*27299*/       OPC_MoveChild, 2,
/*27301*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*27303*/       OPC_MoveChild, 0,
/*27305*/       OPC_CheckOpcode, ISD::LOAD,
/*27307*/       OPC_RecordMemRef,
/*27308*/       OPC_RecordNode, // #1 = 'ld' chained node
/*27309*/       OPC_CheckFoldableChainNode,
/*27310*/       OPC_RecordChild1, // #2 = $src2
/*27311*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*27313*/       OPC_CheckPredicate, 8, // Predicate_load
/*27315*/       OPC_CheckPredicate, 23, // Predicate_memop
/*27317*/       OPC_CheckType, MVT::v2i64,
/*27319*/       OPC_MoveParent,
/*27320*/       OPC_MoveParent,
/*27321*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*27323*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*27326*/       OPC_EmitMergeInputChains, 1, 1, 
/*27329*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PMAXUBrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v16i8, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (intrinsic_wo_chain:v16i8 557:iPTR, VR128:v16i8:$src1, (bitconvert:v16i8 (ld:v2i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>))
                // Dst: (PMAXUBrm:v16i8 VR128:v16i8:$src1, addr:iPTR:$src2)
/*27342*/     /*Scope*/ 44, /*->27387*/
/*27343*/       OPC_MoveChild, 1,
/*27345*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*27347*/       OPC_MoveChild, 0,
/*27349*/       OPC_CheckOpcode, ISD::LOAD,
/*27351*/       OPC_RecordMemRef,
/*27352*/       OPC_RecordNode, // #0 = 'ld' chained node
/*27353*/       OPC_CheckFoldableChainNode,
/*27354*/       OPC_RecordChild1, // #1 = $src2
/*27355*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*27357*/       OPC_CheckPredicate, 8, // Predicate_load
/*27359*/       OPC_CheckPredicate, 23, // Predicate_memop
/*27361*/       OPC_CheckType, MVT::v2i64,
/*27363*/       OPC_MoveParent,
/*27364*/       OPC_MoveParent,
/*27365*/       OPC_RecordChild2, // #2 = $src1
/*27366*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*27368*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*27371*/       OPC_EmitMergeInputChains, 1, 0, 
/*27374*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PMAXUBrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v16i8, 6/*#Ops*/, 2, 3, 4, 5, 6, 7, 
                // Src: (intrinsic_wo_chain:v16i8 557:iPTR, (bitconvert:v16i8 (ld:v2i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>), VR128:v16i8:$src1)
                // Dst: (PMAXUBrm:v16i8 VR128:v16i8:$src1, addr:iPTR:$src2)
/*27387*/     /*Scope*/ 13, /*->27401*/
/*27388*/       OPC_RecordChild1, // #0 = $src1
/*27389*/       OPC_RecordChild2, // #1 = $src2
/*27390*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*27392*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PMAXUBrr), 0,
                    1/*#VTs*/, MVT::v16i8, 2/*#Ops*/, 0, 1, 
                // Src: (intrinsic_wo_chain:v16i8 557:iPTR, VR128:v16i8:$src1, VR128:v16i8:$src2)
                // Dst: (PMAXUBrr:v16i8 VR128:v16i8:$src1, VR128:v16i8:$src2)
/*27401*/     0, /*End of Scope*/
/*27402*/   /*Scope*/ 110, /*->27513*/
/*27403*/     OPC_CheckInteger, 44|128,4/*556*/, 
/*27406*/     OPC_MoveParent,
/*27407*/     OPC_Scope, 44, /*->27453*/ // 3 children in Scope
/*27409*/       OPC_RecordChild1, // #0 = $src1
/*27410*/       OPC_MoveChild, 2,
/*27412*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*27414*/       OPC_MoveChild, 0,
/*27416*/       OPC_CheckOpcode, ISD::LOAD,
/*27418*/       OPC_RecordMemRef,
/*27419*/       OPC_RecordNode, // #1 = 'ld' chained node
/*27420*/       OPC_CheckFoldableChainNode,
/*27421*/       OPC_RecordChild1, // #2 = $src2
/*27422*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*27424*/       OPC_CheckPredicate, 8, // Predicate_load
/*27426*/       OPC_CheckPredicate, 23, // Predicate_memop
/*27428*/       OPC_CheckType, MVT::v2i64,
/*27430*/       OPC_MoveParent,
/*27431*/       OPC_MoveParent,
/*27432*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*27434*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*27437*/       OPC_EmitMergeInputChains, 1, 1, 
/*27440*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PMAXSWrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v8i16, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (intrinsic_wo_chain:v8i16 556:iPTR, VR128:v8i16:$src1, (bitconvert:v8i16 (ld:v2i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>))
                // Dst: (PMAXSWrm:v8i16 VR128:v8i16:$src1, addr:iPTR:$src2)
/*27453*/     /*Scope*/ 44, /*->27498*/
/*27454*/       OPC_MoveChild, 1,
/*27456*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*27458*/       OPC_MoveChild, 0,
/*27460*/       OPC_CheckOpcode, ISD::LOAD,
/*27462*/       OPC_RecordMemRef,
/*27463*/       OPC_RecordNode, // #0 = 'ld' chained node
/*27464*/       OPC_CheckFoldableChainNode,
/*27465*/       OPC_RecordChild1, // #1 = $src2
/*27466*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*27468*/       OPC_CheckPredicate, 8, // Predicate_load
/*27470*/       OPC_CheckPredicate, 23, // Predicate_memop
/*27472*/       OPC_CheckType, MVT::v2i64,
/*27474*/       OPC_MoveParent,
/*27475*/       OPC_MoveParent,
/*27476*/       OPC_RecordChild2, // #2 = $src1
/*27477*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*27479*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*27482*/       OPC_EmitMergeInputChains, 1, 0, 
/*27485*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PMAXSWrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v8i16, 6/*#Ops*/, 2, 3, 4, 5, 6, 7, 
                // Src: (intrinsic_wo_chain:v8i16 556:iPTR, (bitconvert:v8i16 (ld:v2i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>), VR128:v8i16:$src1)
                // Dst: (PMAXSWrm:v8i16 VR128:v8i16:$src1, addr:iPTR:$src2)
/*27498*/     /*Scope*/ 13, /*->27512*/
/*27499*/       OPC_RecordChild1, // #0 = $src1
/*27500*/       OPC_RecordChild2, // #1 = $src2
/*27501*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*27503*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PMAXSWrr), 0,
                    1/*#VTs*/, MVT::v8i16, 2/*#Ops*/, 0, 1, 
                // Src: (intrinsic_wo_chain:v8i16 556:iPTR, VR128:v8i16:$src1, VR128:v8i16:$src2)
                // Dst: (PMAXSWrr:v8i16 VR128:v8i16:$src1, VR128:v8i16:$src2)
/*27512*/     0, /*End of Scope*/
/*27513*/   /*Scope*/ 110, /*->27624*/
/*27514*/     OPC_CheckInteger, 52|128,4/*564*/, 
/*27517*/     OPC_MoveParent,
/*27518*/     OPC_Scope, 44, /*->27564*/ // 3 children in Scope
/*27520*/       OPC_RecordChild1, // #0 = $src1
/*27521*/       OPC_MoveChild, 2,
/*27523*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*27525*/       OPC_MoveChild, 0,
/*27527*/       OPC_CheckOpcode, ISD::LOAD,
/*27529*/       OPC_RecordMemRef,
/*27530*/       OPC_RecordNode, // #1 = 'ld' chained node
/*27531*/       OPC_CheckFoldableChainNode,
/*27532*/       OPC_RecordChild1, // #2 = $src2
/*27533*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*27535*/       OPC_CheckPredicate, 8, // Predicate_load
/*27537*/       OPC_CheckPredicate, 23, // Predicate_memop
/*27539*/       OPC_CheckType, MVT::v2i64,
/*27541*/       OPC_MoveParent,
/*27542*/       OPC_MoveParent,
/*27543*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*27545*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*27548*/       OPC_EmitMergeInputChains, 1, 1, 
/*27551*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PSADBWrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v2i64, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (intrinsic_wo_chain:v2i64 564:iPTR, VR128:v16i8:$src1, (bitconvert:v16i8 (ld:v2i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>))
                // Dst: (PSADBWrm:v2i64 VR128:v16i8:$src1, addr:iPTR:$src2)
/*27564*/     /*Scope*/ 44, /*->27609*/
/*27565*/       OPC_MoveChild, 1,
/*27567*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*27569*/       OPC_MoveChild, 0,
/*27571*/       OPC_CheckOpcode, ISD::LOAD,
/*27573*/       OPC_RecordMemRef,
/*27574*/       OPC_RecordNode, // #0 = 'ld' chained node
/*27575*/       OPC_CheckFoldableChainNode,
/*27576*/       OPC_RecordChild1, // #1 = $src2
/*27577*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*27579*/       OPC_CheckPredicate, 8, // Predicate_load
/*27581*/       OPC_CheckPredicate, 23, // Predicate_memop
/*27583*/       OPC_CheckType, MVT::v2i64,
/*27585*/       OPC_MoveParent,
/*27586*/       OPC_MoveParent,
/*27587*/       OPC_RecordChild2, // #2 = $src1
/*27588*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*27590*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*27593*/       OPC_EmitMergeInputChains, 1, 0, 
/*27596*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PSADBWrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v2i64, 6/*#Ops*/, 2, 3, 4, 5, 6, 7, 
                // Src: (intrinsic_wo_chain:v2i64 564:iPTR, (bitconvert:v16i8 (ld:v2i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>), VR128:v16i8:$src1)
                // Dst: (PSADBWrm:v2i64 VR128:v16i8:$src1, addr:iPTR:$src2)
/*27609*/     /*Scope*/ 13, /*->27623*/
/*27610*/       OPC_RecordChild1, // #0 = $src1
/*27611*/       OPC_RecordChild2, // #1 = $src2
/*27612*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*27614*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PSADBWrr), 0,
                    1/*#VTs*/, MVT::v2i64, 2/*#Ops*/, 0, 1, 
                // Src: (intrinsic_wo_chain:v2i64 564:iPTR, VR128:v16i8:$src1, VR128:v16i8:$src2)
                // Dst: (PSADBWrr:v2i64 VR128:v16i8:$src1, VR128:v16i8:$src2)
/*27623*/     0, /*End of Scope*/
/*27624*/   /*Scope*/ 64, /*->27689*/
/*27625*/     OPC_CheckInteger, 57|128,4/*569*/, 
/*27628*/     OPC_MoveParent,
/*27629*/     OPC_RecordChild1, // #0 = $src1
/*27630*/     OPC_Scope, 43, /*->27675*/ // 2 children in Scope
/*27632*/       OPC_MoveChild, 2,
/*27634*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*27636*/       OPC_MoveChild, 0,
/*27638*/       OPC_CheckOpcode, ISD::LOAD,
/*27640*/       OPC_RecordMemRef,
/*27641*/       OPC_RecordNode, // #1 = 'ld' chained node
/*27642*/       OPC_CheckFoldableChainNode,
/*27643*/       OPC_RecordChild1, // #2 = $src2
/*27644*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*27646*/       OPC_CheckPredicate, 8, // Predicate_load
/*27648*/       OPC_CheckPredicate, 23, // Predicate_memop
/*27650*/       OPC_CheckType, MVT::v2i64,
/*27652*/       OPC_MoveParent,
/*27653*/       OPC_MoveParent,
/*27654*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*27656*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*27659*/       OPC_EmitMergeInputChains, 1, 1, 
/*27662*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PSLLWrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v8i16, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (intrinsic_wo_chain:v8i16 569:iPTR, VR128:v8i16:$src1, (bitconvert:v8i16 (ld:v2i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>))
                // Dst: (PSLLWrm:v8i16 VR128:v8i16:$src1, addr:iPTR:$src2)
/*27675*/     /*Scope*/ 12, /*->27688*/
/*27676*/       OPC_RecordChild2, // #1 = $src2
/*27677*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*27679*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PSLLWrr), 0,
                    1/*#VTs*/, MVT::v8i16, 2/*#Ops*/, 0, 1, 
                // Src: (intrinsic_wo_chain:v8i16 569:iPTR, VR128:v8i16:$src1, VR128:v8i16:$src2)
                // Dst: (PSLLWrr:v8i16 VR128:v8i16:$src1, VR128:v8i16:$src2)
/*27688*/     0, /*End of Scope*/
/*27689*/   /*Scope*/ 64, /*->27754*/
/*27690*/     OPC_CheckInteger, 53|128,4/*565*/, 
/*27693*/     OPC_MoveParent,
/*27694*/     OPC_RecordChild1, // #0 = $src1
/*27695*/     OPC_Scope, 43, /*->27740*/ // 2 children in Scope
/*27697*/       OPC_MoveChild, 2,
/*27699*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*27701*/       OPC_MoveChild, 0,
/*27703*/       OPC_CheckOpcode, ISD::LOAD,
/*27705*/       OPC_RecordMemRef,
/*27706*/       OPC_RecordNode, // #1 = 'ld' chained node
/*27707*/       OPC_CheckFoldableChainNode,
/*27708*/       OPC_RecordChild1, // #2 = $src2
/*27709*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*27711*/       OPC_CheckPredicate, 8, // Predicate_load
/*27713*/       OPC_CheckPredicate, 23, // Predicate_memop
/*27715*/       OPC_CheckType, MVT::v2i64,
/*27717*/       OPC_MoveParent,
/*27718*/       OPC_MoveParent,
/*27719*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*27721*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*27724*/       OPC_EmitMergeInputChains, 1, 1, 
/*27727*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PSLLDrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v4i32, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (intrinsic_wo_chain:v4i32 565:iPTR, VR128:v4i32:$src1, (bitconvert:v4i32 (ld:v2i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>))
                // Dst: (PSLLDrm:v4i32 VR128:v4i32:$src1, addr:iPTR:$src2)
/*27740*/     /*Scope*/ 12, /*->27753*/
/*27741*/       OPC_RecordChild2, // #1 = $src2
/*27742*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*27744*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PSLLDrr), 0,
                    1/*#VTs*/, MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (intrinsic_wo_chain:v4i32 565:iPTR, VR128:v4i32:$src1, VR128:v4i32:$src2)
                // Dst: (PSLLDrr:v4i32 VR128:v4i32:$src1, VR128:v4i32:$src2)
/*27753*/     0, /*End of Scope*/
/*27754*/   /*Scope*/ 64, /*->27819*/
/*27755*/     OPC_CheckInteger, 56|128,4/*568*/, 
/*27758*/     OPC_MoveParent,
/*27759*/     OPC_RecordChild1, // #0 = $src1
/*27760*/     OPC_Scope, 43, /*->27805*/ // 2 children in Scope
/*27762*/       OPC_MoveChild, 2,
/*27764*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*27766*/       OPC_MoveChild, 0,
/*27768*/       OPC_CheckOpcode, ISD::LOAD,
/*27770*/       OPC_RecordMemRef,
/*27771*/       OPC_RecordNode, // #1 = 'ld' chained node
/*27772*/       OPC_CheckFoldableChainNode,
/*27773*/       OPC_RecordChild1, // #2 = $src2
/*27774*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*27776*/       OPC_CheckPredicate, 8, // Predicate_load
/*27778*/       OPC_CheckPredicate, 23, // Predicate_memop
/*27780*/       OPC_CheckType, MVT::v2i64,
/*27782*/       OPC_MoveParent,
/*27783*/       OPC_MoveParent,
/*27784*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*27786*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*27789*/       OPC_EmitMergeInputChains, 1, 1, 
/*27792*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PSLLQrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v2i64, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (intrinsic_wo_chain:v2i64 568:iPTR, VR128:v2i64:$src1, (bitconvert:v2i64 (ld:v2i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>))
                // Dst: (PSLLQrm:v2i64 VR128:v2i64:$src1, addr:iPTR:$src2)
/*27805*/     /*Scope*/ 12, /*->27818*/
/*27806*/       OPC_RecordChild2, // #1 = $src2
/*27807*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*27809*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PSLLQrr), 0,
                    1/*#VTs*/, MVT::v2i64, 2/*#Ops*/, 0, 1, 
                // Src: (intrinsic_wo_chain:v2i64 568:iPTR, VR128:v2i64:$src1, VR128:v2i64:$src2)
                // Dst: (PSLLQrr:v2i64 VR128:v2i64:$src1, VR128:v2i64:$src2)
/*27818*/     0, /*End of Scope*/
/*27819*/   /*Scope*/ 64, /*->27884*/
/*27820*/     OPC_CheckInteger, 69|128,4/*581*/, 
/*27823*/     OPC_MoveParent,
/*27824*/     OPC_RecordChild1, // #0 = $src1
/*27825*/     OPC_Scope, 43, /*->27870*/ // 2 children in Scope
/*27827*/       OPC_MoveChild, 2,
/*27829*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*27831*/       OPC_MoveChild, 0,
/*27833*/       OPC_CheckOpcode, ISD::LOAD,
/*27835*/       OPC_RecordMemRef,
/*27836*/       OPC_RecordNode, // #1 = 'ld' chained node
/*27837*/       OPC_CheckFoldableChainNode,
/*27838*/       OPC_RecordChild1, // #2 = $src2
/*27839*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*27841*/       OPC_CheckPredicate, 8, // Predicate_load
/*27843*/       OPC_CheckPredicate, 23, // Predicate_memop
/*27845*/       OPC_CheckType, MVT::v2i64,
/*27847*/       OPC_MoveParent,
/*27848*/       OPC_MoveParent,
/*27849*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*27851*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*27854*/       OPC_EmitMergeInputChains, 1, 1, 
/*27857*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PSRLWrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v8i16, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (intrinsic_wo_chain:v8i16 581:iPTR, VR128:v8i16:$src1, (bitconvert:v8i16 (ld:v2i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>))
                // Dst: (PSRLWrm:v8i16 VR128:v8i16:$src1, addr:iPTR:$src2)
/*27870*/     /*Scope*/ 12, /*->27883*/
/*27871*/       OPC_RecordChild2, // #1 = $src2
/*27872*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*27874*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PSRLWrr), 0,
                    1/*#VTs*/, MVT::v8i16, 2/*#Ops*/, 0, 1, 
                // Src: (intrinsic_wo_chain:v8i16 581:iPTR, VR128:v8i16:$src1, VR128:v8i16:$src2)
                // Dst: (PSRLWrr:v8i16 VR128:v8i16:$src1, VR128:v8i16:$src2)
/*27883*/     0, /*End of Scope*/
/*27884*/   /*Scope*/ 64, /*->27949*/
/*27885*/     OPC_CheckInteger, 65|128,4/*577*/, 
/*27888*/     OPC_MoveParent,
/*27889*/     OPC_RecordChild1, // #0 = $src1
/*27890*/     OPC_Scope, 43, /*->27935*/ // 2 children in Scope
/*27892*/       OPC_MoveChild, 2,
/*27894*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*27896*/       OPC_MoveChild, 0,
/*27898*/       OPC_CheckOpcode, ISD::LOAD,
/*27900*/       OPC_RecordMemRef,
/*27901*/       OPC_RecordNode, // #1 = 'ld' chained node
/*27902*/       OPC_CheckFoldableChainNode,
/*27903*/       OPC_RecordChild1, // #2 = $src2
/*27904*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*27906*/       OPC_CheckPredicate, 8, // Predicate_load
/*27908*/       OPC_CheckPredicate, 23, // Predicate_memop
/*27910*/       OPC_CheckType, MVT::v2i64,
/*27912*/       OPC_MoveParent,
/*27913*/       OPC_MoveParent,
/*27914*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*27916*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*27919*/       OPC_EmitMergeInputChains, 1, 1, 
/*27922*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PSRLDrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v4i32, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (intrinsic_wo_chain:v4i32 577:iPTR, VR128:v4i32:$src1, (bitconvert:v4i32 (ld:v2i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>))
                // Dst: (PSRLDrm:v4i32 VR128:v4i32:$src1, addr:iPTR:$src2)
/*27935*/     /*Scope*/ 12, /*->27948*/
/*27936*/       OPC_RecordChild2, // #1 = $src2
/*27937*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*27939*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PSRLDrr), 0,
                    1/*#VTs*/, MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (intrinsic_wo_chain:v4i32 577:iPTR, VR128:v4i32:$src1, VR128:v4i32:$src2)
                // Dst: (PSRLDrr:v4i32 VR128:v4i32:$src1, VR128:v4i32:$src2)
/*27948*/     0, /*End of Scope*/
/*27949*/   /*Scope*/ 64, /*->28014*/
/*27950*/     OPC_CheckInteger, 68|128,4/*580*/, 
/*27953*/     OPC_MoveParent,
/*27954*/     OPC_RecordChild1, // #0 = $src1
/*27955*/     OPC_Scope, 43, /*->28000*/ // 2 children in Scope
/*27957*/       OPC_MoveChild, 2,
/*27959*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*27961*/       OPC_MoveChild, 0,
/*27963*/       OPC_CheckOpcode, ISD::LOAD,
/*27965*/       OPC_RecordMemRef,
/*27966*/       OPC_RecordNode, // #1 = 'ld' chained node
/*27967*/       OPC_CheckFoldableChainNode,
/*27968*/       OPC_RecordChild1, // #2 = $src2
/*27969*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*27971*/       OPC_CheckPredicate, 8, // Predicate_load
/*27973*/       OPC_CheckPredicate, 23, // Predicate_memop
/*27975*/       OPC_CheckType, MVT::v2i64,
/*27977*/       OPC_MoveParent,
/*27978*/       OPC_MoveParent,
/*27979*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*27981*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*27984*/       OPC_EmitMergeInputChains, 1, 1, 
/*27987*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PSRLQrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v2i64, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (intrinsic_wo_chain:v2i64 580:iPTR, VR128:v2i64:$src1, (bitconvert:v2i64 (ld:v2i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>))
                // Dst: (PSRLQrm:v2i64 VR128:v2i64:$src1, addr:iPTR:$src2)
/*28000*/     /*Scope*/ 12, /*->28013*/
/*28001*/       OPC_RecordChild2, // #1 = $src2
/*28002*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*28004*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PSRLQrr), 0,
                    1/*#VTs*/, MVT::v2i64, 2/*#Ops*/, 0, 1, 
                // Src: (intrinsic_wo_chain:v2i64 580:iPTR, VR128:v2i64:$src1, VR128:v2i64:$src2)
                // Dst: (PSRLQrr:v2i64 VR128:v2i64:$src1, VR128:v2i64:$src2)
/*28013*/     0, /*End of Scope*/
/*28014*/   /*Scope*/ 64, /*->28079*/
/*28015*/     OPC_CheckInteger, 62|128,4/*574*/, 
/*28018*/     OPC_MoveParent,
/*28019*/     OPC_RecordChild1, // #0 = $src1
/*28020*/     OPC_Scope, 43, /*->28065*/ // 2 children in Scope
/*28022*/       OPC_MoveChild, 2,
/*28024*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*28026*/       OPC_MoveChild, 0,
/*28028*/       OPC_CheckOpcode, ISD::LOAD,
/*28030*/       OPC_RecordMemRef,
/*28031*/       OPC_RecordNode, // #1 = 'ld' chained node
/*28032*/       OPC_CheckFoldableChainNode,
/*28033*/       OPC_RecordChild1, // #2 = $src2
/*28034*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*28036*/       OPC_CheckPredicate, 8, // Predicate_load
/*28038*/       OPC_CheckPredicate, 23, // Predicate_memop
/*28040*/       OPC_CheckType, MVT::v2i64,
/*28042*/       OPC_MoveParent,
/*28043*/       OPC_MoveParent,
/*28044*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*28046*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*28049*/       OPC_EmitMergeInputChains, 1, 1, 
/*28052*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PSRAWrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v8i16, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (intrinsic_wo_chain:v8i16 574:iPTR, VR128:v8i16:$src1, (bitconvert:v8i16 (ld:v2i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>))
                // Dst: (PSRAWrm:v8i16 VR128:v8i16:$src1, addr:iPTR:$src2)
/*28065*/     /*Scope*/ 12, /*->28078*/
/*28066*/       OPC_RecordChild2, // #1 = $src2
/*28067*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*28069*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PSRAWrr), 0,
                    1/*#VTs*/, MVT::v8i16, 2/*#Ops*/, 0, 1, 
                // Src: (intrinsic_wo_chain:v8i16 574:iPTR, VR128:v8i16:$src1, VR128:v8i16:$src2)
                // Dst: (PSRAWrr:v8i16 VR128:v8i16:$src1, VR128:v8i16:$src2)
/*28078*/     0, /*End of Scope*/
/*28079*/   /*Scope*/ 64, /*->28144*/
/*28080*/     OPC_CheckInteger, 61|128,4/*573*/, 
/*28083*/     OPC_MoveParent,
/*28084*/     OPC_RecordChild1, // #0 = $src1
/*28085*/     OPC_Scope, 43, /*->28130*/ // 2 children in Scope
/*28087*/       OPC_MoveChild, 2,
/*28089*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*28091*/       OPC_MoveChild, 0,
/*28093*/       OPC_CheckOpcode, ISD::LOAD,
/*28095*/       OPC_RecordMemRef,
/*28096*/       OPC_RecordNode, // #1 = 'ld' chained node
/*28097*/       OPC_CheckFoldableChainNode,
/*28098*/       OPC_RecordChild1, // #2 = $src2
/*28099*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*28101*/       OPC_CheckPredicate, 8, // Predicate_load
/*28103*/       OPC_CheckPredicate, 23, // Predicate_memop
/*28105*/       OPC_CheckType, MVT::v2i64,
/*28107*/       OPC_MoveParent,
/*28108*/       OPC_MoveParent,
/*28109*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*28111*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*28114*/       OPC_EmitMergeInputChains, 1, 1, 
/*28117*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PSRADrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v4i32, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (intrinsic_wo_chain:v4i32 573:iPTR, VR128:v4i32:$src1, (bitconvert:v4i32 (ld:v2i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>))
                // Dst: (PSRADrm:v4i32 VR128:v4i32:$src1, addr:iPTR:$src2)
/*28130*/     /*Scope*/ 12, /*->28143*/
/*28131*/       OPC_RecordChild2, // #1 = $src2
/*28132*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*28134*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PSRADrr), 0,
                    1/*#VTs*/, MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (intrinsic_wo_chain:v4i32 573:iPTR, VR128:v4i32:$src1, VR128:v4i32:$src2)
                // Dst: (PSRADrr:v4i32 VR128:v4i32:$src1, VR128:v4i32:$src2)
/*28143*/     0, /*End of Scope*/
/*28144*/   /*Scope*/ 64, /*->28209*/
/*28145*/     OPC_CheckInteger, 37|128,4/*549*/, 
/*28148*/     OPC_MoveParent,
/*28149*/     OPC_RecordChild1, // #0 = $src1
/*28150*/     OPC_Scope, 43, /*->28195*/ // 2 children in Scope
/*28152*/       OPC_MoveChild, 2,
/*28154*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*28156*/       OPC_MoveChild, 0,
/*28158*/       OPC_CheckOpcode, ISD::LOAD,
/*28160*/       OPC_RecordMemRef,
/*28161*/       OPC_RecordNode, // #1 = 'ld' chained node
/*28162*/       OPC_CheckFoldableChainNode,
/*28163*/       OPC_RecordChild1, // #2 = $src2
/*28164*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*28166*/       OPC_CheckPredicate, 8, // Predicate_load
/*28168*/       OPC_CheckPredicate, 23, // Predicate_memop
/*28170*/       OPC_CheckType, MVT::v2i64,
/*28172*/       OPC_MoveParent,
/*28173*/       OPC_MoveParent,
/*28174*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*28176*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*28179*/       OPC_EmitMergeInputChains, 1, 1, 
/*28182*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PCMPEQBrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v16i8, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (intrinsic_wo_chain:v16i8 549:iPTR, VR128:v16i8:$src1, (bitconvert:v16i8 (ld:v2i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>))
                // Dst: (PCMPEQBrm:v16i8 VR128:v16i8:$src1, addr:iPTR:$src2)
/*28195*/     /*Scope*/ 12, /*->28208*/
/*28196*/       OPC_RecordChild2, // #1 = $src2
/*28197*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*28199*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PCMPEQBrr), 0,
                    1/*#VTs*/, MVT::v16i8, 2/*#Ops*/, 0, 1, 
                // Src: (intrinsic_wo_chain:v16i8 549:iPTR, VR128:v16i8:$src1, VR128:v16i8:$src2)
                // Dst: (PCMPEQBrr:v16i8 VR128:v16i8:$src1, VR128:v16i8:$src2)
/*28208*/     0, /*End of Scope*/
/*28209*/   /*Scope*/ 64, /*->28274*/
/*28210*/     OPC_CheckInteger, 39|128,4/*551*/, 
/*28213*/     OPC_MoveParent,
/*28214*/     OPC_RecordChild1, // #0 = $src1
/*28215*/     OPC_Scope, 43, /*->28260*/ // 2 children in Scope
/*28217*/       OPC_MoveChild, 2,
/*28219*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*28221*/       OPC_MoveChild, 0,
/*28223*/       OPC_CheckOpcode, ISD::LOAD,
/*28225*/       OPC_RecordMemRef,
/*28226*/       OPC_RecordNode, // #1 = 'ld' chained node
/*28227*/       OPC_CheckFoldableChainNode,
/*28228*/       OPC_RecordChild1, // #2 = $src2
/*28229*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*28231*/       OPC_CheckPredicate, 8, // Predicate_load
/*28233*/       OPC_CheckPredicate, 23, // Predicate_memop
/*28235*/       OPC_CheckType, MVT::v2i64,
/*28237*/       OPC_MoveParent,
/*28238*/       OPC_MoveParent,
/*28239*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*28241*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*28244*/       OPC_EmitMergeInputChains, 1, 1, 
/*28247*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PCMPEQWrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v8i16, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (intrinsic_wo_chain:v8i16 551:iPTR, VR128:v8i16:$src1, (bitconvert:v8i16 (ld:v2i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>))
                // Dst: (PCMPEQWrm:v8i16 VR128:v8i16:$src1, addr:iPTR:$src2)
/*28260*/     /*Scope*/ 12, /*->28273*/
/*28261*/       OPC_RecordChild2, // #1 = $src2
/*28262*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*28264*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PCMPEQWrr), 0,
                    1/*#VTs*/, MVT::v8i16, 2/*#Ops*/, 0, 1, 
                // Src: (intrinsic_wo_chain:v8i16 551:iPTR, VR128:v8i16:$src1, VR128:v8i16:$src2)
                // Dst: (PCMPEQWrr:v8i16 VR128:v8i16:$src1, VR128:v8i16:$src2)
/*28273*/     0, /*End of Scope*/
/*28274*/   /*Scope*/ 64, /*->28339*/
/*28275*/     OPC_CheckInteger, 38|128,4/*550*/, 
/*28278*/     OPC_MoveParent,
/*28279*/     OPC_RecordChild1, // #0 = $src1
/*28280*/     OPC_Scope, 43, /*->28325*/ // 2 children in Scope
/*28282*/       OPC_MoveChild, 2,
/*28284*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*28286*/       OPC_MoveChild, 0,
/*28288*/       OPC_CheckOpcode, ISD::LOAD,
/*28290*/       OPC_RecordMemRef,
/*28291*/       OPC_RecordNode, // #1 = 'ld' chained node
/*28292*/       OPC_CheckFoldableChainNode,
/*28293*/       OPC_RecordChild1, // #2 = $src2
/*28294*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*28296*/       OPC_CheckPredicate, 8, // Predicate_load
/*28298*/       OPC_CheckPredicate, 23, // Predicate_memop
/*28300*/       OPC_CheckType, MVT::v2i64,
/*28302*/       OPC_MoveParent,
/*28303*/       OPC_MoveParent,
/*28304*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*28306*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*28309*/       OPC_EmitMergeInputChains, 1, 1, 
/*28312*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PCMPEQDrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v4i32, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (intrinsic_wo_chain:v4i32 550:iPTR, VR128:v4i32:$src1, (bitconvert:v4i32 (ld:v2i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>))
                // Dst: (PCMPEQDrm:v4i32 VR128:v4i32:$src1, addr:iPTR:$src2)
/*28325*/     /*Scope*/ 12, /*->28338*/
/*28326*/       OPC_RecordChild2, // #1 = $src2
/*28327*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*28329*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PCMPEQDrr), 0,
                    1/*#VTs*/, MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (intrinsic_wo_chain:v4i32 550:iPTR, VR128:v4i32:$src1, VR128:v4i32:$src2)
                // Dst: (PCMPEQDrr:v4i32 VR128:v4i32:$src1, VR128:v4i32:$src2)
/*28338*/     0, /*End of Scope*/
/*28339*/   /*Scope*/ 64, /*->28404*/
/*28340*/     OPC_CheckInteger, 40|128,4/*552*/, 
/*28343*/     OPC_MoveParent,
/*28344*/     OPC_RecordChild1, // #0 = $src1
/*28345*/     OPC_Scope, 43, /*->28390*/ // 2 children in Scope
/*28347*/       OPC_MoveChild, 2,
/*28349*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*28351*/       OPC_MoveChild, 0,
/*28353*/       OPC_CheckOpcode, ISD::LOAD,
/*28355*/       OPC_RecordMemRef,
/*28356*/       OPC_RecordNode, // #1 = 'ld' chained node
/*28357*/       OPC_CheckFoldableChainNode,
/*28358*/       OPC_RecordChild1, // #2 = $src2
/*28359*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*28361*/       OPC_CheckPredicate, 8, // Predicate_load
/*28363*/       OPC_CheckPredicate, 23, // Predicate_memop
/*28365*/       OPC_CheckType, MVT::v2i64,
/*28367*/       OPC_MoveParent,
/*28368*/       OPC_MoveParent,
/*28369*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*28371*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*28374*/       OPC_EmitMergeInputChains, 1, 1, 
/*28377*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PCMPGTBrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v16i8, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (intrinsic_wo_chain:v16i8 552:iPTR, VR128:v16i8:$src1, (bitconvert:v16i8 (ld:v2i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>))
                // Dst: (PCMPGTBrm:v16i8 VR128:v16i8:$src1, addr:iPTR:$src2)
/*28390*/     /*Scope*/ 12, /*->28403*/
/*28391*/       OPC_RecordChild2, // #1 = $src2
/*28392*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*28394*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PCMPGTBrr), 0,
                    1/*#VTs*/, MVT::v16i8, 2/*#Ops*/, 0, 1, 
                // Src: (intrinsic_wo_chain:v16i8 552:iPTR, VR128:v16i8:$src1, VR128:v16i8:$src2)
                // Dst: (PCMPGTBrr:v16i8 VR128:v16i8:$src1, VR128:v16i8:$src2)
/*28403*/     0, /*End of Scope*/
/*28404*/   /*Scope*/ 64, /*->28469*/
/*28405*/     OPC_CheckInteger, 42|128,4/*554*/, 
/*28408*/     OPC_MoveParent,
/*28409*/     OPC_RecordChild1, // #0 = $src1
/*28410*/     OPC_Scope, 43, /*->28455*/ // 2 children in Scope
/*28412*/       OPC_MoveChild, 2,
/*28414*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*28416*/       OPC_MoveChild, 0,
/*28418*/       OPC_CheckOpcode, ISD::LOAD,
/*28420*/       OPC_RecordMemRef,
/*28421*/       OPC_RecordNode, // #1 = 'ld' chained node
/*28422*/       OPC_CheckFoldableChainNode,
/*28423*/       OPC_RecordChild1, // #2 = $src2
/*28424*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*28426*/       OPC_CheckPredicate, 8, // Predicate_load
/*28428*/       OPC_CheckPredicate, 23, // Predicate_memop
/*28430*/       OPC_CheckType, MVT::v2i64,
/*28432*/       OPC_MoveParent,
/*28433*/       OPC_MoveParent,
/*28434*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*28436*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*28439*/       OPC_EmitMergeInputChains, 1, 1, 
/*28442*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PCMPGTWrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v8i16, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (intrinsic_wo_chain:v8i16 554:iPTR, VR128:v8i16:$src1, (bitconvert:v8i16 (ld:v2i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>))
                // Dst: (PCMPGTWrm:v8i16 VR128:v8i16:$src1, addr:iPTR:$src2)
/*28455*/     /*Scope*/ 12, /*->28468*/
/*28456*/       OPC_RecordChild2, // #1 = $src2
/*28457*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*28459*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PCMPGTWrr), 0,
                    1/*#VTs*/, MVT::v8i16, 2/*#Ops*/, 0, 1, 
                // Src: (intrinsic_wo_chain:v8i16 554:iPTR, VR128:v8i16:$src1, VR128:v8i16:$src2)
                // Dst: (PCMPGTWrr:v8i16 VR128:v8i16:$src1, VR128:v8i16:$src2)
/*28468*/     0, /*End of Scope*/
/*28469*/   /*Scope*/ 64, /*->28534*/
/*28470*/     OPC_CheckInteger, 41|128,4/*553*/, 
/*28473*/     OPC_MoveParent,
/*28474*/     OPC_RecordChild1, // #0 = $src1
/*28475*/     OPC_Scope, 43, /*->28520*/ // 2 children in Scope
/*28477*/       OPC_MoveChild, 2,
/*28479*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*28481*/       OPC_MoveChild, 0,
/*28483*/       OPC_CheckOpcode, ISD::LOAD,
/*28485*/       OPC_RecordMemRef,
/*28486*/       OPC_RecordNode, // #1 = 'ld' chained node
/*28487*/       OPC_CheckFoldableChainNode,
/*28488*/       OPC_RecordChild1, // #2 = $src2
/*28489*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*28491*/       OPC_CheckPredicate, 8, // Predicate_load
/*28493*/       OPC_CheckPredicate, 23, // Predicate_memop
/*28495*/       OPC_CheckType, MVT::v2i64,
/*28497*/       OPC_MoveParent,
/*28498*/       OPC_MoveParent,
/*28499*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*28501*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*28504*/       OPC_EmitMergeInputChains, 1, 1, 
/*28507*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PCMPGTDrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v4i32, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (intrinsic_wo_chain:v4i32 553:iPTR, VR128:v4i32:$src1, (bitconvert:v4i32 (ld:v2i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>))
                // Dst: (PCMPGTDrm:v4i32 VR128:v4i32:$src1, addr:iPTR:$src2)
/*28520*/     /*Scope*/ 12, /*->28533*/
/*28521*/       OPC_RecordChild2, // #1 = $src2
/*28522*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*28524*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PCMPGTDrr), 0,
                    1/*#VTs*/, MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (intrinsic_wo_chain:v4i32 553:iPTR, VR128:v4i32:$src1, VR128:v4i32:$src2)
                // Dst: (PCMPGTDrr:v4i32 VR128:v4i32:$src1, VR128:v4i32:$src2)
/*28533*/     0, /*End of Scope*/
/*28534*/   /*Scope*/ 64, /*->28599*/
/*28535*/     OPC_CheckInteger, 29|128,4/*541*/, 
/*28538*/     OPC_MoveParent,
/*28539*/     OPC_RecordChild1, // #0 = $src1
/*28540*/     OPC_Scope, 43, /*->28585*/ // 2 children in Scope
/*28542*/       OPC_MoveChild, 2,
/*28544*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*28546*/       OPC_MoveChild, 0,
/*28548*/       OPC_CheckOpcode, ISD::LOAD,
/*28550*/       OPC_RecordMemRef,
/*28551*/       OPC_RecordNode, // #1 = 'ld' chained node
/*28552*/       OPC_CheckFoldableChainNode,
/*28553*/       OPC_RecordChild1, // #2 = $src2
/*28554*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*28556*/       OPC_CheckPredicate, 8, // Predicate_load
/*28558*/       OPC_CheckPredicate, 23, // Predicate_memop
/*28560*/       OPC_CheckType, MVT::v2i64,
/*28562*/       OPC_MoveParent,
/*28563*/       OPC_MoveParent,
/*28564*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*28566*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*28569*/       OPC_EmitMergeInputChains, 1, 1, 
/*28572*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PACKSSWBrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v16i8, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (intrinsic_wo_chain:v16i8 541:iPTR, VR128:v8i16:$src1, (bitconvert:v8i16 (ld:v2i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>))
                // Dst: (PACKSSWBrm:v16i8 VR128:v8i16:$src1, addr:iPTR:$src2)
/*28585*/     /*Scope*/ 12, /*->28598*/
/*28586*/       OPC_RecordChild2, // #1 = $src2
/*28587*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*28589*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PACKSSWBrr), 0,
                    1/*#VTs*/, MVT::v16i8, 2/*#Ops*/, 0, 1, 
                // Src: (intrinsic_wo_chain:v16i8 541:iPTR, VR128:v8i16:$src1, VR128:v8i16:$src2)
                // Dst: (PACKSSWBrr:v16i8 VR128:v8i16:$src1, VR128:v8i16:$src2)
/*28598*/     0, /*End of Scope*/
/*28599*/   /*Scope*/ 64, /*->28664*/
/*28600*/     OPC_CheckInteger, 28|128,4/*540*/, 
/*28603*/     OPC_MoveParent,
/*28604*/     OPC_RecordChild1, // #0 = $src1
/*28605*/     OPC_Scope, 43, /*->28650*/ // 2 children in Scope
/*28607*/       OPC_MoveChild, 2,
/*28609*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*28611*/       OPC_MoveChild, 0,
/*28613*/       OPC_CheckOpcode, ISD::LOAD,
/*28615*/       OPC_RecordMemRef,
/*28616*/       OPC_RecordNode, // #1 = 'ld' chained node
/*28617*/       OPC_CheckFoldableChainNode,
/*28618*/       OPC_RecordChild1, // #2 = $src2
/*28619*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*28621*/       OPC_CheckPredicate, 8, // Predicate_load
/*28623*/       OPC_CheckPredicate, 23, // Predicate_memop
/*28625*/       OPC_CheckType, MVT::v2i64,
/*28627*/       OPC_MoveParent,
/*28628*/       OPC_MoveParent,
/*28629*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*28631*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*28634*/       OPC_EmitMergeInputChains, 1, 1, 
/*28637*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PACKSSDWrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v8i16, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (intrinsic_wo_chain:v8i16 540:iPTR, VR128:v4i32:$src1, (bitconvert:v4i32 (ld:v2i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>))
                // Dst: (PACKSSDWrm:v8i16 VR128:v4i32:$src1, addr:iPTR:$src2)
/*28650*/     /*Scope*/ 12, /*->28663*/
/*28651*/       OPC_RecordChild2, // #1 = $src2
/*28652*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*28654*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PACKSSDWrr), 0,
                    1/*#VTs*/, MVT::v8i16, 2/*#Ops*/, 0, 1, 
                // Src: (intrinsic_wo_chain:v8i16 540:iPTR, VR128:v4i32:$src1, VR128:v4i32:$src2)
                // Dst: (PACKSSDWrr:v8i16 VR128:v4i32:$src1, VR128:v4i32:$src2)
/*28663*/     0, /*End of Scope*/
/*28664*/   /*Scope*/ 64, /*->28729*/
/*28665*/     OPC_CheckInteger, 30|128,4/*542*/, 
/*28668*/     OPC_MoveParent,
/*28669*/     OPC_RecordChild1, // #0 = $src1
/*28670*/     OPC_Scope, 43, /*->28715*/ // 2 children in Scope
/*28672*/       OPC_MoveChild, 2,
/*28674*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*28676*/       OPC_MoveChild, 0,
/*28678*/       OPC_CheckOpcode, ISD::LOAD,
/*28680*/       OPC_RecordMemRef,
/*28681*/       OPC_RecordNode, // #1 = 'ld' chained node
/*28682*/       OPC_CheckFoldableChainNode,
/*28683*/       OPC_RecordChild1, // #2 = $src2
/*28684*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*28686*/       OPC_CheckPredicate, 8, // Predicate_load
/*28688*/       OPC_CheckPredicate, 23, // Predicate_memop
/*28690*/       OPC_CheckType, MVT::v2i64,
/*28692*/       OPC_MoveParent,
/*28693*/       OPC_MoveParent,
/*28694*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*28696*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*28699*/       OPC_EmitMergeInputChains, 1, 1, 
/*28702*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PACKUSWBrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v16i8, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (intrinsic_wo_chain:v16i8 542:iPTR, VR128:v8i16:$src1, (bitconvert:v8i16 (ld:v2i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>))
                // Dst: (PACKUSWBrm:v16i8 VR128:v8i16:$src1, addr:iPTR:$src2)
/*28715*/     /*Scope*/ 12, /*->28728*/
/*28716*/       OPC_RecordChild2, // #1 = $src2
/*28717*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*28719*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PACKUSWBrr), 0,
                    1/*#VTs*/, MVT::v16i8, 2/*#Ops*/, 0, 1, 
                // Src: (intrinsic_wo_chain:v16i8 542:iPTR, VR128:v8i16:$src1, VR128:v8i16:$src2)
                // Dst: (PACKUSWBrr:v16i8 VR128:v8i16:$src1, VR128:v8i16:$src2)
/*28728*/     0, /*End of Scope*/
/*28729*/   /*Scope*/ 61, /*->28791*/
/*28730*/     OPC_CheckInteger, 83|128,5/*723*/, 
/*28733*/     OPC_MoveParent,
/*28734*/     OPC_Scope, 42, /*->28778*/ // 2 children in Scope
/*28736*/       OPC_MoveChild, 1,
/*28738*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*28740*/       OPC_MoveChild, 0,
/*28742*/       OPC_CheckOpcode, ISD::LOAD,
/*28744*/       OPC_RecordMemRef,
/*28745*/       OPC_RecordNode, // #0 = 'ld' chained node
/*28746*/       OPC_CheckFoldableChainNode,
/*28747*/       OPC_RecordChild1, // #1 = $src
/*28748*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*28750*/       OPC_CheckPredicate, 8, // Predicate_load
/*28752*/       OPC_CheckPredicate, 66, // Predicate_memop64
/*28754*/       OPC_CheckType, MVT::v8i8,
/*28756*/       OPC_MoveParent,
/*28757*/       OPC_MoveParent,
/*28758*/       OPC_CheckPatternPredicate, 11, // (Subtarget->hasSSSE3())
/*28760*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*28763*/       OPC_EmitMergeInputChains, 1, 0, 
/*28766*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PABSBrm64), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v8i8, 5/*#Ops*/, 2, 3, 4, 5, 6, 
                // Src: (intrinsic_wo_chain:v8i8 723:iPTR, (bitconvert:v8i8 (ld:v8i8 addr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop64>>))
                // Dst: (PABSBrm64:v8i8 addr:iPTR:$src)
/*28778*/     /*Scope*/ 11, /*->28790*/
/*28779*/       OPC_RecordChild1, // #0 = $src
/*28780*/       OPC_CheckPatternPredicate, 11, // (Subtarget->hasSSSE3())
/*28782*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PABSBrr64), 0,
                    1/*#VTs*/, MVT::v8i8, 1/*#Ops*/, 0, 
                // Src: (intrinsic_wo_chain:v8i8 723:iPTR, VR64:v8i8:$src)
                // Dst: (PABSBrr64:v8i8 VR64:v8i8:$src)
/*28790*/     0, /*End of Scope*/
/*28791*/   /*Scope*/ 61, /*->28853*/
/*28792*/     OPC_CheckInteger, 84|128,5/*724*/, 
/*28795*/     OPC_MoveParent,
/*28796*/     OPC_Scope, 42, /*->28840*/ // 2 children in Scope
/*28798*/       OPC_MoveChild, 1,
/*28800*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*28802*/       OPC_MoveChild, 0,
/*28804*/       OPC_CheckOpcode, ISD::LOAD,
/*28806*/       OPC_RecordMemRef,
/*28807*/       OPC_RecordNode, // #0 = 'ld' chained node
/*28808*/       OPC_CheckFoldableChainNode,
/*28809*/       OPC_RecordChild1, // #1 = $src
/*28810*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*28812*/       OPC_CheckPredicate, 8, // Predicate_load
/*28814*/       OPC_CheckPredicate, 23, // Predicate_memop
/*28816*/       OPC_CheckType, MVT::v16i8,
/*28818*/       OPC_MoveParent,
/*28819*/       OPC_MoveParent,
/*28820*/       OPC_CheckPatternPredicate, 11, // (Subtarget->hasSSSE3())
/*28822*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*28825*/       OPC_EmitMergeInputChains, 1, 0, 
/*28828*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PABSBrm128), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v16i8, 5/*#Ops*/, 2, 3, 4, 5, 6, 
                // Src: (intrinsic_wo_chain:v16i8 724:iPTR, (bitconvert:v16i8 (ld:v16i8 addr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>))
                // Dst: (PABSBrm128:v16i8 addr:iPTR:$src)
/*28840*/     /*Scope*/ 11, /*->28852*/
/*28841*/       OPC_RecordChild1, // #0 = $src
/*28842*/       OPC_CheckPatternPredicate, 11, // (Subtarget->hasSSSE3())
/*28844*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PABSBrr128), 0,
                    1/*#VTs*/, MVT::v16i8, 1/*#Ops*/, 0, 
                // Src: (intrinsic_wo_chain:v16i8 724:iPTR, VR128:v16i8:$src)
                // Dst: (PABSBrr128:v16i8 VR128:v16i8:$src)
/*28852*/     0, /*End of Scope*/
/*28853*/   /*Scope*/ 61, /*->28915*/
/*28854*/     OPC_CheckInteger, 87|128,5/*727*/, 
/*28857*/     OPC_MoveParent,
/*28858*/     OPC_Scope, 42, /*->28902*/ // 2 children in Scope
/*28860*/       OPC_MoveChild, 1,
/*28862*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*28864*/       OPC_MoveChild, 0,
/*28866*/       OPC_CheckOpcode, ISD::LOAD,
/*28868*/       OPC_RecordMemRef,
/*28869*/       OPC_RecordNode, // #0 = 'ld' chained node
/*28870*/       OPC_CheckFoldableChainNode,
/*28871*/       OPC_RecordChild1, // #1 = $src
/*28872*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*28874*/       OPC_CheckPredicate, 8, // Predicate_load
/*28876*/       OPC_CheckPredicate, 66, // Predicate_memop64
/*28878*/       OPC_CheckType, MVT::v4i16,
/*28880*/       OPC_MoveParent,
/*28881*/       OPC_MoveParent,
/*28882*/       OPC_CheckPatternPredicate, 11, // (Subtarget->hasSSSE3())
/*28884*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*28887*/       OPC_EmitMergeInputChains, 1, 0, 
/*28890*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PABSWrm64), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v4i16, 5/*#Ops*/, 2, 3, 4, 5, 6, 
                // Src: (intrinsic_wo_chain:v4i16 727:iPTR, (bitconvert:v4i16 (ld:v4i16 addr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop64>>))
                // Dst: (PABSWrm64:v4i16 addr:iPTR:$src)
/*28902*/     /*Scope*/ 11, /*->28914*/
/*28903*/       OPC_RecordChild1, // #0 = $src
/*28904*/       OPC_CheckPatternPredicate, 11, // (Subtarget->hasSSSE3())
/*28906*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PABSWrr64), 0,
                    1/*#VTs*/, MVT::v4i16, 1/*#Ops*/, 0, 
                // Src: (intrinsic_wo_chain:v4i16 727:iPTR, VR64:v4i16:$src)
                // Dst: (PABSWrr64:v4i16 VR64:v4i16:$src)
/*28914*/     0, /*End of Scope*/
/*28915*/   /*Scope*/ 61, /*->28977*/
/*28916*/     OPC_CheckInteger, 88|128,5/*728*/, 
/*28919*/     OPC_MoveParent,
/*28920*/     OPC_Scope, 42, /*->28964*/ // 2 children in Scope
/*28922*/       OPC_MoveChild, 1,
/*28924*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*28926*/       OPC_MoveChild, 0,
/*28928*/       OPC_CheckOpcode, ISD::LOAD,
/*28930*/       OPC_RecordMemRef,
/*28931*/       OPC_RecordNode, // #0 = 'ld' chained node
/*28932*/       OPC_CheckFoldableChainNode,
/*28933*/       OPC_RecordChild1, // #1 = $src
/*28934*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*28936*/       OPC_CheckPredicate, 8, // Predicate_load
/*28938*/       OPC_CheckPredicate, 66, // Predicate_memop64
/*28940*/       OPC_CheckType, MVT::v8i16,
/*28942*/       OPC_MoveParent,
/*28943*/       OPC_MoveParent,
/*28944*/       OPC_CheckPatternPredicate, 11, // (Subtarget->hasSSSE3())
/*28946*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*28949*/       OPC_EmitMergeInputChains, 1, 0, 
/*28952*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PABSWrm128), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v8i16, 5/*#Ops*/, 2, 3, 4, 5, 6, 
                // Src: (intrinsic_wo_chain:v8i16 728:iPTR, (bitconvert:v8i16 (ld:v8i16 addr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop64>>))
                // Dst: (PABSWrm128:v8i16 addr:iPTR:$src)
/*28964*/     /*Scope*/ 11, /*->28976*/
/*28965*/       OPC_RecordChild1, // #0 = $src
/*28966*/       OPC_CheckPatternPredicate, 11, // (Subtarget->hasSSSE3())
/*28968*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PABSWrr128), 0,
                    1/*#VTs*/, MVT::v8i16, 1/*#Ops*/, 0, 
                // Src: (intrinsic_wo_chain:v8i16 728:iPTR, VR128:v8i16:$src)
                // Dst: (PABSWrr128:v8i16 VR128:v8i16:$src)
/*28976*/     0, /*End of Scope*/
/*28977*/   /*Scope*/ 61, /*->29039*/
/*28978*/     OPC_CheckInteger, 85|128,5/*725*/, 
/*28981*/     OPC_MoveParent,
/*28982*/     OPC_Scope, 42, /*->29026*/ // 2 children in Scope
/*28984*/       OPC_MoveChild, 1,
/*28986*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*28988*/       OPC_MoveChild, 0,
/*28990*/       OPC_CheckOpcode, ISD::LOAD,
/*28992*/       OPC_RecordMemRef,
/*28993*/       OPC_RecordNode, // #0 = 'ld' chained node
/*28994*/       OPC_CheckFoldableChainNode,
/*28995*/       OPC_RecordChild1, // #1 = $src
/*28996*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*28998*/       OPC_CheckPredicate, 8, // Predicate_load
/*29000*/       OPC_CheckPredicate, 66, // Predicate_memop64
/*29002*/       OPC_CheckType, MVT::v2i32,
/*29004*/       OPC_MoveParent,
/*29005*/       OPC_MoveParent,
/*29006*/       OPC_CheckPatternPredicate, 11, // (Subtarget->hasSSSE3())
/*29008*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*29011*/       OPC_EmitMergeInputChains, 1, 0, 
/*29014*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PABSDrm64), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v2i32, 5/*#Ops*/, 2, 3, 4, 5, 6, 
                // Src: (intrinsic_wo_chain:v2i32 725:iPTR, (bitconvert:v2i32 (ld:v2i32 addr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop64>>))
                // Dst: (PABSDrm64:v2i32 addr:iPTR:$src)
/*29026*/     /*Scope*/ 11, /*->29038*/
/*29027*/       OPC_RecordChild1, // #0 = $src
/*29028*/       OPC_CheckPatternPredicate, 11, // (Subtarget->hasSSSE3())
/*29030*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PABSDrr64), 0,
                    1/*#VTs*/, MVT::v2i32, 1/*#Ops*/, 0, 
                // Src: (intrinsic_wo_chain:v2i32 725:iPTR, VR64:v2i32:$src)
                // Dst: (PABSDrr64:v2i32 VR64:v2i32:$src)
/*29038*/     0, /*End of Scope*/
/*29039*/   /*Scope*/ 61, /*->29101*/
/*29040*/     OPC_CheckInteger, 86|128,5/*726*/, 
/*29043*/     OPC_MoveParent,
/*29044*/     OPC_Scope, 42, /*->29088*/ // 2 children in Scope
/*29046*/       OPC_MoveChild, 1,
/*29048*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*29050*/       OPC_MoveChild, 0,
/*29052*/       OPC_CheckOpcode, ISD::LOAD,
/*29054*/       OPC_RecordMemRef,
/*29055*/       OPC_RecordNode, // #0 = 'ld' chained node
/*29056*/       OPC_CheckFoldableChainNode,
/*29057*/       OPC_RecordChild1, // #1 = $src
/*29058*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*29060*/       OPC_CheckPredicate, 8, // Predicate_load
/*29062*/       OPC_CheckPredicate, 23, // Predicate_memop
/*29064*/       OPC_CheckType, MVT::v4i32,
/*29066*/       OPC_MoveParent,
/*29067*/       OPC_MoveParent,
/*29068*/       OPC_CheckPatternPredicate, 11, // (Subtarget->hasSSSE3())
/*29070*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*29073*/       OPC_EmitMergeInputChains, 1, 0, 
/*29076*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PABSDrm128), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v4i32, 5/*#Ops*/, 2, 3, 4, 5, 6, 
                // Src: (intrinsic_wo_chain:v4i32 726:iPTR, (bitconvert:v4i32 (ld:v4i32 addr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>))
                // Dst: (PABSDrm128:v4i32 addr:iPTR:$src)
/*29088*/     /*Scope*/ 11, /*->29100*/
/*29089*/       OPC_RecordChild1, // #0 = $src
/*29090*/       OPC_CheckPatternPredicate, 11, // (Subtarget->hasSSSE3())
/*29092*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PABSDrr128), 0,
                    1/*#VTs*/, MVT::v4i32, 1/*#Ops*/, 0, 
                // Src: (intrinsic_wo_chain:v4i32 726:iPTR, VR128:v4i32:$src)
                // Dst: (PABSDrr128:v4i32 VR128:v4i32:$src)
/*29100*/     0, /*End of Scope*/
/*29101*/   /*Scope*/ 64, /*->29166*/
/*29102*/     OPC_CheckInteger, 95|128,5/*735*/, 
/*29105*/     OPC_MoveParent,
/*29106*/     OPC_RecordChild1, // #0 = $src1
/*29107*/     OPC_Scope, 43, /*->29152*/ // 2 children in Scope
/*29109*/       OPC_MoveChild, 2,
/*29111*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*29113*/       OPC_MoveChild, 0,
/*29115*/       OPC_CheckOpcode, ISD::LOAD,
/*29117*/       OPC_RecordMemRef,
/*29118*/       OPC_RecordNode, // #1 = 'ld' chained node
/*29119*/       OPC_CheckFoldableChainNode,
/*29120*/       OPC_RecordChild1, // #2 = $src2
/*29121*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*29123*/       OPC_CheckPredicate, 8, // Predicate_load
/*29125*/       OPC_CheckPredicate, 66, // Predicate_memop64
/*29127*/       OPC_CheckType, MVT::v4i16,
/*29129*/       OPC_MoveParent,
/*29130*/       OPC_MoveParent,
/*29131*/       OPC_CheckPatternPredicate, 11, // (Subtarget->hasSSSE3())
/*29133*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*29136*/       OPC_EmitMergeInputChains, 1, 1, 
/*29139*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PHADDWrm64), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v4i16, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (intrinsic_wo_chain:v4i16 735:iPTR, VR64:v4i16:$src1, (bitconvert:v4i16 (ld:v4i16 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop64>>))
                // Dst: (PHADDWrm64:v4i16 VR64:v4i16:$src1, addr:iPTR:$src2)
/*29152*/     /*Scope*/ 12, /*->29165*/
/*29153*/       OPC_RecordChild2, // #1 = $src2
/*29154*/       OPC_CheckPatternPredicate, 11, // (Subtarget->hasSSSE3())
/*29156*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PHADDWrr64), 0,
                    1/*#VTs*/, MVT::v4i16, 2/*#Ops*/, 0, 1, 
                // Src: (intrinsic_wo_chain:v4i16 735:iPTR, VR64:v4i16:$src1, VR64:v4i16:$src2)
                // Dst: (PHADDWrr64:v4i16 VR64:v4i16:$src1, VR64:v4i16:$src2)
/*29165*/     0, /*End of Scope*/
/*29166*/   /*Scope*/ 64, /*->29231*/
/*29167*/     OPC_CheckInteger, 96|128,5/*736*/, 
/*29170*/     OPC_MoveParent,
/*29171*/     OPC_RecordChild1, // #0 = $src1
/*29172*/     OPC_Scope, 43, /*->29217*/ // 2 children in Scope
/*29174*/       OPC_MoveChild, 2,
/*29176*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*29178*/       OPC_MoveChild, 0,
/*29180*/       OPC_CheckOpcode, ISD::LOAD,
/*29182*/       OPC_RecordMemRef,
/*29183*/       OPC_RecordNode, // #1 = 'ld' chained node
/*29184*/       OPC_CheckFoldableChainNode,
/*29185*/       OPC_RecordChild1, // #2 = $src2
/*29186*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*29188*/       OPC_CheckPredicate, 8, // Predicate_load
/*29190*/       OPC_CheckPredicate, 66, // Predicate_memop64
/*29192*/       OPC_CheckType, MVT::v8i16,
/*29194*/       OPC_MoveParent,
/*29195*/       OPC_MoveParent,
/*29196*/       OPC_CheckPatternPredicate, 11, // (Subtarget->hasSSSE3())
/*29198*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*29201*/       OPC_EmitMergeInputChains, 1, 1, 
/*29204*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PHADDWrm128), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v8i16, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (intrinsic_wo_chain:v8i16 736:iPTR, VR128:v8i16:$src1, (bitconvert:v8i16 (ld:v8i16 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop64>>))
                // Dst: (PHADDWrm128:v8i16 VR128:v8i16:$src1, addr:iPTR:$src2)
/*29217*/     /*Scope*/ 12, /*->29230*/
/*29218*/       OPC_RecordChild2, // #1 = $src2
/*29219*/       OPC_CheckPatternPredicate, 11, // (Subtarget->hasSSSE3())
/*29221*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PHADDWrr128), 0,
                    1/*#VTs*/, MVT::v8i16, 2/*#Ops*/, 0, 1, 
                // Src: (intrinsic_wo_chain:v8i16 736:iPTR, VR128:v8i16:$src1, VR128:v8i16:$src2)
                // Dst: (PHADDWrr128:v8i16 VR128:v8i16:$src1, VR128:v8i16:$src2)
/*29230*/     0, /*End of Scope*/
/*29231*/   /*Scope*/ 64, /*->29296*/
/*29232*/     OPC_CheckInteger, 91|128,5/*731*/, 
/*29235*/     OPC_MoveParent,
/*29236*/     OPC_RecordChild1, // #0 = $src1
/*29237*/     OPC_Scope, 43, /*->29282*/ // 2 children in Scope
/*29239*/       OPC_MoveChild, 2,
/*29241*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*29243*/       OPC_MoveChild, 0,
/*29245*/       OPC_CheckOpcode, ISD::LOAD,
/*29247*/       OPC_RecordMemRef,
/*29248*/       OPC_RecordNode, // #1 = 'ld' chained node
/*29249*/       OPC_CheckFoldableChainNode,
/*29250*/       OPC_RecordChild1, // #2 = $src2
/*29251*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*29253*/       OPC_CheckPredicate, 8, // Predicate_load
/*29255*/       OPC_CheckPredicate, 66, // Predicate_memop64
/*29257*/       OPC_CheckType, MVT::v2i32,
/*29259*/       OPC_MoveParent,
/*29260*/       OPC_MoveParent,
/*29261*/       OPC_CheckPatternPredicate, 11, // (Subtarget->hasSSSE3())
/*29263*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*29266*/       OPC_EmitMergeInputChains, 1, 1, 
/*29269*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PHADDDrm64), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v2i32, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (intrinsic_wo_chain:v2i32 731:iPTR, VR64:v2i32:$src1, (bitconvert:v2i32 (ld:v2i32 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop64>>))
                // Dst: (PHADDDrm64:v2i32 VR64:v2i32:$src1, addr:iPTR:$src2)
/*29282*/     /*Scope*/ 12, /*->29295*/
/*29283*/       OPC_RecordChild2, // #1 = $src2
/*29284*/       OPC_CheckPatternPredicate, 11, // (Subtarget->hasSSSE3())
/*29286*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PHADDDrr64), 0,
                    1/*#VTs*/, MVT::v2i32, 2/*#Ops*/, 0, 1, 
                // Src: (intrinsic_wo_chain:v2i32 731:iPTR, VR64:v2i32:$src1, VR64:v2i32:$src2)
                // Dst: (PHADDDrr64:v2i32 VR64:v2i32:$src1, VR64:v2i32:$src2)
/*29295*/     0, /*End of Scope*/
/*29296*/   /*Scope*/ 64, /*->29361*/
/*29297*/     OPC_CheckInteger, 92|128,5/*732*/, 
/*29300*/     OPC_MoveParent,
/*29301*/     OPC_RecordChild1, // #0 = $src1
/*29302*/     OPC_Scope, 43, /*->29347*/ // 2 children in Scope
/*29304*/       OPC_MoveChild, 2,
/*29306*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*29308*/       OPC_MoveChild, 0,
/*29310*/       OPC_CheckOpcode, ISD::LOAD,
/*29312*/       OPC_RecordMemRef,
/*29313*/       OPC_RecordNode, // #1 = 'ld' chained node
/*29314*/       OPC_CheckFoldableChainNode,
/*29315*/       OPC_RecordChild1, // #2 = $src2
/*29316*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*29318*/       OPC_CheckPredicate, 8, // Predicate_load
/*29320*/       OPC_CheckPredicate, 23, // Predicate_memop
/*29322*/       OPC_CheckType, MVT::v4i32,
/*29324*/       OPC_MoveParent,
/*29325*/       OPC_MoveParent,
/*29326*/       OPC_CheckPatternPredicate, 11, // (Subtarget->hasSSSE3())
/*29328*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*29331*/       OPC_EmitMergeInputChains, 1, 1, 
/*29334*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PHADDDrm128), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v4i32, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (intrinsic_wo_chain:v4i32 732:iPTR, VR128:v4i32:$src1, (bitconvert:v4i32 (ld:v4i32 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>))
                // Dst: (PHADDDrm128:v4i32 VR128:v4i32:$src1, addr:iPTR:$src2)
/*29347*/     /*Scope*/ 12, /*->29360*/
/*29348*/       OPC_RecordChild2, // #1 = $src2
/*29349*/       OPC_CheckPatternPredicate, 11, // (Subtarget->hasSSSE3())
/*29351*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PHADDDrr128), 0,
                    1/*#VTs*/, MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (intrinsic_wo_chain:v4i32 732:iPTR, VR128:v4i32:$src1, VR128:v4i32:$src2)
                // Dst: (PHADDDrr128:v4i32 VR128:v4i32:$src1, VR128:v4i32:$src2)
/*29360*/     0, /*End of Scope*/
/*29361*/   /*Scope*/ 64, /*->29426*/
/*29362*/     OPC_CheckInteger, 93|128,5/*733*/, 
/*29365*/     OPC_MoveParent,
/*29366*/     OPC_RecordChild1, // #0 = $src1
/*29367*/     OPC_Scope, 43, /*->29412*/ // 2 children in Scope
/*29369*/       OPC_MoveChild, 2,
/*29371*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*29373*/       OPC_MoveChild, 0,
/*29375*/       OPC_CheckOpcode, ISD::LOAD,
/*29377*/       OPC_RecordMemRef,
/*29378*/       OPC_RecordNode, // #1 = 'ld' chained node
/*29379*/       OPC_CheckFoldableChainNode,
/*29380*/       OPC_RecordChild1, // #2 = $src2
/*29381*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*29383*/       OPC_CheckPredicate, 8, // Predicate_load
/*29385*/       OPC_CheckPredicate, 66, // Predicate_memop64
/*29387*/       OPC_CheckType, MVT::v4i16,
/*29389*/       OPC_MoveParent,
/*29390*/       OPC_MoveParent,
/*29391*/       OPC_CheckPatternPredicate, 11, // (Subtarget->hasSSSE3())
/*29393*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*29396*/       OPC_EmitMergeInputChains, 1, 1, 
/*29399*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PHADDSWrm64), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v4i16, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (intrinsic_wo_chain:v4i16 733:iPTR, VR64:v4i16:$src1, (bitconvert:v4i16 (ld:v4i16 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop64>>))
                // Dst: (PHADDSWrm64:v4i16 VR64:v4i16:$src1, addr:iPTR:$src2)
/*29412*/     /*Scope*/ 12, /*->29425*/
/*29413*/       OPC_RecordChild2, // #1 = $src2
/*29414*/       OPC_CheckPatternPredicate, 11, // (Subtarget->hasSSSE3())
/*29416*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PHADDSWrr64), 0,
                    1/*#VTs*/, MVT::v4i16, 2/*#Ops*/, 0, 1, 
                // Src: (intrinsic_wo_chain:v4i16 733:iPTR, VR64:v4i16:$src1, VR64:v4i16:$src2)
                // Dst: (PHADDSWrr64:v4i16 VR64:v4i16:$src1, VR64:v4i16:$src2)
/*29425*/     0, /*End of Scope*/
/*29426*/   /*Scope*/ 64, /*->29491*/
/*29427*/     OPC_CheckInteger, 94|128,5/*734*/, 
/*29430*/     OPC_MoveParent,
/*29431*/     OPC_RecordChild1, // #0 = $src1
/*29432*/     OPC_Scope, 43, /*->29477*/ // 2 children in Scope
/*29434*/       OPC_MoveChild, 2,
/*29436*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*29438*/       OPC_MoveChild, 0,
/*29440*/       OPC_CheckOpcode, ISD::LOAD,
/*29442*/       OPC_RecordMemRef,
/*29443*/       OPC_RecordNode, // #1 = 'ld' chained node
/*29444*/       OPC_CheckFoldableChainNode,
/*29445*/       OPC_RecordChild1, // #2 = $src2
/*29446*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*29448*/       OPC_CheckPredicate, 8, // Predicate_load
/*29450*/       OPC_CheckPredicate, 66, // Predicate_memop64
/*29452*/       OPC_CheckType, MVT::v8i16,
/*29454*/       OPC_MoveParent,
/*29455*/       OPC_MoveParent,
/*29456*/       OPC_CheckPatternPredicate, 11, // (Subtarget->hasSSSE3())
/*29458*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*29461*/       OPC_EmitMergeInputChains, 1, 1, 
/*29464*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PHADDSWrm128), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v4i32, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (intrinsic_wo_chain:v4i32 734:iPTR, VR128:v4i32:$src1, (bitconvert:v4i32 (ld:v8i16 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop64>>))
                // Dst: (PHADDSWrm128:v4i32 VR128:v4i32:$src1, addr:iPTR:$src2)
/*29477*/     /*Scope*/ 12, /*->29490*/
/*29478*/       OPC_RecordChild2, // #1 = $src2
/*29479*/       OPC_CheckPatternPredicate, 11, // (Subtarget->hasSSSE3())
/*29481*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PHADDSWrr128), 0,
                    1/*#VTs*/, MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (intrinsic_wo_chain:v4i32 734:iPTR, VR128:v4i32:$src1, VR128:v4i32:$src2)
                // Dst: (PHADDSWrr128:v4i32 VR128:v4i32:$src1, VR128:v4i32:$src2)
/*29490*/     0, /*End of Scope*/
/*29491*/   /*Scope*/ 64, /*->29556*/
/*29492*/     OPC_CheckInteger, 101|128,5/*741*/, 
/*29495*/     OPC_MoveParent,
/*29496*/     OPC_RecordChild1, // #0 = $src1
/*29497*/     OPC_Scope, 43, /*->29542*/ // 2 children in Scope
/*29499*/       OPC_MoveChild, 2,
/*29501*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*29503*/       OPC_MoveChild, 0,
/*29505*/       OPC_CheckOpcode, ISD::LOAD,
/*29507*/       OPC_RecordMemRef,
/*29508*/       OPC_RecordNode, // #1 = 'ld' chained node
/*29509*/       OPC_CheckFoldableChainNode,
/*29510*/       OPC_RecordChild1, // #2 = $src2
/*29511*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*29513*/       OPC_CheckPredicate, 8, // Predicate_load
/*29515*/       OPC_CheckPredicate, 66, // Predicate_memop64
/*29517*/       OPC_CheckType, MVT::v4i16,
/*29519*/       OPC_MoveParent,
/*29520*/       OPC_MoveParent,
/*29521*/       OPC_CheckPatternPredicate, 11, // (Subtarget->hasSSSE3())
/*29523*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*29526*/       OPC_EmitMergeInputChains, 1, 1, 
/*29529*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PHSUBWrm64), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v4i16, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (intrinsic_wo_chain:v4i16 741:iPTR, VR64:v4i16:$src1, (bitconvert:v4i16 (ld:v4i16 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop64>>))
                // Dst: (PHSUBWrm64:v4i16 VR64:v4i16:$src1, addr:iPTR:$src2)
/*29542*/     /*Scope*/ 12, /*->29555*/
/*29543*/       OPC_RecordChild2, // #1 = $src2
/*29544*/       OPC_CheckPatternPredicate, 11, // (Subtarget->hasSSSE3())
/*29546*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PHSUBWrr64), 0,
                    1/*#VTs*/, MVT::v4i16, 2/*#Ops*/, 0, 1, 
                // Src: (intrinsic_wo_chain:v4i16 741:iPTR, VR64:v4i16:$src1, VR64:v4i16:$src2)
                // Dst: (PHSUBWrr64:v4i16 VR64:v4i16:$src1, VR64:v4i16:$src2)
/*29555*/     0, /*End of Scope*/
/*29556*/   /*Scope*/ 64, /*->29621*/
/*29557*/     OPC_CheckInteger, 102|128,5/*742*/, 
/*29560*/     OPC_MoveParent,
/*29561*/     OPC_RecordChild1, // #0 = $src1
/*29562*/     OPC_Scope, 43, /*->29607*/ // 2 children in Scope
/*29564*/       OPC_MoveChild, 2,
/*29566*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*29568*/       OPC_MoveChild, 0,
/*29570*/       OPC_CheckOpcode, ISD::LOAD,
/*29572*/       OPC_RecordMemRef,
/*29573*/       OPC_RecordNode, // #1 = 'ld' chained node
/*29574*/       OPC_CheckFoldableChainNode,
/*29575*/       OPC_RecordChild1, // #2 = $src2
/*29576*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*29578*/       OPC_CheckPredicate, 8, // Predicate_load
/*29580*/       OPC_CheckPredicate, 66, // Predicate_memop64
/*29582*/       OPC_CheckType, MVT::v8i16,
/*29584*/       OPC_MoveParent,
/*29585*/       OPC_MoveParent,
/*29586*/       OPC_CheckPatternPredicate, 11, // (Subtarget->hasSSSE3())
/*29588*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*29591*/       OPC_EmitMergeInputChains, 1, 1, 
/*29594*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PHSUBWrm128), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v8i16, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (intrinsic_wo_chain:v8i16 742:iPTR, VR128:v8i16:$src1, (bitconvert:v8i16 (ld:v8i16 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop64>>))
                // Dst: (PHSUBWrm128:v8i16 VR128:v8i16:$src1, addr:iPTR:$src2)
/*29607*/     /*Scope*/ 12, /*->29620*/
/*29608*/       OPC_RecordChild2, // #1 = $src2
/*29609*/       OPC_CheckPatternPredicate, 11, // (Subtarget->hasSSSE3())
/*29611*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PHSUBWrr128), 0,
                    1/*#VTs*/, MVT::v8i16, 2/*#Ops*/, 0, 1, 
                // Src: (intrinsic_wo_chain:v8i16 742:iPTR, VR128:v8i16:$src1, VR128:v8i16:$src2)
                // Dst: (PHSUBWrr128:v8i16 VR128:v8i16:$src1, VR128:v8i16:$src2)
/*29620*/     0, /*End of Scope*/
/*29621*/   /*Scope*/ 64, /*->29686*/
/*29622*/     OPC_CheckInteger, 97|128,5/*737*/, 
/*29625*/     OPC_MoveParent,
/*29626*/     OPC_RecordChild1, // #0 = $src1
/*29627*/     OPC_Scope, 43, /*->29672*/ // 2 children in Scope
/*29629*/       OPC_MoveChild, 2,
/*29631*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*29633*/       OPC_MoveChild, 0,
/*29635*/       OPC_CheckOpcode, ISD::LOAD,
/*29637*/       OPC_RecordMemRef,
/*29638*/       OPC_RecordNode, // #1 = 'ld' chained node
/*29639*/       OPC_CheckFoldableChainNode,
/*29640*/       OPC_RecordChild1, // #2 = $src2
/*29641*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*29643*/       OPC_CheckPredicate, 8, // Predicate_load
/*29645*/       OPC_CheckPredicate, 66, // Predicate_memop64
/*29647*/       OPC_CheckType, MVT::v2i32,
/*29649*/       OPC_MoveParent,
/*29650*/       OPC_MoveParent,
/*29651*/       OPC_CheckPatternPredicate, 11, // (Subtarget->hasSSSE3())
/*29653*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*29656*/       OPC_EmitMergeInputChains, 1, 1, 
/*29659*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PHSUBDrm64), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v2i32, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (intrinsic_wo_chain:v2i32 737:iPTR, VR64:v2i32:$src1, (bitconvert:v2i32 (ld:v2i32 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop64>>))
                // Dst: (PHSUBDrm64:v2i32 VR64:v2i32:$src1, addr:iPTR:$src2)
/*29672*/     /*Scope*/ 12, /*->29685*/
/*29673*/       OPC_RecordChild2, // #1 = $src2
/*29674*/       OPC_CheckPatternPredicate, 11, // (Subtarget->hasSSSE3())
/*29676*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PHSUBDrr64), 0,
                    1/*#VTs*/, MVT::v2i32, 2/*#Ops*/, 0, 1, 
                // Src: (intrinsic_wo_chain:v2i32 737:iPTR, VR64:v2i32:$src1, VR64:v2i32:$src2)
                // Dst: (PHSUBDrr64:v2i32 VR64:v2i32:$src1, VR64:v2i32:$src2)
/*29685*/     0, /*End of Scope*/
/*29686*/   /*Scope*/ 64, /*->29751*/
/*29687*/     OPC_CheckInteger, 98|128,5/*738*/, 
/*29690*/     OPC_MoveParent,
/*29691*/     OPC_RecordChild1, // #0 = $src1
/*29692*/     OPC_Scope, 43, /*->29737*/ // 2 children in Scope
/*29694*/       OPC_MoveChild, 2,
/*29696*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*29698*/       OPC_MoveChild, 0,
/*29700*/       OPC_CheckOpcode, ISD::LOAD,
/*29702*/       OPC_RecordMemRef,
/*29703*/       OPC_RecordNode, // #1 = 'ld' chained node
/*29704*/       OPC_CheckFoldableChainNode,
/*29705*/       OPC_RecordChild1, // #2 = $src2
/*29706*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*29708*/       OPC_CheckPredicate, 8, // Predicate_load
/*29710*/       OPC_CheckPredicate, 23, // Predicate_memop
/*29712*/       OPC_CheckType, MVT::v4i32,
/*29714*/       OPC_MoveParent,
/*29715*/       OPC_MoveParent,
/*29716*/       OPC_CheckPatternPredicate, 11, // (Subtarget->hasSSSE3())
/*29718*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*29721*/       OPC_EmitMergeInputChains, 1, 1, 
/*29724*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PHSUBDrm128), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v4i32, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (intrinsic_wo_chain:v4i32 738:iPTR, VR128:v4i32:$src1, (bitconvert:v4i32 (ld:v4i32 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>))
                // Dst: (PHSUBDrm128:v4i32 VR128:v4i32:$src1, addr:iPTR:$src2)
/*29737*/     /*Scope*/ 12, /*->29750*/
/*29738*/       OPC_RecordChild2, // #1 = $src2
/*29739*/       OPC_CheckPatternPredicate, 11, // (Subtarget->hasSSSE3())
/*29741*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PHSUBDrr128), 0,
                    1/*#VTs*/, MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (intrinsic_wo_chain:v4i32 738:iPTR, VR128:v4i32:$src1, VR128:v4i32:$src2)
                // Dst: (PHSUBDrr128:v4i32 VR128:v4i32:$src1, VR128:v4i32:$src2)
/*29750*/     0, /*End of Scope*/
/*29751*/   /*Scope*/ 64, /*->29816*/
/*29752*/     OPC_CheckInteger, 99|128,5/*739*/, 
/*29755*/     OPC_MoveParent,
/*29756*/     OPC_RecordChild1, // #0 = $src1
/*29757*/     OPC_Scope, 43, /*->29802*/ // 2 children in Scope
/*29759*/       OPC_MoveChild, 2,
/*29761*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*29763*/       OPC_MoveChild, 0,
/*29765*/       OPC_CheckOpcode, ISD::LOAD,
/*29767*/       OPC_RecordMemRef,
/*29768*/       OPC_RecordNode, // #1 = 'ld' chained node
/*29769*/       OPC_CheckFoldableChainNode,
/*29770*/       OPC_RecordChild1, // #2 = $src2
/*29771*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*29773*/       OPC_CheckPredicate, 8, // Predicate_load
/*29775*/       OPC_CheckPredicate, 66, // Predicate_memop64
/*29777*/       OPC_CheckType, MVT::v4i16,
/*29779*/       OPC_MoveParent,
/*29780*/       OPC_MoveParent,
/*29781*/       OPC_CheckPatternPredicate, 11, // (Subtarget->hasSSSE3())
/*29783*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*29786*/       OPC_EmitMergeInputChains, 1, 1, 
/*29789*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PHSUBSWrm64), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v4i16, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (intrinsic_wo_chain:v4i16 739:iPTR, VR64:v4i16:$src1, (bitconvert:v4i16 (ld:v4i16 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop64>>))
                // Dst: (PHSUBSWrm64:v4i16 VR64:v4i16:$src1, addr:iPTR:$src2)
/*29802*/     /*Scope*/ 12, /*->29815*/
/*29803*/       OPC_RecordChild2, // #1 = $src2
/*29804*/       OPC_CheckPatternPredicate, 11, // (Subtarget->hasSSSE3())
/*29806*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PHSUBSWrr64), 0,
                    1/*#VTs*/, MVT::v4i16, 2/*#Ops*/, 0, 1, 
                // Src: (intrinsic_wo_chain:v4i16 739:iPTR, VR64:v4i16:$src1, VR64:v4i16:$src2)
                // Dst: (PHSUBSWrr64:v4i16 VR64:v4i16:$src1, VR64:v4i16:$src2)
/*29815*/     0, /*End of Scope*/
/*29816*/   /*Scope*/ 64, /*->29881*/
/*29817*/     OPC_CheckInteger, 100|128,5/*740*/, 
/*29820*/     OPC_MoveParent,
/*29821*/     OPC_RecordChild1, // #0 = $src1
/*29822*/     OPC_Scope, 43, /*->29867*/ // 2 children in Scope
/*29824*/       OPC_MoveChild, 2,
/*29826*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*29828*/       OPC_MoveChild, 0,
/*29830*/       OPC_CheckOpcode, ISD::LOAD,
/*29832*/       OPC_RecordMemRef,
/*29833*/       OPC_RecordNode, // #1 = 'ld' chained node
/*29834*/       OPC_CheckFoldableChainNode,
/*29835*/       OPC_RecordChild1, // #2 = $src2
/*29836*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*29838*/       OPC_CheckPredicate, 8, // Predicate_load
/*29840*/       OPC_CheckPredicate, 66, // Predicate_memop64
/*29842*/       OPC_CheckType, MVT::v8i16,
/*29844*/       OPC_MoveParent,
/*29845*/       OPC_MoveParent,
/*29846*/       OPC_CheckPatternPredicate, 11, // (Subtarget->hasSSSE3())
/*29848*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*29851*/       OPC_EmitMergeInputChains, 1, 1, 
/*29854*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PHSUBSWrm128), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v8i16, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (intrinsic_wo_chain:v8i16 740:iPTR, VR128:v8i16:$src1, (bitconvert:v8i16 (ld:v8i16 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop64>>))
                // Dst: (PHSUBSWrm128:v8i16 VR128:v8i16:$src1, addr:iPTR:$src2)
/*29867*/     /*Scope*/ 12, /*->29880*/
/*29868*/       OPC_RecordChild2, // #1 = $src2
/*29869*/       OPC_CheckPatternPredicate, 11, // (Subtarget->hasSSSE3())
/*29871*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PHSUBSWrr128), 0,
                    1/*#VTs*/, MVT::v8i16, 2/*#Ops*/, 0, 1, 
                // Src: (intrinsic_wo_chain:v8i16 740:iPTR, VR128:v8i16:$src1, VR128:v8i16:$src2)
                // Dst: (PHSUBSWrr128:v8i16 VR128:v8i16:$src1, VR128:v8i16:$src2)
/*29880*/     0, /*End of Scope*/
/*29881*/   /*Scope*/ 64, /*->29946*/
/*29882*/     OPC_CheckInteger, 103|128,5/*743*/, 
/*29885*/     OPC_MoveParent,
/*29886*/     OPC_RecordChild1, // #0 = $src1
/*29887*/     OPC_Scope, 43, /*->29932*/ // 2 children in Scope
/*29889*/       OPC_MoveChild, 2,
/*29891*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*29893*/       OPC_MoveChild, 0,
/*29895*/       OPC_CheckOpcode, ISD::LOAD,
/*29897*/       OPC_RecordMemRef,
/*29898*/       OPC_RecordNode, // #1 = 'ld' chained node
/*29899*/       OPC_CheckFoldableChainNode,
/*29900*/       OPC_RecordChild1, // #2 = $src2
/*29901*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*29903*/       OPC_CheckPredicate, 8, // Predicate_load
/*29905*/       OPC_CheckPredicate, 66, // Predicate_memop64
/*29907*/       OPC_CheckType, MVT::v8i8,
/*29909*/       OPC_MoveParent,
/*29910*/       OPC_MoveParent,
/*29911*/       OPC_CheckPatternPredicate, 11, // (Subtarget->hasSSSE3())
/*29913*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*29916*/       OPC_EmitMergeInputChains, 1, 1, 
/*29919*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PMADDUBSWrm64), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v4i16, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (intrinsic_wo_chain:v4i16 743:iPTR, VR64:v4i16:$src1, (bitconvert:v4i16 (ld:v8i8 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop64>>))
                // Dst: (PMADDUBSWrm64:v4i16 VR64:v4i16:$src1, addr:iPTR:$src2)
/*29932*/     /*Scope*/ 12, /*->29945*/
/*29933*/       OPC_RecordChild2, // #1 = $src2
/*29934*/       OPC_CheckPatternPredicate, 11, // (Subtarget->hasSSSE3())
/*29936*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PMADDUBSWrr64), 0,
                    1/*#VTs*/, MVT::v4i16, 2/*#Ops*/, 0, 1, 
                // Src: (intrinsic_wo_chain:v4i16 743:iPTR, VR64:v4i16:$src1, VR64:v4i16:$src2)
                // Dst: (PMADDUBSWrr64:v4i16 VR64:v4i16:$src1, VR64:v4i16:$src2)
/*29945*/     0, /*End of Scope*/
/*29946*/   /*Scope*/ 64, /*->30011*/
/*29947*/     OPC_CheckInteger, 104|128,5/*744*/, 
/*29950*/     OPC_MoveParent,
/*29951*/     OPC_RecordChild1, // #0 = $src1
/*29952*/     OPC_Scope, 43, /*->29997*/ // 2 children in Scope
/*29954*/       OPC_MoveChild, 2,
/*29956*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*29958*/       OPC_MoveChild, 0,
/*29960*/       OPC_CheckOpcode, ISD::LOAD,
/*29962*/       OPC_RecordMemRef,
/*29963*/       OPC_RecordNode, // #1 = 'ld' chained node
/*29964*/       OPC_CheckFoldableChainNode,
/*29965*/       OPC_RecordChild1, // #2 = $src2
/*29966*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*29968*/       OPC_CheckPredicate, 8, // Predicate_load
/*29970*/       OPC_CheckPredicate, 23, // Predicate_memop
/*29972*/       OPC_CheckType, MVT::v16i8,
/*29974*/       OPC_MoveParent,
/*29975*/       OPC_MoveParent,
/*29976*/       OPC_CheckPatternPredicate, 11, // (Subtarget->hasSSSE3())
/*29978*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*29981*/       OPC_EmitMergeInputChains, 1, 1, 
/*29984*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PMADDUBSWrm128), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v8i16, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (intrinsic_wo_chain:v8i16 744:iPTR, VR128:v8i16:$src1, (bitconvert:v8i16 (ld:v16i8 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>))
                // Dst: (PMADDUBSWrm128:v8i16 VR128:v8i16:$src1, addr:iPTR:$src2)
/*29997*/     /*Scope*/ 12, /*->30010*/
/*29998*/       OPC_RecordChild2, // #1 = $src2
/*29999*/       OPC_CheckPatternPredicate, 11, // (Subtarget->hasSSSE3())
/*30001*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PMADDUBSWrr128), 0,
                    1/*#VTs*/, MVT::v8i16, 2/*#Ops*/, 0, 1, 
                // Src: (intrinsic_wo_chain:v8i16 744:iPTR, VR128:v8i16:$src1, VR128:v8i16:$src2)
                // Dst: (PMADDUBSWrr128:v8i16 VR128:v8i16:$src1, VR128:v8i16:$src2)
/*30010*/     0, /*End of Scope*/
/*30011*/   /*Scope*/ 110, /*->30122*/
/*30012*/     OPC_CheckInteger, 105|128,5/*745*/, 
/*30015*/     OPC_MoveParent,
/*30016*/     OPC_Scope, 44, /*->30062*/ // 3 children in Scope
/*30018*/       OPC_RecordChild1, // #0 = $src1
/*30019*/       OPC_MoveChild, 2,
/*30021*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*30023*/       OPC_MoveChild, 0,
/*30025*/       OPC_CheckOpcode, ISD::LOAD,
/*30027*/       OPC_RecordMemRef,
/*30028*/       OPC_RecordNode, // #1 = 'ld' chained node
/*30029*/       OPC_CheckFoldableChainNode,
/*30030*/       OPC_RecordChild1, // #2 = $src2
/*30031*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*30033*/       OPC_CheckPredicate, 8, // Predicate_load
/*30035*/       OPC_CheckPredicate, 66, // Predicate_memop64
/*30037*/       OPC_CheckType, MVT::v4i16,
/*30039*/       OPC_MoveParent,
/*30040*/       OPC_MoveParent,
/*30041*/       OPC_CheckPatternPredicate, 11, // (Subtarget->hasSSSE3())
/*30043*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*30046*/       OPC_EmitMergeInputChains, 1, 1, 
/*30049*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PMULHRSWrm64), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v4i16, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (intrinsic_wo_chain:v4i16 745:iPTR, VR64:v4i16:$src1, (bitconvert:v4i16 (ld:v4i16 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop64>>))
                // Dst: (PMULHRSWrm64:v4i16 VR64:v4i16:$src1, addr:iPTR:$src2)
/*30062*/     /*Scope*/ 44, /*->30107*/
/*30063*/       OPC_MoveChild, 1,
/*30065*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*30067*/       OPC_MoveChild, 0,
/*30069*/       OPC_CheckOpcode, ISD::LOAD,
/*30071*/       OPC_RecordMemRef,
/*30072*/       OPC_RecordNode, // #0 = 'ld' chained node
/*30073*/       OPC_CheckFoldableChainNode,
/*30074*/       OPC_RecordChild1, // #1 = $src2
/*30075*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*30077*/       OPC_CheckPredicate, 8, // Predicate_load
/*30079*/       OPC_CheckPredicate, 66, // Predicate_memop64
/*30081*/       OPC_CheckType, MVT::v4i16,
/*30083*/       OPC_MoveParent,
/*30084*/       OPC_MoveParent,
/*30085*/       OPC_RecordChild2, // #2 = $src1
/*30086*/       OPC_CheckPatternPredicate, 11, // (Subtarget->hasSSSE3())
/*30088*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*30091*/       OPC_EmitMergeInputChains, 1, 0, 
/*30094*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PMULHRSWrm64), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v4i16, 6/*#Ops*/, 2, 3, 4, 5, 6, 7, 
                // Src: (intrinsic_wo_chain:v4i16 745:iPTR, (bitconvert:v4i16 (ld:v4i16 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop64>>), VR64:v4i16:$src1)
                // Dst: (PMULHRSWrm64:v4i16 VR64:v4i16:$src1, addr:iPTR:$src2)
/*30107*/     /*Scope*/ 13, /*->30121*/
/*30108*/       OPC_RecordChild1, // #0 = $src1
/*30109*/       OPC_RecordChild2, // #1 = $src2
/*30110*/       OPC_CheckPatternPredicate, 11, // (Subtarget->hasSSSE3())
/*30112*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PMULHRSWrr64), 0,
                    1/*#VTs*/, MVT::v4i16, 2/*#Ops*/, 0, 1, 
                // Src: (intrinsic_wo_chain:v4i16 745:iPTR, VR64:v4i16:$src1, VR64:v4i16:$src2)
                // Dst: (PMULHRSWrr64:v4i16 VR64:v4i16:$src1, VR64:v4i16:$src2)
/*30121*/     0, /*End of Scope*/
/*30122*/   /*Scope*/ 110, /*->30233*/
/*30123*/     OPC_CheckInteger, 106|128,5/*746*/, 
/*30126*/     OPC_MoveParent,
/*30127*/     OPC_Scope, 44, /*->30173*/ // 3 children in Scope
/*30129*/       OPC_RecordChild1, // #0 = $src1
/*30130*/       OPC_MoveChild, 2,
/*30132*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*30134*/       OPC_MoveChild, 0,
/*30136*/       OPC_CheckOpcode, ISD::LOAD,
/*30138*/       OPC_RecordMemRef,
/*30139*/       OPC_RecordNode, // #1 = 'ld' chained node
/*30140*/       OPC_CheckFoldableChainNode,
/*30141*/       OPC_RecordChild1, // #2 = $src2
/*30142*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*30144*/       OPC_CheckPredicate, 8, // Predicate_load
/*30146*/       OPC_CheckPredicate, 66, // Predicate_memop64
/*30148*/       OPC_CheckType, MVT::v8i16,
/*30150*/       OPC_MoveParent,
/*30151*/       OPC_MoveParent,
/*30152*/       OPC_CheckPatternPredicate, 11, // (Subtarget->hasSSSE3())
/*30154*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*30157*/       OPC_EmitMergeInputChains, 1, 1, 
/*30160*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PMULHRSWrm128), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v8i16, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (intrinsic_wo_chain:v8i16 746:iPTR, VR128:v8i16:$src1, (bitconvert:v8i16 (ld:v8i16 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop64>>))
                // Dst: (PMULHRSWrm128:v8i16 VR128:v8i16:$src1, addr:iPTR:$src2)
/*30173*/     /*Scope*/ 44, /*->30218*/
/*30174*/       OPC_MoveChild, 1,
/*30176*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*30178*/       OPC_MoveChild, 0,
/*30180*/       OPC_CheckOpcode, ISD::LOAD,
/*30182*/       OPC_RecordMemRef,
/*30183*/       OPC_RecordNode, // #0 = 'ld' chained node
/*30184*/       OPC_CheckFoldableChainNode,
/*30185*/       OPC_RecordChild1, // #1 = $src2
/*30186*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*30188*/       OPC_CheckPredicate, 8, // Predicate_load
/*30190*/       OPC_CheckPredicate, 66, // Predicate_memop64
/*30192*/       OPC_CheckType, MVT::v8i16,
/*30194*/       OPC_MoveParent,
/*30195*/       OPC_MoveParent,
/*30196*/       OPC_RecordChild2, // #2 = $src1
/*30197*/       OPC_CheckPatternPredicate, 11, // (Subtarget->hasSSSE3())
/*30199*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*30202*/       OPC_EmitMergeInputChains, 1, 0, 
/*30205*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PMULHRSWrm128), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v8i16, 6/*#Ops*/, 2, 3, 4, 5, 6, 7, 
                // Src: (intrinsic_wo_chain:v8i16 746:iPTR, (bitconvert:v8i16 (ld:v8i16 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop64>>), VR128:v8i16:$src1)
                // Dst: (PMULHRSWrm128:v8i16 VR128:v8i16:$src1, addr:iPTR:$src2)
/*30218*/     /*Scope*/ 13, /*->30232*/
/*30219*/       OPC_RecordChild1, // #0 = $src1
/*30220*/       OPC_RecordChild2, // #1 = $src2
/*30221*/       OPC_CheckPatternPredicate, 11, // (Subtarget->hasSSSE3())
/*30223*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PMULHRSWrr128), 0,
                    1/*#VTs*/, MVT::v8i16, 2/*#Ops*/, 0, 1, 
                // Src: (intrinsic_wo_chain:v8i16 746:iPTR, VR128:v8i16:$src1, VR128:v8i16:$src2)
                // Dst: (PMULHRSWrr128:v8i16 VR128:v8i16:$src1, VR128:v8i16:$src2)
/*30232*/     0, /*End of Scope*/
/*30233*/   /*Scope*/ 64, /*->30298*/
/*30234*/     OPC_CheckInteger, 107|128,5/*747*/, 
/*30237*/     OPC_MoveParent,
/*30238*/     OPC_RecordChild1, // #0 = $src1
/*30239*/     OPC_Scope, 43, /*->30284*/ // 2 children in Scope
/*30241*/       OPC_MoveChild, 2,
/*30243*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*30245*/       OPC_MoveChild, 0,
/*30247*/       OPC_CheckOpcode, ISD::LOAD,
/*30249*/       OPC_RecordMemRef,
/*30250*/       OPC_RecordNode, // #1 = 'ld' chained node
/*30251*/       OPC_CheckFoldableChainNode,
/*30252*/       OPC_RecordChild1, // #2 = $src2
/*30253*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*30255*/       OPC_CheckPredicate, 8, // Predicate_load
/*30257*/       OPC_CheckPredicate, 66, // Predicate_memop64
/*30259*/       OPC_CheckType, MVT::v8i8,
/*30261*/       OPC_MoveParent,
/*30262*/       OPC_MoveParent,
/*30263*/       OPC_CheckPatternPredicate, 11, // (Subtarget->hasSSSE3())
/*30265*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*30268*/       OPC_EmitMergeInputChains, 1, 1, 
/*30271*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PSHUFBrm64), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v8i8, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (intrinsic_wo_chain:v8i8 747:iPTR, VR64:v8i8:$src1, (bitconvert:v8i8 (ld:v8i8 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop64>>))
                // Dst: (PSHUFBrm64:v8i8 VR64:v8i8:$src1, addr:iPTR:$src2)
/*30284*/     /*Scope*/ 12, /*->30297*/
/*30285*/       OPC_RecordChild2, // #1 = $src2
/*30286*/       OPC_CheckPatternPredicate, 11, // (Subtarget->hasSSSE3())
/*30288*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PSHUFBrr64), 0,
                    1/*#VTs*/, MVT::v8i8, 2/*#Ops*/, 0, 1, 
                // Src: (intrinsic_wo_chain:v8i8 747:iPTR, VR64:v8i8:$src1, VR64:v8i8:$src2)
                // Dst: (PSHUFBrr64:v8i8 VR64:v8i8:$src1, VR64:v8i8:$src2)
/*30297*/     0, /*End of Scope*/
/*30298*/   /*Scope*/ 64, /*->30363*/
/*30299*/     OPC_CheckInteger, 108|128,5/*748*/, 
/*30302*/     OPC_MoveParent,
/*30303*/     OPC_RecordChild1, // #0 = $src1
/*30304*/     OPC_Scope, 43, /*->30349*/ // 2 children in Scope
/*30306*/       OPC_MoveChild, 2,
/*30308*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*30310*/       OPC_MoveChild, 0,
/*30312*/       OPC_CheckOpcode, ISD::LOAD,
/*30314*/       OPC_RecordMemRef,
/*30315*/       OPC_RecordNode, // #1 = 'ld' chained node
/*30316*/       OPC_CheckFoldableChainNode,
/*30317*/       OPC_RecordChild1, // #2 = $src2
/*30318*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*30320*/       OPC_CheckPredicate, 8, // Predicate_load
/*30322*/       OPC_CheckPredicate, 23, // Predicate_memop
/*30324*/       OPC_CheckType, MVT::v16i8,
/*30326*/       OPC_MoveParent,
/*30327*/       OPC_MoveParent,
/*30328*/       OPC_CheckPatternPredicate, 11, // (Subtarget->hasSSSE3())
/*30330*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*30333*/       OPC_EmitMergeInputChains, 1, 1, 
/*30336*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PSHUFBrm128), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v16i8, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (intrinsic_wo_chain:v16i8 748:iPTR, VR128:v16i8:$src1, (bitconvert:v16i8 (ld:v16i8 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>))
                // Dst: (PSHUFBrm128:v16i8 VR128:v16i8:$src1, addr:iPTR:$src2)
/*30349*/     /*Scope*/ 12, /*->30362*/
/*30350*/       OPC_RecordChild2, // #1 = $src2
/*30351*/       OPC_CheckPatternPredicate, 11, // (Subtarget->hasSSSE3())
/*30353*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PSHUFBrr128), 0,
                    1/*#VTs*/, MVT::v16i8, 2/*#Ops*/, 0, 1, 
                // Src: (intrinsic_wo_chain:v16i8 748:iPTR, VR128:v16i8:$src1, VR128:v16i8:$src2)
                // Dst: (PSHUFBrr128:v16i8 VR128:v16i8:$src1, VR128:v16i8:$src2)
/*30362*/     0, /*End of Scope*/
/*30363*/   /*Scope*/ 64, /*->30428*/
/*30364*/     OPC_CheckInteger, 109|128,5/*749*/, 
/*30367*/     OPC_MoveParent,
/*30368*/     OPC_RecordChild1, // #0 = $src1
/*30369*/     OPC_Scope, 43, /*->30414*/ // 2 children in Scope
/*30371*/       OPC_MoveChild, 2,
/*30373*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*30375*/       OPC_MoveChild, 0,
/*30377*/       OPC_CheckOpcode, ISD::LOAD,
/*30379*/       OPC_RecordMemRef,
/*30380*/       OPC_RecordNode, // #1 = 'ld' chained node
/*30381*/       OPC_CheckFoldableChainNode,
/*30382*/       OPC_RecordChild1, // #2 = $src2
/*30383*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*30385*/       OPC_CheckPredicate, 8, // Predicate_load
/*30387*/       OPC_CheckPredicate, 66, // Predicate_memop64
/*30389*/       OPC_CheckType, MVT::v8i8,
/*30391*/       OPC_MoveParent,
/*30392*/       OPC_MoveParent,
/*30393*/       OPC_CheckPatternPredicate, 11, // (Subtarget->hasSSSE3())
/*30395*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*30398*/       OPC_EmitMergeInputChains, 1, 1, 
/*30401*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PSIGNBrm64), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v8i8, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (intrinsic_wo_chain:v8i8 749:iPTR, VR64:v8i8:$src1, (bitconvert:v8i8 (ld:v8i8 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop64>>))
                // Dst: (PSIGNBrm64:v8i8 VR64:v8i8:$src1, addr:iPTR:$src2)
/*30414*/     /*Scope*/ 12, /*->30427*/
/*30415*/       OPC_RecordChild2, // #1 = $src2
/*30416*/       OPC_CheckPatternPredicate, 11, // (Subtarget->hasSSSE3())
/*30418*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PSIGNBrr64), 0,
                    1/*#VTs*/, MVT::v8i8, 2/*#Ops*/, 0, 1, 
                // Src: (intrinsic_wo_chain:v8i8 749:iPTR, VR64:v8i8:$src1, VR64:v8i8:$src2)
                // Dst: (PSIGNBrr64:v8i8 VR64:v8i8:$src1, VR64:v8i8:$src2)
/*30427*/     0, /*End of Scope*/
/*30428*/   /*Scope*/ 64, /*->30493*/
/*30429*/     OPC_CheckInteger, 110|128,5/*750*/, 
/*30432*/     OPC_MoveParent,
/*30433*/     OPC_RecordChild1, // #0 = $src1
/*30434*/     OPC_Scope, 43, /*->30479*/ // 2 children in Scope
/*30436*/       OPC_MoveChild, 2,
/*30438*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*30440*/       OPC_MoveChild, 0,
/*30442*/       OPC_CheckOpcode, ISD::LOAD,
/*30444*/       OPC_RecordMemRef,
/*30445*/       OPC_RecordNode, // #1 = 'ld' chained node
/*30446*/       OPC_CheckFoldableChainNode,
/*30447*/       OPC_RecordChild1, // #2 = $src2
/*30448*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*30450*/       OPC_CheckPredicate, 8, // Predicate_load
/*30452*/       OPC_CheckPredicate, 23, // Predicate_memop
/*30454*/       OPC_CheckType, MVT::v16i8,
/*30456*/       OPC_MoveParent,
/*30457*/       OPC_MoveParent,
/*30458*/       OPC_CheckPatternPredicate, 11, // (Subtarget->hasSSSE3())
/*30460*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*30463*/       OPC_EmitMergeInputChains, 1, 1, 
/*30466*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PSIGNBrm128), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v16i8, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (intrinsic_wo_chain:v16i8 750:iPTR, VR128:v16i8:$src1, (bitconvert:v16i8 (ld:v16i8 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>))
                // Dst: (PSIGNBrm128:v16i8 VR128:v16i8:$src1, addr:iPTR:$src2)
/*30479*/     /*Scope*/ 12, /*->30492*/
/*30480*/       OPC_RecordChild2, // #1 = $src2
/*30481*/       OPC_CheckPatternPredicate, 11, // (Subtarget->hasSSSE3())
/*30483*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PSIGNBrr128), 0,
                    1/*#VTs*/, MVT::v16i8, 2/*#Ops*/, 0, 1, 
                // Src: (intrinsic_wo_chain:v16i8 750:iPTR, VR128:v16i8:$src1, VR128:v16i8:$src2)
                // Dst: (PSIGNBrr128:v16i8 VR128:v16i8:$src1, VR128:v16i8:$src2)
/*30492*/     0, /*End of Scope*/
/*30493*/   /*Scope*/ 64, /*->30558*/
/*30494*/     OPC_CheckInteger, 113|128,5/*753*/, 
/*30497*/     OPC_MoveParent,
/*30498*/     OPC_RecordChild1, // #0 = $src1
/*30499*/     OPC_Scope, 43, /*->30544*/ // 2 children in Scope
/*30501*/       OPC_MoveChild, 2,
/*30503*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*30505*/       OPC_MoveChild, 0,
/*30507*/       OPC_CheckOpcode, ISD::LOAD,
/*30509*/       OPC_RecordMemRef,
/*30510*/       OPC_RecordNode, // #1 = 'ld' chained node
/*30511*/       OPC_CheckFoldableChainNode,
/*30512*/       OPC_RecordChild1, // #2 = $src2
/*30513*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*30515*/       OPC_CheckPredicate, 8, // Predicate_load
/*30517*/       OPC_CheckPredicate, 66, // Predicate_memop64
/*30519*/       OPC_CheckType, MVT::v4i16,
/*30521*/       OPC_MoveParent,
/*30522*/       OPC_MoveParent,
/*30523*/       OPC_CheckPatternPredicate, 11, // (Subtarget->hasSSSE3())
/*30525*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*30528*/       OPC_EmitMergeInputChains, 1, 1, 
/*30531*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PSIGNWrm64), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v4i16, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (intrinsic_wo_chain:v4i16 753:iPTR, VR64:v4i16:$src1, (bitconvert:v4i16 (ld:v4i16 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop64>>))
                // Dst: (PSIGNWrm64:v4i16 VR64:v4i16:$src1, addr:iPTR:$src2)
/*30544*/     /*Scope*/ 12, /*->30557*/
/*30545*/       OPC_RecordChild2, // #1 = $src2
/*30546*/       OPC_CheckPatternPredicate, 11, // (Subtarget->hasSSSE3())
/*30548*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PSIGNWrr64), 0,
                    1/*#VTs*/, MVT::v4i16, 2/*#Ops*/, 0, 1, 
                // Src: (intrinsic_wo_chain:v4i16 753:iPTR, VR64:v4i16:$src1, VR64:v4i16:$src2)
                // Dst: (PSIGNWrr64:v4i16 VR64:v4i16:$src1, VR64:v4i16:$src2)
/*30557*/     0, /*End of Scope*/
/*30558*/   /*Scope*/ 64, /*->30623*/
/*30559*/     OPC_CheckInteger, 114|128,5/*754*/, 
/*30562*/     OPC_MoveParent,
/*30563*/     OPC_RecordChild1, // #0 = $src1
/*30564*/     OPC_Scope, 43, /*->30609*/ // 2 children in Scope
/*30566*/       OPC_MoveChild, 2,
/*30568*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*30570*/       OPC_MoveChild, 0,
/*30572*/       OPC_CheckOpcode, ISD::LOAD,
/*30574*/       OPC_RecordMemRef,
/*30575*/       OPC_RecordNode, // #1 = 'ld' chained node
/*30576*/       OPC_CheckFoldableChainNode,
/*30577*/       OPC_RecordChild1, // #2 = $src2
/*30578*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*30580*/       OPC_CheckPredicate, 8, // Predicate_load
/*30582*/       OPC_CheckPredicate, 66, // Predicate_memop64
/*30584*/       OPC_CheckType, MVT::v8i16,
/*30586*/       OPC_MoveParent,
/*30587*/       OPC_MoveParent,
/*30588*/       OPC_CheckPatternPredicate, 11, // (Subtarget->hasSSSE3())
/*30590*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*30593*/       OPC_EmitMergeInputChains, 1, 1, 
/*30596*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PSIGNWrm128), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v8i16, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (intrinsic_wo_chain:v8i16 754:iPTR, VR128:v8i16:$src1, (bitconvert:v8i16 (ld:v8i16 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop64>>))
                // Dst: (PSIGNWrm128:v8i16 VR128:v8i16:$src1, addr:iPTR:$src2)
/*30609*/     /*Scope*/ 12, /*->30622*/
/*30610*/       OPC_RecordChild2, // #1 = $src2
/*30611*/       OPC_CheckPatternPredicate, 11, // (Subtarget->hasSSSE3())
/*30613*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PSIGNWrr128), 0,
                    1/*#VTs*/, MVT::v8i16, 2/*#Ops*/, 0, 1, 
                // Src: (intrinsic_wo_chain:v8i16 754:iPTR, VR128:v8i16:$src1, VR128:v8i16:$src2)
                // Dst: (PSIGNWrr128:v8i16 VR128:v8i16:$src1, VR128:v8i16:$src2)
/*30622*/     0, /*End of Scope*/
/*30623*/   /*Scope*/ 64, /*->30688*/
/*30624*/     OPC_CheckInteger, 111|128,5/*751*/, 
/*30627*/     OPC_MoveParent,
/*30628*/     OPC_RecordChild1, // #0 = $src1
/*30629*/     OPC_Scope, 43, /*->30674*/ // 2 children in Scope
/*30631*/       OPC_MoveChild, 2,
/*30633*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*30635*/       OPC_MoveChild, 0,
/*30637*/       OPC_CheckOpcode, ISD::LOAD,
/*30639*/       OPC_RecordMemRef,
/*30640*/       OPC_RecordNode, // #1 = 'ld' chained node
/*30641*/       OPC_CheckFoldableChainNode,
/*30642*/       OPC_RecordChild1, // #2 = $src2
/*30643*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*30645*/       OPC_CheckPredicate, 8, // Predicate_load
/*30647*/       OPC_CheckPredicate, 66, // Predicate_memop64
/*30649*/       OPC_CheckType, MVT::v2i32,
/*30651*/       OPC_MoveParent,
/*30652*/       OPC_MoveParent,
/*30653*/       OPC_CheckPatternPredicate, 11, // (Subtarget->hasSSSE3())
/*30655*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*30658*/       OPC_EmitMergeInputChains, 1, 1, 
/*30661*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PSIGNDrm64), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v2i32, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (intrinsic_wo_chain:v2i32 751:iPTR, VR64:v2i32:$src1, (bitconvert:v2i32 (ld:v2i32 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop64>>))
                // Dst: (PSIGNDrm64:v2i32 VR64:v2i32:$src1, addr:iPTR:$src2)
/*30674*/     /*Scope*/ 12, /*->30687*/
/*30675*/       OPC_RecordChild2, // #1 = $src2
/*30676*/       OPC_CheckPatternPredicate, 11, // (Subtarget->hasSSSE3())
/*30678*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PSIGNDrr64), 0,
                    1/*#VTs*/, MVT::v2i32, 2/*#Ops*/, 0, 1, 
                // Src: (intrinsic_wo_chain:v2i32 751:iPTR, VR64:v2i32:$src1, VR64:v2i32:$src2)
                // Dst: (PSIGNDrr64:v2i32 VR64:v2i32:$src1, VR64:v2i32:$src2)
/*30687*/     0, /*End of Scope*/
/*30688*/   /*Scope*/ 64, /*->30753*/
/*30689*/     OPC_CheckInteger, 112|128,5/*752*/, 
/*30692*/     OPC_MoveParent,
/*30693*/     OPC_RecordChild1, // #0 = $src1
/*30694*/     OPC_Scope, 43, /*->30739*/ // 2 children in Scope
/*30696*/       OPC_MoveChild, 2,
/*30698*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*30700*/       OPC_MoveChild, 0,
/*30702*/       OPC_CheckOpcode, ISD::LOAD,
/*30704*/       OPC_RecordMemRef,
/*30705*/       OPC_RecordNode, // #1 = 'ld' chained node
/*30706*/       OPC_CheckFoldableChainNode,
/*30707*/       OPC_RecordChild1, // #2 = $src2
/*30708*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*30710*/       OPC_CheckPredicate, 8, // Predicate_load
/*30712*/       OPC_CheckPredicate, 23, // Predicate_memop
/*30714*/       OPC_CheckType, MVT::v4i32,
/*30716*/       OPC_MoveParent,
/*30717*/       OPC_MoveParent,
/*30718*/       OPC_CheckPatternPredicate, 11, // (Subtarget->hasSSSE3())
/*30720*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*30723*/       OPC_EmitMergeInputChains, 1, 1, 
/*30726*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PSIGNDrm128), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v4i32, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (intrinsic_wo_chain:v4i32 752:iPTR, VR128:v4i32:$src1, (bitconvert:v4i32 (ld:v4i32 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>))
                // Dst: (PSIGNDrm128:v4i32 VR128:v4i32:$src1, addr:iPTR:$src2)
/*30739*/     /*Scope*/ 12, /*->30752*/
/*30740*/       OPC_RecordChild2, // #1 = $src2
/*30741*/       OPC_CheckPatternPredicate, 11, // (Subtarget->hasSSSE3())
/*30743*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PSIGNDrr128), 0,
                    1/*#VTs*/, MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (intrinsic_wo_chain:v4i32 752:iPTR, VR128:v4i32:$src1, VR128:v4i32:$src2)
                // Dst: (PSIGNDrr128:v4i32 VR128:v4i32:$src1, VR128:v4i32:$src2)
/*30752*/     0, /*End of Scope*/
/*30753*/   /*Scope*/ 81, /*->30835*/
/*30754*/     OPC_CheckInteger, 89|128,5/*729*/, 
/*30757*/     OPC_MoveParent,
/*30758*/     OPC_RecordChild1, // #0 = $src1
/*30759*/     OPC_Scope, 48, /*->30809*/ // 2 children in Scope
/*30761*/       OPC_MoveChild, 2,
/*30763*/       OPC_CheckOpcode, ISD::LOAD,
/*30765*/       OPC_RecordMemRef,
/*30766*/       OPC_RecordNode, // #1 = 'ld' chained node
/*30767*/       OPC_CheckFoldableChainNode,
/*30768*/       OPC_RecordChild1, // #2 = $src2
/*30769*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*30771*/       OPC_CheckPredicate, 8, // Predicate_load
/*30773*/       OPC_CheckPredicate, 66, // Predicate_memop64
/*30775*/       OPC_MoveParent,
/*30776*/       OPC_RecordChild3, // #3 = $src3
/*30777*/       OPC_MoveChild, 3,
/*30779*/       OPC_CheckOpcode, ISD::Constant,
/*30781*/       OPC_MoveParent,
/*30782*/       OPC_CheckPatternPredicate, 11, // (Subtarget->hasSSSE3())
/*30784*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #4 #5 #6 #7 #8
/*30787*/       OPC_EmitMergeInputChains, 1, 1, 
/*30790*/       OPC_EmitConvertToTarget, 3,
/*30792*/       OPC_EmitNodeXForm, 5, 9, // BYTE_imm
/*30795*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PALIGNR64rm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v1i64, 7/*#Ops*/, 0, 4, 5, 6, 7, 8, 10, 
                // Src: (intrinsic_wo_chain:v1i64 729:iPTR, VR64:v1i64:$src1, (ld:v1i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop64>>, (imm:i8):$src3)
                // Dst: (PALIGNR64rm:v1i64 VR64:v8i8:$src1, addr:iPTR:$src2, (BYTE_imm:i8 (imm:i8):$src3))
/*30809*/     /*Scope*/ 24, /*->30834*/
/*30810*/       OPC_RecordChild2, // #1 = $src2
/*30811*/       OPC_RecordChild3, // #2 = $src3
/*30812*/       OPC_MoveChild, 3,
/*30814*/       OPC_CheckOpcode, ISD::Constant,
/*30816*/       OPC_MoveParent,
/*30817*/       OPC_CheckPatternPredicate, 11, // (Subtarget->hasSSSE3())
/*30819*/       OPC_EmitConvertToTarget, 2,
/*30821*/       OPC_EmitNodeXForm, 5, 3, // BYTE_imm
/*30824*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PALIGNR64rr), 0,
                    1/*#VTs*/, MVT::v1i64, 3/*#Ops*/, 0, 1, 4, 
                // Src: (intrinsic_wo_chain:v1i64 729:iPTR, VR64:v1i64:$src1, VR64:v1i64:$src2, (imm:i8):$src3)
                // Dst: (PALIGNR64rr:v1i64 VR64:v8i8:$src1, VR64:v8i8:$src2, (BYTE_imm:i8 (imm:i8):$src3))
/*30834*/     0, /*End of Scope*/
/*30835*/   /*Scope*/ 81, /*->30917*/
/*30836*/     OPC_CheckInteger, 90|128,5/*730*/, 
/*30839*/     OPC_MoveParent,
/*30840*/     OPC_RecordChild1, // #0 = $src1
/*30841*/     OPC_Scope, 48, /*->30891*/ // 2 children in Scope
/*30843*/       OPC_MoveChild, 2,
/*30845*/       OPC_CheckOpcode, ISD::LOAD,
/*30847*/       OPC_RecordMemRef,
/*30848*/       OPC_RecordNode, // #1 = 'ld' chained node
/*30849*/       OPC_CheckFoldableChainNode,
/*30850*/       OPC_RecordChild1, // #2 = $src2
/*30851*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*30853*/       OPC_CheckPredicate, 8, // Predicate_load
/*30855*/       OPC_CheckPredicate, 23, // Predicate_memop
/*30857*/       OPC_MoveParent,
/*30858*/       OPC_RecordChild3, // #3 = $src3
/*30859*/       OPC_MoveChild, 3,
/*30861*/       OPC_CheckOpcode, ISD::Constant,
/*30863*/       OPC_MoveParent,
/*30864*/       OPC_CheckPatternPredicate, 11, // (Subtarget->hasSSSE3())
/*30866*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #4 #5 #6 #7 #8
/*30869*/       OPC_EmitMergeInputChains, 1, 1, 
/*30872*/       OPC_EmitConvertToTarget, 3,
/*30874*/       OPC_EmitNodeXForm, 5, 9, // BYTE_imm
/*30877*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PALIGNR128rm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v2i64, 7/*#Ops*/, 0, 4, 5, 6, 7, 8, 10, 
                // Src: (intrinsic_wo_chain:v2i64 730:iPTR, VR128:v2i64:$src1, (ld:v2i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>, (imm:i8):$src3)
                // Dst: (PALIGNR128rm:v2i64 VR128:v16i8:$src1, addr:iPTR:$src2, (BYTE_imm:i8 (imm:i8):$src3))
/*30891*/     /*Scope*/ 24, /*->30916*/
/*30892*/       OPC_RecordChild2, // #1 = $src2
/*30893*/       OPC_RecordChild3, // #2 = $src3
/*30894*/       OPC_MoveChild, 3,
/*30896*/       OPC_CheckOpcode, ISD::Constant,
/*30898*/       OPC_MoveParent,
/*30899*/       OPC_CheckPatternPredicate, 11, // (Subtarget->hasSSSE3())
/*30901*/       OPC_EmitConvertToTarget, 2,
/*30903*/       OPC_EmitNodeXForm, 5, 3, // BYTE_imm
/*30906*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PALIGNR128rr), 0,
                    1/*#VTs*/, MVT::v2i64, 3/*#Ops*/, 0, 1, 4, 
                // Src: (intrinsic_wo_chain:v2i64 730:iPTR, VR128:v2i64:$src1, VR128:v2i64:$src2, (imm:i8):$src3)
                // Dst: (PALIGNR128rr:v2i64 VR128:v16i8:$src1, VR128:v16i8:$src2, (BYTE_imm:i8 (imm:i8):$src3))
/*30916*/     0, /*End of Scope*/
/*30917*/   /*Scope*/ 72, /*->30990*/
/*30918*/     OPC_CheckInteger, 14|128,5/*654*/, 
/*30921*/     OPC_MoveParent,
/*30922*/     OPC_Scope, 44, /*->30968*/ // 2 children in Scope
/*30924*/       OPC_MoveChild, 1,
/*30926*/       OPC_CheckOpcode, ISD::LOAD,
/*30928*/       OPC_RecordMemRef,
/*30929*/       OPC_RecordNode, // #0 = 'ld' chained node
/*30930*/       OPC_CheckFoldableChainNode,
/*30931*/       OPC_RecordChild1, // #1 = $src1
/*30932*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*30934*/       OPC_CheckPredicate, 8, // Predicate_load
/*30936*/       OPC_CheckPredicate, 23, // Predicate_memop
/*30938*/       OPC_MoveParent,
/*30939*/       OPC_RecordChild2, // #2 = $src2
/*30940*/       OPC_MoveChild, 2,
/*30942*/       OPC_CheckOpcode, ISD::Constant,
/*30944*/       OPC_MoveParent,
/*30945*/       OPC_CheckPatternPredicate, 4, // (Subtarget->hasSSE41())
/*30947*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src1 #3 #4 #5 #6 #7
/*30950*/       OPC_EmitMergeInputChains, 1, 0, 
/*30953*/       OPC_EmitConvertToTarget, 2,
/*30955*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::ROUNDPSm_Int), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v4f32, 6/*#Ops*/, 3, 4, 5, 6, 7, 8, 
                // Src: (intrinsic_wo_chain:v4f32 654:iPTR, (ld:v4f32 addr:iPTR:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>, (imm:i32):$src2)
                // Dst: (ROUNDPSm_Int:v4f32 addr:iPTR:$src1, (imm:i32):$src2)
/*30968*/     /*Scope*/ 20, /*->30989*/
/*30969*/       OPC_RecordChild1, // #0 = $src1
/*30970*/       OPC_RecordChild2, // #1 = $src2
/*30971*/       OPC_MoveChild, 2,
/*30973*/       OPC_CheckOpcode, ISD::Constant,
/*30975*/       OPC_MoveParent,
/*30976*/       OPC_CheckPatternPredicate, 4, // (Subtarget->hasSSE41())
/*30978*/       OPC_EmitConvertToTarget, 1,
/*30980*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::ROUNDPSr_Int), 0,
                    1/*#VTs*/, MVT::v4f32, 2/*#Ops*/, 0, 2, 
                // Src: (intrinsic_wo_chain:v4f32 654:iPTR, VR128:v4f32:$src1, (imm:i32):$src2)
                // Dst: (ROUNDPSr_Int:v4f32 VR128:v4f32:$src1, (imm:i32):$src2)
/*30989*/     0, /*End of Scope*/
/*30990*/   /*Scope*/ 72, /*->31063*/
/*30991*/     OPC_CheckInteger, 13|128,5/*653*/, 
/*30994*/     OPC_MoveParent,
/*30995*/     OPC_Scope, 44, /*->31041*/ // 2 children in Scope
/*30997*/       OPC_MoveChild, 1,
/*30999*/       OPC_CheckOpcode, ISD::LOAD,
/*31001*/       OPC_RecordMemRef,
/*31002*/       OPC_RecordNode, // #0 = 'ld' chained node
/*31003*/       OPC_CheckFoldableChainNode,
/*31004*/       OPC_RecordChild1, // #1 = $src1
/*31005*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*31007*/       OPC_CheckPredicate, 8, // Predicate_load
/*31009*/       OPC_CheckPredicate, 23, // Predicate_memop
/*31011*/       OPC_MoveParent,
/*31012*/       OPC_RecordChild2, // #2 = $src2
/*31013*/       OPC_MoveChild, 2,
/*31015*/       OPC_CheckOpcode, ISD::Constant,
/*31017*/       OPC_MoveParent,
/*31018*/       OPC_CheckPatternPredicate, 4, // (Subtarget->hasSSE41())
/*31020*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src1 #3 #4 #5 #6 #7
/*31023*/       OPC_EmitMergeInputChains, 1, 0, 
/*31026*/       OPC_EmitConvertToTarget, 2,
/*31028*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::ROUNDPDm_Int), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v2f64, 6/*#Ops*/, 3, 4, 5, 6, 7, 8, 
                // Src: (intrinsic_wo_chain:v2f64 653:iPTR, (ld:v2f64 addr:iPTR:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>, (imm:i32):$src2)
                // Dst: (ROUNDPDm_Int:v2f64 addr:iPTR:$src1, (imm:i32):$src2)
/*31041*/     /*Scope*/ 20, /*->31062*/
/*31042*/       OPC_RecordChild1, // #0 = $src1
/*31043*/       OPC_RecordChild2, // #1 = $src2
/*31044*/       OPC_MoveChild, 2,
/*31046*/       OPC_CheckOpcode, ISD::Constant,
/*31048*/       OPC_MoveParent,
/*31049*/       OPC_CheckPatternPredicate, 4, // (Subtarget->hasSSE41())
/*31051*/       OPC_EmitConvertToTarget, 1,
/*31053*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::ROUNDPDr_Int), 0,
                    1/*#VTs*/, MVT::v2f64, 2/*#Ops*/, 0, 2, 
                // Src: (intrinsic_wo_chain:v2f64 653:iPTR, VR128:v2f64:$src1, (imm:i32):$src2)
                // Dst: (ROUNDPDr_Int:v2f64 VR128:v2f64:$src1, (imm:i32):$src2)
/*31062*/     0, /*End of Scope*/
/*31063*/   /*Scope*/ 61, /*->31125*/
/*31064*/     OPC_CheckInteger, 115|128,4/*627*/, 
/*31067*/     OPC_MoveParent,
/*31068*/     OPC_Scope, 42, /*->31112*/ // 2 children in Scope
/*31070*/       OPC_MoveChild, 1,
/*31072*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*31074*/       OPC_MoveChild, 0,
/*31076*/       OPC_CheckOpcode, ISD::LOAD,
/*31078*/       OPC_RecordMemRef,
/*31079*/       OPC_RecordNode, // #0 = 'ld' chained node
/*31080*/       OPC_CheckFoldableChainNode,
/*31081*/       OPC_RecordChild1, // #1 = $src
/*31082*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*31084*/       OPC_CheckPredicate, 8, // Predicate_load
/*31086*/       OPC_CheckPredicate, 66, // Predicate_memop64
/*31088*/       OPC_CheckType, MVT::v8i16,
/*31090*/       OPC_MoveParent,
/*31091*/       OPC_MoveParent,
/*31092*/       OPC_CheckPatternPredicate, 4, // (Subtarget->hasSSE41())
/*31094*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*31097*/       OPC_EmitMergeInputChains, 1, 0, 
/*31100*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PHMINPOSUWrm128), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v8i16, 5/*#Ops*/, 2, 3, 4, 5, 6, 
                // Src: (intrinsic_wo_chain:v8i16 627:iPTR, (bitconvert:v8i16 (ld:v8i16 addr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop64>>))
                // Dst: (PHMINPOSUWrm128:v8i16 addr:iPTR:$src)
/*31112*/     /*Scope*/ 11, /*->31124*/
/*31113*/       OPC_RecordChild1, // #0 = $src
/*31114*/       OPC_CheckPatternPredicate, 4, // (Subtarget->hasSSE41())
/*31116*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PHMINPOSUWrr128), 0,
                    1/*#VTs*/, MVT::v8i16, 1/*#Ops*/, 0, 
                // Src: (intrinsic_wo_chain:v8i16 627:iPTR, VR128:v8i16:$src)
                // Dst: (PHMINPOSUWrr128:v8i16 VR128:v8i16:$src)
/*31124*/     0, /*End of Scope*/
/*31125*/   /*Scope*/ 110, /*->31236*/
/*31126*/     OPC_CheckInteger, 111|128,4/*623*/, 
/*31129*/     OPC_MoveParent,
/*31130*/     OPC_Scope, 44, /*->31176*/ // 3 children in Scope
/*31132*/       OPC_RecordChild1, // #0 = $src1
/*31133*/       OPC_MoveChild, 2,
/*31135*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*31137*/       OPC_MoveChild, 0,
/*31139*/       OPC_CheckOpcode, ISD::LOAD,
/*31141*/       OPC_RecordMemRef,
/*31142*/       OPC_RecordNode, // #1 = 'ld' chained node
/*31143*/       OPC_CheckFoldableChainNode,
/*31144*/       OPC_RecordChild1, // #2 = $src2
/*31145*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*31147*/       OPC_CheckPredicate, 8, // Predicate_load
/*31149*/       OPC_CheckPredicate, 23, // Predicate_memop
/*31151*/       OPC_CheckType, MVT::v16i8,
/*31153*/       OPC_MoveParent,
/*31154*/       OPC_MoveParent,
/*31155*/       OPC_CheckPatternPredicate, 4, // (Subtarget->hasSSE41())
/*31157*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*31160*/       OPC_EmitMergeInputChains, 1, 1, 
/*31163*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PCMPEQQrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v2i64, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (intrinsic_wo_chain:v2i64 623:iPTR, VR128:v2i64:$src1, (bitconvert:v2i64 (ld:v16i8 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>))
                // Dst: (PCMPEQQrm:v2i64 VR128:v2i64:$src1, addr:iPTR:$src2)
/*31176*/     /*Scope*/ 44, /*->31221*/
/*31177*/       OPC_MoveChild, 1,
/*31179*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*31181*/       OPC_MoveChild, 0,
/*31183*/       OPC_CheckOpcode, ISD::LOAD,
/*31185*/       OPC_RecordMemRef,
/*31186*/       OPC_RecordNode, // #0 = 'ld' chained node
/*31187*/       OPC_CheckFoldableChainNode,
/*31188*/       OPC_RecordChild1, // #1 = $src2
/*31189*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*31191*/       OPC_CheckPredicate, 8, // Predicate_load
/*31193*/       OPC_CheckPredicate, 23, // Predicate_memop
/*31195*/       OPC_CheckType, MVT::v16i8,
/*31197*/       OPC_MoveParent,
/*31198*/       OPC_MoveParent,
/*31199*/       OPC_RecordChild2, // #2 = $src1
/*31200*/       OPC_CheckPatternPredicate, 4, // (Subtarget->hasSSE41())
/*31202*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*31205*/       OPC_EmitMergeInputChains, 1, 0, 
/*31208*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PCMPEQQrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v2i64, 6/*#Ops*/, 2, 3, 4, 5, 6, 7, 
                // Src: (intrinsic_wo_chain:v2i64 623:iPTR, (bitconvert:v2i64 (ld:v16i8 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>), VR128:v2i64:$src1)
                // Dst: (PCMPEQQrm:v2i64 VR128:v2i64:$src1, addr:iPTR:$src2)
/*31221*/     /*Scope*/ 13, /*->31235*/
/*31222*/       OPC_RecordChild1, // #0 = $src1
/*31223*/       OPC_RecordChild2, // #1 = $src2
/*31224*/       OPC_CheckPatternPredicate, 4, // (Subtarget->hasSSE41())
/*31226*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PCMPEQQrr), 0,
                    1/*#VTs*/, MVT::v2i64, 2/*#Ops*/, 0, 1, 
                // Src: (intrinsic_wo_chain:v2i64 623:iPTR, VR128:v2i64:$src1, VR128:v2i64:$src2)
                // Dst: (PCMPEQQrr:v2i64 VR128:v2i64:$src1, VR128:v2i64:$src2)
/*31235*/     0, /*End of Scope*/
/*31236*/   /*Scope*/ 64, /*->31301*/
/*31237*/     OPC_CheckInteger, 108|128,4/*620*/, 
/*31240*/     OPC_MoveParent,
/*31241*/     OPC_RecordChild1, // #0 = $src1
/*31242*/     OPC_Scope, 43, /*->31287*/ // 2 children in Scope
/*31244*/       OPC_MoveChild, 2,
/*31246*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*31248*/       OPC_MoveChild, 0,
/*31250*/       OPC_CheckOpcode, ISD::LOAD,
/*31252*/       OPC_RecordMemRef,
/*31253*/       OPC_RecordNode, // #1 = 'ld' chained node
/*31254*/       OPC_CheckFoldableChainNode,
/*31255*/       OPC_RecordChild1, // #2 = $src2
/*31256*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*31258*/       OPC_CheckPredicate, 8, // Predicate_load
/*31260*/       OPC_CheckPredicate, 23, // Predicate_memop
/*31262*/       OPC_CheckType, MVT::v16i8,
/*31264*/       OPC_MoveParent,
/*31265*/       OPC_MoveParent,
/*31266*/       OPC_CheckPatternPredicate, 4, // (Subtarget->hasSSE41())
/*31268*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*31271*/       OPC_EmitMergeInputChains, 1, 1, 
/*31274*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PACKUSDWrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v8i16, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (intrinsic_wo_chain:v8i16 620:iPTR, VR128:v4i32:$src1, (bitconvert:v4i32 (ld:v16i8 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>))
                // Dst: (PACKUSDWrm:v8i16 VR128:v4i32:$src1, addr:iPTR:$src2)
/*31287*/     /*Scope*/ 12, /*->31300*/
/*31288*/       OPC_RecordChild2, // #1 = $src2
/*31289*/       OPC_CheckPatternPredicate, 4, // (Subtarget->hasSSE41())
/*31291*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PACKUSDWrr), 0,
                    1/*#VTs*/, MVT::v8i16, 2/*#Ops*/, 0, 1, 
                // Src: (intrinsic_wo_chain:v8i16 620:iPTR, VR128:v4i32:$src1, VR128:v4i32:$src2)
                // Dst: (PACKUSDWrr:v8i16 VR128:v4i32:$src1, VR128:v4i32:$src2)
/*31300*/     0, /*End of Scope*/
/*31301*/   /*Scope*/ 110, /*->31412*/
/*31302*/     OPC_CheckInteger, 120|128,4/*632*/, 
/*31305*/     OPC_MoveParent,
/*31306*/     OPC_Scope, 44, /*->31352*/ // 3 children in Scope
/*31308*/       OPC_RecordChild1, // #0 = $src1
/*31309*/       OPC_MoveChild, 2,
/*31311*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*31313*/       OPC_MoveChild, 0,
/*31315*/       OPC_CheckOpcode, ISD::LOAD,
/*31317*/       OPC_RecordMemRef,
/*31318*/       OPC_RecordNode, // #1 = 'ld' chained node
/*31319*/       OPC_CheckFoldableChainNode,
/*31320*/       OPC_RecordChild1, // #2 = $src2
/*31321*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*31323*/       OPC_CheckPredicate, 8, // Predicate_load
/*31325*/       OPC_CheckPredicate, 23, // Predicate_memop
/*31327*/       OPC_CheckType, MVT::v16i8,
/*31329*/       OPC_MoveParent,
/*31330*/       OPC_MoveParent,
/*31331*/       OPC_CheckPatternPredicate, 4, // (Subtarget->hasSSE41())
/*31333*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*31336*/       OPC_EmitMergeInputChains, 1, 1, 
/*31339*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PMINSBrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v16i8, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (intrinsic_wo_chain:v16i8 632:iPTR, VR128:v16i8:$src1, (bitconvert:v16i8 (ld:v16i8 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>))
                // Dst: (PMINSBrm:v16i8 VR128:v16i8:$src1, addr:iPTR:$src2)
/*31352*/     /*Scope*/ 44, /*->31397*/
/*31353*/       OPC_MoveChild, 1,
/*31355*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*31357*/       OPC_MoveChild, 0,
/*31359*/       OPC_CheckOpcode, ISD::LOAD,
/*31361*/       OPC_RecordMemRef,
/*31362*/       OPC_RecordNode, // #0 = 'ld' chained node
/*31363*/       OPC_CheckFoldableChainNode,
/*31364*/       OPC_RecordChild1, // #1 = $src2
/*31365*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*31367*/       OPC_CheckPredicate, 8, // Predicate_load
/*31369*/       OPC_CheckPredicate, 23, // Predicate_memop
/*31371*/       OPC_CheckType, MVT::v16i8,
/*31373*/       OPC_MoveParent,
/*31374*/       OPC_MoveParent,
/*31375*/       OPC_RecordChild2, // #2 = $src1
/*31376*/       OPC_CheckPatternPredicate, 4, // (Subtarget->hasSSE41())
/*31378*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*31381*/       OPC_EmitMergeInputChains, 1, 0, 
/*31384*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PMINSBrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v16i8, 6/*#Ops*/, 2, 3, 4, 5, 6, 7, 
                // Src: (intrinsic_wo_chain:v16i8 632:iPTR, (bitconvert:v16i8 (ld:v16i8 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>), VR128:v16i8:$src1)
                // Dst: (PMINSBrm:v16i8 VR128:v16i8:$src1, addr:iPTR:$src2)
/*31397*/     /*Scope*/ 13, /*->31411*/
/*31398*/       OPC_RecordChild1, // #0 = $src1
/*31399*/       OPC_RecordChild2, // #1 = $src2
/*31400*/       OPC_CheckPatternPredicate, 4, // (Subtarget->hasSSE41())
/*31402*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PMINSBrr), 0,
                    1/*#VTs*/, MVT::v16i8, 2/*#Ops*/, 0, 1, 
                // Src: (intrinsic_wo_chain:v16i8 632:iPTR, VR128:v16i8:$src1, VR128:v16i8:$src2)
                // Dst: (PMINSBrr:v16i8 VR128:v16i8:$src1, VR128:v16i8:$src2)
/*31411*/     0, /*End of Scope*/
/*31412*/   /*Scope*/ 110, /*->31523*/
/*31413*/     OPC_CheckInteger, 121|128,4/*633*/, 
/*31416*/     OPC_MoveParent,
/*31417*/     OPC_Scope, 44, /*->31463*/ // 3 children in Scope
/*31419*/       OPC_RecordChild1, // #0 = $src1
/*31420*/       OPC_MoveChild, 2,
/*31422*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*31424*/       OPC_MoveChild, 0,
/*31426*/       OPC_CheckOpcode, ISD::LOAD,
/*31428*/       OPC_RecordMemRef,
/*31429*/       OPC_RecordNode, // #1 = 'ld' chained node
/*31430*/       OPC_CheckFoldableChainNode,
/*31431*/       OPC_RecordChild1, // #2 = $src2
/*31432*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*31434*/       OPC_CheckPredicate, 8, // Predicate_load
/*31436*/       OPC_CheckPredicate, 23, // Predicate_memop
/*31438*/       OPC_CheckType, MVT::v16i8,
/*31440*/       OPC_MoveParent,
/*31441*/       OPC_MoveParent,
/*31442*/       OPC_CheckPatternPredicate, 4, // (Subtarget->hasSSE41())
/*31444*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*31447*/       OPC_EmitMergeInputChains, 1, 1, 
/*31450*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PMINSDrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v4i32, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (intrinsic_wo_chain:v4i32 633:iPTR, VR128:v4i32:$src1, (bitconvert:v4i32 (ld:v16i8 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>))
                // Dst: (PMINSDrm:v4i32 VR128:v4i32:$src1, addr:iPTR:$src2)
/*31463*/     /*Scope*/ 44, /*->31508*/
/*31464*/       OPC_MoveChild, 1,
/*31466*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*31468*/       OPC_MoveChild, 0,
/*31470*/       OPC_CheckOpcode, ISD::LOAD,
/*31472*/       OPC_RecordMemRef,
/*31473*/       OPC_RecordNode, // #0 = 'ld' chained node
/*31474*/       OPC_CheckFoldableChainNode,
/*31475*/       OPC_RecordChild1, // #1 = $src2
/*31476*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*31478*/       OPC_CheckPredicate, 8, // Predicate_load
/*31480*/       OPC_CheckPredicate, 23, // Predicate_memop
/*31482*/       OPC_CheckType, MVT::v16i8,
/*31484*/       OPC_MoveParent,
/*31485*/       OPC_MoveParent,
/*31486*/       OPC_RecordChild2, // #2 = $src1
/*31487*/       OPC_CheckPatternPredicate, 4, // (Subtarget->hasSSE41())
/*31489*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*31492*/       OPC_EmitMergeInputChains, 1, 0, 
/*31495*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PMINSDrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v4i32, 6/*#Ops*/, 2, 3, 4, 5, 6, 7, 
                // Src: (intrinsic_wo_chain:v4i32 633:iPTR, (bitconvert:v4i32 (ld:v16i8 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>), VR128:v4i32:$src1)
                // Dst: (PMINSDrm:v4i32 VR128:v4i32:$src1, addr:iPTR:$src2)
/*31508*/     /*Scope*/ 13, /*->31522*/
/*31509*/       OPC_RecordChild1, // #0 = $src1
/*31510*/       OPC_RecordChild2, // #1 = $src2
/*31511*/       OPC_CheckPatternPredicate, 4, // (Subtarget->hasSSE41())
/*31513*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PMINSDrr), 0,
                    1/*#VTs*/, MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (intrinsic_wo_chain:v4i32 633:iPTR, VR128:v4i32:$src1, VR128:v4i32:$src2)
                // Dst: (PMINSDrr:v4i32 VR128:v4i32:$src1, VR128:v4i32:$src2)
/*31522*/     0, /*End of Scope*/
/*31523*/   /*Scope*/ 110, /*->31634*/
/*31524*/     OPC_CheckInteger, 122|128,4/*634*/, 
/*31527*/     OPC_MoveParent,
/*31528*/     OPC_Scope, 44, /*->31574*/ // 3 children in Scope
/*31530*/       OPC_RecordChild1, // #0 = $src1
/*31531*/       OPC_MoveChild, 2,
/*31533*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*31535*/       OPC_MoveChild, 0,
/*31537*/       OPC_CheckOpcode, ISD::LOAD,
/*31539*/       OPC_RecordMemRef,
/*31540*/       OPC_RecordNode, // #1 = 'ld' chained node
/*31541*/       OPC_CheckFoldableChainNode,
/*31542*/       OPC_RecordChild1, // #2 = $src2
/*31543*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*31545*/       OPC_CheckPredicate, 8, // Predicate_load
/*31547*/       OPC_CheckPredicate, 23, // Predicate_memop
/*31549*/       OPC_CheckType, MVT::v16i8,
/*31551*/       OPC_MoveParent,
/*31552*/       OPC_MoveParent,
/*31553*/       OPC_CheckPatternPredicate, 4, // (Subtarget->hasSSE41())
/*31555*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*31558*/       OPC_EmitMergeInputChains, 1, 1, 
/*31561*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PMINUDrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v4i32, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (intrinsic_wo_chain:v4i32 634:iPTR, VR128:v4i32:$src1, (bitconvert:v4i32 (ld:v16i8 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>))
                // Dst: (PMINUDrm:v4i32 VR128:v4i32:$src1, addr:iPTR:$src2)
/*31574*/     /*Scope*/ 44, /*->31619*/
/*31575*/       OPC_MoveChild, 1,
/*31577*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*31579*/       OPC_MoveChild, 0,
/*31581*/       OPC_CheckOpcode, ISD::LOAD,
/*31583*/       OPC_RecordMemRef,
/*31584*/       OPC_RecordNode, // #0 = 'ld' chained node
/*31585*/       OPC_CheckFoldableChainNode,
/*31586*/       OPC_RecordChild1, // #1 = $src2
/*31587*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*31589*/       OPC_CheckPredicate, 8, // Predicate_load
/*31591*/       OPC_CheckPredicate, 23, // Predicate_memop
/*31593*/       OPC_CheckType, MVT::v16i8,
/*31595*/       OPC_MoveParent,
/*31596*/       OPC_MoveParent,
/*31597*/       OPC_RecordChild2, // #2 = $src1
/*31598*/       OPC_CheckPatternPredicate, 4, // (Subtarget->hasSSE41())
/*31600*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*31603*/       OPC_EmitMergeInputChains, 1, 0, 
/*31606*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PMINUDrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v4i32, 6/*#Ops*/, 2, 3, 4, 5, 6, 7, 
                // Src: (intrinsic_wo_chain:v4i32 634:iPTR, (bitconvert:v4i32 (ld:v16i8 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>), VR128:v4i32:$src1)
                // Dst: (PMINUDrm:v4i32 VR128:v4i32:$src1, addr:iPTR:$src2)
/*31619*/     /*Scope*/ 13, /*->31633*/
/*31620*/       OPC_RecordChild1, // #0 = $src1
/*31621*/       OPC_RecordChild2, // #1 = $src2
/*31622*/       OPC_CheckPatternPredicate, 4, // (Subtarget->hasSSE41())
/*31624*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PMINUDrr), 0,
                    1/*#VTs*/, MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (intrinsic_wo_chain:v4i32 634:iPTR, VR128:v4i32:$src1, VR128:v4i32:$src2)
                // Dst: (PMINUDrr:v4i32 VR128:v4i32:$src1, VR128:v4i32:$src2)
/*31633*/     0, /*End of Scope*/
/*31634*/   /*Scope*/ 110, /*->31745*/
/*31635*/     OPC_CheckInteger, 123|128,4/*635*/, 
/*31638*/     OPC_MoveParent,
/*31639*/     OPC_Scope, 44, /*->31685*/ // 3 children in Scope
/*31641*/       OPC_RecordChild1, // #0 = $src1
/*31642*/       OPC_MoveChild, 2,
/*31644*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*31646*/       OPC_MoveChild, 0,
/*31648*/       OPC_CheckOpcode, ISD::LOAD,
/*31650*/       OPC_RecordMemRef,
/*31651*/       OPC_RecordNode, // #1 = 'ld' chained node
/*31652*/       OPC_CheckFoldableChainNode,
/*31653*/       OPC_RecordChild1, // #2 = $src2
/*31654*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*31656*/       OPC_CheckPredicate, 8, // Predicate_load
/*31658*/       OPC_CheckPredicate, 23, // Predicate_memop
/*31660*/       OPC_CheckType, MVT::v16i8,
/*31662*/       OPC_MoveParent,
/*31663*/       OPC_MoveParent,
/*31664*/       OPC_CheckPatternPredicate, 4, // (Subtarget->hasSSE41())
/*31666*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*31669*/       OPC_EmitMergeInputChains, 1, 1, 
/*31672*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PMINUWrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v8i16, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (intrinsic_wo_chain:v8i16 635:iPTR, VR128:v8i16:$src1, (bitconvert:v8i16 (ld:v16i8 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>))
                // Dst: (PMINUWrm:v8i16 VR128:v8i16:$src1, addr:iPTR:$src2)
/*31685*/     /*Scope*/ 44, /*->31730*/
/*31686*/       OPC_MoveChild, 1,
/*31688*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*31690*/       OPC_MoveChild, 0,
/*31692*/       OPC_CheckOpcode, ISD::LOAD,
/*31694*/       OPC_RecordMemRef,
/*31695*/       OPC_RecordNode, // #0 = 'ld' chained node
/*31696*/       OPC_CheckFoldableChainNode,
/*31697*/       OPC_RecordChild1, // #1 = $src2
/*31698*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*31700*/       OPC_CheckPredicate, 8, // Predicate_load
/*31702*/       OPC_CheckPredicate, 23, // Predicate_memop
/*31704*/       OPC_CheckType, MVT::v16i8,
/*31706*/       OPC_MoveParent,
/*31707*/       OPC_MoveParent,
/*31708*/       OPC_RecordChild2, // #2 = $src1
/*31709*/       OPC_CheckPatternPredicate, 4, // (Subtarget->hasSSE41())
/*31711*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*31714*/       OPC_EmitMergeInputChains, 1, 0, 
/*31717*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PMINUWrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v8i16, 6/*#Ops*/, 2, 3, 4, 5, 6, 7, 
                // Src: (intrinsic_wo_chain:v8i16 635:iPTR, (bitconvert:v8i16 (ld:v16i8 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>), VR128:v8i16:$src1)
                // Dst: (PMINUWrm:v8i16 VR128:v8i16:$src1, addr:iPTR:$src2)
/*31730*/     /*Scope*/ 13, /*->31744*/
/*31731*/       OPC_RecordChild1, // #0 = $src1
/*31732*/       OPC_RecordChild2, // #1 = $src2
/*31733*/       OPC_CheckPatternPredicate, 4, // (Subtarget->hasSSE41())
/*31735*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PMINUWrr), 0,
                    1/*#VTs*/, MVT::v8i16, 2/*#Ops*/, 0, 1, 
                // Src: (intrinsic_wo_chain:v8i16 635:iPTR, VR128:v8i16:$src1, VR128:v8i16:$src2)
                // Dst: (PMINUWrr:v8i16 VR128:v8i16:$src1, VR128:v8i16:$src2)
/*31744*/     0, /*End of Scope*/
/*31745*/   /*Scope*/ 110, /*->31856*/
/*31746*/     OPC_CheckInteger, 116|128,4/*628*/, 
/*31749*/     OPC_MoveParent,
/*31750*/     OPC_Scope, 44, /*->31796*/ // 3 children in Scope
/*31752*/       OPC_RecordChild1, // #0 = $src1
/*31753*/       OPC_MoveChild, 2,
/*31755*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*31757*/       OPC_MoveChild, 0,
/*31759*/       OPC_CheckOpcode, ISD::LOAD,
/*31761*/       OPC_RecordMemRef,
/*31762*/       OPC_RecordNode, // #1 = 'ld' chained node
/*31763*/       OPC_CheckFoldableChainNode,
/*31764*/       OPC_RecordChild1, // #2 = $src2
/*31765*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*31767*/       OPC_CheckPredicate, 8, // Predicate_load
/*31769*/       OPC_CheckPredicate, 23, // Predicate_memop
/*31771*/       OPC_CheckType, MVT::v16i8,
/*31773*/       OPC_MoveParent,
/*31774*/       OPC_MoveParent,
/*31775*/       OPC_CheckPatternPredicate, 4, // (Subtarget->hasSSE41())
/*31777*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*31780*/       OPC_EmitMergeInputChains, 1, 1, 
/*31783*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PMAXSBrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v16i8, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (intrinsic_wo_chain:v16i8 628:iPTR, VR128:v16i8:$src1, (bitconvert:v16i8 (ld:v16i8 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>))
                // Dst: (PMAXSBrm:v16i8 VR128:v16i8:$src1, addr:iPTR:$src2)
/*31796*/     /*Scope*/ 44, /*->31841*/
/*31797*/       OPC_MoveChild, 1,
/*31799*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*31801*/       OPC_MoveChild, 0,
/*31803*/       OPC_CheckOpcode, ISD::LOAD,
/*31805*/       OPC_RecordMemRef,
/*31806*/       OPC_RecordNode, // #0 = 'ld' chained node
/*31807*/       OPC_CheckFoldableChainNode,
/*31808*/       OPC_RecordChild1, // #1 = $src2
/*31809*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*31811*/       OPC_CheckPredicate, 8, // Predicate_load
/*31813*/       OPC_CheckPredicate, 23, // Predicate_memop
/*31815*/       OPC_CheckType, MVT::v16i8,
/*31817*/       OPC_MoveParent,
/*31818*/       OPC_MoveParent,
/*31819*/       OPC_RecordChild2, // #2 = $src1
/*31820*/       OPC_CheckPatternPredicate, 4, // (Subtarget->hasSSE41())
/*31822*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*31825*/       OPC_EmitMergeInputChains, 1, 0, 
/*31828*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PMAXSBrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v16i8, 6/*#Ops*/, 2, 3, 4, 5, 6, 7, 
                // Src: (intrinsic_wo_chain:v16i8 628:iPTR, (bitconvert:v16i8 (ld:v16i8 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>), VR128:v16i8:$src1)
                // Dst: (PMAXSBrm:v16i8 VR128:v16i8:$src1, addr:iPTR:$src2)
/*31841*/     /*Scope*/ 13, /*->31855*/
/*31842*/       OPC_RecordChild1, // #0 = $src1
/*31843*/       OPC_RecordChild2, // #1 = $src2
/*31844*/       OPC_CheckPatternPredicate, 4, // (Subtarget->hasSSE41())
/*31846*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PMAXSBrr), 0,
                    1/*#VTs*/, MVT::v16i8, 2/*#Ops*/, 0, 1, 
                // Src: (intrinsic_wo_chain:v16i8 628:iPTR, VR128:v16i8:$src1, VR128:v16i8:$src2)
                // Dst: (PMAXSBrr:v16i8 VR128:v16i8:$src1, VR128:v16i8:$src2)
/*31855*/     0, /*End of Scope*/
/*31856*/   /*Scope*/ 110, /*->31967*/
/*31857*/     OPC_CheckInteger, 117|128,4/*629*/, 
/*31860*/     OPC_MoveParent,
/*31861*/     OPC_Scope, 44, /*->31907*/ // 3 children in Scope
/*31863*/       OPC_RecordChild1, // #0 = $src1
/*31864*/       OPC_MoveChild, 2,
/*31866*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*31868*/       OPC_MoveChild, 0,
/*31870*/       OPC_CheckOpcode, ISD::LOAD,
/*31872*/       OPC_RecordMemRef,
/*31873*/       OPC_RecordNode, // #1 = 'ld' chained node
/*31874*/       OPC_CheckFoldableChainNode,
/*31875*/       OPC_RecordChild1, // #2 = $src2
/*31876*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*31878*/       OPC_CheckPredicate, 8, // Predicate_load
/*31880*/       OPC_CheckPredicate, 23, // Predicate_memop
/*31882*/       OPC_CheckType, MVT::v16i8,
/*31884*/       OPC_MoveParent,
/*31885*/       OPC_MoveParent,
/*31886*/       OPC_CheckPatternPredicate, 4, // (Subtarget->hasSSE41())
/*31888*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*31891*/       OPC_EmitMergeInputChains, 1, 1, 
/*31894*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PMAXSDrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v4i32, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (intrinsic_wo_chain:v4i32 629:iPTR, VR128:v4i32:$src1, (bitconvert:v4i32 (ld:v16i8 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>))
                // Dst: (PMAXSDrm:v4i32 VR128:v4i32:$src1, addr:iPTR:$src2)
/*31907*/     /*Scope*/ 44, /*->31952*/
/*31908*/       OPC_MoveChild, 1,
/*31910*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*31912*/       OPC_MoveChild, 0,
/*31914*/       OPC_CheckOpcode, ISD::LOAD,
/*31916*/       OPC_RecordMemRef,
/*31917*/       OPC_RecordNode, // #0 = 'ld' chained node
/*31918*/       OPC_CheckFoldableChainNode,
/*31919*/       OPC_RecordChild1, // #1 = $src2
/*31920*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*31922*/       OPC_CheckPredicate, 8, // Predicate_load
/*31924*/       OPC_CheckPredicate, 23, // Predicate_memop
/*31926*/       OPC_CheckType, MVT::v16i8,
/*31928*/       OPC_MoveParent,
/*31929*/       OPC_MoveParent,
/*31930*/       OPC_RecordChild2, // #2 = $src1
/*31931*/       OPC_CheckPatternPredicate, 4, // (Subtarget->hasSSE41())
/*31933*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*31936*/       OPC_EmitMergeInputChains, 1, 0, 
/*31939*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PMAXSDrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v4i32, 6/*#Ops*/, 2, 3, 4, 5, 6, 7, 
                // Src: (intrinsic_wo_chain:v4i32 629:iPTR, (bitconvert:v4i32 (ld:v16i8 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>), VR128:v4i32:$src1)
                // Dst: (PMAXSDrm:v4i32 VR128:v4i32:$src1, addr:iPTR:$src2)
/*31952*/     /*Scope*/ 13, /*->31966*/
/*31953*/       OPC_RecordChild1, // #0 = $src1
/*31954*/       OPC_RecordChild2, // #1 = $src2
/*31955*/       OPC_CheckPatternPredicate, 4, // (Subtarget->hasSSE41())
/*31957*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PMAXSDrr), 0,
                    1/*#VTs*/, MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (intrinsic_wo_chain:v4i32 629:iPTR, VR128:v4i32:$src1, VR128:v4i32:$src2)
                // Dst: (PMAXSDrr:v4i32 VR128:v4i32:$src1, VR128:v4i32:$src2)
/*31966*/     0, /*End of Scope*/
/*31967*/   /*Scope*/ 110, /*->32078*/
/*31968*/     OPC_CheckInteger, 118|128,4/*630*/, 
/*31971*/     OPC_MoveParent,
/*31972*/     OPC_Scope, 44, /*->32018*/ // 3 children in Scope
/*31974*/       OPC_RecordChild1, // #0 = $src1
/*31975*/       OPC_MoveChild, 2,
/*31977*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*31979*/       OPC_MoveChild, 0,
/*31981*/       OPC_CheckOpcode, ISD::LOAD,
/*31983*/       OPC_RecordMemRef,
/*31984*/       OPC_RecordNode, // #1 = 'ld' chained node
/*31985*/       OPC_CheckFoldableChainNode,
/*31986*/       OPC_RecordChild1, // #2 = $src2
/*31987*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*31989*/       OPC_CheckPredicate, 8, // Predicate_load
/*31991*/       OPC_CheckPredicate, 23, // Predicate_memop
/*31993*/       OPC_CheckType, MVT::v16i8,
/*31995*/       OPC_MoveParent,
/*31996*/       OPC_MoveParent,
/*31997*/       OPC_CheckPatternPredicate, 4, // (Subtarget->hasSSE41())
/*31999*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*32002*/       OPC_EmitMergeInputChains, 1, 1, 
/*32005*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PMAXUDrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v4i32, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (intrinsic_wo_chain:v4i32 630:iPTR, VR128:v4i32:$src1, (bitconvert:v4i32 (ld:v16i8 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>))
                // Dst: (PMAXUDrm:v4i32 VR128:v4i32:$src1, addr:iPTR:$src2)
/*32018*/     /*Scope*/ 44, /*->32063*/
/*32019*/       OPC_MoveChild, 1,
/*32021*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*32023*/       OPC_MoveChild, 0,
/*32025*/       OPC_CheckOpcode, ISD::LOAD,
/*32027*/       OPC_RecordMemRef,
/*32028*/       OPC_RecordNode, // #0 = 'ld' chained node
/*32029*/       OPC_CheckFoldableChainNode,
/*32030*/       OPC_RecordChild1, // #1 = $src2
/*32031*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*32033*/       OPC_CheckPredicate, 8, // Predicate_load
/*32035*/       OPC_CheckPredicate, 23, // Predicate_memop
/*32037*/       OPC_CheckType, MVT::v16i8,
/*32039*/       OPC_MoveParent,
/*32040*/       OPC_MoveParent,
/*32041*/       OPC_RecordChild2, // #2 = $src1
/*32042*/       OPC_CheckPatternPredicate, 4, // (Subtarget->hasSSE41())
/*32044*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*32047*/       OPC_EmitMergeInputChains, 1, 0, 
/*32050*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PMAXUDrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v4i32, 6/*#Ops*/, 2, 3, 4, 5, 6, 7, 
                // Src: (intrinsic_wo_chain:v4i32 630:iPTR, (bitconvert:v4i32 (ld:v16i8 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>), VR128:v4i32:$src1)
                // Dst: (PMAXUDrm:v4i32 VR128:v4i32:$src1, addr:iPTR:$src2)
/*32063*/     /*Scope*/ 13, /*->32077*/
/*32064*/       OPC_RecordChild1, // #0 = $src1
/*32065*/       OPC_RecordChild2, // #1 = $src2
/*32066*/       OPC_CheckPatternPredicate, 4, // (Subtarget->hasSSE41())
/*32068*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PMAXUDrr), 0,
                    1/*#VTs*/, MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (intrinsic_wo_chain:v4i32 630:iPTR, VR128:v4i32:$src1, VR128:v4i32:$src2)
                // Dst: (PMAXUDrr:v4i32 VR128:v4i32:$src1, VR128:v4i32:$src2)
/*32077*/     0, /*End of Scope*/
/*32078*/   /*Scope*/ 110, /*->32189*/
/*32079*/     OPC_CheckInteger, 119|128,4/*631*/, 
/*32082*/     OPC_MoveParent,
/*32083*/     OPC_Scope, 44, /*->32129*/ // 3 children in Scope
/*32085*/       OPC_RecordChild1, // #0 = $src1
/*32086*/       OPC_MoveChild, 2,
/*32088*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*32090*/       OPC_MoveChild, 0,
/*32092*/       OPC_CheckOpcode, ISD::LOAD,
/*32094*/       OPC_RecordMemRef,
/*32095*/       OPC_RecordNode, // #1 = 'ld' chained node
/*32096*/       OPC_CheckFoldableChainNode,
/*32097*/       OPC_RecordChild1, // #2 = $src2
/*32098*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*32100*/       OPC_CheckPredicate, 8, // Predicate_load
/*32102*/       OPC_CheckPredicate, 23, // Predicate_memop
/*32104*/       OPC_CheckType, MVT::v16i8,
/*32106*/       OPC_MoveParent,
/*32107*/       OPC_MoveParent,
/*32108*/       OPC_CheckPatternPredicate, 4, // (Subtarget->hasSSE41())
/*32110*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*32113*/       OPC_EmitMergeInputChains, 1, 1, 
/*32116*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PMAXUWrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v8i16, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (intrinsic_wo_chain:v8i16 631:iPTR, VR128:v8i16:$src1, (bitconvert:v8i16 (ld:v16i8 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>))
                // Dst: (PMAXUWrm:v8i16 VR128:v8i16:$src1, addr:iPTR:$src2)
/*32129*/     /*Scope*/ 44, /*->32174*/
/*32130*/       OPC_MoveChild, 1,
/*32132*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*32134*/       OPC_MoveChild, 0,
/*32136*/       OPC_CheckOpcode, ISD::LOAD,
/*32138*/       OPC_RecordMemRef,
/*32139*/       OPC_RecordNode, // #0 = 'ld' chained node
/*32140*/       OPC_CheckFoldableChainNode,
/*32141*/       OPC_RecordChild1, // #1 = $src2
/*32142*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*32144*/       OPC_CheckPredicate, 8, // Predicate_load
/*32146*/       OPC_CheckPredicate, 23, // Predicate_memop
/*32148*/       OPC_CheckType, MVT::v16i8,
/*32150*/       OPC_MoveParent,
/*32151*/       OPC_MoveParent,
/*32152*/       OPC_RecordChild2, // #2 = $src1
/*32153*/       OPC_CheckPatternPredicate, 4, // (Subtarget->hasSSE41())
/*32155*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*32158*/       OPC_EmitMergeInputChains, 1, 0, 
/*32161*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PMAXUWrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v8i16, 6/*#Ops*/, 2, 3, 4, 5, 6, 7, 
                // Src: (intrinsic_wo_chain:v8i16 631:iPTR, (bitconvert:v8i16 (ld:v16i8 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>), VR128:v8i16:$src1)
                // Dst: (PMAXUWrm:v8i16 VR128:v8i16:$src1, addr:iPTR:$src2)
/*32174*/     /*Scope*/ 13, /*->32188*/
/*32175*/       OPC_RecordChild1, // #0 = $src1
/*32176*/       OPC_RecordChild2, // #1 = $src2
/*32177*/       OPC_CheckPatternPredicate, 4, // (Subtarget->hasSSE41())
/*32179*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PMAXUWrr), 0,
                    1/*#VTs*/, MVT::v8i16, 2/*#Ops*/, 0, 1, 
                // Src: (intrinsic_wo_chain:v8i16 631:iPTR, VR128:v8i16:$src1, VR128:v8i16:$src2)
                // Dst: (PMAXUWrr:v8i16 VR128:v8i16:$src1, VR128:v8i16:$src2)
/*32188*/     0, /*End of Scope*/
/*32189*/   /*Scope*/ 110, /*->32300*/
/*32190*/     OPC_CheckInteger, 8|128,5/*648*/, 
/*32193*/     OPC_MoveParent,
/*32194*/     OPC_Scope, 44, /*->32240*/ // 3 children in Scope
/*32196*/       OPC_RecordChild1, // #0 = $src1
/*32197*/       OPC_MoveChild, 2,
/*32199*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*32201*/       OPC_MoveChild, 0,
/*32203*/       OPC_CheckOpcode, ISD::LOAD,
/*32205*/       OPC_RecordMemRef,
/*32206*/       OPC_RecordNode, // #1 = 'ld' chained node
/*32207*/       OPC_CheckFoldableChainNode,
/*32208*/       OPC_RecordChild1, // #2 = $src2
/*32209*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*32211*/       OPC_CheckPredicate, 8, // Predicate_load
/*32213*/       OPC_CheckPredicate, 23, // Predicate_memop
/*32215*/       OPC_CheckType, MVT::v16i8,
/*32217*/       OPC_MoveParent,
/*32218*/       OPC_MoveParent,
/*32219*/       OPC_CheckPatternPredicate, 4, // (Subtarget->hasSSE41())
/*32221*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*32224*/       OPC_EmitMergeInputChains, 1, 1, 
/*32227*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PMULDQrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v2i64, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (intrinsic_wo_chain:v2i64 648:iPTR, VR128:v4i32:$src1, (bitconvert:v4i32 (ld:v16i8 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>))
                // Dst: (PMULDQrm:v2i64 VR128:v4i32:$src1, addr:iPTR:$src2)
/*32240*/     /*Scope*/ 44, /*->32285*/
/*32241*/       OPC_MoveChild, 1,
/*32243*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*32245*/       OPC_MoveChild, 0,
/*32247*/       OPC_CheckOpcode, ISD::LOAD,
/*32249*/       OPC_RecordMemRef,
/*32250*/       OPC_RecordNode, // #0 = 'ld' chained node
/*32251*/       OPC_CheckFoldableChainNode,
/*32252*/       OPC_RecordChild1, // #1 = $src2
/*32253*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*32255*/       OPC_CheckPredicate, 8, // Predicate_load
/*32257*/       OPC_CheckPredicate, 23, // Predicate_memop
/*32259*/       OPC_CheckType, MVT::v16i8,
/*32261*/       OPC_MoveParent,
/*32262*/       OPC_MoveParent,
/*32263*/       OPC_RecordChild2, // #2 = $src1
/*32264*/       OPC_CheckPatternPredicate, 4, // (Subtarget->hasSSE41())
/*32266*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*32269*/       OPC_EmitMergeInputChains, 1, 0, 
/*32272*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PMULDQrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v2i64, 6/*#Ops*/, 2, 3, 4, 5, 6, 7, 
                // Src: (intrinsic_wo_chain:v2i64 648:iPTR, (bitconvert:v4i32 (ld:v16i8 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>), VR128:v4i32:$src1)
                // Dst: (PMULDQrm:v2i64 VR128:v4i32:$src1, addr:iPTR:$src2)
/*32285*/     /*Scope*/ 13, /*->32299*/
/*32286*/       OPC_RecordChild1, // #0 = $src1
/*32287*/       OPC_RecordChild2, // #1 = $src2
/*32288*/       OPC_CheckPatternPredicate, 4, // (Subtarget->hasSSE41())
/*32290*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PMULDQrr), 0,
                    1/*#VTs*/, MVT::v2i64, 2/*#Ops*/, 0, 1, 
                // Src: (intrinsic_wo_chain:v2i64 648:iPTR, VR128:v4i32:$src1, VR128:v4i32:$src2)
                // Dst: (PMULDQrr:v2i64 VR128:v4i32:$src1, VR128:v4i32:$src2)
/*32299*/     0, /*End of Scope*/
/*32300*/   /*Scope*/ 72, /*->32373*/
/*32301*/     OPC_CheckInteger, 100|128,4/*612*/, 
/*32304*/     OPC_MoveParent,
/*32305*/     OPC_RecordChild1, // #0 = $src1
/*32306*/     OPC_Scope, 47, /*->32355*/ // 2 children in Scope
/*32308*/       OPC_MoveChild, 2,
/*32310*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*32312*/       OPC_MoveChild, 0,
/*32314*/       OPC_CheckOpcode, ISD::LOAD,
/*32316*/       OPC_RecordMemRef,
/*32317*/       OPC_RecordNode, // #1 = 'ld' chained node
/*32318*/       OPC_CheckFoldableChainNode,
/*32319*/       OPC_RecordChild1, // #2 = $src2
/*32320*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*32322*/       OPC_CheckPredicate, 8, // Predicate_load
/*32324*/       OPC_CheckPredicate, 23, // Predicate_memop
/*32326*/       OPC_CheckType, MVT::v16i8,
/*32328*/       OPC_MoveParent,
/*32329*/       OPC_MoveParent,
/*32330*/       OPC_RecordChild3, // #3 = physreg input XMM0
/*32331*/       OPC_CheckPatternPredicate, 4, // (Subtarget->hasSSE41())
/*32333*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #4 #5 #6 #7 #8
/*32336*/       OPC_EmitMergeInputChains, 1, 1, 
/*32339*/       OPC_EmitCopyToReg, 3, X86::XMM0,
/*32342*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::BLENDVPDrm0), 0|OPFL_Chain|OPFL_FlagInput|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v2f64, 6/*#Ops*/, 0, 4, 5, 6, 7, 8, 
                // Src: (intrinsic_wo_chain:v2f64 612:iPTR, VR128:v2f64:$src1, (bitconvert:v2f64 (ld:v16i8 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>), XMM0:v2f64)
                // Dst: (BLENDVPDrm0:v2f64 VR128:v2f64:$src1, addr:iPTR:$src2)
/*32355*/     /*Scope*/ 16, /*->32372*/
/*32356*/       OPC_RecordChild2, // #1 = $src2
/*32357*/       OPC_RecordChild3, // #2 = physreg input XMM0
/*32358*/       OPC_CheckPatternPredicate, 4, // (Subtarget->hasSSE41())
/*32360*/       OPC_EmitCopyToReg, 2, X86::XMM0,
/*32363*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::BLENDVPDrr0), 0|OPFL_FlagInput,
                    1/*#VTs*/, MVT::v2f64, 2/*#Ops*/, 0, 1, 
                // Src: (intrinsic_wo_chain:v2f64 612:iPTR, VR128:v2f64:$src1, VR128:v2f64:$src2, XMM0:v2f64)
                // Dst: (BLENDVPDrr0:v2f64 VR128:v2f64:$src1, VR128:v2f64:$src2)
/*32372*/     0, /*End of Scope*/
/*32373*/   /*Scope*/ 72, /*->32446*/
/*32374*/     OPC_CheckInteger, 101|128,4/*613*/, 
/*32377*/     OPC_MoveParent,
/*32378*/     OPC_RecordChild1, // #0 = $src1
/*32379*/     OPC_Scope, 47, /*->32428*/ // 2 children in Scope
/*32381*/       OPC_MoveChild, 2,
/*32383*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*32385*/       OPC_MoveChild, 0,
/*32387*/       OPC_CheckOpcode, ISD::LOAD,
/*32389*/       OPC_RecordMemRef,
/*32390*/       OPC_RecordNode, // #1 = 'ld' chained node
/*32391*/       OPC_CheckFoldableChainNode,
/*32392*/       OPC_RecordChild1, // #2 = $src2
/*32393*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*32395*/       OPC_CheckPredicate, 8, // Predicate_load
/*32397*/       OPC_CheckPredicate, 23, // Predicate_memop
/*32399*/       OPC_CheckType, MVT::v16i8,
/*32401*/       OPC_MoveParent,
/*32402*/       OPC_MoveParent,
/*32403*/       OPC_RecordChild3, // #3 = physreg input XMM0
/*32404*/       OPC_CheckPatternPredicate, 4, // (Subtarget->hasSSE41())
/*32406*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #4 #5 #6 #7 #8
/*32409*/       OPC_EmitMergeInputChains, 1, 1, 
/*32412*/       OPC_EmitCopyToReg, 3, X86::XMM0,
/*32415*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::BLENDVPSrm0), 0|OPFL_Chain|OPFL_FlagInput|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v4f32, 6/*#Ops*/, 0, 4, 5, 6, 7, 8, 
                // Src: (intrinsic_wo_chain:v4f32 613:iPTR, VR128:v4f32:$src1, (bitconvert:v4f32 (ld:v16i8 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>), XMM0:v4f32)
                // Dst: (BLENDVPSrm0:v4f32 VR128:v4f32:$src1, addr:iPTR:$src2)
/*32428*/     /*Scope*/ 16, /*->32445*/
/*32429*/       OPC_RecordChild2, // #1 = $src2
/*32430*/       OPC_RecordChild3, // #2 = physreg input XMM0
/*32431*/       OPC_CheckPatternPredicate, 4, // (Subtarget->hasSSE41())
/*32433*/       OPC_EmitCopyToReg, 2, X86::XMM0,
/*32436*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::BLENDVPSrr0), 0|OPFL_FlagInput,
                    1/*#VTs*/, MVT::v4f32, 2/*#Ops*/, 0, 1, 
                // Src: (intrinsic_wo_chain:v4f32 613:iPTR, VR128:v4f32:$src1, VR128:v4f32:$src2, XMM0:v4f32)
                // Dst: (BLENDVPSrr0:v4f32 VR128:v4f32:$src1, VR128:v4f32:$src2)
/*32445*/     0, /*End of Scope*/
/*32446*/   /*Scope*/ 72, /*->32519*/
/*32447*/     OPC_CheckInteger, 109|128,4/*621*/, 
/*32450*/     OPC_MoveParent,
/*32451*/     OPC_RecordChild1, // #0 = $src1
/*32452*/     OPC_Scope, 47, /*->32501*/ // 2 children in Scope
/*32454*/       OPC_MoveChild, 2,
/*32456*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*32458*/       OPC_MoveChild, 0,
/*32460*/       OPC_CheckOpcode, ISD::LOAD,
/*32462*/       OPC_RecordMemRef,
/*32463*/       OPC_RecordNode, // #1 = 'ld' chained node
/*32464*/       OPC_CheckFoldableChainNode,
/*32465*/       OPC_RecordChild1, // #2 = $src2
/*32466*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*32468*/       OPC_CheckPredicate, 8, // Predicate_load
/*32470*/       OPC_CheckPredicate, 23, // Predicate_memop
/*32472*/       OPC_CheckType, MVT::v16i8,
/*32474*/       OPC_MoveParent,
/*32475*/       OPC_MoveParent,
/*32476*/       OPC_RecordChild3, // #3 = physreg input XMM0
/*32477*/       OPC_CheckPatternPredicate, 4, // (Subtarget->hasSSE41())
/*32479*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #4 #5 #6 #7 #8
/*32482*/       OPC_EmitMergeInputChains, 1, 1, 
/*32485*/       OPC_EmitCopyToReg, 3, X86::XMM0,
/*32488*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PBLENDVBrm0), 0|OPFL_Chain|OPFL_FlagInput|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v16i8, 6/*#Ops*/, 0, 4, 5, 6, 7, 8, 
                // Src: (intrinsic_wo_chain:v16i8 621:iPTR, VR128:v16i8:$src1, (bitconvert:v16i8 (ld:v16i8 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>), XMM0:v16i8)
                // Dst: (PBLENDVBrm0:v16i8 VR128:v16i8:$src1, addr:iPTR:$src2)
/*32501*/     /*Scope*/ 16, /*->32518*/
/*32502*/       OPC_RecordChild2, // #1 = $src2
/*32503*/       OPC_RecordChild3, // #2 = physreg input XMM0
/*32504*/       OPC_CheckPatternPredicate, 4, // (Subtarget->hasSSE41())
/*32506*/       OPC_EmitCopyToReg, 2, X86::XMM0,
/*32509*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PBLENDVBrr0), 0|OPFL_FlagInput,
                    1/*#VTs*/, MVT::v16i8, 2/*#Ops*/, 0, 1, 
                // Src: (intrinsic_wo_chain:v16i8 621:iPTR, VR128:v16i8:$src1, VR128:v16i8:$src2, XMM0:v16i8)
                // Dst: (PBLENDVBrr0:v16i8 VR128:v16i8:$src1, VR128:v16i8:$src2)
/*32518*/     0, /*End of Scope*/
/*32519*/   /*Scope*/ 64, /*->32584*/
/*32520*/     OPC_CheckInteger, 28|128,5/*668*/, 
/*32523*/     OPC_MoveParent,
/*32524*/     OPC_RecordChild1, // #0 = $src1
/*32525*/     OPC_Scope, 43, /*->32570*/ // 2 children in Scope
/*32527*/       OPC_MoveChild, 2,
/*32529*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*32531*/       OPC_MoveChild, 0,
/*32533*/       OPC_CheckOpcode, ISD::LOAD,
/*32535*/       OPC_RecordMemRef,
/*32536*/       OPC_RecordNode, // #1 = 'ld' chained node
/*32537*/       OPC_CheckFoldableChainNode,
/*32538*/       OPC_RecordChild1, // #2 = $src2
/*32539*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*32541*/       OPC_CheckPredicate, 8, // Predicate_load
/*32543*/       OPC_CheckPredicate, 23, // Predicate_memop
/*32545*/       OPC_CheckType, MVT::v16i8,
/*32547*/       OPC_MoveParent,
/*32548*/       OPC_MoveParent,
/*32549*/       OPC_CheckPatternPredicate, 14, // (Subtarget->hasSSE42())
/*32551*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*32554*/       OPC_EmitMergeInputChains, 1, 1, 
/*32557*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PCMPGTQrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v2i64, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (intrinsic_wo_chain:v2i64 668:iPTR, VR128:v2i64:$src1, (bitconvert:v2i64 (ld:v16i8 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>))
                // Dst: (PCMPGTQrm:v2i64 VR128:v2i64:$src1, addr:iPTR:$src2)
/*32570*/     /*Scope*/ 12, /*->32583*/
/*32571*/       OPC_RecordChild2, // #1 = $src2
/*32572*/       OPC_CheckPatternPredicate, 14, // (Subtarget->hasSSE42())
/*32574*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PCMPGTQrr), 0,
                    1/*#VTs*/, MVT::v2i64, 2/*#Ops*/, 0, 1, 
                // Src: (intrinsic_wo_chain:v2i64 668:iPTR, VR128:v2i64:$src1, VR128:v2i64:$src2)
                // Dst: (PCMPGTQrr:v2i64 VR128:v2i64:$src1, VR128:v2i64:$src2)
/*32583*/     0, /*End of Scope*/
/*32584*/   /*Scope*/ 75, /*->32660*/
/*32585*/     OPC_CheckInteger, 29|128,5/*669*/, 
/*32588*/     OPC_MoveParent,
/*32589*/     OPC_RecordChild1, // #0 = $src1
/*32590*/     OPC_Scope, 44, /*->32636*/ // 2 children in Scope
/*32592*/       OPC_MoveChild, 2,
/*32594*/       OPC_CheckOpcode, ISD::LOAD,
/*32596*/       OPC_RecordMemRef,
/*32597*/       OPC_RecordNode, // #1 = 'ld' chained node
/*32598*/       OPC_CheckFoldableChainNode,
/*32599*/       OPC_RecordChild1, // #2 = $src2
/*32600*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*32602*/       OPC_CheckPredicate, 8, // Predicate_load
/*32604*/       OPC_MoveParent,
/*32605*/       OPC_RecordChild3, // #3 = $src3
/*32606*/       OPC_MoveChild, 3,
/*32608*/       OPC_CheckOpcode, ISD::Constant,
/*32610*/       OPC_MoveParent,
/*32611*/       OPC_CheckPatternPredicate, 14, // (Subtarget->hasSSE42())
/*32613*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #4 #5 #6 #7 #8
/*32616*/       OPC_EmitMergeInputChains, 1, 1, 
/*32619*/       OPC_EmitConvertToTarget, 3,
/*32621*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PCMPISTRIrm), 0|OPFL_Chain|OPFL_MemRefs,
                    2/*#VTs*/, MVT::i32, MVT::i32, 7/*#Ops*/, 0, 4, 5, 6, 7, 8, 9, 
                // Src: (intrinsic_wo_chain:i32 669:iPTR, VR128:v16i8:$src1, (ld:v16i8 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:i8):$src3)
                // Dst: (PCMPISTRIrm:isVoid VR128:v16i8:$src1, addr:iPTR:$src2, (imm:i8):$src3)
/*32636*/     /*Scope*/ 22, /*->32659*/
/*32637*/       OPC_RecordChild2, // #1 = $src2
/*32638*/       OPC_RecordChild3, // #2 = $src3
/*32639*/       OPC_MoveChild, 3,
/*32641*/       OPC_CheckOpcode, ISD::Constant,
/*32643*/       OPC_MoveParent,
/*32644*/       OPC_CheckPatternPredicate, 14, // (Subtarget->hasSSE42())
/*32646*/       OPC_EmitConvertToTarget, 2,
/*32648*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PCMPISTRIrr), 0,
                    2/*#VTs*/, MVT::i32, MVT::i32, 3/*#Ops*/, 0, 1, 3, 
                // Src: (intrinsic_wo_chain:i32 669:iPTR, VR128:v16i8:$src1, VR128:v16i8:$src2, (imm:i8):$src3)
                // Dst: (PCMPISTRIrr:isVoid VR128:v16i8:$src1, VR128:v16i8:$src2, (imm:i8):$src3)
/*32659*/     0, /*End of Scope*/
/*32660*/   /*Scope*/ 75, /*->32736*/
/*32661*/     OPC_CheckInteger, 30|128,5/*670*/, 
/*32664*/     OPC_MoveParent,
/*32665*/     OPC_RecordChild1, // #0 = $src1
/*32666*/     OPC_Scope, 44, /*->32712*/ // 2 children in Scope
/*32668*/       OPC_MoveChild, 2,
/*32670*/       OPC_CheckOpcode, ISD::LOAD,
/*32672*/       OPC_RecordMemRef,
/*32673*/       OPC_RecordNode, // #1 = 'ld' chained node
/*32674*/       OPC_CheckFoldableChainNode,
/*32675*/       OPC_RecordChild1, // #2 = $src2
/*32676*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*32678*/       OPC_CheckPredicate, 8, // Predicate_load
/*32680*/       OPC_MoveParent,
/*32681*/       OPC_RecordChild3, // #3 = $src3
/*32682*/       OPC_MoveChild, 3,
/*32684*/       OPC_CheckOpcode, ISD::Constant,
/*32686*/       OPC_MoveParent,
/*32687*/       OPC_CheckPatternPredicate, 14, // (Subtarget->hasSSE42())
/*32689*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #4 #5 #6 #7 #8
/*32692*/       OPC_EmitMergeInputChains, 1, 1, 
/*32695*/       OPC_EmitConvertToTarget, 3,
/*32697*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PCMPISTRIArm), 0|OPFL_Chain|OPFL_MemRefs,
                    2/*#VTs*/, MVT::i32, MVT::i32, 7/*#Ops*/, 0, 4, 5, 6, 7, 8, 9, 
                // Src: (intrinsic_wo_chain:i32 670:iPTR, VR128:v16i8:$src1, (ld:v16i8 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:i8):$src3)
                // Dst: (PCMPISTRIArm:isVoid VR128:v16i8:$src1, addr:iPTR:$src2, (imm:i8):$src3)
/*32712*/     /*Scope*/ 22, /*->32735*/
/*32713*/       OPC_RecordChild2, // #1 = $src2
/*32714*/       OPC_RecordChild3, // #2 = $src3
/*32715*/       OPC_MoveChild, 3,
/*32717*/       OPC_CheckOpcode, ISD::Constant,
/*32719*/       OPC_MoveParent,
/*32720*/       OPC_CheckPatternPredicate, 14, // (Subtarget->hasSSE42())
/*32722*/       OPC_EmitConvertToTarget, 2,
/*32724*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PCMPISTRIArr), 0,
                    2/*#VTs*/, MVT::i32, MVT::i32, 3/*#Ops*/, 0, 1, 3, 
                // Src: (intrinsic_wo_chain:i32 670:iPTR, VR128:v16i8:$src1, VR128:v16i8:$src2, (imm:i8):$src3)
                // Dst: (PCMPISTRIArr:isVoid VR128:v16i8:$src1, VR128:v16i8:$src2, (imm:i8):$src3)
/*32735*/     0, /*End of Scope*/
/*32736*/   /*Scope*/ 75, /*->32812*/
/*32737*/     OPC_CheckInteger, 31|128,5/*671*/, 
/*32740*/     OPC_MoveParent,
/*32741*/     OPC_RecordChild1, // #0 = $src1
/*32742*/     OPC_Scope, 44, /*->32788*/ // 2 children in Scope
/*32744*/       OPC_MoveChild, 2,
/*32746*/       OPC_CheckOpcode, ISD::LOAD,
/*32748*/       OPC_RecordMemRef,
/*32749*/       OPC_RecordNode, // #1 = 'ld' chained node
/*32750*/       OPC_CheckFoldableChainNode,
/*32751*/       OPC_RecordChild1, // #2 = $src2
/*32752*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*32754*/       OPC_CheckPredicate, 8, // Predicate_load
/*32756*/       OPC_MoveParent,
/*32757*/       OPC_RecordChild3, // #3 = $src3
/*32758*/       OPC_MoveChild, 3,
/*32760*/       OPC_CheckOpcode, ISD::Constant,
/*32762*/       OPC_MoveParent,
/*32763*/       OPC_CheckPatternPredicate, 14, // (Subtarget->hasSSE42())
/*32765*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #4 #5 #6 #7 #8
/*32768*/       OPC_EmitMergeInputChains, 1, 1, 
/*32771*/       OPC_EmitConvertToTarget, 3,
/*32773*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PCMPISTRICrm), 0|OPFL_Chain|OPFL_MemRefs,
                    2/*#VTs*/, MVT::i32, MVT::i32, 7/*#Ops*/, 0, 4, 5, 6, 7, 8, 9, 
                // Src: (intrinsic_wo_chain:i32 671:iPTR, VR128:v16i8:$src1, (ld:v16i8 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:i8):$src3)
                // Dst: (PCMPISTRICrm:isVoid VR128:v16i8:$src1, addr:iPTR:$src2, (imm:i8):$src3)
/*32788*/     /*Scope*/ 22, /*->32811*/
/*32789*/       OPC_RecordChild2, // #1 = $src2
/*32790*/       OPC_RecordChild3, // #2 = $src3
/*32791*/       OPC_MoveChild, 3,
/*32793*/       OPC_CheckOpcode, ISD::Constant,
/*32795*/       OPC_MoveParent,
/*32796*/       OPC_CheckPatternPredicate, 14, // (Subtarget->hasSSE42())
/*32798*/       OPC_EmitConvertToTarget, 2,
/*32800*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PCMPISTRICrr), 0,
                    2/*#VTs*/, MVT::i32, MVT::i32, 3/*#Ops*/, 0, 1, 3, 
                // Src: (intrinsic_wo_chain:i32 671:iPTR, VR128:v16i8:$src1, VR128:v16i8:$src2, (imm:i8):$src3)
                // Dst: (PCMPISTRICrr:isVoid VR128:v16i8:$src1, VR128:v16i8:$src2, (imm:i8):$src3)
/*32811*/     0, /*End of Scope*/
/*32812*/   /*Scope*/ 75, /*->32888*/
/*32813*/     OPC_CheckInteger, 32|128,5/*672*/, 
/*32816*/     OPC_MoveParent,
/*32817*/     OPC_RecordChild1, // #0 = $src1
/*32818*/     OPC_Scope, 44, /*->32864*/ // 2 children in Scope
/*32820*/       OPC_MoveChild, 2,
/*32822*/       OPC_CheckOpcode, ISD::LOAD,
/*32824*/       OPC_RecordMemRef,
/*32825*/       OPC_RecordNode, // #1 = 'ld' chained node
/*32826*/       OPC_CheckFoldableChainNode,
/*32827*/       OPC_RecordChild1, // #2 = $src2
/*32828*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*32830*/       OPC_CheckPredicate, 8, // Predicate_load
/*32832*/       OPC_MoveParent,
/*32833*/       OPC_RecordChild3, // #3 = $src3
/*32834*/       OPC_MoveChild, 3,
/*32836*/       OPC_CheckOpcode, ISD::Constant,
/*32838*/       OPC_MoveParent,
/*32839*/       OPC_CheckPatternPredicate, 14, // (Subtarget->hasSSE42())
/*32841*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #4 #5 #6 #7 #8
/*32844*/       OPC_EmitMergeInputChains, 1, 1, 
/*32847*/       OPC_EmitConvertToTarget, 3,
/*32849*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PCMPISTRIOrm), 0|OPFL_Chain|OPFL_MemRefs,
                    2/*#VTs*/, MVT::i32, MVT::i32, 7/*#Ops*/, 0, 4, 5, 6, 7, 8, 9, 
                // Src: (intrinsic_wo_chain:i32 672:iPTR, VR128:v16i8:$src1, (ld:v16i8 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:i8):$src3)
                // Dst: (PCMPISTRIOrm:isVoid VR128:v16i8:$src1, addr:iPTR:$src2, (imm:i8):$src3)
/*32864*/     /*Scope*/ 22, /*->32887*/
/*32865*/       OPC_RecordChild2, // #1 = $src2
/*32866*/       OPC_RecordChild3, // #2 = $src3
/*32867*/       OPC_MoveChild, 3,
/*32869*/       OPC_CheckOpcode, ISD::Constant,
/*32871*/       OPC_MoveParent,
/*32872*/       OPC_CheckPatternPredicate, 14, // (Subtarget->hasSSE42())
/*32874*/       OPC_EmitConvertToTarget, 2,
/*32876*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PCMPISTRIOrr), 0,
                    2/*#VTs*/, MVT::i32, MVT::i32, 3/*#Ops*/, 0, 1, 3, 
                // Src: (intrinsic_wo_chain:i32 672:iPTR, VR128:v16i8:$src1, VR128:v16i8:$src2, (imm:i8):$src3)
                // Dst: (PCMPISTRIOrr:isVoid VR128:v16i8:$src1, VR128:v16i8:$src2, (imm:i8):$src3)
/*32887*/     0, /*End of Scope*/
/*32888*/   /*Scope*/ 75, /*->32964*/
/*32889*/     OPC_CheckInteger, 33|128,5/*673*/, 
/*32892*/     OPC_MoveParent,
/*32893*/     OPC_RecordChild1, // #0 = $src1
/*32894*/     OPC_Scope, 44, /*->32940*/ // 2 children in Scope
/*32896*/       OPC_MoveChild, 2,
/*32898*/       OPC_CheckOpcode, ISD::LOAD,
/*32900*/       OPC_RecordMemRef,
/*32901*/       OPC_RecordNode, // #1 = 'ld' chained node
/*32902*/       OPC_CheckFoldableChainNode,
/*32903*/       OPC_RecordChild1, // #2 = $src2
/*32904*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*32906*/       OPC_CheckPredicate, 8, // Predicate_load
/*32908*/       OPC_MoveParent,
/*32909*/       OPC_RecordChild3, // #3 = $src3
/*32910*/       OPC_MoveChild, 3,
/*32912*/       OPC_CheckOpcode, ISD::Constant,
/*32914*/       OPC_MoveParent,
/*32915*/       OPC_CheckPatternPredicate, 14, // (Subtarget->hasSSE42())
/*32917*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #4 #5 #6 #7 #8
/*32920*/       OPC_EmitMergeInputChains, 1, 1, 
/*32923*/       OPC_EmitConvertToTarget, 3,
/*32925*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PCMPISTRISrm), 0|OPFL_Chain|OPFL_MemRefs,
                    2/*#VTs*/, MVT::i32, MVT::i32, 7/*#Ops*/, 0, 4, 5, 6, 7, 8, 9, 
                // Src: (intrinsic_wo_chain:i32 673:iPTR, VR128:v16i8:$src1, (ld:v16i8 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:i8):$src3)
                // Dst: (PCMPISTRISrm:isVoid VR128:v16i8:$src1, addr:iPTR:$src2, (imm:i8):$src3)
/*32940*/     /*Scope*/ 22, /*->32963*/
/*32941*/       OPC_RecordChild2, // #1 = $src2
/*32942*/       OPC_RecordChild3, // #2 = $src3
/*32943*/       OPC_MoveChild, 3,
/*32945*/       OPC_CheckOpcode, ISD::Constant,
/*32947*/       OPC_MoveParent,
/*32948*/       OPC_CheckPatternPredicate, 14, // (Subtarget->hasSSE42())
/*32950*/       OPC_EmitConvertToTarget, 2,
/*32952*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PCMPISTRISrr), 0,
                    2/*#VTs*/, MVT::i32, MVT::i32, 3/*#Ops*/, 0, 1, 3, 
                // Src: (intrinsic_wo_chain:i32 673:iPTR, VR128:v16i8:$src1, VR128:v16i8:$src2, (imm:i8):$src3)
                // Dst: (PCMPISTRISrr:isVoid VR128:v16i8:$src1, VR128:v16i8:$src2, (imm:i8):$src3)
/*32963*/     0, /*End of Scope*/
/*32964*/   /*Scope*/ 75, /*->33040*/
/*32965*/     OPC_CheckInteger, 34|128,5/*674*/, 
/*32968*/     OPC_MoveParent,
/*32969*/     OPC_RecordChild1, // #0 = $src1
/*32970*/     OPC_Scope, 44, /*->33016*/ // 2 children in Scope
/*32972*/       OPC_MoveChild, 2,
/*32974*/       OPC_CheckOpcode, ISD::LOAD,
/*32976*/       OPC_RecordMemRef,
/*32977*/       OPC_RecordNode, // #1 = 'ld' chained node
/*32978*/       OPC_CheckFoldableChainNode,
/*32979*/       OPC_RecordChild1, // #2 = $src2
/*32980*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*32982*/       OPC_CheckPredicate, 8, // Predicate_load
/*32984*/       OPC_MoveParent,
/*32985*/       OPC_RecordChild3, // #3 = $src3
/*32986*/       OPC_MoveChild, 3,
/*32988*/       OPC_CheckOpcode, ISD::Constant,
/*32990*/       OPC_MoveParent,
/*32991*/       OPC_CheckPatternPredicate, 14, // (Subtarget->hasSSE42())
/*32993*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #4 #5 #6 #7 #8
/*32996*/       OPC_EmitMergeInputChains, 1, 1, 
/*32999*/       OPC_EmitConvertToTarget, 3,
/*33001*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PCMPISTRIZrm), 0|OPFL_Chain|OPFL_MemRefs,
                    2/*#VTs*/, MVT::i32, MVT::i32, 7/*#Ops*/, 0, 4, 5, 6, 7, 8, 9, 
                // Src: (intrinsic_wo_chain:i32 674:iPTR, VR128:v16i8:$src1, (ld:v16i8 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:i8):$src3)
                // Dst: (PCMPISTRIZrm:isVoid VR128:v16i8:$src1, addr:iPTR:$src2, (imm:i8):$src3)
/*33016*/     /*Scope*/ 22, /*->33039*/
/*33017*/       OPC_RecordChild2, // #1 = $src2
/*33018*/       OPC_RecordChild3, // #2 = $src3
/*33019*/       OPC_MoveChild, 3,
/*33021*/       OPC_CheckOpcode, ISD::Constant,
/*33023*/       OPC_MoveParent,
/*33024*/       OPC_CheckPatternPredicate, 14, // (Subtarget->hasSSE42())
/*33026*/       OPC_EmitConvertToTarget, 2,
/*33028*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PCMPISTRIZrr), 0,
                    2/*#VTs*/, MVT::i32, MVT::i32, 3/*#Ops*/, 0, 1, 3, 
                // Src: (intrinsic_wo_chain:i32 674:iPTR, VR128:v16i8:$src1, VR128:v16i8:$src2, (imm:i8):$src3)
                // Dst: (PCMPISTRIZrr:isVoid VR128:v16i8:$src1, VR128:v16i8:$src2, (imm:i8):$src3)
/*33039*/     0, /*End of Scope*/
/*33040*/   /*Scope*/ 90, /*->33131*/
/*33041*/     OPC_CheckInteger, 21|128,5/*661*/, 
/*33044*/     OPC_MoveParent,
/*33045*/     OPC_RecordChild1, // #0 = $src1
/*33046*/     OPC_RecordChild2, // #1 = physreg input EAX
/*33047*/     OPC_Scope, 51, /*->33100*/ // 2 children in Scope
/*33049*/       OPC_MoveChild, 3,
/*33051*/       OPC_CheckOpcode, ISD::LOAD,
/*33053*/       OPC_RecordMemRef,
/*33054*/       OPC_RecordNode, // #2 = 'ld' chained node
/*33055*/       OPC_CheckFoldableChainNode,
/*33056*/       OPC_RecordChild1, // #3 = $src3
/*33057*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*33059*/       OPC_CheckPredicate, 8, // Predicate_load
/*33061*/       OPC_MoveParent,
/*33062*/       OPC_RecordChild4, // #4 = physreg input EDX
/*33063*/       OPC_RecordChild5, // #5 = $src5
/*33064*/       OPC_MoveChild, 5,
/*33066*/       OPC_CheckOpcode, ISD::Constant,
/*33068*/       OPC_MoveParent,
/*33069*/       OPC_CheckPatternPredicate, 14, // (Subtarget->hasSSE42())
/*33071*/       OPC_CheckComplexPat, /*CP*/0, /*#*/3, // SelectAddr:$src3 #6 #7 #8 #9 #10
/*33074*/       OPC_EmitMergeInputChains, 1, 2, 
/*33077*/       OPC_EmitConvertToTarget, 5,
/*33079*/       OPC_EmitCopyToReg, 1, X86::EAX,
/*33082*/       OPC_EmitCopyToReg, 4, X86::EDX,
/*33085*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PCMPESTRIrm), 0|OPFL_Chain|OPFL_FlagInput|OPFL_MemRefs,
                    2/*#VTs*/, MVT::i32, MVT::i32, 7/*#Ops*/, 0, 6, 7, 8, 9, 10, 11, 
                // Src: (intrinsic_wo_chain:i32 661:iPTR, VR128:v16i8:$src1, EAX:i32, (ld:v16i8 addr:iPTR:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, EDX:i32, (imm:i8):$src5)
                // Dst: (PCMPESTRIrm:isVoid VR128:v16i8:$src1, addr:iPTR:$src3, (imm:i8):$src5)
/*33100*/     /*Scope*/ 29, /*->33130*/
/*33101*/       OPC_RecordChild3, // #2 = $src3
/*33102*/       OPC_RecordChild4, // #3 = physreg input EDX
/*33103*/       OPC_RecordChild5, // #4 = $src5
/*33104*/       OPC_MoveChild, 5,
/*33106*/       OPC_CheckOpcode, ISD::Constant,
/*33108*/       OPC_MoveParent,
/*33109*/       OPC_CheckPatternPredicate, 14, // (Subtarget->hasSSE42())
/*33111*/       OPC_EmitConvertToTarget, 4,
/*33113*/       OPC_EmitCopyToReg, 1, X86::EAX,
/*33116*/       OPC_EmitCopyToReg, 3, X86::EDX,
/*33119*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PCMPESTRIrr), 0|OPFL_FlagInput,
                    2/*#VTs*/, MVT::i32, MVT::i32, 3/*#Ops*/, 0, 2, 5, 
                // Src: (intrinsic_wo_chain:i32 661:iPTR, VR128:v16i8:$src1, EAX:i32, VR128:v16i8:$src3, EDX:i32, (imm:i8):$src5)
                // Dst: (PCMPESTRIrr:isVoid VR128:v16i8:$src1, VR128:v16i8:$src3, (imm:i8):$src5)
/*33130*/     0, /*End of Scope*/
/*33131*/   /*Scope*/ 90, /*->33222*/
/*33132*/     OPC_CheckInteger, 22|128,5/*662*/, 
/*33135*/     OPC_MoveParent,
/*33136*/     OPC_RecordChild1, // #0 = $src1
/*33137*/     OPC_RecordChild2, // #1 = physreg input EAX
/*33138*/     OPC_Scope, 51, /*->33191*/ // 2 children in Scope
/*33140*/       OPC_MoveChild, 3,
/*33142*/       OPC_CheckOpcode, ISD::LOAD,
/*33144*/       OPC_RecordMemRef,
/*33145*/       OPC_RecordNode, // #2 = 'ld' chained node
/*33146*/       OPC_CheckFoldableChainNode,
/*33147*/       OPC_RecordChild1, // #3 = $src3
/*33148*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*33150*/       OPC_CheckPredicate, 8, // Predicate_load
/*33152*/       OPC_MoveParent,
/*33153*/       OPC_RecordChild4, // #4 = physreg input EDX
/*33154*/       OPC_RecordChild5, // #5 = $src5
/*33155*/       OPC_MoveChild, 5,
/*33157*/       OPC_CheckOpcode, ISD::Constant,
/*33159*/       OPC_MoveParent,
/*33160*/       OPC_CheckPatternPredicate, 14, // (Subtarget->hasSSE42())
/*33162*/       OPC_CheckComplexPat, /*CP*/0, /*#*/3, // SelectAddr:$src3 #6 #7 #8 #9 #10
/*33165*/       OPC_EmitMergeInputChains, 1, 2, 
/*33168*/       OPC_EmitConvertToTarget, 5,
/*33170*/       OPC_EmitCopyToReg, 1, X86::EAX,
/*33173*/       OPC_EmitCopyToReg, 4, X86::EDX,
/*33176*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PCMPESTRIArm), 0|OPFL_Chain|OPFL_FlagInput|OPFL_MemRefs,
                    2/*#VTs*/, MVT::i32, MVT::i32, 7/*#Ops*/, 0, 6, 7, 8, 9, 10, 11, 
                // Src: (intrinsic_wo_chain:i32 662:iPTR, VR128:v16i8:$src1, EAX:i32, (ld:v16i8 addr:iPTR:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, EDX:i32, (imm:i8):$src5)
                // Dst: (PCMPESTRIArm:isVoid VR128:v16i8:$src1, addr:iPTR:$src3, (imm:i8):$src5)
/*33191*/     /*Scope*/ 29, /*->33221*/
/*33192*/       OPC_RecordChild3, // #2 = $src3
/*33193*/       OPC_RecordChild4, // #3 = physreg input EDX
/*33194*/       OPC_RecordChild5, // #4 = $src5
/*33195*/       OPC_MoveChild, 5,
/*33197*/       OPC_CheckOpcode, ISD::Constant,
/*33199*/       OPC_MoveParent,
/*33200*/       OPC_CheckPatternPredicate, 14, // (Subtarget->hasSSE42())
/*33202*/       OPC_EmitConvertToTarget, 4,
/*33204*/       OPC_EmitCopyToReg, 1, X86::EAX,
/*33207*/       OPC_EmitCopyToReg, 3, X86::EDX,
/*33210*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PCMPESTRIArr), 0|OPFL_FlagInput,
                    2/*#VTs*/, MVT::i32, MVT::i32, 3/*#Ops*/, 0, 2, 5, 
                // Src: (intrinsic_wo_chain:i32 662:iPTR, VR128:v16i8:$src1, EAX:i32, VR128:v16i8:$src3, EDX:i32, (imm:i8):$src5)
                // Dst: (PCMPESTRIArr:isVoid VR128:v16i8:$src1, VR128:v16i8:$src3, (imm:i8):$src5)
/*33221*/     0, /*End of Scope*/
/*33222*/   /*Scope*/ 90, /*->33313*/
/*33223*/     OPC_CheckInteger, 23|128,5/*663*/, 
/*33226*/     OPC_MoveParent,
/*33227*/     OPC_RecordChild1, // #0 = $src1
/*33228*/     OPC_RecordChild2, // #1 = physreg input EAX
/*33229*/     OPC_Scope, 51, /*->33282*/ // 2 children in Scope
/*33231*/       OPC_MoveChild, 3,
/*33233*/       OPC_CheckOpcode, ISD::LOAD,
/*33235*/       OPC_RecordMemRef,
/*33236*/       OPC_RecordNode, // #2 = 'ld' chained node
/*33237*/       OPC_CheckFoldableChainNode,
/*33238*/       OPC_RecordChild1, // #3 = $src3
/*33239*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*33241*/       OPC_CheckPredicate, 8, // Predicate_load
/*33243*/       OPC_MoveParent,
/*33244*/       OPC_RecordChild4, // #4 = physreg input EDX
/*33245*/       OPC_RecordChild5, // #5 = $src5
/*33246*/       OPC_MoveChild, 5,
/*33248*/       OPC_CheckOpcode, ISD::Constant,
/*33250*/       OPC_MoveParent,
/*33251*/       OPC_CheckPatternPredicate, 14, // (Subtarget->hasSSE42())
/*33253*/       OPC_CheckComplexPat, /*CP*/0, /*#*/3, // SelectAddr:$src3 #6 #7 #8 #9 #10
/*33256*/       OPC_EmitMergeInputChains, 1, 2, 
/*33259*/       OPC_EmitConvertToTarget, 5,
/*33261*/       OPC_EmitCopyToReg, 1, X86::EAX,
/*33264*/       OPC_EmitCopyToReg, 4, X86::EDX,
/*33267*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PCMPESTRICrm), 0|OPFL_Chain|OPFL_FlagInput|OPFL_MemRefs,
                    2/*#VTs*/, MVT::i32, MVT::i32, 7/*#Ops*/, 0, 6, 7, 8, 9, 10, 11, 
                // Src: (intrinsic_wo_chain:i32 663:iPTR, VR128:v16i8:$src1, EAX:i32, (ld:v16i8 addr:iPTR:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, EDX:i32, (imm:i8):$src5)
                // Dst: (PCMPESTRICrm:isVoid VR128:v16i8:$src1, addr:iPTR:$src3, (imm:i8):$src5)
/*33282*/     /*Scope*/ 29, /*->33312*/
/*33283*/       OPC_RecordChild3, // #2 = $src3
/*33284*/       OPC_RecordChild4, // #3 = physreg input EDX
/*33285*/       OPC_RecordChild5, // #4 = $src5
/*33286*/       OPC_MoveChild, 5,
/*33288*/       OPC_CheckOpcode, ISD::Constant,
/*33290*/       OPC_MoveParent,
/*33291*/       OPC_CheckPatternPredicate, 14, // (Subtarget->hasSSE42())
/*33293*/       OPC_EmitConvertToTarget, 4,
/*33295*/       OPC_EmitCopyToReg, 1, X86::EAX,
/*33298*/       OPC_EmitCopyToReg, 3, X86::EDX,
/*33301*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PCMPESTRICrr), 0|OPFL_FlagInput,
                    2/*#VTs*/, MVT::i32, MVT::i32, 3/*#Ops*/, 0, 2, 5, 
                // Src: (intrinsic_wo_chain:i32 663:iPTR, VR128:v16i8:$src1, EAX:i32, VR128:v16i8:$src3, EDX:i32, (imm:i8):$src5)
                // Dst: (PCMPESTRICrr:isVoid VR128:v16i8:$src1, VR128:v16i8:$src3, (imm:i8):$src5)
/*33312*/     0, /*End of Scope*/
/*33313*/   /*Scope*/ 90, /*->33404*/
/*33314*/     OPC_CheckInteger, 24|128,5/*664*/, 
/*33317*/     OPC_MoveParent,
/*33318*/     OPC_RecordChild1, // #0 = $src1
/*33319*/     OPC_RecordChild2, // #1 = physreg input EAX
/*33320*/     OPC_Scope, 51, /*->33373*/ // 2 children in Scope
/*33322*/       OPC_MoveChild, 3,
/*33324*/       OPC_CheckOpcode, ISD::LOAD,
/*33326*/       OPC_RecordMemRef,
/*33327*/       OPC_RecordNode, // #2 = 'ld' chained node
/*33328*/       OPC_CheckFoldableChainNode,
/*33329*/       OPC_RecordChild1, // #3 = $src3
/*33330*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*33332*/       OPC_CheckPredicate, 8, // Predicate_load
/*33334*/       OPC_MoveParent,
/*33335*/       OPC_RecordChild4, // #4 = physreg input EDX
/*33336*/       OPC_RecordChild5, // #5 = $src5
/*33337*/       OPC_MoveChild, 5,
/*33339*/       OPC_CheckOpcode, ISD::Constant,
/*33341*/       OPC_MoveParent,
/*33342*/       OPC_CheckPatternPredicate, 14, // (Subtarget->hasSSE42())
/*33344*/       OPC_CheckComplexPat, /*CP*/0, /*#*/3, // SelectAddr:$src3 #6 #7 #8 #9 #10
/*33347*/       OPC_EmitMergeInputChains, 1, 2, 
/*33350*/       OPC_EmitConvertToTarget, 5,
/*33352*/       OPC_EmitCopyToReg, 1, X86::EAX,
/*33355*/       OPC_EmitCopyToReg, 4, X86::EDX,
/*33358*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PCMPESTRIOrm), 0|OPFL_Chain|OPFL_FlagInput|OPFL_MemRefs,
                    2/*#VTs*/, MVT::i32, MVT::i32, 7/*#Ops*/, 0, 6, 7, 8, 9, 10, 11, 
                // Src: (intrinsic_wo_chain:i32 664:iPTR, VR128:v16i8:$src1, EAX:i32, (ld:v16i8 addr:iPTR:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, EDX:i32, (imm:i8):$src5)
                // Dst: (PCMPESTRIOrm:isVoid VR128:v16i8:$src1, addr:iPTR:$src3, (imm:i8):$src5)
/*33373*/     /*Scope*/ 29, /*->33403*/
/*33374*/       OPC_RecordChild3, // #2 = $src3
/*33375*/       OPC_RecordChild4, // #3 = physreg input EDX
/*33376*/       OPC_RecordChild5, // #4 = $src5
/*33377*/       OPC_MoveChild, 5,
/*33379*/       OPC_CheckOpcode, ISD::Constant,
/*33381*/       OPC_MoveParent,
/*33382*/       OPC_CheckPatternPredicate, 14, // (Subtarget->hasSSE42())
/*33384*/       OPC_EmitConvertToTarget, 4,
/*33386*/       OPC_EmitCopyToReg, 1, X86::EAX,
/*33389*/       OPC_EmitCopyToReg, 3, X86::EDX,
/*33392*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PCMPESTRIOrr), 0|OPFL_FlagInput,
                    2/*#VTs*/, MVT::i32, MVT::i32, 3/*#Ops*/, 0, 2, 5, 
                // Src: (intrinsic_wo_chain:i32 664:iPTR, VR128:v16i8:$src1, EAX:i32, VR128:v16i8:$src3, EDX:i32, (imm:i8):$src5)
                // Dst: (PCMPESTRIOrr:isVoid VR128:v16i8:$src1, VR128:v16i8:$src3, (imm:i8):$src5)
/*33403*/     0, /*End of Scope*/
/*33404*/   /*Scope*/ 90, /*->33495*/
/*33405*/     OPC_CheckInteger, 25|128,5/*665*/, 
/*33408*/     OPC_MoveParent,
/*33409*/     OPC_RecordChild1, // #0 = $src1
/*33410*/     OPC_RecordChild2, // #1 = physreg input EAX
/*33411*/     OPC_Scope, 51, /*->33464*/ // 2 children in Scope
/*33413*/       OPC_MoveChild, 3,
/*33415*/       OPC_CheckOpcode, ISD::LOAD,
/*33417*/       OPC_RecordMemRef,
/*33418*/       OPC_RecordNode, // #2 = 'ld' chained node
/*33419*/       OPC_CheckFoldableChainNode,
/*33420*/       OPC_RecordChild1, // #3 = $src3
/*33421*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*33423*/       OPC_CheckPredicate, 8, // Predicate_load
/*33425*/       OPC_MoveParent,
/*33426*/       OPC_RecordChild4, // #4 = physreg input EDX
/*33427*/       OPC_RecordChild5, // #5 = $src5
/*33428*/       OPC_MoveChild, 5,
/*33430*/       OPC_CheckOpcode, ISD::Constant,
/*33432*/       OPC_MoveParent,
/*33433*/       OPC_CheckPatternPredicate, 14, // (Subtarget->hasSSE42())
/*33435*/       OPC_CheckComplexPat, /*CP*/0, /*#*/3, // SelectAddr:$src3 #6 #7 #8 #9 #10
/*33438*/       OPC_EmitMergeInputChains, 1, 2, 
/*33441*/       OPC_EmitConvertToTarget, 5,
/*33443*/       OPC_EmitCopyToReg, 1, X86::EAX,
/*33446*/       OPC_EmitCopyToReg, 4, X86::EDX,
/*33449*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PCMPESTRISrm), 0|OPFL_Chain|OPFL_FlagInput|OPFL_MemRefs,
                    2/*#VTs*/, MVT::i32, MVT::i32, 7/*#Ops*/, 0, 6, 7, 8, 9, 10, 11, 
                // Src: (intrinsic_wo_chain:i32 665:iPTR, VR128:v16i8:$src1, EAX:i32, (ld:v16i8 addr:iPTR:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, EDX:i32, (imm:i8):$src5)
                // Dst: (PCMPESTRISrm:isVoid VR128:v16i8:$src1, addr:iPTR:$src3, (imm:i8):$src5)
/*33464*/     /*Scope*/ 29, /*->33494*/
/*33465*/       OPC_RecordChild3, // #2 = $src3
/*33466*/       OPC_RecordChild4, // #3 = physreg input EDX
/*33467*/       OPC_RecordChild5, // #4 = $src5
/*33468*/       OPC_MoveChild, 5,
/*33470*/       OPC_CheckOpcode, ISD::Constant,
/*33472*/       OPC_MoveParent,
/*33473*/       OPC_CheckPatternPredicate, 14, // (Subtarget->hasSSE42())
/*33475*/       OPC_EmitConvertToTarget, 4,
/*33477*/       OPC_EmitCopyToReg, 1, X86::EAX,
/*33480*/       OPC_EmitCopyToReg, 3, X86::EDX,
/*33483*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PCMPESTRISrr), 0|OPFL_FlagInput,
                    2/*#VTs*/, MVT::i32, MVT::i32, 3/*#Ops*/, 0, 2, 5, 
                // Src: (intrinsic_wo_chain:i32 665:iPTR, VR128:v16i8:$src1, EAX:i32, VR128:v16i8:$src3, EDX:i32, (imm:i8):$src5)
                // Dst: (PCMPESTRISrr:isVoid VR128:v16i8:$src1, VR128:v16i8:$src3, (imm:i8):$src5)
/*33494*/     0, /*End of Scope*/
/*33495*/   /*Scope*/ 90, /*->33586*/
/*33496*/     OPC_CheckInteger, 26|128,5/*666*/, 
/*33499*/     OPC_MoveParent,
/*33500*/     OPC_RecordChild1, // #0 = $src1
/*33501*/     OPC_RecordChild2, // #1 = physreg input EAX
/*33502*/     OPC_Scope, 51, /*->33555*/ // 2 children in Scope
/*33504*/       OPC_MoveChild, 3,
/*33506*/       OPC_CheckOpcode, ISD::LOAD,
/*33508*/       OPC_RecordMemRef,
/*33509*/       OPC_RecordNode, // #2 = 'ld' chained node
/*33510*/       OPC_CheckFoldableChainNode,
/*33511*/       OPC_RecordChild1, // #3 = $src3
/*33512*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*33514*/       OPC_CheckPredicate, 8, // Predicate_load
/*33516*/       OPC_MoveParent,
/*33517*/       OPC_RecordChild4, // #4 = physreg input EDX
/*33518*/       OPC_RecordChild5, // #5 = $src5
/*33519*/       OPC_MoveChild, 5,
/*33521*/       OPC_CheckOpcode, ISD::Constant,
/*33523*/       OPC_MoveParent,
/*33524*/       OPC_CheckPatternPredicate, 14, // (Subtarget->hasSSE42())
/*33526*/       OPC_CheckComplexPat, /*CP*/0, /*#*/3, // SelectAddr:$src3 #6 #7 #8 #9 #10
/*33529*/       OPC_EmitMergeInputChains, 1, 2, 
/*33532*/       OPC_EmitConvertToTarget, 5,
/*33534*/       OPC_EmitCopyToReg, 1, X86::EAX,
/*33537*/       OPC_EmitCopyToReg, 4, X86::EDX,
/*33540*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PCMPESTRIZrm), 0|OPFL_Chain|OPFL_FlagInput|OPFL_MemRefs,
                    2/*#VTs*/, MVT::i32, MVT::i32, 7/*#Ops*/, 0, 6, 7, 8, 9, 10, 11, 
                // Src: (intrinsic_wo_chain:i32 666:iPTR, VR128:v16i8:$src1, EAX:i32, (ld:v16i8 addr:iPTR:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, EDX:i32, (imm:i8):$src5)
                // Dst: (PCMPESTRIZrm:isVoid VR128:v16i8:$src1, addr:iPTR:$src3, (imm:i8):$src5)
/*33555*/     /*Scope*/ 29, /*->33585*/
/*33556*/       OPC_RecordChild3, // #2 = $src3
/*33557*/       OPC_RecordChild4, // #3 = physreg input EDX
/*33558*/       OPC_RecordChild5, // #4 = $src5
/*33559*/       OPC_MoveChild, 5,
/*33561*/       OPC_CheckOpcode, ISD::Constant,
/*33563*/       OPC_MoveParent,
/*33564*/       OPC_CheckPatternPredicate, 14, // (Subtarget->hasSSE42())
/*33566*/       OPC_EmitConvertToTarget, 4,
/*33568*/       OPC_EmitCopyToReg, 1, X86::EAX,
/*33571*/       OPC_EmitCopyToReg, 3, X86::EDX,
/*33574*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PCMPESTRIZrr), 0|OPFL_FlagInput,
                    2/*#VTs*/, MVT::i32, MVT::i32, 3/*#Ops*/, 0, 2, 5, 
                // Src: (intrinsic_wo_chain:i32 666:iPTR, VR128:v16i8:$src1, EAX:i32, VR128:v16i8:$src3, EDX:i32, (imm:i8):$src5)
                // Dst: (PCMPESTRIZrr:isVoid VR128:v16i8:$src1, VR128:v16i8:$src3, (imm:i8):$src5)
/*33585*/     0, /*End of Scope*/
/*33586*/   /*Scope*/ 106, /*->33693*/
/*33587*/     OPC_CheckInteger, 73|128,3/*457*/, 
/*33590*/     OPC_MoveParent,
/*33591*/     OPC_Scope, 42, /*->33635*/ // 3 children in Scope
/*33593*/       OPC_RecordChild1, // #0 = $src1
/*33594*/       OPC_MoveChild, 2,
/*33596*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*33598*/       OPC_MoveChild, 0,
/*33600*/       OPC_CheckOpcode, ISD::LOAD,
/*33602*/       OPC_RecordMemRef,
/*33603*/       OPC_RecordNode, // #1 = 'ld' chained node
/*33604*/       OPC_CheckFoldableChainNode,
/*33605*/       OPC_RecordChild1, // #2 = $src2
/*33606*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*33608*/       OPC_CheckPredicate, 8, // Predicate_load
/*33610*/       OPC_CheckType, MVT::v1i64,
/*33612*/       OPC_MoveParent,
/*33613*/       OPC_MoveParent,
/*33614*/       OPC_CheckPatternPredicate, 8, // (Subtarget->hasMMX())
/*33616*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*33619*/       OPC_EmitMergeInputChains, 1, 1, 
/*33622*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PADDSBrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v8i8, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (intrinsic_wo_chain:v8i8 457:iPTR, VR64:v8i8:$src1, (bitconvert:v8i8 (ld:v1i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>))
                // Dst: (MMX_PADDSBrm:v8i8 VR64:v8i8:$src1, addr:iPTR:$src2)
/*33635*/     /*Scope*/ 42, /*->33678*/
/*33636*/       OPC_MoveChild, 1,
/*33638*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*33640*/       OPC_MoveChild, 0,
/*33642*/       OPC_CheckOpcode, ISD::LOAD,
/*33644*/       OPC_RecordMemRef,
/*33645*/       OPC_RecordNode, // #0 = 'ld' chained node
/*33646*/       OPC_CheckFoldableChainNode,
/*33647*/       OPC_RecordChild1, // #1 = $src2
/*33648*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*33650*/       OPC_CheckPredicate, 8, // Predicate_load
/*33652*/       OPC_CheckType, MVT::v1i64,
/*33654*/       OPC_MoveParent,
/*33655*/       OPC_MoveParent,
/*33656*/       OPC_RecordChild2, // #2 = $src1
/*33657*/       OPC_CheckPatternPredicate, 8, // (Subtarget->hasMMX())
/*33659*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*33662*/       OPC_EmitMergeInputChains, 1, 0, 
/*33665*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PADDSBrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v8i8, 6/*#Ops*/, 2, 3, 4, 5, 6, 7, 
                // Src: (intrinsic_wo_chain:v8i8 457:iPTR, (bitconvert:v8i8 (ld:v1i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>), VR64:v8i8:$src1)
                // Dst: (MMX_PADDSBrm:v8i8 VR64:v8i8:$src1, addr:iPTR:$src2)
/*33678*/     /*Scope*/ 13, /*->33692*/
/*33679*/       OPC_RecordChild1, // #0 = $src1
/*33680*/       OPC_RecordChild2, // #1 = $src2
/*33681*/       OPC_CheckPatternPredicate, 8, // (Subtarget->hasMMX())
/*33683*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PADDSBrr), 0,
                    1/*#VTs*/, MVT::v8i8, 2/*#Ops*/, 0, 1, 
                // Src: (intrinsic_wo_chain:v8i8 457:iPTR, VR64:v8i8:$src1, VR64:v8i8:$src2)
                // Dst: (MMX_PADDSBrr:v8i8 VR64:v8i8:$src1, VR64:v8i8:$src2)
/*33692*/     0, /*End of Scope*/
/*33693*/   /*Scope*/ 106, /*->33800*/
/*33694*/     OPC_CheckInteger, 74|128,3/*458*/, 
/*33697*/     OPC_MoveParent,
/*33698*/     OPC_Scope, 42, /*->33742*/ // 3 children in Scope
/*33700*/       OPC_RecordChild1, // #0 = $src1
/*33701*/       OPC_MoveChild, 2,
/*33703*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*33705*/       OPC_MoveChild, 0,
/*33707*/       OPC_CheckOpcode, ISD::LOAD,
/*33709*/       OPC_RecordMemRef,
/*33710*/       OPC_RecordNode, // #1 = 'ld' chained node
/*33711*/       OPC_CheckFoldableChainNode,
/*33712*/       OPC_RecordChild1, // #2 = $src2
/*33713*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*33715*/       OPC_CheckPredicate, 8, // Predicate_load
/*33717*/       OPC_CheckType, MVT::v1i64,
/*33719*/       OPC_MoveParent,
/*33720*/       OPC_MoveParent,
/*33721*/       OPC_CheckPatternPredicate, 8, // (Subtarget->hasMMX())
/*33723*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*33726*/       OPC_EmitMergeInputChains, 1, 1, 
/*33729*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PADDSWrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v4i16, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (intrinsic_wo_chain:v4i16 458:iPTR, VR64:v4i16:$src1, (bitconvert:v4i16 (ld:v1i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>))
                // Dst: (MMX_PADDSWrm:v4i16 VR64:v4i16:$src1, addr:iPTR:$src2)
/*33742*/     /*Scope*/ 42, /*->33785*/
/*33743*/       OPC_MoveChild, 1,
/*33745*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*33747*/       OPC_MoveChild, 0,
/*33749*/       OPC_CheckOpcode, ISD::LOAD,
/*33751*/       OPC_RecordMemRef,
/*33752*/       OPC_RecordNode, // #0 = 'ld' chained node
/*33753*/       OPC_CheckFoldableChainNode,
/*33754*/       OPC_RecordChild1, // #1 = $src2
/*33755*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*33757*/       OPC_CheckPredicate, 8, // Predicate_load
/*33759*/       OPC_CheckType, MVT::v1i64,
/*33761*/       OPC_MoveParent,
/*33762*/       OPC_MoveParent,
/*33763*/       OPC_RecordChild2, // #2 = $src1
/*33764*/       OPC_CheckPatternPredicate, 8, // (Subtarget->hasMMX())
/*33766*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*33769*/       OPC_EmitMergeInputChains, 1, 0, 
/*33772*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PADDSWrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v4i16, 6/*#Ops*/, 2, 3, 4, 5, 6, 7, 
                // Src: (intrinsic_wo_chain:v4i16 458:iPTR, (bitconvert:v4i16 (ld:v1i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>), VR64:v4i16:$src1)
                // Dst: (MMX_PADDSWrm:v4i16 VR64:v4i16:$src1, addr:iPTR:$src2)
/*33785*/     /*Scope*/ 13, /*->33799*/
/*33786*/       OPC_RecordChild1, // #0 = $src1
/*33787*/       OPC_RecordChild2, // #1 = $src2
/*33788*/       OPC_CheckPatternPredicate, 8, // (Subtarget->hasMMX())
/*33790*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PADDSWrr), 0,
                    1/*#VTs*/, MVT::v4i16, 2/*#Ops*/, 0, 1, 
                // Src: (intrinsic_wo_chain:v4i16 458:iPTR, VR64:v4i16:$src1, VR64:v4i16:$src2)
                // Dst: (MMX_PADDSWrr:v4i16 VR64:v4i16:$src1, VR64:v4i16:$src2)
/*33799*/     0, /*End of Scope*/
/*33800*/   /*Scope*/ 106, /*->33907*/
/*33801*/     OPC_CheckInteger, 75|128,3/*459*/, 
/*33804*/     OPC_MoveParent,
/*33805*/     OPC_Scope, 42, /*->33849*/ // 3 children in Scope
/*33807*/       OPC_RecordChild1, // #0 = $src1
/*33808*/       OPC_MoveChild, 2,
/*33810*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*33812*/       OPC_MoveChild, 0,
/*33814*/       OPC_CheckOpcode, ISD::LOAD,
/*33816*/       OPC_RecordMemRef,
/*33817*/       OPC_RecordNode, // #1 = 'ld' chained node
/*33818*/       OPC_CheckFoldableChainNode,
/*33819*/       OPC_RecordChild1, // #2 = $src2
/*33820*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*33822*/       OPC_CheckPredicate, 8, // Predicate_load
/*33824*/       OPC_CheckType, MVT::v1i64,
/*33826*/       OPC_MoveParent,
/*33827*/       OPC_MoveParent,
/*33828*/       OPC_CheckPatternPredicate, 8, // (Subtarget->hasMMX())
/*33830*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*33833*/       OPC_EmitMergeInputChains, 1, 1, 
/*33836*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PADDUSBrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v8i8, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (intrinsic_wo_chain:v8i8 459:iPTR, VR64:v8i8:$src1, (bitconvert:v8i8 (ld:v1i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>))
                // Dst: (MMX_PADDUSBrm:v8i8 VR64:v8i8:$src1, addr:iPTR:$src2)
/*33849*/     /*Scope*/ 42, /*->33892*/
/*33850*/       OPC_MoveChild, 1,
/*33852*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*33854*/       OPC_MoveChild, 0,
/*33856*/       OPC_CheckOpcode, ISD::LOAD,
/*33858*/       OPC_RecordMemRef,
/*33859*/       OPC_RecordNode, // #0 = 'ld' chained node
/*33860*/       OPC_CheckFoldableChainNode,
/*33861*/       OPC_RecordChild1, // #1 = $src2
/*33862*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*33864*/       OPC_CheckPredicate, 8, // Predicate_load
/*33866*/       OPC_CheckType, MVT::v1i64,
/*33868*/       OPC_MoveParent,
/*33869*/       OPC_MoveParent,
/*33870*/       OPC_RecordChild2, // #2 = $src1
/*33871*/       OPC_CheckPatternPredicate, 8, // (Subtarget->hasMMX())
/*33873*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*33876*/       OPC_EmitMergeInputChains, 1, 0, 
/*33879*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PADDUSBrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v8i8, 6/*#Ops*/, 2, 3, 4, 5, 6, 7, 
                // Src: (intrinsic_wo_chain:v8i8 459:iPTR, (bitconvert:v8i8 (ld:v1i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>), VR64:v8i8:$src1)
                // Dst: (MMX_PADDUSBrm:v8i8 VR64:v8i8:$src1, addr:iPTR:$src2)
/*33892*/     /*Scope*/ 13, /*->33906*/
/*33893*/       OPC_RecordChild1, // #0 = $src1
/*33894*/       OPC_RecordChild2, // #1 = $src2
/*33895*/       OPC_CheckPatternPredicate, 8, // (Subtarget->hasMMX())
/*33897*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PADDUSBrr), 0,
                    1/*#VTs*/, MVT::v8i8, 2/*#Ops*/, 0, 1, 
                // Src: (intrinsic_wo_chain:v8i8 459:iPTR, VR64:v8i8:$src1, VR64:v8i8:$src2)
                // Dst: (MMX_PADDUSBrr:v8i8 VR64:v8i8:$src1, VR64:v8i8:$src2)
/*33906*/     0, /*End of Scope*/
/*33907*/   /*Scope*/ 106, /*->34014*/
/*33908*/     OPC_CheckInteger, 76|128,3/*460*/, 
/*33911*/     OPC_MoveParent,
/*33912*/     OPC_Scope, 42, /*->33956*/ // 3 children in Scope
/*33914*/       OPC_RecordChild1, // #0 = $src1
/*33915*/       OPC_MoveChild, 2,
/*33917*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*33919*/       OPC_MoveChild, 0,
/*33921*/       OPC_CheckOpcode, ISD::LOAD,
/*33923*/       OPC_RecordMemRef,
/*33924*/       OPC_RecordNode, // #1 = 'ld' chained node
/*33925*/       OPC_CheckFoldableChainNode,
/*33926*/       OPC_RecordChild1, // #2 = $src2
/*33927*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*33929*/       OPC_CheckPredicate, 8, // Predicate_load
/*33931*/       OPC_CheckType, MVT::v1i64,
/*33933*/       OPC_MoveParent,
/*33934*/       OPC_MoveParent,
/*33935*/       OPC_CheckPatternPredicate, 8, // (Subtarget->hasMMX())
/*33937*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*33940*/       OPC_EmitMergeInputChains, 1, 1, 
/*33943*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PADDUSWrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v4i16, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (intrinsic_wo_chain:v4i16 460:iPTR, VR64:v4i16:$src1, (bitconvert:v4i16 (ld:v1i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>))
                // Dst: (MMX_PADDUSWrm:v4i16 VR64:v4i16:$src1, addr:iPTR:$src2)
/*33956*/     /*Scope*/ 42, /*->33999*/
/*33957*/       OPC_MoveChild, 1,
/*33959*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*33961*/       OPC_MoveChild, 0,
/*33963*/       OPC_CheckOpcode, ISD::LOAD,
/*33965*/       OPC_RecordMemRef,
/*33966*/       OPC_RecordNode, // #0 = 'ld' chained node
/*33967*/       OPC_CheckFoldableChainNode,
/*33968*/       OPC_RecordChild1, // #1 = $src2
/*33969*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*33971*/       OPC_CheckPredicate, 8, // Predicate_load
/*33973*/       OPC_CheckType, MVT::v1i64,
/*33975*/       OPC_MoveParent,
/*33976*/       OPC_MoveParent,
/*33977*/       OPC_RecordChild2, // #2 = $src1
/*33978*/       OPC_CheckPatternPredicate, 8, // (Subtarget->hasMMX())
/*33980*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*33983*/       OPC_EmitMergeInputChains, 1, 0, 
/*33986*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PADDUSWrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v4i16, 6/*#Ops*/, 2, 3, 4, 5, 6, 7, 
                // Src: (intrinsic_wo_chain:v4i16 460:iPTR, (bitconvert:v4i16 (ld:v1i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>), VR64:v4i16:$src1)
                // Dst: (MMX_PADDUSWrm:v4i16 VR64:v4i16:$src1, addr:iPTR:$src2)
/*33999*/     /*Scope*/ 13, /*->34013*/
/*34000*/       OPC_RecordChild1, // #0 = $src1
/*34001*/       OPC_RecordChild2, // #1 = $src2
/*34002*/       OPC_CheckPatternPredicate, 8, // (Subtarget->hasMMX())
/*34004*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PADDUSWrr), 0,
                    1/*#VTs*/, MVT::v4i16, 2/*#Ops*/, 0, 1, 
                // Src: (intrinsic_wo_chain:v4i16 460:iPTR, VR64:v4i16:$src1, VR64:v4i16:$src2)
                // Dst: (MMX_PADDUSWrr:v4i16 VR64:v4i16:$src1, VR64:v4i16:$src2)
/*34013*/     0, /*End of Scope*/
/*34014*/   /*Scope*/ 62, /*->34077*/
/*34015*/     OPC_CheckInteger, 111|128,3/*495*/, 
/*34018*/     OPC_MoveParent,
/*34019*/     OPC_RecordChild1, // #0 = $src1
/*34020*/     OPC_Scope, 41, /*->34063*/ // 2 children in Scope
/*34022*/       OPC_MoveChild, 2,
/*34024*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*34026*/       OPC_MoveChild, 0,
/*34028*/       OPC_CheckOpcode, ISD::LOAD,
/*34030*/       OPC_RecordMemRef,
/*34031*/       OPC_RecordNode, // #1 = 'ld' chained node
/*34032*/       OPC_CheckFoldableChainNode,
/*34033*/       OPC_RecordChild1, // #2 = $src2
/*34034*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*34036*/       OPC_CheckPredicate, 8, // Predicate_load
/*34038*/       OPC_CheckType, MVT::v1i64,
/*34040*/       OPC_MoveParent,
/*34041*/       OPC_MoveParent,
/*34042*/       OPC_CheckPatternPredicate, 8, // (Subtarget->hasMMX())
/*34044*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*34047*/       OPC_EmitMergeInputChains, 1, 1, 
/*34050*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PSUBSBrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v8i8, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (intrinsic_wo_chain:v8i8 495:iPTR, VR64:v8i8:$src1, (bitconvert:v8i8 (ld:v1i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>))
                // Dst: (MMX_PSUBSBrm:v8i8 VR64:v8i8:$src1, addr:iPTR:$src2)
/*34063*/     /*Scope*/ 12, /*->34076*/
/*34064*/       OPC_RecordChild2, // #1 = $src2
/*34065*/       OPC_CheckPatternPredicate, 8, // (Subtarget->hasMMX())
/*34067*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PSUBSBrr), 0,
                    1/*#VTs*/, MVT::v8i8, 2/*#Ops*/, 0, 1, 
                // Src: (intrinsic_wo_chain:v8i8 495:iPTR, VR64:v8i8:$src1, VR64:v8i8:$src2)
                // Dst: (MMX_PSUBSBrr:v8i8 VR64:v8i8:$src1, VR64:v8i8:$src2)
/*34076*/     0, /*End of Scope*/
/*34077*/   /*Scope*/ 62, /*->34140*/
/*34078*/     OPC_CheckInteger, 112|128,3/*496*/, 
/*34081*/     OPC_MoveParent,
/*34082*/     OPC_RecordChild1, // #0 = $src1
/*34083*/     OPC_Scope, 41, /*->34126*/ // 2 children in Scope
/*34085*/       OPC_MoveChild, 2,
/*34087*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*34089*/       OPC_MoveChild, 0,
/*34091*/       OPC_CheckOpcode, ISD::LOAD,
/*34093*/       OPC_RecordMemRef,
/*34094*/       OPC_RecordNode, // #1 = 'ld' chained node
/*34095*/       OPC_CheckFoldableChainNode,
/*34096*/       OPC_RecordChild1, // #2 = $src2
/*34097*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*34099*/       OPC_CheckPredicate, 8, // Predicate_load
/*34101*/       OPC_CheckType, MVT::v1i64,
/*34103*/       OPC_MoveParent,
/*34104*/       OPC_MoveParent,
/*34105*/       OPC_CheckPatternPredicate, 8, // (Subtarget->hasMMX())
/*34107*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*34110*/       OPC_EmitMergeInputChains, 1, 1, 
/*34113*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PSUBSWrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v4i16, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (intrinsic_wo_chain:v4i16 496:iPTR, VR64:v4i16:$src1, (bitconvert:v4i16 (ld:v1i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>))
                // Dst: (MMX_PSUBSWrm:v4i16 VR64:v4i16:$src1, addr:iPTR:$src2)
/*34126*/     /*Scope*/ 12, /*->34139*/
/*34127*/       OPC_RecordChild2, // #1 = $src2
/*34128*/       OPC_CheckPatternPredicate, 8, // (Subtarget->hasMMX())
/*34130*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PSUBSWrr), 0,
                    1/*#VTs*/, MVT::v4i16, 2/*#Ops*/, 0, 1, 
                // Src: (intrinsic_wo_chain:v4i16 496:iPTR, VR64:v4i16:$src1, VR64:v4i16:$src2)
                // Dst: (MMX_PSUBSWrr:v4i16 VR64:v4i16:$src1, VR64:v4i16:$src2)
/*34139*/     0, /*End of Scope*/
/*34140*/   /*Scope*/ 62, /*->34203*/
/*34141*/     OPC_CheckInteger, 113|128,3/*497*/, 
/*34144*/     OPC_MoveParent,
/*34145*/     OPC_RecordChild1, // #0 = $src1
/*34146*/     OPC_Scope, 41, /*->34189*/ // 2 children in Scope
/*34148*/       OPC_MoveChild, 2,
/*34150*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*34152*/       OPC_MoveChild, 0,
/*34154*/       OPC_CheckOpcode, ISD::LOAD,
/*34156*/       OPC_RecordMemRef,
/*34157*/       OPC_RecordNode, // #1 = 'ld' chained node
/*34158*/       OPC_CheckFoldableChainNode,
/*34159*/       OPC_RecordChild1, // #2 = $src2
/*34160*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*34162*/       OPC_CheckPredicate, 8, // Predicate_load
/*34164*/       OPC_CheckType, MVT::v1i64,
/*34166*/       OPC_MoveParent,
/*34167*/       OPC_MoveParent,
/*34168*/       OPC_CheckPatternPredicate, 8, // (Subtarget->hasMMX())
/*34170*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*34173*/       OPC_EmitMergeInputChains, 1, 1, 
/*34176*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PSUBUSBrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v8i8, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (intrinsic_wo_chain:v8i8 497:iPTR, VR64:v8i8:$src1, (bitconvert:v8i8 (ld:v1i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>))
                // Dst: (MMX_PSUBUSBrm:v8i8 VR64:v8i8:$src1, addr:iPTR:$src2)
/*34189*/     /*Scope*/ 12, /*->34202*/
/*34190*/       OPC_RecordChild2, // #1 = $src2
/*34191*/       OPC_CheckPatternPredicate, 8, // (Subtarget->hasMMX())
/*34193*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PSUBUSBrr), 0,
                    1/*#VTs*/, MVT::v8i8, 2/*#Ops*/, 0, 1, 
                // Src: (intrinsic_wo_chain:v8i8 497:iPTR, VR64:v8i8:$src1, VR64:v8i8:$src2)
                // Dst: (MMX_PSUBUSBrr:v8i8 VR64:v8i8:$src1, VR64:v8i8:$src2)
/*34202*/     0, /*End of Scope*/
/*34203*/   /*Scope*/ 62, /*->34266*/
/*34204*/     OPC_CheckInteger, 114|128,3/*498*/, 
/*34207*/     OPC_MoveParent,
/*34208*/     OPC_RecordChild1, // #0 = $src1
/*34209*/     OPC_Scope, 41, /*->34252*/ // 2 children in Scope
/*34211*/       OPC_MoveChild, 2,
/*34213*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*34215*/       OPC_MoveChild, 0,
/*34217*/       OPC_CheckOpcode, ISD::LOAD,
/*34219*/       OPC_RecordMemRef,
/*34220*/       OPC_RecordNode, // #1 = 'ld' chained node
/*34221*/       OPC_CheckFoldableChainNode,
/*34222*/       OPC_RecordChild1, // #2 = $src2
/*34223*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*34225*/       OPC_CheckPredicate, 8, // Predicate_load
/*34227*/       OPC_CheckType, MVT::v1i64,
/*34229*/       OPC_MoveParent,
/*34230*/       OPC_MoveParent,
/*34231*/       OPC_CheckPatternPredicate, 8, // (Subtarget->hasMMX())
/*34233*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*34236*/       OPC_EmitMergeInputChains, 1, 1, 
/*34239*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PSUBUSWrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v4i16, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (intrinsic_wo_chain:v4i16 498:iPTR, VR64:v4i16:$src1, (bitconvert:v4i16 (ld:v1i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>))
                // Dst: (MMX_PSUBUSWrm:v4i16 VR64:v4i16:$src1, addr:iPTR:$src2)
/*34252*/     /*Scope*/ 12, /*->34265*/
/*34253*/       OPC_RecordChild2, // #1 = $src2
/*34254*/       OPC_CheckPatternPredicate, 8, // (Subtarget->hasMMX())
/*34256*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PSUBUSWrr), 0,
                    1/*#VTs*/, MVT::v4i16, 2/*#Ops*/, 0, 1, 
                // Src: (intrinsic_wo_chain:v4i16 498:iPTR, VR64:v4i16:$src1, VR64:v4i16:$src2)
                // Dst: (MMX_PSUBUSWrr:v4i16 VR64:v4i16:$src1, VR64:v4i16:$src2)
/*34265*/     0, /*End of Scope*/
/*34266*/   /*Scope*/ 106, /*->34373*/
/*34267*/     OPC_CheckInteger, 91|128,3/*475*/, 
/*34270*/     OPC_MoveParent,
/*34271*/     OPC_Scope, 42, /*->34315*/ // 3 children in Scope
/*34273*/       OPC_RecordChild1, // #0 = $src1
/*34274*/       OPC_MoveChild, 2,
/*34276*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*34278*/       OPC_MoveChild, 0,
/*34280*/       OPC_CheckOpcode, ISD::LOAD,
/*34282*/       OPC_RecordMemRef,
/*34283*/       OPC_RecordNode, // #1 = 'ld' chained node
/*34284*/       OPC_CheckFoldableChainNode,
/*34285*/       OPC_RecordChild1, // #2 = $src2
/*34286*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*34288*/       OPC_CheckPredicate, 8, // Predicate_load
/*34290*/       OPC_CheckType, MVT::v1i64,
/*34292*/       OPC_MoveParent,
/*34293*/       OPC_MoveParent,
/*34294*/       OPC_CheckPatternPredicate, 8, // (Subtarget->hasMMX())
/*34296*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*34299*/       OPC_EmitMergeInputChains, 1, 1, 
/*34302*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PMULHWrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v4i16, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (intrinsic_wo_chain:v4i16 475:iPTR, VR64:v4i16:$src1, (bitconvert:v4i16 (ld:v1i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>))
                // Dst: (MMX_PMULHWrm:v4i16 VR64:v4i16:$src1, addr:iPTR:$src2)
/*34315*/     /*Scope*/ 42, /*->34358*/
/*34316*/       OPC_MoveChild, 1,
/*34318*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*34320*/       OPC_MoveChild, 0,
/*34322*/       OPC_CheckOpcode, ISD::LOAD,
/*34324*/       OPC_RecordMemRef,
/*34325*/       OPC_RecordNode, // #0 = 'ld' chained node
/*34326*/       OPC_CheckFoldableChainNode,
/*34327*/       OPC_RecordChild1, // #1 = $src2
/*34328*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*34330*/       OPC_CheckPredicate, 8, // Predicate_load
/*34332*/       OPC_CheckType, MVT::v1i64,
/*34334*/       OPC_MoveParent,
/*34335*/       OPC_MoveParent,
/*34336*/       OPC_RecordChild2, // #2 = $src1
/*34337*/       OPC_CheckPatternPredicate, 8, // (Subtarget->hasMMX())
/*34339*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*34342*/       OPC_EmitMergeInputChains, 1, 0, 
/*34345*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PMULHWrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v4i16, 6/*#Ops*/, 2, 3, 4, 5, 6, 7, 
                // Src: (intrinsic_wo_chain:v4i16 475:iPTR, (bitconvert:v4i16 (ld:v1i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>), VR64:v4i16:$src1)
                // Dst: (MMX_PMULHWrm:v4i16 VR64:v4i16:$src1, addr:iPTR:$src2)
/*34358*/     /*Scope*/ 13, /*->34372*/
/*34359*/       OPC_RecordChild1, // #0 = $src1
/*34360*/       OPC_RecordChild2, // #1 = $src2
/*34361*/       OPC_CheckPatternPredicate, 8, // (Subtarget->hasMMX())
/*34363*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PMULHWrr), 0,
                    1/*#VTs*/, MVT::v4i16, 2/*#Ops*/, 0, 1, 
                // Src: (intrinsic_wo_chain:v4i16 475:iPTR, VR64:v4i16:$src1, VR64:v4i16:$src2)
                // Dst: (MMX_PMULHWrr:v4i16 VR64:v4i16:$src1, VR64:v4i16:$src2)
/*34372*/     0, /*End of Scope*/
/*34373*/   /*Scope*/ 106, /*->34480*/
/*34374*/     OPC_CheckInteger, 92|128,3/*476*/, 
/*34377*/     OPC_MoveParent,
/*34378*/     OPC_Scope, 42, /*->34422*/ // 3 children in Scope
/*34380*/       OPC_RecordChild1, // #0 = $src1
/*34381*/       OPC_MoveChild, 2,
/*34383*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*34385*/       OPC_MoveChild, 0,
/*34387*/       OPC_CheckOpcode, ISD::LOAD,
/*34389*/       OPC_RecordMemRef,
/*34390*/       OPC_RecordNode, // #1 = 'ld' chained node
/*34391*/       OPC_CheckFoldableChainNode,
/*34392*/       OPC_RecordChild1, // #2 = $src2
/*34393*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*34395*/       OPC_CheckPredicate, 8, // Predicate_load
/*34397*/       OPC_CheckType, MVT::v1i64,
/*34399*/       OPC_MoveParent,
/*34400*/       OPC_MoveParent,
/*34401*/       OPC_CheckPatternPredicate, 8, // (Subtarget->hasMMX())
/*34403*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*34406*/       OPC_EmitMergeInputChains, 1, 1, 
/*34409*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PMULHUWrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v4i16, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (intrinsic_wo_chain:v4i16 476:iPTR, VR64:v4i16:$src1, (bitconvert:v4i16 (ld:v1i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>))
                // Dst: (MMX_PMULHUWrm:v4i16 VR64:v4i16:$src1, addr:iPTR:$src2)
/*34422*/     /*Scope*/ 42, /*->34465*/
/*34423*/       OPC_MoveChild, 1,
/*34425*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*34427*/       OPC_MoveChild, 0,
/*34429*/       OPC_CheckOpcode, ISD::LOAD,
/*34431*/       OPC_RecordMemRef,
/*34432*/       OPC_RecordNode, // #0 = 'ld' chained node
/*34433*/       OPC_CheckFoldableChainNode,
/*34434*/       OPC_RecordChild1, // #1 = $src2
/*34435*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*34437*/       OPC_CheckPredicate, 8, // Predicate_load
/*34439*/       OPC_CheckType, MVT::v1i64,
/*34441*/       OPC_MoveParent,
/*34442*/       OPC_MoveParent,
/*34443*/       OPC_RecordChild2, // #2 = $src1
/*34444*/       OPC_CheckPatternPredicate, 8, // (Subtarget->hasMMX())
/*34446*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*34449*/       OPC_EmitMergeInputChains, 1, 0, 
/*34452*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PMULHUWrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v4i16, 6/*#Ops*/, 2, 3, 4, 5, 6, 7, 
                // Src: (intrinsic_wo_chain:v4i16 476:iPTR, (bitconvert:v4i16 (ld:v1i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>), VR64:v4i16:$src1)
                // Dst: (MMX_PMULHUWrm:v4i16 VR64:v4i16:$src1, addr:iPTR:$src2)
/*34465*/     /*Scope*/ 13, /*->34479*/
/*34466*/       OPC_RecordChild1, // #0 = $src1
/*34467*/       OPC_RecordChild2, // #1 = $src2
/*34468*/       OPC_CheckPatternPredicate, 8, // (Subtarget->hasMMX())
/*34470*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PMULHUWrr), 0,
                    1/*#VTs*/, MVT::v4i16, 2/*#Ops*/, 0, 1, 
                // Src: (intrinsic_wo_chain:v4i16 476:iPTR, VR64:v4i16:$src1, VR64:v4i16:$src2)
                // Dst: (MMX_PMULHUWrr:v4i16 VR64:v4i16:$src1, VR64:v4i16:$src2)
/*34479*/     0, /*End of Scope*/
/*34480*/   /*Scope*/ 106, /*->34587*/
/*34481*/     OPC_CheckInteger, 93|128,3/*477*/, 
/*34484*/     OPC_MoveParent,
/*34485*/     OPC_Scope, 42, /*->34529*/ // 3 children in Scope
/*34487*/       OPC_RecordChild1, // #0 = $src1
/*34488*/       OPC_MoveChild, 2,
/*34490*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*34492*/       OPC_MoveChild, 0,
/*34494*/       OPC_CheckOpcode, ISD::LOAD,
/*34496*/       OPC_RecordMemRef,
/*34497*/       OPC_RecordNode, // #1 = 'ld' chained node
/*34498*/       OPC_CheckFoldableChainNode,
/*34499*/       OPC_RecordChild1, // #2 = $src2
/*34500*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*34502*/       OPC_CheckPredicate, 8, // Predicate_load
/*34504*/       OPC_CheckType, MVT::v1i64,
/*34506*/       OPC_MoveParent,
/*34507*/       OPC_MoveParent,
/*34508*/       OPC_CheckPatternPredicate, 8, // (Subtarget->hasMMX())
/*34510*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*34513*/       OPC_EmitMergeInputChains, 1, 1, 
/*34516*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PMULUDQrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v2i32, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (intrinsic_wo_chain:v2i32 477:iPTR, VR64:v2i32:$src1, (bitconvert:v2i32 (ld:v1i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>))
                // Dst: (MMX_PMULUDQrm:v2i32 VR64:v2i32:$src1, addr:iPTR:$src2)
/*34529*/     /*Scope*/ 42, /*->34572*/
/*34530*/       OPC_MoveChild, 1,
/*34532*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*34534*/       OPC_MoveChild, 0,
/*34536*/       OPC_CheckOpcode, ISD::LOAD,
/*34538*/       OPC_RecordMemRef,
/*34539*/       OPC_RecordNode, // #0 = 'ld' chained node
/*34540*/       OPC_CheckFoldableChainNode,
/*34541*/       OPC_RecordChild1, // #1 = $src2
/*34542*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*34544*/       OPC_CheckPredicate, 8, // Predicate_load
/*34546*/       OPC_CheckType, MVT::v1i64,
/*34548*/       OPC_MoveParent,
/*34549*/       OPC_MoveParent,
/*34550*/       OPC_RecordChild2, // #2 = $src1
/*34551*/       OPC_CheckPatternPredicate, 8, // (Subtarget->hasMMX())
/*34553*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*34556*/       OPC_EmitMergeInputChains, 1, 0, 
/*34559*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PMULUDQrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v2i32, 6/*#Ops*/, 2, 3, 4, 5, 6, 7, 
                // Src: (intrinsic_wo_chain:v2i32 477:iPTR, (bitconvert:v2i32 (ld:v1i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>), VR64:v2i32:$src1)
                // Dst: (MMX_PMULUDQrm:v2i32 VR64:v2i32:$src1, addr:iPTR:$src2)
/*34572*/     /*Scope*/ 13, /*->34586*/
/*34573*/       OPC_RecordChild1, // #0 = $src1
/*34574*/       OPC_RecordChild2, // #1 = $src2
/*34575*/       OPC_CheckPatternPredicate, 8, // (Subtarget->hasMMX())
/*34577*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PMULUDQrr), 0,
                    1/*#VTs*/, MVT::v2i32, 2/*#Ops*/, 0, 1, 
                // Src: (intrinsic_wo_chain:v2i32 477:iPTR, VR64:v2i32:$src1, VR64:v2i32:$src2)
                // Dst: (MMX_PMULUDQrr:v2i32 VR64:v2i32:$src1, VR64:v2i32:$src2)
/*34586*/     0, /*End of Scope*/
/*34587*/   /*Scope*/ 106, /*->34694*/
/*34588*/     OPC_CheckInteger, 85|128,3/*469*/, 
/*34591*/     OPC_MoveParent,
/*34592*/     OPC_Scope, 42, /*->34636*/ // 3 children in Scope
/*34594*/       OPC_RecordChild1, // #0 = $src1
/*34595*/       OPC_MoveChild, 2,
/*34597*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*34599*/       OPC_MoveChild, 0,
/*34601*/       OPC_CheckOpcode, ISD::LOAD,
/*34603*/       OPC_RecordMemRef,
/*34604*/       OPC_RecordNode, // #1 = 'ld' chained node
/*34605*/       OPC_CheckFoldableChainNode,
/*34606*/       OPC_RecordChild1, // #2 = $src2
/*34607*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*34609*/       OPC_CheckPredicate, 8, // Predicate_load
/*34611*/       OPC_CheckType, MVT::v1i64,
/*34613*/       OPC_MoveParent,
/*34614*/       OPC_MoveParent,
/*34615*/       OPC_CheckPatternPredicate, 8, // (Subtarget->hasMMX())
/*34617*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*34620*/       OPC_EmitMergeInputChains, 1, 1, 
/*34623*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PMADDWDrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v2i32, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (intrinsic_wo_chain:v2i32 469:iPTR, VR64:v4i16:$src1, (bitconvert:v4i16 (ld:v1i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>))
                // Dst: (MMX_PMADDWDrm:v2i32 VR64:v4i16:$src1, addr:iPTR:$src2)
/*34636*/     /*Scope*/ 42, /*->34679*/
/*34637*/       OPC_MoveChild, 1,
/*34639*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*34641*/       OPC_MoveChild, 0,
/*34643*/       OPC_CheckOpcode, ISD::LOAD,
/*34645*/       OPC_RecordMemRef,
/*34646*/       OPC_RecordNode, // #0 = 'ld' chained node
/*34647*/       OPC_CheckFoldableChainNode,
/*34648*/       OPC_RecordChild1, // #1 = $src2
/*34649*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*34651*/       OPC_CheckPredicate, 8, // Predicate_load
/*34653*/       OPC_CheckType, MVT::v1i64,
/*34655*/       OPC_MoveParent,
/*34656*/       OPC_MoveParent,
/*34657*/       OPC_RecordChild2, // #2 = $src1
/*34658*/       OPC_CheckPatternPredicate, 8, // (Subtarget->hasMMX())
/*34660*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*34663*/       OPC_EmitMergeInputChains, 1, 0, 
/*34666*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PMADDWDrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v2i32, 6/*#Ops*/, 2, 3, 4, 5, 6, 7, 
                // Src: (intrinsic_wo_chain:v2i32 469:iPTR, (bitconvert:v4i16 (ld:v1i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>), VR64:v4i16:$src1)
                // Dst: (MMX_PMADDWDrm:v2i32 VR64:v4i16:$src1, addr:iPTR:$src2)
/*34679*/     /*Scope*/ 13, /*->34693*/
/*34680*/       OPC_RecordChild1, // #0 = $src1
/*34681*/       OPC_RecordChild2, // #1 = $src2
/*34682*/       OPC_CheckPatternPredicate, 8, // (Subtarget->hasMMX())
/*34684*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PMADDWDrr), 0,
                    1/*#VTs*/, MVT::v2i32, 2/*#Ops*/, 0, 1, 
                // Src: (intrinsic_wo_chain:v2i32 469:iPTR, VR64:v4i16:$src1, VR64:v4i16:$src2)
                // Dst: (MMX_PMADDWDrr:v2i32 VR64:v4i16:$src1, VR64:v4i16:$src2)
/*34693*/     0, /*End of Scope*/
/*34694*/   /*Scope*/ 106, /*->34801*/
/*34695*/     OPC_CheckInteger, 77|128,3/*461*/, 
/*34698*/     OPC_MoveParent,
/*34699*/     OPC_Scope, 42, /*->34743*/ // 3 children in Scope
/*34701*/       OPC_RecordChild1, // #0 = $src1
/*34702*/       OPC_MoveChild, 2,
/*34704*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*34706*/       OPC_MoveChild, 0,
/*34708*/       OPC_CheckOpcode, ISD::LOAD,
/*34710*/       OPC_RecordMemRef,
/*34711*/       OPC_RecordNode, // #1 = 'ld' chained node
/*34712*/       OPC_CheckFoldableChainNode,
/*34713*/       OPC_RecordChild1, // #2 = $src2
/*34714*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*34716*/       OPC_CheckPredicate, 8, // Predicate_load
/*34718*/       OPC_CheckType, MVT::v1i64,
/*34720*/       OPC_MoveParent,
/*34721*/       OPC_MoveParent,
/*34722*/       OPC_CheckPatternPredicate, 8, // (Subtarget->hasMMX())
/*34724*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*34727*/       OPC_EmitMergeInputChains, 1, 1, 
/*34730*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PAVGBrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v8i8, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (intrinsic_wo_chain:v8i8 461:iPTR, VR64:v8i8:$src1, (bitconvert:v8i8 (ld:v1i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>))
                // Dst: (MMX_PAVGBrm:v8i8 VR64:v8i8:$src1, addr:iPTR:$src2)
/*34743*/     /*Scope*/ 42, /*->34786*/
/*34744*/       OPC_MoveChild, 1,
/*34746*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*34748*/       OPC_MoveChild, 0,
/*34750*/       OPC_CheckOpcode, ISD::LOAD,
/*34752*/       OPC_RecordMemRef,
/*34753*/       OPC_RecordNode, // #0 = 'ld' chained node
/*34754*/       OPC_CheckFoldableChainNode,
/*34755*/       OPC_RecordChild1, // #1 = $src2
/*34756*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*34758*/       OPC_CheckPredicate, 8, // Predicate_load
/*34760*/       OPC_CheckType, MVT::v1i64,
/*34762*/       OPC_MoveParent,
/*34763*/       OPC_MoveParent,
/*34764*/       OPC_RecordChild2, // #2 = $src1
/*34765*/       OPC_CheckPatternPredicate, 8, // (Subtarget->hasMMX())
/*34767*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*34770*/       OPC_EmitMergeInputChains, 1, 0, 
/*34773*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PAVGBrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v8i8, 6/*#Ops*/, 2, 3, 4, 5, 6, 7, 
                // Src: (intrinsic_wo_chain:v8i8 461:iPTR, (bitconvert:v8i8 (ld:v1i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>), VR64:v8i8:$src1)
                // Dst: (MMX_PAVGBrm:v8i8 VR64:v8i8:$src1, addr:iPTR:$src2)
/*34786*/     /*Scope*/ 13, /*->34800*/
/*34787*/       OPC_RecordChild1, // #0 = $src1
/*34788*/       OPC_RecordChild2, // #1 = $src2
/*34789*/       OPC_CheckPatternPredicate, 8, // (Subtarget->hasMMX())
/*34791*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PAVGBrr), 0,
                    1/*#VTs*/, MVT::v8i8, 2/*#Ops*/, 0, 1, 
                // Src: (intrinsic_wo_chain:v8i8 461:iPTR, VR64:v8i8:$src1, VR64:v8i8:$src2)
                // Dst: (MMX_PAVGBrr:v8i8 VR64:v8i8:$src1, VR64:v8i8:$src2)
/*34800*/     0, /*End of Scope*/
/*34801*/   /*Scope*/ 106, /*->34908*/
/*34802*/     OPC_CheckInteger, 78|128,3/*462*/, 
/*34805*/     OPC_MoveParent,
/*34806*/     OPC_Scope, 42, /*->34850*/ // 3 children in Scope
/*34808*/       OPC_RecordChild1, // #0 = $src1
/*34809*/       OPC_MoveChild, 2,
/*34811*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*34813*/       OPC_MoveChild, 0,
/*34815*/       OPC_CheckOpcode, ISD::LOAD,
/*34817*/       OPC_RecordMemRef,
/*34818*/       OPC_RecordNode, // #1 = 'ld' chained node
/*34819*/       OPC_CheckFoldableChainNode,
/*34820*/       OPC_RecordChild1, // #2 = $src2
/*34821*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*34823*/       OPC_CheckPredicate, 8, // Predicate_load
/*34825*/       OPC_CheckType, MVT::v1i64,
/*34827*/       OPC_MoveParent,
/*34828*/       OPC_MoveParent,
/*34829*/       OPC_CheckPatternPredicate, 8, // (Subtarget->hasMMX())
/*34831*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*34834*/       OPC_EmitMergeInputChains, 1, 1, 
/*34837*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PAVGWrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v4i16, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (intrinsic_wo_chain:v4i16 462:iPTR, VR64:v4i16:$src1, (bitconvert:v4i16 (ld:v1i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>))
                // Dst: (MMX_PAVGWrm:v4i16 VR64:v4i16:$src1, addr:iPTR:$src2)
/*34850*/     /*Scope*/ 42, /*->34893*/
/*34851*/       OPC_MoveChild, 1,
/*34853*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*34855*/       OPC_MoveChild, 0,
/*34857*/       OPC_CheckOpcode, ISD::LOAD,
/*34859*/       OPC_RecordMemRef,
/*34860*/       OPC_RecordNode, // #0 = 'ld' chained node
/*34861*/       OPC_CheckFoldableChainNode,
/*34862*/       OPC_RecordChild1, // #1 = $src2
/*34863*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*34865*/       OPC_CheckPredicate, 8, // Predicate_load
/*34867*/       OPC_CheckType, MVT::v1i64,
/*34869*/       OPC_MoveParent,
/*34870*/       OPC_MoveParent,
/*34871*/       OPC_RecordChild2, // #2 = $src1
/*34872*/       OPC_CheckPatternPredicate, 8, // (Subtarget->hasMMX())
/*34874*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*34877*/       OPC_EmitMergeInputChains, 1, 0, 
/*34880*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PAVGWrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v4i16, 6/*#Ops*/, 2, 3, 4, 5, 6, 7, 
                // Src: (intrinsic_wo_chain:v4i16 462:iPTR, (bitconvert:v4i16 (ld:v1i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>), VR64:v4i16:$src1)
                // Dst: (MMX_PAVGWrm:v4i16 VR64:v4i16:$src1, addr:iPTR:$src2)
/*34893*/     /*Scope*/ 13, /*->34907*/
/*34894*/       OPC_RecordChild1, // #0 = $src1
/*34895*/       OPC_RecordChild2, // #1 = $src2
/*34896*/       OPC_CheckPatternPredicate, 8, // (Subtarget->hasMMX())
/*34898*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PAVGWrr), 0,
                    1/*#VTs*/, MVT::v4i16, 2/*#Ops*/, 0, 1, 
                // Src: (intrinsic_wo_chain:v4i16 462:iPTR, VR64:v4i16:$src1, VR64:v4i16:$src2)
                // Dst: (MMX_PAVGWrr:v4i16 VR64:v4i16:$src1, VR64:v4i16:$src2)
/*34907*/     0, /*End of Scope*/
/*34908*/   /*Scope*/ 106, /*->35015*/
/*34909*/     OPC_CheckInteger, 89|128,3/*473*/, 
/*34912*/     OPC_MoveParent,
/*34913*/     OPC_Scope, 42, /*->34957*/ // 3 children in Scope
/*34915*/       OPC_RecordChild1, // #0 = $src1
/*34916*/       OPC_MoveChild, 2,
/*34918*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*34920*/       OPC_MoveChild, 0,
/*34922*/       OPC_CheckOpcode, ISD::LOAD,
/*34924*/       OPC_RecordMemRef,
/*34925*/       OPC_RecordNode, // #1 = 'ld' chained node
/*34926*/       OPC_CheckFoldableChainNode,
/*34927*/       OPC_RecordChild1, // #2 = $src2
/*34928*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*34930*/       OPC_CheckPredicate, 8, // Predicate_load
/*34932*/       OPC_CheckType, MVT::v1i64,
/*34934*/       OPC_MoveParent,
/*34935*/       OPC_MoveParent,
/*34936*/       OPC_CheckPatternPredicate, 8, // (Subtarget->hasMMX())
/*34938*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*34941*/       OPC_EmitMergeInputChains, 1, 1, 
/*34944*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PMINUBrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v8i8, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (intrinsic_wo_chain:v8i8 473:iPTR, VR64:v8i8:$src1, (bitconvert:v8i8 (ld:v1i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>))
                // Dst: (MMX_PMINUBrm:v8i8 VR64:v8i8:$src1, addr:iPTR:$src2)
/*34957*/     /*Scope*/ 42, /*->35000*/
/*34958*/       OPC_MoveChild, 1,
/*34960*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*34962*/       OPC_MoveChild, 0,
/*34964*/       OPC_CheckOpcode, ISD::LOAD,
/*34966*/       OPC_RecordMemRef,
/*34967*/       OPC_RecordNode, // #0 = 'ld' chained node
/*34968*/       OPC_CheckFoldableChainNode,
/*34969*/       OPC_RecordChild1, // #1 = $src2
/*34970*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*34972*/       OPC_CheckPredicate, 8, // Predicate_load
/*34974*/       OPC_CheckType, MVT::v1i64,
/*34976*/       OPC_MoveParent,
/*34977*/       OPC_MoveParent,
/*34978*/       OPC_RecordChild2, // #2 = $src1
/*34979*/       OPC_CheckPatternPredicate, 8, // (Subtarget->hasMMX())
/*34981*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*34984*/       OPC_EmitMergeInputChains, 1, 0, 
/*34987*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PMINUBrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v8i8, 6/*#Ops*/, 2, 3, 4, 5, 6, 7, 
                // Src: (intrinsic_wo_chain:v8i8 473:iPTR, (bitconvert:v8i8 (ld:v1i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>), VR64:v8i8:$src1)
                // Dst: (MMX_PMINUBrm:v8i8 VR64:v8i8:$src1, addr:iPTR:$src2)
/*35000*/     /*Scope*/ 13, /*->35014*/
/*35001*/       OPC_RecordChild1, // #0 = $src1
/*35002*/       OPC_RecordChild2, // #1 = $src2
/*35003*/       OPC_CheckPatternPredicate, 8, // (Subtarget->hasMMX())
/*35005*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PMINUBrr), 0,
                    1/*#VTs*/, MVT::v8i8, 2/*#Ops*/, 0, 1, 
                // Src: (intrinsic_wo_chain:v8i8 473:iPTR, VR64:v8i8:$src1, VR64:v8i8:$src2)
                // Dst: (MMX_PMINUBrr:v8i8 VR64:v8i8:$src1, VR64:v8i8:$src2)
/*35014*/     0, /*End of Scope*/
/*35015*/   /*Scope*/ 106, /*->35122*/
/*35016*/     OPC_CheckInteger, 88|128,3/*472*/, 
/*35019*/     OPC_MoveParent,
/*35020*/     OPC_Scope, 42, /*->35064*/ // 3 children in Scope
/*35022*/       OPC_RecordChild1, // #0 = $src1
/*35023*/       OPC_MoveChild, 2,
/*35025*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*35027*/       OPC_MoveChild, 0,
/*35029*/       OPC_CheckOpcode, ISD::LOAD,
/*35031*/       OPC_RecordMemRef,
/*35032*/       OPC_RecordNode, // #1 = 'ld' chained node
/*35033*/       OPC_CheckFoldableChainNode,
/*35034*/       OPC_RecordChild1, // #2 = $src2
/*35035*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*35037*/       OPC_CheckPredicate, 8, // Predicate_load
/*35039*/       OPC_CheckType, MVT::v1i64,
/*35041*/       OPC_MoveParent,
/*35042*/       OPC_MoveParent,
/*35043*/       OPC_CheckPatternPredicate, 8, // (Subtarget->hasMMX())
/*35045*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*35048*/       OPC_EmitMergeInputChains, 1, 1, 
/*35051*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PMINSWrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v4i16, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (intrinsic_wo_chain:v4i16 472:iPTR, VR64:v4i16:$src1, (bitconvert:v4i16 (ld:v1i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>))
                // Dst: (MMX_PMINSWrm:v4i16 VR64:v4i16:$src1, addr:iPTR:$src2)
/*35064*/     /*Scope*/ 42, /*->35107*/
/*35065*/       OPC_MoveChild, 1,
/*35067*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*35069*/       OPC_MoveChild, 0,
/*35071*/       OPC_CheckOpcode, ISD::LOAD,
/*35073*/       OPC_RecordMemRef,
/*35074*/       OPC_RecordNode, // #0 = 'ld' chained node
/*35075*/       OPC_CheckFoldableChainNode,
/*35076*/       OPC_RecordChild1, // #1 = $src2
/*35077*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*35079*/       OPC_CheckPredicate, 8, // Predicate_load
/*35081*/       OPC_CheckType, MVT::v1i64,
/*35083*/       OPC_MoveParent,
/*35084*/       OPC_MoveParent,
/*35085*/       OPC_RecordChild2, // #2 = $src1
/*35086*/       OPC_CheckPatternPredicate, 8, // (Subtarget->hasMMX())
/*35088*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*35091*/       OPC_EmitMergeInputChains, 1, 0, 
/*35094*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PMINSWrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v4i16, 6/*#Ops*/, 2, 3, 4, 5, 6, 7, 
                // Src: (intrinsic_wo_chain:v4i16 472:iPTR, (bitconvert:v4i16 (ld:v1i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>), VR64:v4i16:$src1)
                // Dst: (MMX_PMINSWrm:v4i16 VR64:v4i16:$src1, addr:iPTR:$src2)
/*35107*/     /*Scope*/ 13, /*->35121*/
/*35108*/       OPC_RecordChild1, // #0 = $src1
/*35109*/       OPC_RecordChild2, // #1 = $src2
/*35110*/       OPC_CheckPatternPredicate, 8, // (Subtarget->hasMMX())
/*35112*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PMINSWrr), 0,
                    1/*#VTs*/, MVT::v4i16, 2/*#Ops*/, 0, 1, 
                // Src: (intrinsic_wo_chain:v4i16 472:iPTR, VR64:v4i16:$src1, VR64:v4i16:$src2)
                // Dst: (MMX_PMINSWrr:v4i16 VR64:v4i16:$src1, VR64:v4i16:$src2)
/*35121*/     0, /*End of Scope*/
/*35122*/   /*Scope*/ 106, /*->35229*/
/*35123*/     OPC_CheckInteger, 87|128,3/*471*/, 
/*35126*/     OPC_MoveParent,
/*35127*/     OPC_Scope, 42, /*->35171*/ // 3 children in Scope
/*35129*/       OPC_RecordChild1, // #0 = $src1
/*35130*/       OPC_MoveChild, 2,
/*35132*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*35134*/       OPC_MoveChild, 0,
/*35136*/       OPC_CheckOpcode, ISD::LOAD,
/*35138*/       OPC_RecordMemRef,
/*35139*/       OPC_RecordNode, // #1 = 'ld' chained node
/*35140*/       OPC_CheckFoldableChainNode,
/*35141*/       OPC_RecordChild1, // #2 = $src2
/*35142*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*35144*/       OPC_CheckPredicate, 8, // Predicate_load
/*35146*/       OPC_CheckType, MVT::v1i64,
/*35148*/       OPC_MoveParent,
/*35149*/       OPC_MoveParent,
/*35150*/       OPC_CheckPatternPredicate, 8, // (Subtarget->hasMMX())
/*35152*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*35155*/       OPC_EmitMergeInputChains, 1, 1, 
/*35158*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PMAXUBrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v8i8, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (intrinsic_wo_chain:v8i8 471:iPTR, VR64:v8i8:$src1, (bitconvert:v8i8 (ld:v1i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>))
                // Dst: (MMX_PMAXUBrm:v8i8 VR64:v8i8:$src1, addr:iPTR:$src2)
/*35171*/     /*Scope*/ 42, /*->35214*/
/*35172*/       OPC_MoveChild, 1,
/*35174*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*35176*/       OPC_MoveChild, 0,
/*35178*/       OPC_CheckOpcode, ISD::LOAD,
/*35180*/       OPC_RecordMemRef,
/*35181*/       OPC_RecordNode, // #0 = 'ld' chained node
/*35182*/       OPC_CheckFoldableChainNode,
/*35183*/       OPC_RecordChild1, // #1 = $src2
/*35184*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*35186*/       OPC_CheckPredicate, 8, // Predicate_load
/*35188*/       OPC_CheckType, MVT::v1i64,
/*35190*/       OPC_MoveParent,
/*35191*/       OPC_MoveParent,
/*35192*/       OPC_RecordChild2, // #2 = $src1
/*35193*/       OPC_CheckPatternPredicate, 8, // (Subtarget->hasMMX())
/*35195*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*35198*/       OPC_EmitMergeInputChains, 1, 0, 
/*35201*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PMAXUBrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v8i8, 6/*#Ops*/, 2, 3, 4, 5, 6, 7, 
                // Src: (intrinsic_wo_chain:v8i8 471:iPTR, (bitconvert:v8i8 (ld:v1i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>), VR64:v8i8:$src1)
                // Dst: (MMX_PMAXUBrm:v8i8 VR64:v8i8:$src1, addr:iPTR:$src2)
/*35214*/     /*Scope*/ 13, /*->35228*/
/*35215*/       OPC_RecordChild1, // #0 = $src1
/*35216*/       OPC_RecordChild2, // #1 = $src2
/*35217*/       OPC_CheckPatternPredicate, 8, // (Subtarget->hasMMX())
/*35219*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PMAXUBrr), 0,
                    1/*#VTs*/, MVT::v8i8, 2/*#Ops*/, 0, 1, 
                // Src: (intrinsic_wo_chain:v8i8 471:iPTR, VR64:v8i8:$src1, VR64:v8i8:$src2)
                // Dst: (MMX_PMAXUBrr:v8i8 VR64:v8i8:$src1, VR64:v8i8:$src2)
/*35228*/     0, /*End of Scope*/
/*35229*/   /*Scope*/ 106, /*->35336*/
/*35230*/     OPC_CheckInteger, 86|128,3/*470*/, 
/*35233*/     OPC_MoveParent,
/*35234*/     OPC_Scope, 42, /*->35278*/ // 3 children in Scope
/*35236*/       OPC_RecordChild1, // #0 = $src1
/*35237*/       OPC_MoveChild, 2,
/*35239*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*35241*/       OPC_MoveChild, 0,
/*35243*/       OPC_CheckOpcode, ISD::LOAD,
/*35245*/       OPC_RecordMemRef,
/*35246*/       OPC_RecordNode, // #1 = 'ld' chained node
/*35247*/       OPC_CheckFoldableChainNode,
/*35248*/       OPC_RecordChild1, // #2 = $src2
/*35249*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*35251*/       OPC_CheckPredicate, 8, // Predicate_load
/*35253*/       OPC_CheckType, MVT::v1i64,
/*35255*/       OPC_MoveParent,
/*35256*/       OPC_MoveParent,
/*35257*/       OPC_CheckPatternPredicate, 8, // (Subtarget->hasMMX())
/*35259*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*35262*/       OPC_EmitMergeInputChains, 1, 1, 
/*35265*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PMAXSWrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v4i16, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (intrinsic_wo_chain:v4i16 470:iPTR, VR64:v4i16:$src1, (bitconvert:v4i16 (ld:v1i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>))
                // Dst: (MMX_PMAXSWrm:v4i16 VR64:v4i16:$src1, addr:iPTR:$src2)
/*35278*/     /*Scope*/ 42, /*->35321*/
/*35279*/       OPC_MoveChild, 1,
/*35281*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*35283*/       OPC_MoveChild, 0,
/*35285*/       OPC_CheckOpcode, ISD::LOAD,
/*35287*/       OPC_RecordMemRef,
/*35288*/       OPC_RecordNode, // #0 = 'ld' chained node
/*35289*/       OPC_CheckFoldableChainNode,
/*35290*/       OPC_RecordChild1, // #1 = $src2
/*35291*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*35293*/       OPC_CheckPredicate, 8, // Predicate_load
/*35295*/       OPC_CheckType, MVT::v1i64,
/*35297*/       OPC_MoveParent,
/*35298*/       OPC_MoveParent,
/*35299*/       OPC_RecordChild2, // #2 = $src1
/*35300*/       OPC_CheckPatternPredicate, 8, // (Subtarget->hasMMX())
/*35302*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*35305*/       OPC_EmitMergeInputChains, 1, 0, 
/*35308*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PMAXSWrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v4i16, 6/*#Ops*/, 2, 3, 4, 5, 6, 7, 
                // Src: (intrinsic_wo_chain:v4i16 470:iPTR, (bitconvert:v4i16 (ld:v1i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>), VR64:v4i16:$src1)
                // Dst: (MMX_PMAXSWrm:v4i16 VR64:v4i16:$src1, addr:iPTR:$src2)
/*35321*/     /*Scope*/ 13, /*->35335*/
/*35322*/       OPC_RecordChild1, // #0 = $src1
/*35323*/       OPC_RecordChild2, // #1 = $src2
/*35324*/       OPC_CheckPatternPredicate, 8, // (Subtarget->hasMMX())
/*35326*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PMAXSWrr), 0,
                    1/*#VTs*/, MVT::v4i16, 2/*#Ops*/, 0, 1, 
                // Src: (intrinsic_wo_chain:v4i16 470:iPTR, VR64:v4i16:$src1, VR64:v4i16:$src2)
                // Dst: (MMX_PMAXSWrr:v4i16 VR64:v4i16:$src1, VR64:v4i16:$src2)
/*35335*/     0, /*End of Scope*/
/*35336*/   /*Scope*/ 106, /*->35443*/
/*35337*/     OPC_CheckInteger, 94|128,3/*478*/, 
/*35340*/     OPC_MoveParent,
/*35341*/     OPC_Scope, 42, /*->35385*/ // 3 children in Scope
/*35343*/       OPC_RecordChild1, // #0 = $src1
/*35344*/       OPC_MoveChild, 2,
/*35346*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*35348*/       OPC_MoveChild, 0,
/*35350*/       OPC_CheckOpcode, ISD::LOAD,
/*35352*/       OPC_RecordMemRef,
/*35353*/       OPC_RecordNode, // #1 = 'ld' chained node
/*35354*/       OPC_CheckFoldableChainNode,
/*35355*/       OPC_RecordChild1, // #2 = $src2
/*35356*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*35358*/       OPC_CheckPredicate, 8, // Predicate_load
/*35360*/       OPC_CheckType, MVT::v1i64,
/*35362*/       OPC_MoveParent,
/*35363*/       OPC_MoveParent,
/*35364*/       OPC_CheckPatternPredicate, 8, // (Subtarget->hasMMX())
/*35366*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*35369*/       OPC_EmitMergeInputChains, 1, 1, 
/*35372*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PSADBWrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v4i16, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (intrinsic_wo_chain:v4i16 478:iPTR, VR64:v8i8:$src1, (bitconvert:v8i8 (ld:v1i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>))
                // Dst: (MMX_PSADBWrm:v4i16 VR64:v8i8:$src1, addr:iPTR:$src2)
/*35385*/     /*Scope*/ 42, /*->35428*/
/*35386*/       OPC_MoveChild, 1,
/*35388*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*35390*/       OPC_MoveChild, 0,
/*35392*/       OPC_CheckOpcode, ISD::LOAD,
/*35394*/       OPC_RecordMemRef,
/*35395*/       OPC_RecordNode, // #0 = 'ld' chained node
/*35396*/       OPC_CheckFoldableChainNode,
/*35397*/       OPC_RecordChild1, // #1 = $src2
/*35398*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*35400*/       OPC_CheckPredicate, 8, // Predicate_load
/*35402*/       OPC_CheckType, MVT::v1i64,
/*35404*/       OPC_MoveParent,
/*35405*/       OPC_MoveParent,
/*35406*/       OPC_RecordChild2, // #2 = $src1
/*35407*/       OPC_CheckPatternPredicate, 8, // (Subtarget->hasMMX())
/*35409*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*35412*/       OPC_EmitMergeInputChains, 1, 0, 
/*35415*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PSADBWrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v4i16, 6/*#Ops*/, 2, 3, 4, 5, 6, 7, 
                // Src: (intrinsic_wo_chain:v4i16 478:iPTR, (bitconvert:v8i8 (ld:v1i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>), VR64:v8i8:$src1)
                // Dst: (MMX_PSADBWrm:v4i16 VR64:v8i8:$src1, addr:iPTR:$src2)
/*35428*/     /*Scope*/ 13, /*->35442*/
/*35429*/       OPC_RecordChild1, // #0 = $src1
/*35430*/       OPC_RecordChild2, // #1 = $src2
/*35431*/       OPC_CheckPatternPredicate, 8, // (Subtarget->hasMMX())
/*35433*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PSADBWrr), 0,
                    1/*#VTs*/, MVT::v4i16, 2/*#Ops*/, 0, 1, 
                // Src: (intrinsic_wo_chain:v4i16 478:iPTR, VR64:v8i8:$src1, VR64:v8i8:$src2)
                // Dst: (MMX_PSADBWrr:v4i16 VR64:v8i8:$src1, VR64:v8i8:$src2)
/*35442*/     0, /*End of Scope*/
/*35443*/   /*Scope*/ 62, /*->35506*/
/*35444*/     OPC_CheckInteger, 107|128,3/*491*/, 
/*35447*/     OPC_MoveParent,
/*35448*/     OPC_RecordChild1, // #0 = $src1
/*35449*/     OPC_Scope, 41, /*->35492*/ // 2 children in Scope
/*35451*/       OPC_MoveChild, 2,
/*35453*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*35455*/       OPC_MoveChild, 0,
/*35457*/       OPC_CheckOpcode, ISD::LOAD,
/*35459*/       OPC_RecordMemRef,
/*35460*/       OPC_RecordNode, // #1 = 'ld' chained node
/*35461*/       OPC_CheckFoldableChainNode,
/*35462*/       OPC_RecordChild1, // #2 = $src2
/*35463*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*35465*/       OPC_CheckPredicate, 8, // Predicate_load
/*35467*/       OPC_CheckType, MVT::v1i64,
/*35469*/       OPC_MoveParent,
/*35470*/       OPC_MoveParent,
/*35471*/       OPC_CheckPatternPredicate, 8, // (Subtarget->hasMMX())
/*35473*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*35476*/       OPC_EmitMergeInputChains, 1, 1, 
/*35479*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PSRLWrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v4i16, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (intrinsic_wo_chain:v4i16 491:iPTR, VR64:v4i16:$src1, (bitconvert:v1i64 (ld:v1i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>))
                // Dst: (MMX_PSRLWrm:v4i16 VR64:v4i16:$src1, addr:iPTR:$src2)
/*35492*/     /*Scope*/ 12, /*->35505*/
/*35493*/       OPC_RecordChild2, // #1 = $src2
/*35494*/       OPC_CheckPatternPredicate, 8, // (Subtarget->hasMMX())
/*35496*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PSRLWrr), 0,
                    1/*#VTs*/, MVT::v4i16, 2/*#Ops*/, 0, 1, 
                // Src: (intrinsic_wo_chain:v4i16 491:iPTR, VR64:v4i16:$src1, VR64:v1i64:$src2)
                // Dst: (MMX_PSRLWrr:v4i16 VR64:v4i16:$src1, VR64:v1i64:$src2)
/*35505*/     0, /*End of Scope*/
/*35506*/   /*Scope*/ 62, /*->35569*/
/*35507*/     OPC_CheckInteger, 105|128,3/*489*/, 
/*35510*/     OPC_MoveParent,
/*35511*/     OPC_RecordChild1, // #0 = $src1
/*35512*/     OPC_Scope, 41, /*->35555*/ // 2 children in Scope
/*35514*/       OPC_MoveChild, 2,
/*35516*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*35518*/       OPC_MoveChild, 0,
/*35520*/       OPC_CheckOpcode, ISD::LOAD,
/*35522*/       OPC_RecordMemRef,
/*35523*/       OPC_RecordNode, // #1 = 'ld' chained node
/*35524*/       OPC_CheckFoldableChainNode,
/*35525*/       OPC_RecordChild1, // #2 = $src2
/*35526*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*35528*/       OPC_CheckPredicate, 8, // Predicate_load
/*35530*/       OPC_CheckType, MVT::v1i64,
/*35532*/       OPC_MoveParent,
/*35533*/       OPC_MoveParent,
/*35534*/       OPC_CheckPatternPredicate, 8, // (Subtarget->hasMMX())
/*35536*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*35539*/       OPC_EmitMergeInputChains, 1, 1, 
/*35542*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PSRLDrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v2i32, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (intrinsic_wo_chain:v2i32 489:iPTR, VR64:v2i32:$src1, (bitconvert:v1i64 (ld:v1i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>))
                // Dst: (MMX_PSRLDrm:v2i32 VR64:v2i32:$src1, addr:iPTR:$src2)
/*35555*/     /*Scope*/ 12, /*->35568*/
/*35556*/       OPC_RecordChild2, // #1 = $src2
/*35557*/       OPC_CheckPatternPredicate, 8, // (Subtarget->hasMMX())
/*35559*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PSRLDrr), 0,
                    1/*#VTs*/, MVT::v2i32, 2/*#Ops*/, 0, 1, 
                // Src: (intrinsic_wo_chain:v2i32 489:iPTR, VR64:v2i32:$src1, VR64:v1i64:$src2)
                // Dst: (MMX_PSRLDrr:v2i32 VR64:v2i32:$src1, VR64:v1i64:$src2)
/*35568*/     0, /*End of Scope*/
/*35569*/   /*Scope*/ 62, /*->35632*/
/*35570*/     OPC_CheckInteger, 106|128,3/*490*/, 
/*35573*/     OPC_MoveParent,
/*35574*/     OPC_RecordChild1, // #0 = $src1
/*35575*/     OPC_Scope, 41, /*->35618*/ // 2 children in Scope
/*35577*/       OPC_MoveChild, 2,
/*35579*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*35581*/       OPC_MoveChild, 0,
/*35583*/       OPC_CheckOpcode, ISD::LOAD,
/*35585*/       OPC_RecordMemRef,
/*35586*/       OPC_RecordNode, // #1 = 'ld' chained node
/*35587*/       OPC_CheckFoldableChainNode,
/*35588*/       OPC_RecordChild1, // #2 = $src2
/*35589*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*35591*/       OPC_CheckPredicate, 8, // Predicate_load
/*35593*/       OPC_CheckType, MVT::v1i64,
/*35595*/       OPC_MoveParent,
/*35596*/       OPC_MoveParent,
/*35597*/       OPC_CheckPatternPredicate, 8, // (Subtarget->hasMMX())
/*35599*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*35602*/       OPC_EmitMergeInputChains, 1, 1, 
/*35605*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PSRLQrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v1i64, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (intrinsic_wo_chain:v1i64 490:iPTR, VR64:v1i64:$src1, (bitconvert:v1i64 (ld:v1i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>))
                // Dst: (MMX_PSRLQrm:v1i64 VR64:v1i64:$src1, addr:iPTR:$src2)
/*35618*/     /*Scope*/ 12, /*->35631*/
/*35619*/       OPC_RecordChild2, // #1 = $src2
/*35620*/       OPC_CheckPatternPredicate, 8, // (Subtarget->hasMMX())
/*35622*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PSRLQrr), 0,
                    1/*#VTs*/, MVT::v1i64, 2/*#Ops*/, 0, 1, 
                // Src: (intrinsic_wo_chain:v1i64 490:iPTR, VR64:v1i64:$src1, VR64:v1i64:$src2)
                // Dst: (MMX_PSRLQrr:v1i64 VR64:v1i64:$src1, VR64:v1i64:$src2)
/*35631*/     0, /*End of Scope*/
/*35632*/   /*Scope*/ 62, /*->35695*/
/*35633*/     OPC_CheckInteger, 97|128,3/*481*/, 
/*35636*/     OPC_MoveParent,
/*35637*/     OPC_RecordChild1, // #0 = $src1
/*35638*/     OPC_Scope, 41, /*->35681*/ // 2 children in Scope
/*35640*/       OPC_MoveChild, 2,
/*35642*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*35644*/       OPC_MoveChild, 0,
/*35646*/       OPC_CheckOpcode, ISD::LOAD,
/*35648*/       OPC_RecordMemRef,
/*35649*/       OPC_RecordNode, // #1 = 'ld' chained node
/*35650*/       OPC_CheckFoldableChainNode,
/*35651*/       OPC_RecordChild1, // #2 = $src2
/*35652*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*35654*/       OPC_CheckPredicate, 8, // Predicate_load
/*35656*/       OPC_CheckType, MVT::v1i64,
/*35658*/       OPC_MoveParent,
/*35659*/       OPC_MoveParent,
/*35660*/       OPC_CheckPatternPredicate, 8, // (Subtarget->hasMMX())
/*35662*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*35665*/       OPC_EmitMergeInputChains, 1, 1, 
/*35668*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PSLLWrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v4i16, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (intrinsic_wo_chain:v4i16 481:iPTR, VR64:v4i16:$src1, (bitconvert:v1i64 (ld:v1i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>))
                // Dst: (MMX_PSLLWrm:v4i16 VR64:v4i16:$src1, addr:iPTR:$src2)
/*35681*/     /*Scope*/ 12, /*->35694*/
/*35682*/       OPC_RecordChild2, // #1 = $src2
/*35683*/       OPC_CheckPatternPredicate, 8, // (Subtarget->hasMMX())
/*35685*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PSLLWrr), 0,
                    1/*#VTs*/, MVT::v4i16, 2/*#Ops*/, 0, 1, 
                // Src: (intrinsic_wo_chain:v4i16 481:iPTR, VR64:v4i16:$src1, VR64:v1i64:$src2)
                // Dst: (MMX_PSLLWrr:v4i16 VR64:v4i16:$src1, VR64:v1i64:$src2)
/*35694*/     0, /*End of Scope*/
/*35695*/   /*Scope*/ 62, /*->35758*/
/*35696*/     OPC_CheckInteger, 95|128,3/*479*/, 
/*35699*/     OPC_MoveParent,
/*35700*/     OPC_RecordChild1, // #0 = $src1
/*35701*/     OPC_Scope, 41, /*->35744*/ // 2 children in Scope
/*35703*/       OPC_MoveChild, 2,
/*35705*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*35707*/       OPC_MoveChild, 0,
/*35709*/       OPC_CheckOpcode, ISD::LOAD,
/*35711*/       OPC_RecordMemRef,
/*35712*/       OPC_RecordNode, // #1 = 'ld' chained node
/*35713*/       OPC_CheckFoldableChainNode,
/*35714*/       OPC_RecordChild1, // #2 = $src2
/*35715*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*35717*/       OPC_CheckPredicate, 8, // Predicate_load
/*35719*/       OPC_CheckType, MVT::v1i64,
/*35721*/       OPC_MoveParent,
/*35722*/       OPC_MoveParent,
/*35723*/       OPC_CheckPatternPredicate, 8, // (Subtarget->hasMMX())
/*35725*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*35728*/       OPC_EmitMergeInputChains, 1, 1, 
/*35731*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PSLLDrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v2i32, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (intrinsic_wo_chain:v2i32 479:iPTR, VR64:v2i32:$src1, (bitconvert:v1i64 (ld:v1i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>))
                // Dst: (MMX_PSLLDrm:v2i32 VR64:v2i32:$src1, addr:iPTR:$src2)
/*35744*/     /*Scope*/ 12, /*->35757*/
/*35745*/       OPC_RecordChild2, // #1 = $src2
/*35746*/       OPC_CheckPatternPredicate, 8, // (Subtarget->hasMMX())
/*35748*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PSLLDrr), 0,
                    1/*#VTs*/, MVT::v2i32, 2/*#Ops*/, 0, 1, 
                // Src: (intrinsic_wo_chain:v2i32 479:iPTR, VR64:v2i32:$src1, VR64:v1i64:$src2)
                // Dst: (MMX_PSLLDrr:v2i32 VR64:v2i32:$src1, VR64:v1i64:$src2)
/*35757*/     0, /*End of Scope*/
/*35758*/   /*Scope*/ 62, /*->35821*/
/*35759*/     OPC_CheckInteger, 96|128,3/*480*/, 
/*35762*/     OPC_MoveParent,
/*35763*/     OPC_RecordChild1, // #0 = $src1
/*35764*/     OPC_Scope, 41, /*->35807*/ // 2 children in Scope
/*35766*/       OPC_MoveChild, 2,
/*35768*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*35770*/       OPC_MoveChild, 0,
/*35772*/       OPC_CheckOpcode, ISD::LOAD,
/*35774*/       OPC_RecordMemRef,
/*35775*/       OPC_RecordNode, // #1 = 'ld' chained node
/*35776*/       OPC_CheckFoldableChainNode,
/*35777*/       OPC_RecordChild1, // #2 = $src2
/*35778*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*35780*/       OPC_CheckPredicate, 8, // Predicate_load
/*35782*/       OPC_CheckType, MVT::v1i64,
/*35784*/       OPC_MoveParent,
/*35785*/       OPC_MoveParent,
/*35786*/       OPC_CheckPatternPredicate, 8, // (Subtarget->hasMMX())
/*35788*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*35791*/       OPC_EmitMergeInputChains, 1, 1, 
/*35794*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PSLLQrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v1i64, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (intrinsic_wo_chain:v1i64 480:iPTR, VR64:v1i64:$src1, (bitconvert:v1i64 (ld:v1i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>))
                // Dst: (MMX_PSLLQrm:v1i64 VR64:v1i64:$src1, addr:iPTR:$src2)
/*35807*/     /*Scope*/ 12, /*->35820*/
/*35808*/       OPC_RecordChild2, // #1 = $src2
/*35809*/       OPC_CheckPatternPredicate, 8, // (Subtarget->hasMMX())
/*35811*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PSLLQrr), 0,
                    1/*#VTs*/, MVT::v1i64, 2/*#Ops*/, 0, 1, 
                // Src: (intrinsic_wo_chain:v1i64 480:iPTR, VR64:v1i64:$src1, VR64:v1i64:$src2)
                // Dst: (MMX_PSLLQrr:v1i64 VR64:v1i64:$src1, VR64:v1i64:$src2)
/*35820*/     0, /*End of Scope*/
/*35821*/   /*Scope*/ 62, /*->35884*/
/*35822*/     OPC_CheckInteger, 102|128,3/*486*/, 
/*35825*/     OPC_MoveParent,
/*35826*/     OPC_RecordChild1, // #0 = $src1
/*35827*/     OPC_Scope, 41, /*->35870*/ // 2 children in Scope
/*35829*/       OPC_MoveChild, 2,
/*35831*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*35833*/       OPC_MoveChild, 0,
/*35835*/       OPC_CheckOpcode, ISD::LOAD,
/*35837*/       OPC_RecordMemRef,
/*35838*/       OPC_RecordNode, // #1 = 'ld' chained node
/*35839*/       OPC_CheckFoldableChainNode,
/*35840*/       OPC_RecordChild1, // #2 = $src2
/*35841*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*35843*/       OPC_CheckPredicate, 8, // Predicate_load
/*35845*/       OPC_CheckType, MVT::v1i64,
/*35847*/       OPC_MoveParent,
/*35848*/       OPC_MoveParent,
/*35849*/       OPC_CheckPatternPredicate, 8, // (Subtarget->hasMMX())
/*35851*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*35854*/       OPC_EmitMergeInputChains, 1, 1, 
/*35857*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PSRAWrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v4i16, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (intrinsic_wo_chain:v4i16 486:iPTR, VR64:v4i16:$src1, (bitconvert:v1i64 (ld:v1i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>))
                // Dst: (MMX_PSRAWrm:v4i16 VR64:v4i16:$src1, addr:iPTR:$src2)
/*35870*/     /*Scope*/ 12, /*->35883*/
/*35871*/       OPC_RecordChild2, // #1 = $src2
/*35872*/       OPC_CheckPatternPredicate, 8, // (Subtarget->hasMMX())
/*35874*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PSRAWrr), 0,
                    1/*#VTs*/, MVT::v4i16, 2/*#Ops*/, 0, 1, 
                // Src: (intrinsic_wo_chain:v4i16 486:iPTR, VR64:v4i16:$src1, VR64:v1i64:$src2)
                // Dst: (MMX_PSRAWrr:v4i16 VR64:v4i16:$src1, VR64:v1i64:$src2)
/*35883*/     0, /*End of Scope*/
/*35884*/   /*Scope*/ 62, /*->35947*/
/*35885*/     OPC_CheckInteger, 101|128,3/*485*/, 
/*35888*/     OPC_MoveParent,
/*35889*/     OPC_RecordChild1, // #0 = $src1
/*35890*/     OPC_Scope, 41, /*->35933*/ // 2 children in Scope
/*35892*/       OPC_MoveChild, 2,
/*35894*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*35896*/       OPC_MoveChild, 0,
/*35898*/       OPC_CheckOpcode, ISD::LOAD,
/*35900*/       OPC_RecordMemRef,
/*35901*/       OPC_RecordNode, // #1 = 'ld' chained node
/*35902*/       OPC_CheckFoldableChainNode,
/*35903*/       OPC_RecordChild1, // #2 = $src2
/*35904*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*35906*/       OPC_CheckPredicate, 8, // Predicate_load
/*35908*/       OPC_CheckType, MVT::v1i64,
/*35910*/       OPC_MoveParent,
/*35911*/       OPC_MoveParent,
/*35912*/       OPC_CheckPatternPredicate, 8, // (Subtarget->hasMMX())
/*35914*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*35917*/       OPC_EmitMergeInputChains, 1, 1, 
/*35920*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PSRADrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v2i32, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (intrinsic_wo_chain:v2i32 485:iPTR, VR64:v2i32:$src1, (bitconvert:v1i64 (ld:v1i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>))
                // Dst: (MMX_PSRADrm:v2i32 VR64:v2i32:$src1, addr:iPTR:$src2)
/*35933*/     /*Scope*/ 12, /*->35946*/
/*35934*/       OPC_RecordChild2, // #1 = $src2
/*35935*/       OPC_CheckPatternPredicate, 8, // (Subtarget->hasMMX())
/*35937*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PSRADrr), 0,
                    1/*#VTs*/, MVT::v2i32, 2/*#Ops*/, 0, 1, 
                // Src: (intrinsic_wo_chain:v2i32 485:iPTR, VR64:v2i32:$src1, VR64:v1i64:$src2)
                // Dst: (MMX_PSRADrr:v2i32 VR64:v2i32:$src1, VR64:v1i64:$src2)
/*35946*/     0, /*End of Scope*/
/*35947*/   /*Scope*/ 62, /*->36010*/
/*35948*/     OPC_CheckInteger, 79|128,3/*463*/, 
/*35951*/     OPC_MoveParent,
/*35952*/     OPC_RecordChild1, // #0 = $src1
/*35953*/     OPC_Scope, 41, /*->35996*/ // 2 children in Scope
/*35955*/       OPC_MoveChild, 2,
/*35957*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*35959*/       OPC_MoveChild, 0,
/*35961*/       OPC_CheckOpcode, ISD::LOAD,
/*35963*/       OPC_RecordMemRef,
/*35964*/       OPC_RecordNode, // #1 = 'ld' chained node
/*35965*/       OPC_CheckFoldableChainNode,
/*35966*/       OPC_RecordChild1, // #2 = $src2
/*35967*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*35969*/       OPC_CheckPredicate, 8, // Predicate_load
/*35971*/       OPC_CheckType, MVT::v1i64,
/*35973*/       OPC_MoveParent,
/*35974*/       OPC_MoveParent,
/*35975*/       OPC_CheckPatternPredicate, 8, // (Subtarget->hasMMX())
/*35977*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*35980*/       OPC_EmitMergeInputChains, 1, 1, 
/*35983*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PCMPEQBrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v8i8, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (intrinsic_wo_chain:v8i8 463:iPTR, VR64:v8i8:$src1, (bitconvert:v8i8 (ld:v1i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>))
                // Dst: (MMX_PCMPEQBrm:v8i8 VR64:v8i8:$src1, addr:iPTR:$src2)
/*35996*/     /*Scope*/ 12, /*->36009*/
/*35997*/       OPC_RecordChild2, // #1 = $src2
/*35998*/       OPC_CheckPatternPredicate, 8, // (Subtarget->hasMMX())
/*36000*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PCMPEQBrr), 0,
                    1/*#VTs*/, MVT::v8i8, 2/*#Ops*/, 0, 1, 
                // Src: (intrinsic_wo_chain:v8i8 463:iPTR, VR64:v8i8:$src1, VR64:v8i8:$src2)
                // Dst: (MMX_PCMPEQBrr:v8i8 VR64:v8i8:$src1, VR64:v8i8:$src2)
/*36009*/     0, /*End of Scope*/
/*36010*/   /*Scope*/ 62, /*->36073*/
/*36011*/     OPC_CheckInteger, 81|128,3/*465*/, 
/*36014*/     OPC_MoveParent,
/*36015*/     OPC_RecordChild1, // #0 = $src1
/*36016*/     OPC_Scope, 41, /*->36059*/ // 2 children in Scope
/*36018*/       OPC_MoveChild, 2,
/*36020*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*36022*/       OPC_MoveChild, 0,
/*36024*/       OPC_CheckOpcode, ISD::LOAD,
/*36026*/       OPC_RecordMemRef,
/*36027*/       OPC_RecordNode, // #1 = 'ld' chained node
/*36028*/       OPC_CheckFoldableChainNode,
/*36029*/       OPC_RecordChild1, // #2 = $src2
/*36030*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*36032*/       OPC_CheckPredicate, 8, // Predicate_load
/*36034*/       OPC_CheckType, MVT::v1i64,
/*36036*/       OPC_MoveParent,
/*36037*/       OPC_MoveParent,
/*36038*/       OPC_CheckPatternPredicate, 8, // (Subtarget->hasMMX())
/*36040*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*36043*/       OPC_EmitMergeInputChains, 1, 1, 
/*36046*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PCMPEQWrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v4i16, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (intrinsic_wo_chain:v4i16 465:iPTR, VR64:v4i16:$src1, (bitconvert:v4i16 (ld:v1i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>))
                // Dst: (MMX_PCMPEQWrm:v4i16 VR64:v4i16:$src1, addr:iPTR:$src2)
/*36059*/     /*Scope*/ 12, /*->36072*/
/*36060*/       OPC_RecordChild2, // #1 = $src2
/*36061*/       OPC_CheckPatternPredicate, 8, // (Subtarget->hasMMX())
/*36063*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PCMPEQWrr), 0,
                    1/*#VTs*/, MVT::v4i16, 2/*#Ops*/, 0, 1, 
                // Src: (intrinsic_wo_chain:v4i16 465:iPTR, VR64:v4i16:$src1, VR64:v4i16:$src2)
                // Dst: (MMX_PCMPEQWrr:v4i16 VR64:v4i16:$src1, VR64:v4i16:$src2)
/*36072*/     0, /*End of Scope*/
/*36073*/   /*Scope*/ 62, /*->36136*/
/*36074*/     OPC_CheckInteger, 80|128,3/*464*/, 
/*36077*/     OPC_MoveParent,
/*36078*/     OPC_RecordChild1, // #0 = $src1
/*36079*/     OPC_Scope, 41, /*->36122*/ // 2 children in Scope
/*36081*/       OPC_MoveChild, 2,
/*36083*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*36085*/       OPC_MoveChild, 0,
/*36087*/       OPC_CheckOpcode, ISD::LOAD,
/*36089*/       OPC_RecordMemRef,
/*36090*/       OPC_RecordNode, // #1 = 'ld' chained node
/*36091*/       OPC_CheckFoldableChainNode,
/*36092*/       OPC_RecordChild1, // #2 = $src2
/*36093*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*36095*/       OPC_CheckPredicate, 8, // Predicate_load
/*36097*/       OPC_CheckType, MVT::v1i64,
/*36099*/       OPC_MoveParent,
/*36100*/       OPC_MoveParent,
/*36101*/       OPC_CheckPatternPredicate, 8, // (Subtarget->hasMMX())
/*36103*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*36106*/       OPC_EmitMergeInputChains, 1, 1, 
/*36109*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PCMPEQDrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v2i32, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (intrinsic_wo_chain:v2i32 464:iPTR, VR64:v2i32:$src1, (bitconvert:v2i32 (ld:v1i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>))
                // Dst: (MMX_PCMPEQDrm:v2i32 VR64:v2i32:$src1, addr:iPTR:$src2)
/*36122*/     /*Scope*/ 12, /*->36135*/
/*36123*/       OPC_RecordChild2, // #1 = $src2
/*36124*/       OPC_CheckPatternPredicate, 8, // (Subtarget->hasMMX())
/*36126*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PCMPEQDrr), 0,
                    1/*#VTs*/, MVT::v2i32, 2/*#Ops*/, 0, 1, 
                // Src: (intrinsic_wo_chain:v2i32 464:iPTR, VR64:v2i32:$src1, VR64:v2i32:$src2)
                // Dst: (MMX_PCMPEQDrr:v2i32 VR64:v2i32:$src1, VR64:v2i32:$src2)
/*36135*/     0, /*End of Scope*/
/*36136*/   /*Scope*/ 62, /*->36199*/
/*36137*/     OPC_CheckInteger, 82|128,3/*466*/, 
/*36140*/     OPC_MoveParent,
/*36141*/     OPC_RecordChild1, // #0 = $src1
/*36142*/     OPC_Scope, 41, /*->36185*/ // 2 children in Scope
/*36144*/       OPC_MoveChild, 2,
/*36146*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*36148*/       OPC_MoveChild, 0,
/*36150*/       OPC_CheckOpcode, ISD::LOAD,
/*36152*/       OPC_RecordMemRef,
/*36153*/       OPC_RecordNode, // #1 = 'ld' chained node
/*36154*/       OPC_CheckFoldableChainNode,
/*36155*/       OPC_RecordChild1, // #2 = $src2
/*36156*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*36158*/       OPC_CheckPredicate, 8, // Predicate_load
/*36160*/       OPC_CheckType, MVT::v1i64,
/*36162*/       OPC_MoveParent,
/*36163*/       OPC_MoveParent,
/*36164*/       OPC_CheckPatternPredicate, 8, // (Subtarget->hasMMX())
/*36166*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*36169*/       OPC_EmitMergeInputChains, 1, 1, 
/*36172*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PCMPGTBrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v8i8, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (intrinsic_wo_chain:v8i8 466:iPTR, VR64:v8i8:$src1, (bitconvert:v8i8 (ld:v1i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>))
                // Dst: (MMX_PCMPGTBrm:v8i8 VR64:v8i8:$src1, addr:iPTR:$src2)
/*36185*/     /*Scope*/ 12, /*->36198*/
/*36186*/       OPC_RecordChild2, // #1 = $src2
/*36187*/       OPC_CheckPatternPredicate, 8, // (Subtarget->hasMMX())
/*36189*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PCMPGTBrr), 0,
                    1/*#VTs*/, MVT::v8i8, 2/*#Ops*/, 0, 1, 
                // Src: (intrinsic_wo_chain:v8i8 466:iPTR, VR64:v8i8:$src1, VR64:v8i8:$src2)
                // Dst: (MMX_PCMPGTBrr:v8i8 VR64:v8i8:$src1, VR64:v8i8:$src2)
/*36198*/     0, /*End of Scope*/
/*36199*/   /*Scope*/ 62, /*->36262*/
/*36200*/     OPC_CheckInteger, 84|128,3/*468*/, 
/*36203*/     OPC_MoveParent,
/*36204*/     OPC_RecordChild1, // #0 = $src1
/*36205*/     OPC_Scope, 41, /*->36248*/ // 2 children in Scope
/*36207*/       OPC_MoveChild, 2,
/*36209*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*36211*/       OPC_MoveChild, 0,
/*36213*/       OPC_CheckOpcode, ISD::LOAD,
/*36215*/       OPC_RecordMemRef,
/*36216*/       OPC_RecordNode, // #1 = 'ld' chained node
/*36217*/       OPC_CheckFoldableChainNode,
/*36218*/       OPC_RecordChild1, // #2 = $src2
/*36219*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*36221*/       OPC_CheckPredicate, 8, // Predicate_load
/*36223*/       OPC_CheckType, MVT::v1i64,
/*36225*/       OPC_MoveParent,
/*36226*/       OPC_MoveParent,
/*36227*/       OPC_CheckPatternPredicate, 8, // (Subtarget->hasMMX())
/*36229*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*36232*/       OPC_EmitMergeInputChains, 1, 1, 
/*36235*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PCMPGTWrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v4i16, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (intrinsic_wo_chain:v4i16 468:iPTR, VR64:v4i16:$src1, (bitconvert:v4i16 (ld:v1i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>))
                // Dst: (MMX_PCMPGTWrm:v4i16 VR64:v4i16:$src1, addr:iPTR:$src2)
/*36248*/     /*Scope*/ 12, /*->36261*/
/*36249*/       OPC_RecordChild2, // #1 = $src2
/*36250*/       OPC_CheckPatternPredicate, 8, // (Subtarget->hasMMX())
/*36252*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PCMPGTWrr), 0,
                    1/*#VTs*/, MVT::v4i16, 2/*#Ops*/, 0, 1, 
                // Src: (intrinsic_wo_chain:v4i16 468:iPTR, VR64:v4i16:$src1, VR64:v4i16:$src2)
                // Dst: (MMX_PCMPGTWrr:v4i16 VR64:v4i16:$src1, VR64:v4i16:$src2)
/*36261*/     0, /*End of Scope*/
/*36262*/   /*Scope*/ 62, /*->36325*/
/*36263*/     OPC_CheckInteger, 83|128,3/*467*/, 
/*36266*/     OPC_MoveParent,
/*36267*/     OPC_RecordChild1, // #0 = $src1
/*36268*/     OPC_Scope, 41, /*->36311*/ // 2 children in Scope
/*36270*/       OPC_MoveChild, 2,
/*36272*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*36274*/       OPC_MoveChild, 0,
/*36276*/       OPC_CheckOpcode, ISD::LOAD,
/*36278*/       OPC_RecordMemRef,
/*36279*/       OPC_RecordNode, // #1 = 'ld' chained node
/*36280*/       OPC_CheckFoldableChainNode,
/*36281*/       OPC_RecordChild1, // #2 = $src2
/*36282*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*36284*/       OPC_CheckPredicate, 8, // Predicate_load
/*36286*/       OPC_CheckType, MVT::v1i64,
/*36288*/       OPC_MoveParent,
/*36289*/       OPC_MoveParent,
/*36290*/       OPC_CheckPatternPredicate, 8, // (Subtarget->hasMMX())
/*36292*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*36295*/       OPC_EmitMergeInputChains, 1, 1, 
/*36298*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PCMPGTDrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v2i32, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (intrinsic_wo_chain:v2i32 467:iPTR, VR64:v2i32:$src1, (bitconvert:v2i32 (ld:v1i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>))
                // Dst: (MMX_PCMPGTDrm:v2i32 VR64:v2i32:$src1, addr:iPTR:$src2)
/*36311*/     /*Scope*/ 12, /*->36324*/
/*36312*/       OPC_RecordChild2, // #1 = $src2
/*36313*/       OPC_CheckPatternPredicate, 8, // (Subtarget->hasMMX())
/*36315*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PCMPGTDrr), 0,
                    1/*#VTs*/, MVT::v2i32, 2/*#Ops*/, 0, 1, 
                // Src: (intrinsic_wo_chain:v2i32 467:iPTR, VR64:v2i32:$src1, VR64:v2i32:$src2)
                // Dst: (MMX_PCMPGTDrr:v2i32 VR64:v2i32:$src1, VR64:v2i32:$src2)
/*36324*/     0, /*End of Scope*/
/*36325*/   /*Scope*/ 62, /*->36388*/
/*36326*/     OPC_CheckInteger, 71|128,3/*455*/, 
/*36329*/     OPC_MoveParent,
/*36330*/     OPC_RecordChild1, // #0 = $src1
/*36331*/     OPC_Scope, 41, /*->36374*/ // 2 children in Scope
/*36333*/       OPC_MoveChild, 2,
/*36335*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*36337*/       OPC_MoveChild, 0,
/*36339*/       OPC_CheckOpcode, ISD::LOAD,
/*36341*/       OPC_RecordMemRef,
/*36342*/       OPC_RecordNode, // #1 = 'ld' chained node
/*36343*/       OPC_CheckFoldableChainNode,
/*36344*/       OPC_RecordChild1, // #2 = $src2
/*36345*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*36347*/       OPC_CheckPredicate, 8, // Predicate_load
/*36349*/       OPC_CheckType, MVT::v1i64,
/*36351*/       OPC_MoveParent,
/*36352*/       OPC_MoveParent,
/*36353*/       OPC_CheckPatternPredicate, 8, // (Subtarget->hasMMX())
/*36355*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*36358*/       OPC_EmitMergeInputChains, 1, 1, 
/*36361*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PACKSSWBrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v8i8, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (intrinsic_wo_chain:v8i8 455:iPTR, VR64:v4i16:$src1, (bitconvert:v4i16 (ld:v1i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>))
                // Dst: (MMX_PACKSSWBrm:v8i8 VR64:v4i16:$src1, addr:iPTR:$src2)
/*36374*/     /*Scope*/ 12, /*->36387*/
/*36375*/       OPC_RecordChild2, // #1 = $src2
/*36376*/       OPC_CheckPatternPredicate, 8, // (Subtarget->hasMMX())
/*36378*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PACKSSWBrr), 0,
                    1/*#VTs*/, MVT::v8i8, 2/*#Ops*/, 0, 1, 
                // Src: (intrinsic_wo_chain:v8i8 455:iPTR, VR64:v4i16:$src1, VR64:v4i16:$src2)
                // Dst: (MMX_PACKSSWBrr:v8i8 VR64:v4i16:$src1, VR64:v4i16:$src2)
/*36387*/     0, /*End of Scope*/
/*36388*/   /*Scope*/ 62, /*->36451*/
/*36389*/     OPC_CheckInteger, 70|128,3/*454*/, 
/*36392*/     OPC_MoveParent,
/*36393*/     OPC_RecordChild1, // #0 = $src1
/*36394*/     OPC_Scope, 41, /*->36437*/ // 2 children in Scope
/*36396*/       OPC_MoveChild, 2,
/*36398*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*36400*/       OPC_MoveChild, 0,
/*36402*/       OPC_CheckOpcode, ISD::LOAD,
/*36404*/       OPC_RecordMemRef,
/*36405*/       OPC_RecordNode, // #1 = 'ld' chained node
/*36406*/       OPC_CheckFoldableChainNode,
/*36407*/       OPC_RecordChild1, // #2 = $src2
/*36408*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*36410*/       OPC_CheckPredicate, 8, // Predicate_load
/*36412*/       OPC_CheckType, MVT::v1i64,
/*36414*/       OPC_MoveParent,
/*36415*/       OPC_MoveParent,
/*36416*/       OPC_CheckPatternPredicate, 8, // (Subtarget->hasMMX())
/*36418*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*36421*/       OPC_EmitMergeInputChains, 1, 1, 
/*36424*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PACKSSDWrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v4i16, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (intrinsic_wo_chain:v4i16 454:iPTR, VR64:v2i32:$src1, (bitconvert:v2i32 (ld:v1i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>))
                // Dst: (MMX_PACKSSDWrm:v4i16 VR64:v2i32:$src1, addr:iPTR:$src2)
/*36437*/     /*Scope*/ 12, /*->36450*/
/*36438*/       OPC_RecordChild2, // #1 = $src2
/*36439*/       OPC_CheckPatternPredicate, 8, // (Subtarget->hasMMX())
/*36441*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PACKSSDWrr), 0,
                    1/*#VTs*/, MVT::v4i16, 2/*#Ops*/, 0, 1, 
                // Src: (intrinsic_wo_chain:v4i16 454:iPTR, VR64:v2i32:$src1, VR64:v2i32:$src2)
                // Dst: (MMX_PACKSSDWrr:v4i16 VR64:v2i32:$src1, VR64:v2i32:$src2)
/*36450*/     0, /*End of Scope*/
/*36451*/   /*Scope*/ 62, /*->36514*/
/*36452*/     OPC_CheckInteger, 72|128,3/*456*/, 
/*36455*/     OPC_MoveParent,
/*36456*/     OPC_RecordChild1, // #0 = $src1
/*36457*/     OPC_Scope, 41, /*->36500*/ // 2 children in Scope
/*36459*/       OPC_MoveChild, 2,
/*36461*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*36463*/       OPC_MoveChild, 0,
/*36465*/       OPC_CheckOpcode, ISD::LOAD,
/*36467*/       OPC_RecordMemRef,
/*36468*/       OPC_RecordNode, // #1 = 'ld' chained node
/*36469*/       OPC_CheckFoldableChainNode,
/*36470*/       OPC_RecordChild1, // #2 = $src2
/*36471*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*36473*/       OPC_CheckPredicate, 8, // Predicate_load
/*36475*/       OPC_CheckType, MVT::v1i64,
/*36477*/       OPC_MoveParent,
/*36478*/       OPC_MoveParent,
/*36479*/       OPC_CheckPatternPredicate, 8, // (Subtarget->hasMMX())
/*36481*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*36484*/       OPC_EmitMergeInputChains, 1, 1, 
/*36487*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PACKUSWBrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v8i8, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (intrinsic_wo_chain:v8i8 456:iPTR, VR64:v4i16:$src1, (bitconvert:v4i16 (ld:v1i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>))
                // Dst: (MMX_PACKUSWBrm:v8i8 VR64:v4i16:$src1, addr:iPTR:$src2)
/*36500*/     /*Scope*/ 12, /*->36513*/
/*36501*/       OPC_RecordChild2, // #1 = $src2
/*36502*/       OPC_CheckPatternPredicate, 8, // (Subtarget->hasMMX())
/*36504*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PACKUSWBrr), 0,
                    1/*#VTs*/, MVT::v8i8, 2/*#Ops*/, 0, 1, 
                // Src: (intrinsic_wo_chain:v8i8 456:iPTR, VR64:v4i16:$src1, VR64:v4i16:$src2)
                // Dst: (MMX_PACKUSWBrr:v8i8 VR64:v4i16:$src1, VR64:v4i16:$src2)
/*36513*/     0, /*End of Scope*/
/*36514*/   /*Scope*/ 73, /*->36588*/
/*36515*/     OPC_CheckInteger, 35|128,5/*675*/, 
/*36518*/     OPC_MoveParent,
/*36519*/     OPC_RecordChild1, // #0 = $src1
/*36520*/     OPC_Scope, 43, /*->36565*/ // 2 children in Scope
/*36522*/       OPC_MoveChild, 2,
/*36524*/       OPC_CheckOpcode, ISD::LOAD,
/*36526*/       OPC_RecordMemRef,
/*36527*/       OPC_RecordNode, // #1 = 'ld' chained node
/*36528*/       OPC_CheckFoldableChainNode,
/*36529*/       OPC_RecordChild1, // #2 = $src2
/*36530*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*36532*/       OPC_CheckPredicate, 8, // Predicate_load
/*36534*/       OPC_MoveParent,
/*36535*/       OPC_RecordChild3, // #3 = $src3
/*36536*/       OPC_MoveChild, 3,
/*36538*/       OPC_CheckOpcode, ISD::Constant,
/*36540*/       OPC_MoveParent,
/*36541*/       OPC_CheckPatternPredicate, 14, // (Subtarget->hasSSE42())
/*36543*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #4 #5 #6 #7 #8
/*36546*/       OPC_EmitMergeInputChains, 1, 1, 
/*36549*/       OPC_EmitConvertToTarget, 3,
/*36551*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PCMPISTRM128MEM), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v16i8, 7/*#Ops*/, 0, 4, 5, 6, 7, 8, 9, 
                // Src: (intrinsic_wo_chain:v16i8 675:iPTR, VR128:v16i8:$src1, (ld:v16i8 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:i8):$src3)
                // Dst: (PCMPISTRM128MEM:v16i8 VR128:v16i8:$src1, addr:iPTR:$src2, (imm:i8):$src3)
/*36565*/     /*Scope*/ 21, /*->36587*/
/*36566*/       OPC_RecordChild2, // #1 = $src2
/*36567*/       OPC_RecordChild3, // #2 = $src3
/*36568*/       OPC_MoveChild, 3,
/*36570*/       OPC_CheckOpcode, ISD::Constant,
/*36572*/       OPC_MoveParent,
/*36573*/       OPC_CheckPatternPredicate, 14, // (Subtarget->hasSSE42())
/*36575*/       OPC_EmitConvertToTarget, 2,
/*36577*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PCMPISTRM128REG), 0,
                    1/*#VTs*/, MVT::v16i8, 3/*#Ops*/, 0, 1, 3, 
                // Src: (intrinsic_wo_chain:v16i8 675:iPTR, VR128:v16i8:$src1, VR128:v16i8:$src2, (imm:i8):$src3)
                // Dst: (PCMPISTRM128REG:v16i8 VR128:v16i8:$src1, VR128:v16i8:$src2, (imm:i8):$src3)
/*36587*/     0, /*End of Scope*/
/*36588*/   /*Scope*/ 88, /*->36677*/
/*36589*/     OPC_CheckInteger, 27|128,5/*667*/, 
/*36592*/     OPC_MoveParent,
/*36593*/     OPC_RecordChild1, // #0 = $src1
/*36594*/     OPC_RecordChild2, // #1 = physreg input EAX
/*36595*/     OPC_Scope, 50, /*->36647*/ // 2 children in Scope
/*36597*/       OPC_MoveChild, 3,
/*36599*/       OPC_CheckOpcode, ISD::LOAD,
/*36601*/       OPC_RecordMemRef,
/*36602*/       OPC_RecordNode, // #2 = 'ld' chained node
/*36603*/       OPC_CheckFoldableChainNode,
/*36604*/       OPC_RecordChild1, // #3 = $src3
/*36605*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*36607*/       OPC_CheckPredicate, 8, // Predicate_load
/*36609*/       OPC_MoveParent,
/*36610*/       OPC_RecordChild4, // #4 = physreg input EDX
/*36611*/       OPC_RecordChild5, // #5 = $src5
/*36612*/       OPC_MoveChild, 5,
/*36614*/       OPC_CheckOpcode, ISD::Constant,
/*36616*/       OPC_MoveParent,
/*36617*/       OPC_CheckPatternPredicate, 14, // (Subtarget->hasSSE42())
/*36619*/       OPC_CheckComplexPat, /*CP*/0, /*#*/3, // SelectAddr:$src3 #6 #7 #8 #9 #10
/*36622*/       OPC_EmitMergeInputChains, 1, 2, 
/*36625*/       OPC_EmitConvertToTarget, 5,
/*36627*/       OPC_EmitCopyToReg, 1, X86::EAX,
/*36630*/       OPC_EmitCopyToReg, 4, X86::EDX,
/*36633*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PCMPESTRM128MEM), 0|OPFL_Chain|OPFL_FlagInput|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v16i8, 7/*#Ops*/, 0, 6, 7, 8, 9, 10, 11, 
                // Src: (intrinsic_wo_chain:v16i8 667:iPTR, VR128:v16i8:$src1, EAX:i32, (ld:v16i8 addr:iPTR:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, EDX:i32, (imm:i8):$src5)
                // Dst: (PCMPESTRM128MEM:v16i8 VR128:v16i8:$src1, addr:iPTR:$src3, (imm:i8):$src5)
/*36647*/     /*Scope*/ 28, /*->36676*/
/*36648*/       OPC_RecordChild3, // #2 = $src3
/*36649*/       OPC_RecordChild4, // #3 = physreg input EDX
/*36650*/       OPC_RecordChild5, // #4 = $src5
/*36651*/       OPC_MoveChild, 5,
/*36653*/       OPC_CheckOpcode, ISD::Constant,
/*36655*/       OPC_MoveParent,
/*36656*/       OPC_CheckPatternPredicate, 14, // (Subtarget->hasSSE42())
/*36658*/       OPC_EmitConvertToTarget, 4,
/*36660*/       OPC_EmitCopyToReg, 1, X86::EAX,
/*36663*/       OPC_EmitCopyToReg, 3, X86::EDX,
/*36666*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PCMPESTRM128REG), 0|OPFL_FlagInput,
                    1/*#VTs*/, MVT::v16i8, 3/*#Ops*/, 0, 2, 5, 
                // Src: (intrinsic_wo_chain:v16i8 667:iPTR, VR128:v16i8:$src1, EAX:i32, VR128:v16i8:$src3, EDX:i32, (imm:i8):$src5)
                // Dst: (PCMPESTRM128REG:v16i8 VR128:v16i8:$src1, VR128:v16i8:$src3, (imm:i8):$src5)
/*36676*/     0, /*End of Scope*/
/*36677*/   /*Scope*/ 52, /*->36730*/
/*36678*/     OPC_CheckInteger, 4|128,4/*516*/, 
/*36681*/     OPC_MoveParent,
/*36682*/     OPC_Scope, 33, /*->36717*/ // 2 children in Scope
/*36684*/       OPC_MoveChild, 1,
/*36686*/       OPC_CheckOpcode, ISD::LOAD,
/*36688*/       OPC_RecordMemRef,
/*36689*/       OPC_RecordNode, // #0 = 'ld' chained node
/*36690*/       OPC_CheckFoldableChainNode,
/*36691*/       OPC_RecordChild1, // #1 = $src
/*36692*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*36694*/       OPC_CheckPredicate, 8, // Predicate_load
/*36696*/       OPC_MoveParent,
/*36697*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*36699*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*36702*/       OPC_EmitMergeInputChains, 1, 0, 
/*36705*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::Int_CVTSD2SI64rm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::i64, 5/*#Ops*/, 2, 3, 4, 5, 6, 
                // Src: (intrinsic_wo_chain:i64 516:iPTR, (ld:v2f64 addr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)
                // Dst: (Int_CVTSD2SI64rm:i64 addr:iPTR:$src)
/*36717*/     /*Scope*/ 11, /*->36729*/
/*36718*/       OPC_RecordChild1, // #0 = $src
/*36719*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*36721*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::Int_CVTSD2SI64rr), 0,
                    1/*#VTs*/, MVT::i64, 1/*#Ops*/, 0, 
                // Src: (intrinsic_wo_chain:i64 516:iPTR, VR128:v2f64:$src)
                // Dst: (Int_CVTSD2SI64rr:i64 VR128:v2f64:$src)
/*36729*/     0, /*End of Scope*/
/*36730*/   /*Scope*/ 52, /*->36783*/
/*36731*/     OPC_CheckInteger, 12|128,4/*524*/, 
/*36734*/     OPC_MoveParent,
/*36735*/     OPC_Scope, 33, /*->36770*/ // 2 children in Scope
/*36737*/       OPC_MoveChild, 1,
/*36739*/       OPC_CheckOpcode, ISD::LOAD,
/*36741*/       OPC_RecordMemRef,
/*36742*/       OPC_RecordNode, // #0 = 'ld' chained node
/*36743*/       OPC_CheckFoldableChainNode,
/*36744*/       OPC_RecordChild1, // #1 = $src
/*36745*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*36747*/       OPC_CheckPredicate, 8, // Predicate_load
/*36749*/       OPC_MoveParent,
/*36750*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*36752*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*36755*/       OPC_EmitMergeInputChains, 1, 0, 
/*36758*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::Int_CVTTSD2SI64rm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::i64, 5/*#Ops*/, 2, 3, 4, 5, 6, 
                // Src: (intrinsic_wo_chain:i64 524:iPTR, (ld:v2f64 addr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)
                // Dst: (Int_CVTTSD2SI64rm:i64 addr:iPTR:$src)
/*36770*/     /*Scope*/ 11, /*->36782*/
/*36771*/       OPC_RecordChild1, // #0 = $src
/*36772*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*36774*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::Int_CVTTSD2SI64rr), 0,
                    1/*#VTs*/, MVT::i64, 1/*#Ops*/, 0, 
                // Src: (intrinsic_wo_chain:i64 524:iPTR, VR128:v2f64:$src)
                // Dst: (Int_CVTTSD2SI64rr:i64 VR128:v2f64:$src)
/*36782*/     0, /*End of Scope*/
/*36783*/   /*Scope*/ 57, /*->36841*/
/*36784*/     OPC_CheckInteger, 7|128,4/*519*/, 
/*36787*/     OPC_MoveParent,
/*36788*/     OPC_RecordChild1, // #0 = $src1
/*36789*/     OPC_Scope, 36, /*->36827*/ // 2 children in Scope
/*36791*/       OPC_MoveChild, 2,
/*36793*/       OPC_CheckOpcode, ISD::LOAD,
/*36795*/       OPC_RecordMemRef,
/*36796*/       OPC_RecordNode, // #1 = 'ld' chained node
/*36797*/       OPC_CheckFoldableChainNode,
/*36798*/       OPC_RecordChild1, // #2 = $src2
/*36799*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*36801*/       OPC_CheckPredicate, 8, // Predicate_load
/*36803*/       OPC_CheckPredicate, 9, // Predicate_dsload
/*36805*/       OPC_MoveParent,
/*36806*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*36808*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*36811*/       OPC_EmitMergeInputChains, 1, 1, 
/*36814*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::Int_CVTSI2SD64rm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v2f64, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (intrinsic_wo_chain:v2f64 519:iPTR, VR128:v2f64:$src1, (ld:i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>)
                // Dst: (Int_CVTSI2SD64rm:v2f64 VR128:v2f64:$src1, addr:iPTR:$src2)
/*36827*/     /*Scope*/ 12, /*->36840*/
/*36828*/       OPC_RecordChild2, // #1 = $src2
/*36829*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*36831*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::Int_CVTSI2SD64rr), 0,
                    1/*#VTs*/, MVT::v2f64, 2/*#Ops*/, 0, 1, 
                // Src: (intrinsic_wo_chain:v2f64 519:iPTR, VR128:v2f64:$src1, GR64:i64:$src2)
                // Dst: (Int_CVTSI2SD64rr:v2f64 VR128:v2f64:$src1, GR64:i64:$src2)
/*36840*/     0, /*End of Scope*/
/*36841*/   /*Scope*/ 57, /*->36899*/
/*36842*/     OPC_CheckInteger, 50|128,5/*690*/, 
/*36845*/     OPC_MoveParent,
/*36846*/     OPC_RecordChild1, // #0 = $src1
/*36847*/     OPC_Scope, 36, /*->36885*/ // 2 children in Scope
/*36849*/       OPC_MoveChild, 2,
/*36851*/       OPC_CheckOpcode, ISD::LOAD,
/*36853*/       OPC_RecordMemRef,
/*36854*/       OPC_RecordNode, // #1 = 'ld' chained node
/*36855*/       OPC_CheckFoldableChainNode,
/*36856*/       OPC_RecordChild1, // #2 = $src2
/*36857*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*36859*/       OPC_CheckPredicate, 8, // Predicate_load
/*36861*/       OPC_CheckPredicate, 9, // Predicate_dsload
/*36863*/       OPC_MoveParent,
/*36864*/       OPC_CheckPatternPredicate, 0, // (Subtarget->hasSSE1())
/*36866*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*36869*/       OPC_EmitMergeInputChains, 1, 1, 
/*36872*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::Int_CVTSI2SS64rm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v4f32, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (intrinsic_wo_chain:v4f32 690:iPTR, VR128:v4f32:$src1, (ld:i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>)
                // Dst: (Int_CVTSI2SS64rm:v4f32 VR128:v4f32:$src1, addr:iPTR:$src2)
/*36885*/     /*Scope*/ 12, /*->36898*/
/*36886*/       OPC_RecordChild2, // #1 = $src2
/*36887*/       OPC_CheckPatternPredicate, 0, // (Subtarget->hasSSE1())
/*36889*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::Int_CVTSI2SS64rr), 0,
                    1/*#VTs*/, MVT::v4f32, 2/*#Ops*/, 0, 1, 
                // Src: (intrinsic_wo_chain:v4f32 690:iPTR, VR128:v4f32:$src1, GR64:i64:$src2)
                // Dst: (Int_CVTSI2SS64rr:v4f32 VR128:v4f32:$src1, GR64:i64:$src2)
/*36898*/     0, /*End of Scope*/
/*36899*/   /*Scope*/ 52, /*->36952*/
/*36900*/     OPC_CheckInteger, 52|128,5/*692*/, 
/*36903*/     OPC_MoveParent,
/*36904*/     OPC_Scope, 33, /*->36939*/ // 2 children in Scope
/*36906*/       OPC_MoveChild, 1,
/*36908*/       OPC_CheckOpcode, ISD::LOAD,
/*36910*/       OPC_RecordMemRef,
/*36911*/       OPC_RecordNode, // #0 = 'ld' chained node
/*36912*/       OPC_CheckFoldableChainNode,
/*36913*/       OPC_RecordChild1, // #1 = $src
/*36914*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*36916*/       OPC_CheckPredicate, 8, // Predicate_load
/*36918*/       OPC_MoveParent,
/*36919*/       OPC_CheckPatternPredicate, 0, // (Subtarget->hasSSE1())
/*36921*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*36924*/       OPC_EmitMergeInputChains, 1, 0, 
/*36927*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::Int_CVTSS2SI64rm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::i64, 5/*#Ops*/, 2, 3, 4, 5, 6, 
                // Src: (intrinsic_wo_chain:i64 692:iPTR, (ld:v4f32 addr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)
                // Dst: (Int_CVTSS2SI64rm:i64 addr:iPTR:$src)
/*36939*/     /*Scope*/ 11, /*->36951*/
/*36940*/       OPC_RecordChild1, // #0 = $src
/*36941*/       OPC_CheckPatternPredicate, 0, // (Subtarget->hasSSE1())
/*36943*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::Int_CVTSS2SI64rr), 0,
                    1/*#VTs*/, MVT::i64, 1/*#Ops*/, 0, 
                // Src: (intrinsic_wo_chain:i64 692:iPTR, VR128:v4f32:$src)
                // Dst: (Int_CVTSS2SI64rr:i64 VR128:v4f32:$src)
/*36951*/     0, /*End of Scope*/
/*36952*/   /*Scope*/ 52, /*->37005*/
/*36953*/     OPC_CheckInteger, 56|128,5/*696*/, 
/*36956*/     OPC_MoveParent,
/*36957*/     OPC_Scope, 33, /*->36992*/ // 2 children in Scope
/*36959*/       OPC_MoveChild, 1,
/*36961*/       OPC_CheckOpcode, ISD::LOAD,
/*36963*/       OPC_RecordMemRef,
/*36964*/       OPC_RecordNode, // #0 = 'ld' chained node
/*36965*/       OPC_CheckFoldableChainNode,
/*36966*/       OPC_RecordChild1, // #1 = $src
/*36967*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*36969*/       OPC_CheckPredicate, 8, // Predicate_load
/*36971*/       OPC_MoveParent,
/*36972*/       OPC_CheckPatternPredicate, 0, // (Subtarget->hasSSE1())
/*36974*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*36977*/       OPC_EmitMergeInputChains, 1, 0, 
/*36980*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::Int_CVTTSS2SI64rm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::i64, 5/*#Ops*/, 2, 3, 4, 5, 6, 
                // Src: (intrinsic_wo_chain:i64 696:iPTR, (ld:v4f32 addr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)
                // Dst: (Int_CVTTSS2SI64rm:i64 addr:iPTR:$src)
/*36992*/     /*Scope*/ 11, /*->37004*/
/*36993*/       OPC_RecordChild1, // #0 = $src
/*36994*/       OPC_CheckPatternPredicate, 0, // (Subtarget->hasSSE1())
/*36996*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::Int_CVTTSS2SI64rr), 0,
                    1/*#VTs*/, MVT::i64, 1/*#Ops*/, 0, 
                // Src: (intrinsic_wo_chain:i64 696:iPTR, VR128:v4f32:$src)
                // Dst: (Int_CVTTSS2SI64rr:i64 VR128:v4f32:$src)
/*37004*/     0, /*End of Scope*/
/*37005*/   /*Scope*/ 52, /*->37058*/
/*37006*/     OPC_CheckInteger, 51|128,5/*691*/, 
/*37009*/     OPC_MoveParent,
/*37010*/     OPC_Scope, 33, /*->37045*/ // 2 children in Scope
/*37012*/       OPC_MoveChild, 1,
/*37014*/       OPC_CheckOpcode, ISD::LOAD,
/*37016*/       OPC_RecordMemRef,
/*37017*/       OPC_RecordNode, // #0 = 'ld' chained node
/*37018*/       OPC_CheckFoldableChainNode,
/*37019*/       OPC_RecordChild1, // #1 = $src
/*37020*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*37022*/       OPC_CheckPredicate, 8, // Predicate_load
/*37024*/       OPC_MoveParent,
/*37025*/       OPC_CheckPatternPredicate, 0, // (Subtarget->hasSSE1())
/*37027*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*37030*/       OPC_EmitMergeInputChains, 1, 0, 
/*37033*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::Int_CVTSS2SIrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::i32, 5/*#Ops*/, 2, 3, 4, 5, 6, 
                // Src: (intrinsic_wo_chain:i32 691:iPTR, (ld:v4f32 addr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)
                // Dst: (Int_CVTSS2SIrm:i32 addr:iPTR:$src)
/*37045*/     /*Scope*/ 11, /*->37057*/
/*37046*/       OPC_RecordChild1, // #0 = $src
/*37047*/       OPC_CheckPatternPredicate, 0, // (Subtarget->hasSSE1())
/*37049*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::Int_CVTSS2SIrr), 0,
                    1/*#VTs*/, MVT::i32, 1/*#Ops*/, 0, 
                // Src: (intrinsic_wo_chain:i32 691:iPTR, VR128:v4f32:$src)
                // Dst: (Int_CVTSS2SIrr:i32 VR128:v4f32:$src)
/*37057*/     0, /*End of Scope*/
/*37058*/   /*Scope*/ 52, /*->37111*/
/*37059*/     OPC_CheckInteger, 48|128,5/*688*/, 
/*37062*/     OPC_MoveParent,
/*37063*/     OPC_Scope, 33, /*->37098*/ // 2 children in Scope
/*37065*/       OPC_MoveChild, 1,
/*37067*/       OPC_CheckOpcode, ISD::LOAD,
/*37069*/       OPC_RecordMemRef,
/*37070*/       OPC_RecordNode, // #0 = 'ld' chained node
/*37071*/       OPC_CheckFoldableChainNode,
/*37072*/       OPC_RecordChild1, // #1 = $src
/*37073*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*37075*/       OPC_CheckPredicate, 8, // Predicate_load
/*37077*/       OPC_MoveParent,
/*37078*/       OPC_CheckPatternPredicate, 0, // (Subtarget->hasSSE1())
/*37080*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*37083*/       OPC_EmitMergeInputChains, 1, 0, 
/*37086*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::Int_CVTPS2PIrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v2i32, 5/*#Ops*/, 2, 3, 4, 5, 6, 
                // Src: (intrinsic_wo_chain:v2i32 688:iPTR, (ld:v4f32 addr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)
                // Dst: (Int_CVTPS2PIrm:v2i32 addr:iPTR:$src)
/*37098*/     /*Scope*/ 11, /*->37110*/
/*37099*/       OPC_RecordChild1, // #0 = $src
/*37100*/       OPC_CheckPatternPredicate, 0, // (Subtarget->hasSSE1())
/*37102*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::Int_CVTPS2PIrr), 0,
                    1/*#VTs*/, MVT::v2i32, 1/*#Ops*/, 0, 
                // Src: (intrinsic_wo_chain:v2i32 688:iPTR, VR128:v4f32:$src)
                // Dst: (Int_CVTPS2PIrr:v2i32 VR128:v4f32:$src)
/*37110*/     0, /*End of Scope*/
/*37111*/   /*Scope*/ 52, /*->37164*/
/*37112*/     OPC_CheckInteger, 54|128,5/*694*/, 
/*37115*/     OPC_MoveParent,
/*37116*/     OPC_Scope, 33, /*->37151*/ // 2 children in Scope
/*37118*/       OPC_MoveChild, 1,
/*37120*/       OPC_CheckOpcode, ISD::LOAD,
/*37122*/       OPC_RecordMemRef,
/*37123*/       OPC_RecordNode, // #0 = 'ld' chained node
/*37124*/       OPC_CheckFoldableChainNode,
/*37125*/       OPC_RecordChild1, // #1 = $src
/*37126*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*37128*/       OPC_CheckPredicate, 8, // Predicate_load
/*37130*/       OPC_MoveParent,
/*37131*/       OPC_CheckPatternPredicate, 0, // (Subtarget->hasSSE1())
/*37133*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*37136*/       OPC_EmitMergeInputChains, 1, 0, 
/*37139*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::Int_CVTTPS2PIrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v2i32, 5/*#Ops*/, 2, 3, 4, 5, 6, 
                // Src: (intrinsic_wo_chain:v2i32 694:iPTR, (ld:v4f32 addr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)
                // Dst: (Int_CVTTPS2PIrm:v2i32 addr:iPTR:$src)
/*37151*/     /*Scope*/ 11, /*->37163*/
/*37152*/       OPC_RecordChild1, // #0 = $src
/*37153*/       OPC_CheckPatternPredicate, 0, // (Subtarget->hasSSE1())
/*37155*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::Int_CVTTPS2PIrr), 0,
                    1/*#VTs*/, MVT::v2i32, 1/*#Ops*/, 0, 
                // Src: (intrinsic_wo_chain:v2i32 694:iPTR, VR128:v4f32:$src)
                // Dst: (Int_CVTTPS2PIrr:v2i32 VR128:v4f32:$src)
/*37163*/     0, /*End of Scope*/
/*37164*/   /*Scope*/ 55, /*->37220*/
/*37165*/     OPC_CheckInteger, 47|128,5/*687*/, 
/*37168*/     OPC_MoveParent,
/*37169*/     OPC_RecordChild1, // #0 = $src1
/*37170*/     OPC_Scope, 34, /*->37206*/ // 2 children in Scope
/*37172*/       OPC_MoveChild, 2,
/*37174*/       OPC_CheckOpcode, ISD::LOAD,
/*37176*/       OPC_RecordMemRef,
/*37177*/       OPC_RecordNode, // #1 = 'ld' chained node
/*37178*/       OPC_CheckFoldableChainNode,
/*37179*/       OPC_RecordChild1, // #2 = $src2
/*37180*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*37182*/       OPC_CheckPredicate, 8, // Predicate_load
/*37184*/       OPC_MoveParent,
/*37185*/       OPC_CheckPatternPredicate, 0, // (Subtarget->hasSSE1())
/*37187*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*37190*/       OPC_EmitMergeInputChains, 1, 1, 
/*37193*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::Int_CVTPI2PSrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v4f32, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (intrinsic_wo_chain:v4f32 687:iPTR, VR128:v4f32:$src1, (ld:v2i32 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)
                // Dst: (Int_CVTPI2PSrm:v4f32 VR128:v4f32:$src1, addr:iPTR:$src2)
/*37206*/     /*Scope*/ 12, /*->37219*/
/*37207*/       OPC_RecordChild2, // #1 = $src2
/*37208*/       OPC_CheckPatternPredicate, 0, // (Subtarget->hasSSE1())
/*37210*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::Int_CVTPI2PSrr), 0,
                    1/*#VTs*/, MVT::v4f32, 2/*#Ops*/, 0, 1, 
                // Src: (intrinsic_wo_chain:v4f32 687:iPTR, VR128:v4f32:$src1, VR64:v2i32:$src2)
                // Dst: (Int_CVTPI2PSrr:v4f32 VR128:v4f32:$src1, VR64:v2i32:$src2)
/*37219*/     0, /*End of Scope*/
/*37220*/   /*Scope*/ 52, /*->37273*/
/*37221*/     OPC_CheckInteger, 55|128,5/*695*/, 
/*37224*/     OPC_MoveParent,
/*37225*/     OPC_Scope, 33, /*->37260*/ // 2 children in Scope
/*37227*/       OPC_MoveChild, 1,
/*37229*/       OPC_CheckOpcode, ISD::LOAD,
/*37231*/       OPC_RecordMemRef,
/*37232*/       OPC_RecordNode, // #0 = 'ld' chained node
/*37233*/       OPC_CheckFoldableChainNode,
/*37234*/       OPC_RecordChild1, // #1 = $src
/*37235*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*37237*/       OPC_CheckPredicate, 8, // Predicate_load
/*37239*/       OPC_MoveParent,
/*37240*/       OPC_CheckPatternPredicate, 0, // (Subtarget->hasSSE1())
/*37242*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*37245*/       OPC_EmitMergeInputChains, 1, 0, 
/*37248*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::Int_CVTTSS2SIrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::i32, 5/*#Ops*/, 2, 3, 4, 5, 6, 
                // Src: (intrinsic_wo_chain:i32 695:iPTR, (ld:v4f32 addr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)
                // Dst: (Int_CVTTSS2SIrm:i32 addr:iPTR:$src)
/*37260*/     /*Scope*/ 11, /*->37272*/
/*37261*/       OPC_RecordChild1, // #0 = $src
/*37262*/       OPC_CheckPatternPredicate, 0, // (Subtarget->hasSSE1())
/*37264*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::Int_CVTTSS2SIrr), 0,
                    1/*#VTs*/, MVT::i32, 1/*#Ops*/, 0, 
                // Src: (intrinsic_wo_chain:i32 695:iPTR, VR128:v4f32:$src)
                // Dst: (Int_CVTTSS2SIrr:i32 VR128:v4f32:$src)
/*37272*/     0, /*End of Scope*/
/*37273*/   /*Scope*/ 55, /*->37329*/
/*37274*/     OPC_CheckInteger, 49|128,5/*689*/, 
/*37277*/     OPC_MoveParent,
/*37278*/     OPC_RecordChild1, // #0 = $src1
/*37279*/     OPC_Scope, 34, /*->37315*/ // 2 children in Scope
/*37281*/       OPC_MoveChild, 2,
/*37283*/       OPC_CheckOpcode, ISD::LOAD,
/*37285*/       OPC_RecordMemRef,
/*37286*/       OPC_RecordNode, // #1 = 'ld' chained node
/*37287*/       OPC_CheckFoldableChainNode,
/*37288*/       OPC_RecordChild1, // #2 = $src2
/*37289*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*37291*/       OPC_CheckPredicate, 3, // Predicate_loadi32
/*37293*/       OPC_MoveParent,
/*37294*/       OPC_CheckPatternPredicate, 0, // (Subtarget->hasSSE1())
/*37296*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*37299*/       OPC_EmitMergeInputChains, 1, 1, 
/*37302*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::Int_CVTSI2SSrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v4f32, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (intrinsic_wo_chain:v4f32 689:iPTR, VR128:v4f32:$src1, (ld:i32 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)
                // Dst: (Int_CVTSI2SSrm:v4f32 VR128:v4f32:$src1, addr:iPTR:$src2)
/*37315*/     /*Scope*/ 12, /*->37328*/
/*37316*/       OPC_RecordChild2, // #1 = $src2
/*37317*/       OPC_CheckPatternPredicate, 0, // (Subtarget->hasSSE1())
/*37319*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::Int_CVTSI2SSrr), 0,
                    1/*#VTs*/, MVT::v4f32, 2/*#Ops*/, 0, 1, 
                // Src: (intrinsic_wo_chain:v4f32 689:iPTR, VR128:v4f32:$src1, GR32:i32:$src2)
                // Dst: (Int_CVTSI2SSrr:v4f32 VR128:v4f32:$src1, GR32:i32:$src2)
/*37328*/     0, /*End of Scope*/
/*37329*/   /*Scope*/ 57, /*->37387*/
/*37330*/     OPC_CheckInteger, 60|128,5/*700*/, 
/*37333*/     OPC_MoveParent,
/*37334*/     OPC_RecordChild1, // #0 = $src1
/*37335*/     OPC_Scope, 36, /*->37373*/ // 2 children in Scope
/*37337*/       OPC_MoveChild, 2,
/*37339*/       OPC_CheckOpcode, ISD::LOAD,
/*37341*/       OPC_RecordMemRef,
/*37342*/       OPC_RecordNode, // #1 = 'ld' chained node
/*37343*/       OPC_CheckFoldableChainNode,
/*37344*/       OPC_RecordChild1, // #2 = $src2
/*37345*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*37347*/       OPC_CheckPredicate, 8, // Predicate_load
/*37349*/       OPC_CheckPredicate, 23, // Predicate_memop
/*37351*/       OPC_MoveParent,
/*37352*/       OPC_CheckPatternPredicate, 0, // (Subtarget->hasSSE1())
/*37354*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*37357*/       OPC_EmitMergeInputChains, 1, 1, 
/*37360*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MAXPSrm_Int), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v4f32, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (intrinsic_wo_chain:v4f32 700:iPTR, VR128:v4f32:$src1, (ld:v4f32 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>)
                // Dst: (MAXPSrm_Int:v4f32 VR128:v4f32:$src1, addr:iPTR:$src2)
/*37373*/     /*Scope*/ 12, /*->37386*/
/*37374*/       OPC_RecordChild2, // #1 = $src2
/*37375*/       OPC_CheckPatternPredicate, 0, // (Subtarget->hasSSE1())
/*37377*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MAXPSrr_Int), 0,
                    1/*#VTs*/, MVT::v4f32, 2/*#Ops*/, 0, 1, 
                // Src: (intrinsic_wo_chain:v4f32 700:iPTR, VR128:v4f32:$src1, VR128:v4f32:$src2)
                // Dst: (MAXPSrr_Int:v4f32 VR128:v4f32:$src1, VR128:v4f32:$src2)
/*37386*/     0, /*End of Scope*/
/*37387*/   /*Scope*/ 57, /*->37445*/
/*37388*/     OPC_CheckInteger, 62|128,5/*702*/, 
/*37391*/     OPC_MoveParent,
/*37392*/     OPC_RecordChild1, // #0 = $src1
/*37393*/     OPC_Scope, 36, /*->37431*/ // 2 children in Scope
/*37395*/       OPC_MoveChild, 2,
/*37397*/       OPC_CheckOpcode, ISD::LOAD,
/*37399*/       OPC_RecordMemRef,
/*37400*/       OPC_RecordNode, // #1 = 'ld' chained node
/*37401*/       OPC_CheckFoldableChainNode,
/*37402*/       OPC_RecordChild1, // #2 = $src2
/*37403*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*37405*/       OPC_CheckPredicate, 8, // Predicate_load
/*37407*/       OPC_CheckPredicate, 23, // Predicate_memop
/*37409*/       OPC_MoveParent,
/*37410*/       OPC_CheckPatternPredicate, 0, // (Subtarget->hasSSE1())
/*37412*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*37415*/       OPC_EmitMergeInputChains, 1, 1, 
/*37418*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MINPSrm_Int), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v4f32, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (intrinsic_wo_chain:v4f32 702:iPTR, VR128:v4f32:$src1, (ld:v4f32 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>)
                // Dst: (MINPSrm_Int:v4f32 VR128:v4f32:$src1, addr:iPTR:$src2)
/*37431*/     /*Scope*/ 12, /*->37444*/
/*37432*/       OPC_RecordChild2, // #1 = $src2
/*37433*/       OPC_CheckPatternPredicate, 0, // (Subtarget->hasSSE1())
/*37435*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MINPSrr_Int), 0,
                    1/*#VTs*/, MVT::v4f32, 2/*#Ops*/, 0, 1, 
                // Src: (intrinsic_wo_chain:v4f32 702:iPTR, VR128:v4f32:$src1, VR128:v4f32:$src2)
                // Dst: (MINPSrr_Int:v4f32 VR128:v4f32:$src1, VR128:v4f32:$src2)
/*37444*/     0, /*End of Scope*/
/*37445*/   /*Scope*/ 54, /*->37500*/
/*37446*/     OPC_CheckInteger, 72|128,5/*712*/, 
/*37449*/     OPC_MoveParent,
/*37450*/     OPC_Scope, 35, /*->37487*/ // 2 children in Scope
/*37452*/       OPC_MoveChild, 1,
/*37454*/       OPC_CheckOpcode, ISD::LOAD,
/*37456*/       OPC_RecordMemRef,
/*37457*/       OPC_RecordNode, // #0 = 'ld' chained node
/*37458*/       OPC_CheckFoldableChainNode,
/*37459*/       OPC_RecordChild1, // #1 = $src
/*37460*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*37462*/       OPC_CheckPredicate, 8, // Predicate_load
/*37464*/       OPC_CheckPredicate, 23, // Predicate_memop
/*37466*/       OPC_MoveParent,
/*37467*/       OPC_CheckPatternPredicate, 0, // (Subtarget->hasSSE1())
/*37469*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*37472*/       OPC_EmitMergeInputChains, 1, 0, 
/*37475*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::SQRTPSm_Int), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v4f32, 5/*#Ops*/, 2, 3, 4, 5, 6, 
                // Src: (intrinsic_wo_chain:v4f32 712:iPTR, (ld:v4f32 addr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>)
                // Dst: (SQRTPSm_Int:v4f32 addr:iPTR:$src)
/*37487*/     /*Scope*/ 11, /*->37499*/
/*37488*/       OPC_RecordChild1, // #0 = $src
/*37489*/       OPC_CheckPatternPredicate, 0, // (Subtarget->hasSSE1())
/*37491*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::SQRTPSr_Int), 0,
                    1/*#VTs*/, MVT::v4f32, 1/*#Ops*/, 0, 
                // Src: (intrinsic_wo_chain:v4f32 712:iPTR, VR128:v4f32:$src)
                // Dst: (SQRTPSr_Int:v4f32 VR128:v4f32:$src)
/*37499*/     0, /*End of Scope*/
/*37500*/   /*Scope*/ 54, /*->37555*/
/*37501*/     OPC_CheckInteger, 69|128,5/*709*/, 
/*37504*/     OPC_MoveParent,
/*37505*/     OPC_Scope, 35, /*->37542*/ // 2 children in Scope
/*37507*/       OPC_MoveChild, 1,
/*37509*/       OPC_CheckOpcode, ISD::LOAD,
/*37511*/       OPC_RecordMemRef,
/*37512*/       OPC_RecordNode, // #0 = 'ld' chained node
/*37513*/       OPC_CheckFoldableChainNode,
/*37514*/       OPC_RecordChild1, // #1 = $src
/*37515*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*37517*/       OPC_CheckPredicate, 8, // Predicate_load
/*37519*/       OPC_CheckPredicate, 23, // Predicate_memop
/*37521*/       OPC_MoveParent,
/*37522*/       OPC_CheckPatternPredicate, 0, // (Subtarget->hasSSE1())
/*37524*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*37527*/       OPC_EmitMergeInputChains, 1, 0, 
/*37530*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::RSQRTPSm_Int), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v4f32, 5/*#Ops*/, 2, 3, 4, 5, 6, 
                // Src: (intrinsic_wo_chain:v4f32 709:iPTR, (ld:v4f32 addr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>)
                // Dst: (RSQRTPSm_Int:v4f32 addr:iPTR:$src)
/*37542*/     /*Scope*/ 11, /*->37554*/
/*37543*/       OPC_RecordChild1, // #0 = $src
/*37544*/       OPC_CheckPatternPredicate, 0, // (Subtarget->hasSSE1())
/*37546*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::RSQRTPSr_Int), 0,
                    1/*#VTs*/, MVT::v4f32, 1/*#Ops*/, 0, 
                // Src: (intrinsic_wo_chain:v4f32 709:iPTR, VR128:v4f32:$src)
                // Dst: (RSQRTPSr_Int:v4f32 VR128:v4f32:$src)
/*37554*/     0, /*End of Scope*/
/*37555*/   /*Scope*/ 54, /*->37610*/
/*37556*/     OPC_CheckInteger, 67|128,5/*707*/, 
/*37559*/     OPC_MoveParent,
/*37560*/     OPC_Scope, 35, /*->37597*/ // 2 children in Scope
/*37562*/       OPC_MoveChild, 1,
/*37564*/       OPC_CheckOpcode, ISD::LOAD,
/*37566*/       OPC_RecordMemRef,
/*37567*/       OPC_RecordNode, // #0 = 'ld' chained node
/*37568*/       OPC_CheckFoldableChainNode,
/*37569*/       OPC_RecordChild1, // #1 = $src
/*37570*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*37572*/       OPC_CheckPredicate, 8, // Predicate_load
/*37574*/       OPC_CheckPredicate, 23, // Predicate_memop
/*37576*/       OPC_MoveParent,
/*37577*/       OPC_CheckPatternPredicate, 0, // (Subtarget->hasSSE1())
/*37579*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*37582*/       OPC_EmitMergeInputChains, 1, 0, 
/*37585*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::RCPPSm_Int), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v4f32, 5/*#Ops*/, 2, 3, 4, 5, 6, 
                // Src: (intrinsic_wo_chain:v4f32 707:iPTR, (ld:v4f32 addr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>)
                // Dst: (RCPPSm_Int:v4f32 addr:iPTR:$src)
/*37597*/     /*Scope*/ 11, /*->37609*/
/*37598*/       OPC_RecordChild1, // #0 = $src
/*37599*/       OPC_CheckPatternPredicate, 0, // (Subtarget->hasSSE1())
/*37601*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::RCPPSr_Int), 0,
                    1/*#VTs*/, MVT::v4f32, 1/*#Ops*/, 0, 
                // Src: (intrinsic_wo_chain:v4f32 707:iPTR, VR128:v4f32:$src)
                // Dst: (RCPPSr_Int:v4f32 VR128:v4f32:$src)
/*37609*/     0, /*End of Scope*/
/*37610*/   /*Scope*/ 52, /*->37663*/
/*37611*/     OPC_CheckInteger, 3|128,4/*515*/, 
/*37614*/     OPC_MoveParent,
/*37615*/     OPC_Scope, 33, /*->37650*/ // 2 children in Scope
/*37617*/       OPC_MoveChild, 1,
/*37619*/       OPC_CheckOpcode, ISD::LOAD,
/*37621*/       OPC_RecordMemRef,
/*37622*/       OPC_RecordNode, // #0 = 'ld' chained node
/*37623*/       OPC_CheckFoldableChainNode,
/*37624*/       OPC_RecordChild1, // #1 = $src
/*37625*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*37627*/       OPC_CheckPredicate, 8, // Predicate_load
/*37629*/       OPC_MoveParent,
/*37630*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*37632*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*37635*/       OPC_EmitMergeInputChains, 1, 0, 
/*37638*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::Int_CVTSD2SIrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::i32, 5/*#Ops*/, 2, 3, 4, 5, 6, 
                // Src: (intrinsic_wo_chain:i32 515:iPTR, (ld:v2f64 addr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)
                // Dst: (Int_CVTSD2SIrm:i32 addr:iPTR:$src)
/*37650*/     /*Scope*/ 11, /*->37662*/
/*37651*/       OPC_RecordChild1, // #0 = $src
/*37652*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*37654*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::Int_CVTSD2SIrr), 0,
                    1/*#VTs*/, MVT::i32, 1/*#Ops*/, 0, 
                // Src: (intrinsic_wo_chain:i32 515:iPTR, VR128:v2f64:$src)
                // Dst: (Int_CVTSD2SIrr:i32 VR128:v2f64:$src)
/*37662*/     0, /*End of Scope*/
/*37663*/   /*Scope*/ 54, /*->37718*/
/*37664*/     OPC_CheckInteger, 45|128,5/*685*/, 
/*37667*/     OPC_MoveParent,
/*37668*/     OPC_Scope, 35, /*->37705*/ // 2 children in Scope
/*37670*/       OPC_MoveChild, 1,
/*37672*/       OPC_CheckOpcode, ISD::LOAD,
/*37674*/       OPC_RecordMemRef,
/*37675*/       OPC_RecordNode, // #0 = 'ld' chained node
/*37676*/       OPC_CheckFoldableChainNode,
/*37677*/       OPC_RecordChild1, // #1 = $src
/*37678*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*37680*/       OPC_CheckPredicate, 8, // Predicate_load
/*37682*/       OPC_CheckPredicate, 23, // Predicate_memop
/*37684*/       OPC_MoveParent,
/*37685*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*37687*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*37690*/       OPC_EmitMergeInputChains, 1, 0, 
/*37693*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::Int_CVTPD2PIrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v2i32, 5/*#Ops*/, 2, 3, 4, 5, 6, 
                // Src: (intrinsic_wo_chain:v2i32 685:iPTR, (ld:v2f64 addr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>)
                // Dst: (Int_CVTPD2PIrm:v2i32 addr:iPTR:$src)
/*37705*/     /*Scope*/ 11, /*->37717*/
/*37706*/       OPC_RecordChild1, // #0 = $src
/*37707*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*37709*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::Int_CVTPD2PIrr), 0,
                    1/*#VTs*/, MVT::v2i32, 1/*#Ops*/, 0, 
                // Src: (intrinsic_wo_chain:v2i32 685:iPTR, VR128:v2f64:$src)
                // Dst: (Int_CVTPD2PIrr:v2i32 VR128:v2f64:$src)
/*37717*/     0, /*End of Scope*/
/*37718*/   /*Scope*/ 54, /*->37773*/
/*37719*/     OPC_CheckInteger, 53|128,5/*693*/, 
/*37722*/     OPC_MoveParent,
/*37723*/     OPC_Scope, 35, /*->37760*/ // 2 children in Scope
/*37725*/       OPC_MoveChild, 1,
/*37727*/       OPC_CheckOpcode, ISD::LOAD,
/*37729*/       OPC_RecordMemRef,
/*37730*/       OPC_RecordNode, // #0 = 'ld' chained node
/*37731*/       OPC_CheckFoldableChainNode,
/*37732*/       OPC_RecordChild1, // #1 = $src
/*37733*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*37735*/       OPC_CheckPredicate, 8, // Predicate_load
/*37737*/       OPC_CheckPredicate, 23, // Predicate_memop
/*37739*/       OPC_MoveParent,
/*37740*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*37742*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*37745*/       OPC_EmitMergeInputChains, 1, 0, 
/*37748*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::Int_CVTTPD2PIrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v2i32, 5/*#Ops*/, 2, 3, 4, 5, 6, 
                // Src: (intrinsic_wo_chain:v2i32 693:iPTR, (ld:v2f64 addr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>)
                // Dst: (Int_CVTTPD2PIrm:v2i32 addr:iPTR:$src)
/*37760*/     /*Scope*/ 11, /*->37772*/
/*37761*/       OPC_RecordChild1, // #0 = $src
/*37762*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*37764*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::Int_CVTTPD2PIrr), 0,
                    1/*#VTs*/, MVT::v2i32, 1/*#Ops*/, 0, 
                // Src: (intrinsic_wo_chain:v2i32 693:iPTR, VR128:v2f64:$src)
                // Dst: (Int_CVTTPD2PIrr:v2i32 VR128:v2f64:$src)
/*37772*/     0, /*End of Scope*/
/*37773*/   /*Scope*/ 52, /*->37826*/
/*37774*/     OPC_CheckInteger, 46|128,5/*686*/, 
/*37777*/     OPC_MoveParent,
/*37778*/     OPC_Scope, 33, /*->37813*/ // 2 children in Scope
/*37780*/       OPC_MoveChild, 1,
/*37782*/       OPC_CheckOpcode, ISD::LOAD,
/*37784*/       OPC_RecordMemRef,
/*37785*/       OPC_RecordNode, // #0 = 'ld' chained node
/*37786*/       OPC_CheckFoldableChainNode,
/*37787*/       OPC_RecordChild1, // #1 = $src
/*37788*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*37790*/       OPC_CheckPredicate, 8, // Predicate_load
/*37792*/       OPC_MoveParent,
/*37793*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*37795*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*37798*/       OPC_EmitMergeInputChains, 1, 0, 
/*37801*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::Int_CVTPI2PDrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v2f64, 5/*#Ops*/, 2, 3, 4, 5, 6, 
                // Src: (intrinsic_wo_chain:v2f64 686:iPTR, (ld:v2i32 addr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)
                // Dst: (Int_CVTPI2PDrm:v2f64 addr:iPTR:$src)
/*37813*/     /*Scope*/ 11, /*->37825*/
/*37814*/       OPC_RecordChild1, // #0 = $src
/*37815*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*37817*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::Int_CVTPI2PDrr), 0,
                    1/*#VTs*/, MVT::v2f64, 1/*#Ops*/, 0, 
                // Src: (intrinsic_wo_chain:v2f64 686:iPTR, VR64:v2i32:$src)
                // Dst: (Int_CVTPI2PDrr:v2f64 VR64:v2i32:$src)
/*37825*/     0, /*End of Scope*/
/*37826*/   /*Scope*/ 52, /*->37879*/
/*37827*/     OPC_CheckInteger, 11|128,4/*523*/, 
/*37830*/     OPC_MoveParent,
/*37831*/     OPC_Scope, 33, /*->37866*/ // 2 children in Scope
/*37833*/       OPC_MoveChild, 1,
/*37835*/       OPC_CheckOpcode, ISD::LOAD,
/*37837*/       OPC_RecordMemRef,
/*37838*/       OPC_RecordNode, // #0 = 'ld' chained node
/*37839*/       OPC_CheckFoldableChainNode,
/*37840*/       OPC_RecordChild1, // #1 = $src
/*37841*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*37843*/       OPC_CheckPredicate, 8, // Predicate_load
/*37845*/       OPC_MoveParent,
/*37846*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*37848*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*37851*/       OPC_EmitMergeInputChains, 1, 0, 
/*37854*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::Int_CVTTSD2SIrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::i32, 5/*#Ops*/, 2, 3, 4, 5, 6, 
                // Src: (intrinsic_wo_chain:i32 523:iPTR, (ld:v2f64 addr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)
                // Dst: (Int_CVTTSD2SIrm:i32 addr:iPTR:$src)
/*37866*/     /*Scope*/ 11, /*->37878*/
/*37867*/       OPC_RecordChild1, // #0 = $src
/*37868*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*37870*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::Int_CVTTSD2SIrr), 0,
                    1/*#VTs*/, MVT::i32, 1/*#Ops*/, 0, 
                // Src: (intrinsic_wo_chain:i32 523:iPTR, VR128:v2f64:$src)
                // Dst: (Int_CVTTSD2SIrr:i32 VR128:v2f64:$src)
/*37878*/     0, /*End of Scope*/
/*37879*/   /*Scope*/ 57, /*->37937*/
/*37880*/     OPC_CheckInteger, 18|128,4/*530*/, 
/*37883*/     OPC_MoveParent,
/*37884*/     OPC_RecordChild1, // #0 = $src1
/*37885*/     OPC_Scope, 36, /*->37923*/ // 2 children in Scope
/*37887*/       OPC_MoveChild, 2,
/*37889*/       OPC_CheckOpcode, ISD::LOAD,
/*37891*/       OPC_RecordMemRef,
/*37892*/       OPC_RecordNode, // #1 = 'ld' chained node
/*37893*/       OPC_CheckFoldableChainNode,
/*37894*/       OPC_RecordChild1, // #2 = $src2
/*37895*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*37897*/       OPC_CheckPredicate, 8, // Predicate_load
/*37899*/       OPC_CheckPredicate, 23, // Predicate_memop
/*37901*/       OPC_MoveParent,
/*37902*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*37904*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*37907*/       OPC_EmitMergeInputChains, 1, 1, 
/*37910*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MAXPDrm_Int), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v2f64, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (intrinsic_wo_chain:v2f64 530:iPTR, VR128:v2f64:$src1, (ld:v2f64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>)
                // Dst: (MAXPDrm_Int:v2f64 VR128:v2f64:$src1, addr:iPTR:$src2)
/*37923*/     /*Scope*/ 12, /*->37936*/
/*37924*/       OPC_RecordChild2, // #1 = $src2
/*37925*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*37927*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MAXPDrr_Int), 0,
                    1/*#VTs*/, MVT::v2f64, 2/*#Ops*/, 0, 1, 
                // Src: (intrinsic_wo_chain:v2f64 530:iPTR, VR128:v2f64:$src1, VR128:v2f64:$src2)
                // Dst: (MAXPDrr_Int:v2f64 VR128:v2f64:$src1, VR128:v2f64:$src2)
/*37936*/     0, /*End of Scope*/
/*37937*/   /*Scope*/ 57, /*->37995*/
/*37938*/     OPC_CheckInteger, 21|128,4/*533*/, 
/*37941*/     OPC_MoveParent,
/*37942*/     OPC_RecordChild1, // #0 = $src1
/*37943*/     OPC_Scope, 36, /*->37981*/ // 2 children in Scope
/*37945*/       OPC_MoveChild, 2,
/*37947*/       OPC_CheckOpcode, ISD::LOAD,
/*37949*/       OPC_RecordMemRef,
/*37950*/       OPC_RecordNode, // #1 = 'ld' chained node
/*37951*/       OPC_CheckFoldableChainNode,
/*37952*/       OPC_RecordChild1, // #2 = $src2
/*37953*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*37955*/       OPC_CheckPredicate, 8, // Predicate_load
/*37957*/       OPC_CheckPredicate, 23, // Predicate_memop
/*37959*/       OPC_MoveParent,
/*37960*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*37962*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*37965*/       OPC_EmitMergeInputChains, 1, 1, 
/*37968*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MINPDrm_Int), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v2f64, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (intrinsic_wo_chain:v2f64 533:iPTR, VR128:v2f64:$src1, (ld:v2f64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>)
                // Dst: (MINPDrm_Int:v2f64 VR128:v2f64:$src1, addr:iPTR:$src2)
/*37981*/     /*Scope*/ 12, /*->37994*/
/*37982*/       OPC_RecordChild2, // #1 = $src2
/*37983*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*37985*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MINPDrr_Int), 0,
                    1/*#VTs*/, MVT::v2f64, 2/*#Ops*/, 0, 1, 
                // Src: (intrinsic_wo_chain:v2f64 533:iPTR, VR128:v2f64:$src1, VR128:v2f64:$src2)
                // Dst: (MINPDrr_Int:v2f64 VR128:v2f64:$src1, VR128:v2f64:$src2)
/*37994*/     0, /*End of Scope*/
/*37995*/   /*Scope*/ 54, /*->38050*/
/*37996*/     OPC_CheckInteger, 1|128,4/*513*/, 
/*37999*/     OPC_MoveParent,
/*38000*/     OPC_Scope, 35, /*->38037*/ // 2 children in Scope
/*38002*/       OPC_MoveChild, 1,
/*38004*/       OPC_CheckOpcode, ISD::LOAD,
/*38006*/       OPC_RecordMemRef,
/*38007*/       OPC_RecordNode, // #0 = 'ld' chained node
/*38008*/       OPC_CheckFoldableChainNode,
/*38009*/       OPC_RecordChild1, // #1 = $src
/*38010*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*38012*/       OPC_CheckPredicate, 8, // Predicate_load
/*38014*/       OPC_CheckPredicate, 23, // Predicate_memop
/*38016*/       OPC_MoveParent,
/*38017*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*38019*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*38022*/       OPC_EmitMergeInputChains, 1, 0, 
/*38025*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::Int_CVTPS2DQrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v4i32, 5/*#Ops*/, 2, 3, 4, 5, 6, 
                // Src: (intrinsic_wo_chain:v4i32 513:iPTR, (ld:v4f32 addr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>)
                // Dst: (Int_CVTPS2DQrm:v4i32 addr:iPTR:$src)
/*38037*/     /*Scope*/ 11, /*->38049*/
/*38038*/       OPC_RecordChild1, // #0 = $src
/*38039*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*38041*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::Int_CVTPS2DQrr), 0,
                    1/*#VTs*/, MVT::v4i32, 1/*#Ops*/, 0, 
                // Src: (intrinsic_wo_chain:v4i32 513:iPTR, VR128:v4f32:$src)
                // Dst: (Int_CVTPS2DQrr:v4i32 VR128:v4f32:$src)
/*38049*/     0, /*End of Scope*/
/*38050*/   /*Scope*/ 54, /*->38105*/
/*38051*/     OPC_CheckInteger, 10|128,4/*522*/, 
/*38054*/     OPC_MoveParent,
/*38055*/     OPC_Scope, 35, /*->38092*/ // 2 children in Scope
/*38057*/       OPC_MoveChild, 1,
/*38059*/       OPC_CheckOpcode, ISD::LOAD,
/*38061*/       OPC_RecordMemRef,
/*38062*/       OPC_RecordNode, // #0 = 'ld' chained node
/*38063*/       OPC_CheckFoldableChainNode,
/*38064*/       OPC_RecordChild1, // #1 = $src
/*38065*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*38067*/       OPC_CheckPredicate, 8, // Predicate_load
/*38069*/       OPC_CheckPredicate, 23, // Predicate_memop
/*38071*/       OPC_MoveParent,
/*38072*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*38074*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*38077*/       OPC_EmitMergeInputChains, 1, 0, 
/*38080*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::Int_CVTTPS2DQrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v4i32, 5/*#Ops*/, 2, 3, 4, 5, 6, 
                // Src: (intrinsic_wo_chain:v4i32 522:iPTR, (ld:v4f32 addr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>)
                // Dst: (Int_CVTTPS2DQrm:v4i32 addr:iPTR:$src)
/*38092*/     /*Scope*/ 11, /*->38104*/
/*38093*/       OPC_RecordChild1, // #0 = $src
/*38094*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*38096*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::Int_CVTTPS2DQrr), 0,
                    1/*#VTs*/, MVT::v4i32, 1/*#Ops*/, 0, 
                // Src: (intrinsic_wo_chain:v4i32 522:iPTR, VR128:v4f32:$src)
                // Dst: (Int_CVTTPS2DQrr:v4i32 VR128:v4f32:$src)
/*38104*/     0, /*End of Scope*/
/*38105*/   /*Scope*/ 54, /*->38160*/
/*38106*/     OPC_CheckInteger, 127|128,3/*511*/, 
/*38109*/     OPC_MoveParent,
/*38110*/     OPC_Scope, 35, /*->38147*/ // 2 children in Scope
/*38112*/       OPC_MoveChild, 1,
/*38114*/       OPC_CheckOpcode, ISD::LOAD,
/*38116*/       OPC_RecordMemRef,
/*38117*/       OPC_RecordNode, // #0 = 'ld' chained node
/*38118*/       OPC_CheckFoldableChainNode,
/*38119*/       OPC_RecordChild1, // #1 = $src
/*38120*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*38122*/       OPC_CheckPredicate, 8, // Predicate_load
/*38124*/       OPC_CheckPredicate, 23, // Predicate_memop
/*38126*/       OPC_MoveParent,
/*38127*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*38129*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*38132*/       OPC_EmitMergeInputChains, 1, 0, 
/*38135*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::Int_CVTPD2DQrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v4i32, 5/*#Ops*/, 2, 3, 4, 5, 6, 
                // Src: (intrinsic_wo_chain:v4i32 511:iPTR, (ld:v2f64 addr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>)
                // Dst: (Int_CVTPD2DQrm:v4i32 addr:iPTR:$src)
/*38147*/     /*Scope*/ 11, /*->38159*/
/*38148*/       OPC_RecordChild1, // #0 = $src
/*38149*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*38151*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::Int_CVTPD2DQrr), 0,
                    1/*#VTs*/, MVT::v4i32, 1/*#Ops*/, 0, 
                // Src: (intrinsic_wo_chain:v4i32 511:iPTR, VR128:v2f64:$src)
                // Dst: (Int_CVTPD2DQrr:v4i32 VR128:v2f64:$src)
/*38159*/     0, /*End of Scope*/
/*38160*/   /*Scope*/ 54, /*->38215*/
/*38161*/     OPC_CheckInteger, 9|128,4/*521*/, 
/*38164*/     OPC_MoveParent,
/*38165*/     OPC_Scope, 35, /*->38202*/ // 2 children in Scope
/*38167*/       OPC_MoveChild, 1,
/*38169*/       OPC_CheckOpcode, ISD::LOAD,
/*38171*/       OPC_RecordMemRef,
/*38172*/       OPC_RecordNode, // #0 = 'ld' chained node
/*38173*/       OPC_CheckFoldableChainNode,
/*38174*/       OPC_RecordChild1, // #1 = $src
/*38175*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*38177*/       OPC_CheckPredicate, 8, // Predicate_load
/*38179*/       OPC_CheckPredicate, 23, // Predicate_memop
/*38181*/       OPC_MoveParent,
/*38182*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*38184*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*38187*/       OPC_EmitMergeInputChains, 1, 0, 
/*38190*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::Int_CVTTPD2DQrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v4i32, 5/*#Ops*/, 2, 3, 4, 5, 6, 
                // Src: (intrinsic_wo_chain:v4i32 521:iPTR, (ld:v2f64 addr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>)
                // Dst: (Int_CVTTPD2DQrm:v4i32 addr:iPTR:$src)
/*38202*/     /*Scope*/ 11, /*->38214*/
/*38203*/       OPC_RecordChild1, // #0 = $src
/*38204*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*38206*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::Int_CVTTPD2DQrr), 0,
                    1/*#VTs*/, MVT::v4i32, 1/*#Ops*/, 0, 
                // Src: (intrinsic_wo_chain:v4i32 521:iPTR, VR128:v2f64:$src)
                // Dst: (Int_CVTTPD2DQrr:v4i32 VR128:v2f64:$src)
/*38214*/     0, /*End of Scope*/
/*38215*/   /*Scope*/ 52, /*->38268*/
/*38216*/     OPC_CheckInteger, 2|128,4/*514*/, 
/*38219*/     OPC_MoveParent,
/*38220*/     OPC_Scope, 33, /*->38255*/ // 2 children in Scope
/*38222*/       OPC_MoveChild, 1,
/*38224*/       OPC_CheckOpcode, ISD::LOAD,
/*38226*/       OPC_RecordMemRef,
/*38227*/       OPC_RecordNode, // #0 = 'ld' chained node
/*38228*/       OPC_CheckFoldableChainNode,
/*38229*/       OPC_RecordChild1, // #1 = $src
/*38230*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*38232*/       OPC_CheckPredicate, 8, // Predicate_load
/*38234*/       OPC_MoveParent,
/*38235*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*38237*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*38240*/       OPC_EmitMergeInputChains, 1, 0, 
/*38243*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::Int_CVTPS2PDrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v2f64, 5/*#Ops*/, 2, 3, 4, 5, 6, 
                // Src: (intrinsic_wo_chain:v2f64 514:iPTR, (ld:v4f32 addr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)
                // Dst: (Int_CVTPS2PDrm:v2f64 addr:iPTR:$src)
/*38255*/     /*Scope*/ 11, /*->38267*/
/*38256*/       OPC_RecordChild1, // #0 = $src
/*38257*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*38259*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::Int_CVTPS2PDrr), 0,
                    1/*#VTs*/, MVT::v2f64, 1/*#Ops*/, 0, 
                // Src: (intrinsic_wo_chain:v2f64 514:iPTR, VR128:v4f32:$src)
                // Dst: (Int_CVTPS2PDrr:v2f64 VR128:v4f32:$src)
/*38267*/     0, /*End of Scope*/
/*38268*/   /*Scope*/ 54, /*->38323*/
/*38269*/     OPC_CheckInteger, 0|128,4/*512*/, 
/*38272*/     OPC_MoveParent,
/*38273*/     OPC_Scope, 35, /*->38310*/ // 2 children in Scope
/*38275*/       OPC_MoveChild, 1,
/*38277*/       OPC_CheckOpcode, ISD::LOAD,
/*38279*/       OPC_RecordMemRef,
/*38280*/       OPC_RecordNode, // #0 = 'ld' chained node
/*38281*/       OPC_CheckFoldableChainNode,
/*38282*/       OPC_RecordChild1, // #1 = $src
/*38283*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*38285*/       OPC_CheckPredicate, 8, // Predicate_load
/*38287*/       OPC_CheckPredicate, 23, // Predicate_memop
/*38289*/       OPC_MoveParent,
/*38290*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*38292*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*38295*/       OPC_EmitMergeInputChains, 1, 0, 
/*38298*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::Int_CVTPD2PSrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v4f32, 5/*#Ops*/, 2, 3, 4, 5, 6, 
                // Src: (intrinsic_wo_chain:v4f32 512:iPTR, (ld:v2f64 addr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>)
                // Dst: (Int_CVTPD2PSrm:v4f32 addr:iPTR:$src)
/*38310*/     /*Scope*/ 11, /*->38322*/
/*38311*/       OPC_RecordChild1, // #0 = $src
/*38312*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*38314*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::Int_CVTPD2PSrr), 0,
                    1/*#VTs*/, MVT::v4f32, 1/*#Ops*/, 0, 
                // Src: (intrinsic_wo_chain:v4f32 512:iPTR, VR128:v2f64:$src)
                // Dst: (Int_CVTPD2PSrr:v4f32 VR128:v2f64:$src)
/*38322*/     0, /*End of Scope*/
/*38323*/   /*Scope*/ 55, /*->38379*/
/*38324*/     OPC_CheckInteger, 6|128,4/*518*/, 
/*38327*/     OPC_MoveParent,
/*38328*/     OPC_RecordChild1, // #0 = $src1
/*38329*/     OPC_Scope, 34, /*->38365*/ // 2 children in Scope
/*38331*/       OPC_MoveChild, 2,
/*38333*/       OPC_CheckOpcode, ISD::LOAD,
/*38335*/       OPC_RecordMemRef,
/*38336*/       OPC_RecordNode, // #1 = 'ld' chained node
/*38337*/       OPC_CheckFoldableChainNode,
/*38338*/       OPC_RecordChild1, // #2 = $src2
/*38339*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*38341*/       OPC_CheckPredicate, 3, // Predicate_loadi32
/*38343*/       OPC_MoveParent,
/*38344*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*38346*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*38349*/       OPC_EmitMergeInputChains, 1, 1, 
/*38352*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::Int_CVTSI2SDrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v2f64, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (intrinsic_wo_chain:v2f64 518:iPTR, VR128:v2f64:$src1, (ld:i32 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)
                // Dst: (Int_CVTSI2SDrm:v2f64 VR128:v2f64:$src1, addr:iPTR:$src2)
/*38365*/     /*Scope*/ 12, /*->38378*/
/*38366*/       OPC_RecordChild2, // #1 = $src2
/*38367*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*38369*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::Int_CVTSI2SDrr), 0,
                    1/*#VTs*/, MVT::v2f64, 2/*#Ops*/, 0, 1, 
                // Src: (intrinsic_wo_chain:v2f64 518:iPTR, VR128:v2f64:$src1, GR32:i32:$src2)
                // Dst: (Int_CVTSI2SDrr:v2f64 VR128:v2f64:$src1, GR32:i32:$src2)
/*38378*/     0, /*End of Scope*/
/*38379*/   /*Scope*/ 55, /*->38435*/
/*38380*/     OPC_CheckInteger, 5|128,4/*517*/, 
/*38383*/     OPC_MoveParent,
/*38384*/     OPC_RecordChild1, // #0 = $src1
/*38385*/     OPC_Scope, 34, /*->38421*/ // 2 children in Scope
/*38387*/       OPC_MoveChild, 2,
/*38389*/       OPC_CheckOpcode, ISD::LOAD,
/*38391*/       OPC_RecordMemRef,
/*38392*/       OPC_RecordNode, // #1 = 'ld' chained node
/*38393*/       OPC_CheckFoldableChainNode,
/*38394*/       OPC_RecordChild1, // #2 = $src2
/*38395*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*38397*/       OPC_CheckPredicate, 8, // Predicate_load
/*38399*/       OPC_MoveParent,
/*38400*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*38402*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*38405*/       OPC_EmitMergeInputChains, 1, 1, 
/*38408*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::Int_CVTSD2SSrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v4f32, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (intrinsic_wo_chain:v4f32 517:iPTR, VR128:v4f32:$src1, (ld:v2f64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)
                // Dst: (Int_CVTSD2SSrm:v4f32 VR128:v4f32:$src1, addr:iPTR:$src2)
/*38421*/     /*Scope*/ 12, /*->38434*/
/*38422*/       OPC_RecordChild2, // #1 = $src2
/*38423*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*38425*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::Int_CVTSD2SSrr), 0,
                    1/*#VTs*/, MVT::v4f32, 2/*#Ops*/, 0, 1, 
                // Src: (intrinsic_wo_chain:v4f32 517:iPTR, VR128:v4f32:$src1, VR128:v2f64:$src2)
                // Dst: (Int_CVTSD2SSrr:v4f32 VR128:v4f32:$src1, VR128:v2f64:$src2)
/*38434*/     0, /*End of Scope*/
/*38435*/   /*Scope*/ 55, /*->38491*/
/*38436*/     OPC_CheckInteger, 8|128,4/*520*/, 
/*38439*/     OPC_MoveParent,
/*38440*/     OPC_RecordChild1, // #0 = $src1
/*38441*/     OPC_Scope, 34, /*->38477*/ // 2 children in Scope
/*38443*/       OPC_MoveChild, 2,
/*38445*/       OPC_CheckOpcode, ISD::LOAD,
/*38447*/       OPC_RecordMemRef,
/*38448*/       OPC_RecordNode, // #1 = 'ld' chained node
/*38449*/       OPC_CheckFoldableChainNode,
/*38450*/       OPC_RecordChild1, // #2 = $src2
/*38451*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*38453*/       OPC_CheckPredicate, 8, // Predicate_load
/*38455*/       OPC_MoveParent,
/*38456*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*38458*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*38461*/       OPC_EmitMergeInputChains, 1, 1, 
/*38464*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::Int_CVTSS2SDrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v2f64, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (intrinsic_wo_chain:v2f64 520:iPTR, VR128:v2f64:$src1, (ld:v4f32 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)
                // Dst: (Int_CVTSS2SDrm:v2f64 VR128:v2f64:$src1, addr:iPTR:$src2)
/*38477*/     /*Scope*/ 12, /*->38490*/
/*38478*/       OPC_RecordChild2, // #1 = $src2
/*38479*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*38481*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::Int_CVTSS2SDrr), 0,
                    1/*#VTs*/, MVT::v2f64, 2/*#Ops*/, 0, 1, 
                // Src: (intrinsic_wo_chain:v2f64 520:iPTR, VR128:v2f64:$src1, VR128:v4f32:$src2)
                // Dst: (Int_CVTSS2SDrr:v2f64 VR128:v2f64:$src1, VR128:v4f32:$src2)
/*38490*/     0, /*End of Scope*/
/*38491*/   /*Scope*/ 54, /*->38546*/
/*38492*/     OPC_CheckInteger, 77|128,4/*589*/, 
/*38495*/     OPC_MoveParent,
/*38496*/     OPC_Scope, 35, /*->38533*/ // 2 children in Scope
/*38498*/       OPC_MoveChild, 1,
/*38500*/       OPC_CheckOpcode, ISD::LOAD,
/*38502*/       OPC_RecordMemRef,
/*38503*/       OPC_RecordNode, // #0 = 'ld' chained node
/*38504*/       OPC_CheckFoldableChainNode,
/*38505*/       OPC_RecordChild1, // #1 = $src
/*38506*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*38508*/       OPC_CheckPredicate, 8, // Predicate_load
/*38510*/       OPC_CheckPredicate, 23, // Predicate_memop
/*38512*/       OPC_MoveParent,
/*38513*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*38515*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*38518*/       OPC_EmitMergeInputChains, 1, 0, 
/*38521*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::SQRTPDm_Int), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v2f64, 5/*#Ops*/, 2, 3, 4, 5, 6, 
                // Src: (intrinsic_wo_chain:v2f64 589:iPTR, (ld:v2f64 addr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>)
                // Dst: (SQRTPDm_Int:v2f64 addr:iPTR:$src)
/*38533*/     /*Scope*/ 11, /*->38545*/
/*38534*/       OPC_RecordChild1, // #0 = $src
/*38535*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*38537*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::SQRTPDr_Int), 0,
                    1/*#VTs*/, MVT::v2f64, 1/*#Ops*/, 0, 
                // Src: (intrinsic_wo_chain:v2f64 589:iPTR, VR128:v2f64:$src)
                // Dst: (SQRTPDr_Int:v2f64 VR128:v2f64:$src)
/*38545*/     0, /*End of Scope*/
/*38546*/   /*Scope*/ 57, /*->38604*/
/*38547*/     OPC_CheckInteger, 90|128,4/*602*/, 
/*38550*/     OPC_MoveParent,
/*38551*/     OPC_RecordChild1, // #0 = $src1
/*38552*/     OPC_Scope, 36, /*->38590*/ // 2 children in Scope
/*38554*/       OPC_MoveChild, 2,
/*38556*/       OPC_CheckOpcode, ISD::LOAD,
/*38558*/       OPC_RecordMemRef,
/*38559*/       OPC_RecordNode, // #1 = 'ld' chained node
/*38560*/       OPC_CheckFoldableChainNode,
/*38561*/       OPC_RecordChild1, // #2 = $src2
/*38562*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*38564*/       OPC_CheckPredicate, 8, // Predicate_load
/*38566*/       OPC_CheckPredicate, 23, // Predicate_memop
/*38568*/       OPC_MoveParent,
/*38569*/       OPC_CheckPatternPredicate, 9, // (Subtarget->hasSSE3())
/*38571*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*38574*/       OPC_EmitMergeInputChains, 1, 1, 
/*38577*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::ADDSUBPSrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v4f32, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (intrinsic_wo_chain:v4f32 602:iPTR, VR128:v4f32:$src1, (ld:v4f32 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>)
                // Dst: (ADDSUBPSrm:v4f32 VR128:v4f32:$src1, addr:iPTR:$src2)
/*38590*/     /*Scope*/ 12, /*->38603*/
/*38591*/       OPC_RecordChild2, // #1 = $src2
/*38592*/       OPC_CheckPatternPredicate, 9, // (Subtarget->hasSSE3())
/*38594*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::ADDSUBPSrr), 0,
                    1/*#VTs*/, MVT::v4f32, 2/*#Ops*/, 0, 1, 
                // Src: (intrinsic_wo_chain:v4f32 602:iPTR, VR128:v4f32:$src1, VR128:v4f32:$src2)
                // Dst: (ADDSUBPSrr:v4f32 VR128:v4f32:$src1, VR128:v4f32:$src2)
/*38603*/     0, /*End of Scope*/
/*38604*/   /*Scope*/ 57, /*->38662*/
/*38605*/     OPC_CheckInteger, 89|128,4/*601*/, 
/*38608*/     OPC_MoveParent,
/*38609*/     OPC_RecordChild1, // #0 = $src1
/*38610*/     OPC_Scope, 36, /*->38648*/ // 2 children in Scope
/*38612*/       OPC_MoveChild, 2,
/*38614*/       OPC_CheckOpcode, ISD::LOAD,
/*38616*/       OPC_RecordMemRef,
/*38617*/       OPC_RecordNode, // #1 = 'ld' chained node
/*38618*/       OPC_CheckFoldableChainNode,
/*38619*/       OPC_RecordChild1, // #2 = $src2
/*38620*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*38622*/       OPC_CheckPredicate, 8, // Predicate_load
/*38624*/       OPC_CheckPredicate, 23, // Predicate_memop
/*38626*/       OPC_MoveParent,
/*38627*/       OPC_CheckPatternPredicate, 9, // (Subtarget->hasSSE3())
/*38629*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*38632*/       OPC_EmitMergeInputChains, 1, 1, 
/*38635*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::ADDSUBPDrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v2f64, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (intrinsic_wo_chain:v2f64 601:iPTR, VR128:v2f64:$src1, (ld:v2f64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>)
                // Dst: (ADDSUBPDrm:v2f64 VR128:v2f64:$src1, addr:iPTR:$src2)
/*38648*/     /*Scope*/ 12, /*->38661*/
/*38649*/       OPC_RecordChild2, // #1 = $src2
/*38650*/       OPC_CheckPatternPredicate, 9, // (Subtarget->hasSSE3())
/*38652*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::ADDSUBPDrr), 0,
                    1/*#VTs*/, MVT::v2f64, 2/*#Ops*/, 0, 1, 
                // Src: (intrinsic_wo_chain:v2f64 601:iPTR, VR128:v2f64:$src1, VR128:v2f64:$src2)
                // Dst: (ADDSUBPDrr:v2f64 VR128:v2f64:$src1, VR128:v2f64:$src2)
/*38661*/     0, /*End of Scope*/
/*38662*/   /*Scope*/ 57, /*->38720*/
/*38663*/     OPC_CheckInteger, 92|128,4/*604*/, 
/*38666*/     OPC_MoveParent,
/*38667*/     OPC_RecordChild1, // #0 = $src1
/*38668*/     OPC_Scope, 36, /*->38706*/ // 2 children in Scope
/*38670*/       OPC_MoveChild, 2,
/*38672*/       OPC_CheckOpcode, ISD::LOAD,
/*38674*/       OPC_RecordMemRef,
/*38675*/       OPC_RecordNode, // #1 = 'ld' chained node
/*38676*/       OPC_CheckFoldableChainNode,
/*38677*/       OPC_RecordChild1, // #2 = $src2
/*38678*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*38680*/       OPC_CheckPredicate, 8, // Predicate_load
/*38682*/       OPC_CheckPredicate, 23, // Predicate_memop
/*38684*/       OPC_MoveParent,
/*38685*/       OPC_CheckPatternPredicate, 9, // (Subtarget->hasSSE3())
/*38687*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*38690*/       OPC_EmitMergeInputChains, 1, 1, 
/*38693*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::HADDPSrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v4f32, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (intrinsic_wo_chain:v4f32 604:iPTR, VR128:v4f32:$src1, (ld:v4f32 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>)
                // Dst: (HADDPSrm:v4f32 VR128:v4f32:$src1, addr:iPTR:$src2)
/*38706*/     /*Scope*/ 12, /*->38719*/
/*38707*/       OPC_RecordChild2, // #1 = $src2
/*38708*/       OPC_CheckPatternPredicate, 9, // (Subtarget->hasSSE3())
/*38710*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::HADDPSrr), 0,
                    1/*#VTs*/, MVT::v4f32, 2/*#Ops*/, 0, 1, 
                // Src: (intrinsic_wo_chain:v4f32 604:iPTR, VR128:v4f32:$src1, VR128:v4f32:$src2)
                // Dst: (HADDPSrr:v4f32 VR128:v4f32:$src1, VR128:v4f32:$src2)
/*38719*/     0, /*End of Scope*/
/*38720*/   /*Scope*/ 57, /*->38778*/
/*38721*/     OPC_CheckInteger, 91|128,4/*603*/, 
/*38724*/     OPC_MoveParent,
/*38725*/     OPC_RecordChild1, // #0 = $src1
/*38726*/     OPC_Scope, 36, /*->38764*/ // 2 children in Scope
/*38728*/       OPC_MoveChild, 2,
/*38730*/       OPC_CheckOpcode, ISD::LOAD,
/*38732*/       OPC_RecordMemRef,
/*38733*/       OPC_RecordNode, // #1 = 'ld' chained node
/*38734*/       OPC_CheckFoldableChainNode,
/*38735*/       OPC_RecordChild1, // #2 = $src2
/*38736*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*38738*/       OPC_CheckPredicate, 8, // Predicate_load
/*38740*/       OPC_CheckPredicate, 23, // Predicate_memop
/*38742*/       OPC_MoveParent,
/*38743*/       OPC_CheckPatternPredicate, 9, // (Subtarget->hasSSE3())
/*38745*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*38748*/       OPC_EmitMergeInputChains, 1, 1, 
/*38751*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::HADDPDrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v2f64, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (intrinsic_wo_chain:v2f64 603:iPTR, VR128:v2f64:$src1, (ld:v2f64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>)
                // Dst: (HADDPDrm:v2f64 VR128:v2f64:$src1, addr:iPTR:$src2)
/*38764*/     /*Scope*/ 12, /*->38777*/
/*38765*/       OPC_RecordChild2, // #1 = $src2
/*38766*/       OPC_CheckPatternPredicate, 9, // (Subtarget->hasSSE3())
/*38768*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::HADDPDrr), 0,
                    1/*#VTs*/, MVT::v2f64, 2/*#Ops*/, 0, 1, 
                // Src: (intrinsic_wo_chain:v2f64 603:iPTR, VR128:v2f64:$src1, VR128:v2f64:$src2)
                // Dst: (HADDPDrr:v2f64 VR128:v2f64:$src1, VR128:v2f64:$src2)
/*38777*/     0, /*End of Scope*/
/*38778*/   /*Scope*/ 57, /*->38836*/
/*38779*/     OPC_CheckInteger, 94|128,4/*606*/, 
/*38782*/     OPC_MoveParent,
/*38783*/     OPC_RecordChild1, // #0 = $src1
/*38784*/     OPC_Scope, 36, /*->38822*/ // 2 children in Scope
/*38786*/       OPC_MoveChild, 2,
/*38788*/       OPC_CheckOpcode, ISD::LOAD,
/*38790*/       OPC_RecordMemRef,
/*38791*/       OPC_RecordNode, // #1 = 'ld' chained node
/*38792*/       OPC_CheckFoldableChainNode,
/*38793*/       OPC_RecordChild1, // #2 = $src2
/*38794*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*38796*/       OPC_CheckPredicate, 8, // Predicate_load
/*38798*/       OPC_CheckPredicate, 23, // Predicate_memop
/*38800*/       OPC_MoveParent,
/*38801*/       OPC_CheckPatternPredicate, 9, // (Subtarget->hasSSE3())
/*38803*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*38806*/       OPC_EmitMergeInputChains, 1, 1, 
/*38809*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::HSUBPSrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v4f32, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (intrinsic_wo_chain:v4f32 606:iPTR, VR128:v4f32:$src1, (ld:v4f32 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>)
                // Dst: (HSUBPSrm:v4f32 VR128:v4f32:$src1, addr:iPTR:$src2)
/*38822*/     /*Scope*/ 12, /*->38835*/
/*38823*/       OPC_RecordChild2, // #1 = $src2
/*38824*/       OPC_CheckPatternPredicate, 9, // (Subtarget->hasSSE3())
/*38826*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::HSUBPSrr), 0,
                    1/*#VTs*/, MVT::v4f32, 2/*#Ops*/, 0, 1, 
                // Src: (intrinsic_wo_chain:v4f32 606:iPTR, VR128:v4f32:$src1, VR128:v4f32:$src2)
                // Dst: (HSUBPSrr:v4f32 VR128:v4f32:$src1, VR128:v4f32:$src2)
/*38835*/     0, /*End of Scope*/
/*38836*/   /*Scope*/ 57, /*->38894*/
/*38837*/     OPC_CheckInteger, 93|128,4/*605*/, 
/*38840*/     OPC_MoveParent,
/*38841*/     OPC_RecordChild1, // #0 = $src1
/*38842*/     OPC_Scope, 36, /*->38880*/ // 2 children in Scope
/*38844*/       OPC_MoveChild, 2,
/*38846*/       OPC_CheckOpcode, ISD::LOAD,
/*38848*/       OPC_RecordMemRef,
/*38849*/       OPC_RecordNode, // #1 = 'ld' chained node
/*38850*/       OPC_CheckFoldableChainNode,
/*38851*/       OPC_RecordChild1, // #2 = $src2
/*38852*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*38854*/       OPC_CheckPredicate, 8, // Predicate_load
/*38856*/       OPC_CheckPredicate, 23, // Predicate_memop
/*38858*/       OPC_MoveParent,
/*38859*/       OPC_CheckPatternPredicate, 9, // (Subtarget->hasSSE3())
/*38861*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*38864*/       OPC_EmitMergeInputChains, 1, 1, 
/*38867*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::HSUBPDrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v2f64, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (intrinsic_wo_chain:v2f64 605:iPTR, VR128:v2f64:$src1, (ld:v2f64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>)
                // Dst: (HSUBPDrm:v2f64 VR128:v2f64:$src1, addr:iPTR:$src2)
/*38880*/     /*Scope*/ 12, /*->38893*/
/*38881*/       OPC_RecordChild2, // #1 = $src2
/*38882*/       OPC_CheckPatternPredicate, 9, // (Subtarget->hasSSE3())
/*38884*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::HSUBPDrr), 0,
                    1/*#VTs*/, MVT::v2f64, 2/*#Ops*/, 0, 1, 
                // Src: (intrinsic_wo_chain:v2f64 605:iPTR, VR128:v2f64:$src1, VR128:v2f64:$src2)
                // Dst: (HSUBPDrr:v2f64 VR128:v2f64:$src1, VR128:v2f64:$src2)
/*38893*/     0, /*End of Scope*/
/*38894*/   /*Scope*/ 96, /*->38991*/
/*38895*/     OPC_CheckInteger, 9|128,5/*649*/, 
/*38898*/     OPC_MoveParent,
/*38899*/     OPC_Scope, 37, /*->38938*/ // 3 children in Scope
/*38901*/       OPC_RecordChild1, // #0 = $src1
/*38902*/       OPC_MoveChild, 2,
/*38904*/       OPC_CheckOpcode, ISD::LOAD,
/*38906*/       OPC_RecordMemRef,
/*38907*/       OPC_RecordNode, // #1 = 'ld' chained node
/*38908*/       OPC_CheckFoldableChainNode,
/*38909*/       OPC_RecordChild1, // #2 = $src2
/*38910*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*38912*/       OPC_CheckPredicate, 8, // Predicate_load
/*38914*/       OPC_CheckPredicate, 23, // Predicate_memop
/*38916*/       OPC_MoveParent,
/*38917*/       OPC_CheckPatternPredicate, 4, // (Subtarget->hasSSE41())
/*38919*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*38922*/       OPC_EmitMergeInputChains, 1, 1, 
/*38925*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PMULLDrm_int), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v4i32, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (intrinsic_wo_chain:v4i32 649:iPTR, VR128:v4i32:$src1, (ld:v4i32 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>)
                // Dst: (PMULLDrm_int:v4i32 VR128:v4i32:$src1, addr:iPTR:$src2)
/*38938*/     /*Scope*/ 37, /*->38976*/
/*38939*/       OPC_MoveChild, 1,
/*38941*/       OPC_CheckOpcode, ISD::LOAD,
/*38943*/       OPC_RecordMemRef,
/*38944*/       OPC_RecordNode, // #0 = 'ld' chained node
/*38945*/       OPC_CheckFoldableChainNode,
/*38946*/       OPC_RecordChild1, // #1 = $src2
/*38947*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*38949*/       OPC_CheckPredicate, 8, // Predicate_load
/*38951*/       OPC_CheckPredicate, 23, // Predicate_memop
/*38953*/       OPC_MoveParent,
/*38954*/       OPC_RecordChild2, // #2 = $src1
/*38955*/       OPC_CheckPatternPredicate, 4, // (Subtarget->hasSSE41())
/*38957*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*38960*/       OPC_EmitMergeInputChains, 1, 0, 
/*38963*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PMULLDrm_int), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v4i32, 6/*#Ops*/, 2, 3, 4, 5, 6, 7, 
                // Src: (intrinsic_wo_chain:v4i32 649:iPTR, (ld:v4i32 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>, VR128:v4i32:$src1)
                // Dst: (PMULLDrm_int:v4i32 VR128:v4i32:$src1, addr:iPTR:$src2)
/*38976*/     /*Scope*/ 13, /*->38990*/
/*38977*/       OPC_RecordChild1, // #0 = $src1
/*38978*/       OPC_RecordChild2, // #1 = $src2
/*38979*/       OPC_CheckPatternPredicate, 4, // (Subtarget->hasSSE41())
/*38981*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PMULLDrr_int), 0,
                    1/*#VTs*/, MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (intrinsic_wo_chain:v4i32 649:iPTR, VR128:v4i32:$src1, VR128:v4i32:$src2)
                // Dst: (PMULLDrr_int:v4i32 VR128:v4i32:$src1, VR128:v4i32:$src2)
/*38990*/     0, /*End of Scope*/
/*38991*/   /*Scope*/ 55, /*->39047*/
/*38992*/     OPC_CheckInteger, 20|128,5/*660*/, 
/*38995*/     OPC_MoveParent,
/*38996*/     OPC_RecordChild1, // #0 = $src1
/*38997*/     OPC_Scope, 34, /*->39033*/ // 2 children in Scope
/*38999*/       OPC_MoveChild, 2,
/*39001*/       OPC_CheckOpcode, ISD::LOAD,
/*39003*/       OPC_RecordMemRef,
/*39004*/       OPC_RecordNode, // #1 = 'ld' chained node
/*39005*/       OPC_CheckFoldableChainNode,
/*39006*/       OPC_RecordChild1, // #2 = $src2
/*39007*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*39009*/       OPC_CheckPredicate, 8, // Predicate_load
/*39011*/       OPC_MoveParent,
/*39012*/       OPC_CheckPatternPredicate, 14, // (Subtarget->hasSSE42())
/*39014*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*39017*/       OPC_EmitMergeInputChains, 1, 1, 
/*39020*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::CRC32m8), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::i32, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (intrinsic_wo_chain:i32 660:iPTR, GR32:i32:$src1, (ld:i8 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)
                // Dst: (CRC32m8:i32 GR32:i32:$src1, addr:iPTR:$src2)
/*39033*/     /*Scope*/ 12, /*->39046*/
/*39034*/       OPC_RecordChild2, // #1 = $src2
/*39035*/       OPC_CheckPatternPredicate, 14, // (Subtarget->hasSSE42())
/*39037*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::CRC32r8), 0,
                    1/*#VTs*/, MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (intrinsic_wo_chain:i32 660:iPTR, GR32:i32:$src1, GR8:i8:$src2)
                // Dst: (CRC32r8:i32 GR32:i32:$src1, GR8:i8:$src2)
/*39046*/     0, /*End of Scope*/
/*39047*/   /*Scope*/ 55, /*->39103*/
/*39048*/     OPC_CheckInteger, 17|128,5/*657*/, 
/*39051*/     OPC_MoveParent,
/*39052*/     OPC_RecordChild1, // #0 = $src1
/*39053*/     OPC_Scope, 34, /*->39089*/ // 2 children in Scope
/*39055*/       OPC_MoveChild, 2,
/*39057*/       OPC_CheckOpcode, ISD::LOAD,
/*39059*/       OPC_RecordMemRef,
/*39060*/       OPC_RecordNode, // #1 = 'ld' chained node
/*39061*/       OPC_CheckFoldableChainNode,
/*39062*/       OPC_RecordChild1, // #2 = $src2
/*39063*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*39065*/       OPC_CheckPredicate, 8, // Predicate_load
/*39067*/       OPC_MoveParent,
/*39068*/       OPC_CheckPatternPredicate, 14, // (Subtarget->hasSSE42())
/*39070*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*39073*/       OPC_EmitMergeInputChains, 1, 1, 
/*39076*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::CRC32m16), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::i32, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (intrinsic_wo_chain:i32 657:iPTR, GR32:i32:$src1, (ld:i16 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)
                // Dst: (CRC32m16:i32 GR32:i32:$src1, addr:iPTR:$src2)
/*39089*/     /*Scope*/ 12, /*->39102*/
/*39090*/       OPC_RecordChild2, // #1 = $src2
/*39091*/       OPC_CheckPatternPredicate, 14, // (Subtarget->hasSSE42())
/*39093*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::CRC32r16), 0,
                    1/*#VTs*/, MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (intrinsic_wo_chain:i32 657:iPTR, GR32:i32:$src1, GR16:i16:$src2)
                // Dst: (CRC32r16:i32 GR32:i32:$src1, GR16:i16:$src2)
/*39102*/     0, /*End of Scope*/
/*39103*/   /*Scope*/ 55, /*->39159*/
/*39104*/     OPC_CheckInteger, 18|128,5/*658*/, 
/*39107*/     OPC_MoveParent,
/*39108*/     OPC_RecordChild1, // #0 = $src1
/*39109*/     OPC_Scope, 34, /*->39145*/ // 2 children in Scope
/*39111*/       OPC_MoveChild, 2,
/*39113*/       OPC_CheckOpcode, ISD::LOAD,
/*39115*/       OPC_RecordMemRef,
/*39116*/       OPC_RecordNode, // #1 = 'ld' chained node
/*39117*/       OPC_CheckFoldableChainNode,
/*39118*/       OPC_RecordChild1, // #2 = $src2
/*39119*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*39121*/       OPC_CheckPredicate, 8, // Predicate_load
/*39123*/       OPC_MoveParent,
/*39124*/       OPC_CheckPatternPredicate, 14, // (Subtarget->hasSSE42())
/*39126*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*39129*/       OPC_EmitMergeInputChains, 1, 1, 
/*39132*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::CRC32m32), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::i32, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (intrinsic_wo_chain:i32 658:iPTR, GR32:i32:$src1, (ld:i32 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)
                // Dst: (CRC32m32:i32 GR32:i32:$src1, addr:iPTR:$src2)
/*39145*/     /*Scope*/ 12, /*->39158*/
/*39146*/       OPC_RecordChild2, // #1 = $src2
/*39147*/       OPC_CheckPatternPredicate, 14, // (Subtarget->hasSSE42())
/*39149*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::CRC32r32), 0,
                    1/*#VTs*/, MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (intrinsic_wo_chain:i32 658:iPTR, GR32:i32:$src1, GR32:i32:$src2)
                // Dst: (CRC32r32:i32 GR32:i32:$src1, GR32:i32:$src2)
/*39158*/     0, /*End of Scope*/
/*39159*/   /*Scope*/ 55, /*->39215*/
/*39160*/     OPC_CheckInteger, 19|128,5/*659*/, 
/*39163*/     OPC_MoveParent,
/*39164*/     OPC_RecordChild1, // #0 = $src1
/*39165*/     OPC_Scope, 34, /*->39201*/ // 2 children in Scope
/*39167*/       OPC_MoveChild, 2,
/*39169*/       OPC_CheckOpcode, ISD::LOAD,
/*39171*/       OPC_RecordMemRef,
/*39172*/       OPC_RecordNode, // #1 = 'ld' chained node
/*39173*/       OPC_CheckFoldableChainNode,
/*39174*/       OPC_RecordChild1, // #2 = $src2
/*39175*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*39177*/       OPC_CheckPredicate, 8, // Predicate_load
/*39179*/       OPC_MoveParent,
/*39180*/       OPC_CheckPatternPredicate, 14, // (Subtarget->hasSSE42())
/*39182*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*39185*/       OPC_EmitMergeInputChains, 1, 1, 
/*39188*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::CRC64m64), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::i64, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (intrinsic_wo_chain:i64 659:iPTR, GR64:i64:$src1, (ld:i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)
                // Dst: (CRC64m64:i64 GR64:i64:$src1, addr:iPTR:$src2)
/*39201*/     /*Scope*/ 12, /*->39214*/
/*39202*/       OPC_RecordChild2, // #1 = $src2
/*39203*/       OPC_CheckPatternPredicate, 14, // (Subtarget->hasSSE42())
/*39205*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::CRC64r64), 0,
                    1/*#VTs*/, MVT::i64, 2/*#Ops*/, 0, 1, 
                // Src: (intrinsic_wo_chain:i64 659:iPTR, GR64:i64:$src1, GR64:i64:$src2)
                // Dst: (CRC64r64:i64 GR64:i64:$src1, GR64:i64:$src2)
/*39214*/     0, /*End of Scope*/
/*39215*/   /*Scope*/ 52, /*->39268*/
/*39216*/     OPC_CheckInteger, 16|128,5/*656*/, 
/*39219*/     OPC_MoveParent,
/*39220*/     OPC_RecordChild1, // #0 = $src1
/*39221*/     OPC_RecordChild2, // #1 = $src2
/*39222*/     OPC_RecordChild3, // #2 = $src3
/*39223*/     OPC_MoveChild, 3,
/*39225*/     OPC_CheckOpcode, ISD::Constant,
/*39227*/     OPC_MoveParent,
/*39228*/     OPC_CheckPatternPredicate, 4, // (Subtarget->hasSSE41())
/*39230*/     OPC_Scope, 22, /*->39254*/ // 2 children in Scope
/*39232*/       OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectScalarSSELoad:$src2 #3 #4 #5 #6 #7 + chain result
/*39235*/       OPC_EmitMergeInputChains, 1, 8, 
/*39238*/       OPC_EmitConvertToTarget, 2,
/*39240*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::ROUNDSSm_Int), 0|OPFL_Chain,
                    1/*#VTs*/, MVT::v4f32, 7/*#Ops*/, 0, 3, 4, 5, 6, 7, 9, 
                // Src: (intrinsic_wo_chain:v4f32 656:iPTR, VR128:v4f32:$src1, sse_load_f32:v4f32:$src2, (imm:i32):$src3)
                // Dst: (ROUNDSSm_Int:v4f32 VR128:v4f32:$src1, sse_load_f32:v4f32:$src2, (imm:i32):$src3)
/*39254*/     /*Scope*/ 12, /*->39267*/
/*39255*/       OPC_EmitConvertToTarget, 2,
/*39257*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::ROUNDSSr_Int), 0,
                    1/*#VTs*/, MVT::v4f32, 3/*#Ops*/, 0, 1, 3, 
                // Src: (intrinsic_wo_chain:v4f32 656:iPTR, VR128:v4f32:$src1, VR128:v4f32:$src2, (imm:i32):$src3)
                // Dst: (ROUNDSSr_Int:v4f32 VR128:v4f32:$src1, VR128:v4f32:$src2, (imm:i32):$src3)
/*39267*/     0, /*End of Scope*/
/*39268*/   /*Scope*/ 52, /*->39321*/
/*39269*/     OPC_CheckInteger, 15|128,5/*655*/, 
/*39272*/     OPC_MoveParent,
/*39273*/     OPC_RecordChild1, // #0 = $src1
/*39274*/     OPC_RecordChild2, // #1 = $src2
/*39275*/     OPC_RecordChild3, // #2 = $src3
/*39276*/     OPC_MoveChild, 3,
/*39278*/     OPC_CheckOpcode, ISD::Constant,
/*39280*/     OPC_MoveParent,
/*39281*/     OPC_CheckPatternPredicate, 4, // (Subtarget->hasSSE41())
/*39283*/     OPC_Scope, 22, /*->39307*/ // 2 children in Scope
/*39285*/       OPC_CheckComplexPat, /*CP*/2, /*#*/1, // SelectScalarSSELoad:$src2 #3 #4 #5 #6 #7 + chain result
/*39288*/       OPC_EmitMergeInputChains, 1, 8, 
/*39291*/       OPC_EmitConvertToTarget, 2,
/*39293*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::ROUNDSDm_Int), 0|OPFL_Chain,
                    1/*#VTs*/, MVT::v2f64, 7/*#Ops*/, 0, 3, 4, 5, 6, 7, 9, 
                // Src: (intrinsic_wo_chain:v2f64 655:iPTR, VR128:v2f64:$src1, sse_load_f64:v2f64:$src2, (imm:i32):$src3)
                // Dst: (ROUNDSDm_Int:v2f64 VR128:v2f64:$src1, sse_load_f64:v2f64:$src2, (imm:i32):$src3)
/*39307*/     /*Scope*/ 12, /*->39320*/
/*39308*/       OPC_EmitConvertToTarget, 2,
/*39310*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::ROUNDSDr_Int), 0,
                    1/*#VTs*/, MVT::v2f64, 3/*#Ops*/, 0, 1, 3, 
                // Src: (intrinsic_wo_chain:v2f64 655:iPTR, VR128:v2f64:$src1, VR128:v2f64:$src2, (imm:i32):$src3)
                // Dst: (ROUNDSDr_Int:v2f64 VR128:v2f64:$src1, VR128:v2f64:$src2, (imm:i32):$src3)
/*39320*/     0, /*End of Scope*/
/*39321*/   /*Scope*/ 40, /*->39362*/
/*39322*/     OPC_CheckInteger, 36|128,5/*676*/, 
/*39325*/     OPC_MoveParent,
/*39326*/     OPC_RecordChild1, // #0 = $src1
/*39327*/     OPC_RecordChild2, // #1 = $src2
/*39328*/     OPC_CheckPatternPredicate, 0, // (Subtarget->hasSSE1())
/*39330*/     OPC_Scope, 19, /*->39351*/ // 2 children in Scope
/*39332*/       OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectScalarSSELoad:$src2 #2 #3 #4 #5 #6 + chain result
/*39335*/       OPC_EmitMergeInputChains, 1, 7, 
/*39338*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::ADDSSrm_Int), 0|OPFL_Chain,
                    1/*#VTs*/, MVT::v4f32, 6/*#Ops*/, 0, 2, 3, 4, 5, 6, 
                // Src: (intrinsic_wo_chain:v4f32 676:iPTR, VR128:v4f32:$src1, sse_load_f32:v4f32:$src2)
                // Dst: (ADDSSrm_Int:v4f32 VR128:v4f32:$src1, sse_load_f32:v4f32:$src2)
/*39351*/     /*Scope*/ 9, /*->39361*/
/*39352*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::ADDSSrr_Int), 0,
                    1/*#VTs*/, MVT::v4f32, 2/*#Ops*/, 0, 1, 
                // Src: (intrinsic_wo_chain:v4f32 676:iPTR, VR128:v4f32:$src1, VR128:v4f32:$src2)
                // Dst: (ADDSSrr_Int:v4f32 VR128:v4f32:$src1, VR128:v4f32:$src2)
/*39361*/     0, /*End of Scope*/
/*39362*/   /*Scope*/ 40, /*->39403*/
/*39363*/     OPC_CheckInteger, 66|128,5/*706*/, 
/*39366*/     OPC_MoveParent,
/*39367*/     OPC_RecordChild1, // #0 = $src1
/*39368*/     OPC_RecordChild2, // #1 = $src2
/*39369*/     OPC_CheckPatternPredicate, 0, // (Subtarget->hasSSE1())
/*39371*/     OPC_Scope, 19, /*->39392*/ // 2 children in Scope
/*39373*/       OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectScalarSSELoad:$src2 #2 #3 #4 #5 #6 + chain result
/*39376*/       OPC_EmitMergeInputChains, 1, 7, 
/*39379*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MULSSrm_Int), 0|OPFL_Chain,
                    1/*#VTs*/, MVT::v4f32, 6/*#Ops*/, 0, 2, 3, 4, 5, 6, 
                // Src: (intrinsic_wo_chain:v4f32 706:iPTR, VR128:v4f32:$src1, sse_load_f32:v4f32:$src2)
                // Dst: (MULSSrm_Int:v4f32 VR128:v4f32:$src1, sse_load_f32:v4f32:$src2)
/*39392*/     /*Scope*/ 9, /*->39402*/
/*39393*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MULSSrr_Int), 0,
                    1/*#VTs*/, MVT::v4f32, 2/*#Ops*/, 0, 1, 
                // Src: (intrinsic_wo_chain:v4f32 706:iPTR, VR128:v4f32:$src1, VR128:v4f32:$src2)
                // Dst: (MULSSrr_Int:v4f32 VR128:v4f32:$src1, VR128:v4f32:$src2)
/*39402*/     0, /*End of Scope*/
/*39403*/   /*Scope*/ 40, /*->39444*/
/*39404*/     OPC_CheckInteger, 76|128,5/*716*/, 
/*39407*/     OPC_MoveParent,
/*39408*/     OPC_RecordChild1, // #0 = $src1
/*39409*/     OPC_RecordChild2, // #1 = $src2
/*39410*/     OPC_CheckPatternPredicate, 0, // (Subtarget->hasSSE1())
/*39412*/     OPC_Scope, 19, /*->39433*/ // 2 children in Scope
/*39414*/       OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectScalarSSELoad:$src2 #2 #3 #4 #5 #6 + chain result
/*39417*/       OPC_EmitMergeInputChains, 1, 7, 
/*39420*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::SUBSSrm_Int), 0|OPFL_Chain,
                    1/*#VTs*/, MVT::v4f32, 6/*#Ops*/, 0, 2, 3, 4, 5, 6, 
                // Src: (intrinsic_wo_chain:v4f32 716:iPTR, VR128:v4f32:$src1, sse_load_f32:v4f32:$src2)
                // Dst: (SUBSSrm_Int:v4f32 VR128:v4f32:$src1, sse_load_f32:v4f32:$src2)
/*39433*/     /*Scope*/ 9, /*->39443*/
/*39434*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::SUBSSrr_Int), 0,
                    1/*#VTs*/, MVT::v4f32, 2/*#Ops*/, 0, 1, 
                // Src: (intrinsic_wo_chain:v4f32 716:iPTR, VR128:v4f32:$src1, VR128:v4f32:$src2)
                // Dst: (SUBSSrr_Int:v4f32 VR128:v4f32:$src1, VR128:v4f32:$src2)
/*39443*/     0, /*End of Scope*/
/*39444*/   /*Scope*/ 40, /*->39485*/
/*39445*/     OPC_CheckInteger, 57|128,5/*697*/, 
/*39448*/     OPC_MoveParent,
/*39449*/     OPC_RecordChild1, // #0 = $src1
/*39450*/     OPC_RecordChild2, // #1 = $src2
/*39451*/     OPC_CheckPatternPredicate, 0, // (Subtarget->hasSSE1())
/*39453*/     OPC_Scope, 19, /*->39474*/ // 2 children in Scope
/*39455*/       OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectScalarSSELoad:$src2 #2 #3 #4 #5 #6 + chain result
/*39458*/       OPC_EmitMergeInputChains, 1, 7, 
/*39461*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::DIVSSrm_Int), 0|OPFL_Chain,
                    1/*#VTs*/, MVT::v4f32, 6/*#Ops*/, 0, 2, 3, 4, 5, 6, 
                // Src: (intrinsic_wo_chain:v4f32 697:iPTR, VR128:v4f32:$src1, sse_load_f32:v4f32:$src2)
                // Dst: (DIVSSrm_Int:v4f32 VR128:v4f32:$src1, sse_load_f32:v4f32:$src2)
/*39474*/     /*Scope*/ 9, /*->39484*/
/*39475*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::DIVSSrr_Int), 0,
                    1/*#VTs*/, MVT::v4f32, 2/*#Ops*/, 0, 1, 
                // Src: (intrinsic_wo_chain:v4f32 697:iPTR, VR128:v4f32:$src1, VR128:v4f32:$src2)
                // Dst: (DIVSSrr_Int:v4f32 VR128:v4f32:$src1, VR128:v4f32:$src2)
/*39484*/     0, /*End of Scope*/
/*39485*/   /*Scope*/ 40, /*->39526*/
/*39486*/     OPC_CheckInteger, 61|128,5/*701*/, 
/*39489*/     OPC_MoveParent,
/*39490*/     OPC_RecordChild1, // #0 = $src1
/*39491*/     OPC_RecordChild2, // #1 = $src2
/*39492*/     OPC_CheckPatternPredicate, 0, // (Subtarget->hasSSE1())
/*39494*/     OPC_Scope, 19, /*->39515*/ // 2 children in Scope
/*39496*/       OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectScalarSSELoad:$src2 #2 #3 #4 #5 #6 + chain result
/*39499*/       OPC_EmitMergeInputChains, 1, 7, 
/*39502*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MAXSSrm_Int), 0|OPFL_Chain,
                    1/*#VTs*/, MVT::v4f32, 6/*#Ops*/, 0, 2, 3, 4, 5, 6, 
                // Src: (intrinsic_wo_chain:v4f32 701:iPTR, VR128:v4f32:$src1, sse_load_f32:v4f32:$src2)
                // Dst: (MAXSSrm_Int:v4f32 VR128:v4f32:$src1, sse_load_f32:v4f32:$src2)
/*39515*/     /*Scope*/ 9, /*->39525*/
/*39516*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MAXSSrr_Int), 0,
                    1/*#VTs*/, MVT::v4f32, 2/*#Ops*/, 0, 1, 
                // Src: (intrinsic_wo_chain:v4f32 701:iPTR, VR128:v4f32:$src1, VR128:v4f32:$src2)
                // Dst: (MAXSSrr_Int:v4f32 VR128:v4f32:$src1, VR128:v4f32:$src2)
/*39525*/     0, /*End of Scope*/
/*39526*/   /*Scope*/ 40, /*->39567*/
/*39527*/     OPC_CheckInteger, 63|128,5/*703*/, 
/*39530*/     OPC_MoveParent,
/*39531*/     OPC_RecordChild1, // #0 = $src1
/*39532*/     OPC_RecordChild2, // #1 = $src2
/*39533*/     OPC_CheckPatternPredicate, 0, // (Subtarget->hasSSE1())
/*39535*/     OPC_Scope, 19, /*->39556*/ // 2 children in Scope
/*39537*/       OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectScalarSSELoad:$src2 #2 #3 #4 #5 #6 + chain result
/*39540*/       OPC_EmitMergeInputChains, 1, 7, 
/*39543*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MINSSrm_Int), 0|OPFL_Chain,
                    1/*#VTs*/, MVT::v4f32, 6/*#Ops*/, 0, 2, 3, 4, 5, 6, 
                // Src: (intrinsic_wo_chain:v4f32 703:iPTR, VR128:v4f32:$src1, sse_load_f32:v4f32:$src2)
                // Dst: (MINSSrm_Int:v4f32 VR128:v4f32:$src1, sse_load_f32:v4f32:$src2)
/*39556*/     /*Scope*/ 9, /*->39566*/
/*39557*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MINSSrr_Int), 0,
                    1/*#VTs*/, MVT::v4f32, 2/*#Ops*/, 0, 1, 
                // Src: (intrinsic_wo_chain:v4f32 703:iPTR, VR128:v4f32:$src1, VR128:v4f32:$src2)
                // Dst: (MINSSrr_Int:v4f32 VR128:v4f32:$src1, VR128:v4f32:$src2)
/*39566*/     0, /*End of Scope*/
/*39567*/   /*Scope*/ 37, /*->39605*/
/*39568*/     OPC_CheckInteger, 73|128,5/*713*/, 
/*39571*/     OPC_MoveParent,
/*39572*/     OPC_RecordChild1, // #0 = $src
/*39573*/     OPC_CheckPatternPredicate, 0, // (Subtarget->hasSSE1())
/*39575*/     OPC_Scope, 18, /*->39595*/ // 2 children in Scope
/*39577*/       OPC_CheckComplexPat, /*CP*/1, /*#*/0, // SelectScalarSSELoad:$src #1 #2 #3 #4 #5 + chain result
/*39580*/       OPC_EmitMergeInputChains, 1, 6, 
/*39583*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::SQRTSSm_Int), 0|OPFL_Chain,
                    1/*#VTs*/, MVT::v4f32, 5/*#Ops*/, 1, 2, 3, 4, 5, 
                // Src: (intrinsic_wo_chain:v4f32 713:iPTR, sse_load_f32:v4f32:$src)
                // Dst: (SQRTSSm_Int:v4f32 sse_load_f32:v4f32:$src)
/*39595*/     /*Scope*/ 8, /*->39604*/
/*39596*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::SQRTSSr_Int), 0,
                    1/*#VTs*/, MVT::v4f32, 1/*#Ops*/, 0, 
                // Src: (intrinsic_wo_chain:v4f32 713:iPTR, VR128:v4f32:$src)
                // Dst: (SQRTSSr_Int:v4f32 VR128:v4f32:$src)
/*39604*/     0, /*End of Scope*/
/*39605*/   /*Scope*/ 37, /*->39643*/
/*39606*/     OPC_CheckInteger, 70|128,5/*710*/, 
/*39609*/     OPC_MoveParent,
/*39610*/     OPC_RecordChild1, // #0 = $src
/*39611*/     OPC_CheckPatternPredicate, 0, // (Subtarget->hasSSE1())
/*39613*/     OPC_Scope, 18, /*->39633*/ // 2 children in Scope
/*39615*/       OPC_CheckComplexPat, /*CP*/1, /*#*/0, // SelectScalarSSELoad:$src #1 #2 #3 #4 #5 + chain result
/*39618*/       OPC_EmitMergeInputChains, 1, 6, 
/*39621*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::RSQRTSSm_Int), 0|OPFL_Chain,
                    1/*#VTs*/, MVT::v4f32, 5/*#Ops*/, 1, 2, 3, 4, 5, 
                // Src: (intrinsic_wo_chain:v4f32 710:iPTR, sse_load_f32:v4f32:$src)
                // Dst: (RSQRTSSm_Int:v4f32 sse_load_f32:v4f32:$src)
/*39633*/     /*Scope*/ 8, /*->39642*/
/*39634*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::RSQRTSSr_Int), 0,
                    1/*#VTs*/, MVT::v4f32, 1/*#Ops*/, 0, 
                // Src: (intrinsic_wo_chain:v4f32 710:iPTR, VR128:v4f32:$src)
                // Dst: (RSQRTSSr_Int:v4f32 VR128:v4f32:$src)
/*39642*/     0, /*End of Scope*/
/*39643*/   /*Scope*/ 37, /*->39681*/
/*39644*/     OPC_CheckInteger, 68|128,5/*708*/, 
/*39647*/     OPC_MoveParent,
/*39648*/     OPC_RecordChild1, // #0 = $src
/*39649*/     OPC_CheckPatternPredicate, 0, // (Subtarget->hasSSE1())
/*39651*/     OPC_Scope, 18, /*->39671*/ // 2 children in Scope
/*39653*/       OPC_CheckComplexPat, /*CP*/1, /*#*/0, // SelectScalarSSELoad:$src #1 #2 #3 #4 #5 + chain result
/*39656*/       OPC_EmitMergeInputChains, 1, 6, 
/*39659*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::RCPSSm_Int), 0|OPFL_Chain,
                    1/*#VTs*/, MVT::v4f32, 5/*#Ops*/, 1, 2, 3, 4, 5, 
                // Src: (intrinsic_wo_chain:v4f32 708:iPTR, sse_load_f32:v4f32:$src)
                // Dst: (RCPSSm_Int:v4f32 sse_load_f32:v4f32:$src)
/*39671*/     /*Scope*/ 8, /*->39680*/
/*39672*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::RCPSSr_Int), 0,
                    1/*#VTs*/, MVT::v4f32, 1/*#Ops*/, 0, 
                // Src: (intrinsic_wo_chain:v4f32 708:iPTR, VR128:v4f32:$src)
                // Dst: (RCPSSr_Int:v4f32 VR128:v4f32:$src)
/*39680*/     0, /*End of Scope*/
/*39681*/   /*Scope*/ 40, /*->39722*/
/*39682*/     OPC_CheckInteger, 115|128,3/*499*/, 
/*39685*/     OPC_MoveParent,
/*39686*/     OPC_RecordChild1, // #0 = $src1
/*39687*/     OPC_RecordChild2, // #1 = $src2
/*39688*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*39690*/     OPC_Scope, 19, /*->39711*/ // 2 children in Scope
/*39692*/       OPC_CheckComplexPat, /*CP*/2, /*#*/1, // SelectScalarSSELoad:$src2 #2 #3 #4 #5 #6 + chain result
/*39695*/       OPC_EmitMergeInputChains, 1, 7, 
/*39698*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::ADDSDrm_Int), 0|OPFL_Chain,
                    1/*#VTs*/, MVT::v2f64, 6/*#Ops*/, 0, 2, 3, 4, 5, 6, 
                // Src: (intrinsic_wo_chain:v2f64 499:iPTR, VR128:v2f64:$src1, sse_load_f64:v2f64:$src2)
                // Dst: (ADDSDrm_Int:v2f64 VR128:v2f64:$src1, sse_load_f64:v2f64:$src2)
/*39711*/     /*Scope*/ 9, /*->39721*/
/*39712*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::ADDSDrr_Int), 0,
                    1/*#VTs*/, MVT::v2f64, 2/*#Ops*/, 0, 1, 
                // Src: (intrinsic_wo_chain:v2f64 499:iPTR, VR128:v2f64:$src1, VR128:v2f64:$src2)
                // Dst: (ADDSDrr_Int:v2f64 VR128:v2f64:$src1, VR128:v2f64:$src2)
/*39721*/     0, /*End of Scope*/
/*39722*/   /*Scope*/ 40, /*->39763*/
/*39723*/     OPC_CheckInteger, 27|128,4/*539*/, 
/*39726*/     OPC_MoveParent,
/*39727*/     OPC_RecordChild1, // #0 = $src1
/*39728*/     OPC_RecordChild2, // #1 = $src2
/*39729*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*39731*/     OPC_Scope, 19, /*->39752*/ // 2 children in Scope
/*39733*/       OPC_CheckComplexPat, /*CP*/2, /*#*/1, // SelectScalarSSELoad:$src2 #2 #3 #4 #5 #6 + chain result
/*39736*/       OPC_EmitMergeInputChains, 1, 7, 
/*39739*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MULSDrm_Int), 0|OPFL_Chain,
                    1/*#VTs*/, MVT::v2f64, 6/*#Ops*/, 0, 2, 3, 4, 5, 6, 
                // Src: (intrinsic_wo_chain:v2f64 539:iPTR, VR128:v2f64:$src1, sse_load_f64:v2f64:$src2)
                // Dst: (MULSDrm_Int:v2f64 VR128:v2f64:$src1, sse_load_f64:v2f64:$src2)
/*39752*/     /*Scope*/ 9, /*->39762*/
/*39753*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MULSDrr_Int), 0,
                    1/*#VTs*/, MVT::v2f64, 2/*#Ops*/, 0, 1, 
                // Src: (intrinsic_wo_chain:v2f64 539:iPTR, VR128:v2f64:$src1, VR128:v2f64:$src2)
                // Dst: (MULSDrr_Int:v2f64 VR128:v2f64:$src1, VR128:v2f64:$src2)
/*39762*/     0, /*End of Scope*/
/*39763*/   /*Scope*/ 40, /*->39804*/
/*39764*/     OPC_CheckInteger, 82|128,4/*594*/, 
/*39767*/     OPC_MoveParent,
/*39768*/     OPC_RecordChild1, // #0 = $src1
/*39769*/     OPC_RecordChild2, // #1 = $src2
/*39770*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*39772*/     OPC_Scope, 19, /*->39793*/ // 2 children in Scope
/*39774*/       OPC_CheckComplexPat, /*CP*/2, /*#*/1, // SelectScalarSSELoad:$src2 #2 #3 #4 #5 #6 + chain result
/*39777*/       OPC_EmitMergeInputChains, 1, 7, 
/*39780*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::SUBSDrm_Int), 0|OPFL_Chain,
                    1/*#VTs*/, MVT::v2f64, 6/*#Ops*/, 0, 2, 3, 4, 5, 6, 
                // Src: (intrinsic_wo_chain:v2f64 594:iPTR, VR128:v2f64:$src1, sse_load_f64:v2f64:$src2)
                // Dst: (SUBSDrm_Int:v2f64 VR128:v2f64:$src1, sse_load_f64:v2f64:$src2)
/*39793*/     /*Scope*/ 9, /*->39803*/
/*39794*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::SUBSDrr_Int), 0,
                    1/*#VTs*/, MVT::v2f64, 2/*#Ops*/, 0, 1, 
                // Src: (intrinsic_wo_chain:v2f64 594:iPTR, VR128:v2f64:$src1, VR128:v2f64:$src2)
                // Dst: (SUBSDrr_Int:v2f64 VR128:v2f64:$src1, VR128:v2f64:$src2)
/*39803*/     0, /*End of Scope*/
/*39804*/   /*Scope*/ 40, /*->39845*/
/*39805*/     OPC_CheckInteger, 13|128,4/*525*/, 
/*39808*/     OPC_MoveParent,
/*39809*/     OPC_RecordChild1, // #0 = $src1
/*39810*/     OPC_RecordChild2, // #1 = $src2
/*39811*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*39813*/     OPC_Scope, 19, /*->39834*/ // 2 children in Scope
/*39815*/       OPC_CheckComplexPat, /*CP*/2, /*#*/1, // SelectScalarSSELoad:$src2 #2 #3 #4 #5 #6 + chain result
/*39818*/       OPC_EmitMergeInputChains, 1, 7, 
/*39821*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::DIVSDrm_Int), 0|OPFL_Chain,
                    1/*#VTs*/, MVT::v2f64, 6/*#Ops*/, 0, 2, 3, 4, 5, 6, 
                // Src: (intrinsic_wo_chain:v2f64 525:iPTR, VR128:v2f64:$src1, sse_load_f64:v2f64:$src2)
                // Dst: (DIVSDrm_Int:v2f64 VR128:v2f64:$src1, sse_load_f64:v2f64:$src2)
/*39834*/     /*Scope*/ 9, /*->39844*/
/*39835*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::DIVSDrr_Int), 0,
                    1/*#VTs*/, MVT::v2f64, 2/*#Ops*/, 0, 1, 
                // Src: (intrinsic_wo_chain:v2f64 525:iPTR, VR128:v2f64:$src1, VR128:v2f64:$src2)
                // Dst: (DIVSDrr_Int:v2f64 VR128:v2f64:$src1, VR128:v2f64:$src2)
/*39844*/     0, /*End of Scope*/
/*39845*/   /*Scope*/ 40, /*->39886*/
/*39846*/     OPC_CheckInteger, 19|128,4/*531*/, 
/*39849*/     OPC_MoveParent,
/*39850*/     OPC_RecordChild1, // #0 = $src1
/*39851*/     OPC_RecordChild2, // #1 = $src2
/*39852*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*39854*/     OPC_Scope, 19, /*->39875*/ // 2 children in Scope
/*39856*/       OPC_CheckComplexPat, /*CP*/2, /*#*/1, // SelectScalarSSELoad:$src2 #2 #3 #4 #5 #6 + chain result
/*39859*/       OPC_EmitMergeInputChains, 1, 7, 
/*39862*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MAXSDrm_Int), 0|OPFL_Chain,
                    1/*#VTs*/, MVT::v2f64, 6/*#Ops*/, 0, 2, 3, 4, 5, 6, 
                // Src: (intrinsic_wo_chain:v2f64 531:iPTR, VR128:v2f64:$src1, sse_load_f64:v2f64:$src2)
                // Dst: (MAXSDrm_Int:v2f64 VR128:v2f64:$src1, sse_load_f64:v2f64:$src2)
/*39875*/     /*Scope*/ 9, /*->39885*/
/*39876*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MAXSDrr_Int), 0,
                    1/*#VTs*/, MVT::v2f64, 2/*#Ops*/, 0, 1, 
                // Src: (intrinsic_wo_chain:v2f64 531:iPTR, VR128:v2f64:$src1, VR128:v2f64:$src2)
                // Dst: (MAXSDrr_Int:v2f64 VR128:v2f64:$src1, VR128:v2f64:$src2)
/*39885*/     0, /*End of Scope*/
/*39886*/   /*Scope*/ 40, /*->39927*/
/*39887*/     OPC_CheckInteger, 22|128,4/*534*/, 
/*39890*/     OPC_MoveParent,
/*39891*/     OPC_RecordChild1, // #0 = $src1
/*39892*/     OPC_RecordChild2, // #1 = $src2
/*39893*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*39895*/     OPC_Scope, 19, /*->39916*/ // 2 children in Scope
/*39897*/       OPC_CheckComplexPat, /*CP*/2, /*#*/1, // SelectScalarSSELoad:$src2 #2 #3 #4 #5 #6 + chain result
/*39900*/       OPC_EmitMergeInputChains, 1, 7, 
/*39903*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MINSDrm_Int), 0|OPFL_Chain,
                    1/*#VTs*/, MVT::v2f64, 6/*#Ops*/, 0, 2, 3, 4, 5, 6, 
                // Src: (intrinsic_wo_chain:v2f64 534:iPTR, VR128:v2f64:$src1, sse_load_f64:v2f64:$src2)
                // Dst: (MINSDrm_Int:v2f64 VR128:v2f64:$src1, sse_load_f64:v2f64:$src2)
/*39916*/     /*Scope*/ 9, /*->39926*/
/*39917*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MINSDrr_Int), 0,
                    1/*#VTs*/, MVT::v2f64, 2/*#Ops*/, 0, 1, 
                // Src: (intrinsic_wo_chain:v2f64 534:iPTR, VR128:v2f64:$src1, VR128:v2f64:$src2)
                // Dst: (MINSDrr_Int:v2f64 VR128:v2f64:$src1, VR128:v2f64:$src2)
/*39926*/     0, /*End of Scope*/
/*39927*/   /*Scope*/ 37, /*->39965*/
/*39928*/     OPC_CheckInteger, 78|128,4/*590*/, 
/*39931*/     OPC_MoveParent,
/*39932*/     OPC_RecordChild1, // #0 = $src
/*39933*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*39935*/     OPC_Scope, 18, /*->39955*/ // 2 children in Scope
/*39937*/       OPC_CheckComplexPat, /*CP*/2, /*#*/0, // SelectScalarSSELoad:$src #1 #2 #3 #4 #5 + chain result
/*39940*/       OPC_EmitMergeInputChains, 1, 6, 
/*39943*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::SQRTSDm_Int), 0|OPFL_Chain,
                    1/*#VTs*/, MVT::v2f64, 5/*#Ops*/, 1, 2, 3, 4, 5, 
                // Src: (intrinsic_wo_chain:v2f64 590:iPTR, sse_load_f64:v2f64:$src)
                // Dst: (SQRTSDm_Int:v2f64 sse_load_f64:v2f64:$src)
/*39955*/     /*Scope*/ 8, /*->39964*/
/*39956*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::SQRTSDr_Int), 0,
                    1/*#VTs*/, MVT::v2f64, 1/*#Ops*/, 0, 
                // Src: (intrinsic_wo_chain:v2f64 590:iPTR, VR128:v2f64:$src)
                // Dst: (SQRTSDr_Int:v2f64 VR128:v2f64:$src)
/*39964*/     0, /*End of Scope*/
/*39965*/   /*Scope*/ 24, /*->39990*/
/*39966*/     OPC_CheckInteger, 60|128,4/*572*/, 
/*39969*/     OPC_MoveParent,
/*39970*/     OPC_RecordChild1, // #0 = $src1
/*39971*/     OPC_RecordChild2, // #1 = $src2
/*39972*/     OPC_MoveChild, 2,
/*39974*/     OPC_CheckOpcode, ISD::Constant,
/*39976*/     OPC_MoveParent,
/*39977*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*39979*/     OPC_EmitConvertToTarget, 1,
/*39981*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::PSLLWri), 0,
                  1/*#VTs*/, MVT::v8i16, 2/*#Ops*/, 0, 2, 
              // Src: (intrinsic_wo_chain:v8i16 572:iPTR, VR128:v8i16:$src1, (imm:i32):$src2)
              // Dst: (PSLLWri:v8i16 VR128:v8i16:$src1, (imm:i32):$src2)
/*39990*/   /*Scope*/ 24, /*->40015*/
/*39991*/     OPC_CheckInteger, 58|128,4/*570*/, 
/*39994*/     OPC_MoveParent,
/*39995*/     OPC_RecordChild1, // #0 = $src1
/*39996*/     OPC_RecordChild2, // #1 = $src2
/*39997*/     OPC_MoveChild, 2,
/*39999*/     OPC_CheckOpcode, ISD::Constant,
/*40001*/     OPC_MoveParent,
/*40002*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*40004*/     OPC_EmitConvertToTarget, 1,
/*40006*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::PSLLDri), 0,
                  1/*#VTs*/, MVT::v4i32, 2/*#Ops*/, 0, 2, 
              // Src: (intrinsic_wo_chain:v4i32 570:iPTR, VR128:v4i32:$src1, (imm:i32):$src2)
              // Dst: (PSLLDri:v4i32 VR128:v4i32:$src1, (imm:i32):$src2)
/*40015*/   /*Scope*/ 24, /*->40040*/
/*40016*/     OPC_CheckInteger, 59|128,4/*571*/, 
/*40019*/     OPC_MoveParent,
/*40020*/     OPC_RecordChild1, // #0 = $src1
/*40021*/     OPC_RecordChild2, // #1 = $src2
/*40022*/     OPC_MoveChild, 2,
/*40024*/     OPC_CheckOpcode, ISD::Constant,
/*40026*/     OPC_MoveParent,
/*40027*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*40029*/     OPC_EmitConvertToTarget, 1,
/*40031*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::PSLLQri), 0,
                  1/*#VTs*/, MVT::v2i64, 2/*#Ops*/, 0, 2, 
              // Src: (intrinsic_wo_chain:v2i64 571:iPTR, VR128:v2i64:$src1, (imm:i32):$src2)
              // Dst: (PSLLQri:v2i64 VR128:v2i64:$src1, (imm:i32):$src2)
/*40040*/   /*Scope*/ 24, /*->40065*/
/*40041*/     OPC_CheckInteger, 72|128,4/*584*/, 
/*40044*/     OPC_MoveParent,
/*40045*/     OPC_RecordChild1, // #0 = $src1
/*40046*/     OPC_RecordChild2, // #1 = $src2
/*40047*/     OPC_MoveChild, 2,
/*40049*/     OPC_CheckOpcode, ISD::Constant,
/*40051*/     OPC_MoveParent,
/*40052*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*40054*/     OPC_EmitConvertToTarget, 1,
/*40056*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::PSRLWri), 0,
                  1/*#VTs*/, MVT::v8i16, 2/*#Ops*/, 0, 2, 
              // Src: (intrinsic_wo_chain:v8i16 584:iPTR, VR128:v8i16:$src1, (imm:i32):$src2)
              // Dst: (PSRLWri:v8i16 VR128:v8i16:$src1, (imm:i32):$src2)
/*40065*/   /*Scope*/ 24, /*->40090*/
/*40066*/     OPC_CheckInteger, 70|128,4/*582*/, 
/*40069*/     OPC_MoveParent,
/*40070*/     OPC_RecordChild1, // #0 = $src1
/*40071*/     OPC_RecordChild2, // #1 = $src2
/*40072*/     OPC_MoveChild, 2,
/*40074*/     OPC_CheckOpcode, ISD::Constant,
/*40076*/     OPC_MoveParent,
/*40077*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*40079*/     OPC_EmitConvertToTarget, 1,
/*40081*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::PSRLDri), 0,
                  1/*#VTs*/, MVT::v4i32, 2/*#Ops*/, 0, 2, 
              // Src: (intrinsic_wo_chain:v4i32 582:iPTR, VR128:v4i32:$src1, (imm:i32):$src2)
              // Dst: (PSRLDri:v4i32 VR128:v4i32:$src1, (imm:i32):$src2)
/*40090*/   /*Scope*/ 24, /*->40115*/
/*40091*/     OPC_CheckInteger, 71|128,4/*583*/, 
/*40094*/     OPC_MoveParent,
/*40095*/     OPC_RecordChild1, // #0 = $src1
/*40096*/     OPC_RecordChild2, // #1 = $src2
/*40097*/     OPC_MoveChild, 2,
/*40099*/     OPC_CheckOpcode, ISD::Constant,
/*40101*/     OPC_MoveParent,
/*40102*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*40104*/     OPC_EmitConvertToTarget, 1,
/*40106*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::PSRLQri), 0,
                  1/*#VTs*/, MVT::v2i64, 2/*#Ops*/, 0, 2, 
              // Src: (intrinsic_wo_chain:v2i64 583:iPTR, VR128:v2i64:$src1, (imm:i32):$src2)
              // Dst: (PSRLQri:v2i64 VR128:v2i64:$src1, (imm:i32):$src2)
/*40115*/   /*Scope*/ 24, /*->40140*/
/*40116*/     OPC_CheckInteger, 64|128,4/*576*/, 
/*40119*/     OPC_MoveParent,
/*40120*/     OPC_RecordChild1, // #0 = $src1
/*40121*/     OPC_RecordChild2, // #1 = $src2
/*40122*/     OPC_MoveChild, 2,
/*40124*/     OPC_CheckOpcode, ISD::Constant,
/*40126*/     OPC_MoveParent,
/*40127*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*40129*/     OPC_EmitConvertToTarget, 1,
/*40131*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::PSRAWri), 0,
                  1/*#VTs*/, MVT::v8i16, 2/*#Ops*/, 0, 2, 
              // Src: (intrinsic_wo_chain:v8i16 576:iPTR, VR128:v8i16:$src1, (imm:i32):$src2)
              // Dst: (PSRAWri:v8i16 VR128:v8i16:$src1, (imm:i32):$src2)
/*40140*/   /*Scope*/ 24, /*->40165*/
/*40141*/     OPC_CheckInteger, 63|128,4/*575*/, 
/*40144*/     OPC_MoveParent,
/*40145*/     OPC_RecordChild1, // #0 = $src1
/*40146*/     OPC_RecordChild2, // #1 = $src2
/*40147*/     OPC_MoveChild, 2,
/*40149*/     OPC_CheckOpcode, ISD::Constant,
/*40151*/     OPC_MoveParent,
/*40152*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*40154*/     OPC_EmitConvertToTarget, 1,
/*40156*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::PSRADri), 0,
                  1/*#VTs*/, MVT::v4i32, 2/*#Ops*/, 0, 2, 
              // Src: (intrinsic_wo_chain:v4i32 575:iPTR, VR128:v4i32:$src1, (imm:i32):$src2)
              // Dst: (PSRADri:v4i32 VR128:v4i32:$src1, (imm:i32):$src2)
/*40165*/   /*Scope*/ 27, /*->40193*/
/*40166*/     OPC_CheckInteger, 54|128,4/*566*/, 
/*40169*/     OPC_MoveParent,
/*40170*/     OPC_RecordChild1, // #0 = $src1
/*40171*/     OPC_RecordChild2, // #1 = $src2
/*40172*/     OPC_MoveChild, 2,
/*40174*/     OPC_CheckOpcode, ISD::Constant,
/*40176*/     OPC_MoveParent,
/*40177*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*40179*/     OPC_EmitConvertToTarget, 1,
/*40181*/     OPC_EmitNodeXForm, 5, 2, // BYTE_imm
/*40184*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::PSLLDQri), 0,
                  1/*#VTs*/, MVT::v2i64, 2/*#Ops*/, 0, 3, 
              // Src: (intrinsic_wo_chain:v2i64 566:iPTR, VR128:v2i64:$src1, (imm:i32):$src2)
              // Dst: (PSLLDQri:v2i64 VR128:v16i8:$src1, (BYTE_imm:i32 (imm:i32):$src2))
/*40193*/   /*Scope*/ 27, /*->40221*/
/*40194*/     OPC_CheckInteger, 66|128,4/*578*/, 
/*40197*/     OPC_MoveParent,
/*40198*/     OPC_RecordChild1, // #0 = $src1
/*40199*/     OPC_RecordChild2, // #1 = $src2
/*40200*/     OPC_MoveChild, 2,
/*40202*/     OPC_CheckOpcode, ISD::Constant,
/*40204*/     OPC_MoveParent,
/*40205*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*40207*/     OPC_EmitConvertToTarget, 1,
/*40209*/     OPC_EmitNodeXForm, 5, 2, // BYTE_imm
/*40212*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::PSRLDQri), 0,
                  1/*#VTs*/, MVT::v2i64, 2/*#Ops*/, 0, 3, 
              // Src: (intrinsic_wo_chain:v2i64 578:iPTR, VR128:v2i64:$src1, (imm:i32):$src2)
              // Dst: (PSRLDQri:v2i64 VR128:v16i8:$src1, (BYTE_imm:i32 (imm:i32):$src2))
/*40221*/   /*Scope*/ 24, /*->40246*/
/*40222*/     OPC_CheckInteger, 55|128,4/*567*/, 
/*40225*/     OPC_MoveParent,
/*40226*/     OPC_RecordChild1, // #0 = $src1
/*40227*/     OPC_RecordChild2, // #1 = $src2
/*40228*/     OPC_MoveChild, 2,
/*40230*/     OPC_CheckOpcode, ISD::Constant,
/*40232*/     OPC_MoveParent,
/*40233*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*40235*/     OPC_EmitConvertToTarget, 1,
/*40237*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::PSLLDQri), 0,
                  1/*#VTs*/, MVT::v2i64, 2/*#Ops*/, 0, 2, 
              // Src: (intrinsic_wo_chain:v2i64 567:iPTR, VR128:v2i64:$src1, (imm:i32):$src2)
              // Dst: (PSLLDQri:v2i64 VR128:v16i8:$src1, (imm:i32):$src2)
/*40246*/   /*Scope*/ 24, /*->40271*/
/*40247*/     OPC_CheckInteger, 67|128,4/*579*/, 
/*40250*/     OPC_MoveParent,
/*40251*/     OPC_RecordChild1, // #0 = $src1
/*40252*/     OPC_RecordChild2, // #1 = $src2
/*40253*/     OPC_MoveChild, 2,
/*40255*/     OPC_CheckOpcode, ISD::Constant,
/*40257*/     OPC_MoveParent,
/*40258*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*40260*/     OPC_EmitConvertToTarget, 1,
/*40262*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::PSRLDQri), 0,
                  1/*#VTs*/, MVT::v2i64, 2/*#Ops*/, 0, 2, 
              // Src: (intrinsic_wo_chain:v2i64 579:iPTR, VR128:v2i64:$src1, (imm:i32):$src2)
              // Dst: (PSRLDQri:v2i64 VR128:v16i8:$src1, (imm:i32):$src2)
/*40271*/   /*Scope*/ 24, /*->40296*/
/*40272*/     OPC_CheckInteger, 105|128,4/*617*/, 
/*40275*/     OPC_MoveParent,
/*40276*/     OPC_RecordChild1, // #0 = $src1
/*40277*/     OPC_RecordChild2, // #1 = $src2
/*40278*/     OPC_RecordChild3, // #2 = $src3
/*40279*/     OPC_MoveChild, 3,
/*40281*/     OPC_CheckOpcode, ISD::Constant,
/*40283*/     OPC_MoveParent,
/*40284*/     OPC_EmitConvertToTarget, 2,
/*40286*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::INSERTPSrr), 0,
                  1/*#VTs*/, MVT::v4f32, 3/*#Ops*/, 0, 1, 3, 
              // Src: (intrinsic_wo_chain:v4f32 617:iPTR, VR128:v4f32:$src1, VR128:v4f32:$src2, (imm:i32):$src3)
              // Dst: (INSERTPSrr:v4f32 VR128:v16i8:$src1, VR128:v16i8:$src2, (imm:i32):$src3)
/*40296*/   /*Scope*/ 24, /*->40321*/
/*40297*/     OPC_CheckInteger, 110|128,3/*494*/, 
/*40300*/     OPC_MoveParent,
/*40301*/     OPC_RecordChild1, // #0 = $src1
/*40302*/     OPC_RecordChild2, // #1 = $src2
/*40303*/     OPC_MoveChild, 2,
/*40305*/     OPC_CheckOpcode, ISD::Constant,
/*40307*/     OPC_MoveParent,
/*40308*/     OPC_CheckPatternPredicate, 8, // (Subtarget->hasMMX())
/*40310*/     OPC_EmitConvertToTarget, 1,
/*40312*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PSRLWri), 0,
                  1/*#VTs*/, MVT::v4i16, 2/*#Ops*/, 0, 2, 
              // Src: (intrinsic_wo_chain:v4i16 494:iPTR, VR64:v4i16:$src1, (imm:i32):$src2)
              // Dst: (MMX_PSRLWri:v4i16 VR64:v4i16:$src1, (imm:i32):$src2)
/*40321*/   /*Scope*/ 24, /*->40346*/
/*40322*/     OPC_CheckInteger, 108|128,3/*492*/, 
/*40325*/     OPC_MoveParent,
/*40326*/     OPC_RecordChild1, // #0 = $src1
/*40327*/     OPC_RecordChild2, // #1 = $src2
/*40328*/     OPC_MoveChild, 2,
/*40330*/     OPC_CheckOpcode, ISD::Constant,
/*40332*/     OPC_MoveParent,
/*40333*/     OPC_CheckPatternPredicate, 8, // (Subtarget->hasMMX())
/*40335*/     OPC_EmitConvertToTarget, 1,
/*40337*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PSRLDri), 0,
                  1/*#VTs*/, MVT::v2i32, 2/*#Ops*/, 0, 2, 
              // Src: (intrinsic_wo_chain:v2i32 492:iPTR, VR64:v2i32:$src1, (imm:i32):$src2)
              // Dst: (MMX_PSRLDri:v2i32 VR64:v2i32:$src1, (imm:i32):$src2)
/*40346*/   /*Scope*/ 24, /*->40371*/
/*40347*/     OPC_CheckInteger, 109|128,3/*493*/, 
/*40350*/     OPC_MoveParent,
/*40351*/     OPC_RecordChild1, // #0 = $src1
/*40352*/     OPC_RecordChild2, // #1 = $src2
/*40353*/     OPC_MoveChild, 2,
/*40355*/     OPC_CheckOpcode, ISD::Constant,
/*40357*/     OPC_MoveParent,
/*40358*/     OPC_CheckPatternPredicate, 8, // (Subtarget->hasMMX())
/*40360*/     OPC_EmitConvertToTarget, 1,
/*40362*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PSRLQri), 0,
                  1/*#VTs*/, MVT::v1i64, 2/*#Ops*/, 0, 2, 
              // Src: (intrinsic_wo_chain:v1i64 493:iPTR, VR64:v1i64:$src1, (imm:i32):$src2)
              // Dst: (MMX_PSRLQri:v1i64 VR64:v1i64:$src1, (imm:i32):$src2)
/*40371*/   /*Scope*/ 24, /*->40396*/
/*40372*/     OPC_CheckInteger, 100|128,3/*484*/, 
/*40375*/     OPC_MoveParent,
/*40376*/     OPC_RecordChild1, // #0 = $src1
/*40377*/     OPC_RecordChild2, // #1 = $src2
/*40378*/     OPC_MoveChild, 2,
/*40380*/     OPC_CheckOpcode, ISD::Constant,
/*40382*/     OPC_MoveParent,
/*40383*/     OPC_CheckPatternPredicate, 8, // (Subtarget->hasMMX())
/*40385*/     OPC_EmitConvertToTarget, 1,
/*40387*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PSLLWri), 0,
                  1/*#VTs*/, MVT::v4i16, 2/*#Ops*/, 0, 2, 
              // Src: (intrinsic_wo_chain:v4i16 484:iPTR, VR64:v4i16:$src1, (imm:i32):$src2)
              // Dst: (MMX_PSLLWri:v4i16 VR64:v4i16:$src1, (imm:i32):$src2)
/*40396*/   /*Scope*/ 24, /*->40421*/
/*40397*/     OPC_CheckInteger, 98|128,3/*482*/, 
/*40400*/     OPC_MoveParent,
/*40401*/     OPC_RecordChild1, // #0 = $src1
/*40402*/     OPC_RecordChild2, // #1 = $src2
/*40403*/     OPC_MoveChild, 2,
/*40405*/     OPC_CheckOpcode, ISD::Constant,
/*40407*/     OPC_MoveParent,
/*40408*/     OPC_CheckPatternPredicate, 8, // (Subtarget->hasMMX())
/*40410*/     OPC_EmitConvertToTarget, 1,
/*40412*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PSLLDri), 0,
                  1/*#VTs*/, MVT::v2i32, 2/*#Ops*/, 0, 2, 
              // Src: (intrinsic_wo_chain:v2i32 482:iPTR, VR64:v2i32:$src1, (imm:i32):$src2)
              // Dst: (MMX_PSLLDri:v2i32 VR64:v2i32:$src1, (imm:i32):$src2)
/*40421*/   /*Scope*/ 24, /*->40446*/
/*40422*/     OPC_CheckInteger, 99|128,3/*483*/, 
/*40425*/     OPC_MoveParent,
/*40426*/     OPC_RecordChild1, // #0 = $src1
/*40427*/     OPC_RecordChild2, // #1 = $src2
/*40428*/     OPC_MoveChild, 2,
/*40430*/     OPC_CheckOpcode, ISD::Constant,
/*40432*/     OPC_MoveParent,
/*40433*/     OPC_CheckPatternPredicate, 8, // (Subtarget->hasMMX())
/*40435*/     OPC_EmitConvertToTarget, 1,
/*40437*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PSLLQri), 0,
                  1/*#VTs*/, MVT::v1i64, 2/*#Ops*/, 0, 2, 
              // Src: (intrinsic_wo_chain:v1i64 483:iPTR, VR64:v1i64:$src1, (imm:i32):$src2)
              // Dst: (MMX_PSLLQri:v1i64 VR64:v1i64:$src1, (imm:i32):$src2)
/*40446*/   /*Scope*/ 24, /*->40471*/
/*40447*/     OPC_CheckInteger, 104|128,3/*488*/, 
/*40450*/     OPC_MoveParent,
/*40451*/     OPC_RecordChild1, // #0 = $src1
/*40452*/     OPC_RecordChild2, // #1 = $src2
/*40453*/     OPC_MoveChild, 2,
/*40455*/     OPC_CheckOpcode, ISD::Constant,
/*40457*/     OPC_MoveParent,
/*40458*/     OPC_CheckPatternPredicate, 8, // (Subtarget->hasMMX())
/*40460*/     OPC_EmitConvertToTarget, 1,
/*40462*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PSRAWri), 0,
                  1/*#VTs*/, MVT::v4i16, 2/*#Ops*/, 0, 2, 
              // Src: (intrinsic_wo_chain:v4i16 488:iPTR, VR64:v4i16:$src1, (imm:i32):$src2)
              // Dst: (MMX_PSRAWri:v4i16 VR64:v4i16:$src1, (imm:i32):$src2)
/*40471*/   /*Scope*/ 24, /*->40496*/
/*40472*/     OPC_CheckInteger, 103|128,3/*487*/, 
/*40475*/     OPC_MoveParent,
/*40476*/     OPC_RecordChild1, // #0 = $src1
/*40477*/     OPC_RecordChild2, // #1 = $src2
/*40478*/     OPC_MoveChild, 2,
/*40480*/     OPC_CheckOpcode, ISD::Constant,
/*40482*/     OPC_MoveParent,
/*40483*/     OPC_CheckPatternPredicate, 8, // (Subtarget->hasMMX())
/*40485*/     OPC_EmitConvertToTarget, 1,
/*40487*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PSRADri), 0,
                  1/*#VTs*/, MVT::v2i32, 2/*#Ops*/, 0, 2, 
              // Src: (intrinsic_wo_chain:v2i32 487:iPTR, VR64:v2i32:$src1, (imm:i32):$src2)
              // Dst: (MMX_PSRADri:v2i32 VR64:v2i32:$src1, (imm:i32):$src2)
/*40496*/   /*Scope*/ 15, /*->40512*/
/*40497*/     OPC_CheckInteger, 64|128,5/*704*/, 
/*40500*/     OPC_MoveParent,
/*40501*/     OPC_RecordChild1, // #0 = $src
/*40502*/     OPC_CheckPatternPredicate, 0, // (Subtarget->hasSSE1())
/*40504*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVMSKPSrr), 0,
                  1/*#VTs*/, MVT::i32, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:i32 704:iPTR, VR128:v4f32:$src)
              // Dst: (MOVMSKPSrr:i32 VR128:v4f32:$src)
/*40512*/   /*Scope*/ 15, /*->40528*/
/*40513*/     OPC_CheckInteger, 23|128,4/*535*/, 
/*40516*/     OPC_MoveParent,
/*40517*/     OPC_RecordChild1, // #0 = $src
/*40518*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*40520*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVMSKPDrr), 0,
                  1/*#VTs*/, MVT::i32, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:i32 535:iPTR, VR128:v2f64:$src)
              // Dst: (MOVMSKPDrr:i32 VR128:v2f64:$src)
/*40528*/   /*Scope*/ 15, /*->40544*/
/*40529*/     OPC_CheckInteger, 48|128,4/*560*/, 
/*40532*/     OPC_MoveParent,
/*40533*/     OPC_RecordChild1, // #0 = $src
/*40534*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*40536*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::PMOVMSKBrr), 0,
                  1/*#VTs*/, MVT::i32, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:i32 560:iPTR, VR128:v16i8:$src)
              // Dst: (PMOVMSKBrr:i32 VR128:v16i8:$src)
/*40544*/   /*Scope*/ 15, /*->40560*/
/*40545*/     OPC_CheckInteger, 90|128,3/*474*/, 
/*40548*/     OPC_MoveParent,
/*40549*/     OPC_RecordChild1, // #0 = $src
/*40550*/     OPC_CheckPatternPredicate, 8, // (Subtarget->hasMMX())
/*40552*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PMOVMSKBrr), 0,
                  1/*#VTs*/, MVT::i32, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:i32 474:iPTR, VR64:v8i8:$src)
              // Dst: (MMX_PMOVMSKBrr:i32 VR64:v8i8:$src)
/*40560*/   0, /*End of Scope*/
          /*SwitchOpcode*/ 65|128,32/*4161*/,  ISD::AND,// ->44725
/*40564*/   OPC_Scope, 118|128,14/*1910*/, /*->42477*/ // 28 children in Scope
/*40567*/     OPC_MoveChild, 0,
/*40569*/     OPC_SwitchOpcode /*3 cases */, 33|128,7/*929*/,  ISD::XOR,// ->41502
/*40573*/       OPC_Scope, 45|128,1/*173*/, /*->40749*/ // 5 children in Scope
/*40576*/         OPC_MoveChild, 0,
/*40578*/         OPC_CheckOpcode, ISD::BIT_CONVERT,
/*40580*/         OPC_Scope, 57, /*->40639*/ // 3 children in Scope
/*40582*/           OPC_RecordChild0, // #0 = $src1
/*40583*/           OPC_CheckChild0Type, MVT::v4f32,
/*40585*/           OPC_MoveParent,
/*40586*/           OPC_MoveChild, 1,
/*40588*/           OPC_CheckOpcode, ISD::BIT_CONVERT,
/*40590*/           OPC_MoveChild, 0,
/*40592*/           OPC_CheckOpcode, ISD::BUILD_VECTOR,
/*40594*/           OPC_CheckPredicate, 67, // Predicate_immAllOnesV
/*40596*/           OPC_CheckType, MVT::v4i32,
/*40598*/           OPC_MoveParent,
/*40599*/           OPC_MoveParent,
/*40600*/           OPC_MoveParent,
/*40601*/           OPC_MoveChild, 1,
/*40603*/           OPC_CheckOpcode, ISD::LOAD,
/*40605*/           OPC_RecordMemRef,
/*40606*/           OPC_RecordNode, // #1 = 'ld' chained node
/*40607*/           OPC_CheckFoldableChainNode,
/*40608*/           OPC_RecordChild1, // #2 = $src2
/*40609*/           OPC_CheckPredicate, 2, // Predicate_unindexedload
/*40611*/           OPC_CheckPredicate, 8, // Predicate_load
/*40613*/           OPC_CheckPredicate, 23, // Predicate_memop
/*40615*/           OPC_MoveParent,
/*40616*/           OPC_CheckType, MVT::v2i64,
/*40618*/           OPC_CheckPatternPredicate, 0, // (Subtarget->hasSSE1())
/*40620*/           OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*40623*/           OPC_EmitMergeInputChains, 1, 1, 
/*40626*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::ANDNPSrm), 0|OPFL_Chain|OPFL_MemRefs,
                        1/*#VTs*/, MVT::v2i64, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                    // Src: (and:v2i64 (xor:v2i64 (bitconvert:v2i64 VR128:v4f32:$src1), (bitconvert:v2i64 (build_vector:v4i32)<<P:Predicate_immAllOnesV>>)), (ld:v2i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>)
                    // Dst: (ANDNPSrm:v2i64 VR128:v4f32:$src1, addr:iPTR:$src2)
/*40639*/         /*Scope*/ 57, /*->40697*/
/*40640*/           OPC_MoveChild, 0,
/*40642*/           OPC_CheckOpcode, ISD::BUILD_VECTOR,
/*40644*/           OPC_CheckPredicate, 67, // Predicate_immAllOnesV
/*40646*/           OPC_CheckType, MVT::v4i32,
/*40648*/           OPC_MoveParent,
/*40649*/           OPC_MoveParent,
/*40650*/           OPC_MoveChild, 1,
/*40652*/           OPC_CheckOpcode, ISD::BIT_CONVERT,
/*40654*/           OPC_RecordChild0, // #0 = $src1
/*40655*/           OPC_CheckChild0Type, MVT::v4f32,
/*40657*/           OPC_MoveParent,
/*40658*/           OPC_MoveParent,
/*40659*/           OPC_MoveChild, 1,
/*40661*/           OPC_CheckOpcode, ISD::LOAD,
/*40663*/           OPC_RecordMemRef,
/*40664*/           OPC_RecordNode, // #1 = 'ld' chained node
/*40665*/           OPC_CheckFoldableChainNode,
/*40666*/           OPC_RecordChild1, // #2 = $src2
/*40667*/           OPC_CheckPredicate, 2, // Predicate_unindexedload
/*40669*/           OPC_CheckPredicate, 8, // Predicate_load
/*40671*/           OPC_CheckPredicate, 23, // Predicate_memop
/*40673*/           OPC_MoveParent,
/*40674*/           OPC_CheckType, MVT::v2i64,
/*40676*/           OPC_CheckPatternPredicate, 0, // (Subtarget->hasSSE1())
/*40678*/           OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*40681*/           OPC_EmitMergeInputChains, 1, 1, 
/*40684*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::ANDNPSrm), 0|OPFL_Chain|OPFL_MemRefs,
                        1/*#VTs*/, MVT::v2i64, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                    // Src: (and:v2i64 (xor:v2i64 (bitconvert:v2i64 (build_vector:v4i32)<<P:Predicate_immAllOnesV>>), (bitconvert:v2i64 VR128:v4f32:$src1)), (ld:v2i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>)
                    // Dst: (ANDNPSrm:v2i64 VR128:v4f32:$src1, addr:iPTR:$src2)
/*40697*/         /*Scope*/ 50, /*->40748*/
/*40698*/           OPC_RecordChild0, // #0 = $src1
/*40699*/           OPC_CheckChild0Type, MVT::v2f64,
/*40701*/           OPC_MoveParent,
/*40702*/           OPC_MoveChild, 1,
/*40704*/           OPC_CheckOpcode, ISD::BUILD_VECTOR,
/*40706*/           OPC_CheckPredicate, 67, // Predicate_immAllOnesV
/*40708*/           OPC_MoveParent,
/*40709*/           OPC_MoveParent,
/*40710*/           OPC_MoveChild, 1,
/*40712*/           OPC_CheckOpcode, ISD::LOAD,
/*40714*/           OPC_RecordMemRef,
/*40715*/           OPC_RecordNode, // #1 = 'ld' chained node
/*40716*/           OPC_CheckFoldableChainNode,
/*40717*/           OPC_RecordChild1, // #2 = $src2
/*40718*/           OPC_CheckPredicate, 2, // Predicate_unindexedload
/*40720*/           OPC_CheckPredicate, 8, // Predicate_load
/*40722*/           OPC_CheckPredicate, 23, // Predicate_memop
/*40724*/           OPC_MoveParent,
/*40725*/           OPC_CheckType, MVT::v2i64,
/*40727*/           OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*40729*/           OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*40732*/           OPC_EmitMergeInputChains, 1, 1, 
/*40735*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::ANDNPDrm), 0|OPFL_Chain|OPFL_MemRefs,
                        1/*#VTs*/, MVT::v2i64, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                    // Src: (and:v2i64 (xor:v2i64 (bitconvert:v2i64 VR128:v2f64:$src1), (build_vector:v2i64)<<P:Predicate_immAllOnesV>>), (ld:v2i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>)
                    // Dst: (ANDNPDrm:v2i64 VR128:v2f64:$src1, addr:iPTR:$src2)
/*40748*/         0, /*End of Scope*/
/*40749*/       /*Scope*/ 12|128,2/*268*/, /*->41019*/
/*40751*/         OPC_RecordChild0, // #0 = $src1
/*40752*/         OPC_MoveChild, 1,
/*40754*/         OPC_CheckOpcode, ISD::BIT_CONVERT,
/*40756*/         OPC_MoveChild, 0,
/*40758*/         OPC_SwitchOpcode /*2 cases */, 44|128,1/*172*/,  ISD::BUILD_VECTOR,// ->40934
/*40762*/           OPC_CheckPredicate, 67, // Predicate_immAllOnesV
/*40764*/           OPC_SwitchType /*4 cases */, 41,  MVT::v4i32,// ->40808
/*40767*/             OPC_MoveParent,
/*40768*/             OPC_MoveParent,
/*40769*/             OPC_MoveParent,
/*40770*/             OPC_MoveChild, 1,
/*40772*/             OPC_CheckOpcode, ISD::LOAD,
/*40774*/             OPC_RecordMemRef,
/*40775*/             OPC_RecordNode, // #1 = 'ld' chained node
/*40776*/             OPC_CheckFoldableChainNode,
/*40777*/             OPC_RecordChild1, // #2 = $src2
/*40778*/             OPC_CheckPredicate, 2, // Predicate_unindexedload
/*40780*/             OPC_CheckPredicate, 8, // Predicate_load
/*40782*/             OPC_CheckPredicate, 23, // Predicate_memop
/*40784*/             OPC_MoveParent,
/*40785*/             OPC_CheckType, MVT::v2i64,
/*40787*/             OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*40789*/             OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*40792*/             OPC_EmitMergeInputChains, 1, 1, 
/*40795*/             OPC_MorphNodeTo, TARGET_OPCODE(X86::PANDNrm), 0|OPFL_Chain|OPFL_MemRefs,
                          1/*#VTs*/, MVT::v2i64, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                      // Src: (and:v2i64 (xor:v2i64 VR128:v2i64:$src1, (bitconvert:v2i64 (build_vector:v4i32)<<P:Predicate_immAllOnesV>>)), (ld:v2i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>)
                      // Dst: (PANDNrm:v2i64 VR128:v16i8:$src1, addr:iPTR:$src2)
                    /*SwitchType*/ 41,  MVT::v8i16,// ->40851
/*40810*/             OPC_MoveParent,
/*40811*/             OPC_MoveParent,
/*40812*/             OPC_MoveParent,
/*40813*/             OPC_MoveChild, 1,
/*40815*/             OPC_CheckOpcode, ISD::LOAD,
/*40817*/             OPC_RecordMemRef,
/*40818*/             OPC_RecordNode, // #1 = 'ld' chained node
/*40819*/             OPC_CheckFoldableChainNode,
/*40820*/             OPC_RecordChild1, // #2 = $src2
/*40821*/             OPC_CheckPredicate, 2, // Predicate_unindexedload
/*40823*/             OPC_CheckPredicate, 8, // Predicate_load
/*40825*/             OPC_CheckPredicate, 23, // Predicate_memop
/*40827*/             OPC_MoveParent,
/*40828*/             OPC_CheckType, MVT::v2i64,
/*40830*/             OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*40832*/             OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*40835*/             OPC_EmitMergeInputChains, 1, 1, 
/*40838*/             OPC_MorphNodeTo, TARGET_OPCODE(X86::PANDNrm), 0|OPFL_Chain|OPFL_MemRefs,
                          1/*#VTs*/, MVT::v2i64, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                      // Src: (and:v2i64 (xor:v2i64 VR128:v2i64:$src1, (bitconvert:v2i64 (build_vector:v8i16)<<P:Predicate_immAllOnesV>>)), (ld:v2i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>)
                      // Dst: (PANDNrm:v2i64 VR128:v16i8:$src1, addr:iPTR:$src2)
                    /*SwitchType*/ 41,  MVT::v16i8,// ->40894
/*40853*/             OPC_MoveParent,
/*40854*/             OPC_MoveParent,
/*40855*/             OPC_MoveParent,
/*40856*/             OPC_MoveChild, 1,
/*40858*/             OPC_CheckOpcode, ISD::LOAD,
/*40860*/             OPC_RecordMemRef,
/*40861*/             OPC_RecordNode, // #1 = 'ld' chained node
/*40862*/             OPC_CheckFoldableChainNode,
/*40863*/             OPC_RecordChild1, // #2 = $src2
/*40864*/             OPC_CheckPredicate, 2, // Predicate_unindexedload
/*40866*/             OPC_CheckPredicate, 8, // Predicate_load
/*40868*/             OPC_CheckPredicate, 23, // Predicate_memop
/*40870*/             OPC_MoveParent,
/*40871*/             OPC_CheckType, MVT::v2i64,
/*40873*/             OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*40875*/             OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*40878*/             OPC_EmitMergeInputChains, 1, 1, 
/*40881*/             OPC_MorphNodeTo, TARGET_OPCODE(X86::PANDNrm), 0|OPFL_Chain|OPFL_MemRefs,
                          1/*#VTs*/, MVT::v2i64, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                      // Src: (and:v2i64 (xor:v2i64 VR128:v2i64:$src1, (bitconvert:v2i64 (build_vector:v16i8)<<P:Predicate_immAllOnesV>>)), (ld:v2i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>)
                      // Dst: (PANDNrm:v2i64 VR128:v16i8:$src1, addr:iPTR:$src2)
                    /*SwitchType*/ 37,  MVT::v2i32,// ->40933
/*40896*/             OPC_MoveParent,
/*40897*/             OPC_MoveParent,
/*40898*/             OPC_MoveParent,
/*40899*/             OPC_MoveChild, 1,
/*40901*/             OPC_CheckOpcode, ISD::LOAD,
/*40903*/             OPC_RecordMemRef,
/*40904*/             OPC_RecordNode, // #1 = 'ld' chained node
/*40905*/             OPC_CheckFoldableChainNode,
/*40906*/             OPC_RecordChild1, // #2 = $src2
/*40907*/             OPC_CheckPredicate, 2, // Predicate_unindexedload
/*40909*/             OPC_CheckPredicate, 8, // Predicate_load
/*40911*/             OPC_MoveParent,
/*40912*/             OPC_CheckType, MVT::v1i64,
/*40914*/             OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*40917*/             OPC_EmitMergeInputChains, 1, 1, 
/*40920*/             OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PANDNrm), 0|OPFL_Chain|OPFL_MemRefs,
                          1/*#VTs*/, MVT::v1i64, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                      // Src: (and:v1i64 (xor:v1i64 VR64:v1i64:$src1, (bitconvert:v1i64 (build_vector:v2i32)<<P:Predicate_immAllOnesV>>)), (ld:v1i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)
                      // Dst: (MMX_PANDNrm:v1i64 VR64:v8i8:$src1, addr:iPTR:$src2)
                    0, // EndSwitchType
                  /*SwitchOpcode*/ 82,  ISD::BIT_CONVERT,// ->41018
/*40936*/           OPC_CheckPredicate, 68, // Predicate_immAllOnesV_bc
/*40938*/           OPC_SwitchType /*2 cases */, 37,  MVT::v4i16,// ->40978
/*40941*/             OPC_MoveParent,
/*40942*/             OPC_MoveParent,
/*40943*/             OPC_MoveParent,
/*40944*/             OPC_MoveChild, 1,
/*40946*/             OPC_CheckOpcode, ISD::LOAD,
/*40948*/             OPC_RecordMemRef,
/*40949*/             OPC_RecordNode, // #1 = 'ld' chained node
/*40950*/             OPC_CheckFoldableChainNode,
/*40951*/             OPC_RecordChild1, // #2 = $src2
/*40952*/             OPC_CheckPredicate, 2, // Predicate_unindexedload
/*40954*/             OPC_CheckPredicate, 8, // Predicate_load
/*40956*/             OPC_MoveParent,
/*40957*/             OPC_CheckType, MVT::v1i64,
/*40959*/             OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*40962*/             OPC_EmitMergeInputChains, 1, 1, 
/*40965*/             OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PANDNrm), 0|OPFL_Chain|OPFL_MemRefs,
                          1/*#VTs*/, MVT::v1i64, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                      // Src: (and:v1i64 (xor:v1i64 VR64:v1i64:$src1, (bitconvert:v1i64 (bitconvert:v4i16)<<P:Predicate_immAllOnesV_bc>>)), (ld:v1i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)
                      // Dst: (MMX_PANDNrm:v1i64 VR64:v8i8:$src1, addr:iPTR:$src2)
                    /*SwitchType*/ 37,  MVT::v8i8,// ->41017
/*40980*/             OPC_MoveParent,
/*40981*/             OPC_MoveParent,
/*40982*/             OPC_MoveParent,
/*40983*/             OPC_MoveChild, 1,
/*40985*/             OPC_CheckOpcode, ISD::LOAD,
/*40987*/             OPC_RecordMemRef,
/*40988*/             OPC_RecordNode, // #1 = 'ld' chained node
/*40989*/             OPC_CheckFoldableChainNode,
/*40990*/             OPC_RecordChild1, // #2 = $src2
/*40991*/             OPC_CheckPredicate, 2, // Predicate_unindexedload
/*40993*/             OPC_CheckPredicate, 8, // Predicate_load
/*40995*/             OPC_MoveParent,
/*40996*/             OPC_CheckType, MVT::v1i64,
/*40998*/             OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*41001*/             OPC_EmitMergeInputChains, 1, 1, 
/*41004*/             OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PANDNrm), 0|OPFL_Chain|OPFL_MemRefs,
                          1/*#VTs*/, MVT::v1i64, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                      // Src: (and:v1i64 (xor:v1i64 VR64:v1i64:$src1, (bitconvert:v1i64 (bitconvert:v8i8)<<P:Predicate_immAllOnesV_bc>>)), (ld:v1i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)
                      // Dst: (MMX_PANDNrm:v1i64 VR64:v8i8:$src1, addr:iPTR:$src2)
                    0, // EndSwitchType
                  0, // EndSwitchOpcode
/*41019*/       /*Scope*/ 72|128,2/*328*/, /*->41349*/
/*41021*/         OPC_MoveChild, 0,
/*41023*/         OPC_SwitchOpcode /*2 cases */, 50,  ISD::BUILD_VECTOR,// ->41076
/*41026*/           OPC_CheckPredicate, 67, // Predicate_immAllOnesV
/*41028*/           OPC_MoveParent,
/*41029*/           OPC_MoveChild, 1,
/*41031*/           OPC_CheckOpcode, ISD::BIT_CONVERT,
/*41033*/           OPC_RecordChild0, // #0 = $src1
/*41034*/           OPC_CheckChild0Type, MVT::v2f64,
/*41036*/           OPC_MoveParent,
/*41037*/           OPC_MoveParent,
/*41038*/           OPC_MoveChild, 1,
/*41040*/           OPC_CheckOpcode, ISD::LOAD,
/*41042*/           OPC_RecordMemRef,
/*41043*/           OPC_RecordNode, // #1 = 'ld' chained node
/*41044*/           OPC_CheckFoldableChainNode,
/*41045*/           OPC_RecordChild1, // #2 = $src2
/*41046*/           OPC_CheckPredicate, 2, // Predicate_unindexedload
/*41048*/           OPC_CheckPredicate, 8, // Predicate_load
/*41050*/           OPC_CheckPredicate, 23, // Predicate_memop
/*41052*/           OPC_MoveParent,
/*41053*/           OPC_CheckType, MVT::v2i64,
/*41055*/           OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*41057*/           OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*41060*/           OPC_EmitMergeInputChains, 1, 1, 
/*41063*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::ANDNPDrm), 0|OPFL_Chain|OPFL_MemRefs,
                        1/*#VTs*/, MVT::v2i64, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                    // Src: (and:v2i64 (xor:v2i64 (build_vector:v2i64)<<P:Predicate_immAllOnesV>>, (bitconvert:v2i64 VR128:v2f64:$src1)), (ld:v2i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>)
                    // Dst: (ANDNPDrm:v2i64 VR128:v2f64:$src1, addr:iPTR:$src2)
                  /*SwitchOpcode*/ 13|128,2/*269*/,  ISD::BIT_CONVERT,// ->41348
/*41079*/           OPC_MoveChild, 0,
/*41081*/           OPC_SwitchOpcode /*2 cases */, 48|128,1/*176*/,  ISD::BUILD_VECTOR,// ->41261
/*41085*/             OPC_CheckPredicate, 67, // Predicate_immAllOnesV
/*41087*/             OPC_SwitchType /*4 cases */, 42,  MVT::v4i32,// ->41132
/*41090*/               OPC_MoveParent,
/*41091*/               OPC_MoveParent,
/*41092*/               OPC_RecordChild1, // #0 = $src1
/*41093*/               OPC_MoveParent,
/*41094*/               OPC_MoveChild, 1,
/*41096*/               OPC_CheckOpcode, ISD::LOAD,
/*41098*/               OPC_RecordMemRef,
/*41099*/               OPC_RecordNode, // #1 = 'ld' chained node
/*41100*/               OPC_CheckFoldableChainNode,
/*41101*/               OPC_RecordChild1, // #2 = $src2
/*41102*/               OPC_CheckPredicate, 2, // Predicate_unindexedload
/*41104*/               OPC_CheckPredicate, 8, // Predicate_load
/*41106*/               OPC_CheckPredicate, 23, // Predicate_memop
/*41108*/               OPC_MoveParent,
/*41109*/               OPC_CheckType, MVT::v2i64,
/*41111*/               OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*41113*/               OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*41116*/               OPC_EmitMergeInputChains, 1, 1, 
/*41119*/               OPC_MorphNodeTo, TARGET_OPCODE(X86::PANDNrm), 0|OPFL_Chain|OPFL_MemRefs,
                            1/*#VTs*/, MVT::v2i64, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                        // Src: (and:v2i64 (xor:v2i64 (bitconvert:v2i64 (build_vector:v4i32)<<P:Predicate_immAllOnesV>>), VR128:v2i64:$src1), (ld:v2i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>)
                        // Dst: (PANDNrm:v2i64 VR128:v16i8:$src1, addr:iPTR:$src2)
                      /*SwitchType*/ 42,  MVT::v8i16,// ->41176
/*41134*/               OPC_MoveParent,
/*41135*/               OPC_MoveParent,
/*41136*/               OPC_RecordChild1, // #0 = $src1
/*41137*/               OPC_MoveParent,
/*41138*/               OPC_MoveChild, 1,
/*41140*/               OPC_CheckOpcode, ISD::LOAD,
/*41142*/               OPC_RecordMemRef,
/*41143*/               OPC_RecordNode, // #1 = 'ld' chained node
/*41144*/               OPC_CheckFoldableChainNode,
/*41145*/               OPC_RecordChild1, // #2 = $src2
/*41146*/               OPC_CheckPredicate, 2, // Predicate_unindexedload
/*41148*/               OPC_CheckPredicate, 8, // Predicate_load
/*41150*/               OPC_CheckPredicate, 23, // Predicate_memop
/*41152*/               OPC_MoveParent,
/*41153*/               OPC_CheckType, MVT::v2i64,
/*41155*/               OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*41157*/               OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*41160*/               OPC_EmitMergeInputChains, 1, 1, 
/*41163*/               OPC_MorphNodeTo, TARGET_OPCODE(X86::PANDNrm), 0|OPFL_Chain|OPFL_MemRefs,
                            1/*#VTs*/, MVT::v2i64, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                        // Src: (and:v2i64 (xor:v2i64 (bitconvert:v2i64 (build_vector:v8i16)<<P:Predicate_immAllOnesV>>), VR128:v2i64:$src1), (ld:v2i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>)
                        // Dst: (PANDNrm:v2i64 VR128:v16i8:$src1, addr:iPTR:$src2)
                      /*SwitchType*/ 42,  MVT::v16i8,// ->41220
/*41178*/               OPC_MoveParent,
/*41179*/               OPC_MoveParent,
/*41180*/               OPC_RecordChild1, // #0 = $src1
/*41181*/               OPC_MoveParent,
/*41182*/               OPC_MoveChild, 1,
/*41184*/               OPC_CheckOpcode, ISD::LOAD,
/*41186*/               OPC_RecordMemRef,
/*41187*/               OPC_RecordNode, // #1 = 'ld' chained node
/*41188*/               OPC_CheckFoldableChainNode,
/*41189*/               OPC_RecordChild1, // #2 = $src2
/*41190*/               OPC_CheckPredicate, 2, // Predicate_unindexedload
/*41192*/               OPC_CheckPredicate, 8, // Predicate_load
/*41194*/               OPC_CheckPredicate, 23, // Predicate_memop
/*41196*/               OPC_MoveParent,
/*41197*/               OPC_CheckType, MVT::v2i64,
/*41199*/               OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*41201*/               OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*41204*/               OPC_EmitMergeInputChains, 1, 1, 
/*41207*/               OPC_MorphNodeTo, TARGET_OPCODE(X86::PANDNrm), 0|OPFL_Chain|OPFL_MemRefs,
                            1/*#VTs*/, MVT::v2i64, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                        // Src: (and:v2i64 (xor:v2i64 (bitconvert:v2i64 (build_vector:v16i8)<<P:Predicate_immAllOnesV>>), VR128:v2i64:$src1), (ld:v2i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>)
                        // Dst: (PANDNrm:v2i64 VR128:v16i8:$src1, addr:iPTR:$src2)
                      /*SwitchType*/ 38,  MVT::v2i32,// ->41260
/*41222*/               OPC_MoveParent,
/*41223*/               OPC_MoveParent,
/*41224*/               OPC_RecordChild1, // #0 = $src1
/*41225*/               OPC_MoveParent,
/*41226*/               OPC_MoveChild, 1,
/*41228*/               OPC_CheckOpcode, ISD::LOAD,
/*41230*/               OPC_RecordMemRef,
/*41231*/               OPC_RecordNode, // #1 = 'ld' chained node
/*41232*/               OPC_CheckFoldableChainNode,
/*41233*/               OPC_RecordChild1, // #2 = $src2
/*41234*/               OPC_CheckPredicate, 2, // Predicate_unindexedload
/*41236*/               OPC_CheckPredicate, 8, // Predicate_load
/*41238*/               OPC_MoveParent,
/*41239*/               OPC_CheckType, MVT::v1i64,
/*41241*/               OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*41244*/               OPC_EmitMergeInputChains, 1, 1, 
/*41247*/               OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PANDNrm), 0|OPFL_Chain|OPFL_MemRefs,
                            1/*#VTs*/, MVT::v1i64, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                        // Src: (and:v1i64 (xor:v1i64 (bitconvert:v1i64 (build_vector:v2i32)<<P:Predicate_immAllOnesV>>), VR64:v1i64:$src1), (ld:v1i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)
                        // Dst: (MMX_PANDNrm:v1i64 VR64:v8i8:$src1, addr:iPTR:$src2)
                      0, // EndSwitchType
                    /*SwitchOpcode*/ 84,  ISD::BIT_CONVERT,// ->41347
/*41263*/             OPC_CheckPredicate, 68, // Predicate_immAllOnesV_bc
/*41265*/             OPC_SwitchType /*2 cases */, 38,  MVT::v4i16,// ->41306
/*41268*/               OPC_MoveParent,
/*41269*/               OPC_MoveParent,
/*41270*/               OPC_RecordChild1, // #0 = $src1
/*41271*/               OPC_MoveParent,
/*41272*/               OPC_MoveChild, 1,
/*41274*/               OPC_CheckOpcode, ISD::LOAD,
/*41276*/               OPC_RecordMemRef,
/*41277*/               OPC_RecordNode, // #1 = 'ld' chained node
/*41278*/               OPC_CheckFoldableChainNode,
/*41279*/               OPC_RecordChild1, // #2 = $src2
/*41280*/               OPC_CheckPredicate, 2, // Predicate_unindexedload
/*41282*/               OPC_CheckPredicate, 8, // Predicate_load
/*41284*/               OPC_MoveParent,
/*41285*/               OPC_CheckType, MVT::v1i64,
/*41287*/               OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*41290*/               OPC_EmitMergeInputChains, 1, 1, 
/*41293*/               OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PANDNrm), 0|OPFL_Chain|OPFL_MemRefs,
                            1/*#VTs*/, MVT::v1i64, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                        // Src: (and:v1i64 (xor:v1i64 (bitconvert:v1i64 (bitconvert:v4i16)<<P:Predicate_immAllOnesV_bc>>), VR64:v1i64:$src1), (ld:v1i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)
                        // Dst: (MMX_PANDNrm:v1i64 VR64:v8i8:$src1, addr:iPTR:$src2)
                      /*SwitchType*/ 38,  MVT::v8i8,// ->41346
/*41308*/               OPC_MoveParent,
/*41309*/               OPC_MoveParent,
/*41310*/               OPC_RecordChild1, // #0 = $src1
/*41311*/               OPC_MoveParent,
/*41312*/               OPC_MoveChild, 1,
/*41314*/               OPC_CheckOpcode, ISD::LOAD,
/*41316*/               OPC_RecordMemRef,
/*41317*/               OPC_RecordNode, // #1 = 'ld' chained node
/*41318*/               OPC_CheckFoldableChainNode,
/*41319*/               OPC_RecordChild1, // #2 = $src2
/*41320*/               OPC_CheckPredicate, 2, // Predicate_unindexedload
/*41322*/               OPC_CheckPredicate, 8, // Predicate_load
/*41324*/               OPC_MoveParent,
/*41325*/               OPC_CheckType, MVT::v1i64,
/*41327*/               OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*41330*/               OPC_EmitMergeInputChains, 1, 1, 
/*41333*/               OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PANDNrm), 0|OPFL_Chain|OPFL_MemRefs,
                            1/*#VTs*/, MVT::v1i64, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                        // Src: (and:v1i64 (xor:v1i64 (bitconvert:v1i64 (bitconvert:v8i8)<<P:Predicate_immAllOnesV_bc>>), VR64:v1i64:$src1), (ld:v1i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)
                        // Dst: (MMX_PANDNrm:v1i64 VR64:v8i8:$src1, addr:iPTR:$src2)
                      0, // EndSwitchType
                    0, // EndSwitchOpcode
                  0, // EndSwitchOpcode
/*41349*/       /*Scope*/ 75, /*->41425*/
/*41350*/         OPC_RecordChild0, // #0 = $src1
/*41351*/         OPC_MoveChild, 1,
/*41353*/         OPC_CheckOpcode, ISD::BUILD_VECTOR,
/*41355*/         OPC_CheckPredicate, 67, // Predicate_immAllOnesV
/*41357*/         OPC_MoveParent,
/*41358*/         OPC_MoveParent,
/*41359*/         OPC_MoveChild, 1,
/*41361*/         OPC_CheckOpcode, ISD::LOAD,
/*41363*/         OPC_RecordMemRef,
/*41364*/         OPC_RecordNode, // #1 = 'ld' chained node
/*41365*/         OPC_CheckFoldableChainNode,
/*41366*/         OPC_RecordChild1, // #2 = $src2
/*41367*/         OPC_CheckPredicate, 2, // Predicate_unindexedload
/*41369*/         OPC_CheckPredicate, 8, // Predicate_load
/*41371*/         OPC_Scope, 26, /*->41399*/ // 2 children in Scope
/*41373*/           OPC_CheckPredicate, 23, // Predicate_memop
/*41375*/           OPC_MoveParent,
/*41376*/           OPC_CheckType, MVT::v2i64,
/*41378*/           OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*41380*/           OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*41383*/           OPC_EmitMergeInputChains, 1, 1, 
/*41386*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::PANDNrm), 0|OPFL_Chain|OPFL_MemRefs,
                        1/*#VTs*/, MVT::v2i64, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                    // Src: (and:v2i64 (xor:v2i64 VR128:v2i64:$src1, (build_vector:v2i64)<<P:Predicate_immAllOnesV>>), (ld:v2i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>)
                    // Dst: (PANDNrm:v2i64 VR128:v2i64:$src1, addr:iPTR:$src2)
/*41399*/         /*Scope*/ 24, /*->41424*/
/*41400*/           OPC_MoveParent,
/*41401*/           OPC_CheckType, MVT::v1i64,
/*41403*/           OPC_CheckPatternPredicate, 8, // (Subtarget->hasMMX())
/*41405*/           OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*41408*/           OPC_EmitMergeInputChains, 1, 1, 
/*41411*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PANDNrm), 0|OPFL_Chain|OPFL_MemRefs,
                        1/*#VTs*/, MVT::v1i64, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                    // Src: (and:v1i64 (xor:v1i64 VR64:v1i64:$src1, (build_vector:v1i64)<<P:Predicate_immAllOnesV>>), (ld:v1i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)
                    // Dst: (MMX_PANDNrm:v1i64 VR64:v1i64:$src1, addr:iPTR:$src2)
/*41424*/         0, /*End of Scope*/
/*41425*/       /*Scope*/ 75, /*->41501*/
/*41426*/         OPC_MoveChild, 0,
/*41428*/         OPC_CheckOpcode, ISD::BUILD_VECTOR,
/*41430*/         OPC_CheckPredicate, 67, // Predicate_immAllOnesV
/*41432*/         OPC_MoveParent,
/*41433*/         OPC_RecordChild1, // #0 = $src1
/*41434*/         OPC_MoveParent,
/*41435*/         OPC_MoveChild, 1,
/*41437*/         OPC_CheckOpcode, ISD::LOAD,
/*41439*/         OPC_RecordMemRef,
/*41440*/         OPC_RecordNode, // #1 = 'ld' chained node
/*41441*/         OPC_CheckFoldableChainNode,
/*41442*/         OPC_RecordChild1, // #2 = $src2
/*41443*/         OPC_CheckPredicate, 2, // Predicate_unindexedload
/*41445*/         OPC_CheckPredicate, 8, // Predicate_load
/*41447*/         OPC_Scope, 26, /*->41475*/ // 2 children in Scope
/*41449*/           OPC_CheckPredicate, 23, // Predicate_memop
/*41451*/           OPC_MoveParent,
/*41452*/           OPC_CheckType, MVT::v2i64,
/*41454*/           OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*41456*/           OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*41459*/           OPC_EmitMergeInputChains, 1, 1, 
/*41462*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::PANDNrm), 0|OPFL_Chain|OPFL_MemRefs,
                        1/*#VTs*/, MVT::v2i64, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                    // Src: (and:v2i64 (xor:v2i64 (build_vector:v2i64)<<P:Predicate_immAllOnesV>>, VR128:v2i64:$src1), (ld:v2i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>)
                    // Dst: (PANDNrm:v2i64 VR128:v2i64:$src1, addr:iPTR:$src2)
/*41475*/         /*Scope*/ 24, /*->41500*/
/*41476*/           OPC_MoveParent,
/*41477*/           OPC_CheckType, MVT::v1i64,
/*41479*/           OPC_CheckPatternPredicate, 8, // (Subtarget->hasMMX())
/*41481*/           OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*41484*/           OPC_EmitMergeInputChains, 1, 1, 
/*41487*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PANDNrm), 0|OPFL_Chain|OPFL_MemRefs,
                        1/*#VTs*/, MVT::v1i64, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                    // Src: (and:v1i64 (xor:v1i64 (build_vector:v1i64)<<P:Predicate_immAllOnesV>>, VR64:v1i64:$src1), (ld:v1i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)
                    // Dst: (MMX_PANDNrm:v1i64 VR64:v1i64:$src1, addr:iPTR:$src2)
/*41500*/         0, /*End of Scope*/
/*41501*/       0, /*End of Scope*/
              /*SwitchOpcode*/ 114|128,6/*882*/,  ISD::LOAD,// ->42387
/*41505*/       OPC_RecordMemRef,
/*41506*/       OPC_RecordNode, // #0 = 'ld' chained node
/*41507*/       OPC_CheckFoldableChainNode,
/*41508*/       OPC_RecordChild1, // #1 = $src2
/*41509*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*41511*/       OPC_CheckPredicate, 8, // Predicate_load
/*41513*/       OPC_Scope, 34|128,3/*418*/, /*->41934*/ // 5 children in Scope
/*41516*/         OPC_CheckPredicate, 23, // Predicate_memop
/*41518*/         OPC_MoveParent,
/*41519*/         OPC_MoveChild, 1,
/*41521*/         OPC_CheckOpcode, ISD::XOR,
/*41523*/         OPC_Scope, 39|128,1/*167*/, /*->41693*/ // 7 children in Scope
/*41526*/           OPC_MoveChild, 0,
/*41528*/           OPC_SwitchOpcode /*2 cases */, 124,  ISD::BIT_CONVERT,// ->41655
/*41531*/             OPC_Scope, 42, /*->41575*/ // 3 children in Scope
/*41533*/               OPC_RecordChild0, // #2 = $src1
/*41534*/               OPC_CheckChild0Type, MVT::v4f32,
/*41536*/               OPC_MoveParent,
/*41537*/               OPC_MoveChild, 1,
/*41539*/               OPC_CheckOpcode, ISD::BIT_CONVERT,
/*41541*/               OPC_MoveChild, 0,
/*41543*/               OPC_CheckOpcode, ISD::BUILD_VECTOR,
/*41545*/               OPC_CheckPredicate, 67, // Predicate_immAllOnesV
/*41547*/               OPC_CheckType, MVT::v4i32,
/*41549*/               OPC_MoveParent,
/*41550*/               OPC_MoveParent,
/*41551*/               OPC_MoveParent,
/*41552*/               OPC_CheckType, MVT::v2i64,
/*41554*/               OPC_CheckPatternPredicate, 0, // (Subtarget->hasSSE1())
/*41556*/               OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*41559*/               OPC_EmitMergeInputChains, 1, 0, 
/*41562*/               OPC_MorphNodeTo, TARGET_OPCODE(X86::ANDNPSrm), 0|OPFL_Chain|OPFL_MemRefs,
                            1/*#VTs*/, MVT::v2i64, 6/*#Ops*/, 2, 3, 4, 5, 6, 7, 
                        // Src: (and:v2i64 (ld:v2i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>, (xor:v2i64 (bitconvert:v2i64 VR128:v4f32:$src1), (bitconvert:v2i64 (build_vector:v4i32)<<P:Predicate_immAllOnesV>>)))
                        // Dst: (ANDNPSrm:v2i64 VR128:v4f32:$src1, addr:iPTR:$src2)
/*41575*/             /*Scope*/ 42, /*->41618*/
/*41576*/               OPC_MoveChild, 0,
/*41578*/               OPC_CheckOpcode, ISD::BUILD_VECTOR,
/*41580*/               OPC_CheckPredicate, 67, // Predicate_immAllOnesV
/*41582*/               OPC_CheckType, MVT::v4i32,
/*41584*/               OPC_MoveParent,
/*41585*/               OPC_MoveParent,
/*41586*/               OPC_MoveChild, 1,
/*41588*/               OPC_CheckOpcode, ISD::BIT_CONVERT,
/*41590*/               OPC_RecordChild0, // #2 = $src1
/*41591*/               OPC_CheckChild0Type, MVT::v4f32,
/*41593*/               OPC_MoveParent,
/*41594*/               OPC_MoveParent,
/*41595*/               OPC_CheckType, MVT::v2i64,
/*41597*/               OPC_CheckPatternPredicate, 0, // (Subtarget->hasSSE1())
/*41599*/               OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*41602*/               OPC_EmitMergeInputChains, 1, 0, 
/*41605*/               OPC_MorphNodeTo, TARGET_OPCODE(X86::ANDNPSrm), 0|OPFL_Chain|OPFL_MemRefs,
                            1/*#VTs*/, MVT::v2i64, 6/*#Ops*/, 2, 3, 4, 5, 6, 7, 
                        // Src: (and:v2i64 (ld:v2i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>, (xor:v2i64 (bitconvert:v2i64 (build_vector:v4i32)<<P:Predicate_immAllOnesV>>), (bitconvert:v2i64 VR128:v4f32:$src1)))
                        // Dst: (ANDNPSrm:v2i64 VR128:v4f32:$src1, addr:iPTR:$src2)
/*41618*/             /*Scope*/ 35, /*->41654*/
/*41619*/               OPC_RecordChild0, // #2 = $src1
/*41620*/               OPC_CheckChild0Type, MVT::v2f64,
/*41622*/               OPC_MoveParent,
/*41623*/               OPC_MoveChild, 1,
/*41625*/               OPC_CheckOpcode, ISD::BUILD_VECTOR,
/*41627*/               OPC_CheckPredicate, 67, // Predicate_immAllOnesV
/*41629*/               OPC_MoveParent,
/*41630*/               OPC_MoveParent,
/*41631*/               OPC_CheckType, MVT::v2i64,
/*41633*/               OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*41635*/               OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*41638*/               OPC_EmitMergeInputChains, 1, 0, 
/*41641*/               OPC_MorphNodeTo, TARGET_OPCODE(X86::ANDNPDrm), 0|OPFL_Chain|OPFL_MemRefs,
                            1/*#VTs*/, MVT::v2i64, 6/*#Ops*/, 2, 3, 4, 5, 6, 7, 
                        // Src: (and:v2i64 (ld:v2i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>, (xor:v2i64 (bitconvert:v2i64 VR128:v2f64:$src1), (build_vector:v2i64)<<P:Predicate_immAllOnesV>>))
                        // Dst: (ANDNPDrm:v2i64 VR128:v2f64:$src1, addr:iPTR:$src2)
/*41654*/             0, /*End of Scope*/
                    /*SwitchOpcode*/ 35,  ISD::BUILD_VECTOR,// ->41692
/*41657*/             OPC_CheckPredicate, 67, // Predicate_immAllOnesV
/*41659*/             OPC_MoveParent,
/*41660*/             OPC_MoveChild, 1,
/*41662*/             OPC_CheckOpcode, ISD::BIT_CONVERT,
/*41664*/             OPC_RecordChild0, // #2 = $src1
/*41665*/             OPC_CheckChild0Type, MVT::v2f64,
/*41667*/             OPC_MoveParent,
/*41668*/             OPC_MoveParent,
/*41669*/             OPC_CheckType, MVT::v2i64,
/*41671*/             OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*41673*/             OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*41676*/             OPC_EmitMergeInputChains, 1, 0, 
/*41679*/             OPC_MorphNodeTo, TARGET_OPCODE(X86::ANDNPDrm), 0|OPFL_Chain|OPFL_MemRefs,
                          1/*#VTs*/, MVT::v2i64, 6/*#Ops*/, 2, 3, 4, 5, 6, 7, 
                      // Src: (and:v2i64 (ld:v2i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>, (xor:v2i64 (build_vector:v2i64)<<P:Predicate_immAllOnesV>>, (bitconvert:v2i64 VR128:v2f64:$src1)))
                      // Dst: (ANDNPDrm:v2i64 VR128:v2f64:$src1, addr:iPTR:$src2)
                    0, // EndSwitchOpcode
/*41693*/         /*Scope*/ 39, /*->41733*/
/*41694*/           OPC_RecordChild0, // #2 = $src1
/*41695*/           OPC_MoveChild, 1,
/*41697*/           OPC_CheckOpcode, ISD::BIT_CONVERT,
/*41699*/           OPC_MoveChild, 0,
/*41701*/           OPC_CheckOpcode, ISD::BUILD_VECTOR,
/*41703*/           OPC_CheckPredicate, 67, // Predicate_immAllOnesV
/*41705*/           OPC_CheckType, MVT::v4i32,
/*41707*/           OPC_MoveParent,
/*41708*/           OPC_MoveParent,
/*41709*/           OPC_MoveParent,
/*41710*/           OPC_CheckType, MVT::v2i64,
/*41712*/           OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*41714*/           OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*41717*/           OPC_EmitMergeInputChains, 1, 0, 
/*41720*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::PANDNrm), 0|OPFL_Chain|OPFL_MemRefs,
                        1/*#VTs*/, MVT::v2i64, 6/*#Ops*/, 2, 3, 4, 5, 6, 7, 
                    // Src: (and:v2i64 (ld:v2i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>, (xor:v2i64 VR128:v2i64:$src1, (bitconvert:v2i64 (build_vector:v4i32)<<P:Predicate_immAllOnesV>>)))
                    // Dst: (PANDNrm:v2i64 VR128:v16i8:$src1, addr:iPTR:$src2)
/*41733*/         /*Scope*/ 39, /*->41773*/
/*41734*/           OPC_MoveChild, 0,
/*41736*/           OPC_CheckOpcode, ISD::BIT_CONVERT,
/*41738*/           OPC_MoveChild, 0,
/*41740*/           OPC_CheckOpcode, ISD::BUILD_VECTOR,
/*41742*/           OPC_CheckPredicate, 67, // Predicate_immAllOnesV
/*41744*/           OPC_CheckType, MVT::v4i32,
/*41746*/           OPC_MoveParent,
/*41747*/           OPC_MoveParent,
/*41748*/           OPC_RecordChild1, // #2 = $src1
/*41749*/           OPC_MoveParent,
/*41750*/           OPC_CheckType, MVT::v2i64,
/*41752*/           OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*41754*/           OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*41757*/           OPC_EmitMergeInputChains, 1, 0, 
/*41760*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::PANDNrm), 0|OPFL_Chain|OPFL_MemRefs,
                        1/*#VTs*/, MVT::v2i64, 6/*#Ops*/, 2, 3, 4, 5, 6, 7, 
                    // Src: (and:v2i64 (ld:v2i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>, (xor:v2i64 (bitconvert:v2i64 (build_vector:v4i32)<<P:Predicate_immAllOnesV>>), VR128:v2i64:$src1))
                    // Dst: (PANDNrm:v2i64 VR128:v16i8:$src1, addr:iPTR:$src2)
/*41773*/         /*Scope*/ 39, /*->41813*/
/*41774*/           OPC_RecordChild0, // #2 = $src1
/*41775*/           OPC_MoveChild, 1,
/*41777*/           OPC_CheckOpcode, ISD::BIT_CONVERT,
/*41779*/           OPC_MoveChild, 0,
/*41781*/           OPC_CheckOpcode, ISD::BUILD_VECTOR,
/*41783*/           OPC_CheckPredicate, 67, // Predicate_immAllOnesV
/*41785*/           OPC_CheckType, MVT::v8i16,
/*41787*/           OPC_MoveParent,
/*41788*/           OPC_MoveParent,
/*41789*/           OPC_MoveParent,
/*41790*/           OPC_CheckType, MVT::v2i64,
/*41792*/           OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*41794*/           OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*41797*/           OPC_EmitMergeInputChains, 1, 0, 
/*41800*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::PANDNrm), 0|OPFL_Chain|OPFL_MemRefs,
                        1/*#VTs*/, MVT::v2i64, 6/*#Ops*/, 2, 3, 4, 5, 6, 7, 
                    // Src: (and:v2i64 (ld:v2i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>, (xor:v2i64 VR128:v2i64:$src1, (bitconvert:v2i64 (build_vector:v8i16)<<P:Predicate_immAllOnesV>>)))
                    // Dst: (PANDNrm:v2i64 VR128:v16i8:$src1, addr:iPTR:$src2)
/*41813*/         /*Scope*/ 39, /*->41853*/
/*41814*/           OPC_MoveChild, 0,
/*41816*/           OPC_CheckOpcode, ISD::BIT_CONVERT,
/*41818*/           OPC_MoveChild, 0,
/*41820*/           OPC_CheckOpcode, ISD::BUILD_VECTOR,
/*41822*/           OPC_CheckPredicate, 67, // Predicate_immAllOnesV
/*41824*/           OPC_CheckType, MVT::v8i16,
/*41826*/           OPC_MoveParent,
/*41827*/           OPC_MoveParent,
/*41828*/           OPC_RecordChild1, // #2 = $src1
/*41829*/           OPC_MoveParent,
/*41830*/           OPC_CheckType, MVT::v2i64,
/*41832*/           OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*41834*/           OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*41837*/           OPC_EmitMergeInputChains, 1, 0, 
/*41840*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::PANDNrm), 0|OPFL_Chain|OPFL_MemRefs,
                        1/*#VTs*/, MVT::v2i64, 6/*#Ops*/, 2, 3, 4, 5, 6, 7, 
                    // Src: (and:v2i64 (ld:v2i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>, (xor:v2i64 (bitconvert:v2i64 (build_vector:v8i16)<<P:Predicate_immAllOnesV>>), VR128:v2i64:$src1))
                    // Dst: (PANDNrm:v2i64 VR128:v16i8:$src1, addr:iPTR:$src2)
/*41853*/         /*Scope*/ 39, /*->41893*/
/*41854*/           OPC_RecordChild0, // #2 = $src1
/*41855*/           OPC_MoveChild, 1,
/*41857*/           OPC_CheckOpcode, ISD::BIT_CONVERT,
/*41859*/           OPC_MoveChild, 0,
/*41861*/           OPC_CheckOpcode, ISD::BUILD_VECTOR,
/*41863*/           OPC_CheckPredicate, 67, // Predicate_immAllOnesV
/*41865*/           OPC_CheckType, MVT::v16i8,
/*41867*/           OPC_MoveParent,
/*41868*/           OPC_MoveParent,
/*41869*/           OPC_MoveParent,
/*41870*/           OPC_CheckType, MVT::v2i64,
/*41872*/           OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*41874*/           OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*41877*/           OPC_EmitMergeInputChains, 1, 0, 
/*41880*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::PANDNrm), 0|OPFL_Chain|OPFL_MemRefs,
                        1/*#VTs*/, MVT::v2i64, 6/*#Ops*/, 2, 3, 4, 5, 6, 7, 
                    // Src: (and:v2i64 (ld:v2i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>, (xor:v2i64 VR128:v2i64:$src1, (bitconvert:v2i64 (build_vector:v16i8)<<P:Predicate_immAllOnesV>>)))
                    // Dst: (PANDNrm:v2i64 VR128:v16i8:$src1, addr:iPTR:$src2)
/*41893*/         /*Scope*/ 39, /*->41933*/
/*41894*/           OPC_MoveChild, 0,
/*41896*/           OPC_CheckOpcode, ISD::BIT_CONVERT,
/*41898*/           OPC_MoveChild, 0,
/*41900*/           OPC_CheckOpcode, ISD::BUILD_VECTOR,
/*41902*/           OPC_CheckPredicate, 67, // Predicate_immAllOnesV
/*41904*/           OPC_CheckType, MVT::v16i8,
/*41906*/           OPC_MoveParent,
/*41907*/           OPC_MoveParent,
/*41908*/           OPC_RecordChild1, // #2 = $src1
/*41909*/           OPC_MoveParent,
/*41910*/           OPC_CheckType, MVT::v2i64,
/*41912*/           OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*41914*/           OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*41917*/           OPC_EmitMergeInputChains, 1, 0, 
/*41920*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::PANDNrm), 0|OPFL_Chain|OPFL_MemRefs,
                        1/*#VTs*/, MVT::v2i64, 6/*#Ops*/, 2, 3, 4, 5, 6, 7, 
                    // Src: (and:v2i64 (ld:v2i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>, (xor:v2i64 (bitconvert:v2i64 (build_vector:v16i8)<<P:Predicate_immAllOnesV>>), VR128:v2i64:$src1))
                    // Dst: (PANDNrm:v2i64 VR128:v16i8:$src1, addr:iPTR:$src2)
/*41933*/         0, /*End of Scope*/
/*41934*/       /*Scope*/ 107|128,1/*235*/, /*->42171*/
/*41936*/         OPC_MoveParent,
/*41937*/         OPC_MoveChild, 1,
/*41939*/         OPC_CheckOpcode, ISD::XOR,
/*41941*/         OPC_Scope, 37, /*->41980*/ // 6 children in Scope
/*41943*/           OPC_RecordChild0, // #2 = $src1
/*41944*/           OPC_MoveChild, 1,
/*41946*/           OPC_CheckOpcode, ISD::BIT_CONVERT,
/*41948*/           OPC_MoveChild, 0,
/*41950*/           OPC_CheckOpcode, ISD::BUILD_VECTOR,
/*41952*/           OPC_CheckPredicate, 67, // Predicate_immAllOnesV
/*41954*/           OPC_CheckType, MVT::v2i32,
/*41956*/           OPC_MoveParent,
/*41957*/           OPC_MoveParent,
/*41958*/           OPC_MoveParent,
/*41959*/           OPC_CheckType, MVT::v1i64,
/*41961*/           OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*41964*/           OPC_EmitMergeInputChains, 1, 0, 
/*41967*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PANDNrm), 0|OPFL_Chain|OPFL_MemRefs,
                        1/*#VTs*/, MVT::v1i64, 6/*#Ops*/, 2, 3, 4, 5, 6, 7, 
                    // Src: (and:v1i64 (ld:v1i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (xor:v1i64 VR64:v1i64:$src1, (bitconvert:v1i64 (build_vector:v2i32)<<P:Predicate_immAllOnesV>>)))
                    // Dst: (MMX_PANDNrm:v1i64 VR64:v8i8:$src1, addr:iPTR:$src2)
/*41980*/         /*Scope*/ 37, /*->42018*/
/*41981*/           OPC_MoveChild, 0,
/*41983*/           OPC_CheckOpcode, ISD::BIT_CONVERT,
/*41985*/           OPC_MoveChild, 0,
/*41987*/           OPC_CheckOpcode, ISD::BUILD_VECTOR,
/*41989*/           OPC_CheckPredicate, 67, // Predicate_immAllOnesV
/*41991*/           OPC_CheckType, MVT::v2i32,
/*41993*/           OPC_MoveParent,
/*41994*/           OPC_MoveParent,
/*41995*/           OPC_RecordChild1, // #2 = $src1
/*41996*/           OPC_MoveParent,
/*41997*/           OPC_CheckType, MVT::v1i64,
/*41999*/           OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*42002*/           OPC_EmitMergeInputChains, 1, 0, 
/*42005*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PANDNrm), 0|OPFL_Chain|OPFL_MemRefs,
                        1/*#VTs*/, MVT::v1i64, 6/*#Ops*/, 2, 3, 4, 5, 6, 7, 
                    // Src: (and:v1i64 (ld:v1i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (xor:v1i64 (bitconvert:v1i64 (build_vector:v2i32)<<P:Predicate_immAllOnesV>>), VR64:v1i64:$src1))
                    // Dst: (MMX_PANDNrm:v1i64 VR64:v8i8:$src1, addr:iPTR:$src2)
/*42018*/         /*Scope*/ 37, /*->42056*/
/*42019*/           OPC_RecordChild0, // #2 = $src1
/*42020*/           OPC_MoveChild, 1,
/*42022*/           OPC_CheckOpcode, ISD::BIT_CONVERT,
/*42024*/           OPC_MoveChild, 0,
/*42026*/           OPC_CheckOpcode, ISD::BIT_CONVERT,
/*42028*/           OPC_CheckPredicate, 68, // Predicate_immAllOnesV_bc
/*42030*/           OPC_CheckType, MVT::v4i16,
/*42032*/           OPC_MoveParent,
/*42033*/           OPC_MoveParent,
/*42034*/           OPC_MoveParent,
/*42035*/           OPC_CheckType, MVT::v1i64,
/*42037*/           OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*42040*/           OPC_EmitMergeInputChains, 1, 0, 
/*42043*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PANDNrm), 0|OPFL_Chain|OPFL_MemRefs,
                        1/*#VTs*/, MVT::v1i64, 6/*#Ops*/, 2, 3, 4, 5, 6, 7, 
                    // Src: (and:v1i64 (ld:v1i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (xor:v1i64 VR64:v1i64:$src1, (bitconvert:v1i64 (bitconvert:v4i16)<<P:Predicate_immAllOnesV_bc>>)))
                    // Dst: (MMX_PANDNrm:v1i64 VR64:v8i8:$src1, addr:iPTR:$src2)
/*42056*/         /*Scope*/ 37, /*->42094*/
/*42057*/           OPC_MoveChild, 0,
/*42059*/           OPC_CheckOpcode, ISD::BIT_CONVERT,
/*42061*/           OPC_MoveChild, 0,
/*42063*/           OPC_CheckOpcode, ISD::BIT_CONVERT,
/*42065*/           OPC_CheckPredicate, 68, // Predicate_immAllOnesV_bc
/*42067*/           OPC_CheckType, MVT::v4i16,
/*42069*/           OPC_MoveParent,
/*42070*/           OPC_MoveParent,
/*42071*/           OPC_RecordChild1, // #2 = $src1
/*42072*/           OPC_MoveParent,
/*42073*/           OPC_CheckType, MVT::v1i64,
/*42075*/           OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*42078*/           OPC_EmitMergeInputChains, 1, 0, 
/*42081*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PANDNrm), 0|OPFL_Chain|OPFL_MemRefs,
                        1/*#VTs*/, MVT::v1i64, 6/*#Ops*/, 2, 3, 4, 5, 6, 7, 
                    // Src: (and:v1i64 (ld:v1i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (xor:v1i64 (bitconvert:v1i64 (bitconvert:v4i16)<<P:Predicate_immAllOnesV_bc>>), VR64:v1i64:$src1))
                    // Dst: (MMX_PANDNrm:v1i64 VR64:v8i8:$src1, addr:iPTR:$src2)
/*42094*/         /*Scope*/ 37, /*->42132*/
/*42095*/           OPC_RecordChild0, // #2 = $src1
/*42096*/           OPC_MoveChild, 1,
/*42098*/           OPC_CheckOpcode, ISD::BIT_CONVERT,
/*42100*/           OPC_MoveChild, 0,
/*42102*/           OPC_CheckOpcode, ISD::BIT_CONVERT,
/*42104*/           OPC_CheckPredicate, 68, // Predicate_immAllOnesV_bc
/*42106*/           OPC_CheckType, MVT::v8i8,
/*42108*/           OPC_MoveParent,
/*42109*/           OPC_MoveParent,
/*42110*/           OPC_MoveParent,
/*42111*/           OPC_CheckType, MVT::v1i64,
/*42113*/           OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*42116*/           OPC_EmitMergeInputChains, 1, 0, 
/*42119*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PANDNrm), 0|OPFL_Chain|OPFL_MemRefs,
                        1/*#VTs*/, MVT::v1i64, 6/*#Ops*/, 2, 3, 4, 5, 6, 7, 
                    // Src: (and:v1i64 (ld:v1i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (xor:v1i64 VR64:v1i64:$src1, (bitconvert:v1i64 (bitconvert:v8i8)<<P:Predicate_immAllOnesV_bc>>)))
                    // Dst: (MMX_PANDNrm:v1i64 VR64:v8i8:$src1, addr:iPTR:$src2)
/*42132*/         /*Scope*/ 37, /*->42170*/
/*42133*/           OPC_MoveChild, 0,
/*42135*/           OPC_CheckOpcode, ISD::BIT_CONVERT,
/*42137*/           OPC_MoveChild, 0,
/*42139*/           OPC_CheckOpcode, ISD::BIT_CONVERT,
/*42141*/           OPC_CheckPredicate, 68, // Predicate_immAllOnesV_bc
/*42143*/           OPC_CheckType, MVT::v8i8,
/*42145*/           OPC_MoveParent,
/*42146*/           OPC_MoveParent,
/*42147*/           OPC_RecordChild1, // #2 = $src1
/*42148*/           OPC_MoveParent,
/*42149*/           OPC_CheckType, MVT::v1i64,
/*42151*/           OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*42154*/           OPC_EmitMergeInputChains, 1, 0, 
/*42157*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PANDNrm), 0|OPFL_Chain|OPFL_MemRefs,
                        1/*#VTs*/, MVT::v1i64, 6/*#Ops*/, 2, 3, 4, 5, 6, 7, 
                    // Src: (and:v1i64 (ld:v1i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (xor:v1i64 (bitconvert:v1i64 (bitconvert:v8i8)<<P:Predicate_immAllOnesV_bc>>), VR64:v1i64:$src1))
                    // Dst: (MMX_PANDNrm:v1i64 VR64:v8i8:$src1, addr:iPTR:$src2)
/*42170*/         0, /*End of Scope*/
/*42171*/       /*Scope*/ 75, /*->42247*/
/*42172*/         OPC_CheckPredicate, 23, // Predicate_memop
/*42174*/         OPC_MoveParent,
/*42175*/         OPC_MoveChild, 1,
/*42177*/         OPC_CheckOpcode, ISD::XOR,
/*42179*/         OPC_Scope, 32, /*->42213*/ // 2 children in Scope
/*42181*/           OPC_RecordChild0, // #2 = $src1
/*42182*/           OPC_MoveChild, 1,
/*42184*/           OPC_CheckOpcode, ISD::BUILD_VECTOR,
/*42186*/           OPC_CheckPredicate, 67, // Predicate_immAllOnesV
/*42188*/           OPC_MoveParent,
/*42189*/           OPC_MoveParent,
/*42190*/           OPC_CheckType, MVT::v2i64,
/*42192*/           OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*42194*/           OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*42197*/           OPC_EmitMergeInputChains, 1, 0, 
/*42200*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::PANDNrm), 0|OPFL_Chain|OPFL_MemRefs,
                        1/*#VTs*/, MVT::v2i64, 6/*#Ops*/, 2, 3, 4, 5, 6, 7, 
                    // Src: (and:v2i64 (ld:v2i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>, (xor:v2i64 VR128:v2i64:$src1, (build_vector:v2i64)<<P:Predicate_immAllOnesV>>))
                    // Dst: (PANDNrm:v2i64 VR128:v2i64:$src1, addr:iPTR:$src2)
/*42213*/         /*Scope*/ 32, /*->42246*/
/*42214*/           OPC_MoveChild, 0,
/*42216*/           OPC_CheckOpcode, ISD::BUILD_VECTOR,
/*42218*/           OPC_CheckPredicate, 67, // Predicate_immAllOnesV
/*42220*/           OPC_MoveParent,
/*42221*/           OPC_RecordChild1, // #2 = $src1
/*42222*/           OPC_MoveParent,
/*42223*/           OPC_CheckType, MVT::v2i64,
/*42225*/           OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*42227*/           OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*42230*/           OPC_EmitMergeInputChains, 1, 0, 
/*42233*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::PANDNrm), 0|OPFL_Chain|OPFL_MemRefs,
                        1/*#VTs*/, MVT::v2i64, 6/*#Ops*/, 2, 3, 4, 5, 6, 7, 
                    // Src: (and:v2i64 (ld:v2i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>, (xor:v2i64 (build_vector:v2i64)<<P:Predicate_immAllOnesV>>, VR128:v2i64:$src1))
                    // Dst: (PANDNrm:v2i64 VR128:v2i64:$src1, addr:iPTR:$src2)
/*42246*/         0, /*End of Scope*/
/*42247*/       /*Scope*/ 73, /*->42321*/
/*42248*/         OPC_MoveParent,
/*42249*/         OPC_MoveChild, 1,
/*42251*/         OPC_CheckOpcode, ISD::XOR,
/*42253*/         OPC_Scope, 32, /*->42287*/ // 2 children in Scope
/*42255*/           OPC_RecordChild0, // #2 = $src1
/*42256*/           OPC_MoveChild, 1,
/*42258*/           OPC_CheckOpcode, ISD::BUILD_VECTOR,
/*42260*/           OPC_CheckPredicate, 67, // Predicate_immAllOnesV
/*42262*/           OPC_MoveParent,
/*42263*/           OPC_MoveParent,
/*42264*/           OPC_CheckType, MVT::v1i64,
/*42266*/           OPC_CheckPatternPredicate, 8, // (Subtarget->hasMMX())
/*42268*/           OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*42271*/           OPC_EmitMergeInputChains, 1, 0, 
/*42274*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PANDNrm), 0|OPFL_Chain|OPFL_MemRefs,
                        1/*#VTs*/, MVT::v1i64, 6/*#Ops*/, 2, 3, 4, 5, 6, 7, 
                    // Src: (and:v1i64 (ld:v1i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (xor:v1i64 VR64:v1i64:$src1, (build_vector:v1i64)<<P:Predicate_immAllOnesV>>))
                    // Dst: (MMX_PANDNrm:v1i64 VR64:v1i64:$src1, addr:iPTR:$src2)
/*42287*/         /*Scope*/ 32, /*->42320*/
/*42288*/           OPC_MoveChild, 0,
/*42290*/           OPC_CheckOpcode, ISD::BUILD_VECTOR,
/*42292*/           OPC_CheckPredicate, 67, // Predicate_immAllOnesV
/*42294*/           OPC_MoveParent,
/*42295*/           OPC_RecordChild1, // #2 = $src1
/*42296*/           OPC_MoveParent,
/*42297*/           OPC_CheckType, MVT::v1i64,
/*42299*/           OPC_CheckPatternPredicate, 8, // (Subtarget->hasMMX())
/*42301*/           OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*42304*/           OPC_EmitMergeInputChains, 1, 0, 
/*42307*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PANDNrm), 0|OPFL_Chain|OPFL_MemRefs,
                        1/*#VTs*/, MVT::v1i64, 6/*#Ops*/, 2, 3, 4, 5, 6, 7, 
                    // Src: (and:v1i64 (ld:v1i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (xor:v1i64 (build_vector:v1i64)<<P:Predicate_immAllOnesV>>, VR64:v1i64:$src1))
                    // Dst: (MMX_PANDNrm:v1i64 VR64:v1i64:$src1, addr:iPTR:$src2)
/*42320*/         0, /*End of Scope*/
/*42321*/       /*Scope*/ 64, /*->42386*/
/*42322*/         OPC_CheckPredicate, 23, // Predicate_memop
/*42324*/         OPC_MoveParent,
/*42325*/         OPC_MoveChild, 1,
/*42327*/         OPC_CheckOpcode, ISD::BIT_CONVERT,
/*42329*/         OPC_RecordChild0, // #2 = $src1
/*42330*/         OPC_Scope, 26, /*->42358*/ // 2 children in Scope
/*42332*/           OPC_CheckChild0Type, MVT::v4f32,
/*42334*/           OPC_MoveParent,
/*42335*/           OPC_CheckType, MVT::v2i64,
/*42337*/           OPC_CheckPatternPredicate, 0, // (Subtarget->hasSSE1())
/*42339*/           OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*42342*/           OPC_EmitMergeInputChains, 1, 0, 
/*42345*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::ANDPSrm), 0|OPFL_Chain|OPFL_MemRefs,
                        1/*#VTs*/, MVT::v2i64, 6/*#Ops*/, 2, 3, 4, 5, 6, 7, 
                    // Src: (and:v2i64 (ld:v2i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>, (bitconvert:v2i64 VR128:v4f32:$src1))
                    // Dst: (ANDPSrm:v2i64 VR128:v4f32:$src1, addr:iPTR:$src2)
/*42358*/         /*Scope*/ 26, /*->42385*/
/*42359*/           OPC_CheckChild0Type, MVT::v2f64,
/*42361*/           OPC_MoveParent,
/*42362*/           OPC_CheckType, MVT::v2i64,
/*42364*/           OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*42366*/           OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*42369*/           OPC_EmitMergeInputChains, 1, 0, 
/*42372*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::ANDPDrm), 0|OPFL_Chain|OPFL_MemRefs,
                        1/*#VTs*/, MVT::v2i64, 6/*#Ops*/, 2, 3, 4, 5, 6, 7, 
                    // Src: (and:v2i64 (ld:v2i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>, (bitconvert:v2i64 VR128:v2f64:$src1))
                    // Dst: (ANDPDrm:v2i64 VR128:v2f64:$src1, addr:iPTR:$src2)
/*42385*/         0, /*End of Scope*/
/*42386*/       0, /*End of Scope*/
              /*SwitchOpcode*/ 87,  ISD::BIT_CONVERT,// ->42476
/*42389*/       OPC_RecordChild0, // #0 = $src1
/*42390*/       OPC_Scope, 41, /*->42433*/ // 2 children in Scope
/*42392*/         OPC_CheckChild0Type, MVT::v4f32,
/*42394*/         OPC_MoveParent,
/*42395*/         OPC_MoveChild, 1,
/*42397*/         OPC_CheckOpcode, ISD::LOAD,
/*42399*/         OPC_RecordMemRef,
/*42400*/         OPC_RecordNode, // #1 = 'ld' chained node
/*42401*/         OPC_CheckFoldableChainNode,
/*42402*/         OPC_RecordChild1, // #2 = $src2
/*42403*/         OPC_CheckPredicate, 2, // Predicate_unindexedload
/*42405*/         OPC_CheckPredicate, 8, // Predicate_load
/*42407*/         OPC_CheckPredicate, 23, // Predicate_memop
/*42409*/         OPC_MoveParent,
/*42410*/         OPC_CheckType, MVT::v2i64,
/*42412*/         OPC_CheckPatternPredicate, 0, // (Subtarget->hasSSE1())
/*42414*/         OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*42417*/         OPC_EmitMergeInputChains, 1, 1, 
/*42420*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::ANDPSrm), 0|OPFL_Chain|OPFL_MemRefs,
                      1/*#VTs*/, MVT::v2i64, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                  // Src: (and:v2i64 (bitconvert:v2i64 VR128:v4f32:$src1), (ld:v2i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>)
                  // Dst: (ANDPSrm:v2i64 VR128:v4f32:$src1, addr:iPTR:$src2)
/*42433*/       /*Scope*/ 41, /*->42475*/
/*42434*/         OPC_CheckChild0Type, MVT::v2f64,
/*42436*/         OPC_MoveParent,
/*42437*/         OPC_MoveChild, 1,
/*42439*/         OPC_CheckOpcode, ISD::LOAD,
/*42441*/         OPC_RecordMemRef,
/*42442*/         OPC_RecordNode, // #1 = 'ld' chained node
/*42443*/         OPC_CheckFoldableChainNode,
/*42444*/         OPC_RecordChild1, // #2 = $src2
/*42445*/         OPC_CheckPredicate, 2, // Predicate_unindexedload
/*42447*/         OPC_CheckPredicate, 8, // Predicate_load
/*42449*/         OPC_CheckPredicate, 23, // Predicate_memop
/*42451*/         OPC_MoveParent,
/*42452*/         OPC_CheckType, MVT::v2i64,
/*42454*/         OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*42456*/         OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*42459*/         OPC_EmitMergeInputChains, 1, 1, 
/*42462*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::ANDPDrm), 0|OPFL_Chain|OPFL_MemRefs,
                      1/*#VTs*/, MVT::v2i64, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                  // Src: (and:v2i64 (bitconvert:v2i64 VR128:v2f64:$src1), (ld:v2i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>)
                  // Dst: (ANDPDrm:v2i64 VR128:v2f64:$src1, addr:iPTR:$src2)
/*42475*/       0, /*End of Scope*/
              0, // EndSwitchOpcode
/*42477*/   /*Scope*/ 46|128,1/*174*/, /*->42653*/
/*42479*/     OPC_RecordChild0, // #0 = $src1
/*42480*/     OPC_MoveChild, 1,
/*42482*/     OPC_CheckOpcode, ISD::LOAD,
/*42484*/     OPC_RecordMemRef,
/*42485*/     OPC_RecordNode, // #1 = 'ld' chained node
/*42486*/     OPC_CheckFoldableChainNode,
/*42487*/     OPC_RecordChild1, // #2 = $src2
/*42488*/     OPC_CheckPredicate, 2, // Predicate_unindexedload
/*42490*/     OPC_Scope, 27, /*->42519*/ // 4 children in Scope
/*42492*/       OPC_CheckPredicate, 8, // Predicate_load
/*42494*/       OPC_CheckPredicate, 9, // Predicate_dsload
/*42496*/       OPC_MoveParent,
/*42497*/       OPC_CheckType, MVT::i8,
/*42499*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*42502*/       OPC_EmitMergeInputChains, 1, 1, 
/*42505*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::AND8rm), 0|OPFL_Chain|OPFL_MemRefs,
                    2/*#VTs*/, MVT::i8, MVT::i32, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (and:i8 GR8:i8:$src1, (ld:i8 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>)
                // Dst: (AND8rm:i8 GR8:i8:$src1, addr:iPTR:$src2)
/*42519*/     /*Scope*/ 25, /*->42545*/
/*42520*/       OPC_CheckPredicate, 6, // Predicate_loadi16
/*42522*/       OPC_MoveParent,
/*42523*/       OPC_CheckType, MVT::i16,
/*42525*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*42528*/       OPC_EmitMergeInputChains, 1, 1, 
/*42531*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::AND16rm), 0|OPFL_Chain|OPFL_MemRefs,
                    2/*#VTs*/, MVT::i16, MVT::i32, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (and:i16 GR16:i16:$src1, (ld:i16 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>)
                // Dst: (AND16rm:i16 GR16:i16:$src1, addr:iPTR:$src2)
/*42545*/     /*Scope*/ 25, /*->42571*/
/*42546*/       OPC_CheckPredicate, 3, // Predicate_loadi32
/*42548*/       OPC_MoveParent,
/*42549*/       OPC_CheckType, MVT::i32,
/*42551*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*42554*/       OPC_EmitMergeInputChains, 1, 1, 
/*42557*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::AND32rm), 0|OPFL_Chain|OPFL_MemRefs,
                    2/*#VTs*/, MVT::i32, MVT::i32, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (and:i32 GR32:i32:$src1, (ld:i32 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)
                // Dst: (AND32rm:i32 GR32:i32:$src1, addr:iPTR:$src2)
/*42571*/     /*Scope*/ 80, /*->42652*/
/*42572*/       OPC_CheckPredicate, 8, // Predicate_load
/*42574*/       OPC_Scope, 23, /*->42599*/ // 3 children in Scope
/*42576*/         OPC_MoveParent,
/*42577*/         OPC_CheckType, MVT::i64,
/*42579*/         OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*42582*/         OPC_EmitMergeInputChains, 1, 1, 
/*42585*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::AND64rm), 0|OPFL_Chain|OPFL_MemRefs,
                      2/*#VTs*/, MVT::i64, MVT::i32, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                  // Src: (and:i64 GR64:i64:$src1, (ld:i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)
                  // Dst: (AND64rm:i64 GR64:i64:$src1, addr:iPTR:$src2)
/*42599*/       /*Scope*/ 26, /*->42626*/
/*42600*/         OPC_CheckPredicate, 23, // Predicate_memop
/*42602*/         OPC_MoveParent,
/*42603*/         OPC_CheckType, MVT::v2i64,
/*42605*/         OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*42607*/         OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*42610*/         OPC_EmitMergeInputChains, 1, 1, 
/*42613*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::PANDrm), 0|OPFL_Chain|OPFL_MemRefs,
                      1/*#VTs*/, MVT::v2i64, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                  // Src: (and:v2i64 VR128:v2i64:$src1, (ld:v2i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>)
                  // Dst: (PANDrm:v2i64 VR128:v2i64:$src1, addr:iPTR:$src2)
/*42626*/       /*Scope*/ 24, /*->42651*/
/*42627*/         OPC_MoveParent,
/*42628*/         OPC_CheckType, MVT::v1i64,
/*42630*/         OPC_CheckPatternPredicate, 8, // (Subtarget->hasMMX())
/*42632*/         OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*42635*/         OPC_EmitMergeInputChains, 1, 1, 
/*42638*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PANDrm), 0|OPFL_Chain|OPFL_MemRefs,
                      1/*#VTs*/, MVT::v1i64, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                  // Src: (and:v1i64 VR64:v1i64:$src1, (ld:v1i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)
                  // Dst: (MMX_PANDrm:v1i64 VR64:v1i64:$src1, addr:iPTR:$src2)
/*42651*/       0, /*End of Scope*/
/*42652*/     0, /*End of Scope*/
/*42653*/   /*Scope*/ 51|128,1/*179*/, /*->42834*/
/*42655*/     OPC_MoveChild, 0,
/*42657*/     OPC_CheckOpcode, ISD::LOAD,
/*42659*/     OPC_RecordMemRef,
/*42660*/     OPC_RecordNode, // #0 = 'ld' chained node
/*42661*/     OPC_CheckFoldableChainNode,
/*42662*/     OPC_RecordChild1, // #1 = $src2
/*42663*/     OPC_CheckPredicate, 2, // Predicate_unindexedload
/*42665*/     OPC_Scope, 28, /*->42695*/ // 4 children in Scope
/*42667*/       OPC_CheckPredicate, 8, // Predicate_load
/*42669*/       OPC_CheckPredicate, 9, // Predicate_dsload
/*42671*/       OPC_MoveParent,
/*42672*/       OPC_RecordChild1, // #2 = $src1
/*42673*/       OPC_CheckType, MVT::i8,
/*42675*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*42678*/       OPC_EmitMergeInputChains, 1, 0, 
/*42681*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::AND8rm), 0|OPFL_Chain|OPFL_MemRefs,
                    2/*#VTs*/, MVT::i8, MVT::i32, 6/*#Ops*/, 2, 3, 4, 5, 6, 7, 
                // Src: (and:i8 (ld:i8 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>, GR8:i8:$src1)
                // Dst: (AND8rm:i8 GR8:i8:$src1, addr:iPTR:$src2)
/*42695*/     /*Scope*/ 26, /*->42722*/
/*42696*/       OPC_CheckPredicate, 6, // Predicate_loadi16
/*42698*/       OPC_MoveParent,
/*42699*/       OPC_RecordChild1, // #2 = $src1
/*42700*/       OPC_CheckType, MVT::i16,
/*42702*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*42705*/       OPC_EmitMergeInputChains, 1, 0, 
/*42708*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::AND16rm), 0|OPFL_Chain|OPFL_MemRefs,
                    2/*#VTs*/, MVT::i16, MVT::i32, 6/*#Ops*/, 2, 3, 4, 5, 6, 7, 
                // Src: (and:i16 (ld:i16 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, GR16:i16:$src1)
                // Dst: (AND16rm:i16 GR16:i16:$src1, addr:iPTR:$src2)
/*42722*/     /*Scope*/ 26, /*->42749*/
/*42723*/       OPC_CheckPredicate, 3, // Predicate_loadi32
/*42725*/       OPC_MoveParent,
/*42726*/       OPC_RecordChild1, // #2 = $src1
/*42727*/       OPC_CheckType, MVT::i32,
/*42729*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*42732*/       OPC_EmitMergeInputChains, 1, 0, 
/*42735*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::AND32rm), 0|OPFL_Chain|OPFL_MemRefs,
                    2/*#VTs*/, MVT::i32, MVT::i32, 6/*#Ops*/, 2, 3, 4, 5, 6, 7, 
                // Src: (and:i32 (ld:i32 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, GR32:i32:$src1)
                // Dst: (AND32rm:i32 GR32:i32:$src1, addr:iPTR:$src2)
/*42749*/     /*Scope*/ 83, /*->42833*/
/*42750*/       OPC_CheckPredicate, 8, // Predicate_load
/*42752*/       OPC_Scope, 24, /*->42778*/ // 3 children in Scope
/*42754*/         OPC_MoveParent,
/*42755*/         OPC_RecordChild1, // #2 = $src1
/*42756*/         OPC_CheckType, MVT::i64,
/*42758*/         OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*42761*/         OPC_EmitMergeInputChains, 1, 0, 
/*42764*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::AND64rm), 0|OPFL_Chain|OPFL_MemRefs,
                      2/*#VTs*/, MVT::i64, MVT::i32, 6/*#Ops*/, 2, 3, 4, 5, 6, 7, 
                  // Src: (and:i64 (ld:i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR64:i64:$src1)
                  // Dst: (AND64rm:i64 GR64:i64:$src1, addr:iPTR:$src2)
/*42778*/       /*Scope*/ 27, /*->42806*/
/*42779*/         OPC_CheckPredicate, 23, // Predicate_memop
/*42781*/         OPC_MoveParent,
/*42782*/         OPC_RecordChild1, // #2 = $src1
/*42783*/         OPC_CheckType, MVT::v2i64,
/*42785*/         OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*42787*/         OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*42790*/         OPC_EmitMergeInputChains, 1, 0, 
/*42793*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::PANDrm), 0|OPFL_Chain|OPFL_MemRefs,
                      1/*#VTs*/, MVT::v2i64, 6/*#Ops*/, 2, 3, 4, 5, 6, 7, 
                  // Src: (and:v2i64 (ld:v2i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>, VR128:v2i64:$src1)
                  // Dst: (PANDrm:v2i64 VR128:v2i64:$src1, addr:iPTR:$src2)
/*42806*/       /*Scope*/ 25, /*->42832*/
/*42807*/         OPC_MoveParent,
/*42808*/         OPC_RecordChild1, // #2 = $src1
/*42809*/         OPC_CheckType, MVT::v1i64,
/*42811*/         OPC_CheckPatternPredicate, 8, // (Subtarget->hasMMX())
/*42813*/         OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*42816*/         OPC_EmitMergeInputChains, 1, 0, 
/*42819*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PANDrm), 0|OPFL_Chain|OPFL_MemRefs,
                      1/*#VTs*/, MVT::v1i64, 6/*#Ops*/, 2, 3, 4, 5, 6, 7, 
                  // Src: (and:v1i64 (ld:v1i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR64:v1i64:$src1)
                  // Dst: (MMX_PANDrm:v1i64 VR64:v1i64:$src1, addr:iPTR:$src2)
/*42832*/       0, /*End of Scope*/
/*42833*/     0, /*End of Scope*/
/*42834*/   /*Scope*/ 16|128,1/*144*/, /*->42980*/
/*42836*/     OPC_CheckAndImm, 127|128,1/*255*/, 
/*42839*/     OPC_MoveChild, 0,
/*42841*/     OPC_CheckOpcode, ISD::SRL,
/*42843*/     OPC_RecordChild0, // #0 = $src
/*42844*/     OPC_MoveChild, 1,
/*42846*/     OPC_CheckInteger, 8, 
/*42848*/     OPC_CheckType, MVT::i8,
/*42850*/     OPC_MoveParent,
/*42851*/     OPC_CheckPredicate, 15, // Predicate_srl_su
/*42853*/     OPC_MoveParent,
/*42854*/     OPC_SwitchType /*2 cases */, 72,  MVT::i32,// ->42929
/*42857*/       OPC_Scope, 34, /*->42893*/ // 2 children in Scope
/*42859*/         OPC_CheckPatternPredicate, 2, // (!Subtarget->is64Bit())
/*42861*/         OPC_EmitInteger, MVT::i32, X86::GR32_ABCDRegClassID,
/*42864*/         OPC_EmitNode, TARGET_OPCODE(TargetOpcode::COPY_TO_REGCLASS), 0,
                      1/*#VTs*/, MVT::i32, 2/*#Ops*/, 0, 1,  // Results = #2 
/*42873*/         OPC_EmitInteger, MVT::i32, 2, 
/*42876*/         OPC_EmitNode, TARGET_OPCODE(TargetOpcode::EXTRACT_SUBREG), 0,
                      1/*#VTs*/, MVT::i8, 2/*#Ops*/, 2, 3,  // Results = #4 
/*42885*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVZX32rr8), 0,
                      1/*#VTs*/, MVT::i32, 1/*#Ops*/, 4, 
                  // Src: (and:i32 (srl:i32 GR32:i32:$src, 8:i8)<<P:Predicate_srl_su>>, 255:i32)
                  // Dst: (MOVZX32rr8:i32 (EXTRACT_SUBREG:i8 (COPY_TO_REGCLASS:i32 GR32:i32:$src, GR32_ABCD:i32), 2:i32))
/*42893*/       /*Scope*/ 34, /*->42928*/
/*42894*/         OPC_CheckPatternPredicate, 3, // (Subtarget->is64Bit())
/*42896*/         OPC_EmitInteger, MVT::i32, X86::GR32_ABCDRegClassID,
/*42899*/         OPC_EmitNode, TARGET_OPCODE(TargetOpcode::COPY_TO_REGCLASS), 0,
                      1/*#VTs*/, MVT::i32, 2/*#Ops*/, 0, 1,  // Results = #2 
/*42908*/         OPC_EmitInteger, MVT::i32, 2, 
/*42911*/         OPC_EmitNode, TARGET_OPCODE(TargetOpcode::EXTRACT_SUBREG), 0,
                      1/*#VTs*/, MVT::i8, 2/*#Ops*/, 2, 3,  // Results = #4 
/*42920*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVZX32_NOREXrr8), 0,
                      1/*#VTs*/, MVT::i32, 1/*#Ops*/, 4, 
                  // Src: (and:i32 (srl:i32 GR32:i32:$src, 8:i8)<<P:Predicate_srl_su>>, 255:i32)
                  // Dst: (MOVZX32_NOREXrr8:i32 (EXTRACT_SUBREG:i8 (COPY_TO_REGCLASS:i32 GR32:i32:$src, GR32_ABCD:i32), 2:i32))
/*42928*/       0, /*End of Scope*/
              /*SwitchType*/ 48,  MVT::i64,// ->42979
/*42931*/       OPC_EmitInteger, MVT::i64, 0, 
/*42934*/       OPC_EmitInteger, MVT::i32, X86::GR64_ABCDRegClassID,
/*42937*/       OPC_EmitNode, TARGET_OPCODE(TargetOpcode::COPY_TO_REGCLASS), 0,
                    1/*#VTs*/, MVT::i64, 2/*#Ops*/, 0, 2,  // Results = #3 
/*42946*/       OPC_EmitInteger, MVT::i32, 2, 
/*42949*/       OPC_EmitNode, TARGET_OPCODE(TargetOpcode::EXTRACT_SUBREG), 0,
                    1/*#VTs*/, MVT::i8, 2/*#Ops*/, 3, 4,  // Results = #5 
/*42958*/       OPC_EmitNode, TARGET_OPCODE(X86::MOVZX32_NOREXrr8), 0,
                    1/*#VTs*/, MVT::i32, 1/*#Ops*/, 5,  // Results = #6 
/*42966*/       OPC_EmitInteger, MVT::i32, 4, 
/*42969*/       OPC_MorphNodeTo, TARGET_OPCODE(TargetOpcode::SUBREG_TO_REG), 0,
                    1/*#VTs*/, MVT::i64, 3/*#Ops*/, 1, 6, 7, 
                // Src: (and:i64 (srl:i64 GR64:i64:$src, 8:i8)<<P:Predicate_srl_su>>, 255:i64)
                // Dst: (SUBREG_TO_REG:i64 0:i64, (MOVZX32_NOREXrr8:i32 (EXTRACT_SUBREG:i8 (COPY_TO_REGCLASS:i64 GR64:i64:$src, GR64_ABCD:i64), 2:i32)), 4:i32)
              0, // EndSwitchType
/*42980*/   /*Scope*/ 73|128,2/*329*/, /*->43311*/
/*42982*/     OPC_MoveChild, 0,
/*42984*/     OPC_SwitchOpcode /*2 cases */, 126|128,1/*254*/,  ISD::XOR,// ->43242
/*42988*/       OPC_Scope, 74, /*->43064*/ // 3 children in Scope
/*42990*/         OPC_MoveChild, 0,
/*42992*/         OPC_SwitchOpcode /*2 cases */, 33,  ISD::BIT_CONVERT,// ->43028
/*42995*/           OPC_RecordChild0, // #0 = $src1
/*42996*/           OPC_CheckChild0Type, MVT::v2f64,
/*42998*/           OPC_MoveParent,
/*42999*/           OPC_MoveChild, 1,
/*43001*/           OPC_CheckOpcode, ISD::BUILD_VECTOR,
/*43003*/           OPC_CheckPredicate, 67, // Predicate_immAllOnesV
/*43005*/           OPC_MoveParent,
/*43006*/           OPC_MoveParent,
/*43007*/           OPC_MoveChild, 1,
/*43009*/           OPC_CheckOpcode, ISD::BIT_CONVERT,
/*43011*/           OPC_RecordChild0, // #1 = $src2
/*43012*/           OPC_CheckChild0Type, MVT::v2f64,
/*43014*/           OPC_MoveParent,
/*43015*/           OPC_CheckType, MVT::v2i64,
/*43017*/           OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*43019*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::ANDNPDrr), 0,
                        1/*#VTs*/, MVT::v2i64, 2/*#Ops*/, 0, 1, 
                    // Src: (and:v2i64 (xor:v2i64 (bitconvert:v2i64 VR128:v2f64:$src1), (build_vector:v2i64)<<P:Predicate_immAllOnesV>>), (bitconvert:v2i64 VR128:v2f64:$src2))
                    // Dst: (ANDNPDrr:v2i64 VR128:v2f64:$src1, VR128:v2f64:$src2)
                  /*SwitchOpcode*/ 33,  ISD::BUILD_VECTOR,// ->43063
/*43030*/           OPC_CheckPredicate, 67, // Predicate_immAllOnesV
/*43032*/           OPC_MoveParent,
/*43033*/           OPC_MoveChild, 1,
/*43035*/           OPC_CheckOpcode, ISD::BIT_CONVERT,
/*43037*/           OPC_RecordChild0, // #0 = $src1
/*43038*/           OPC_CheckChild0Type, MVT::v2f64,
/*43040*/           OPC_MoveParent,
/*43041*/           OPC_MoveParent,
/*43042*/           OPC_MoveChild, 1,
/*43044*/           OPC_CheckOpcode, ISD::BIT_CONVERT,
/*43046*/           OPC_RecordChild0, // #1 = $src2
/*43047*/           OPC_CheckChild0Type, MVT::v2f64,
/*43049*/           OPC_MoveParent,
/*43050*/           OPC_CheckType, MVT::v2i64,
/*43052*/           OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*43054*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::ANDNPDrr), 0,
                        1/*#VTs*/, MVT::v2i64, 2/*#Ops*/, 0, 1, 
                    // Src: (and:v2i64 (xor:v2i64 (build_vector:v2i64)<<P:Predicate_immAllOnesV>>, (bitconvert:v2i64 VR128:v2f64:$src1)), (bitconvert:v2i64 VR128:v2f64:$src2))
                    // Dst: (ANDNPDrr:v2i64 VR128:v2f64:$src1, VR128:v2f64:$src2)
                  0, // EndSwitchOpcode
/*43064*/       /*Scope*/ 16|128,1/*144*/, /*->43210*/
/*43066*/         OPC_RecordChild0, // #0 = $src1
/*43067*/         OPC_MoveChild, 1,
/*43069*/         OPC_CheckOpcode, ISD::BIT_CONVERT,
/*43071*/         OPC_MoveChild, 0,
/*43073*/         OPC_SwitchOpcode /*2 cases */, 93,  ISD::BUILD_VECTOR,// ->43169
/*43076*/           OPC_CheckPredicate, 67, // Predicate_immAllOnesV
/*43078*/           OPC_SwitchType /*4 cases */, 32,  MVT::v4i32,// ->43113
/*43081*/             OPC_MoveParent,
/*43082*/             OPC_MoveParent,
/*43083*/             OPC_MoveParent,
/*43084*/             OPC_RecordChild1, // #1 = $src2
/*43085*/             OPC_CheckType, MVT::v2i64,
/*43087*/             OPC_Scope, 11, /*->43100*/ // 2 children in Scope
/*43089*/               OPC_CheckPatternPredicate, 0, // (Subtarget->hasSSE1())
/*43091*/               OPC_MorphNodeTo, TARGET_OPCODE(X86::ANDNPSrr), 0,
                            1/*#VTs*/, MVT::v2i64, 2/*#Ops*/, 0, 1, 
                        // Src: (and:v2i64 (xor:v2i64 VR128:v2i64:$src1, (bitconvert:v2i64 (build_vector:v4i32)<<P:Predicate_immAllOnesV>>)), VR128:v2i64:$src2)
                        // Dst: (ANDNPSrr:v2i64 VR128:v2i64:$src1, VR128:v2i64:$src2)
/*43100*/             /*Scope*/ 11, /*->43112*/
/*43101*/               OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*43103*/               OPC_MorphNodeTo, TARGET_OPCODE(X86::PANDNrr), 0,
                            1/*#VTs*/, MVT::v2i64, 2/*#Ops*/, 0, 1, 
                        // Src: (and:v2i64 (xor:v2i64 VR128:v2i64:$src1, (bitconvert:v2i64 (build_vector:v4i32)<<P:Predicate_immAllOnesV>>)), VR128:v2i64:$src2)
                        // Dst: (PANDNrr:v2i64 VR128:v16i8:$src1, VR128:v16i8:$src2)
/*43112*/             0, /*End of Scope*/
                    /*SwitchType*/ 17,  MVT::v8i16,// ->43132
/*43115*/             OPC_MoveParent,
/*43116*/             OPC_MoveParent,
/*43117*/             OPC_MoveParent,
/*43118*/             OPC_RecordChild1, // #1 = $src2
/*43119*/             OPC_CheckType, MVT::v2i64,
/*43121*/             OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*43123*/             OPC_MorphNodeTo, TARGET_OPCODE(X86::PANDNrr), 0,
                          1/*#VTs*/, MVT::v2i64, 2/*#Ops*/, 0, 1, 
                      // Src: (and:v2i64 (xor:v2i64 VR128:v2i64:$src1, (bitconvert:v2i64 (build_vector:v8i16)<<P:Predicate_immAllOnesV>>)), VR128:v2i64:$src2)
                      // Dst: (PANDNrr:v2i64 VR128:v16i8:$src1, VR128:v16i8:$src2)
                    /*SwitchType*/ 17,  MVT::v16i8,// ->43151
/*43134*/             OPC_MoveParent,
/*43135*/             OPC_MoveParent,
/*43136*/             OPC_MoveParent,
/*43137*/             OPC_RecordChild1, // #1 = $src2
/*43138*/             OPC_CheckType, MVT::v2i64,
/*43140*/             OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*43142*/             OPC_MorphNodeTo, TARGET_OPCODE(X86::PANDNrr), 0,
                          1/*#VTs*/, MVT::v2i64, 2/*#Ops*/, 0, 1, 
                      // Src: (and:v2i64 (xor:v2i64 VR128:v2i64:$src1, (bitconvert:v2i64 (build_vector:v16i8)<<P:Predicate_immAllOnesV>>)), VR128:v2i64:$src2)
                      // Dst: (PANDNrr:v2i64 VR128:v16i8:$src1, VR128:v16i8:$src2)
                    /*SwitchType*/ 15,  MVT::v2i32,// ->43168
/*43153*/             OPC_MoveParent,
/*43154*/             OPC_MoveParent,
/*43155*/             OPC_MoveParent,
/*43156*/             OPC_RecordChild1, // #1 = $src2
/*43157*/             OPC_CheckType, MVT::v1i64,
/*43159*/             OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PANDNrr), 0,
                          1/*#VTs*/, MVT::v1i64, 2/*#Ops*/, 0, 1, 
                      // Src: (and:v1i64 (xor:v1i64 VR64:v1i64:$src1, (bitconvert:v1i64 (build_vector:v2i32)<<P:Predicate_immAllOnesV>>)), VR64:v1i64:$src2)
                      // Dst: (MMX_PANDNrr:v1i64 VR64:v8i8:$src1, VR64:v8i8:$src2)
                    0, // EndSwitchType
                  /*SwitchOpcode*/ 38,  ISD::BIT_CONVERT,// ->43209
/*43171*/           OPC_CheckPredicate, 68, // Predicate_immAllOnesV_bc
/*43173*/           OPC_SwitchType /*2 cases */, 15,  MVT::v4i16,// ->43191
/*43176*/             OPC_MoveParent,
/*43177*/             OPC_MoveParent,
/*43178*/             OPC_MoveParent,
/*43179*/             OPC_RecordChild1, // #1 = $src2
/*43180*/             OPC_CheckType, MVT::v1i64,
/*43182*/             OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PANDNrr), 0,
                          1/*#VTs*/, MVT::v1i64, 2/*#Ops*/, 0, 1, 
                      // Src: (and:v1i64 (xor:v1i64 VR64:v1i64:$src1, (bitconvert:v1i64 (bitconvert:v4i16)<<P:Predicate_immAllOnesV_bc>>)), VR64:v1i64:$src2)
                      // Dst: (MMX_PANDNrr:v1i64 VR64:v8i8:$src1, VR64:v8i8:$src2)
                    /*SwitchType*/ 15,  MVT::v8i8,// ->43208
/*43193*/             OPC_MoveParent,
/*43194*/             OPC_MoveParent,
/*43195*/             OPC_MoveParent,
/*43196*/             OPC_RecordChild1, // #1 = $src2
/*43197*/             OPC_CheckType, MVT::v1i64,
/*43199*/             OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PANDNrr), 0,
                          1/*#VTs*/, MVT::v1i64, 2/*#Ops*/, 0, 1, 
                      // Src: (and:v1i64 (xor:v1i64 VR64:v1i64:$src1, (bitconvert:v1i64 (bitconvert:v8i8)<<P:Predicate_immAllOnesV_bc>>)), VR64:v1i64:$src2)
                      // Dst: (MMX_PANDNrr:v1i64 VR64:v8i8:$src1, VR64:v8i8:$src2)
                    0, // EndSwitchType
                  0, // EndSwitchOpcode
/*43210*/       /*Scope*/ 30, /*->43241*/
/*43211*/         OPC_MoveChild, 0,
/*43213*/         OPC_CheckOpcode, ISD::BIT_CONVERT,
/*43215*/         OPC_MoveChild, 0,
/*43217*/         OPC_CheckOpcode, ISD::BUILD_VECTOR,
/*43219*/         OPC_CheckPredicate, 67, // Predicate_immAllOnesV
/*43221*/         OPC_CheckType, MVT::v4i32,
/*43223*/         OPC_MoveParent,
/*43224*/         OPC_MoveParent,
/*43225*/         OPC_RecordChild1, // #0 = $src1
/*43226*/         OPC_MoveParent,
/*43227*/         OPC_RecordChild1, // #1 = $src2
/*43228*/         OPC_CheckType, MVT::v2i64,
/*43230*/         OPC_CheckPatternPredicate, 0, // (Subtarget->hasSSE1())
/*43232*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::ANDNPSrr), 0,
                      1/*#VTs*/, MVT::v2i64, 2/*#Ops*/, 0, 1, 
                  // Src: (and:v2i64 (xor:v2i64 (bitconvert:v2i64 (build_vector:v4i32)<<P:Predicate_immAllOnesV>>), VR128:v2i64:$src1), VR128:v2i64:$src2)
                  // Dst: (ANDNPSrr:v2i64 VR128:v2i64:$src1, VR128:v2i64:$src2)
/*43241*/       0, /*End of Scope*/
              /*SwitchOpcode*/ 66,  ISD::BIT_CONVERT,// ->43310
/*43244*/       OPC_RecordChild0, // #0 = $src2
/*43245*/       OPC_CheckChild0Type, MVT::v2f64,
/*43247*/       OPC_MoveParent,
/*43248*/       OPC_MoveChild, 1,
/*43250*/       OPC_CheckOpcode, ISD::XOR,
/*43252*/       OPC_MoveChild, 0,
/*43254*/       OPC_SwitchOpcode /*2 cases */, 25,  ISD::BIT_CONVERT,// ->43282
/*43257*/         OPC_RecordChild0, // #1 = $src1
/*43258*/         OPC_CheckChild0Type, MVT::v2f64,
/*43260*/         OPC_MoveParent,
/*43261*/         OPC_MoveChild, 1,
/*43263*/         OPC_CheckOpcode, ISD::BUILD_VECTOR,
/*43265*/         OPC_CheckPredicate, 67, // Predicate_immAllOnesV
/*43267*/         OPC_MoveParent,
/*43268*/         OPC_MoveParent,
/*43269*/         OPC_CheckType, MVT::v2i64,
/*43271*/         OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*43273*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::ANDNPDrr), 0,
                      1/*#VTs*/, MVT::v2i64, 2/*#Ops*/, 1, 0, 
                  // Src: (and:v2i64 (bitconvert:v2i64 VR128:v2f64:$src2), (xor:v2i64 (bitconvert:v2i64 VR128:v2f64:$src1), (build_vector:v2i64)<<P:Predicate_immAllOnesV>>))
                  // Dst: (ANDNPDrr:v2i64 VR128:v2f64:$src1, VR128:v2f64:$src2)
                /*SwitchOpcode*/ 25,  ISD::BUILD_VECTOR,// ->43309
/*43284*/         OPC_CheckPredicate, 67, // Predicate_immAllOnesV
/*43286*/         OPC_MoveParent,
/*43287*/         OPC_MoveChild, 1,
/*43289*/         OPC_CheckOpcode, ISD::BIT_CONVERT,
/*43291*/         OPC_RecordChild0, // #1 = $src1
/*43292*/         OPC_CheckChild0Type, MVT::v2f64,
/*43294*/         OPC_MoveParent,
/*43295*/         OPC_MoveParent,
/*43296*/         OPC_CheckType, MVT::v2i64,
/*43298*/         OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*43300*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::ANDNPDrr), 0,
                      1/*#VTs*/, MVT::v2i64, 2/*#Ops*/, 1, 0, 
                  // Src: (and:v2i64 (bitconvert:v2i64 VR128:v2f64:$src2), (xor:v2i64 (build_vector:v2i64)<<P:Predicate_immAllOnesV>>, (bitconvert:v2i64 VR128:v2f64:$src1)))
                  // Dst: (ANDNPDrr:v2i64 VR128:v2f64:$src1, VR128:v2f64:$src2)
                0, // EndSwitchOpcode
              0, // EndSwitchOpcode
/*43311*/   /*Scope*/ 67, /*->43379*/
/*43312*/     OPC_RecordChild0, // #0 = $src2
/*43313*/     OPC_MoveChild, 1,
/*43315*/     OPC_CheckOpcode, ISD::XOR,
/*43317*/     OPC_Scope, 29, /*->43348*/ // 2 children in Scope
/*43319*/       OPC_RecordChild0, // #1 = $src1
/*43320*/       OPC_MoveChild, 1,
/*43322*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*43324*/       OPC_MoveChild, 0,
/*43326*/       OPC_CheckOpcode, ISD::BUILD_VECTOR,
/*43328*/       OPC_CheckPredicate, 67, // Predicate_immAllOnesV
/*43330*/       OPC_CheckType, MVT::v4i32,
/*43332*/       OPC_MoveParent,
/*43333*/       OPC_MoveParent,
/*43334*/       OPC_MoveParent,
/*43335*/       OPC_CheckType, MVT::v2i64,
/*43337*/       OPC_CheckPatternPredicate, 0, // (Subtarget->hasSSE1())
/*43339*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::ANDNPSrr), 0,
                    1/*#VTs*/, MVT::v2i64, 2/*#Ops*/, 1, 0, 
                // Src: (and:v2i64 VR128:v2i64:$src2, (xor:v2i64 VR128:v2i64:$src1, (bitconvert:v2i64 (build_vector:v4i32)<<P:Predicate_immAllOnesV>>)))
                // Dst: (ANDNPSrr:v2i64 VR128:v2i64:$src1, VR128:v2i64:$src2)
/*43348*/     /*Scope*/ 29, /*->43378*/
/*43349*/       OPC_MoveChild, 0,
/*43351*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*43353*/       OPC_MoveChild, 0,
/*43355*/       OPC_CheckOpcode, ISD::BUILD_VECTOR,
/*43357*/       OPC_CheckPredicate, 67, // Predicate_immAllOnesV
/*43359*/       OPC_CheckType, MVT::v4i32,
/*43361*/       OPC_MoveParent,
/*43362*/       OPC_MoveParent,
/*43363*/       OPC_RecordChild1, // #1 = $src1
/*43364*/       OPC_MoveParent,
/*43365*/       OPC_CheckType, MVT::v2i64,
/*43367*/       OPC_CheckPatternPredicate, 0, // (Subtarget->hasSSE1())
/*43369*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::ANDNPSrr), 0,
                    1/*#VTs*/, MVT::v2i64, 2/*#Ops*/, 1, 0, 
                // Src: (and:v2i64 VR128:v2i64:$src2, (xor:v2i64 (bitconvert:v2i64 (build_vector:v4i32)<<P:Predicate_immAllOnesV>>), VR128:v2i64:$src1))
                // Dst: (ANDNPSrr:v2i64 VR128:v2i64:$src1, VR128:v2i64:$src2)
/*43378*/     0, /*End of Scope*/
/*43379*/   /*Scope*/ 34, /*->43414*/
/*43380*/     OPC_MoveChild, 0,
/*43382*/     OPC_CheckOpcode, ISD::XOR,
/*43384*/     OPC_MoveChild, 0,
/*43386*/     OPC_CheckOpcode, ISD::BIT_CONVERT,
/*43388*/     OPC_MoveChild, 0,
/*43390*/     OPC_CheckOpcode, ISD::BUILD_VECTOR,
/*43392*/     OPC_CheckPredicate, 67, // Predicate_immAllOnesV
/*43394*/     OPC_CheckType, MVT::v4i32,
/*43396*/     OPC_MoveParent,
/*43397*/     OPC_MoveParent,
/*43398*/     OPC_RecordChild1, // #0 = $src1
/*43399*/     OPC_MoveParent,
/*43400*/     OPC_RecordChild1, // #1 = $src2
/*43401*/     OPC_CheckType, MVT::v2i64,
/*43403*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*43405*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::PANDNrr), 0,
                  1/*#VTs*/, MVT::v2i64, 2/*#Ops*/, 0, 1, 
              // Src: (and:v2i64 (xor:v2i64 (bitconvert:v2i64 (build_vector:v4i32)<<P:Predicate_immAllOnesV>>), VR128:v2i64:$src1), VR128:v2i64:$src2)
              // Dst: (PANDNrr:v2i64 VR128:v16i8:$src1, VR128:v16i8:$src2)
/*43414*/   /*Scope*/ 67, /*->43482*/
/*43415*/     OPC_RecordChild0, // #0 = $src2
/*43416*/     OPC_MoveChild, 1,
/*43418*/     OPC_CheckOpcode, ISD::XOR,
/*43420*/     OPC_Scope, 29, /*->43451*/ // 2 children in Scope
/*43422*/       OPC_RecordChild0, // #1 = $src1
/*43423*/       OPC_MoveChild, 1,
/*43425*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*43427*/       OPC_MoveChild, 0,
/*43429*/       OPC_CheckOpcode, ISD::BUILD_VECTOR,
/*43431*/       OPC_CheckPredicate, 67, // Predicate_immAllOnesV
/*43433*/       OPC_CheckType, MVT::v4i32,
/*43435*/       OPC_MoveParent,
/*43436*/       OPC_MoveParent,
/*43437*/       OPC_MoveParent,
/*43438*/       OPC_CheckType, MVT::v2i64,
/*43440*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*43442*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PANDNrr), 0,
                    1/*#VTs*/, MVT::v2i64, 2/*#Ops*/, 1, 0, 
                // Src: (and:v2i64 VR128:v2i64:$src2, (xor:v2i64 VR128:v2i64:$src1, (bitconvert:v2i64 (build_vector:v4i32)<<P:Predicate_immAllOnesV>>)))
                // Dst: (PANDNrr:v2i64 VR128:v16i8:$src1, VR128:v16i8:$src2)
/*43451*/     /*Scope*/ 29, /*->43481*/
/*43452*/       OPC_MoveChild, 0,
/*43454*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*43456*/       OPC_MoveChild, 0,
/*43458*/       OPC_CheckOpcode, ISD::BUILD_VECTOR,
/*43460*/       OPC_CheckPredicate, 67, // Predicate_immAllOnesV
/*43462*/       OPC_CheckType, MVT::v4i32,
/*43464*/       OPC_MoveParent,
/*43465*/       OPC_MoveParent,
/*43466*/       OPC_RecordChild1, // #1 = $src1
/*43467*/       OPC_MoveParent,
/*43468*/       OPC_CheckType, MVT::v2i64,
/*43470*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*43472*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PANDNrr), 0,
                    1/*#VTs*/, MVT::v2i64, 2/*#Ops*/, 1, 0, 
                // Src: (and:v2i64 VR128:v2i64:$src2, (xor:v2i64 (bitconvert:v2i64 (build_vector:v4i32)<<P:Predicate_immAllOnesV>>), VR128:v2i64:$src1))
                // Dst: (PANDNrr:v2i64 VR128:v16i8:$src1, VR128:v16i8:$src2)
/*43481*/     0, /*End of Scope*/
/*43482*/   /*Scope*/ 34, /*->43517*/
/*43483*/     OPC_MoveChild, 0,
/*43485*/     OPC_CheckOpcode, ISD::XOR,
/*43487*/     OPC_MoveChild, 0,
/*43489*/     OPC_CheckOpcode, ISD::BIT_CONVERT,
/*43491*/     OPC_MoveChild, 0,
/*43493*/     OPC_CheckOpcode, ISD::BUILD_VECTOR,
/*43495*/     OPC_CheckPredicate, 67, // Predicate_immAllOnesV
/*43497*/     OPC_CheckType, MVT::v8i16,
/*43499*/     OPC_MoveParent,
/*43500*/     OPC_MoveParent,
/*43501*/     OPC_RecordChild1, // #0 = $src1
/*43502*/     OPC_MoveParent,
/*43503*/     OPC_RecordChild1, // #1 = $src2
/*43504*/     OPC_CheckType, MVT::v2i64,
/*43506*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*43508*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::PANDNrr), 0,
                  1/*#VTs*/, MVT::v2i64, 2/*#Ops*/, 0, 1, 
              // Src: (and:v2i64 (xor:v2i64 (bitconvert:v2i64 (build_vector:v8i16)<<P:Predicate_immAllOnesV>>), VR128:v2i64:$src1), VR128:v2i64:$src2)
              // Dst: (PANDNrr:v2i64 VR128:v16i8:$src1, VR128:v16i8:$src2)
/*43517*/   /*Scope*/ 67, /*->43585*/
/*43518*/     OPC_RecordChild0, // #0 = $src2
/*43519*/     OPC_MoveChild, 1,
/*43521*/     OPC_CheckOpcode, ISD::XOR,
/*43523*/     OPC_Scope, 29, /*->43554*/ // 2 children in Scope
/*43525*/       OPC_RecordChild0, // #1 = $src1
/*43526*/       OPC_MoveChild, 1,
/*43528*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*43530*/       OPC_MoveChild, 0,
/*43532*/       OPC_CheckOpcode, ISD::BUILD_VECTOR,
/*43534*/       OPC_CheckPredicate, 67, // Predicate_immAllOnesV
/*43536*/       OPC_CheckType, MVT::v8i16,
/*43538*/       OPC_MoveParent,
/*43539*/       OPC_MoveParent,
/*43540*/       OPC_MoveParent,
/*43541*/       OPC_CheckType, MVT::v2i64,
/*43543*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*43545*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PANDNrr), 0,
                    1/*#VTs*/, MVT::v2i64, 2/*#Ops*/, 1, 0, 
                // Src: (and:v2i64 VR128:v2i64:$src2, (xor:v2i64 VR128:v2i64:$src1, (bitconvert:v2i64 (build_vector:v8i16)<<P:Predicate_immAllOnesV>>)))
                // Dst: (PANDNrr:v2i64 VR128:v16i8:$src1, VR128:v16i8:$src2)
/*43554*/     /*Scope*/ 29, /*->43584*/
/*43555*/       OPC_MoveChild, 0,
/*43557*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*43559*/       OPC_MoveChild, 0,
/*43561*/       OPC_CheckOpcode, ISD::BUILD_VECTOR,
/*43563*/       OPC_CheckPredicate, 67, // Predicate_immAllOnesV
/*43565*/       OPC_CheckType, MVT::v8i16,
/*43567*/       OPC_MoveParent,
/*43568*/       OPC_MoveParent,
/*43569*/       OPC_RecordChild1, // #1 = $src1
/*43570*/       OPC_MoveParent,
/*43571*/       OPC_CheckType, MVT::v2i64,
/*43573*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*43575*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PANDNrr), 0,
                    1/*#VTs*/, MVT::v2i64, 2/*#Ops*/, 1, 0, 
                // Src: (and:v2i64 VR128:v2i64:$src2, (xor:v2i64 (bitconvert:v2i64 (build_vector:v8i16)<<P:Predicate_immAllOnesV>>), VR128:v2i64:$src1))
                // Dst: (PANDNrr:v2i64 VR128:v16i8:$src1, VR128:v16i8:$src2)
/*43584*/     0, /*End of Scope*/
/*43585*/   /*Scope*/ 34, /*->43620*/
/*43586*/     OPC_MoveChild, 0,
/*43588*/     OPC_CheckOpcode, ISD::XOR,
/*43590*/     OPC_MoveChild, 0,
/*43592*/     OPC_CheckOpcode, ISD::BIT_CONVERT,
/*43594*/     OPC_MoveChild, 0,
/*43596*/     OPC_CheckOpcode, ISD::BUILD_VECTOR,
/*43598*/     OPC_CheckPredicate, 67, // Predicate_immAllOnesV
/*43600*/     OPC_CheckType, MVT::v16i8,
/*43602*/     OPC_MoveParent,
/*43603*/     OPC_MoveParent,
/*43604*/     OPC_RecordChild1, // #0 = $src1
/*43605*/     OPC_MoveParent,
/*43606*/     OPC_RecordChild1, // #1 = $src2
/*43607*/     OPC_CheckType, MVT::v2i64,
/*43609*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*43611*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::PANDNrr), 0,
                  1/*#VTs*/, MVT::v2i64, 2/*#Ops*/, 0, 1, 
              // Src: (and:v2i64 (xor:v2i64 (bitconvert:v2i64 (build_vector:v16i8)<<P:Predicate_immAllOnesV>>), VR128:v2i64:$src1), VR128:v2i64:$src2)
              // Dst: (PANDNrr:v2i64 VR128:v16i8:$src1, VR128:v16i8:$src2)
/*43620*/   /*Scope*/ 67, /*->43688*/
/*43621*/     OPC_RecordChild0, // #0 = $src2
/*43622*/     OPC_MoveChild, 1,
/*43624*/     OPC_CheckOpcode, ISD::XOR,
/*43626*/     OPC_Scope, 29, /*->43657*/ // 2 children in Scope
/*43628*/       OPC_RecordChild0, // #1 = $src1
/*43629*/       OPC_MoveChild, 1,
/*43631*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*43633*/       OPC_MoveChild, 0,
/*43635*/       OPC_CheckOpcode, ISD::BUILD_VECTOR,
/*43637*/       OPC_CheckPredicate, 67, // Predicate_immAllOnesV
/*43639*/       OPC_CheckType, MVT::v16i8,
/*43641*/       OPC_MoveParent,
/*43642*/       OPC_MoveParent,
/*43643*/       OPC_MoveParent,
/*43644*/       OPC_CheckType, MVT::v2i64,
/*43646*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*43648*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PANDNrr), 0,
                    1/*#VTs*/, MVT::v2i64, 2/*#Ops*/, 1, 0, 
                // Src: (and:v2i64 VR128:v2i64:$src2, (xor:v2i64 VR128:v2i64:$src1, (bitconvert:v2i64 (build_vector:v16i8)<<P:Predicate_immAllOnesV>>)))
                // Dst: (PANDNrr:v2i64 VR128:v16i8:$src1, VR128:v16i8:$src2)
/*43657*/     /*Scope*/ 29, /*->43687*/
/*43658*/       OPC_MoveChild, 0,
/*43660*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*43662*/       OPC_MoveChild, 0,
/*43664*/       OPC_CheckOpcode, ISD::BUILD_VECTOR,
/*43666*/       OPC_CheckPredicate, 67, // Predicate_immAllOnesV
/*43668*/       OPC_CheckType, MVT::v16i8,
/*43670*/       OPC_MoveParent,
/*43671*/       OPC_MoveParent,
/*43672*/       OPC_RecordChild1, // #1 = $src1
/*43673*/       OPC_MoveParent,
/*43674*/       OPC_CheckType, MVT::v2i64,
/*43676*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*43678*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PANDNrr), 0,
                    1/*#VTs*/, MVT::v2i64, 2/*#Ops*/, 1, 0, 
                // Src: (and:v2i64 VR128:v2i64:$src2, (xor:v2i64 (bitconvert:v2i64 (build_vector:v16i8)<<P:Predicate_immAllOnesV>>), VR128:v2i64:$src1))
                // Dst: (PANDNrr:v2i64 VR128:v16i8:$src1, VR128:v16i8:$src2)
/*43687*/     0, /*End of Scope*/
/*43688*/   /*Scope*/ 32, /*->43721*/
/*43689*/     OPC_MoveChild, 0,
/*43691*/     OPC_CheckOpcode, ISD::XOR,
/*43693*/     OPC_MoveChild, 0,
/*43695*/     OPC_CheckOpcode, ISD::BIT_CONVERT,
/*43697*/     OPC_MoveChild, 0,
/*43699*/     OPC_CheckOpcode, ISD::BUILD_VECTOR,
/*43701*/     OPC_CheckPredicate, 67, // Predicate_immAllOnesV
/*43703*/     OPC_CheckType, MVT::v2i32,
/*43705*/     OPC_MoveParent,
/*43706*/     OPC_MoveParent,
/*43707*/     OPC_RecordChild1, // #0 = $src1
/*43708*/     OPC_MoveParent,
/*43709*/     OPC_RecordChild1, // #1 = $src2
/*43710*/     OPC_CheckType, MVT::v1i64,
/*43712*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PANDNrr), 0,
                  1/*#VTs*/, MVT::v1i64, 2/*#Ops*/, 0, 1, 
              // Src: (and:v1i64 (xor:v1i64 (bitconvert:v1i64 (build_vector:v2i32)<<P:Predicate_immAllOnesV>>), VR64:v1i64:$src1), VR64:v1i64:$src2)
              // Dst: (MMX_PANDNrr:v1i64 VR64:v8i8:$src1, VR64:v8i8:$src2)
/*43721*/   /*Scope*/ 63, /*->43785*/
/*43722*/     OPC_RecordChild0, // #0 = $src2
/*43723*/     OPC_MoveChild, 1,
/*43725*/     OPC_CheckOpcode, ISD::XOR,
/*43727*/     OPC_Scope, 27, /*->43756*/ // 2 children in Scope
/*43729*/       OPC_RecordChild0, // #1 = $src1
/*43730*/       OPC_MoveChild, 1,
/*43732*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*43734*/       OPC_MoveChild, 0,
/*43736*/       OPC_CheckOpcode, ISD::BUILD_VECTOR,
/*43738*/       OPC_CheckPredicate, 67, // Predicate_immAllOnesV
/*43740*/       OPC_CheckType, MVT::v2i32,
/*43742*/       OPC_MoveParent,
/*43743*/       OPC_MoveParent,
/*43744*/       OPC_MoveParent,
/*43745*/       OPC_CheckType, MVT::v1i64,
/*43747*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PANDNrr), 0,
                    1/*#VTs*/, MVT::v1i64, 2/*#Ops*/, 1, 0, 
                // Src: (and:v1i64 VR64:v1i64:$src2, (xor:v1i64 VR64:v1i64:$src1, (bitconvert:v1i64 (build_vector:v2i32)<<P:Predicate_immAllOnesV>>)))
                // Dst: (MMX_PANDNrr:v1i64 VR64:v8i8:$src1, VR64:v8i8:$src2)
/*43756*/     /*Scope*/ 27, /*->43784*/
/*43757*/       OPC_MoveChild, 0,
/*43759*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*43761*/       OPC_MoveChild, 0,
/*43763*/       OPC_CheckOpcode, ISD::BUILD_VECTOR,
/*43765*/       OPC_CheckPredicate, 67, // Predicate_immAllOnesV
/*43767*/       OPC_CheckType, MVT::v2i32,
/*43769*/       OPC_MoveParent,
/*43770*/       OPC_MoveParent,
/*43771*/       OPC_RecordChild1, // #1 = $src1
/*43772*/       OPC_MoveParent,
/*43773*/       OPC_CheckType, MVT::v1i64,
/*43775*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PANDNrr), 0,
                    1/*#VTs*/, MVT::v1i64, 2/*#Ops*/, 1, 0, 
                // Src: (and:v1i64 VR64:v1i64:$src2, (xor:v1i64 (bitconvert:v1i64 (build_vector:v2i32)<<P:Predicate_immAllOnesV>>), VR64:v1i64:$src1))
                // Dst: (MMX_PANDNrr:v1i64 VR64:v8i8:$src1, VR64:v8i8:$src2)
/*43784*/     0, /*End of Scope*/
/*43785*/   /*Scope*/ 32, /*->43818*/
/*43786*/     OPC_MoveChild, 0,
/*43788*/     OPC_CheckOpcode, ISD::XOR,
/*43790*/     OPC_MoveChild, 0,
/*43792*/     OPC_CheckOpcode, ISD::BIT_CONVERT,
/*43794*/     OPC_MoveChild, 0,
/*43796*/     OPC_CheckOpcode, ISD::BIT_CONVERT,
/*43798*/     OPC_CheckPredicate, 68, // Predicate_immAllOnesV_bc
/*43800*/     OPC_CheckType, MVT::v4i16,
/*43802*/     OPC_MoveParent,
/*43803*/     OPC_MoveParent,
/*43804*/     OPC_RecordChild1, // #0 = $src1
/*43805*/     OPC_MoveParent,
/*43806*/     OPC_RecordChild1, // #1 = $src2
/*43807*/     OPC_CheckType, MVT::v1i64,
/*43809*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PANDNrr), 0,
                  1/*#VTs*/, MVT::v1i64, 2/*#Ops*/, 0, 1, 
              // Src: (and:v1i64 (xor:v1i64 (bitconvert:v1i64 (bitconvert:v4i16)<<P:Predicate_immAllOnesV_bc>>), VR64:v1i64:$src1), VR64:v1i64:$src2)
              // Dst: (MMX_PANDNrr:v1i64 VR64:v8i8:$src1, VR64:v8i8:$src2)
/*43818*/   /*Scope*/ 63, /*->43882*/
/*43819*/     OPC_RecordChild0, // #0 = $src2
/*43820*/     OPC_MoveChild, 1,
/*43822*/     OPC_CheckOpcode, ISD::XOR,
/*43824*/     OPC_Scope, 27, /*->43853*/ // 2 children in Scope
/*43826*/       OPC_RecordChild0, // #1 = $src1
/*43827*/       OPC_MoveChild, 1,
/*43829*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*43831*/       OPC_MoveChild, 0,
/*43833*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*43835*/       OPC_CheckPredicate, 68, // Predicate_immAllOnesV_bc
/*43837*/       OPC_CheckType, MVT::v4i16,
/*43839*/       OPC_MoveParent,
/*43840*/       OPC_MoveParent,
/*43841*/       OPC_MoveParent,
/*43842*/       OPC_CheckType, MVT::v1i64,
/*43844*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PANDNrr), 0,
                    1/*#VTs*/, MVT::v1i64, 2/*#Ops*/, 1, 0, 
                // Src: (and:v1i64 VR64:v1i64:$src2, (xor:v1i64 VR64:v1i64:$src1, (bitconvert:v1i64 (bitconvert:v4i16)<<P:Predicate_immAllOnesV_bc>>)))
                // Dst: (MMX_PANDNrr:v1i64 VR64:v8i8:$src1, VR64:v8i8:$src2)
/*43853*/     /*Scope*/ 27, /*->43881*/
/*43854*/       OPC_MoveChild, 0,
/*43856*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*43858*/       OPC_MoveChild, 0,
/*43860*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*43862*/       OPC_CheckPredicate, 68, // Predicate_immAllOnesV_bc
/*43864*/       OPC_CheckType, MVT::v4i16,
/*43866*/       OPC_MoveParent,
/*43867*/       OPC_MoveParent,
/*43868*/       OPC_RecordChild1, // #1 = $src1
/*43869*/       OPC_MoveParent,
/*43870*/       OPC_CheckType, MVT::v1i64,
/*43872*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PANDNrr), 0,
                    1/*#VTs*/, MVT::v1i64, 2/*#Ops*/, 1, 0, 
                // Src: (and:v1i64 VR64:v1i64:$src2, (xor:v1i64 (bitconvert:v1i64 (bitconvert:v4i16)<<P:Predicate_immAllOnesV_bc>>), VR64:v1i64:$src1))
                // Dst: (MMX_PANDNrr:v1i64 VR64:v8i8:$src1, VR64:v8i8:$src2)
/*43881*/     0, /*End of Scope*/
/*43882*/   /*Scope*/ 32, /*->43915*/
/*43883*/     OPC_MoveChild, 0,
/*43885*/     OPC_CheckOpcode, ISD::XOR,
/*43887*/     OPC_MoveChild, 0,
/*43889*/     OPC_CheckOpcode, ISD::BIT_CONVERT,
/*43891*/     OPC_MoveChild, 0,
/*43893*/     OPC_CheckOpcode, ISD::BIT_CONVERT,
/*43895*/     OPC_CheckPredicate, 68, // Predicate_immAllOnesV_bc
/*43897*/     OPC_CheckType, MVT::v8i8,
/*43899*/     OPC_MoveParent,
/*43900*/     OPC_MoveParent,
/*43901*/     OPC_RecordChild1, // #0 = $src1
/*43902*/     OPC_MoveParent,
/*43903*/     OPC_RecordChild1, // #1 = $src2
/*43904*/     OPC_CheckType, MVT::v1i64,
/*43906*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PANDNrr), 0,
                  1/*#VTs*/, MVT::v1i64, 2/*#Ops*/, 0, 1, 
              // Src: (and:v1i64 (xor:v1i64 (bitconvert:v1i64 (bitconvert:v8i8)<<P:Predicate_immAllOnesV_bc>>), VR64:v1i64:$src1), VR64:v1i64:$src2)
              // Dst: (MMX_PANDNrr:v1i64 VR64:v8i8:$src1, VR64:v8i8:$src2)
/*43915*/   /*Scope*/ 63, /*->43979*/
/*43916*/     OPC_RecordChild0, // #0 = $src2
/*43917*/     OPC_MoveChild, 1,
/*43919*/     OPC_CheckOpcode, ISD::XOR,
/*43921*/     OPC_Scope, 27, /*->43950*/ // 2 children in Scope
/*43923*/       OPC_RecordChild0, // #1 = $src1
/*43924*/       OPC_MoveChild, 1,
/*43926*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*43928*/       OPC_MoveChild, 0,
/*43930*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*43932*/       OPC_CheckPredicate, 68, // Predicate_immAllOnesV_bc
/*43934*/       OPC_CheckType, MVT::v8i8,
/*43936*/       OPC_MoveParent,
/*43937*/       OPC_MoveParent,
/*43938*/       OPC_MoveParent,
/*43939*/       OPC_CheckType, MVT::v1i64,
/*43941*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PANDNrr), 0,
                    1/*#VTs*/, MVT::v1i64, 2/*#Ops*/, 1, 0, 
                // Src: (and:v1i64 VR64:v1i64:$src2, (xor:v1i64 VR64:v1i64:$src1, (bitconvert:v1i64 (bitconvert:v8i8)<<P:Predicate_immAllOnesV_bc>>)))
                // Dst: (MMX_PANDNrr:v1i64 VR64:v8i8:$src1, VR64:v8i8:$src2)
/*43950*/     /*Scope*/ 27, /*->43978*/
/*43951*/       OPC_MoveChild, 0,
/*43953*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*43955*/       OPC_MoveChild, 0,
/*43957*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*43959*/       OPC_CheckPredicate, 68, // Predicate_immAllOnesV_bc
/*43961*/       OPC_CheckType, MVT::v8i8,
/*43963*/       OPC_MoveParent,
/*43964*/       OPC_MoveParent,
/*43965*/       OPC_RecordChild1, // #1 = $src1
/*43966*/       OPC_MoveParent,
/*43967*/       OPC_CheckType, MVT::v1i64,
/*43969*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PANDNrr), 0,
                    1/*#VTs*/, MVT::v1i64, 2/*#Ops*/, 1, 0, 
                // Src: (and:v1i64 VR64:v1i64:$src2, (xor:v1i64 (bitconvert:v1i64 (bitconvert:v8i8)<<P:Predicate_immAllOnesV_bc>>), VR64:v1i64:$src1))
                // Dst: (MMX_PANDNrr:v1i64 VR64:v8i8:$src1, VR64:v8i8:$src2)
/*43978*/     0, /*End of Scope*/
/*43979*/   /*Scope*/ 69, /*->44049*/
/*43980*/     OPC_MoveChild, 0,
/*43982*/     OPC_CheckOpcode, ISD::XOR,
/*43984*/     OPC_Scope, 38, /*->44024*/ // 2 children in Scope
/*43986*/       OPC_RecordChild0, // #0 = $src1
/*43987*/       OPC_MoveChild, 1,
/*43989*/       OPC_CheckOpcode, ISD::BUILD_VECTOR,
/*43991*/       OPC_CheckPredicate, 67, // Predicate_immAllOnesV
/*43993*/       OPC_MoveParent,
/*43994*/       OPC_MoveParent,
/*43995*/       OPC_RecordChild1, // #1 = $src2
/*43996*/       OPC_SwitchType /*2 cases */, 11,  MVT::v2i64,// ->44010
/*43999*/         OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*44001*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::PANDNrr), 0,
                      1/*#VTs*/, MVT::v2i64, 2/*#Ops*/, 0, 1, 
                  // Src: (and:v2i64 (xor:v2i64 VR128:v2i64:$src1, (build_vector:v2i64)<<P:Predicate_immAllOnesV>>), VR128:v2i64:$src2)
                  // Dst: (PANDNrr:v2i64 VR128:v2i64:$src1, VR128:v2i64:$src2)
                /*SwitchType*/ 11,  MVT::v1i64,// ->44023
/*44012*/         OPC_CheckPatternPredicate, 8, // (Subtarget->hasMMX())
/*44014*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PANDNrr), 0,
                      1/*#VTs*/, MVT::v1i64, 2/*#Ops*/, 0, 1, 
                  // Src: (and:v1i64 (xor:v1i64 VR64:v1i64:$src1, (build_vector:v1i64)<<P:Predicate_immAllOnesV>>), VR64:v1i64:$src2)
                  // Dst: (MMX_PANDNrr:v1i64 VR64:v1i64:$src1, VR64:v1i64:$src2)
                0, // EndSwitchType
/*44024*/     /*Scope*/ 23, /*->44048*/
/*44025*/       OPC_MoveChild, 0,
/*44027*/       OPC_CheckOpcode, ISD::BUILD_VECTOR,
/*44029*/       OPC_CheckPredicate, 67, // Predicate_immAllOnesV
/*44031*/       OPC_MoveParent,
/*44032*/       OPC_RecordChild1, // #0 = $src1
/*44033*/       OPC_MoveParent,
/*44034*/       OPC_RecordChild1, // #1 = $src2
/*44035*/       OPC_CheckType, MVT::v2i64,
/*44037*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*44039*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PANDNrr), 0,
                    1/*#VTs*/, MVT::v2i64, 2/*#Ops*/, 0, 1, 
                // Src: (and:v2i64 (xor:v2i64 (build_vector:v2i64)<<P:Predicate_immAllOnesV>>, VR128:v2i64:$src1), VR128:v2i64:$src2)
                // Dst: (PANDNrr:v2i64 VR128:v2i64:$src1, VR128:v2i64:$src2)
/*44048*/     0, /*End of Scope*/
/*44049*/   /*Scope*/ 53, /*->44103*/
/*44050*/     OPC_RecordChild0, // #0 = $src2
/*44051*/     OPC_MoveChild, 1,
/*44053*/     OPC_CheckOpcode, ISD::XOR,
/*44055*/     OPC_Scope, 22, /*->44079*/ // 2 children in Scope
/*44057*/       OPC_RecordChild0, // #1 = $src1
/*44058*/       OPC_MoveChild, 1,
/*44060*/       OPC_CheckOpcode, ISD::BUILD_VECTOR,
/*44062*/       OPC_CheckPredicate, 67, // Predicate_immAllOnesV
/*44064*/       OPC_MoveParent,
/*44065*/       OPC_MoveParent,
/*44066*/       OPC_CheckType, MVT::v2i64,
/*44068*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*44070*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PANDNrr), 0,
                    1/*#VTs*/, MVT::v2i64, 2/*#Ops*/, 1, 0, 
                // Src: (and:v2i64 VR128:v2i64:$src2, (xor:v2i64 VR128:v2i64:$src1, (build_vector:v2i64)<<P:Predicate_immAllOnesV>>))
                // Dst: (PANDNrr:v2i64 VR128:v2i64:$src1, VR128:v2i64:$src2)
/*44079*/     /*Scope*/ 22, /*->44102*/
/*44080*/       OPC_MoveChild, 0,
/*44082*/       OPC_CheckOpcode, ISD::BUILD_VECTOR,
/*44084*/       OPC_CheckPredicate, 67, // Predicate_immAllOnesV
/*44086*/       OPC_MoveParent,
/*44087*/       OPC_RecordChild1, // #1 = $src1
/*44088*/       OPC_MoveParent,
/*44089*/       OPC_CheckType, MVT::v2i64,
/*44091*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*44093*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PANDNrr), 0,
                    1/*#VTs*/, MVT::v2i64, 2/*#Ops*/, 1, 0, 
                // Src: (and:v2i64 VR128:v2i64:$src2, (xor:v2i64 (build_vector:v2i64)<<P:Predicate_immAllOnesV>>, VR128:v2i64:$src1))
                // Dst: (PANDNrr:v2i64 VR128:v2i64:$src1, VR128:v2i64:$src2)
/*44102*/     0, /*End of Scope*/
/*44103*/   /*Scope*/ 27, /*->44131*/
/*44104*/     OPC_MoveChild, 0,
/*44106*/     OPC_CheckOpcode, ISD::XOR,
/*44108*/     OPC_MoveChild, 0,
/*44110*/     OPC_CheckOpcode, ISD::BUILD_VECTOR,
/*44112*/     OPC_CheckPredicate, 67, // Predicate_immAllOnesV
/*44114*/     OPC_MoveParent,
/*44115*/     OPC_RecordChild1, // #0 = $src1
/*44116*/     OPC_MoveParent,
/*44117*/     OPC_RecordChild1, // #1 = $src2
/*44118*/     OPC_CheckType, MVT::v1i64,
/*44120*/     OPC_CheckPatternPredicate, 8, // (Subtarget->hasMMX())
/*44122*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PANDNrr), 0,
                  1/*#VTs*/, MVT::v1i64, 2/*#Ops*/, 0, 1, 
              // Src: (and:v1i64 (xor:v1i64 (build_vector:v1i64)<<P:Predicate_immAllOnesV>>, VR64:v1i64:$src1), VR64:v1i64:$src2)
              // Dst: (MMX_PANDNrr:v1i64 VR64:v1i64:$src1, VR64:v1i64:$src2)
/*44131*/   /*Scope*/ 53, /*->44185*/
/*44132*/     OPC_RecordChild0, // #0 = $src2
/*44133*/     OPC_MoveChild, 1,
/*44135*/     OPC_CheckOpcode, ISD::XOR,
/*44137*/     OPC_Scope, 22, /*->44161*/ // 2 children in Scope
/*44139*/       OPC_RecordChild0, // #1 = $src1
/*44140*/       OPC_MoveChild, 1,
/*44142*/       OPC_CheckOpcode, ISD::BUILD_VECTOR,
/*44144*/       OPC_CheckPredicate, 67, // Predicate_immAllOnesV
/*44146*/       OPC_MoveParent,
/*44147*/       OPC_MoveParent,
/*44148*/       OPC_CheckType, MVT::v1i64,
/*44150*/       OPC_CheckPatternPredicate, 8, // (Subtarget->hasMMX())
/*44152*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PANDNrr), 0,
                    1/*#VTs*/, MVT::v1i64, 2/*#Ops*/, 1, 0, 
                // Src: (and:v1i64 VR64:v1i64:$src2, (xor:v1i64 VR64:v1i64:$src1, (build_vector:v1i64)<<P:Predicate_immAllOnesV>>))
                // Dst: (MMX_PANDNrr:v1i64 VR64:v1i64:$src1, VR64:v1i64:$src2)
/*44161*/     /*Scope*/ 22, /*->44184*/
/*44162*/       OPC_MoveChild, 0,
/*44164*/       OPC_CheckOpcode, ISD::BUILD_VECTOR,
/*44166*/       OPC_CheckPredicate, 67, // Predicate_immAllOnesV
/*44168*/       OPC_MoveParent,
/*44169*/       OPC_RecordChild1, // #1 = $src1
/*44170*/       OPC_MoveParent,
/*44171*/       OPC_CheckType, MVT::v1i64,
/*44173*/       OPC_CheckPatternPredicate, 8, // (Subtarget->hasMMX())
/*44175*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PANDNrr), 0,
                    1/*#VTs*/, MVT::v1i64, 2/*#Ops*/, 1, 0, 
                // Src: (and:v1i64 VR64:v1i64:$src2, (xor:v1i64 (build_vector:v1i64)<<P:Predicate_immAllOnesV>>, VR64:v1i64:$src1))
                // Dst: (MMX_PANDNrr:v1i64 VR64:v1i64:$src1, VR64:v1i64:$src2)
/*44184*/     0, /*End of Scope*/
/*44185*/   /*Scope*/ 29, /*->44215*/
/*44186*/     OPC_MoveChild, 0,
/*44188*/     OPC_CheckOpcode, ISD::BIT_CONVERT,
/*44190*/     OPC_RecordChild0, // #0 = $src1
/*44191*/     OPC_CheckChild0Type, MVT::v2f64,
/*44193*/     OPC_MoveParent,
/*44194*/     OPC_MoveChild, 1,
/*44196*/     OPC_CheckOpcode, ISD::BIT_CONVERT,
/*44198*/     OPC_RecordChild0, // #1 = $src2
/*44199*/     OPC_CheckChild0Type, MVT::v2f64,
/*44201*/     OPC_MoveParent,
/*44202*/     OPC_CheckType, MVT::v2i64,
/*44204*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*44206*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::ANDPDrr), 0,
                  1/*#VTs*/, MVT::v2i64, 2/*#Ops*/, 0, 1, 
              // Src: (and:v2i64 (bitconvert:v2i64 VR128:v2f64:$src1), (bitconvert:v2i64 VR128:v2f64:$src2))
              // Dst: (ANDPDrr:v2i64 VR128:v2f64:$src1, VR128:v2f64:$src2)
/*44215*/   /*Scope*/ 27, /*->44243*/
/*44216*/     OPC_CheckAndImm, 127|128,127|128,3/*65535*/, 
/*44220*/     OPC_RecordChild0, // #0 = $src1
/*44221*/     OPC_CheckType, MVT::i32,
/*44223*/     OPC_EmitInteger, MVT::i32, 3, 
/*44226*/     OPC_EmitNode, TARGET_OPCODE(TargetOpcode::EXTRACT_SUBREG), 0,
                  1/*#VTs*/, MVT::i16, 2/*#Ops*/, 0, 1,  // Results = #2 
/*44235*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVZX32rr16), 0,
                  1/*#VTs*/, MVT::i32, 1/*#Ops*/, 2, 
              // Src: (and:i32 GR32:i32:$src1, 65535:i32)
              // Dst: (MOVZX32rr16:i32 (EXTRACT_SUBREG:i16 GR32:i32:$src1, 3:i32))
/*44243*/   /*Scope*/ 29, /*->44273*/
/*44244*/     OPC_CheckAndImm, 127|128,127|128,127|128,127|128,15/*4294967295*/, 
/*44250*/     OPC_RecordChild0, // #0 = $src
/*44251*/     OPC_CheckType, MVT::i64,
/*44253*/     OPC_EmitInteger, MVT::i32, 4, 
/*44256*/     OPC_EmitNode, TARGET_OPCODE(TargetOpcode::EXTRACT_SUBREG), 0,
                  1/*#VTs*/, MVT::i32, 2/*#Ops*/, 0, 1,  // Results = #2 
/*44265*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVZX64rr32), 0,
                  1/*#VTs*/, MVT::i64, 1/*#Ops*/, 2, 
              // Src: (and:i64 GR64:i64:$src, 4294967295:i64)
              // Dst: (MOVZX64rr32:i64 (EXTRACT_SUBREG:i32 GR64:i64:$src, 4:i32))
/*44273*/   /*Scope*/ 27, /*->44301*/
/*44274*/     OPC_CheckAndImm, 127|128,127|128,3/*65535*/, 
/*44278*/     OPC_RecordChild0, // #0 = $src
/*44279*/     OPC_CheckType, MVT::i64,
/*44281*/     OPC_EmitInteger, MVT::i32, 3, 
/*44284*/     OPC_EmitNode, TARGET_OPCODE(TargetOpcode::EXTRACT_SUBREG), 0,
                  1/*#VTs*/, MVT::i16, 2/*#Ops*/, 0, 1,  // Results = #2 
/*44293*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVZX64rr16), 0,
                  1/*#VTs*/, MVT::i64, 1/*#Ops*/, 2, 
              // Src: (and:i64 GR64:i64:$src, 65535:i64)
              // Dst: (MOVZX64rr16:i64 (EXTRACT_SUBREG:i16 GR64:i64:$src, 3:i32))
/*44301*/   /*Scope*/ 24|128,1/*152*/, /*->44455*/
/*44303*/     OPC_CheckAndImm, 127|128,1/*255*/, 
/*44306*/     OPC_RecordChild0, // #0 = $src
/*44307*/     OPC_SwitchType /*3 cases */, 20,  MVT::i64,// ->44330
/*44310*/       OPC_EmitInteger, MVT::i32, 1, 
/*44313*/       OPC_EmitNode, TARGET_OPCODE(TargetOpcode::EXTRACT_SUBREG), 0,
                    1/*#VTs*/, MVT::i8, 2/*#Ops*/, 0, 1,  // Results = #2 
/*44322*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVZX64rr8), 0,
                    1/*#VTs*/, MVT::i64, 1/*#Ops*/, 2, 
                // Src: (and:i64 GR64:i64:$src, 255:i64)
                // Dst: (MOVZX64rr8:i64 (EXTRACT_SUBREG:i8 GR64:i64:$src, 1:i32))
              /*SwitchType*/ 60,  MVT::i32,// ->44392
/*44332*/       OPC_Scope, 22, /*->44356*/ // 2 children in Scope
/*44334*/         OPC_CheckPatternPredicate, 3, // (Subtarget->is64Bit())
/*44336*/         OPC_EmitInteger, MVT::i32, 1, 
/*44339*/         OPC_EmitNode, TARGET_OPCODE(TargetOpcode::EXTRACT_SUBREG), 0,
                      1/*#VTs*/, MVT::i8, 2/*#Ops*/, 0, 1,  // Results = #2 
/*44348*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVZX32rr8), 0,
                      1/*#VTs*/, MVT::i32, 1/*#Ops*/, 2, 
                  // Src: (and:i32 GR32:i32:$src1, 255:i32)
                  // Dst: (MOVZX32rr8:i32 (EXTRACT_SUBREG:i8 GR32:i32:$src1, 1:i32))
/*44356*/       /*Scope*/ 34, /*->44391*/
/*44357*/         OPC_CheckPatternPredicate, 2, // (!Subtarget->is64Bit())
/*44359*/         OPC_EmitInteger, MVT::i32, X86::GR32_ABCDRegClassID,
/*44362*/         OPC_EmitNode, TARGET_OPCODE(TargetOpcode::COPY_TO_REGCLASS), 0,
                      1/*#VTs*/, MVT::i32, 2/*#Ops*/, 0, 1,  // Results = #2 
/*44371*/         OPC_EmitInteger, MVT::i32, 1, 
/*44374*/         OPC_EmitNode, TARGET_OPCODE(TargetOpcode::EXTRACT_SUBREG), 0,
                      1/*#VTs*/, MVT::i8, 2/*#Ops*/, 2, 3,  // Results = #4 
/*44383*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVZX32rr8), 0,
                      1/*#VTs*/, MVT::i32, 1/*#Ops*/, 4, 
                  // Src: (and:i32 GR32:i32:$src1, 255:i32)
                  // Dst: (MOVZX32rr8:i32 (EXTRACT_SUBREG:i8 (COPY_TO_REGCLASS:i32 GR32:i32:$src1, GR32_ABCD:i32), 1:i32))
/*44391*/       0, /*End of Scope*/
              /*SwitchType*/ 60,  MVT::i16,// ->44454
/*44394*/       OPC_Scope, 22, /*->44418*/ // 2 children in Scope
/*44396*/         OPC_CheckPatternPredicate, 3, // (Subtarget->is64Bit())
/*44398*/         OPC_EmitInteger, MVT::i32, 1, 
/*44401*/         OPC_EmitNode, TARGET_OPCODE(TargetOpcode::EXTRACT_SUBREG), 0,
                      1/*#VTs*/, MVT::i8, 2/*#Ops*/, 0, 1,  // Results = #2 
/*44410*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVZX16rr8), 0,
                      1/*#VTs*/, MVT::i16, 1/*#Ops*/, 2, 
                  // Src: (and:i16 GR16:i16:$src1, 255:i16)
                  // Dst: (MOVZX16rr8:i16 (EXTRACT_SUBREG:i8 GR16:i16:$src1, 1:i32))
/*44418*/       /*Scope*/ 34, /*->44453*/
/*44419*/         OPC_CheckPatternPredicate, 2, // (!Subtarget->is64Bit())
/*44421*/         OPC_EmitInteger, MVT::i32, X86::GR16_ABCDRegClassID,
/*44424*/         OPC_EmitNode, TARGET_OPCODE(TargetOpcode::COPY_TO_REGCLASS), 0,
                      1/*#VTs*/, MVT::i16, 2/*#Ops*/, 0, 1,  // Results = #2 
/*44433*/         OPC_EmitInteger, MVT::i32, 1, 
/*44436*/         OPC_EmitNode, TARGET_OPCODE(TargetOpcode::EXTRACT_SUBREG), 0,
                      1/*#VTs*/, MVT::i8, 2/*#Ops*/, 2, 3,  // Results = #4 
/*44445*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVZX16rr8), 0,
                      1/*#VTs*/, MVT::i16, 1/*#Ops*/, 4, 
                  // Src: (and:i16 GR16:i16:$src1, 255:i16)
                  // Dst: (MOVZX16rr8:i16 (EXTRACT_SUBREG:i8 (COPY_TO_REGCLASS:i16 GR16:i16:$src1, GR16_ABCD:i16), 1:i32))
/*44453*/       0, /*End of Scope*/
              0, // EndSwitchType
/*44455*/   /*Scope*/ 11|128,2/*267*/, /*->44724*/
/*44457*/     OPC_RecordChild0, // #0 = $src1
/*44458*/     OPC_RecordChild1, // #1 = $src2
/*44459*/     OPC_Scope, 38|128,1/*166*/, /*->44628*/ // 7 children in Scope
/*44462*/       OPC_MoveChild, 1,
/*44464*/       OPC_CheckOpcode, ISD::Constant,
/*44466*/       OPC_Scope, 47, /*->44515*/ // 4 children in Scope
/*44468*/         OPC_CheckPredicate, 11, // Predicate_immSext8
/*44470*/         OPC_MoveParent,
/*44471*/         OPC_SwitchType /*3 cases */, 12,  MVT::i16,// ->44486
/*44474*/           OPC_EmitConvertToTarget, 1,
/*44476*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::AND16ri8), 0,
                        2/*#VTs*/, MVT::i16, MVT::i32, 2/*#Ops*/, 0, 2, 
                    // Src: (and:i16 GR16:i16:$src1, (imm:i16)<<P:Predicate_immSext8>>:$src2)
                    // Dst: (AND16ri8:i16 GR16:i16:$src1, (imm:i16):$src2)
                  /*SwitchType*/ 12,  MVT::i32,// ->44500
/*44488*/           OPC_EmitConvertToTarget, 1,
/*44490*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::AND32ri8), 0,
                        2/*#VTs*/, MVT::i32, MVT::i32, 2/*#Ops*/, 0, 2, 
                    // Src: (and:i32 GR32:i32:$src1, (imm:i32)<<P:Predicate_immSext8>>:$src2)
                    // Dst: (AND32ri8:i32 GR32:i32:$src1, (imm:i32):$src2)
                  /*SwitchType*/ 12,  MVT::i64,// ->44514
/*44502*/           OPC_EmitConvertToTarget, 1,
/*44504*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::AND64ri8), 0,
                        2/*#VTs*/, MVT::i64, MVT::i32, 2/*#Ops*/, 0, 2, 
                    // Src: (and:i64 GR64:i64:$src1, (imm:i64)<<P:Predicate_immSext8>>:$src2)
                    // Dst: (AND64ri8:i64 GR64:i64:$src1, (imm:i64):$src2)
                  0, // EndSwitchType
/*44515*/       /*Scope*/ 17, /*->44533*/
/*44516*/         OPC_CheckPredicate, 12, // Predicate_i64immSExt32
/*44518*/         OPC_MoveParent,
/*44519*/         OPC_CheckType, MVT::i64,
/*44521*/         OPC_EmitConvertToTarget, 1,
/*44523*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::AND64ri32), 0,
                      2/*#VTs*/, MVT::i64, MVT::i32, 2/*#Ops*/, 0, 2, 
                  // Src: (and:i64 GR64:i64:$src1, (imm:i64)<<P:Predicate_i64immSExt32>>:$src2)
                  // Dst: (AND64ri32:i64 GR64:i64:$src1, (imm:i64):$src2)
/*44533*/       /*Scope*/ 47, /*->44581*/
/*44534*/         OPC_CheckPredicate, 69, // Predicate_i64immZExt32
/*44536*/         OPC_MoveParent,
/*44537*/         OPC_CheckType, MVT::i64,
/*44539*/         OPC_EmitInteger, MVT::i64, 0, 
/*44542*/         OPC_EmitInteger, MVT::i32, 4, 
/*44545*/         OPC_EmitNode, TARGET_OPCODE(TargetOpcode::EXTRACT_SUBREG), 0,
                      1/*#VTs*/, MVT::i32, 2/*#Ops*/, 0, 3,  // Results = #4 
/*44554*/         OPC_EmitConvertToTarget, 1,
/*44556*/         OPC_EmitNodeXForm, 6, 5, // GetLo32XForm
/*44559*/         OPC_EmitNode, TARGET_OPCODE(X86::AND32ri), 0,
                      1/*#VTs*/, MVT::i32, 2/*#Ops*/, 4, 6,  // Results = #7 
/*44568*/         OPC_EmitInteger, MVT::i32, 4, 
/*44571*/         OPC_MorphNodeTo, TARGET_OPCODE(TargetOpcode::SUBREG_TO_REG), 0,
                      1/*#VTs*/, MVT::i64, 3/*#Ops*/, 2, 7, 8, 
                  // Src: (and:i64 GR64:i64:$src, (imm:i64)<<P:Predicate_i64immZExt32>>:$imm)
                  // Dst: (SUBREG_TO_REG:i64 0:i64, (AND32ri:i32 (EXTRACT_SUBREG:i32 GR64:i64:$src, 4:i32), (GetLo32XForm:i32 (imm:i32):$imm)), 4:i32)
/*44581*/       /*Scope*/ 45, /*->44627*/
/*44582*/         OPC_MoveParent,
/*44583*/         OPC_SwitchType /*3 cases */, 12,  MVT::i8,// ->44598
/*44586*/           OPC_EmitConvertToTarget, 1,
/*44588*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::AND8ri), 0,
                        2/*#VTs*/, MVT::i8, MVT::i32, 2/*#Ops*/, 0, 2, 
                    // Src: (and:i8 GR8:i8:$src1, (imm:i8):$src2)
                    // Dst: (AND8ri:i8 GR8:i8:$src1, (imm:i8):$src2)
                  /*SwitchType*/ 12,  MVT::i16,// ->44612
/*44600*/           OPC_EmitConvertToTarget, 1,
/*44602*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::AND16ri), 0,
                        2/*#VTs*/, MVT::i16, MVT::i32, 2/*#Ops*/, 0, 2, 
                    // Src: (and:i16 GR16:i16:$src1, (imm:i16):$src2)
                    // Dst: (AND16ri:i16 GR16:i16:$src1, (imm:i16):$src2)
                  /*SwitchType*/ 12,  MVT::i32,// ->44626
/*44614*/           OPC_EmitConvertToTarget, 1,
/*44616*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::AND32ri), 0,
                        2/*#VTs*/, MVT::i32, MVT::i32, 2/*#Ops*/, 0, 2, 
                    // Src: (and:i32 GR32:i32:$src1, (imm:i32):$src2)
                    // Dst: (AND32ri:i32 GR32:i32:$src1, (imm:i32):$src2)
                  0, // EndSwitchType
/*44627*/       0, /*End of Scope*/
/*44628*/     /*Scope*/ 12, /*->44641*/
/*44629*/       OPC_CheckType, MVT::i8,
/*44631*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::AND8rr), 0,
                    2/*#VTs*/, MVT::i8, MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (and:i8 GR8:i8:$src1, GR8:i8:$src2)
                // Dst: (AND8rr:i8 GR8:i8:$src1, GR8:i8:$src2)
/*44641*/     /*Scope*/ 12, /*->44654*/
/*44642*/       OPC_CheckType, MVT::i16,
/*44644*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::AND16rr), 0,
                    2/*#VTs*/, MVT::i16, MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (and:i16 GR16:i16:$src1, GR16:i16:$src2)
                // Dst: (AND16rr:i16 GR16:i16:$src1, GR16:i16:$src2)
/*44654*/     /*Scope*/ 12, /*->44667*/
/*44655*/       OPC_CheckType, MVT::i32,
/*44657*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::AND32rr), 0,
                    2/*#VTs*/, MVT::i32, MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (and:i32 GR32:i32:$src1, GR32:i32:$src2)
                // Dst: (AND32rr:i32 GR32:i32:$src1, GR32:i32:$src2)
/*44667*/     /*Scope*/ 12, /*->44680*/
/*44668*/       OPC_CheckType, MVT::i64,
/*44670*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::AND64rr), 0,
                    2/*#VTs*/, MVT::i64, MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (and:i64 GR64:i64:$src1, GR64:i64:$src2)
                // Dst: (AND64rr:i64 GR64:i64:$src1, GR64:i64:$src2)
/*44680*/     /*Scope*/ 28, /*->44709*/
/*44681*/       OPC_CheckType, MVT::v2i64,
/*44683*/       OPC_Scope, 11, /*->44696*/ // 2 children in Scope
/*44685*/         OPC_CheckPatternPredicate, 0, // (Subtarget->hasSSE1())
/*44687*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::ANDPSrr), 0,
                      1/*#VTs*/, MVT::v2i64, 2/*#Ops*/, 0, 1, 
                  // Src: (and:v2i64 VR128:v2i64:$src1, VR128:v2i64:$src2)
                  // Dst: (ANDPSrr:v2i64 VR128:v2i64:$src1, VR128:v2i64:$src2)
/*44696*/       /*Scope*/ 11, /*->44708*/
/*44697*/         OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*44699*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::PANDrr), 0,
                      1/*#VTs*/, MVT::v2i64, 2/*#Ops*/, 0, 1, 
                  // Src: (and:v2i64 VR128:v2i64:$src1, VR128:v2i64:$src2)
                  // Dst: (PANDrr:v2i64 VR128:v2i64:$src1, VR128:v2i64:$src2)
/*44708*/       0, /*End of Scope*/
/*44709*/     /*Scope*/ 13, /*->44723*/
/*44710*/       OPC_CheckType, MVT::v1i64,
/*44712*/       OPC_CheckPatternPredicate, 8, // (Subtarget->hasMMX())
/*44714*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PANDrr), 0,
                    1/*#VTs*/, MVT::v1i64, 2/*#Ops*/, 0, 1, 
                // Src: (and:v1i64 VR64:v1i64:$src1, VR64:v1i64:$src2)
                // Dst: (MMX_PANDrr:v1i64 VR64:v1i64:$src1, VR64:v1i64:$src2)
/*44723*/     0, /*End of Scope*/
/*44724*/   0, /*End of Scope*/
          /*SwitchOpcode*/ 42|128,12/*1578*/,  X86ISD::CMP,// ->46306
/*44728*/   OPC_Scope, 23|128,6/*791*/, /*->45522*/ // 6 children in Scope
/*44731*/     OPC_MoveChild, 0,
/*44733*/     OPC_SwitchOpcode /*2 cases */, 76|128,3/*460*/,  ISD::AND,// ->45197
/*44737*/       OPC_Scope, 39|128,1/*167*/, /*->44907*/ // 3 children in Scope
/*44740*/         OPC_MoveChild, 0,
/*44742*/         OPC_CheckOpcode, ISD::LOAD,
/*44744*/         OPC_RecordMemRef,
/*44745*/         OPC_RecordNode, // #0 = 'ld' chained node
/*44746*/         OPC_CheckFoldableChainNode,
/*44747*/         OPC_RecordChild1, // #1 = $src1
/*44748*/         OPC_CheckPredicate, 2, // Predicate_unindexedload
/*44750*/         OPC_Scope, 76, /*->44828*/ // 3 children in Scope
/*44752*/           OPC_CheckPredicate, 8, // Predicate_load
/*44754*/           OPC_CheckPredicate, 9, // Predicate_dsload
/*44756*/           OPC_MoveParent,
/*44757*/           OPC_RecordChild1, // #2 = $src2
/*44758*/           OPC_MoveChild, 1,
/*44760*/           OPC_CheckOpcode, ISD::Constant,
/*44762*/           OPC_Scope, 32, /*->44796*/ // 2 children in Scope
/*44764*/             OPC_CheckPredicate, 12, // Predicate_i64immSExt32
/*44766*/             OPC_MoveParent,
/*44767*/             OPC_CheckType, MVT::i64,
/*44769*/             OPC_MoveParent,
/*44770*/             OPC_MoveChild, 1,
/*44772*/             OPC_CheckInteger, 0, 
/*44774*/             OPC_MoveParent,
/*44775*/             OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src1 #3 #4 #5 #6 #7
/*44778*/             OPC_EmitMergeInputChains, 1, 0, 
/*44781*/             OPC_EmitConvertToTarget, 2,
/*44783*/             OPC_MorphNodeTo, TARGET_OPCODE(X86::TEST64mi32), 0|OPFL_Chain|OPFL_MemRefs,
                          1/*#VTs*/, MVT::i32, 6/*#Ops*/, 3, 4, 5, 6, 7, 8, 
                      // Src: (X86cmp:isVoid (and:i64 (ld:i64 addr:iPTR:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>, (imm:i64)<<P:Predicate_i64immSExt32>>:$src2), 0:i64)
                      // Dst: (TEST64mi32:isVoid addr:iPTR:$src1, (imm:i64):$src2)
/*44796*/           /*Scope*/ 30, /*->44827*/
/*44797*/             OPC_MoveParent,
/*44798*/             OPC_CheckType, MVT::i8,
/*44800*/             OPC_MoveParent,
/*44801*/             OPC_MoveChild, 1,
/*44803*/             OPC_CheckInteger, 0, 
/*44805*/             OPC_MoveParent,
/*44806*/             OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src1 #3 #4 #5 #6 #7
/*44809*/             OPC_EmitMergeInputChains, 1, 0, 
/*44812*/             OPC_EmitConvertToTarget, 2,
/*44814*/             OPC_MorphNodeTo, TARGET_OPCODE(X86::TEST8mi), 0|OPFL_Chain|OPFL_MemRefs,
                          1/*#VTs*/, MVT::i32, 6/*#Ops*/, 3, 4, 5, 6, 7, 8, 
                      // Src: (X86cmp:isVoid (and:i8 (ld:i8 addr:iPTR:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>, (imm:i8):$src2), 0:i8)
                      // Dst: (TEST8mi:isVoid addr:iPTR:$src1, (imm:i8):$src2)
/*44827*/           0, /*End of Scope*/
/*44828*/         /*Scope*/ 38, /*->44867*/
/*44829*/           OPC_CheckPredicate, 6, // Predicate_loadi16
/*44831*/           OPC_MoveParent,
/*44832*/           OPC_RecordChild1, // #2 = $src2
/*44833*/           OPC_MoveChild, 1,
/*44835*/           OPC_CheckOpcode, ISD::Constant,
/*44837*/           OPC_MoveParent,
/*44838*/           OPC_CheckType, MVT::i16,
/*44840*/           OPC_MoveParent,
/*44841*/           OPC_MoveChild, 1,
/*44843*/           OPC_CheckInteger, 0, 
/*44845*/           OPC_MoveParent,
/*44846*/           OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src1 #3 #4 #5 #6 #7
/*44849*/           OPC_EmitMergeInputChains, 1, 0, 
/*44852*/           OPC_EmitConvertToTarget, 2,
/*44854*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::TEST16mi), 0|OPFL_Chain|OPFL_MemRefs,
                        1/*#VTs*/, MVT::i32, 6/*#Ops*/, 3, 4, 5, 6, 7, 8, 
                    // Src: (X86cmp:isVoid (and:i16 (ld:i16 addr:iPTR:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, (imm:i16):$src2), 0:i16)
                    // Dst: (TEST16mi:isVoid addr:iPTR:$src1, (imm:i16):$src2)
/*44867*/         /*Scope*/ 38, /*->44906*/
/*44868*/           OPC_CheckPredicate, 3, // Predicate_loadi32
/*44870*/           OPC_MoveParent,
/*44871*/           OPC_RecordChild1, // #2 = $src2
/*44872*/           OPC_MoveChild, 1,
/*44874*/           OPC_CheckOpcode, ISD::Constant,
/*44876*/           OPC_MoveParent,
/*44877*/           OPC_CheckType, MVT::i32,
/*44879*/           OPC_MoveParent,
/*44880*/           OPC_MoveChild, 1,
/*44882*/           OPC_CheckInteger, 0, 
/*44884*/           OPC_MoveParent,
/*44885*/           OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src1 #3 #4 #5 #6 #7
/*44888*/           OPC_EmitMergeInputChains, 1, 0, 
/*44891*/           OPC_EmitConvertToTarget, 2,
/*44893*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::TEST32mi), 0|OPFL_Chain|OPFL_MemRefs,
                        1/*#VTs*/, MVT::i32, 6/*#Ops*/, 3, 4, 5, 6, 7, 8, 
                    // Src: (X86cmp:isVoid (and:i32 (ld:i32 addr:iPTR:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, (imm:i32):$src2), 0:i32)
                    // Dst: (TEST32mi:isVoid addr:iPTR:$src1, (imm:i32):$src2)
/*44906*/         0, /*End of Scope*/
/*44907*/       /*Scope*/ 13|128,1/*141*/, /*->45050*/
/*44909*/         OPC_RecordChild0, // #0 = $src1
/*44910*/         OPC_MoveChild, 1,
/*44912*/         OPC_CheckOpcode, ISD::LOAD,
/*44914*/         OPC_RecordMemRef,
/*44915*/         OPC_RecordNode, // #1 = 'ld' chained node
/*44916*/         OPC_CheckFoldableChainNode,
/*44917*/         OPC_RecordChild1, // #2 = $src2
/*44918*/         OPC_CheckPredicate, 2, // Predicate_unindexedload
/*44920*/         OPC_Scope, 32, /*->44954*/ // 4 children in Scope
/*44922*/           OPC_CheckPredicate, 8, // Predicate_load
/*44924*/           OPC_CheckPredicate, 9, // Predicate_dsload
/*44926*/           OPC_MoveParent,
/*44927*/           OPC_CheckType, MVT::i8,
/*44929*/           OPC_MoveParent,
/*44930*/           OPC_MoveChild, 1,
/*44932*/           OPC_CheckInteger, 0, 
/*44934*/           OPC_MoveParent,
/*44935*/           OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*44938*/           OPC_EmitMergeInputChains, 1, 1, 
/*44941*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::TEST8rm), 0|OPFL_Chain|OPFL_MemRefs,
                        1/*#VTs*/, MVT::i32, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                    // Src: (X86cmp:isVoid (and:i8 GR8:i8:$src1, (ld:i8 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>), 0:i8)
                    // Dst: (TEST8rm:isVoid GR8:i8:$src1, addr:iPTR:$src2)
/*44954*/         /*Scope*/ 30, /*->44985*/
/*44955*/           OPC_CheckPredicate, 6, // Predicate_loadi16
/*44957*/           OPC_MoveParent,
/*44958*/           OPC_CheckType, MVT::i16,
/*44960*/           OPC_MoveParent,
/*44961*/           OPC_MoveChild, 1,
/*44963*/           OPC_CheckInteger, 0, 
/*44965*/           OPC_MoveParent,
/*44966*/           OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*44969*/           OPC_EmitMergeInputChains, 1, 1, 
/*44972*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::TEST16rm), 0|OPFL_Chain|OPFL_MemRefs,
                        1/*#VTs*/, MVT::i32, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                    // Src: (X86cmp:isVoid (and:i16 GR16:i16:$src1, (ld:i16 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>), 0:i16)
                    // Dst: (TEST16rm:isVoid GR16:i16:$src1, addr:iPTR:$src2)
/*44985*/         /*Scope*/ 30, /*->45016*/
/*44986*/           OPC_CheckPredicate, 3, // Predicate_loadi32
/*44988*/           OPC_MoveParent,
/*44989*/           OPC_CheckType, MVT::i32,
/*44991*/           OPC_MoveParent,
/*44992*/           OPC_MoveChild, 1,
/*44994*/           OPC_CheckInteger, 0, 
/*44996*/           OPC_MoveParent,
/*44997*/           OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*45000*/           OPC_EmitMergeInputChains, 1, 1, 
/*45003*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::TEST32rm), 0|OPFL_Chain|OPFL_MemRefs,
                        1/*#VTs*/, MVT::i32, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                    // Src: (X86cmp:isVoid (and:i32 GR32:i32:$src1, (ld:i32 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>), 0:i32)
                    // Dst: (TEST32rm:isVoid GR32:i32:$src1, addr:iPTR:$src2)
/*45016*/         /*Scope*/ 32, /*->45049*/
/*45017*/           OPC_CheckPredicate, 8, // Predicate_load
/*45019*/           OPC_CheckPredicate, 9, // Predicate_dsload
/*45021*/           OPC_MoveParent,
/*45022*/           OPC_CheckType, MVT::i64,
/*45024*/           OPC_MoveParent,
/*45025*/           OPC_MoveChild, 1,
/*45027*/           OPC_CheckInteger, 0, 
/*45029*/           OPC_MoveParent,
/*45030*/           OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*45033*/           OPC_EmitMergeInputChains, 1, 1, 
/*45036*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::TEST64rm), 0|OPFL_Chain|OPFL_MemRefs,
                        1/*#VTs*/, MVT::i32, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                    // Src: (X86cmp:isVoid (and:i64 GR64:i64:$src1, (ld:i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>), 0:i64)
                    // Dst: (TEST64rm:isVoid GR64:i64:$src1, addr:iPTR:$src2)
/*45049*/         0, /*End of Scope*/
/*45050*/       /*Scope*/ 16|128,1/*144*/, /*->45196*/
/*45052*/         OPC_MoveChild, 0,
/*45054*/         OPC_CheckOpcode, ISD::LOAD,
/*45056*/         OPC_RecordMemRef,
/*45057*/         OPC_RecordNode, // #0 = 'ld' chained node
/*45058*/         OPC_CheckFoldableChainNode,
/*45059*/         OPC_RecordChild1, // #1 = $src2
/*45060*/         OPC_CheckPredicate, 2, // Predicate_unindexedload
/*45062*/         OPC_Scope, 33, /*->45097*/ // 4 children in Scope
/*45064*/           OPC_CheckPredicate, 8, // Predicate_load
/*45066*/           OPC_CheckPredicate, 9, // Predicate_dsload
/*45068*/           OPC_MoveParent,
/*45069*/           OPC_RecordChild1, // #2 = $src1
/*45070*/           OPC_CheckType, MVT::i8,
/*45072*/           OPC_MoveParent,
/*45073*/           OPC_MoveChild, 1,
/*45075*/           OPC_CheckInteger, 0, 
/*45077*/           OPC_MoveParent,
/*45078*/           OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*45081*/           OPC_EmitMergeInputChains, 1, 0, 
/*45084*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::TEST8rm), 0|OPFL_Chain|OPFL_MemRefs,
                        1/*#VTs*/, MVT::i32, 6/*#Ops*/, 2, 3, 4, 5, 6, 7, 
                    // Src: (X86cmp:isVoid (and:i8 (ld:i8 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>, GR8:i8:$src1), 0:i8)
                    // Dst: (TEST8rm:isVoid GR8:i8:$src1, addr:iPTR:$src2)
/*45097*/         /*Scope*/ 31, /*->45129*/
/*45098*/           OPC_CheckPredicate, 6, // Predicate_loadi16
/*45100*/           OPC_MoveParent,
/*45101*/           OPC_RecordChild1, // #2 = $src1
/*45102*/           OPC_CheckType, MVT::i16,
/*45104*/           OPC_MoveParent,
/*45105*/           OPC_MoveChild, 1,
/*45107*/           OPC_CheckInteger, 0, 
/*45109*/           OPC_MoveParent,
/*45110*/           OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*45113*/           OPC_EmitMergeInputChains, 1, 0, 
/*45116*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::TEST16rm), 0|OPFL_Chain|OPFL_MemRefs,
                        1/*#VTs*/, MVT::i32, 6/*#Ops*/, 2, 3, 4, 5, 6, 7, 
                    // Src: (X86cmp:isVoid (and:i16 (ld:i16 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, GR16:i16:$src1), 0:i16)
                    // Dst: (TEST16rm:isVoid GR16:i16:$src1, addr:iPTR:$src2)
/*45129*/         /*Scope*/ 31, /*->45161*/
/*45130*/           OPC_CheckPredicate, 3, // Predicate_loadi32
/*45132*/           OPC_MoveParent,
/*45133*/           OPC_RecordChild1, // #2 = $src1
/*45134*/           OPC_CheckType, MVT::i32,
/*45136*/           OPC_MoveParent,
/*45137*/           OPC_MoveChild, 1,
/*45139*/           OPC_CheckInteger, 0, 
/*45141*/           OPC_MoveParent,
/*45142*/           OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*45145*/           OPC_EmitMergeInputChains, 1, 0, 
/*45148*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::TEST32rm), 0|OPFL_Chain|OPFL_MemRefs,
                        1/*#VTs*/, MVT::i32, 6/*#Ops*/, 2, 3, 4, 5, 6, 7, 
                    // Src: (X86cmp:isVoid (and:i32 (ld:i32 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, GR32:i32:$src1), 0:i32)
                    // Dst: (TEST32rm:isVoid GR32:i32:$src1, addr:iPTR:$src2)
/*45161*/         /*Scope*/ 33, /*->45195*/
/*45162*/           OPC_CheckPredicate, 8, // Predicate_load
/*45164*/           OPC_CheckPredicate, 9, // Predicate_dsload
/*45166*/           OPC_MoveParent,
/*45167*/           OPC_RecordChild1, // #2 = $src1
/*45168*/           OPC_CheckType, MVT::i64,
/*45170*/           OPC_MoveParent,
/*45171*/           OPC_MoveChild, 1,
/*45173*/           OPC_CheckInteger, 0, 
/*45175*/           OPC_MoveParent,
/*45176*/           OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*45179*/           OPC_EmitMergeInputChains, 1, 0, 
/*45182*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::TEST64rm), 0|OPFL_Chain|OPFL_MemRefs,
                        1/*#VTs*/, MVT::i32, 6/*#Ops*/, 2, 3, 4, 5, 6, 7, 
                    // Src: (X86cmp:isVoid (and:i64 (ld:i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>, GR64:i64:$src1), 0:i64)
                    // Dst: (TEST64rm:isVoid GR64:i64:$src1, addr:iPTR:$src2)
/*45195*/         0, /*End of Scope*/
/*45196*/       0, /*End of Scope*/
              /*SwitchOpcode*/ 65|128,2/*321*/,  ISD::LOAD,// ->45521
/*45200*/       OPC_RecordMemRef,
/*45201*/       OPC_RecordNode, // #0 = 'ld' chained node
/*45202*/       OPC_CheckFoldableChainNode,
/*45203*/       OPC_RecordChild1, // #1 = $src1
/*45204*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*45206*/       OPC_Scope, 34, /*->45242*/ // 8 children in Scope
/*45208*/         OPC_CheckPredicate, 6, // Predicate_loadi16
/*45210*/         OPC_CheckType, MVT::i16,
/*45212*/         OPC_MoveParent,
/*45213*/         OPC_RecordChild1, // #2 = $src2
/*45214*/         OPC_MoveChild, 1,
/*45216*/         OPC_CheckOpcode, ISD::Constant,
/*45218*/         OPC_CheckPredicate, 11, // Predicate_immSext8
/*45220*/         OPC_MoveParent,
/*45221*/         OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src1 #3 #4 #5 #6 #7
/*45224*/         OPC_EmitMergeInputChains, 1, 0, 
/*45227*/         OPC_EmitConvertToTarget, 2,
/*45229*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::CMP16mi8), 0|OPFL_Chain|OPFL_MemRefs,
                      1/*#VTs*/, MVT::i32, 6/*#Ops*/, 3, 4, 5, 6, 7, 8, 
                  // Src: (X86cmp:isVoid (ld:i16 addr:iPTR:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, (imm:i16)<<P:Predicate_immSext8>>:$src2)
                  // Dst: (CMP16mi8:isVoid addr:iPTR:$src1, (imm:i16):$src2)
/*45242*/       /*Scope*/ 34, /*->45277*/
/*45243*/         OPC_CheckPredicate, 3, // Predicate_loadi32
/*45245*/         OPC_CheckType, MVT::i32,
/*45247*/         OPC_MoveParent,
/*45248*/         OPC_RecordChild1, // #2 = $src2
/*45249*/         OPC_MoveChild, 1,
/*45251*/         OPC_CheckOpcode, ISD::Constant,
/*45253*/         OPC_CheckPredicate, 11, // Predicate_immSext8
/*45255*/         OPC_MoveParent,
/*45256*/         OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src1 #3 #4 #5 #6 #7
/*45259*/         OPC_EmitMergeInputChains, 1, 0, 
/*45262*/         OPC_EmitConvertToTarget, 2,
/*45264*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::CMP32mi8), 0|OPFL_Chain|OPFL_MemRefs,
                      1/*#VTs*/, MVT::i32, 6/*#Ops*/, 3, 4, 5, 6, 7, 8, 
                  // Src: (X86cmp:isVoid (ld:i32 addr:iPTR:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, (imm:i32)<<P:Predicate_immSext8>>:$src2)
                  // Dst: (CMP32mi8:isVoid addr:iPTR:$src1, (imm:i32):$src2)
/*45277*/       /*Scope*/ 96, /*->45374*/
/*45278*/         OPC_CheckPredicate, 8, // Predicate_load
/*45280*/         OPC_CheckPredicate, 9, // Predicate_dsload
/*45282*/         OPC_SwitchType /*2 cases */, 58,  MVT::i64,// ->45343
/*45285*/           OPC_MoveParent,
/*45286*/           OPC_RecordChild1, // #2 = $src2
/*45287*/           OPC_MoveChild, 1,
/*45289*/           OPC_CheckOpcode, ISD::Constant,
/*45291*/           OPC_Scope, 24, /*->45317*/ // 2 children in Scope
/*45293*/             OPC_CheckPredicate, 11, // Predicate_immSext8
/*45295*/             OPC_MoveParent,
/*45296*/             OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src1 #3 #4 #5 #6 #7
/*45299*/             OPC_EmitMergeInputChains, 1, 0, 
/*45302*/             OPC_EmitConvertToTarget, 2,
/*45304*/             OPC_MorphNodeTo, TARGET_OPCODE(X86::CMP64mi8), 0|OPFL_Chain|OPFL_MemRefs,
                          1/*#VTs*/, MVT::i32, 6/*#Ops*/, 3, 4, 5, 6, 7, 8, 
                      // Src: (X86cmp:isVoid (ld:i64 addr:iPTR:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>, (imm:i64)<<P:Predicate_immSext8>>:$src2)
                      // Dst: (CMP64mi8:isVoid addr:iPTR:$src1, (imm:i64):$src2)
/*45317*/           /*Scope*/ 24, /*->45342*/
/*45318*/             OPC_CheckPredicate, 12, // Predicate_i64immSExt32
/*45320*/             OPC_MoveParent,
/*45321*/             OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src1 #3 #4 #5 #6 #7
/*45324*/             OPC_EmitMergeInputChains, 1, 0, 
/*45327*/             OPC_EmitConvertToTarget, 2,
/*45329*/             OPC_MorphNodeTo, TARGET_OPCODE(X86::CMP64mi32), 0|OPFL_Chain|OPFL_MemRefs,
                          1/*#VTs*/, MVT::i32, 6/*#Ops*/, 3, 4, 5, 6, 7, 8, 
                      // Src: (X86cmp:isVoid (ld:i64 addr:iPTR:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>, (imm:i64)<<P:Predicate_i64immSExt32>>:$src2)
                      // Dst: (CMP64mi32:isVoid addr:iPTR:$src1, (imm:i64):$src2)
/*45342*/           0, /*End of Scope*/
                  /*SwitchType*/ 28,  MVT::i8,// ->45373
/*45345*/           OPC_MoveParent,
/*45346*/           OPC_RecordChild1, // #2 = $src2
/*45347*/           OPC_MoveChild, 1,
/*45349*/           OPC_CheckOpcode, ISD::Constant,
/*45351*/           OPC_MoveParent,
/*45352*/           OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src1 #3 #4 #5 #6 #7
/*45355*/           OPC_EmitMergeInputChains, 1, 0, 
/*45358*/           OPC_EmitConvertToTarget, 2,
/*45360*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::CMP8mi), 0|OPFL_Chain|OPFL_MemRefs,
                        1/*#VTs*/, MVT::i32, 6/*#Ops*/, 3, 4, 5, 6, 7, 8, 
                    // Src: (X86cmp:isVoid (ld:i8 addr:iPTR:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>, (imm:i8):$src2)
                    // Dst: (CMP8mi:isVoid addr:iPTR:$src1, (imm:i8):$src2)
                  0, // EndSwitchType
/*45374*/       /*Scope*/ 32, /*->45407*/
/*45375*/         OPC_CheckPredicate, 6, // Predicate_loadi16
/*45377*/         OPC_CheckType, MVT::i16,
/*45379*/         OPC_MoveParent,
/*45380*/         OPC_RecordChild1, // #2 = $src2
/*45381*/         OPC_MoveChild, 1,
/*45383*/         OPC_CheckOpcode, ISD::Constant,
/*45385*/         OPC_MoveParent,
/*45386*/         OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src1 #3 #4 #5 #6 #7
/*45389*/         OPC_EmitMergeInputChains, 1, 0, 
/*45392*/         OPC_EmitConvertToTarget, 2,
/*45394*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::CMP16mi), 0|OPFL_Chain|OPFL_MemRefs,
                      1/*#VTs*/, MVT::i32, 6/*#Ops*/, 3, 4, 5, 6, 7, 8, 
                  // Src: (X86cmp:isVoid (ld:i16 addr:iPTR:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, (imm:i16):$src2)
                  // Dst: (CMP16mi:isVoid addr:iPTR:$src1, (imm:i16):$src2)
/*45407*/       /*Scope*/ 32, /*->45440*/
/*45408*/         OPC_CheckPredicate, 3, // Predicate_loadi32
/*45410*/         OPC_CheckType, MVT::i32,
/*45412*/         OPC_MoveParent,
/*45413*/         OPC_RecordChild1, // #2 = $src2
/*45414*/         OPC_MoveChild, 1,
/*45416*/         OPC_CheckOpcode, ISD::Constant,
/*45418*/         OPC_MoveParent,
/*45419*/         OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src1 #3 #4 #5 #6 #7
/*45422*/         OPC_EmitMergeInputChains, 1, 0, 
/*45425*/         OPC_EmitConvertToTarget, 2,
/*45427*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::CMP32mi), 0|OPFL_Chain|OPFL_MemRefs,
                      1/*#VTs*/, MVT::i32, 6/*#Ops*/, 3, 4, 5, 6, 7, 8, 
                  // Src: (X86cmp:isVoid (ld:i32 addr:iPTR:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, (imm:i32):$src2)
                  // Dst: (CMP32mi:isVoid addr:iPTR:$src1, (imm:i32):$src2)
/*45440*/       /*Scope*/ 27, /*->45468*/
/*45441*/         OPC_CheckPredicate, 8, // Predicate_load
/*45443*/         OPC_CheckPredicate, 9, // Predicate_dsload
/*45445*/         OPC_CheckType, MVT::i8,
/*45447*/         OPC_MoveParent,
/*45448*/         OPC_RecordChild1, // #2 = $src2
/*45449*/         OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src1 #3 #4 #5 #6 #7
/*45452*/         OPC_EmitMergeInputChains, 1, 0, 
/*45455*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::CMP8mr), 0|OPFL_Chain|OPFL_MemRefs,
                      1/*#VTs*/, MVT::i32, 6/*#Ops*/, 3, 4, 5, 6, 7, 2, 
                  // Src: (X86cmp:isVoid (ld:i8 addr:iPTR:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>, GR8:i8:$src2)
                  // Dst: (CMP8mr:isVoid addr:iPTR:$src1, GR8:i8:$src2)
/*45468*/       /*Scope*/ 25, /*->45494*/
/*45469*/         OPC_CheckPredicate, 6, // Predicate_loadi16
/*45471*/         OPC_CheckType, MVT::i16,
/*45473*/         OPC_MoveParent,
/*45474*/         OPC_RecordChild1, // #2 = $src2
/*45475*/         OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src1 #3 #4 #5 #6 #7
/*45478*/         OPC_EmitMergeInputChains, 1, 0, 
/*45481*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::CMP16mr), 0|OPFL_Chain|OPFL_MemRefs,
                      1/*#VTs*/, MVT::i32, 6/*#Ops*/, 3, 4, 5, 6, 7, 2, 
                  // Src: (X86cmp:isVoid (ld:i16 addr:iPTR:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, GR16:i16:$src2)
                  // Dst: (CMP16mr:isVoid addr:iPTR:$src1, GR16:i16:$src2)
/*45494*/       /*Scope*/ 25, /*->45520*/
/*45495*/         OPC_CheckPredicate, 3, // Predicate_loadi32
/*45497*/         OPC_CheckType, MVT::i32,
/*45499*/         OPC_MoveParent,
/*45500*/         OPC_RecordChild1, // #2 = $src2
/*45501*/         OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src1 #3 #4 #5 #6 #7
/*45504*/         OPC_EmitMergeInputChains, 1, 0, 
/*45507*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::CMP32mr), 0|OPFL_Chain|OPFL_MemRefs,
                      1/*#VTs*/, MVT::i32, 6/*#Ops*/, 3, 4, 5, 6, 7, 2, 
                  // Src: (X86cmp:isVoid (ld:i32 addr:iPTR:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, GR32:i32:$src2)
                  // Dst: (CMP32mr:isVoid addr:iPTR:$src1, GR32:i32:$src2)
/*45520*/       0, /*End of Scope*/
              0, // EndSwitchOpcode
/*45522*/   /*Scope*/ 110, /*->45633*/
/*45523*/     OPC_RecordChild0, // #0 = $src1
/*45524*/     OPC_Scope, 36, /*->45562*/ // 3 children in Scope
/*45526*/       OPC_CheckChild0Type, MVT::i8,
/*45528*/       OPC_MoveChild, 1,
/*45530*/       OPC_CheckOpcode, ISD::LOAD,
/*45532*/       OPC_RecordMemRef,
/*45533*/       OPC_RecordNode, // #1 = 'ld' chained node
/*45534*/       OPC_CheckFoldableChainNode,
/*45535*/       OPC_RecordChild1, // #2 = $src2
/*45536*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*45538*/       OPC_CheckPredicate, 8, // Predicate_load
/*45540*/       OPC_CheckPredicate, 9, // Predicate_dsload
/*45542*/       OPC_MoveParent,
/*45543*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*45546*/       OPC_EmitMergeInputChains, 1, 1, 
/*45549*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::CMP8rm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::i32, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (X86cmp:isVoid GR8:i8:$src1, (ld:i8 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>)
                // Dst: (CMP8rm:isVoid GR8:i8:$src1, addr:iPTR:$src2)
/*45562*/     /*Scope*/ 34, /*->45597*/
/*45563*/       OPC_CheckChild0Type, MVT::i16,
/*45565*/       OPC_MoveChild, 1,
/*45567*/       OPC_CheckOpcode, ISD::LOAD,
/*45569*/       OPC_RecordMemRef,
/*45570*/       OPC_RecordNode, // #1 = 'ld' chained node
/*45571*/       OPC_CheckFoldableChainNode,
/*45572*/       OPC_RecordChild1, // #2 = $src2
/*45573*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*45575*/       OPC_CheckPredicate, 6, // Predicate_loadi16
/*45577*/       OPC_MoveParent,
/*45578*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*45581*/       OPC_EmitMergeInputChains, 1, 1, 
/*45584*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::CMP16rm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::i32, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (X86cmp:isVoid GR16:i16:$src1, (ld:i16 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>)
                // Dst: (CMP16rm:isVoid GR16:i16:$src1, addr:iPTR:$src2)
/*45597*/     /*Scope*/ 34, /*->45632*/
/*45598*/       OPC_CheckChild0Type, MVT::i32,
/*45600*/       OPC_MoveChild, 1,
/*45602*/       OPC_CheckOpcode, ISD::LOAD,
/*45604*/       OPC_RecordMemRef,
/*45605*/       OPC_RecordNode, // #1 = 'ld' chained node
/*45606*/       OPC_CheckFoldableChainNode,
/*45607*/       OPC_RecordChild1, // #2 = $src2
/*45608*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*45610*/       OPC_CheckPredicate, 3, // Predicate_loadi32
/*45612*/       OPC_MoveParent,
/*45613*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*45616*/       OPC_EmitMergeInputChains, 1, 1, 
/*45619*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::CMP32rm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::i32, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (X86cmp:isVoid GR32:i32:$src1, (ld:i32 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)
                // Dst: (CMP32rm:isVoid GR32:i32:$src1, addr:iPTR:$src2)
/*45632*/     0, /*End of Scope*/
/*45633*/   /*Scope*/ 37, /*->45671*/
/*45634*/     OPC_MoveChild, 0,
/*45636*/     OPC_CheckOpcode, ISD::LOAD,
/*45638*/     OPC_RecordMemRef,
/*45639*/     OPC_RecordNode, // #0 = 'ld' chained node
/*45640*/     OPC_CheckFoldableChainNode,
/*45641*/     OPC_RecordChild1, // #1 = $src1
/*45642*/     OPC_CheckPredicate, 2, // Predicate_unindexedload
/*45644*/     OPC_CheckPredicate, 8, // Predicate_load
/*45646*/     OPC_CheckPredicate, 9, // Predicate_dsload
/*45648*/     OPC_CheckType, MVT::i64,
/*45650*/     OPC_MoveParent,
/*45651*/     OPC_RecordChild1, // #2 = $src2
/*45652*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src1 #3 #4 #5 #6 #7
/*45655*/     OPC_EmitMergeInputChains, 1, 0, 
/*45658*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::CMP64mr), 0|OPFL_Chain|OPFL_MemRefs,
                  1/*#VTs*/, MVT::i32, 6/*#Ops*/, 3, 4, 5, 6, 7, 2, 
              // Src: (X86cmp:isVoid (ld:i64 addr:iPTR:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>, GR64:i64:$src2)
              // Dst: (CMP64mr:isVoid addr:iPTR:$src1, GR64:i64:$src2)
/*45671*/   /*Scope*/ 118, /*->45790*/
/*45672*/     OPC_RecordChild0, // #0 = $src1
/*45673*/     OPC_Scope, 36, /*->45711*/ // 3 children in Scope
/*45675*/       OPC_CheckChild0Type, MVT::i64,
/*45677*/       OPC_MoveChild, 1,
/*45679*/       OPC_CheckOpcode, ISD::LOAD,
/*45681*/       OPC_RecordMemRef,
/*45682*/       OPC_RecordNode, // #1 = 'ld' chained node
/*45683*/       OPC_CheckFoldableChainNode,
/*45684*/       OPC_RecordChild1, // #2 = $src2
/*45685*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*45687*/       OPC_CheckPredicate, 8, // Predicate_load
/*45689*/       OPC_CheckPredicate, 9, // Predicate_dsload
/*45691*/       OPC_MoveParent,
/*45692*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*45695*/       OPC_EmitMergeInputChains, 1, 1, 
/*45698*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::CMP64rm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::i32, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (X86cmp:isVoid GR64:i64:$src1, (ld:i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>)
                // Dst: (CMP64rm:isVoid GR64:i64:$src1, addr:iPTR:$src2)
/*45711*/     /*Scope*/ 38, /*->45750*/
/*45712*/       OPC_CheckChild0Type, MVT::f32,
/*45714*/       OPC_MoveChild, 1,
/*45716*/       OPC_CheckOpcode, ISD::LOAD,
/*45718*/       OPC_RecordMemRef,
/*45719*/       OPC_RecordNode, // #1 = 'ld' chained node
/*45720*/       OPC_CheckFoldableChainNode,
/*45721*/       OPC_RecordChild1, // #2 = $src2
/*45722*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*45724*/       OPC_CheckPredicate, 8, // Predicate_load
/*45726*/       OPC_CheckPredicate, 9, // Predicate_dsload
/*45728*/       OPC_MoveParent,
/*45729*/       OPC_CheckPatternPredicate, 0, // (Subtarget->hasSSE1())
/*45731*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*45734*/       OPC_EmitMergeInputChains, 1, 1, 
/*45737*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::UCOMISSrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::i32, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (X86cmp:isVoid FR32:f32:$src1, (ld:f32 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>)
                // Dst: (UCOMISSrm:isVoid FR32:f32:$src1, addr:iPTR:$src2)
/*45750*/     /*Scope*/ 38, /*->45789*/
/*45751*/       OPC_CheckChild0Type, MVT::f64,
/*45753*/       OPC_MoveChild, 1,
/*45755*/       OPC_CheckOpcode, ISD::LOAD,
/*45757*/       OPC_RecordMemRef,
/*45758*/       OPC_RecordNode, // #1 = 'ld' chained node
/*45759*/       OPC_CheckFoldableChainNode,
/*45760*/       OPC_RecordChild1, // #2 = $src2
/*45761*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*45763*/       OPC_CheckPredicate, 8, // Predicate_load
/*45765*/       OPC_CheckPredicate, 9, // Predicate_dsload
/*45767*/       OPC_MoveParent,
/*45768*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*45770*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*45773*/       OPC_EmitMergeInputChains, 1, 1, 
/*45776*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::UCOMISDrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::i32, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (X86cmp:isVoid FR64:f64:$src1, (ld:f64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>)
                // Dst: (UCOMISDrm:isVoid FR64:f64:$src1, addr:iPTR:$src2)
/*45789*/     0, /*End of Scope*/
/*45790*/   /*Scope*/ 47|128,1/*175*/, /*->45967*/
/*45792*/     OPC_MoveChild, 0,
/*45794*/     OPC_CheckOpcode, ISD::AND,
/*45796*/     OPC_RecordChild0, // #0 = $src1
/*45797*/     OPC_RecordChild1, // #1 = $src2
/*45798*/     OPC_Scope, 92, /*->45892*/ // 3 children in Scope
/*45800*/       OPC_MoveChild, 1,
/*45802*/       OPC_CheckOpcode, ISD::Constant,
/*45804*/       OPC_Scope, 62, /*->45868*/ // 2 children in Scope
/*45806*/         OPC_MoveParent,
/*45807*/         OPC_CheckPredicate, 70, // Predicate_and_su
/*45809*/         OPC_SwitchType /*3 cases */, 17,  MVT::i8,// ->45829
/*45812*/           OPC_MoveParent,
/*45813*/           OPC_MoveChild, 1,
/*45815*/           OPC_CheckInteger, 0, 
/*45817*/           OPC_MoveParent,
/*45818*/           OPC_EmitConvertToTarget, 1,
/*45820*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::TEST8ri), 0,
                        1/*#VTs*/, MVT::i32, 2/*#Ops*/, 0, 2, 
                    // Src: (X86cmp:isVoid (and:i8 GR8:i8:$src1, (imm:i8):$src2)<<P:Predicate_and_su>>, 0:i8)
                    // Dst: (TEST8ri:isVoid GR8:i8:$src1, (imm:i8):$src2)
                  /*SwitchType*/ 17,  MVT::i16,// ->45848
/*45831*/           OPC_MoveParent,
/*45832*/           OPC_MoveChild, 1,
/*45834*/           OPC_CheckInteger, 0, 
/*45836*/           OPC_MoveParent,
/*45837*/           OPC_EmitConvertToTarget, 1,
/*45839*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::TEST16ri), 0,
                        1/*#VTs*/, MVT::i32, 2/*#Ops*/, 0, 2, 
                    // Src: (X86cmp:isVoid (and:i16 GR16:i16:$src1, (imm:i16):$src2)<<P:Predicate_and_su>>, 0:i16)
                    // Dst: (TEST16ri:isVoid GR16:i16:$src1, (imm:i16):$src2)
                  /*SwitchType*/ 17,  MVT::i32,// ->45867
/*45850*/           OPC_MoveParent,
/*45851*/           OPC_MoveChild, 1,
/*45853*/           OPC_CheckInteger, 0, 
/*45855*/           OPC_MoveParent,
/*45856*/           OPC_EmitConvertToTarget, 1,
/*45858*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::TEST32ri), 0,
                        1/*#VTs*/, MVT::i32, 2/*#Ops*/, 0, 2, 
                    // Src: (X86cmp:isVoid (and:i32 GR32:i32:$src1, (imm:i32):$src2)<<P:Predicate_and_su>>, 0:i32)
                    // Dst: (TEST32ri:isVoid GR32:i32:$src1, (imm:i32):$src2)
                  0, // EndSwitchType
/*45868*/       /*Scope*/ 22, /*->45891*/
/*45869*/         OPC_CheckPredicate, 12, // Predicate_i64immSExt32
/*45871*/         OPC_MoveParent,
/*45872*/         OPC_CheckType, MVT::i64,
/*45874*/         OPC_MoveParent,
/*45875*/         OPC_MoveChild, 1,
/*45877*/         OPC_CheckInteger, 0, 
/*45879*/         OPC_MoveParent,
/*45880*/         OPC_EmitConvertToTarget, 1,
/*45882*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::TEST64ri32), 0,
                      1/*#VTs*/, MVT::i32, 2/*#Ops*/, 0, 2, 
                  // Src: (X86cmp:isVoid (and:i64 GR64:i64:$src1, (imm:i64)<<P:Predicate_i64immSExt32>>:$src2), 0:i64)
                  // Dst: (TEST64ri32:isVoid GR64:i64:$src1, (imm:i64):$src2)
/*45891*/       0, /*End of Scope*/
/*45892*/     /*Scope*/ 55, /*->45948*/
/*45893*/       OPC_CheckPredicate, 70, // Predicate_and_su
/*45895*/       OPC_SwitchType /*3 cases */, 15,  MVT::i8,// ->45913
/*45898*/         OPC_MoveParent,
/*45899*/         OPC_MoveChild, 1,
/*45901*/         OPC_CheckInteger, 0, 
/*45903*/         OPC_MoveParent,
/*45904*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::TEST8rr), 0,
                      1/*#VTs*/, MVT::i32, 2/*#Ops*/, 0, 1, 
                  // Src: (X86cmp:isVoid (and:i8 GR8:i8:$src1, GR8:i8:$src2)<<P:Predicate_and_su>>, 0:i8)
                  // Dst: (TEST8rr:isVoid GR8:i8:$src1, GR8:i8:$src2)
                /*SwitchType*/ 15,  MVT::i16,// ->45930
/*45915*/         OPC_MoveParent,
/*45916*/         OPC_MoveChild, 1,
/*45918*/         OPC_CheckInteger, 0, 
/*45920*/         OPC_MoveParent,
/*45921*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::TEST16rr), 0,
                      1/*#VTs*/, MVT::i32, 2/*#Ops*/, 0, 1, 
                  // Src: (X86cmp:isVoid (and:i16 GR16:i16:$src1, GR16:i16:$src2)<<P:Predicate_and_su>>, 0:i16)
                  // Dst: (TEST16rr:isVoid GR16:i16:$src1, GR16:i16:$src2)
                /*SwitchType*/ 15,  MVT::i32,// ->45947
/*45932*/         OPC_MoveParent,
/*45933*/         OPC_MoveChild, 1,
/*45935*/         OPC_CheckInteger, 0, 
/*45937*/         OPC_MoveParent,
/*45938*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::TEST32rr), 0,
                      1/*#VTs*/, MVT::i32, 2/*#Ops*/, 0, 1, 
                  // Src: (X86cmp:isVoid (and:i32 GR32:i32:$src1, GR32:i32:$src2)<<P:Predicate_and_su>>, 0:i32)
                  // Dst: (TEST32rr:isVoid GR32:i32:$src1, GR32:i32:$src2)
                0, // EndSwitchType
/*45948*/     /*Scope*/ 17, /*->45966*/
/*45949*/       OPC_CheckType, MVT::i64,
/*45951*/       OPC_MoveParent,
/*45952*/       OPC_MoveChild, 1,
/*45954*/       OPC_CheckInteger, 0, 
/*45956*/       OPC_MoveParent,
/*45957*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::TEST64rr), 0,
                    1/*#VTs*/, MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (X86cmp:isVoid (and:i64 GR64:i64:$src1, GR64:i64:$src2), 0:i64)
                // Dst: (TEST64rr:isVoid GR64:i64:$src1, GR64:i64:$src2)
/*45966*/     0, /*End of Scope*/
/*45967*/   /*Scope*/ 80|128,2/*336*/, /*->46305*/
/*45969*/     OPC_RecordChild0, // #0 = $src1
/*45970*/     OPC_Scope, 50, /*->46022*/ // 7 children in Scope
/*45972*/       OPC_CheckChild0Type, MVT::i8,
/*45974*/       OPC_Scope, 14, /*->45990*/ // 2 children in Scope
/*45976*/         OPC_MoveChild, 1,
/*45978*/         OPC_CheckInteger, 0, 
/*45980*/         OPC_MoveParent,
/*45981*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::TEST8rr), 0,
                      1/*#VTs*/, MVT::i32, 2/*#Ops*/, 0, 0, 
                  // Src: (X86cmp:isVoid GR8:i8:$src1, 0:i8)
                  // Dst: (TEST8rr:isVoid GR8:i8:$src1, GR8:i8:$src1)
/*45990*/       /*Scope*/ 30, /*->46021*/
/*45991*/         OPC_RecordChild1, // #1 = $src2
/*45992*/         OPC_Scope, 16, /*->46010*/ // 2 children in Scope
/*45994*/           OPC_MoveChild, 1,
/*45996*/           OPC_CheckOpcode, ISD::Constant,
/*45998*/           OPC_MoveParent,
/*45999*/           OPC_EmitConvertToTarget, 1,
/*46001*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::CMP8ri), 0,
                        1/*#VTs*/, MVT::i32, 2/*#Ops*/, 0, 2, 
                    // Src: (X86cmp:isVoid GR8:i8:$src1, (imm:i8):$src2)
                    // Dst: (CMP8ri:isVoid GR8:i8:$src1, (imm:i8):$src2)
/*46010*/         /*Scope*/ 9, /*->46020*/
/*46011*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::CMP8rr), 0,
                        1/*#VTs*/, MVT::i32, 2/*#Ops*/, 0, 1, 
                    // Src: (X86cmp:isVoid GR8:i8:$src1, GR8:i8:$src2)
                    // Dst: (CMP8rr:isVoid GR8:i8:$src1, GR8:i8:$src2)
/*46020*/         0, /*End of Scope*/
/*46021*/       0, /*End of Scope*/
/*46022*/     /*Scope*/ 68, /*->46091*/
/*46023*/       OPC_CheckChild0Type, MVT::i16,
/*46025*/       OPC_Scope, 14, /*->46041*/ // 2 children in Scope
/*46027*/         OPC_MoveChild, 1,
/*46029*/         OPC_CheckInteger, 0, 
/*46031*/         OPC_MoveParent,
/*46032*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::TEST16rr), 0,
                      1/*#VTs*/, MVT::i32, 2/*#Ops*/, 0, 0, 
                  // Src: (X86cmp:isVoid GR16:i16:$src1, 0:i16)
                  // Dst: (TEST16rr:isVoid GR16:i16:$src1, GR16:i16:$src1)
/*46041*/       /*Scope*/ 48, /*->46090*/
/*46042*/         OPC_RecordChild1, // #1 = $src2
/*46043*/         OPC_Scope, 34, /*->46079*/ // 2 children in Scope
/*46045*/           OPC_MoveChild, 1,
/*46047*/           OPC_CheckOpcode, ISD::Constant,
/*46049*/           OPC_Scope, 14, /*->46065*/ // 2 children in Scope
/*46051*/             OPC_CheckPredicate, 11, // Predicate_immSext8
/*46053*/             OPC_MoveParent,
/*46054*/             OPC_EmitConvertToTarget, 1,
/*46056*/             OPC_MorphNodeTo, TARGET_OPCODE(X86::CMP16ri8), 0,
                          1/*#VTs*/, MVT::i32, 2/*#Ops*/, 0, 2, 
                      // Src: (X86cmp:isVoid GR16:i16:$src1, (imm:i16)<<P:Predicate_immSext8>>:$src2)
                      // Dst: (CMP16ri8:isVoid GR16:i16:$src1, (imm:i16):$src2)
/*46065*/           /*Scope*/ 12, /*->46078*/
/*46066*/             OPC_MoveParent,
/*46067*/             OPC_EmitConvertToTarget, 1,
/*46069*/             OPC_MorphNodeTo, TARGET_OPCODE(X86::CMP16ri), 0,
                          1/*#VTs*/, MVT::i32, 2/*#Ops*/, 0, 2, 
                      // Src: (X86cmp:isVoid GR16:i16:$src1, (imm:i16):$src2)
                      // Dst: (CMP16ri:isVoid GR16:i16:$src1, (imm:i16):$src2)
/*46078*/           0, /*End of Scope*/
/*46079*/         /*Scope*/ 9, /*->46089*/
/*46080*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::CMP16rr), 0,
                        1/*#VTs*/, MVT::i32, 2/*#Ops*/, 0, 1, 
                    // Src: (X86cmp:isVoid GR16:i16:$src1, GR16:i16:$src2)
                    // Dst: (CMP16rr:isVoid GR16:i16:$src1, GR16:i16:$src2)
/*46089*/         0, /*End of Scope*/
/*46090*/       0, /*End of Scope*/
/*46091*/     /*Scope*/ 68, /*->46160*/
/*46092*/       OPC_CheckChild0Type, MVT::i32,
/*46094*/       OPC_Scope, 14, /*->46110*/ // 2 children in Scope
/*46096*/         OPC_MoveChild, 1,
/*46098*/         OPC_CheckInteger, 0, 
/*46100*/         OPC_MoveParent,
/*46101*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::TEST32rr), 0,
                      1/*#VTs*/, MVT::i32, 2/*#Ops*/, 0, 0, 
                  // Src: (X86cmp:isVoid GR32:i32:$src1, 0:i32)
                  // Dst: (TEST32rr:isVoid GR32:i32:$src1, GR32:i32:$src1)
/*46110*/       /*Scope*/ 48, /*->46159*/
/*46111*/         OPC_RecordChild1, // #1 = $src2
/*46112*/         OPC_Scope, 34, /*->46148*/ // 2 children in Scope
/*46114*/           OPC_MoveChild, 1,
/*46116*/           OPC_CheckOpcode, ISD::Constant,
/*46118*/           OPC_Scope, 14, /*->46134*/ // 2 children in Scope
/*46120*/             OPC_CheckPredicate, 11, // Predicate_immSext8
/*46122*/             OPC_MoveParent,
/*46123*/             OPC_EmitConvertToTarget, 1,
/*46125*/             OPC_MorphNodeTo, TARGET_OPCODE(X86::CMP32ri8), 0,
                          1/*#VTs*/, MVT::i32, 2/*#Ops*/, 0, 2, 
                      // Src: (X86cmp:isVoid GR32:i32:$src1, (imm:i32)<<P:Predicate_immSext8>>:$src2)
                      // Dst: (CMP32ri8:isVoid GR32:i32:$src1, (imm:i32):$src2)
/*46134*/           /*Scope*/ 12, /*->46147*/
/*46135*/             OPC_MoveParent,
/*46136*/             OPC_EmitConvertToTarget, 1,
/*46138*/             OPC_MorphNodeTo, TARGET_OPCODE(X86::CMP32ri), 0,
                          1/*#VTs*/, MVT::i32, 2/*#Ops*/, 0, 2, 
                      // Src: (X86cmp:isVoid GR32:i32:$src1, (imm:i32):$src2)
                      // Dst: (CMP32ri:isVoid GR32:i32:$src1, (imm:i32):$src2)
/*46147*/           0, /*End of Scope*/
/*46148*/         /*Scope*/ 9, /*->46158*/
/*46149*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::CMP32rr), 0,
                        1/*#VTs*/, MVT::i32, 2/*#Ops*/, 0, 1, 
                    // Src: (X86cmp:isVoid GR32:i32:$src1, GR32:i32:$src2)
                    // Dst: (CMP32rr:isVoid GR32:i32:$src1, GR32:i32:$src2)
/*46158*/         0, /*End of Scope*/
/*46159*/       0, /*End of Scope*/
/*46160*/     /*Scope*/ 70, /*->46231*/
/*46161*/       OPC_CheckChild0Type, MVT::i64,
/*46163*/       OPC_Scope, 14, /*->46179*/ // 2 children in Scope
/*46165*/         OPC_MoveChild, 1,
/*46167*/         OPC_CheckInteger, 0, 
/*46169*/         OPC_MoveParent,
/*46170*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::TEST64rr), 0,
                      1/*#VTs*/, MVT::i32, 2/*#Ops*/, 0, 0, 
                  // Src: (X86cmp:isVoid GR64:i64:$src1, 0:i64)
                  // Dst: (TEST64rr:isVoid GR64:i64:$src1, GR64:i64:$src1)
/*46179*/       /*Scope*/ 50, /*->46230*/
/*46180*/         OPC_RecordChild1, // #1 = $src2
/*46181*/         OPC_Scope, 36, /*->46219*/ // 2 children in Scope
/*46183*/           OPC_MoveChild, 1,
/*46185*/           OPC_CheckOpcode, ISD::Constant,
/*46187*/           OPC_Scope, 14, /*->46203*/ // 2 children in Scope
/*46189*/             OPC_CheckPredicate, 11, // Predicate_immSext8
/*46191*/             OPC_MoveParent,
/*46192*/             OPC_EmitConvertToTarget, 1,
/*46194*/             OPC_MorphNodeTo, TARGET_OPCODE(X86::CMP64ri8), 0,
                          1/*#VTs*/, MVT::i32, 2/*#Ops*/, 0, 2, 
                      // Src: (X86cmp:isVoid GR64:i64:$src1, (imm:i64)<<P:Predicate_immSext8>>:$src2)
                      // Dst: (CMP64ri8:isVoid GR64:i64:$src1, (imm:i64):$src2)
/*46203*/           /*Scope*/ 14, /*->46218*/
/*46204*/             OPC_CheckPredicate, 12, // Predicate_i64immSExt32
/*46206*/             OPC_MoveParent,
/*46207*/             OPC_EmitConvertToTarget, 1,
/*46209*/             OPC_MorphNodeTo, TARGET_OPCODE(X86::CMP64ri32), 0,
                          1/*#VTs*/, MVT::i32, 2/*#Ops*/, 0, 2, 
                      // Src: (X86cmp:isVoid GR64:i64:$src1, (imm:i64)<<P:Predicate_i64immSExt32>>:$src2)
                      // Dst: (CMP64ri32:isVoid GR64:i64:$src1, (imm:i64):$src2)
/*46218*/           0, /*End of Scope*/
/*46219*/         /*Scope*/ 9, /*->46229*/
/*46220*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::CMP64rr), 0,
                        1/*#VTs*/, MVT::i32, 2/*#Ops*/, 0, 1, 
                    // Src: (X86cmp:isVoid GR64:i64:$src1, GR64:i64:$src2)
                    // Dst: (CMP64rr:isVoid GR64:i64:$src1, GR64:i64:$src2)
/*46229*/         0, /*End of Scope*/
/*46230*/       0, /*End of Scope*/
/*46231*/     /*Scope*/ 29, /*->46261*/
/*46232*/       OPC_CheckChild0Type, MVT::f32,
/*46234*/       OPC_RecordChild1, // #1 = $rhs
/*46235*/       OPC_Scope, 11, /*->46248*/ // 2 children in Scope
/*46237*/         OPC_CheckPatternPredicate, 6, // (!Subtarget->hasSSE1())
/*46239*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::UCOM_FpIr32), 0,
                      1/*#VTs*/, MVT::i32, 2/*#Ops*/, 0, 1, 
                  // Src: (X86cmp:isVoid RFP32:f32:$lhs, RFP32:f32:$rhs)
                  // Dst: (UCOM_FpIr32:isVoid RFP32:f32:$lhs, RFP32:f32:$rhs)
/*46248*/       /*Scope*/ 11, /*->46260*/
/*46249*/         OPC_CheckPatternPredicate, 0, // (Subtarget->hasSSE1())
/*46251*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::UCOMISSrr), 0,
                      1/*#VTs*/, MVT::i32, 2/*#Ops*/, 0, 1, 
                  // Src: (X86cmp:isVoid FR32:f32:$src1, FR32:f32:$src2)
                  // Dst: (UCOMISSrr:isVoid FR32:f32:$src1, FR32:f32:$src2)
/*46260*/       0, /*End of Scope*/
/*46261*/     /*Scope*/ 29, /*->46291*/
/*46262*/       OPC_CheckChild0Type, MVT::f64,
/*46264*/       OPC_RecordChild1, // #1 = $rhs
/*46265*/       OPC_Scope, 11, /*->46278*/ // 2 children in Scope
/*46267*/         OPC_CheckPatternPredicate, 7, // (!Subtarget->hasSSE2())
/*46269*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::UCOM_FpIr64), 0,
                      1/*#VTs*/, MVT::i32, 2/*#Ops*/, 0, 1, 
                  // Src: (X86cmp:isVoid RFP64:f64:$lhs, RFP64:f64:$rhs)
                  // Dst: (UCOM_FpIr64:isVoid RFP64:f64:$lhs, RFP64:f64:$rhs)
/*46278*/       /*Scope*/ 11, /*->46290*/
/*46279*/         OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*46281*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::UCOMISDrr), 0,
                      1/*#VTs*/, MVT::i32, 2/*#Ops*/, 0, 1, 
                  // Src: (X86cmp:isVoid FR64:f64:$src1, FR64:f64:$src2)
                  // Dst: (UCOMISDrr:isVoid FR64:f64:$src1, FR64:f64:$src2)
/*46290*/       0, /*End of Scope*/
/*46291*/     /*Scope*/ 12, /*->46304*/
/*46292*/       OPC_CheckChild0Type, MVT::f80,
/*46294*/       OPC_RecordChild1, // #1 = $rhs
/*46295*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::UCOM_FpIr80), 0,
                    1/*#VTs*/, MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (X86cmp:isVoid RFP80:f80:$lhs, RFP80:f80:$rhs)
                // Dst: (UCOM_FpIr80:isVoid RFP80:f80:$lhs, RFP80:f80:$rhs)
/*46304*/     0, /*End of Scope*/
/*46305*/   0, /*End of Scope*/
          /*SwitchOpcode*/ 78,  X86ISD::INSERTPS,// ->46386
/*46308*/   OPC_RecordChild0, // #0 = $src1
/*46309*/   OPC_Scope, 52, /*->46363*/ // 2 children in Scope
/*46311*/     OPC_MoveChild, 1,
/*46313*/     OPC_CheckOpcode, ISD::SCALAR_TO_VECTOR,
/*46315*/     OPC_MoveChild, 0,
/*46317*/     OPC_CheckOpcode, ISD::LOAD,
/*46319*/     OPC_RecordMemRef,
/*46320*/     OPC_RecordNode, // #1 = 'ld' chained node
/*46321*/     OPC_CheckFoldableChainNode,
/*46322*/     OPC_RecordChild1, // #2 = $src2
/*46323*/     OPC_CheckPredicate, 2, // Predicate_unindexedload
/*46325*/     OPC_CheckPredicate, 8, // Predicate_load
/*46327*/     OPC_CheckPredicate, 9, // Predicate_dsload
/*46329*/     OPC_CheckType, MVT::f32,
/*46331*/     OPC_MoveParent,
/*46332*/     OPC_MoveParent,
/*46333*/     OPC_RecordChild2, // #3 = $src3
/*46334*/     OPC_MoveChild, 2,
/*46336*/     OPC_CheckOpcode, ISD::Constant,
/*46338*/     OPC_MoveParent,
/*46339*/     OPC_CheckPatternPredicate, 4, // (Subtarget->hasSSE41())
/*46341*/     OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #4 #5 #6 #7 #8
/*46344*/     OPC_EmitMergeInputChains, 1, 1, 
/*46347*/     OPC_EmitConvertToTarget, 3,
/*46349*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::INSERTPSrm), 0|OPFL_Chain|OPFL_MemRefs,
                  1/*#VTs*/, MVT::v4f32, 7/*#Ops*/, 0, 4, 5, 6, 7, 8, 9, 
              // Src: (X86insrtps:v4f32 VR128:v4f32:$src1, (scalar_to_vector:v4f32 (ld:f32 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>), (imm:iPTR):$src3)
              // Dst: (INSERTPSrm:v4f32 VR128:v4f32:$src1, addr:iPTR:$src2, (imm:i32):$src3)
/*46363*/   /*Scope*/ 21, /*->46385*/
/*46364*/     OPC_RecordChild1, // #1 = $src2
/*46365*/     OPC_RecordChild2, // #2 = $src3
/*46366*/     OPC_MoveChild, 2,
/*46368*/     OPC_CheckOpcode, ISD::Constant,
/*46370*/     OPC_MoveParent,
/*46371*/     OPC_CheckPatternPredicate, 4, // (Subtarget->hasSSE41())
/*46373*/     OPC_EmitConvertToTarget, 2,
/*46375*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::INSERTPSrr), 0,
                  1/*#VTs*/, MVT::v4f32, 3/*#Ops*/, 0, 1, 3, 
              // Src: (X86insrtps:v4f32 VR128:v4f32:$src1, VR128:v4f32:$src2, (imm:iPTR):$src3)
              // Dst: (INSERTPSrr:v4f32 VR128:v4f32:$src1, VR128:v4f32:$src2, (imm:i32):$src3)
/*46385*/   0, /*End of Scope*/
          /*SwitchOpcode*/ 76,  X86ISD::MMX_PINSRW,// ->46464
/*46388*/   OPC_RecordChild0, // #0 = $src1
/*46389*/   OPC_Scope, 50, /*->46441*/ // 2 children in Scope
/*46391*/     OPC_MoveChild, 1,
/*46393*/     OPC_CheckOpcode, ISD::ANY_EXTEND,
/*46395*/     OPC_MoveChild, 0,
/*46397*/     OPC_CheckOpcode, ISD::LOAD,
/*46399*/     OPC_RecordMemRef,
/*46400*/     OPC_RecordNode, // #1 = 'ld' chained node
/*46401*/     OPC_CheckFoldableChainNode,
/*46402*/     OPC_RecordChild1, // #2 = $src2
/*46403*/     OPC_CheckPredicate, 2, // Predicate_unindexedload
/*46405*/     OPC_CheckPredicate, 6, // Predicate_loadi16
/*46407*/     OPC_CheckType, MVT::i16,
/*46409*/     OPC_MoveParent,
/*46410*/     OPC_MoveParent,
/*46411*/     OPC_RecordChild2, // #3 = $src3
/*46412*/     OPC_MoveChild, 2,
/*46414*/     OPC_CheckOpcode, ISD::Constant,
/*46416*/     OPC_MoveParent,
/*46417*/     OPC_CheckPatternPredicate, 8, // (Subtarget->hasMMX())
/*46419*/     OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #4 #5 #6 #7 #8
/*46422*/     OPC_EmitMergeInputChains, 1, 1, 
/*46425*/     OPC_EmitConvertToTarget, 3,
/*46427*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PINSRWrmi), 0|OPFL_Chain|OPFL_MemRefs,
                  1/*#VTs*/, MVT::v4i16, 7/*#Ops*/, 0, 4, 5, 6, 7, 8, 9, 
              // Src: (MMX_X86pinsrw:v4i16 VR64:v4i16:$src1, (anyext:i32 (ld:i16 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>), (imm:iPTR):$src3)
              // Dst: (MMX_PINSRWrmi:v4i16 VR64:v4i16:$src1, addr:iPTR:$src2, (imm:i16):$src3)
/*46441*/   /*Scope*/ 21, /*->46463*/
/*46442*/     OPC_RecordChild1, // #1 = $src2
/*46443*/     OPC_RecordChild2, // #2 = $src3
/*46444*/     OPC_MoveChild, 2,
/*46446*/     OPC_CheckOpcode, ISD::Constant,
/*46448*/     OPC_MoveParent,
/*46449*/     OPC_CheckPatternPredicate, 8, // (Subtarget->hasMMX())
/*46451*/     OPC_EmitConvertToTarget, 2,
/*46453*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PINSRWrri), 0,
                  1/*#VTs*/, MVT::v4i16, 3/*#Ops*/, 0, 1, 3, 
              // Src: (MMX_X86pinsrw:v4i16 VR64:v4i16:$src1, GR32:i32:$src2, (imm:iPTR):$src3)
              // Dst: (MMX_PINSRWrri:v4i16 VR64:v4i16:$src1, GR32:i32:$src2, (imm:i16):$src3)
/*46463*/   0, /*End of Scope*/
          /*SwitchOpcode*/ 88,  X86ISD::MOVQ2DQ,// ->46554
/*46466*/   OPC_Scope, 75, /*->46543*/ // 2 children in Scope
/*46468*/     OPC_MoveChild, 0,
/*46470*/     OPC_SwitchOpcode /*2 cases */, 41,  ISD::BIT_CONVERT,// ->46514
/*46473*/       OPC_MoveChild, 0,
/*46475*/       OPC_CheckOpcode, ISD::SCALAR_TO_VECTOR,
/*46477*/       OPC_MoveChild, 0,
/*46479*/       OPC_CheckOpcode, ISD::LOAD,
/*46481*/       OPC_RecordMemRef,
/*46482*/       OPC_RecordNode, // #0 = 'ld' chained node
/*46483*/       OPC_CheckFoldableChainNode,
/*46484*/       OPC_RecordChild1, // #1 = $src
/*46485*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*46487*/       OPC_CheckPredicate, 3, // Predicate_loadi32
/*46489*/       OPC_CheckType, MVT::i32,
/*46491*/       OPC_MoveParent,
/*46492*/       OPC_CheckType, MVT::v2i32,
/*46494*/       OPC_MoveParent,
/*46495*/       OPC_MoveParent,
/*46496*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*46499*/       OPC_EmitMergeInputChains, 1, 0, 
/*46502*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVDI2PDIrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v2i64, 5/*#Ops*/, 2, 3, 4, 5, 6, 
                // Src: (MMX_X86movq2dq:v2i64 (bitconvert:v1i64 (scalar_to_vector:v2i32 (ld:i32 addr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)))
                // Dst: (MOVDI2PDIrm:v2i64 addr:iPTR:$src)
              /*SwitchOpcode*/ 26,  ISD::LOAD,// ->46542
/*46516*/       OPC_RecordMemRef,
/*46517*/       OPC_RecordNode, // #0 = 'ld' chained node
/*46518*/       OPC_RecordChild1, // #1 = $src
/*46519*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*46521*/       OPC_CheckPredicate, 8, // Predicate_load
/*46523*/       OPC_MoveParent,
/*46524*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*46527*/       OPC_EmitMergeInputChains, 1, 0, 
/*46530*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVQI2PQIrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v2i64, 5/*#Ops*/, 2, 3, 4, 5, 6, 
                // Src: (MMX_X86movq2dq:v2i64 (ld:v1i64 addr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)
                // Dst: (MOVQI2PQIrm:v2i64 addr:iPTR:$src)
              0, // EndSwitchOpcode
/*46543*/   /*Scope*/ 9, /*->46553*/
/*46544*/     OPC_RecordChild0, // #0 = $src
/*46545*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_MOVQ2DQrr), 0,
                  1/*#VTs*/, MVT::v2i64, 1/*#Ops*/, 0, 
              // Src: (MMX_X86movq2dq:v2i64 VR64:v1i64:$src)
              // Dst: (MMX_MOVQ2DQrr:v2i64 VR64:v8i8:$src)
/*46553*/   0, /*End of Scope*/
          /*SwitchOpcode*/ 25|128,35/*4505*/,  X86ISD::CMOV,// ->51062
/*46557*/   OPC_Scope, 77|128,8/*1101*/, /*->47661*/ // 5 children in Scope
/*46560*/     OPC_RecordChild0, // #0 = $src1
/*46561*/     OPC_MoveChild, 1,
/*46563*/     OPC_CheckOpcode, ISD::LOAD,
/*46565*/     OPC_RecordMemRef,
/*46566*/     OPC_RecordNode, // #1 = 'ld' chained node
/*46567*/     OPC_CheckFoldableChainNode,
/*46568*/     OPC_RecordChild1, // #2 = $src2
/*46569*/     OPC_CheckPredicate, 2, // Predicate_unindexedload
/*46571*/     OPC_Scope, 33, /*->46606*/ // 32 children in Scope
/*46573*/       OPC_CheckPredicate, 6, // Predicate_loadi16
/*46575*/       OPC_MoveParent,
/*46576*/       OPC_MoveChild, 2,
/*46578*/       OPC_CheckInteger, 2, 
/*46580*/       OPC_MoveParent,
/*46581*/       OPC_RecordChild3, // #3 = physreg input EFLAGS
/*46582*/       OPC_CheckType, MVT::i16,
/*46584*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #4 #5 #6 #7 #8
/*46587*/       OPC_EmitMergeInputChains, 1, 1, 
/*46590*/       OPC_EmitCopyToReg, 3, X86::EFLAGS,
/*46593*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::CMOVB16rm), 0|OPFL_Chain|OPFL_FlagInput|OPFL_MemRefs,
                    1/*#VTs*/, MVT::i16, 6/*#Ops*/, 0, 4, 5, 6, 7, 8, 
                // Src: (X86cmov:i16 GR16:i16:$src1, (ld:i16 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, 2:i8, EFLAGS:i32)
                // Dst: (CMOVB16rm:i16 GR16:i16:$src1, addr:iPTR:$src2)
/*46606*/     /*Scope*/ 33, /*->46640*/
/*46607*/       OPC_CheckPredicate, 3, // Predicate_loadi32
/*46609*/       OPC_MoveParent,
/*46610*/       OPC_MoveChild, 2,
/*46612*/       OPC_CheckInteger, 2, 
/*46614*/       OPC_MoveParent,
/*46615*/       OPC_RecordChild3, // #3 = physreg input EFLAGS
/*46616*/       OPC_CheckType, MVT::i32,
/*46618*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #4 #5 #6 #7 #8
/*46621*/       OPC_EmitMergeInputChains, 1, 1, 
/*46624*/       OPC_EmitCopyToReg, 3, X86::EFLAGS,
/*46627*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::CMOVB32rm), 0|OPFL_Chain|OPFL_FlagInput|OPFL_MemRefs,
                    1/*#VTs*/, MVT::i32, 6/*#Ops*/, 0, 4, 5, 6, 7, 8, 
                // Src: (X86cmov:i32 GR32:i32:$src1, (ld:i32 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, 2:i8, EFLAGS:i32)
                // Dst: (CMOVB32rm:i32 GR32:i32:$src1, addr:iPTR:$src2)
/*46640*/     /*Scope*/ 33, /*->46674*/
/*46641*/       OPC_CheckPredicate, 6, // Predicate_loadi16
/*46643*/       OPC_MoveParent,
/*46644*/       OPC_MoveChild, 2,
/*46646*/       OPC_CheckInteger, 1, 
/*46648*/       OPC_MoveParent,
/*46649*/       OPC_RecordChild3, // #3 = physreg input EFLAGS
/*46650*/       OPC_CheckType, MVT::i16,
/*46652*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #4 #5 #6 #7 #8
/*46655*/       OPC_EmitMergeInputChains, 1, 1, 
/*46658*/       OPC_EmitCopyToReg, 3, X86::EFLAGS,
/*46661*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::CMOVAE16rm), 0|OPFL_Chain|OPFL_FlagInput|OPFL_MemRefs,
                    1/*#VTs*/, MVT::i16, 6/*#Ops*/, 0, 4, 5, 6, 7, 8, 
                // Src: (X86cmov:i16 GR16:i16:$src1, (ld:i16 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, 1:i8, EFLAGS:i32)
                // Dst: (CMOVAE16rm:i16 GR16:i16:$src1, addr:iPTR:$src2)
/*46674*/     /*Scope*/ 33, /*->46708*/
/*46675*/       OPC_CheckPredicate, 3, // Predicate_loadi32
/*46677*/       OPC_MoveParent,
/*46678*/       OPC_MoveChild, 2,
/*46680*/       OPC_CheckInteger, 1, 
/*46682*/       OPC_MoveParent,
/*46683*/       OPC_RecordChild3, // #3 = physreg input EFLAGS
/*46684*/       OPC_CheckType, MVT::i32,
/*46686*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #4 #5 #6 #7 #8
/*46689*/       OPC_EmitMergeInputChains, 1, 1, 
/*46692*/       OPC_EmitCopyToReg, 3, X86::EFLAGS,
/*46695*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::CMOVAE32rm), 0|OPFL_Chain|OPFL_FlagInput|OPFL_MemRefs,
                    1/*#VTs*/, MVT::i32, 6/*#Ops*/, 0, 4, 5, 6, 7, 8, 
                // Src: (X86cmov:i32 GR32:i32:$src1, (ld:i32 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, 1:i8, EFLAGS:i32)
                // Dst: (CMOVAE32rm:i32 GR32:i32:$src1, addr:iPTR:$src2)
/*46708*/     /*Scope*/ 33, /*->46742*/
/*46709*/       OPC_CheckPredicate, 6, // Predicate_loadi16
/*46711*/       OPC_MoveParent,
/*46712*/       OPC_MoveChild, 2,
/*46714*/       OPC_CheckInteger, 4, 
/*46716*/       OPC_MoveParent,
/*46717*/       OPC_RecordChild3, // #3 = physreg input EFLAGS
/*46718*/       OPC_CheckType, MVT::i16,
/*46720*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #4 #5 #6 #7 #8
/*46723*/       OPC_EmitMergeInputChains, 1, 1, 
/*46726*/       OPC_EmitCopyToReg, 3, X86::EFLAGS,
/*46729*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::CMOVE16rm), 0|OPFL_Chain|OPFL_FlagInput|OPFL_MemRefs,
                    1/*#VTs*/, MVT::i16, 6/*#Ops*/, 0, 4, 5, 6, 7, 8, 
                // Src: (X86cmov:i16 GR16:i16:$src1, (ld:i16 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, 4:i8, EFLAGS:i32)
                // Dst: (CMOVE16rm:i16 GR16:i16:$src1, addr:iPTR:$src2)
/*46742*/     /*Scope*/ 33, /*->46776*/
/*46743*/       OPC_CheckPredicate, 3, // Predicate_loadi32
/*46745*/       OPC_MoveParent,
/*46746*/       OPC_MoveChild, 2,
/*46748*/       OPC_CheckInteger, 4, 
/*46750*/       OPC_MoveParent,
/*46751*/       OPC_RecordChild3, // #3 = physreg input EFLAGS
/*46752*/       OPC_CheckType, MVT::i32,
/*46754*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #4 #5 #6 #7 #8
/*46757*/       OPC_EmitMergeInputChains, 1, 1, 
/*46760*/       OPC_EmitCopyToReg, 3, X86::EFLAGS,
/*46763*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::CMOVE32rm), 0|OPFL_Chain|OPFL_FlagInput|OPFL_MemRefs,
                    1/*#VTs*/, MVT::i32, 6/*#Ops*/, 0, 4, 5, 6, 7, 8, 
                // Src: (X86cmov:i32 GR32:i32:$src1, (ld:i32 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, 4:i8, EFLAGS:i32)
                // Dst: (CMOVE32rm:i32 GR32:i32:$src1, addr:iPTR:$src2)
/*46776*/     /*Scope*/ 33, /*->46810*/
/*46777*/       OPC_CheckPredicate, 6, // Predicate_loadi16
/*46779*/       OPC_MoveParent,
/*46780*/       OPC_MoveChild, 2,
/*46782*/       OPC_CheckInteger, 9, 
/*46784*/       OPC_MoveParent,
/*46785*/       OPC_RecordChild3, // #3 = physreg input EFLAGS
/*46786*/       OPC_CheckType, MVT::i16,
/*46788*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #4 #5 #6 #7 #8
/*46791*/       OPC_EmitMergeInputChains, 1, 1, 
/*46794*/       OPC_EmitCopyToReg, 3, X86::EFLAGS,
/*46797*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::CMOVNE16rm), 0|OPFL_Chain|OPFL_FlagInput|OPFL_MemRefs,
                    1/*#VTs*/, MVT::i16, 6/*#Ops*/, 0, 4, 5, 6, 7, 8, 
                // Src: (X86cmov:i16 GR16:i16:$src1, (ld:i16 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, 9:i8, EFLAGS:i32)
                // Dst: (CMOVNE16rm:i16 GR16:i16:$src1, addr:iPTR:$src2)
/*46810*/     /*Scope*/ 33, /*->46844*/
/*46811*/       OPC_CheckPredicate, 3, // Predicate_loadi32
/*46813*/       OPC_MoveParent,
/*46814*/       OPC_MoveChild, 2,
/*46816*/       OPC_CheckInteger, 9, 
/*46818*/       OPC_MoveParent,
/*46819*/       OPC_RecordChild3, // #3 = physreg input EFLAGS
/*46820*/       OPC_CheckType, MVT::i32,
/*46822*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #4 #5 #6 #7 #8
/*46825*/       OPC_EmitMergeInputChains, 1, 1, 
/*46828*/       OPC_EmitCopyToReg, 3, X86::EFLAGS,
/*46831*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::CMOVNE32rm), 0|OPFL_Chain|OPFL_FlagInput|OPFL_MemRefs,
                    1/*#VTs*/, MVT::i32, 6/*#Ops*/, 0, 4, 5, 6, 7, 8, 
                // Src: (X86cmov:i32 GR32:i32:$src1, (ld:i32 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, 9:i8, EFLAGS:i32)
                // Dst: (CMOVNE32rm:i32 GR32:i32:$src1, addr:iPTR:$src2)
/*46844*/     /*Scope*/ 33, /*->46878*/
/*46845*/       OPC_CheckPredicate, 6, // Predicate_loadi16
/*46847*/       OPC_MoveParent,
/*46848*/       OPC_MoveChild, 2,
/*46850*/       OPC_CheckInteger, 3, 
/*46852*/       OPC_MoveParent,
/*46853*/       OPC_RecordChild3, // #3 = physreg input EFLAGS
/*46854*/       OPC_CheckType, MVT::i16,
/*46856*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #4 #5 #6 #7 #8
/*46859*/       OPC_EmitMergeInputChains, 1, 1, 
/*46862*/       OPC_EmitCopyToReg, 3, X86::EFLAGS,
/*46865*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::CMOVBE16rm), 0|OPFL_Chain|OPFL_FlagInput|OPFL_MemRefs,
                    1/*#VTs*/, MVT::i16, 6/*#Ops*/, 0, 4, 5, 6, 7, 8, 
                // Src: (X86cmov:i16 GR16:i16:$src1, (ld:i16 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, 3:i8, EFLAGS:i32)
                // Dst: (CMOVBE16rm:i16 GR16:i16:$src1, addr:iPTR:$src2)
/*46878*/     /*Scope*/ 33, /*->46912*/
/*46879*/       OPC_CheckPredicate, 3, // Predicate_loadi32
/*46881*/       OPC_MoveParent,
/*46882*/       OPC_MoveChild, 2,
/*46884*/       OPC_CheckInteger, 3, 
/*46886*/       OPC_MoveParent,
/*46887*/       OPC_RecordChild3, // #3 = physreg input EFLAGS
/*46888*/       OPC_CheckType, MVT::i32,
/*46890*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #4 #5 #6 #7 #8
/*46893*/       OPC_EmitMergeInputChains, 1, 1, 
/*46896*/       OPC_EmitCopyToReg, 3, X86::EFLAGS,
/*46899*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::CMOVBE32rm), 0|OPFL_Chain|OPFL_FlagInput|OPFL_MemRefs,
                    1/*#VTs*/, MVT::i32, 6/*#Ops*/, 0, 4, 5, 6, 7, 8, 
                // Src: (X86cmov:i32 GR32:i32:$src1, (ld:i32 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, 3:i8, EFLAGS:i32)
                // Dst: (CMOVBE32rm:i32 GR32:i32:$src1, addr:iPTR:$src2)
/*46912*/     /*Scope*/ 33, /*->46946*/
/*46913*/       OPC_CheckPredicate, 6, // Predicate_loadi16
/*46915*/       OPC_MoveParent,
/*46916*/       OPC_MoveChild, 2,
/*46918*/       OPC_CheckInteger, 0, 
/*46920*/       OPC_MoveParent,
/*46921*/       OPC_RecordChild3, // #3 = physreg input EFLAGS
/*46922*/       OPC_CheckType, MVT::i16,
/*46924*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #4 #5 #6 #7 #8
/*46927*/       OPC_EmitMergeInputChains, 1, 1, 
/*46930*/       OPC_EmitCopyToReg, 3, X86::EFLAGS,
/*46933*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::CMOVA16rm), 0|OPFL_Chain|OPFL_FlagInput|OPFL_MemRefs,
                    1/*#VTs*/, MVT::i16, 6/*#Ops*/, 0, 4, 5, 6, 7, 8, 
                // Src: (X86cmov:i16 GR16:i16:$src1, (ld:i16 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, 0:i8, EFLAGS:i32)
                // Dst: (CMOVA16rm:i16 GR16:i16:$src1, addr:iPTR:$src2)
/*46946*/     /*Scope*/ 33, /*->46980*/
/*46947*/       OPC_CheckPredicate, 3, // Predicate_loadi32
/*46949*/       OPC_MoveParent,
/*46950*/       OPC_MoveChild, 2,
/*46952*/       OPC_CheckInteger, 0, 
/*46954*/       OPC_MoveParent,
/*46955*/       OPC_RecordChild3, // #3 = physreg input EFLAGS
/*46956*/       OPC_CheckType, MVT::i32,
/*46958*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #4 #5 #6 #7 #8
/*46961*/       OPC_EmitMergeInputChains, 1, 1, 
/*46964*/       OPC_EmitCopyToReg, 3, X86::EFLAGS,
/*46967*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::CMOVA32rm), 0|OPFL_Chain|OPFL_FlagInput|OPFL_MemRefs,
                    1/*#VTs*/, MVT::i32, 6/*#Ops*/, 0, 4, 5, 6, 7, 8, 
                // Src: (X86cmov:i32 GR32:i32:$src1, (ld:i32 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, 0:i8, EFLAGS:i32)
                // Dst: (CMOVA32rm:i32 GR32:i32:$src1, addr:iPTR:$src2)
/*46980*/     /*Scope*/ 33, /*->47014*/
/*46981*/       OPC_CheckPredicate, 6, // Predicate_loadi16
/*46983*/       OPC_MoveParent,
/*46984*/       OPC_MoveChild, 2,
/*46986*/       OPC_CheckInteger, 7, 
/*46988*/       OPC_MoveParent,
/*46989*/       OPC_RecordChild3, // #3 = physreg input EFLAGS
/*46990*/       OPC_CheckType, MVT::i16,
/*46992*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #4 #5 #6 #7 #8
/*46995*/       OPC_EmitMergeInputChains, 1, 1, 
/*46998*/       OPC_EmitCopyToReg, 3, X86::EFLAGS,
/*47001*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::CMOVL16rm), 0|OPFL_Chain|OPFL_FlagInput|OPFL_MemRefs,
                    1/*#VTs*/, MVT::i16, 6/*#Ops*/, 0, 4, 5, 6, 7, 8, 
                // Src: (X86cmov:i16 GR16:i16:$src1, (ld:i16 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, 7:i8, EFLAGS:i32)
                // Dst: (CMOVL16rm:i16 GR16:i16:$src1, addr:iPTR:$src2)
/*47014*/     /*Scope*/ 33, /*->47048*/
/*47015*/       OPC_CheckPredicate, 3, // Predicate_loadi32
/*47017*/       OPC_MoveParent,
/*47018*/       OPC_MoveChild, 2,
/*47020*/       OPC_CheckInteger, 7, 
/*47022*/       OPC_MoveParent,
/*47023*/       OPC_RecordChild3, // #3 = physreg input EFLAGS
/*47024*/       OPC_CheckType, MVT::i32,
/*47026*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #4 #5 #6 #7 #8
/*47029*/       OPC_EmitMergeInputChains, 1, 1, 
/*47032*/       OPC_EmitCopyToReg, 3, X86::EFLAGS,
/*47035*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::CMOVL32rm), 0|OPFL_Chain|OPFL_FlagInput|OPFL_MemRefs,
                    1/*#VTs*/, MVT::i32, 6/*#Ops*/, 0, 4, 5, 6, 7, 8, 
                // Src: (X86cmov:i32 GR32:i32:$src1, (ld:i32 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, 7:i8, EFLAGS:i32)
                // Dst: (CMOVL32rm:i32 GR32:i32:$src1, addr:iPTR:$src2)
/*47048*/     /*Scope*/ 33, /*->47082*/
/*47049*/       OPC_CheckPredicate, 6, // Predicate_loadi16
/*47051*/       OPC_MoveParent,
/*47052*/       OPC_MoveChild, 2,
/*47054*/       OPC_CheckInteger, 6, 
/*47056*/       OPC_MoveParent,
/*47057*/       OPC_RecordChild3, // #3 = physreg input EFLAGS
/*47058*/       OPC_CheckType, MVT::i16,
/*47060*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #4 #5 #6 #7 #8
/*47063*/       OPC_EmitMergeInputChains, 1, 1, 
/*47066*/       OPC_EmitCopyToReg, 3, X86::EFLAGS,
/*47069*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::CMOVGE16rm), 0|OPFL_Chain|OPFL_FlagInput|OPFL_MemRefs,
                    1/*#VTs*/, MVT::i16, 6/*#Ops*/, 0, 4, 5, 6, 7, 8, 
                // Src: (X86cmov:i16 GR16:i16:$src1, (ld:i16 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, 6:i8, EFLAGS:i32)
                // Dst: (CMOVGE16rm:i16 GR16:i16:$src1, addr:iPTR:$src2)
/*47082*/     /*Scope*/ 33, /*->47116*/
/*47083*/       OPC_CheckPredicate, 3, // Predicate_loadi32
/*47085*/       OPC_MoveParent,
/*47086*/       OPC_MoveChild, 2,
/*47088*/       OPC_CheckInteger, 6, 
/*47090*/       OPC_MoveParent,
/*47091*/       OPC_RecordChild3, // #3 = physreg input EFLAGS
/*47092*/       OPC_CheckType, MVT::i32,
/*47094*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #4 #5 #6 #7 #8
/*47097*/       OPC_EmitMergeInputChains, 1, 1, 
/*47100*/       OPC_EmitCopyToReg, 3, X86::EFLAGS,
/*47103*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::CMOVGE32rm), 0|OPFL_Chain|OPFL_FlagInput|OPFL_MemRefs,
                    1/*#VTs*/, MVT::i32, 6/*#Ops*/, 0, 4, 5, 6, 7, 8, 
                // Src: (X86cmov:i32 GR32:i32:$src1, (ld:i32 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, 6:i8, EFLAGS:i32)
                // Dst: (CMOVGE32rm:i32 GR32:i32:$src1, addr:iPTR:$src2)
/*47116*/     /*Scope*/ 33, /*->47150*/
/*47117*/       OPC_CheckPredicate, 6, // Predicate_loadi16
/*47119*/       OPC_MoveParent,
/*47120*/       OPC_MoveChild, 2,
/*47122*/       OPC_CheckInteger, 8, 
/*47124*/       OPC_MoveParent,
/*47125*/       OPC_RecordChild3, // #3 = physreg input EFLAGS
/*47126*/       OPC_CheckType, MVT::i16,
/*47128*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #4 #5 #6 #7 #8
/*47131*/       OPC_EmitMergeInputChains, 1, 1, 
/*47134*/       OPC_EmitCopyToReg, 3, X86::EFLAGS,
/*47137*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::CMOVLE16rm), 0|OPFL_Chain|OPFL_FlagInput|OPFL_MemRefs,
                    1/*#VTs*/, MVT::i16, 6/*#Ops*/, 0, 4, 5, 6, 7, 8, 
                // Src: (X86cmov:i16 GR16:i16:$src1, (ld:i16 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, 8:i8, EFLAGS:i32)
                // Dst: (CMOVLE16rm:i16 GR16:i16:$src1, addr:iPTR:$src2)
/*47150*/     /*Scope*/ 33, /*->47184*/
/*47151*/       OPC_CheckPredicate, 3, // Predicate_loadi32
/*47153*/       OPC_MoveParent,
/*47154*/       OPC_MoveChild, 2,
/*47156*/       OPC_CheckInteger, 8, 
/*47158*/       OPC_MoveParent,
/*47159*/       OPC_RecordChild3, // #3 = physreg input EFLAGS
/*47160*/       OPC_CheckType, MVT::i32,
/*47162*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #4 #5 #6 #7 #8
/*47165*/       OPC_EmitMergeInputChains, 1, 1, 
/*47168*/       OPC_EmitCopyToReg, 3, X86::EFLAGS,
/*47171*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::CMOVLE32rm), 0|OPFL_Chain|OPFL_FlagInput|OPFL_MemRefs,
                    1/*#VTs*/, MVT::i32, 6/*#Ops*/, 0, 4, 5, 6, 7, 8, 
                // Src: (X86cmov:i32 GR32:i32:$src1, (ld:i32 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, 8:i8, EFLAGS:i32)
                // Dst: (CMOVLE32rm:i32 GR32:i32:$src1, addr:iPTR:$src2)
/*47184*/     /*Scope*/ 33, /*->47218*/
/*47185*/       OPC_CheckPredicate, 6, // Predicate_loadi16
/*47187*/       OPC_MoveParent,
/*47188*/       OPC_MoveChild, 2,
/*47190*/       OPC_CheckInteger, 5, 
/*47192*/       OPC_MoveParent,
/*47193*/       OPC_RecordChild3, // #3 = physreg input EFLAGS
/*47194*/       OPC_CheckType, MVT::i16,
/*47196*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #4 #5 #6 #7 #8
/*47199*/       OPC_EmitMergeInputChains, 1, 1, 
/*47202*/       OPC_EmitCopyToReg, 3, X86::EFLAGS,
/*47205*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::CMOVG16rm), 0|OPFL_Chain|OPFL_FlagInput|OPFL_MemRefs,
                    1/*#VTs*/, MVT::i16, 6/*#Ops*/, 0, 4, 5, 6, 7, 8, 
                // Src: (X86cmov:i16 GR16:i16:$src1, (ld:i16 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, 5:i8, EFLAGS:i32)
                // Dst: (CMOVG16rm:i16 GR16:i16:$src1, addr:iPTR:$src2)
/*47218*/     /*Scope*/ 33, /*->47252*/
/*47219*/       OPC_CheckPredicate, 3, // Predicate_loadi32
/*47221*/       OPC_MoveParent,
/*47222*/       OPC_MoveChild, 2,
/*47224*/       OPC_CheckInteger, 5, 
/*47226*/       OPC_MoveParent,
/*47227*/       OPC_RecordChild3, // #3 = physreg input EFLAGS
/*47228*/       OPC_CheckType, MVT::i32,
/*47230*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #4 #5 #6 #7 #8
/*47233*/       OPC_EmitMergeInputChains, 1, 1, 
/*47236*/       OPC_EmitCopyToReg, 3, X86::EFLAGS,
/*47239*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::CMOVG32rm), 0|OPFL_Chain|OPFL_FlagInput|OPFL_MemRefs,
                    1/*#VTs*/, MVT::i32, 6/*#Ops*/, 0, 4, 5, 6, 7, 8, 
                // Src: (X86cmov:i32 GR32:i32:$src1, (ld:i32 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, 5:i8, EFLAGS:i32)
                // Dst: (CMOVG32rm:i32 GR32:i32:$src1, addr:iPTR:$src2)
/*47252*/     /*Scope*/ 33, /*->47286*/
/*47253*/       OPC_CheckPredicate, 6, // Predicate_loadi16
/*47255*/       OPC_MoveParent,
/*47256*/       OPC_MoveChild, 2,
/*47258*/       OPC_CheckInteger, 15, 
/*47260*/       OPC_MoveParent,
/*47261*/       OPC_RecordChild3, // #3 = physreg input EFLAGS
/*47262*/       OPC_CheckType, MVT::i16,
/*47264*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #4 #5 #6 #7 #8
/*47267*/       OPC_EmitMergeInputChains, 1, 1, 
/*47270*/       OPC_EmitCopyToReg, 3, X86::EFLAGS,
/*47273*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::CMOVS16rm), 0|OPFL_Chain|OPFL_FlagInput|OPFL_MemRefs,
                    1/*#VTs*/, MVT::i16, 6/*#Ops*/, 0, 4, 5, 6, 7, 8, 
                // Src: (X86cmov:i16 GR16:i16:$src1, (ld:i16 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, 15:i8, EFLAGS:i32)
                // Dst: (CMOVS16rm:i16 GR16:i16:$src1, addr:iPTR:$src2)
/*47286*/     /*Scope*/ 33, /*->47320*/
/*47287*/       OPC_CheckPredicate, 3, // Predicate_loadi32
/*47289*/       OPC_MoveParent,
/*47290*/       OPC_MoveChild, 2,
/*47292*/       OPC_CheckInteger, 15, 
/*47294*/       OPC_MoveParent,
/*47295*/       OPC_RecordChild3, // #3 = physreg input EFLAGS
/*47296*/       OPC_CheckType, MVT::i32,
/*47298*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #4 #5 #6 #7 #8
/*47301*/       OPC_EmitMergeInputChains, 1, 1, 
/*47304*/       OPC_EmitCopyToReg, 3, X86::EFLAGS,
/*47307*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::CMOVS32rm), 0|OPFL_Chain|OPFL_FlagInput|OPFL_MemRefs,
                    1/*#VTs*/, MVT::i32, 6/*#Ops*/, 0, 4, 5, 6, 7, 8, 
                // Src: (X86cmov:i32 GR32:i32:$src1, (ld:i32 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, 15:i8, EFLAGS:i32)
                // Dst: (CMOVS32rm:i32 GR32:i32:$src1, addr:iPTR:$src2)
/*47320*/     /*Scope*/ 33, /*->47354*/
/*47321*/       OPC_CheckPredicate, 6, // Predicate_loadi16
/*47323*/       OPC_MoveParent,
/*47324*/       OPC_MoveChild, 2,
/*47326*/       OPC_CheckInteger, 12, 
/*47328*/       OPC_MoveParent,
/*47329*/       OPC_RecordChild3, // #3 = physreg input EFLAGS
/*47330*/       OPC_CheckType, MVT::i16,
/*47332*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #4 #5 #6 #7 #8
/*47335*/       OPC_EmitMergeInputChains, 1, 1, 
/*47338*/       OPC_EmitCopyToReg, 3, X86::EFLAGS,
/*47341*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::CMOVNS16rm), 0|OPFL_Chain|OPFL_FlagInput|OPFL_MemRefs,
                    1/*#VTs*/, MVT::i16, 6/*#Ops*/, 0, 4, 5, 6, 7, 8, 
                // Src: (X86cmov:i16 GR16:i16:$src1, (ld:i16 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, 12:i8, EFLAGS:i32)
                // Dst: (CMOVNS16rm:i16 GR16:i16:$src1, addr:iPTR:$src2)
/*47354*/     /*Scope*/ 33, /*->47388*/
/*47355*/       OPC_CheckPredicate, 3, // Predicate_loadi32
/*47357*/       OPC_MoveParent,
/*47358*/       OPC_MoveChild, 2,
/*47360*/       OPC_CheckInteger, 12, 
/*47362*/       OPC_MoveParent,
/*47363*/       OPC_RecordChild3, // #3 = physreg input EFLAGS
/*47364*/       OPC_CheckType, MVT::i32,
/*47366*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #4 #5 #6 #7 #8
/*47369*/       OPC_EmitMergeInputChains, 1, 1, 
/*47372*/       OPC_EmitCopyToReg, 3, X86::EFLAGS,
/*47375*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::CMOVNS32rm), 0|OPFL_Chain|OPFL_FlagInput|OPFL_MemRefs,
                    1/*#VTs*/, MVT::i32, 6/*#Ops*/, 0, 4, 5, 6, 7, 8, 
                // Src: (X86cmov:i32 GR32:i32:$src1, (ld:i32 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, 12:i8, EFLAGS:i32)
                // Dst: (CMOVNS32rm:i32 GR32:i32:$src1, addr:iPTR:$src2)
/*47388*/     /*Scope*/ 33, /*->47422*/
/*47389*/       OPC_CheckPredicate, 6, // Predicate_loadi16
/*47391*/       OPC_MoveParent,
/*47392*/       OPC_MoveChild, 2,
/*47394*/       OPC_CheckInteger, 14, 
/*47396*/       OPC_MoveParent,
/*47397*/       OPC_RecordChild3, // #3 = physreg input EFLAGS
/*47398*/       OPC_CheckType, MVT::i16,
/*47400*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #4 #5 #6 #7 #8
/*47403*/       OPC_EmitMergeInputChains, 1, 1, 
/*47406*/       OPC_EmitCopyToReg, 3, X86::EFLAGS,
/*47409*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::CMOVP16rm), 0|OPFL_Chain|OPFL_FlagInput|OPFL_MemRefs,
                    1/*#VTs*/, MVT::i16, 6/*#Ops*/, 0, 4, 5, 6, 7, 8, 
                // Src: (X86cmov:i16 GR16:i16:$src1, (ld:i16 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, 14:i8, EFLAGS:i32)
                // Dst: (CMOVP16rm:i16 GR16:i16:$src1, addr:iPTR:$src2)
/*47422*/     /*Scope*/ 33, /*->47456*/
/*47423*/       OPC_CheckPredicate, 3, // Predicate_loadi32
/*47425*/       OPC_MoveParent,
/*47426*/       OPC_MoveChild, 2,
/*47428*/       OPC_CheckInteger, 14, 
/*47430*/       OPC_MoveParent,
/*47431*/       OPC_RecordChild3, // #3 = physreg input EFLAGS
/*47432*/       OPC_CheckType, MVT::i32,
/*47434*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #4 #5 #6 #7 #8
/*47437*/       OPC_EmitMergeInputChains, 1, 1, 
/*47440*/       OPC_EmitCopyToReg, 3, X86::EFLAGS,
/*47443*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::CMOVP32rm), 0|OPFL_Chain|OPFL_FlagInput|OPFL_MemRefs,
                    1/*#VTs*/, MVT::i32, 6/*#Ops*/, 0, 4, 5, 6, 7, 8, 
                // Src: (X86cmov:i32 GR32:i32:$src1, (ld:i32 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, 14:i8, EFLAGS:i32)
                // Dst: (CMOVP32rm:i32 GR32:i32:$src1, addr:iPTR:$src2)
/*47456*/     /*Scope*/ 33, /*->47490*/
/*47457*/       OPC_CheckPredicate, 6, // Predicate_loadi16
/*47459*/       OPC_MoveParent,
/*47460*/       OPC_MoveChild, 2,
/*47462*/       OPC_CheckInteger, 11, 
/*47464*/       OPC_MoveParent,
/*47465*/       OPC_RecordChild3, // #3 = physreg input EFLAGS
/*47466*/       OPC_CheckType, MVT::i16,
/*47468*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #4 #5 #6 #7 #8
/*47471*/       OPC_EmitMergeInputChains, 1, 1, 
/*47474*/       OPC_EmitCopyToReg, 3, X86::EFLAGS,
/*47477*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::CMOVNP16rm), 0|OPFL_Chain|OPFL_FlagInput|OPFL_MemRefs,
                    1/*#VTs*/, MVT::i16, 6/*#Ops*/, 0, 4, 5, 6, 7, 8, 
                // Src: (X86cmov:i16 GR16:i16:$src1, (ld:i16 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, 11:i8, EFLAGS:i32)
                // Dst: (CMOVNP16rm:i16 GR16:i16:$src1, addr:iPTR:$src2)
/*47490*/     /*Scope*/ 33, /*->47524*/
/*47491*/       OPC_CheckPredicate, 3, // Predicate_loadi32
/*47493*/       OPC_MoveParent,
/*47494*/       OPC_MoveChild, 2,
/*47496*/       OPC_CheckInteger, 11, 
/*47498*/       OPC_MoveParent,
/*47499*/       OPC_RecordChild3, // #3 = physreg input EFLAGS
/*47500*/       OPC_CheckType, MVT::i32,
/*47502*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #4 #5 #6 #7 #8
/*47505*/       OPC_EmitMergeInputChains, 1, 1, 
/*47508*/       OPC_EmitCopyToReg, 3, X86::EFLAGS,
/*47511*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::CMOVNP32rm), 0|OPFL_Chain|OPFL_FlagInput|OPFL_MemRefs,
                    1/*#VTs*/, MVT::i32, 6/*#Ops*/, 0, 4, 5, 6, 7, 8, 
                // Src: (X86cmov:i32 GR32:i32:$src1, (ld:i32 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, 11:i8, EFLAGS:i32)
                // Dst: (CMOVNP32rm:i32 GR32:i32:$src1, addr:iPTR:$src2)
/*47524*/     /*Scope*/ 33, /*->47558*/
/*47525*/       OPC_CheckPredicate, 6, // Predicate_loadi16
/*47527*/       OPC_MoveParent,
/*47528*/       OPC_MoveChild, 2,
/*47530*/       OPC_CheckInteger, 13, 
/*47532*/       OPC_MoveParent,
/*47533*/       OPC_RecordChild3, // #3 = physreg input EFLAGS
/*47534*/       OPC_CheckType, MVT::i16,
/*47536*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #4 #5 #6 #7 #8
/*47539*/       OPC_EmitMergeInputChains, 1, 1, 
/*47542*/       OPC_EmitCopyToReg, 3, X86::EFLAGS,
/*47545*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::CMOVO16rm), 0|OPFL_Chain|OPFL_FlagInput|OPFL_MemRefs,
                    1/*#VTs*/, MVT::i16, 6/*#Ops*/, 0, 4, 5, 6, 7, 8, 
                // Src: (X86cmov:i16 GR16:i16:$src1, (ld:i16 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, 13:i8, EFLAGS:i32)
                // Dst: (CMOVO16rm:i16 GR16:i16:$src1, addr:iPTR:$src2)
/*47558*/     /*Scope*/ 33, /*->47592*/
/*47559*/       OPC_CheckPredicate, 3, // Predicate_loadi32
/*47561*/       OPC_MoveParent,
/*47562*/       OPC_MoveChild, 2,
/*47564*/       OPC_CheckInteger, 13, 
/*47566*/       OPC_MoveParent,
/*47567*/       OPC_RecordChild3, // #3 = physreg input EFLAGS
/*47568*/       OPC_CheckType, MVT::i32,
/*47570*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #4 #5 #6 #7 #8
/*47573*/       OPC_EmitMergeInputChains, 1, 1, 
/*47576*/       OPC_EmitCopyToReg, 3, X86::EFLAGS,
/*47579*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::CMOVO32rm), 0|OPFL_Chain|OPFL_FlagInput|OPFL_MemRefs,
                    1/*#VTs*/, MVT::i32, 6/*#Ops*/, 0, 4, 5, 6, 7, 8, 
                // Src: (X86cmov:i32 GR32:i32:$src1, (ld:i32 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, 13:i8, EFLAGS:i32)
                // Dst: (CMOVO32rm:i32 GR32:i32:$src1, addr:iPTR:$src2)
/*47592*/     /*Scope*/ 33, /*->47626*/
/*47593*/       OPC_CheckPredicate, 6, // Predicate_loadi16
/*47595*/       OPC_MoveParent,
/*47596*/       OPC_MoveChild, 2,
/*47598*/       OPC_CheckInteger, 10, 
/*47600*/       OPC_MoveParent,
/*47601*/       OPC_RecordChild3, // #3 = physreg input EFLAGS
/*47602*/       OPC_CheckType, MVT::i16,
/*47604*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #4 #5 #6 #7 #8
/*47607*/       OPC_EmitMergeInputChains, 1, 1, 
/*47610*/       OPC_EmitCopyToReg, 3, X86::EFLAGS,
/*47613*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::CMOVNO16rm), 0|OPFL_Chain|OPFL_FlagInput|OPFL_MemRefs,
                    1/*#VTs*/, MVT::i16, 6/*#Ops*/, 0, 4, 5, 6, 7, 8, 
                // Src: (X86cmov:i16 GR16:i16:$src1, (ld:i16 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, 10:i8, EFLAGS:i32)
                // Dst: (CMOVNO16rm:i16 GR16:i16:$src1, addr:iPTR:$src2)
/*47626*/     /*Scope*/ 33, /*->47660*/
/*47627*/       OPC_CheckPredicate, 3, // Predicate_loadi32
/*47629*/       OPC_MoveParent,
/*47630*/       OPC_MoveChild, 2,
/*47632*/       OPC_CheckInteger, 10, 
/*47634*/       OPC_MoveParent,
/*47635*/       OPC_RecordChild3, // #3 = physreg input EFLAGS
/*47636*/       OPC_CheckType, MVT::i32,
/*47638*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #4 #5 #6 #7 #8
/*47641*/       OPC_EmitMergeInputChains, 1, 1, 
/*47644*/       OPC_EmitCopyToReg, 3, X86::EFLAGS,
/*47647*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::CMOVNO32rm), 0|OPFL_Chain|OPFL_FlagInput|OPFL_MemRefs,
                    1/*#VTs*/, MVT::i32, 6/*#Ops*/, 0, 4, 5, 6, 7, 8, 
                // Src: (X86cmov:i32 GR32:i32:$src1, (ld:i32 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, 10:i8, EFLAGS:i32)
                // Dst: (CMOVNO32rm:i32 GR32:i32:$src1, addr:iPTR:$src2)
/*47660*/     0, /*End of Scope*/
/*47661*/   /*Scope*/ 108|128,8/*1132*/, /*->48795*/
/*47663*/     OPC_MoveChild, 0,
/*47665*/     OPC_CheckOpcode, ISD::LOAD,
/*47667*/     OPC_RecordMemRef,
/*47668*/     OPC_RecordNode, // #0 = 'ld' chained node
/*47669*/     OPC_CheckFoldableChainNode,
/*47670*/     OPC_RecordChild1, // #1 = $src1
/*47671*/     OPC_CheckPredicate, 2, // Predicate_unindexedload
/*47673*/     OPC_Scope, 34, /*->47709*/ // 32 children in Scope
/*47675*/       OPC_CheckPredicate, 6, // Predicate_loadi16
/*47677*/       OPC_MoveParent,
/*47678*/       OPC_RecordChild1, // #2 = $src2
/*47679*/       OPC_MoveChild, 2,
/*47681*/       OPC_CheckInteger, 2, 
/*47683*/       OPC_MoveParent,
/*47684*/       OPC_RecordChild3, // #3 = physreg input EFLAGS
/*47685*/       OPC_CheckType, MVT::i16,
/*47687*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src1 #4 #5 #6 #7 #8
/*47690*/       OPC_EmitMergeInputChains, 1, 0, 
/*47693*/       OPC_EmitCopyToReg, 3, X86::EFLAGS,
/*47696*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::CMOVAE16rm), 0|OPFL_Chain|OPFL_FlagInput|OPFL_MemRefs,
                    1/*#VTs*/, MVT::i16, 6/*#Ops*/, 2, 4, 5, 6, 7, 8, 
                // Src: (X86cmov:i16 (ld:i16 addr:iPTR:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, GR16:i16:$src2, 2:i8, EFLAGS:i32)
                // Dst: (CMOVAE16rm:i16 GR16:i16:$src2, addr:iPTR:$src1)
/*47709*/     /*Scope*/ 34, /*->47744*/
/*47710*/       OPC_CheckPredicate, 3, // Predicate_loadi32
/*47712*/       OPC_MoveParent,
/*47713*/       OPC_RecordChild1, // #2 = $src2
/*47714*/       OPC_MoveChild, 2,
/*47716*/       OPC_CheckInteger, 2, 
/*47718*/       OPC_MoveParent,
/*47719*/       OPC_RecordChild3, // #3 = physreg input EFLAGS
/*47720*/       OPC_CheckType, MVT::i32,
/*47722*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src1 #4 #5 #6 #7 #8
/*47725*/       OPC_EmitMergeInputChains, 1, 0, 
/*47728*/       OPC_EmitCopyToReg, 3, X86::EFLAGS,
/*47731*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::CMOVAE32rm), 0|OPFL_Chain|OPFL_FlagInput|OPFL_MemRefs,
                    1/*#VTs*/, MVT::i32, 6/*#Ops*/, 2, 4, 5, 6, 7, 8, 
                // Src: (X86cmov:i32 (ld:i32 addr:iPTR:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, GR32:i32:$src2, 2:i8, EFLAGS:i32)
                // Dst: (CMOVAE32rm:i32 GR32:i32:$src2, addr:iPTR:$src1)
/*47744*/     /*Scope*/ 34, /*->47779*/
/*47745*/       OPC_CheckPredicate, 6, // Predicate_loadi16
/*47747*/       OPC_MoveParent,
/*47748*/       OPC_RecordChild1, // #2 = $src2
/*47749*/       OPC_MoveChild, 2,
/*47751*/       OPC_CheckInteger, 1, 
/*47753*/       OPC_MoveParent,
/*47754*/       OPC_RecordChild3, // #3 = physreg input EFLAGS
/*47755*/       OPC_CheckType, MVT::i16,
/*47757*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src1 #4 #5 #6 #7 #8
/*47760*/       OPC_EmitMergeInputChains, 1, 0, 
/*47763*/       OPC_EmitCopyToReg, 3, X86::EFLAGS,
/*47766*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::CMOVB16rm), 0|OPFL_Chain|OPFL_FlagInput|OPFL_MemRefs,
                    1/*#VTs*/, MVT::i16, 6/*#Ops*/, 2, 4, 5, 6, 7, 8, 
                // Src: (X86cmov:i16 (ld:i16 addr:iPTR:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, GR16:i16:$src2, 1:i8, EFLAGS:i32)
                // Dst: (CMOVB16rm:i16 GR16:i16:$src2, addr:iPTR:$src1)
/*47779*/     /*Scope*/ 34, /*->47814*/
/*47780*/       OPC_CheckPredicate, 3, // Predicate_loadi32
/*47782*/       OPC_MoveParent,
/*47783*/       OPC_RecordChild1, // #2 = $src2
/*47784*/       OPC_MoveChild, 2,
/*47786*/       OPC_CheckInteger, 1, 
/*47788*/       OPC_MoveParent,
/*47789*/       OPC_RecordChild3, // #3 = physreg input EFLAGS
/*47790*/       OPC_CheckType, MVT::i32,
/*47792*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src1 #4 #5 #6 #7 #8
/*47795*/       OPC_EmitMergeInputChains, 1, 0, 
/*47798*/       OPC_EmitCopyToReg, 3, X86::EFLAGS,
/*47801*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::CMOVB32rm), 0|OPFL_Chain|OPFL_FlagInput|OPFL_MemRefs,
                    1/*#VTs*/, MVT::i32, 6/*#Ops*/, 2, 4, 5, 6, 7, 8, 
                // Src: (X86cmov:i32 (ld:i32 addr:iPTR:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, GR32:i32:$src2, 1:i8, EFLAGS:i32)
                // Dst: (CMOVB32rm:i32 GR32:i32:$src2, addr:iPTR:$src1)
/*47814*/     /*Scope*/ 34, /*->47849*/
/*47815*/       OPC_CheckPredicate, 6, // Predicate_loadi16
/*47817*/       OPC_MoveParent,
/*47818*/       OPC_RecordChild1, // #2 = $src2
/*47819*/       OPC_MoveChild, 2,
/*47821*/       OPC_CheckInteger, 4, 
/*47823*/       OPC_MoveParent,
/*47824*/       OPC_RecordChild3, // #3 = physreg input EFLAGS
/*47825*/       OPC_CheckType, MVT::i16,
/*47827*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src1 #4 #5 #6 #7 #8
/*47830*/       OPC_EmitMergeInputChains, 1, 0, 
/*47833*/       OPC_EmitCopyToReg, 3, X86::EFLAGS,
/*47836*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::CMOVNE16rm), 0|OPFL_Chain|OPFL_FlagInput|OPFL_MemRefs,
                    1/*#VTs*/, MVT::i16, 6/*#Ops*/, 2, 4, 5, 6, 7, 8, 
                // Src: (X86cmov:i16 (ld:i16 addr:iPTR:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, GR16:i16:$src2, 4:i8, EFLAGS:i32)
                // Dst: (CMOVNE16rm:i16 GR16:i16:$src2, addr:iPTR:$src1)
/*47849*/     /*Scope*/ 34, /*->47884*/
/*47850*/       OPC_CheckPredicate, 3, // Predicate_loadi32
/*47852*/       OPC_MoveParent,
/*47853*/       OPC_RecordChild1, // #2 = $src2
/*47854*/       OPC_MoveChild, 2,
/*47856*/       OPC_CheckInteger, 4, 
/*47858*/       OPC_MoveParent,
/*47859*/       OPC_RecordChild3, // #3 = physreg input EFLAGS
/*47860*/       OPC_CheckType, MVT::i32,
/*47862*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src1 #4 #5 #6 #7 #8
/*47865*/       OPC_EmitMergeInputChains, 1, 0, 
/*47868*/       OPC_EmitCopyToReg, 3, X86::EFLAGS,
/*47871*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::CMOVNE32rm), 0|OPFL_Chain|OPFL_FlagInput|OPFL_MemRefs,
                    1/*#VTs*/, MVT::i32, 6/*#Ops*/, 2, 4, 5, 6, 7, 8, 
                // Src: (X86cmov:i32 (ld:i32 addr:iPTR:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, GR32:i32:$src2, 4:i8, EFLAGS:i32)
                // Dst: (CMOVNE32rm:i32 GR32:i32:$src2, addr:iPTR:$src1)
/*47884*/     /*Scope*/ 34, /*->47919*/
/*47885*/       OPC_CheckPredicate, 6, // Predicate_loadi16
/*47887*/       OPC_MoveParent,
/*47888*/       OPC_RecordChild1, // #2 = $src2
/*47889*/       OPC_MoveChild, 2,
/*47891*/       OPC_CheckInteger, 9, 
/*47893*/       OPC_MoveParent,
/*47894*/       OPC_RecordChild3, // #3 = physreg input EFLAGS
/*47895*/       OPC_CheckType, MVT::i16,
/*47897*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src1 #4 #5 #6 #7 #8
/*47900*/       OPC_EmitMergeInputChains, 1, 0, 
/*47903*/       OPC_EmitCopyToReg, 3, X86::EFLAGS,
/*47906*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::CMOVE16rm), 0|OPFL_Chain|OPFL_FlagInput|OPFL_MemRefs,
                    1/*#VTs*/, MVT::i16, 6/*#Ops*/, 2, 4, 5, 6, 7, 8, 
                // Src: (X86cmov:i16 (ld:i16 addr:iPTR:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, GR16:i16:$src2, 9:i8, EFLAGS:i32)
                // Dst: (CMOVE16rm:i16 GR16:i16:$src2, addr:iPTR:$src1)
/*47919*/     /*Scope*/ 34, /*->47954*/
/*47920*/       OPC_CheckPredicate, 3, // Predicate_loadi32
/*47922*/       OPC_MoveParent,
/*47923*/       OPC_RecordChild1, // #2 = $src2
/*47924*/       OPC_MoveChild, 2,
/*47926*/       OPC_CheckInteger, 9, 
/*47928*/       OPC_MoveParent,
/*47929*/       OPC_RecordChild3, // #3 = physreg input EFLAGS
/*47930*/       OPC_CheckType, MVT::i32,
/*47932*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src1 #4 #5 #6 #7 #8
/*47935*/       OPC_EmitMergeInputChains, 1, 0, 
/*47938*/       OPC_EmitCopyToReg, 3, X86::EFLAGS,
/*47941*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::CMOVE32rm), 0|OPFL_Chain|OPFL_FlagInput|OPFL_MemRefs,
                    1/*#VTs*/, MVT::i32, 6/*#Ops*/, 2, 4, 5, 6, 7, 8, 
                // Src: (X86cmov:i32 (ld:i32 addr:iPTR:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, GR32:i32:$src2, 9:i8, EFLAGS:i32)
                // Dst: (CMOVE32rm:i32 GR32:i32:$src2, addr:iPTR:$src1)
/*47954*/     /*Scope*/ 34, /*->47989*/
/*47955*/       OPC_CheckPredicate, 6, // Predicate_loadi16
/*47957*/       OPC_MoveParent,
/*47958*/       OPC_RecordChild1, // #2 = $src2
/*47959*/       OPC_MoveChild, 2,
/*47961*/       OPC_CheckInteger, 3, 
/*47963*/       OPC_MoveParent,
/*47964*/       OPC_RecordChild3, // #3 = physreg input EFLAGS
/*47965*/       OPC_CheckType, MVT::i16,
/*47967*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src1 #4 #5 #6 #7 #8
/*47970*/       OPC_EmitMergeInputChains, 1, 0, 
/*47973*/       OPC_EmitCopyToReg, 3, X86::EFLAGS,
/*47976*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::CMOVA16rm), 0|OPFL_Chain|OPFL_FlagInput|OPFL_MemRefs,
                    1/*#VTs*/, MVT::i16, 6/*#Ops*/, 2, 4, 5, 6, 7, 8, 
                // Src: (X86cmov:i16 (ld:i16 addr:iPTR:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, GR16:i16:$src2, 3:i8, EFLAGS:i32)
                // Dst: (CMOVA16rm:i16 GR16:i16:$src2, addr:iPTR:$src1)
/*47989*/     /*Scope*/ 34, /*->48024*/
/*47990*/       OPC_CheckPredicate, 3, // Predicate_loadi32
/*47992*/       OPC_MoveParent,
/*47993*/       OPC_RecordChild1, // #2 = $src2
/*47994*/       OPC_MoveChild, 2,
/*47996*/       OPC_CheckInteger, 3, 
/*47998*/       OPC_MoveParent,
/*47999*/       OPC_RecordChild3, // #3 = physreg input EFLAGS
/*48000*/       OPC_CheckType, MVT::i32,
/*48002*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src1 #4 #5 #6 #7 #8
/*48005*/       OPC_EmitMergeInputChains, 1, 0, 
/*48008*/       OPC_EmitCopyToReg, 3, X86::EFLAGS,
/*48011*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::CMOVA32rm), 0|OPFL_Chain|OPFL_FlagInput|OPFL_MemRefs,
                    1/*#VTs*/, MVT::i32, 6/*#Ops*/, 2, 4, 5, 6, 7, 8, 
                // Src: (X86cmov:i32 (ld:i32 addr:iPTR:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, GR32:i32:$src2, 3:i8, EFLAGS:i32)
                // Dst: (CMOVA32rm:i32 GR32:i32:$src2, addr:iPTR:$src1)
/*48024*/     /*Scope*/ 34, /*->48059*/
/*48025*/       OPC_CheckPredicate, 6, // Predicate_loadi16
/*48027*/       OPC_MoveParent,
/*48028*/       OPC_RecordChild1, // #2 = $src2
/*48029*/       OPC_MoveChild, 2,
/*48031*/       OPC_CheckInteger, 0, 
/*48033*/       OPC_MoveParent,
/*48034*/       OPC_RecordChild3, // #3 = physreg input EFLAGS
/*48035*/       OPC_CheckType, MVT::i16,
/*48037*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src1 #4 #5 #6 #7 #8
/*48040*/       OPC_EmitMergeInputChains, 1, 0, 
/*48043*/       OPC_EmitCopyToReg, 3, X86::EFLAGS,
/*48046*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::CMOVBE16rm), 0|OPFL_Chain|OPFL_FlagInput|OPFL_MemRefs,
                    1/*#VTs*/, MVT::i16, 6/*#Ops*/, 2, 4, 5, 6, 7, 8, 
                // Src: (X86cmov:i16 (ld:i16 addr:iPTR:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, GR16:i16:$src2, 0:i8, EFLAGS:i32)
                // Dst: (CMOVBE16rm:i16 GR16:i16:$src2, addr:iPTR:$src1)
/*48059*/     /*Scope*/ 34, /*->48094*/
/*48060*/       OPC_CheckPredicate, 3, // Predicate_loadi32
/*48062*/       OPC_MoveParent,
/*48063*/       OPC_RecordChild1, // #2 = $src2
/*48064*/       OPC_MoveChild, 2,
/*48066*/       OPC_CheckInteger, 0, 
/*48068*/       OPC_MoveParent,
/*48069*/       OPC_RecordChild3, // #3 = physreg input EFLAGS
/*48070*/       OPC_CheckType, MVT::i32,
/*48072*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src1 #4 #5 #6 #7 #8
/*48075*/       OPC_EmitMergeInputChains, 1, 0, 
/*48078*/       OPC_EmitCopyToReg, 3, X86::EFLAGS,
/*48081*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::CMOVBE32rm), 0|OPFL_Chain|OPFL_FlagInput|OPFL_MemRefs,
                    1/*#VTs*/, MVT::i32, 6/*#Ops*/, 2, 4, 5, 6, 7, 8, 
                // Src: (X86cmov:i32 (ld:i32 addr:iPTR:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, GR32:i32:$src2, 0:i8, EFLAGS:i32)
                // Dst: (CMOVBE32rm:i32 GR32:i32:$src2, addr:iPTR:$src1)
/*48094*/     /*Scope*/ 34, /*->48129*/
/*48095*/       OPC_CheckPredicate, 6, // Predicate_loadi16
/*48097*/       OPC_MoveParent,
/*48098*/       OPC_RecordChild1, // #2 = $src2
/*48099*/       OPC_MoveChild, 2,
/*48101*/       OPC_CheckInteger, 7, 
/*48103*/       OPC_MoveParent,
/*48104*/       OPC_RecordChild3, // #3 = physreg input EFLAGS
/*48105*/       OPC_CheckType, MVT::i16,
/*48107*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src1 #4 #5 #6 #7 #8
/*48110*/       OPC_EmitMergeInputChains, 1, 0, 
/*48113*/       OPC_EmitCopyToReg, 3, X86::EFLAGS,
/*48116*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::CMOVGE16rm), 0|OPFL_Chain|OPFL_FlagInput|OPFL_MemRefs,
                    1/*#VTs*/, MVT::i16, 6/*#Ops*/, 2, 4, 5, 6, 7, 8, 
                // Src: (X86cmov:i16 (ld:i16 addr:iPTR:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, GR16:i16:$src2, 7:i8, EFLAGS:i32)
                // Dst: (CMOVGE16rm:i16 GR16:i16:$src2, addr:iPTR:$src1)
/*48129*/     /*Scope*/ 34, /*->48164*/
/*48130*/       OPC_CheckPredicate, 3, // Predicate_loadi32
/*48132*/       OPC_MoveParent,
/*48133*/       OPC_RecordChild1, // #2 = $src2
/*48134*/       OPC_MoveChild, 2,
/*48136*/       OPC_CheckInteger, 7, 
/*48138*/       OPC_MoveParent,
/*48139*/       OPC_RecordChild3, // #3 = physreg input EFLAGS
/*48140*/       OPC_CheckType, MVT::i32,
/*48142*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src1 #4 #5 #6 #7 #8
/*48145*/       OPC_EmitMergeInputChains, 1, 0, 
/*48148*/       OPC_EmitCopyToReg, 3, X86::EFLAGS,
/*48151*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::CMOVGE32rm), 0|OPFL_Chain|OPFL_FlagInput|OPFL_MemRefs,
                    1/*#VTs*/, MVT::i32, 6/*#Ops*/, 2, 4, 5, 6, 7, 8, 
                // Src: (X86cmov:i32 (ld:i32 addr:iPTR:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, GR32:i32:$src2, 7:i8, EFLAGS:i32)
                // Dst: (CMOVGE32rm:i32 GR32:i32:$src2, addr:iPTR:$src1)
/*48164*/     /*Scope*/ 34, /*->48199*/
/*48165*/       OPC_CheckPredicate, 6, // Predicate_loadi16
/*48167*/       OPC_MoveParent,
/*48168*/       OPC_RecordChild1, // #2 = $src2
/*48169*/       OPC_MoveChild, 2,
/*48171*/       OPC_CheckInteger, 6, 
/*48173*/       OPC_MoveParent,
/*48174*/       OPC_RecordChild3, // #3 = physreg input EFLAGS
/*48175*/       OPC_CheckType, MVT::i16,
/*48177*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src1 #4 #5 #6 #7 #8
/*48180*/       OPC_EmitMergeInputChains, 1, 0, 
/*48183*/       OPC_EmitCopyToReg, 3, X86::EFLAGS,
/*48186*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::CMOVL16rm), 0|OPFL_Chain|OPFL_FlagInput|OPFL_MemRefs,
                    1/*#VTs*/, MVT::i16, 6/*#Ops*/, 2, 4, 5, 6, 7, 8, 
                // Src: (X86cmov:i16 (ld:i16 addr:iPTR:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, GR16:i16:$src2, 6:i8, EFLAGS:i32)
                // Dst: (CMOVL16rm:i16 GR16:i16:$src2, addr:iPTR:$src1)
/*48199*/     /*Scope*/ 34, /*->48234*/
/*48200*/       OPC_CheckPredicate, 3, // Predicate_loadi32
/*48202*/       OPC_MoveParent,
/*48203*/       OPC_RecordChild1, // #2 = $src2
/*48204*/       OPC_MoveChild, 2,
/*48206*/       OPC_CheckInteger, 6, 
/*48208*/       OPC_MoveParent,
/*48209*/       OPC_RecordChild3, // #3 = physreg input EFLAGS
/*48210*/       OPC_CheckType, MVT::i32,
/*48212*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src1 #4 #5 #6 #7 #8
/*48215*/       OPC_EmitMergeInputChains, 1, 0, 
/*48218*/       OPC_EmitCopyToReg, 3, X86::EFLAGS,
/*48221*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::CMOVL32rm), 0|OPFL_Chain|OPFL_FlagInput|OPFL_MemRefs,
                    1/*#VTs*/, MVT::i32, 6/*#Ops*/, 2, 4, 5, 6, 7, 8, 
                // Src: (X86cmov:i32 (ld:i32 addr:iPTR:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, GR32:i32:$src2, 6:i8, EFLAGS:i32)
                // Dst: (CMOVL32rm:i32 GR32:i32:$src2, addr:iPTR:$src1)
/*48234*/     /*Scope*/ 34, /*->48269*/
/*48235*/       OPC_CheckPredicate, 6, // Predicate_loadi16
/*48237*/       OPC_MoveParent,
/*48238*/       OPC_RecordChild1, // #2 = $src2
/*48239*/       OPC_MoveChild, 2,
/*48241*/       OPC_CheckInteger, 8, 
/*48243*/       OPC_MoveParent,
/*48244*/       OPC_RecordChild3, // #3 = physreg input EFLAGS
/*48245*/       OPC_CheckType, MVT::i16,
/*48247*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src1 #4 #5 #6 #7 #8
/*48250*/       OPC_EmitMergeInputChains, 1, 0, 
/*48253*/       OPC_EmitCopyToReg, 3, X86::EFLAGS,
/*48256*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::CMOVG16rm), 0|OPFL_Chain|OPFL_FlagInput|OPFL_MemRefs,
                    1/*#VTs*/, MVT::i16, 6/*#Ops*/, 2, 4, 5, 6, 7, 8, 
                // Src: (X86cmov:i16 (ld:i16 addr:iPTR:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, GR16:i16:$src2, 8:i8, EFLAGS:i32)
                // Dst: (CMOVG16rm:i16 GR16:i16:$src2, addr:iPTR:$src1)
/*48269*/     /*Scope*/ 34, /*->48304*/
/*48270*/       OPC_CheckPredicate, 3, // Predicate_loadi32
/*48272*/       OPC_MoveParent,
/*48273*/       OPC_RecordChild1, // #2 = $src2
/*48274*/       OPC_MoveChild, 2,
/*48276*/       OPC_CheckInteger, 8, 
/*48278*/       OPC_MoveParent,
/*48279*/       OPC_RecordChild3, // #3 = physreg input EFLAGS
/*48280*/       OPC_CheckType, MVT::i32,
/*48282*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src1 #4 #5 #6 #7 #8
/*48285*/       OPC_EmitMergeInputChains, 1, 0, 
/*48288*/       OPC_EmitCopyToReg, 3, X86::EFLAGS,
/*48291*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::CMOVG32rm), 0|OPFL_Chain|OPFL_FlagInput|OPFL_MemRefs,
                    1/*#VTs*/, MVT::i32, 6/*#Ops*/, 2, 4, 5, 6, 7, 8, 
                // Src: (X86cmov:i32 (ld:i32 addr:iPTR:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, GR32:i32:$src2, 8:i8, EFLAGS:i32)
                // Dst: (CMOVG32rm:i32 GR32:i32:$src2, addr:iPTR:$src1)
/*48304*/     /*Scope*/ 34, /*->48339*/
/*48305*/       OPC_CheckPredicate, 6, // Predicate_loadi16
/*48307*/       OPC_MoveParent,
/*48308*/       OPC_RecordChild1, // #2 = $src2
/*48309*/       OPC_MoveChild, 2,
/*48311*/       OPC_CheckInteger, 5, 
/*48313*/       OPC_MoveParent,
/*48314*/       OPC_RecordChild3, // #3 = physreg input EFLAGS
/*48315*/       OPC_CheckType, MVT::i16,
/*48317*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src1 #4 #5 #6 #7 #8
/*48320*/       OPC_EmitMergeInputChains, 1, 0, 
/*48323*/       OPC_EmitCopyToReg, 3, X86::EFLAGS,
/*48326*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::CMOVLE16rm), 0|OPFL_Chain|OPFL_FlagInput|OPFL_MemRefs,
                    1/*#VTs*/, MVT::i16, 6/*#Ops*/, 2, 4, 5, 6, 7, 8, 
                // Src: (X86cmov:i16 (ld:i16 addr:iPTR:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, GR16:i16:$src2, 5:i8, EFLAGS:i32)
                // Dst: (CMOVLE16rm:i16 GR16:i16:$src2, addr:iPTR:$src1)
/*48339*/     /*Scope*/ 34, /*->48374*/
/*48340*/       OPC_CheckPredicate, 3, // Predicate_loadi32
/*48342*/       OPC_MoveParent,
/*48343*/       OPC_RecordChild1, // #2 = $src2
/*48344*/       OPC_MoveChild, 2,
/*48346*/       OPC_CheckInteger, 5, 
/*48348*/       OPC_MoveParent,
/*48349*/       OPC_RecordChild3, // #3 = physreg input EFLAGS
/*48350*/       OPC_CheckType, MVT::i32,
/*48352*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src1 #4 #5 #6 #7 #8
/*48355*/       OPC_EmitMergeInputChains, 1, 0, 
/*48358*/       OPC_EmitCopyToReg, 3, X86::EFLAGS,
/*48361*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::CMOVLE32rm), 0|OPFL_Chain|OPFL_FlagInput|OPFL_MemRefs,
                    1/*#VTs*/, MVT::i32, 6/*#Ops*/, 2, 4, 5, 6, 7, 8, 
                // Src: (X86cmov:i32 (ld:i32 addr:iPTR:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, GR32:i32:$src2, 5:i8, EFLAGS:i32)
                // Dst: (CMOVLE32rm:i32 GR32:i32:$src2, addr:iPTR:$src1)
/*48374*/     /*Scope*/ 34, /*->48409*/
/*48375*/       OPC_CheckPredicate, 6, // Predicate_loadi16
/*48377*/       OPC_MoveParent,
/*48378*/       OPC_RecordChild1, // #2 = $src2
/*48379*/       OPC_MoveChild, 2,
/*48381*/       OPC_CheckInteger, 14, 
/*48383*/       OPC_MoveParent,
/*48384*/       OPC_RecordChild3, // #3 = physreg input EFLAGS
/*48385*/       OPC_CheckType, MVT::i16,
/*48387*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src1 #4 #5 #6 #7 #8
/*48390*/       OPC_EmitMergeInputChains, 1, 0, 
/*48393*/       OPC_EmitCopyToReg, 3, X86::EFLAGS,
/*48396*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::CMOVNP16rm), 0|OPFL_Chain|OPFL_FlagInput|OPFL_MemRefs,
                    1/*#VTs*/, MVT::i16, 6/*#Ops*/, 2, 4, 5, 6, 7, 8, 
                // Src: (X86cmov:i16 (ld:i16 addr:iPTR:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, GR16:i16:$src2, 14:i8, EFLAGS:i32)
                // Dst: (CMOVNP16rm:i16 GR16:i16:$src2, addr:iPTR:$src1)
/*48409*/     /*Scope*/ 34, /*->48444*/
/*48410*/       OPC_CheckPredicate, 3, // Predicate_loadi32
/*48412*/       OPC_MoveParent,
/*48413*/       OPC_RecordChild1, // #2 = $src2
/*48414*/       OPC_MoveChild, 2,
/*48416*/       OPC_CheckInteger, 14, 
/*48418*/       OPC_MoveParent,
/*48419*/       OPC_RecordChild3, // #3 = physreg input EFLAGS
/*48420*/       OPC_CheckType, MVT::i32,
/*48422*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src1 #4 #5 #6 #7 #8
/*48425*/       OPC_EmitMergeInputChains, 1, 0, 
/*48428*/       OPC_EmitCopyToReg, 3, X86::EFLAGS,
/*48431*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::CMOVNP32rm), 0|OPFL_Chain|OPFL_FlagInput|OPFL_MemRefs,
                    1/*#VTs*/, MVT::i32, 6/*#Ops*/, 2, 4, 5, 6, 7, 8, 
                // Src: (X86cmov:i32 (ld:i32 addr:iPTR:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, GR32:i32:$src2, 14:i8, EFLAGS:i32)
                // Dst: (CMOVNP32rm:i32 GR32:i32:$src2, addr:iPTR:$src1)
/*48444*/     /*Scope*/ 34, /*->48479*/
/*48445*/       OPC_CheckPredicate, 6, // Predicate_loadi16
/*48447*/       OPC_MoveParent,
/*48448*/       OPC_RecordChild1, // #2 = $src2
/*48449*/       OPC_MoveChild, 2,
/*48451*/       OPC_CheckInteger, 11, 
/*48453*/       OPC_MoveParent,
/*48454*/       OPC_RecordChild3, // #3 = physreg input EFLAGS
/*48455*/       OPC_CheckType, MVT::i16,
/*48457*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src1 #4 #5 #6 #7 #8
/*48460*/       OPC_EmitMergeInputChains, 1, 0, 
/*48463*/       OPC_EmitCopyToReg, 3, X86::EFLAGS,
/*48466*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::CMOVP16rm), 0|OPFL_Chain|OPFL_FlagInput|OPFL_MemRefs,
                    1/*#VTs*/, MVT::i16, 6/*#Ops*/, 2, 4, 5, 6, 7, 8, 
                // Src: (X86cmov:i16 (ld:i16 addr:iPTR:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, GR16:i16:$src2, 11:i8, EFLAGS:i32)
                // Dst: (CMOVP16rm:i16 GR16:i16:$src2, addr:iPTR:$src1)
/*48479*/     /*Scope*/ 34, /*->48514*/
/*48480*/       OPC_CheckPredicate, 3, // Predicate_loadi32
/*48482*/       OPC_MoveParent,
/*48483*/       OPC_RecordChild1, // #2 = $src2
/*48484*/       OPC_MoveChild, 2,
/*48486*/       OPC_CheckInteger, 11, 
/*48488*/       OPC_MoveParent,
/*48489*/       OPC_RecordChild3, // #3 = physreg input EFLAGS
/*48490*/       OPC_CheckType, MVT::i32,
/*48492*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src1 #4 #5 #6 #7 #8
/*48495*/       OPC_EmitMergeInputChains, 1, 0, 
/*48498*/       OPC_EmitCopyToReg, 3, X86::EFLAGS,
/*48501*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::CMOVP32rm), 0|OPFL_Chain|OPFL_FlagInput|OPFL_MemRefs,
                    1/*#VTs*/, MVT::i32, 6/*#Ops*/, 2, 4, 5, 6, 7, 8, 
                // Src: (X86cmov:i32 (ld:i32 addr:iPTR:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, GR32:i32:$src2, 11:i8, EFLAGS:i32)
                // Dst: (CMOVP32rm:i32 GR32:i32:$src2, addr:iPTR:$src1)
/*48514*/     /*Scope*/ 34, /*->48549*/
/*48515*/       OPC_CheckPredicate, 6, // Predicate_loadi16
/*48517*/       OPC_MoveParent,
/*48518*/       OPC_RecordChild1, // #2 = $src2
/*48519*/       OPC_MoveChild, 2,
/*48521*/       OPC_CheckInteger, 15, 
/*48523*/       OPC_MoveParent,
/*48524*/       OPC_RecordChild3, // #3 = physreg input EFLAGS
/*48525*/       OPC_CheckType, MVT::i16,
/*48527*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src1 #4 #5 #6 #7 #8
/*48530*/       OPC_EmitMergeInputChains, 1, 0, 
/*48533*/       OPC_EmitCopyToReg, 3, X86::EFLAGS,
/*48536*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::CMOVNS16rm), 0|OPFL_Chain|OPFL_FlagInput|OPFL_MemRefs,
                    1/*#VTs*/, MVT::i16, 6/*#Ops*/, 2, 4, 5, 6, 7, 8, 
                // Src: (X86cmov:i16 (ld:i16 addr:iPTR:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, GR16:i16:$src2, 15:i8, EFLAGS:i32)
                // Dst: (CMOVNS16rm:i16 GR16:i16:$src2, addr:iPTR:$src1)
/*48549*/     /*Scope*/ 34, /*->48584*/
/*48550*/       OPC_CheckPredicate, 3, // Predicate_loadi32
/*48552*/       OPC_MoveParent,
/*48553*/       OPC_RecordChild1, // #2 = $src2
/*48554*/       OPC_MoveChild, 2,
/*48556*/       OPC_CheckInteger, 15, 
/*48558*/       OPC_MoveParent,
/*48559*/       OPC_RecordChild3, // #3 = physreg input EFLAGS
/*48560*/       OPC_CheckType, MVT::i32,
/*48562*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src1 #4 #5 #6 #7 #8
/*48565*/       OPC_EmitMergeInputChains, 1, 0, 
/*48568*/       OPC_EmitCopyToReg, 3, X86::EFLAGS,
/*48571*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::CMOVNS32rm), 0|OPFL_Chain|OPFL_FlagInput|OPFL_MemRefs,
                    1/*#VTs*/, MVT::i32, 6/*#Ops*/, 2, 4, 5, 6, 7, 8, 
                // Src: (X86cmov:i32 (ld:i32 addr:iPTR:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, GR32:i32:$src2, 15:i8, EFLAGS:i32)
                // Dst: (CMOVNS32rm:i32 GR32:i32:$src2, addr:iPTR:$src1)
/*48584*/     /*Scope*/ 34, /*->48619*/
/*48585*/       OPC_CheckPredicate, 6, // Predicate_loadi16
/*48587*/       OPC_MoveParent,
/*48588*/       OPC_RecordChild1, // #2 = $src2
/*48589*/       OPC_MoveChild, 2,
/*48591*/       OPC_CheckInteger, 12, 
/*48593*/       OPC_MoveParent,
/*48594*/       OPC_RecordChild3, // #3 = physreg input EFLAGS
/*48595*/       OPC_CheckType, MVT::i16,
/*48597*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src1 #4 #5 #6 #7 #8
/*48600*/       OPC_EmitMergeInputChains, 1, 0, 
/*48603*/       OPC_EmitCopyToReg, 3, X86::EFLAGS,
/*48606*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::CMOVS16rm), 0|OPFL_Chain|OPFL_FlagInput|OPFL_MemRefs,
                    1/*#VTs*/, MVT::i16, 6/*#Ops*/, 2, 4, 5, 6, 7, 8, 
                // Src: (X86cmov:i16 (ld:i16 addr:iPTR:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, GR16:i16:$src2, 12:i8, EFLAGS:i32)
                // Dst: (CMOVS16rm:i16 GR16:i16:$src2, addr:iPTR:$src1)
/*48619*/     /*Scope*/ 34, /*->48654*/
/*48620*/       OPC_CheckPredicate, 3, // Predicate_loadi32
/*48622*/       OPC_MoveParent,
/*48623*/       OPC_RecordChild1, // #2 = $src2
/*48624*/       OPC_MoveChild, 2,
/*48626*/       OPC_CheckInteger, 12, 
/*48628*/       OPC_MoveParent,
/*48629*/       OPC_RecordChild3, // #3 = physreg input EFLAGS
/*48630*/       OPC_CheckType, MVT::i32,
/*48632*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src1 #4 #5 #6 #7 #8
/*48635*/       OPC_EmitMergeInputChains, 1, 0, 
/*48638*/       OPC_EmitCopyToReg, 3, X86::EFLAGS,
/*48641*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::CMOVS32rm), 0|OPFL_Chain|OPFL_FlagInput|OPFL_MemRefs,
                    1/*#VTs*/, MVT::i32, 6/*#Ops*/, 2, 4, 5, 6, 7, 8, 
                // Src: (X86cmov:i32 (ld:i32 addr:iPTR:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, GR32:i32:$src2, 12:i8, EFLAGS:i32)
                // Dst: (CMOVS32rm:i32 GR32:i32:$src2, addr:iPTR:$src1)
/*48654*/     /*Scope*/ 34, /*->48689*/
/*48655*/       OPC_CheckPredicate, 6, // Predicate_loadi16
/*48657*/       OPC_MoveParent,
/*48658*/       OPC_RecordChild1, // #2 = $src2
/*48659*/       OPC_MoveChild, 2,
/*48661*/       OPC_CheckInteger, 13, 
/*48663*/       OPC_MoveParent,
/*48664*/       OPC_RecordChild3, // #3 = physreg input EFLAGS
/*48665*/       OPC_CheckType, MVT::i16,
/*48667*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src1 #4 #5 #6 #7 #8
/*48670*/       OPC_EmitMergeInputChains, 1, 0, 
/*48673*/       OPC_EmitCopyToReg, 3, X86::EFLAGS,
/*48676*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::CMOVNO16rm), 0|OPFL_Chain|OPFL_FlagInput|OPFL_MemRefs,
                    1/*#VTs*/, MVT::i16, 6/*#Ops*/, 2, 4, 5, 6, 7, 8, 
                // Src: (X86cmov:i16 (ld:i16 addr:iPTR:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, GR16:i16:$src2, 13:i8, EFLAGS:i32)
                // Dst: (CMOVNO16rm:i16 GR16:i16:$src2, addr:iPTR:$src1)
/*48689*/     /*Scope*/ 34, /*->48724*/
/*48690*/       OPC_CheckPredicate, 3, // Predicate_loadi32
/*48692*/       OPC_MoveParent,
/*48693*/       OPC_RecordChild1, // #2 = $src2
/*48694*/       OPC_MoveChild, 2,
/*48696*/       OPC_CheckInteger, 13, 
/*48698*/       OPC_MoveParent,
/*48699*/       OPC_RecordChild3, // #3 = physreg input EFLAGS
/*48700*/       OPC_CheckType, MVT::i32,
/*48702*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src1 #4 #5 #6 #7 #8
/*48705*/       OPC_EmitMergeInputChains, 1, 0, 
/*48708*/       OPC_EmitCopyToReg, 3, X86::EFLAGS,
/*48711*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::CMOVNO32rm), 0|OPFL_Chain|OPFL_FlagInput|OPFL_MemRefs,
                    1/*#VTs*/, MVT::i32, 6/*#Ops*/, 2, 4, 5, 6, 7, 8, 
                // Src: (X86cmov:i32 (ld:i32 addr:iPTR:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, GR32:i32:$src2, 13:i8, EFLAGS:i32)
                // Dst: (CMOVNO32rm:i32 GR32:i32:$src2, addr:iPTR:$src1)
/*48724*/     /*Scope*/ 34, /*->48759*/
/*48725*/       OPC_CheckPredicate, 6, // Predicate_loadi16
/*48727*/       OPC_MoveParent,
/*48728*/       OPC_RecordChild1, // #2 = $src2
/*48729*/       OPC_MoveChild, 2,
/*48731*/       OPC_CheckInteger, 10, 
/*48733*/       OPC_MoveParent,
/*48734*/       OPC_RecordChild3, // #3 = physreg input EFLAGS
/*48735*/       OPC_CheckType, MVT::i16,
/*48737*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src1 #4 #5 #6 #7 #8
/*48740*/       OPC_EmitMergeInputChains, 1, 0, 
/*48743*/       OPC_EmitCopyToReg, 3, X86::EFLAGS,
/*48746*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::CMOVO16rm), 0|OPFL_Chain|OPFL_FlagInput|OPFL_MemRefs,
                    1/*#VTs*/, MVT::i16, 6/*#Ops*/, 2, 4, 5, 6, 7, 8, 
                // Src: (X86cmov:i16 (ld:i16 addr:iPTR:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, GR16:i16:$src2, 10:i8, EFLAGS:i32)
                // Dst: (CMOVO16rm:i16 GR16:i16:$src2, addr:iPTR:$src1)
/*48759*/     /*Scope*/ 34, /*->48794*/
/*48760*/       OPC_CheckPredicate, 3, // Predicate_loadi32
/*48762*/       OPC_MoveParent,
/*48763*/       OPC_RecordChild1, // #2 = $src2
/*48764*/       OPC_MoveChild, 2,
/*48766*/       OPC_CheckInteger, 10, 
/*48768*/       OPC_MoveParent,
/*48769*/       OPC_RecordChild3, // #3 = physreg input EFLAGS
/*48770*/       OPC_CheckType, MVT::i32,
/*48772*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src1 #4 #5 #6 #7 #8
/*48775*/       OPC_EmitMergeInputChains, 1, 0, 
/*48778*/       OPC_EmitCopyToReg, 3, X86::EFLAGS,
/*48781*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::CMOVO32rm), 0|OPFL_Chain|OPFL_FlagInput|OPFL_MemRefs,
                    1/*#VTs*/, MVT::i32, 6/*#Ops*/, 2, 4, 5, 6, 7, 8, 
                // Src: (X86cmov:i32 (ld:i32 addr:iPTR:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, GR32:i32:$src2, 10:i8, EFLAGS:i32)
                // Dst: (CMOVO32rm:i32 GR32:i32:$src2, addr:iPTR:$src1)
/*48794*/     0, /*End of Scope*/
/*48795*/   /*Scope*/ 100|128,3/*484*/, /*->49281*/
/*48797*/     OPC_RecordChild0, // #0 = $src1
/*48798*/     OPC_MoveChild, 1,
/*48800*/     OPC_CheckOpcode, ISD::LOAD,
/*48802*/     OPC_RecordMemRef,
/*48803*/     OPC_RecordNode, // #1 = 'ld' chained node
/*48804*/     OPC_CheckFoldableChainNode,
/*48805*/     OPC_RecordChild1, // #2 = $src2
/*48806*/     OPC_CheckPredicate, 2, // Predicate_unindexedload
/*48808*/     OPC_CheckPredicate, 8, // Predicate_load
/*48810*/     OPC_CheckPredicate, 9, // Predicate_dsload
/*48812*/     OPC_MoveParent,
/*48813*/     OPC_MoveChild, 2,
/*48815*/     OPC_Scope, 28, /*->48845*/ // 16 children in Scope
/*48817*/       OPC_CheckInteger, 2, 
/*48819*/       OPC_MoveParent,
/*48820*/       OPC_RecordChild3, // #3 = physreg input EFLAGS
/*48821*/       OPC_CheckType, MVT::i64,
/*48823*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #4 #5 #6 #7 #8
/*48826*/       OPC_EmitMergeInputChains, 1, 1, 
/*48829*/       OPC_EmitCopyToReg, 3, X86::EFLAGS,
/*48832*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::CMOVB64rm), 0|OPFL_Chain|OPFL_FlagInput|OPFL_MemRefs,
                    1/*#VTs*/, MVT::i64, 6/*#Ops*/, 0, 4, 5, 6, 7, 8, 
                // Src: (X86cmov:i64 GR64:i64:$src1, (ld:i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>, 2:i8, EFLAGS:i32)
                // Dst: (CMOVB64rm:i64 GR64:i64:$src1, addr:iPTR:$src2)
/*48845*/     /*Scope*/ 28, /*->48874*/
/*48846*/       OPC_CheckInteger, 1, 
/*48848*/       OPC_MoveParent,
/*48849*/       OPC_RecordChild3, // #3 = physreg input EFLAGS
/*48850*/       OPC_CheckType, MVT::i64,
/*48852*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #4 #5 #6 #7 #8
/*48855*/       OPC_EmitMergeInputChains, 1, 1, 
/*48858*/       OPC_EmitCopyToReg, 3, X86::EFLAGS,
/*48861*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::CMOVAE64rm), 0|OPFL_Chain|OPFL_FlagInput|OPFL_MemRefs,
                    1/*#VTs*/, MVT::i64, 6/*#Ops*/, 0, 4, 5, 6, 7, 8, 
                // Src: (X86cmov:i64 GR64:i64:$src1, (ld:i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>, 1:i8, EFLAGS:i32)
                // Dst: (CMOVAE64rm:i64 GR64:i64:$src1, addr:iPTR:$src2)
/*48874*/     /*Scope*/ 28, /*->48903*/
/*48875*/       OPC_CheckInteger, 4, 
/*48877*/       OPC_MoveParent,
/*48878*/       OPC_RecordChild3, // #3 = physreg input EFLAGS
/*48879*/       OPC_CheckType, MVT::i64,
/*48881*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #4 #5 #6 #7 #8
/*48884*/       OPC_EmitMergeInputChains, 1, 1, 
/*48887*/       OPC_EmitCopyToReg, 3, X86::EFLAGS,
/*48890*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::CMOVE64rm), 0|OPFL_Chain|OPFL_FlagInput|OPFL_MemRefs,
                    1/*#VTs*/, MVT::i64, 6/*#Ops*/, 0, 4, 5, 6, 7, 8, 
                // Src: (X86cmov:i64 GR64:i64:$src1, (ld:i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>, 4:i8, EFLAGS:i32)
                // Dst: (CMOVE64rm:i64 GR64:i64:$src1, addr:iPTR:$src2)
/*48903*/     /*Scope*/ 28, /*->48932*/
/*48904*/       OPC_CheckInteger, 9, 
/*48906*/       OPC_MoveParent,
/*48907*/       OPC_RecordChild3, // #3 = physreg input EFLAGS
/*48908*/       OPC_CheckType, MVT::i64,
/*48910*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #4 #5 #6 #7 #8
/*48913*/       OPC_EmitMergeInputChains, 1, 1, 
/*48916*/       OPC_EmitCopyToReg, 3, X86::EFLAGS,
/*48919*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::CMOVNE64rm), 0|OPFL_Chain|OPFL_FlagInput|OPFL_MemRefs,
                    1/*#VTs*/, MVT::i64, 6/*#Ops*/, 0, 4, 5, 6, 7, 8, 
                // Src: (X86cmov:i64 GR64:i64:$src1, (ld:i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>, 9:i8, EFLAGS:i32)
                // Dst: (CMOVNE64rm:i64 GR64:i64:$src1, addr:iPTR:$src2)
/*48932*/     /*Scope*/ 28, /*->48961*/
/*48933*/       OPC_CheckInteger, 3, 
/*48935*/       OPC_MoveParent,
/*48936*/       OPC_RecordChild3, // #3 = physreg input EFLAGS
/*48937*/       OPC_CheckType, MVT::i64,
/*48939*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #4 #5 #6 #7 #8
/*48942*/       OPC_EmitMergeInputChains, 1, 1, 
/*48945*/       OPC_EmitCopyToReg, 3, X86::EFLAGS,
/*48948*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::CMOVBE64rm), 0|OPFL_Chain|OPFL_FlagInput|OPFL_MemRefs,
                    1/*#VTs*/, MVT::i64, 6/*#Ops*/, 0, 4, 5, 6, 7, 8, 
                // Src: (X86cmov:i64 GR64:i64:$src1, (ld:i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>, 3:i8, EFLAGS:i32)
                // Dst: (CMOVBE64rm:i64 GR64:i64:$src1, addr:iPTR:$src2)
/*48961*/     /*Scope*/ 28, /*->48990*/
/*48962*/       OPC_CheckInteger, 0, 
/*48964*/       OPC_MoveParent,
/*48965*/       OPC_RecordChild3, // #3 = physreg input EFLAGS
/*48966*/       OPC_CheckType, MVT::i64,
/*48968*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #4 #5 #6 #7 #8
/*48971*/       OPC_EmitMergeInputChains, 1, 1, 
/*48974*/       OPC_EmitCopyToReg, 3, X86::EFLAGS,
/*48977*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::CMOVA64rm), 0|OPFL_Chain|OPFL_FlagInput|OPFL_MemRefs,
                    1/*#VTs*/, MVT::i64, 6/*#Ops*/, 0, 4, 5, 6, 7, 8, 
                // Src: (X86cmov:i64 GR64:i64:$src1, (ld:i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>, 0:i8, EFLAGS:i32)
                // Dst: (CMOVA64rm:i64 GR64:i64:$src1, addr:iPTR:$src2)
/*48990*/     /*Scope*/ 28, /*->49019*/
/*48991*/       OPC_CheckInteger, 7, 
/*48993*/       OPC_MoveParent,
/*48994*/       OPC_RecordChild3, // #3 = physreg input EFLAGS
/*48995*/       OPC_CheckType, MVT::i64,
/*48997*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #4 #5 #6 #7 #8
/*49000*/       OPC_EmitMergeInputChains, 1, 1, 
/*49003*/       OPC_EmitCopyToReg, 3, X86::EFLAGS,
/*49006*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::CMOVL64rm), 0|OPFL_Chain|OPFL_FlagInput|OPFL_MemRefs,
                    1/*#VTs*/, MVT::i64, 6/*#Ops*/, 0, 4, 5, 6, 7, 8, 
                // Src: (X86cmov:i64 GR64:i64:$src1, (ld:i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>, 7:i8, EFLAGS:i32)
                // Dst: (CMOVL64rm:i64 GR64:i64:$src1, addr:iPTR:$src2)
/*49019*/     /*Scope*/ 28, /*->49048*/
/*49020*/       OPC_CheckInteger, 6, 
/*49022*/       OPC_MoveParent,
/*49023*/       OPC_RecordChild3, // #3 = physreg input EFLAGS
/*49024*/       OPC_CheckType, MVT::i64,
/*49026*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #4 #5 #6 #7 #8
/*49029*/       OPC_EmitMergeInputChains, 1, 1, 
/*49032*/       OPC_EmitCopyToReg, 3, X86::EFLAGS,
/*49035*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::CMOVGE64rm), 0|OPFL_Chain|OPFL_FlagInput|OPFL_MemRefs,
                    1/*#VTs*/, MVT::i64, 6/*#Ops*/, 0, 4, 5, 6, 7, 8, 
                // Src: (X86cmov:i64 GR64:i64:$src1, (ld:i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>, 6:i8, EFLAGS:i32)
                // Dst: (CMOVGE64rm:i64 GR64:i64:$src1, addr:iPTR:$src2)
/*49048*/     /*Scope*/ 28, /*->49077*/
/*49049*/       OPC_CheckInteger, 8, 
/*49051*/       OPC_MoveParent,
/*49052*/       OPC_RecordChild3, // #3 = physreg input EFLAGS
/*49053*/       OPC_CheckType, MVT::i64,
/*49055*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #4 #5 #6 #7 #8
/*49058*/       OPC_EmitMergeInputChains, 1, 1, 
/*49061*/       OPC_EmitCopyToReg, 3, X86::EFLAGS,
/*49064*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::CMOVLE64rm), 0|OPFL_Chain|OPFL_FlagInput|OPFL_MemRefs,
                    1/*#VTs*/, MVT::i64, 6/*#Ops*/, 0, 4, 5, 6, 7, 8, 
                // Src: (X86cmov:i64 GR64:i64:$src1, (ld:i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>, 8:i8, EFLAGS:i32)
                // Dst: (CMOVLE64rm:i64 GR64:i64:$src1, addr:iPTR:$src2)
/*49077*/     /*Scope*/ 28, /*->49106*/
/*49078*/       OPC_CheckInteger, 5, 
/*49080*/       OPC_MoveParent,
/*49081*/       OPC_RecordChild3, // #3 = physreg input EFLAGS
/*49082*/       OPC_CheckType, MVT::i64,
/*49084*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #4 #5 #6 #7 #8
/*49087*/       OPC_EmitMergeInputChains, 1, 1, 
/*49090*/       OPC_EmitCopyToReg, 3, X86::EFLAGS,
/*49093*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::CMOVG64rm), 0|OPFL_Chain|OPFL_FlagInput|OPFL_MemRefs,
                    1/*#VTs*/, MVT::i64, 6/*#Ops*/, 0, 4, 5, 6, 7, 8, 
                // Src: (X86cmov:i64 GR64:i64:$src1, (ld:i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>, 5:i8, EFLAGS:i32)
                // Dst: (CMOVG64rm:i64 GR64:i64:$src1, addr:iPTR:$src2)
/*49106*/     /*Scope*/ 28, /*->49135*/
/*49107*/       OPC_CheckInteger, 15, 
/*49109*/       OPC_MoveParent,
/*49110*/       OPC_RecordChild3, // #3 = physreg input EFLAGS
/*49111*/       OPC_CheckType, MVT::i64,
/*49113*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #4 #5 #6 #7 #8
/*49116*/       OPC_EmitMergeInputChains, 1, 1, 
/*49119*/       OPC_EmitCopyToReg, 3, X86::EFLAGS,
/*49122*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::CMOVS64rm), 0|OPFL_Chain|OPFL_FlagInput|OPFL_MemRefs,
                    1/*#VTs*/, MVT::i64, 6/*#Ops*/, 0, 4, 5, 6, 7, 8, 
                // Src: (X86cmov:i64 GR64:i64:$src1, (ld:i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>, 15:i8, EFLAGS:i32)
                // Dst: (CMOVS64rm:i64 GR64:i64:$src1, addr:iPTR:$src2)
/*49135*/     /*Scope*/ 28, /*->49164*/
/*49136*/       OPC_CheckInteger, 12, 
/*49138*/       OPC_MoveParent,
/*49139*/       OPC_RecordChild3, // #3 = physreg input EFLAGS
/*49140*/       OPC_CheckType, MVT::i64,
/*49142*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #4 #5 #6 #7 #8
/*49145*/       OPC_EmitMergeInputChains, 1, 1, 
/*49148*/       OPC_EmitCopyToReg, 3, X86::EFLAGS,
/*49151*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::CMOVNS64rm), 0|OPFL_Chain|OPFL_FlagInput|OPFL_MemRefs,
                    1/*#VTs*/, MVT::i64, 6/*#Ops*/, 0, 4, 5, 6, 7, 8, 
                // Src: (X86cmov:i64 GR64:i64:$src1, (ld:i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>, 12:i8, EFLAGS:i32)
                // Dst: (CMOVNS64rm:i64 GR64:i64:$src1, addr:iPTR:$src2)
/*49164*/     /*Scope*/ 28, /*->49193*/
/*49165*/       OPC_CheckInteger, 14, 
/*49167*/       OPC_MoveParent,
/*49168*/       OPC_RecordChild3, // #3 = physreg input EFLAGS
/*49169*/       OPC_CheckType, MVT::i64,
/*49171*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #4 #5 #6 #7 #8
/*49174*/       OPC_EmitMergeInputChains, 1, 1, 
/*49177*/       OPC_EmitCopyToReg, 3, X86::EFLAGS,
/*49180*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::CMOVP64rm), 0|OPFL_Chain|OPFL_FlagInput|OPFL_MemRefs,
                    1/*#VTs*/, MVT::i64, 6/*#Ops*/, 0, 4, 5, 6, 7, 8, 
                // Src: (X86cmov:i64 GR64:i64:$src1, (ld:i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>, 14:i8, EFLAGS:i32)
                // Dst: (CMOVP64rm:i64 GR64:i64:$src1, addr:iPTR:$src2)
/*49193*/     /*Scope*/ 28, /*->49222*/
/*49194*/       OPC_CheckInteger, 11, 
/*49196*/       OPC_MoveParent,
/*49197*/       OPC_RecordChild3, // #3 = physreg input EFLAGS
/*49198*/       OPC_CheckType, MVT::i64,
/*49200*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #4 #5 #6 #7 #8
/*49203*/       OPC_EmitMergeInputChains, 1, 1, 
/*49206*/       OPC_EmitCopyToReg, 3, X86::EFLAGS,
/*49209*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::CMOVNP64rm), 0|OPFL_Chain|OPFL_FlagInput|OPFL_MemRefs,
                    1/*#VTs*/, MVT::i64, 6/*#Ops*/, 0, 4, 5, 6, 7, 8, 
                // Src: (X86cmov:i64 GR64:i64:$src1, (ld:i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>, 11:i8, EFLAGS:i32)
                // Dst: (CMOVNP64rm:i64 GR64:i64:$src1, addr:iPTR:$src2)
/*49222*/     /*Scope*/ 28, /*->49251*/
/*49223*/       OPC_CheckInteger, 13, 
/*49225*/       OPC_MoveParent,
/*49226*/       OPC_RecordChild3, // #3 = physreg input EFLAGS
/*49227*/       OPC_CheckType, MVT::i64,
/*49229*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #4 #5 #6 #7 #8
/*49232*/       OPC_EmitMergeInputChains, 1, 1, 
/*49235*/       OPC_EmitCopyToReg, 3, X86::EFLAGS,
/*49238*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::CMOVO64rm), 0|OPFL_Chain|OPFL_FlagInput|OPFL_MemRefs,
                    1/*#VTs*/, MVT::i64, 6/*#Ops*/, 0, 4, 5, 6, 7, 8, 
                // Src: (X86cmov:i64 GR64:i64:$src1, (ld:i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>, 13:i8, EFLAGS:i32)
                // Dst: (CMOVO64rm:i64 GR64:i64:$src1, addr:iPTR:$src2)
/*49251*/     /*Scope*/ 28, /*->49280*/
/*49252*/       OPC_CheckInteger, 10, 
/*49254*/       OPC_MoveParent,
/*49255*/       OPC_RecordChild3, // #3 = physreg input EFLAGS
/*49256*/       OPC_CheckType, MVT::i64,
/*49258*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #4 #5 #6 #7 #8
/*49261*/       OPC_EmitMergeInputChains, 1, 1, 
/*49264*/       OPC_EmitCopyToReg, 3, X86::EFLAGS,
/*49267*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::CMOVNO64rm), 0|OPFL_Chain|OPFL_FlagInput|OPFL_MemRefs,
                    1/*#VTs*/, MVT::i64, 6/*#Ops*/, 0, 4, 5, 6, 7, 8, 
                // Src: (X86cmov:i64 GR64:i64:$src1, (ld:i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>, 10:i8, EFLAGS:i32)
                // Dst: (CMOVNO64rm:i64 GR64:i64:$src1, addr:iPTR:$src2)
/*49280*/     0, /*End of Scope*/
/*49281*/   /*Scope*/ 100|128,3/*484*/, /*->49767*/
/*49283*/     OPC_MoveChild, 0,
/*49285*/     OPC_CheckOpcode, ISD::LOAD,
/*49287*/     OPC_RecordMemRef,
/*49288*/     OPC_RecordNode, // #0 = 'ld' chained node
/*49289*/     OPC_CheckFoldableChainNode,
/*49290*/     OPC_RecordChild1, // #1 = $src1
/*49291*/     OPC_CheckPredicate, 2, // Predicate_unindexedload
/*49293*/     OPC_CheckPredicate, 8, // Predicate_load
/*49295*/     OPC_CheckPredicate, 9, // Predicate_dsload
/*49297*/     OPC_MoveParent,
/*49298*/     OPC_RecordChild1, // #2 = $src2
/*49299*/     OPC_MoveChild, 2,
/*49301*/     OPC_Scope, 28, /*->49331*/ // 16 children in Scope
/*49303*/       OPC_CheckInteger, 2, 
/*49305*/       OPC_MoveParent,
/*49306*/       OPC_RecordChild3, // #3 = physreg input EFLAGS
/*49307*/       OPC_CheckType, MVT::i64,
/*49309*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src1 #4 #5 #6 #7 #8
/*49312*/       OPC_EmitMergeInputChains, 1, 0, 
/*49315*/       OPC_EmitCopyToReg, 3, X86::EFLAGS,
/*49318*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::CMOVAE64rm), 0|OPFL_Chain|OPFL_FlagInput|OPFL_MemRefs,
                    1/*#VTs*/, MVT::i64, 6/*#Ops*/, 2, 4, 5, 6, 7, 8, 
                // Src: (X86cmov:i64 (ld:i64 addr:iPTR:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>, GR64:i64:$src2, 2:i8, EFLAGS:i32)
                // Dst: (CMOVAE64rm:i64 GR64:i64:$src2, addr:iPTR:$src1)
/*49331*/     /*Scope*/ 28, /*->49360*/
/*49332*/       OPC_CheckInteger, 1, 
/*49334*/       OPC_MoveParent,
/*49335*/       OPC_RecordChild3, // #3 = physreg input EFLAGS
/*49336*/       OPC_CheckType, MVT::i64,
/*49338*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src1 #4 #5 #6 #7 #8
/*49341*/       OPC_EmitMergeInputChains, 1, 0, 
/*49344*/       OPC_EmitCopyToReg, 3, X86::EFLAGS,
/*49347*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::CMOVB64rm), 0|OPFL_Chain|OPFL_FlagInput|OPFL_MemRefs,
                    1/*#VTs*/, MVT::i64, 6/*#Ops*/, 2, 4, 5, 6, 7, 8, 
                // Src: (X86cmov:i64 (ld:i64 addr:iPTR:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>, GR64:i64:$src2, 1:i8, EFLAGS:i32)
                // Dst: (CMOVB64rm:i64 GR64:i64:$src2, addr:iPTR:$src1)
/*49360*/     /*Scope*/ 28, /*->49389*/
/*49361*/       OPC_CheckInteger, 4, 
/*49363*/       OPC_MoveParent,
/*49364*/       OPC_RecordChild3, // #3 = physreg input EFLAGS
/*49365*/       OPC_CheckType, MVT::i64,
/*49367*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src1 #4 #5 #6 #7 #8
/*49370*/       OPC_EmitMergeInputChains, 1, 0, 
/*49373*/       OPC_EmitCopyToReg, 3, X86::EFLAGS,
/*49376*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::CMOVNE64rm), 0|OPFL_Chain|OPFL_FlagInput|OPFL_MemRefs,
                    1/*#VTs*/, MVT::i64, 6/*#Ops*/, 2, 4, 5, 6, 7, 8, 
                // Src: (X86cmov:i64 (ld:i64 addr:iPTR:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>, GR64:i64:$src2, 4:i8, EFLAGS:i32)
                // Dst: (CMOVNE64rm:i64 GR64:i64:$src2, addr:iPTR:$src1)
/*49389*/     /*Scope*/ 28, /*->49418*/
/*49390*/       OPC_CheckInteger, 9, 
/*49392*/       OPC_MoveParent,
/*49393*/       OPC_RecordChild3, // #3 = physreg input EFLAGS
/*49394*/       OPC_CheckType, MVT::i64,
/*49396*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src1 #4 #5 #6 #7 #8
/*49399*/       OPC_EmitMergeInputChains, 1, 0, 
/*49402*/       OPC_EmitCopyToReg, 3, X86::EFLAGS,
/*49405*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::CMOVE64rm), 0|OPFL_Chain|OPFL_FlagInput|OPFL_MemRefs,
                    1/*#VTs*/, MVT::i64, 6/*#Ops*/, 2, 4, 5, 6, 7, 8, 
                // Src: (X86cmov:i64 (ld:i64 addr:iPTR:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>, GR64:i64:$src2, 9:i8, EFLAGS:i32)
                // Dst: (CMOVE64rm:i64 GR64:i64:$src2, addr:iPTR:$src1)
/*49418*/     /*Scope*/ 28, /*->49447*/
/*49419*/       OPC_CheckInteger, 3, 
/*49421*/       OPC_MoveParent,
/*49422*/       OPC_RecordChild3, // #3 = physreg input EFLAGS
/*49423*/       OPC_CheckType, MVT::i64,
/*49425*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src1 #4 #5 #6 #7 #8
/*49428*/       OPC_EmitMergeInputChains, 1, 0, 
/*49431*/       OPC_EmitCopyToReg, 3, X86::EFLAGS,
/*49434*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::CMOVA64rm), 0|OPFL_Chain|OPFL_FlagInput|OPFL_MemRefs,
                    1/*#VTs*/, MVT::i64, 6/*#Ops*/, 2, 4, 5, 6, 7, 8, 
                // Src: (X86cmov:i64 (ld:i64 addr:iPTR:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>, GR64:i64:$src2, 3:i8, EFLAGS:i32)
                // Dst: (CMOVA64rm:i64 GR64:i64:$src2, addr:iPTR:$src1)
/*49447*/     /*Scope*/ 28, /*->49476*/
/*49448*/       OPC_CheckInteger, 0, 
/*49450*/       OPC_MoveParent,
/*49451*/       OPC_RecordChild3, // #3 = physreg input EFLAGS
/*49452*/       OPC_CheckType, MVT::i64,
/*49454*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src1 #4 #5 #6 #7 #8
/*49457*/       OPC_EmitMergeInputChains, 1, 0, 
/*49460*/       OPC_EmitCopyToReg, 3, X86::EFLAGS,
/*49463*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::CMOVBE64rm), 0|OPFL_Chain|OPFL_FlagInput|OPFL_MemRefs,
                    1/*#VTs*/, MVT::i64, 6/*#Ops*/, 2, 4, 5, 6, 7, 8, 
                // Src: (X86cmov:i64 (ld:i64 addr:iPTR:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>, GR64:i64:$src2, 0:i8, EFLAGS:i32)
                // Dst: (CMOVBE64rm:i64 GR64:i64:$src2, addr:iPTR:$src1)
/*49476*/     /*Scope*/ 28, /*->49505*/
/*49477*/       OPC_CheckInteger, 7, 
/*49479*/       OPC_MoveParent,
/*49480*/       OPC_RecordChild3, // #3 = physreg input EFLAGS
/*49481*/       OPC_CheckType, MVT::i64,
/*49483*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src1 #4 #5 #6 #7 #8
/*49486*/       OPC_EmitMergeInputChains, 1, 0, 
/*49489*/       OPC_EmitCopyToReg, 3, X86::EFLAGS,
/*49492*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::CMOVGE64rm), 0|OPFL_Chain|OPFL_FlagInput|OPFL_MemRefs,
                    1/*#VTs*/, MVT::i64, 6/*#Ops*/, 2, 4, 5, 6, 7, 8, 
                // Src: (X86cmov:i64 (ld:i64 addr:iPTR:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>, GR64:i64:$src2, 7:i8, EFLAGS:i32)
                // Dst: (CMOVGE64rm:i64 GR64:i64:$src2, addr:iPTR:$src1)
/*49505*/     /*Scope*/ 28, /*->49534*/
/*49506*/       OPC_CheckInteger, 6, 
/*49508*/       OPC_MoveParent,
/*49509*/       OPC_RecordChild3, // #3 = physreg input EFLAGS
/*49510*/       OPC_CheckType, MVT::i64,
/*49512*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src1 #4 #5 #6 #7 #8
/*49515*/       OPC_EmitMergeInputChains, 1, 0, 
/*49518*/       OPC_EmitCopyToReg, 3, X86::EFLAGS,
/*49521*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::CMOVL64rm), 0|OPFL_Chain|OPFL_FlagInput|OPFL_MemRefs,
                    1/*#VTs*/, MVT::i64, 6/*#Ops*/, 2, 4, 5, 6, 7, 8, 
                // Src: (X86cmov:i64 (ld:i64 addr:iPTR:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>, GR64:i64:$src2, 6:i8, EFLAGS:i32)
                // Dst: (CMOVL64rm:i64 GR64:i64:$src2, addr:iPTR:$src1)
/*49534*/     /*Scope*/ 28, /*->49563*/
/*49535*/       OPC_CheckInteger, 8, 
/*49537*/       OPC_MoveParent,
/*49538*/       OPC_RecordChild3, // #3 = physreg input EFLAGS
/*49539*/       OPC_CheckType, MVT::i64,
/*49541*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src1 #4 #5 #6 #7 #8
/*49544*/       OPC_EmitMergeInputChains, 1, 0, 
/*49547*/       OPC_EmitCopyToReg, 3, X86::EFLAGS,
/*49550*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::CMOVG64rm), 0|OPFL_Chain|OPFL_FlagInput|OPFL_MemRefs,
                    1/*#VTs*/, MVT::i64, 6/*#Ops*/, 2, 4, 5, 6, 7, 8, 
                // Src: (X86cmov:i64 (ld:i64 addr:iPTR:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>, GR64:i64:$src2, 8:i8, EFLAGS:i32)
                // Dst: (CMOVG64rm:i64 GR64:i64:$src2, addr:iPTR:$src1)
/*49563*/     /*Scope*/ 28, /*->49592*/
/*49564*/       OPC_CheckInteger, 5, 
/*49566*/       OPC_MoveParent,
/*49567*/       OPC_RecordChild3, // #3 = physreg input EFLAGS
/*49568*/       OPC_CheckType, MVT::i64,
/*49570*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src1 #4 #5 #6 #7 #8
/*49573*/       OPC_EmitMergeInputChains, 1, 0, 
/*49576*/       OPC_EmitCopyToReg, 3, X86::EFLAGS,
/*49579*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::CMOVLE64rm), 0|OPFL_Chain|OPFL_FlagInput|OPFL_MemRefs,
                    1/*#VTs*/, MVT::i64, 6/*#Ops*/, 2, 4, 5, 6, 7, 8, 
                // Src: (X86cmov:i64 (ld:i64 addr:iPTR:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>, GR64:i64:$src2, 5:i8, EFLAGS:i32)
                // Dst: (CMOVLE64rm:i64 GR64:i64:$src2, addr:iPTR:$src1)
/*49592*/     /*Scope*/ 28, /*->49621*/
/*49593*/       OPC_CheckInteger, 14, 
/*49595*/       OPC_MoveParent,
/*49596*/       OPC_RecordChild3, // #3 = physreg input EFLAGS
/*49597*/       OPC_CheckType, MVT::i64,
/*49599*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src1 #4 #5 #6 #7 #8
/*49602*/       OPC_EmitMergeInputChains, 1, 0, 
/*49605*/       OPC_EmitCopyToReg, 3, X86::EFLAGS,
/*49608*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::CMOVNP64rm), 0|OPFL_Chain|OPFL_FlagInput|OPFL_MemRefs,
                    1/*#VTs*/, MVT::i64, 6/*#Ops*/, 2, 4, 5, 6, 7, 8, 
                // Src: (X86cmov:i64 (ld:i64 addr:iPTR:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>, GR64:i64:$src2, 14:i8, EFLAGS:i32)
                // Dst: (CMOVNP64rm:i64 GR64:i64:$src2, addr:iPTR:$src1)
/*49621*/     /*Scope*/ 28, /*->49650*/
/*49622*/       OPC_CheckInteger, 11, 
/*49624*/       OPC_MoveParent,
/*49625*/       OPC_RecordChild3, // #3 = physreg input EFLAGS
/*49626*/       OPC_CheckType, MVT::i64,
/*49628*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src1 #4 #5 #6 #7 #8
/*49631*/       OPC_EmitMergeInputChains, 1, 0, 
/*49634*/       OPC_EmitCopyToReg, 3, X86::EFLAGS,
/*49637*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::CMOVP64rm), 0|OPFL_Chain|OPFL_FlagInput|OPFL_MemRefs,
                    1/*#VTs*/, MVT::i64, 6/*#Ops*/, 2, 4, 5, 6, 7, 8, 
                // Src: (X86cmov:i64 (ld:i64 addr:iPTR:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>, GR64:i64:$src2, 11:i8, EFLAGS:i32)
                // Dst: (CMOVP64rm:i64 GR64:i64:$src2, addr:iPTR:$src1)
/*49650*/     /*Scope*/ 28, /*->49679*/
/*49651*/       OPC_CheckInteger, 15, 
/*49653*/       OPC_MoveParent,
/*49654*/       OPC_RecordChild3, // #3 = physreg input EFLAGS
/*49655*/       OPC_CheckType, MVT::i64,
/*49657*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src1 #4 #5 #6 #7 #8
/*49660*/       OPC_EmitMergeInputChains, 1, 0, 
/*49663*/       OPC_EmitCopyToReg, 3, X86::EFLAGS,
/*49666*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::CMOVNS64rm), 0|OPFL_Chain|OPFL_FlagInput|OPFL_MemRefs,
                    1/*#VTs*/, MVT::i64, 6/*#Ops*/, 2, 4, 5, 6, 7, 8, 
                // Src: (X86cmov:i64 (ld:i64 addr:iPTR:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>, GR64:i64:$src2, 15:i8, EFLAGS:i32)
                // Dst: (CMOVNS64rm:i64 GR64:i64:$src2, addr:iPTR:$src1)
/*49679*/     /*Scope*/ 28, /*->49708*/
/*49680*/       OPC_CheckInteger, 12, 
/*49682*/       OPC_MoveParent,
/*49683*/       OPC_RecordChild3, // #3 = physreg input EFLAGS
/*49684*/       OPC_CheckType, MVT::i64,
/*49686*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src1 #4 #5 #6 #7 #8
/*49689*/       OPC_EmitMergeInputChains, 1, 0, 
/*49692*/       OPC_EmitCopyToReg, 3, X86::EFLAGS,
/*49695*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::CMOVS64rm), 0|OPFL_Chain|OPFL_FlagInput|OPFL_MemRefs,
                    1/*#VTs*/, MVT::i64, 6/*#Ops*/, 2, 4, 5, 6, 7, 8, 
                // Src: (X86cmov:i64 (ld:i64 addr:iPTR:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>, GR64:i64:$src2, 12:i8, EFLAGS:i32)
                // Dst: (CMOVS64rm:i64 GR64:i64:$src2, addr:iPTR:$src1)
/*49708*/     /*Scope*/ 28, /*->49737*/
/*49709*/       OPC_CheckInteger, 13, 
/*49711*/       OPC_MoveParent,
/*49712*/       OPC_RecordChild3, // #3 = physreg input EFLAGS
/*49713*/       OPC_CheckType, MVT::i64,
/*49715*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src1 #4 #5 #6 #7 #8
/*49718*/       OPC_EmitMergeInputChains, 1, 0, 
/*49721*/       OPC_EmitCopyToReg, 3, X86::EFLAGS,
/*49724*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::CMOVNO64rm), 0|OPFL_Chain|OPFL_FlagInput|OPFL_MemRefs,
                    1/*#VTs*/, MVT::i64, 6/*#Ops*/, 2, 4, 5, 6, 7, 8, 
                // Src: (X86cmov:i64 (ld:i64 addr:iPTR:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>, GR64:i64:$src2, 13:i8, EFLAGS:i32)
                // Dst: (CMOVNO64rm:i64 GR64:i64:$src2, addr:iPTR:$src1)
/*49737*/     /*Scope*/ 28, /*->49766*/
/*49738*/       OPC_CheckInteger, 10, 
/*49740*/       OPC_MoveParent,
/*49741*/       OPC_RecordChild3, // #3 = physreg input EFLAGS
/*49742*/       OPC_CheckType, MVT::i64,
/*49744*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src1 #4 #5 #6 #7 #8
/*49747*/       OPC_EmitMergeInputChains, 1, 0, 
/*49750*/       OPC_EmitCopyToReg, 3, X86::EFLAGS,
/*49753*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::CMOVO64rm), 0|OPFL_Chain|OPFL_FlagInput|OPFL_MemRefs,
                    1/*#VTs*/, MVT::i64, 6/*#Ops*/, 2, 4, 5, 6, 7, 8, 
                // Src: (X86cmov:i64 (ld:i64 addr:iPTR:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>, GR64:i64:$src2, 10:i8, EFLAGS:i32)
                // Dst: (CMOVO64rm:i64 GR64:i64:$src2, addr:iPTR:$src1)
/*49766*/     0, /*End of Scope*/
/*49767*/   /*Scope*/ 12|128,10/*1292*/, /*->51061*/
/*49769*/     OPC_RecordChild0, // #0 = $src1
/*49770*/     OPC_RecordChild1, // #1 = $src2
/*49771*/     OPC_Scope, 4|128,9/*1156*/, /*->50930*/ // 2 children in Scope
/*49774*/       OPC_MoveChild, 2,
/*49776*/       OPC_Scope, 94, /*->49872*/ // 16 children in Scope
/*49778*/         OPC_CheckInteger, 2, 
/*49780*/         OPC_MoveParent,
/*49781*/         OPC_RecordChild3, // #2 = physreg input EFLAGS
/*49782*/         OPC_SwitchType /*6 cases */, 14,  MVT::f32,// ->49799
/*49785*/           OPC_CheckPatternPredicate, 6, // (!Subtarget->hasSSE1())
/*49787*/           OPC_EmitCopyToReg, 2, X86::EFLAGS,
/*49790*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::CMOVB_Fp32), 0|OPFL_FlagInput,
                        1/*#VTs*/, MVT::f32, 2/*#Ops*/, 0, 1, 
                    // Src: (X86cmov:f32 RFP32:f32:$src1, RFP32:f32:$src2, 2:i8, EFLAGS:i32)
                    // Dst: (CMOVB_Fp32:f32 RFP32:f32:$src1, RFP32:f32:$src2)
                  /*SwitchType*/ 14,  MVT::f64,// ->49815
/*49801*/           OPC_CheckPatternPredicate, 7, // (!Subtarget->hasSSE2())
/*49803*/           OPC_EmitCopyToReg, 2, X86::EFLAGS,
/*49806*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::CMOVB_Fp64), 0|OPFL_FlagInput,
                        1/*#VTs*/, MVT::f64, 2/*#Ops*/, 0, 1, 
                    // Src: (X86cmov:f64 RFP64:f64:$src1, RFP64:f64:$src2, 2:i8, EFLAGS:i32)
                    // Dst: (CMOVB_Fp64:f64 RFP64:f64:$src1, RFP64:f64:$src2)
                  /*SwitchType*/ 12,  MVT::f80,// ->49829
/*49817*/           OPC_EmitCopyToReg, 2, X86::EFLAGS,
/*49820*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::CMOVB_Fp80), 0|OPFL_FlagInput,
                        1/*#VTs*/, MVT::f80, 2/*#Ops*/, 0, 1, 
                    // Src: (X86cmov:f80 RFP80:f80:$src1, RFP80:f80:$src2, 2:i8, EFLAGS:i32)
                    // Dst: (CMOVB_Fp80:f80 RFP80:f80:$src1, RFP80:f80:$src2)
                  /*SwitchType*/ 12,  MVT::i16,// ->49843
/*49831*/           OPC_EmitCopyToReg, 2, X86::EFLAGS,
/*49834*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::CMOVB16rr), 0|OPFL_FlagInput,
                        1/*#VTs*/, MVT::i16, 2/*#Ops*/, 0, 1, 
                    // Src: (X86cmov:i16 GR16:i16:$src1, GR16:i16:$src2, 2:i8, EFLAGS:i32)
                    // Dst: (CMOVB16rr:i16 GR16:i16:$src1, GR16:i16:$src2)
                  /*SwitchType*/ 12,  MVT::i32,// ->49857
/*49845*/           OPC_EmitCopyToReg, 2, X86::EFLAGS,
/*49848*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::CMOVB32rr), 0|OPFL_FlagInput,
                        1/*#VTs*/, MVT::i32, 2/*#Ops*/, 0, 1, 
                    // Src: (X86cmov:i32 GR32:i32:$src1, GR32:i32:$src2, 2:i8, EFLAGS:i32)
                    // Dst: (CMOVB32rr:i32 GR32:i32:$src1, GR32:i32:$src2)
                  /*SwitchType*/ 12,  MVT::i64,// ->49871
/*49859*/           OPC_EmitCopyToReg, 2, X86::EFLAGS,
/*49862*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::CMOVB64rr), 0|OPFL_FlagInput,
                        1/*#VTs*/, MVT::i64, 2/*#Ops*/, 0, 1, 
                    // Src: (X86cmov:i64 GR64:i64:$src1, GR64:i64:$src2, 2:i8, EFLAGS:i32)
                    // Dst: (CMOVB64rr:i64 GR64:i64:$src1, GR64:i64:$src2)
                  0, // EndSwitchType
/*49872*/       /*Scope*/ 94, /*->49967*/
/*49873*/         OPC_CheckInteger, 3, 
/*49875*/         OPC_MoveParent,
/*49876*/         OPC_RecordChild3, // #2 = physreg input EFLAGS
/*49877*/         OPC_SwitchType /*6 cases */, 14,  MVT::f32,// ->49894
/*49880*/           OPC_CheckPatternPredicate, 6, // (!Subtarget->hasSSE1())
/*49882*/           OPC_EmitCopyToReg, 2, X86::EFLAGS,
/*49885*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::CMOVBE_Fp32), 0|OPFL_FlagInput,
                        1/*#VTs*/, MVT::f32, 2/*#Ops*/, 0, 1, 
                    // Src: (X86cmov:f32 RFP32:f32:$src1, RFP32:f32:$src2, 3:i8, EFLAGS:i32)
                    // Dst: (CMOVBE_Fp32:f32 RFP32:f32:$src1, RFP32:f32:$src2)
                  /*SwitchType*/ 14,  MVT::f64,// ->49910
/*49896*/           OPC_CheckPatternPredicate, 7, // (!Subtarget->hasSSE2())
/*49898*/           OPC_EmitCopyToReg, 2, X86::EFLAGS,
/*49901*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::CMOVBE_Fp64), 0|OPFL_FlagInput,
                        1/*#VTs*/, MVT::f64, 2/*#Ops*/, 0, 1, 
                    // Src: (X86cmov:f64 RFP64:f64:$src1, RFP64:f64:$src2, 3:i8, EFLAGS:i32)
                    // Dst: (CMOVBE_Fp64:f64 RFP64:f64:$src1, RFP64:f64:$src2)
                  /*SwitchType*/ 12,  MVT::f80,// ->49924
/*49912*/           OPC_EmitCopyToReg, 2, X86::EFLAGS,
/*49915*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::CMOVBE_Fp80), 0|OPFL_FlagInput,
                        1/*#VTs*/, MVT::f80, 2/*#Ops*/, 0, 1, 
                    // Src: (X86cmov:f80 RFP80:f80:$src1, RFP80:f80:$src2, 3:i8, EFLAGS:i32)
                    // Dst: (CMOVBE_Fp80:f80 RFP80:f80:$src1, RFP80:f80:$src2)
                  /*SwitchType*/ 12,  MVT::i16,// ->49938
/*49926*/           OPC_EmitCopyToReg, 2, X86::EFLAGS,
/*49929*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::CMOVBE16rr), 0|OPFL_FlagInput,
                        1/*#VTs*/, MVT::i16, 2/*#Ops*/, 0, 1, 
                    // Src: (X86cmov:i16 GR16:i16:$src1, GR16:i16:$src2, 3:i8, EFLAGS:i32)
                    // Dst: (CMOVBE16rr:i16 GR16:i16:$src1, GR16:i16:$src2)
                  /*SwitchType*/ 12,  MVT::i32,// ->49952
/*49940*/           OPC_EmitCopyToReg, 2, X86::EFLAGS,
/*49943*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::CMOVBE32rr), 0|OPFL_FlagInput,
                        1/*#VTs*/, MVT::i32, 2/*#Ops*/, 0, 1, 
                    // Src: (X86cmov:i32 GR32:i32:$src1, GR32:i32:$src2, 3:i8, EFLAGS:i32)
                    // Dst: (CMOVBE32rr:i32 GR32:i32:$src1, GR32:i32:$src2)
                  /*SwitchType*/ 12,  MVT::i64,// ->49966
/*49954*/           OPC_EmitCopyToReg, 2, X86::EFLAGS,
/*49957*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::CMOVBE64rr), 0|OPFL_FlagInput,
                        1/*#VTs*/, MVT::i64, 2/*#Ops*/, 0, 1, 
                    // Src: (X86cmov:i64 GR64:i64:$src1, GR64:i64:$src2, 3:i8, EFLAGS:i32)
                    // Dst: (CMOVBE64rr:i64 GR64:i64:$src1, GR64:i64:$src2)
                  0, // EndSwitchType
/*49967*/       /*Scope*/ 94, /*->50062*/
/*49968*/         OPC_CheckInteger, 4, 
/*49970*/         OPC_MoveParent,
/*49971*/         OPC_RecordChild3, // #2 = physreg input EFLAGS
/*49972*/         OPC_SwitchType /*6 cases */, 14,  MVT::f32,// ->49989
/*49975*/           OPC_CheckPatternPredicate, 6, // (!Subtarget->hasSSE1())
/*49977*/           OPC_EmitCopyToReg, 2, X86::EFLAGS,
/*49980*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::CMOVE_Fp32), 0|OPFL_FlagInput,
                        1/*#VTs*/, MVT::f32, 2/*#Ops*/, 0, 1, 
                    // Src: (X86cmov:f32 RFP32:f32:$src1, RFP32:f32:$src2, 4:i8, EFLAGS:i32)
                    // Dst: (CMOVE_Fp32:f32 RFP32:f32:$src1, RFP32:f32:$src2)
                  /*SwitchType*/ 14,  MVT::f64,// ->50005
/*49991*/           OPC_CheckPatternPredicate, 7, // (!Subtarget->hasSSE2())
/*49993*/           OPC_EmitCopyToReg, 2, X86::EFLAGS,
/*49996*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::CMOVE_Fp64), 0|OPFL_FlagInput,
                        1/*#VTs*/, MVT::f64, 2/*#Ops*/, 0, 1, 
                    // Src: (X86cmov:f64 RFP64:f64:$src1, RFP64:f64:$src2, 4:i8, EFLAGS:i32)
                    // Dst: (CMOVE_Fp64:f64 RFP64:f64:$src1, RFP64:f64:$src2)
                  /*SwitchType*/ 12,  MVT::f80,// ->50019
/*50007*/           OPC_EmitCopyToReg, 2, X86::EFLAGS,
/*50010*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::CMOVE_Fp80), 0|OPFL_FlagInput,
                        1/*#VTs*/, MVT::f80, 2/*#Ops*/, 0, 1, 
                    // Src: (X86cmov:f80 RFP80:f80:$src1, RFP80:f80:$src2, 4:i8, EFLAGS:i32)
                    // Dst: (CMOVE_Fp80:f80 RFP80:f80:$src1, RFP80:f80:$src2)
                  /*SwitchType*/ 12,  MVT::i16,// ->50033
/*50021*/           OPC_EmitCopyToReg, 2, X86::EFLAGS,
/*50024*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::CMOVE16rr), 0|OPFL_FlagInput,
                        1/*#VTs*/, MVT::i16, 2/*#Ops*/, 0, 1, 
                    // Src: (X86cmov:i16 GR16:i16:$src1, GR16:i16:$src2, 4:i8, EFLAGS:i32)
                    // Dst: (CMOVE16rr:i16 GR16:i16:$src1, GR16:i16:$src2)
                  /*SwitchType*/ 12,  MVT::i32,// ->50047
/*50035*/           OPC_EmitCopyToReg, 2, X86::EFLAGS,
/*50038*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::CMOVE32rr), 0|OPFL_FlagInput,
                        1/*#VTs*/, MVT::i32, 2/*#Ops*/, 0, 1, 
                    // Src: (X86cmov:i32 GR32:i32:$src1, GR32:i32:$src2, 4:i8, EFLAGS:i32)
                    // Dst: (CMOVE32rr:i32 GR32:i32:$src1, GR32:i32:$src2)
                  /*SwitchType*/ 12,  MVT::i64,// ->50061
/*50049*/           OPC_EmitCopyToReg, 2, X86::EFLAGS,
/*50052*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::CMOVE64rr), 0|OPFL_FlagInput,
                        1/*#VTs*/, MVT::i64, 2/*#Ops*/, 0, 1, 
                    // Src: (X86cmov:i64 GR64:i64:$src1, GR64:i64:$src2, 4:i8, EFLAGS:i32)
                    // Dst: (CMOVE64rr:i64 GR64:i64:$src1, GR64:i64:$src2)
                  0, // EndSwitchType
/*50062*/       /*Scope*/ 94, /*->50157*/
/*50063*/         OPC_CheckInteger, 14, 
/*50065*/         OPC_MoveParent,
/*50066*/         OPC_RecordChild3, // #2 = physreg input EFLAGS
/*50067*/         OPC_SwitchType /*6 cases */, 14,  MVT::f32,// ->50084
/*50070*/           OPC_CheckPatternPredicate, 6, // (!Subtarget->hasSSE1())
/*50072*/           OPC_EmitCopyToReg, 2, X86::EFLAGS,
/*50075*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::CMOVP_Fp32), 0|OPFL_FlagInput,
                        1/*#VTs*/, MVT::f32, 2/*#Ops*/, 0, 1, 
                    // Src: (X86cmov:f32 RFP32:f32:$src1, RFP32:f32:$src2, 14:i8, EFLAGS:i32)
                    // Dst: (CMOVP_Fp32:f32 RFP32:f32:$src1, RFP32:f32:$src2)
                  /*SwitchType*/ 14,  MVT::f64,// ->50100
/*50086*/           OPC_CheckPatternPredicate, 7, // (!Subtarget->hasSSE2())
/*50088*/           OPC_EmitCopyToReg, 2, X86::EFLAGS,
/*50091*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::CMOVP_Fp64), 0|OPFL_FlagInput,
                        1/*#VTs*/, MVT::f64, 2/*#Ops*/, 0, 1, 
                    // Src: (X86cmov:f64 RFP64:f64:$src1, RFP64:f64:$src2, 14:i8, EFLAGS:i32)
                    // Dst: (CMOVP_Fp64:f64 RFP64:f64:$src1, RFP64:f64:$src2)
                  /*SwitchType*/ 12,  MVT::f80,// ->50114
/*50102*/           OPC_EmitCopyToReg, 2, X86::EFLAGS,
/*50105*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::CMOVP_Fp80), 0|OPFL_FlagInput,
                        1/*#VTs*/, MVT::f80, 2/*#Ops*/, 0, 1, 
                    // Src: (X86cmov:f80 RFP80:f80:$src1, RFP80:f80:$src2, 14:i8, EFLAGS:i32)
                    // Dst: (CMOVP_Fp80:f80 RFP80:f80:$src1, RFP80:f80:$src2)
                  /*SwitchType*/ 12,  MVT::i16,// ->50128
/*50116*/           OPC_EmitCopyToReg, 2, X86::EFLAGS,
/*50119*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::CMOVP16rr), 0|OPFL_FlagInput,
                        1/*#VTs*/, MVT::i16, 2/*#Ops*/, 0, 1, 
                    // Src: (X86cmov:i16 GR16:i16:$src1, GR16:i16:$src2, 14:i8, EFLAGS:i32)
                    // Dst: (CMOVP16rr:i16 GR16:i16:$src1, GR16:i16:$src2)
                  /*SwitchType*/ 12,  MVT::i32,// ->50142
/*50130*/           OPC_EmitCopyToReg, 2, X86::EFLAGS,
/*50133*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::CMOVP32rr), 0|OPFL_FlagInput,
                        1/*#VTs*/, MVT::i32, 2/*#Ops*/, 0, 1, 
                    // Src: (X86cmov:i32 GR32:i32:$src1, GR32:i32:$src2, 14:i8, EFLAGS:i32)
                    // Dst: (CMOVP32rr:i32 GR32:i32:$src1, GR32:i32:$src2)
                  /*SwitchType*/ 12,  MVT::i64,// ->50156
/*50144*/           OPC_EmitCopyToReg, 2, X86::EFLAGS,
/*50147*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::CMOVP64rr), 0|OPFL_FlagInput,
                        1/*#VTs*/, MVT::i64, 2/*#Ops*/, 0, 1, 
                    // Src: (X86cmov:i64 GR64:i64:$src1, GR64:i64:$src2, 14:i8, EFLAGS:i32)
                    // Dst: (CMOVP64rr:i64 GR64:i64:$src1, GR64:i64:$src2)
                  0, // EndSwitchType
/*50157*/       /*Scope*/ 94, /*->50252*/
/*50158*/         OPC_CheckInteger, 1, 
/*50160*/         OPC_MoveParent,
/*50161*/         OPC_RecordChild3, // #2 = physreg input EFLAGS
/*50162*/         OPC_SwitchType /*6 cases */, 14,  MVT::f32,// ->50179
/*50165*/           OPC_CheckPatternPredicate, 6, // (!Subtarget->hasSSE1())
/*50167*/           OPC_EmitCopyToReg, 2, X86::EFLAGS,
/*50170*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::CMOVNB_Fp32), 0|OPFL_FlagInput,
                        1/*#VTs*/, MVT::f32, 2/*#Ops*/, 0, 1, 
                    // Src: (X86cmov:f32 RFP32:f32:$src1, RFP32:f32:$src2, 1:i8, EFLAGS:i32)
                    // Dst: (CMOVNB_Fp32:f32 RFP32:f32:$src1, RFP32:f32:$src2)
                  /*SwitchType*/ 14,  MVT::f64,// ->50195
/*50181*/           OPC_CheckPatternPredicate, 7, // (!Subtarget->hasSSE2())
/*50183*/           OPC_EmitCopyToReg, 2, X86::EFLAGS,
/*50186*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::CMOVNB_Fp64), 0|OPFL_FlagInput,
                        1/*#VTs*/, MVT::f64, 2/*#Ops*/, 0, 1, 
                    // Src: (X86cmov:f64 RFP64:f64:$src1, RFP64:f64:$src2, 1:i8, EFLAGS:i32)
                    // Dst: (CMOVNB_Fp64:f64 RFP64:f64:$src1, RFP64:f64:$src2)
                  /*SwitchType*/ 12,  MVT::f80,// ->50209
/*50197*/           OPC_EmitCopyToReg, 2, X86::EFLAGS,
/*50200*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::CMOVNB_Fp80), 0|OPFL_FlagInput,
                        1/*#VTs*/, MVT::f80, 2/*#Ops*/, 0, 1, 
                    // Src: (X86cmov:f80 RFP80:f80:$src1, RFP80:f80:$src2, 1:i8, EFLAGS:i32)
                    // Dst: (CMOVNB_Fp80:f80 RFP80:f80:$src1, RFP80:f80:$src2)
                  /*SwitchType*/ 12,  MVT::i16,// ->50223
/*50211*/           OPC_EmitCopyToReg, 2, X86::EFLAGS,
/*50214*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::CMOVAE16rr), 0|OPFL_FlagInput,
                        1/*#VTs*/, MVT::i16, 2/*#Ops*/, 0, 1, 
                    // Src: (X86cmov:i16 GR16:i16:$src1, GR16:i16:$src2, 1:i8, EFLAGS:i32)
                    // Dst: (CMOVAE16rr:i16 GR16:i16:$src1, GR16:i16:$src2)
                  /*SwitchType*/ 12,  MVT::i32,// ->50237
/*50225*/           OPC_EmitCopyToReg, 2, X86::EFLAGS,
/*50228*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::CMOVAE32rr), 0|OPFL_FlagInput,
                        1/*#VTs*/, MVT::i32, 2/*#Ops*/, 0, 1, 
                    // Src: (X86cmov:i32 GR32:i32:$src1, GR32:i32:$src2, 1:i8, EFLAGS:i32)
                    // Dst: (CMOVAE32rr:i32 GR32:i32:$src1, GR32:i32:$src2)
                  /*SwitchType*/ 12,  MVT::i64,// ->50251
/*50239*/           OPC_EmitCopyToReg, 2, X86::EFLAGS,
/*50242*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::CMOVAE64rr), 0|OPFL_FlagInput,
                        1/*#VTs*/, MVT::i64, 2/*#Ops*/, 0, 1, 
                    // Src: (X86cmov:i64 GR64:i64:$src1, GR64:i64:$src2, 1:i8, EFLAGS:i32)
                    // Dst: (CMOVAE64rr:i64 GR64:i64:$src1, GR64:i64:$src2)
                  0, // EndSwitchType
/*50252*/       /*Scope*/ 94, /*->50347*/
/*50253*/         OPC_CheckInteger, 0, 
/*50255*/         OPC_MoveParent,
/*50256*/         OPC_RecordChild3, // #2 = physreg input EFLAGS
/*50257*/         OPC_SwitchType /*6 cases */, 14,  MVT::f32,// ->50274
/*50260*/           OPC_CheckPatternPredicate, 6, // (!Subtarget->hasSSE1())
/*50262*/           OPC_EmitCopyToReg, 2, X86::EFLAGS,
/*50265*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::CMOVNBE_Fp32), 0|OPFL_FlagInput,
                        1/*#VTs*/, MVT::f32, 2/*#Ops*/, 0, 1, 
                    // Src: (X86cmov:f32 RFP32:f32:$src1, RFP32:f32:$src2, 0:i8, EFLAGS:i32)
                    // Dst: (CMOVNBE_Fp32:f32 RFP32:f32:$src1, RFP32:f32:$src2)
                  /*SwitchType*/ 14,  MVT::f64,// ->50290
/*50276*/           OPC_CheckPatternPredicate, 7, // (!Subtarget->hasSSE2())
/*50278*/           OPC_EmitCopyToReg, 2, X86::EFLAGS,
/*50281*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::CMOVNBE_Fp64), 0|OPFL_FlagInput,
                        1/*#VTs*/, MVT::f64, 2/*#Ops*/, 0, 1, 
                    // Src: (X86cmov:f64 RFP64:f64:$src1, RFP64:f64:$src2, 0:i8, EFLAGS:i32)
                    // Dst: (CMOVNBE_Fp64:f64 RFP64:f64:$src1, RFP64:f64:$src2)
                  /*SwitchType*/ 12,  MVT::f80,// ->50304
/*50292*/           OPC_EmitCopyToReg, 2, X86::EFLAGS,
/*50295*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::CMOVNBE_Fp80), 0|OPFL_FlagInput,
                        1/*#VTs*/, MVT::f80, 2/*#Ops*/, 0, 1, 
                    // Src: (X86cmov:f80 RFP80:f80:$src1, RFP80:f80:$src2, 0:i8, EFLAGS:i32)
                    // Dst: (CMOVNBE_Fp80:f80 RFP80:f80:$src1, RFP80:f80:$src2)
                  /*SwitchType*/ 12,  MVT::i16,// ->50318
/*50306*/           OPC_EmitCopyToReg, 2, X86::EFLAGS,
/*50309*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::CMOVA16rr), 0|OPFL_FlagInput,
                        1/*#VTs*/, MVT::i16, 2/*#Ops*/, 0, 1, 
                    // Src: (X86cmov:i16 GR16:i16:$src1, GR16:i16:$src2, 0:i8, EFLAGS:i32)
                    // Dst: (CMOVA16rr:i16 GR16:i16:$src1, GR16:i16:$src2)
                  /*SwitchType*/ 12,  MVT::i32,// ->50332
/*50320*/           OPC_EmitCopyToReg, 2, X86::EFLAGS,
/*50323*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::CMOVA32rr), 0|OPFL_FlagInput,
                        1/*#VTs*/, MVT::i32, 2/*#Ops*/, 0, 1, 
                    // Src: (X86cmov:i32 GR32:i32:$src1, GR32:i32:$src2, 0:i8, EFLAGS:i32)
                    // Dst: (CMOVA32rr:i32 GR32:i32:$src1, GR32:i32:$src2)
                  /*SwitchType*/ 12,  MVT::i64,// ->50346
/*50334*/           OPC_EmitCopyToReg, 2, X86::EFLAGS,
/*50337*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::CMOVA64rr), 0|OPFL_FlagInput,
                        1/*#VTs*/, MVT::i64, 2/*#Ops*/, 0, 1, 
                    // Src: (X86cmov:i64 GR64:i64:$src1, GR64:i64:$src2, 0:i8, EFLAGS:i32)
                    // Dst: (CMOVA64rr:i64 GR64:i64:$src1, GR64:i64:$src2)
                  0, // EndSwitchType
/*50347*/       /*Scope*/ 94, /*->50442*/
/*50348*/         OPC_CheckInteger, 9, 
/*50350*/         OPC_MoveParent,
/*50351*/         OPC_RecordChild3, // #2 = physreg input EFLAGS
/*50352*/         OPC_SwitchType /*6 cases */, 14,  MVT::f32,// ->50369
/*50355*/           OPC_CheckPatternPredicate, 6, // (!Subtarget->hasSSE1())
/*50357*/           OPC_EmitCopyToReg, 2, X86::EFLAGS,
/*50360*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::CMOVNE_Fp32), 0|OPFL_FlagInput,
                        1/*#VTs*/, MVT::f32, 2/*#Ops*/, 0, 1, 
                    // Src: (X86cmov:f32 RFP32:f32:$src1, RFP32:f32:$src2, 9:i8, EFLAGS:i32)
                    // Dst: (CMOVNE_Fp32:f32 RFP32:f32:$src1, RFP32:f32:$src2)
                  /*SwitchType*/ 14,  MVT::f64,// ->50385
/*50371*/           OPC_CheckPatternPredicate, 7, // (!Subtarget->hasSSE2())
/*50373*/           OPC_EmitCopyToReg, 2, X86::EFLAGS,
/*50376*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::CMOVNE_Fp64), 0|OPFL_FlagInput,
                        1/*#VTs*/, MVT::f64, 2/*#Ops*/, 0, 1, 
                    // Src: (X86cmov:f64 RFP64:f64:$src1, RFP64:f64:$src2, 9:i8, EFLAGS:i32)
                    // Dst: (CMOVNE_Fp64:f64 RFP64:f64:$src1, RFP64:f64:$src2)
                  /*SwitchType*/ 12,  MVT::f80,// ->50399
/*50387*/           OPC_EmitCopyToReg, 2, X86::EFLAGS,
/*50390*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::CMOVNE_Fp80), 0|OPFL_FlagInput,
                        1/*#VTs*/, MVT::f80, 2/*#Ops*/, 0, 1, 
                    // Src: (X86cmov:f80 RFP80:f80:$src1, RFP80:f80:$src2, 9:i8, EFLAGS:i32)
                    // Dst: (CMOVNE_Fp80:f80 RFP80:f80:$src1, RFP80:f80:$src2)
                  /*SwitchType*/ 12,  MVT::i16,// ->50413
/*50401*/           OPC_EmitCopyToReg, 2, X86::EFLAGS,
/*50404*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::CMOVNE16rr), 0|OPFL_FlagInput,
                        1/*#VTs*/, MVT::i16, 2/*#Ops*/, 0, 1, 
                    // Src: (X86cmov:i16 GR16:i16:$src1, GR16:i16:$src2, 9:i8, EFLAGS:i32)
                    // Dst: (CMOVNE16rr:i16 GR16:i16:$src1, GR16:i16:$src2)
                  /*SwitchType*/ 12,  MVT::i32,// ->50427
/*50415*/           OPC_EmitCopyToReg, 2, X86::EFLAGS,
/*50418*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::CMOVNE32rr), 0|OPFL_FlagInput,
                        1/*#VTs*/, MVT::i32, 2/*#Ops*/, 0, 1, 
                    // Src: (X86cmov:i32 GR32:i32:$src1, GR32:i32:$src2, 9:i8, EFLAGS:i32)
                    // Dst: (CMOVNE32rr:i32 GR32:i32:$src1, GR32:i32:$src2)
                  /*SwitchType*/ 12,  MVT::i64,// ->50441
/*50429*/           OPC_EmitCopyToReg, 2, X86::EFLAGS,
/*50432*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::CMOVNE64rr), 0|OPFL_FlagInput,
                        1/*#VTs*/, MVT::i64, 2/*#Ops*/, 0, 1, 
                    // Src: (X86cmov:i64 GR64:i64:$src1, GR64:i64:$src2, 9:i8, EFLAGS:i32)
                    // Dst: (CMOVNE64rr:i64 GR64:i64:$src1, GR64:i64:$src2)
                  0, // EndSwitchType
/*50442*/       /*Scope*/ 94, /*->50537*/
/*50443*/         OPC_CheckInteger, 11, 
/*50445*/         OPC_MoveParent,
/*50446*/         OPC_RecordChild3, // #2 = physreg input EFLAGS
/*50447*/         OPC_SwitchType /*6 cases */, 14,  MVT::f32,// ->50464
/*50450*/           OPC_CheckPatternPredicate, 6, // (!Subtarget->hasSSE1())
/*50452*/           OPC_EmitCopyToReg, 2, X86::EFLAGS,
/*50455*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::CMOVNP_Fp32), 0|OPFL_FlagInput,
                        1/*#VTs*/, MVT::f32, 2/*#Ops*/, 0, 1, 
                    // Src: (X86cmov:f32 RFP32:f32:$src1, RFP32:f32:$src2, 11:i8, EFLAGS:i32)
                    // Dst: (CMOVNP_Fp32:f32 RFP32:f32:$src1, RFP32:f32:$src2)
                  /*SwitchType*/ 14,  MVT::f64,// ->50480
/*50466*/           OPC_CheckPatternPredicate, 7, // (!Subtarget->hasSSE2())
/*50468*/           OPC_EmitCopyToReg, 2, X86::EFLAGS,
/*50471*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::CMOVNP_Fp64), 0|OPFL_FlagInput,
                        1/*#VTs*/, MVT::f64, 2/*#Ops*/, 0, 1, 
                    // Src: (X86cmov:f64 RFP64:f64:$src1, RFP64:f64:$src2, 11:i8, EFLAGS:i32)
                    // Dst: (CMOVNP_Fp64:f64 RFP64:f64:$src1, RFP64:f64:$src2)
                  /*SwitchType*/ 12,  MVT::f80,// ->50494
/*50482*/           OPC_EmitCopyToReg, 2, X86::EFLAGS,
/*50485*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::CMOVNP_Fp80), 0|OPFL_FlagInput,
                        1/*#VTs*/, MVT::f80, 2/*#Ops*/, 0, 1, 
                    // Src: (X86cmov:f80 RFP80:f80:$src1, RFP80:f80:$src2, 11:i8, EFLAGS:i32)
                    // Dst: (CMOVNP_Fp80:f80 RFP80:f80:$src1, RFP80:f80:$src2)
                  /*SwitchType*/ 12,  MVT::i16,// ->50508
/*50496*/           OPC_EmitCopyToReg, 2, X86::EFLAGS,
/*50499*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::CMOVNP16rr), 0|OPFL_FlagInput,
                        1/*#VTs*/, MVT::i16, 2/*#Ops*/, 0, 1, 
                    // Src: (X86cmov:i16 GR16:i16:$src1, GR16:i16:$src2, 11:i8, EFLAGS:i32)
                    // Dst: (CMOVNP16rr:i16 GR16:i16:$src1, GR16:i16:$src2)
                  /*SwitchType*/ 12,  MVT::i32,// ->50522
/*50510*/           OPC_EmitCopyToReg, 2, X86::EFLAGS,
/*50513*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::CMOVNP32rr), 0|OPFL_FlagInput,
                        1/*#VTs*/, MVT::i32, 2/*#Ops*/, 0, 1, 
                    // Src: (X86cmov:i32 GR32:i32:$src1, GR32:i32:$src2, 11:i8, EFLAGS:i32)
                    // Dst: (CMOVNP32rr:i32 GR32:i32:$src1, GR32:i32:$src2)
                  /*SwitchType*/ 12,  MVT::i64,// ->50536
/*50524*/           OPC_EmitCopyToReg, 2, X86::EFLAGS,
/*50527*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::CMOVNP64rr), 0|OPFL_FlagInput,
                        1/*#VTs*/, MVT::i64, 2/*#Ops*/, 0, 1, 
                    // Src: (X86cmov:i64 GR64:i64:$src1, GR64:i64:$src2, 11:i8, EFLAGS:i32)
                    // Dst: (CMOVNP64rr:i64 GR64:i64:$src1, GR64:i64:$src2)
                  0, // EndSwitchType
/*50537*/       /*Scope*/ 48, /*->50586*/
/*50538*/         OPC_CheckInteger, 7, 
/*50540*/         OPC_MoveParent,
/*50541*/         OPC_RecordChild3, // #2 = physreg input EFLAGS
/*50542*/         OPC_SwitchType /*3 cases */, 12,  MVT::i16,// ->50557
/*50545*/           OPC_EmitCopyToReg, 2, X86::EFLAGS,
/*50548*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::CMOVL16rr), 0|OPFL_FlagInput,
                        1/*#VTs*/, MVT::i16, 2/*#Ops*/, 0, 1, 
                    // Src: (X86cmov:i16 GR16:i16:$src1, GR16:i16:$src2, 7:i8, EFLAGS:i32)
                    // Dst: (CMOVL16rr:i16 GR16:i16:$src1, GR16:i16:$src2)
                  /*SwitchType*/ 12,  MVT::i32,// ->50571
/*50559*/           OPC_EmitCopyToReg, 2, X86::EFLAGS,
/*50562*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::CMOVL32rr), 0|OPFL_FlagInput,
                        1/*#VTs*/, MVT::i32, 2/*#Ops*/, 0, 1, 
                    // Src: (X86cmov:i32 GR32:i32:$src1, GR32:i32:$src2, 7:i8, EFLAGS:i32)
                    // Dst: (CMOVL32rr:i32 GR32:i32:$src1, GR32:i32:$src2)
                  /*SwitchType*/ 12,  MVT::i64,// ->50585
/*50573*/           OPC_EmitCopyToReg, 2, X86::EFLAGS,
/*50576*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::CMOVL64rr), 0|OPFL_FlagInput,
                        1/*#VTs*/, MVT::i64, 2/*#Ops*/, 0, 1, 
                    // Src: (X86cmov:i64 GR64:i64:$src1, GR64:i64:$src2, 7:i8, EFLAGS:i32)
                    // Dst: (CMOVL64rr:i64 GR64:i64:$src1, GR64:i64:$src2)
                  0, // EndSwitchType
/*50586*/       /*Scope*/ 48, /*->50635*/
/*50587*/         OPC_CheckInteger, 6, 
/*50589*/         OPC_MoveParent,
/*50590*/         OPC_RecordChild3, // #2 = physreg input EFLAGS
/*50591*/         OPC_SwitchType /*3 cases */, 12,  MVT::i16,// ->50606
/*50594*/           OPC_EmitCopyToReg, 2, X86::EFLAGS,
/*50597*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::CMOVGE16rr), 0|OPFL_FlagInput,
                        1/*#VTs*/, MVT::i16, 2/*#Ops*/, 0, 1, 
                    // Src: (X86cmov:i16 GR16:i16:$src1, GR16:i16:$src2, 6:i8, EFLAGS:i32)
                    // Dst: (CMOVGE16rr:i16 GR16:i16:$src1, GR16:i16:$src2)
                  /*SwitchType*/ 12,  MVT::i32,// ->50620
/*50608*/           OPC_EmitCopyToReg, 2, X86::EFLAGS,
/*50611*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::CMOVGE32rr), 0|OPFL_FlagInput,
                        1/*#VTs*/, MVT::i32, 2/*#Ops*/, 0, 1, 
                    // Src: (X86cmov:i32 GR32:i32:$src1, GR32:i32:$src2, 6:i8, EFLAGS:i32)
                    // Dst: (CMOVGE32rr:i32 GR32:i32:$src1, GR32:i32:$src2)
                  /*SwitchType*/ 12,  MVT::i64,// ->50634
/*50622*/           OPC_EmitCopyToReg, 2, X86::EFLAGS,
/*50625*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::CMOVGE64rr), 0|OPFL_FlagInput,
                        1/*#VTs*/, MVT::i64, 2/*#Ops*/, 0, 1, 
                    // Src: (X86cmov:i64 GR64:i64:$src1, GR64:i64:$src2, 6:i8, EFLAGS:i32)
                    // Dst: (CMOVGE64rr:i64 GR64:i64:$src1, GR64:i64:$src2)
                  0, // EndSwitchType
/*50635*/       /*Scope*/ 48, /*->50684*/
/*50636*/         OPC_CheckInteger, 8, 
/*50638*/         OPC_MoveParent,
/*50639*/         OPC_RecordChild3, // #2 = physreg input EFLAGS
/*50640*/         OPC_SwitchType /*3 cases */, 12,  MVT::i16,// ->50655
/*50643*/           OPC_EmitCopyToReg, 2, X86::EFLAGS,
/*50646*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::CMOVLE16rr), 0|OPFL_FlagInput,
                        1/*#VTs*/, MVT::i16, 2/*#Ops*/, 0, 1, 
                    // Src: (X86cmov:i16 GR16:i16:$src1, GR16:i16:$src2, 8:i8, EFLAGS:i32)
                    // Dst: (CMOVLE16rr:i16 GR16:i16:$src1, GR16:i16:$src2)
                  /*SwitchType*/ 12,  MVT::i32,// ->50669
/*50657*/           OPC_EmitCopyToReg, 2, X86::EFLAGS,
/*50660*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::CMOVLE32rr), 0|OPFL_FlagInput,
                        1/*#VTs*/, MVT::i32, 2/*#Ops*/, 0, 1, 
                    // Src: (X86cmov:i32 GR32:i32:$src1, GR32:i32:$src2, 8:i8, EFLAGS:i32)
                    // Dst: (CMOVLE32rr:i32 GR32:i32:$src1, GR32:i32:$src2)
                  /*SwitchType*/ 12,  MVT::i64,// ->50683
/*50671*/           OPC_EmitCopyToReg, 2, X86::EFLAGS,
/*50674*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::CMOVLE64rr), 0|OPFL_FlagInput,
                        1/*#VTs*/, MVT::i64, 2/*#Ops*/, 0, 1, 
                    // Src: (X86cmov:i64 GR64:i64:$src1, GR64:i64:$src2, 8:i8, EFLAGS:i32)
                    // Dst: (CMOVLE64rr:i64 GR64:i64:$src1, GR64:i64:$src2)
                  0, // EndSwitchType
/*50684*/       /*Scope*/ 48, /*->50733*/
/*50685*/         OPC_CheckInteger, 5, 
/*50687*/         OPC_MoveParent,
/*50688*/         OPC_RecordChild3, // #2 = physreg input EFLAGS
/*50689*/         OPC_SwitchType /*3 cases */, 12,  MVT::i16,// ->50704
/*50692*/           OPC_EmitCopyToReg, 2, X86::EFLAGS,
/*50695*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::CMOVG16rr), 0|OPFL_FlagInput,
                        1/*#VTs*/, MVT::i16, 2/*#Ops*/, 0, 1, 
                    // Src: (X86cmov:i16 GR16:i16:$src1, GR16:i16:$src2, 5:i8, EFLAGS:i32)
                    // Dst: (CMOVG16rr:i16 GR16:i16:$src1, GR16:i16:$src2)
                  /*SwitchType*/ 12,  MVT::i32,// ->50718
/*50706*/           OPC_EmitCopyToReg, 2, X86::EFLAGS,
/*50709*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::CMOVG32rr), 0|OPFL_FlagInput,
                        1/*#VTs*/, MVT::i32, 2/*#Ops*/, 0, 1, 
                    // Src: (X86cmov:i32 GR32:i32:$src1, GR32:i32:$src2, 5:i8, EFLAGS:i32)
                    // Dst: (CMOVG32rr:i32 GR32:i32:$src1, GR32:i32:$src2)
                  /*SwitchType*/ 12,  MVT::i64,// ->50732
/*50720*/           OPC_EmitCopyToReg, 2, X86::EFLAGS,
/*50723*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::CMOVG64rr), 0|OPFL_FlagInput,
                        1/*#VTs*/, MVT::i64, 2/*#Ops*/, 0, 1, 
                    // Src: (X86cmov:i64 GR64:i64:$src1, GR64:i64:$src2, 5:i8, EFLAGS:i32)
                    // Dst: (CMOVG64rr:i64 GR64:i64:$src1, GR64:i64:$src2)
                  0, // EndSwitchType
/*50733*/       /*Scope*/ 48, /*->50782*/
/*50734*/         OPC_CheckInteger, 15, 
/*50736*/         OPC_MoveParent,
/*50737*/         OPC_RecordChild3, // #2 = physreg input EFLAGS
/*50738*/         OPC_SwitchType /*3 cases */, 12,  MVT::i16,// ->50753
/*50741*/           OPC_EmitCopyToReg, 2, X86::EFLAGS,
/*50744*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::CMOVS16rr), 0|OPFL_FlagInput,
                        1/*#VTs*/, MVT::i16, 2/*#Ops*/, 0, 1, 
                    // Src: (X86cmov:i16 GR16:i16:$src1, GR16:i16:$src2, 15:i8, EFLAGS:i32)
                    // Dst: (CMOVS16rr:i16 GR16:i16:$src1, GR16:i16:$src2)
                  /*SwitchType*/ 12,  MVT::i32,// ->50767
/*50755*/           OPC_EmitCopyToReg, 2, X86::EFLAGS,
/*50758*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::CMOVS32rr), 0|OPFL_FlagInput,
                        1/*#VTs*/, MVT::i32, 2/*#Ops*/, 0, 1, 
                    // Src: (X86cmov:i32 GR32:i32:$src1, GR32:i32:$src2, 15:i8, EFLAGS:i32)
                    // Dst: (CMOVS32rr:i32 GR32:i32:$src1, GR32:i32:$src2)
                  /*SwitchType*/ 12,  MVT::i64,// ->50781
/*50769*/           OPC_EmitCopyToReg, 2, X86::EFLAGS,
/*50772*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::CMOVS64rr), 0|OPFL_FlagInput,
                        1/*#VTs*/, MVT::i64, 2/*#Ops*/, 0, 1, 
                    // Src: (X86cmov:i64 GR64:i64:$src1, GR64:i64:$src2, 15:i8, EFLAGS:i32)
                    // Dst: (CMOVS64rr:i64 GR64:i64:$src1, GR64:i64:$src2)
                  0, // EndSwitchType
/*50782*/       /*Scope*/ 48, /*->50831*/
/*50783*/         OPC_CheckInteger, 12, 
/*50785*/         OPC_MoveParent,
/*50786*/         OPC_RecordChild3, // #2 = physreg input EFLAGS
/*50787*/         OPC_SwitchType /*3 cases */, 12,  MVT::i16,// ->50802
/*50790*/           OPC_EmitCopyToReg, 2, X86::EFLAGS,
/*50793*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::CMOVNS16rr), 0|OPFL_FlagInput,
                        1/*#VTs*/, MVT::i16, 2/*#Ops*/, 0, 1, 
                    // Src: (X86cmov:i16 GR16:i16:$src1, GR16:i16:$src2, 12:i8, EFLAGS:i32)
                    // Dst: (CMOVNS16rr:i16 GR16:i16:$src1, GR16:i16:$src2)
                  /*SwitchType*/ 12,  MVT::i32,// ->50816
/*50804*/           OPC_EmitCopyToReg, 2, X86::EFLAGS,
/*50807*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::CMOVNS32rr), 0|OPFL_FlagInput,
                        1/*#VTs*/, MVT::i32, 2/*#Ops*/, 0, 1, 
                    // Src: (X86cmov:i32 GR32:i32:$src1, GR32:i32:$src2, 12:i8, EFLAGS:i32)
                    // Dst: (CMOVNS32rr:i32 GR32:i32:$src1, GR32:i32:$src2)
                  /*SwitchType*/ 12,  MVT::i64,// ->50830
/*50818*/           OPC_EmitCopyToReg, 2, X86::EFLAGS,
/*50821*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::CMOVNS64rr), 0|OPFL_FlagInput,
                        1/*#VTs*/, MVT::i64, 2/*#Ops*/, 0, 1, 
                    // Src: (X86cmov:i64 GR64:i64:$src1, GR64:i64:$src2, 12:i8, EFLAGS:i32)
                    // Dst: (CMOVNS64rr:i64 GR64:i64:$src1, GR64:i64:$src2)
                  0, // EndSwitchType
/*50831*/       /*Scope*/ 48, /*->50880*/
/*50832*/         OPC_CheckInteger, 13, 
/*50834*/         OPC_MoveParent,
/*50835*/         OPC_RecordChild3, // #2 = physreg input EFLAGS
/*50836*/         OPC_SwitchType /*3 cases */, 12,  MVT::i16,// ->50851
/*50839*/           OPC_EmitCopyToReg, 2, X86::EFLAGS,
/*50842*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::CMOVO16rr), 0|OPFL_FlagInput,
                        1/*#VTs*/, MVT::i16, 2/*#Ops*/, 0, 1, 
                    // Src: (X86cmov:i16 GR16:i16:$src1, GR16:i16:$src2, 13:i8, EFLAGS:i32)
                    // Dst: (CMOVO16rr:i16 GR16:i16:$src1, GR16:i16:$src2)
                  /*SwitchType*/ 12,  MVT::i32,// ->50865
/*50853*/           OPC_EmitCopyToReg, 2, X86::EFLAGS,
/*50856*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::CMOVO32rr), 0|OPFL_FlagInput,
                        1/*#VTs*/, MVT::i32, 2/*#Ops*/, 0, 1, 
                    // Src: (X86cmov:i32 GR32:i32:$src1, GR32:i32:$src2, 13:i8, EFLAGS:i32)
                    // Dst: (CMOVO32rr:i32 GR32:i32:$src1, GR32:i32:$src2)
                  /*SwitchType*/ 12,  MVT::i64,// ->50879
/*50867*/           OPC_EmitCopyToReg, 2, X86::EFLAGS,
/*50870*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::CMOVO64rr), 0|OPFL_FlagInput,
                        1/*#VTs*/, MVT::i64, 2/*#Ops*/, 0, 1, 
                    // Src: (X86cmov:i64 GR64:i64:$src1, GR64:i64:$src2, 13:i8, EFLAGS:i32)
                    // Dst: (CMOVO64rr:i64 GR64:i64:$src1, GR64:i64:$src2)
                  0, // EndSwitchType
/*50880*/       /*Scope*/ 48, /*->50929*/
/*50881*/         OPC_CheckInteger, 10, 
/*50883*/         OPC_MoveParent,
/*50884*/         OPC_RecordChild3, // #2 = physreg input EFLAGS
/*50885*/         OPC_SwitchType /*3 cases */, 12,  MVT::i16,// ->50900
/*50888*/           OPC_EmitCopyToReg, 2, X86::EFLAGS,
/*50891*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::CMOVNO16rr), 0|OPFL_FlagInput,
                        1/*#VTs*/, MVT::i16, 2/*#Ops*/, 0, 1, 
                    // Src: (X86cmov:i16 GR16:i16:$src1, GR16:i16:$src2, 10:i8, EFLAGS:i32)
                    // Dst: (CMOVNO16rr:i16 GR16:i16:$src1, GR16:i16:$src2)
                  /*SwitchType*/ 12,  MVT::i32,// ->50914
/*50902*/           OPC_EmitCopyToReg, 2, X86::EFLAGS,
/*50905*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::CMOVNO32rr), 0|OPFL_FlagInput,
                        1/*#VTs*/, MVT::i32, 2/*#Ops*/, 0, 1, 
                    // Src: (X86cmov:i32 GR32:i32:$src1, GR32:i32:$src2, 10:i8, EFLAGS:i32)
                    // Dst: (CMOVNO32rr:i32 GR32:i32:$src1, GR32:i32:$src2)
                  /*SwitchType*/ 12,  MVT::i64,// ->50928
/*50916*/           OPC_EmitCopyToReg, 2, X86::EFLAGS,
/*50919*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::CMOVNO64rr), 0|OPFL_FlagInput,
                        1/*#VTs*/, MVT::i64, 2/*#Ops*/, 0, 1, 
                    // Src: (X86cmov:i64 GR64:i64:$src1, GR64:i64:$src2, 10:i8, EFLAGS:i32)
                    // Dst: (CMOVNO64rr:i64 GR64:i64:$src1, GR64:i64:$src2)
                  0, // EndSwitchType
/*50929*/       0, /*End of Scope*/
/*50930*/     /*Scope*/ 0|128,1/*128*/, /*->51060*/
/*50932*/       OPC_RecordChild2, // #2 = $cond
/*50933*/       OPC_MoveChild, 2,
/*50935*/       OPC_CheckOpcode, ISD::Constant,
/*50937*/       OPC_MoveParent,
/*50938*/       OPC_RecordChild3, // #3 = physreg input EFLAGS
/*50939*/       OPC_SwitchType /*7 cases */, 15,  MVT::i8,// ->50957
/*50942*/         OPC_EmitConvertToTarget, 2,
/*50944*/         OPC_EmitCopyToReg, 3, X86::EFLAGS,
/*50947*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::CMOV_GR8), 0|OPFL_FlagInput,
                      1/*#VTs*/, MVT::i8, 3/*#Ops*/, 0, 1, 4, 
                  // Src: (X86cmov:i8 GR8:i8:$src1, GR8:i8:$src2, (imm:i8):$cond, EFLAGS:i32)
                  // Dst: (CMOV_GR8:i8 GR8:i8:$src1, GR8:i8:$src2, (imm:i8):$cond)
                /*SwitchType*/ 15,  MVT::f32,// ->50974
/*50959*/         OPC_EmitConvertToTarget, 2,
/*50961*/         OPC_EmitCopyToReg, 3, X86::EFLAGS,
/*50964*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::CMOV_FR32), 0|OPFL_FlagInput,
                      1/*#VTs*/, MVT::f32, 3/*#Ops*/, 0, 1, 4, 
                  // Src: (X86cmov:f32 FR32:f32:$t, FR32:f32:$f, (imm:i8):$cond, EFLAGS:i32)
                  // Dst: (CMOV_FR32:f32 FR32:f32:$t, FR32:f32:$f, (imm:i8):$cond)
                /*SwitchType*/ 15,  MVT::f64,// ->50991
/*50976*/         OPC_EmitConvertToTarget, 2,
/*50978*/         OPC_EmitCopyToReg, 3, X86::EFLAGS,
/*50981*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::CMOV_FR64), 0|OPFL_FlagInput,
                      1/*#VTs*/, MVT::f64, 3/*#Ops*/, 0, 1, 4, 
                  // Src: (X86cmov:f64 FR64:f64:$t, FR64:f64:$f, (imm:i8):$cond, EFLAGS:i32)
                  // Dst: (CMOV_FR64:f64 FR64:f64:$t, FR64:f64:$f, (imm:i8):$cond)
                /*SwitchType*/ 15,  MVT::v4f32,// ->51008
/*50993*/         OPC_EmitConvertToTarget, 2,
/*50995*/         OPC_EmitCopyToReg, 3, X86::EFLAGS,
/*50998*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::CMOV_V4F32), 0|OPFL_FlagInput,
                      1/*#VTs*/, MVT::v4f32, 3/*#Ops*/, 0, 1, 4, 
                  // Src: (X86cmov:v4f32 VR128:v4f32:$t, VR128:v4f32:$f, (imm:i8):$cond, EFLAGS:i32)
                  // Dst: (CMOV_V4F32:v4f32 VR128:v4f32:$t, VR128:v4f32:$f, (imm:i8):$cond)
                /*SwitchType*/ 15,  MVT::v2f64,// ->51025
/*51010*/         OPC_EmitConvertToTarget, 2,
/*51012*/         OPC_EmitCopyToReg, 3, X86::EFLAGS,
/*51015*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::CMOV_V2F64), 0|OPFL_FlagInput,
                      1/*#VTs*/, MVT::v2f64, 3/*#Ops*/, 0, 1, 4, 
                  // Src: (X86cmov:v2f64 VR128:v2f64:$t, VR128:v2f64:$f, (imm:i8):$cond, EFLAGS:i32)
                  // Dst: (CMOV_V2F64:v2f64 VR128:v2f64:$t, VR128:v2f64:$f, (imm:i8):$cond)
                /*SwitchType*/ 15,  MVT::v2i64,// ->51042
/*51027*/         OPC_EmitConvertToTarget, 2,
/*51029*/         OPC_EmitCopyToReg, 3, X86::EFLAGS,
/*51032*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::CMOV_V2I64), 0|OPFL_FlagInput,
                      1/*#VTs*/, MVT::v2i64, 3/*#Ops*/, 0, 1, 4, 
                  // Src: (X86cmov:v2i64 VR128:v2i64:$t, VR128:v2i64:$f, (imm:i8):$cond, EFLAGS:i32)
                  // Dst: (CMOV_V2I64:v2i64 VR128:v2i64:$t, VR128:v2i64:$f, (imm:i8):$cond)
                /*SwitchType*/ 15,  MVT::v1i64,// ->51059
/*51044*/         OPC_EmitConvertToTarget, 2,
/*51046*/         OPC_EmitCopyToReg, 3, X86::EFLAGS,
/*51049*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::CMOV_V1I64), 0|OPFL_FlagInput,
                      1/*#VTs*/, MVT::v1i64, 3/*#Ops*/, 0, 1, 4, 
                  // Src: (X86cmov:v1i64 VR64:v1i64:$t, VR64:v1i64:$f, (imm:i8):$cond, EFLAGS:i32)
                  // Dst: (CMOV_V1I64:v1i64 VR64:v1i64:$t, VR64:v1i64:$f, (imm:i8):$cond)
                0, // EndSwitchType
/*51060*/     0, /*End of Scope*/
/*51061*/   0, /*End of Scope*/
          /*SwitchOpcode*/ 88|128,6/*856*/,  ISD::MUL,// ->51921
/*51065*/   OPC_Scope, 50|128,1/*178*/, /*->51246*/ // 7 children in Scope
/*51068*/     OPC_MoveChild, 0,
/*51070*/     OPC_CheckOpcode, ISD::LOAD,
/*51072*/     OPC_RecordMemRef,
/*51073*/     OPC_RecordNode, // #0 = 'ld' chained node
/*51074*/     OPC_CheckFoldableChainNode,
/*51075*/     OPC_RecordChild1, // #1 = $src1
/*51076*/     OPC_CheckPredicate, 2, // Predicate_unindexedload
/*51078*/     OPC_CheckPredicate, 8, // Predicate_load
/*51080*/     OPC_MoveParent,
/*51081*/     OPC_RecordChild1, // #2 = $src2
/*51082*/     OPC_MoveChild, 1,
/*51084*/     OPC_CheckOpcode, ISD::Constant,
/*51086*/     OPC_Scope, 77, /*->51165*/ // 3 children in Scope
/*51088*/       OPC_CheckPredicate, 11, // Predicate_immSext8
/*51090*/       OPC_MoveParent,
/*51091*/       OPC_SwitchType /*3 cases */, 22,  MVT::i16,// ->51116
/*51094*/         OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src1 #3 #4 #5 #6 #7
/*51097*/         OPC_EmitMergeInputChains, 1, 0, 
/*51100*/         OPC_EmitConvertToTarget, 2,
/*51102*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::IMUL16rmi8), 0|OPFL_Chain|OPFL_MemRefs,
                      2/*#VTs*/, MVT::i16, MVT::i32, 6/*#Ops*/, 3, 4, 5, 6, 7, 8, 
                  // Src: (mul:i16 (ld:i16 addr:iPTR:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:i16)<<P:Predicate_immSext8>>:$src2)
                  // Dst: (IMUL16rmi8:i16 addr:iPTR:$src1, (imm:i16):$src2)
                /*SwitchType*/ 22,  MVT::i32,// ->51140
/*51118*/         OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src1 #3 #4 #5 #6 #7
/*51121*/         OPC_EmitMergeInputChains, 1, 0, 
/*51124*/         OPC_EmitConvertToTarget, 2,
/*51126*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::IMUL32rmi8), 0|OPFL_Chain|OPFL_MemRefs,
                      2/*#VTs*/, MVT::i32, MVT::i32, 6/*#Ops*/, 3, 4, 5, 6, 7, 8, 
                  // Src: (mul:i32 (ld:i32 addr:iPTR:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:i32)<<P:Predicate_immSext8>>:$src2)
                  // Dst: (IMUL32rmi8:i32 addr:iPTR:$src1, (imm:i32):$src2)
                /*SwitchType*/ 22,  MVT::i64,// ->51164
/*51142*/         OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src1 #3 #4 #5 #6 #7
/*51145*/         OPC_EmitMergeInputChains, 1, 0, 
/*51148*/         OPC_EmitConvertToTarget, 2,
/*51150*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::IMUL64rmi8), 0|OPFL_Chain|OPFL_MemRefs,
                      2/*#VTs*/, MVT::i64, MVT::i32, 6/*#Ops*/, 3, 4, 5, 6, 7, 8, 
                  // Src: (mul:i64 (ld:i64 addr:iPTR:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:i64)<<P:Predicate_immSext8>>:$src2)
                  // Dst: (IMUL64rmi8:i64 addr:iPTR:$src1, (imm:i64):$src2)
                0, // EndSwitchType
/*51165*/     /*Scope*/ 27, /*->51193*/
/*51166*/       OPC_CheckPredicate, 12, // Predicate_i64immSExt32
/*51168*/       OPC_MoveParent,
/*51169*/       OPC_CheckType, MVT::i64,
/*51171*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src1 #3 #4 #5 #6 #7
/*51174*/       OPC_EmitMergeInputChains, 1, 0, 
/*51177*/       OPC_EmitConvertToTarget, 2,
/*51179*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::IMUL64rmi32), 0|OPFL_Chain|OPFL_MemRefs,
                    2/*#VTs*/, MVT::i64, MVT::i32, 6/*#Ops*/, 3, 4, 5, 6, 7, 8, 
                // Src: (mul:i64 (ld:i64 addr:iPTR:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:i64)<<P:Predicate_i64immSExt32>>:$src2)
                // Dst: (IMUL64rmi32:i64 addr:iPTR:$src1, (imm:i64):$src2)
/*51193*/     /*Scope*/ 51, /*->51245*/
/*51194*/       OPC_MoveParent,
/*51195*/       OPC_SwitchType /*2 cases */, 22,  MVT::i16,// ->51220
/*51198*/         OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src1 #3 #4 #5 #6 #7
/*51201*/         OPC_EmitMergeInputChains, 1, 0, 
/*51204*/         OPC_EmitConvertToTarget, 2,
/*51206*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::IMUL16rmi), 0|OPFL_Chain|OPFL_MemRefs,
                      2/*#VTs*/, MVT::i16, MVT::i32, 6/*#Ops*/, 3, 4, 5, 6, 7, 8, 
                  // Src: (mul:i16 (ld:i16 addr:iPTR:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:i16):$src2)
                  // Dst: (IMUL16rmi:i16 addr:iPTR:$src1, (imm:i16):$src2)
                /*SwitchType*/ 22,  MVT::i32,// ->51244
/*51222*/         OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src1 #3 #4 #5 #6 #7
/*51225*/         OPC_EmitMergeInputChains, 1, 0, 
/*51228*/         OPC_EmitConvertToTarget, 2,
/*51230*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::IMUL32rmi), 0|OPFL_Chain|OPFL_MemRefs,
                      2/*#VTs*/, MVT::i32, MVT::i32, 6/*#Ops*/, 3, 4, 5, 6, 7, 8, 
                  // Src: (mul:i32 (ld:i32 addr:iPTR:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:i32):$src2)
                  // Dst: (IMUL32rmi:i32 addr:iPTR:$src1, (imm:i32):$src2)
                0, // EndSwitchType
/*51245*/     0, /*End of Scope*/
/*51246*/   /*Scope*/ 75, /*->51322*/
/*51247*/     OPC_RecordChild0, // #0 = $src1
/*51248*/     OPC_MoveChild, 1,
/*51250*/     OPC_CheckOpcode, ISD::BIT_CONVERT,
/*51252*/     OPC_MoveChild, 0,
/*51254*/     OPC_CheckOpcode, ISD::LOAD,
/*51256*/     OPC_RecordMemRef,
/*51257*/     OPC_RecordNode, // #1 = 'ld' chained node
/*51258*/     OPC_CheckFoldableChainNode,
/*51259*/     OPC_RecordChild1, // #2 = $src2
/*51260*/     OPC_CheckPredicate, 2, // Predicate_unindexedload
/*51262*/     OPC_CheckPredicate, 8, // Predicate_load
/*51264*/     OPC_SwitchType /*2 cases */, 27,  MVT::v2i64,// ->51294
/*51267*/       OPC_CheckPredicate, 23, // Predicate_memop
/*51269*/       OPC_MoveParent,
/*51270*/       OPC_MoveParent,
/*51271*/       OPC_CheckType, MVT::v8i16,
/*51273*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*51275*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*51278*/       OPC_EmitMergeInputChains, 1, 1, 
/*51281*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PMULLWrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v8i16, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (mul:v8i16 VR128:v8i16:$src1, (bitconvert:v8i16 (ld:v2i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>))
                // Dst: (PMULLWrm:v8i16 VR128:v8i16:$src1, addr:iPTR:$src2)
              /*SwitchType*/ 25,  MVT::v1i64,// ->51321
/*51296*/       OPC_MoveParent,
/*51297*/       OPC_MoveParent,
/*51298*/       OPC_CheckType, MVT::v4i16,
/*51300*/       OPC_CheckPatternPredicate, 8, // (Subtarget->hasMMX())
/*51302*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*51305*/       OPC_EmitMergeInputChains, 1, 1, 
/*51308*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PMULLWrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v4i16, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (mul:v4i16 VR64:v4i16:$src1, (bitconvert:v4i16 (ld:v1i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>))
                // Dst: (MMX_PMULLWrm:v4i16 VR64:v4i16:$src1, addr:iPTR:$src2)
              0, // EndSwitchType
/*51322*/   /*Scope*/ 76, /*->51399*/
/*51323*/     OPC_MoveChild, 0,
/*51325*/     OPC_CheckOpcode, ISD::BIT_CONVERT,
/*51327*/     OPC_MoveChild, 0,
/*51329*/     OPC_CheckOpcode, ISD::LOAD,
/*51331*/     OPC_RecordMemRef,
/*51332*/     OPC_RecordNode, // #0 = 'ld' chained node
/*51333*/     OPC_CheckFoldableChainNode,
/*51334*/     OPC_RecordChild1, // #1 = $src2
/*51335*/     OPC_CheckPredicate, 2, // Predicate_unindexedload
/*51337*/     OPC_CheckPredicate, 8, // Predicate_load
/*51339*/     OPC_SwitchType /*2 cases */, 28,  MVT::v2i64,// ->51370
/*51342*/       OPC_CheckPredicate, 23, // Predicate_memop
/*51344*/       OPC_MoveParent,
/*51345*/       OPC_MoveParent,
/*51346*/       OPC_RecordChild1, // #2 = $src1
/*51347*/       OPC_CheckType, MVT::v8i16,
/*51349*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*51351*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*51354*/       OPC_EmitMergeInputChains, 1, 0, 
/*51357*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PMULLWrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v8i16, 6/*#Ops*/, 2, 3, 4, 5, 6, 7, 
                // Src: (mul:v8i16 (bitconvert:v8i16 (ld:v2i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>), VR128:v8i16:$src1)
                // Dst: (PMULLWrm:v8i16 VR128:v8i16:$src1, addr:iPTR:$src2)
              /*SwitchType*/ 26,  MVT::v1i64,// ->51398
/*51372*/       OPC_MoveParent,
/*51373*/       OPC_MoveParent,
/*51374*/       OPC_RecordChild1, // #2 = $src1
/*51375*/       OPC_CheckType, MVT::v4i16,
/*51377*/       OPC_CheckPatternPredicate, 8, // (Subtarget->hasMMX())
/*51379*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*51382*/       OPC_EmitMergeInputChains, 1, 0, 
/*51385*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PMULLWrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v4i16, 6/*#Ops*/, 2, 3, 4, 5, 6, 7, 
                // Src: (mul:v4i16 (bitconvert:v4i16 (ld:v1i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>), VR64:v4i16:$src1)
                // Dst: (MMX_PMULLWrm:v4i16 VR64:v4i16:$src1, addr:iPTR:$src2)
              0, // EndSwitchType
/*51399*/   /*Scope*/ 12|128,1/*140*/, /*->51541*/
/*51401*/     OPC_RecordChild0, // #0 = physreg input AL
/*51402*/     OPC_MoveChild, 1,
/*51404*/     OPC_CheckOpcode, ISD::LOAD,
/*51406*/     OPC_RecordMemRef,
/*51407*/     OPC_RecordNode, // #1 = 'ld' chained node
/*51408*/     OPC_CheckFoldableChainNode,
/*51409*/     OPC_RecordChild1, // #2 = $src
/*51410*/     OPC_CheckPredicate, 2, // Predicate_unindexedload
/*51412*/     OPC_CheckPredicate, 8, // Predicate_load
/*51414*/     OPC_Scope, 27, /*->51443*/ // 3 children in Scope
/*51416*/       OPC_CheckPredicate, 9, // Predicate_dsload
/*51418*/       OPC_MoveParent,
/*51419*/       OPC_CheckType, MVT::i8,
/*51421*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src #3 #4 #5 #6 #7
/*51424*/       OPC_EmitMergeInputChains, 1, 1, 
/*51427*/       OPC_EmitCopyToReg, 0, X86::AL,
/*51430*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MUL8m), 0|OPFL_Chain|OPFL_FlagInput|OPFL_MemRefs,
                    2/*#VTs*/, MVT::i8, MVT::i32, 5/*#Ops*/, 3, 4, 5, 6, 7, 
                // Src: (mul:i8 AL:i8, (ld:i8 addr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>)
                // Dst: (MUL8m:isVoid addr:iPTR:$src)
/*51443*/     /*Scope*/ 69, /*->51513*/
/*51444*/       OPC_MoveParent,
/*51445*/       OPC_SwitchType /*3 cases */, 20,  MVT::i16,// ->51468
/*51448*/         OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*51451*/         OPC_EmitMergeInputChains, 1, 1, 
/*51454*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::IMUL16rm), 0|OPFL_Chain|OPFL_MemRefs,
                      2/*#VTs*/, MVT::i16, MVT::i32, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                  // Src: (mul:i16 GR16:i16:$src1, (ld:i16 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)
                  // Dst: (IMUL16rm:i16 GR16:i16:$src1, addr:iPTR:$src2)
                /*SwitchType*/ 20,  MVT::i32,// ->51490
/*51470*/         OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*51473*/         OPC_EmitMergeInputChains, 1, 1, 
/*51476*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::IMUL32rm), 0|OPFL_Chain|OPFL_MemRefs,
                      2/*#VTs*/, MVT::i32, MVT::i32, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                  // Src: (mul:i32 GR32:i32:$src1, (ld:i32 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)
                  // Dst: (IMUL32rm:i32 GR32:i32:$src1, addr:iPTR:$src2)
                /*SwitchType*/ 20,  MVT::i64,// ->51512
/*51492*/         OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*51495*/         OPC_EmitMergeInputChains, 1, 1, 
/*51498*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::IMUL64rm), 0|OPFL_Chain|OPFL_MemRefs,
                      2/*#VTs*/, MVT::i64, MVT::i32, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                  // Src: (mul:i64 GR64:i64:$src1, (ld:i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)
                  // Dst: (IMUL64rm:i64 GR64:i64:$src1, addr:iPTR:$src2)
                0, // EndSwitchType
/*51513*/     /*Scope*/ 26, /*->51540*/
/*51514*/       OPC_CheckPredicate, 23, // Predicate_memop
/*51516*/       OPC_MoveParent,
/*51517*/       OPC_CheckType, MVT::v4i32,
/*51519*/       OPC_CheckPatternPredicate, 4, // (Subtarget->hasSSE41())
/*51521*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*51524*/       OPC_EmitMergeInputChains, 1, 1, 
/*51527*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PMULLDrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v4i32, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (mul:v4i32 VR128:v4i32:$src1, (ld:v4i32 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>)
                // Dst: (PMULLDrm:v4i32 VR128:v4i32:$src1, addr:iPTR:$src2)
/*51540*/     0, /*End of Scope*/
/*51541*/   /*Scope*/ 113, /*->51655*/
/*51542*/     OPC_MoveChild, 0,
/*51544*/     OPC_CheckOpcode, ISD::LOAD,
/*51546*/     OPC_RecordMemRef,
/*51547*/     OPC_RecordNode, // #0 = 'ld' chained node
/*51548*/     OPC_CheckFoldableChainNode,
/*51549*/     OPC_RecordChild1, // #1 = $src2
/*51550*/     OPC_CheckPredicate, 2, // Predicate_unindexedload
/*51552*/     OPC_CheckPredicate, 8, // Predicate_load
/*51554*/     OPC_Scope, 70, /*->51626*/ // 2 children in Scope
/*51556*/       OPC_MoveParent,
/*51557*/       OPC_RecordChild1, // #2 = $src1
/*51558*/       OPC_SwitchType /*3 cases */, 20,  MVT::i16,// ->51581
/*51561*/         OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*51564*/         OPC_EmitMergeInputChains, 1, 0, 
/*51567*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::IMUL16rm), 0|OPFL_Chain|OPFL_MemRefs,
                      2/*#VTs*/, MVT::i16, MVT::i32, 6/*#Ops*/, 2, 3, 4, 5, 6, 7, 
                  // Src: (mul:i16 (ld:i16 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR16:i16:$src1)
                  // Dst: (IMUL16rm:i16 GR16:i16:$src1, addr:iPTR:$src2)
                /*SwitchType*/ 20,  MVT::i32,// ->51603
/*51583*/         OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*51586*/         OPC_EmitMergeInputChains, 1, 0, 
/*51589*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::IMUL32rm), 0|OPFL_Chain|OPFL_MemRefs,
                      2/*#VTs*/, MVT::i32, MVT::i32, 6/*#Ops*/, 2, 3, 4, 5, 6, 7, 
                  // Src: (mul:i32 (ld:i32 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR32:i32:$src1)
                  // Dst: (IMUL32rm:i32 GR32:i32:$src1, addr:iPTR:$src2)
                /*SwitchType*/ 20,  MVT::i64,// ->51625
/*51605*/         OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*51608*/         OPC_EmitMergeInputChains, 1, 0, 
/*51611*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::IMUL64rm), 0|OPFL_Chain|OPFL_MemRefs,
                      2/*#VTs*/, MVT::i64, MVT::i32, 6/*#Ops*/, 2, 3, 4, 5, 6, 7, 
                  // Src: (mul:i64 (ld:i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR64:i64:$src1)
                  // Dst: (IMUL64rm:i64 GR64:i64:$src1, addr:iPTR:$src2)
                0, // EndSwitchType
/*51626*/     /*Scope*/ 27, /*->51654*/
/*51627*/       OPC_CheckPredicate, 23, // Predicate_memop
/*51629*/       OPC_MoveParent,
/*51630*/       OPC_RecordChild1, // #2 = $src1
/*51631*/       OPC_CheckType, MVT::v4i32,
/*51633*/       OPC_CheckPatternPredicate, 4, // (Subtarget->hasSSE41())
/*51635*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*51638*/       OPC_EmitMergeInputChains, 1, 0, 
/*51641*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PMULLDrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v4i32, 6/*#Ops*/, 2, 3, 4, 5, 6, 7, 
                // Src: (mul:v4i32 (ld:v4i32 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>, VR128:v4i32:$src1)
                // Dst: (PMULLDrm:v4i32 VR128:v4i32:$src1, addr:iPTR:$src2)
/*51654*/     0, /*End of Scope*/
/*51655*/   /*Scope*/ 57, /*->51713*/
/*51656*/     OPC_RecordNode, // #0 = $src
/*51657*/     OPC_SwitchType /*2 cases */, 36,  MVT::i32,// ->51696
/*51660*/       OPC_Scope, 16, /*->51678*/ // 2 children in Scope
/*51662*/         OPC_CheckPatternPredicate, 2, // (!Subtarget->is64Bit())
/*51664*/         OPC_CheckComplexPat, /*CP*/3, /*#*/0, // SelectLEAAddr:$src #1 #2 #3 #4
/*51667*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::LEA32r), 0,
                      1/*#VTs*/, MVT::i32, 4/*#Ops*/, 1, 2, 3, 4, 
                  // Src: lea32addr:i32:$src
                  // Dst: (LEA32r:i32 lea32addr:i32:$src)
/*51678*/       /*Scope*/ 16, /*->51695*/
/*51679*/         OPC_CheckPatternPredicate, 3, // (Subtarget->is64Bit())
/*51681*/         OPC_CheckComplexPat, /*CP*/3, /*#*/0, // SelectLEAAddr:$src #1 #2 #3 #4
/*51684*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::LEA64_32r), 0,
                      1/*#VTs*/, MVT::i32, 4/*#Ops*/, 1, 2, 3, 4, 
                  // Src: lea32addr:i32:$src
                  // Dst: (LEA64_32r:i32 lea32addr:i32:$src)
/*51695*/       0, /*End of Scope*/
              /*SwitchType*/ 14,  MVT::i64,// ->51712
/*51698*/       OPC_CheckComplexPat, /*CP*/4, /*#*/0, // SelectLEAAddr:$src #1 #2 #3 #4
/*51701*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::LEA64r), 0,
                    1/*#VTs*/, MVT::i64, 4/*#Ops*/, 1, 2, 3, 4, 
                // Src: lea64addr:i64:$src
                // Dst: (LEA64r:i64 lea64addr:i64:$src)
              0, // EndSwitchType
/*51713*/   /*Scope*/ 77|128,1/*205*/, /*->51920*/
/*51715*/     OPC_RecordChild0, // #0 = $src1
/*51716*/     OPC_RecordChild1, // #1 = $src2
/*51717*/     OPC_Scope, 104, /*->51823*/ // 8 children in Scope
/*51719*/       OPC_MoveChild, 1,
/*51721*/       OPC_CheckOpcode, ISD::Constant,
/*51723*/       OPC_Scope, 47, /*->51772*/ // 3 children in Scope
/*51725*/         OPC_CheckPredicate, 11, // Predicate_immSext8
/*51727*/         OPC_MoveParent,
/*51728*/         OPC_SwitchType /*3 cases */, 12,  MVT::i16,// ->51743
/*51731*/           OPC_EmitConvertToTarget, 1,
/*51733*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::IMUL16rri8), 0,
                        2/*#VTs*/, MVT::i16, MVT::i32, 2/*#Ops*/, 0, 2, 
                    // Src: (mul:i16 GR16:i16:$src1, (imm:i16)<<P:Predicate_immSext8>>:$src2)
                    // Dst: (IMUL16rri8:i16 GR16:i16:$src1, (imm:i16):$src2)
                  /*SwitchType*/ 12,  MVT::i32,// ->51757
/*51745*/           OPC_EmitConvertToTarget, 1,
/*51747*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::IMUL32rri8), 0,
                        2/*#VTs*/, MVT::i32, MVT::i32, 2/*#Ops*/, 0, 2, 
                    // Src: (mul:i32 GR32:i32:$src1, (imm:i32)<<P:Predicate_immSext8>>:$src2)
                    // Dst: (IMUL32rri8:i32 GR32:i32:$src1, (imm:i32):$src2)
                  /*SwitchType*/ 12,  MVT::i64,// ->51771
/*51759*/           OPC_EmitConvertToTarget, 1,
/*51761*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::IMUL64rri8), 0,
                        2/*#VTs*/, MVT::i64, MVT::i32, 2/*#Ops*/, 0, 2, 
                    // Src: (mul:i64 GR64:i64:$src1, (imm:i64)<<P:Predicate_immSext8>>:$src2)
                    // Dst: (IMUL64rri8:i64 GR64:i64:$src1, (imm:i64):$src2)
                  0, // EndSwitchType
/*51772*/       /*Scope*/ 17, /*->51790*/
/*51773*/         OPC_CheckPredicate, 12, // Predicate_i64immSExt32
/*51775*/         OPC_MoveParent,
/*51776*/         OPC_CheckType, MVT::i64,
/*51778*/         OPC_EmitConvertToTarget, 1,
/*51780*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::IMUL64rri32), 0,
                      2/*#VTs*/, MVT::i64, MVT::i32, 2/*#Ops*/, 0, 2, 
                  // Src: (mul:i64 GR64:i64:$src1, (imm:i64)<<P:Predicate_i64immSExt32>>:$src2)
                  // Dst: (IMUL64rri32:i64 GR64:i64:$src1, (imm:i64):$src2)
/*51790*/       /*Scope*/ 31, /*->51822*/
/*51791*/         OPC_MoveParent,
/*51792*/         OPC_SwitchType /*2 cases */, 12,  MVT::i16,// ->51807
/*51795*/           OPC_EmitConvertToTarget, 1,
/*51797*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::IMUL16rri), 0,
                        2/*#VTs*/, MVT::i16, MVT::i32, 2/*#Ops*/, 0, 2, 
                    // Src: (mul:i16 GR16:i16:$src1, (imm:i16):$src2)
                    // Dst: (IMUL16rri:i16 GR16:i16:$src1, (imm:i16):$src2)
                  /*SwitchType*/ 12,  MVT::i32,// ->51821
/*51809*/           OPC_EmitConvertToTarget, 1,
/*51811*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::IMUL32rri), 0,
                        2/*#VTs*/, MVT::i32, MVT::i32, 2/*#Ops*/, 0, 2, 
                    // Src: (mul:i32 GR32:i32:$src1, (imm:i32):$src2)
                    // Dst: (IMUL32rri:i32 GR32:i32:$src1, (imm:i32):$src2)
                  0, // EndSwitchType
/*51822*/       0, /*End of Scope*/
/*51823*/     /*Scope*/ 14, /*->51838*/
/*51824*/       OPC_CheckType, MVT::i8,
/*51826*/       OPC_EmitCopyToReg, 0, X86::AL,
/*51829*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MUL8r), 0|OPFL_FlagInput,
                    2/*#VTs*/, MVT::i8, MVT::i32, 1/*#Ops*/, 1, 
                // Src: (mul:i8 AL:i8, GR8:i8:$src)
                // Dst: (MUL8r:isVoid GR8:i8:$src)
/*51838*/     /*Scope*/ 12, /*->51851*/
/*51839*/       OPC_CheckType, MVT::i16,
/*51841*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::IMUL16rr), 0,
                    2/*#VTs*/, MVT::i16, MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (mul:i16 GR16:i16:$src1, GR16:i16:$src2)
                // Dst: (IMUL16rr:i16 GR16:i16:$src1, GR16:i16:$src2)
/*51851*/     /*Scope*/ 12, /*->51864*/
/*51852*/       OPC_CheckType, MVT::i32,
/*51854*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::IMUL32rr), 0,
                    2/*#VTs*/, MVT::i32, MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (mul:i32 GR32:i32:$src1, GR32:i32:$src2)
                // Dst: (IMUL32rr:i32 GR32:i32:$src1, GR32:i32:$src2)
/*51864*/     /*Scope*/ 12, /*->51877*/
/*51865*/       OPC_CheckType, MVT::i64,
/*51867*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::IMUL64rr), 0,
                    2/*#VTs*/, MVT::i64, MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (mul:i64 GR64:i64:$src1, GR64:i64:$src2)
                // Dst: (IMUL64rr:i64 GR64:i64:$src1, GR64:i64:$src2)
/*51877*/     /*Scope*/ 13, /*->51891*/
/*51878*/       OPC_CheckType, MVT::v8i16,
/*51880*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*51882*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PMULLWrr), 0,
                    1/*#VTs*/, MVT::v8i16, 2/*#Ops*/, 0, 1, 
                // Src: (mul:v8i16 VR128:v8i16:$src1, VR128:v8i16:$src2)
                // Dst: (PMULLWrr:v8i16 VR128:v8i16:$src1, VR128:v8i16:$src2)
/*51891*/     /*Scope*/ 13, /*->51905*/
/*51892*/       OPC_CheckType, MVT::v4i32,
/*51894*/       OPC_CheckPatternPredicate, 4, // (Subtarget->hasSSE41())
/*51896*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PMULLDrr), 0,
                    1/*#VTs*/, MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (mul:v4i32 VR128:v4i32:$src1, VR128:v4i32:$src2)
                // Dst: (PMULLDrr:v4i32 VR128:v4i32:$src1, VR128:v4i32:$src2)
/*51905*/     /*Scope*/ 13, /*->51919*/
/*51906*/       OPC_CheckType, MVT::v4i16,
/*51908*/       OPC_CheckPatternPredicate, 8, // (Subtarget->hasMMX())
/*51910*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PMULLWrr), 0,
                    1/*#VTs*/, MVT::v4i16, 2/*#Ops*/, 0, 1, 
                // Src: (mul:v4i16 VR64:v4i16:$src1, VR64:v4i16:$src2)
                // Dst: (MMX_PMULLWrr:v4i16 VR64:v4i16:$src1, VR64:v4i16:$src2)
/*51919*/     0, /*End of Scope*/
/*51920*/   0, /*End of Scope*/
          /*SwitchOpcode*/ 100|128,1/*228*/,  X86ISD::BT,// ->52152
/*51924*/   OPC_Scope, 116, /*->52042*/ // 2 children in Scope
/*51926*/     OPC_MoveChild, 0,
/*51928*/     OPC_CheckOpcode, ISD::LOAD,
/*51930*/     OPC_RecordMemRef,
/*51931*/     OPC_RecordNode, // #0 = 'ld' chained node
/*51932*/     OPC_CheckFoldableChainNode,
/*51933*/     OPC_RecordChild1, // #1 = $src1
/*51934*/     OPC_CheckPredicate, 2, // Predicate_unindexedload
/*51936*/     OPC_SwitchType /*3 cases */, 32,  MVT::i16,// ->51971
/*51939*/       OPC_CheckPredicate, 6, // Predicate_loadi16
/*51941*/       OPC_MoveParent,
/*51942*/       OPC_RecordChild1, // #2 = $src2
/*51943*/       OPC_MoveChild, 1,
/*51945*/       OPC_CheckOpcode, ISD::Constant,
/*51947*/       OPC_CheckPredicate, 11, // Predicate_immSext8
/*51949*/       OPC_MoveParent,
/*51950*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src1 #3 #4 #5 #6 #7
/*51953*/       OPC_EmitMergeInputChains, 1, 0, 
/*51956*/       OPC_EmitConvertToTarget, 2,
/*51958*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::BT16mi8), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::i32, 6/*#Ops*/, 3, 4, 5, 6, 7, 8, 
                // Src: (X86bt:isVoid (ld:i16 addr:iPTR:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, (imm:i16)<<P:Predicate_immSext8>>:$src2)
                // Dst: (BT16mi8:isVoid addr:iPTR:$src1, (imm:i16):$src2)
              /*SwitchType*/ 32,  MVT::i32,// ->52005
/*51973*/       OPC_CheckPredicate, 3, // Predicate_loadi32
/*51975*/       OPC_MoveParent,
/*51976*/       OPC_RecordChild1, // #2 = $src2
/*51977*/       OPC_MoveChild, 1,
/*51979*/       OPC_CheckOpcode, ISD::Constant,
/*51981*/       OPC_CheckPredicate, 11, // Predicate_immSext8
/*51983*/       OPC_MoveParent,
/*51984*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src1 #3 #4 #5 #6 #7
/*51987*/       OPC_EmitMergeInputChains, 1, 0, 
/*51990*/       OPC_EmitConvertToTarget, 2,
/*51992*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::BT32mi8), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::i32, 6/*#Ops*/, 3, 4, 5, 6, 7, 8, 
                // Src: (X86bt:isVoid (ld:i32 addr:iPTR:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, (imm:i32)<<P:Predicate_immSext8>>:$src2)
                // Dst: (BT32mi8:isVoid addr:iPTR:$src1, (imm:i32):$src2)
              /*SwitchType*/ 34,  MVT::i64,// ->52041
/*52007*/       OPC_CheckPredicate, 8, // Predicate_load
/*52009*/       OPC_CheckPredicate, 9, // Predicate_dsload
/*52011*/       OPC_MoveParent,
/*52012*/       OPC_RecordChild1, // #2 = $src2
/*52013*/       OPC_MoveChild, 1,
/*52015*/       OPC_CheckOpcode, ISD::Constant,
/*52017*/       OPC_CheckPredicate, 11, // Predicate_immSext8
/*52019*/       OPC_MoveParent,
/*52020*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src1 #3 #4 #5 #6 #7
/*52023*/       OPC_EmitMergeInputChains, 1, 0, 
/*52026*/       OPC_EmitConvertToTarget, 2,
/*52028*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::BT64mi8), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::i32, 6/*#Ops*/, 3, 4, 5, 6, 7, 8, 
                // Src: (X86bt:isVoid (ld:i64 addr:iPTR:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>, (imm:i64)<<P:Predicate_immSext8>>:$src2)
                // Dst: (BT64mi8:isVoid addr:iPTR:$src1, (imm:i64):$src2)
              0, // EndSwitchType
/*52042*/   /*Scope*/ 108, /*->52151*/
/*52043*/     OPC_RecordChild0, // #0 = $src1
/*52044*/     OPC_Scope, 34, /*->52080*/ // 3 children in Scope
/*52046*/       OPC_CheckChild0Type, MVT::i16,
/*52048*/       OPC_RecordChild1, // #1 = $src2
/*52049*/       OPC_Scope, 18, /*->52069*/ // 2 children in Scope
/*52051*/         OPC_MoveChild, 1,
/*52053*/         OPC_CheckOpcode, ISD::Constant,
/*52055*/         OPC_CheckPredicate, 11, // Predicate_immSext8
/*52057*/         OPC_MoveParent,
/*52058*/         OPC_EmitConvertToTarget, 1,
/*52060*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::BT16ri8), 0,
                      1/*#VTs*/, MVT::i32, 2/*#Ops*/, 0, 2, 
                  // Src: (X86bt:isVoid GR16:i16:$src1, (imm:i16)<<P:Predicate_immSext8>>:$src2)
                  // Dst: (BT16ri8:isVoid GR16:i16:$src1, (imm:i16):$src2)
/*52069*/       /*Scope*/ 9, /*->52079*/
/*52070*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::BT16rr), 0,
                      1/*#VTs*/, MVT::i32, 2/*#Ops*/, 0, 1, 
                  // Src: (X86bt:isVoid GR16:i16:$src1, GR16:i16:$src2)
                  // Dst: (BT16rr:isVoid GR16:i16:$src1, GR16:i16:$src2)
/*52079*/       0, /*End of Scope*/
/*52080*/     /*Scope*/ 34, /*->52115*/
/*52081*/       OPC_CheckChild0Type, MVT::i32,
/*52083*/       OPC_RecordChild1, // #1 = $src2
/*52084*/       OPC_Scope, 18, /*->52104*/ // 2 children in Scope
/*52086*/         OPC_MoveChild, 1,
/*52088*/         OPC_CheckOpcode, ISD::Constant,
/*52090*/         OPC_CheckPredicate, 11, // Predicate_immSext8
/*52092*/         OPC_MoveParent,
/*52093*/         OPC_EmitConvertToTarget, 1,
/*52095*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::BT32ri8), 0,
                      1/*#VTs*/, MVT::i32, 2/*#Ops*/, 0, 2, 
                  // Src: (X86bt:isVoid GR32:i32:$src1, (imm:i32)<<P:Predicate_immSext8>>:$src2)
                  // Dst: (BT32ri8:isVoid GR32:i32:$src1, (imm:i32):$src2)
/*52104*/       /*Scope*/ 9, /*->52114*/
/*52105*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::BT32rr), 0,
                      1/*#VTs*/, MVT::i32, 2/*#Ops*/, 0, 1, 
                  // Src: (X86bt:isVoid GR32:i32:$src1, GR32:i32:$src2)
                  // Dst: (BT32rr:isVoid GR32:i32:$src1, GR32:i32:$src2)
/*52114*/       0, /*End of Scope*/
/*52115*/     /*Scope*/ 34, /*->52150*/
/*52116*/       OPC_CheckChild0Type, MVT::i64,
/*52118*/       OPC_RecordChild1, // #1 = $src2
/*52119*/       OPC_Scope, 18, /*->52139*/ // 2 children in Scope
/*52121*/         OPC_MoveChild, 1,
/*52123*/         OPC_CheckOpcode, ISD::Constant,
/*52125*/         OPC_CheckPredicate, 11, // Predicate_immSext8
/*52127*/         OPC_MoveParent,
/*52128*/         OPC_EmitConvertToTarget, 1,
/*52130*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::BT64ri8), 0,
                      1/*#VTs*/, MVT::i32, 2/*#Ops*/, 0, 2, 
                  // Src: (X86bt:isVoid GR64:i64:$src1, (imm:i64)<<P:Predicate_immSext8>>:$src2)
                  // Dst: (BT64ri8:isVoid GR64:i64:$src1, (imm:i64):$src2)
/*52139*/       /*Scope*/ 9, /*->52149*/
/*52140*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::BT64rr), 0,
                      1/*#VTs*/, MVT::i32, 2/*#Ops*/, 0, 1, 
                  // Src: (X86bt:isVoid GR64:i64:$src1, GR64:i64:$src2)
                  // Dst: (BT64rr:isVoid GR64:i64:$src1, GR64:i64:$src2)
/*52149*/       0, /*End of Scope*/
/*52150*/     0, /*End of Scope*/
/*52151*/   0, /*End of Scope*/
          /*SwitchOpcode*/ 89|128,4/*601*/,  X86ISD::SMUL,// ->52756
/*52155*/   OPC_Scope, 93|128,1/*221*/, /*->52379*/ // 4 children in Scope
/*52158*/     OPC_MoveChild, 0,
/*52160*/     OPC_CheckOpcode, ISD::LOAD,
/*52162*/     OPC_RecordMemRef,
/*52163*/     OPC_RecordNode, // #0 = 'ld' chained node
/*52164*/     OPC_CheckFoldableChainNode,
/*52165*/     OPC_RecordChild1, // #1 = $src1
/*52166*/     OPC_CheckPredicate, 2, // Predicate_unindexedload
/*52168*/     OPC_Scope, 35, /*->52205*/ // 5 children in Scope
/*52170*/       OPC_CheckPredicate, 6, // Predicate_loadi16
/*52172*/       OPC_MoveParent,
/*52173*/       OPC_RecordChild1, // #2 = $src2
/*52174*/       OPC_MoveChild, 1,
/*52176*/       OPC_CheckOpcode, ISD::Constant,
/*52178*/       OPC_CheckPredicate, 11, // Predicate_immSext8
/*52180*/       OPC_MoveParent,
/*52181*/       OPC_CheckType, MVT::i16,
/*52183*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src1 #3 #4 #5 #6 #7
/*52186*/       OPC_EmitMergeInputChains, 1, 0, 
/*52189*/       OPC_EmitConvertToTarget, 2,
/*52191*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::IMUL16rmi8), 0|OPFL_Chain|OPFL_MemRefs,
                    2/*#VTs*/, MVT::i16, MVT::i32, 6/*#Ops*/, 3, 4, 5, 6, 7, 8, 
                // Src: (X86smul_flag:i16 (ld:i16 addr:iPTR:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, (imm:i16)<<P:Predicate_immSext8>>:$src2)
                // Dst: (IMUL16rmi8:i16 addr:iPTR:$src1, (imm:i16)<<P:Predicate_immSext8>>:$src2)
/*52205*/     /*Scope*/ 35, /*->52241*/
/*52206*/       OPC_CheckPredicate, 3, // Predicate_loadi32
/*52208*/       OPC_MoveParent,
/*52209*/       OPC_RecordChild1, // #2 = $src2
/*52210*/       OPC_MoveChild, 1,
/*52212*/       OPC_CheckOpcode, ISD::Constant,
/*52214*/       OPC_CheckPredicate, 11, // Predicate_immSext8
/*52216*/       OPC_MoveParent,
/*52217*/       OPC_CheckType, MVT::i32,
/*52219*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src1 #3 #4 #5 #6 #7
/*52222*/       OPC_EmitMergeInputChains, 1, 0, 
/*52225*/       OPC_EmitConvertToTarget, 2,
/*52227*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::IMUL32rmi8), 0|OPFL_Chain|OPFL_MemRefs,
                    2/*#VTs*/, MVT::i32, MVT::i32, 6/*#Ops*/, 3, 4, 5, 6, 7, 8, 
                // Src: (X86smul_flag:i32 (ld:i32 addr:iPTR:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, (imm:i32)<<P:Predicate_immSext8>>:$src2)
                // Dst: (IMUL32rmi8:i32 addr:iPTR:$src1, (imm:i32)<<P:Predicate_immSext8>>:$src2)
/*52241*/     /*Scope*/ 68, /*->52310*/
/*52242*/       OPC_CheckPredicate, 8, // Predicate_load
/*52244*/       OPC_CheckPredicate, 9, // Predicate_dsload
/*52246*/       OPC_MoveParent,
/*52247*/       OPC_RecordChild1, // #2 = $src2
/*52248*/       OPC_MoveChild, 1,
/*52250*/       OPC_CheckOpcode, ISD::Constant,
/*52252*/       OPC_Scope, 27, /*->52281*/ // 2 children in Scope
/*52254*/         OPC_CheckPredicate, 11, // Predicate_immSext8
/*52256*/         OPC_MoveParent,
/*52257*/         OPC_CheckType, MVT::i64,
/*52259*/         OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src1 #3 #4 #5 #6 #7
/*52262*/         OPC_EmitMergeInputChains, 1, 0, 
/*52265*/         OPC_EmitConvertToTarget, 2,
/*52267*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::IMUL64rmi8), 0|OPFL_Chain|OPFL_MemRefs,
                      2/*#VTs*/, MVT::i64, MVT::i32, 6/*#Ops*/, 3, 4, 5, 6, 7, 8, 
                  // Src: (X86smul_flag:i64 (ld:i64 addr:iPTR:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>, (imm:i64)<<P:Predicate_immSext8>>:$src2)
                  // Dst: (IMUL64rmi8:i64 addr:iPTR:$src1, (imm:i64)<<P:Predicate_immSext8>>:$src2)
/*52281*/       /*Scope*/ 27, /*->52309*/
/*52282*/         OPC_CheckPredicate, 12, // Predicate_i64immSExt32
/*52284*/         OPC_MoveParent,
/*52285*/         OPC_CheckType, MVT::i64,
/*52287*/         OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src1 #3 #4 #5 #6 #7
/*52290*/         OPC_EmitMergeInputChains, 1, 0, 
/*52293*/         OPC_EmitConvertToTarget, 2,
/*52295*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::IMUL64rmi32), 0|OPFL_Chain|OPFL_MemRefs,
                      2/*#VTs*/, MVT::i64, MVT::i32, 6/*#Ops*/, 3, 4, 5, 6, 7, 8, 
                  // Src: (X86smul_flag:i64 (ld:i64 addr:iPTR:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>, (imm:i64)<<P:Predicate_i64immSExt32>>:$src2)
                  // Dst: (IMUL64rmi32:i64 addr:iPTR:$src1, (imm:i64)<<P:Predicate_i64immSExt32>>:$src2)
/*52309*/       0, /*End of Scope*/
/*52310*/     /*Scope*/ 33, /*->52344*/
/*52311*/       OPC_CheckPredicate, 6, // Predicate_loadi16
/*52313*/       OPC_MoveParent,
/*52314*/       OPC_RecordChild1, // #2 = $src2
/*52315*/       OPC_MoveChild, 1,
/*52317*/       OPC_CheckOpcode, ISD::Constant,
/*52319*/       OPC_MoveParent,
/*52320*/       OPC_CheckType, MVT::i16,
/*52322*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src1 #3 #4 #5 #6 #7
/*52325*/       OPC_EmitMergeInputChains, 1, 0, 
/*52328*/       OPC_EmitConvertToTarget, 2,
/*52330*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::IMUL16rmi), 0|OPFL_Chain|OPFL_MemRefs,
                    2/*#VTs*/, MVT::i16, MVT::i32, 6/*#Ops*/, 3, 4, 5, 6, 7, 8, 
                // Src: (X86smul_flag:i16 (ld:i16 addr:iPTR:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, (imm:i16):$src2)
                // Dst: (IMUL16rmi:i16 addr:iPTR:$src1, (imm:i16):$src2)
/*52344*/     /*Scope*/ 33, /*->52378*/
/*52345*/       OPC_CheckPredicate, 3, // Predicate_loadi32
/*52347*/       OPC_MoveParent,
/*52348*/       OPC_RecordChild1, // #2 = $src2
/*52349*/       OPC_MoveChild, 1,
/*52351*/       OPC_CheckOpcode, ISD::Constant,
/*52353*/       OPC_MoveParent,
/*52354*/       OPC_CheckType, MVT::i32,
/*52356*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src1 #3 #4 #5 #6 #7
/*52359*/       OPC_EmitMergeInputChains, 1, 0, 
/*52362*/       OPC_EmitConvertToTarget, 2,
/*52364*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::IMUL32rmi), 0|OPFL_Chain|OPFL_MemRefs,
                    2/*#VTs*/, MVT::i32, MVT::i32, 6/*#Ops*/, 3, 4, 5, 6, 7, 8, 
                // Src: (X86smul_flag:i32 (ld:i32 addr:iPTR:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, (imm:i32):$src2)
                // Dst: (IMUL32rmi:i32 addr:iPTR:$src1, (imm:i32):$src2)
/*52378*/     0, /*End of Scope*/
/*52379*/   /*Scope*/ 93, /*->52473*/
/*52380*/     OPC_RecordChild0, // #0 = $src1
/*52381*/     OPC_MoveChild, 1,
/*52383*/     OPC_CheckOpcode, ISD::LOAD,
/*52385*/     OPC_RecordMemRef,
/*52386*/     OPC_RecordNode, // #1 = 'ld' chained node
/*52387*/     OPC_CheckFoldableChainNode,
/*52388*/     OPC_RecordChild1, // #2 = $src2
/*52389*/     OPC_CheckPredicate, 2, // Predicate_unindexedload
/*52391*/     OPC_Scope, 25, /*->52418*/ // 3 children in Scope
/*52393*/       OPC_CheckPredicate, 6, // Predicate_loadi16
/*52395*/       OPC_MoveParent,
/*52396*/       OPC_CheckType, MVT::i16,
/*52398*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*52401*/       OPC_EmitMergeInputChains, 1, 1, 
/*52404*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::IMUL16rm), 0|OPFL_Chain|OPFL_MemRefs,
                    2/*#VTs*/, MVT::i16, MVT::i32, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (X86smul_flag:i16 GR16:i16:$src1, (ld:i16 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>)
                // Dst: (IMUL16rm:i16 GR16:i16:$src1, addr:iPTR:$src2)
/*52418*/     /*Scope*/ 25, /*->52444*/
/*52419*/       OPC_CheckPredicate, 3, // Predicate_loadi32
/*52421*/       OPC_MoveParent,
/*52422*/       OPC_CheckType, MVT::i32,
/*52424*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*52427*/       OPC_EmitMergeInputChains, 1, 1, 
/*52430*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::IMUL32rm), 0|OPFL_Chain|OPFL_MemRefs,
                    2/*#VTs*/, MVT::i32, MVT::i32, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (X86smul_flag:i32 GR32:i32:$src1, (ld:i32 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)
                // Dst: (IMUL32rm:i32 GR32:i32:$src1, addr:iPTR:$src2)
/*52444*/     /*Scope*/ 27, /*->52472*/
/*52445*/       OPC_CheckPredicate, 8, // Predicate_load
/*52447*/       OPC_CheckPredicate, 9, // Predicate_dsload
/*52449*/       OPC_MoveParent,
/*52450*/       OPC_CheckType, MVT::i64,
/*52452*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*52455*/       OPC_EmitMergeInputChains, 1, 1, 
/*52458*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::IMUL64rm), 0|OPFL_Chain|OPFL_MemRefs,
                    2/*#VTs*/, MVT::i64, MVT::i32, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (X86smul_flag:i64 GR64:i64:$src1, (ld:i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>)
                // Dst: (IMUL64rm:i64 GR64:i64:$src1, addr:iPTR:$src2)
/*52472*/     0, /*End of Scope*/
/*52473*/   /*Scope*/ 95, /*->52569*/
/*52474*/     OPC_MoveChild, 0,
/*52476*/     OPC_CheckOpcode, ISD::LOAD,
/*52478*/     OPC_RecordMemRef,
/*52479*/     OPC_RecordNode, // #0 = 'ld' chained node
/*52480*/     OPC_CheckFoldableChainNode,
/*52481*/     OPC_RecordChild1, // #1 = $src2
/*52482*/     OPC_CheckPredicate, 2, // Predicate_unindexedload
/*52484*/     OPC_Scope, 26, /*->52512*/ // 3 children in Scope
/*52486*/       OPC_CheckPredicate, 6, // Predicate_loadi16
/*52488*/       OPC_MoveParent,
/*52489*/       OPC_RecordChild1, // #2 = $src1
/*52490*/       OPC_CheckType, MVT::i16,
/*52492*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*52495*/       OPC_EmitMergeInputChains, 1, 0, 
/*52498*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::IMUL16rm), 0|OPFL_Chain|OPFL_MemRefs,
                    2/*#VTs*/, MVT::i16, MVT::i32, 6/*#Ops*/, 2, 3, 4, 5, 6, 7, 
                // Src: (X86smul_flag:i16 (ld:i16 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, GR16:i16:$src1)
                // Dst: (IMUL16rm:i16 GR16:i16:$src1, addr:iPTR:$src2)
/*52512*/     /*Scope*/ 26, /*->52539*/
/*52513*/       OPC_CheckPredicate, 3, // Predicate_loadi32
/*52515*/       OPC_MoveParent,
/*52516*/       OPC_RecordChild1, // #2 = $src1
/*52517*/       OPC_CheckType, MVT::i32,
/*52519*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*52522*/       OPC_EmitMergeInputChains, 1, 0, 
/*52525*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::IMUL32rm), 0|OPFL_Chain|OPFL_MemRefs,
                    2/*#VTs*/, MVT::i32, MVT::i32, 6/*#Ops*/, 2, 3, 4, 5, 6, 7, 
                // Src: (X86smul_flag:i32 (ld:i32 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, GR32:i32:$src1)
                // Dst: (IMUL32rm:i32 GR32:i32:$src1, addr:iPTR:$src2)
/*52539*/     /*Scope*/ 28, /*->52568*/
/*52540*/       OPC_CheckPredicate, 8, // Predicate_load
/*52542*/       OPC_CheckPredicate, 9, // Predicate_dsload
/*52544*/       OPC_MoveParent,
/*52545*/       OPC_RecordChild1, // #2 = $src1
/*52546*/       OPC_CheckType, MVT::i64,
/*52548*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*52551*/       OPC_EmitMergeInputChains, 1, 0, 
/*52554*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::IMUL64rm), 0|OPFL_Chain|OPFL_MemRefs,
                    2/*#VTs*/, MVT::i64, MVT::i32, 6/*#Ops*/, 2, 3, 4, 5, 6, 7, 
                // Src: (X86smul_flag:i64 (ld:i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>, GR64:i64:$src1)
                // Dst: (IMUL64rm:i64 GR64:i64:$src1, addr:iPTR:$src2)
/*52568*/     0, /*End of Scope*/
/*52569*/   /*Scope*/ 56|128,1/*184*/, /*->52755*/
/*52571*/     OPC_RecordChild0, // #0 = $src1
/*52572*/     OPC_Scope, 31, /*->52605*/ // 2 children in Scope
/*52574*/       OPC_MoveChild, 1,
/*52576*/       OPC_CheckInteger, 2, 
/*52578*/       OPC_MoveParent,
/*52579*/       OPC_SwitchType /*2 cases */, 10,  MVT::i16,// ->52592
/*52582*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::ADD16rr), 0,
                      2/*#VTs*/, MVT::i16, MVT::i32, 2/*#Ops*/, 0, 0, 
                  // Src: (X86smul_flag:i16 GR16:i16:$src1, 2:i16)
                  // Dst: (ADD16rr:i16 GR16:i16:$src1, GR16:i16:$src1)
                /*SwitchType*/ 10,  MVT::i32,// ->52604
/*52594*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::ADD32rr), 0,
                      2/*#VTs*/, MVT::i32, MVT::i32, 2/*#Ops*/, 0, 0, 
                  // Src: (X86smul_flag:i32 GR32:i32:$src1, 2:i32)
                  // Dst: (ADD32rr:i32 GR32:i32:$src1, GR32:i32:$src1)
                0, // EndSwitchType
/*52605*/     /*Scope*/ 19|128,1/*147*/, /*->52754*/
/*52607*/       OPC_RecordChild1, // #1 = $src2
/*52608*/       OPC_Scope, 104, /*->52714*/ // 4 children in Scope
/*52610*/         OPC_MoveChild, 1,
/*52612*/         OPC_CheckOpcode, ISD::Constant,
/*52614*/         OPC_Scope, 47, /*->52663*/ // 3 children in Scope
/*52616*/           OPC_CheckPredicate, 11, // Predicate_immSext8
/*52618*/           OPC_MoveParent,
/*52619*/           OPC_SwitchType /*3 cases */, 12,  MVT::i16,// ->52634
/*52622*/             OPC_EmitConvertToTarget, 1,
/*52624*/             OPC_MorphNodeTo, TARGET_OPCODE(X86::IMUL16rri8), 0,
                          2/*#VTs*/, MVT::i16, MVT::i32, 2/*#Ops*/, 0, 2, 
                      // Src: (X86smul_flag:i16 GR16:i16:$src1, (imm:i16)<<P:Predicate_immSext8>>:$src2)
                      // Dst: (IMUL16rri8:i16 GR16:i16:$src1, (imm:i16)<<P:Predicate_immSext8>>:$src2)
                    /*SwitchType*/ 12,  MVT::i32,// ->52648
/*52636*/             OPC_EmitConvertToTarget, 1,
/*52638*/             OPC_MorphNodeTo, TARGET_OPCODE(X86::IMUL32rri8), 0,
                          2/*#VTs*/, MVT::i32, MVT::i32, 2/*#Ops*/, 0, 2, 
                      // Src: (X86smul_flag:i32 GR32:i32:$src1, (imm:i32)<<P:Predicate_immSext8>>:$src2)
                      // Dst: (IMUL32rri8:i32 GR32:i32:$src1, (imm:i32)<<P:Predicate_immSext8>>:$src2)
                    /*SwitchType*/ 12,  MVT::i64,// ->52662
/*52650*/             OPC_EmitConvertToTarget, 1,
/*52652*/             OPC_MorphNodeTo, TARGET_OPCODE(X86::IMUL64rri8), 0,
                          2/*#VTs*/, MVT::i64, MVT::i32, 2/*#Ops*/, 0, 2, 
                      // Src: (X86smul_flag:i64 GR64:i64:$src1, (imm:i64)<<P:Predicate_immSext8>>:$src2)
                      // Dst: (IMUL64rri8:i64 GR64:i64:$src1, (imm:i64)<<P:Predicate_immSext8>>:$src2)
                    0, // EndSwitchType
/*52663*/         /*Scope*/ 17, /*->52681*/
/*52664*/           OPC_CheckPredicate, 12, // Predicate_i64immSExt32
/*52666*/           OPC_MoveParent,
/*52667*/           OPC_CheckType, MVT::i64,
/*52669*/           OPC_EmitConvertToTarget, 1,
/*52671*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::IMUL64rri32), 0,
                        2/*#VTs*/, MVT::i64, MVT::i32, 2/*#Ops*/, 0, 2, 
                    // Src: (X86smul_flag:i64 GR64:i64:$src1, (imm:i64)<<P:Predicate_i64immSExt32>>:$src2)
                    // Dst: (IMUL64rri32:i64 GR64:i64:$src1, (imm:i64)<<P:Predicate_i64immSExt32>>:$src2)
/*52681*/         /*Scope*/ 31, /*->52713*/
/*52682*/           OPC_MoveParent,
/*52683*/           OPC_SwitchType /*2 cases */, 12,  MVT::i16,// ->52698
/*52686*/             OPC_EmitConvertToTarget, 1,
/*52688*/             OPC_MorphNodeTo, TARGET_OPCODE(X86::IMUL16rri), 0,
                          2/*#VTs*/, MVT::i16, MVT::i32, 2/*#Ops*/, 0, 2, 
                      // Src: (X86smul_flag:i16 GR16:i16:$src1, (imm:i16):$src2)
                      // Dst: (IMUL16rri:i16 GR16:i16:$src1, (imm:i16):$src2)
                    /*SwitchType*/ 12,  MVT::i32,// ->52712
/*52700*/             OPC_EmitConvertToTarget, 1,
/*52702*/             OPC_MorphNodeTo, TARGET_OPCODE(X86::IMUL32rri), 0,
                          2/*#VTs*/, MVT::i32, MVT::i32, 2/*#Ops*/, 0, 2, 
                      // Src: (X86smul_flag:i32 GR32:i32:$src1, (imm:i32):$src2)
                      // Dst: (IMUL32rri:i32 GR32:i32:$src1, (imm:i32):$src2)
                    0, // EndSwitchType
/*52713*/         0, /*End of Scope*/
/*52714*/       /*Scope*/ 12, /*->52727*/
/*52715*/         OPC_CheckType, MVT::i16,
/*52717*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::IMUL16rr), 0,
                      2/*#VTs*/, MVT::i16, MVT::i32, 2/*#Ops*/, 0, 1, 
                  // Src: (X86smul_flag:i16 GR16:i16:$src1, GR16:i16:$src2)
                  // Dst: (IMUL16rr:i16 GR16:i16:$src1, GR16:i16:$src2)
/*52727*/       /*Scope*/ 12, /*->52740*/
/*52728*/         OPC_CheckType, MVT::i32,
/*52730*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::IMUL32rr), 0,
                      2/*#VTs*/, MVT::i32, MVT::i32, 2/*#Ops*/, 0, 1, 
                  // Src: (X86smul_flag:i32 GR32:i32:$src1, GR32:i32:$src2)
                  // Dst: (IMUL32rr:i32 GR32:i32:$src1, GR32:i32:$src2)
/*52740*/       /*Scope*/ 12, /*->52753*/
/*52741*/         OPC_CheckType, MVT::i64,
/*52743*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::IMUL64rr), 0,
                      2/*#VTs*/, MVT::i64, MVT::i32, 2/*#Ops*/, 0, 1, 
                  // Src: (X86smul_flag:i64 GR64:i64:$src1, GR64:i64:$src2)
                  // Dst: (IMUL64rr:i64 GR64:i64:$src1, GR64:i64:$src2)
/*52753*/       0, /*End of Scope*/
/*52754*/     0, /*End of Scope*/
/*52755*/   0, /*End of Scope*/
          /*SwitchOpcode*/ 105,  ISD::PREFETCH,// ->52863
/*52758*/   OPC_RecordNode,   // #0 = 'prefetch' chained node
/*52759*/   OPC_RecordChild1, // #1 = $src
/*52760*/   OPC_MoveChild, 2,
/*52762*/   OPC_CheckOpcode, ISD::Constant,
/*52764*/   OPC_CheckType, MVT::i32,
/*52766*/   OPC_MoveParent,
/*52767*/   OPC_MoveChild, 3,
/*52769*/   OPC_Scope, 22, /*->52793*/ // 4 children in Scope
/*52771*/     OPC_CheckInteger, 3, 
/*52773*/     OPC_MoveParent,
/*52774*/     OPC_CheckPatternPredicate, 0, // (Subtarget->hasSSE1())
/*52776*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*52779*/     OPC_EmitMergeInputChains, 1, 0, 
/*52782*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::PREFETCHT0), 0|OPFL_Chain,
                  0/*#VTs*/, 5/*#Ops*/, 2, 3, 4, 5, 6, 
              // Src: (prefetch:isVoid addr:iPTR:$src, (imm:i32), 3:i32)
              // Dst: (PREFETCHT0:isVoid addr:iPTR:$src)
/*52793*/   /*Scope*/ 22, /*->52816*/
/*52794*/     OPC_CheckInteger, 2, 
/*52796*/     OPC_MoveParent,
/*52797*/     OPC_CheckPatternPredicate, 0, // (Subtarget->hasSSE1())
/*52799*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*52802*/     OPC_EmitMergeInputChains, 1, 0, 
/*52805*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::PREFETCHT1), 0|OPFL_Chain,
                  0/*#VTs*/, 5/*#Ops*/, 2, 3, 4, 5, 6, 
              // Src: (prefetch:isVoid addr:iPTR:$src, (imm:i32), 2:i32)
              // Dst: (PREFETCHT1:isVoid addr:iPTR:$src)
/*52816*/   /*Scope*/ 22, /*->52839*/
/*52817*/     OPC_CheckInteger, 1, 
/*52819*/     OPC_MoveParent,
/*52820*/     OPC_CheckPatternPredicate, 0, // (Subtarget->hasSSE1())
/*52822*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*52825*/     OPC_EmitMergeInputChains, 1, 0, 
/*52828*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::PREFETCHT2), 0|OPFL_Chain,
                  0/*#VTs*/, 5/*#Ops*/, 2, 3, 4, 5, 6, 
              // Src: (prefetch:isVoid addr:iPTR:$src, (imm:i32), 1:i32)
              // Dst: (PREFETCHT2:isVoid addr:iPTR:$src)
/*52839*/   /*Scope*/ 22, /*->52862*/
/*52840*/     OPC_CheckInteger, 0, 
/*52842*/     OPC_MoveParent,
/*52843*/     OPC_CheckPatternPredicate, 0, // (Subtarget->hasSSE1())
/*52845*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*52848*/     OPC_EmitMergeInputChains, 1, 0, 
/*52851*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::PREFETCHNTA), 0|OPFL_Chain,
                  0/*#VTs*/, 5/*#Ops*/, 2, 3, 4, 5, 6, 
              // Src: (prefetch:isVoid addr:iPTR:$src, (imm:i32), 0:i32)
              // Dst: (PREFETCHNTA:isVoid addr:iPTR:$src)
/*52862*/   0, /*End of Scope*/
          /*SwitchOpcode*/ 4|128,1/*132*/,  ISD::INSERT_VECTOR_ELT,// ->52998
/*52866*/   OPC_RecordChild0, // #0 = $src1
/*52867*/   OPC_Scope, 86, /*->52955*/ // 2 children in Scope
/*52869*/     OPC_MoveChild, 1,
/*52871*/     OPC_CheckOpcode, ISD::LOAD,
/*52873*/     OPC_RecordMemRef,
/*52874*/     OPC_RecordNode, // #1 = 'ld' chained node
/*52875*/     OPC_CheckFoldableChainNode,
/*52876*/     OPC_RecordChild1, // #2 = $src2
/*52877*/     OPC_CheckPredicate, 2, // Predicate_unindexedload
/*52879*/     OPC_Scope, 37, /*->52918*/ // 2 children in Scope
/*52881*/       OPC_CheckPredicate, 8, // Predicate_load
/*52883*/       OPC_CheckPredicate, 9, // Predicate_dsload
/*52885*/       OPC_MoveParent,
/*52886*/       OPC_RecordChild2, // #3 = $src3
/*52887*/       OPC_MoveChild, 2,
/*52889*/       OPC_CheckOpcode, ISD::Constant,
/*52891*/       OPC_MoveParent,
/*52892*/       OPC_CheckType, MVT::v2i64,
/*52894*/       OPC_CheckPatternPredicate, 4, // (Subtarget->hasSSE41())
/*52896*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #4 #5 #6 #7 #8
/*52899*/       OPC_EmitMergeInputChains, 1, 1, 
/*52902*/       OPC_EmitConvertToTarget, 3,
/*52904*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PINSRQrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v2i64, 7/*#Ops*/, 0, 4, 5, 6, 7, 8, 9, 
                // Src: (insertelt:v2i64 VR128:v2i64:$src1, (ld:i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>, (imm:iPTR):$src3)
                // Dst: (PINSRQrm:v2i64 VR128:v2i64:$src1, addr:iPTR:$src2, (imm:i32):$src3)
/*52918*/     /*Scope*/ 35, /*->52954*/
/*52919*/       OPC_CheckPredicate, 3, // Predicate_loadi32
/*52921*/       OPC_MoveParent,
/*52922*/       OPC_RecordChild2, // #3 = $src3
/*52923*/       OPC_MoveChild, 2,
/*52925*/       OPC_CheckOpcode, ISD::Constant,
/*52927*/       OPC_MoveParent,
/*52928*/       OPC_CheckType, MVT::v4i32,
/*52930*/       OPC_CheckPatternPredicate, 4, // (Subtarget->hasSSE41())
/*52932*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #4 #5 #6 #7 #8
/*52935*/       OPC_EmitMergeInputChains, 1, 1, 
/*52938*/       OPC_EmitConvertToTarget, 3,
/*52940*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PINSRDrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v4i32, 7/*#Ops*/, 0, 4, 5, 6, 7, 8, 9, 
                // Src: (insertelt:v4i32 VR128:v4i32:$src1, (ld:i32 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, (imm:iPTR):$src3)
                // Dst: (PINSRDrm:v4i32 VR128:v4i32:$src1, addr:iPTR:$src2, (imm:i32):$src3)
/*52954*/     0, /*End of Scope*/
/*52955*/   /*Scope*/ 41, /*->52997*/
/*52956*/     OPC_RecordChild1, // #1 = $src2
/*52957*/     OPC_RecordChild2, // #2 = $src3
/*52958*/     OPC_MoveChild, 2,
/*52960*/     OPC_CheckOpcode, ISD::Constant,
/*52962*/     OPC_MoveParent,
/*52963*/     OPC_SwitchType /*2 cases */, 14,  MVT::v2i64,// ->52980
/*52966*/       OPC_CheckPatternPredicate, 4, // (Subtarget->hasSSE41())
/*52968*/       OPC_EmitConvertToTarget, 2,
/*52970*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PINSRQrr), 0,
                    1/*#VTs*/, MVT::v2i64, 3/*#Ops*/, 0, 1, 3, 
                // Src: (insertelt:v2i64 VR128:v2i64:$src1, GR64:i64:$src2, (imm:iPTR):$src3)
                // Dst: (PINSRQrr:v2i64 VR128:v2i64:$src1, GR64:i64:$src2, (imm:i32):$src3)
              /*SwitchType*/ 14,  MVT::v4i32,// ->52996
/*52982*/       OPC_CheckPatternPredicate, 4, // (Subtarget->hasSSE41())
/*52984*/       OPC_EmitConvertToTarget, 2,
/*52986*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PINSRDrr), 0,
                    1/*#VTs*/, MVT::v4i32, 3/*#Ops*/, 0, 1, 3, 
                // Src: (insertelt:v4i32 VR128:v4i32:$src1, GR32:i32:$src2, (imm:iPTR):$src3)
                // Dst: (PINSRDrr:v4i32 VR128:v4i32:$src1, GR32:i32:$src2, (imm:i32):$src3)
              0, // EndSwitchType
/*52997*/   0, /*End of Scope*/
          /*SwitchOpcode*/ 60|128,15/*1980*/,  ISD::OR,// ->54981
/*53001*/   OPC_Scope, 39|128,1/*167*/, /*->53171*/ // 7 children in Scope
/*53004*/     OPC_MoveChild, 0,
/*53006*/     OPC_SwitchOpcode /*2 cases */, 87,  ISD::BIT_CONVERT,// ->53096
/*53009*/       OPC_RecordChild0, // #0 = $src1
/*53010*/       OPC_Scope, 41, /*->53053*/ // 2 children in Scope
/*53012*/         OPC_CheckChild0Type, MVT::v4f32,
/*53014*/         OPC_MoveParent,
/*53015*/         OPC_MoveChild, 1,
/*53017*/         OPC_CheckOpcode, ISD::LOAD,
/*53019*/         OPC_RecordMemRef,
/*53020*/         OPC_RecordNode, // #1 = 'ld' chained node
/*53021*/         OPC_CheckFoldableChainNode,
/*53022*/         OPC_RecordChild1, // #2 = $src2
/*53023*/         OPC_CheckPredicate, 2, // Predicate_unindexedload
/*53025*/         OPC_CheckPredicate, 8, // Predicate_load
/*53027*/         OPC_CheckPredicate, 23, // Predicate_memop
/*53029*/         OPC_MoveParent,
/*53030*/         OPC_CheckType, MVT::v2i64,
/*53032*/         OPC_CheckPatternPredicate, 0, // (Subtarget->hasSSE1())
/*53034*/         OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*53037*/         OPC_EmitMergeInputChains, 1, 1, 
/*53040*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::ORPSrm), 0|OPFL_Chain|OPFL_MemRefs,
                      1/*#VTs*/, MVT::v2i64, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                  // Src: (or:v2i64 (bitconvert:v2i64 VR128:v4f32:$src1), (ld:v2i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>)
                  // Dst: (ORPSrm:v2i64 VR128:v4f32:$src1, addr:iPTR:$src2)
/*53053*/       /*Scope*/ 41, /*->53095*/
/*53054*/         OPC_CheckChild0Type, MVT::v2f64,
/*53056*/         OPC_MoveParent,
/*53057*/         OPC_MoveChild, 1,
/*53059*/         OPC_CheckOpcode, ISD::LOAD,
/*53061*/         OPC_RecordMemRef,
/*53062*/         OPC_RecordNode, // #1 = 'ld' chained node
/*53063*/         OPC_CheckFoldableChainNode,
/*53064*/         OPC_RecordChild1, // #2 = $src2
/*53065*/         OPC_CheckPredicate, 2, // Predicate_unindexedload
/*53067*/         OPC_CheckPredicate, 8, // Predicate_load
/*53069*/         OPC_CheckPredicate, 23, // Predicate_memop
/*53071*/         OPC_MoveParent,
/*53072*/         OPC_CheckType, MVT::v2i64,
/*53074*/         OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*53076*/         OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*53079*/         OPC_EmitMergeInputChains, 1, 1, 
/*53082*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::ORPDrm), 0|OPFL_Chain|OPFL_MemRefs,
                      1/*#VTs*/, MVT::v2i64, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                  // Src: (or:v2i64 (bitconvert:v2i64 VR128:v2f64:$src1), (ld:v2i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>)
                  // Dst: (ORPDrm:v2i64 VR128:v2f64:$src1, addr:iPTR:$src2)
/*53095*/       0, /*End of Scope*/
              /*SwitchOpcode*/ 72,  ISD::LOAD,// ->53170
/*53098*/       OPC_RecordMemRef,
/*53099*/       OPC_RecordNode, // #0 = 'ld' chained node
/*53100*/       OPC_CheckFoldableChainNode,
/*53101*/       OPC_RecordChild1, // #1 = $src2
/*53102*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*53104*/       OPC_CheckPredicate, 8, // Predicate_load
/*53106*/       OPC_CheckPredicate, 23, // Predicate_memop
/*53108*/       OPC_MoveParent,
/*53109*/       OPC_MoveChild, 1,
/*53111*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*53113*/       OPC_RecordChild0, // #2 = $src1
/*53114*/       OPC_Scope, 26, /*->53142*/ // 2 children in Scope
/*53116*/         OPC_CheckChild0Type, MVT::v4f32,
/*53118*/         OPC_MoveParent,
/*53119*/         OPC_CheckType, MVT::v2i64,
/*53121*/         OPC_CheckPatternPredicate, 0, // (Subtarget->hasSSE1())
/*53123*/         OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*53126*/         OPC_EmitMergeInputChains, 1, 0, 
/*53129*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::ORPSrm), 0|OPFL_Chain|OPFL_MemRefs,
                      1/*#VTs*/, MVT::v2i64, 6/*#Ops*/, 2, 3, 4, 5, 6, 7, 
                  // Src: (or:v2i64 (ld:v2i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>, (bitconvert:v2i64 VR128:v4f32:$src1))
                  // Dst: (ORPSrm:v2i64 VR128:v4f32:$src1, addr:iPTR:$src2)
/*53142*/       /*Scope*/ 26, /*->53169*/
/*53143*/         OPC_CheckChild0Type, MVT::v2f64,
/*53145*/         OPC_MoveParent,
/*53146*/         OPC_CheckType, MVT::v2i64,
/*53148*/         OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*53150*/         OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*53153*/         OPC_EmitMergeInputChains, 1, 0, 
/*53156*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::ORPDrm), 0|OPFL_Chain|OPFL_MemRefs,
                      1/*#VTs*/, MVT::v2i64, 6/*#Ops*/, 2, 3, 4, 5, 6, 7, 
                  // Src: (or:v2i64 (ld:v2i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>, (bitconvert:v2i64 VR128:v2f64:$src1))
                  // Dst: (ORPDrm:v2i64 VR128:v2f64:$src1, addr:iPTR:$src2)
/*53169*/       0, /*End of Scope*/
              0, // EndSwitchOpcode
/*53171*/   /*Scope*/ 31|128,1/*159*/, /*->53332*/
/*53173*/     OPC_RecordChild0, // #0 = $src1
/*53174*/     OPC_MoveChild, 1,
/*53176*/     OPC_CheckOpcode, ISD::LOAD,
/*53178*/     OPC_RecordMemRef,
/*53179*/     OPC_RecordNode, // #1 = 'ld' chained node
/*53180*/     OPC_CheckFoldableChainNode,
/*53181*/     OPC_RecordChild1, // #2 = $src2
/*53182*/     OPC_CheckPredicate, 2, // Predicate_unindexedload
/*53184*/     OPC_CheckPredicate, 8, // Predicate_load
/*53186*/     OPC_Scope, 91, /*->53279*/ // 3 children in Scope
/*53188*/       OPC_MoveParent,
/*53189*/       OPC_SwitchType /*4 cases */, 20,  MVT::i8,// ->53212
/*53192*/         OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*53195*/         OPC_EmitMergeInputChains, 1, 1, 
/*53198*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::OR8rm), 0|OPFL_Chain|OPFL_MemRefs,
                      2/*#VTs*/, MVT::i8, MVT::i32, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                  // Src: (or:i8 GR8:i8:$src1, (ld:i8 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)
                  // Dst: (OR8rm:i8 GR8:i8:$src1, addr:iPTR:$src2)
                /*SwitchType*/ 20,  MVT::i16,// ->53234
/*53214*/         OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*53217*/         OPC_EmitMergeInputChains, 1, 1, 
/*53220*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::OR16rm), 0|OPFL_Chain|OPFL_MemRefs,
                      2/*#VTs*/, MVT::i16, MVT::i32, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                  // Src: (or:i16 GR16:i16:$src1, (ld:i16 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)
                  // Dst: (OR16rm:i16 GR16:i16:$src1, addr:iPTR:$src2)
                /*SwitchType*/ 20,  MVT::i32,// ->53256
/*53236*/         OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*53239*/         OPC_EmitMergeInputChains, 1, 1, 
/*53242*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::OR32rm), 0|OPFL_Chain|OPFL_MemRefs,
                      2/*#VTs*/, MVT::i32, MVT::i32, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                  // Src: (or:i32 GR32:i32:$src1, (ld:i32 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)
                  // Dst: (OR32rm:i32 GR32:i32:$src1, addr:iPTR:$src2)
                /*SwitchType*/ 20,  MVT::i64,// ->53278
/*53258*/         OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*53261*/         OPC_EmitMergeInputChains, 1, 1, 
/*53264*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::OR64rm), 0|OPFL_Chain|OPFL_MemRefs,
                      2/*#VTs*/, MVT::i64, MVT::i32, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                  // Src: (or:i64 GR64:i64:$src1, (ld:i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)
                  // Dst: (OR64rm:i64 GR64:i64:$src1, addr:iPTR:$src2)
                0, // EndSwitchType
/*53279*/     /*Scope*/ 26, /*->53306*/
/*53280*/       OPC_CheckPredicate, 23, // Predicate_memop
/*53282*/       OPC_MoveParent,
/*53283*/       OPC_CheckType, MVT::v2i64,
/*53285*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*53287*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*53290*/       OPC_EmitMergeInputChains, 1, 1, 
/*53293*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PORrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v2i64, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (or:v2i64 VR128:v2i64:$src1, (ld:v2i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>)
                // Dst: (PORrm:v2i64 VR128:v2i64:$src1, addr:iPTR:$src2)
/*53306*/     /*Scope*/ 24, /*->53331*/
/*53307*/       OPC_MoveParent,
/*53308*/       OPC_CheckType, MVT::v1i64,
/*53310*/       OPC_CheckPatternPredicate, 8, // (Subtarget->hasMMX())
/*53312*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*53315*/       OPC_EmitMergeInputChains, 1, 1, 
/*53318*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PORrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v1i64, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (or:v1i64 VR64:v1i64:$src1, (ld:v1i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)
                // Dst: (MMX_PORrm:v1i64 VR64:v1i64:$src1, addr:iPTR:$src2)
/*53331*/     0, /*End of Scope*/
/*53332*/   /*Scope*/ 28|128,9/*1180*/, /*->54514*/
/*53334*/     OPC_MoveChild, 0,
/*53336*/     OPC_SwitchOpcode /*3 cases */, 29|128,1/*157*/,  ISD::LOAD,// ->53497
/*53340*/       OPC_RecordMemRef,
/*53341*/       OPC_RecordNode, // #0 = 'ld' chained node
/*53342*/       OPC_CheckFoldableChainNode,
/*53343*/       OPC_RecordChild1, // #1 = $src2
/*53344*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*53346*/       OPC_CheckPredicate, 8, // Predicate_load
/*53348*/       OPC_Scope, 92, /*->53442*/ // 3 children in Scope
/*53350*/         OPC_MoveParent,
/*53351*/         OPC_RecordChild1, // #2 = $src1
/*53352*/         OPC_SwitchType /*4 cases */, 20,  MVT::i8,// ->53375
/*53355*/           OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*53358*/           OPC_EmitMergeInputChains, 1, 0, 
/*53361*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::OR8rm), 0|OPFL_Chain|OPFL_MemRefs,
                        2/*#VTs*/, MVT::i8, MVT::i32, 6/*#Ops*/, 2, 3, 4, 5, 6, 7, 
                    // Src: (or:i8 (ld:i8 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR8:i8:$src1)
                    // Dst: (OR8rm:i8 GR8:i8:$src1, addr:iPTR:$src2)
                  /*SwitchType*/ 20,  MVT::i16,// ->53397
/*53377*/           OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*53380*/           OPC_EmitMergeInputChains, 1, 0, 
/*53383*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::OR16rm), 0|OPFL_Chain|OPFL_MemRefs,
                        2/*#VTs*/, MVT::i16, MVT::i32, 6/*#Ops*/, 2, 3, 4, 5, 6, 7, 
                    // Src: (or:i16 (ld:i16 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR16:i16:$src1)
                    // Dst: (OR16rm:i16 GR16:i16:$src1, addr:iPTR:$src2)
                  /*SwitchType*/ 20,  MVT::i32,// ->53419
/*53399*/           OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*53402*/           OPC_EmitMergeInputChains, 1, 0, 
/*53405*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::OR32rm), 0|OPFL_Chain|OPFL_MemRefs,
                        2/*#VTs*/, MVT::i32, MVT::i32, 6/*#Ops*/, 2, 3, 4, 5, 6, 7, 
                    // Src: (or:i32 (ld:i32 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR32:i32:$src1)
                    // Dst: (OR32rm:i32 GR32:i32:$src1, addr:iPTR:$src2)
                  /*SwitchType*/ 20,  MVT::i64,// ->53441
/*53421*/           OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*53424*/           OPC_EmitMergeInputChains, 1, 0, 
/*53427*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::OR64rm), 0|OPFL_Chain|OPFL_MemRefs,
                        2/*#VTs*/, MVT::i64, MVT::i32, 6/*#Ops*/, 2, 3, 4, 5, 6, 7, 
                    // Src: (or:i64 (ld:i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR64:i64:$src1)
                    // Dst: (OR64rm:i64 GR64:i64:$src1, addr:iPTR:$src2)
                  0, // EndSwitchType
/*53442*/       /*Scope*/ 27, /*->53470*/
/*53443*/         OPC_CheckPredicate, 23, // Predicate_memop
/*53445*/         OPC_MoveParent,
/*53446*/         OPC_RecordChild1, // #2 = $src1
/*53447*/         OPC_CheckType, MVT::v2i64,
/*53449*/         OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*53451*/         OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*53454*/         OPC_EmitMergeInputChains, 1, 0, 
/*53457*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::PORrm), 0|OPFL_Chain|OPFL_MemRefs,
                      1/*#VTs*/, MVT::v2i64, 6/*#Ops*/, 2, 3, 4, 5, 6, 7, 
                  // Src: (or:v2i64 (ld:v2i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>, VR128:v2i64:$src1)
                  // Dst: (PORrm:v2i64 VR128:v2i64:$src1, addr:iPTR:$src2)
/*53470*/       /*Scope*/ 25, /*->53496*/
/*53471*/         OPC_MoveParent,
/*53472*/         OPC_RecordChild1, // #2 = $src1
/*53473*/         OPC_CheckType, MVT::v1i64,
/*53475*/         OPC_CheckPatternPredicate, 8, // (Subtarget->hasMMX())
/*53477*/         OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*53480*/         OPC_EmitMergeInputChains, 1, 0, 
/*53483*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PORrm), 0|OPFL_Chain|OPFL_MemRefs,
                      1/*#VTs*/, MVT::v1i64, 6/*#Ops*/, 2, 3, 4, 5, 6, 7, 
                  // Src: (or:v1i64 (ld:v1i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR64:v1i64:$src1)
                  // Dst: (MMX_PORrm:v1i64 VR64:v1i64:$src1, addr:iPTR:$src2)
/*53496*/       0, /*End of Scope*/
              /*SwitchOpcode*/ 121|128,3/*505*/,  ISD::SRL,// ->54005
/*53500*/       OPC_RecordChild0, // #0 = $src1
/*53501*/       OPC_Scope, 82|128,1/*210*/, /*->53714*/ // 5 children in Scope
/*53504*/         OPC_MoveChild, 1,
/*53506*/         OPC_CheckOpcode, ISD::TRUNCATE,
/*53508*/         OPC_Scope, 104, /*->53614*/ // 2 children in Scope
/*53510*/           OPC_RecordChild0, // #1 = $amt
/*53511*/           OPC_RecordChild0, // #2 = physreg input ECX
/*53512*/           OPC_CheckType, MVT::i8,
/*53514*/           OPC_Scope, 48, /*->53564*/ // 2 children in Scope
/*53516*/             OPC_CheckChild0Type, MVT::i32,
/*53518*/             OPC_MoveParent,
/*53519*/             OPC_MoveParent,
/*53520*/             OPC_MoveChild, 1,
/*53522*/             OPC_CheckOpcode, ISD::SHL,
/*53524*/             OPC_RecordChild0, // #3 = $src2
/*53525*/             OPC_MoveChild, 1,
/*53527*/             OPC_CheckOpcode, ISD::TRUNCATE,
/*53529*/             OPC_MoveChild, 0,
/*53531*/             OPC_CheckOpcode, ISD::SUB,
/*53533*/             OPC_MoveChild, 0,
/*53535*/             OPC_CheckInteger, 32, 
/*53537*/             OPC_MoveParent,
/*53538*/             OPC_MoveChild, 1,
/*53540*/             OPC_CheckSame, 1,
/*53542*/             OPC_MoveParent,
/*53543*/             OPC_CheckType, MVT::i32,
/*53545*/             OPC_MoveParent,
/*53546*/             OPC_CheckType, MVT::i8,
/*53548*/             OPC_MoveParent,
/*53549*/             OPC_MoveParent,
/*53550*/             OPC_CheckType, MVT::i32,
/*53552*/             OPC_EmitCopyToReg, 2, X86::ECX,
/*53555*/             OPC_MorphNodeTo, TARGET_OPCODE(X86::SHRD32rrCL), 0|OPFL_FlagInput,
                          1/*#VTs*/, MVT::i32, 2/*#Ops*/, 0, 3, 
                      // Src: (or:i32 (srl:i32 GR32:i32:$src1, (trunc:i8 ECX:i32:$amt)), (shl:i32 GR32:i32:$src2, (trunc:i8 (sub:i32 32:i32, ECX:i32:$amt))))
                      // Dst: (SHRD32rrCL:i32 GR32:i32:$src1, GR32:i32:$src2)
/*53564*/           /*Scope*/ 48, /*->53613*/
/*53565*/             OPC_CheckChild0Type, MVT::i16,
/*53567*/             OPC_MoveParent,
/*53568*/             OPC_MoveParent,
/*53569*/             OPC_MoveChild, 1,
/*53571*/             OPC_CheckOpcode, ISD::SHL,
/*53573*/             OPC_RecordChild0, // #3 = $src2
/*53574*/             OPC_MoveChild, 1,
/*53576*/             OPC_CheckOpcode, ISD::TRUNCATE,
/*53578*/             OPC_MoveChild, 0,
/*53580*/             OPC_CheckOpcode, ISD::SUB,
/*53582*/             OPC_MoveChild, 0,
/*53584*/             OPC_CheckInteger, 16, 
/*53586*/             OPC_MoveParent,
/*53587*/             OPC_MoveChild, 1,
/*53589*/             OPC_CheckSame, 1,
/*53591*/             OPC_MoveParent,
/*53592*/             OPC_CheckType, MVT::i16,
/*53594*/             OPC_MoveParent,
/*53595*/             OPC_CheckType, MVT::i8,
/*53597*/             OPC_MoveParent,
/*53598*/             OPC_MoveParent,
/*53599*/             OPC_CheckType, MVT::i16,
/*53601*/             OPC_EmitCopyToReg, 2, X86::CX,
/*53604*/             OPC_MorphNodeTo, TARGET_OPCODE(X86::SHRD16rrCL), 0|OPFL_FlagInput,
                          1/*#VTs*/, MVT::i16, 2/*#Ops*/, 0, 3, 
                      // Src: (or:i16 (srl:i16 GR16:i16:$src1, (trunc:i8 CX:i16:$amt)), (shl:i16 GR16:i16:$src2, (trunc:i8 (sub:i16 16:i16, CX:i16:$amt))))
                      // Dst: (SHRD16rrCL:i16 GR16:i16:$src1, GR16:i16:$src2)
/*53613*/           0, /*End of Scope*/
/*53614*/         /*Scope*/ 98, /*->53713*/
/*53615*/           OPC_MoveChild, 0,
/*53617*/           OPC_CheckOpcode, ISD::SUB,
/*53619*/           OPC_MoveChild, 0,
/*53621*/           OPC_Scope, 44, /*->53667*/ // 2 children in Scope
/*53623*/             OPC_CheckInteger, 32, 
/*53625*/             OPC_MoveParent,
/*53626*/             OPC_RecordChild1, // #1 = $amt
/*53627*/             OPC_RecordChild1, // #2 = physreg input ECX
/*53628*/             OPC_CheckType, MVT::i32,
/*53630*/             OPC_MoveParent,
/*53631*/             OPC_CheckType, MVT::i8,
/*53633*/             OPC_MoveParent,
/*53634*/             OPC_MoveParent,
/*53635*/             OPC_MoveChild, 1,
/*53637*/             OPC_CheckOpcode, ISD::SHL,
/*53639*/             OPC_RecordChild0, // #3 = $src1
/*53640*/             OPC_MoveChild, 1,
/*53642*/             OPC_CheckOpcode, ISD::TRUNCATE,
/*53644*/             OPC_MoveChild, 0,
/*53646*/             OPC_CheckSame, 1,
/*53648*/             OPC_MoveParent,
/*53649*/             OPC_CheckType, MVT::i8,
/*53651*/             OPC_MoveParent,
/*53652*/             OPC_MoveParent,
/*53653*/             OPC_CheckType, MVT::i32,
/*53655*/             OPC_EmitCopyToReg, 2, X86::ECX,
/*53658*/             OPC_MorphNodeTo, TARGET_OPCODE(X86::SHLD32rrCL), 0|OPFL_FlagInput,
                          1/*#VTs*/, MVT::i32, 2/*#Ops*/, 3, 0, 
                      // Src: (or:i32 (srl:i32 GR32:i32:$src2, (trunc:i8 (sub:i32 32:i32, ECX:i32:$amt))), (shl:i32 GR32:i32:$src1, (trunc:i8 ECX:i32:$amt)))
                      // Dst: (SHLD32rrCL:i32 GR32:i32:$src1, GR32:i32:$src2)
/*53667*/           /*Scope*/ 44, /*->53712*/
/*53668*/             OPC_CheckInteger, 16, 
/*53670*/             OPC_MoveParent,
/*53671*/             OPC_RecordChild1, // #1 = $amt
/*53672*/             OPC_RecordChild1, // #2 = physreg input CX
/*53673*/             OPC_CheckType, MVT::i16,
/*53675*/             OPC_MoveParent,
/*53676*/             OPC_CheckType, MVT::i8,
/*53678*/             OPC_MoveParent,
/*53679*/             OPC_MoveParent,
/*53680*/             OPC_MoveChild, 1,
/*53682*/             OPC_CheckOpcode, ISD::SHL,
/*53684*/             OPC_RecordChild0, // #3 = $src1
/*53685*/             OPC_MoveChild, 1,
/*53687*/             OPC_CheckOpcode, ISD::TRUNCATE,
/*53689*/             OPC_MoveChild, 0,
/*53691*/             OPC_CheckSame, 1,
/*53693*/             OPC_MoveParent,
/*53694*/             OPC_CheckType, MVT::i8,
/*53696*/             OPC_MoveParent,
/*53697*/             OPC_MoveParent,
/*53698*/             OPC_CheckType, MVT::i16,
/*53700*/             OPC_EmitCopyToReg, 2, X86::CX,
/*53703*/             OPC_MorphNodeTo, TARGET_OPCODE(X86::SHLD16rrCL), 0|OPFL_FlagInput,
                          1/*#VTs*/, MVT::i16, 2/*#Ops*/, 3, 0, 
                      // Src: (or:i16 (srl:i16 GR16:i16:$src2, (trunc:i8 (sub:i16 16:i16, CX:i16:$amt))), (shl:i16 GR16:i16:$src1, (trunc:i8 CX:i16:$amt)))
                      // Dst: (SHLD16rrCL:i16 GR16:i16:$src1, GR16:i16:$src2)
/*53712*/           0, /*End of Scope*/
/*53713*/         0, /*End of Scope*/
/*53714*/       /*Scope*/ 72, /*->53787*/
/*53715*/         OPC_RecordChild1, // #1 = $amt
/*53716*/         OPC_RecordChild1, // #2 = physreg input CL
/*53717*/         OPC_CheckChild1Type, MVT::i8,
/*53719*/         OPC_MoveParent,
/*53720*/         OPC_MoveChild, 1,
/*53722*/         OPC_CheckOpcode, ISD::SHL,
/*53724*/         OPC_RecordChild0, // #3 = $src2
/*53725*/         OPC_MoveChild, 1,
/*53727*/         OPC_CheckOpcode, ISD::SUB,
/*53729*/         OPC_MoveChild, 0,
/*53731*/         OPC_Scope, 26, /*->53759*/ // 2 children in Scope
/*53733*/           OPC_CheckInteger, 32, 
/*53735*/           OPC_MoveParent,
/*53736*/           OPC_MoveChild, 1,
/*53738*/           OPC_CheckSame, 1,
/*53740*/           OPC_MoveParent,
/*53741*/           OPC_CheckType, MVT::i8,
/*53743*/           OPC_MoveParent,
/*53744*/           OPC_MoveParent,
/*53745*/           OPC_CheckType, MVT::i32,
/*53747*/           OPC_EmitCopyToReg, 2, X86::CL,
/*53750*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::SHRD32rrCL), 0|OPFL_FlagInput,
                        1/*#VTs*/, MVT::i32, 2/*#Ops*/, 0, 3, 
                    // Src: (or:i32 (srl:i32 GR32:i32:$src1, CL:i8:$amt), (shl:i32 GR32:i32:$src2, (sub:i8 32:i8, CL:i8:$amt)))
                    // Dst: (SHRD32rrCL:i32 GR32:i32:$src1, GR32:i32:$src2)
/*53759*/         /*Scope*/ 26, /*->53786*/
/*53760*/           OPC_CheckInteger, 16, 
/*53762*/           OPC_MoveParent,
/*53763*/           OPC_MoveChild, 1,
/*53765*/           OPC_CheckSame, 1,
/*53767*/           OPC_MoveParent,
/*53768*/           OPC_CheckType, MVT::i8,
/*53770*/           OPC_MoveParent,
/*53771*/           OPC_MoveParent,
/*53772*/           OPC_CheckType, MVT::i16,
/*53774*/           OPC_EmitCopyToReg, 2, X86::CL,
/*53777*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::SHRD16rrCL), 0|OPFL_FlagInput,
                        1/*#VTs*/, MVT::i16, 2/*#Ops*/, 0, 3, 
                    // Src: (or:i16 (srl:i16 GR16:i16:$src1, CL:i8:$amt), (shl:i16 GR16:i16:$src2, (sub:i8 16:i8, CL:i8:$amt)))
                    // Dst: (SHRD16rrCL:i16 GR16:i16:$src1, GR16:i16:$src2)
/*53786*/         0, /*End of Scope*/
/*53787*/       /*Scope*/ 78, /*->53866*/
/*53788*/         OPC_MoveChild, 1,
/*53790*/         OPC_CheckOpcode, ISD::SUB,
/*53792*/         OPC_MoveChild, 0,
/*53794*/         OPC_Scope, 34, /*->53830*/ // 2 children in Scope
/*53796*/           OPC_CheckInteger, 32, 
/*53798*/           OPC_MoveParent,
/*53799*/           OPC_RecordChild1, // #1 = $amt
/*53800*/           OPC_RecordChild1, // #2 = physreg input CL
/*53801*/           OPC_CheckType, MVT::i8,
/*53803*/           OPC_MoveParent,
/*53804*/           OPC_MoveParent,
/*53805*/           OPC_MoveChild, 1,
/*53807*/           OPC_CheckOpcode, ISD::SHL,
/*53809*/           OPC_RecordChild0, // #3 = $src1
/*53810*/           OPC_MoveChild, 1,
/*53812*/           OPC_CheckSame, 1,
/*53814*/           OPC_MoveParent,
/*53815*/           OPC_MoveParent,
/*53816*/           OPC_CheckType, MVT::i32,
/*53818*/           OPC_EmitCopyToReg, 2, X86::CL,
/*53821*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::SHLD32rrCL), 0|OPFL_FlagInput,
                        1/*#VTs*/, MVT::i32, 2/*#Ops*/, 3, 0, 
                    // Src: (or:i32 (srl:i32 GR32:i32:$src2, (sub:i8 32:i8, CL:i8:$amt)), (shl:i32 GR32:i32:$src1, CL:i8:$amt))
                    // Dst: (SHLD32rrCL:i32 GR32:i32:$src1, GR32:i32:$src2)
/*53830*/         /*Scope*/ 34, /*->53865*/
/*53831*/           OPC_CheckInteger, 16, 
/*53833*/           OPC_MoveParent,
/*53834*/           OPC_RecordChild1, // #1 = $amt
/*53835*/           OPC_RecordChild1, // #2 = physreg input CL
/*53836*/           OPC_CheckType, MVT::i8,
/*53838*/           OPC_MoveParent,
/*53839*/           OPC_MoveParent,
/*53840*/           OPC_MoveChild, 1,
/*53842*/           OPC_CheckOpcode, ISD::SHL,
/*53844*/           OPC_RecordChild0, // #3 = $src1
/*53845*/           OPC_MoveChild, 1,
/*53847*/           OPC_CheckSame, 1,
/*53849*/           OPC_MoveParent,
/*53850*/           OPC_MoveParent,
/*53851*/           OPC_CheckType, MVT::i16,
/*53853*/           OPC_EmitCopyToReg, 2, X86::CL,
/*53856*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::SHLD16rrCL), 0|OPFL_FlagInput,
                        1/*#VTs*/, MVT::i16, 2/*#Ops*/, 3, 0, 
                    // Src: (or:i16 (srl:i16 GR16:i16:$src2, (sub:i8 16:i8, CL:i8:$amt)), (shl:i16 GR16:i16:$src1, CL:i8:$amt))
                    // Dst: (SHLD16rrCL:i16 GR16:i16:$src1, GR16:i16:$src2)
/*53865*/         0, /*End of Scope*/
/*53866*/       /*Scope*/ 68, /*->53935*/
/*53867*/         OPC_RecordChild1, // #1 = $amt1
/*53868*/         OPC_MoveChild, 1,
/*53870*/         OPC_CheckOpcode, ISD::Constant,
/*53872*/         OPC_CheckType, MVT::i8,
/*53874*/         OPC_MoveParent,
/*53875*/         OPC_MoveParent,
/*53876*/         OPC_MoveChild, 1,
/*53878*/         OPC_CheckOpcode, ISD::SHL,
/*53880*/         OPC_RecordChild0, // #2 = $src2
/*53881*/         OPC_MoveChild, 1,
/*53883*/         OPC_CheckOpcode, ISD::Constant,
/*53885*/         OPC_CheckType, MVT::i8,
/*53887*/         OPC_MoveParent,
/*53888*/         OPC_MoveParent,
/*53889*/         OPC_CheckPredicate, 7, // Predicate_shrd
/*53891*/         OPC_SwitchType /*3 cases */, 12,  MVT::i32,// ->53906
/*53894*/           OPC_EmitConvertToTarget, 1,
/*53896*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::SHRD32rri8), 0,
                        1/*#VTs*/, MVT::i32, 3/*#Ops*/, 0, 2, 3, 
                    // Src: (or:i32 (srl:i32 GR32:i32:$src1, (imm:i8):$amt1), (shl:i32 GR32:i32:$src2, (imm:i8)))<<P:Predicate_shrd>>
                    // Dst: (SHRD32rri8:i32 GR32:i32:$src1, GR32:i32:$src2, (imm:i8):$amt1)
                  /*SwitchType*/ 12,  MVT::i16,// ->53920
/*53908*/           OPC_EmitConvertToTarget, 1,
/*53910*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::SHRD16rri8), 0,
                        1/*#VTs*/, MVT::i16, 3/*#Ops*/, 0, 2, 3, 
                    // Src: (or:i16 (srl:i16 GR16:i16:$src1, (imm:i8):$amt1), (shl:i16 GR16:i16:$src2, (imm:i8)))<<P:Predicate_shrd>>
                    // Dst: (SHRD16rri8:i16 GR16:i16:$src1, GR16:i16:$src2, (imm:i8):$amt1)
                  /*SwitchType*/ 12,  MVT::i64,// ->53934
/*53922*/           OPC_EmitConvertToTarget, 1,
/*53924*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::SHRD64rri8), 0,
                        1/*#VTs*/, MVT::i64, 3/*#Ops*/, 0, 2, 3, 
                    // Src: (or:i64 (srl:i64 GR64:i64:$src1, (imm:i8):$amt1), (shl:i64 GR64:i64:$src2, (imm:i8)))<<P:Predicate_shrd>>
                    // Dst: (SHRD64rri8:i64 GR64:i64:$src1, GR64:i64:$src2, (imm:i8):$amt1)
                  0, // EndSwitchType
/*53935*/       /*Scope*/ 68, /*->54004*/
/*53936*/         OPC_MoveChild, 1,
/*53938*/         OPC_CheckOpcode, ISD::Constant,
/*53940*/         OPC_CheckType, MVT::i8,
/*53942*/         OPC_MoveParent,
/*53943*/         OPC_MoveParent,
/*53944*/         OPC_MoveChild, 1,
/*53946*/         OPC_CheckOpcode, ISD::SHL,
/*53948*/         OPC_RecordChild0, // #1 = $src1
/*53949*/         OPC_RecordChild1, // #2 = $amt1
/*53950*/         OPC_MoveChild, 1,
/*53952*/         OPC_CheckOpcode, ISD::Constant,
/*53954*/         OPC_CheckType, MVT::i8,
/*53956*/         OPC_MoveParent,
/*53957*/         OPC_MoveParent,
/*53958*/         OPC_CheckPredicate, 10, // Predicate_shld
/*53960*/         OPC_SwitchType /*3 cases */, 12,  MVT::i32,// ->53975
/*53963*/           OPC_EmitConvertToTarget, 2,
/*53965*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::SHLD32rri8), 0,
                        1/*#VTs*/, MVT::i32, 3/*#Ops*/, 1, 0, 3, 
                    // Src: (or:i32 (srl:i32 GR32:i32:$src2, (imm:i8)), (shl:i32 GR32:i32:$src1, (imm:i8):$amt1))<<P:Predicate_shld>>
                    // Dst: (SHLD32rri8:i32 GR32:i32:$src1, GR32:i32:$src2, (imm:i8):$amt1)
                  /*SwitchType*/ 12,  MVT::i16,// ->53989
/*53977*/           OPC_EmitConvertToTarget, 2,
/*53979*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::SHLD16rri8), 0,
                        1/*#VTs*/, MVT::i16, 3/*#Ops*/, 1, 0, 3, 
                    // Src: (or:i16 (srl:i16 GR16:i16:$src2, (imm:i8)), (shl:i16 GR16:i16:$src1, (imm:i8):$amt1))<<P:Predicate_shld>>
                    // Dst: (SHLD16rri8:i16 GR16:i16:$src1, GR16:i16:$src2, (imm:i8):$amt1)
                  /*SwitchType*/ 12,  MVT::i64,// ->54003
/*53991*/           OPC_EmitConvertToTarget, 2,
/*53993*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::SHLD64rri8), 0,
                        1/*#VTs*/, MVT::i64, 3/*#Ops*/, 1, 0, 3, 
                    // Src: (or:i64 (srl:i64 GR64:i64:$src2, (imm:i8)), (shl:i64 GR64:i64:$src1, (imm:i8):$amt1))<<P:Predicate_shld>>
                    // Dst: (SHLD64rri8:i64 GR64:i64:$src1, GR64:i64:$src2, (imm:i8):$amt1)
                  0, // EndSwitchType
/*54004*/       0, /*End of Scope*/
              /*SwitchOpcode*/ 121|128,3/*505*/,  ISD::SHL,// ->54513
/*54008*/       OPC_RecordChild0, // #0 = $src1
/*54009*/       OPC_Scope, 82|128,1/*210*/, /*->54222*/ // 5 children in Scope
/*54012*/         OPC_MoveChild, 1,
/*54014*/         OPC_CheckOpcode, ISD::TRUNCATE,
/*54016*/         OPC_Scope, 104, /*->54122*/ // 2 children in Scope
/*54018*/           OPC_RecordChild0, // #1 = $amt
/*54019*/           OPC_RecordChild0, // #2 = physreg input ECX
/*54020*/           OPC_CheckType, MVT::i8,
/*54022*/           OPC_Scope, 48, /*->54072*/ // 2 children in Scope
/*54024*/             OPC_CheckChild0Type, MVT::i32,
/*54026*/             OPC_MoveParent,
/*54027*/             OPC_MoveParent,
/*54028*/             OPC_MoveChild, 1,
/*54030*/             OPC_CheckOpcode, ISD::SRL,
/*54032*/             OPC_RecordChild0, // #3 = $src2
/*54033*/             OPC_MoveChild, 1,
/*54035*/             OPC_CheckOpcode, ISD::TRUNCATE,
/*54037*/             OPC_MoveChild, 0,
/*54039*/             OPC_CheckOpcode, ISD::SUB,
/*54041*/             OPC_MoveChild, 0,
/*54043*/             OPC_CheckInteger, 32, 
/*54045*/             OPC_MoveParent,
/*54046*/             OPC_MoveChild, 1,
/*54048*/             OPC_CheckSame, 1,
/*54050*/             OPC_MoveParent,
/*54051*/             OPC_CheckType, MVT::i32,
/*54053*/             OPC_MoveParent,
/*54054*/             OPC_CheckType, MVT::i8,
/*54056*/             OPC_MoveParent,
/*54057*/             OPC_MoveParent,
/*54058*/             OPC_CheckType, MVT::i32,
/*54060*/             OPC_EmitCopyToReg, 2, X86::ECX,
/*54063*/             OPC_MorphNodeTo, TARGET_OPCODE(X86::SHLD32rrCL), 0|OPFL_FlagInput,
                          1/*#VTs*/, MVT::i32, 2/*#Ops*/, 0, 3, 
                      // Src: (or:i32 (shl:i32 GR32:i32:$src1, (trunc:i8 ECX:i32:$amt)), (srl:i32 GR32:i32:$src2, (trunc:i8 (sub:i32 32:i32, ECX:i32:$amt))))
                      // Dst: (SHLD32rrCL:i32 GR32:i32:$src1, GR32:i32:$src2)
/*54072*/           /*Scope*/ 48, /*->54121*/
/*54073*/             OPC_CheckChild0Type, MVT::i16,
/*54075*/             OPC_MoveParent,
/*54076*/             OPC_MoveParent,
/*54077*/             OPC_MoveChild, 1,
/*54079*/             OPC_CheckOpcode, ISD::SRL,
/*54081*/             OPC_RecordChild0, // #3 = $src2
/*54082*/             OPC_MoveChild, 1,
/*54084*/             OPC_CheckOpcode, ISD::TRUNCATE,
/*54086*/             OPC_MoveChild, 0,
/*54088*/             OPC_CheckOpcode, ISD::SUB,
/*54090*/             OPC_MoveChild, 0,
/*54092*/             OPC_CheckInteger, 16, 
/*54094*/             OPC_MoveParent,
/*54095*/             OPC_MoveChild, 1,
/*54097*/             OPC_CheckSame, 1,
/*54099*/             OPC_MoveParent,
/*54100*/             OPC_CheckType, MVT::i16,
/*54102*/             OPC_MoveParent,
/*54103*/             OPC_CheckType, MVT::i8,
/*54105*/             OPC_MoveParent,
/*54106*/             OPC_MoveParent,
/*54107*/             OPC_CheckType, MVT::i16,
/*54109*/             OPC_EmitCopyToReg, 2, X86::CX,
/*54112*/             OPC_MorphNodeTo, TARGET_OPCODE(X86::SHLD16rrCL), 0|OPFL_FlagInput,
                          1/*#VTs*/, MVT::i16, 2/*#Ops*/, 0, 3, 
                      // Src: (or:i16 (shl:i16 GR16:i16:$src1, (trunc:i8 CX:i16:$amt)), (srl:i16 GR16:i16:$src2, (trunc:i8 (sub:i16 16:i16, CX:i16:$amt))))
                      // Dst: (SHLD16rrCL:i16 GR16:i16:$src1, GR16:i16:$src2)
/*54121*/           0, /*End of Scope*/
/*54122*/         /*Scope*/ 98, /*->54221*/
/*54123*/           OPC_MoveChild, 0,
/*54125*/           OPC_CheckOpcode, ISD::SUB,
/*54127*/           OPC_MoveChild, 0,
/*54129*/           OPC_Scope, 44, /*->54175*/ // 2 children in Scope
/*54131*/             OPC_CheckInteger, 32, 
/*54133*/             OPC_MoveParent,
/*54134*/             OPC_RecordChild1, // #1 = $amt
/*54135*/             OPC_RecordChild1, // #2 = physreg input ECX
/*54136*/             OPC_CheckType, MVT::i32,
/*54138*/             OPC_MoveParent,
/*54139*/             OPC_CheckType, MVT::i8,
/*54141*/             OPC_MoveParent,
/*54142*/             OPC_MoveParent,
/*54143*/             OPC_MoveChild, 1,
/*54145*/             OPC_CheckOpcode, ISD::SRL,
/*54147*/             OPC_RecordChild0, // #3 = $src1
/*54148*/             OPC_MoveChild, 1,
/*54150*/             OPC_CheckOpcode, ISD::TRUNCATE,
/*54152*/             OPC_MoveChild, 0,
/*54154*/             OPC_CheckSame, 1,
/*54156*/             OPC_MoveParent,
/*54157*/             OPC_CheckType, MVT::i8,
/*54159*/             OPC_MoveParent,
/*54160*/             OPC_MoveParent,
/*54161*/             OPC_CheckType, MVT::i32,
/*54163*/             OPC_EmitCopyToReg, 2, X86::ECX,
/*54166*/             OPC_MorphNodeTo, TARGET_OPCODE(X86::SHRD32rrCL), 0|OPFL_FlagInput,
                          1/*#VTs*/, MVT::i32, 2/*#Ops*/, 3, 0, 
                      // Src: (or:i32 (shl:i32 GR32:i32:$src2, (trunc:i8 (sub:i32 32:i32, ECX:i32:$amt))), (srl:i32 GR32:i32:$src1, (trunc:i8 ECX:i32:$amt)))
                      // Dst: (SHRD32rrCL:i32 GR32:i32:$src1, GR32:i32:$src2)
/*54175*/           /*Scope*/ 44, /*->54220*/
/*54176*/             OPC_CheckInteger, 16, 
/*54178*/             OPC_MoveParent,
/*54179*/             OPC_RecordChild1, // #1 = $amt
/*54180*/             OPC_RecordChild1, // #2 = physreg input CX
/*54181*/             OPC_CheckType, MVT::i16,
/*54183*/             OPC_MoveParent,
/*54184*/             OPC_CheckType, MVT::i8,
/*54186*/             OPC_MoveParent,
/*54187*/             OPC_MoveParent,
/*54188*/             OPC_MoveChild, 1,
/*54190*/             OPC_CheckOpcode, ISD::SRL,
/*54192*/             OPC_RecordChild0, // #3 = $src1
/*54193*/             OPC_MoveChild, 1,
/*54195*/             OPC_CheckOpcode, ISD::TRUNCATE,
/*54197*/             OPC_MoveChild, 0,
/*54199*/             OPC_CheckSame, 1,
/*54201*/             OPC_MoveParent,
/*54202*/             OPC_CheckType, MVT::i8,
/*54204*/             OPC_MoveParent,
/*54205*/             OPC_MoveParent,
/*54206*/             OPC_CheckType, MVT::i16,
/*54208*/             OPC_EmitCopyToReg, 2, X86::CX,
/*54211*/             OPC_MorphNodeTo, TARGET_OPCODE(X86::SHRD16rrCL), 0|OPFL_FlagInput,
                          1/*#VTs*/, MVT::i16, 2/*#Ops*/, 3, 0, 
                      // Src: (or:i16 (shl:i16 GR16:i16:$src2, (trunc:i8 (sub:i16 16:i16, CX:i16:$amt))), (srl:i16 GR16:i16:$src1, (trunc:i8 CX:i16:$amt)))
                      // Dst: (SHRD16rrCL:i16 GR16:i16:$src1, GR16:i16:$src2)
/*54220*/           0, /*End of Scope*/
/*54221*/         0, /*End of Scope*/
/*54222*/       /*Scope*/ 72, /*->54295*/
/*54223*/         OPC_RecordChild1, // #1 = $amt
/*54224*/         OPC_RecordChild1, // #2 = physreg input CL
/*54225*/         OPC_CheckChild1Type, MVT::i8,
/*54227*/         OPC_MoveParent,
/*54228*/         OPC_MoveChild, 1,
/*54230*/         OPC_CheckOpcode, ISD::SRL,
/*54232*/         OPC_RecordChild0, // #3 = $src2
/*54233*/         OPC_MoveChild, 1,
/*54235*/         OPC_CheckOpcode, ISD::SUB,
/*54237*/         OPC_MoveChild, 0,
/*54239*/         OPC_Scope, 26, /*->54267*/ // 2 children in Scope
/*54241*/           OPC_CheckInteger, 32, 
/*54243*/           OPC_MoveParent,
/*54244*/           OPC_MoveChild, 1,
/*54246*/           OPC_CheckSame, 1,
/*54248*/           OPC_MoveParent,
/*54249*/           OPC_CheckType, MVT::i8,
/*54251*/           OPC_MoveParent,
/*54252*/           OPC_MoveParent,
/*54253*/           OPC_CheckType, MVT::i32,
/*54255*/           OPC_EmitCopyToReg, 2, X86::CL,
/*54258*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::SHLD32rrCL), 0|OPFL_FlagInput,
                        1/*#VTs*/, MVT::i32, 2/*#Ops*/, 0, 3, 
                    // Src: (or:i32 (shl:i32 GR32:i32:$src1, CL:i8:$amt), (srl:i32 GR32:i32:$src2, (sub:i8 32:i8, CL:i8:$amt)))
                    // Dst: (SHLD32rrCL:i32 GR32:i32:$src1, GR32:i32:$src2)
/*54267*/         /*Scope*/ 26, /*->54294*/
/*54268*/           OPC_CheckInteger, 16, 
/*54270*/           OPC_MoveParent,
/*54271*/           OPC_MoveChild, 1,
/*54273*/           OPC_CheckSame, 1,
/*54275*/           OPC_MoveParent,
/*54276*/           OPC_CheckType, MVT::i8,
/*54278*/           OPC_MoveParent,
/*54279*/           OPC_MoveParent,
/*54280*/           OPC_CheckType, MVT::i16,
/*54282*/           OPC_EmitCopyToReg, 2, X86::CL,
/*54285*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::SHLD16rrCL), 0|OPFL_FlagInput,
                        1/*#VTs*/, MVT::i16, 2/*#Ops*/, 0, 3, 
                    // Src: (or:i16 (shl:i16 GR16:i16:$src1, CL:i8:$amt), (srl:i16 GR16:i16:$src2, (sub:i8 16:i8, CL:i8:$amt)))
                    // Dst: (SHLD16rrCL:i16 GR16:i16:$src1, GR16:i16:$src2)
/*54294*/         0, /*End of Scope*/
/*54295*/       /*Scope*/ 78, /*->54374*/
/*54296*/         OPC_MoveChild, 1,
/*54298*/         OPC_CheckOpcode, ISD::SUB,
/*54300*/         OPC_MoveChild, 0,
/*54302*/         OPC_Scope, 34, /*->54338*/ // 2 children in Scope
/*54304*/           OPC_CheckInteger, 32, 
/*54306*/           OPC_MoveParent,
/*54307*/           OPC_RecordChild1, // #1 = $amt
/*54308*/           OPC_RecordChild1, // #2 = physreg input CL
/*54309*/           OPC_CheckType, MVT::i8,
/*54311*/           OPC_MoveParent,
/*54312*/           OPC_MoveParent,
/*54313*/           OPC_MoveChild, 1,
/*54315*/           OPC_CheckOpcode, ISD::SRL,
/*54317*/           OPC_RecordChild0, // #3 = $src1
/*54318*/           OPC_MoveChild, 1,
/*54320*/           OPC_CheckSame, 1,
/*54322*/           OPC_MoveParent,
/*54323*/           OPC_MoveParent,
/*54324*/           OPC_CheckType, MVT::i32,
/*54326*/           OPC_EmitCopyToReg, 2, X86::CL,
/*54329*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::SHRD32rrCL), 0|OPFL_FlagInput,
                        1/*#VTs*/, MVT::i32, 2/*#Ops*/, 3, 0, 
                    // Src: (or:i32 (shl:i32 GR32:i32:$src2, (sub:i8 32:i8, CL:i8:$amt)), (srl:i32 GR32:i32:$src1, CL:i8:$amt))
                    // Dst: (SHRD32rrCL:i32 GR32:i32:$src1, GR32:i32:$src2)
/*54338*/         /*Scope*/ 34, /*->54373*/
/*54339*/           OPC_CheckInteger, 16, 
/*54341*/           OPC_MoveParent,
/*54342*/           OPC_RecordChild1, // #1 = $amt
/*54343*/           OPC_RecordChild1, // #2 = physreg input CL
/*54344*/           OPC_CheckType, MVT::i8,
/*54346*/           OPC_MoveParent,
/*54347*/           OPC_MoveParent,
/*54348*/           OPC_MoveChild, 1,
/*54350*/           OPC_CheckOpcode, ISD::SRL,
/*54352*/           OPC_RecordChild0, // #3 = $src1
/*54353*/           OPC_MoveChild, 1,
/*54355*/           OPC_CheckSame, 1,
/*54357*/           OPC_MoveParent,
/*54358*/           OPC_MoveParent,
/*54359*/           OPC_CheckType, MVT::i16,
/*54361*/           OPC_EmitCopyToReg, 2, X86::CL,
/*54364*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::SHRD16rrCL), 0|OPFL_FlagInput,
                        1/*#VTs*/, MVT::i16, 2/*#Ops*/, 3, 0, 
                    // Src: (or:i16 (shl:i16 GR16:i16:$src2, (sub:i8 16:i8, CL:i8:$amt)), (srl:i16 GR16:i16:$src1, CL:i8:$amt))
                    // Dst: (SHRD16rrCL:i16 GR16:i16:$src1, GR16:i16:$src2)
/*54373*/         0, /*End of Scope*/
/*54374*/       /*Scope*/ 68, /*->54443*/
/*54375*/         OPC_RecordChild1, // #1 = $amt1
/*54376*/         OPC_MoveChild, 1,
/*54378*/         OPC_CheckOpcode, ISD::Constant,
/*54380*/         OPC_CheckType, MVT::i8,
/*54382*/         OPC_MoveParent,
/*54383*/         OPC_MoveParent,
/*54384*/         OPC_MoveChild, 1,
/*54386*/         OPC_CheckOpcode, ISD::SRL,
/*54388*/         OPC_RecordChild0, // #2 = $src2
/*54389*/         OPC_MoveChild, 1,
/*54391*/         OPC_CheckOpcode, ISD::Constant,
/*54393*/         OPC_CheckType, MVT::i8,
/*54395*/         OPC_MoveParent,
/*54396*/         OPC_MoveParent,
/*54397*/         OPC_CheckPredicate, 10, // Predicate_shld
/*54399*/         OPC_SwitchType /*3 cases */, 12,  MVT::i32,// ->54414
/*54402*/           OPC_EmitConvertToTarget, 1,
/*54404*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::SHLD32rri8), 0,
                        1/*#VTs*/, MVT::i32, 3/*#Ops*/, 0, 2, 3, 
                    // Src: (or:i32 (shl:i32 GR32:i32:$src1, (imm:i8):$amt1), (srl:i32 GR32:i32:$src2, (imm:i8)))<<P:Predicate_shld>>
                    // Dst: (SHLD32rri8:i32 GR32:i32:$src1, GR32:i32:$src2, (imm:i8):$amt1)
                  /*SwitchType*/ 12,  MVT::i16,// ->54428
/*54416*/           OPC_EmitConvertToTarget, 1,
/*54418*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::SHLD16rri8), 0,
                        1/*#VTs*/, MVT::i16, 3/*#Ops*/, 0, 2, 3, 
                    // Src: (or:i16 (shl:i16 GR16:i16:$src1, (imm:i8):$amt1), (srl:i16 GR16:i16:$src2, (imm:i8)))<<P:Predicate_shld>>
                    // Dst: (SHLD16rri8:i16 GR16:i16:$src1, GR16:i16:$src2, (imm:i8):$amt1)
                  /*SwitchType*/ 12,  MVT::i64,// ->54442
/*54430*/           OPC_EmitConvertToTarget, 1,
/*54432*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::SHLD64rri8), 0,
                        1/*#VTs*/, MVT::i64, 3/*#Ops*/, 0, 2, 3, 
                    // Src: (or:i64 (shl:i64 GR64:i64:$src1, (imm:i8):$amt1), (srl:i64 GR64:i64:$src2, (imm:i8)))<<P:Predicate_shld>>
                    // Dst: (SHLD64rri8:i64 GR64:i64:$src1, GR64:i64:$src2, (imm:i8):$amt1)
                  0, // EndSwitchType
/*54443*/       /*Scope*/ 68, /*->54512*/
/*54444*/         OPC_MoveChild, 1,
/*54446*/         OPC_CheckOpcode, ISD::Constant,
/*54448*/         OPC_CheckType, MVT::i8,
/*54450*/         OPC_MoveParent,
/*54451*/         OPC_MoveParent,
/*54452*/         OPC_MoveChild, 1,
/*54454*/         OPC_CheckOpcode, ISD::SRL,
/*54456*/         OPC_RecordChild0, // #1 = $src1
/*54457*/         OPC_RecordChild1, // #2 = $amt1
/*54458*/         OPC_MoveChild, 1,
/*54460*/         OPC_CheckOpcode, ISD::Constant,
/*54462*/         OPC_CheckType, MVT::i8,
/*54464*/         OPC_MoveParent,
/*54465*/         OPC_MoveParent,
/*54466*/         OPC_CheckPredicate, 7, // Predicate_shrd
/*54468*/         OPC_SwitchType /*3 cases */, 12,  MVT::i32,// ->54483
/*54471*/           OPC_EmitConvertToTarget, 2,
/*54473*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::SHRD32rri8), 0,
                        1/*#VTs*/, MVT::i32, 3/*#Ops*/, 1, 0, 3, 
                    // Src: (or:i32 (shl:i32 GR32:i32:$src2, (imm:i8)), (srl:i32 GR32:i32:$src1, (imm:i8):$amt1))<<P:Predicate_shrd>>
                    // Dst: (SHRD32rri8:i32 GR32:i32:$src1, GR32:i32:$src2, (imm:i8):$amt1)
                  /*SwitchType*/ 12,  MVT::i16,// ->54497
/*54485*/           OPC_EmitConvertToTarget, 2,
/*54487*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::SHRD16rri8), 0,
                        1/*#VTs*/, MVT::i16, 3/*#Ops*/, 1, 0, 3, 
                    // Src: (or:i16 (shl:i16 GR16:i16:$src2, (imm:i8)), (srl:i16 GR16:i16:$src1, (imm:i8):$amt1))<<P:Predicate_shrd>>
                    // Dst: (SHRD16rri8:i16 GR16:i16:$src1, GR16:i16:$src2, (imm:i8):$amt1)
                  /*SwitchType*/ 12,  MVT::i64,// ->54511
/*54499*/           OPC_EmitConvertToTarget, 2,
/*54501*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::SHRD64rri8), 0,
                        1/*#VTs*/, MVT::i64, 3/*#Ops*/, 1, 0, 3, 
                    // Src: (or:i64 (shl:i64 GR64:i64:$src2, (imm:i8)), (srl:i64 GR64:i64:$src1, (imm:i8):$amt1))<<P:Predicate_shrd>>
                    // Dst: (SHRD64rri8:i64 GR64:i64:$src1, GR64:i64:$src2, (imm:i8):$amt1)
                  0, // EndSwitchType
/*54512*/       0, /*End of Scope*/
              0, // EndSwitchOpcode
/*54514*/   /*Scope*/ 57, /*->54572*/
/*54515*/     OPC_RecordNode, // #0 = $src
/*54516*/     OPC_SwitchType /*2 cases */, 36,  MVT::i32,// ->54555
/*54519*/       OPC_Scope, 16, /*->54537*/ // 2 children in Scope
/*54521*/         OPC_CheckPatternPredicate, 2, // (!Subtarget->is64Bit())
/*54523*/         OPC_CheckComplexPat, /*CP*/3, /*#*/0, // SelectLEAAddr:$src #1 #2 #3 #4
/*54526*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::LEA32r), 0,
                      1/*#VTs*/, MVT::i32, 4/*#Ops*/, 1, 2, 3, 4, 
                  // Src: lea32addr:i32:$src
                  // Dst: (LEA32r:i32 lea32addr:i32:$src)
/*54537*/       /*Scope*/ 16, /*->54554*/
/*54538*/         OPC_CheckPatternPredicate, 3, // (Subtarget->is64Bit())
/*54540*/         OPC_CheckComplexPat, /*CP*/3, /*#*/0, // SelectLEAAddr:$src #1 #2 #3 #4
/*54543*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::LEA64_32r), 0,
                      1/*#VTs*/, MVT::i32, 4/*#Ops*/, 1, 2, 3, 4, 
                  // Src: lea32addr:i32:$src
                  // Dst: (LEA64_32r:i32 lea32addr:i32:$src)
/*54554*/       0, /*End of Scope*/
              /*SwitchType*/ 14,  MVT::i64,// ->54571
/*54557*/       OPC_CheckComplexPat, /*CP*/4, /*#*/0, // SelectLEAAddr:$src #1 #2 #3 #4
/*54560*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::LEA64r), 0,
                    1/*#VTs*/, MVT::i64, 4/*#Ops*/, 1, 2, 3, 4, 
                // Src: lea64addr:i64:$src
                // Dst: (LEA64r:i64 lea64addr:i64:$src)
              0, // EndSwitchType
/*54572*/   /*Scope*/ 28|128,1/*156*/, /*->54730*/
/*54574*/     OPC_RecordChild0, // #0 = $src1
/*54575*/     OPC_RecordChild1, // #1 = $src2
/*54576*/     OPC_Scope, 110, /*->54688*/ // 2 children in Scope
/*54578*/       OPC_MoveChild, 1,
/*54580*/       OPC_CheckOpcode, ISD::Constant,
/*54582*/       OPC_Scope, 49, /*->54633*/ // 3 children in Scope
/*54584*/         OPC_CheckPredicate, 11, // Predicate_immSext8
/*54586*/         OPC_MoveParent,
/*54587*/         OPC_CheckPredicate, 71, // Predicate_or_is_add
/*54589*/         OPC_SwitchType /*3 cases */, 12,  MVT::i16,// ->54604
/*54592*/           OPC_EmitConvertToTarget, 1,
/*54594*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::ADD16ri8), 0,
                        2/*#VTs*/, MVT::i16, MVT::i32, 2/*#Ops*/, 0, 2, 
                    // Src: (or:i16 GR16:i16:$src1, (imm:i16)<<P:Predicate_immSext8>>:$src2)<<P:Predicate_or_is_add>>
                    // Dst: (ADD16ri8:i16 GR16:i16:$src1, (imm:i16)<<P:Predicate_immSext8>>:$src2)
                  /*SwitchType*/ 12,  MVT::i32,// ->54618
/*54606*/           OPC_EmitConvertToTarget, 1,
/*54608*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::ADD32ri8), 0,
                        2/*#VTs*/, MVT::i32, MVT::i32, 2/*#Ops*/, 0, 2, 
                    // Src: (or:i32 GR32:i32:$src1, (imm:i32)<<P:Predicate_immSext8>>:$src2)<<P:Predicate_or_is_add>>
                    // Dst: (ADD32ri8:i32 GR32:i32:$src1, (imm:i32)<<P:Predicate_immSext8>>:$src2)
                  /*SwitchType*/ 12,  MVT::i64,// ->54632
/*54620*/           OPC_EmitConvertToTarget, 1,
/*54622*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::ADD64ri8), 0,
                        2/*#VTs*/, MVT::i64, MVT::i32, 2/*#Ops*/, 0, 2, 
                    // Src: (or:i64 GR64:i64:$src1, (imm:i64)<<P:Predicate_immSext8>>:$src2)<<P:Predicate_or_is_add>>
                    // Dst: (ADD64ri8:i64 GR64:i64:$src1, (imm:i64)<<P:Predicate_immSext8>>:$src2)
                  0, // EndSwitchType
/*54633*/       /*Scope*/ 19, /*->54653*/
/*54634*/         OPC_CheckPredicate, 12, // Predicate_i64immSExt32
/*54636*/         OPC_MoveParent,
/*54637*/         OPC_CheckPredicate, 71, // Predicate_or_is_add
/*54639*/         OPC_CheckType, MVT::i64,
/*54641*/         OPC_EmitConvertToTarget, 1,
/*54643*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::ADD64ri32), 0,
                      2/*#VTs*/, MVT::i64, MVT::i32, 2/*#Ops*/, 0, 2, 
                  // Src: (or:i64 GR64:i64:$src1, (imm:i64)<<P:Predicate_i64immSExt32>>:$src2)<<P:Predicate_or_is_add>>
                  // Dst: (ADD64ri32:i64 GR64:i64:$src1, (imm:i64)<<P:Predicate_i64immSExt32>>:$src2)
/*54653*/       /*Scope*/ 33, /*->54687*/
/*54654*/         OPC_MoveParent,
/*54655*/         OPC_CheckPredicate, 71, // Predicate_or_is_add
/*54657*/         OPC_SwitchType /*2 cases */, 12,  MVT::i16,// ->54672
/*54660*/           OPC_EmitConvertToTarget, 1,
/*54662*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::ADD16ri), 0,
                        2/*#VTs*/, MVT::i16, MVT::i32, 2/*#Ops*/, 0, 2, 
                    // Src: (or:i16 GR16:i16:$src1, (imm:i16):$src2)<<P:Predicate_or_is_add>>
                    // Dst: (ADD16ri:i16 GR16:i16:$src1, (imm:i16):$src2)
                  /*SwitchType*/ 12,  MVT::i32,// ->54686
/*54674*/           OPC_EmitConvertToTarget, 1,
/*54676*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::ADD32ri), 0,
                        2/*#VTs*/, MVT::i32, MVT::i32, 2/*#Ops*/, 0, 2, 
                    // Src: (or:i32 GR32:i32:$src1, (imm:i32):$src2)<<P:Predicate_or_is_add>>
                    // Dst: (ADD32ri:i32 GR32:i32:$src1, (imm:i32):$src2)
                  0, // EndSwitchType
/*54687*/       0, /*End of Scope*/
/*54688*/     /*Scope*/ 40, /*->54729*/
/*54689*/       OPC_CheckPredicate, 71, // Predicate_or_is_add
/*54691*/       OPC_SwitchType /*3 cases */, 10,  MVT::i16,// ->54704
/*54694*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::ADD16rr), 0,
                      2/*#VTs*/, MVT::i16, MVT::i32, 2/*#Ops*/, 0, 1, 
                  // Src: (or:i16 GR16:i16:$src1, GR16:i16:$src2)<<P:Predicate_or_is_add>>
                  // Dst: (ADD16rr:i16 GR16:i16:$src1, GR16:i16:$src2)
                /*SwitchType*/ 10,  MVT::i32,// ->54716
/*54706*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::ADD32rr), 0,
                      2/*#VTs*/, MVT::i32, MVT::i32, 2/*#Ops*/, 0, 1, 
                  // Src: (or:i32 GR32:i32:$src1, GR32:i32:$src2)<<P:Predicate_or_is_add>>
                  // Dst: (ADD32rr:i32 GR32:i32:$src1, GR32:i32:$src2)
                /*SwitchType*/ 10,  MVT::i64,// ->54728
/*54718*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::ADD64rr), 0,
                      2/*#VTs*/, MVT::i64, MVT::i32, 2/*#Ops*/, 0, 1, 
                  // Src: (or:i64 GR64:i64:$src1, GR64:i64:$src2)<<P:Predicate_or_is_add>>
                  // Dst: (ADD64rr:i64 GR64:i64:$src1, GR64:i64:$src2)
                0, // EndSwitchType
/*54729*/     0, /*End of Scope*/
/*54730*/   /*Scope*/ 29, /*->54760*/
/*54731*/     OPC_MoveChild, 0,
/*54733*/     OPC_CheckOpcode, ISD::BIT_CONVERT,
/*54735*/     OPC_RecordChild0, // #0 = $src1
/*54736*/     OPC_CheckChild0Type, MVT::v2f64,
/*54738*/     OPC_MoveParent,
/*54739*/     OPC_MoveChild, 1,
/*54741*/     OPC_CheckOpcode, ISD::BIT_CONVERT,
/*54743*/     OPC_RecordChild0, // #1 = $src2
/*54744*/     OPC_CheckChild0Type, MVT::v2f64,
/*54746*/     OPC_MoveParent,
/*54747*/     OPC_CheckType, MVT::v2i64,
/*54749*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*54751*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::ORPDrr), 0,
                  1/*#VTs*/, MVT::v2i64, 2/*#Ops*/, 0, 1, 
              // Src: (or:v2i64 (bitconvert:v2i64 VR128:v2f64:$src1), (bitconvert:v2i64 VR128:v2f64:$src2))
              // Dst: (ORPDrr:v2i64 VR128:v2f64:$src1, VR128:v2f64:$src2)
/*54760*/   /*Scope*/ 90|128,1/*218*/, /*->54980*/
/*54762*/     OPC_RecordChild0, // #0 = $src1
/*54763*/     OPC_RecordChild1, // #1 = $src2
/*54764*/     OPC_Scope, 118, /*->54884*/ // 7 children in Scope
/*54766*/       OPC_MoveChild, 1,
/*54768*/       OPC_CheckOpcode, ISD::Constant,
/*54770*/       OPC_Scope, 47, /*->54819*/ // 3 children in Scope
/*54772*/         OPC_CheckPredicate, 11, // Predicate_immSext8
/*54774*/         OPC_MoveParent,
/*54775*/         OPC_SwitchType /*3 cases */, 12,  MVT::i16,// ->54790
/*54778*/           OPC_EmitConvertToTarget, 1,
/*54780*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::OR16ri8), 0,
                        2/*#VTs*/, MVT::i16, MVT::i32, 2/*#Ops*/, 0, 2, 
                    // Src: (or:i16 GR16:i16:$src1, (imm:i16)<<P:Predicate_immSext8>>:$src2)
                    // Dst: (OR16ri8:i16 GR16:i16:$src1, (imm:i16):$src2)
                  /*SwitchType*/ 12,  MVT::i32,// ->54804
/*54792*/           OPC_EmitConvertToTarget, 1,
/*54794*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::OR32ri8), 0,
                        2/*#VTs*/, MVT::i32, MVT::i32, 2/*#Ops*/, 0, 2, 
                    // Src: (or:i32 GR32:i32:$src1, (imm:i32)<<P:Predicate_immSext8>>:$src2)
                    // Dst: (OR32ri8:i32 GR32:i32:$src1, (imm:i32):$src2)
                  /*SwitchType*/ 12,  MVT::i64,// ->54818
/*54806*/           OPC_EmitConvertToTarget, 1,
/*54808*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::OR64ri8), 0,
                        2/*#VTs*/, MVT::i64, MVT::i32, 2/*#Ops*/, 0, 2, 
                    // Src: (or:i64 GR64:i64:$src1, (imm:i64)<<P:Predicate_immSext8>>:$src2)
                    // Dst: (OR64ri8:i64 GR64:i64:$src1, (imm:i64):$src2)
                  0, // EndSwitchType
/*54819*/       /*Scope*/ 17, /*->54837*/
/*54820*/         OPC_CheckPredicate, 12, // Predicate_i64immSExt32
/*54822*/         OPC_MoveParent,
/*54823*/         OPC_CheckType, MVT::i64,
/*54825*/         OPC_EmitConvertToTarget, 1,
/*54827*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::OR64ri32), 0,
                      2/*#VTs*/, MVT::i64, MVT::i32, 2/*#Ops*/, 0, 2, 
                  // Src: (or:i64 GR64:i64:$src1, (imm:i64)<<P:Predicate_i64immSExt32>>:$src2)
                  // Dst: (OR64ri32:i64 GR64:i64:$src1, (imm:i64):$src2)
/*54837*/       /*Scope*/ 45, /*->54883*/
/*54838*/         OPC_MoveParent,
/*54839*/         OPC_SwitchType /*3 cases */, 12,  MVT::i8,// ->54854
/*54842*/           OPC_EmitConvertToTarget, 1,
/*54844*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::OR8ri), 0,
                        2/*#VTs*/, MVT::i8, MVT::i32, 2/*#Ops*/, 0, 2, 
                    // Src: (or:i8 GR8:i8:$src1, (imm:i8):$src2)
                    // Dst: (OR8ri:i8 GR8:i8:$src1, (imm:i8):$src2)
                  /*SwitchType*/ 12,  MVT::i16,// ->54868
/*54856*/           OPC_EmitConvertToTarget, 1,
/*54858*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::OR16ri), 0,
                        2/*#VTs*/, MVT::i16, MVT::i32, 2/*#Ops*/, 0, 2, 
                    // Src: (or:i16 GR16:i16:$src1, (imm:i16):$src2)
                    // Dst: (OR16ri:i16 GR16:i16:$src1, (imm:i16):$src2)
                  /*SwitchType*/ 12,  MVT::i32,// ->54882
/*54870*/           OPC_EmitConvertToTarget, 1,
/*54872*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::OR32ri), 0,
                        2/*#VTs*/, MVT::i32, MVT::i32, 2/*#Ops*/, 0, 2, 
                    // Src: (or:i32 GR32:i32:$src1, (imm:i32):$src2)
                    // Dst: (OR32ri:i32 GR32:i32:$src1, (imm:i32):$src2)
                  0, // EndSwitchType
/*54883*/       0, /*End of Scope*/
/*54884*/     /*Scope*/ 12, /*->54897*/
/*54885*/       OPC_CheckType, MVT::i8,
/*54887*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::OR8rr), 0,
                    2/*#VTs*/, MVT::i8, MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (or:i8 GR8:i8:$src1, GR8:i8:$src2)
                // Dst: (OR8rr:i8 GR8:i8:$src1, GR8:i8:$src2)
/*54897*/     /*Scope*/ 12, /*->54910*/
/*54898*/       OPC_CheckType, MVT::i16,
/*54900*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::OR16rr), 0,
                    2/*#VTs*/, MVT::i16, MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (or:i16 GR16:i16:$src1, GR16:i16:$src2)
                // Dst: (OR16rr:i16 GR16:i16:$src1, GR16:i16:$src2)
/*54910*/     /*Scope*/ 12, /*->54923*/
/*54911*/       OPC_CheckType, MVT::i32,
/*54913*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::OR32rr), 0,
                    2/*#VTs*/, MVT::i32, MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (or:i32 GR32:i32:$src1, GR32:i32:$src2)
                // Dst: (OR32rr:i32 GR32:i32:$src1, GR32:i32:$src2)
/*54923*/     /*Scope*/ 12, /*->54936*/
/*54924*/       OPC_CheckType, MVT::i64,
/*54926*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::OR64rr), 0,
                    2/*#VTs*/, MVT::i64, MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (or:i64 GR64:i64:$src1, GR64:i64:$src2)
                // Dst: (OR64rr:i64 GR64:i64:$src1, GR64:i64:$src2)
/*54936*/     /*Scope*/ 28, /*->54965*/
/*54937*/       OPC_CheckType, MVT::v2i64,
/*54939*/       OPC_Scope, 11, /*->54952*/ // 2 children in Scope
/*54941*/         OPC_CheckPatternPredicate, 0, // (Subtarget->hasSSE1())
/*54943*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::ORPSrr), 0,
                      1/*#VTs*/, MVT::v2i64, 2/*#Ops*/, 0, 1, 
                  // Src: (or:v2i64 VR128:v2i64:$src1, VR128:v2i64:$src2)
                  // Dst: (ORPSrr:v2i64 VR128:v2i64:$src1, VR128:v2i64:$src2)
/*54952*/       /*Scope*/ 11, /*->54964*/
/*54953*/         OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*54955*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::PORrr), 0,
                      1/*#VTs*/, MVT::v2i64, 2/*#Ops*/, 0, 1, 
                  // Src: (or:v2i64 VR128:v2i64:$src1, VR128:v2i64:$src2)
                  // Dst: (PORrr:v2i64 VR128:v2i64:$src1, VR128:v2i64:$src2)
/*54964*/       0, /*End of Scope*/
/*54965*/     /*Scope*/ 13, /*->54979*/
/*54966*/       OPC_CheckType, MVT::v1i64,
/*54968*/       OPC_CheckPatternPredicate, 8, // (Subtarget->hasMMX())
/*54970*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PORrr), 0,
                    1/*#VTs*/, MVT::v1i64, 2/*#Ops*/, 0, 1, 
                // Src: (or:v1i64 VR64:v1i64:$src1, VR64:v1i64:$src2)
                // Dst: (MMX_PORrr:v1i64 VR64:v1i64:$src1, VR64:v1i64:$src2)
/*54979*/     0, /*End of Scope*/
/*54980*/   0, /*End of Scope*/
          /*SwitchOpcode*/ 35|128,6/*803*/,  ISD::XOR,// ->55787
/*54984*/   OPC_Scope, 39|128,1/*167*/, /*->55154*/ // 6 children in Scope
/*54987*/     OPC_MoveChild, 0,
/*54989*/     OPC_SwitchOpcode /*2 cases */, 87,  ISD::BIT_CONVERT,// ->55079
/*54992*/       OPC_RecordChild0, // #0 = $src1
/*54993*/       OPC_Scope, 41, /*->55036*/ // 2 children in Scope
/*54995*/         OPC_CheckChild0Type, MVT::v4f32,
/*54997*/         OPC_MoveParent,
/*54998*/         OPC_MoveChild, 1,
/*55000*/         OPC_CheckOpcode, ISD::LOAD,
/*55002*/         OPC_RecordMemRef,
/*55003*/         OPC_RecordNode, // #1 = 'ld' chained node
/*55004*/         OPC_CheckFoldableChainNode,
/*55005*/         OPC_RecordChild1, // #2 = $src2
/*55006*/         OPC_CheckPredicate, 2, // Predicate_unindexedload
/*55008*/         OPC_CheckPredicate, 8, // Predicate_load
/*55010*/         OPC_CheckPredicate, 23, // Predicate_memop
/*55012*/         OPC_MoveParent,
/*55013*/         OPC_CheckType, MVT::v2i64,
/*55015*/         OPC_CheckPatternPredicate, 0, // (Subtarget->hasSSE1())
/*55017*/         OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*55020*/         OPC_EmitMergeInputChains, 1, 1, 
/*55023*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::XORPSrm), 0|OPFL_Chain|OPFL_MemRefs,
                      1/*#VTs*/, MVT::v2i64, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                  // Src: (xor:v2i64 (bitconvert:v2i64 VR128:v4f32:$src1), (ld:v2i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>)
                  // Dst: (XORPSrm:v2i64 VR128:v4f32:$src1, addr:iPTR:$src2)
/*55036*/       /*Scope*/ 41, /*->55078*/
/*55037*/         OPC_CheckChild0Type, MVT::v2f64,
/*55039*/         OPC_MoveParent,
/*55040*/         OPC_MoveChild, 1,
/*55042*/         OPC_CheckOpcode, ISD::LOAD,
/*55044*/         OPC_RecordMemRef,
/*55045*/         OPC_RecordNode, // #1 = 'ld' chained node
/*55046*/         OPC_CheckFoldableChainNode,
/*55047*/         OPC_RecordChild1, // #2 = $src2
/*55048*/         OPC_CheckPredicate, 2, // Predicate_unindexedload
/*55050*/         OPC_CheckPredicate, 8, // Predicate_load
/*55052*/         OPC_CheckPredicate, 23, // Predicate_memop
/*55054*/         OPC_MoveParent,
/*55055*/         OPC_CheckType, MVT::v2i64,
/*55057*/         OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*55059*/         OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*55062*/         OPC_EmitMergeInputChains, 1, 1, 
/*55065*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::XORPDrm), 0|OPFL_Chain|OPFL_MemRefs,
                      1/*#VTs*/, MVT::v2i64, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                  // Src: (xor:v2i64 (bitconvert:v2i64 VR128:v2f64:$src1), (ld:v2i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>)
                  // Dst: (XORPDrm:v2i64 VR128:v2f64:$src1, addr:iPTR:$src2)
/*55078*/       0, /*End of Scope*/
              /*SwitchOpcode*/ 72,  ISD::LOAD,// ->55153
/*55081*/       OPC_RecordMemRef,
/*55082*/       OPC_RecordNode, // #0 = 'ld' chained node
/*55083*/       OPC_CheckFoldableChainNode,
/*55084*/       OPC_RecordChild1, // #1 = $src2
/*55085*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*55087*/       OPC_CheckPredicate, 8, // Predicate_load
/*55089*/       OPC_CheckPredicate, 23, // Predicate_memop
/*55091*/       OPC_MoveParent,
/*55092*/       OPC_MoveChild, 1,
/*55094*/       OPC_CheckOpcode, ISD::BIT_CONVERT,
/*55096*/       OPC_RecordChild0, // #2 = $src1
/*55097*/       OPC_Scope, 26, /*->55125*/ // 2 children in Scope
/*55099*/         OPC_CheckChild0Type, MVT::v4f32,
/*55101*/         OPC_MoveParent,
/*55102*/         OPC_CheckType, MVT::v2i64,
/*55104*/         OPC_CheckPatternPredicate, 0, // (Subtarget->hasSSE1())
/*55106*/         OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*55109*/         OPC_EmitMergeInputChains, 1, 0, 
/*55112*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::XORPSrm), 0|OPFL_Chain|OPFL_MemRefs,
                      1/*#VTs*/, MVT::v2i64, 6/*#Ops*/, 2, 3, 4, 5, 6, 7, 
                  // Src: (xor:v2i64 (ld:v2i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>, (bitconvert:v2i64 VR128:v4f32:$src1))
                  // Dst: (XORPSrm:v2i64 VR128:v4f32:$src1, addr:iPTR:$src2)
/*55125*/       /*Scope*/ 26, /*->55152*/
/*55126*/         OPC_CheckChild0Type, MVT::v2f64,
/*55128*/         OPC_MoveParent,
/*55129*/         OPC_CheckType, MVT::v2i64,
/*55131*/         OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*55133*/         OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*55136*/         OPC_EmitMergeInputChains, 1, 0, 
/*55139*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::XORPDrm), 0|OPFL_Chain|OPFL_MemRefs,
                      1/*#VTs*/, MVT::v2i64, 6/*#Ops*/, 2, 3, 4, 5, 6, 7, 
                  // Src: (xor:v2i64 (ld:v2i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>, (bitconvert:v2i64 VR128:v2f64:$src1))
                  // Dst: (XORPDrm:v2i64 VR128:v2f64:$src1, addr:iPTR:$src2)
/*55152*/       0, /*End of Scope*/
              0, // EndSwitchOpcode
/*55154*/   /*Scope*/ 31|128,1/*159*/, /*->55315*/
/*55156*/     OPC_RecordChild0, // #0 = $src1
/*55157*/     OPC_MoveChild, 1,
/*55159*/     OPC_CheckOpcode, ISD::LOAD,
/*55161*/     OPC_RecordMemRef,
/*55162*/     OPC_RecordNode, // #1 = 'ld' chained node
/*55163*/     OPC_CheckFoldableChainNode,
/*55164*/     OPC_RecordChild1, // #2 = $src2
/*55165*/     OPC_CheckPredicate, 2, // Predicate_unindexedload
/*55167*/     OPC_CheckPredicate, 8, // Predicate_load
/*55169*/     OPC_Scope, 91, /*->55262*/ // 3 children in Scope
/*55171*/       OPC_MoveParent,
/*55172*/       OPC_SwitchType /*4 cases */, 20,  MVT::i8,// ->55195
/*55175*/         OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*55178*/         OPC_EmitMergeInputChains, 1, 1, 
/*55181*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::XOR8rm), 0|OPFL_Chain|OPFL_MemRefs,
                      2/*#VTs*/, MVT::i8, MVT::i32, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                  // Src: (xor:i8 GR8:i8:$src1, (ld:i8 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)
                  // Dst: (XOR8rm:i8 GR8:i8:$src1, addr:iPTR:$src2)
                /*SwitchType*/ 20,  MVT::i16,// ->55217
/*55197*/         OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*55200*/         OPC_EmitMergeInputChains, 1, 1, 
/*55203*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::XOR16rm), 0|OPFL_Chain|OPFL_MemRefs,
                      2/*#VTs*/, MVT::i16, MVT::i32, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                  // Src: (xor:i16 GR16:i16:$src1, (ld:i16 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)
                  // Dst: (XOR16rm:i16 GR16:i16:$src1, addr:iPTR:$src2)
                /*SwitchType*/ 20,  MVT::i32,// ->55239
/*55219*/         OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*55222*/         OPC_EmitMergeInputChains, 1, 1, 
/*55225*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::XOR32rm), 0|OPFL_Chain|OPFL_MemRefs,
                      2/*#VTs*/, MVT::i32, MVT::i32, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                  // Src: (xor:i32 GR32:i32:$src1, (ld:i32 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)
                  // Dst: (XOR32rm:i32 GR32:i32:$src1, addr:iPTR:$src2)
                /*SwitchType*/ 20,  MVT::i64,// ->55261
/*55241*/         OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*55244*/         OPC_EmitMergeInputChains, 1, 1, 
/*55247*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::XOR64rm), 0|OPFL_Chain|OPFL_MemRefs,
                      2/*#VTs*/, MVT::i64, MVT::i32, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                  // Src: (xor:i64 GR64:i64:$src1, (ld:i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)
                  // Dst: (XOR64rm:i64 GR64:i64:$src1, addr:iPTR:$src2)
                0, // EndSwitchType
/*55262*/     /*Scope*/ 26, /*->55289*/
/*55263*/       OPC_CheckPredicate, 23, // Predicate_memop
/*55265*/       OPC_MoveParent,
/*55266*/       OPC_CheckType, MVT::v2i64,
/*55268*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*55270*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*55273*/       OPC_EmitMergeInputChains, 1, 1, 
/*55276*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PXORrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v2i64, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (xor:v2i64 VR128:v2i64:$src1, (ld:v2i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>)
                // Dst: (PXORrm:v2i64 VR128:v2i64:$src1, addr:iPTR:$src2)
/*55289*/     /*Scope*/ 24, /*->55314*/
/*55290*/       OPC_MoveParent,
/*55291*/       OPC_CheckType, MVT::v1i64,
/*55293*/       OPC_CheckPatternPredicate, 8, // (Subtarget->hasMMX())
/*55295*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*55298*/       OPC_EmitMergeInputChains, 1, 1, 
/*55301*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PXORrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v1i64, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (xor:v1i64 VR64:v1i64:$src1, (ld:v1i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)
                // Dst: (MMX_PXORrm:v1i64 VR64:v1i64:$src1, addr:iPTR:$src2)
/*55314*/     0, /*End of Scope*/
/*55315*/   /*Scope*/ 33|128,1/*161*/, /*->55478*/
/*55317*/     OPC_MoveChild, 0,
/*55319*/     OPC_CheckOpcode, ISD::LOAD,
/*55321*/     OPC_RecordMemRef,
/*55322*/     OPC_RecordNode, // #0 = 'ld' chained node
/*55323*/     OPC_CheckFoldableChainNode,
/*55324*/     OPC_RecordChild1, // #1 = $src2
/*55325*/     OPC_CheckPredicate, 2, // Predicate_unindexedload
/*55327*/     OPC_CheckPredicate, 8, // Predicate_load
/*55329*/     OPC_Scope, 92, /*->55423*/ // 3 children in Scope
/*55331*/       OPC_MoveParent,
/*55332*/       OPC_RecordChild1, // #2 = $src1
/*55333*/       OPC_SwitchType /*4 cases */, 20,  MVT::i8,// ->55356
/*55336*/         OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*55339*/         OPC_EmitMergeInputChains, 1, 0, 
/*55342*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::XOR8rm), 0|OPFL_Chain|OPFL_MemRefs,
                      2/*#VTs*/, MVT::i8, MVT::i32, 6/*#Ops*/, 2, 3, 4, 5, 6, 7, 
                  // Src: (xor:i8 (ld:i8 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR8:i8:$src1)
                  // Dst: (XOR8rm:i8 GR8:i8:$src1, addr:iPTR:$src2)
                /*SwitchType*/ 20,  MVT::i16,// ->55378
/*55358*/         OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*55361*/         OPC_EmitMergeInputChains, 1, 0, 
/*55364*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::XOR16rm), 0|OPFL_Chain|OPFL_MemRefs,
                      2/*#VTs*/, MVT::i16, MVT::i32, 6/*#Ops*/, 2, 3, 4, 5, 6, 7, 
                  // Src: (xor:i16 (ld:i16 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR16:i16:$src1)
                  // Dst: (XOR16rm:i16 GR16:i16:$src1, addr:iPTR:$src2)
                /*SwitchType*/ 20,  MVT::i32,// ->55400
/*55380*/         OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*55383*/         OPC_EmitMergeInputChains, 1, 0, 
/*55386*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::XOR32rm), 0|OPFL_Chain|OPFL_MemRefs,
                      2/*#VTs*/, MVT::i32, MVT::i32, 6/*#Ops*/, 2, 3, 4, 5, 6, 7, 
                  // Src: (xor:i32 (ld:i32 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR32:i32:$src1)
                  // Dst: (XOR32rm:i32 GR32:i32:$src1, addr:iPTR:$src2)
                /*SwitchType*/ 20,  MVT::i64,// ->55422
/*55402*/         OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*55405*/         OPC_EmitMergeInputChains, 1, 0, 
/*55408*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::XOR64rm), 0|OPFL_Chain|OPFL_MemRefs,
                      2/*#VTs*/, MVT::i64, MVT::i32, 6/*#Ops*/, 2, 3, 4, 5, 6, 7, 
                  // Src: (xor:i64 (ld:i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR64:i64:$src1)
                  // Dst: (XOR64rm:i64 GR64:i64:$src1, addr:iPTR:$src2)
                0, // EndSwitchType
/*55423*/     /*Scope*/ 27, /*->55451*/
/*55424*/       OPC_CheckPredicate, 23, // Predicate_memop
/*55426*/       OPC_MoveParent,
/*55427*/       OPC_RecordChild1, // #2 = $src1
/*55428*/       OPC_CheckType, MVT::v2i64,
/*55430*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*55432*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*55435*/       OPC_EmitMergeInputChains, 1, 0, 
/*55438*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PXORrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v2i64, 6/*#Ops*/, 2, 3, 4, 5, 6, 7, 
                // Src: (xor:v2i64 (ld:v2i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>, VR128:v2i64:$src1)
                // Dst: (PXORrm:v2i64 VR128:v2i64:$src1, addr:iPTR:$src2)
/*55451*/     /*Scope*/ 25, /*->55477*/
/*55452*/       OPC_MoveParent,
/*55453*/       OPC_RecordChild1, // #2 = $src1
/*55454*/       OPC_CheckType, MVT::v1i64,
/*55456*/       OPC_CheckPatternPredicate, 8, // (Subtarget->hasMMX())
/*55458*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*55461*/       OPC_EmitMergeInputChains, 1, 0, 
/*55464*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PXORrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v1i64, 6/*#Ops*/, 2, 3, 4, 5, 6, 7, 
                // Src: (xor:v1i64 (ld:v1i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR64:v1i64:$src1)
                // Dst: (MMX_PXORrm:v1i64 VR64:v1i64:$src1, addr:iPTR:$src2)
/*55477*/     0, /*End of Scope*/
/*55478*/   /*Scope*/ 57, /*->55536*/
/*55479*/     OPC_RecordChild0, // #0 = $src
/*55480*/     OPC_MoveChild, 1,
/*55482*/     OPC_CheckInteger, 127|128,127|128,127|128,127|128,127|128,127|128,127|128,127|128,127|128,1/*18446744073709551615*/, 
/*55493*/     OPC_MoveParent,
/*55494*/     OPC_SwitchType /*4 cases */, 8,  MVT::i8,// ->55505
/*55497*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::NOT8r), 0,
                    1/*#VTs*/, MVT::i8, 1/*#Ops*/, 0, 
                // Src: (xor:i8 GR8:i8:$src, -1:i8)
                // Dst: (NOT8r:i8 GR8:i8:$src)
              /*SwitchType*/ 8,  MVT::i16,// ->55515
/*55507*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::NOT16r), 0,
                    1/*#VTs*/, MVT::i16, 1/*#Ops*/, 0, 
                // Src: (xor:i16 GR16:i16:$src, -1:i16)
                // Dst: (NOT16r:i16 GR16:i16:$src)
              /*SwitchType*/ 8,  MVT::i32,// ->55525
/*55517*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::NOT32r), 0,
                    1/*#VTs*/, MVT::i32, 1/*#Ops*/, 0, 
                // Src: (xor:i32 GR32:i32:$src, -1:i32)
                // Dst: (NOT32r:i32 GR32:i32:$src)
              /*SwitchType*/ 8,  MVT::i64,// ->55535
/*55527*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::NOT64r), 0,
                    1/*#VTs*/, MVT::i64, 1/*#Ops*/, 0, 
                // Src: (xor:i64 GR64:i64:$src, -1:i64)
                // Dst: (NOT64r:i64 GR64:i64:$src)
              0, // EndSwitchType
/*55536*/   /*Scope*/ 29, /*->55566*/
/*55537*/     OPC_MoveChild, 0,
/*55539*/     OPC_CheckOpcode, ISD::BIT_CONVERT,
/*55541*/     OPC_RecordChild0, // #0 = $src1
/*55542*/     OPC_CheckChild0Type, MVT::v2f64,
/*55544*/     OPC_MoveParent,
/*55545*/     OPC_MoveChild, 1,
/*55547*/     OPC_CheckOpcode, ISD::BIT_CONVERT,
/*55549*/     OPC_RecordChild0, // #1 = $src2
/*55550*/     OPC_CheckChild0Type, MVT::v2f64,
/*55552*/     OPC_MoveParent,
/*55553*/     OPC_CheckType, MVT::v2i64,
/*55555*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*55557*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::XORPDrr), 0,
                  1/*#VTs*/, MVT::v2i64, 2/*#Ops*/, 0, 1, 
              // Src: (xor:v2i64 (bitconvert:v2i64 VR128:v2f64:$src1), (bitconvert:v2i64 VR128:v2f64:$src2))
              // Dst: (XORPDrr:v2i64 VR128:v2f64:$src1, VR128:v2f64:$src2)
/*55566*/   /*Scope*/ 90|128,1/*218*/, /*->55786*/
/*55568*/     OPC_RecordChild0, // #0 = $src1
/*55569*/     OPC_RecordChild1, // #1 = $src2
/*55570*/     OPC_Scope, 118, /*->55690*/ // 7 children in Scope
/*55572*/       OPC_MoveChild, 1,
/*55574*/       OPC_CheckOpcode, ISD::Constant,
/*55576*/       OPC_Scope, 47, /*->55625*/ // 3 children in Scope
/*55578*/         OPC_CheckPredicate, 11, // Predicate_immSext8
/*55580*/         OPC_MoveParent,
/*55581*/         OPC_SwitchType /*3 cases */, 12,  MVT::i16,// ->55596
/*55584*/           OPC_EmitConvertToTarget, 1,
/*55586*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::XOR16ri8), 0,
                        2/*#VTs*/, MVT::i16, MVT::i32, 2/*#Ops*/, 0, 2, 
                    // Src: (xor:i16 GR16:i16:$src1, (imm:i16)<<P:Predicate_immSext8>>:$src2)
                    // Dst: (XOR16ri8:i16 GR16:i16:$src1, (imm:i16):$src2)
                  /*SwitchType*/ 12,  MVT::i32,// ->55610
/*55598*/           OPC_EmitConvertToTarget, 1,
/*55600*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::XOR32ri8), 0,
                        2/*#VTs*/, MVT::i32, MVT::i32, 2/*#Ops*/, 0, 2, 
                    // Src: (xor:i32 GR32:i32:$src1, (imm:i32)<<P:Predicate_immSext8>>:$src2)
                    // Dst: (XOR32ri8:i32 GR32:i32:$src1, (imm:i32):$src2)
                  /*SwitchType*/ 12,  MVT::i64,// ->55624
/*55612*/           OPC_EmitConvertToTarget, 1,
/*55614*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::XOR64ri8), 0,
                        2/*#VTs*/, MVT::i64, MVT::i32, 2/*#Ops*/, 0, 2, 
                    // Src: (xor:i64 GR64:i64:$src1, (imm:i64)<<P:Predicate_immSext8>>:$src2)
                    // Dst: (XOR64ri8:i64 GR64:i64:$src1, (imm:i64):$src2)
                  0, // EndSwitchType
/*55625*/       /*Scope*/ 17, /*->55643*/
/*55626*/         OPC_CheckPredicate, 12, // Predicate_i64immSExt32
/*55628*/         OPC_MoveParent,
/*55629*/         OPC_CheckType, MVT::i64,
/*55631*/         OPC_EmitConvertToTarget, 1,
/*55633*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::XOR64ri32), 0,
                      2/*#VTs*/, MVT::i64, MVT::i32, 2/*#Ops*/, 0, 2, 
                  // Src: (xor:i64 GR64:i64:$src1, (imm:i64)<<P:Predicate_i64immSExt32>>:$src2)
                  // Dst: (XOR64ri32:i64 GR64:i64:$src1, (imm:i64):$src2)
/*55643*/       /*Scope*/ 45, /*->55689*/
/*55644*/         OPC_MoveParent,
/*55645*/         OPC_SwitchType /*3 cases */, 12,  MVT::i8,// ->55660
/*55648*/           OPC_EmitConvertToTarget, 1,
/*55650*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::XOR8ri), 0,
                        2/*#VTs*/, MVT::i8, MVT::i32, 2/*#Ops*/, 0, 2, 
                    // Src: (xor:i8 GR8:i8:$src1, (imm:i8):$src2)
                    // Dst: (XOR8ri:i8 GR8:i8:$src1, (imm:i8):$src2)
                  /*SwitchType*/ 12,  MVT::i16,// ->55674
/*55662*/           OPC_EmitConvertToTarget, 1,
/*55664*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::XOR16ri), 0,
                        2/*#VTs*/, MVT::i16, MVT::i32, 2/*#Ops*/, 0, 2, 
                    // Src: (xor:i16 GR16:i16:$src1, (imm:i16):$src2)
                    // Dst: (XOR16ri:i16 GR16:i16:$src1, (imm:i16):$src2)
                  /*SwitchType*/ 12,  MVT::i32,// ->55688
/*55676*/           OPC_EmitConvertToTarget, 1,
/*55678*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::XOR32ri), 0,
                        2/*#VTs*/, MVT::i32, MVT::i32, 2/*#Ops*/, 0, 2, 
                    // Src: (xor:i32 GR32:i32:$src1, (imm:i32):$src2)
                    // Dst: (XOR32ri:i32 GR32:i32:$src1, (imm:i32):$src2)
                  0, // EndSwitchType
/*55689*/       0, /*End of Scope*/
/*55690*/     /*Scope*/ 12, /*->55703*/
/*55691*/       OPC_CheckType, MVT::i8,
/*55693*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::XOR8rr), 0,
                    2/*#VTs*/, MVT::i8, MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (xor:i8 GR8:i8:$src1, GR8:i8:$src2)
                // Dst: (XOR8rr:i8 GR8:i8:$src1, GR8:i8:$src2)
/*55703*/     /*Scope*/ 12, /*->55716*/
/*55704*/       OPC_CheckType, MVT::i16,
/*55706*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::XOR16rr), 0,
                    2/*#VTs*/, MVT::i16, MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (xor:i16 GR16:i16:$src1, GR16:i16:$src2)
                // Dst: (XOR16rr:i16 GR16:i16:$src1, GR16:i16:$src2)
/*55716*/     /*Scope*/ 12, /*->55729*/
/*55717*/       OPC_CheckType, MVT::i32,
/*55719*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::XOR32rr), 0,
                    2/*#VTs*/, MVT::i32, MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (xor:i32 GR32:i32:$src1, GR32:i32:$src2)
                // Dst: (XOR32rr:i32 GR32:i32:$src1, GR32:i32:$src2)
/*55729*/     /*Scope*/ 12, /*->55742*/
/*55730*/       OPC_CheckType, MVT::i64,
/*55732*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::XOR64rr), 0,
                    2/*#VTs*/, MVT::i64, MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (xor:i64 GR64:i64:$src1, GR64:i64:$src2)
                // Dst: (XOR64rr:i64 GR64:i64:$src1, GR64:i64:$src2)
/*55742*/     /*Scope*/ 28, /*->55771*/
/*55743*/       OPC_CheckType, MVT::v2i64,
/*55745*/       OPC_Scope, 11, /*->55758*/ // 2 children in Scope
/*55747*/         OPC_CheckPatternPredicate, 0, // (Subtarget->hasSSE1())
/*55749*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::XORPSrr), 0,
                      1/*#VTs*/, MVT::v2i64, 2/*#Ops*/, 0, 1, 
                  // Src: (xor:v2i64 VR128:v2i64:$src1, VR128:v2i64:$src2)
                  // Dst: (XORPSrr:v2i64 VR128:v2i64:$src1, VR128:v2i64:$src2)
/*55758*/       /*Scope*/ 11, /*->55770*/
/*55759*/         OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*55761*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::PXORrr), 0,
                      1/*#VTs*/, MVT::v2i64, 2/*#Ops*/, 0, 1, 
                  // Src: (xor:v2i64 VR128:v2i64:$src1, VR128:v2i64:$src2)
                  // Dst: (PXORrr:v2i64 VR128:v2i64:$src1, VR128:v2i64:$src2)
/*55770*/       0, /*End of Scope*/
/*55771*/     /*Scope*/ 13, /*->55785*/
/*55772*/       OPC_CheckType, MVT::v1i64,
/*55774*/       OPC_CheckPatternPredicate, 8, // (Subtarget->hasMMX())
/*55776*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PXORrr), 0,
                    1/*#VTs*/, MVT::v1i64, 2/*#Ops*/, 0, 1, 
                // Src: (xor:v1i64 VR64:v1i64:$src1, VR64:v1i64:$src2)
                // Dst: (MMX_PXORrr:v1i64 VR64:v1i64:$src1, VR64:v1i64:$src2)
/*55785*/     0, /*End of Scope*/
/*55786*/   0, /*End of Scope*/
          /*SwitchOpcode*/ 73,  X86ISD::CMPPS,// ->55862
/*55789*/   OPC_RecordChild0, // #0 = $src1
/*55790*/   OPC_CheckChild0Type, MVT::v4f32,
/*55792*/   OPC_Scope, 45, /*->55839*/ // 2 children in Scope
/*55794*/     OPC_MoveChild, 1,
/*55796*/     OPC_CheckOpcode, ISD::LOAD,
/*55798*/     OPC_RecordMemRef,
/*55799*/     OPC_RecordNode, // #1 = 'ld' chained node
/*55800*/     OPC_CheckFoldableChainNode,
/*55801*/     OPC_RecordChild1, // #2 = $src2
/*55802*/     OPC_CheckPredicate, 2, // Predicate_unindexedload
/*55804*/     OPC_CheckPredicate, 8, // Predicate_load
/*55806*/     OPC_CheckPredicate, 23, // Predicate_memop
/*55808*/     OPC_MoveParent,
/*55809*/     OPC_RecordChild2, // #3 = $cc
/*55810*/     OPC_MoveChild, 2,
/*55812*/     OPC_CheckOpcode, ISD::Constant,
/*55814*/     OPC_MoveParent,
/*55815*/     OPC_CheckType, MVT::v4i32,
/*55817*/     OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #4 #5 #6 #7 #8
/*55820*/     OPC_EmitMergeInputChains, 1, 1, 
/*55823*/     OPC_EmitConvertToTarget, 3,
/*55825*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::CMPPSrmi), 0|OPFL_Chain|OPFL_MemRefs,
                  1/*#VTs*/, MVT::v4i32, 7/*#Ops*/, 0, 4, 5, 6, 7, 8, 9, 
              // Src: (X86cmpps:v4i32 VR128:v4f32:$src1, (ld:v4f32 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>, (imm:i8):$cc)
              // Dst: (CMPPSrmi:v4i32 VR128:v16i8:$src1, addr:iPTR:$src2, (imm:i8):$cc)
/*55839*/   /*Scope*/ 21, /*->55861*/
/*55840*/     OPC_RecordChild1, // #1 = $src2
/*55841*/     OPC_RecordChild2, // #2 = $cc
/*55842*/     OPC_MoveChild, 2,
/*55844*/     OPC_CheckOpcode, ISD::Constant,
/*55846*/     OPC_MoveParent,
/*55847*/     OPC_CheckType, MVT::v4i32,
/*55849*/     OPC_EmitConvertToTarget, 2,
/*55851*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::CMPPSrri), 0,
                  1/*#VTs*/, MVT::v4i32, 3/*#Ops*/, 0, 1, 3, 
              // Src: (X86cmpps:v4i32 VR128:v4f32:$src1, VR128:v4f32:$src2, (imm:i8):$cc)
              // Dst: (CMPPSrri:v4i32 VR128:v16i8:$src1, VR128:v16i8:$src2, (imm:i8):$cc)
/*55861*/   0, /*End of Scope*/
          /*SwitchOpcode*/ 73,  X86ISD::CMPPD,// ->55937
/*55864*/   OPC_RecordChild0, // #0 = $src1
/*55865*/   OPC_CheckChild0Type, MVT::v2f64,
/*55867*/   OPC_Scope, 45, /*->55914*/ // 2 children in Scope
/*55869*/     OPC_MoveChild, 1,
/*55871*/     OPC_CheckOpcode, ISD::LOAD,
/*55873*/     OPC_RecordMemRef,
/*55874*/     OPC_RecordNode, // #1 = 'ld' chained node
/*55875*/     OPC_CheckFoldableChainNode,
/*55876*/     OPC_RecordChild1, // #2 = $src2
/*55877*/     OPC_CheckPredicate, 2, // Predicate_unindexedload
/*55879*/     OPC_CheckPredicate, 8, // Predicate_load
/*55881*/     OPC_CheckPredicate, 23, // Predicate_memop
/*55883*/     OPC_MoveParent,
/*55884*/     OPC_RecordChild2, // #3 = $cc
/*55885*/     OPC_MoveChild, 2,
/*55887*/     OPC_CheckOpcode, ISD::Constant,
/*55889*/     OPC_MoveParent,
/*55890*/     OPC_CheckType, MVT::v2i64,
/*55892*/     OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #4 #5 #6 #7 #8
/*55895*/     OPC_EmitMergeInputChains, 1, 1, 
/*55898*/     OPC_EmitConvertToTarget, 3,
/*55900*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::CMPPDrmi), 0|OPFL_Chain|OPFL_MemRefs,
                  1/*#VTs*/, MVT::v2i64, 7/*#Ops*/, 0, 4, 5, 6, 7, 8, 9, 
              // Src: (X86cmppd:v2i64 VR128:v2f64:$src1, (ld:v2f64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>, (imm:i8):$cc)
              // Dst: (CMPPDrmi:v2i64 VR128:v16i8:$src1, addr:iPTR:$src2, (imm:i8):$cc)
/*55914*/   /*Scope*/ 21, /*->55936*/
/*55915*/     OPC_RecordChild1, // #1 = $src2
/*55916*/     OPC_RecordChild2, // #2 = $cc
/*55917*/     OPC_MoveChild, 2,
/*55919*/     OPC_CheckOpcode, ISD::Constant,
/*55921*/     OPC_MoveParent,
/*55922*/     OPC_CheckType, MVT::v2i64,
/*55924*/     OPC_EmitConvertToTarget, 2,
/*55926*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::CMPPDrri), 0,
                  1/*#VTs*/, MVT::v2i64, 3/*#Ops*/, 0, 1, 3, 
              // Src: (X86cmppd:v2i64 VR128:v2f64:$src1, VR128:v2f64:$src2, (imm:i8):$cc)
              // Dst: (CMPPDrri:v2i64 VR128:v16i8:$src1, VR128:v16i8:$src2, (imm:i8):$cc)
/*55936*/   0, /*End of Scope*/
          /*SwitchOpcode*/ 77|128,11/*1485*/,  ISD::ADD,// ->57425
/*55940*/   OPC_Scope, 66|128,1/*194*/, /*->56137*/ // 8 children in Scope
/*55943*/     OPC_RecordChild0, // #0 = $src1
/*55944*/     OPC_MoveChild, 1,
/*55946*/     OPC_CheckOpcode, ISD::BIT_CONVERT,
/*55948*/     OPC_MoveChild, 0,
/*55950*/     OPC_CheckOpcode, ISD::LOAD,
/*55952*/     OPC_RecordMemRef,
/*55953*/     OPC_RecordNode, // #1 = 'ld' chained node
/*55954*/     OPC_CheckFoldableChainNode,
/*55955*/     OPC_RecordChild1, // #2 = $src2
/*55956*/     OPC_CheckPredicate, 2, // Predicate_unindexedload
/*55958*/     OPC_CheckPredicate, 8, // Predicate_load
/*55960*/     OPC_SwitchType /*2 cases */, 75,  MVT::v2i64,// ->56038
/*55963*/       OPC_CheckPredicate, 23, // Predicate_memop
/*55965*/       OPC_MoveParent,
/*55966*/       OPC_MoveParent,
/*55967*/       OPC_SwitchType /*3 cases */, 21,  MVT::v16i8,// ->55991
/*55970*/         OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*55972*/         OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*55975*/         OPC_EmitMergeInputChains, 1, 1, 
/*55978*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::PADDBrm), 0|OPFL_Chain|OPFL_MemRefs,
                      1/*#VTs*/, MVT::v16i8, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                  // Src: (add:v16i8 VR128:v16i8:$src1, (bitconvert:v16i8 (ld:v2i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>))
                  // Dst: (PADDBrm:v16i8 VR128:v16i8:$src1, addr:iPTR:$src2)
                /*SwitchType*/ 21,  MVT::v8i16,// ->56014
/*55993*/         OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*55995*/         OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*55998*/         OPC_EmitMergeInputChains, 1, 1, 
/*56001*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::PADDWrm), 0|OPFL_Chain|OPFL_MemRefs,
                      1/*#VTs*/, MVT::v8i16, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                  // Src: (add:v8i16 VR128:v8i16:$src1, (bitconvert:v8i16 (ld:v2i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>))
                  // Dst: (PADDWrm:v8i16 VR128:v8i16:$src1, addr:iPTR:$src2)
                /*SwitchType*/ 21,  MVT::v4i32,// ->56037
/*56016*/         OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*56018*/         OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*56021*/         OPC_EmitMergeInputChains, 1, 1, 
/*56024*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::PADDDrm), 0|OPFL_Chain|OPFL_MemRefs,
                      1/*#VTs*/, MVT::v4i32, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                  // Src: (add:v4i32 VR128:v4i32:$src1, (bitconvert:v4i32 (ld:v2i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>))
                  // Dst: (PADDDrm:v4i32 VR128:v4i32:$src1, addr:iPTR:$src2)
                0, // EndSwitchType
              /*SwitchType*/ 96,  MVT::v1i64,// ->56136
/*56040*/       OPC_MoveParent,
/*56041*/       OPC_MoveParent,
/*56042*/       OPC_SwitchType /*4 cases */, 21,  MVT::v8i8,// ->56066
/*56045*/         OPC_CheckPatternPredicate, 8, // (Subtarget->hasMMX())
/*56047*/         OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*56050*/         OPC_EmitMergeInputChains, 1, 1, 
/*56053*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PADDBrm), 0|OPFL_Chain|OPFL_MemRefs,
                      1/*#VTs*/, MVT::v8i8, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                  // Src: (add:v8i8 VR64:v8i8:$src1, (bitconvert:v8i8 (ld:v1i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>))
                  // Dst: (MMX_PADDBrm:v8i8 VR64:v8i8:$src1, addr:iPTR:$src2)
                /*SwitchType*/ 21,  MVT::v4i16,// ->56089
/*56068*/         OPC_CheckPatternPredicate, 8, // (Subtarget->hasMMX())
/*56070*/         OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*56073*/         OPC_EmitMergeInputChains, 1, 1, 
/*56076*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PADDWrm), 0|OPFL_Chain|OPFL_MemRefs,
                      1/*#VTs*/, MVT::v4i16, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                  // Src: (add:v4i16 VR64:v4i16:$src1, (bitconvert:v4i16 (ld:v1i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>))
                  // Dst: (MMX_PADDWrm:v4i16 VR64:v4i16:$src1, addr:iPTR:$src2)
                /*SwitchType*/ 21,  MVT::v2i32,// ->56112
/*56091*/         OPC_CheckPatternPredicate, 8, // (Subtarget->hasMMX())
/*56093*/         OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*56096*/         OPC_EmitMergeInputChains, 1, 1, 
/*56099*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PADDDrm), 0|OPFL_Chain|OPFL_MemRefs,
                      1/*#VTs*/, MVT::v2i32, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                  // Src: (add:v2i32 VR64:v2i32:$src1, (bitconvert:v2i32 (ld:v1i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>))
                  // Dst: (MMX_PADDDrm:v2i32 VR64:v2i32:$src1, addr:iPTR:$src2)
                /*SwitchType*/ 21,  MVT::v1i64,// ->56135
/*56114*/         OPC_CheckPatternPredicate, 8, // (Subtarget->hasMMX())
/*56116*/         OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*56119*/         OPC_EmitMergeInputChains, 1, 1, 
/*56122*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PADDQrm), 0|OPFL_Chain|OPFL_MemRefs,
                      1/*#VTs*/, MVT::v1i64, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                  // Src: (add:v1i64 VR64:v1i64:$src1, (bitconvert:v1i64 (ld:v1i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>))
                  // Dst: (MMX_PADDQrm:v1i64 VR64:v1i64:$src1, addr:iPTR:$src2)
                0, // EndSwitchType
              0, // EndSwitchType
/*56137*/   /*Scope*/ 67|128,1/*195*/, /*->56334*/
/*56139*/     OPC_MoveChild, 0,
/*56141*/     OPC_CheckOpcode, ISD::BIT_CONVERT,
/*56143*/     OPC_MoveChild, 0,
/*56145*/     OPC_CheckOpcode, ISD::LOAD,
/*56147*/     OPC_RecordMemRef,
/*56148*/     OPC_RecordNode, // #0 = 'ld' chained node
/*56149*/     OPC_CheckFoldableChainNode,
/*56150*/     OPC_RecordChild1, // #1 = $src2
/*56151*/     OPC_CheckPredicate, 2, // Predicate_unindexedload
/*56153*/     OPC_CheckPredicate, 8, // Predicate_load
/*56155*/     OPC_SwitchType /*2 cases */, 76,  MVT::v2i64,// ->56234
/*56158*/       OPC_CheckPredicate, 23, // Predicate_memop
/*56160*/       OPC_MoveParent,
/*56161*/       OPC_MoveParent,
/*56162*/       OPC_RecordChild1, // #2 = $src1
/*56163*/       OPC_SwitchType /*3 cases */, 21,  MVT::v16i8,// ->56187
/*56166*/         OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*56168*/         OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*56171*/         OPC_EmitMergeInputChains, 1, 0, 
/*56174*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::PADDBrm), 0|OPFL_Chain|OPFL_MemRefs,
                      1/*#VTs*/, MVT::v16i8, 6/*#Ops*/, 2, 3, 4, 5, 6, 7, 
                  // Src: (add:v16i8 (bitconvert:v16i8 (ld:v2i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>), VR128:v16i8:$src1)
                  // Dst: (PADDBrm:v16i8 VR128:v16i8:$src1, addr:iPTR:$src2)
                /*SwitchType*/ 21,  MVT::v8i16,// ->56210
/*56189*/         OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*56191*/         OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*56194*/         OPC_EmitMergeInputChains, 1, 0, 
/*56197*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::PADDWrm), 0|OPFL_Chain|OPFL_MemRefs,
                      1/*#VTs*/, MVT::v8i16, 6/*#Ops*/, 2, 3, 4, 5, 6, 7, 
                  // Src: (add:v8i16 (bitconvert:v8i16 (ld:v2i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>), VR128:v8i16:$src1)
                  // Dst: (PADDWrm:v8i16 VR128:v8i16:$src1, addr:iPTR:$src2)
                /*SwitchType*/ 21,  MVT::v4i32,// ->56233
/*56212*/         OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*56214*/         OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*56217*/         OPC_EmitMergeInputChains, 1, 0, 
/*56220*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::PADDDrm), 0|OPFL_Chain|OPFL_MemRefs,
                      1/*#VTs*/, MVT::v4i32, 6/*#Ops*/, 2, 3, 4, 5, 6, 7, 
                  // Src: (add:v4i32 (bitconvert:v4i32 (ld:v2i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>), VR128:v4i32:$src1)
                  // Dst: (PADDDrm:v4i32 VR128:v4i32:$src1, addr:iPTR:$src2)
                0, // EndSwitchType
              /*SwitchType*/ 97,  MVT::v1i64,// ->56333
/*56236*/       OPC_MoveParent,
/*56237*/       OPC_MoveParent,
/*56238*/       OPC_RecordChild1, // #2 = $src1
/*56239*/       OPC_SwitchType /*4 cases */, 21,  MVT::v8i8,// ->56263
/*56242*/         OPC_CheckPatternPredicate, 8, // (Subtarget->hasMMX())
/*56244*/         OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*56247*/         OPC_EmitMergeInputChains, 1, 0, 
/*56250*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PADDBrm), 0|OPFL_Chain|OPFL_MemRefs,
                      1/*#VTs*/, MVT::v8i8, 6/*#Ops*/, 2, 3, 4, 5, 6, 7, 
                  // Src: (add:v8i8 (bitconvert:v8i8 (ld:v1i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>), VR64:v8i8:$src1)
                  // Dst: (MMX_PADDBrm:v8i8 VR64:v8i8:$src1, addr:iPTR:$src2)
                /*SwitchType*/ 21,  MVT::v4i16,// ->56286
/*56265*/         OPC_CheckPatternPredicate, 8, // (Subtarget->hasMMX())
/*56267*/         OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*56270*/         OPC_EmitMergeInputChains, 1, 0, 
/*56273*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PADDWrm), 0|OPFL_Chain|OPFL_MemRefs,
                      1/*#VTs*/, MVT::v4i16, 6/*#Ops*/, 2, 3, 4, 5, 6, 7, 
                  // Src: (add:v4i16 (bitconvert:v4i16 (ld:v1i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>), VR64:v4i16:$src1)
                  // Dst: (MMX_PADDWrm:v4i16 VR64:v4i16:$src1, addr:iPTR:$src2)
                /*SwitchType*/ 21,  MVT::v2i32,// ->56309
/*56288*/         OPC_CheckPatternPredicate, 8, // (Subtarget->hasMMX())
/*56290*/         OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*56293*/         OPC_EmitMergeInputChains, 1, 0, 
/*56296*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PADDDrm), 0|OPFL_Chain|OPFL_MemRefs,
                      1/*#VTs*/, MVT::v2i32, 6/*#Ops*/, 2, 3, 4, 5, 6, 7, 
                  // Src: (add:v2i32 (bitconvert:v2i32 (ld:v1i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>), VR64:v2i32:$src1)
                  // Dst: (MMX_PADDDrm:v2i32 VR64:v2i32:$src1, addr:iPTR:$src2)
                /*SwitchType*/ 21,  MVT::v1i64,// ->56332
/*56311*/         OPC_CheckPatternPredicate, 8, // (Subtarget->hasMMX())
/*56313*/         OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*56316*/         OPC_EmitMergeInputChains, 1, 0, 
/*56319*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PADDQrm), 0|OPFL_Chain|OPFL_MemRefs,
                      1/*#VTs*/, MVT::v1i64, 6/*#Ops*/, 2, 3, 4, 5, 6, 7, 
                  // Src: (add:v1i64 (bitconvert:v1i64 (ld:v1i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>), VR64:v1i64:$src1)
                  // Dst: (MMX_PADDQrm:v1i64 VR64:v1i64:$src1, addr:iPTR:$src2)
                0, // EndSwitchType
              0, // EndSwitchType
/*56334*/   /*Scope*/ 6|128,1/*134*/, /*->56470*/
/*56336*/     OPC_RecordChild0, // #0 = $src1
/*56337*/     OPC_MoveChild, 1,
/*56339*/     OPC_CheckOpcode, ISD::LOAD,
/*56341*/     OPC_RecordMemRef,
/*56342*/     OPC_RecordNode, // #1 = 'ld' chained node
/*56343*/     OPC_CheckFoldableChainNode,
/*56344*/     OPC_RecordChild1, // #2 = $src2
/*56345*/     OPC_CheckPredicate, 2, // Predicate_unindexedload
/*56347*/     OPC_CheckPredicate, 8, // Predicate_load
/*56349*/     OPC_Scope, 91, /*->56442*/ // 2 children in Scope
/*56351*/       OPC_MoveParent,
/*56352*/       OPC_SwitchType /*4 cases */, 20,  MVT::i8,// ->56375
/*56355*/         OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*56358*/         OPC_EmitMergeInputChains, 1, 1, 
/*56361*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::ADD8rm), 0|OPFL_Chain|OPFL_MemRefs,
                      2/*#VTs*/, MVT::i8, MVT::i32, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                  // Src: (add:i8 GR8:i8:$src1, (ld:i8 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)
                  // Dst: (ADD8rm:i8 GR8:i8:$src1, addr:iPTR:$src2)
                /*SwitchType*/ 20,  MVT::i16,// ->56397
/*56377*/         OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*56380*/         OPC_EmitMergeInputChains, 1, 1, 
/*56383*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::ADD16rm), 0|OPFL_Chain|OPFL_MemRefs,
                      2/*#VTs*/, MVT::i16, MVT::i32, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                  // Src: (add:i16 GR16:i16:$src1, (ld:i16 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)
                  // Dst: (ADD16rm:i16 GR16:i16:$src1, addr:iPTR:$src2)
                /*SwitchType*/ 20,  MVT::i32,// ->56419
/*56399*/         OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*56402*/         OPC_EmitMergeInputChains, 1, 1, 
/*56405*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::ADD32rm), 0|OPFL_Chain|OPFL_MemRefs,
                      2/*#VTs*/, MVT::i32, MVT::i32, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                  // Src: (add:i32 GR32:i32:$src1, (ld:i32 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)
                  // Dst: (ADD32rm:i32 GR32:i32:$src1, addr:iPTR:$src2)
                /*SwitchType*/ 20,  MVT::i64,// ->56441
/*56421*/         OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*56424*/         OPC_EmitMergeInputChains, 1, 1, 
/*56427*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::ADD64rm), 0|OPFL_Chain|OPFL_MemRefs,
                      2/*#VTs*/, MVT::i64, MVT::i32, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                  // Src: (add:i64 GR64:i64:$src1, (ld:i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)
                  // Dst: (ADD64rm:i64 GR64:i64:$src1, addr:iPTR:$src2)
                0, // EndSwitchType
/*56442*/     /*Scope*/ 26, /*->56469*/
/*56443*/       OPC_CheckPredicate, 23, // Predicate_memop
/*56445*/       OPC_MoveParent,
/*56446*/       OPC_CheckType, MVT::v2i64,
/*56448*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*56450*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*56453*/       OPC_EmitMergeInputChains, 1, 1, 
/*56456*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PADDQrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v2i64, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (add:v2i64 VR128:v2i64:$src1, (ld:v2i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>)
                // Dst: (PADDQrm:v2i64 VR128:v2i64:$src1, addr:iPTR:$src2)
/*56469*/     0, /*End of Scope*/
/*56470*/   /*Scope*/ 7|128,1/*135*/, /*->56607*/
/*56472*/     OPC_MoveChild, 0,
/*56474*/     OPC_CheckOpcode, ISD::LOAD,
/*56476*/     OPC_RecordMemRef,
/*56477*/     OPC_RecordNode, // #0 = 'ld' chained node
/*56478*/     OPC_CheckFoldableChainNode,
/*56479*/     OPC_RecordChild1, // #1 = $src2
/*56480*/     OPC_CheckPredicate, 2, // Predicate_unindexedload
/*56482*/     OPC_CheckPredicate, 8, // Predicate_load
/*56484*/     OPC_Scope, 92, /*->56578*/ // 2 children in Scope
/*56486*/       OPC_MoveParent,
/*56487*/       OPC_RecordChild1, // #2 = $src1
/*56488*/       OPC_SwitchType /*4 cases */, 20,  MVT::i8,// ->56511
/*56491*/         OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*56494*/         OPC_EmitMergeInputChains, 1, 0, 
/*56497*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::ADD8rm), 0|OPFL_Chain|OPFL_MemRefs,
                      2/*#VTs*/, MVT::i8, MVT::i32, 6/*#Ops*/, 2, 3, 4, 5, 6, 7, 
                  // Src: (add:i8 (ld:i8 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR8:i8:$src1)
                  // Dst: (ADD8rm:i8 GR8:i8:$src1, addr:iPTR:$src2)
                /*SwitchType*/ 20,  MVT::i16,// ->56533
/*56513*/         OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*56516*/         OPC_EmitMergeInputChains, 1, 0, 
/*56519*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::ADD16rm), 0|OPFL_Chain|OPFL_MemRefs,
                      2/*#VTs*/, MVT::i16, MVT::i32, 6/*#Ops*/, 2, 3, 4, 5, 6, 7, 
                  // Src: (add:i16 (ld:i16 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR16:i16:$src1)
                  // Dst: (ADD16rm:i16 GR16:i16:$src1, addr:iPTR:$src2)
                /*SwitchType*/ 20,  MVT::i32,// ->56555
/*56535*/         OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*56538*/         OPC_EmitMergeInputChains, 1, 0, 
/*56541*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::ADD32rm), 0|OPFL_Chain|OPFL_MemRefs,
                      2/*#VTs*/, MVT::i32, MVT::i32, 6/*#Ops*/, 2, 3, 4, 5, 6, 7, 
                  // Src: (add:i32 (ld:i32 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR32:i32:$src1)
                  // Dst: (ADD32rm:i32 GR32:i32:$src1, addr:iPTR:$src2)
                /*SwitchType*/ 20,  MVT::i64,// ->56577
/*56557*/         OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*56560*/         OPC_EmitMergeInputChains, 1, 0, 
/*56563*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::ADD64rm), 0|OPFL_Chain|OPFL_MemRefs,
                      2/*#VTs*/, MVT::i64, MVT::i32, 6/*#Ops*/, 2, 3, 4, 5, 6, 7, 
                  // Src: (add:i64 (ld:i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR64:i64:$src1)
                  // Dst: (ADD64rm:i64 GR64:i64:$src1, addr:iPTR:$src2)
                0, // EndSwitchType
/*56578*/     /*Scope*/ 27, /*->56606*/
/*56579*/       OPC_CheckPredicate, 23, // Predicate_memop
/*56581*/       OPC_MoveParent,
/*56582*/       OPC_RecordChild1, // #2 = $src1
/*56583*/       OPC_CheckType, MVT::v2i64,
/*56585*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*56587*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*56590*/       OPC_EmitMergeInputChains, 1, 0, 
/*56593*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PADDQrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v2i64, 6/*#Ops*/, 2, 3, 4, 5, 6, 7, 
                // Src: (add:v2i64 (ld:v2i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>, VR128:v2i64:$src1)
                // Dst: (PADDQrm:v2i64 VR128:v2i64:$src1, addr:iPTR:$src2)
/*56606*/     0, /*End of Scope*/
/*56607*/   /*Scope*/ 57, /*->56665*/
/*56608*/     OPC_RecordNode, // #0 = $src
/*56609*/     OPC_SwitchType /*2 cases */, 36,  MVT::i32,// ->56648
/*56612*/       OPC_Scope, 16, /*->56630*/ // 2 children in Scope
/*56614*/         OPC_CheckPatternPredicate, 2, // (!Subtarget->is64Bit())
/*56616*/         OPC_CheckComplexPat, /*CP*/3, /*#*/0, // SelectLEAAddr:$src #1 #2 #3 #4
/*56619*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::LEA32r), 0,
                      1/*#VTs*/, MVT::i32, 4/*#Ops*/, 1, 2, 3, 4, 
                  // Src: lea32addr:i32:$src
                  // Dst: (LEA32r:i32 lea32addr:i32:$src)
/*56630*/       /*Scope*/ 16, /*->56647*/
/*56631*/         OPC_CheckPatternPredicate, 3, // (Subtarget->is64Bit())
/*56633*/         OPC_CheckComplexPat, /*CP*/3, /*#*/0, // SelectLEAAddr:$src #1 #2 #3 #4
/*56636*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::LEA64_32r), 0,
                      1/*#VTs*/, MVT::i32, 4/*#Ops*/, 1, 2, 3, 4, 
                  // Src: lea32addr:i32:$src
                  // Dst: (LEA64_32r:i32 lea32addr:i32:$src)
/*56647*/       0, /*End of Scope*/
              /*SwitchType*/ 14,  MVT::i64,// ->56664
/*56650*/       OPC_CheckComplexPat, /*CP*/4, /*#*/0, // SelectLEAAddr:$src #1 #2 #3 #4
/*56653*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::LEA64r), 0,
                    1/*#VTs*/, MVT::i64, 4/*#Ops*/, 1, 2, 3, 4, 
                // Src: lea64addr:i64:$src
                // Dst: (LEA64r:i64 lea64addr:i64:$src)
              0, // EndSwitchType
/*56665*/   /*Scope*/ 85, /*->56751*/
/*56666*/     OPC_RecordChild0, // #0 = $src1
/*56667*/     OPC_MoveChild, 1,
/*56669*/     OPC_CheckOpcode, X86ISD::Wrapper,
/*56671*/     OPC_RecordChild0, // #1 = $src2
/*56672*/     OPC_MoveChild, 0,
/*56674*/     OPC_SwitchOpcode /*5 cases */, 13,  ISD::TargetConstantPool,// ->56690
/*56677*/       OPC_MoveParent,
/*56678*/       OPC_MoveParent,
/*56679*/       OPC_CheckType, MVT::i32,
/*56681*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::ADD32ri), 0,
                    1/*#VTs*/, MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (add:i32 GR32:i32:$src1, (X86Wrapper:i32 (tconstpool:i32):$src2))
                // Dst: (ADD32ri:i32 GR32:i32:$src1, (tconstpool:i32):$src2)
              /*SwitchOpcode*/ 13,  ISD::TargetJumpTable,// ->56705
/*56692*/       OPC_MoveParent,
/*56693*/       OPC_MoveParent,
/*56694*/       OPC_CheckType, MVT::i32,
/*56696*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::ADD32ri), 0,
                    1/*#VTs*/, MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (add:i32 GR32:i32:$src1, (X86Wrapper:i32 (tjumptable:i32):$src2))
                // Dst: (ADD32ri:i32 GR32:i32:$src1, (tjumptable:i32):$src2)
              /*SwitchOpcode*/ 13,  ISD::TargetGlobalAddress,// ->56720
/*56707*/       OPC_MoveParent,
/*56708*/       OPC_MoveParent,
/*56709*/       OPC_CheckType, MVT::i32,
/*56711*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::ADD32ri), 0,
                    1/*#VTs*/, MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (add:i32 GR32:i32:$src1, (X86Wrapper:i32 (tglobaladdr:i32):$src2))
                // Dst: (ADD32ri:i32 GR32:i32:$src1, (tglobaladdr:i32):$src2)
              /*SwitchOpcode*/ 13,  ISD::TargetExternalSymbol,// ->56735
/*56722*/       OPC_MoveParent,
/*56723*/       OPC_MoveParent,
/*56724*/       OPC_CheckType, MVT::i32,
/*56726*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::ADD32ri), 0,
                    1/*#VTs*/, MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (add:i32 GR32:i32:$src1, (X86Wrapper:i32 (texternalsym:i32):$src2))
                // Dst: (ADD32ri:i32 GR32:i32:$src1, (texternalsym:i32):$src2)
              /*SwitchOpcode*/ 13,  ISD::TargetBlockAddress,// ->56750
/*56737*/       OPC_MoveParent,
/*56738*/       OPC_MoveParent,
/*56739*/       OPC_CheckType, MVT::i32,
/*56741*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::ADD32ri), 0,
                    1/*#VTs*/, MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (add:i32 GR32:i32:$src1, (X86Wrapper:i32 (tblockaddress:i32):$src2))
                // Dst: (ADD32ri:i32 GR32:i32:$src1, (tblockaddress:i32):$src2)
              0, // EndSwitchOpcode
/*56751*/   /*Scope*/ 89, /*->56841*/
/*56752*/     OPC_MoveChild, 0,
/*56754*/     OPC_CheckOpcode, X86ISD::Wrapper,
/*56756*/     OPC_RecordChild0, // #0 = $src2
/*56757*/     OPC_MoveChild, 0,
/*56759*/     OPC_SwitchOpcode /*5 cases */, 14,  ISD::TargetConstantPool,// ->56776
/*56762*/       OPC_MoveParent,
/*56763*/       OPC_MoveParent,
/*56764*/       OPC_RecordChild1, // #1 = $src1
/*56765*/       OPC_CheckType, MVT::i32,
/*56767*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::ADD32ri), 0,
                    1/*#VTs*/, MVT::i32, 2/*#Ops*/, 1, 0, 
                // Src: (add:i32 (X86Wrapper:i32 (tconstpool:i32):$src2), GR32:i32:$src1)
                // Dst: (ADD32ri:i32 GR32:i32:$src1, (tconstpool:i32):$src2)
              /*SwitchOpcode*/ 14,  ISD::TargetJumpTable,// ->56792
/*56778*/       OPC_MoveParent,
/*56779*/       OPC_MoveParent,
/*56780*/       OPC_RecordChild1, // #1 = $src1
/*56781*/       OPC_CheckType, MVT::i32,
/*56783*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::ADD32ri), 0,
                    1/*#VTs*/, MVT::i32, 2/*#Ops*/, 1, 0, 
                // Src: (add:i32 (X86Wrapper:i32 (tjumptable:i32):$src2), GR32:i32:$src1)
                // Dst: (ADD32ri:i32 GR32:i32:$src1, (tjumptable:i32):$src2)
              /*SwitchOpcode*/ 14,  ISD::TargetGlobalAddress,// ->56808
/*56794*/       OPC_MoveParent,
/*56795*/       OPC_MoveParent,
/*56796*/       OPC_RecordChild1, // #1 = $src1
/*56797*/       OPC_CheckType, MVT::i32,
/*56799*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::ADD32ri), 0,
                    1/*#VTs*/, MVT::i32, 2/*#Ops*/, 1, 0, 
                // Src: (add:i32 (X86Wrapper:i32 (tglobaladdr:i32):$src2), GR32:i32:$src1)
                // Dst: (ADD32ri:i32 GR32:i32:$src1, (tglobaladdr:i32):$src2)
              /*SwitchOpcode*/ 14,  ISD::TargetExternalSymbol,// ->56824
/*56810*/       OPC_MoveParent,
/*56811*/       OPC_MoveParent,
/*56812*/       OPC_RecordChild1, // #1 = $src1
/*56813*/       OPC_CheckType, MVT::i32,
/*56815*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::ADD32ri), 0,
                    1/*#VTs*/, MVT::i32, 2/*#Ops*/, 1, 0, 
                // Src: (add:i32 (X86Wrapper:i32 (texternalsym:i32):$src2), GR32:i32:$src1)
                // Dst: (ADD32ri:i32 GR32:i32:$src1, (texternalsym:i32):$src2)
              /*SwitchOpcode*/ 14,  ISD::TargetBlockAddress,// ->56840
/*56826*/       OPC_MoveParent,
/*56827*/       OPC_MoveParent,
/*56828*/       OPC_RecordChild1, // #1 = $src1
/*56829*/       OPC_CheckType, MVT::i32,
/*56831*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::ADD32ri), 0,
                    1/*#VTs*/, MVT::i32, 2/*#Ops*/, 1, 0, 
                // Src: (add:i32 (X86Wrapper:i32 (tblockaddress:i32):$src2), GR32:i32:$src1)
                // Dst: (ADD32ri:i32 GR32:i32:$src1, (tblockaddress:i32):$src2)
              0, // EndSwitchOpcode
/*56841*/   /*Scope*/ 69|128,4/*581*/, /*->57424*/
/*56843*/     OPC_RecordChild0, // #0 = $src
/*56844*/     OPC_Scope, 32|128,2/*288*/, /*->57135*/ // 2 children in Scope
/*56847*/       OPC_MoveChild, 1,
/*56849*/       OPC_Scope, 83, /*->56934*/ // 4 children in Scope
/*56851*/         OPC_CheckInteger, 1, 
/*56853*/         OPC_MoveParent,
/*56854*/         OPC_SwitchType /*4 cases */, 26,  MVT::i16,// ->56883
/*56857*/           OPC_Scope, 11, /*->56870*/ // 2 children in Scope
/*56859*/             OPC_CheckPatternPredicate, 2, // (!Subtarget->is64Bit())
/*56861*/             OPC_MorphNodeTo, TARGET_OPCODE(X86::INC16r), 0,
                          2/*#VTs*/, MVT::i16, MVT::i32, 1/*#Ops*/, 0, 
                      // Src: (add:i16 GR16:i16:$src, 1:i16)
                      // Dst: (INC16r:i16 GR16:i16:$src)
/*56870*/           /*Scope*/ 11, /*->56882*/
/*56871*/             OPC_CheckPatternPredicate, 3, // (Subtarget->is64Bit())
/*56873*/             OPC_MorphNodeTo, TARGET_OPCODE(X86::INC64_16r), 0,
                          2/*#VTs*/, MVT::i16, MVT::i32, 1/*#Ops*/, 0, 
                      // Src: (add:i16 GR16:i16:$src, 1:i16)
                      // Dst: (INC64_16r:i16 GR16:i16:$src)
/*56882*/           0, /*End of Scope*/
                  /*SwitchType*/ 26,  MVT::i32,// ->56911
/*56885*/           OPC_Scope, 11, /*->56898*/ // 2 children in Scope
/*56887*/             OPC_CheckPatternPredicate, 2, // (!Subtarget->is64Bit())
/*56889*/             OPC_MorphNodeTo, TARGET_OPCODE(X86::INC32r), 0,
                          2/*#VTs*/, MVT::i32, MVT::i32, 1/*#Ops*/, 0, 
                      // Src: (add:i32 GR32:i32:$src, 1:i32)
                      // Dst: (INC32r:i32 GR32:i32:$src)
/*56898*/           /*Scope*/ 11, /*->56910*/
/*56899*/             OPC_CheckPatternPredicate, 3, // (Subtarget->is64Bit())
/*56901*/             OPC_MorphNodeTo, TARGET_OPCODE(X86::INC64_32r), 0,
                          2/*#VTs*/, MVT::i32, MVT::i32, 1/*#Ops*/, 0, 
                      // Src: (add:i32 GR32:i32:$src, 1:i32)
                      // Dst: (INC64_32r:i32 GR32:i32:$src)
/*56910*/           0, /*End of Scope*/
                  /*SwitchType*/ 9,  MVT::i8,// ->56922
/*56913*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::INC8r), 0,
                        2/*#VTs*/, MVT::i8, MVT::i32, 1/*#Ops*/, 0, 
                    // Src: (add:i8 GR8:i8:$src, 1:i8)
                    // Dst: (INC8r:i8 GR8:i8:$src)
                  /*SwitchType*/ 9,  MVT::i64,// ->56933
/*56924*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::INC64r), 0,
                        2/*#VTs*/, MVT::i64, MVT::i32, 1/*#Ops*/, 0, 
                    // Src: (add:i64 GR64:i64:$src, 1:i64)
                    // Dst: (INC64r:i64 GR64:i64:$src)
                  0, // EndSwitchType
/*56934*/       /*Scope*/ 92, /*->57027*/
/*56935*/         OPC_CheckInteger, 127|128,127|128,127|128,127|128,127|128,127|128,127|128,127|128,127|128,1/*18446744073709551615*/, 
/*56946*/         OPC_MoveParent,
/*56947*/         OPC_SwitchType /*4 cases */, 26,  MVT::i16,// ->56976
/*56950*/           OPC_Scope, 11, /*->56963*/ // 2 children in Scope
/*56952*/             OPC_CheckPatternPredicate, 2, // (!Subtarget->is64Bit())
/*56954*/             OPC_MorphNodeTo, TARGET_OPCODE(X86::DEC16r), 0,
                          2/*#VTs*/, MVT::i16, MVT::i32, 1/*#Ops*/, 0, 
                      // Src: (add:i16 GR16:i16:$src, -1:i16)
                      // Dst: (DEC16r:i16 GR16:i16:$src)
/*56963*/           /*Scope*/ 11, /*->56975*/
/*56964*/             OPC_CheckPatternPredicate, 3, // (Subtarget->is64Bit())
/*56966*/             OPC_MorphNodeTo, TARGET_OPCODE(X86::DEC64_16r), 0,
                          2/*#VTs*/, MVT::i16, MVT::i32, 1/*#Ops*/, 0, 
                      // Src: (add:i16 GR16:i16:$src, -1:i16)
                      // Dst: (DEC64_16r:i16 GR16:i16:$src)
/*56975*/           0, /*End of Scope*/
                  /*SwitchType*/ 26,  MVT::i32,// ->57004
/*56978*/           OPC_Scope, 11, /*->56991*/ // 2 children in Scope
/*56980*/             OPC_CheckPatternPredicate, 2, // (!Subtarget->is64Bit())
/*56982*/             OPC_MorphNodeTo, TARGET_OPCODE(X86::DEC32r), 0,
                          2/*#VTs*/, MVT::i32, MVT::i32, 1/*#Ops*/, 0, 
                      // Src: (add:i32 GR32:i32:$src, -1:i32)
                      // Dst: (DEC32r:i32 GR32:i32:$src)
/*56991*/           /*Scope*/ 11, /*->57003*/
/*56992*/             OPC_CheckPatternPredicate, 3, // (Subtarget->is64Bit())
/*56994*/             OPC_MorphNodeTo, TARGET_OPCODE(X86::DEC64_32r), 0,
                          2/*#VTs*/, MVT::i32, MVT::i32, 1/*#Ops*/, 0, 
                      // Src: (add:i32 GR32:i32:$src, -1:i32)
                      // Dst: (DEC64_32r:i32 GR32:i32:$src)
/*57003*/           0, /*End of Scope*/
                  /*SwitchType*/ 9,  MVT::i8,// ->57015
/*57006*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::DEC8r), 0,
                        2/*#VTs*/, MVT::i8, MVT::i32, 1/*#Ops*/, 0, 
                    // Src: (add:i8 GR8:i8:$src, -1:i8)
                    // Dst: (DEC8r:i8 GR8:i8:$src)
                  /*SwitchType*/ 9,  MVT::i64,// ->57026
/*57017*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::DEC64r), 0,
                        2/*#VTs*/, MVT::i64, MVT::i32, 1/*#Ops*/, 0, 
                    // Src: (add:i64 GR64:i64:$src, -1:i64)
                    // Dst: (DEC64r:i64 GR64:i64:$src)
                  0, // EndSwitchType
/*57027*/       /*Scope*/ 75, /*->57103*/
/*57028*/         OPC_CheckInteger, 0|128,1/*128*/, 
/*57031*/         OPC_MoveParent,
/*57032*/         OPC_SwitchType /*3 cases */, 21,  MVT::i16,// ->57056
/*57035*/           OPC_EmitInteger, MVT::i16, 0|128,127|128,127|128,127|128,127|128,127|128,127|128,127|128,127|128,1/*18446744073709551488*/, 
/*57047*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::SUB16ri8), 0,
                        1/*#VTs*/, MVT::i16, 2/*#Ops*/, 0, 1, 
                    // Src: (add:i16 GR16:i16:$src1, 128:i16)
                    // Dst: (SUB16ri8:i16 GR16:i16:$src1, -128:i16)
                  /*SwitchType*/ 21,  MVT::i32,// ->57079
/*57058*/           OPC_EmitInteger, MVT::i32, 0|128,127|128,127|128,127|128,127|128,127|128,127|128,127|128,127|128,1/*18446744073709551488*/, 
/*57070*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::SUB32ri8), 0,
                        1/*#VTs*/, MVT::i32, 2/*#Ops*/, 0, 1, 
                    // Src: (add:i32 GR32:i32:$src1, 128:i32)
                    // Dst: (SUB32ri8:i32 GR32:i32:$src1, -128:i32)
                  /*SwitchType*/ 21,  MVT::i64,// ->57102
/*57081*/           OPC_EmitInteger, MVT::i64, 0|128,127|128,127|128,127|128,127|128,127|128,127|128,127|128,127|128,1/*18446744073709551488*/, 
/*57093*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::SUB64ri8), 0,
                        1/*#VTs*/, MVT::i64, 2/*#Ops*/, 0, 1, 
                    // Src: (add:i64 GR64:i64:$src1, 128:i64)
                    // Dst: (SUB64ri8:i64 GR64:i64:$src1, -128:i64)
                  0, // EndSwitchType
/*57103*/       /*Scope*/ 30, /*->57134*/
/*57104*/         OPC_CheckInteger, 0|128,0|128,0|128,0|128,8/*2147483648*/, 
/*57110*/         OPC_MoveParent,
/*57111*/         OPC_CheckType, MVT::i64,
/*57113*/         OPC_EmitInteger, MVT::i64, 0|128,0|128,0|128,0|128,120|128,127|128,127|128,127|128,127|128,1/*18446744071562067968*/, 
/*57125*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::SUB64ri32), 0,
                      1/*#VTs*/, MVT::i64, 2/*#Ops*/, 0, 1, 
                  // Src: (add:i64 GR64:i64:$src1, 2147483648:i64)
                  // Dst: (SUB64ri32:i64 GR64:i64:$src1, -2147483648:i64)
/*57134*/       0, /*End of Scope*/
/*57135*/     /*Scope*/ 30|128,2/*286*/, /*->57423*/
/*57137*/       OPC_RecordChild1, // #1 = $src2
/*57138*/       OPC_Scope, 118, /*->57258*/ // 13 children in Scope
/*57140*/         OPC_MoveChild, 1,
/*57142*/         OPC_CheckOpcode, ISD::Constant,
/*57144*/         OPC_Scope, 47, /*->57193*/ // 3 children in Scope
/*57146*/           OPC_CheckPredicate, 11, // Predicate_immSext8
/*57148*/           OPC_MoveParent,
/*57149*/           OPC_SwitchType /*3 cases */, 12,  MVT::i16,// ->57164
/*57152*/             OPC_EmitConvertToTarget, 1,
/*57154*/             OPC_MorphNodeTo, TARGET_OPCODE(X86::ADD16ri8), 0,
                          2/*#VTs*/, MVT::i16, MVT::i32, 2/*#Ops*/, 0, 2, 
                      // Src: (add:i16 GR16:i16:$src1, (imm:i16)<<P:Predicate_immSext8>>:$src2)
                      // Dst: (ADD16ri8:i16 GR16:i16:$src1, (imm:i16):$src2)
                    /*SwitchType*/ 12,  MVT::i32,// ->57178
/*57166*/             OPC_EmitConvertToTarget, 1,
/*57168*/             OPC_MorphNodeTo, TARGET_OPCODE(X86::ADD32ri8), 0,
                          2/*#VTs*/, MVT::i32, MVT::i32, 2/*#Ops*/, 0, 2, 
                      // Src: (add:i32 GR32:i32:$src1, (imm:i32)<<P:Predicate_immSext8>>:$src2)
                      // Dst: (ADD32ri8:i32 GR32:i32:$src1, (imm:i32):$src2)
                    /*SwitchType*/ 12,  MVT::i64,// ->57192
/*57180*/             OPC_EmitConvertToTarget, 1,
/*57182*/             OPC_MorphNodeTo, TARGET_OPCODE(X86::ADD64ri8), 0,
                          2/*#VTs*/, MVT::i64, MVT::i32, 2/*#Ops*/, 0, 2, 
                      // Src: (add:i64 GR64:i64:$src1, (imm:i64)<<P:Predicate_immSext8>>:$src2)
                      // Dst: (ADD64ri8:i64 GR64:i64:$src1, (imm:i64):$src2)
                    0, // EndSwitchType
/*57193*/         /*Scope*/ 17, /*->57211*/
/*57194*/           OPC_CheckPredicate, 12, // Predicate_i64immSExt32
/*57196*/           OPC_MoveParent,
/*57197*/           OPC_CheckType, MVT::i64,
/*57199*/           OPC_EmitConvertToTarget, 1,
/*57201*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::ADD64ri32), 0,
                        2/*#VTs*/, MVT::i64, MVT::i32, 2/*#Ops*/, 0, 2, 
                    // Src: (add:i64 GR64:i64:$src1, (imm:i64)<<P:Predicate_i64immSExt32>>:$src2)
                    // Dst: (ADD64ri32:i64 GR64:i64:$src1, (imm:i64):$src2)
/*57211*/         /*Scope*/ 45, /*->57257*/
/*57212*/           OPC_MoveParent,
/*57213*/           OPC_SwitchType /*3 cases */, 12,  MVT::i8,// ->57228
/*57216*/             OPC_EmitConvertToTarget, 1,
/*57218*/             OPC_MorphNodeTo, TARGET_OPCODE(X86::ADD8ri), 0,
                          2/*#VTs*/, MVT::i8, MVT::i32, 2/*#Ops*/, 0, 2, 
                      // Src: (add:i8 GR8:i8:$src1, (imm:i8):$src2)
                      // Dst: (ADD8ri:i8 GR8:i8:$src1, (imm:i8):$src2)
                    /*SwitchType*/ 12,  MVT::i16,// ->57242
/*57230*/             OPC_EmitConvertToTarget, 1,
/*57232*/             OPC_MorphNodeTo, TARGET_OPCODE(X86::ADD16ri), 0,
                          2/*#VTs*/, MVT::i16, MVT::i32, 2/*#Ops*/, 0, 2, 
                      // Src: (add:i16 GR16:i16:$src1, (imm:i16):$src2)
                      // Dst: (ADD16ri:i16 GR16:i16:$src1, (imm:i16):$src2)
                    /*SwitchType*/ 12,  MVT::i32,// ->57256
/*57244*/             OPC_EmitConvertToTarget, 1,
/*57246*/             OPC_MorphNodeTo, TARGET_OPCODE(X86::ADD32ri), 0,
                          2/*#VTs*/, MVT::i32, MVT::i32, 2/*#Ops*/, 0, 2, 
                      // Src: (add:i32 GR32:i32:$src1, (imm:i32):$src2)
                      // Dst: (ADD32ri:i32 GR32:i32:$src1, (imm:i32):$src2)
                    0, // EndSwitchType
/*57257*/         0, /*End of Scope*/
/*57258*/       /*Scope*/ 12, /*->57271*/
/*57259*/         OPC_CheckType, MVT::i8,
/*57261*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::ADD8rr), 0,
                      2/*#VTs*/, MVT::i8, MVT::i32, 2/*#Ops*/, 0, 1, 
                  // Src: (add:i8 GR8:i8:$src1, GR8:i8:$src2)
                  // Dst: (ADD8rr:i8 GR8:i8:$src1, GR8:i8:$src2)
/*57271*/       /*Scope*/ 12, /*->57284*/
/*57272*/         OPC_CheckType, MVT::i16,
/*57274*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::ADD16rr), 0,
                      2/*#VTs*/, MVT::i16, MVT::i32, 2/*#Ops*/, 0, 1, 
                  // Src: (add:i16 GR16:i16:$src1, GR16:i16:$src2)
                  // Dst: (ADD16rr:i16 GR16:i16:$src1, GR16:i16:$src2)
/*57284*/       /*Scope*/ 12, /*->57297*/
/*57285*/         OPC_CheckType, MVT::i32,
/*57287*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::ADD32rr), 0,
                      2/*#VTs*/, MVT::i32, MVT::i32, 2/*#Ops*/, 0, 1, 
                  // Src: (add:i32 GR32:i32:$src1, GR32:i32:$src2)
                  // Dst: (ADD32rr:i32 GR32:i32:$src1, GR32:i32:$src2)
/*57297*/       /*Scope*/ 12, /*->57310*/
/*57298*/         OPC_CheckType, MVT::i64,
/*57300*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::ADD64rr), 0,
                      2/*#VTs*/, MVT::i64, MVT::i32, 2/*#Ops*/, 0, 1, 
                  // Src: (add:i64 GR64:i64:$src1, GR64:i64:$src2)
                  // Dst: (ADD64rr:i64 GR64:i64:$src1, GR64:i64:$src2)
/*57310*/       /*Scope*/ 13, /*->57324*/
/*57311*/         OPC_CheckType, MVT::v16i8,
/*57313*/         OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*57315*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::PADDBrr), 0,
                      1/*#VTs*/, MVT::v16i8, 2/*#Ops*/, 0, 1, 
                  // Src: (add:v16i8 VR128:v16i8:$src1, VR128:v16i8:$src2)
                  // Dst: (PADDBrr:v16i8 VR128:v16i8:$src1, VR128:v16i8:$src2)
/*57324*/       /*Scope*/ 13, /*->57338*/
/*57325*/         OPC_CheckType, MVT::v8i16,
/*57327*/         OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*57329*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::PADDWrr), 0,
                      1/*#VTs*/, MVT::v8i16, 2/*#Ops*/, 0, 1, 
                  // Src: (add:v8i16 VR128:v8i16:$src1, VR128:v8i16:$src2)
                  // Dst: (PADDWrr:v8i16 VR128:v8i16:$src1, VR128:v8i16:$src2)
/*57338*/       /*Scope*/ 13, /*->57352*/
/*57339*/         OPC_CheckType, MVT::v4i32,
/*57341*/         OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*57343*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::PADDDrr), 0,
                      1/*#VTs*/, MVT::v4i32, 2/*#Ops*/, 0, 1, 
                  // Src: (add:v4i32 VR128:v4i32:$src1, VR128:v4i32:$src2)
                  // Dst: (PADDDrr:v4i32 VR128:v4i32:$src1, VR128:v4i32:$src2)
/*57352*/       /*Scope*/ 13, /*->57366*/
/*57353*/         OPC_CheckType, MVT::v2i64,
/*57355*/         OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*57357*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::PADDQrr), 0,
                      1/*#VTs*/, MVT::v2i64, 2/*#Ops*/, 0, 1, 
                  // Src: (add:v2i64 VR128:v2i64:$src1, VR128:v2i64:$src2)
                  // Dst: (PADDQrr:v2i64 VR128:v2i64:$src1, VR128:v2i64:$src2)
/*57366*/       /*Scope*/ 13, /*->57380*/
/*57367*/         OPC_CheckType, MVT::v8i8,
/*57369*/         OPC_CheckPatternPredicate, 8, // (Subtarget->hasMMX())
/*57371*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PADDBrr), 0,
                      1/*#VTs*/, MVT::v8i8, 2/*#Ops*/, 0, 1, 
                  // Src: (add:v8i8 VR64:v8i8:$src1, VR64:v8i8:$src2)
                  // Dst: (MMX_PADDBrr:v8i8 VR64:v8i8:$src1, VR64:v8i8:$src2)
/*57380*/       /*Scope*/ 13, /*->57394*/
/*57381*/         OPC_CheckType, MVT::v4i16,
/*57383*/         OPC_CheckPatternPredicate, 8, // (Subtarget->hasMMX())
/*57385*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PADDWrr), 0,
                      1/*#VTs*/, MVT::v4i16, 2/*#Ops*/, 0, 1, 
                  // Src: (add:v4i16 VR64:v4i16:$src1, VR64:v4i16:$src2)
                  // Dst: (MMX_PADDWrr:v4i16 VR64:v4i16:$src1, VR64:v4i16:$src2)
/*57394*/       /*Scope*/ 13, /*->57408*/
/*57395*/         OPC_CheckType, MVT::v2i32,
/*57397*/         OPC_CheckPatternPredicate, 8, // (Subtarget->hasMMX())
/*57399*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PADDDrr), 0,
                      1/*#VTs*/, MVT::v2i32, 2/*#Ops*/, 0, 1, 
                  // Src: (add:v2i32 VR64:v2i32:$src1, VR64:v2i32:$src2)
                  // Dst: (MMX_PADDDrr:v2i32 VR64:v2i32:$src1, VR64:v2i32:$src2)
/*57408*/       /*Scope*/ 13, /*->57422*/
/*57409*/         OPC_CheckType, MVT::v1i64,
/*57411*/         OPC_CheckPatternPredicate, 8, // (Subtarget->hasMMX())
/*57413*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PADDQrr), 0,
                      1/*#VTs*/, MVT::v1i64, 2/*#Ops*/, 0, 1, 
                  // Src: (add:v1i64 VR64:v1i64:$src1, VR64:v1i64:$src2)
                  // Dst: (MMX_PADDQrr:v1i64 VR64:v1i64:$src1, VR64:v1i64:$src2)
/*57422*/       0, /*End of Scope*/
/*57423*/     0, /*End of Scope*/
/*57424*/   0, /*End of Scope*/
          /*SwitchOpcode*/ 93|128,5/*733*/,  ISD::SUB,// ->58161
/*57428*/   OPC_Scope, 73|128,2/*329*/, /*->57760*/ // 4 children in Scope
/*57431*/     OPC_RecordChild0, // #0 = $src1
/*57432*/     OPC_MoveChild, 1,
/*57434*/     OPC_SwitchOpcode /*2 cases */, 61|128,1/*189*/,  ISD::BIT_CONVERT,// ->57627
/*57438*/       OPC_MoveChild, 0,
/*57440*/       OPC_CheckOpcode, ISD::LOAD,
/*57442*/       OPC_RecordMemRef,
/*57443*/       OPC_RecordNode, // #1 = 'ld' chained node
/*57444*/       OPC_CheckFoldableChainNode,
/*57445*/       OPC_RecordChild1, // #2 = $src2
/*57446*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*57448*/       OPC_CheckPredicate, 8, // Predicate_load
/*57450*/       OPC_SwitchType /*2 cases */, 75,  MVT::v2i64,// ->57528
/*57453*/         OPC_CheckPredicate, 23, // Predicate_memop
/*57455*/         OPC_MoveParent,
/*57456*/         OPC_MoveParent,
/*57457*/         OPC_SwitchType /*3 cases */, 21,  MVT::v16i8,// ->57481
/*57460*/           OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*57462*/           OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*57465*/           OPC_EmitMergeInputChains, 1, 1, 
/*57468*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::PSUBBrm), 0|OPFL_Chain|OPFL_MemRefs,
                        1/*#VTs*/, MVT::v16i8, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                    // Src: (sub:v16i8 VR128:v16i8:$src1, (bitconvert:v16i8 (ld:v2i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>))
                    // Dst: (PSUBBrm:v16i8 VR128:v16i8:$src1, addr:iPTR:$src2)
                  /*SwitchType*/ 21,  MVT::v8i16,// ->57504
/*57483*/           OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*57485*/           OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*57488*/           OPC_EmitMergeInputChains, 1, 1, 
/*57491*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::PSUBWrm), 0|OPFL_Chain|OPFL_MemRefs,
                        1/*#VTs*/, MVT::v8i16, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                    // Src: (sub:v8i16 VR128:v8i16:$src1, (bitconvert:v8i16 (ld:v2i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>))
                    // Dst: (PSUBWrm:v8i16 VR128:v8i16:$src1, addr:iPTR:$src2)
                  /*SwitchType*/ 21,  MVT::v4i32,// ->57527
/*57506*/           OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*57508*/           OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*57511*/           OPC_EmitMergeInputChains, 1, 1, 
/*57514*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::PSUBDrm), 0|OPFL_Chain|OPFL_MemRefs,
                        1/*#VTs*/, MVT::v4i32, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                    // Src: (sub:v4i32 VR128:v4i32:$src1, (bitconvert:v4i32 (ld:v2i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>))
                    // Dst: (PSUBDrm:v4i32 VR128:v4i32:$src1, addr:iPTR:$src2)
                  0, // EndSwitchType
                /*SwitchType*/ 96,  MVT::v1i64,// ->57626
/*57530*/         OPC_MoveParent,
/*57531*/         OPC_MoveParent,
/*57532*/         OPC_SwitchType /*4 cases */, 21,  MVT::v8i8,// ->57556
/*57535*/           OPC_CheckPatternPredicate, 8, // (Subtarget->hasMMX())
/*57537*/           OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*57540*/           OPC_EmitMergeInputChains, 1, 1, 
/*57543*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PSUBBrm), 0|OPFL_Chain|OPFL_MemRefs,
                        1/*#VTs*/, MVT::v8i8, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                    // Src: (sub:v8i8 VR64:v8i8:$src1, (bitconvert:v8i8 (ld:v1i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>))
                    // Dst: (MMX_PSUBBrm:v8i8 VR64:v8i8:$src1, addr:iPTR:$src2)
                  /*SwitchType*/ 21,  MVT::v4i16,// ->57579
/*57558*/           OPC_CheckPatternPredicate, 8, // (Subtarget->hasMMX())
/*57560*/           OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*57563*/           OPC_EmitMergeInputChains, 1, 1, 
/*57566*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PSUBWrm), 0|OPFL_Chain|OPFL_MemRefs,
                        1/*#VTs*/, MVT::v4i16, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                    // Src: (sub:v4i16 VR64:v4i16:$src1, (bitconvert:v4i16 (ld:v1i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>))
                    // Dst: (MMX_PSUBWrm:v4i16 VR64:v4i16:$src1, addr:iPTR:$src2)
                  /*SwitchType*/ 21,  MVT::v2i32,// ->57602
/*57581*/           OPC_CheckPatternPredicate, 8, // (Subtarget->hasMMX())
/*57583*/           OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*57586*/           OPC_EmitMergeInputChains, 1, 1, 
/*57589*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PSUBDrm), 0|OPFL_Chain|OPFL_MemRefs,
                        1/*#VTs*/, MVT::v2i32, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                    // Src: (sub:v2i32 VR64:v2i32:$src1, (bitconvert:v2i32 (ld:v1i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>))
                    // Dst: (MMX_PSUBDrm:v2i32 VR64:v2i32:$src1, addr:iPTR:$src2)
                  /*SwitchType*/ 21,  MVT::v1i64,// ->57625
/*57604*/           OPC_CheckPatternPredicate, 8, // (Subtarget->hasMMX())
/*57606*/           OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*57609*/           OPC_EmitMergeInputChains, 1, 1, 
/*57612*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PSUBQrm), 0|OPFL_Chain|OPFL_MemRefs,
                        1/*#VTs*/, MVT::v1i64, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                    // Src: (sub:v1i64 VR64:v1i64:$src1, (bitconvert:v1i64 (ld:v1i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>))
                    // Dst: (MMX_PSUBQrm:v1i64 VR64:v1i64:$src1, addr:iPTR:$src2)
                  0, // EndSwitchType
                0, // EndSwitchType
              /*SwitchOpcode*/ 1|128,1/*129*/,  ISD::LOAD,// ->57759
/*57630*/       OPC_RecordMemRef,
/*57631*/       OPC_RecordNode, // #1 = 'ld' chained node
/*57632*/       OPC_CheckFoldableChainNode,
/*57633*/       OPC_RecordChild1, // #2 = $src2
/*57634*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*57636*/       OPC_CheckPredicate, 8, // Predicate_load
/*57638*/       OPC_Scope, 91, /*->57731*/ // 2 children in Scope
/*57640*/         OPC_MoveParent,
/*57641*/         OPC_SwitchType /*4 cases */, 20,  MVT::i8,// ->57664
/*57644*/           OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*57647*/           OPC_EmitMergeInputChains, 1, 1, 
/*57650*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::SUB8rm), 0|OPFL_Chain|OPFL_MemRefs,
                        2/*#VTs*/, MVT::i8, MVT::i32, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                    // Src: (sub:i8 GR8:i8:$src1, (ld:i8 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)
                    // Dst: (SUB8rm:i8 GR8:i8:$src1, addr:iPTR:$src2)
                  /*SwitchType*/ 20,  MVT::i16,// ->57686
/*57666*/           OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*57669*/           OPC_EmitMergeInputChains, 1, 1, 
/*57672*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::SUB16rm), 0|OPFL_Chain|OPFL_MemRefs,
                        2/*#VTs*/, MVT::i16, MVT::i32, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                    // Src: (sub:i16 GR16:i16:$src1, (ld:i16 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)
                    // Dst: (SUB16rm:i16 GR16:i16:$src1, addr:iPTR:$src2)
                  /*SwitchType*/ 20,  MVT::i32,// ->57708
/*57688*/           OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*57691*/           OPC_EmitMergeInputChains, 1, 1, 
/*57694*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::SUB32rm), 0|OPFL_Chain|OPFL_MemRefs,
                        2/*#VTs*/, MVT::i32, MVT::i32, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                    // Src: (sub:i32 GR32:i32:$src1, (ld:i32 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)
                    // Dst: (SUB32rm:i32 GR32:i32:$src1, addr:iPTR:$src2)
                  /*SwitchType*/ 20,  MVT::i64,// ->57730
/*57710*/           OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*57713*/           OPC_EmitMergeInputChains, 1, 1, 
/*57716*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::SUB64rm), 0|OPFL_Chain|OPFL_MemRefs,
                        2/*#VTs*/, MVT::i64, MVT::i32, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                    // Src: (sub:i64 GR64:i64:$src1, (ld:i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)
                    // Dst: (SUB64rm:i64 GR64:i64:$src1, addr:iPTR:$src2)
                  0, // EndSwitchType
/*57731*/       /*Scope*/ 26, /*->57758*/
/*57732*/         OPC_CheckPredicate, 23, // Predicate_memop
/*57734*/         OPC_MoveParent,
/*57735*/         OPC_CheckType, MVT::v2i64,
/*57737*/         OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*57739*/         OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*57742*/         OPC_EmitMergeInputChains, 1, 1, 
/*57745*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::PSUBQrm), 0|OPFL_Chain|OPFL_MemRefs,
                      1/*#VTs*/, MVT::v2i64, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                  // Src: (sub:v2i64 VR128:v2i64:$src1, (ld:v2i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>)
                  // Dst: (PSUBQrm:v2i64 VR128:v2i64:$src1, addr:iPTR:$src2)
/*57758*/       0, /*End of Scope*/
              0, // EndSwitchOpcode
/*57760*/   /*Scope*/ 57, /*->57818*/
/*57761*/     OPC_RecordNode, // #0 = $src
/*57762*/     OPC_SwitchType /*2 cases */, 36,  MVT::i32,// ->57801
/*57765*/       OPC_Scope, 16, /*->57783*/ // 2 children in Scope
/*57767*/         OPC_CheckPatternPredicate, 2, // (!Subtarget->is64Bit())
/*57769*/         OPC_CheckComplexPat, /*CP*/3, /*#*/0, // SelectLEAAddr:$src #1 #2 #3 #4
/*57772*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::LEA32r), 0,
                      1/*#VTs*/, MVT::i32, 4/*#Ops*/, 1, 2, 3, 4, 
                  // Src: lea32addr:i32:$src
                  // Dst: (LEA32r:i32 lea32addr:i32:$src)
/*57783*/       /*Scope*/ 16, /*->57800*/
/*57784*/         OPC_CheckPatternPredicate, 3, // (Subtarget->is64Bit())
/*57786*/         OPC_CheckComplexPat, /*CP*/3, /*#*/0, // SelectLEAAddr:$src #1 #2 #3 #4
/*57789*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::LEA64_32r), 0,
                      1/*#VTs*/, MVT::i32, 4/*#Ops*/, 1, 2, 3, 4, 
                  // Src: lea32addr:i32:$src
                  // Dst: (LEA64_32r:i32 lea32addr:i32:$src)
/*57800*/       0, /*End of Scope*/
              /*SwitchType*/ 14,  MVT::i64,// ->57817
/*57803*/       OPC_CheckComplexPat, /*CP*/4, /*#*/0, // SelectLEAAddr:$src #1 #2 #3 #4
/*57806*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::LEA64r), 0,
                    1/*#VTs*/, MVT::i64, 4/*#Ops*/, 1, 2, 3, 4, 
                // Src: lea64addr:i64:$src
                // Dst: (LEA64r:i64 lea64addr:i64:$src)
              0, // EndSwitchType
/*57818*/   /*Scope*/ 52, /*->57871*/
/*57819*/     OPC_MoveChild, 0,
/*57821*/     OPC_CheckInteger, 0, 
/*57823*/     OPC_MoveParent,
/*57824*/     OPC_RecordChild1, // #0 = $src
/*57825*/     OPC_SwitchType /*4 cases */, 9,  MVT::i8,// ->57837
/*57828*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::NEG8r), 0,
                    2/*#VTs*/, MVT::i8, MVT::i32, 1/*#Ops*/, 0, 
                // Src: (sub:i8 0:i8, GR8:i8:$src)
                // Dst: (NEG8r:i8 GR8:i8:$src)
              /*SwitchType*/ 9,  MVT::i16,// ->57848
/*57839*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::NEG16r), 0,
                    2/*#VTs*/, MVT::i16, MVT::i32, 1/*#Ops*/, 0, 
                // Src: (sub:i16 0:i16, GR16:i16:$src)
                // Dst: (NEG16r:i16 GR16:i16:$src)
              /*SwitchType*/ 9,  MVT::i32,// ->57859
/*57850*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::NEG32r), 0,
                    2/*#VTs*/, MVT::i32, MVT::i32, 1/*#Ops*/, 0, 
                // Src: (sub:i32 0:i32, GR32:i32:$src)
                // Dst: (NEG32r:i32 GR32:i32:$src)
              /*SwitchType*/ 9,  MVT::i64,// ->57870
/*57861*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::NEG64r), 0,
                    2/*#VTs*/, MVT::i64, MVT::i32, 1/*#Ops*/, 0, 
                // Src: (sub:i64 0:i64, GR64:i64:$src)
                // Dst: (NEG64r:i64 GR64:i64:$src)
              0, // EndSwitchType
/*57871*/   /*Scope*/ 31|128,2/*287*/, /*->58160*/
/*57873*/     OPC_RecordChild0, // #0 = $src1
/*57874*/     OPC_RecordChild1, // #1 = $src2
/*57875*/     OPC_Scope, 118, /*->57995*/ // 13 children in Scope
/*57877*/       OPC_MoveChild, 1,
/*57879*/       OPC_CheckOpcode, ISD::Constant,
/*57881*/       OPC_Scope, 47, /*->57930*/ // 3 children in Scope
/*57883*/         OPC_CheckPredicate, 11, // Predicate_immSext8
/*57885*/         OPC_MoveParent,
/*57886*/         OPC_SwitchType /*3 cases */, 12,  MVT::i16,// ->57901
/*57889*/           OPC_EmitConvertToTarget, 1,
/*57891*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::SUB16ri8), 0,
                        2/*#VTs*/, MVT::i16, MVT::i32, 2/*#Ops*/, 0, 2, 
                    // Src: (sub:i16 GR16:i16:$src1, (imm:i16)<<P:Predicate_immSext8>>:$src2)
                    // Dst: (SUB16ri8:i16 GR16:i16:$src1, (imm:i16):$src2)
                  /*SwitchType*/ 12,  MVT::i32,// ->57915
/*57903*/           OPC_EmitConvertToTarget, 1,
/*57905*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::SUB32ri8), 0,
                        2/*#VTs*/, MVT::i32, MVT::i32, 2/*#Ops*/, 0, 2, 
                    // Src: (sub:i32 GR32:i32:$src1, (imm:i32)<<P:Predicate_immSext8>>:$src2)
                    // Dst: (SUB32ri8:i32 GR32:i32:$src1, (imm:i32):$src2)
                  /*SwitchType*/ 12,  MVT::i64,// ->57929
/*57917*/           OPC_EmitConvertToTarget, 1,
/*57919*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::SUB64ri8), 0,
                        2/*#VTs*/, MVT::i64, MVT::i32, 2/*#Ops*/, 0, 2, 
                    // Src: (sub:i64 GR64:i64:$src1, (imm:i64)<<P:Predicate_immSext8>>:$src2)
                    // Dst: (SUB64ri8:i64 GR64:i64:$src1, (imm:i64):$src2)
                  0, // EndSwitchType
/*57930*/       /*Scope*/ 17, /*->57948*/
/*57931*/         OPC_CheckPredicate, 12, // Predicate_i64immSExt32
/*57933*/         OPC_MoveParent,
/*57934*/         OPC_CheckType, MVT::i64,
/*57936*/         OPC_EmitConvertToTarget, 1,
/*57938*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::SUB64ri32), 0,
                      2/*#VTs*/, MVT::i64, MVT::i32, 2/*#Ops*/, 0, 2, 
                  // Src: (sub:i64 GR64:i64:$src1, (imm:i64)<<P:Predicate_i64immSExt32>>:$src2)
                  // Dst: (SUB64ri32:i64 GR64:i64:$src1, (imm:i64):$src2)
/*57948*/       /*Scope*/ 45, /*->57994*/
/*57949*/         OPC_MoveParent,
/*57950*/         OPC_SwitchType /*3 cases */, 12,  MVT::i8,// ->57965
/*57953*/           OPC_EmitConvertToTarget, 1,
/*57955*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::SUB8ri), 0,
                        2/*#VTs*/, MVT::i8, MVT::i32, 2/*#Ops*/, 0, 2, 
                    // Src: (sub:i8 GR8:i8:$src1, (imm:i8):$src2)
                    // Dst: (SUB8ri:i8 GR8:i8:$src1, (imm:i8):$src2)
                  /*SwitchType*/ 12,  MVT::i16,// ->57979
/*57967*/           OPC_EmitConvertToTarget, 1,
/*57969*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::SUB16ri), 0,
                        2/*#VTs*/, MVT::i16, MVT::i32, 2/*#Ops*/, 0, 2, 
                    // Src: (sub:i16 GR16:i16:$src1, (imm:i16):$src2)
                    // Dst: (SUB16ri:i16 GR16:i16:$src1, (imm:i16):$src2)
                  /*SwitchType*/ 12,  MVT::i32,// ->57993
/*57981*/           OPC_EmitConvertToTarget, 1,
/*57983*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::SUB32ri), 0,
                        2/*#VTs*/, MVT::i32, MVT::i32, 2/*#Ops*/, 0, 2, 
                    // Src: (sub:i32 GR32:i32:$src1, (imm:i32):$src2)
                    // Dst: (SUB32ri:i32 GR32:i32:$src1, (imm:i32):$src2)
                  0, // EndSwitchType
/*57994*/       0, /*End of Scope*/
/*57995*/     /*Scope*/ 12, /*->58008*/
/*57996*/       OPC_CheckType, MVT::i8,
/*57998*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::SUB8rr), 0,
                    2/*#VTs*/, MVT::i8, MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (sub:i8 GR8:i8:$src1, GR8:i8:$src2)
                // Dst: (SUB8rr:i8 GR8:i8:$src1, GR8:i8:$src2)
/*58008*/     /*Scope*/ 12, /*->58021*/
/*58009*/       OPC_CheckType, MVT::i16,
/*58011*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::SUB16rr), 0,
                    2/*#VTs*/, MVT::i16, MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (sub:i16 GR16:i16:$src1, GR16:i16:$src2)
                // Dst: (SUB16rr:i16 GR16:i16:$src1, GR16:i16:$src2)
/*58021*/     /*Scope*/ 12, /*->58034*/
/*58022*/       OPC_CheckType, MVT::i32,
/*58024*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::SUB32rr), 0,
                    2/*#VTs*/, MVT::i32, MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (sub:i32 GR32:i32:$src1, GR32:i32:$src2)
                // Dst: (SUB32rr:i32 GR32:i32:$src1, GR32:i32:$src2)
/*58034*/     /*Scope*/ 12, /*->58047*/
/*58035*/       OPC_CheckType, MVT::i64,
/*58037*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::SUB64rr), 0,
                    2/*#VTs*/, MVT::i64, MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (sub:i64 GR64:i64:$src1, GR64:i64:$src2)
                // Dst: (SUB64rr:i64 GR64:i64:$src1, GR64:i64:$src2)
/*58047*/     /*Scope*/ 13, /*->58061*/
/*58048*/       OPC_CheckType, MVT::v16i8,
/*58050*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*58052*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PSUBBrr), 0,
                    1/*#VTs*/, MVT::v16i8, 2/*#Ops*/, 0, 1, 
                // Src: (sub:v16i8 VR128:v16i8:$src1, VR128:v16i8:$src2)
                // Dst: (PSUBBrr:v16i8 VR128:v16i8:$src1, VR128:v16i8:$src2)
/*58061*/     /*Scope*/ 13, /*->58075*/
/*58062*/       OPC_CheckType, MVT::v8i16,
/*58064*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*58066*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PSUBWrr), 0,
                    1/*#VTs*/, MVT::v8i16, 2/*#Ops*/, 0, 1, 
                // Src: (sub:v8i16 VR128:v8i16:$src1, VR128:v8i16:$src2)
                // Dst: (PSUBWrr:v8i16 VR128:v8i16:$src1, VR128:v8i16:$src2)
/*58075*/     /*Scope*/ 13, /*->58089*/
/*58076*/       OPC_CheckType, MVT::v4i32,
/*58078*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*58080*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PSUBDrr), 0,
                    1/*#VTs*/, MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (sub:v4i32 VR128:v4i32:$src1, VR128:v4i32:$src2)
                // Dst: (PSUBDrr:v4i32 VR128:v4i32:$src1, VR128:v4i32:$src2)
/*58089*/     /*Scope*/ 13, /*->58103*/
/*58090*/       OPC_CheckType, MVT::v2i64,
/*58092*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*58094*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PSUBQrr), 0,
                    1/*#VTs*/, MVT::v2i64, 2/*#Ops*/, 0, 1, 
                // Src: (sub:v2i64 VR128:v2i64:$src1, VR128:v2i64:$src2)
                // Dst: (PSUBQrr:v2i64 VR128:v2i64:$src1, VR128:v2i64:$src2)
/*58103*/     /*Scope*/ 13, /*->58117*/
/*58104*/       OPC_CheckType, MVT::v8i8,
/*58106*/       OPC_CheckPatternPredicate, 8, // (Subtarget->hasMMX())
/*58108*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PSUBBrr), 0,
                    1/*#VTs*/, MVT::v8i8, 2/*#Ops*/, 0, 1, 
                // Src: (sub:v8i8 VR64:v8i8:$src1, VR64:v8i8:$src2)
                // Dst: (MMX_PSUBBrr:v8i8 VR64:v8i8:$src1, VR64:v8i8:$src2)
/*58117*/     /*Scope*/ 13, /*->58131*/
/*58118*/       OPC_CheckType, MVT::v4i16,
/*58120*/       OPC_CheckPatternPredicate, 8, // (Subtarget->hasMMX())
/*58122*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PSUBWrr), 0,
                    1/*#VTs*/, MVT::v4i16, 2/*#Ops*/, 0, 1, 
                // Src: (sub:v4i16 VR64:v4i16:$src1, VR64:v4i16:$src2)
                // Dst: (MMX_PSUBWrr:v4i16 VR64:v4i16:$src1, VR64:v4i16:$src2)
/*58131*/     /*Scope*/ 13, /*->58145*/
/*58132*/       OPC_CheckType, MVT::v2i32,
/*58134*/       OPC_CheckPatternPredicate, 8, // (Subtarget->hasMMX())
/*58136*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PSUBDrr), 0,
                    1/*#VTs*/, MVT::v2i32, 2/*#Ops*/, 0, 1, 
                // Src: (sub:v2i32 VR64:v2i32:$src1, VR64:v2i32:$src2)
                // Dst: (MMX_PSUBDrr:v2i32 VR64:v2i32:$src1, VR64:v2i32:$src2)
/*58145*/     /*Scope*/ 13, /*->58159*/
/*58146*/       OPC_CheckType, MVT::v1i64,
/*58148*/       OPC_CheckPatternPredicate, 8, // (Subtarget->hasMMX())
/*58150*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PSUBQrr), 0,
                    1/*#VTs*/, MVT::v1i64, 2/*#Ops*/, 0, 1, 
                // Src: (sub:v1i64 VR64:v1i64:$src1, VR64:v1i64:$src2)
                // Dst: (MMX_PSUBQrr:v1i64 VR64:v1i64:$src1, VR64:v1i64:$src2)
/*58159*/     0, /*End of Scope*/
/*58160*/   0, /*End of Scope*/
          /*SwitchOpcode*/ 71,  X86ISD::PINSRW,// ->58234
/*58163*/   OPC_RecordChild0, // #0 = $src1
/*58164*/   OPC_Scope, 45, /*->58211*/ // 2 children in Scope
/*58166*/     OPC_MoveChild, 1,
/*58168*/     OPC_CheckOpcode, ISD::LOAD,
/*58170*/     OPC_RecordMemRef,
/*58171*/     OPC_RecordNode, // #1 = 'ld' chained node
/*58172*/     OPC_CheckFoldableChainNode,
/*58173*/     OPC_RecordChild1, // #2 = $src2
/*58174*/     OPC_CheckPredicate, 2, // Predicate_unindexedload
/*58176*/     OPC_CheckPredicate, 48, // Predicate_extload
/*58178*/     OPC_CheckPredicate, 60, // Predicate_extloadi16
/*58180*/     OPC_MoveParent,
/*58181*/     OPC_RecordChild2, // #3 = $src3
/*58182*/     OPC_MoveChild, 2,
/*58184*/     OPC_CheckOpcode, ISD::Constant,
/*58186*/     OPC_MoveParent,
/*58187*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*58189*/     OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #4 #5 #6 #7 #8
/*58192*/     OPC_EmitMergeInputChains, 1, 1, 
/*58195*/     OPC_EmitConvertToTarget, 3,
/*58197*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::PINSRWrmi), 0|OPFL_Chain|OPFL_MemRefs,
                  1/*#VTs*/, MVT::v8i16, 7/*#Ops*/, 0, 4, 5, 6, 7, 8, 9, 
              // Src: (X86pinsrw:v8i16 VR128:v8i16:$src1, (ld:i32 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, (imm:iPTR):$src3)
              // Dst: (PINSRWrmi:v8i16 VR128:v8i16:$src1, addr:iPTR:$src2, (imm:i32):$src3)
/*58211*/   /*Scope*/ 21, /*->58233*/
/*58212*/     OPC_RecordChild1, // #1 = $src2
/*58213*/     OPC_RecordChild2, // #2 = $src3
/*58214*/     OPC_MoveChild, 2,
/*58216*/     OPC_CheckOpcode, ISD::Constant,
/*58218*/     OPC_MoveParent,
/*58219*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*58221*/     OPC_EmitConvertToTarget, 2,
/*58223*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::PINSRWrri), 0,
                  1/*#VTs*/, MVT::v8i16, 3/*#Ops*/, 0, 1, 3, 
              // Src: (X86pinsrw:v8i16 VR128:v8i16:$src1, GR32:i32:$src2, (imm:iPTR):$src3)
              // Dst: (PINSRWrri:v8i16 VR128:v8i16:$src1, GR32:i32:$src2, (imm:i32):$src3)
/*58233*/   0, /*End of Scope*/
          /*SwitchOpcode*/ 122,  ISD::MEMBARRIER,// ->58358
/*58236*/   OPC_RecordNode,   // #0 = 'membarrier' chained node
/*58237*/   OPC_MoveChild, 1,
/*58239*/   OPC_CheckType, MVT::i8,
/*58241*/   OPC_Scope, 32, /*->58275*/ // 3 children in Scope
/*58243*/     OPC_CheckInteger, 0, 
/*58245*/     OPC_MoveParent,
/*58246*/     OPC_MoveChild, 2,
/*58248*/     OPC_CheckInteger, 0, 
/*58250*/     OPC_MoveParent,
/*58251*/     OPC_MoveChild, 3,
/*58253*/     OPC_CheckInteger, 0, 
/*58255*/     OPC_MoveParent,
/*58256*/     OPC_MoveChild, 4,
/*58258*/     OPC_CheckInteger, 1, 
/*58260*/     OPC_MoveParent,
/*58261*/     OPC_MoveChild, 5,
/*58263*/     OPC_CheckInteger, 1, 
/*58265*/     OPC_MoveParent,
/*58266*/     OPC_EmitMergeInputChains, 1, 0, 
/*58269*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::SFENCE), 0|OPFL_Chain,
                  0/*#VTs*/, 0/*#Ops*/, 
              // Src: (membarrier:isVoid 0:i8, 0:i8, 0:i8, 1:i8, 1:i8)
              // Dst: (SFENCE:isVoid)
/*58275*/   /*Scope*/ 32, /*->58308*/
/*58276*/     OPC_CheckInteger, 1, 
/*58278*/     OPC_MoveParent,
/*58279*/     OPC_MoveChild, 2,
/*58281*/     OPC_CheckInteger, 0, 
/*58283*/     OPC_MoveParent,
/*58284*/     OPC_MoveChild, 3,
/*58286*/     OPC_CheckInteger, 0, 
/*58288*/     OPC_MoveParent,
/*58289*/     OPC_MoveChild, 4,
/*58291*/     OPC_CheckInteger, 0, 
/*58293*/     OPC_MoveParent,
/*58294*/     OPC_MoveChild, 5,
/*58296*/     OPC_CheckInteger, 1, 
/*58298*/     OPC_MoveParent,
/*58299*/     OPC_EmitMergeInputChains, 1, 0, 
/*58302*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::LFENCE), 0|OPFL_Chain,
                  0/*#VTs*/, 0/*#Ops*/, 
              // Src: (membarrier:isVoid 1:i8, 0:i8, 0:i8, 0:i8, 1:i8)
              // Dst: (LFENCE:isVoid)
/*58308*/   /*Scope*/ 48, /*->58357*/
/*58309*/     OPC_CheckOpcode, ISD::Constant,
/*58311*/     OPC_MoveParent,
/*58312*/     OPC_MoveChild, 2,
/*58314*/     OPC_CheckOpcode, ISD::Constant,
/*58316*/     OPC_MoveParent,
/*58317*/     OPC_MoveChild, 3,
/*58319*/     OPC_CheckOpcode, ISD::Constant,
/*58321*/     OPC_MoveParent,
/*58322*/     OPC_MoveChild, 4,
/*58324*/     OPC_CheckOpcode, ISD::Constant,
/*58326*/     OPC_MoveParent,
/*58327*/     OPC_MoveChild, 5,
/*58329*/     OPC_Scope, 12, /*->58343*/ // 2 children in Scope
/*58331*/       OPC_CheckInteger, 0, 
/*58333*/       OPC_MoveParent,
/*58334*/       OPC_EmitMergeInputChains, 1, 0, 
/*58337*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::NOOP), 0|OPFL_Chain,
                    0/*#VTs*/, 0/*#Ops*/, 
                // Src: (membarrier:isVoid (imm:i8), (imm:i8), (imm:i8), (imm:i8), 0:i8)
                // Dst: (NOOP:isVoid)
/*58343*/     /*Scope*/ 12, /*->58356*/
/*58344*/       OPC_CheckInteger, 1, 
/*58346*/       OPC_MoveParent,
/*58347*/       OPC_EmitMergeInputChains, 1, 0, 
/*58350*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MFENCE), 0|OPFL_Chain,
                    0/*#VTs*/, 0/*#Ops*/, 
                // Src: (membarrier:isVoid (imm:i8), (imm:i8), (imm:i8), (imm:i8), 1:i8)
                // Dst: (MFENCE:isVoid)
/*58356*/     0, /*End of Scope*/
/*58357*/   0, /*End of Scope*/
          /*SwitchOpcode*/ 60,  X86ISD::PSHUFB,// ->58420
/*58360*/   OPC_RecordChild0, // #0 = $src
/*58361*/   OPC_Scope, 43, /*->58406*/ // 2 children in Scope
/*58363*/     OPC_MoveChild, 1,
/*58365*/     OPC_CheckOpcode, ISD::BIT_CONVERT,
/*58367*/     OPC_MoveChild, 0,
/*58369*/     OPC_CheckOpcode, ISD::LOAD,
/*58371*/     OPC_RecordMemRef,
/*58372*/     OPC_RecordNode, // #1 = 'ld' chained node
/*58373*/     OPC_CheckFoldableChainNode,
/*58374*/     OPC_RecordChild1, // #2 = $mask
/*58375*/     OPC_CheckPredicate, 2, // Predicate_unindexedload
/*58377*/     OPC_CheckPredicate, 8, // Predicate_load
/*58379*/     OPC_CheckPredicate, 23, // Predicate_memop
/*58381*/     OPC_CheckType, MVT::v2i64,
/*58383*/     OPC_MoveParent,
/*58384*/     OPC_MoveParent,
/*58385*/     OPC_CheckPatternPredicate, 11, // (Subtarget->hasSSSE3())
/*58387*/     OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$mask #3 #4 #5 #6 #7
/*58390*/     OPC_EmitMergeInputChains, 1, 1, 
/*58393*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::PSHUFBrm128), 0|OPFL_Chain|OPFL_MemRefs,
                  1/*#VTs*/, MVT::v16i8, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
              // Src: (X86pshufb:v16i8 VR128:v16i8:$src, (bitconvert:v16i8 (ld:v2i64 addr:iPTR:$mask)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>))
              // Dst: (PSHUFBrm128:v16i8 VR128:v16i8:$src, addr:iPTR:$mask)
/*58406*/   /*Scope*/ 12, /*->58419*/
/*58407*/     OPC_RecordChild1, // #1 = $mask
/*58408*/     OPC_CheckPatternPredicate, 11, // (Subtarget->hasSSSE3())
/*58410*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::PSHUFBrr128), 0,
                  1/*#VTs*/, MVT::v16i8, 2/*#Ops*/, 0, 1, 
              // Src: (X86pshufb:v16i8 VR128:v16i8:$src, VR128:v16i8:$mask)
              // Dst: (PSHUFBrr128:v16i8 VR128:v16i8:$src, VR128:v16i8:$mask)
/*58419*/   0, /*End of Scope*/
          /*SwitchOpcode*/ 71,  X86ISD::PINSRB,// ->58493
/*58422*/   OPC_RecordChild0, // #0 = $src1
/*58423*/   OPC_Scope, 45, /*->58470*/ // 2 children in Scope
/*58425*/     OPC_MoveChild, 1,
/*58427*/     OPC_CheckOpcode, ISD::LOAD,
/*58429*/     OPC_RecordMemRef,
/*58430*/     OPC_RecordNode, // #1 = 'ld' chained node
/*58431*/     OPC_CheckFoldableChainNode,
/*58432*/     OPC_RecordChild1, // #2 = $src2
/*58433*/     OPC_CheckPredicate, 2, // Predicate_unindexedload
/*58435*/     OPC_CheckPredicate, 48, // Predicate_extload
/*58437*/     OPC_CheckPredicate, 59, // Predicate_extloadi8
/*58439*/     OPC_MoveParent,
/*58440*/     OPC_RecordChild2, // #3 = $src3
/*58441*/     OPC_MoveChild, 2,
/*58443*/     OPC_CheckOpcode, ISD::Constant,
/*58445*/     OPC_MoveParent,
/*58446*/     OPC_CheckPatternPredicate, 4, // (Subtarget->hasSSE41())
/*58448*/     OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #4 #5 #6 #7 #8
/*58451*/     OPC_EmitMergeInputChains, 1, 1, 
/*58454*/     OPC_EmitConvertToTarget, 3,
/*58456*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::PINSRBrm), 0|OPFL_Chain|OPFL_MemRefs,
                  1/*#VTs*/, MVT::v16i8, 7/*#Ops*/, 0, 4, 5, 6, 7, 8, 9, 
              // Src: (X86pinsrb:v16i8 VR128:v16i8:$src1, (ld:i32 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, (imm:iPTR):$src3)
              // Dst: (PINSRBrm:v16i8 VR128:v16i8:$src1, addr:iPTR:$src2, (imm:i32):$src3)
/*58470*/   /*Scope*/ 21, /*->58492*/
/*58471*/     OPC_RecordChild1, // #1 = $src2
/*58472*/     OPC_RecordChild2, // #2 = $src3
/*58473*/     OPC_MoveChild, 2,
/*58475*/     OPC_CheckOpcode, ISD::Constant,
/*58477*/     OPC_MoveParent,
/*58478*/     OPC_CheckPatternPredicate, 4, // (Subtarget->hasSSE41())
/*58480*/     OPC_EmitConvertToTarget, 2,
/*58482*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::PINSRBrr), 0,
                  1/*#VTs*/, MVT::v16i8, 3/*#Ops*/, 0, 1, 3, 
              // Src: (X86pinsrb:v16i8 VR128:v16i8:$src1, GR32:i32:$src2, (imm:iPTR):$src3)
              // Dst: (PINSRBrr:v16i8 VR128:v16i8:$src1, GR32:i32:$src2, (imm:i32):$src3)
/*58492*/   0, /*End of Scope*/
          /*SwitchOpcode*/ 63|128,1/*191*/,  X86ISD::PCMPEQB,// ->58687
/*58496*/   OPC_Scope, 42, /*->58540*/ // 5 children in Scope
/*58498*/     OPC_RecordChild0, // #0 = $src1
/*58499*/     OPC_MoveChild, 1,
/*58501*/     OPC_CheckOpcode, ISD::BIT_CONVERT,
/*58503*/     OPC_MoveChild, 0,
/*58505*/     OPC_CheckOpcode, ISD::LOAD,
/*58507*/     OPC_RecordMemRef,
/*58508*/     OPC_RecordNode, // #1 = 'ld' chained node
/*58509*/     OPC_CheckFoldableChainNode,
/*58510*/     OPC_RecordChild1, // #2 = $src2
/*58511*/     OPC_CheckPredicate, 2, // Predicate_unindexedload
/*58513*/     OPC_CheckPredicate, 8, // Predicate_load
/*58515*/     OPC_CheckType, MVT::v1i64,
/*58517*/     OPC_MoveParent,
/*58518*/     OPC_MoveParent,
/*58519*/     OPC_CheckType, MVT::v8i8,
/*58521*/     OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*58524*/     OPC_EmitMergeInputChains, 1, 1, 
/*58527*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PCMPEQBrm), 0|OPFL_Chain|OPFL_MemRefs,
                  1/*#VTs*/, MVT::v8i8, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
              // Src: (X86pcmpeqb:v8i8 VR64:v8i8:$src1, (bitconvert:v8i8 (ld:v1i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>))
              // Dst: (MMX_PCMPEQBrm:v8i8 VR64:v8i8:$src1, addr:iPTR:$src2)
/*58540*/   /*Scope*/ 42, /*->58583*/
/*58541*/     OPC_MoveChild, 0,
/*58543*/     OPC_CheckOpcode, ISD::BIT_CONVERT,
/*58545*/     OPC_MoveChild, 0,
/*58547*/     OPC_CheckOpcode, ISD::LOAD,
/*58549*/     OPC_RecordMemRef,
/*58550*/     OPC_RecordNode, // #0 = 'ld' chained node
/*58551*/     OPC_CheckFoldableChainNode,
/*58552*/     OPC_RecordChild1, // #1 = $src2
/*58553*/     OPC_CheckPredicate, 2, // Predicate_unindexedload
/*58555*/     OPC_CheckPredicate, 8, // Predicate_load
/*58557*/     OPC_CheckType, MVT::v1i64,
/*58559*/     OPC_MoveParent,
/*58560*/     OPC_MoveParent,
/*58561*/     OPC_RecordChild1, // #2 = $src1
/*58562*/     OPC_CheckType, MVT::v8i8,
/*58564*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*58567*/     OPC_EmitMergeInputChains, 1, 0, 
/*58570*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PCMPEQBrm), 0|OPFL_Chain|OPFL_MemRefs,
                  1/*#VTs*/, MVT::v8i8, 6/*#Ops*/, 2, 3, 4, 5, 6, 7, 
              // Src: (X86pcmpeqb:v8i8 (bitconvert:v8i8 (ld:v1i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>), VR64:v8i8:$src1)
              // Dst: (MMX_PCMPEQBrm:v8i8 VR64:v8i8:$src1, addr:iPTR:$src2)
/*58583*/   /*Scope*/ 37, /*->58621*/
/*58584*/     OPC_RecordChild0, // #0 = $src1
/*58585*/     OPC_MoveChild, 1,
/*58587*/     OPC_CheckOpcode, ISD::LOAD,
/*58589*/     OPC_RecordMemRef,
/*58590*/     OPC_RecordNode, // #1 = 'ld' chained node
/*58591*/     OPC_CheckFoldableChainNode,
/*58592*/     OPC_RecordChild1, // #2 = $src2
/*58593*/     OPC_CheckPredicate, 2, // Predicate_unindexedload
/*58595*/     OPC_CheckPredicate, 8, // Predicate_load
/*58597*/     OPC_CheckPredicate, 23, // Predicate_memop
/*58599*/     OPC_MoveParent,
/*58600*/     OPC_CheckType, MVT::v16i8,
/*58602*/     OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*58605*/     OPC_EmitMergeInputChains, 1, 1, 
/*58608*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::PCMPEQBrm), 0|OPFL_Chain|OPFL_MemRefs,
                  1/*#VTs*/, MVT::v16i8, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
              // Src: (X86pcmpeqb:v16i8 VR128:v16i8:$src1, (ld:v16i8 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>)
              // Dst: (PCMPEQBrm:v16i8 VR128:v16i8:$src1, addr:iPTR:$src2)
/*58621*/   /*Scope*/ 37, /*->58659*/
/*58622*/     OPC_MoveChild, 0,
/*58624*/     OPC_CheckOpcode, ISD::LOAD,
/*58626*/     OPC_RecordMemRef,
/*58627*/     OPC_RecordNode, // #0 = 'ld' chained node
/*58628*/     OPC_CheckFoldableChainNode,
/*58629*/     OPC_RecordChild1, // #1 = $src2
/*58630*/     OPC_CheckPredicate, 2, // Predicate_unindexedload
/*58632*/     OPC_CheckPredicate, 8, // Predicate_load
/*58634*/     OPC_CheckPredicate, 23, // Predicate_memop
/*58636*/     OPC_MoveParent,
/*58637*/     OPC_RecordChild1, // #2 = $src1
/*58638*/     OPC_CheckType, MVT::v16i8,
/*58640*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*58643*/     OPC_EmitMergeInputChains, 1, 0, 
/*58646*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::PCMPEQBrm), 0|OPFL_Chain|OPFL_MemRefs,
                  1/*#VTs*/, MVT::v16i8, 6/*#Ops*/, 2, 3, 4, 5, 6, 7, 
              // Src: (X86pcmpeqb:v16i8 (ld:v16i8 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>, VR128:v16i8:$src1)
              // Dst: (PCMPEQBrm:v16i8 VR128:v16i8:$src1, addr:iPTR:$src2)
/*58659*/   /*Scope*/ 26, /*->58686*/
/*58660*/     OPC_RecordChild0, // #0 = $src1
/*58661*/     OPC_RecordChild1, // #1 = $src2
/*58662*/     OPC_SwitchType /*2 cases */, 9,  MVT::v16i8,// ->58674
/*58665*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PCMPEQBrr), 0,
                    1/*#VTs*/, MVT::v16i8, 2/*#Ops*/, 0, 1, 
                // Src: (X86pcmpeqb:v16i8 VR128:v16i8:$src1, VR128:v16i8:$src2)
                // Dst: (PCMPEQBrr:v16i8 VR128:v16i8:$src1, VR128:v16i8:$src2)
              /*SwitchType*/ 9,  MVT::v8i8,// ->58685
/*58676*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PCMPEQBrr), 0,
                    1/*#VTs*/, MVT::v8i8, 2/*#Ops*/, 0, 1, 
                // Src: (X86pcmpeqb:v8i8 VR64:v8i8:$src1, VR64:v8i8:$src2)
                // Dst: (MMX_PCMPEQBrr:v8i8 VR64:v8i8:$src1, VR64:v8i8:$src2)
              0, // EndSwitchType
/*58686*/   0, /*End of Scope*/
          /*SwitchOpcode*/ 63|128,1/*191*/,  X86ISD::PCMPEQW,// ->58881
/*58690*/   OPC_Scope, 42, /*->58734*/ // 5 children in Scope
/*58692*/     OPC_RecordChild0, // #0 = $src1
/*58693*/     OPC_MoveChild, 1,
/*58695*/     OPC_CheckOpcode, ISD::BIT_CONVERT,
/*58697*/     OPC_MoveChild, 0,
/*58699*/     OPC_CheckOpcode, ISD::LOAD,
/*58701*/     OPC_RecordMemRef,
/*58702*/     OPC_RecordNode, // #1 = 'ld' chained node
/*58703*/     OPC_CheckFoldableChainNode,
/*58704*/     OPC_RecordChild1, // #2 = $src2
/*58705*/     OPC_CheckPredicate, 2, // Predicate_unindexedload
/*58707*/     OPC_CheckPredicate, 8, // Predicate_load
/*58709*/     OPC_CheckType, MVT::v1i64,
/*58711*/     OPC_MoveParent,
/*58712*/     OPC_MoveParent,
/*58713*/     OPC_CheckType, MVT::v4i16,
/*58715*/     OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*58718*/     OPC_EmitMergeInputChains, 1, 1, 
/*58721*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PCMPEQWrm), 0|OPFL_Chain|OPFL_MemRefs,
                  1/*#VTs*/, MVT::v4i16, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
              // Src: (X86pcmpeqw:v4i16 VR64:v4i16:$src1, (bitconvert:v4i16 (ld:v1i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>))
              // Dst: (MMX_PCMPEQWrm:v4i16 VR64:v8i8:$src1, addr:iPTR:$src2)
/*58734*/   /*Scope*/ 42, /*->58777*/
/*58735*/     OPC_MoveChild, 0,
/*58737*/     OPC_CheckOpcode, ISD::BIT_CONVERT,
/*58739*/     OPC_MoveChild, 0,
/*58741*/     OPC_CheckOpcode, ISD::LOAD,
/*58743*/     OPC_RecordMemRef,
/*58744*/     OPC_RecordNode, // #0 = 'ld' chained node
/*58745*/     OPC_CheckFoldableChainNode,
/*58746*/     OPC_RecordChild1, // #1 = $src2
/*58747*/     OPC_CheckPredicate, 2, // Predicate_unindexedload
/*58749*/     OPC_CheckPredicate, 8, // Predicate_load
/*58751*/     OPC_CheckType, MVT::v1i64,
/*58753*/     OPC_MoveParent,
/*58754*/     OPC_MoveParent,
/*58755*/     OPC_RecordChild1, // #2 = $src1
/*58756*/     OPC_CheckType, MVT::v4i16,
/*58758*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*58761*/     OPC_EmitMergeInputChains, 1, 0, 
/*58764*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PCMPEQWrm), 0|OPFL_Chain|OPFL_MemRefs,
                  1/*#VTs*/, MVT::v4i16, 6/*#Ops*/, 2, 3, 4, 5, 6, 7, 
              // Src: (X86pcmpeqw:v4i16 (bitconvert:v4i16 (ld:v1i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>), VR64:v4i16:$src1)
              // Dst: (MMX_PCMPEQWrm:v4i16 VR64:v8i8:$src1, addr:iPTR:$src2)
/*58777*/   /*Scope*/ 37, /*->58815*/
/*58778*/     OPC_RecordChild0, // #0 = $src1
/*58779*/     OPC_MoveChild, 1,
/*58781*/     OPC_CheckOpcode, ISD::LOAD,
/*58783*/     OPC_RecordMemRef,
/*58784*/     OPC_RecordNode, // #1 = 'ld' chained node
/*58785*/     OPC_CheckFoldableChainNode,
/*58786*/     OPC_RecordChild1, // #2 = $src2
/*58787*/     OPC_CheckPredicate, 2, // Predicate_unindexedload
/*58789*/     OPC_CheckPredicate, 8, // Predicate_load
/*58791*/     OPC_CheckPredicate, 23, // Predicate_memop
/*58793*/     OPC_MoveParent,
/*58794*/     OPC_CheckType, MVT::v8i16,
/*58796*/     OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*58799*/     OPC_EmitMergeInputChains, 1, 1, 
/*58802*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::PCMPEQWrm), 0|OPFL_Chain|OPFL_MemRefs,
                  1/*#VTs*/, MVT::v8i16, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
              // Src: (X86pcmpeqw:v8i16 VR128:v8i16:$src1, (ld:v8i16 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>)
              // Dst: (PCMPEQWrm:v8i16 VR128:v16i8:$src1, addr:iPTR:$src2)
/*58815*/   /*Scope*/ 37, /*->58853*/
/*58816*/     OPC_MoveChild, 0,
/*58818*/     OPC_CheckOpcode, ISD::LOAD,
/*58820*/     OPC_RecordMemRef,
/*58821*/     OPC_RecordNode, // #0 = 'ld' chained node
/*58822*/     OPC_CheckFoldableChainNode,
/*58823*/     OPC_RecordChild1, // #1 = $src2
/*58824*/     OPC_CheckPredicate, 2, // Predicate_unindexedload
/*58826*/     OPC_CheckPredicate, 8, // Predicate_load
/*58828*/     OPC_CheckPredicate, 23, // Predicate_memop
/*58830*/     OPC_MoveParent,
/*58831*/     OPC_RecordChild1, // #2 = $src1
/*58832*/     OPC_CheckType, MVT::v8i16,
/*58834*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*58837*/     OPC_EmitMergeInputChains, 1, 0, 
/*58840*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::PCMPEQWrm), 0|OPFL_Chain|OPFL_MemRefs,
                  1/*#VTs*/, MVT::v8i16, 6/*#Ops*/, 2, 3, 4, 5, 6, 7, 
              // Src: (X86pcmpeqw:v8i16 (ld:v8i16 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>, VR128:v8i16:$src1)
              // Dst: (PCMPEQWrm:v8i16 VR128:v16i8:$src1, addr:iPTR:$src2)
/*58853*/   /*Scope*/ 26, /*->58880*/
/*58854*/     OPC_RecordChild0, // #0 = $src1
/*58855*/     OPC_RecordChild1, // #1 = $src2
/*58856*/     OPC_SwitchType /*2 cases */, 9,  MVT::v8i16,// ->58868
/*58859*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PCMPEQWrr), 0,
                    1/*#VTs*/, MVT::v8i16, 2/*#Ops*/, 0, 1, 
                // Src: (X86pcmpeqw:v8i16 VR128:v8i16:$src1, VR128:v8i16:$src2)
                // Dst: (PCMPEQWrr:v8i16 VR128:v16i8:$src1, VR128:v16i8:$src2)
              /*SwitchType*/ 9,  MVT::v4i16,// ->58879
/*58870*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PCMPEQWrr), 0,
                    1/*#VTs*/, MVT::v4i16, 2/*#Ops*/, 0, 1, 
                // Src: (X86pcmpeqw:v4i16 VR64:v4i16:$src1, VR64:v4i16:$src2)
                // Dst: (MMX_PCMPEQWrr:v4i16 VR64:v8i8:$src1, VR64:v8i8:$src2)
              0, // EndSwitchType
/*58880*/   0, /*End of Scope*/
          /*SwitchOpcode*/ 63|128,1/*191*/,  X86ISD::PCMPEQD,// ->59075
/*58884*/   OPC_Scope, 42, /*->58928*/ // 5 children in Scope
/*58886*/     OPC_RecordChild0, // #0 = $src1
/*58887*/     OPC_MoveChild, 1,
/*58889*/     OPC_CheckOpcode, ISD::BIT_CONVERT,
/*58891*/     OPC_MoveChild, 0,
/*58893*/     OPC_CheckOpcode, ISD::LOAD,
/*58895*/     OPC_RecordMemRef,
/*58896*/     OPC_RecordNode, // #1 = 'ld' chained node
/*58897*/     OPC_CheckFoldableChainNode,
/*58898*/     OPC_RecordChild1, // #2 = $src2
/*58899*/     OPC_CheckPredicate, 2, // Predicate_unindexedload
/*58901*/     OPC_CheckPredicate, 8, // Predicate_load
/*58903*/     OPC_CheckType, MVT::v1i64,
/*58905*/     OPC_MoveParent,
/*58906*/     OPC_MoveParent,
/*58907*/     OPC_CheckType, MVT::v2i32,
/*58909*/     OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*58912*/     OPC_EmitMergeInputChains, 1, 1, 
/*58915*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PCMPEQDrm), 0|OPFL_Chain|OPFL_MemRefs,
                  1/*#VTs*/, MVT::v2i32, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
              // Src: (X86pcmpeqd:v2i32 VR64:v2i32:$src1, (bitconvert:v2i32 (ld:v1i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>))
              // Dst: (MMX_PCMPEQDrm:v2i32 VR64:v8i8:$src1, addr:iPTR:$src2)
/*58928*/   /*Scope*/ 42, /*->58971*/
/*58929*/     OPC_MoveChild, 0,
/*58931*/     OPC_CheckOpcode, ISD::BIT_CONVERT,
/*58933*/     OPC_MoveChild, 0,
/*58935*/     OPC_CheckOpcode, ISD::LOAD,
/*58937*/     OPC_RecordMemRef,
/*58938*/     OPC_RecordNode, // #0 = 'ld' chained node
/*58939*/     OPC_CheckFoldableChainNode,
/*58940*/     OPC_RecordChild1, // #1 = $src2
/*58941*/     OPC_CheckPredicate, 2, // Predicate_unindexedload
/*58943*/     OPC_CheckPredicate, 8, // Predicate_load
/*58945*/     OPC_CheckType, MVT::v1i64,
/*58947*/     OPC_MoveParent,
/*58948*/     OPC_MoveParent,
/*58949*/     OPC_RecordChild1, // #2 = $src1
/*58950*/     OPC_CheckType, MVT::v2i32,
/*58952*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*58955*/     OPC_EmitMergeInputChains, 1, 0, 
/*58958*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PCMPEQDrm), 0|OPFL_Chain|OPFL_MemRefs,
                  1/*#VTs*/, MVT::v2i32, 6/*#Ops*/, 2, 3, 4, 5, 6, 7, 
              // Src: (X86pcmpeqd:v2i32 (bitconvert:v2i32 (ld:v1i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>), VR64:v2i32:$src1)
              // Dst: (MMX_PCMPEQDrm:v2i32 VR64:v8i8:$src1, addr:iPTR:$src2)
/*58971*/   /*Scope*/ 37, /*->59009*/
/*58972*/     OPC_RecordChild0, // #0 = $src1
/*58973*/     OPC_MoveChild, 1,
/*58975*/     OPC_CheckOpcode, ISD::LOAD,
/*58977*/     OPC_RecordMemRef,
/*58978*/     OPC_RecordNode, // #1 = 'ld' chained node
/*58979*/     OPC_CheckFoldableChainNode,
/*58980*/     OPC_RecordChild1, // #2 = $src2
/*58981*/     OPC_CheckPredicate, 2, // Predicate_unindexedload
/*58983*/     OPC_CheckPredicate, 8, // Predicate_load
/*58985*/     OPC_CheckPredicate, 23, // Predicate_memop
/*58987*/     OPC_MoveParent,
/*58988*/     OPC_CheckType, MVT::v4i32,
/*58990*/     OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*58993*/     OPC_EmitMergeInputChains, 1, 1, 
/*58996*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::PCMPEQDrm), 0|OPFL_Chain|OPFL_MemRefs,
                  1/*#VTs*/, MVT::v4i32, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
              // Src: (X86pcmpeqd:v4i32 VR128:v4i32:$src1, (ld:v4i32 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>)
              // Dst: (PCMPEQDrm:v4i32 VR128:v16i8:$src1, addr:iPTR:$src2)
/*59009*/   /*Scope*/ 37, /*->59047*/
/*59010*/     OPC_MoveChild, 0,
/*59012*/     OPC_CheckOpcode, ISD::LOAD,
/*59014*/     OPC_RecordMemRef,
/*59015*/     OPC_RecordNode, // #0 = 'ld' chained node
/*59016*/     OPC_CheckFoldableChainNode,
/*59017*/     OPC_RecordChild1, // #1 = $src2
/*59018*/     OPC_CheckPredicate, 2, // Predicate_unindexedload
/*59020*/     OPC_CheckPredicate, 8, // Predicate_load
/*59022*/     OPC_CheckPredicate, 23, // Predicate_memop
/*59024*/     OPC_MoveParent,
/*59025*/     OPC_RecordChild1, // #2 = $src1
/*59026*/     OPC_CheckType, MVT::v4i32,
/*59028*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*59031*/     OPC_EmitMergeInputChains, 1, 0, 
/*59034*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::PCMPEQDrm), 0|OPFL_Chain|OPFL_MemRefs,
                  1/*#VTs*/, MVT::v4i32, 6/*#Ops*/, 2, 3, 4, 5, 6, 7, 
              // Src: (X86pcmpeqd:v4i32 (ld:v4i32 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>, VR128:v4i32:$src1)
              // Dst: (PCMPEQDrm:v4i32 VR128:v16i8:$src1, addr:iPTR:$src2)
/*59047*/   /*Scope*/ 26, /*->59074*/
/*59048*/     OPC_RecordChild0, // #0 = $src1
/*59049*/     OPC_RecordChild1, // #1 = $src2
/*59050*/     OPC_SwitchType /*2 cases */, 9,  MVT::v4i32,// ->59062
/*59053*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PCMPEQDrr), 0,
                    1/*#VTs*/, MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (X86pcmpeqd:v4i32 VR128:v4i32:$src1, VR128:v4i32:$src2)
                // Dst: (PCMPEQDrr:v4i32 VR128:v16i8:$src1, VR128:v16i8:$src2)
              /*SwitchType*/ 9,  MVT::v2i32,// ->59073
/*59064*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PCMPEQDrr), 0,
                    1/*#VTs*/, MVT::v2i32, 2/*#Ops*/, 0, 1, 
                // Src: (X86pcmpeqd:v2i32 VR64:v2i32:$src1, VR64:v2i32:$src2)
                // Dst: (MMX_PCMPEQDrr:v2i32 VR64:v8i8:$src1, VR64:v8i8:$src2)
              0, // EndSwitchType
/*59074*/   0, /*End of Scope*/
          /*SwitchOpcode*/ 107,  X86ISD::PCMPGTB,// ->59184
/*59077*/   OPC_RecordChild0, // #0 = $src1
/*59078*/   OPC_Scope, 77, /*->59157*/ // 2 children in Scope
/*59080*/     OPC_MoveChild, 1,
/*59082*/     OPC_SwitchOpcode /*2 cases */, 37,  ISD::BIT_CONVERT,// ->59122
/*59085*/       OPC_MoveChild, 0,
/*59087*/       OPC_CheckOpcode, ISD::LOAD,
/*59089*/       OPC_RecordMemRef,
/*59090*/       OPC_RecordNode, // #1 = 'ld' chained node
/*59091*/       OPC_CheckFoldableChainNode,
/*59092*/       OPC_RecordChild1, // #2 = $src2
/*59093*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*59095*/       OPC_CheckPredicate, 8, // Predicate_load
/*59097*/       OPC_CheckType, MVT::v1i64,
/*59099*/       OPC_MoveParent,
/*59100*/       OPC_MoveParent,
/*59101*/       OPC_CheckType, MVT::v8i8,
/*59103*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*59106*/       OPC_EmitMergeInputChains, 1, 1, 
/*59109*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PCMPGTBrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v8i8, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (X86pcmpgtb:v8i8 VR64:v8i8:$src1, (bitconvert:v8i8 (ld:v1i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>))
                // Dst: (MMX_PCMPGTBrm:v8i8 VR64:v8i8:$src1, addr:iPTR:$src2)
              /*SwitchOpcode*/ 32,  ISD::LOAD,// ->59156
/*59124*/       OPC_RecordMemRef,
/*59125*/       OPC_RecordNode, // #1 = 'ld' chained node
/*59126*/       OPC_CheckFoldableChainNode,
/*59127*/       OPC_RecordChild1, // #2 = $src2
/*59128*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*59130*/       OPC_CheckPredicate, 8, // Predicate_load
/*59132*/       OPC_CheckPredicate, 23, // Predicate_memop
/*59134*/       OPC_MoveParent,
/*59135*/       OPC_CheckType, MVT::v16i8,
/*59137*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*59140*/       OPC_EmitMergeInputChains, 1, 1, 
/*59143*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PCMPGTBrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v16i8, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (X86pcmpgtb:v16i8 VR128:v16i8:$src1, (ld:v16i8 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>)
                // Dst: (PCMPGTBrm:v16i8 VR128:v16i8:$src1, addr:iPTR:$src2)
              0, // EndSwitchOpcode
/*59157*/   /*Scope*/ 25, /*->59183*/
/*59158*/     OPC_RecordChild1, // #1 = $src2
/*59159*/     OPC_SwitchType /*2 cases */, 9,  MVT::v16i8,// ->59171
/*59162*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PCMPGTBrr), 0,
                    1/*#VTs*/, MVT::v16i8, 2/*#Ops*/, 0, 1, 
                // Src: (X86pcmpgtb:v16i8 VR128:v16i8:$src1, VR128:v16i8:$src2)
                // Dst: (PCMPGTBrr:v16i8 VR128:v16i8:$src1, VR128:v16i8:$src2)
              /*SwitchType*/ 9,  MVT::v8i8,// ->59182
/*59173*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PCMPGTBrr), 0,
                    1/*#VTs*/, MVT::v8i8, 2/*#Ops*/, 0, 1, 
                // Src: (X86pcmpgtb:v8i8 VR64:v8i8:$src1, VR64:v8i8:$src2)
                // Dst: (MMX_PCMPGTBrr:v8i8 VR64:v8i8:$src1, VR64:v8i8:$src2)
              0, // EndSwitchType
/*59183*/   0, /*End of Scope*/
          /*SwitchOpcode*/ 107,  X86ISD::PCMPGTW,// ->59293
/*59186*/   OPC_RecordChild0, // #0 = $src1
/*59187*/   OPC_Scope, 77, /*->59266*/ // 2 children in Scope
/*59189*/     OPC_MoveChild, 1,
/*59191*/     OPC_SwitchOpcode /*2 cases */, 37,  ISD::BIT_CONVERT,// ->59231
/*59194*/       OPC_MoveChild, 0,
/*59196*/       OPC_CheckOpcode, ISD::LOAD,
/*59198*/       OPC_RecordMemRef,
/*59199*/       OPC_RecordNode, // #1 = 'ld' chained node
/*59200*/       OPC_CheckFoldableChainNode,
/*59201*/       OPC_RecordChild1, // #2 = $src2
/*59202*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*59204*/       OPC_CheckPredicate, 8, // Predicate_load
/*59206*/       OPC_CheckType, MVT::v1i64,
/*59208*/       OPC_MoveParent,
/*59209*/       OPC_MoveParent,
/*59210*/       OPC_CheckType, MVT::v4i16,
/*59212*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*59215*/       OPC_EmitMergeInputChains, 1, 1, 
/*59218*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PCMPGTWrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v4i16, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (X86pcmpgtw:v4i16 VR64:v4i16:$src1, (bitconvert:v4i16 (ld:v1i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>))
                // Dst: (MMX_PCMPGTWrm:v4i16 VR64:v8i8:$src1, addr:iPTR:$src2)
              /*SwitchOpcode*/ 32,  ISD::LOAD,// ->59265
/*59233*/       OPC_RecordMemRef,
/*59234*/       OPC_RecordNode, // #1 = 'ld' chained node
/*59235*/       OPC_CheckFoldableChainNode,
/*59236*/       OPC_RecordChild1, // #2 = $src2
/*59237*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*59239*/       OPC_CheckPredicate, 8, // Predicate_load
/*59241*/       OPC_CheckPredicate, 23, // Predicate_memop
/*59243*/       OPC_MoveParent,
/*59244*/       OPC_CheckType, MVT::v8i16,
/*59246*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*59249*/       OPC_EmitMergeInputChains, 1, 1, 
/*59252*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PCMPGTWrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v8i16, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (X86pcmpgtw:v8i16 VR128:v8i16:$src1, (ld:v8i16 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>)
                // Dst: (PCMPGTWrm:v8i16 VR128:v16i8:$src1, addr:iPTR:$src2)
              0, // EndSwitchOpcode
/*59266*/   /*Scope*/ 25, /*->59292*/
/*59267*/     OPC_RecordChild1, // #1 = $src2
/*59268*/     OPC_SwitchType /*2 cases */, 9,  MVT::v8i16,// ->59280
/*59271*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PCMPGTWrr), 0,
                    1/*#VTs*/, MVT::v8i16, 2/*#Ops*/, 0, 1, 
                // Src: (X86pcmpgtw:v8i16 VR128:v8i16:$src1, VR128:v8i16:$src2)
                // Dst: (PCMPGTWrr:v8i16 VR128:v16i8:$src1, VR128:v16i8:$src2)
              /*SwitchType*/ 9,  MVT::v4i16,// ->59291
/*59282*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PCMPGTWrr), 0,
                    1/*#VTs*/, MVT::v4i16, 2/*#Ops*/, 0, 1, 
                // Src: (X86pcmpgtw:v4i16 VR64:v4i16:$src1, VR64:v4i16:$src2)
                // Dst: (MMX_PCMPGTWrr:v4i16 VR64:v8i8:$src1, VR64:v8i8:$src2)
              0, // EndSwitchType
/*59292*/   0, /*End of Scope*/
          /*SwitchOpcode*/ 107,  X86ISD::PCMPGTD,// ->59402
/*59295*/   OPC_RecordChild0, // #0 = $src1
/*59296*/   OPC_Scope, 77, /*->59375*/ // 2 children in Scope
/*59298*/     OPC_MoveChild, 1,
/*59300*/     OPC_SwitchOpcode /*2 cases */, 37,  ISD::BIT_CONVERT,// ->59340
/*59303*/       OPC_MoveChild, 0,
/*59305*/       OPC_CheckOpcode, ISD::LOAD,
/*59307*/       OPC_RecordMemRef,
/*59308*/       OPC_RecordNode, // #1 = 'ld' chained node
/*59309*/       OPC_CheckFoldableChainNode,
/*59310*/       OPC_RecordChild1, // #2 = $src2
/*59311*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*59313*/       OPC_CheckPredicate, 8, // Predicate_load
/*59315*/       OPC_CheckType, MVT::v1i64,
/*59317*/       OPC_MoveParent,
/*59318*/       OPC_MoveParent,
/*59319*/       OPC_CheckType, MVT::v2i32,
/*59321*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*59324*/       OPC_EmitMergeInputChains, 1, 1, 
/*59327*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PCMPGTDrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v2i32, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (X86pcmpgtd:v2i32 VR64:v2i32:$src1, (bitconvert:v2i32 (ld:v1i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>))
                // Dst: (MMX_PCMPGTDrm:v2i32 VR64:v8i8:$src1, addr:iPTR:$src2)
              /*SwitchOpcode*/ 32,  ISD::LOAD,// ->59374
/*59342*/       OPC_RecordMemRef,
/*59343*/       OPC_RecordNode, // #1 = 'ld' chained node
/*59344*/       OPC_CheckFoldableChainNode,
/*59345*/       OPC_RecordChild1, // #2 = $src2
/*59346*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*59348*/       OPC_CheckPredicate, 8, // Predicate_load
/*59350*/       OPC_CheckPredicate, 23, // Predicate_memop
/*59352*/       OPC_MoveParent,
/*59353*/       OPC_CheckType, MVT::v4i32,
/*59355*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*59358*/       OPC_EmitMergeInputChains, 1, 1, 
/*59361*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PCMPGTDrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v4i32, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (X86pcmpgtd:v4i32 VR128:v4i32:$src1, (ld:v4i32 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>)
                // Dst: (PCMPGTDrm:v4i32 VR128:v16i8:$src1, addr:iPTR:$src2)
              0, // EndSwitchOpcode
/*59375*/   /*Scope*/ 25, /*->59401*/
/*59376*/     OPC_RecordChild1, // #1 = $src2
/*59377*/     OPC_SwitchType /*2 cases */, 9,  MVT::v4i32,// ->59389
/*59380*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::PCMPGTDrr), 0,
                    1/*#VTs*/, MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (X86pcmpgtd:v4i32 VR128:v4i32:$src1, VR128:v4i32:$src2)
                // Dst: (PCMPGTDrr:v4i32 VR128:v16i8:$src1, VR128:v16i8:$src2)
              /*SwitchType*/ 9,  MVT::v2i32,// ->59400
/*59391*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PCMPGTDrr), 0,
                    1/*#VTs*/, MVT::v2i32, 2/*#Ops*/, 0, 1, 
                // Src: (X86pcmpgtd:v2i32 VR64:v2i32:$src1, VR64:v2i32:$src2)
                // Dst: (MMX_PCMPGTDrr:v2i32 VR64:v8i8:$src1, VR64:v8i8:$src2)
              0, // EndSwitchType
/*59401*/   0, /*End of Scope*/
          /*SwitchOpcode*/ 110,  X86ISD::LCMPXCHG_DAG,// ->59514
/*59404*/   OPC_RecordNode,   // #0 = 'X86cas' chained node
/*59405*/   OPC_CaptureFlagInput,
/*59406*/   OPC_RecordChild1, // #1 = $ptr
/*59407*/   OPC_RecordChild2, // #2 = $swap
/*59408*/   OPC_Scope, 25, /*->59435*/ // 4 children in Scope
/*59410*/     OPC_CheckChild2Type, MVT::i32,
/*59412*/     OPC_MoveChild, 3,
/*59414*/     OPC_CheckInteger, 4, 
/*59416*/     OPC_MoveParent,
/*59417*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$ptr #3 #4 #5 #6 #7
/*59420*/     OPC_EmitMergeInputChains, 1, 0, 
/*59423*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::LCMPXCHG32), 0|OPFL_Chain|OPFL_FlagInput|OPFL_FlagOutput,
                  0/*#VTs*/, 6/*#Ops*/, 3, 4, 5, 6, 7, 2, 
              // Src: (X86cas:isVoid addr:iPTR:$ptr, GR32:i32:$swap, 4:i8)
              // Dst: (LCMPXCHG32:isVoid addr:iPTR:$ptr, GR32:i32:$swap)
/*59435*/   /*Scope*/ 25, /*->59461*/
/*59436*/     OPC_CheckChild2Type, MVT::i16,
/*59438*/     OPC_MoveChild, 3,
/*59440*/     OPC_CheckInteger, 2, 
/*59442*/     OPC_MoveParent,
/*59443*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$ptr #3 #4 #5 #6 #7
/*59446*/     OPC_EmitMergeInputChains, 1, 0, 
/*59449*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::LCMPXCHG16), 0|OPFL_Chain|OPFL_FlagInput|OPFL_FlagOutput,
                  0/*#VTs*/, 6/*#Ops*/, 3, 4, 5, 6, 7, 2, 
              // Src: (X86cas:isVoid addr:iPTR:$ptr, GR16:i16:$swap, 2:i8)
              // Dst: (LCMPXCHG16:isVoid addr:iPTR:$ptr, GR16:i16:$swap)
/*59461*/   /*Scope*/ 25, /*->59487*/
/*59462*/     OPC_CheckChild2Type, MVT::i8,
/*59464*/     OPC_MoveChild, 3,
/*59466*/     OPC_CheckInteger, 1, 
/*59468*/     OPC_MoveParent,
/*59469*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$ptr #3 #4 #5 #6 #7
/*59472*/     OPC_EmitMergeInputChains, 1, 0, 
/*59475*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::LCMPXCHG8), 0|OPFL_Chain|OPFL_FlagInput|OPFL_FlagOutput,
                  0/*#VTs*/, 6/*#Ops*/, 3, 4, 5, 6, 7, 2, 
              // Src: (X86cas:isVoid addr:iPTR:$ptr, GR8:i8:$swap, 1:i8)
              // Dst: (LCMPXCHG8:isVoid addr:iPTR:$ptr, GR8:i8:$swap)
/*59487*/   /*Scope*/ 25, /*->59513*/
/*59488*/     OPC_CheckChild2Type, MVT::i64,
/*59490*/     OPC_MoveChild, 3,
/*59492*/     OPC_CheckInteger, 8, 
/*59494*/     OPC_MoveParent,
/*59495*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$ptr #3 #4 #5 #6 #7
/*59498*/     OPC_EmitMergeInputChains, 1, 0, 
/*59501*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::LCMPXCHG64), 0|OPFL_Chain|OPFL_FlagInput|OPFL_FlagOutput,
                  0/*#VTs*/, 6/*#Ops*/, 3, 4, 5, 6, 7, 2, 
              // Src: (X86cas:isVoid addr:iPTR:$ptr, GR64:i64:$swap, 8:i8)
              // Dst: (LCMPXCHG64:isVoid addr:iPTR:$ptr, GR64:i64:$swap)
/*59513*/   0, /*End of Scope*/
          /*SwitchOpcode*/ 7|128,1/*135*/,  ISD::INTRINSIC_W_CHAIN,// ->59652
/*59517*/   OPC_RecordNode,   // #0 = 'intrinsic_w_chain' chained node
/*59518*/   OPC_MoveChild, 1,
/*59520*/   OPC_Scope, 25, /*->59547*/ // 5 children in Scope
/*59522*/     OPC_CheckInteger, 59|128,5/*699*/, 
/*59525*/     OPC_MoveParent,
/*59526*/     OPC_RecordChild2, // #1 = $src
/*59527*/     OPC_CheckPatternPredicate, 0, // (Subtarget->hasSSE1())
/*59529*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*59532*/     OPC_EmitMergeInputChains, 1, 0, 
/*59535*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVUPSrm_Int), 0|OPFL_Chain,
                  1/*#VTs*/, MVT::v4f32, 5/*#Ops*/, 2, 3, 4, 5, 6, 
              // Src: (intrinsic_w_chain:v4f32 699:iPTR, addr:iPTR:$src)
              // Dst: (MOVUPSrm_Int:v4f32 addr:iPTR:$src)
/*59547*/   /*Scope*/ 25, /*->59573*/
/*59548*/     OPC_CheckInteger, 16|128,4/*528*/, 
/*59551*/     OPC_MoveParent,
/*59552*/     OPC_RecordChild2, // #1 = $src
/*59553*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*59555*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*59558*/     OPC_EmitMergeInputChains, 1, 0, 
/*59561*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVUPDrm_Int), 0|OPFL_Chain,
                  1/*#VTs*/, MVT::v2f64, 5/*#Ops*/, 2, 3, 4, 5, 6, 
              // Src: (intrinsic_w_chain:v2f64 528:iPTR, addr:iPTR:$src)
              // Dst: (MOVUPDrm_Int:v2f64 addr:iPTR:$src)
/*59573*/   /*Scope*/ 25, /*->59599*/
/*59574*/     OPC_CheckInteger, 15|128,4/*527*/, 
/*59577*/     OPC_MoveParent,
/*59578*/     OPC_RecordChild2, // #1 = $src
/*59579*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*59581*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*59584*/     OPC_EmitMergeInputChains, 1, 0, 
/*59587*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVDQUrm_Int), 0|OPFL_Chain,
                  1/*#VTs*/, MVT::v16i8, 5/*#Ops*/, 2, 3, 4, 5, 6, 
              // Src: (intrinsic_w_chain:v16i8 527:iPTR, addr:iPTR:$src)
              // Dst: (MOVDQUrm_Int:v16i8 addr:iPTR:$src)
/*59599*/   /*Scope*/ 25, /*->59625*/
/*59600*/     OPC_CheckInteger, 95|128,4/*607*/, 
/*59603*/     OPC_MoveParent,
/*59604*/     OPC_RecordChild2, // #1 = $src
/*59605*/     OPC_CheckPatternPredicate, 9, // (Subtarget->hasSSE3())
/*59607*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*59610*/     OPC_EmitMergeInputChains, 1, 0, 
/*59613*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::LDDQUrm), 0|OPFL_Chain,
                  1/*#VTs*/, MVT::v16i8, 5/*#Ops*/, 2, 3, 4, 5, 6, 
              // Src: (intrinsic_w_chain:v16i8 607:iPTR, addr:iPTR:$src)
              // Dst: (LDDQUrm:v16i8 addr:iPTR:$src)
/*59625*/   /*Scope*/ 25, /*->59651*/
/*59626*/     OPC_CheckInteger, 106|128,4/*618*/, 
/*59629*/     OPC_MoveParent,
/*59630*/     OPC_RecordChild2, // #1 = $src
/*59631*/     OPC_CheckPatternPredicate, 4, // (Subtarget->hasSSE41())
/*59633*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*59636*/     OPC_EmitMergeInputChains, 1, 0, 
/*59639*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVNTDQArm), 0|OPFL_Chain,
                  1/*#VTs*/, MVT::v2i64, 5/*#Ops*/, 2, 3, 4, 5, 6, 
              // Src: (intrinsic_w_chain:v2i64 618:iPTR, addr:iPTR:$src)
              // Dst: (MOVNTDQArm:v2i64 addr:iPTR:$src)
/*59651*/   0, /*End of Scope*/
          /*SwitchOpcode*/ 41|128,4/*553*/,  ISD::INTRINSIC_VOID,// ->60208
/*59655*/   OPC_RecordNode,   // #0 = 'intrinsic_void' chained node
/*59656*/   OPC_MoveChild, 1,
/*59658*/   OPC_Scope, 26, /*->59686*/ // 21 children in Scope
/*59660*/     OPC_CheckInteger, 75|128,5/*715*/, 
/*59663*/     OPC_MoveParent,
/*59664*/     OPC_RecordChild2, // #1 = $dst
/*59665*/     OPC_RecordChild3, // #2 = $src
/*59666*/     OPC_CheckPatternPredicate, 0, // (Subtarget->hasSSE1())
/*59668*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$dst #3 #4 #5 #6 #7
/*59671*/     OPC_EmitMergeInputChains, 1, 0, 
/*59674*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVUPSmr_Int), 0|OPFL_Chain,
                  0/*#VTs*/, 6/*#Ops*/, 3, 4, 5, 6, 7, 2, 
              // Src: (intrinsic_void:isVoid 715:iPTR, addr:iPTR:$dst, VR128:v4f32:$src)
              // Dst: (MOVUPSmr_Int:isVoid addr:iPTR:$dst, VR128:v4f32:$src)
/*59686*/   /*Scope*/ 26, /*->59713*/
/*59687*/     OPC_CheckInteger, 65|128,5/*705*/, 
/*59690*/     OPC_MoveParent,
/*59691*/     OPC_RecordChild2, // #1 = $dst
/*59692*/     OPC_RecordChild3, // #2 = $src
/*59693*/     OPC_CheckPatternPredicate, 0, // (Subtarget->hasSSE1())
/*59695*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$dst #3 #4 #5 #6 #7
/*59698*/     OPC_EmitMergeInputChains, 1, 0, 
/*59701*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVNTPSmr_Int), 0|OPFL_Chain,
                  0/*#VTs*/, 6/*#Ops*/, 3, 4, 5, 6, 7, 2, 
              // Src: (intrinsic_void:isVoid 705:iPTR, addr:iPTR:$dst, VR128:v4f32:$src)
              // Dst: (MOVNTPSmr_Int:isVoid addr:iPTR:$dst, VR128:v4f32:$src)
/*59713*/   /*Scope*/ 24, /*->59738*/
/*59714*/     OPC_CheckInteger, 58|128,5/*698*/, 
/*59717*/     OPC_MoveParent,
/*59718*/     OPC_RecordChild2, // #1 = $src
/*59719*/     OPC_CheckPatternPredicate, 0, // (Subtarget->hasSSE1())
/*59721*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*59724*/     OPC_EmitMergeInputChains, 1, 0, 
/*59727*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::LDMXCSR), 0|OPFL_Chain,
                  0/*#VTs*/, 5/*#Ops*/, 2, 3, 4, 5, 6, 
              // Src: (intrinsic_void:isVoid 698:iPTR, addr:iPTR:$src)
              // Dst: (LDMXCSR:isVoid addr:iPTR:$src)
/*59738*/   /*Scope*/ 24, /*->59763*/
/*59739*/     OPC_CheckInteger, 74|128,5/*714*/, 
/*59742*/     OPC_MoveParent,
/*59743*/     OPC_RecordChild2, // #1 = $dst
/*59744*/     OPC_CheckPatternPredicate, 0, // (Subtarget->hasSSE1())
/*59746*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$dst #2 #3 #4 #5 #6
/*59749*/     OPC_EmitMergeInputChains, 1, 0, 
/*59752*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::STMXCSR), 0|OPFL_Chain,
                  0/*#VTs*/, 5/*#Ops*/, 2, 3, 4, 5, 6, 
              // Src: (intrinsic_void:isVoid 714:iPTR, addr:iPTR:$dst)
              // Dst: (STMXCSR:isVoid addr:iPTR:$dst)
/*59763*/   /*Scope*/ 26, /*->59790*/
/*59764*/     OPC_CheckInteger, 81|128,4/*593*/, 
/*59767*/     OPC_MoveParent,
/*59768*/     OPC_RecordChild2, // #1 = $dst
/*59769*/     OPC_RecordChild3, // #2 = $src
/*59770*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*59772*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$dst #3 #4 #5 #6 #7
/*59775*/     OPC_EmitMergeInputChains, 1, 0, 
/*59778*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVUPDmr_Int), 0|OPFL_Chain,
                  0/*#VTs*/, 6/*#Ops*/, 3, 4, 5, 6, 7, 2, 
              // Src: (intrinsic_void:isVoid 593:iPTR, addr:iPTR:$dst, VR128:v2f64:$src)
              // Dst: (MOVUPDmr_Int:isVoid addr:iPTR:$dst, VR128:v2f64:$src)
/*59790*/   /*Scope*/ 26, /*->59817*/
/*59791*/     OPC_CheckInteger, 80|128,4/*592*/, 
/*59794*/     OPC_MoveParent,
/*59795*/     OPC_RecordChild2, // #1 = $dst
/*59796*/     OPC_RecordChild3, // #2 = $src
/*59797*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*59799*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$dst #3 #4 #5 #6 #7
/*59802*/     OPC_EmitMergeInputChains, 1, 0, 
/*59805*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVDQUmr_Int), 0|OPFL_Chain,
                  0/*#VTs*/, 6/*#Ops*/, 3, 4, 5, 6, 7, 2, 
              // Src: (intrinsic_void:isVoid 592:iPTR, addr:iPTR:$dst, VR128:v16i8:$src)
              // Dst: (MOVDQUmr_Int:isVoid addr:iPTR:$dst, VR128:v16i8:$src)
/*59817*/   /*Scope*/ 26, /*->59844*/
/*59818*/     OPC_CheckInteger, 26|128,4/*538*/, 
/*59821*/     OPC_MoveParent,
/*59822*/     OPC_RecordChild2, // #1 = $dst
/*59823*/     OPC_RecordChild3, // #2 = $src
/*59824*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*59826*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$dst #3 #4 #5 #6 #7
/*59829*/     OPC_EmitMergeInputChains, 1, 0, 
/*59832*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVNTPDmr_Int), 0|OPFL_Chain,
                  0/*#VTs*/, 6/*#Ops*/, 3, 4, 5, 6, 7, 2, 
              // Src: (intrinsic_void:isVoid 538:iPTR, addr:iPTR:$dst, VR128:v2f64:$src)
              // Dst: (MOVNTPDmr_Int:isVoid addr:iPTR:$dst, VR128:v2f64:$src)
/*59844*/   /*Scope*/ 26, /*->59871*/
/*59845*/     OPC_CheckInteger, 24|128,4/*536*/, 
/*59848*/     OPC_MoveParent,
/*59849*/     OPC_RecordChild2, // #1 = $dst
/*59850*/     OPC_RecordChild3, // #2 = $src
/*59851*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*59853*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$dst #3 #4 #5 #6 #7
/*59856*/     OPC_EmitMergeInputChains, 1, 0, 
/*59859*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVNTDQmr_Int), 0|OPFL_Chain,
                  0/*#VTs*/, 6/*#Ops*/, 3, 4, 5, 6, 7, 2, 
              // Src: (intrinsic_void:isVoid 536:iPTR, addr:iPTR:$dst, VR128:v2i64:$src)
              // Dst: (MOVNTDQmr_Int:isVoid addr:iPTR:$dst, VR128:v2i64:$src)
/*59871*/   /*Scope*/ 26, /*->59898*/
/*59872*/     OPC_CheckInteger, 25|128,4/*537*/, 
/*59875*/     OPC_MoveParent,
/*59876*/     OPC_RecordChild2, // #1 = $dst
/*59877*/     OPC_RecordChild3, // #2 = $src
/*59878*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*59880*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$dst #3 #4 #5 #6 #7
/*59883*/     OPC_EmitMergeInputChains, 1, 0, 
/*59886*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVNTImr_Int), 0|OPFL_Chain,
                  0/*#VTs*/, 6/*#Ops*/, 3, 4, 5, 6, 7, 2, 
              // Src: (intrinsic_void:isVoid 537:iPTR, addr:iPTR:$dst, GR32:i32:$src)
              // Dst: (MOVNTImr_Int:isVoid addr:iPTR:$dst, GR32:i32:$src)
/*59898*/   /*Scope*/ 24, /*->59923*/
/*59899*/     OPC_CheckInteger, 116|128,3/*500*/, 
/*59902*/     OPC_MoveParent,
/*59903*/     OPC_RecordChild2, // #1 = $src
/*59904*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*59906*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*59909*/     OPC_EmitMergeInputChains, 1, 0, 
/*59912*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::CLFLUSH), 0|OPFL_Chain,
                  0/*#VTs*/, 5/*#Ops*/, 2, 3, 4, 5, 6, 
              // Src: (intrinsic_void:isVoid 500:iPTR, addr:iPTR:$src)
              // Dst: (CLFLUSH:isVoid addr:iPTR:$src)
/*59923*/   /*Scope*/ 26, /*->59950*/
/*59924*/     OPC_CheckInteger, 79|128,4/*591*/, 
/*59927*/     OPC_MoveParent,
/*59928*/     OPC_RecordChild2, // #1 = $dst
/*59929*/     OPC_RecordChild3, // #2 = $src
/*59930*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*59932*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$dst #3 #4 #5 #6 #7
/*59935*/     OPC_EmitMergeInputChains, 1, 0, 
/*59938*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVLQ128mr), 0|OPFL_Chain,
                  0/*#VTs*/, 6/*#Ops*/, 3, 4, 5, 6, 7, 2, 
              // Src: (intrinsic_void:isVoid 591:iPTR, addr:iPTR:$dst, VR128:v4i32:$src)
              // Dst: (MOVLQ128mr:isVoid addr:iPTR:$dst, VR128:v4i32:$src)
/*59950*/   /*Scope*/ 26, /*->59977*/
/*59951*/     OPC_CheckInteger, 69|128,3/*453*/, 
/*59954*/     OPC_MoveParent,
/*59955*/     OPC_RecordChild2, // #1 = $dst
/*59956*/     OPC_RecordChild3, // #2 = $src
/*59957*/     OPC_CheckPatternPredicate, 8, // (Subtarget->hasMMX())
/*59959*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$dst #3 #4 #5 #6 #7
/*59962*/     OPC_EmitMergeInputChains, 1, 0, 
/*59965*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_MOVNTQmr), 0|OPFL_Chain,
                  0/*#VTs*/, 6/*#Ops*/, 3, 4, 5, 6, 7, 2, 
              // Src: (intrinsic_void:isVoid 453:iPTR, addr:iPTR:$dst, VR64:v1i64:$src)
              // Dst: (MMX_MOVNTQmr:isVoid addr:iPTR:$dst, VR64:v1i64:$src)
/*59977*/   /*Scope*/ 15, /*->59993*/
/*59978*/     OPC_CheckInteger, 71|128,5/*711*/, 
/*59981*/     OPC_MoveParent,
/*59982*/     OPC_CheckPatternPredicate, 0, // (Subtarget->hasSSE1())
/*59984*/     OPC_EmitMergeInputChains, 1, 0, 
/*59987*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::SFENCE), 0|OPFL_Chain,
                  0/*#VTs*/, 0/*#Ops*/, 
              // Src: (intrinsic_void:isVoid 711:iPTR)
              // Dst: (SFENCE:isVoid)
/*59993*/   /*Scope*/ 47, /*->60041*/
/*59994*/     OPC_CheckInteger, 17|128,4/*529*/, 
/*59997*/     OPC_MoveParent,
/*59998*/     OPC_RecordChild2, // #1 = $src
/*59999*/     OPC_RecordChild3, // #2 = $mask
/*60000*/     OPC_RecordChild4, // #3 = physreg input EDI
/*60001*/     OPC_Scope, 18, /*->60021*/ // 2 children in Scope
/*60003*/       OPC_CheckChild4Type, MVT::i32,
/*60005*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*60007*/       OPC_EmitMergeInputChains, 1, 0, 
/*60010*/       OPC_EmitCopyToReg, 3, X86::EDI,
/*60013*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MASKMOVDQU), 0|OPFL_Chain|OPFL_FlagInput,
                    0/*#VTs*/, 2/*#Ops*/, 1, 2, 
                // Src: (intrinsic_void:isVoid 529:iPTR, VR128:v16i8:$src, VR128:v16i8:$mask, EDI:i32)
                // Dst: (MASKMOVDQU:isVoid VR128:v16i8:$src, VR128:v16i8:$mask)
/*60021*/     /*Scope*/ 18, /*->60040*/
/*60022*/       OPC_CheckChild4Type, MVT::i64,
/*60024*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*60026*/       OPC_EmitMergeInputChains, 1, 0, 
/*60029*/       OPC_EmitCopyToReg, 3, X86::RDI,
/*60032*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MASKMOVDQU64), 0|OPFL_Chain|OPFL_FlagInput,
                    0/*#VTs*/, 2/*#Ops*/, 1, 2, 
                // Src: (intrinsic_void:isVoid 529:iPTR, VR128:v16i8:$src, VR128:v16i8:$mask, RDI:i64)
                // Dst: (MASKMOVDQU64:isVoid VR128:v16i8:$src, VR128:v16i8:$mask)
/*60040*/     0, /*End of Scope*/
/*60041*/   /*Scope*/ 15, /*->60057*/
/*60042*/     OPC_CheckInteger, 14|128,4/*526*/, 
/*60045*/     OPC_MoveParent,
/*60046*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*60048*/     OPC_EmitMergeInputChains, 1, 0, 
/*60051*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::LFENCE), 0|OPFL_Chain,
                  0/*#VTs*/, 0/*#Ops*/, 
              // Src: (intrinsic_void:isVoid 526:iPTR)
              // Dst: (LFENCE:isVoid)
/*60057*/   /*Scope*/ 15, /*->60073*/
/*60058*/     OPC_CheckInteger, 20|128,4/*532*/, 
/*60061*/     OPC_MoveParent,
/*60062*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*60064*/     OPC_EmitMergeInputChains, 1, 0, 
/*60067*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::MFENCE), 0|OPFL_Chain,
                  0/*#VTs*/, 0/*#Ops*/, 
              // Src: (intrinsic_void:isVoid 532:iPTR)
              // Dst: (MFENCE:isVoid)
/*60073*/   /*Scope*/ 29, /*->60103*/
/*60074*/     OPC_CheckInteger, 96|128,4/*608*/, 
/*60077*/     OPC_MoveParent,
/*60078*/     OPC_RecordChild2, // #1 = physreg input EAX
/*60079*/     OPC_CheckChild2Type, MVT::i32,
/*60081*/     OPC_RecordChild3, // #2 = physreg input ECX
/*60082*/     OPC_RecordChild4, // #3 = physreg input EDX
/*60083*/     OPC_CheckPatternPredicate, 9, // (Subtarget->hasSSE3())
/*60085*/     OPC_EmitMergeInputChains, 1, 0, 
/*60088*/     OPC_EmitCopyToReg, 1, X86::EAX,
/*60091*/     OPC_EmitCopyToReg, 2, X86::ECX,
/*60094*/     OPC_EmitCopyToReg, 3, X86::EDX,
/*60097*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::MONITOR), 0|OPFL_Chain|OPFL_FlagInput,
                  0/*#VTs*/, 0/*#Ops*/, 
              // Src: (intrinsic_void:isVoid 608:iPTR, EAX:i32, ECX:i32, EDX:i32)
              // Dst: (MONITOR:isVoid)
/*60103*/   /*Scope*/ 23, /*->60127*/
/*60104*/     OPC_CheckInteger, 97|128,4/*609*/, 
/*60107*/     OPC_MoveParent,
/*60108*/     OPC_RecordChild2, // #1 = physreg input ECX
/*60109*/     OPC_RecordChild3, // #2 = physreg input EAX
/*60110*/     OPC_CheckPatternPredicate, 9, // (Subtarget->hasSSE3())
/*60112*/     OPC_EmitMergeInputChains, 1, 0, 
/*60115*/     OPC_EmitCopyToReg, 1, X86::ECX,
/*60118*/     OPC_EmitCopyToReg, 2, X86::EAX,
/*60121*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::MWAIT), 0|OPFL_Chain|OPFL_FlagInput,
                  0/*#VTs*/, 0/*#Ops*/, 
              // Src: (intrinsic_void:isVoid 609:iPTR, ECX:i32, EAX:i32)
              // Dst: (MWAIT:isVoid)
/*60127*/   /*Scope*/ 15, /*->60143*/
/*60128*/     OPC_CheckInteger, 66|128,3/*450*/, 
/*60131*/     OPC_MoveParent,
/*60132*/     OPC_CheckPatternPredicate, 8, // (Subtarget->hasMMX())
/*60134*/     OPC_EmitMergeInputChains, 1, 0, 
/*60137*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_EMMS), 0|OPFL_Chain,
                  0/*#VTs*/, 0/*#Ops*/, 
              // Src: (intrinsic_void:isVoid 450:iPTR)
              // Dst: (MMX_EMMS:isVoid)
/*60143*/   /*Scope*/ 15, /*->60159*/
/*60144*/     OPC_CheckInteger, 67|128,3/*451*/, 
/*60147*/     OPC_MoveParent,
/*60148*/     OPC_CheckPatternPredicate, 8, // (Subtarget->hasMMX())
/*60150*/     OPC_EmitMergeInputChains, 1, 0, 
/*60153*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_FEMMS), 0|OPFL_Chain,
                  0/*#VTs*/, 0/*#Ops*/, 
              // Src: (intrinsic_void:isVoid 451:iPTR)
              // Dst: (MMX_FEMMS:isVoid)
/*60159*/   /*Scope*/ 47, /*->60207*/
/*60160*/     OPC_CheckInteger, 68|128,3/*452*/, 
/*60163*/     OPC_MoveParent,
/*60164*/     OPC_RecordChild2, // #1 = $src
/*60165*/     OPC_RecordChild3, // #2 = $mask
/*60166*/     OPC_RecordChild4, // #3 = physreg input EDI
/*60167*/     OPC_Scope, 18, /*->60187*/ // 2 children in Scope
/*60169*/       OPC_CheckChild4Type, MVT::i32,
/*60171*/       OPC_CheckPatternPredicate, 8, // (Subtarget->hasMMX())
/*60173*/       OPC_EmitMergeInputChains, 1, 0, 
/*60176*/       OPC_EmitCopyToReg, 3, X86::EDI,
/*60179*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_MASKMOVQ), 0|OPFL_Chain|OPFL_FlagInput,
                    0/*#VTs*/, 2/*#Ops*/, 1, 2, 
                // Src: (intrinsic_void:isVoid 452:iPTR, VR64:v8i8:$src, VR64:v8i8:$mask, EDI:i32)
                // Dst: (MMX_MASKMOVQ:isVoid VR64:v8i8:$src, VR64:v8i8:$mask)
/*60187*/     /*Scope*/ 18, /*->60206*/
/*60188*/       OPC_CheckChild4Type, MVT::i64,
/*60190*/       OPC_CheckPatternPredicate, 15, // (Subtarget->hasMMX()) && (Subtarget->is64Bit())
/*60192*/       OPC_EmitMergeInputChains, 1, 0, 
/*60195*/       OPC_EmitCopyToReg, 3, X86::RDI,
/*60198*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_MASKMOVQ64), 0|OPFL_Chain|OPFL_FlagInput,
                    0/*#VTs*/, 2/*#Ops*/, 1, 2, 
                // Src: (intrinsic_void:isVoid 452:iPTR, VR64:v8i8:$src, VR64:v8i8:$mask, RDI:i64)
                // Dst: (MMX_MASKMOVQ64:isVoid VR64:v8i8:$src, VR64:v8i8:$mask)
/*60206*/     0, /*End of Scope*/
/*60207*/   0, /*End of Scope*/
          /*SwitchOpcode*/ 72|128,7/*968*/,  ISD::FADD,// ->61179
/*60211*/   OPC_Scope, 19|128,1/*147*/, /*->60361*/ // 7 children in Scope
/*60214*/     OPC_RecordChild0, // #0 = $src1
/*60215*/     OPC_MoveChild, 1,
/*60217*/     OPC_CheckOpcode, ISD::LOAD,
/*60219*/     OPC_RecordMemRef,
/*60220*/     OPC_RecordNode, // #1 = 'ld' chained node
/*60221*/     OPC_CheckFoldableChainNode,
/*60222*/     OPC_RecordChild1, // #2 = $src2
/*60223*/     OPC_CheckPredicate, 2, // Predicate_unindexedload
/*60225*/     OPC_Scope, 53, /*->60280*/ // 2 children in Scope
/*60227*/       OPC_CheckPredicate, 8, // Predicate_load
/*60229*/       OPC_CheckPredicate, 9, // Predicate_dsload
/*60231*/       OPC_MoveParent,
/*60232*/       OPC_SwitchType /*2 cases */, 21,  MVT::f32,// ->60256
/*60235*/         OPC_CheckPatternPredicate, 6, // (!Subtarget->hasSSE1())
/*60237*/         OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*60240*/         OPC_EmitMergeInputChains, 1, 1, 
/*60243*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::ADD_Fp32m), 0|OPFL_Chain|OPFL_MemRefs,
                      1/*#VTs*/, MVT::f32, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                  // Src: (fadd:f32 RFP32:f32:$src1, (ld:f32 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>)
                  // Dst: (ADD_Fp32m:f32 RFP32:f32:$src1, addr:iPTR:$src2)
                /*SwitchType*/ 21,  MVT::f64,// ->60279
/*60258*/         OPC_CheckPatternPredicate, 7, // (!Subtarget->hasSSE2())
/*60260*/         OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*60263*/         OPC_EmitMergeInputChains, 1, 1, 
/*60266*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::ADD_Fp64m), 0|OPFL_Chain|OPFL_MemRefs,
                      1/*#VTs*/, MVT::f64, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                  // Src: (fadd:f64 RFP64:f64:$src1, (ld:f64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>)
                  // Dst: (ADD_Fp64m:f64 RFP64:f64:$src1, addr:iPTR:$src2)
                0, // EndSwitchType
/*60280*/     /*Scope*/ 79, /*->60360*/
/*60281*/       OPC_CheckPredicate, 48, // Predicate_extload
/*60283*/       OPC_Scope, 49, /*->60334*/ // 2 children in Scope
/*60285*/         OPC_CheckPredicate, 49, // Predicate_extloadf32
/*60287*/         OPC_MoveParent,
/*60288*/         OPC_SwitchType /*2 cases */, 21,  MVT::f64,// ->60312
/*60291*/           OPC_CheckPatternPredicate, 7, // (!Subtarget->hasSSE2())
/*60293*/           OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*60296*/           OPC_EmitMergeInputChains, 1, 1, 
/*60299*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::ADD_Fp64m32), 0|OPFL_Chain|OPFL_MemRefs,
                        1/*#VTs*/, MVT::f64, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                    // Src: (fadd:f64 RFP64:f64:$src1, (ld:f64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>)
                    // Dst: (ADD_Fp64m32:f64 RFP64:f64:$src1, addr:iPTR:$src2)
                  /*SwitchType*/ 19,  MVT::f80,// ->60333
/*60314*/           OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*60317*/           OPC_EmitMergeInputChains, 1, 1, 
/*60320*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::ADD_Fp80m32), 0|OPFL_Chain|OPFL_MemRefs,
                        1/*#VTs*/, MVT::f80, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                    // Src: (fadd:f80 RFP80:f80:$src1, (ld:f80 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>)
                    // Dst: (ADD_Fp80m32:f80 RFP80:f80:$src1, addr:iPTR:$src2)
                  0, // EndSwitchType
/*60334*/       /*Scope*/ 24, /*->60359*/
/*60335*/         OPC_CheckPredicate, 50, // Predicate_extloadf64
/*60337*/         OPC_MoveParent,
/*60338*/         OPC_CheckType, MVT::f80,
/*60340*/         OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*60343*/         OPC_EmitMergeInputChains, 1, 1, 
/*60346*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::ADD_Fp80m64), 0|OPFL_Chain|OPFL_MemRefs,
                      1/*#VTs*/, MVT::f80, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                  // Src: (fadd:f80 RFP80:f80:$src1, (ld:f80 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf64>>)
                  // Dst: (ADD_Fp80m64:f80 RFP80:f80:$src1, addr:iPTR:$src2)
/*60359*/       0, /*End of Scope*/
/*60360*/     0, /*End of Scope*/
/*60361*/   /*Scope*/ 21|128,1/*149*/, /*->60512*/
/*60363*/     OPC_MoveChild, 0,
/*60365*/     OPC_CheckOpcode, ISD::LOAD,
/*60367*/     OPC_RecordMemRef,
/*60368*/     OPC_RecordNode, // #0 = 'ld' chained node
/*60369*/     OPC_CheckFoldableChainNode,
/*60370*/     OPC_RecordChild1, // #1 = $src2
/*60371*/     OPC_CheckPredicate, 2, // Predicate_unindexedload
/*60373*/     OPC_Scope, 54, /*->60429*/ // 2 children in Scope
/*60375*/       OPC_CheckPredicate, 8, // Predicate_load
/*60377*/       OPC_CheckPredicate, 9, // Predicate_dsload
/*60379*/       OPC_MoveParent,
/*60380*/       OPC_RecordChild1, // #2 = $src1
/*60381*/       OPC_SwitchType /*2 cases */, 21,  MVT::f32,// ->60405
/*60384*/         OPC_CheckPatternPredicate, 6, // (!Subtarget->hasSSE1())
/*60386*/         OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*60389*/         OPC_EmitMergeInputChains, 1, 0, 
/*60392*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::ADD_Fp32m), 0|OPFL_Chain|OPFL_MemRefs,
                      1/*#VTs*/, MVT::f32, 6/*#Ops*/, 2, 3, 4, 5, 6, 7, 
                  // Src: (fadd:f32 (ld:f32 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>, RFP32:f32:$src1)
                  // Dst: (ADD_Fp32m:f32 RFP32:f32:$src1, addr:iPTR:$src2)
                /*SwitchType*/ 21,  MVT::f64,// ->60428
/*60407*/         OPC_CheckPatternPredicate, 7, // (!Subtarget->hasSSE2())
/*60409*/         OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*60412*/         OPC_EmitMergeInputChains, 1, 0, 
/*60415*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::ADD_Fp64m), 0|OPFL_Chain|OPFL_MemRefs,
                      1/*#VTs*/, MVT::f64, 6/*#Ops*/, 2, 3, 4, 5, 6, 7, 
                  // Src: (fadd:f64 (ld:f64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>, RFP64:f64:$src1)
                  // Dst: (ADD_Fp64m:f64 RFP64:f64:$src1, addr:iPTR:$src2)
                0, // EndSwitchType
/*60429*/     /*Scope*/ 81, /*->60511*/
/*60430*/       OPC_CheckPredicate, 48, // Predicate_extload
/*60432*/       OPC_Scope, 50, /*->60484*/ // 2 children in Scope
/*60434*/         OPC_CheckPredicate, 49, // Predicate_extloadf32
/*60436*/         OPC_MoveParent,
/*60437*/         OPC_RecordChild1, // #2 = $src1
/*60438*/         OPC_SwitchType /*2 cases */, 21,  MVT::f64,// ->60462
/*60441*/           OPC_CheckPatternPredicate, 7, // (!Subtarget->hasSSE2())
/*60443*/           OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*60446*/           OPC_EmitMergeInputChains, 1, 0, 
/*60449*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::ADD_Fp64m32), 0|OPFL_Chain|OPFL_MemRefs,
                        1/*#VTs*/, MVT::f64, 6/*#Ops*/, 2, 3, 4, 5, 6, 7, 
                    // Src: (fadd:f64 (ld:f64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>, RFP64:f64:$src1)
                    // Dst: (ADD_Fp64m32:f64 RFP64:f64:$src1, addr:iPTR:$src2)
                  /*SwitchType*/ 19,  MVT::f80,// ->60483
/*60464*/           OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*60467*/           OPC_EmitMergeInputChains, 1, 0, 
/*60470*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::ADD_Fp80m32), 0|OPFL_Chain|OPFL_MemRefs,
                        1/*#VTs*/, MVT::f80, 6/*#Ops*/, 2, 3, 4, 5, 6, 7, 
                    // Src: (fadd:f80 (ld:f80 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>, RFP80:f80:$src1)
                    // Dst: (ADD_Fp80m32:f80 RFP80:f80:$src1, addr:iPTR:$src2)
                  0, // EndSwitchType
/*60484*/       /*Scope*/ 25, /*->60510*/
/*60485*/         OPC_CheckPredicate, 50, // Predicate_extloadf64
/*60487*/         OPC_MoveParent,
/*60488*/         OPC_RecordChild1, // #2 = $src1
/*60489*/         OPC_CheckType, MVT::f80,
/*60491*/         OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*60494*/         OPC_EmitMergeInputChains, 1, 0, 
/*60497*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::ADD_Fp80m64), 0|OPFL_Chain|OPFL_MemRefs,
                      1/*#VTs*/, MVT::f80, 6/*#Ops*/, 2, 3, 4, 5, 6, 7, 
                  // Src: (fadd:f80 (ld:f80 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf64>>, RFP80:f80:$src1)
                  // Dst: (ADD_Fp80m64:f80 RFP80:f80:$src1, addr:iPTR:$src2)
/*60510*/       0, /*End of Scope*/
/*60511*/     0, /*End of Scope*/
/*60512*/   /*Scope*/ 119, /*->60632*/
/*60513*/     OPC_RecordChild0, // #0 = $src1
/*60514*/     OPC_MoveChild, 1,
/*60516*/     OPC_CheckOpcode, ISD::LOAD,
/*60518*/     OPC_RecordMemRef,
/*60519*/     OPC_RecordNode, // #1 = 'ld' chained node
/*60520*/     OPC_CheckFoldableChainNode,
/*60521*/     OPC_RecordChild1, // #2 = $src2
/*60522*/     OPC_CheckPredicate, 2, // Predicate_unindexedload
/*60524*/     OPC_CheckPredicate, 8, // Predicate_load
/*60526*/     OPC_Scope, 24, /*->60552*/ // 4 children in Scope
/*60528*/       OPC_MoveParent,
/*60529*/       OPC_CheckType, MVT::f32,
/*60531*/       OPC_CheckPatternPredicate, 0, // (Subtarget->hasSSE1())
/*60533*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*60536*/       OPC_EmitMergeInputChains, 1, 1, 
/*60539*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::ADDSSrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::f32, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (fadd:f32 FR32:f32:$src1, (ld:f32 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)
                // Dst: (ADDSSrm:f32 FR32:f32:$src1, addr:iPTR:$src2)
/*60552*/     /*Scope*/ 26, /*->60579*/
/*60553*/       OPC_CheckPredicate, 23, // Predicate_memop
/*60555*/       OPC_MoveParent,
/*60556*/       OPC_CheckType, MVT::v4f32,
/*60558*/       OPC_CheckPatternPredicate, 0, // (Subtarget->hasSSE1())
/*60560*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*60563*/       OPC_EmitMergeInputChains, 1, 1, 
/*60566*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::ADDPSrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v4f32, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (fadd:v4f32 VR128:v4f32:$src1, (ld:v4f32 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>)
                // Dst: (ADDPSrm:v4f32 VR128:v4f32:$src1, addr:iPTR:$src2)
/*60579*/     /*Scope*/ 24, /*->60604*/
/*60580*/       OPC_MoveParent,
/*60581*/       OPC_CheckType, MVT::f64,
/*60583*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*60585*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*60588*/       OPC_EmitMergeInputChains, 1, 1, 
/*60591*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::ADDSDrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::f64, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (fadd:f64 FR64:f64:$src1, (ld:f64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)
                // Dst: (ADDSDrm:f64 FR64:f64:$src1, addr:iPTR:$src2)
/*60604*/     /*Scope*/ 26, /*->60631*/
/*60605*/       OPC_CheckPredicate, 23, // Predicate_memop
/*60607*/       OPC_MoveParent,
/*60608*/       OPC_CheckType, MVT::v2f64,
/*60610*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*60612*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*60615*/       OPC_EmitMergeInputChains, 1, 1, 
/*60618*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::ADDPDrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v2f64, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (fadd:v2f64 VR128:v2f64:$src1, (ld:v2f64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>)
                // Dst: (ADDPDrm:v2f64 VR128:v2f64:$src1, addr:iPTR:$src2)
/*60631*/     0, /*End of Scope*/
/*60632*/   /*Scope*/ 122, /*->60755*/
/*60633*/     OPC_MoveChild, 0,
/*60635*/     OPC_CheckOpcode, ISD::LOAD,
/*60637*/     OPC_RecordMemRef,
/*60638*/     OPC_RecordNode, // #0 = 'ld' chained node
/*60639*/     OPC_CheckFoldableChainNode,
/*60640*/     OPC_RecordChild1, // #1 = $src2
/*60641*/     OPC_CheckPredicate, 2, // Predicate_unindexedload
/*60643*/     OPC_CheckPredicate, 8, // Predicate_load
/*60645*/     OPC_Scope, 25, /*->60672*/ // 4 children in Scope
/*60647*/       OPC_MoveParent,
/*60648*/       OPC_RecordChild1, // #2 = $src1
/*60649*/       OPC_CheckType, MVT::f32,
/*60651*/       OPC_CheckPatternPredicate, 0, // (Subtarget->hasSSE1())
/*60653*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*60656*/       OPC_EmitMergeInputChains, 1, 0, 
/*60659*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::ADDSSrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::f32, 6/*#Ops*/, 2, 3, 4, 5, 6, 7, 
                // Src: (fadd:f32 (ld:f32 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR32:f32:$src1)
                // Dst: (ADDSSrm:f32 FR32:f32:$src1, addr:iPTR:$src2)
/*60672*/     /*Scope*/ 27, /*->60700*/
/*60673*/       OPC_CheckPredicate, 23, // Predicate_memop
/*60675*/       OPC_MoveParent,
/*60676*/       OPC_RecordChild1, // #2 = $src1
/*60677*/       OPC_CheckType, MVT::v4f32,
/*60679*/       OPC_CheckPatternPredicate, 0, // (Subtarget->hasSSE1())
/*60681*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*60684*/       OPC_EmitMergeInputChains, 1, 0, 
/*60687*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::ADDPSrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v4f32, 6/*#Ops*/, 2, 3, 4, 5, 6, 7, 
                // Src: (fadd:v4f32 (ld:v4f32 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>, VR128:v4f32:$src1)
                // Dst: (ADDPSrm:v4f32 VR128:v4f32:$src1, addr:iPTR:$src2)
/*60700*/     /*Scope*/ 25, /*->60726*/
/*60701*/       OPC_MoveParent,
/*60702*/       OPC_RecordChild1, // #2 = $src1
/*60703*/       OPC_CheckType, MVT::f64,
/*60705*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*60707*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*60710*/       OPC_EmitMergeInputChains, 1, 0, 
/*60713*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::ADDSDrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::f64, 6/*#Ops*/, 2, 3, 4, 5, 6, 7, 
                // Src: (fadd:f64 (ld:f64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR64:f64:$src1)
                // Dst: (ADDSDrm:f64 FR64:f64:$src1, addr:iPTR:$src2)
/*60726*/     /*Scope*/ 27, /*->60754*/
/*60727*/       OPC_CheckPredicate, 23, // Predicate_memop
/*60729*/       OPC_MoveParent,
/*60730*/       OPC_RecordChild1, // #2 = $src1
/*60731*/       OPC_CheckType, MVT::v2f64,
/*60733*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*60735*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*60738*/       OPC_EmitMergeInputChains, 1, 0, 
/*60741*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::ADDPDrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v2f64, 6/*#Ops*/, 2, 3, 4, 5, 6, 7, 
                // Src: (fadd:v2f64 (ld:v2f64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>, VR128:v2f64:$src1)
                // Dst: (ADDPDrm:v2f64 VR128:v2f64:$src1, addr:iPTR:$src2)
/*60754*/     0, /*End of Scope*/
/*60755*/   /*Scope*/ 32|128,1/*160*/, /*->60917*/
/*60757*/     OPC_RecordChild0, // #0 = $src1
/*60758*/     OPC_MoveChild, 1,
/*60760*/     OPC_CheckOpcode, X86ISD::FILD,
/*60762*/     OPC_RecordNode, // #1 = 'X86fild' chained node
/*60763*/     OPC_CheckFoldableChainNode,
/*60764*/     OPC_RecordChild1, // #2 = $src2
/*60765*/     OPC_MoveChild, 2,
/*60767*/     OPC_Scope, 73, /*->60842*/ // 2 children in Scope
/*60769*/       OPC_CheckValueType, MVT::i16,
/*60771*/       OPC_MoveParent,
/*60772*/       OPC_MoveParent,
/*60773*/       OPC_SwitchType /*3 cases */, 21,  MVT::f32,// ->60797
/*60776*/         OPC_CheckPatternPredicate, 6, // (!Subtarget->hasSSE1())
/*60778*/         OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*60781*/         OPC_EmitMergeInputChains, 1, 1, 
/*60784*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::ADD_FpI16m32), 0|OPFL_Chain,
                      1/*#VTs*/, MVT::f32, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                  // Src: (fadd:f32 RFP32:f32:$src1, (X86fild:f32 addr:iPTR:$src2, i16:Other))
                  // Dst: (ADD_FpI16m32:f32 RFP32:f32:$src1, addr:iPTR:$src2)
                /*SwitchType*/ 21,  MVT::f64,// ->60820
/*60799*/         OPC_CheckPatternPredicate, 7, // (!Subtarget->hasSSE2())
/*60801*/         OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*60804*/         OPC_EmitMergeInputChains, 1, 1, 
/*60807*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::ADD_FpI16m64), 0|OPFL_Chain,
                      1/*#VTs*/, MVT::f64, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                  // Src: (fadd:f64 RFP64:f64:$src1, (X86fild:f64 addr:iPTR:$src2, i16:Other))
                  // Dst: (ADD_FpI16m64:f64 RFP64:f64:$src1, addr:iPTR:$src2)
                /*SwitchType*/ 19,  MVT::f80,// ->60841
/*60822*/         OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*60825*/         OPC_EmitMergeInputChains, 1, 1, 
/*60828*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::ADD_FpI16m80), 0|OPFL_Chain,
                      1/*#VTs*/, MVT::f80, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                  // Src: (fadd:f80 RFP80:f80:$src1, (X86fild:f80 addr:iPTR:$src2, i16:Other))
                  // Dst: (ADD_FpI16m80:f80 RFP80:f80:$src1, addr:iPTR:$src2)
                0, // EndSwitchType
/*60842*/     /*Scope*/ 73, /*->60916*/
/*60843*/       OPC_CheckValueType, MVT::i32,
/*60845*/       OPC_MoveParent,
/*60846*/       OPC_MoveParent,
/*60847*/       OPC_SwitchType /*3 cases */, 21,  MVT::f32,// ->60871
/*60850*/         OPC_CheckPatternPredicate, 6, // (!Subtarget->hasSSE1())
/*60852*/         OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*60855*/         OPC_EmitMergeInputChains, 1, 1, 
/*60858*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::ADD_FpI32m32), 0|OPFL_Chain,
                      1/*#VTs*/, MVT::f32, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                  // Src: (fadd:f32 RFP32:f32:$src1, (X86fild:f32 addr:iPTR:$src2, i32:Other))
                  // Dst: (ADD_FpI32m32:f32 RFP32:f32:$src1, addr:iPTR:$src2)
                /*SwitchType*/ 21,  MVT::f64,// ->60894
/*60873*/         OPC_CheckPatternPredicate, 7, // (!Subtarget->hasSSE2())
/*60875*/         OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*60878*/         OPC_EmitMergeInputChains, 1, 1, 
/*60881*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::ADD_FpI32m64), 0|OPFL_Chain,
                      1/*#VTs*/, MVT::f64, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                  // Src: (fadd:f64 RFP64:f64:$src1, (X86fild:f64 addr:iPTR:$src2, i32:Other))
                  // Dst: (ADD_FpI32m64:f64 RFP64:f64:$src1, addr:iPTR:$src2)
                /*SwitchType*/ 19,  MVT::f80,// ->60915
/*60896*/         OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*60899*/         OPC_EmitMergeInputChains, 1, 1, 
/*60902*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::ADD_FpI32m80), 0|OPFL_Chain,
                      1/*#VTs*/, MVT::f80, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                  // Src: (fadd:f80 RFP80:f80:$src1, (X86fild:f80 addr:iPTR:$src2, i32:Other))
                  // Dst: (ADD_FpI32m80:f80 RFP80:f80:$src1, addr:iPTR:$src2)
                0, // EndSwitchType
/*60916*/     0, /*End of Scope*/
/*60917*/   /*Scope*/ 33|128,1/*161*/, /*->61080*/
/*60919*/     OPC_MoveChild, 0,
/*60921*/     OPC_CheckOpcode, X86ISD::FILD,
/*60923*/     OPC_RecordNode, // #0 = 'X86fild' chained node
/*60924*/     OPC_CheckFoldableChainNode,
/*60925*/     OPC_RecordChild1, // #1 = $src2
/*60926*/     OPC_MoveChild, 2,
/*60928*/     OPC_Scope, 74, /*->61004*/ // 2 children in Scope
/*60930*/       OPC_CheckValueType, MVT::i16,
/*60932*/       OPC_MoveParent,
/*60933*/       OPC_MoveParent,
/*60934*/       OPC_RecordChild1, // #2 = $src1
/*60935*/       OPC_SwitchType /*3 cases */, 21,  MVT::f32,// ->60959
/*60938*/         OPC_CheckPatternPredicate, 6, // (!Subtarget->hasSSE1())
/*60940*/         OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*60943*/         OPC_EmitMergeInputChains, 1, 0, 
/*60946*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::ADD_FpI16m32), 0|OPFL_Chain,
                      1/*#VTs*/, MVT::f32, 6/*#Ops*/, 2, 3, 4, 5, 6, 7, 
                  // Src: (fadd:f32 (X86fild:f32 addr:iPTR:$src2, i16:Other), RFP32:f32:$src1)
                  // Dst: (ADD_FpI16m32:f32 RFP32:f32:$src1, addr:iPTR:$src2)
                /*SwitchType*/ 21,  MVT::f64,// ->60982
/*60961*/         OPC_CheckPatternPredicate, 7, // (!Subtarget->hasSSE2())
/*60963*/         OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*60966*/         OPC_EmitMergeInputChains, 1, 0, 
/*60969*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::ADD_FpI16m64), 0|OPFL_Chain,
                      1/*#VTs*/, MVT::f64, 6/*#Ops*/, 2, 3, 4, 5, 6, 7, 
                  // Src: (fadd:f64 (X86fild:f64 addr:iPTR:$src2, i16:Other), RFP64:f64:$src1)
                  // Dst: (ADD_FpI16m64:f64 RFP64:f64:$src1, addr:iPTR:$src2)
                /*SwitchType*/ 19,  MVT::f80,// ->61003
/*60984*/         OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*60987*/         OPC_EmitMergeInputChains, 1, 0, 
/*60990*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::ADD_FpI16m80), 0|OPFL_Chain,
                      1/*#VTs*/, MVT::f80, 6/*#Ops*/, 2, 3, 4, 5, 6, 7, 
                  // Src: (fadd:f80 (X86fild:f80 addr:iPTR:$src2, i16:Other), RFP80:f80:$src1)
                  // Dst: (ADD_FpI16m80:f80 RFP80:f80:$src1, addr:iPTR:$src2)
                0, // EndSwitchType
/*61004*/     /*Scope*/ 74, /*->61079*/
/*61005*/       OPC_CheckValueType, MVT::i32,
/*61007*/       OPC_MoveParent,
/*61008*/       OPC_MoveParent,
/*61009*/       OPC_RecordChild1, // #2 = $src1
/*61010*/       OPC_SwitchType /*3 cases */, 21,  MVT::f32,// ->61034
/*61013*/         OPC_CheckPatternPredicate, 6, // (!Subtarget->hasSSE1())
/*61015*/         OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*61018*/         OPC_EmitMergeInputChains, 1, 0, 
/*61021*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::ADD_FpI32m32), 0|OPFL_Chain,
                      1/*#VTs*/, MVT::f32, 6/*#Ops*/, 2, 3, 4, 5, 6, 7, 
                  // Src: (fadd:f32 (X86fild:f32 addr:iPTR:$src2, i32:Other), RFP32:f32:$src1)
                  // Dst: (ADD_FpI32m32:f32 RFP32:f32:$src1, addr:iPTR:$src2)
                /*SwitchType*/ 21,  MVT::f64,// ->61057
/*61036*/         OPC_CheckPatternPredicate, 7, // (!Subtarget->hasSSE2())
/*61038*/         OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*61041*/         OPC_EmitMergeInputChains, 1, 0, 
/*61044*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::ADD_FpI32m64), 0|OPFL_Chain,
                      1/*#VTs*/, MVT::f64, 6/*#Ops*/, 2, 3, 4, 5, 6, 7, 
                  // Src: (fadd:f64 (X86fild:f64 addr:iPTR:$src2, i32:Other), RFP64:f64:$src1)
                  // Dst: (ADD_FpI32m64:f64 RFP64:f64:$src1, addr:iPTR:$src2)
                /*SwitchType*/ 19,  MVT::f80,// ->61078
/*61059*/         OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*61062*/         OPC_EmitMergeInputChains, 1, 0, 
/*61065*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::ADD_FpI32m80), 0|OPFL_Chain,
                      1/*#VTs*/, MVT::f80, 6/*#Ops*/, 2, 3, 4, 5, 6, 7, 
                  // Src: (fadd:f80 (X86fild:f80 addr:iPTR:$src2, i32:Other), RFP80:f80:$src1)
                  // Dst: (ADD_FpI32m80:f80 RFP80:f80:$src1, addr:iPTR:$src2)
                0, // EndSwitchType
/*61079*/     0, /*End of Scope*/
/*61080*/   /*Scope*/ 97, /*->61178*/
/*61081*/     OPC_RecordChild0, // #0 = $src1
/*61082*/     OPC_RecordChild1, // #1 = $src2
/*61083*/     OPC_SwitchType /*5 cases */, 26,  MVT::f32,// ->61112
/*61086*/       OPC_Scope, 11, /*->61099*/ // 2 children in Scope
/*61088*/         OPC_CheckPatternPredicate, 6, // (!Subtarget->hasSSE1())
/*61090*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::ADD_Fp32), 0,
                      1/*#VTs*/, MVT::f32, 2/*#Ops*/, 0, 1, 
                  // Src: (fadd:f32 RFP32:f32:$src1, RFP32:f32:$src2)
                  // Dst: (ADD_Fp32:f32 RFP32:f32:$src1, RFP32:f32:$src2)
/*61099*/       /*Scope*/ 11, /*->61111*/
/*61100*/         OPC_CheckPatternPredicate, 0, // (Subtarget->hasSSE1())
/*61102*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::ADDSSrr), 0,
                      1/*#VTs*/, MVT::f32, 2/*#Ops*/, 0, 1, 
                  // Src: (fadd:f32 FR32:f32:$src1, FR32:f32:$src2)
                  // Dst: (ADDSSrr:f32 FR32:f32:$src1, FR32:f32:$src2)
/*61111*/       0, /*End of Scope*/
              /*SwitchType*/ 26,  MVT::f64,// ->61140
/*61114*/       OPC_Scope, 11, /*->61127*/ // 2 children in Scope
/*61116*/         OPC_CheckPatternPredicate, 7, // (!Subtarget->hasSSE2())
/*61118*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::ADD_Fp64), 0,
                      1/*#VTs*/, MVT::f64, 2/*#Ops*/, 0, 1, 
                  // Src: (fadd:f64 RFP64:f64:$src1, RFP64:f64:$src2)
                  // Dst: (ADD_Fp64:f64 RFP64:f64:$src1, RFP64:f64:$src2)
/*61127*/       /*Scope*/ 11, /*->61139*/
/*61128*/         OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*61130*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::ADDSDrr), 0,
                      1/*#VTs*/, MVT::f64, 2/*#Ops*/, 0, 1, 
                  // Src: (fadd:f64 FR64:f64:$src1, FR64:f64:$src2)
                  // Dst: (ADDSDrr:f64 FR64:f64:$src1, FR64:f64:$src2)
/*61139*/       0, /*End of Scope*/
              /*SwitchType*/ 9,  MVT::f80,// ->61151
/*61142*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::ADD_Fp80), 0,
                    1/*#VTs*/, MVT::f80, 2/*#Ops*/, 0, 1, 
                // Src: (fadd:f80 RFP80:f80:$src1, RFP80:f80:$src2)
                // Dst: (ADD_Fp80:f80 RFP80:f80:$src1, RFP80:f80:$src2)
              /*SwitchType*/ 11,  MVT::v4f32,// ->61164
/*61153*/       OPC_CheckPatternPredicate, 0, // (Subtarget->hasSSE1())
/*61155*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::ADDPSrr), 0,
                    1/*#VTs*/, MVT::v4f32, 2/*#Ops*/, 0, 1, 
                // Src: (fadd:v4f32 VR128:v4f32:$src1, VR128:v4f32:$src2)
                // Dst: (ADDPSrr:v4f32 VR128:v4f32:$src1, VR128:v4f32:$src2)
              /*SwitchType*/ 11,  MVT::v2f64,// ->61177
/*61166*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*61168*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::ADDPDrr), 0,
                    1/*#VTs*/, MVT::v2f64, 2/*#Ops*/, 0, 1, 
                // Src: (fadd:v2f64 VR128:v2f64:$src1, VR128:v2f64:$src2)
                // Dst: (ADDPDrr:v2f64 VR128:v2f64:$src1, VR128:v2f64:$src2)
              0, // EndSwitchType
/*61178*/   0, /*End of Scope*/
          /*SwitchOpcode*/ 114|128,5/*754*/,  ISD::FSUB,// ->61936
/*61182*/   OPC_RecordChild0, // #0 = $src1
/*61183*/   OPC_Scope, 12|128,5/*652*/, /*->61838*/ // 2 children in Scope
/*61186*/     OPC_MoveChild, 1,
/*61188*/     OPC_SwitchOpcode /*2 cases */, 1|128,3/*385*/,  ISD::LOAD,// ->61577
/*61192*/       OPC_RecordMemRef,
/*61193*/       OPC_RecordNode, // #1 = 'ld' chained node
/*61194*/       OPC_CheckFoldableChainNode,
/*61195*/       OPC_RecordChild1, // #2 = $src2
/*61196*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*61198*/       OPC_Scope, 53, /*->61253*/ // 5 children in Scope
/*61200*/         OPC_CheckPredicate, 8, // Predicate_load
/*61202*/         OPC_CheckPredicate, 9, // Predicate_dsload
/*61204*/         OPC_MoveParent,
/*61205*/         OPC_SwitchType /*2 cases */, 21,  MVT::f32,// ->61229
/*61208*/           OPC_CheckPatternPredicate, 6, // (!Subtarget->hasSSE1())
/*61210*/           OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*61213*/           OPC_EmitMergeInputChains, 1, 1, 
/*61216*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::SUB_Fp32m), 0|OPFL_Chain|OPFL_MemRefs,
                        1/*#VTs*/, MVT::f32, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                    // Src: (fsub:f32 RFP32:f32:$src1, (ld:f32 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>)
                    // Dst: (SUB_Fp32m:f32 RFP32:f32:$src1, addr:iPTR:$src2)
                  /*SwitchType*/ 21,  MVT::f64,// ->61252
/*61231*/           OPC_CheckPatternPredicate, 7, // (!Subtarget->hasSSE2())
/*61233*/           OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*61236*/           OPC_EmitMergeInputChains, 1, 1, 
/*61239*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::SUB_Fp64m), 0|OPFL_Chain|OPFL_MemRefs,
                        1/*#VTs*/, MVT::f64, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                    // Src: (fsub:f64 RFP64:f64:$src1, (ld:f64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>)
                    // Dst: (SUB_Fp64m:f64 RFP64:f64:$src1, addr:iPTR:$src2)
                  0, // EndSwitchType
/*61253*/       /*Scope*/ 79, /*->61333*/
/*61254*/         OPC_CheckPredicate, 48, // Predicate_extload
/*61256*/         OPC_Scope, 49, /*->61307*/ // 2 children in Scope
/*61258*/           OPC_CheckPredicate, 49, // Predicate_extloadf32
/*61260*/           OPC_MoveParent,
/*61261*/           OPC_SwitchType /*2 cases */, 21,  MVT::f64,// ->61285
/*61264*/             OPC_CheckPatternPredicate, 7, // (!Subtarget->hasSSE2())
/*61266*/             OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*61269*/             OPC_EmitMergeInputChains, 1, 1, 
/*61272*/             OPC_MorphNodeTo, TARGET_OPCODE(X86::SUB_Fp64m32), 0|OPFL_Chain|OPFL_MemRefs,
                          1/*#VTs*/, MVT::f64, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                      // Src: (fsub:f64 RFP64:f64:$src1, (ld:f64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>)
                      // Dst: (SUB_Fp64m32:f64 RFP64:f64:$src1, addr:iPTR:$src2)
                    /*SwitchType*/ 19,  MVT::f80,// ->61306
/*61287*/             OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*61290*/             OPC_EmitMergeInputChains, 1, 1, 
/*61293*/             OPC_MorphNodeTo, TARGET_OPCODE(X86::SUB_Fp80m32), 0|OPFL_Chain|OPFL_MemRefs,
                          1/*#VTs*/, MVT::f80, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                      // Src: (fsub:f80 RFP80:f80:$src1, (ld:f80 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>)
                      // Dst: (SUB_Fp80m32:f80 RFP80:f80:$src1, addr:iPTR:$src2)
                    0, // EndSwitchType
/*61307*/         /*Scope*/ 24, /*->61332*/
/*61308*/           OPC_CheckPredicate, 50, // Predicate_extloadf64
/*61310*/           OPC_MoveParent,
/*61311*/           OPC_CheckType, MVT::f80,
/*61313*/           OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*61316*/           OPC_EmitMergeInputChains, 1, 1, 
/*61319*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::SUB_Fp80m64), 0|OPFL_Chain|OPFL_MemRefs,
                        1/*#VTs*/, MVT::f80, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                    // Src: (fsub:f80 RFP80:f80:$src1, (ld:f80 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf64>>)
                    // Dst: (SUB_Fp80m64:f80 RFP80:f80:$src1, addr:iPTR:$src2)
/*61332*/         0, /*End of Scope*/
/*61333*/       /*Scope*/ 53, /*->61387*/
/*61334*/         OPC_CheckPredicate, 8, // Predicate_load
/*61336*/         OPC_CheckPredicate, 9, // Predicate_dsload
/*61338*/         OPC_MoveParent,
/*61339*/         OPC_SwitchType /*2 cases */, 21,  MVT::f32,// ->61363
/*61342*/           OPC_CheckPatternPredicate, 6, // (!Subtarget->hasSSE1())
/*61344*/           OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*61347*/           OPC_EmitMergeInputChains, 1, 1, 
/*61350*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::SUBR_Fp32m), 0|OPFL_Chain|OPFL_MemRefs,
                        1/*#VTs*/, MVT::f32, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                    // Src: (fsub:f32 RFP32:f32:$src1, (ld:f32 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>)
                    // Dst: (SUBR_Fp32m:f32 RFP32:f32:$src1, addr:iPTR:$src2)
                  /*SwitchType*/ 21,  MVT::f64,// ->61386
/*61365*/           OPC_CheckPatternPredicate, 7, // (!Subtarget->hasSSE2())
/*61367*/           OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*61370*/           OPC_EmitMergeInputChains, 1, 1, 
/*61373*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::SUBR_Fp64m), 0|OPFL_Chain|OPFL_MemRefs,
                        1/*#VTs*/, MVT::f64, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                    // Src: (fsub:f64 RFP64:f64:$src1, (ld:f64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>)
                    // Dst: (SUBR_Fp64m:f64 RFP64:f64:$src1, addr:iPTR:$src2)
                  0, // EndSwitchType
/*61387*/       /*Scope*/ 79, /*->61467*/
/*61388*/         OPC_CheckPredicate, 48, // Predicate_extload
/*61390*/         OPC_Scope, 49, /*->61441*/ // 2 children in Scope
/*61392*/           OPC_CheckPredicate, 49, // Predicate_extloadf32
/*61394*/           OPC_MoveParent,
/*61395*/           OPC_SwitchType /*2 cases */, 21,  MVT::f64,// ->61419
/*61398*/             OPC_CheckPatternPredicate, 7, // (!Subtarget->hasSSE2())
/*61400*/             OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*61403*/             OPC_EmitMergeInputChains, 1, 1, 
/*61406*/             OPC_MorphNodeTo, TARGET_OPCODE(X86::SUBR_Fp64m32), 0|OPFL_Chain|OPFL_MemRefs,
                          1/*#VTs*/, MVT::f64, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                      // Src: (fsub:f64 RFP64:f64:$src1, (ld:f64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>)
                      // Dst: (SUBR_Fp64m32:f64 RFP64:f64:$src1, addr:iPTR:$src2)
                    /*SwitchType*/ 19,  MVT::f80,// ->61440
/*61421*/             OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*61424*/             OPC_EmitMergeInputChains, 1, 1, 
/*61427*/             OPC_MorphNodeTo, TARGET_OPCODE(X86::SUBR_Fp80m32), 0|OPFL_Chain|OPFL_MemRefs,
                          1/*#VTs*/, MVT::f80, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                      // Src: (fsub:f80 RFP80:f80:$src1, (ld:f80 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>)
                      // Dst: (SUBR_Fp80m32:f80 RFP80:f80:$src1, addr:iPTR:$src2)
                    0, // EndSwitchType
/*61441*/         /*Scope*/ 24, /*->61466*/
/*61442*/           OPC_CheckPredicate, 50, // Predicate_extloadf64
/*61444*/           OPC_MoveParent,
/*61445*/           OPC_CheckType, MVT::f80,
/*61447*/           OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*61450*/           OPC_EmitMergeInputChains, 1, 1, 
/*61453*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::SUBR_Fp80m64), 0|OPFL_Chain|OPFL_MemRefs,
                        1/*#VTs*/, MVT::f80, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                    // Src: (fsub:f80 RFP80:f80:$src1, (ld:f80 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf64>>)
                    // Dst: (SUBR_Fp80m64:f80 RFP80:f80:$src1, addr:iPTR:$src2)
/*61466*/         0, /*End of Scope*/
/*61467*/       /*Scope*/ 108, /*->61576*/
/*61468*/         OPC_CheckPredicate, 8, // Predicate_load
/*61470*/         OPC_Scope, 24, /*->61496*/ // 4 children in Scope
/*61472*/           OPC_MoveParent,
/*61473*/           OPC_CheckType, MVT::f32,
/*61475*/           OPC_CheckPatternPredicate, 0, // (Subtarget->hasSSE1())
/*61477*/           OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*61480*/           OPC_EmitMergeInputChains, 1, 1, 
/*61483*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::SUBSSrm), 0|OPFL_Chain|OPFL_MemRefs,
                        1/*#VTs*/, MVT::f32, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                    // Src: (fsub:f32 FR32:f32:$src1, (ld:f32 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)
                    // Dst: (SUBSSrm:f32 FR32:f32:$src1, addr:iPTR:$src2)
/*61496*/         /*Scope*/ 26, /*->61523*/
/*61497*/           OPC_CheckPredicate, 23, // Predicate_memop
/*61499*/           OPC_MoveParent,
/*61500*/           OPC_CheckType, MVT::v4f32,
/*61502*/           OPC_CheckPatternPredicate, 0, // (Subtarget->hasSSE1())
/*61504*/           OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*61507*/           OPC_EmitMergeInputChains, 1, 1, 
/*61510*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::SUBPSrm), 0|OPFL_Chain|OPFL_MemRefs,
                        1/*#VTs*/, MVT::v4f32, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                    // Src: (fsub:v4f32 VR128:v4f32:$src1, (ld:v4f32 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>)
                    // Dst: (SUBPSrm:v4f32 VR128:v4f32:$src1, addr:iPTR:$src2)
/*61523*/         /*Scope*/ 24, /*->61548*/
/*61524*/           OPC_MoveParent,
/*61525*/           OPC_CheckType, MVT::f64,
/*61527*/           OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*61529*/           OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*61532*/           OPC_EmitMergeInputChains, 1, 1, 
/*61535*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::SUBSDrm), 0|OPFL_Chain|OPFL_MemRefs,
                        1/*#VTs*/, MVT::f64, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                    // Src: (fsub:f64 FR64:f64:$src1, (ld:f64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)
                    // Dst: (SUBSDrm:f64 FR64:f64:$src1, addr:iPTR:$src2)
/*61548*/         /*Scope*/ 26, /*->61575*/
/*61549*/           OPC_CheckPredicate, 23, // Predicate_memop
/*61551*/           OPC_MoveParent,
/*61552*/           OPC_CheckType, MVT::v2f64,
/*61554*/           OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*61556*/           OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*61559*/           OPC_EmitMergeInputChains, 1, 1, 
/*61562*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::SUBPDrm), 0|OPFL_Chain|OPFL_MemRefs,
                        1/*#VTs*/, MVT::v2f64, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                    // Src: (fsub:v2f64 VR128:v2f64:$src1, (ld:v2f64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>)
                    // Dst: (SUBPDrm:v2f64 VR128:v2f64:$src1, addr:iPTR:$src2)
/*61575*/         0, /*End of Scope*/
/*61576*/       0, /*End of Scope*/
              /*SwitchOpcode*/ 1|128,2/*257*/,  X86ISD::FILD,// ->61837
/*61580*/       OPC_RecordNode, // #1 = 'X86fild' chained node
/*61581*/       OPC_CheckFoldableChainNode,
/*61582*/       OPC_RecordChild1, // #2 = $src2
/*61583*/       OPC_MoveChild, 2,
/*61585*/       OPC_Scope, 124, /*->61711*/ // 2 children in Scope
/*61587*/         OPC_CheckValueType, MVT::i16,
/*61589*/         OPC_MoveParent,
/*61590*/         OPC_MoveParent,
/*61591*/         OPC_SwitchType /*3 cases */, 38,  MVT::f32,// ->61632
/*61594*/           OPC_CheckPatternPredicate, 6, // (!Subtarget->hasSSE1())
/*61596*/           OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*61599*/           OPC_EmitMergeInputChains, 1, 1, 
/*61602*/           OPC_Scope, 13, /*->61617*/ // 2 children in Scope
/*61604*/             OPC_MorphNodeTo, TARGET_OPCODE(X86::SUB_FpI16m32), 0|OPFL_Chain,
                          1/*#VTs*/, MVT::f32, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                      // Src: (fsub:f32 RFP32:f32:$src1, (X86fild:f32 addr:iPTR:$src2, i16:Other))
                      // Dst: (SUB_FpI16m32:f32 RFP32:f32:$src1, addr:iPTR:$src2)
/*61617*/           /*Scope*/ 13, /*->61631*/
/*61618*/             OPC_MorphNodeTo, TARGET_OPCODE(X86::SUBR_FpI16m32), 0|OPFL_Chain,
                          1/*#VTs*/, MVT::f32, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                      // Src: (fsub:f32 RFP32:f32:$src1, (X86fild:f32 addr:iPTR:$src2, i16:Other))
                      // Dst: (SUBR_FpI16m32:f32 RFP32:f32:$src1, addr:iPTR:$src2)
/*61631*/           0, /*End of Scope*/
                  /*SwitchType*/ 38,  MVT::f64,// ->61672
/*61634*/           OPC_CheckPatternPredicate, 7, // (!Subtarget->hasSSE2())
/*61636*/           OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*61639*/           OPC_EmitMergeInputChains, 1, 1, 
/*61642*/           OPC_Scope, 13, /*->61657*/ // 2 children in Scope
/*61644*/             OPC_MorphNodeTo, TARGET_OPCODE(X86::SUB_FpI16m64), 0|OPFL_Chain,
                          1/*#VTs*/, MVT::f64, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                      // Src: (fsub:f64 RFP64:f64:$src1, (X86fild:f64 addr:iPTR:$src2, i16:Other))
                      // Dst: (SUB_FpI16m64:f64 RFP64:f64:$src1, addr:iPTR:$src2)
/*61657*/           /*Scope*/ 13, /*->61671*/
/*61658*/             OPC_MorphNodeTo, TARGET_OPCODE(X86::SUBR_FpI16m64), 0|OPFL_Chain,
                          1/*#VTs*/, MVT::f64, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                      // Src: (fsub:f64 RFP64:f64:$src1, (X86fild:f64 addr:iPTR:$src2, i16:Other))
                      // Dst: (SUBR_FpI16m64:f64 RFP64:f64:$src1, addr:iPTR:$src2)
/*61671*/           0, /*End of Scope*/
                  /*SwitchType*/ 36,  MVT::f80,// ->61710
/*61674*/           OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*61677*/           OPC_EmitMergeInputChains, 1, 1, 
/*61680*/           OPC_Scope, 13, /*->61695*/ // 2 children in Scope
/*61682*/             OPC_MorphNodeTo, TARGET_OPCODE(X86::SUB_FpI16m80), 0|OPFL_Chain,
                          1/*#VTs*/, MVT::f80, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                      // Src: (fsub:f80 RFP80:f80:$src1, (X86fild:f80 addr:iPTR:$src2, i16:Other))
                      // Dst: (SUB_FpI16m80:f80 RFP80:f80:$src1, addr:iPTR:$src2)
/*61695*/           /*Scope*/ 13, /*->61709*/
/*61696*/             OPC_MorphNodeTo, TARGET_OPCODE(X86::SUBR_FpI16m80), 0|OPFL_Chain,
                          1/*#VTs*/, MVT::f80, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                      // Src: (fsub:f80 RFP80:f80:$src1, (X86fild:f80 addr:iPTR:$src2, i16:Other))
                      // Dst: (SUBR_FpI16m80:f80 RFP80:f80:$src1, addr:iPTR:$src2)
/*61709*/           0, /*End of Scope*/
                  0, // EndSwitchType
/*61711*/       /*Scope*/ 124, /*->61836*/
/*61712*/         OPC_CheckValueType, MVT::i32,
/*61714*/         OPC_MoveParent,
/*61715*/         OPC_MoveParent,
/*61716*/         OPC_SwitchType /*3 cases */, 38,  MVT::f32,// ->61757
/*61719*/           OPC_CheckPatternPredicate, 6, // (!Subtarget->hasSSE1())
/*61721*/           OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*61724*/           OPC_EmitMergeInputChains, 1, 1, 
/*61727*/           OPC_Scope, 13, /*->61742*/ // 2 children in Scope
/*61729*/             OPC_MorphNodeTo, TARGET_OPCODE(X86::SUB_FpI32m32), 0|OPFL_Chain,
                          1/*#VTs*/, MVT::f32, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                      // Src: (fsub:f32 RFP32:f32:$src1, (X86fild:f32 addr:iPTR:$src2, i32:Other))
                      // Dst: (SUB_FpI32m32:f32 RFP32:f32:$src1, addr:iPTR:$src2)
/*61742*/           /*Scope*/ 13, /*->61756*/
/*61743*/             OPC_MorphNodeTo, TARGET_OPCODE(X86::SUBR_FpI32m32), 0|OPFL_Chain,
                          1/*#VTs*/, MVT::f32, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                      // Src: (fsub:f32 RFP32:f32:$src1, (X86fild:f32 addr:iPTR:$src2, i32:Other))
                      // Dst: (SUBR_FpI32m32:f32 RFP32:f32:$src1, addr:iPTR:$src2)
/*61756*/           0, /*End of Scope*/
                  /*SwitchType*/ 38,  MVT::f64,// ->61797
/*61759*/           OPC_CheckPatternPredicate, 7, // (!Subtarget->hasSSE2())
/*61761*/           OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*61764*/           OPC_EmitMergeInputChains, 1, 1, 
/*61767*/           OPC_Scope, 13, /*->61782*/ // 2 children in Scope
/*61769*/             OPC_MorphNodeTo, TARGET_OPCODE(X86::SUB_FpI32m64), 0|OPFL_Chain,
                          1/*#VTs*/, MVT::f64, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                      // Src: (fsub:f64 RFP64:f64:$src1, (X86fild:f64 addr:iPTR:$src2, i32:Other))
                      // Dst: (SUB_FpI32m64:f64 RFP64:f64:$src1, addr:iPTR:$src2)
/*61782*/           /*Scope*/ 13, /*->61796*/
/*61783*/             OPC_MorphNodeTo, TARGET_OPCODE(X86::SUBR_FpI32m64), 0|OPFL_Chain,
                          1/*#VTs*/, MVT::f64, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                      // Src: (fsub:f64 RFP64:f64:$src1, (X86fild:f64 addr:iPTR:$src2, i32:Other))
                      // Dst: (SUBR_FpI32m64:f64 RFP64:f64:$src1, addr:iPTR:$src2)
/*61796*/           0, /*End of Scope*/
                  /*SwitchType*/ 36,  MVT::f80,// ->61835
/*61799*/           OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*61802*/           OPC_EmitMergeInputChains, 1, 1, 
/*61805*/           OPC_Scope, 13, /*->61820*/ // 2 children in Scope
/*61807*/             OPC_MorphNodeTo, TARGET_OPCODE(X86::SUB_FpI32m80), 0|OPFL_Chain,
                          1/*#VTs*/, MVT::f80, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                      // Src: (fsub:f80 RFP80:f80:$src1, (X86fild:f80 addr:iPTR:$src2, i32:Other))
                      // Dst: (SUB_FpI32m80:f80 RFP80:f80:$src1, addr:iPTR:$src2)
/*61820*/           /*Scope*/ 13, /*->61834*/
/*61821*/             OPC_MorphNodeTo, TARGET_OPCODE(X86::SUBR_FpI32m80), 0|OPFL_Chain,
                          1/*#VTs*/, MVT::f80, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                      // Src: (fsub:f80 RFP80:f80:$src1, (X86fild:f80 addr:iPTR:$src2, i32:Other))
                      // Dst: (SUBR_FpI32m80:f80 RFP80:f80:$src1, addr:iPTR:$src2)
/*61834*/           0, /*End of Scope*/
                  0, // EndSwitchType
/*61836*/       0, /*End of Scope*/
              0, // EndSwitchOpcode
/*61838*/   /*Scope*/ 96, /*->61935*/
/*61839*/     OPC_RecordChild1, // #1 = $src2
/*61840*/     OPC_SwitchType /*5 cases */, 26,  MVT::f32,// ->61869
/*61843*/       OPC_Scope, 11, /*->61856*/ // 2 children in Scope
/*61845*/         OPC_CheckPatternPredicate, 6, // (!Subtarget->hasSSE1())
/*61847*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::SUB_Fp32), 0,
                      1/*#VTs*/, MVT::f32, 2/*#Ops*/, 0, 1, 
                  // Src: (fsub:f32 RFP32:f32:$src1, RFP32:f32:$src2)
                  // Dst: (SUB_Fp32:f32 RFP32:f32:$src1, RFP32:f32:$src2)
/*61856*/       /*Scope*/ 11, /*->61868*/
/*61857*/         OPC_CheckPatternPredicate, 0, // (Subtarget->hasSSE1())
/*61859*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::SUBSSrr), 0,
                      1/*#VTs*/, MVT::f32, 2/*#Ops*/, 0, 1, 
                  // Src: (fsub:f32 FR32:f32:$src1, FR32:f32:$src2)
                  // Dst: (SUBSSrr:f32 FR32:f32:$src1, FR32:f32:$src2)
/*61868*/       0, /*End of Scope*/
              /*SwitchType*/ 26,  MVT::f64,// ->61897
/*61871*/       OPC_Scope, 11, /*->61884*/ // 2 children in Scope
/*61873*/         OPC_CheckPatternPredicate, 7, // (!Subtarget->hasSSE2())
/*61875*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::SUB_Fp64), 0,
                      1/*#VTs*/, MVT::f64, 2/*#Ops*/, 0, 1, 
                  // Src: (fsub:f64 RFP64:f64:$src1, RFP64:f64:$src2)
                  // Dst: (SUB_Fp64:f64 RFP64:f64:$src1, RFP64:f64:$src2)
/*61884*/       /*Scope*/ 11, /*->61896*/
/*61885*/         OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*61887*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::SUBSDrr), 0,
                      1/*#VTs*/, MVT::f64, 2/*#Ops*/, 0, 1, 
                  // Src: (fsub:f64 FR64:f64:$src1, FR64:f64:$src2)
                  // Dst: (SUBSDrr:f64 FR64:f64:$src1, FR64:f64:$src2)
/*61896*/       0, /*End of Scope*/
              /*SwitchType*/ 9,  MVT::f80,// ->61908
/*61899*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::SUB_Fp80), 0,
                    1/*#VTs*/, MVT::f80, 2/*#Ops*/, 0, 1, 
                // Src: (fsub:f80 RFP80:f80:$src1, RFP80:f80:$src2)
                // Dst: (SUB_Fp80:f80 RFP80:f80:$src1, RFP80:f80:$src2)
              /*SwitchType*/ 11,  MVT::v4f32,// ->61921
/*61910*/       OPC_CheckPatternPredicate, 0, // (Subtarget->hasSSE1())
/*61912*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::SUBPSrr), 0,
                    1/*#VTs*/, MVT::v4f32, 2/*#Ops*/, 0, 1, 
                // Src: (fsub:v4f32 VR128:v4f32:$src1, VR128:v4f32:$src2)
                // Dst: (SUBPSrr:v4f32 VR128:v4f32:$src1, VR128:v4f32:$src2)
              /*SwitchType*/ 11,  MVT::v2f64,// ->61934
/*61923*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*61925*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::SUBPDrr), 0,
                    1/*#VTs*/, MVT::v2f64, 2/*#Ops*/, 0, 1, 
                // Src: (fsub:v2f64 VR128:v2f64:$src1, VR128:v2f64:$src2)
                // Dst: (SUBPDrr:v2f64 VR128:v2f64:$src1, VR128:v2f64:$src2)
              0, // EndSwitchType
/*61935*/   0, /*End of Scope*/
          /*SwitchOpcode*/ 72|128,7/*968*/,  ISD::FMUL,// ->62907
/*61939*/   OPC_Scope, 19|128,1/*147*/, /*->62089*/ // 7 children in Scope
/*61942*/     OPC_RecordChild0, // #0 = $src1
/*61943*/     OPC_MoveChild, 1,
/*61945*/     OPC_CheckOpcode, ISD::LOAD,
/*61947*/     OPC_RecordMemRef,
/*61948*/     OPC_RecordNode, // #1 = 'ld' chained node
/*61949*/     OPC_CheckFoldableChainNode,
/*61950*/     OPC_RecordChild1, // #2 = $src2
/*61951*/     OPC_CheckPredicate, 2, // Predicate_unindexedload
/*61953*/     OPC_Scope, 53, /*->62008*/ // 2 children in Scope
/*61955*/       OPC_CheckPredicate, 8, // Predicate_load
/*61957*/       OPC_CheckPredicate, 9, // Predicate_dsload
/*61959*/       OPC_MoveParent,
/*61960*/       OPC_SwitchType /*2 cases */, 21,  MVT::f32,// ->61984
/*61963*/         OPC_CheckPatternPredicate, 6, // (!Subtarget->hasSSE1())
/*61965*/         OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*61968*/         OPC_EmitMergeInputChains, 1, 1, 
/*61971*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::MUL_Fp32m), 0|OPFL_Chain|OPFL_MemRefs,
                      1/*#VTs*/, MVT::f32, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                  // Src: (fmul:f32 RFP32:f32:$src1, (ld:f32 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>)
                  // Dst: (MUL_Fp32m:f32 RFP32:f32:$src1, addr:iPTR:$src2)
                /*SwitchType*/ 21,  MVT::f64,// ->62007
/*61986*/         OPC_CheckPatternPredicate, 7, // (!Subtarget->hasSSE2())
/*61988*/         OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*61991*/         OPC_EmitMergeInputChains, 1, 1, 
/*61994*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::MUL_Fp64m), 0|OPFL_Chain|OPFL_MemRefs,
                      1/*#VTs*/, MVT::f64, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                  // Src: (fmul:f64 RFP64:f64:$src1, (ld:f64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>)
                  // Dst: (MUL_Fp64m:f64 RFP64:f64:$src1, addr:iPTR:$src2)
                0, // EndSwitchType
/*62008*/     /*Scope*/ 79, /*->62088*/
/*62009*/       OPC_CheckPredicate, 48, // Predicate_extload
/*62011*/       OPC_Scope, 49, /*->62062*/ // 2 children in Scope
/*62013*/         OPC_CheckPredicate, 49, // Predicate_extloadf32
/*62015*/         OPC_MoveParent,
/*62016*/         OPC_SwitchType /*2 cases */, 21,  MVT::f64,// ->62040
/*62019*/           OPC_CheckPatternPredicate, 7, // (!Subtarget->hasSSE2())
/*62021*/           OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*62024*/           OPC_EmitMergeInputChains, 1, 1, 
/*62027*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::MUL_Fp64m32), 0|OPFL_Chain|OPFL_MemRefs,
                        1/*#VTs*/, MVT::f64, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                    // Src: (fmul:f64 RFP64:f64:$src1, (ld:f64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>)
                    // Dst: (MUL_Fp64m32:f64 RFP64:f64:$src1, addr:iPTR:$src2)
                  /*SwitchType*/ 19,  MVT::f80,// ->62061
/*62042*/           OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*62045*/           OPC_EmitMergeInputChains, 1, 1, 
/*62048*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::MUL_Fp80m32), 0|OPFL_Chain|OPFL_MemRefs,
                        1/*#VTs*/, MVT::f80, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                    // Src: (fmul:f80 RFP80:f80:$src1, (ld:f80 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>)
                    // Dst: (MUL_Fp80m32:f80 RFP80:f80:$src1, addr:iPTR:$src2)
                  0, // EndSwitchType
/*62062*/       /*Scope*/ 24, /*->62087*/
/*62063*/         OPC_CheckPredicate, 50, // Predicate_extloadf64
/*62065*/         OPC_MoveParent,
/*62066*/         OPC_CheckType, MVT::f80,
/*62068*/         OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*62071*/         OPC_EmitMergeInputChains, 1, 1, 
/*62074*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::MUL_Fp80m64), 0|OPFL_Chain|OPFL_MemRefs,
                      1/*#VTs*/, MVT::f80, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                  // Src: (fmul:f80 RFP80:f80:$src1, (ld:f80 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf64>>)
                  // Dst: (MUL_Fp80m64:f80 RFP80:f80:$src1, addr:iPTR:$src2)
/*62087*/       0, /*End of Scope*/
/*62088*/     0, /*End of Scope*/
/*62089*/   /*Scope*/ 21|128,1/*149*/, /*->62240*/
/*62091*/     OPC_MoveChild, 0,
/*62093*/     OPC_CheckOpcode, ISD::LOAD,
/*62095*/     OPC_RecordMemRef,
/*62096*/     OPC_RecordNode, // #0 = 'ld' chained node
/*62097*/     OPC_CheckFoldableChainNode,
/*62098*/     OPC_RecordChild1, // #1 = $src2
/*62099*/     OPC_CheckPredicate, 2, // Predicate_unindexedload
/*62101*/     OPC_Scope, 54, /*->62157*/ // 2 children in Scope
/*62103*/       OPC_CheckPredicate, 8, // Predicate_load
/*62105*/       OPC_CheckPredicate, 9, // Predicate_dsload
/*62107*/       OPC_MoveParent,
/*62108*/       OPC_RecordChild1, // #2 = $src1
/*62109*/       OPC_SwitchType /*2 cases */, 21,  MVT::f32,// ->62133
/*62112*/         OPC_CheckPatternPredicate, 6, // (!Subtarget->hasSSE1())
/*62114*/         OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*62117*/         OPC_EmitMergeInputChains, 1, 0, 
/*62120*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::MUL_Fp32m), 0|OPFL_Chain|OPFL_MemRefs,
                      1/*#VTs*/, MVT::f32, 6/*#Ops*/, 2, 3, 4, 5, 6, 7, 
                  // Src: (fmul:f32 (ld:f32 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>, RFP32:f32:$src1)
                  // Dst: (MUL_Fp32m:f32 RFP32:f32:$src1, addr:iPTR:$src2)
                /*SwitchType*/ 21,  MVT::f64,// ->62156
/*62135*/         OPC_CheckPatternPredicate, 7, // (!Subtarget->hasSSE2())
/*62137*/         OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*62140*/         OPC_EmitMergeInputChains, 1, 0, 
/*62143*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::MUL_Fp64m), 0|OPFL_Chain|OPFL_MemRefs,
                      1/*#VTs*/, MVT::f64, 6/*#Ops*/, 2, 3, 4, 5, 6, 7, 
                  // Src: (fmul:f64 (ld:f64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>, RFP64:f64:$src1)
                  // Dst: (MUL_Fp64m:f64 RFP64:f64:$src1, addr:iPTR:$src2)
                0, // EndSwitchType
/*62157*/     /*Scope*/ 81, /*->62239*/
/*62158*/       OPC_CheckPredicate, 48, // Predicate_extload
/*62160*/       OPC_Scope, 50, /*->62212*/ // 2 children in Scope
/*62162*/         OPC_CheckPredicate, 49, // Predicate_extloadf32
/*62164*/         OPC_MoveParent,
/*62165*/         OPC_RecordChild1, // #2 = $src1
/*62166*/         OPC_SwitchType /*2 cases */, 21,  MVT::f64,// ->62190
/*62169*/           OPC_CheckPatternPredicate, 7, // (!Subtarget->hasSSE2())
/*62171*/           OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*62174*/           OPC_EmitMergeInputChains, 1, 0, 
/*62177*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::MUL_Fp64m32), 0|OPFL_Chain|OPFL_MemRefs,
                        1/*#VTs*/, MVT::f64, 6/*#Ops*/, 2, 3, 4, 5, 6, 7, 
                    // Src: (fmul:f64 (ld:f64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>, RFP64:f64:$src1)
                    // Dst: (MUL_Fp64m32:f64 RFP64:f64:$src1, addr:iPTR:$src2)
                  /*SwitchType*/ 19,  MVT::f80,// ->62211
/*62192*/           OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*62195*/           OPC_EmitMergeInputChains, 1, 0, 
/*62198*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::MUL_Fp80m32), 0|OPFL_Chain|OPFL_MemRefs,
                        1/*#VTs*/, MVT::f80, 6/*#Ops*/, 2, 3, 4, 5, 6, 7, 
                    // Src: (fmul:f80 (ld:f80 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>, RFP80:f80:$src1)
                    // Dst: (MUL_Fp80m32:f80 RFP80:f80:$src1, addr:iPTR:$src2)
                  0, // EndSwitchType
/*62212*/       /*Scope*/ 25, /*->62238*/
/*62213*/         OPC_CheckPredicate, 50, // Predicate_extloadf64
/*62215*/         OPC_MoveParent,
/*62216*/         OPC_RecordChild1, // #2 = $src1
/*62217*/         OPC_CheckType, MVT::f80,
/*62219*/         OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*62222*/         OPC_EmitMergeInputChains, 1, 0, 
/*62225*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::MUL_Fp80m64), 0|OPFL_Chain|OPFL_MemRefs,
                      1/*#VTs*/, MVT::f80, 6/*#Ops*/, 2, 3, 4, 5, 6, 7, 
                  // Src: (fmul:f80 (ld:f80 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf64>>, RFP80:f80:$src1)
                  // Dst: (MUL_Fp80m64:f80 RFP80:f80:$src1, addr:iPTR:$src2)
/*62238*/       0, /*End of Scope*/
/*62239*/     0, /*End of Scope*/
/*62240*/   /*Scope*/ 119, /*->62360*/
/*62241*/     OPC_RecordChild0, // #0 = $src1
/*62242*/     OPC_MoveChild, 1,
/*62244*/     OPC_CheckOpcode, ISD::LOAD,
/*62246*/     OPC_RecordMemRef,
/*62247*/     OPC_RecordNode, // #1 = 'ld' chained node
/*62248*/     OPC_CheckFoldableChainNode,
/*62249*/     OPC_RecordChild1, // #2 = $src2
/*62250*/     OPC_CheckPredicate, 2, // Predicate_unindexedload
/*62252*/     OPC_CheckPredicate, 8, // Predicate_load
/*62254*/     OPC_Scope, 24, /*->62280*/ // 4 children in Scope
/*62256*/       OPC_MoveParent,
/*62257*/       OPC_CheckType, MVT::f32,
/*62259*/       OPC_CheckPatternPredicate, 0, // (Subtarget->hasSSE1())
/*62261*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*62264*/       OPC_EmitMergeInputChains, 1, 1, 
/*62267*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MULSSrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::f32, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (fmul:f32 FR32:f32:$src1, (ld:f32 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)
                // Dst: (MULSSrm:f32 FR32:f32:$src1, addr:iPTR:$src2)
/*62280*/     /*Scope*/ 26, /*->62307*/
/*62281*/       OPC_CheckPredicate, 23, // Predicate_memop
/*62283*/       OPC_MoveParent,
/*62284*/       OPC_CheckType, MVT::v4f32,
/*62286*/       OPC_CheckPatternPredicate, 0, // (Subtarget->hasSSE1())
/*62288*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*62291*/       OPC_EmitMergeInputChains, 1, 1, 
/*62294*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MULPSrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v4f32, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (fmul:v4f32 VR128:v4f32:$src1, (ld:v4f32 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>)
                // Dst: (MULPSrm:v4f32 VR128:v4f32:$src1, addr:iPTR:$src2)
/*62307*/     /*Scope*/ 24, /*->62332*/
/*62308*/       OPC_MoveParent,
/*62309*/       OPC_CheckType, MVT::f64,
/*62311*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*62313*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*62316*/       OPC_EmitMergeInputChains, 1, 1, 
/*62319*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MULSDrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::f64, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (fmul:f64 FR64:f64:$src1, (ld:f64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)
                // Dst: (MULSDrm:f64 FR64:f64:$src1, addr:iPTR:$src2)
/*62332*/     /*Scope*/ 26, /*->62359*/
/*62333*/       OPC_CheckPredicate, 23, // Predicate_memop
/*62335*/       OPC_MoveParent,
/*62336*/       OPC_CheckType, MVT::v2f64,
/*62338*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*62340*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*62343*/       OPC_EmitMergeInputChains, 1, 1, 
/*62346*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MULPDrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v2f64, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (fmul:v2f64 VR128:v2f64:$src1, (ld:v2f64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>)
                // Dst: (MULPDrm:v2f64 VR128:v2f64:$src1, addr:iPTR:$src2)
/*62359*/     0, /*End of Scope*/
/*62360*/   /*Scope*/ 122, /*->62483*/
/*62361*/     OPC_MoveChild, 0,
/*62363*/     OPC_CheckOpcode, ISD::LOAD,
/*62365*/     OPC_RecordMemRef,
/*62366*/     OPC_RecordNode, // #0 = 'ld' chained node
/*62367*/     OPC_CheckFoldableChainNode,
/*62368*/     OPC_RecordChild1, // #1 = $src2
/*62369*/     OPC_CheckPredicate, 2, // Predicate_unindexedload
/*62371*/     OPC_CheckPredicate, 8, // Predicate_load
/*62373*/     OPC_Scope, 25, /*->62400*/ // 4 children in Scope
/*62375*/       OPC_MoveParent,
/*62376*/       OPC_RecordChild1, // #2 = $src1
/*62377*/       OPC_CheckType, MVT::f32,
/*62379*/       OPC_CheckPatternPredicate, 0, // (Subtarget->hasSSE1())
/*62381*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*62384*/       OPC_EmitMergeInputChains, 1, 0, 
/*62387*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MULSSrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::f32, 6/*#Ops*/, 2, 3, 4, 5, 6, 7, 
                // Src: (fmul:f32 (ld:f32 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR32:f32:$src1)
                // Dst: (MULSSrm:f32 FR32:f32:$src1, addr:iPTR:$src2)
/*62400*/     /*Scope*/ 27, /*->62428*/
/*62401*/       OPC_CheckPredicate, 23, // Predicate_memop
/*62403*/       OPC_MoveParent,
/*62404*/       OPC_RecordChild1, // #2 = $src1
/*62405*/       OPC_CheckType, MVT::v4f32,
/*62407*/       OPC_CheckPatternPredicate, 0, // (Subtarget->hasSSE1())
/*62409*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*62412*/       OPC_EmitMergeInputChains, 1, 0, 
/*62415*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MULPSrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v4f32, 6/*#Ops*/, 2, 3, 4, 5, 6, 7, 
                // Src: (fmul:v4f32 (ld:v4f32 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>, VR128:v4f32:$src1)
                // Dst: (MULPSrm:v4f32 VR128:v4f32:$src1, addr:iPTR:$src2)
/*62428*/     /*Scope*/ 25, /*->62454*/
/*62429*/       OPC_MoveParent,
/*62430*/       OPC_RecordChild1, // #2 = $src1
/*62431*/       OPC_CheckType, MVT::f64,
/*62433*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*62435*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*62438*/       OPC_EmitMergeInputChains, 1, 0, 
/*62441*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MULSDrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::f64, 6/*#Ops*/, 2, 3, 4, 5, 6, 7, 
                // Src: (fmul:f64 (ld:f64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR64:f64:$src1)
                // Dst: (MULSDrm:f64 FR64:f64:$src1, addr:iPTR:$src2)
/*62454*/     /*Scope*/ 27, /*->62482*/
/*62455*/       OPC_CheckPredicate, 23, // Predicate_memop
/*62457*/       OPC_MoveParent,
/*62458*/       OPC_RecordChild1, // #2 = $src1
/*62459*/       OPC_CheckType, MVT::v2f64,
/*62461*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*62463*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*62466*/       OPC_EmitMergeInputChains, 1, 0, 
/*62469*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MULPDrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v2f64, 6/*#Ops*/, 2, 3, 4, 5, 6, 7, 
                // Src: (fmul:v2f64 (ld:v2f64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>, VR128:v2f64:$src1)
                // Dst: (MULPDrm:v2f64 VR128:v2f64:$src1, addr:iPTR:$src2)
/*62482*/     0, /*End of Scope*/
/*62483*/   /*Scope*/ 32|128,1/*160*/, /*->62645*/
/*62485*/     OPC_RecordChild0, // #0 = $src1
/*62486*/     OPC_MoveChild, 1,
/*62488*/     OPC_CheckOpcode, X86ISD::FILD,
/*62490*/     OPC_RecordNode, // #1 = 'X86fild' chained node
/*62491*/     OPC_CheckFoldableChainNode,
/*62492*/     OPC_RecordChild1, // #2 = $src2
/*62493*/     OPC_MoveChild, 2,
/*62495*/     OPC_Scope, 73, /*->62570*/ // 2 children in Scope
/*62497*/       OPC_CheckValueType, MVT::i16,
/*62499*/       OPC_MoveParent,
/*62500*/       OPC_MoveParent,
/*62501*/       OPC_SwitchType /*3 cases */, 21,  MVT::f32,// ->62525
/*62504*/         OPC_CheckPatternPredicate, 6, // (!Subtarget->hasSSE1())
/*62506*/         OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*62509*/         OPC_EmitMergeInputChains, 1, 1, 
/*62512*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::MUL_FpI16m32), 0|OPFL_Chain,
                      1/*#VTs*/, MVT::f32, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                  // Src: (fmul:f32 RFP32:f32:$src1, (X86fild:f32 addr:iPTR:$src2, i16:Other))
                  // Dst: (MUL_FpI16m32:f32 RFP32:f32:$src1, addr:iPTR:$src2)
                /*SwitchType*/ 21,  MVT::f64,// ->62548
/*62527*/         OPC_CheckPatternPredicate, 7, // (!Subtarget->hasSSE2())
/*62529*/         OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*62532*/         OPC_EmitMergeInputChains, 1, 1, 
/*62535*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::MUL_FpI16m64), 0|OPFL_Chain,
                      1/*#VTs*/, MVT::f64, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                  // Src: (fmul:f64 RFP64:f64:$src1, (X86fild:f64 addr:iPTR:$src2, i16:Other))
                  // Dst: (MUL_FpI16m64:f64 RFP64:f64:$src1, addr:iPTR:$src2)
                /*SwitchType*/ 19,  MVT::f80,// ->62569
/*62550*/         OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*62553*/         OPC_EmitMergeInputChains, 1, 1, 
/*62556*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::MUL_FpI16m80), 0|OPFL_Chain,
                      1/*#VTs*/, MVT::f80, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                  // Src: (fmul:f80 RFP80:f80:$src1, (X86fild:f80 addr:iPTR:$src2, i16:Other))
                  // Dst: (MUL_FpI16m80:f80 RFP80:f80:$src1, addr:iPTR:$src2)
                0, // EndSwitchType
/*62570*/     /*Scope*/ 73, /*->62644*/
/*62571*/       OPC_CheckValueType, MVT::i32,
/*62573*/       OPC_MoveParent,
/*62574*/       OPC_MoveParent,
/*62575*/       OPC_SwitchType /*3 cases */, 21,  MVT::f32,// ->62599
/*62578*/         OPC_CheckPatternPredicate, 6, // (!Subtarget->hasSSE1())
/*62580*/         OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*62583*/         OPC_EmitMergeInputChains, 1, 1, 
/*62586*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::MUL_FpI32m32), 0|OPFL_Chain,
                      1/*#VTs*/, MVT::f32, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                  // Src: (fmul:f32 RFP32:f32:$src1, (X86fild:f32 addr:iPTR:$src2, i32:Other))
                  // Dst: (MUL_FpI32m32:f32 RFP32:f32:$src1, addr:iPTR:$src2)
                /*SwitchType*/ 21,  MVT::f64,// ->62622
/*62601*/         OPC_CheckPatternPredicate, 7, // (!Subtarget->hasSSE2())
/*62603*/         OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*62606*/         OPC_EmitMergeInputChains, 1, 1, 
/*62609*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::MUL_FpI32m64), 0|OPFL_Chain,
                      1/*#VTs*/, MVT::f64, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                  // Src: (fmul:f64 RFP64:f64:$src1, (X86fild:f64 addr:iPTR:$src2, i32:Other))
                  // Dst: (MUL_FpI32m64:f64 RFP64:f64:$src1, addr:iPTR:$src2)
                /*SwitchType*/ 19,  MVT::f80,// ->62643
/*62624*/         OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*62627*/         OPC_EmitMergeInputChains, 1, 1, 
/*62630*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::MUL_FpI32m80), 0|OPFL_Chain,
                      1/*#VTs*/, MVT::f80, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                  // Src: (fmul:f80 RFP80:f80:$src1, (X86fild:f80 addr:iPTR:$src2, i32:Other))
                  // Dst: (MUL_FpI32m80:f80 RFP80:f80:$src1, addr:iPTR:$src2)
                0, // EndSwitchType
/*62644*/     0, /*End of Scope*/
/*62645*/   /*Scope*/ 33|128,1/*161*/, /*->62808*/
/*62647*/     OPC_MoveChild, 0,
/*62649*/     OPC_CheckOpcode, X86ISD::FILD,
/*62651*/     OPC_RecordNode, // #0 = 'X86fild' chained node
/*62652*/     OPC_CheckFoldableChainNode,
/*62653*/     OPC_RecordChild1, // #1 = $src2
/*62654*/     OPC_MoveChild, 2,
/*62656*/     OPC_Scope, 74, /*->62732*/ // 2 children in Scope
/*62658*/       OPC_CheckValueType, MVT::i16,
/*62660*/       OPC_MoveParent,
/*62661*/       OPC_MoveParent,
/*62662*/       OPC_RecordChild1, // #2 = $src1
/*62663*/       OPC_SwitchType /*3 cases */, 21,  MVT::f32,// ->62687
/*62666*/         OPC_CheckPatternPredicate, 6, // (!Subtarget->hasSSE1())
/*62668*/         OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*62671*/         OPC_EmitMergeInputChains, 1, 0, 
/*62674*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::MUL_FpI16m32), 0|OPFL_Chain,
                      1/*#VTs*/, MVT::f32, 6/*#Ops*/, 2, 3, 4, 5, 6, 7, 
                  // Src: (fmul:f32 (X86fild:f32 addr:iPTR:$src2, i16:Other), RFP32:f32:$src1)
                  // Dst: (MUL_FpI16m32:f32 RFP32:f32:$src1, addr:iPTR:$src2)
                /*SwitchType*/ 21,  MVT::f64,// ->62710
/*62689*/         OPC_CheckPatternPredicate, 7, // (!Subtarget->hasSSE2())
/*62691*/         OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*62694*/         OPC_EmitMergeInputChains, 1, 0, 
/*62697*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::MUL_FpI16m64), 0|OPFL_Chain,
                      1/*#VTs*/, MVT::f64, 6/*#Ops*/, 2, 3, 4, 5, 6, 7, 
                  // Src: (fmul:f64 (X86fild:f64 addr:iPTR:$src2, i16:Other), RFP64:f64:$src1)
                  // Dst: (MUL_FpI16m64:f64 RFP64:f64:$src1, addr:iPTR:$src2)
                /*SwitchType*/ 19,  MVT::f80,// ->62731
/*62712*/         OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*62715*/         OPC_EmitMergeInputChains, 1, 0, 
/*62718*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::MUL_FpI16m80), 0|OPFL_Chain,
                      1/*#VTs*/, MVT::f80, 6/*#Ops*/, 2, 3, 4, 5, 6, 7, 
                  // Src: (fmul:f80 (X86fild:f80 addr:iPTR:$src2, i16:Other), RFP80:f80:$src1)
                  // Dst: (MUL_FpI16m80:f80 RFP80:f80:$src1, addr:iPTR:$src2)
                0, // EndSwitchType
/*62732*/     /*Scope*/ 74, /*->62807*/
/*62733*/       OPC_CheckValueType, MVT::i32,
/*62735*/       OPC_MoveParent,
/*62736*/       OPC_MoveParent,
/*62737*/       OPC_RecordChild1, // #2 = $src1
/*62738*/       OPC_SwitchType /*3 cases */, 21,  MVT::f32,// ->62762
/*62741*/         OPC_CheckPatternPredicate, 6, // (!Subtarget->hasSSE1())
/*62743*/         OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*62746*/         OPC_EmitMergeInputChains, 1, 0, 
/*62749*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::MUL_FpI32m32), 0|OPFL_Chain,
                      1/*#VTs*/, MVT::f32, 6/*#Ops*/, 2, 3, 4, 5, 6, 7, 
                  // Src: (fmul:f32 (X86fild:f32 addr:iPTR:$src2, i32:Other), RFP32:f32:$src1)
                  // Dst: (MUL_FpI32m32:f32 RFP32:f32:$src1, addr:iPTR:$src2)
                /*SwitchType*/ 21,  MVT::f64,// ->62785
/*62764*/         OPC_CheckPatternPredicate, 7, // (!Subtarget->hasSSE2())
/*62766*/         OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*62769*/         OPC_EmitMergeInputChains, 1, 0, 
/*62772*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::MUL_FpI32m64), 0|OPFL_Chain,
                      1/*#VTs*/, MVT::f64, 6/*#Ops*/, 2, 3, 4, 5, 6, 7, 
                  // Src: (fmul:f64 (X86fild:f64 addr:iPTR:$src2, i32:Other), RFP64:f64:$src1)
                  // Dst: (MUL_FpI32m64:f64 RFP64:f64:$src1, addr:iPTR:$src2)
                /*SwitchType*/ 19,  MVT::f80,// ->62806
/*62787*/         OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*62790*/         OPC_EmitMergeInputChains, 1, 0, 
/*62793*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::MUL_FpI32m80), 0|OPFL_Chain,
                      1/*#VTs*/, MVT::f80, 6/*#Ops*/, 2, 3, 4, 5, 6, 7, 
                  // Src: (fmul:f80 (X86fild:f80 addr:iPTR:$src2, i32:Other), RFP80:f80:$src1)
                  // Dst: (MUL_FpI32m80:f80 RFP80:f80:$src1, addr:iPTR:$src2)
                0, // EndSwitchType
/*62807*/     0, /*End of Scope*/
/*62808*/   /*Scope*/ 97, /*->62906*/
/*62809*/     OPC_RecordChild0, // #0 = $src1
/*62810*/     OPC_RecordChild1, // #1 = $src2
/*62811*/     OPC_SwitchType /*5 cases */, 26,  MVT::f32,// ->62840
/*62814*/       OPC_Scope, 11, /*->62827*/ // 2 children in Scope
/*62816*/         OPC_CheckPatternPredicate, 6, // (!Subtarget->hasSSE1())
/*62818*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::MUL_Fp32), 0,
                      1/*#VTs*/, MVT::f32, 2/*#Ops*/, 0, 1, 
                  // Src: (fmul:f32 RFP32:f32:$src1, RFP32:f32:$src2)
                  // Dst: (MUL_Fp32:f32 RFP32:f32:$src1, RFP32:f32:$src2)
/*62827*/       /*Scope*/ 11, /*->62839*/
/*62828*/         OPC_CheckPatternPredicate, 0, // (Subtarget->hasSSE1())
/*62830*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::MULSSrr), 0,
                      1/*#VTs*/, MVT::f32, 2/*#Ops*/, 0, 1, 
                  // Src: (fmul:f32 FR32:f32:$src1, FR32:f32:$src2)
                  // Dst: (MULSSrr:f32 FR32:f32:$src1, FR32:f32:$src2)
/*62839*/       0, /*End of Scope*/
              /*SwitchType*/ 26,  MVT::f64,// ->62868
/*62842*/       OPC_Scope, 11, /*->62855*/ // 2 children in Scope
/*62844*/         OPC_CheckPatternPredicate, 7, // (!Subtarget->hasSSE2())
/*62846*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::MUL_Fp64), 0,
                      1/*#VTs*/, MVT::f64, 2/*#Ops*/, 0, 1, 
                  // Src: (fmul:f64 RFP64:f64:$src1, RFP64:f64:$src2)
                  // Dst: (MUL_Fp64:f64 RFP64:f64:$src1, RFP64:f64:$src2)
/*62855*/       /*Scope*/ 11, /*->62867*/
/*62856*/         OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*62858*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::MULSDrr), 0,
                      1/*#VTs*/, MVT::f64, 2/*#Ops*/, 0, 1, 
                  // Src: (fmul:f64 FR64:f64:$src1, FR64:f64:$src2)
                  // Dst: (MULSDrr:f64 FR64:f64:$src1, FR64:f64:$src2)
/*62867*/       0, /*End of Scope*/
              /*SwitchType*/ 9,  MVT::f80,// ->62879
/*62870*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MUL_Fp80), 0,
                    1/*#VTs*/, MVT::f80, 2/*#Ops*/, 0, 1, 
                // Src: (fmul:f80 RFP80:f80:$src1, RFP80:f80:$src2)
                // Dst: (MUL_Fp80:f80 RFP80:f80:$src1, RFP80:f80:$src2)
              /*SwitchType*/ 11,  MVT::v4f32,// ->62892
/*62881*/       OPC_CheckPatternPredicate, 0, // (Subtarget->hasSSE1())
/*62883*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MULPSrr), 0,
                    1/*#VTs*/, MVT::v4f32, 2/*#Ops*/, 0, 1, 
                // Src: (fmul:v4f32 VR128:v4f32:$src1, VR128:v4f32:$src2)
                // Dst: (MULPSrr:v4f32 VR128:v4f32:$src1, VR128:v4f32:$src2)
              /*SwitchType*/ 11,  MVT::v2f64,// ->62905
/*62894*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*62896*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MULPDrr), 0,
                    1/*#VTs*/, MVT::v2f64, 2/*#Ops*/, 0, 1, 
                // Src: (fmul:v2f64 VR128:v2f64:$src1, VR128:v2f64:$src2)
                // Dst: (MULPDrr:v2f64 VR128:v2f64:$src1, VR128:v2f64:$src2)
              0, // EndSwitchType
/*62906*/   0, /*End of Scope*/
          /*SwitchOpcode*/ 114|128,5/*754*/,  ISD::FDIV,// ->63664
/*62910*/   OPC_RecordChild0, // #0 = $src1
/*62911*/   OPC_Scope, 12|128,5/*652*/, /*->63566*/ // 2 children in Scope
/*62914*/     OPC_MoveChild, 1,
/*62916*/     OPC_SwitchOpcode /*2 cases */, 1|128,3/*385*/,  ISD::LOAD,// ->63305
/*62920*/       OPC_RecordMemRef,
/*62921*/       OPC_RecordNode, // #1 = 'ld' chained node
/*62922*/       OPC_CheckFoldableChainNode,
/*62923*/       OPC_RecordChild1, // #2 = $src2
/*62924*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*62926*/       OPC_Scope, 53, /*->62981*/ // 5 children in Scope
/*62928*/         OPC_CheckPredicate, 8, // Predicate_load
/*62930*/         OPC_CheckPredicate, 9, // Predicate_dsload
/*62932*/         OPC_MoveParent,
/*62933*/         OPC_SwitchType /*2 cases */, 21,  MVT::f32,// ->62957
/*62936*/           OPC_CheckPatternPredicate, 6, // (!Subtarget->hasSSE1())
/*62938*/           OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*62941*/           OPC_EmitMergeInputChains, 1, 1, 
/*62944*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::DIV_Fp32m), 0|OPFL_Chain|OPFL_MemRefs,
                        1/*#VTs*/, MVT::f32, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                    // Src: (fdiv:f32 RFP32:f32:$src1, (ld:f32 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>)
                    // Dst: (DIV_Fp32m:f32 RFP32:f32:$src1, addr:iPTR:$src2)
                  /*SwitchType*/ 21,  MVT::f64,// ->62980
/*62959*/           OPC_CheckPatternPredicate, 7, // (!Subtarget->hasSSE2())
/*62961*/           OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*62964*/           OPC_EmitMergeInputChains, 1, 1, 
/*62967*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::DIV_Fp64m), 0|OPFL_Chain|OPFL_MemRefs,
                        1/*#VTs*/, MVT::f64, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                    // Src: (fdiv:f64 RFP64:f64:$src1, (ld:f64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>)
                    // Dst: (DIV_Fp64m:f64 RFP64:f64:$src1, addr:iPTR:$src2)
                  0, // EndSwitchType
/*62981*/       /*Scope*/ 79, /*->63061*/
/*62982*/         OPC_CheckPredicate, 48, // Predicate_extload
/*62984*/         OPC_Scope, 49, /*->63035*/ // 2 children in Scope
/*62986*/           OPC_CheckPredicate, 49, // Predicate_extloadf32
/*62988*/           OPC_MoveParent,
/*62989*/           OPC_SwitchType /*2 cases */, 21,  MVT::f64,// ->63013
/*62992*/             OPC_CheckPatternPredicate, 7, // (!Subtarget->hasSSE2())
/*62994*/             OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*62997*/             OPC_EmitMergeInputChains, 1, 1, 
/*63000*/             OPC_MorphNodeTo, TARGET_OPCODE(X86::DIV_Fp64m32), 0|OPFL_Chain|OPFL_MemRefs,
                          1/*#VTs*/, MVT::f64, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                      // Src: (fdiv:f64 RFP64:f64:$src1, (ld:f64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>)
                      // Dst: (DIV_Fp64m32:f64 RFP64:f64:$src1, addr:iPTR:$src2)
                    /*SwitchType*/ 19,  MVT::f80,// ->63034
/*63015*/             OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*63018*/             OPC_EmitMergeInputChains, 1, 1, 
/*63021*/             OPC_MorphNodeTo, TARGET_OPCODE(X86::DIV_Fp80m32), 0|OPFL_Chain|OPFL_MemRefs,
                          1/*#VTs*/, MVT::f80, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                      // Src: (fdiv:f80 RFP80:f80:$src1, (ld:f80 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>)
                      // Dst: (DIV_Fp80m32:f80 RFP80:f80:$src1, addr:iPTR:$src2)
                    0, // EndSwitchType
/*63035*/         /*Scope*/ 24, /*->63060*/
/*63036*/           OPC_CheckPredicate, 50, // Predicate_extloadf64
/*63038*/           OPC_MoveParent,
/*63039*/           OPC_CheckType, MVT::f80,
/*63041*/           OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*63044*/           OPC_EmitMergeInputChains, 1, 1, 
/*63047*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::DIV_Fp80m64), 0|OPFL_Chain|OPFL_MemRefs,
                        1/*#VTs*/, MVT::f80, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                    // Src: (fdiv:f80 RFP80:f80:$src1, (ld:f80 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf64>>)
                    // Dst: (DIV_Fp80m64:f80 RFP80:f80:$src1, addr:iPTR:$src2)
/*63060*/         0, /*End of Scope*/
/*63061*/       /*Scope*/ 53, /*->63115*/
/*63062*/         OPC_CheckPredicate, 8, // Predicate_load
/*63064*/         OPC_CheckPredicate, 9, // Predicate_dsload
/*63066*/         OPC_MoveParent,
/*63067*/         OPC_SwitchType /*2 cases */, 21,  MVT::f32,// ->63091
/*63070*/           OPC_CheckPatternPredicate, 6, // (!Subtarget->hasSSE1())
/*63072*/           OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*63075*/           OPC_EmitMergeInputChains, 1, 1, 
/*63078*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::DIVR_Fp32m), 0|OPFL_Chain|OPFL_MemRefs,
                        1/*#VTs*/, MVT::f32, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                    // Src: (fdiv:f32 RFP32:f32:$src1, (ld:f32 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>)
                    // Dst: (DIVR_Fp32m:f32 RFP32:f32:$src1, addr:iPTR:$src2)
                  /*SwitchType*/ 21,  MVT::f64,// ->63114
/*63093*/           OPC_CheckPatternPredicate, 7, // (!Subtarget->hasSSE2())
/*63095*/           OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*63098*/           OPC_EmitMergeInputChains, 1, 1, 
/*63101*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::DIVR_Fp64m), 0|OPFL_Chain|OPFL_MemRefs,
                        1/*#VTs*/, MVT::f64, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                    // Src: (fdiv:f64 RFP64:f64:$src1, (ld:f64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>)
                    // Dst: (DIVR_Fp64m:f64 RFP64:f64:$src1, addr:iPTR:$src2)
                  0, // EndSwitchType
/*63115*/       /*Scope*/ 79, /*->63195*/
/*63116*/         OPC_CheckPredicate, 48, // Predicate_extload
/*63118*/         OPC_Scope, 49, /*->63169*/ // 2 children in Scope
/*63120*/           OPC_CheckPredicate, 49, // Predicate_extloadf32
/*63122*/           OPC_MoveParent,
/*63123*/           OPC_SwitchType /*2 cases */, 21,  MVT::f64,// ->63147
/*63126*/             OPC_CheckPatternPredicate, 7, // (!Subtarget->hasSSE2())
/*63128*/             OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*63131*/             OPC_EmitMergeInputChains, 1, 1, 
/*63134*/             OPC_MorphNodeTo, TARGET_OPCODE(X86::DIVR_Fp64m32), 0|OPFL_Chain|OPFL_MemRefs,
                          1/*#VTs*/, MVT::f64, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                      // Src: (fdiv:f64 RFP64:f64:$src1, (ld:f64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>)
                      // Dst: (DIVR_Fp64m32:f64 RFP64:f64:$src1, addr:iPTR:$src2)
                    /*SwitchType*/ 19,  MVT::f80,// ->63168
/*63149*/             OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*63152*/             OPC_EmitMergeInputChains, 1, 1, 
/*63155*/             OPC_MorphNodeTo, TARGET_OPCODE(X86::DIVR_Fp80m32), 0|OPFL_Chain|OPFL_MemRefs,
                          1/*#VTs*/, MVT::f80, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                      // Src: (fdiv:f80 RFP80:f80:$src1, (ld:f80 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>)
                      // Dst: (DIVR_Fp80m32:f80 RFP80:f80:$src1, addr:iPTR:$src2)
                    0, // EndSwitchType
/*63169*/         /*Scope*/ 24, /*->63194*/
/*63170*/           OPC_CheckPredicate, 50, // Predicate_extloadf64
/*63172*/           OPC_MoveParent,
/*63173*/           OPC_CheckType, MVT::f80,
/*63175*/           OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*63178*/           OPC_EmitMergeInputChains, 1, 1, 
/*63181*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::DIVR_Fp80m64), 0|OPFL_Chain|OPFL_MemRefs,
                        1/*#VTs*/, MVT::f80, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                    // Src: (fdiv:f80 RFP80:f80:$src1, (ld:f80 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf64>>)
                    // Dst: (DIVR_Fp80m64:f80 RFP80:f80:$src1, addr:iPTR:$src2)
/*63194*/         0, /*End of Scope*/
/*63195*/       /*Scope*/ 108, /*->63304*/
/*63196*/         OPC_CheckPredicate, 8, // Predicate_load
/*63198*/         OPC_Scope, 24, /*->63224*/ // 4 children in Scope
/*63200*/           OPC_MoveParent,
/*63201*/           OPC_CheckType, MVT::f32,
/*63203*/           OPC_CheckPatternPredicate, 0, // (Subtarget->hasSSE1())
/*63205*/           OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*63208*/           OPC_EmitMergeInputChains, 1, 1, 
/*63211*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::DIVSSrm), 0|OPFL_Chain|OPFL_MemRefs,
                        1/*#VTs*/, MVT::f32, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                    // Src: (fdiv:f32 FR32:f32:$src1, (ld:f32 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)
                    // Dst: (DIVSSrm:f32 FR32:f32:$src1, addr:iPTR:$src2)
/*63224*/         /*Scope*/ 26, /*->63251*/
/*63225*/           OPC_CheckPredicate, 23, // Predicate_memop
/*63227*/           OPC_MoveParent,
/*63228*/           OPC_CheckType, MVT::v4f32,
/*63230*/           OPC_CheckPatternPredicate, 0, // (Subtarget->hasSSE1())
/*63232*/           OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*63235*/           OPC_EmitMergeInputChains, 1, 1, 
/*63238*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::DIVPSrm), 0|OPFL_Chain|OPFL_MemRefs,
                        1/*#VTs*/, MVT::v4f32, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                    // Src: (fdiv:v4f32 VR128:v4f32:$src1, (ld:v4f32 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>)
                    // Dst: (DIVPSrm:v4f32 VR128:v4f32:$src1, addr:iPTR:$src2)
/*63251*/         /*Scope*/ 24, /*->63276*/
/*63252*/           OPC_MoveParent,
/*63253*/           OPC_CheckType, MVT::f64,
/*63255*/           OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*63257*/           OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*63260*/           OPC_EmitMergeInputChains, 1, 1, 
/*63263*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::DIVSDrm), 0|OPFL_Chain|OPFL_MemRefs,
                        1/*#VTs*/, MVT::f64, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                    // Src: (fdiv:f64 FR64:f64:$src1, (ld:f64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)
                    // Dst: (DIVSDrm:f64 FR64:f64:$src1, addr:iPTR:$src2)
/*63276*/         /*Scope*/ 26, /*->63303*/
/*63277*/           OPC_CheckPredicate, 23, // Predicate_memop
/*63279*/           OPC_MoveParent,
/*63280*/           OPC_CheckType, MVT::v2f64,
/*63282*/           OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*63284*/           OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*63287*/           OPC_EmitMergeInputChains, 1, 1, 
/*63290*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::DIVPDrm), 0|OPFL_Chain|OPFL_MemRefs,
                        1/*#VTs*/, MVT::v2f64, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                    // Src: (fdiv:v2f64 VR128:v2f64:$src1, (ld:v2f64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>)
                    // Dst: (DIVPDrm:v2f64 VR128:v2f64:$src1, addr:iPTR:$src2)
/*63303*/         0, /*End of Scope*/
/*63304*/       0, /*End of Scope*/
              /*SwitchOpcode*/ 1|128,2/*257*/,  X86ISD::FILD,// ->63565
/*63308*/       OPC_RecordNode, // #1 = 'X86fild' chained node
/*63309*/       OPC_CheckFoldableChainNode,
/*63310*/       OPC_RecordChild1, // #2 = $src2
/*63311*/       OPC_MoveChild, 2,
/*63313*/       OPC_Scope, 124, /*->63439*/ // 2 children in Scope
/*63315*/         OPC_CheckValueType, MVT::i16,
/*63317*/         OPC_MoveParent,
/*63318*/         OPC_MoveParent,
/*63319*/         OPC_SwitchType /*3 cases */, 38,  MVT::f32,// ->63360
/*63322*/           OPC_CheckPatternPredicate, 6, // (!Subtarget->hasSSE1())
/*63324*/           OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*63327*/           OPC_EmitMergeInputChains, 1, 1, 
/*63330*/           OPC_Scope, 13, /*->63345*/ // 2 children in Scope
/*63332*/             OPC_MorphNodeTo, TARGET_OPCODE(X86::DIV_FpI16m32), 0|OPFL_Chain,
                          1/*#VTs*/, MVT::f32, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                      // Src: (fdiv:f32 RFP32:f32:$src1, (X86fild:f32 addr:iPTR:$src2, i16:Other))
                      // Dst: (DIV_FpI16m32:f32 RFP32:f32:$src1, addr:iPTR:$src2)
/*63345*/           /*Scope*/ 13, /*->63359*/
/*63346*/             OPC_MorphNodeTo, TARGET_OPCODE(X86::DIVR_FpI16m32), 0|OPFL_Chain,
                          1/*#VTs*/, MVT::f32, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                      // Src: (fdiv:f32 RFP32:f32:$src1, (X86fild:f32 addr:iPTR:$src2, i16:Other))
                      // Dst: (DIVR_FpI16m32:f32 RFP32:f32:$src1, addr:iPTR:$src2)
/*63359*/           0, /*End of Scope*/
                  /*SwitchType*/ 38,  MVT::f64,// ->63400
/*63362*/           OPC_CheckPatternPredicate, 7, // (!Subtarget->hasSSE2())
/*63364*/           OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*63367*/           OPC_EmitMergeInputChains, 1, 1, 
/*63370*/           OPC_Scope, 13, /*->63385*/ // 2 children in Scope
/*63372*/             OPC_MorphNodeTo, TARGET_OPCODE(X86::DIV_FpI16m64), 0|OPFL_Chain,
                          1/*#VTs*/, MVT::f64, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                      // Src: (fdiv:f64 RFP64:f64:$src1, (X86fild:f64 addr:iPTR:$src2, i16:Other))
                      // Dst: (DIV_FpI16m64:f64 RFP64:f64:$src1, addr:iPTR:$src2)
/*63385*/           /*Scope*/ 13, /*->63399*/
/*63386*/             OPC_MorphNodeTo, TARGET_OPCODE(X86::DIVR_FpI16m64), 0|OPFL_Chain,
                          1/*#VTs*/, MVT::f64, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                      // Src: (fdiv:f64 RFP64:f64:$src1, (X86fild:f64 addr:iPTR:$src2, i16:Other))
                      // Dst: (DIVR_FpI16m64:f64 RFP64:f64:$src1, addr:iPTR:$src2)
/*63399*/           0, /*End of Scope*/
                  /*SwitchType*/ 36,  MVT::f80,// ->63438
/*63402*/           OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*63405*/           OPC_EmitMergeInputChains, 1, 1, 
/*63408*/           OPC_Scope, 13, /*->63423*/ // 2 children in Scope
/*63410*/             OPC_MorphNodeTo, TARGET_OPCODE(X86::DIV_FpI16m80), 0|OPFL_Chain,
                          1/*#VTs*/, MVT::f80, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                      // Src: (fdiv:f80 RFP80:f80:$src1, (X86fild:f80 addr:iPTR:$src2, i16:Other))
                      // Dst: (DIV_FpI16m80:f80 RFP80:f80:$src1, addr:iPTR:$src2)
/*63423*/           /*Scope*/ 13, /*->63437*/
/*63424*/             OPC_MorphNodeTo, TARGET_OPCODE(X86::DIVR_FpI16m80), 0|OPFL_Chain,
                          1/*#VTs*/, MVT::f80, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                      // Src: (fdiv:f80 RFP80:f80:$src1, (X86fild:f80 addr:iPTR:$src2, i16:Other))
                      // Dst: (DIVR_FpI16m80:f80 RFP80:f80:$src1, addr:iPTR:$src2)
/*63437*/           0, /*End of Scope*/
                  0, // EndSwitchType
/*63439*/       /*Scope*/ 124, /*->63564*/
/*63440*/         OPC_CheckValueType, MVT::i32,
/*63442*/         OPC_MoveParent,
/*63443*/         OPC_MoveParent,
/*63444*/         OPC_SwitchType /*3 cases */, 38,  MVT::f32,// ->63485
/*63447*/           OPC_CheckPatternPredicate, 6, // (!Subtarget->hasSSE1())
/*63449*/           OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*63452*/           OPC_EmitMergeInputChains, 1, 1, 
/*63455*/           OPC_Scope, 13, /*->63470*/ // 2 children in Scope
/*63457*/             OPC_MorphNodeTo, TARGET_OPCODE(X86::DIV_FpI32m32), 0|OPFL_Chain,
                          1/*#VTs*/, MVT::f32, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                      // Src: (fdiv:f32 RFP32:f32:$src1, (X86fild:f32 addr:iPTR:$src2, i32:Other))
                      // Dst: (DIV_FpI32m32:f32 RFP32:f32:$src1, addr:iPTR:$src2)
/*63470*/           /*Scope*/ 13, /*->63484*/
/*63471*/             OPC_MorphNodeTo, TARGET_OPCODE(X86::DIVR_FpI32m32), 0|OPFL_Chain,
                          1/*#VTs*/, MVT::f32, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                      // Src: (fdiv:f32 RFP32:f32:$src1, (X86fild:f32 addr:iPTR:$src2, i32:Other))
                      // Dst: (DIVR_FpI32m32:f32 RFP32:f32:$src1, addr:iPTR:$src2)
/*63484*/           0, /*End of Scope*/
                  /*SwitchType*/ 38,  MVT::f64,// ->63525
/*63487*/           OPC_CheckPatternPredicate, 7, // (!Subtarget->hasSSE2())
/*63489*/           OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*63492*/           OPC_EmitMergeInputChains, 1, 1, 
/*63495*/           OPC_Scope, 13, /*->63510*/ // 2 children in Scope
/*63497*/             OPC_MorphNodeTo, TARGET_OPCODE(X86::DIV_FpI32m64), 0|OPFL_Chain,
                          1/*#VTs*/, MVT::f64, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                      // Src: (fdiv:f64 RFP64:f64:$src1, (X86fild:f64 addr:iPTR:$src2, i32:Other))
                      // Dst: (DIV_FpI32m64:f64 RFP64:f64:$src1, addr:iPTR:$src2)
/*63510*/           /*Scope*/ 13, /*->63524*/
/*63511*/             OPC_MorphNodeTo, TARGET_OPCODE(X86::DIVR_FpI32m64), 0|OPFL_Chain,
                          1/*#VTs*/, MVT::f64, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                      // Src: (fdiv:f64 RFP64:f64:$src1, (X86fild:f64 addr:iPTR:$src2, i32:Other))
                      // Dst: (DIVR_FpI32m64:f64 RFP64:f64:$src1, addr:iPTR:$src2)
/*63524*/           0, /*End of Scope*/
                  /*SwitchType*/ 36,  MVT::f80,// ->63563
/*63527*/           OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*63530*/           OPC_EmitMergeInputChains, 1, 1, 
/*63533*/           OPC_Scope, 13, /*->63548*/ // 2 children in Scope
/*63535*/             OPC_MorphNodeTo, TARGET_OPCODE(X86::DIV_FpI32m80), 0|OPFL_Chain,
                          1/*#VTs*/, MVT::f80, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                      // Src: (fdiv:f80 RFP80:f80:$src1, (X86fild:f80 addr:iPTR:$src2, i32:Other))
                      // Dst: (DIV_FpI32m80:f80 RFP80:f80:$src1, addr:iPTR:$src2)
/*63548*/           /*Scope*/ 13, /*->63562*/
/*63549*/             OPC_MorphNodeTo, TARGET_OPCODE(X86::DIVR_FpI32m80), 0|OPFL_Chain,
                          1/*#VTs*/, MVT::f80, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                      // Src: (fdiv:f80 RFP80:f80:$src1, (X86fild:f80 addr:iPTR:$src2, i32:Other))
                      // Dst: (DIVR_FpI32m80:f80 RFP80:f80:$src1, addr:iPTR:$src2)
/*63562*/           0, /*End of Scope*/
                  0, // EndSwitchType
/*63564*/       0, /*End of Scope*/
              0, // EndSwitchOpcode
/*63566*/   /*Scope*/ 96, /*->63663*/
/*63567*/     OPC_RecordChild1, // #1 = $src2
/*63568*/     OPC_SwitchType /*5 cases */, 26,  MVT::f32,// ->63597
/*63571*/       OPC_Scope, 11, /*->63584*/ // 2 children in Scope
/*63573*/         OPC_CheckPatternPredicate, 6, // (!Subtarget->hasSSE1())
/*63575*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::DIV_Fp32), 0,
                      1/*#VTs*/, MVT::f32, 2/*#Ops*/, 0, 1, 
                  // Src: (fdiv:f32 RFP32:f32:$src1, RFP32:f32:$src2)
                  // Dst: (DIV_Fp32:f32 RFP32:f32:$src1, RFP32:f32:$src2)
/*63584*/       /*Scope*/ 11, /*->63596*/
/*63585*/         OPC_CheckPatternPredicate, 0, // (Subtarget->hasSSE1())
/*63587*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::DIVSSrr), 0,
                      1/*#VTs*/, MVT::f32, 2/*#Ops*/, 0, 1, 
                  // Src: (fdiv:f32 FR32:f32:$src1, FR32:f32:$src2)
                  // Dst: (DIVSSrr:f32 FR32:f32:$src1, FR32:f32:$src2)
/*63596*/       0, /*End of Scope*/
              /*SwitchType*/ 26,  MVT::f64,// ->63625
/*63599*/       OPC_Scope, 11, /*->63612*/ // 2 children in Scope
/*63601*/         OPC_CheckPatternPredicate, 7, // (!Subtarget->hasSSE2())
/*63603*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::DIV_Fp64), 0,
                      1/*#VTs*/, MVT::f64, 2/*#Ops*/, 0, 1, 
                  // Src: (fdiv:f64 RFP64:f64:$src1, RFP64:f64:$src2)
                  // Dst: (DIV_Fp64:f64 RFP64:f64:$src1, RFP64:f64:$src2)
/*63612*/       /*Scope*/ 11, /*->63624*/
/*63613*/         OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*63615*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::DIVSDrr), 0,
                      1/*#VTs*/, MVT::f64, 2/*#Ops*/, 0, 1, 
                  // Src: (fdiv:f64 FR64:f64:$src1, FR64:f64:$src2)
                  // Dst: (DIVSDrr:f64 FR64:f64:$src1, FR64:f64:$src2)
/*63624*/       0, /*End of Scope*/
              /*SwitchType*/ 9,  MVT::f80,// ->63636
/*63627*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::DIV_Fp80), 0,
                    1/*#VTs*/, MVT::f80, 2/*#Ops*/, 0, 1, 
                // Src: (fdiv:f80 RFP80:f80:$src1, RFP80:f80:$src2)
                // Dst: (DIV_Fp80:f80 RFP80:f80:$src1, RFP80:f80:$src2)
              /*SwitchType*/ 11,  MVT::v4f32,// ->63649
/*63638*/       OPC_CheckPatternPredicate, 0, // (Subtarget->hasSSE1())
/*63640*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::DIVPSrr), 0,
                    1/*#VTs*/, MVT::v4f32, 2/*#Ops*/, 0, 1, 
                // Src: (fdiv:v4f32 VR128:v4f32:$src1, VR128:v4f32:$src2)
                // Dst: (DIVPSrr:v4f32 VR128:v4f32:$src1, VR128:v4f32:$src2)
              /*SwitchType*/ 11,  MVT::v2f64,// ->63662
/*63651*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*63653*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::DIVPDrr), 0,
                    1/*#VTs*/, MVT::v2f64, 2/*#Ops*/, 0, 1, 
                // Src: (fdiv:v2f64 VR128:v2f64:$src1, VR128:v2f64:$src2)
                // Dst: (DIVPDrr:v2f64 VR128:v2f64:$src1, VR128:v2f64:$src2)
              0, // EndSwitchType
/*63663*/   0, /*End of Scope*/
          /*SwitchOpcode*/ 94,  ISD::BRIND,// ->63760
/*63666*/   OPC_RecordNode,   // #0 = 'brind' chained node
/*63667*/   OPC_Scope, 60, /*->63729*/ // 2 children in Scope
/*63669*/     OPC_MoveChild, 1,
/*63671*/     OPC_CheckOpcode, ISD::LOAD,
/*63673*/     OPC_RecordMemRef,
/*63674*/     OPC_RecordNode, // #1 = 'ld' chained node
/*63675*/     OPC_CheckFoldableChainNode,
/*63676*/     OPC_RecordChild1, // #2 = $dst
/*63677*/     OPC_CheckPredicate, 2, // Predicate_unindexedload
/*63679*/     OPC_SwitchType /*2 cases */, 21,  MVT::i32,// ->63703
/*63682*/       OPC_CheckPredicate, 3, // Predicate_loadi32
/*63684*/       OPC_MoveParent,
/*63685*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #3 #4 #5 #6 #7
/*63688*/       OPC_EmitMergeInputChains, 2, 0, 1, 
/*63692*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::JMP32m), 0|OPFL_Chain|OPFL_MemRefs,
                    0/*#VTs*/, 5/*#Ops*/, 3, 4, 5, 6, 7, 
                // Src: (brind:isVoid (ld:i32 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)
                // Dst: (JMP32m:isVoid addr:iPTR:$dst)
              /*SwitchType*/ 23,  MVT::i64,// ->63728
/*63705*/       OPC_CheckPredicate, 8, // Predicate_load
/*63707*/       OPC_CheckPredicate, 9, // Predicate_dsload
/*63709*/       OPC_MoveParent,
/*63710*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #3 #4 #5 #6 #7
/*63713*/       OPC_EmitMergeInputChains, 2, 0, 1, 
/*63717*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::JMP64m), 0|OPFL_Chain|OPFL_MemRefs,
                    0/*#VTs*/, 5/*#Ops*/, 3, 4, 5, 6, 7, 
                // Src: (brind:isVoid (ld:i64 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>)
                // Dst: (JMP64m:isVoid addr:iPTR:$dst)
              0, // EndSwitchType
/*63729*/   /*Scope*/ 29, /*->63759*/
/*63730*/     OPC_RecordChild1, // #1 = $dst
/*63731*/     OPC_Scope, 12, /*->63745*/ // 2 children in Scope
/*63733*/       OPC_CheckChild1Type, MVT::i32,
/*63735*/       OPC_EmitMergeInputChains, 1, 0, 
/*63738*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::JMP32r), 0|OPFL_Chain,
                    0/*#VTs*/, 1/*#Ops*/, 1, 
                // Src: (brind:isVoid GR32:i32:$dst)
                // Dst: (JMP32r:isVoid GR32:i32:$dst)
/*63745*/     /*Scope*/ 12, /*->63758*/
/*63746*/       OPC_CheckChild1Type, MVT::i64,
/*63748*/       OPC_EmitMergeInputChains, 1, 0, 
/*63751*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::JMP64r), 0|OPFL_Chain,
                    0/*#VTs*/, 1/*#Ops*/, 1, 
                // Src: (brind:isVoid GR64:i64:$dst)
                // Dst: (JMP64r:isVoid GR64:i64:$dst)
/*63758*/     0, /*End of Scope*/
/*63759*/   0, /*End of Scope*/
          /*SwitchOpcode*/ 4|128,2/*260*/,  X86ISD::CALL,// ->64023
/*63763*/   OPC_RecordNode,   // #0 = 'X86call' chained node
/*63764*/   OPC_CaptureFlagInput,
/*63765*/   OPC_Scope, 86, /*->63853*/ // 2 children in Scope
/*63767*/     OPC_MoveChild, 1,
/*63769*/     OPC_CheckOpcode, ISD::LOAD,
/*63771*/     OPC_RecordMemRef,
/*63772*/     OPC_RecordNode, // #1 = 'ld' chained node
/*63773*/     OPC_CheckFoldableChainNode,
/*63774*/     OPC_RecordChild1, // #2 = $dst
/*63775*/     OPC_CheckPredicate, 2, // Predicate_unindexedload
/*63777*/     OPC_SwitchType /*2 cases */, 21,  MVT::i32,// ->63801
/*63780*/       OPC_CheckPredicate, 3, // Predicate_loadi32
/*63782*/       OPC_MoveParent,
/*63783*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #3 #4 #5 #6 #7
/*63786*/       OPC_EmitMergeInputChains, 2, 0, 1, 
/*63790*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::CALL32m), 0|OPFL_Chain|OPFL_FlagInput|OPFL_FlagOutput|OPFL_MemRefs|OPFL_Variadic1,
                    0/*#VTs*/, 5/*#Ops*/, 3, 4, 5, 6, 7, 
                // Src: (X86call:isVoid (ld:i32 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)
                // Dst: (CALL32m:isVoid addr:iPTR:$dst)
              /*SwitchType*/ 49,  MVT::i64,// ->63852
/*63803*/       OPC_CheckPredicate, 8, // Predicate_load
/*63805*/       OPC_CheckPredicate, 9, // Predicate_dsload
/*63807*/       OPC_MoveParent,
/*63808*/       OPC_Scope, 20, /*->63830*/ // 2 children in Scope
/*63810*/         OPC_CheckPatternPredicate, 16, // (!Subtarget->isTargetWin64())
/*63812*/         OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #3 #4 #5 #6 #7
/*63815*/         OPC_EmitMergeInputChains, 2, 0, 1, 
/*63819*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::CALL64m), 0|OPFL_Chain|OPFL_FlagInput|OPFL_FlagOutput|OPFL_MemRefs|OPFL_Variadic1,
                      0/*#VTs*/, 5/*#Ops*/, 3, 4, 5, 6, 7, 
                  // Src: (X86call:isVoid (ld:i64 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>)
                  // Dst: (CALL64m:isVoid addr:iPTR:$dst)
/*63830*/       /*Scope*/ 20, /*->63851*/
/*63831*/         OPC_CheckPatternPredicate, 17, // (Subtarget->isTargetWin64())
/*63833*/         OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #3 #4 #5 #6 #7
/*63836*/         OPC_EmitMergeInputChains, 2, 0, 1, 
/*63840*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::WINCALL64m), 0|OPFL_Chain|OPFL_FlagInput|OPFL_FlagOutput|OPFL_MemRefs|OPFL_Variadic1,
                      0/*#VTs*/, 5/*#Ops*/, 3, 4, 5, 6, 7, 
                  // Src: (X86call:isVoid (ld:i64 addr:iPTR:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>)
                  // Dst: (WINCALL64m:isVoid addr:iPTR:$dst)
/*63851*/       0, /*End of Scope*/
              0, // EndSwitchType
/*63853*/   /*Scope*/ 39|128,1/*167*/, /*->64022*/
/*63855*/     OPC_RecordChild1, // #1 = $dst
/*63856*/     OPC_Scope, 119, /*->63977*/ // 3 children in Scope
/*63858*/       OPC_MoveChild, 1,
/*63860*/       OPC_SwitchOpcode /*3 cases */, 46,  ISD::TargetGlobalAddress,// ->63909
/*63863*/         OPC_SwitchType /*2 cases */, 11,  MVT::i32,// ->63877
/*63866*/           OPC_MoveParent,
/*63867*/           OPC_EmitMergeInputChains, 1, 0, 
/*63870*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::CALLpcrel32), 0|OPFL_Chain|OPFL_FlagInput|OPFL_FlagOutput|OPFL_Variadic1,
                        0/*#VTs*/, 1/*#Ops*/, 1, 
                    // Src: (X86call:isVoid (tglobaladdr:i32):$dst)
                    // Dst: (CALLpcrel32:isVoid (tglobaladdr:i32):$dst)
                  /*SwitchType*/ 29,  MVT::i64,// ->63908
/*63879*/           OPC_MoveParent,
/*63880*/           OPC_Scope, 12, /*->63894*/ // 2 children in Scope
/*63882*/             OPC_CheckPatternPredicate, 16, // (!Subtarget->isTargetWin64())
/*63884*/             OPC_EmitMergeInputChains, 1, 0, 
/*63887*/             OPC_MorphNodeTo, TARGET_OPCODE(X86::CALL64pcrel32), 0|OPFL_Chain|OPFL_FlagInput|OPFL_FlagOutput|OPFL_Variadic1,
                          0/*#VTs*/, 1/*#Ops*/, 1, 
                      // Src: (X86call:isVoid (tglobaladdr:i64):$dst)
                      // Dst: (CALL64pcrel32:isVoid (tglobaladdr:i64):$dst)
/*63894*/           /*Scope*/ 12, /*->63907*/
/*63895*/             OPC_CheckPatternPredicate, 17, // (Subtarget->isTargetWin64())
/*63897*/             OPC_EmitMergeInputChains, 1, 0, 
/*63900*/             OPC_MorphNodeTo, TARGET_OPCODE(X86::WINCALL64pcrel32), 0|OPFL_Chain|OPFL_FlagInput|OPFL_FlagOutput|OPFL_Variadic1,
                          0/*#VTs*/, 1/*#Ops*/, 1, 
                      // Src: (X86call:isVoid (tglobaladdr:i64):$dst)
                      // Dst: (WINCALL64pcrel32:isVoid (tglobaladdr:i64):$dst)
/*63907*/           0, /*End of Scope*/
                  0, // EndSwitchType
                /*SwitchOpcode*/ 46,  ISD::TargetExternalSymbol,// ->63957
/*63911*/         OPC_SwitchType /*2 cases */, 11,  MVT::i32,// ->63925
/*63914*/           OPC_MoveParent,
/*63915*/           OPC_EmitMergeInputChains, 1, 0, 
/*63918*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::CALLpcrel32), 0|OPFL_Chain|OPFL_FlagInput|OPFL_FlagOutput|OPFL_Variadic1,
                        0/*#VTs*/, 1/*#Ops*/, 1, 
                    // Src: (X86call:isVoid (texternalsym:i32):$dst)
                    // Dst: (CALLpcrel32:isVoid (texternalsym:i32):$dst)
                  /*SwitchType*/ 29,  MVT::i64,// ->63956
/*63927*/           OPC_MoveParent,
/*63928*/           OPC_Scope, 12, /*->63942*/ // 2 children in Scope
/*63930*/             OPC_CheckPatternPredicate, 16, // (!Subtarget->isTargetWin64())
/*63932*/             OPC_EmitMergeInputChains, 1, 0, 
/*63935*/             OPC_MorphNodeTo, TARGET_OPCODE(X86::CALL64pcrel32), 0|OPFL_Chain|OPFL_FlagInput|OPFL_FlagOutput|OPFL_Variadic1,
                          0/*#VTs*/, 1/*#Ops*/, 1, 
                      // Src: (X86call:isVoid (texternalsym:i64):$dst)
                      // Dst: (CALL64pcrel32:isVoid (texternalsym:i64):$dst)
/*63942*/           /*Scope*/ 12, /*->63955*/
/*63943*/             OPC_CheckPatternPredicate, 17, // (Subtarget->isTargetWin64())
/*63945*/             OPC_EmitMergeInputChains, 1, 0, 
/*63948*/             OPC_MorphNodeTo, TARGET_OPCODE(X86::WINCALL64pcrel32), 0|OPFL_Chain|OPFL_FlagInput|OPFL_FlagOutput|OPFL_Variadic1,
                          0/*#VTs*/, 1/*#Ops*/, 1, 
                      // Src: (X86call:isVoid (texternalsym:i64):$dst)
                      // Dst: (WINCALL64pcrel32:isVoid (texternalsym:i64):$dst)
/*63955*/           0, /*End of Scope*/
                  0, // EndSwitchType
                /*SwitchOpcode*/ 17,  ISD::Constant,// ->63976
/*63959*/         OPC_CheckType, MVT::i32,
/*63961*/         OPC_MoveParent,
/*63962*/         OPC_CheckPatternPredicate, 18, // (Subtarget->IsLegalToCallImmediateAddr(TM))
/*63964*/         OPC_EmitMergeInputChains, 1, 0, 
/*63967*/         OPC_EmitConvertToTarget, 1,
/*63969*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::CALLpcrel32), 0|OPFL_Chain|OPFL_FlagInput|OPFL_FlagOutput|OPFL_Variadic1,
                      0/*#VTs*/, 1/*#Ops*/, 2, 
                  // Src: (X86call:isVoid (imm:i32):$dst)
                  // Dst: (CALLpcrel32:isVoid (imm:i32):$dst)
                0, // EndSwitchOpcode
/*63977*/     /*Scope*/ 12, /*->63990*/
/*63978*/       OPC_CheckChild1Type, MVT::i32,
/*63980*/       OPC_EmitMergeInputChains, 1, 0, 
/*63983*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::CALL32r), 0|OPFL_Chain|OPFL_FlagInput|OPFL_FlagOutput|OPFL_Variadic1,
                    0/*#VTs*/, 1/*#Ops*/, 1, 
                // Src: (X86call:isVoid GR32:i32:$dst)
                // Dst: (CALL32r:isVoid GR32:i32:$dst)
/*63990*/     /*Scope*/ 30, /*->64021*/
/*63991*/       OPC_CheckChild1Type, MVT::i64,
/*63993*/       OPC_Scope, 12, /*->64007*/ // 2 children in Scope
/*63995*/         OPC_CheckPatternPredicate, 16, // (!Subtarget->isTargetWin64())
/*63997*/         OPC_EmitMergeInputChains, 1, 0, 
/*64000*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::CALL64r), 0|OPFL_Chain|OPFL_FlagInput|OPFL_FlagOutput|OPFL_Variadic1,
                      0/*#VTs*/, 1/*#Ops*/, 1, 
                  // Src: (X86call:isVoid GR64:i64:$dst)
                  // Dst: (CALL64r:isVoid GR64:i64:$dst)
/*64007*/       /*Scope*/ 12, /*->64020*/
/*64008*/         OPC_CheckPatternPredicate, 17, // (Subtarget->isTargetWin64())
/*64010*/         OPC_EmitMergeInputChains, 1, 0, 
/*64013*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::WINCALL64r), 0|OPFL_Chain|OPFL_FlagInput|OPFL_FlagOutput|OPFL_Variadic1,
                      0/*#VTs*/, 1/*#Ops*/, 1, 
                  // Src: (X86call:isVoid GR64:i64:$dst)
                  // Dst: (WINCALL64r:isVoid GR64:i64:$dst)
/*64020*/       0, /*End of Scope*/
/*64021*/     0, /*End of Scope*/
/*64022*/   0, /*End of Scope*/
          /*SwitchOpcode*/ 0|128,1/*128*/,  X86ISD::BSF,// ->64154
/*64026*/   OPC_Scope, 88, /*->64116*/ // 2 children in Scope
/*64028*/     OPC_MoveChild, 0,
/*64030*/     OPC_CheckOpcode, ISD::LOAD,
/*64032*/     OPC_RecordMemRef,
/*64033*/     OPC_RecordNode, // #0 = 'ld' chained node
/*64034*/     OPC_RecordChild1, // #1 = $src
/*64035*/     OPC_CheckPredicate, 2, // Predicate_unindexedload
/*64037*/     OPC_Scope, 24, /*->64063*/ // 3 children in Scope
/*64039*/       OPC_CheckPredicate, 6, // Predicate_loadi16
/*64041*/       OPC_MoveParent,
/*64042*/       OPC_CheckType, MVT::i16,
/*64044*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*64047*/       OPC_EmitMergeInputChains, 1, 0, 
/*64050*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::BSF16rm), 0|OPFL_Chain|OPFL_MemRefs,
                    2/*#VTs*/, MVT::i16, MVT::i32, 5/*#Ops*/, 2, 3, 4, 5, 6, 
                // Src: (X86bsf:i16 (ld:i16 addr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>)
                // Dst: (BSF16rm:i16 addr:iPTR:$src)
/*64063*/     /*Scope*/ 24, /*->64088*/
/*64064*/       OPC_CheckPredicate, 3, // Predicate_loadi32
/*64066*/       OPC_MoveParent,
/*64067*/       OPC_CheckType, MVT::i32,
/*64069*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*64072*/       OPC_EmitMergeInputChains, 1, 0, 
/*64075*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::BSF32rm), 0|OPFL_Chain|OPFL_MemRefs,
                    2/*#VTs*/, MVT::i32, MVT::i32, 5/*#Ops*/, 2, 3, 4, 5, 6, 
                // Src: (X86bsf:i32 (ld:i32 addr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)
                // Dst: (BSF32rm:i32 addr:iPTR:$src)
/*64088*/     /*Scope*/ 26, /*->64115*/
/*64089*/       OPC_CheckPredicate, 8, // Predicate_load
/*64091*/       OPC_CheckPredicate, 9, // Predicate_dsload
/*64093*/       OPC_MoveParent,
/*64094*/       OPC_CheckType, MVT::i64,
/*64096*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*64099*/       OPC_EmitMergeInputChains, 1, 0, 
/*64102*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::BSF64rm), 0|OPFL_Chain|OPFL_MemRefs,
                    2/*#VTs*/, MVT::i64, MVT::i32, 5/*#Ops*/, 2, 3, 4, 5, 6, 
                // Src: (X86bsf:i64 (ld:i64 addr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>)
                // Dst: (BSF64rm:i64 addr:iPTR:$src)
/*64115*/     0, /*End of Scope*/
/*64116*/   /*Scope*/ 36, /*->64153*/
/*64117*/     OPC_RecordChild0, // #0 = $src
/*64118*/     OPC_SwitchType /*3 cases */, 9,  MVT::i16,// ->64130
/*64121*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::BSF16rr), 0,
                    2/*#VTs*/, MVT::i16, MVT::i32, 1/*#Ops*/, 0, 
                // Src: (X86bsf:i16 GR16:i16:$src)
                // Dst: (BSF16rr:i16 GR16:i16:$src)
              /*SwitchType*/ 9,  MVT::i32,// ->64141
/*64132*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::BSF32rr), 0,
                    2/*#VTs*/, MVT::i32, MVT::i32, 1/*#Ops*/, 0, 
                // Src: (X86bsf:i32 GR32:i32:$src)
                // Dst: (BSF32rr:i32 GR32:i32:$src)
              /*SwitchType*/ 9,  MVT::i64,// ->64152
/*64143*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::BSF64rr), 0,
                    2/*#VTs*/, MVT::i64, MVT::i32, 1/*#Ops*/, 0, 
                // Src: (X86bsf:i64 GR64:i64:$src)
                // Dst: (BSF64rr:i64 GR64:i64:$src)
              0, // EndSwitchType
/*64153*/   0, /*End of Scope*/
          /*SwitchOpcode*/ 0|128,1/*128*/,  X86ISD::BSR,// ->64285
/*64157*/   OPC_Scope, 88, /*->64247*/ // 2 children in Scope
/*64159*/     OPC_MoveChild, 0,
/*64161*/     OPC_CheckOpcode, ISD::LOAD,
/*64163*/     OPC_RecordMemRef,
/*64164*/     OPC_RecordNode, // #0 = 'ld' chained node
/*64165*/     OPC_RecordChild1, // #1 = $src
/*64166*/     OPC_CheckPredicate, 2, // Predicate_unindexedload
/*64168*/     OPC_Scope, 24, /*->64194*/ // 3 children in Scope
/*64170*/       OPC_CheckPredicate, 6, // Predicate_loadi16
/*64172*/       OPC_MoveParent,
/*64173*/       OPC_CheckType, MVT::i16,
/*64175*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*64178*/       OPC_EmitMergeInputChains, 1, 0, 
/*64181*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::BSR16rm), 0|OPFL_Chain|OPFL_MemRefs,
                    2/*#VTs*/, MVT::i16, MVT::i32, 5/*#Ops*/, 2, 3, 4, 5, 6, 
                // Src: (X86bsr:i16 (ld:i16 addr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>)
                // Dst: (BSR16rm:i16 addr:iPTR:$src)
/*64194*/     /*Scope*/ 24, /*->64219*/
/*64195*/       OPC_CheckPredicate, 3, // Predicate_loadi32
/*64197*/       OPC_MoveParent,
/*64198*/       OPC_CheckType, MVT::i32,
/*64200*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*64203*/       OPC_EmitMergeInputChains, 1, 0, 
/*64206*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::BSR32rm), 0|OPFL_Chain|OPFL_MemRefs,
                    2/*#VTs*/, MVT::i32, MVT::i32, 5/*#Ops*/, 2, 3, 4, 5, 6, 
                // Src: (X86bsr:i32 (ld:i32 addr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)
                // Dst: (BSR32rm:i32 addr:iPTR:$src)
/*64219*/     /*Scope*/ 26, /*->64246*/
/*64220*/       OPC_CheckPredicate, 8, // Predicate_load
/*64222*/       OPC_CheckPredicate, 9, // Predicate_dsload
/*64224*/       OPC_MoveParent,
/*64225*/       OPC_CheckType, MVT::i64,
/*64227*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*64230*/       OPC_EmitMergeInputChains, 1, 0, 
/*64233*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::BSR64rm), 0|OPFL_Chain|OPFL_MemRefs,
                    2/*#VTs*/, MVT::i64, MVT::i32, 5/*#Ops*/, 2, 3, 4, 5, 6, 
                // Src: (X86bsr:i64 (ld:i64 addr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>)
                // Dst: (BSR64rm:i64 addr:iPTR:$src)
/*64246*/     0, /*End of Scope*/
/*64247*/   /*Scope*/ 36, /*->64284*/
/*64248*/     OPC_RecordChild0, // #0 = $src
/*64249*/     OPC_SwitchType /*3 cases */, 9,  MVT::i16,// ->64261
/*64252*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::BSR16rr), 0,
                    2/*#VTs*/, MVT::i16, MVT::i32, 1/*#Ops*/, 0, 
                // Src: (X86bsr:i16 GR16:i16:$src)
                // Dst: (BSR16rr:i16 GR16:i16:$src)
              /*SwitchType*/ 9,  MVT::i32,// ->64272
/*64263*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::BSR32rr), 0,
                    2/*#VTs*/, MVT::i32, MVT::i32, 1/*#Ops*/, 0, 
                // Src: (X86bsr:i32 GR32:i32:$src)
                // Dst: (BSR32rr:i32 GR32:i32:$src)
              /*SwitchType*/ 9,  MVT::i64,// ->64283
/*64274*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::BSR64rr), 0,
                    2/*#VTs*/, MVT::i64, MVT::i32, 1/*#Ops*/, 0, 
                // Src: (X86bsr:i64 GR64:i64:$src)
                // Dst: (BSR64rr:i64 GR64:i64:$src)
              0, // EndSwitchType
/*64284*/   0, /*End of Scope*/
          /*SwitchOpcode*/ 115|128,2/*371*/,  ISD::ADDE,// ->64659
/*64288*/   OPC_CaptureFlagInput,
/*64289*/   OPC_Scope, 100, /*->64391*/ // 3 children in Scope
/*64291*/     OPC_RecordChild0, // #0 = $src1
/*64292*/     OPC_MoveChild, 1,
/*64294*/     OPC_CheckOpcode, ISD::LOAD,
/*64296*/     OPC_RecordMemRef,
/*64297*/     OPC_RecordNode, // #1 = 'ld' chained node
/*64298*/     OPC_CheckFoldableChainNode,
/*64299*/     OPC_RecordChild1, // #2 = $src2
/*64300*/     OPC_CheckPredicate, 2, // Predicate_unindexedload
/*64302*/     OPC_CheckPredicate, 8, // Predicate_load
/*64304*/     OPC_MoveParent,
/*64305*/     OPC_SwitchType /*4 cases */, 19,  MVT::i8,// ->64327
/*64308*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*64311*/       OPC_EmitMergeInputChains, 1, 1, 
/*64314*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::ADC8rm), 0|OPFL_Chain|OPFL_FlagInput|OPFL_FlagOutput|OPFL_MemRefs,
                    1/*#VTs*/, MVT::i8, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (adde:i8 GR8:i8:$src1, (ld:i8 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)
                // Dst: (ADC8rm:i8 GR8:i8:$src1, addr:iPTR:$src2)
              /*SwitchType*/ 19,  MVT::i16,// ->64348
/*64329*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*64332*/       OPC_EmitMergeInputChains, 1, 1, 
/*64335*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::ADC16rm), 0|OPFL_Chain|OPFL_FlagInput|OPFL_FlagOutput|OPFL_MemRefs,
                    1/*#VTs*/, MVT::i16, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (adde:i16 GR16:i16:$src1, (ld:i16 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)
                // Dst: (ADC16rm:i16 GR16:i16:$src1, addr:iPTR:$src2)
              /*SwitchType*/ 19,  MVT::i32,// ->64369
/*64350*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*64353*/       OPC_EmitMergeInputChains, 1, 1, 
/*64356*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::ADC32rm), 0|OPFL_Chain|OPFL_FlagInput|OPFL_FlagOutput|OPFL_MemRefs,
                    1/*#VTs*/, MVT::i32, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (adde:i32 GR32:i32:$src1, (ld:i32 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)
                // Dst: (ADC32rm:i32 GR32:i32:$src1, addr:iPTR:$src2)
              /*SwitchType*/ 19,  MVT::i64,// ->64390
/*64371*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*64374*/       OPC_EmitMergeInputChains, 1, 1, 
/*64377*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::ADC64rm), 0|OPFL_Chain|OPFL_FlagInput|OPFL_FlagOutput|OPFL_MemRefs,
                    1/*#VTs*/, MVT::i64, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (adde:i64 GR64:i64:$src1, (ld:i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)
                // Dst: (ADC64rm:i64 GR64:i64:$src1, addr:iPTR:$src2)
              0, // EndSwitchType
/*64391*/   /*Scope*/ 100, /*->64492*/
/*64392*/     OPC_MoveChild, 0,
/*64394*/     OPC_CheckOpcode, ISD::LOAD,
/*64396*/     OPC_RecordMemRef,
/*64397*/     OPC_RecordNode, // #0 = 'ld' chained node
/*64398*/     OPC_CheckFoldableChainNode,
/*64399*/     OPC_RecordChild1, // #1 = $src2
/*64400*/     OPC_CheckPredicate, 2, // Predicate_unindexedload
/*64402*/     OPC_CheckPredicate, 8, // Predicate_load
/*64404*/     OPC_MoveParent,
/*64405*/     OPC_RecordChild1, // #2 = $src1
/*64406*/     OPC_SwitchType /*4 cases */, 19,  MVT::i8,// ->64428
/*64409*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*64412*/       OPC_EmitMergeInputChains, 1, 0, 
/*64415*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::ADC8rm), 0|OPFL_Chain|OPFL_FlagInput|OPFL_FlagOutput|OPFL_MemRefs,
                    1/*#VTs*/, MVT::i8, 6/*#Ops*/, 2, 3, 4, 5, 6, 7, 
                // Src: (adde:i8 (ld:i8 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR8:i8:$src1)
                // Dst: (ADC8rm:i8 GR8:i8:$src1, addr:iPTR:$src2)
              /*SwitchType*/ 19,  MVT::i16,// ->64449
/*64430*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*64433*/       OPC_EmitMergeInputChains, 1, 0, 
/*64436*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::ADC16rm), 0|OPFL_Chain|OPFL_FlagInput|OPFL_FlagOutput|OPFL_MemRefs,
                    1/*#VTs*/, MVT::i16, 6/*#Ops*/, 2, 3, 4, 5, 6, 7, 
                // Src: (adde:i16 (ld:i16 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR16:i16:$src1)
                // Dst: (ADC16rm:i16 GR16:i16:$src1, addr:iPTR:$src2)
              /*SwitchType*/ 19,  MVT::i32,// ->64470
/*64451*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*64454*/       OPC_EmitMergeInputChains, 1, 0, 
/*64457*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::ADC32rm), 0|OPFL_Chain|OPFL_FlagInput|OPFL_FlagOutput|OPFL_MemRefs,
                    1/*#VTs*/, MVT::i32, 6/*#Ops*/, 2, 3, 4, 5, 6, 7, 
                // Src: (adde:i32 (ld:i32 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR32:i32:$src1)
                // Dst: (ADC32rm:i32 GR32:i32:$src1, addr:iPTR:$src2)
              /*SwitchType*/ 19,  MVT::i64,// ->64491
/*64472*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*64475*/       OPC_EmitMergeInputChains, 1, 0, 
/*64478*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::ADC64rm), 0|OPFL_Chain|OPFL_FlagInput|OPFL_FlagOutput|OPFL_MemRefs,
                    1/*#VTs*/, MVT::i64, 6/*#Ops*/, 2, 3, 4, 5, 6, 7, 
                // Src: (adde:i64 (ld:i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR64:i64:$src1)
                // Dst: (ADC64rm:i64 GR64:i64:$src1, addr:iPTR:$src2)
              0, // EndSwitchType
/*64492*/   /*Scope*/ 36|128,1/*164*/, /*->64658*/
/*64494*/     OPC_RecordChild0, // #0 = $src1
/*64495*/     OPC_RecordChild1, // #1 = $src2
/*64496*/     OPC_Scope, 111, /*->64609*/ // 5 children in Scope
/*64498*/       OPC_MoveChild, 1,
/*64500*/       OPC_CheckOpcode, ISD::Constant,
/*64502*/       OPC_Scope, 44, /*->64548*/ // 3 children in Scope
/*64504*/         OPC_CheckPredicate, 11, // Predicate_immSext8
/*64506*/         OPC_MoveParent,
/*64507*/         OPC_SwitchType /*3 cases */, 11,  MVT::i16,// ->64521
/*64510*/           OPC_EmitConvertToTarget, 1,
/*64512*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::ADC16ri8), 0|OPFL_FlagInput|OPFL_FlagOutput,
                        1/*#VTs*/, MVT::i16, 2/*#Ops*/, 0, 2, 
                    // Src: (adde:i16 GR16:i16:$src1, (imm:i16)<<P:Predicate_immSext8>>:$src2)
                    // Dst: (ADC16ri8:i16 GR16:i16:$src1, (imm:i16):$src2)
                  /*SwitchType*/ 11,  MVT::i32,// ->64534
/*64523*/           OPC_EmitConvertToTarget, 1,
/*64525*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::ADC32ri8), 0|OPFL_FlagInput|OPFL_FlagOutput,
                        1/*#VTs*/, MVT::i32, 2/*#Ops*/, 0, 2, 
                    // Src: (adde:i32 GR32:i32:$src1, (imm:i32)<<P:Predicate_immSext8>>:$src2)
                    // Dst: (ADC32ri8:i32 GR32:i32:$src1, (imm:i32):$src2)
                  /*SwitchType*/ 11,  MVT::i64,// ->64547
/*64536*/           OPC_EmitConvertToTarget, 1,
/*64538*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::ADC64ri8), 0|OPFL_FlagInput|OPFL_FlagOutput,
                        1/*#VTs*/, MVT::i64, 2/*#Ops*/, 0, 2, 
                    // Src: (adde:i64 GR64:i64:$src1, (imm:i64)<<P:Predicate_immSext8>>:$src2)
                    // Dst: (ADC64ri8:i64 GR64:i64:$src1, (imm:i64):$src2)
                  0, // EndSwitchType
/*64548*/       /*Scope*/ 16, /*->64565*/
/*64549*/         OPC_CheckPredicate, 12, // Predicate_i64immSExt32
/*64551*/         OPC_MoveParent,
/*64552*/         OPC_CheckType, MVT::i64,
/*64554*/         OPC_EmitConvertToTarget, 1,
/*64556*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::ADC64ri32), 0|OPFL_FlagInput|OPFL_FlagOutput,
                      1/*#VTs*/, MVT::i64, 2/*#Ops*/, 0, 2, 
                  // Src: (adde:i64 GR64:i64:$src1, (imm:i64)<<P:Predicate_i64immSExt32>>:$src2)
                  // Dst: (ADC64ri32:i64 GR64:i64:$src1, (imm:i64):$src2)
/*64565*/       /*Scope*/ 42, /*->64608*/
/*64566*/         OPC_MoveParent,
/*64567*/         OPC_SwitchType /*3 cases */, 11,  MVT::i8,// ->64581
/*64570*/           OPC_EmitConvertToTarget, 1,
/*64572*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::ADC8ri), 0|OPFL_FlagInput|OPFL_FlagOutput,
                        1/*#VTs*/, MVT::i8, 2/*#Ops*/, 0, 2, 
                    // Src: (adde:i8 GR8:i8:$src1, (imm:i8):$src2)
                    // Dst: (ADC8ri:i8 GR8:i8:$src1, (imm:i8):$src2)
                  /*SwitchType*/ 11,  MVT::i16,// ->64594
/*64583*/           OPC_EmitConvertToTarget, 1,
/*64585*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::ADC16ri), 0|OPFL_FlagInput|OPFL_FlagOutput,
                        1/*#VTs*/, MVT::i16, 2/*#Ops*/, 0, 2, 
                    // Src: (adde:i16 GR16:i16:$src1, (imm:i16):$src2)
                    // Dst: (ADC16ri:i16 GR16:i16:$src1, (imm:i16):$src2)
                  /*SwitchType*/ 11,  MVT::i32,// ->64607
/*64596*/           OPC_EmitConvertToTarget, 1,
/*64598*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::ADC32ri), 0|OPFL_FlagInput|OPFL_FlagOutput,
                        1/*#VTs*/, MVT::i32, 2/*#Ops*/, 0, 2, 
                    // Src: (adde:i32 GR32:i32:$src1, (imm:i32):$src2)
                    // Dst: (ADC32ri:i32 GR32:i32:$src1, (imm:i32):$src2)
                  0, // EndSwitchType
/*64608*/       0, /*End of Scope*/
/*64609*/     /*Scope*/ 11, /*->64621*/
/*64610*/       OPC_CheckType, MVT::i8,
/*64612*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::ADC8rr), 0|OPFL_FlagInput|OPFL_FlagOutput,
                    1/*#VTs*/, MVT::i8, 2/*#Ops*/, 0, 1, 
                // Src: (adde:i8 GR8:i8:$src1, GR8:i8:$src2)
                // Dst: (ADC8rr:i8 GR8:i8:$src1, GR8:i8:$src2)
/*64621*/     /*Scope*/ 11, /*->64633*/
/*64622*/       OPC_CheckType, MVT::i16,
/*64624*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::ADC16rr), 0|OPFL_FlagInput|OPFL_FlagOutput,
                    1/*#VTs*/, MVT::i16, 2/*#Ops*/, 0, 1, 
                // Src: (adde:i16 GR16:i16:$src1, GR16:i16:$src2)
                // Dst: (ADC16rr:i16 GR16:i16:$src1, GR16:i16:$src2)
/*64633*/     /*Scope*/ 11, /*->64645*/
/*64634*/       OPC_CheckType, MVT::i32,
/*64636*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::ADC32rr), 0|OPFL_FlagInput|OPFL_FlagOutput,
                    1/*#VTs*/, MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (adde:i32 GR32:i32:$src1, GR32:i32:$src2)
                // Dst: (ADC32rr:i32 GR32:i32:$src1, GR32:i32:$src2)
/*64645*/     /*Scope*/ 11, /*->64657*/
/*64646*/       OPC_CheckType, MVT::i64,
/*64648*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::ADC64rr), 0|OPFL_FlagInput|OPFL_FlagOutput,
                    1/*#VTs*/, MVT::i64, 2/*#Ops*/, 0, 1, 
                // Src: (adde:i64 GR64:i64:$src1, GR64:i64:$src2)
                // Dst: (ADC64rr:i64 GR64:i64:$src1, GR64:i64:$src2)
/*64657*/     0, /*End of Scope*/
/*64658*/   0, /*End of Scope*/
          /*SwitchOpcode*/ 13|128,2/*269*/,  ISD::SUBE,// ->64931
/*64662*/   OPC_CaptureFlagInput,
/*64663*/   OPC_RecordChild0, // #0 = $src1
/*64664*/   OPC_Scope, 99, /*->64765*/ // 2 children in Scope
/*64666*/     OPC_MoveChild, 1,
/*64668*/     OPC_CheckOpcode, ISD::LOAD,
/*64670*/     OPC_RecordMemRef,
/*64671*/     OPC_RecordNode, // #1 = 'ld' chained node
/*64672*/     OPC_CheckFoldableChainNode,
/*64673*/     OPC_RecordChild1, // #2 = $src2
/*64674*/     OPC_CheckPredicate, 2, // Predicate_unindexedload
/*64676*/     OPC_CheckPredicate, 8, // Predicate_load
/*64678*/     OPC_MoveParent,
/*64679*/     OPC_SwitchType /*4 cases */, 19,  MVT::i8,// ->64701
/*64682*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*64685*/       OPC_EmitMergeInputChains, 1, 1, 
/*64688*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::SBB8rm), 0|OPFL_Chain|OPFL_FlagInput|OPFL_FlagOutput|OPFL_MemRefs,
                    1/*#VTs*/, MVT::i8, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (sube:i8 GR8:i8:$src1, (ld:i8 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)
                // Dst: (SBB8rm:i8 GR8:i8:$src1, addr:iPTR:$src2)
              /*SwitchType*/ 19,  MVT::i16,// ->64722
/*64703*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*64706*/       OPC_EmitMergeInputChains, 1, 1, 
/*64709*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::SBB16rm), 0|OPFL_Chain|OPFL_FlagInput|OPFL_FlagOutput|OPFL_MemRefs,
                    1/*#VTs*/, MVT::i16, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (sube:i16 GR16:i16:$src1, (ld:i16 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)
                // Dst: (SBB16rm:i16 GR16:i16:$src1, addr:iPTR:$src2)
              /*SwitchType*/ 19,  MVT::i32,// ->64743
/*64724*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*64727*/       OPC_EmitMergeInputChains, 1, 1, 
/*64730*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::SBB32rm), 0|OPFL_Chain|OPFL_FlagInput|OPFL_FlagOutput|OPFL_MemRefs,
                    1/*#VTs*/, MVT::i32, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (sube:i32 GR32:i32:$src1, (ld:i32 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)
                // Dst: (SBB32rm:i32 GR32:i32:$src1, addr:iPTR:$src2)
              /*SwitchType*/ 19,  MVT::i64,// ->64764
/*64745*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*64748*/       OPC_EmitMergeInputChains, 1, 1, 
/*64751*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::SBB64rm), 0|OPFL_Chain|OPFL_FlagInput|OPFL_FlagOutput|OPFL_MemRefs,
                    1/*#VTs*/, MVT::i64, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (sube:i64 GR64:i64:$src1, (ld:i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)
                // Dst: (SBB64rm:i64 GR64:i64:$src1, addr:iPTR:$src2)
              0, // EndSwitchType
/*64765*/   /*Scope*/ 35|128,1/*163*/, /*->64930*/
/*64767*/     OPC_RecordChild1, // #1 = $src2
/*64768*/     OPC_Scope, 111, /*->64881*/ // 5 children in Scope
/*64770*/       OPC_MoveChild, 1,
/*64772*/       OPC_CheckOpcode, ISD::Constant,
/*64774*/       OPC_Scope, 44, /*->64820*/ // 3 children in Scope
/*64776*/         OPC_CheckPredicate, 11, // Predicate_immSext8
/*64778*/         OPC_MoveParent,
/*64779*/         OPC_SwitchType /*3 cases */, 11,  MVT::i16,// ->64793
/*64782*/           OPC_EmitConvertToTarget, 1,
/*64784*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::SBB16ri8), 0|OPFL_FlagInput|OPFL_FlagOutput,
                        1/*#VTs*/, MVT::i16, 2/*#Ops*/, 0, 2, 
                    // Src: (sube:i16 GR16:i16:$src1, (imm:i16)<<P:Predicate_immSext8>>:$src2)
                    // Dst: (SBB16ri8:i16 GR16:i16:$src1, (imm:i16):$src2)
                  /*SwitchType*/ 11,  MVT::i32,// ->64806
/*64795*/           OPC_EmitConvertToTarget, 1,
/*64797*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::SBB32ri8), 0|OPFL_FlagInput|OPFL_FlagOutput,
                        1/*#VTs*/, MVT::i32, 2/*#Ops*/, 0, 2, 
                    // Src: (sube:i32 GR32:i32:$src1, (imm:i32)<<P:Predicate_immSext8>>:$src2)
                    // Dst: (SBB32ri8:i32 GR32:i32:$src1, (imm:i32):$src2)
                  /*SwitchType*/ 11,  MVT::i64,// ->64819
/*64808*/           OPC_EmitConvertToTarget, 1,
/*64810*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::SBB64ri8), 0|OPFL_FlagInput|OPFL_FlagOutput,
                        1/*#VTs*/, MVT::i64, 2/*#Ops*/, 0, 2, 
                    // Src: (sube:i64 GR64:i64:$src1, (imm:i64)<<P:Predicate_immSext8>>:$src2)
                    // Dst: (SBB64ri8:i64 GR64:i64:$src1, (imm:i64):$src2)
                  0, // EndSwitchType
/*64820*/       /*Scope*/ 16, /*->64837*/
/*64821*/         OPC_CheckPredicate, 12, // Predicate_i64immSExt32
/*64823*/         OPC_MoveParent,
/*64824*/         OPC_CheckType, MVT::i64,
/*64826*/         OPC_EmitConvertToTarget, 1,
/*64828*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::SBB64ri32), 0|OPFL_FlagInput|OPFL_FlagOutput,
                      1/*#VTs*/, MVT::i64, 2/*#Ops*/, 0, 2, 
                  // Src: (sube:i64 GR64:i64:$src1, (imm:i64)<<P:Predicate_i64immSExt32>>:$src2)
                  // Dst: (SBB64ri32:i64 GR64:i64:$src1, (imm:i64):$src2)
/*64837*/       /*Scope*/ 42, /*->64880*/
/*64838*/         OPC_MoveParent,
/*64839*/         OPC_SwitchType /*3 cases */, 11,  MVT::i8,// ->64853
/*64842*/           OPC_EmitConvertToTarget, 1,
/*64844*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::SBB8ri), 0|OPFL_FlagInput|OPFL_FlagOutput,
                        1/*#VTs*/, MVT::i8, 2/*#Ops*/, 0, 2, 
                    // Src: (sube:i8 GR8:i8:$src1, (imm:i8):$src2)
                    // Dst: (SBB8ri:i8 GR8:i8:$src1, (imm:i8):$src2)
                  /*SwitchType*/ 11,  MVT::i16,// ->64866
/*64855*/           OPC_EmitConvertToTarget, 1,
/*64857*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::SBB16ri), 0|OPFL_FlagInput|OPFL_FlagOutput,
                        1/*#VTs*/, MVT::i16, 2/*#Ops*/, 0, 2, 
                    // Src: (sube:i16 GR16:i16:$src1, (imm:i16):$src2)
                    // Dst: (SBB16ri:i16 GR16:i16:$src1, (imm:i16):$src2)
                  /*SwitchType*/ 11,  MVT::i32,// ->64879
/*64868*/           OPC_EmitConvertToTarget, 1,
/*64870*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::SBB32ri), 0|OPFL_FlagInput|OPFL_FlagOutput,
                        1/*#VTs*/, MVT::i32, 2/*#Ops*/, 0, 2, 
                    // Src: (sube:i32 GR32:i32:$src1, (imm:i32):$src2)
                    // Dst: (SBB32ri:i32 GR32:i32:$src1, (imm:i32):$src2)
                  0, // EndSwitchType
/*64880*/       0, /*End of Scope*/
/*64881*/     /*Scope*/ 11, /*->64893*/
/*64882*/       OPC_CheckType, MVT::i8,
/*64884*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::SBB8rr), 0|OPFL_FlagInput|OPFL_FlagOutput,
                    1/*#VTs*/, MVT::i8, 2/*#Ops*/, 0, 1, 
                // Src: (sube:i8 GR8:i8:$src1, GR8:i8:$src2)
                // Dst: (SBB8rr:i8 GR8:i8:$src1, GR8:i8:$src2)
/*64893*/     /*Scope*/ 11, /*->64905*/
/*64894*/       OPC_CheckType, MVT::i16,
/*64896*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::SBB16rr), 0|OPFL_FlagInput|OPFL_FlagOutput,
                    1/*#VTs*/, MVT::i16, 2/*#Ops*/, 0, 1, 
                // Src: (sube:i16 GR16:i16:$src1, GR16:i16:$src2)
                // Dst: (SBB16rr:i16 GR16:i16:$src1, GR16:i16:$src2)
/*64905*/     /*Scope*/ 11, /*->64917*/
/*64906*/       OPC_CheckType, MVT::i32,
/*64908*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::SBB32rr), 0|OPFL_FlagInput|OPFL_FlagOutput,
                    1/*#VTs*/, MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (sube:i32 GR32:i32:$src1, GR32:i32:$src2)
                // Dst: (SBB32rr:i32 GR32:i32:$src1, GR32:i32:$src2)
/*64917*/     /*Scope*/ 11, /*->64929*/
/*64918*/       OPC_CheckType, MVT::i64,
/*64920*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::SBB64rr), 0|OPFL_FlagInput|OPFL_FlagOutput,
                    1/*#VTs*/, MVT::i64, 2/*#Ops*/, 0, 1, 
                // Src: (sube:i64 GR64:i64:$src1, GR64:i64:$src2)
                // Dst: (SBB64rr:i64 GR64:i64:$src1, GR64:i64:$src2)
/*64929*/     0, /*End of Scope*/
/*64930*/   0, /*End of Scope*/
          /*SwitchOpcode*/ 92|128,1/*220*/,  ISD::ADDC,// ->65154
/*64934*/   OPC_Scope, 58, /*->64994*/ // 3 children in Scope
/*64936*/     OPC_RecordChild0, // #0 = $src1
/*64937*/     OPC_MoveChild, 1,
/*64939*/     OPC_CheckOpcode, ISD::LOAD,
/*64941*/     OPC_RecordMemRef,
/*64942*/     OPC_RecordNode, // #1 = 'ld' chained node
/*64943*/     OPC_CheckFoldableChainNode,
/*64944*/     OPC_RecordChild1, // #2 = $src2
/*64945*/     OPC_CheckPredicate, 2, // Predicate_unindexedload
/*64947*/     OPC_CheckPredicate, 8, // Predicate_load
/*64949*/     OPC_MoveParent,
/*64950*/     OPC_SwitchType /*2 cases */, 19,  MVT::i32,// ->64972
/*64953*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*64956*/       OPC_EmitMergeInputChains, 1, 1, 
/*64959*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::ADD32rm), 0|OPFL_Chain|OPFL_FlagOutput|OPFL_MemRefs,
                    1/*#VTs*/, MVT::i32, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (addc:i32 GR32:i32:$src1, (ld:i32 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)
                // Dst: (ADD32rm:i32 GR32:i32:$src1, addr:iPTR:$src2)
              /*SwitchType*/ 19,  MVT::i64,// ->64993
/*64974*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*64977*/       OPC_EmitMergeInputChains, 1, 1, 
/*64980*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::ADD64rm), 0|OPFL_Chain|OPFL_FlagOutput|OPFL_MemRefs,
                    1/*#VTs*/, MVT::i64, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (addc:i64 GR64:i64:$src1, (ld:i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)
                // Dst: (ADD64rm:i64 GR64:i64:$src1, addr:iPTR:$src2)
              0, // EndSwitchType
/*64994*/   /*Scope*/ 58, /*->65053*/
/*64995*/     OPC_MoveChild, 0,
/*64997*/     OPC_CheckOpcode, ISD::LOAD,
/*64999*/     OPC_RecordMemRef,
/*65000*/     OPC_RecordNode, // #0 = 'ld' chained node
/*65001*/     OPC_CheckFoldableChainNode,
/*65002*/     OPC_RecordChild1, // #1 = $src2
/*65003*/     OPC_CheckPredicate, 2, // Predicate_unindexedload
/*65005*/     OPC_CheckPredicate, 8, // Predicate_load
/*65007*/     OPC_MoveParent,
/*65008*/     OPC_RecordChild1, // #2 = $src1
/*65009*/     OPC_SwitchType /*2 cases */, 19,  MVT::i64,// ->65031
/*65012*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*65015*/       OPC_EmitMergeInputChains, 1, 0, 
/*65018*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::ADD64rm), 0|OPFL_Chain|OPFL_FlagOutput|OPFL_MemRefs,
                    1/*#VTs*/, MVT::i64, 6/*#Ops*/, 2, 3, 4, 5, 6, 7, 
                // Src: (addc:i64 (ld:i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR64:i64:$src1)
                // Dst: (ADD64rm:i64 GR64:i64:$src1, addr:iPTR:$src2)
              /*SwitchType*/ 19,  MVT::i32,// ->65052
/*65033*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*65036*/       OPC_EmitMergeInputChains, 1, 0, 
/*65039*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::ADD32rm), 0|OPFL_Chain|OPFL_FlagOutput|OPFL_MemRefs,
                    1/*#VTs*/, MVT::i32, 6/*#Ops*/, 2, 3, 4, 5, 6, 7, 
                // Src: (addc:i32 (ld:i32 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR32:i32:$src1)
                // Dst: (ADD32rm:i32 GR32:i32:$src1, addr:iPTR:$src2)
              0, // EndSwitchType
/*65053*/   /*Scope*/ 99, /*->65153*/
/*65054*/     OPC_RecordChild0, // #0 = $src1
/*65055*/     OPC_RecordChild1, // #1 = $src2
/*65056*/     OPC_Scope, 70, /*->65128*/ // 3 children in Scope
/*65058*/       OPC_MoveChild, 1,
/*65060*/       OPC_CheckOpcode, ISD::Constant,
/*65062*/       OPC_Scope, 31, /*->65095*/ // 3 children in Scope
/*65064*/         OPC_CheckPredicate, 11, // Predicate_immSext8
/*65066*/         OPC_MoveParent,
/*65067*/         OPC_SwitchType /*2 cases */, 11,  MVT::i32,// ->65081
/*65070*/           OPC_EmitConvertToTarget, 1,
/*65072*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::ADD32ri8), 0|OPFL_FlagOutput,
                        1/*#VTs*/, MVT::i32, 2/*#Ops*/, 0, 2, 
                    // Src: (addc:i32 GR32:i32:$src1, (imm:i32)<<P:Predicate_immSext8>>:$src2)
                    // Dst: (ADD32ri8:i32 GR32:i32:$src1, (imm:i32)<<P:Predicate_immSext8>>:$src2)
                  /*SwitchType*/ 11,  MVT::i64,// ->65094
/*65083*/           OPC_EmitConvertToTarget, 1,
/*65085*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::ADD64ri8), 0|OPFL_FlagOutput,
                        1/*#VTs*/, MVT::i64, 2/*#Ops*/, 0, 2, 
                    // Src: (addc:i64 GR64:i64:$src1, (imm:i64)<<P:Predicate_immSext8>>:$src2)
                    // Dst: (ADD64ri8:i64 GR64:i64:$src1, (imm:i64)<<P:Predicate_immSext8>>:$src2)
                  0, // EndSwitchType
/*65095*/       /*Scope*/ 16, /*->65112*/
/*65096*/         OPC_CheckPredicate, 12, // Predicate_i64immSExt32
/*65098*/         OPC_MoveParent,
/*65099*/         OPC_CheckType, MVT::i64,
/*65101*/         OPC_EmitConvertToTarget, 1,
/*65103*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::ADD64ri32), 0|OPFL_FlagOutput,
                      1/*#VTs*/, MVT::i64, 2/*#Ops*/, 0, 2, 
                  // Src: (addc:i64 GR64:i64:$src1, (imm:i64)<<P:Predicate_i64immSExt32>>:$src2)
                  // Dst: (ADD64ri32:i64 GR64:i64:$src1, (imm:i64):$src2)
/*65112*/       /*Scope*/ 14, /*->65127*/
/*65113*/         OPC_MoveParent,
/*65114*/         OPC_CheckType, MVT::i32,
/*65116*/         OPC_EmitConvertToTarget, 1,
/*65118*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::ADD32ri), 0|OPFL_FlagOutput,
                      1/*#VTs*/, MVT::i32, 2/*#Ops*/, 0, 2, 
                  // Src: (addc:i32 GR32:i32:$src1, (imm:i32):$src2)
                  // Dst: (ADD32ri:i32 GR32:i32:$src1, (imm:i32):$src2)
/*65127*/       0, /*End of Scope*/
/*65128*/     /*Scope*/ 11, /*->65140*/
/*65129*/       OPC_CheckType, MVT::i32,
/*65131*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::ADD32rr), 0|OPFL_FlagOutput,
                    1/*#VTs*/, MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (addc:i32 GR32:i32:$src1, GR32:i32:$src2)
                // Dst: (ADD32rr:i32 GR32:i32:$src1, GR32:i32:$src2)
/*65140*/     /*Scope*/ 11, /*->65152*/
/*65141*/       OPC_CheckType, MVT::i64,
/*65143*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::ADD64rr), 0|OPFL_FlagOutput,
                    1/*#VTs*/, MVT::i64, 2/*#Ops*/, 0, 1, 
                // Src: (addc:i64 GR64:i64:$src1, GR64:i64:$src2)
                // Dst: (ADD64rr:i64 GR64:i64:$src1, GR64:i64:$src2)
/*65152*/     0, /*End of Scope*/
/*65153*/   0, /*End of Scope*/
          /*SwitchOpcode*/ 30|128,1/*158*/,  ISD::SUBC,// ->65315
/*65157*/   OPC_RecordChild0, // #0 = $src1
/*65158*/   OPC_Scope, 57, /*->65217*/ // 2 children in Scope
/*65160*/     OPC_MoveChild, 1,
/*65162*/     OPC_CheckOpcode, ISD::LOAD,
/*65164*/     OPC_RecordMemRef,
/*65165*/     OPC_RecordNode, // #1 = 'ld' chained node
/*65166*/     OPC_CheckFoldableChainNode,
/*65167*/     OPC_RecordChild1, // #2 = $src2
/*65168*/     OPC_CheckPredicate, 2, // Predicate_unindexedload
/*65170*/     OPC_CheckPredicate, 8, // Predicate_load
/*65172*/     OPC_MoveParent,
/*65173*/     OPC_SwitchType /*2 cases */, 19,  MVT::i32,// ->65195
/*65176*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*65179*/       OPC_EmitMergeInputChains, 1, 1, 
/*65182*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::SUB32rm), 0|OPFL_Chain|OPFL_FlagOutput|OPFL_MemRefs,
                    1/*#VTs*/, MVT::i32, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (subc:i32 GR32:i32:$src1, (ld:i32 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)
                // Dst: (SUB32rm:i32 GR32:i32:$src1, addr:iPTR:$src2)
              /*SwitchType*/ 19,  MVT::i64,// ->65216
/*65197*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*65200*/       OPC_EmitMergeInputChains, 1, 1, 
/*65203*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::SUB64rm), 0|OPFL_Chain|OPFL_FlagOutput|OPFL_MemRefs,
                    1/*#VTs*/, MVT::i64, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (subc:i64 GR64:i64:$src1, (ld:i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)
                // Dst: (SUB64rm:i64 GR64:i64:$src1, addr:iPTR:$src2)
              0, // EndSwitchType
/*65217*/   /*Scope*/ 96, /*->65314*/
/*65218*/     OPC_RecordChild1, // #1 = $src2
/*65219*/     OPC_Scope, 68, /*->65289*/ // 3 children in Scope
/*65221*/       OPC_MoveChild, 1,
/*65223*/       OPC_CheckOpcode, ISD::Constant,
/*65225*/       OPC_Scope, 31, /*->65258*/ // 2 children in Scope
/*65227*/         OPC_CheckPredicate, 11, // Predicate_immSext8
/*65229*/         OPC_MoveParent,
/*65230*/         OPC_SwitchType /*2 cases */, 11,  MVT::i32,// ->65244
/*65233*/           OPC_EmitConvertToTarget, 1,
/*65235*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::SUB32ri8), 0|OPFL_FlagOutput,
                        1/*#VTs*/, MVT::i32, 2/*#Ops*/, 0, 2, 
                    // Src: (subc:i32 GR32:i32:$src1, (imm:i32)<<P:Predicate_immSext8>>:$src2)
                    // Dst: (SUB32ri8:i32 GR32:i32:$src1, (imm:i32)<<P:Predicate_immSext8>>:$src2)
                  /*SwitchType*/ 11,  MVT::i64,// ->65257
/*65246*/           OPC_EmitConvertToTarget, 1,
/*65248*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::SUB64ri8), 0|OPFL_FlagOutput,
                        1/*#VTs*/, MVT::i64, 2/*#Ops*/, 0, 2, 
                    // Src: (subc:i64 GR64:i64:$src1, (imm:i64)<<P:Predicate_immSext8>>:$src2)
                    // Dst: (SUB64ri8:i64 GR64:i64:$src1, (imm:i64)<<P:Predicate_immSext8>>:$src2)
                  0, // EndSwitchType
/*65258*/       /*Scope*/ 29, /*->65288*/
/*65259*/         OPC_MoveParent,
/*65260*/         OPC_SwitchType /*2 cases */, 11,  MVT::i32,// ->65274
/*65263*/           OPC_EmitConvertToTarget, 1,
/*65265*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::SUB32ri), 0|OPFL_FlagOutput,
                        1/*#VTs*/, MVT::i32, 2/*#Ops*/, 0, 2, 
                    // Src: (subc:i32 GR32:i32:$src1, (imm:i32):$src2)
                    // Dst: (SUB32ri:i32 GR32:i32:$src1, (imm:i32):$src2)
                  /*SwitchType*/ 11,  MVT::i64,// ->65287
/*65276*/           OPC_EmitConvertToTarget, 1,
/*65278*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::SUB64ri32), 0|OPFL_FlagOutput,
                        1/*#VTs*/, MVT::i64, 2/*#Ops*/, 0, 2, 
                    // Src: (subc:i64 GR64:i64:$src1, (imm:i64):$src2)
                    // Dst: (SUB64ri32:i64 GR64:i64:$src1, (imm:i64)<<P:Predicate_i64immSExt32>>:$src2)
                  0, // EndSwitchType
/*65288*/       0, /*End of Scope*/
/*65289*/     /*Scope*/ 11, /*->65301*/
/*65290*/       OPC_CheckType, MVT::i32,
/*65292*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::SUB32rr), 0|OPFL_FlagOutput,
                    1/*#VTs*/, MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (subc:i32 GR32:i32:$src1, GR32:i32:$src2)
                // Dst: (SUB32rr:i32 GR32:i32:$src1, GR32:i32:$src2)
/*65301*/     /*Scope*/ 11, /*->65313*/
/*65302*/       OPC_CheckType, MVT::i64,
/*65304*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::SUB64rr), 0|OPFL_FlagOutput,
                    1/*#VTs*/, MVT::i64, 2/*#Ops*/, 0, 1, 
                // Src: (subc:i64 GR64:i64:$src1, GR64:i64:$src2)
                // Dst: (SUB64rr:i64 GR64:i64:$src1, GR64:i64:$src2)
/*65313*/     0, /*End of Scope*/
/*65314*/   0, /*End of Scope*/
          /*SwitchOpcode*/ 42|128,3/*426*/,  X86ISD::ADD,// ->65744
/*65318*/   OPC_Scope, 121, /*->65441*/ // 3 children in Scope
/*65320*/     OPC_RecordChild0, // #0 = $src1
/*65321*/     OPC_MoveChild, 1,
/*65323*/     OPC_CheckOpcode, ISD::LOAD,
/*65325*/     OPC_RecordMemRef,
/*65326*/     OPC_RecordNode, // #1 = 'ld' chained node
/*65327*/     OPC_CheckFoldableChainNode,
/*65328*/     OPC_RecordChild1, // #2 = $src2
/*65329*/     OPC_CheckPredicate, 2, // Predicate_unindexedload
/*65331*/     OPC_Scope, 27, /*->65360*/ // 4 children in Scope
/*65333*/       OPC_CheckPredicate, 8, // Predicate_load
/*65335*/       OPC_CheckPredicate, 9, // Predicate_dsload
/*65337*/       OPC_MoveParent,
/*65338*/       OPC_CheckType, MVT::i8,
/*65340*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*65343*/       OPC_EmitMergeInputChains, 1, 1, 
/*65346*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::ADD8rm), 0|OPFL_Chain|OPFL_MemRefs,
                    2/*#VTs*/, MVT::i8, MVT::i32, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (X86add_flag:i8 GR8:i8:$src1, (ld:i8 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>)
                // Dst: (ADD8rm:i8 GR8:i8:$src1, addr:iPTR:$src2)
/*65360*/     /*Scope*/ 25, /*->65386*/
/*65361*/       OPC_CheckPredicate, 6, // Predicate_loadi16
/*65363*/       OPC_MoveParent,
/*65364*/       OPC_CheckType, MVT::i16,
/*65366*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*65369*/       OPC_EmitMergeInputChains, 1, 1, 
/*65372*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::ADD16rm), 0|OPFL_Chain|OPFL_MemRefs,
                    2/*#VTs*/, MVT::i16, MVT::i32, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (X86add_flag:i16 GR16:i16:$src1, (ld:i16 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>)
                // Dst: (ADD16rm:i16 GR16:i16:$src1, addr:iPTR:$src2)
/*65386*/     /*Scope*/ 25, /*->65412*/
/*65387*/       OPC_CheckPredicate, 3, // Predicate_loadi32
/*65389*/       OPC_MoveParent,
/*65390*/       OPC_CheckType, MVT::i32,
/*65392*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*65395*/       OPC_EmitMergeInputChains, 1, 1, 
/*65398*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::ADD32rm), 0|OPFL_Chain|OPFL_MemRefs,
                    2/*#VTs*/, MVT::i32, MVT::i32, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (X86add_flag:i32 GR32:i32:$src1, (ld:i32 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)
                // Dst: (ADD32rm:i32 GR32:i32:$src1, addr:iPTR:$src2)
/*65412*/     /*Scope*/ 27, /*->65440*/
/*65413*/       OPC_CheckPredicate, 8, // Predicate_load
/*65415*/       OPC_CheckPredicate, 9, // Predicate_dsload
/*65417*/       OPC_MoveParent,
/*65418*/       OPC_CheckType, MVT::i64,
/*65420*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*65423*/       OPC_EmitMergeInputChains, 1, 1, 
/*65426*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::ADD64rm), 0|OPFL_Chain|OPFL_MemRefs,
                    2/*#VTs*/, MVT::i64, MVT::i32, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (X86add_flag:i64 GR64:i64:$src1, (ld:i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>)
                // Dst: (ADD64rm:i64 GR64:i64:$src1, addr:iPTR:$src2)
/*65440*/     0, /*End of Scope*/
/*65441*/   /*Scope*/ 124, /*->65566*/
/*65442*/     OPC_MoveChild, 0,
/*65444*/     OPC_CheckOpcode, ISD::LOAD,
/*65446*/     OPC_RecordMemRef,
/*65447*/     OPC_RecordNode, // #0 = 'ld' chained node
/*65448*/     OPC_CheckFoldableChainNode,
/*65449*/     OPC_RecordChild1, // #1 = $src2
/*65450*/     OPC_CheckPredicate, 2, // Predicate_unindexedload
/*65452*/     OPC_Scope, 28, /*->65482*/ // 4 children in Scope
/*65454*/       OPC_CheckPredicate, 8, // Predicate_load
/*65456*/       OPC_CheckPredicate, 9, // Predicate_dsload
/*65458*/       OPC_MoveParent,
/*65459*/       OPC_RecordChild1, // #2 = $src1
/*65460*/       OPC_CheckType, MVT::i8,
/*65462*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*65465*/       OPC_EmitMergeInputChains, 1, 0, 
/*65468*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::ADD8rm), 0|OPFL_Chain|OPFL_MemRefs,
                    2/*#VTs*/, MVT::i8, MVT::i32, 6/*#Ops*/, 2, 3, 4, 5, 6, 7, 
                // Src: (X86add_flag:i8 (ld:i8 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>, GR8:i8:$src1)
                // Dst: (ADD8rm:i8 GR8:i8:$src1, addr:iPTR:$src2)
/*65482*/     /*Scope*/ 26, /*->65509*/
/*65483*/       OPC_CheckPredicate, 6, // Predicate_loadi16
/*65485*/       OPC_MoveParent,
/*65486*/       OPC_RecordChild1, // #2 = $src1
/*65487*/       OPC_CheckType, MVT::i16,
/*65489*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*65492*/       OPC_EmitMergeInputChains, 1, 0, 
/*65495*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::ADD16rm), 0|OPFL_Chain|OPFL_MemRefs,
                    2/*#VTs*/, MVT::i16, MVT::i32, 6/*#Ops*/, 2, 3, 4, 5, 6, 7, 
                // Src: (X86add_flag:i16 (ld:i16 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, GR16:i16:$src1)
                // Dst: (ADD16rm:i16 GR16:i16:$src1, addr:iPTR:$src2)
/*65509*/     /*Scope*/ 26, /*->65536*/
/*65510*/       OPC_CheckPredicate, 3, // Predicate_loadi32
/*65512*/       OPC_MoveParent,
/*65513*/       OPC_RecordChild1, // #2 = $src1
/*65514*/       OPC_CheckType, MVT::i32,
/*65516*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*65519*/       OPC_EmitMergeInputChains, 1, 0, 
/*65522*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::ADD32rm), 0|OPFL_Chain|OPFL_MemRefs,
                    2/*#VTs*/, MVT::i32, MVT::i32, 6/*#Ops*/, 2, 3, 4, 5, 6, 7, 
                // Src: (X86add_flag:i32 (ld:i32 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, GR32:i32:$src1)
                // Dst: (ADD32rm:i32 GR32:i32:$src1, addr:iPTR:$src2)
/*65536*/     /*Scope*/ 28, /*->65565*/
/*65537*/       OPC_CheckPredicate, 8, // Predicate_load
/*65539*/       OPC_CheckPredicate, 9, // Predicate_dsload
/*65541*/       OPC_MoveParent,
/*65542*/       OPC_RecordChild1, // #2 = $src1
/*65543*/       OPC_CheckType, MVT::i64,
/*65545*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*65548*/       OPC_EmitMergeInputChains, 1, 0, 
/*65551*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::ADD64rm), 0|OPFL_Chain|OPFL_MemRefs,
                    2/*#VTs*/, MVT::i64, MVT::i32, 6/*#Ops*/, 2, 3, 4, 5, 6, 7, 
                // Src: (X86add_flag:i64 (ld:i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>, GR64:i64:$src1)
                // Dst: (ADD64rm:i64 GR64:i64:$src1, addr:iPTR:$src2)
/*65565*/     0, /*End of Scope*/
/*65566*/   /*Scope*/ 47|128,1/*175*/, /*->65743*/
/*65568*/     OPC_RecordChild0, // #0 = $src1
/*65569*/     OPC_RecordChild1, // #1 = $src2
/*65570*/     OPC_Scope, 118, /*->65690*/ // 5 children in Scope
/*65572*/       OPC_MoveChild, 1,
/*65574*/       OPC_CheckOpcode, ISD::Constant,
/*65576*/       OPC_Scope, 47, /*->65625*/ // 3 children in Scope
/*65578*/         OPC_CheckPredicate, 11, // Predicate_immSext8
/*65580*/         OPC_MoveParent,
/*65581*/         OPC_SwitchType /*3 cases */, 12,  MVT::i16,// ->65596
/*65584*/           OPC_EmitConvertToTarget, 1,
/*65586*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::ADD16ri8), 0,
                        2/*#VTs*/, MVT::i16, MVT::i32, 2/*#Ops*/, 0, 2, 
                    // Src: (X86add_flag:i16 GR16:i16:$src1, (imm:i16)<<P:Predicate_immSext8>>:$src2)
                    // Dst: (ADD16ri8:i16 GR16:i16:$src1, (imm:i16)<<P:Predicate_immSext8>>:$src2)
                  /*SwitchType*/ 12,  MVT::i32,// ->65610
/*65598*/           OPC_EmitConvertToTarget, 1,
/*65600*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::ADD32ri8), 0,
                        2/*#VTs*/, MVT::i32, MVT::i32, 2/*#Ops*/, 0, 2, 
                    // Src: (X86add_flag:i32 GR32:i32:$src1, (imm:i32)<<P:Predicate_immSext8>>:$src2)
                    // Dst: (ADD32ri8:i32 GR32:i32:$src1, (imm:i32)<<P:Predicate_immSext8>>:$src2)
                  /*SwitchType*/ 12,  MVT::i64,// ->65624
/*65612*/           OPC_EmitConvertToTarget, 1,
/*65614*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::ADD64ri8), 0,
                        2/*#VTs*/, MVT::i64, MVT::i32, 2/*#Ops*/, 0, 2, 
                    // Src: (X86add_flag:i64 GR64:i64:$src1, (imm:i64)<<P:Predicate_immSext8>>:$src2)
                    // Dst: (ADD64ri8:i64 GR64:i64:$src1, (imm:i64)<<P:Predicate_immSext8>>:$src2)
                  0, // EndSwitchType
/*65625*/       /*Scope*/ 17, /*->65643*/
/*65626*/         OPC_CheckPredicate, 12, // Predicate_i64immSExt32
/*65628*/         OPC_MoveParent,
/*65629*/         OPC_CheckType, MVT::i64,
/*65631*/         OPC_EmitConvertToTarget, 1,
/*65633*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::ADD64ri32), 0,
                      2/*#VTs*/, MVT::i64, MVT::i32, 2/*#Ops*/, 0, 2, 
                  // Src: (X86add_flag:i64 GR64:i64:$src1, (imm:i64)<<P:Predicate_i64immSExt32>>:$src2)
                  // Dst: (ADD64ri32:i64 GR64:i64:$src1, (imm:i64)<<P:Predicate_i64immSExt32>>:$src2)
/*65643*/       /*Scope*/ 45, /*->65689*/
/*65644*/         OPC_MoveParent,
/*65645*/         OPC_SwitchType /*3 cases */, 12,  MVT::i8,// ->65660
/*65648*/           OPC_EmitConvertToTarget, 1,
/*65650*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::ADD8ri), 0,
                        2/*#VTs*/, MVT::i8, MVT::i32, 2/*#Ops*/, 0, 2, 
                    // Src: (X86add_flag:i8 GR8:i8:$src1, (imm:i8):$src2)
                    // Dst: (ADD8ri:i8 GR8:i8:$src1, (imm:i8):$src2)
                  /*SwitchType*/ 12,  MVT::i16,// ->65674
/*65662*/           OPC_EmitConvertToTarget, 1,
/*65664*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::ADD16ri), 0,
                        2/*#VTs*/, MVT::i16, MVT::i32, 2/*#Ops*/, 0, 2, 
                    // Src: (X86add_flag:i16 GR16:i16:$src1, (imm:i16):$src2)
                    // Dst: (ADD16ri:i16 GR16:i16:$src1, (imm:i16):$src2)
                  /*SwitchType*/ 12,  MVT::i32,// ->65688
/*65676*/           OPC_EmitConvertToTarget, 1,
/*65678*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::ADD32ri), 0,
                        2/*#VTs*/, MVT::i32, MVT::i32, 2/*#Ops*/, 0, 2, 
                    // Src: (X86add_flag:i32 GR32:i32:$src1, (imm:i32):$src2)
                    // Dst: (ADD32ri:i32 GR32:i32:$src1, (imm:i32):$src2)
                  0, // EndSwitchType
/*65689*/       0, /*End of Scope*/
/*65690*/     /*Scope*/ 12, /*->65703*/
/*65691*/       OPC_CheckType, MVT::i8,
/*65693*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::ADD8rr), 0,
                    2/*#VTs*/, MVT::i8, MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (X86add_flag:i8 GR8:i8:$src1, GR8:i8:$src2)
                // Dst: (ADD8rr:i8 GR8:i8:$src1, GR8:i8:$src2)
/*65703*/     /*Scope*/ 12, /*->65716*/
/*65704*/       OPC_CheckType, MVT::i16,
/*65706*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::ADD16rr), 0,
                    2/*#VTs*/, MVT::i16, MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (X86add_flag:i16 GR16:i16:$src1, GR16:i16:$src2)
                // Dst: (ADD16rr:i16 GR16:i16:$src1, GR16:i16:$src2)
/*65716*/     /*Scope*/ 12, /*->65729*/
/*65717*/       OPC_CheckType, MVT::i32,
/*65719*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::ADD32rr), 0,
                    2/*#VTs*/, MVT::i32, MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (X86add_flag:i32 GR32:i32:$src1, GR32:i32:$src2)
                // Dst: (ADD32rr:i32 GR32:i32:$src1, GR32:i32:$src2)
/*65729*/     /*Scope*/ 12, /*->65742*/
/*65730*/       OPC_CheckType, MVT::i64,
/*65732*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::ADD64rr), 0,
                    2/*#VTs*/, MVT::i64, MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (X86add_flag:i64 GR64:i64:$src1, GR64:i64:$src2)
                // Dst: (ADD64rr:i64 GR64:i64:$src1, GR64:i64:$src2)
/*65742*/     0, /*End of Scope*/
/*65743*/   0, /*End of Scope*/
          /*SwitchOpcode*/ 44|128,2/*300*/,  X86ISD::SUB,// ->66047
/*65747*/   OPC_RecordChild0, // #0 = $src1
/*65748*/   OPC_Scope, 120, /*->65870*/ // 2 children in Scope
/*65750*/     OPC_MoveChild, 1,
/*65752*/     OPC_CheckOpcode, ISD::LOAD,
/*65754*/     OPC_RecordMemRef,
/*65755*/     OPC_RecordNode, // #1 = 'ld' chained node
/*65756*/     OPC_CheckFoldableChainNode,
/*65757*/     OPC_RecordChild1, // #2 = $src2
/*65758*/     OPC_CheckPredicate, 2, // Predicate_unindexedload
/*65760*/     OPC_Scope, 27, /*->65789*/ // 4 children in Scope
/*65762*/       OPC_CheckPredicate, 8, // Predicate_load
/*65764*/       OPC_CheckPredicate, 9, // Predicate_dsload
/*65766*/       OPC_MoveParent,
/*65767*/       OPC_CheckType, MVT::i8,
/*65769*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*65772*/       OPC_EmitMergeInputChains, 1, 1, 
/*65775*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::SUB8rm), 0|OPFL_Chain|OPFL_MemRefs,
                    2/*#VTs*/, MVT::i8, MVT::i32, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (X86sub_flag:i8 GR8:i8:$src1, (ld:i8 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>)
                // Dst: (SUB8rm:i8 GR8:i8:$src1, addr:iPTR:$src2)
/*65789*/     /*Scope*/ 25, /*->65815*/
/*65790*/       OPC_CheckPredicate, 6, // Predicate_loadi16
/*65792*/       OPC_MoveParent,
/*65793*/       OPC_CheckType, MVT::i16,
/*65795*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*65798*/       OPC_EmitMergeInputChains, 1, 1, 
/*65801*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::SUB16rm), 0|OPFL_Chain|OPFL_MemRefs,
                    2/*#VTs*/, MVT::i16, MVT::i32, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (X86sub_flag:i16 GR16:i16:$src1, (ld:i16 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>)
                // Dst: (SUB16rm:i16 GR16:i16:$src1, addr:iPTR:$src2)
/*65815*/     /*Scope*/ 25, /*->65841*/
/*65816*/       OPC_CheckPredicate, 3, // Predicate_loadi32
/*65818*/       OPC_MoveParent,
/*65819*/       OPC_CheckType, MVT::i32,
/*65821*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*65824*/       OPC_EmitMergeInputChains, 1, 1, 
/*65827*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::SUB32rm), 0|OPFL_Chain|OPFL_MemRefs,
                    2/*#VTs*/, MVT::i32, MVT::i32, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (X86sub_flag:i32 GR32:i32:$src1, (ld:i32 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)
                // Dst: (SUB32rm:i32 GR32:i32:$src1, addr:iPTR:$src2)
/*65841*/     /*Scope*/ 27, /*->65869*/
/*65842*/       OPC_CheckPredicate, 8, // Predicate_load
/*65844*/       OPC_CheckPredicate, 9, // Predicate_dsload
/*65846*/       OPC_MoveParent,
/*65847*/       OPC_CheckType, MVT::i64,
/*65849*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*65852*/       OPC_EmitMergeInputChains, 1, 1, 
/*65855*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::SUB64rm), 0|OPFL_Chain|OPFL_MemRefs,
                    2/*#VTs*/, MVT::i64, MVT::i32, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (X86sub_flag:i64 GR64:i64:$src1, (ld:i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>)
                // Dst: (SUB64rm:i64 GR64:i64:$src1, addr:iPTR:$src2)
/*65869*/     0, /*End of Scope*/
/*65870*/   /*Scope*/ 46|128,1/*174*/, /*->66046*/
/*65872*/     OPC_RecordChild1, // #1 = $src2
/*65873*/     OPC_Scope, 118, /*->65993*/ // 5 children in Scope
/*65875*/       OPC_MoveChild, 1,
/*65877*/       OPC_CheckOpcode, ISD::Constant,
/*65879*/       OPC_Scope, 47, /*->65928*/ // 3 children in Scope
/*65881*/         OPC_CheckPredicate, 11, // Predicate_immSext8
/*65883*/         OPC_MoveParent,
/*65884*/         OPC_SwitchType /*3 cases */, 12,  MVT::i16,// ->65899
/*65887*/           OPC_EmitConvertToTarget, 1,
/*65889*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::SUB16ri8), 0,
                        2/*#VTs*/, MVT::i16, MVT::i32, 2/*#Ops*/, 0, 2, 
                    // Src: (X86sub_flag:i16 GR16:i16:$src1, (imm:i16)<<P:Predicate_immSext8>>:$src2)
                    // Dst: (SUB16ri8:i16 GR16:i16:$src1, (imm:i16)<<P:Predicate_immSext8>>:$src2)
                  /*SwitchType*/ 12,  MVT::i32,// ->65913
/*65901*/           OPC_EmitConvertToTarget, 1,
/*65903*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::SUB32ri8), 0,
                        2/*#VTs*/, MVT::i32, MVT::i32, 2/*#Ops*/, 0, 2, 
                    // Src: (X86sub_flag:i32 GR32:i32:$src1, (imm:i32)<<P:Predicate_immSext8>>:$src2)
                    // Dst: (SUB32ri8:i32 GR32:i32:$src1, (imm:i32)<<P:Predicate_immSext8>>:$src2)
                  /*SwitchType*/ 12,  MVT::i64,// ->65927
/*65915*/           OPC_EmitConvertToTarget, 1,
/*65917*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::SUB64ri8), 0,
                        2/*#VTs*/, MVT::i64, MVT::i32, 2/*#Ops*/, 0, 2, 
                    // Src: (X86sub_flag:i64 GR64:i64:$src1, (imm:i64)<<P:Predicate_immSext8>>:$src2)
                    // Dst: (SUB64ri8:i64 GR64:i64:$src1, (imm:i64)<<P:Predicate_immSext8>>:$src2)
                  0, // EndSwitchType
/*65928*/       /*Scope*/ 17, /*->65946*/
/*65929*/         OPC_CheckPredicate, 12, // Predicate_i64immSExt32
/*65931*/         OPC_MoveParent,
/*65932*/         OPC_CheckType, MVT::i64,
/*65934*/         OPC_EmitConvertToTarget, 1,
/*65936*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::SUB64ri32), 0,
                      2/*#VTs*/, MVT::i64, MVT::i32, 2/*#Ops*/, 0, 2, 
                  // Src: (X86sub_flag:i64 GR64:i64:$src1, (imm:i64)<<P:Predicate_i64immSExt32>>:$src2)
                  // Dst: (SUB64ri32:i64 GR64:i64:$src1, (imm:i64)<<P:Predicate_i64immSExt32>>:$src2)
/*65946*/       /*Scope*/ 45, /*->65992*/
/*65947*/         OPC_MoveParent,
/*65948*/         OPC_SwitchType /*3 cases */, 12,  MVT::i8,// ->65963
/*65951*/           OPC_EmitConvertToTarget, 1,
/*65953*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::SUB8ri), 0,
                        2/*#VTs*/, MVT::i8, MVT::i32, 2/*#Ops*/, 0, 2, 
                    // Src: (X86sub_flag:i8 GR8:i8:$src1, (imm:i8):$src2)
                    // Dst: (SUB8ri:i8 GR8:i8:$src1, (imm:i8):$src2)
                  /*SwitchType*/ 12,  MVT::i16,// ->65977
/*65965*/           OPC_EmitConvertToTarget, 1,
/*65967*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::SUB16ri), 0,
                        2/*#VTs*/, MVT::i16, MVT::i32, 2/*#Ops*/, 0, 2, 
                    // Src: (X86sub_flag:i16 GR16:i16:$src1, (imm:i16):$src2)
                    // Dst: (SUB16ri:i16 GR16:i16:$src1, (imm:i16):$src2)
                  /*SwitchType*/ 12,  MVT::i32,// ->65991
/*65979*/           OPC_EmitConvertToTarget, 1,
/*65981*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::SUB32ri), 0,
                        2/*#VTs*/, MVT::i32, MVT::i32, 2/*#Ops*/, 0, 2, 
                    // Src: (X86sub_flag:i32 GR32:i32:$src1, (imm:i32):$src2)
                    // Dst: (SUB32ri:i32 GR32:i32:$src1, (imm:i32):$src2)
                  0, // EndSwitchType
/*65992*/       0, /*End of Scope*/
/*65993*/     /*Scope*/ 12, /*->66006*/
/*65994*/       OPC_CheckType, MVT::i8,
/*65996*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::SUB8rr), 0,
                    2/*#VTs*/, MVT::i8, MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (X86sub_flag:i8 GR8:i8:$src1, GR8:i8:$src2)
                // Dst: (SUB8rr:i8 GR8:i8:$src1, GR8:i8:$src2)
/*66006*/     /*Scope*/ 12, /*->66019*/
/*66007*/       OPC_CheckType, MVT::i16,
/*66009*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::SUB16rr), 0,
                    2/*#VTs*/, MVT::i16, MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (X86sub_flag:i16 GR16:i16:$src1, GR16:i16:$src2)
                // Dst: (SUB16rr:i16 GR16:i16:$src1, GR16:i16:$src2)
/*66019*/     /*Scope*/ 12, /*->66032*/
/*66020*/       OPC_CheckType, MVT::i32,
/*66022*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::SUB32rr), 0,
                    2/*#VTs*/, MVT::i32, MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (X86sub_flag:i32 GR32:i32:$src1, GR32:i32:$src2)
                // Dst: (SUB32rr:i32 GR32:i32:$src1, GR32:i32:$src2)
/*66032*/     /*Scope*/ 12, /*->66045*/
/*66033*/       OPC_CheckType, MVT::i64,
/*66035*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::SUB64rr), 0,
                    2/*#VTs*/, MVT::i64, MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (X86sub_flag:i64 GR64:i64:$src1, GR64:i64:$src2)
                // Dst: (SUB64rr:i64 GR64:i64:$src1, GR64:i64:$src2)
/*66045*/     0, /*End of Scope*/
/*66046*/   0, /*End of Scope*/
          /*SwitchOpcode*/ 42|128,3/*426*/,  X86ISD::OR,// ->66476
/*66050*/   OPC_Scope, 121, /*->66173*/ // 3 children in Scope
/*66052*/     OPC_RecordChild0, // #0 = $src1
/*66053*/     OPC_MoveChild, 1,
/*66055*/     OPC_CheckOpcode, ISD::LOAD,
/*66057*/     OPC_RecordMemRef,
/*66058*/     OPC_RecordNode, // #1 = 'ld' chained node
/*66059*/     OPC_CheckFoldableChainNode,
/*66060*/     OPC_RecordChild1, // #2 = $src2
/*66061*/     OPC_CheckPredicate, 2, // Predicate_unindexedload
/*66063*/     OPC_Scope, 27, /*->66092*/ // 4 children in Scope
/*66065*/       OPC_CheckPredicate, 8, // Predicate_load
/*66067*/       OPC_CheckPredicate, 9, // Predicate_dsload
/*66069*/       OPC_MoveParent,
/*66070*/       OPC_CheckType, MVT::i8,
/*66072*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*66075*/       OPC_EmitMergeInputChains, 1, 1, 
/*66078*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::OR8rm), 0|OPFL_Chain|OPFL_MemRefs,
                    2/*#VTs*/, MVT::i8, MVT::i32, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (X86or_flag:i8 GR8:i8:$src1, (ld:i8 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>)
                // Dst: (OR8rm:i8 GR8:i8:$src1, addr:iPTR:$src2)
/*66092*/     /*Scope*/ 25, /*->66118*/
/*66093*/       OPC_CheckPredicate, 6, // Predicate_loadi16
/*66095*/       OPC_MoveParent,
/*66096*/       OPC_CheckType, MVT::i16,
/*66098*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*66101*/       OPC_EmitMergeInputChains, 1, 1, 
/*66104*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::OR16rm), 0|OPFL_Chain|OPFL_MemRefs,
                    2/*#VTs*/, MVT::i16, MVT::i32, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (X86or_flag:i16 GR16:i16:$src1, (ld:i16 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>)
                // Dst: (OR16rm:i16 GR16:i16:$src1, addr:iPTR:$src2)
/*66118*/     /*Scope*/ 25, /*->66144*/
/*66119*/       OPC_CheckPredicate, 3, // Predicate_loadi32
/*66121*/       OPC_MoveParent,
/*66122*/       OPC_CheckType, MVT::i32,
/*66124*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*66127*/       OPC_EmitMergeInputChains, 1, 1, 
/*66130*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::OR32rm), 0|OPFL_Chain|OPFL_MemRefs,
                    2/*#VTs*/, MVT::i32, MVT::i32, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (X86or_flag:i32 GR32:i32:$src1, (ld:i32 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)
                // Dst: (OR32rm:i32 GR32:i32:$src1, addr:iPTR:$src2)
/*66144*/     /*Scope*/ 27, /*->66172*/
/*66145*/       OPC_CheckPredicate, 8, // Predicate_load
/*66147*/       OPC_CheckPredicate, 9, // Predicate_dsload
/*66149*/       OPC_MoveParent,
/*66150*/       OPC_CheckType, MVT::i64,
/*66152*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*66155*/       OPC_EmitMergeInputChains, 1, 1, 
/*66158*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::OR64rm), 0|OPFL_Chain|OPFL_MemRefs,
                    2/*#VTs*/, MVT::i64, MVT::i32, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (X86or_flag:i64 GR64:i64:$src1, (ld:i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>)
                // Dst: (OR64rm:i64 GR64:i64:$src1, addr:iPTR:$src2)
/*66172*/     0, /*End of Scope*/
/*66173*/   /*Scope*/ 124, /*->66298*/
/*66174*/     OPC_MoveChild, 0,
/*66176*/     OPC_CheckOpcode, ISD::LOAD,
/*66178*/     OPC_RecordMemRef,
/*66179*/     OPC_RecordNode, // #0 = 'ld' chained node
/*66180*/     OPC_CheckFoldableChainNode,
/*66181*/     OPC_RecordChild1, // #1 = $src2
/*66182*/     OPC_CheckPredicate, 2, // Predicate_unindexedload
/*66184*/     OPC_Scope, 28, /*->66214*/ // 4 children in Scope
/*66186*/       OPC_CheckPredicate, 8, // Predicate_load
/*66188*/       OPC_CheckPredicate, 9, // Predicate_dsload
/*66190*/       OPC_MoveParent,
/*66191*/       OPC_RecordChild1, // #2 = $src1
/*66192*/       OPC_CheckType, MVT::i8,
/*66194*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*66197*/       OPC_EmitMergeInputChains, 1, 0, 
/*66200*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::OR8rm), 0|OPFL_Chain|OPFL_MemRefs,
                    2/*#VTs*/, MVT::i8, MVT::i32, 6/*#Ops*/, 2, 3, 4, 5, 6, 7, 
                // Src: (X86or_flag:i8 (ld:i8 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>, GR8:i8:$src1)
                // Dst: (OR8rm:i8 GR8:i8:$src1, addr:iPTR:$src2)
/*66214*/     /*Scope*/ 26, /*->66241*/
/*66215*/       OPC_CheckPredicate, 6, // Predicate_loadi16
/*66217*/       OPC_MoveParent,
/*66218*/       OPC_RecordChild1, // #2 = $src1
/*66219*/       OPC_CheckType, MVT::i16,
/*66221*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*66224*/       OPC_EmitMergeInputChains, 1, 0, 
/*66227*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::OR16rm), 0|OPFL_Chain|OPFL_MemRefs,
                    2/*#VTs*/, MVT::i16, MVT::i32, 6/*#Ops*/, 2, 3, 4, 5, 6, 7, 
                // Src: (X86or_flag:i16 (ld:i16 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, GR16:i16:$src1)
                // Dst: (OR16rm:i16 GR16:i16:$src1, addr:iPTR:$src2)
/*66241*/     /*Scope*/ 26, /*->66268*/
/*66242*/       OPC_CheckPredicate, 3, // Predicate_loadi32
/*66244*/       OPC_MoveParent,
/*66245*/       OPC_RecordChild1, // #2 = $src1
/*66246*/       OPC_CheckType, MVT::i32,
/*66248*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*66251*/       OPC_EmitMergeInputChains, 1, 0, 
/*66254*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::OR32rm), 0|OPFL_Chain|OPFL_MemRefs,
                    2/*#VTs*/, MVT::i32, MVT::i32, 6/*#Ops*/, 2, 3, 4, 5, 6, 7, 
                // Src: (X86or_flag:i32 (ld:i32 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, GR32:i32:$src1)
                // Dst: (OR32rm:i32 GR32:i32:$src1, addr:iPTR:$src2)
/*66268*/     /*Scope*/ 28, /*->66297*/
/*66269*/       OPC_CheckPredicate, 8, // Predicate_load
/*66271*/       OPC_CheckPredicate, 9, // Predicate_dsload
/*66273*/       OPC_MoveParent,
/*66274*/       OPC_RecordChild1, // #2 = $src1
/*66275*/       OPC_CheckType, MVT::i64,
/*66277*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*66280*/       OPC_EmitMergeInputChains, 1, 0, 
/*66283*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::OR64rm), 0|OPFL_Chain|OPFL_MemRefs,
                    2/*#VTs*/, MVT::i64, MVT::i32, 6/*#Ops*/, 2, 3, 4, 5, 6, 7, 
                // Src: (X86or_flag:i64 (ld:i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>, GR64:i64:$src1)
                // Dst: (OR64rm:i64 GR64:i64:$src1, addr:iPTR:$src2)
/*66297*/     0, /*End of Scope*/
/*66298*/   /*Scope*/ 47|128,1/*175*/, /*->66475*/
/*66300*/     OPC_RecordChild0, // #0 = $src1
/*66301*/     OPC_RecordChild1, // #1 = $src2
/*66302*/     OPC_Scope, 118, /*->66422*/ // 5 children in Scope
/*66304*/       OPC_MoveChild, 1,
/*66306*/       OPC_CheckOpcode, ISD::Constant,
/*66308*/       OPC_Scope, 47, /*->66357*/ // 3 children in Scope
/*66310*/         OPC_CheckPredicate, 11, // Predicate_immSext8
/*66312*/         OPC_MoveParent,
/*66313*/         OPC_SwitchType /*3 cases */, 12,  MVT::i16,// ->66328
/*66316*/           OPC_EmitConvertToTarget, 1,
/*66318*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::OR16ri8), 0,
                        2/*#VTs*/, MVT::i16, MVT::i32, 2/*#Ops*/, 0, 2, 
                    // Src: (X86or_flag:i16 GR16:i16:$src1, (imm:i16)<<P:Predicate_immSext8>>:$src2)
                    // Dst: (OR16ri8:i16 GR16:i16:$src1, (imm:i16)<<P:Predicate_immSext8>>:$src2)
                  /*SwitchType*/ 12,  MVT::i32,// ->66342
/*66330*/           OPC_EmitConvertToTarget, 1,
/*66332*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::OR32ri8), 0,
                        2/*#VTs*/, MVT::i32, MVT::i32, 2/*#Ops*/, 0, 2, 
                    // Src: (X86or_flag:i32 GR32:i32:$src1, (imm:i32)<<P:Predicate_immSext8>>:$src2)
                    // Dst: (OR32ri8:i32 GR32:i32:$src1, (imm:i32)<<P:Predicate_immSext8>>:$src2)
                  /*SwitchType*/ 12,  MVT::i64,// ->66356
/*66344*/           OPC_EmitConvertToTarget, 1,
/*66346*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::OR64ri8), 0,
                        2/*#VTs*/, MVT::i64, MVT::i32, 2/*#Ops*/, 0, 2, 
                    // Src: (X86or_flag:i64 GR64:i64:$src1, (imm:i64)<<P:Predicate_immSext8>>:$src2)
                    // Dst: (OR64ri8:i64 GR64:i64:$src1, (imm:i64)<<P:Predicate_immSext8>>:$src2)
                  0, // EndSwitchType
/*66357*/       /*Scope*/ 17, /*->66375*/
/*66358*/         OPC_CheckPredicate, 12, // Predicate_i64immSExt32
/*66360*/         OPC_MoveParent,
/*66361*/         OPC_CheckType, MVT::i64,
/*66363*/         OPC_EmitConvertToTarget, 1,
/*66365*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::OR64ri32), 0,
                      2/*#VTs*/, MVT::i64, MVT::i32, 2/*#Ops*/, 0, 2, 
                  // Src: (X86or_flag:i64 GR64:i64:$src1, (imm:i64)<<P:Predicate_i64immSExt32>>:$src2)
                  // Dst: (OR64ri32:i64 GR64:i64:$src1, (imm:i64)<<P:Predicate_i64immSExt32>>:$src2)
/*66375*/       /*Scope*/ 45, /*->66421*/
/*66376*/         OPC_MoveParent,
/*66377*/         OPC_SwitchType /*3 cases */, 12,  MVT::i8,// ->66392
/*66380*/           OPC_EmitConvertToTarget, 1,
/*66382*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::OR8ri), 0,
                        2/*#VTs*/, MVT::i8, MVT::i32, 2/*#Ops*/, 0, 2, 
                    // Src: (X86or_flag:i8 GR8:i8:$src1, (imm:i8):$src2)
                    // Dst: (OR8ri:i8 GR8:i8:$src1, (imm:i8):$src2)
                  /*SwitchType*/ 12,  MVT::i16,// ->66406
/*66394*/           OPC_EmitConvertToTarget, 1,
/*66396*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::OR16ri), 0,
                        2/*#VTs*/, MVT::i16, MVT::i32, 2/*#Ops*/, 0, 2, 
                    // Src: (X86or_flag:i16 GR16:i16:$src1, (imm:i16):$src2)
                    // Dst: (OR16ri:i16 GR16:i16:$src1, (imm:i16):$src2)
                  /*SwitchType*/ 12,  MVT::i32,// ->66420
/*66408*/           OPC_EmitConvertToTarget, 1,
/*66410*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::OR32ri), 0,
                        2/*#VTs*/, MVT::i32, MVT::i32, 2/*#Ops*/, 0, 2, 
                    // Src: (X86or_flag:i32 GR32:i32:$src1, (imm:i32):$src2)
                    // Dst: (OR32ri:i32 GR32:i32:$src1, (imm:i32):$src2)
                  0, // EndSwitchType
/*66421*/       0, /*End of Scope*/
/*66422*/     /*Scope*/ 12, /*->66435*/
/*66423*/       OPC_CheckType, MVT::i8,
/*66425*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::OR8rr), 0,
                    2/*#VTs*/, MVT::i8, MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (X86or_flag:i8 GR8:i8:$src1, GR8:i8:$src2)
                // Dst: (OR8rr:i8 GR8:i8:$src1, GR8:i8:$src2)
/*66435*/     /*Scope*/ 12, /*->66448*/
/*66436*/       OPC_CheckType, MVT::i16,
/*66438*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::OR16rr), 0,
                    2/*#VTs*/, MVT::i16, MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (X86or_flag:i16 GR16:i16:$src1, GR16:i16:$src2)
                // Dst: (OR16rr:i16 GR16:i16:$src1, GR16:i16:$src2)
/*66448*/     /*Scope*/ 12, /*->66461*/
/*66449*/       OPC_CheckType, MVT::i32,
/*66451*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::OR32rr), 0,
                    2/*#VTs*/, MVT::i32, MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (X86or_flag:i32 GR32:i32:$src1, GR32:i32:$src2)
                // Dst: (OR32rr:i32 GR32:i32:$src1, GR32:i32:$src2)
/*66461*/     /*Scope*/ 12, /*->66474*/
/*66462*/       OPC_CheckType, MVT::i64,
/*66464*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::OR64rr), 0,
                    2/*#VTs*/, MVT::i64, MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (X86or_flag:i64 GR64:i64:$src1, GR64:i64:$src2)
                // Dst: (OR64rr:i64 GR64:i64:$src1, GR64:i64:$src2)
/*66474*/     0, /*End of Scope*/
/*66475*/   0, /*End of Scope*/
          /*SwitchOpcode*/ 42|128,3/*426*/,  X86ISD::XOR,// ->66905
/*66479*/   OPC_Scope, 121, /*->66602*/ // 3 children in Scope
/*66481*/     OPC_RecordChild0, // #0 = $src1
/*66482*/     OPC_MoveChild, 1,
/*66484*/     OPC_CheckOpcode, ISD::LOAD,
/*66486*/     OPC_RecordMemRef,
/*66487*/     OPC_RecordNode, // #1 = 'ld' chained node
/*66488*/     OPC_CheckFoldableChainNode,
/*66489*/     OPC_RecordChild1, // #2 = $src2
/*66490*/     OPC_CheckPredicate, 2, // Predicate_unindexedload
/*66492*/     OPC_Scope, 27, /*->66521*/ // 4 children in Scope
/*66494*/       OPC_CheckPredicate, 8, // Predicate_load
/*66496*/       OPC_CheckPredicate, 9, // Predicate_dsload
/*66498*/       OPC_MoveParent,
/*66499*/       OPC_CheckType, MVT::i8,
/*66501*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*66504*/       OPC_EmitMergeInputChains, 1, 1, 
/*66507*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::XOR8rm), 0|OPFL_Chain|OPFL_MemRefs,
                    2/*#VTs*/, MVT::i8, MVT::i32, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (X86xor_flag:i8 GR8:i8:$src1, (ld:i8 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>)
                // Dst: (XOR8rm:i8 GR8:i8:$src1, addr:iPTR:$src2)
/*66521*/     /*Scope*/ 25, /*->66547*/
/*66522*/       OPC_CheckPredicate, 6, // Predicate_loadi16
/*66524*/       OPC_MoveParent,
/*66525*/       OPC_CheckType, MVT::i16,
/*66527*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*66530*/       OPC_EmitMergeInputChains, 1, 1, 
/*66533*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::XOR16rm), 0|OPFL_Chain|OPFL_MemRefs,
                    2/*#VTs*/, MVT::i16, MVT::i32, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (X86xor_flag:i16 GR16:i16:$src1, (ld:i16 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>)
                // Dst: (XOR16rm:i16 GR16:i16:$src1, addr:iPTR:$src2)
/*66547*/     /*Scope*/ 25, /*->66573*/
/*66548*/       OPC_CheckPredicate, 3, // Predicate_loadi32
/*66550*/       OPC_MoveParent,
/*66551*/       OPC_CheckType, MVT::i32,
/*66553*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*66556*/       OPC_EmitMergeInputChains, 1, 1, 
/*66559*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::XOR32rm), 0|OPFL_Chain|OPFL_MemRefs,
                    2/*#VTs*/, MVT::i32, MVT::i32, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (X86xor_flag:i32 GR32:i32:$src1, (ld:i32 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)
                // Dst: (XOR32rm:i32 GR32:i32:$src1, addr:iPTR:$src2)
/*66573*/     /*Scope*/ 27, /*->66601*/
/*66574*/       OPC_CheckPredicate, 8, // Predicate_load
/*66576*/       OPC_CheckPredicate, 9, // Predicate_dsload
/*66578*/       OPC_MoveParent,
/*66579*/       OPC_CheckType, MVT::i64,
/*66581*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*66584*/       OPC_EmitMergeInputChains, 1, 1, 
/*66587*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::XOR64rm), 0|OPFL_Chain|OPFL_MemRefs,
                    2/*#VTs*/, MVT::i64, MVT::i32, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (X86xor_flag:i64 GR64:i64:$src1, (ld:i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>)
                // Dst: (XOR64rm:i64 GR64:i64:$src1, addr:iPTR:$src2)
/*66601*/     0, /*End of Scope*/
/*66602*/   /*Scope*/ 124, /*->66727*/
/*66603*/     OPC_MoveChild, 0,
/*66605*/     OPC_CheckOpcode, ISD::LOAD,
/*66607*/     OPC_RecordMemRef,
/*66608*/     OPC_RecordNode, // #0 = 'ld' chained node
/*66609*/     OPC_CheckFoldableChainNode,
/*66610*/     OPC_RecordChild1, // #1 = $src2
/*66611*/     OPC_CheckPredicate, 2, // Predicate_unindexedload
/*66613*/     OPC_Scope, 28, /*->66643*/ // 4 children in Scope
/*66615*/       OPC_CheckPredicate, 8, // Predicate_load
/*66617*/       OPC_CheckPredicate, 9, // Predicate_dsload
/*66619*/       OPC_MoveParent,
/*66620*/       OPC_RecordChild1, // #2 = $src1
/*66621*/       OPC_CheckType, MVT::i8,
/*66623*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*66626*/       OPC_EmitMergeInputChains, 1, 0, 
/*66629*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::XOR8rm), 0|OPFL_Chain|OPFL_MemRefs,
                    2/*#VTs*/, MVT::i8, MVT::i32, 6/*#Ops*/, 2, 3, 4, 5, 6, 7, 
                // Src: (X86xor_flag:i8 (ld:i8 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>, GR8:i8:$src1)
                // Dst: (XOR8rm:i8 GR8:i8:$src1, addr:iPTR:$src2)
/*66643*/     /*Scope*/ 26, /*->66670*/
/*66644*/       OPC_CheckPredicate, 6, // Predicate_loadi16
/*66646*/       OPC_MoveParent,
/*66647*/       OPC_RecordChild1, // #2 = $src1
/*66648*/       OPC_CheckType, MVT::i16,
/*66650*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*66653*/       OPC_EmitMergeInputChains, 1, 0, 
/*66656*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::XOR16rm), 0|OPFL_Chain|OPFL_MemRefs,
                    2/*#VTs*/, MVT::i16, MVT::i32, 6/*#Ops*/, 2, 3, 4, 5, 6, 7, 
                // Src: (X86xor_flag:i16 (ld:i16 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, GR16:i16:$src1)
                // Dst: (XOR16rm:i16 GR16:i16:$src1, addr:iPTR:$src2)
/*66670*/     /*Scope*/ 26, /*->66697*/
/*66671*/       OPC_CheckPredicate, 3, // Predicate_loadi32
/*66673*/       OPC_MoveParent,
/*66674*/       OPC_RecordChild1, // #2 = $src1
/*66675*/       OPC_CheckType, MVT::i32,
/*66677*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*66680*/       OPC_EmitMergeInputChains, 1, 0, 
/*66683*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::XOR32rm), 0|OPFL_Chain|OPFL_MemRefs,
                    2/*#VTs*/, MVT::i32, MVT::i32, 6/*#Ops*/, 2, 3, 4, 5, 6, 7, 
                // Src: (X86xor_flag:i32 (ld:i32 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, GR32:i32:$src1)
                // Dst: (XOR32rm:i32 GR32:i32:$src1, addr:iPTR:$src2)
/*66697*/     /*Scope*/ 28, /*->66726*/
/*66698*/       OPC_CheckPredicate, 8, // Predicate_load
/*66700*/       OPC_CheckPredicate, 9, // Predicate_dsload
/*66702*/       OPC_MoveParent,
/*66703*/       OPC_RecordChild1, // #2 = $src1
/*66704*/       OPC_CheckType, MVT::i64,
/*66706*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*66709*/       OPC_EmitMergeInputChains, 1, 0, 
/*66712*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::XOR64rm), 0|OPFL_Chain|OPFL_MemRefs,
                    2/*#VTs*/, MVT::i64, MVT::i32, 6/*#Ops*/, 2, 3, 4, 5, 6, 7, 
                // Src: (X86xor_flag:i64 (ld:i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>, GR64:i64:$src1)
                // Dst: (XOR64rm:i64 GR64:i64:$src1, addr:iPTR:$src2)
/*66726*/     0, /*End of Scope*/
/*66727*/   /*Scope*/ 47|128,1/*175*/, /*->66904*/
/*66729*/     OPC_RecordChild0, // #0 = $src1
/*66730*/     OPC_RecordChild1, // #1 = $src2
/*66731*/     OPC_Scope, 118, /*->66851*/ // 5 children in Scope
/*66733*/       OPC_MoveChild, 1,
/*66735*/       OPC_CheckOpcode, ISD::Constant,
/*66737*/       OPC_Scope, 47, /*->66786*/ // 3 children in Scope
/*66739*/         OPC_CheckPredicate, 11, // Predicate_immSext8
/*66741*/         OPC_MoveParent,
/*66742*/         OPC_SwitchType /*3 cases */, 12,  MVT::i16,// ->66757
/*66745*/           OPC_EmitConvertToTarget, 1,
/*66747*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::XOR16ri8), 0,
                        2/*#VTs*/, MVT::i16, MVT::i32, 2/*#Ops*/, 0, 2, 
                    // Src: (X86xor_flag:i16 GR16:i16:$src1, (imm:i16)<<P:Predicate_immSext8>>:$src2)
                    // Dst: (XOR16ri8:i16 GR16:i16:$src1, (imm:i16)<<P:Predicate_immSext8>>:$src2)
                  /*SwitchType*/ 12,  MVT::i32,// ->66771
/*66759*/           OPC_EmitConvertToTarget, 1,
/*66761*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::XOR32ri8), 0,
                        2/*#VTs*/, MVT::i32, MVT::i32, 2/*#Ops*/, 0, 2, 
                    // Src: (X86xor_flag:i32 GR32:i32:$src1, (imm:i32)<<P:Predicate_immSext8>>:$src2)
                    // Dst: (XOR32ri8:i32 GR32:i32:$src1, (imm:i32)<<P:Predicate_immSext8>>:$src2)
                  /*SwitchType*/ 12,  MVT::i64,// ->66785
/*66773*/           OPC_EmitConvertToTarget, 1,
/*66775*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::XOR64ri8), 0,
                        2/*#VTs*/, MVT::i64, MVT::i32, 2/*#Ops*/, 0, 2, 
                    // Src: (X86xor_flag:i64 GR64:i64:$src1, (imm:i64)<<P:Predicate_immSext8>>:$src2)
                    // Dst: (XOR64ri8:i64 GR64:i64:$src1, (imm:i64)<<P:Predicate_immSext8>>:$src2)
                  0, // EndSwitchType
/*66786*/       /*Scope*/ 17, /*->66804*/
/*66787*/         OPC_CheckPredicate, 12, // Predicate_i64immSExt32
/*66789*/         OPC_MoveParent,
/*66790*/         OPC_CheckType, MVT::i64,
/*66792*/         OPC_EmitConvertToTarget, 1,
/*66794*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::XOR64ri32), 0,
                      2/*#VTs*/, MVT::i64, MVT::i32, 2/*#Ops*/, 0, 2, 
                  // Src: (X86xor_flag:i64 GR64:i64:$src1, (imm:i64)<<P:Predicate_i64immSExt32>>:$src2)
                  // Dst: (XOR64ri32:i64 GR64:i64:$src1, (imm:i64)<<P:Predicate_i64immSExt32>>:$src2)
/*66804*/       /*Scope*/ 45, /*->66850*/
/*66805*/         OPC_MoveParent,
/*66806*/         OPC_SwitchType /*3 cases */, 12,  MVT::i8,// ->66821
/*66809*/           OPC_EmitConvertToTarget, 1,
/*66811*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::XOR8ri), 0,
                        2/*#VTs*/, MVT::i8, MVT::i32, 2/*#Ops*/, 0, 2, 
                    // Src: (X86xor_flag:i8 GR8:i8:$src1, (imm:i8):$src2)
                    // Dst: (XOR8ri:i8 GR8:i8:$src1, (imm:i8):$src2)
                  /*SwitchType*/ 12,  MVT::i16,// ->66835
/*66823*/           OPC_EmitConvertToTarget, 1,
/*66825*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::XOR16ri), 0,
                        2/*#VTs*/, MVT::i16, MVT::i32, 2/*#Ops*/, 0, 2, 
                    // Src: (X86xor_flag:i16 GR16:i16:$src1, (imm:i16):$src2)
                    // Dst: (XOR16ri:i16 GR16:i16:$src1, (imm:i16):$src2)
                  /*SwitchType*/ 12,  MVT::i32,// ->66849
/*66837*/           OPC_EmitConvertToTarget, 1,
/*66839*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::XOR32ri), 0,
                        2/*#VTs*/, MVT::i32, MVT::i32, 2/*#Ops*/, 0, 2, 
                    // Src: (X86xor_flag:i32 GR32:i32:$src1, (imm:i32):$src2)
                    // Dst: (XOR32ri:i32 GR32:i32:$src1, (imm:i32):$src2)
                  0, // EndSwitchType
/*66850*/       0, /*End of Scope*/
/*66851*/     /*Scope*/ 12, /*->66864*/
/*66852*/       OPC_CheckType, MVT::i8,
/*66854*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::XOR8rr), 0,
                    2/*#VTs*/, MVT::i8, MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (X86xor_flag:i8 GR8:i8:$src1, GR8:i8:$src2)
                // Dst: (XOR8rr:i8 GR8:i8:$src1, GR8:i8:$src2)
/*66864*/     /*Scope*/ 12, /*->66877*/
/*66865*/       OPC_CheckType, MVT::i16,
/*66867*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::XOR16rr), 0,
                    2/*#VTs*/, MVT::i16, MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (X86xor_flag:i16 GR16:i16:$src1, GR16:i16:$src2)
                // Dst: (XOR16rr:i16 GR16:i16:$src1, GR16:i16:$src2)
/*66877*/     /*Scope*/ 12, /*->66890*/
/*66878*/       OPC_CheckType, MVT::i32,
/*66880*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::XOR32rr), 0,
                    2/*#VTs*/, MVT::i32, MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (X86xor_flag:i32 GR32:i32:$src1, GR32:i32:$src2)
                // Dst: (XOR32rr:i32 GR32:i32:$src1, GR32:i32:$src2)
/*66890*/     /*Scope*/ 12, /*->66903*/
/*66891*/       OPC_CheckType, MVT::i64,
/*66893*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::XOR64rr), 0,
                    2/*#VTs*/, MVT::i64, MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (X86xor_flag:i64 GR64:i64:$src1, GR64:i64:$src2)
                // Dst: (XOR64rr:i64 GR64:i64:$src1, GR64:i64:$src2)
/*66903*/     0, /*End of Scope*/
/*66904*/   0, /*End of Scope*/
          /*SwitchOpcode*/ 42|128,3/*426*/,  X86ISD::AND,// ->67334
/*66908*/   OPC_Scope, 121, /*->67031*/ // 3 children in Scope
/*66910*/     OPC_RecordChild0, // #0 = $src1
/*66911*/     OPC_MoveChild, 1,
/*66913*/     OPC_CheckOpcode, ISD::LOAD,
/*66915*/     OPC_RecordMemRef,
/*66916*/     OPC_RecordNode, // #1 = 'ld' chained node
/*66917*/     OPC_CheckFoldableChainNode,
/*66918*/     OPC_RecordChild1, // #2 = $src2
/*66919*/     OPC_CheckPredicate, 2, // Predicate_unindexedload
/*66921*/     OPC_Scope, 27, /*->66950*/ // 4 children in Scope
/*66923*/       OPC_CheckPredicate, 8, // Predicate_load
/*66925*/       OPC_CheckPredicate, 9, // Predicate_dsload
/*66927*/       OPC_MoveParent,
/*66928*/       OPC_CheckType, MVT::i8,
/*66930*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*66933*/       OPC_EmitMergeInputChains, 1, 1, 
/*66936*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::AND8rm), 0|OPFL_Chain|OPFL_MemRefs,
                    2/*#VTs*/, MVT::i8, MVT::i32, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (X86and_flag:i8 GR8:i8:$src1, (ld:i8 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>)
                // Dst: (AND8rm:i8 GR8:i8:$src1, addr:iPTR:$src2)
/*66950*/     /*Scope*/ 25, /*->66976*/
/*66951*/       OPC_CheckPredicate, 6, // Predicate_loadi16
/*66953*/       OPC_MoveParent,
/*66954*/       OPC_CheckType, MVT::i16,
/*66956*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*66959*/       OPC_EmitMergeInputChains, 1, 1, 
/*66962*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::AND16rm), 0|OPFL_Chain|OPFL_MemRefs,
                    2/*#VTs*/, MVT::i16, MVT::i32, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (X86and_flag:i16 GR16:i16:$src1, (ld:i16 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>)
                // Dst: (AND16rm:i16 GR16:i16:$src1, addr:iPTR:$src2)
/*66976*/     /*Scope*/ 25, /*->67002*/
/*66977*/       OPC_CheckPredicate, 3, // Predicate_loadi32
/*66979*/       OPC_MoveParent,
/*66980*/       OPC_CheckType, MVT::i32,
/*66982*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*66985*/       OPC_EmitMergeInputChains, 1, 1, 
/*66988*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::AND32rm), 0|OPFL_Chain|OPFL_MemRefs,
                    2/*#VTs*/, MVT::i32, MVT::i32, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (X86and_flag:i32 GR32:i32:$src1, (ld:i32 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)
                // Dst: (AND32rm:i32 GR32:i32:$src1, addr:iPTR:$src2)
/*67002*/     /*Scope*/ 27, /*->67030*/
/*67003*/       OPC_CheckPredicate, 8, // Predicate_load
/*67005*/       OPC_CheckPredicate, 9, // Predicate_dsload
/*67007*/       OPC_MoveParent,
/*67008*/       OPC_CheckType, MVT::i64,
/*67010*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*67013*/       OPC_EmitMergeInputChains, 1, 1, 
/*67016*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::AND64rm), 0|OPFL_Chain|OPFL_MemRefs,
                    2/*#VTs*/, MVT::i64, MVT::i32, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (X86and_flag:i64 GR64:i64:$src1, (ld:i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>)
                // Dst: (AND64rm:i64 GR64:i64:$src1, addr:iPTR:$src2)
/*67030*/     0, /*End of Scope*/
/*67031*/   /*Scope*/ 124, /*->67156*/
/*67032*/     OPC_MoveChild, 0,
/*67034*/     OPC_CheckOpcode, ISD::LOAD,
/*67036*/     OPC_RecordMemRef,
/*67037*/     OPC_RecordNode, // #0 = 'ld' chained node
/*67038*/     OPC_CheckFoldableChainNode,
/*67039*/     OPC_RecordChild1, // #1 = $src2
/*67040*/     OPC_CheckPredicate, 2, // Predicate_unindexedload
/*67042*/     OPC_Scope, 28, /*->67072*/ // 4 children in Scope
/*67044*/       OPC_CheckPredicate, 8, // Predicate_load
/*67046*/       OPC_CheckPredicate, 9, // Predicate_dsload
/*67048*/       OPC_MoveParent,
/*67049*/       OPC_RecordChild1, // #2 = $src1
/*67050*/       OPC_CheckType, MVT::i8,
/*67052*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*67055*/       OPC_EmitMergeInputChains, 1, 0, 
/*67058*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::AND8rm), 0|OPFL_Chain|OPFL_MemRefs,
                    2/*#VTs*/, MVT::i8, MVT::i32, 6/*#Ops*/, 2, 3, 4, 5, 6, 7, 
                // Src: (X86and_flag:i8 (ld:i8 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>, GR8:i8:$src1)
                // Dst: (AND8rm:i8 GR8:i8:$src1, addr:iPTR:$src2)
/*67072*/     /*Scope*/ 26, /*->67099*/
/*67073*/       OPC_CheckPredicate, 6, // Predicate_loadi16
/*67075*/       OPC_MoveParent,
/*67076*/       OPC_RecordChild1, // #2 = $src1
/*67077*/       OPC_CheckType, MVT::i16,
/*67079*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*67082*/       OPC_EmitMergeInputChains, 1, 0, 
/*67085*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::AND16rm), 0|OPFL_Chain|OPFL_MemRefs,
                    2/*#VTs*/, MVT::i16, MVT::i32, 6/*#Ops*/, 2, 3, 4, 5, 6, 7, 
                // Src: (X86and_flag:i16 (ld:i16 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, GR16:i16:$src1)
                // Dst: (AND16rm:i16 GR16:i16:$src1, addr:iPTR:$src2)
/*67099*/     /*Scope*/ 26, /*->67126*/
/*67100*/       OPC_CheckPredicate, 3, // Predicate_loadi32
/*67102*/       OPC_MoveParent,
/*67103*/       OPC_RecordChild1, // #2 = $src1
/*67104*/       OPC_CheckType, MVT::i32,
/*67106*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*67109*/       OPC_EmitMergeInputChains, 1, 0, 
/*67112*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::AND32rm), 0|OPFL_Chain|OPFL_MemRefs,
                    2/*#VTs*/, MVT::i32, MVT::i32, 6/*#Ops*/, 2, 3, 4, 5, 6, 7, 
                // Src: (X86and_flag:i32 (ld:i32 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, GR32:i32:$src1)
                // Dst: (AND32rm:i32 GR32:i32:$src1, addr:iPTR:$src2)
/*67126*/     /*Scope*/ 28, /*->67155*/
/*67127*/       OPC_CheckPredicate, 8, // Predicate_load
/*67129*/       OPC_CheckPredicate, 9, // Predicate_dsload
/*67131*/       OPC_MoveParent,
/*67132*/       OPC_RecordChild1, // #2 = $src1
/*67133*/       OPC_CheckType, MVT::i64,
/*67135*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*67138*/       OPC_EmitMergeInputChains, 1, 0, 
/*67141*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::AND64rm), 0|OPFL_Chain|OPFL_MemRefs,
                    2/*#VTs*/, MVT::i64, MVT::i32, 6/*#Ops*/, 2, 3, 4, 5, 6, 7, 
                // Src: (X86and_flag:i64 (ld:i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>, GR64:i64:$src1)
                // Dst: (AND64rm:i64 GR64:i64:$src1, addr:iPTR:$src2)
/*67155*/     0, /*End of Scope*/
/*67156*/   /*Scope*/ 47|128,1/*175*/, /*->67333*/
/*67158*/     OPC_RecordChild0, // #0 = $src1
/*67159*/     OPC_RecordChild1, // #1 = $src2
/*67160*/     OPC_Scope, 118, /*->67280*/ // 5 children in Scope
/*67162*/       OPC_MoveChild, 1,
/*67164*/       OPC_CheckOpcode, ISD::Constant,
/*67166*/       OPC_Scope, 47, /*->67215*/ // 3 children in Scope
/*67168*/         OPC_CheckPredicate, 11, // Predicate_immSext8
/*67170*/         OPC_MoveParent,
/*67171*/         OPC_SwitchType /*3 cases */, 12,  MVT::i16,// ->67186
/*67174*/           OPC_EmitConvertToTarget, 1,
/*67176*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::AND16ri8), 0,
                        2/*#VTs*/, MVT::i16, MVT::i32, 2/*#Ops*/, 0, 2, 
                    // Src: (X86and_flag:i16 GR16:i16:$src1, (imm:i16)<<P:Predicate_immSext8>>:$src2)
                    // Dst: (AND16ri8:i16 GR16:i16:$src1, (imm:i16)<<P:Predicate_immSext8>>:$src2)
                  /*SwitchType*/ 12,  MVT::i32,// ->67200
/*67188*/           OPC_EmitConvertToTarget, 1,
/*67190*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::AND32ri8), 0,
                        2/*#VTs*/, MVT::i32, MVT::i32, 2/*#Ops*/, 0, 2, 
                    // Src: (X86and_flag:i32 GR32:i32:$src1, (imm:i32)<<P:Predicate_immSext8>>:$src2)
                    // Dst: (AND32ri8:i32 GR32:i32:$src1, (imm:i32)<<P:Predicate_immSext8>>:$src2)
                  /*SwitchType*/ 12,  MVT::i64,// ->67214
/*67202*/           OPC_EmitConvertToTarget, 1,
/*67204*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::AND64ri8), 0,
                        2/*#VTs*/, MVT::i64, MVT::i32, 2/*#Ops*/, 0, 2, 
                    // Src: (X86and_flag:i64 GR64:i64:$src1, (imm:i64)<<P:Predicate_immSext8>>:$src2)
                    // Dst: (AND64ri8:i64 GR64:i64:$src1, (imm:i64)<<P:Predicate_immSext8>>:$src2)
                  0, // EndSwitchType
/*67215*/       /*Scope*/ 17, /*->67233*/
/*67216*/         OPC_CheckPredicate, 12, // Predicate_i64immSExt32
/*67218*/         OPC_MoveParent,
/*67219*/         OPC_CheckType, MVT::i64,
/*67221*/         OPC_EmitConvertToTarget, 1,
/*67223*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::AND64ri32), 0,
                      2/*#VTs*/, MVT::i64, MVT::i32, 2/*#Ops*/, 0, 2, 
                  // Src: (X86and_flag:i64 GR64:i64:$src1, (imm:i64)<<P:Predicate_i64immSExt32>>:$src2)
                  // Dst: (AND64ri32:i64 GR64:i64:$src1, (imm:i64)<<P:Predicate_i64immSExt32>>:$src2)
/*67233*/       /*Scope*/ 45, /*->67279*/
/*67234*/         OPC_MoveParent,
/*67235*/         OPC_SwitchType /*3 cases */, 12,  MVT::i8,// ->67250
/*67238*/           OPC_EmitConvertToTarget, 1,
/*67240*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::AND8ri), 0,
                        2/*#VTs*/, MVT::i8, MVT::i32, 2/*#Ops*/, 0, 2, 
                    // Src: (X86and_flag:i8 GR8:i8:$src1, (imm:i8):$src2)
                    // Dst: (AND8ri:i8 GR8:i8:$src1, (imm:i8):$src2)
                  /*SwitchType*/ 12,  MVT::i16,// ->67264
/*67252*/           OPC_EmitConvertToTarget, 1,
/*67254*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::AND16ri), 0,
                        2/*#VTs*/, MVT::i16, MVT::i32, 2/*#Ops*/, 0, 2, 
                    // Src: (X86and_flag:i16 GR16:i16:$src1, (imm:i16):$src2)
                    // Dst: (AND16ri:i16 GR16:i16:$src1, (imm:i16):$src2)
                  /*SwitchType*/ 12,  MVT::i32,// ->67278
/*67266*/           OPC_EmitConvertToTarget, 1,
/*67268*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::AND32ri), 0,
                        2/*#VTs*/, MVT::i32, MVT::i32, 2/*#Ops*/, 0, 2, 
                    // Src: (X86and_flag:i32 GR32:i32:$src1, (imm:i32):$src2)
                    // Dst: (AND32ri:i32 GR32:i32:$src1, (imm:i32):$src2)
                  0, // EndSwitchType
/*67279*/       0, /*End of Scope*/
/*67280*/     /*Scope*/ 12, /*->67293*/
/*67281*/       OPC_CheckType, MVT::i8,
/*67283*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::AND8rr), 0,
                    2/*#VTs*/, MVT::i8, MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (X86and_flag:i8 GR8:i8:$src1, GR8:i8:$src2)
                // Dst: (AND8rr:i8 GR8:i8:$src1, GR8:i8:$src2)
/*67293*/     /*Scope*/ 12, /*->67306*/
/*67294*/       OPC_CheckType, MVT::i16,
/*67296*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::AND16rr), 0,
                    2/*#VTs*/, MVT::i16, MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (X86and_flag:i16 GR16:i16:$src1, GR16:i16:$src2)
                // Dst: (AND16rr:i16 GR16:i16:$src1, GR16:i16:$src2)
/*67306*/     /*Scope*/ 12, /*->67319*/
/*67307*/       OPC_CheckType, MVT::i32,
/*67309*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::AND32rr), 0,
                    2/*#VTs*/, MVT::i32, MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (X86and_flag:i32 GR32:i32:$src1, GR32:i32:$src2)
                // Dst: (AND32rr:i32 GR32:i32:$src1, GR32:i32:$src2)
/*67319*/     /*Scope*/ 12, /*->67332*/
/*67320*/       OPC_CheckType, MVT::i64,
/*67322*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::AND64rr), 0,
                    2/*#VTs*/, MVT::i64, MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (X86and_flag:i64 GR64:i64:$src1, GR64:i64:$src2)
                // Dst: (AND64rr:i64 GR64:i64:$src1, GR64:i64:$src2)
/*67332*/     0, /*End of Scope*/
/*67333*/   0, /*End of Scope*/
          /*SwitchOpcode*/ 80|128,1/*208*/,  ISD::FP_TO_SINT,// ->67545
/*67337*/   OPC_Scope, 113, /*->67452*/ // 2 children in Scope
/*67339*/     OPC_MoveChild, 0,
/*67341*/     OPC_CheckOpcode, ISD::LOAD,
/*67343*/     OPC_RecordMemRef,
/*67344*/     OPC_RecordNode, // #0 = 'ld' chained node
/*67345*/     OPC_RecordChild1, // #1 = $src
/*67346*/     OPC_CheckPredicate, 2, // Predicate_unindexedload
/*67348*/     OPC_CheckPredicate, 8, // Predicate_load
/*67350*/     OPC_CheckPredicate, 9, // Predicate_dsload
/*67352*/     OPC_SwitchType /*2 cases */, 47,  MVT::f64,// ->67402
/*67355*/       OPC_MoveParent,
/*67356*/       OPC_SwitchType /*2 cases */, 20,  MVT::i64,// ->67379
/*67359*/         OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*67361*/         OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*67364*/         OPC_EmitMergeInputChains, 1, 0, 
/*67367*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::CVTTSD2SI64rm), 0|OPFL_Chain|OPFL_MemRefs,
                      1/*#VTs*/, MVT::i64, 5/*#Ops*/, 2, 3, 4, 5, 6, 
                  // Src: (fp_to_sint:i64 (ld:f64 addr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>)
                  // Dst: (CVTTSD2SI64rm:i64 addr:iPTR:$src)
                /*SwitchType*/ 20,  MVT::i32,// ->67401
/*67381*/         OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*67383*/         OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*67386*/         OPC_EmitMergeInputChains, 1, 0, 
/*67389*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::CVTTSD2SIrm), 0|OPFL_Chain|OPFL_MemRefs,
                      1/*#VTs*/, MVT::i32, 5/*#Ops*/, 2, 3, 4, 5, 6, 
                  // Src: (fp_to_sint:i32 (ld:f64 addr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>)
                  // Dst: (CVTTSD2SIrm:i32 addr:iPTR:$src)
                0, // EndSwitchType
              /*SwitchType*/ 47,  MVT::f32,// ->67451
/*67404*/       OPC_MoveParent,
/*67405*/       OPC_SwitchType /*2 cases */, 20,  MVT::i64,// ->67428
/*67408*/         OPC_CheckPatternPredicate, 0, // (Subtarget->hasSSE1())
/*67410*/         OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*67413*/         OPC_EmitMergeInputChains, 1, 0, 
/*67416*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::CVTTSS2SI64rm), 0|OPFL_Chain|OPFL_MemRefs,
                      1/*#VTs*/, MVT::i64, 5/*#Ops*/, 2, 3, 4, 5, 6, 
                  // Src: (fp_to_sint:i64 (ld:f32 addr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>)
                  // Dst: (CVTTSS2SI64rm:i64 addr:iPTR:$src)
                /*SwitchType*/ 20,  MVT::i32,// ->67450
/*67430*/         OPC_CheckPatternPredicate, 0, // (Subtarget->hasSSE1())
/*67432*/         OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*67435*/         OPC_EmitMergeInputChains, 1, 0, 
/*67438*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::CVTTSS2SIrm), 0|OPFL_Chain|OPFL_MemRefs,
                      1/*#VTs*/, MVT::i32, 5/*#Ops*/, 2, 3, 4, 5, 6, 
                  // Src: (fp_to_sint:i32 (ld:f32 addr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>)
                  // Dst: (CVTTSS2SIrm:i32 addr:iPTR:$src)
                0, // EndSwitchType
              0, // EndSwitchType
/*67452*/   /*Scope*/ 91, /*->67544*/
/*67453*/     OPC_RecordChild0, // #0 = $src
/*67454*/     OPC_Scope, 28, /*->67484*/ // 4 children in Scope
/*67456*/       OPC_CheckChild0Type, MVT::f64,
/*67458*/       OPC_SwitchType /*2 cases */, 10,  MVT::i64,// ->67471
/*67461*/         OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*67463*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::CVTTSD2SI64rr), 0,
                      1/*#VTs*/, MVT::i64, 1/*#Ops*/, 0, 
                  // Src: (fp_to_sint:i64 FR64:f64:$src)
                  // Dst: (CVTTSD2SI64rr:i64 FR64:f64:$src)
                /*SwitchType*/ 10,  MVT::i32,// ->67483
/*67473*/         OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*67475*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::CVTTSD2SIrr), 0,
                      1/*#VTs*/, MVT::i32, 1/*#Ops*/, 0, 
                  // Src: (fp_to_sint:i32 FR64:f64:$src)
                  // Dst: (CVTTSD2SIrr:i32 FR64:f64:$src)
                0, // EndSwitchType
/*67484*/     /*Scope*/ 28, /*->67513*/
/*67485*/       OPC_CheckChild0Type, MVT::f32,
/*67487*/       OPC_SwitchType /*2 cases */, 10,  MVT::i64,// ->67500
/*67490*/         OPC_CheckPatternPredicate, 0, // (Subtarget->hasSSE1())
/*67492*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::CVTTSS2SI64rr), 0,
                      1/*#VTs*/, MVT::i64, 1/*#Ops*/, 0, 
                  // Src: (fp_to_sint:i64 FR32:f32:$src)
                  // Dst: (CVTTSS2SI64rr:i64 FR32:f32:$src)
                /*SwitchType*/ 10,  MVT::i32,// ->67512
/*67502*/         OPC_CheckPatternPredicate, 0, // (Subtarget->hasSSE1())
/*67504*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::CVTTSS2SIrr), 0,
                      1/*#VTs*/, MVT::i32, 1/*#Ops*/, 0, 
                  // Src: (fp_to_sint:i32 FR32:f32:$src)
                  // Dst: (CVTTSS2SIrr:i32 FR32:f32:$src)
                0, // EndSwitchType
/*67513*/     /*Scope*/ 14, /*->67528*/
/*67514*/       OPC_CheckChild0Type, MVT::v4f32,
/*67516*/       OPC_CheckType, MVT::v4i32,
/*67518*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*67520*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::Int_CVTTPS2DQrr), 0,
                    1/*#VTs*/, MVT::v4i32, 1/*#Ops*/, 0, 
                // Src: (fp_to_sint:v4i32 VR128:v4f32:$src)
                // Dst: (Int_CVTTPS2DQrr:v4i32 VR128:v16i8:$src)
/*67528*/     /*Scope*/ 14, /*->67543*/
/*67529*/       OPC_CheckChild0Type, MVT::v2f64,
/*67531*/       OPC_CheckType, MVT::v2i32,
/*67533*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*67535*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::Int_CVTTPD2PIrr), 0,
                    1/*#VTs*/, MVT::v2i32, 1/*#Ops*/, 0, 
                // Src: (fp_to_sint:v2i32 VR128:v2f64:$src)
                // Dst: (Int_CVTTPD2PIrr:v2i32 VR128:v16i8:$src)
/*67543*/     0, /*End of Scope*/
/*67544*/   0, /*End of Scope*/
          /*SwitchOpcode*/ 82|128,1/*210*/,  ISD::SINT_TO_FP,// ->67758
/*67548*/   OPC_Scope, 115, /*->67665*/ // 2 children in Scope
/*67550*/     OPC_MoveChild, 0,
/*67552*/     OPC_CheckOpcode, ISD::LOAD,
/*67554*/     OPC_RecordMemRef,
/*67555*/     OPC_RecordNode, // #0 = 'ld' chained node
/*67556*/     OPC_RecordChild1, // #1 = $src
/*67557*/     OPC_CheckPredicate, 2, // Predicate_unindexedload
/*67559*/     OPC_SwitchType /*2 cases */, 51,  MVT::i64,// ->67613
/*67562*/       OPC_CheckPredicate, 8, // Predicate_load
/*67564*/       OPC_CheckPredicate, 9, // Predicate_dsload
/*67566*/       OPC_MoveParent,
/*67567*/       OPC_SwitchType /*2 cases */, 20,  MVT::f64,// ->67590
/*67570*/         OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*67572*/         OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*67575*/         OPC_EmitMergeInputChains, 1, 0, 
/*67578*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::CVTSI2SD64rm), 0|OPFL_Chain|OPFL_MemRefs,
                      1/*#VTs*/, MVT::f64, 5/*#Ops*/, 2, 3, 4, 5, 6, 
                  // Src: (sint_to_fp:f64 (ld:i64 addr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>)
                  // Dst: (CVTSI2SD64rm:f64 addr:iPTR:$src)
                /*SwitchType*/ 20,  MVT::f32,// ->67612
/*67592*/         OPC_CheckPatternPredicate, 0, // (Subtarget->hasSSE1())
/*67594*/         OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*67597*/         OPC_EmitMergeInputChains, 1, 0, 
/*67600*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::CVTSI2SS64rm), 0|OPFL_Chain|OPFL_MemRefs,
                      1/*#VTs*/, MVT::f32, 5/*#Ops*/, 2, 3, 4, 5, 6, 
                  // Src: (sint_to_fp:f32 (ld:i64 addr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>)
                  // Dst: (CVTSI2SS64rm:f32 addr:iPTR:$src)
                0, // EndSwitchType
              /*SwitchType*/ 49,  MVT::i32,// ->67664
/*67615*/       OPC_CheckPredicate, 3, // Predicate_loadi32
/*67617*/       OPC_MoveParent,
/*67618*/       OPC_SwitchType /*2 cases */, 20,  MVT::f32,// ->67641
/*67621*/         OPC_CheckPatternPredicate, 0, // (Subtarget->hasSSE1())
/*67623*/         OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*67626*/         OPC_EmitMergeInputChains, 1, 0, 
/*67629*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::CVTSI2SSrm), 0|OPFL_Chain|OPFL_MemRefs,
                      1/*#VTs*/, MVT::f32, 5/*#Ops*/, 2, 3, 4, 5, 6, 
                  // Src: (sint_to_fp:f32 (ld:i32 addr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)
                  // Dst: (CVTSI2SSrm:f32 addr:iPTR:$src)
                /*SwitchType*/ 20,  MVT::f64,// ->67663
/*67643*/         OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*67645*/         OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*67648*/         OPC_EmitMergeInputChains, 1, 0, 
/*67651*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::CVTSI2SDrm), 0|OPFL_Chain|OPFL_MemRefs,
                      1/*#VTs*/, MVT::f64, 5/*#Ops*/, 2, 3, 4, 5, 6, 
                  // Src: (sint_to_fp:f64 (ld:i32 addr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)
                  // Dst: (CVTSI2SDrm:f64 addr:iPTR:$src)
                0, // EndSwitchType
              0, // EndSwitchType
/*67665*/   /*Scope*/ 91, /*->67757*/
/*67666*/     OPC_RecordChild0, // #0 = $src
/*67667*/     OPC_Scope, 28, /*->67697*/ // 4 children in Scope
/*67669*/       OPC_CheckChild0Type, MVT::i64,
/*67671*/       OPC_SwitchType /*2 cases */, 10,  MVT::f64,// ->67684
/*67674*/         OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*67676*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::CVTSI2SD64rr), 0,
                      1/*#VTs*/, MVT::f64, 1/*#Ops*/, 0, 
                  // Src: (sint_to_fp:f64 GR64:i64:$src)
                  // Dst: (CVTSI2SD64rr:f64 GR64:i64:$src)
                /*SwitchType*/ 10,  MVT::f32,// ->67696
/*67686*/         OPC_CheckPatternPredicate, 0, // (Subtarget->hasSSE1())
/*67688*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::CVTSI2SS64rr), 0,
                      1/*#VTs*/, MVT::f32, 1/*#Ops*/, 0, 
                  // Src: (sint_to_fp:f32 GR64:i64:$src)
                  // Dst: (CVTSI2SS64rr:f32 GR64:i64:$src)
                0, // EndSwitchType
/*67697*/     /*Scope*/ 28, /*->67726*/
/*67698*/       OPC_CheckChild0Type, MVT::i32,
/*67700*/       OPC_SwitchType /*2 cases */, 10,  MVT::f32,// ->67713
/*67703*/         OPC_CheckPatternPredicate, 0, // (Subtarget->hasSSE1())
/*67705*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::CVTSI2SSrr), 0,
                      1/*#VTs*/, MVT::f32, 1/*#Ops*/, 0, 
                  // Src: (sint_to_fp:f32 GR32:i32:$src)
                  // Dst: (CVTSI2SSrr:f32 GR32:i32:$src)
                /*SwitchType*/ 10,  MVT::f64,// ->67725
/*67715*/         OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*67717*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::CVTSI2SDrr), 0,
                      1/*#VTs*/, MVT::f64, 1/*#Ops*/, 0, 
                  // Src: (sint_to_fp:f64 GR32:i32:$src)
                  // Dst: (CVTSI2SDrr:f64 GR32:i32:$src)
                0, // EndSwitchType
/*67726*/     /*Scope*/ 14, /*->67741*/
/*67727*/       OPC_CheckChild0Type, MVT::v4i32,
/*67729*/       OPC_CheckType, MVT::v4f32,
/*67731*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*67733*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::Int_CVTDQ2PSrr), 0,
                    1/*#VTs*/, MVT::v4f32, 1/*#Ops*/, 0, 
                // Src: (sint_to_fp:v4f32 VR128:v4i32:$src)
                // Dst: (Int_CVTDQ2PSrr:v4f32 VR128:v16i8:$src)
/*67741*/     /*Scope*/ 14, /*->67756*/
/*67742*/       OPC_CheckChild0Type, MVT::v2i32,
/*67744*/       OPC_CheckType, MVT::v2f64,
/*67746*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*67748*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::Int_CVTPI2PDrr), 0,
                    1/*#VTs*/, MVT::v2f64, 1/*#Ops*/, 0, 
                // Src: (sint_to_fp:v2f64 VR64:v2i32:$src)
                // Dst: (Int_CVTPI2PDrr:v2f64 VR64:v8i8:$src)
/*67756*/     0, /*End of Scope*/
/*67757*/   0, /*End of Scope*/
          /*SwitchOpcode*/ 61|128,5/*701*/,  ISD::BIT_CONVERT,// ->68462
/*67761*/   OPC_Scope, 126, /*->67889*/ // 2 children in Scope
/*67763*/     OPC_MoveChild, 0,
/*67765*/     OPC_SwitchOpcode /*2 cases */, 63,  ISD::LOAD,// ->67831
/*67768*/       OPC_RecordMemRef,
/*67769*/       OPC_RecordNode, // #0 = 'ld' chained node
/*67770*/       OPC_RecordChild1, // #1 = $src
/*67771*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*67773*/       OPC_SwitchType /*2 cases */, 27,  MVT::i64,// ->67803
/*67776*/         OPC_CheckPredicate, 8, // Predicate_load
/*67778*/         OPC_CheckPredicate, 9, // Predicate_dsload
/*67780*/         OPC_MoveParent,
/*67781*/         OPC_CheckType, MVT::f64,
/*67783*/         OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*67785*/         OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*67788*/         OPC_EmitMergeInputChains, 1, 0, 
/*67791*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::MOV64toSDrm), 0|OPFL_Chain|OPFL_MemRefs,
                      1/*#VTs*/, MVT::f64, 5/*#Ops*/, 2, 3, 4, 5, 6, 
                  // Src: (bitconvert:f64 (ld:i64 addr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>)
                  // Dst: (MOV64toSDrm:f64 addr:iPTR:$src)
                /*SwitchType*/ 25,  MVT::i32,// ->67830
/*67805*/         OPC_CheckPredicate, 3, // Predicate_loadi32
/*67807*/         OPC_MoveParent,
/*67808*/         OPC_CheckType, MVT::f32,
/*67810*/         OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*67812*/         OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*67815*/         OPC_EmitMergeInputChains, 1, 0, 
/*67818*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVDI2SSrm), 0|OPFL_Chain|OPFL_MemRefs,
                      1/*#VTs*/, MVT::f32, 5/*#Ops*/, 2, 3, 4, 5, 6, 
                  // Src: (bitconvert:f32 (ld:i32 addr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)
                  // Dst: (MOVDI2SSrm:f32 addr:iPTR:$src)
                0, // EndSwitchType
              /*SwitchOpcode*/ 55,  ISD::EXTRACT_VECTOR_ELT,// ->67888
/*67833*/       OPC_RecordChild0, // #0 = $src
/*67834*/       OPC_CheckChild0Type, MVT::v2i64,
/*67836*/       OPC_MoveChild, 1,
/*67838*/       OPC_CheckInteger, 0, 
/*67840*/       OPC_MoveParent,
/*67841*/       OPC_CheckType, MVT::i64,
/*67843*/       OPC_MoveParent,
/*67844*/       OPC_SwitchType /*4 cases */, 10,  MVT::v1i64,// ->67857
/*67847*/         OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*67849*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_MOVDQ2Qrr), 0,
                      1/*#VTs*/, MVT::v1i64, 1/*#Ops*/, 0, 
                  // Src: (bitconvert:v1i64 (vector_extract:i64 VR128:v2i64:$src, 0:iPTR))
                  // Dst: (MMX_MOVDQ2Qrr:v1i64 VR128:v2i64:$src)
                /*SwitchType*/ 8,  MVT::v2i32,// ->67867
/*67859*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_MOVDQ2Qrr), 0,
                      1/*#VTs*/, MVT::v2i32, 1/*#Ops*/, 0, 
                  // Src: (bitconvert:v2i32 (vector_extract:i64 VR128:v2i64:$src, 0:iPTR))
                  // Dst: (MMX_MOVDQ2Qrr:v2i32 VR128:v16i8:$src)
                /*SwitchType*/ 8,  MVT::v4i16,// ->67877
/*67869*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_MOVDQ2Qrr), 0,
                      1/*#VTs*/, MVT::v4i16, 1/*#Ops*/, 0, 
                  // Src: (bitconvert:v4i16 (vector_extract:i64 VR128:v2i64:$src, 0:iPTR))
                  // Dst: (MMX_MOVDQ2Qrr:v4i16 VR128:v16i8:$src)
                /*SwitchType*/ 8,  MVT::v8i8,// ->67887
/*67879*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_MOVDQ2Qrr), 0,
                      1/*#VTs*/, MVT::v8i8, 1/*#Ops*/, 0, 
                  // Src: (bitconvert:v8i8 (vector_extract:i64 VR128:v2i64:$src, 0:iPTR))
                  // Dst: (MMX_MOVDQ2Qrr:v8i8 VR128:v16i8:$src)
                0, // EndSwitchType
              0, // EndSwitchOpcode
/*67889*/   /*Scope*/ 58|128,4/*570*/, /*->68461*/
/*67891*/     OPC_RecordChild0, // #0 = $src
/*67892*/     OPC_Scope, 39, /*->67933*/ // 15 children in Scope
/*67894*/       OPC_CheckChild0Type, MVT::v4i32,
/*67896*/       OPC_SwitchType /*5 cases */, 5,  MVT::v2i64,// ->67904
/*67899*/         OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*67901*/         OPC_CompleteMatch, 1, 0, 
                  // Src: (bitconvert:v2i64 VR128:v4i32:$src)
                  // Dst: VR128:v2i64:$src
                /*SwitchType*/ 5,  MVT::v8i16,// ->67911
/*67906*/         OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*67908*/         OPC_CompleteMatch, 1, 0, 
                  // Src: (bitconvert:v8i16 VR128:v4i32:$src)
                  // Dst: VR128:v8i16:$src
                /*SwitchType*/ 5,  MVT::v16i8,// ->67918
/*67913*/         OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*67915*/         OPC_CompleteMatch, 1, 0, 
                  // Src: (bitconvert:v16i8 VR128:v4i32:$src)
                  // Dst: VR128:v16i8:$src
                /*SwitchType*/ 5,  MVT::v4f32,// ->67925
/*67920*/         OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*67922*/         OPC_CompleteMatch, 1, 0, 
                  // Src: (bitconvert:v4f32 VR128:v4i32:$src)
                  // Dst: VR128:v4f32:$src
                /*SwitchType*/ 5,  MVT::v2f64,// ->67932
/*67927*/         OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*67929*/         OPC_CompleteMatch, 1, 0, 
                  // Src: (bitconvert:v2f64 VR128:v4i32:$src)
                  // Dst: VR128:v2f64:$src
                0, // EndSwitchType
/*67933*/     /*Scope*/ 39, /*->67973*/
/*67934*/       OPC_CheckChild0Type, MVT::v8i16,
/*67936*/       OPC_SwitchType /*5 cases */, 5,  MVT::v2i64,// ->67944
/*67939*/         OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*67941*/         OPC_CompleteMatch, 1, 0, 
                  // Src: (bitconvert:v2i64 VR128:v8i16:$src)
                  // Dst: VR128:v2i64:$src
                /*SwitchType*/ 5,  MVT::v4i32,// ->67951
/*67946*/         OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*67948*/         OPC_CompleteMatch, 1, 0, 
                  // Src: (bitconvert:v4i32 VR128:v8i16:$src)
                  // Dst: VR128:v4i32:$src
                /*SwitchType*/ 5,  MVT::v16i8,// ->67958
/*67953*/         OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*67955*/         OPC_CompleteMatch, 1, 0, 
                  // Src: (bitconvert:v16i8 VR128:v8i16:$src)
                  // Dst: VR128:v16i8:$src
                /*SwitchType*/ 5,  MVT::v4f32,// ->67965
/*67960*/         OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*67962*/         OPC_CompleteMatch, 1, 0, 
                  // Src: (bitconvert:v4f32 VR128:v8i16:$src)
                  // Dst: VR128:v4f32:$src
                /*SwitchType*/ 5,  MVT::v2f64,// ->67972
/*67967*/         OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*67969*/         OPC_CompleteMatch, 1, 0, 
                  // Src: (bitconvert:v2f64 VR128:v8i16:$src)
                  // Dst: VR128:v2f64:$src
                0, // EndSwitchType
/*67973*/     /*Scope*/ 39, /*->68013*/
/*67974*/       OPC_CheckChild0Type, MVT::v16i8,
/*67976*/       OPC_SwitchType /*5 cases */, 5,  MVT::v2i64,// ->67984
/*67979*/         OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*67981*/         OPC_CompleteMatch, 1, 0, 
                  // Src: (bitconvert:v2i64 VR128:v16i8:$src)
                  // Dst: VR128:v2i64:$src
                /*SwitchType*/ 5,  MVT::v4i32,// ->67991
/*67986*/         OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*67988*/         OPC_CompleteMatch, 1, 0, 
                  // Src: (bitconvert:v4i32 VR128:v16i8:$src)
                  // Dst: VR128:v4i32:$src
                /*SwitchType*/ 5,  MVT::v8i16,// ->67998
/*67993*/         OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*67995*/         OPC_CompleteMatch, 1, 0, 
                  // Src: (bitconvert:v8i16 VR128:v16i8:$src)
                  // Dst: VR128:v8i16:$src
                /*SwitchType*/ 5,  MVT::v4f32,// ->68005
/*68000*/         OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*68002*/         OPC_CompleteMatch, 1, 0, 
                  // Src: (bitconvert:v4f32 VR128:v16i8:$src)
                  // Dst: VR128:v4f32:$src
                /*SwitchType*/ 5,  MVT::v2f64,// ->68012
/*68007*/         OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*68009*/         OPC_CompleteMatch, 1, 0, 
                  // Src: (bitconvert:v2f64 VR128:v16i8:$src)
                  // Dst: VR128:v2f64:$src
                0, // EndSwitchType
/*68013*/     /*Scope*/ 39, /*->68053*/
/*68014*/       OPC_CheckChild0Type, MVT::v2f64,
/*68016*/       OPC_SwitchType /*5 cases */, 5,  MVT::v2i64,// ->68024
/*68019*/         OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*68021*/         OPC_CompleteMatch, 1, 0, 
                  // Src: (bitconvert:v2i64 VR128:v2f64:$src)
                  // Dst: VR128:v2i64:$src
                /*SwitchType*/ 5,  MVT::v4i32,// ->68031
/*68026*/         OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*68028*/         OPC_CompleteMatch, 1, 0, 
                  // Src: (bitconvert:v4i32 VR128:v2f64:$src)
                  // Dst: VR128:v4i32:$src
                /*SwitchType*/ 5,  MVT::v8i16,// ->68038
/*68033*/         OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*68035*/         OPC_CompleteMatch, 1, 0, 
                  // Src: (bitconvert:v8i16 VR128:v2f64:$src)
                  // Dst: VR128:v8i16:$src
                /*SwitchType*/ 5,  MVT::v16i8,// ->68045
/*68040*/         OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*68042*/         OPC_CompleteMatch, 1, 0, 
                  // Src: (bitconvert:v16i8 VR128:v2f64:$src)
                  // Dst: VR128:v16i8:$src
                /*SwitchType*/ 5,  MVT::v4f32,// ->68052
/*68047*/         OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*68049*/         OPC_CompleteMatch, 1, 0, 
                  // Src: (bitconvert:v4f32 VR128:v2f64:$src)
                  // Dst: VR128:v4f32:$src
                0, // EndSwitchType
/*68053*/     /*Scope*/ 39, /*->68093*/
/*68054*/       OPC_CheckChild0Type, MVT::v4f32,
/*68056*/       OPC_SwitchType /*5 cases */, 5,  MVT::v2i64,// ->68064
/*68059*/         OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*68061*/         OPC_CompleteMatch, 1, 0, 
                  // Src: (bitconvert:v2i64 VR128:v4f32:$src)
                  // Dst: VR128:v2i64:$src
                /*SwitchType*/ 5,  MVT::v4i32,// ->68071
/*68066*/         OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*68068*/         OPC_CompleteMatch, 1, 0, 
                  // Src: (bitconvert:v4i32 VR128:v4f32:$src)
                  // Dst: VR128:v4i32:$src
                /*SwitchType*/ 5,  MVT::v8i16,// ->68078
/*68073*/         OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*68075*/         OPC_CompleteMatch, 1, 0, 
                  // Src: (bitconvert:v8i16 VR128:v4f32:$src)
                  // Dst: VR128:v8i16:$src
                /*SwitchType*/ 5,  MVT::v16i8,// ->68085
/*68080*/         OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*68082*/         OPC_CompleteMatch, 1, 0, 
                  // Src: (bitconvert:v16i8 VR128:v4f32:$src)
                  // Dst: VR128:v16i8:$src
                /*SwitchType*/ 5,  MVT::v2f64,// ->68092
/*68087*/         OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*68089*/         OPC_CompleteMatch, 1, 0, 
                  // Src: (bitconvert:v2f64 VR128:v4f32:$src)
                  // Dst: VR128:v2f64:$src
                0, // EndSwitchType
/*68093*/     /*Scope*/ 39, /*->68133*/
/*68094*/       OPC_CheckChild0Type, MVT::v2i64,
/*68096*/       OPC_SwitchType /*5 cases */, 5,  MVT::v4i32,// ->68104
/*68099*/         OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*68101*/         OPC_CompleteMatch, 1, 0, 
                  // Src: (bitconvert:v4i32 VR128:v2i64:$src)
                  // Dst: VR128:v4i32:$src
                /*SwitchType*/ 5,  MVT::v8i16,// ->68111
/*68106*/         OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*68108*/         OPC_CompleteMatch, 1, 0, 
                  // Src: (bitconvert:v8i16 VR128:v2i64:$src)
                  // Dst: VR128:v8i16:$src
                /*SwitchType*/ 5,  MVT::v16i8,// ->68118
/*68113*/         OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*68115*/         OPC_CompleteMatch, 1, 0, 
                  // Src: (bitconvert:v16i8 VR128:v2i64:$src)
                  // Dst: VR128:v16i8:$src
                /*SwitchType*/ 5,  MVT::v4f32,// ->68125
/*68120*/         OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*68122*/         OPC_CompleteMatch, 1, 0, 
                  // Src: (bitconvert:v4f32 VR128:v2i64:$src)
                  // Dst: VR128:v4f32:$src
                /*SwitchType*/ 5,  MVT::v2f64,// ->68132
/*68127*/         OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*68129*/         OPC_CompleteMatch, 1, 0, 
                  // Src: (bitconvert:v2f64 VR128:v2i64:$src)
                  // Dst: VR128:v2f64:$src
                0, // EndSwitchType
/*68133*/     /*Scope*/ 44, /*->68178*/
/*68134*/       OPC_CheckChild0Type, MVT::v1i64,
/*68136*/       OPC_SwitchType /*6 cases */, 3,  MVT::v8i8,// ->68142
/*68139*/         OPC_CompleteMatch, 1, 0, 
                  // Src: (bitconvert:v8i8 VR64:v1i64:$src)
                  // Dst: VR64:v8i8:$src
                /*SwitchType*/ 3,  MVT::v4i16,// ->68147
/*68144*/         OPC_CompleteMatch, 1, 0, 
                  // Src: (bitconvert:v4i16 VR64:v1i64:$src)
                  // Dst: VR64:v4i16:$src
                /*SwitchType*/ 3,  MVT::v2i32,// ->68152
/*68149*/         OPC_CompleteMatch, 1, 0, 
                  // Src: (bitconvert:v2i32 VR64:v1i64:$src)
                  // Dst: VR64:v2i32:$src
                /*SwitchType*/ 3,  MVT::v2f32,// ->68157
/*68154*/         OPC_CompleteMatch, 1, 0, 
                  // Src: (bitconvert:v2f32 VR64:v1i64:$src)
                  // Dst: VR64:v2f32:$src
                /*SwitchType*/ 8,  MVT::i64,// ->68167
/*68159*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_MOVD64from64rr), 0,
                      1/*#VTs*/, MVT::i64, 1/*#Ops*/, 0, 
                  // Src: (bitconvert:i64 VR64:v1i64:$src)
                  // Dst: (MMX_MOVD64from64rr:i64 VR64:v8i8:$src)
                /*SwitchType*/ 8,  MVT::f64,// ->68177
/*68169*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_MOVQ2FR64rr), 0,
                      1/*#VTs*/, MVT::f64, 1/*#Ops*/, 0, 
                  // Src: (bitconvert:f64 VR64:v1i64:$src)
                  // Dst: (MMX_MOVQ2FR64rr:f64 VR64:v8i8:$src)
                0, // EndSwitchType
/*68178*/     /*Scope*/ 44, /*->68223*/
/*68179*/       OPC_CheckChild0Type, MVT::v2i32,
/*68181*/       OPC_SwitchType /*6 cases */, 3,  MVT::v8i8,// ->68187
/*68184*/         OPC_CompleteMatch, 1, 0, 
                  // Src: (bitconvert:v8i8 VR64:v2i32:$src)
                  // Dst: VR64:v8i8:$src
                /*SwitchType*/ 3,  MVT::v4i16,// ->68192
/*68189*/         OPC_CompleteMatch, 1, 0, 
                  // Src: (bitconvert:v4i16 VR64:v2i32:$src)
                  // Dst: VR64:v4i16:$src
                /*SwitchType*/ 3,  MVT::v2f32,// ->68197
/*68194*/         OPC_CompleteMatch, 1, 0, 
                  // Src: (bitconvert:v2f32 VR64:v2i32:$src)
                  // Dst: VR64:v2f32:$src
                /*SwitchType*/ 3,  MVT::v1i64,// ->68202
/*68199*/         OPC_CompleteMatch, 1, 0, 
                  // Src: (bitconvert:v1i64 VR64:v2i32:$src)
                  // Dst: VR64:v1i64:$src
                /*SwitchType*/ 8,  MVT::i64,// ->68212
/*68204*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_MOVD64from64rr), 0,
                      1/*#VTs*/, MVT::i64, 1/*#Ops*/, 0, 
                  // Src: (bitconvert:i64 VR64:v2i32:$src)
                  // Dst: (MMX_MOVD64from64rr:i64 VR64:v8i8:$src)
                /*SwitchType*/ 8,  MVT::f64,// ->68222
/*68214*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_MOVQ2FR64rr), 0,
                      1/*#VTs*/, MVT::f64, 1/*#Ops*/, 0, 
                  // Src: (bitconvert:f64 VR64:v2i32:$src)
                  // Dst: (MMX_MOVQ2FR64rr:f64 VR64:v8i8:$src)
                0, // EndSwitchType
/*68223*/     /*Scope*/ 34, /*->68258*/
/*68224*/       OPC_CheckChild0Type, MVT::v2f32,
/*68226*/       OPC_SwitchType /*5 cases */, 3,  MVT::v8i8,// ->68232
/*68229*/         OPC_CompleteMatch, 1, 0, 
                  // Src: (bitconvert:v8i8 VR64:v2f32:$src)
                  // Dst: VR64:v8i8:$src
                /*SwitchType*/ 3,  MVT::v4i16,// ->68237
/*68234*/         OPC_CompleteMatch, 1, 0, 
                  // Src: (bitconvert:v4i16 VR64:v2f32:$src)
                  // Dst: VR64:v4i16:$src
                /*SwitchType*/ 3,  MVT::v2i32,// ->68242
/*68239*/         OPC_CompleteMatch, 1, 0, 
                  // Src: (bitconvert:v2i32 VR64:v2f32:$src)
                  // Dst: VR64:v2i32:$src
                /*SwitchType*/ 3,  MVT::v1i64,// ->68247
/*68244*/         OPC_CompleteMatch, 1, 0, 
                  // Src: (bitconvert:v1i64 VR64:v2f32:$src)
                  // Dst: VR64:v1i64:$src
                /*SwitchType*/ 8,  MVT::i64,// ->68257
/*68249*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_MOVD64from64rr), 0,
                      1/*#VTs*/, MVT::i64, 1/*#Ops*/, 0, 
                  // Src: (bitconvert:i64 VR64:v2f32:$src)
                  // Dst: (MMX_MOVD64from64rr:i64 VR64:v8i8:$src)
                0, // EndSwitchType
/*68258*/     /*Scope*/ 44, /*->68303*/
/*68259*/       OPC_CheckChild0Type, MVT::v4i16,
/*68261*/       OPC_SwitchType /*6 cases */, 3,  MVT::v8i8,// ->68267
/*68264*/         OPC_CompleteMatch, 1, 0, 
                  // Src: (bitconvert:v8i8 VR64:v4i16:$src)
                  // Dst: VR64:v8i8:$src
                /*SwitchType*/ 3,  MVT::v2i32,// ->68272
/*68269*/         OPC_CompleteMatch, 1, 0, 
                  // Src: (bitconvert:v2i32 VR64:v4i16:$src)
                  // Dst: VR64:v2i32:$src
                /*SwitchType*/ 3,  MVT::v2f32,// ->68277
/*68274*/         OPC_CompleteMatch, 1, 0, 
                  // Src: (bitconvert:v2f32 VR64:v4i16:$src)
                  // Dst: VR64:v2f32:$src
                /*SwitchType*/ 3,  MVT::v1i64,// ->68282
/*68279*/         OPC_CompleteMatch, 1, 0, 
                  // Src: (bitconvert:v1i64 VR64:v4i16:$src)
                  // Dst: VR64:v1i64:$src
                /*SwitchType*/ 8,  MVT::i64,// ->68292
/*68284*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_MOVD64from64rr), 0,
                      1/*#VTs*/, MVT::i64, 1/*#Ops*/, 0, 
                  // Src: (bitconvert:i64 VR64:v4i16:$src)
                  // Dst: (MMX_MOVD64from64rr:i64 VR64:v8i8:$src)
                /*SwitchType*/ 8,  MVT::f64,// ->68302
/*68294*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_MOVQ2FR64rr), 0,
                      1/*#VTs*/, MVT::f64, 1/*#Ops*/, 0, 
                  // Src: (bitconvert:f64 VR64:v4i16:$src)
                  // Dst: (MMX_MOVQ2FR64rr:f64 VR64:v8i8:$src)
                0, // EndSwitchType
/*68303*/     /*Scope*/ 44, /*->68348*/
/*68304*/       OPC_CheckChild0Type, MVT::v8i8,
/*68306*/       OPC_SwitchType /*6 cases */, 3,  MVT::v4i16,// ->68312
/*68309*/         OPC_CompleteMatch, 1, 0, 
                  // Src: (bitconvert:v4i16 VR64:v8i8:$src)
                  // Dst: VR64:v4i16:$src
                /*SwitchType*/ 3,  MVT::v2i32,// ->68317
/*68314*/         OPC_CompleteMatch, 1, 0, 
                  // Src: (bitconvert:v2i32 VR64:v8i8:$src)
                  // Dst: VR64:v2i32:$src
                /*SwitchType*/ 3,  MVT::v2f32,// ->68322
/*68319*/         OPC_CompleteMatch, 1, 0, 
                  // Src: (bitconvert:v2f32 VR64:v8i8:$src)
                  // Dst: VR64:v2f32:$src
                /*SwitchType*/ 3,  MVT::v1i64,// ->68327
/*68324*/         OPC_CompleteMatch, 1, 0, 
                  // Src: (bitconvert:v1i64 VR64:v8i8:$src)
                  // Dst: VR64:v1i64:$src
                /*SwitchType*/ 8,  MVT::i64,// ->68337
/*68329*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_MOVD64from64rr), 0,
                      1/*#VTs*/, MVT::i64, 1/*#Ops*/, 0, 
                  // Src: (bitconvert:i64 VR64:v8i8:$src)
                  // Dst: (MMX_MOVD64from64rr:i64 VR64:v8i8:$src)
                /*SwitchType*/ 8,  MVT::f64,// ->68347
/*68339*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_MOVQ2FR64rr), 0,
                      1/*#VTs*/, MVT::f64, 1/*#Ops*/, 0, 
                  // Src: (bitconvert:f64 VR64:v8i8:$src)
                  // Dst: (MMX_MOVQ2FR64rr:f64 VR64:v8i8:$src)
                0, // EndSwitchType
/*68348*/     /*Scope*/ 66, /*->68415*/
/*68349*/       OPC_CheckChild0Type, MVT::i64,
/*68351*/       OPC_SwitchType /*6 cases */, 10,  MVT::f64,// ->68364
/*68354*/         OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*68356*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::MOV64toSDrr), 0,
                      1/*#VTs*/, MVT::f64, 1/*#Ops*/, 0, 
                  // Src: (bitconvert:f64 GR64:i64:$src)
                  // Dst: (MOV64toSDrr:f64 GR64:i64:$src)
                /*SwitchType*/ 8,  MVT::v1i64,// ->68374
/*68366*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_MOVD64to64rr), 0,
                      1/*#VTs*/, MVT::v1i64, 1/*#Ops*/, 0, 
                  // Src: (bitconvert:v1i64 GR64:i64:$src)
                  // Dst: (MMX_MOVD64to64rr:v1i64 GR64:i64:$src)
                /*SwitchType*/ 8,  MVT::v2i32,// ->68384
/*68376*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_MOVD64to64rr), 0,
                      1/*#VTs*/, MVT::v2i32, 1/*#Ops*/, 0, 
                  // Src: (bitconvert:v2i32 GR64:i64:$src)
                  // Dst: (MMX_MOVD64to64rr:v2i32 GR64:i64:$src)
                /*SwitchType*/ 8,  MVT::v2f32,// ->68394
/*68386*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_MOVD64to64rr), 0,
                      1/*#VTs*/, MVT::v2f32, 1/*#Ops*/, 0, 
                  // Src: (bitconvert:v2f32 GR64:i64:$src)
                  // Dst: (MMX_MOVD64to64rr:v2f32 GR64:i64:$src)
                /*SwitchType*/ 8,  MVT::v4i16,// ->68404
/*68396*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_MOVD64to64rr), 0,
                      1/*#VTs*/, MVT::v4i16, 1/*#Ops*/, 0, 
                  // Src: (bitconvert:v4i16 GR64:i64:$src)
                  // Dst: (MMX_MOVD64to64rr:v4i16 GR64:i64:$src)
                /*SwitchType*/ 8,  MVT::v8i8,// ->68414
/*68406*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_MOVD64to64rr), 0,
                      1/*#VTs*/, MVT::v8i8, 1/*#Ops*/, 0, 
                  // Src: (bitconvert:v8i8 GR64:i64:$src)
                  // Dst: (MMX_MOVD64to64rr:v8i8 GR64:i64:$src)
                0, // EndSwitchType
/*68415*/     /*Scope*/ 14, /*->68430*/
/*68416*/       OPC_CheckChild0Type, MVT::f64,
/*68418*/       OPC_CheckType, MVT::i64,
/*68420*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*68422*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVSDto64rr), 0,
                    1/*#VTs*/, MVT::i64, 1/*#Ops*/, 0, 
                // Src: (bitconvert:i64 FR64:f64:$src)
                // Dst: (MOVSDto64rr:i64 FR64:f64:$src)
/*68430*/     /*Scope*/ 14, /*->68445*/
/*68431*/       OPC_CheckChild0Type, MVT::i32,
/*68433*/       OPC_CheckType, MVT::f32,
/*68435*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*68437*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVDI2SSrr), 0,
                    1/*#VTs*/, MVT::f32, 1/*#Ops*/, 0, 
                // Src: (bitconvert:f32 GR32:i32:$src)
                // Dst: (MOVDI2SSrr:f32 GR32:i32:$src)
/*68445*/     /*Scope*/ 14, /*->68460*/
/*68446*/       OPC_CheckChild0Type, MVT::f32,
/*68448*/       OPC_CheckType, MVT::i32,
/*68450*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*68452*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVSS2DIrr), 0,
                    1/*#VTs*/, MVT::i32, 1/*#Ops*/, 0, 
                // Src: (bitconvert:i32 FR32:f32:$src)
                // Dst: (MOVSS2DIrr:i32 FR32:f32:$src)
/*68460*/     0, /*End of Scope*/
/*68461*/   0, /*End of Scope*/
          /*SwitchOpcode*/ 109,  X86ISD::UCOMI,// ->68573
/*68464*/   OPC_RecordChild0, // #0 = $src1
/*68465*/   OPC_Scope, 52, /*->68519*/ // 2 children in Scope
/*68467*/     OPC_CheckChild0Type, MVT::v4f32,
/*68469*/     OPC_Scope, 34, /*->68505*/ // 2 children in Scope
/*68471*/       OPC_MoveChild, 1,
/*68473*/       OPC_CheckOpcode, ISD::LOAD,
/*68475*/       OPC_RecordMemRef,
/*68476*/       OPC_RecordNode, // #1 = 'ld' chained node
/*68477*/       OPC_CheckFoldableChainNode,
/*68478*/       OPC_RecordChild1, // #2 = $src2
/*68479*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*68481*/       OPC_CheckPredicate, 8, // Predicate_load
/*68483*/       OPC_MoveParent,
/*68484*/       OPC_CheckPatternPredicate, 0, // (Subtarget->hasSSE1())
/*68486*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*68489*/       OPC_EmitMergeInputChains, 1, 1, 
/*68492*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::Int_UCOMISSrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::i32, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (X86ucomi:isVoid VR128:v4f32:$src1, (ld:v4f32 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)
                // Dst: (Int_UCOMISSrm:isVoid VR128:v4f32:$src1, addr:iPTR:$src2)
/*68505*/     /*Scope*/ 12, /*->68518*/
/*68506*/       OPC_RecordChild1, // #1 = $src2
/*68507*/       OPC_CheckPatternPredicate, 0, // (Subtarget->hasSSE1())
/*68509*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::Int_UCOMISSrr), 0,
                    1/*#VTs*/, MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (X86ucomi:isVoid VR128:v4f32:$src1, VR128:v4f32:$src2)
                // Dst: (Int_UCOMISSrr:isVoid VR128:v4f32:$src1, VR128:v4f32:$src2)
/*68518*/     0, /*End of Scope*/
/*68519*/   /*Scope*/ 52, /*->68572*/
/*68520*/     OPC_CheckChild0Type, MVT::v2f64,
/*68522*/     OPC_Scope, 34, /*->68558*/ // 2 children in Scope
/*68524*/       OPC_MoveChild, 1,
/*68526*/       OPC_CheckOpcode, ISD::LOAD,
/*68528*/       OPC_RecordMemRef,
/*68529*/       OPC_RecordNode, // #1 = 'ld' chained node
/*68530*/       OPC_CheckFoldableChainNode,
/*68531*/       OPC_RecordChild1, // #2 = $src2
/*68532*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*68534*/       OPC_CheckPredicate, 8, // Predicate_load
/*68536*/       OPC_MoveParent,
/*68537*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*68539*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*68542*/       OPC_EmitMergeInputChains, 1, 1, 
/*68545*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::Int_UCOMISDrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::i32, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (X86ucomi:isVoid VR128:v2f64:$src1, (ld:v2f64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)
                // Dst: (Int_UCOMISDrm:isVoid VR128:v2f64:$src1, addr:iPTR:$src2)
/*68558*/     /*Scope*/ 12, /*->68571*/
/*68559*/       OPC_RecordChild1, // #1 = $src2
/*68560*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*68562*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::Int_UCOMISDrr), 0,
                    1/*#VTs*/, MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (X86ucomi:isVoid VR128:v2f64:$src1, VR128:v2f64:$src2)
                // Dst: (Int_UCOMISDrr:isVoid VR128:v2f64:$src1, VR128:v2f64:$src2)
/*68571*/     0, /*End of Scope*/
/*68572*/   0, /*End of Scope*/
          /*SwitchOpcode*/ 109,  X86ISD::COMI,// ->68684
/*68575*/   OPC_RecordChild0, // #0 = $src1
/*68576*/   OPC_Scope, 52, /*->68630*/ // 2 children in Scope
/*68578*/     OPC_CheckChild0Type, MVT::v4f32,
/*68580*/     OPC_Scope, 34, /*->68616*/ // 2 children in Scope
/*68582*/       OPC_MoveChild, 1,
/*68584*/       OPC_CheckOpcode, ISD::LOAD,
/*68586*/       OPC_RecordMemRef,
/*68587*/       OPC_RecordNode, // #1 = 'ld' chained node
/*68588*/       OPC_CheckFoldableChainNode,
/*68589*/       OPC_RecordChild1, // #2 = $src2
/*68590*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*68592*/       OPC_CheckPredicate, 8, // Predicate_load
/*68594*/       OPC_MoveParent,
/*68595*/       OPC_CheckPatternPredicate, 0, // (Subtarget->hasSSE1())
/*68597*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*68600*/       OPC_EmitMergeInputChains, 1, 1, 
/*68603*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::Int_COMISSrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::i32, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (X86comi:isVoid VR128:v4f32:$src1, (ld:v4f32 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)
                // Dst: (Int_COMISSrm:isVoid VR128:v4f32:$src1, addr:iPTR:$src2)
/*68616*/     /*Scope*/ 12, /*->68629*/
/*68617*/       OPC_RecordChild1, // #1 = $src2
/*68618*/       OPC_CheckPatternPredicate, 0, // (Subtarget->hasSSE1())
/*68620*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::Int_COMISSrr), 0,
                    1/*#VTs*/, MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (X86comi:isVoid VR128:v4f32:$src1, VR128:v4f32:$src2)
                // Dst: (Int_COMISSrr:isVoid VR128:v4f32:$src1, VR128:v4f32:$src2)
/*68629*/     0, /*End of Scope*/
/*68630*/   /*Scope*/ 52, /*->68683*/
/*68631*/     OPC_CheckChild0Type, MVT::v2f64,
/*68633*/     OPC_Scope, 34, /*->68669*/ // 2 children in Scope
/*68635*/       OPC_MoveChild, 1,
/*68637*/       OPC_CheckOpcode, ISD::LOAD,
/*68639*/       OPC_RecordMemRef,
/*68640*/       OPC_RecordNode, // #1 = 'ld' chained node
/*68641*/       OPC_CheckFoldableChainNode,
/*68642*/       OPC_RecordChild1, // #2 = $src2
/*68643*/       OPC_CheckPredicate, 2, // Predicate_unindexedload
/*68645*/       OPC_CheckPredicate, 8, // Predicate_load
/*68647*/       OPC_MoveParent,
/*68648*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*68650*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*68653*/       OPC_EmitMergeInputChains, 1, 1, 
/*68656*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::Int_COMISDrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::i32, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (X86comi:isVoid VR128:v2f64:$src1, (ld:v2f64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)
                // Dst: (Int_COMISDrm:isVoid VR128:v2f64:$src1, addr:iPTR:$src2)
/*68669*/     /*Scope*/ 12, /*->68682*/
/*68670*/       OPC_RecordChild1, // #1 = $src2
/*68671*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*68673*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::Int_COMISDrr), 0,
                    1/*#VTs*/, MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (X86comi:isVoid VR128:v2f64:$src1, VR128:v2f64:$src2)
                // Dst: (Int_COMISDrr:isVoid VR128:v2f64:$src1, VR128:v2f64:$src2)
/*68682*/     0, /*End of Scope*/
/*68683*/   0, /*End of Scope*/
          /*SwitchOpcode*/ 35|128,1/*163*/,  X86ISD::FAND,// ->68850
/*68687*/   OPC_Scope, 64, /*->68753*/ // 3 children in Scope
/*68689*/     OPC_RecordChild0, // #0 = $src1
/*68690*/     OPC_MoveChild, 1,
/*68692*/     OPC_CheckOpcode, ISD::LOAD,
/*68694*/     OPC_RecordMemRef,
/*68695*/     OPC_RecordNode, // #1 = 'ld' chained node
/*68696*/     OPC_CheckFoldableChainNode,
/*68697*/     OPC_RecordChild1, // #2 = $src2
/*68698*/     OPC_CheckPredicate, 2, // Predicate_unindexedload
/*68700*/     OPC_CheckPredicate, 8, // Predicate_load
/*68702*/     OPC_CheckPredicate, 23, // Predicate_memop
/*68704*/     OPC_MoveParent,
/*68705*/     OPC_SwitchType /*2 cases */, 21,  MVT::f32,// ->68729
/*68708*/       OPC_CheckPatternPredicate, 0, // (Subtarget->hasSSE1())
/*68710*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*68713*/       OPC_EmitMergeInputChains, 1, 1, 
/*68716*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::FsANDPSrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::f32, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (X86fand:f32 FR32:f32:$src1, (ld:f32 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>)
                // Dst: (FsANDPSrm:f32 FR32:f32:$src1, addr:iPTR:$src2)
              /*SwitchType*/ 21,  MVT::f64,// ->68752
/*68731*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*68733*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*68736*/       OPC_EmitMergeInputChains, 1, 1, 
/*68739*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::FsANDPDrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::f64, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (X86fand:f64 FR64:f64:$src1, (ld:f64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>)
                // Dst: (FsANDPDrm:f64 FR64:f64:$src1, addr:iPTR:$src2)
              0, // EndSwitchType
/*68753*/   /*Scope*/ 64, /*->68818*/
/*68754*/     OPC_MoveChild, 0,
/*68756*/     OPC_CheckOpcode, ISD::LOAD,
/*68758*/     OPC_RecordMemRef,
/*68759*/     OPC_RecordNode, // #0 = 'ld' chained node
/*68760*/     OPC_CheckFoldableChainNode,
/*68761*/     OPC_RecordChild1, // #1 = $src2
/*68762*/     OPC_CheckPredicate, 2, // Predicate_unindexedload
/*68764*/     OPC_CheckPredicate, 8, // Predicate_load
/*68766*/     OPC_CheckPredicate, 23, // Predicate_memop
/*68768*/     OPC_MoveParent,
/*68769*/     OPC_RecordChild1, // #2 = $src1
/*68770*/     OPC_SwitchType /*2 cases */, 21,  MVT::f32,// ->68794
/*68773*/       OPC_CheckPatternPredicate, 0, // (Subtarget->hasSSE1())
/*68775*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*68778*/       OPC_EmitMergeInputChains, 1, 0, 
/*68781*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::FsANDPSrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::f32, 6/*#Ops*/, 2, 3, 4, 5, 6, 7, 
                // Src: (X86fand:f32 (ld:f32 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>, FR32:f32:$src1)
                // Dst: (FsANDPSrm:f32 FR32:f32:$src1, addr:iPTR:$src2)
              /*SwitchType*/ 21,  MVT::f64,// ->68817
/*68796*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*68798*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*68801*/       OPC_EmitMergeInputChains, 1, 0, 
/*68804*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::FsANDPDrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::f64, 6/*#Ops*/, 2, 3, 4, 5, 6, 7, 
                // Src: (X86fand:f64 (ld:f64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>, FR64:f64:$src1)
                // Dst: (FsANDPDrm:f64 FR64:f64:$src1, addr:iPTR:$src2)
              0, // EndSwitchType
/*68818*/   /*Scope*/ 30, /*->68849*/
/*68819*/     OPC_RecordChild0, // #0 = $src1
/*68820*/     OPC_RecordChild1, // #1 = $src2
/*68821*/     OPC_SwitchType /*2 cases */, 11,  MVT::f32,// ->68835
/*68824*/       OPC_CheckPatternPredicate, 0, // (Subtarget->hasSSE1())
/*68826*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::FsANDPSrr), 0,
                    1/*#VTs*/, MVT::f32, 2/*#Ops*/, 0, 1, 
                // Src: (X86fand:f32 FR32:f32:$src1, FR32:f32:$src2)
                // Dst: (FsANDPSrr:f32 FR32:f32:$src1, FR32:f32:$src2)
              /*SwitchType*/ 11,  MVT::f64,// ->68848
/*68837*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*68839*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::FsANDPDrr), 0,
                    1/*#VTs*/, MVT::f64, 2/*#Ops*/, 0, 1, 
                // Src: (X86fand:f64 FR64:f64:$src1, FR64:f64:$src2)
                // Dst: (FsANDPDrr:f64 FR64:f64:$src1, FR64:f64:$src2)
              0, // EndSwitchType
/*68849*/   0, /*End of Scope*/
          /*SwitchOpcode*/ 35|128,1/*163*/,  X86ISD::FOR,// ->69016
/*68853*/   OPC_Scope, 64, /*->68919*/ // 3 children in Scope
/*68855*/     OPC_RecordChild0, // #0 = $src1
/*68856*/     OPC_MoveChild, 1,
/*68858*/     OPC_CheckOpcode, ISD::LOAD,
/*68860*/     OPC_RecordMemRef,
/*68861*/     OPC_RecordNode, // #1 = 'ld' chained node
/*68862*/     OPC_CheckFoldableChainNode,
/*68863*/     OPC_RecordChild1, // #2 = $src2
/*68864*/     OPC_CheckPredicate, 2, // Predicate_unindexedload
/*68866*/     OPC_CheckPredicate, 8, // Predicate_load
/*68868*/     OPC_CheckPredicate, 23, // Predicate_memop
/*68870*/     OPC_MoveParent,
/*68871*/     OPC_SwitchType /*2 cases */, 21,  MVT::f32,// ->68895
/*68874*/       OPC_CheckPatternPredicate, 0, // (Subtarget->hasSSE1())
/*68876*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*68879*/       OPC_EmitMergeInputChains, 1, 1, 
/*68882*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::FsORPSrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::f32, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (X86for:f32 FR32:f32:$src1, (ld:f32 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>)
                // Dst: (FsORPSrm:f32 FR32:f32:$src1, addr:iPTR:$src2)
              /*SwitchType*/ 21,  MVT::f64,// ->68918
/*68897*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*68899*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*68902*/       OPC_EmitMergeInputChains, 1, 1, 
/*68905*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::FsORPDrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::f64, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (X86for:f64 FR64:f64:$src1, (ld:f64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>)
                // Dst: (FsORPDrm:f64 FR64:f64:$src1, addr:iPTR:$src2)
              0, // EndSwitchType
/*68919*/   /*Scope*/ 64, /*->68984*/
/*68920*/     OPC_MoveChild, 0,
/*68922*/     OPC_CheckOpcode, ISD::LOAD,
/*68924*/     OPC_RecordMemRef,
/*68925*/     OPC_RecordNode, // #0 = 'ld' chained node
/*68926*/     OPC_CheckFoldableChainNode,
/*68927*/     OPC_RecordChild1, // #1 = $src2
/*68928*/     OPC_CheckPredicate, 2, // Predicate_unindexedload
/*68930*/     OPC_CheckPredicate, 8, // Predicate_load
/*68932*/     OPC_CheckPredicate, 23, // Predicate_memop
/*68934*/     OPC_MoveParent,
/*68935*/     OPC_RecordChild1, // #2 = $src1
/*68936*/     OPC_SwitchType /*2 cases */, 21,  MVT::f32,// ->68960
/*68939*/       OPC_CheckPatternPredicate, 0, // (Subtarget->hasSSE1())
/*68941*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*68944*/       OPC_EmitMergeInputChains, 1, 0, 
/*68947*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::FsORPSrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::f32, 6/*#Ops*/, 2, 3, 4, 5, 6, 7, 
                // Src: (X86for:f32 (ld:f32 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>, FR32:f32:$src1)
                // Dst: (FsORPSrm:f32 FR32:f32:$src1, addr:iPTR:$src2)
              /*SwitchType*/ 21,  MVT::f64,// ->68983
/*68962*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*68964*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*68967*/       OPC_EmitMergeInputChains, 1, 0, 
/*68970*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::FsORPDrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::f64, 6/*#Ops*/, 2, 3, 4, 5, 6, 7, 
                // Src: (X86for:f64 (ld:f64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>, FR64:f64:$src1)
                // Dst: (FsORPDrm:f64 FR64:f64:$src1, addr:iPTR:$src2)
              0, // EndSwitchType
/*68984*/   /*Scope*/ 30, /*->69015*/
/*68985*/     OPC_RecordChild0, // #0 = $src1
/*68986*/     OPC_RecordChild1, // #1 = $src2
/*68987*/     OPC_SwitchType /*2 cases */, 11,  MVT::f32,// ->69001
/*68990*/       OPC_CheckPatternPredicate, 0, // (Subtarget->hasSSE1())
/*68992*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::FsORPSrr), 0,
                    1/*#VTs*/, MVT::f32, 2/*#Ops*/, 0, 1, 
                // Src: (X86for:f32 FR32:f32:$src1, FR32:f32:$src2)
                // Dst: (FsORPSrr:f32 FR32:f32:$src1, FR32:f32:$src2)
              /*SwitchType*/ 11,  MVT::f64,// ->69014
/*69003*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*69005*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::FsORPDrr), 0,
                    1/*#VTs*/, MVT::f64, 2/*#Ops*/, 0, 1, 
                // Src: (X86for:f64 FR64:f64:$src1, FR64:f64:$src2)
                // Dst: (FsORPDrr:f64 FR64:f64:$src1, FR64:f64:$src2)
              0, // EndSwitchType
/*69015*/   0, /*End of Scope*/
          /*SwitchOpcode*/ 35|128,1/*163*/,  X86ISD::FXOR,// ->69182
/*69019*/   OPC_Scope, 64, /*->69085*/ // 3 children in Scope
/*69021*/     OPC_RecordChild0, // #0 = $src1
/*69022*/     OPC_MoveChild, 1,
/*69024*/     OPC_CheckOpcode, ISD::LOAD,
/*69026*/     OPC_RecordMemRef,
/*69027*/     OPC_RecordNode, // #1 = 'ld' chained node
/*69028*/     OPC_CheckFoldableChainNode,
/*69029*/     OPC_RecordChild1, // #2 = $src2
/*69030*/     OPC_CheckPredicate, 2, // Predicate_unindexedload
/*69032*/     OPC_CheckPredicate, 8, // Predicate_load
/*69034*/     OPC_CheckPredicate, 23, // Predicate_memop
/*69036*/     OPC_MoveParent,
/*69037*/     OPC_SwitchType /*2 cases */, 21,  MVT::f32,// ->69061
/*69040*/       OPC_CheckPatternPredicate, 0, // (Subtarget->hasSSE1())
/*69042*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*69045*/       OPC_EmitMergeInputChains, 1, 1, 
/*69048*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::FsXORPSrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::f32, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (X86fxor:f32 FR32:f32:$src1, (ld:f32 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>)
                // Dst: (FsXORPSrm:f32 FR32:f32:$src1, addr:iPTR:$src2)
              /*SwitchType*/ 21,  MVT::f64,// ->69084
/*69063*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*69065*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*69068*/       OPC_EmitMergeInputChains, 1, 1, 
/*69071*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::FsXORPDrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::f64, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (X86fxor:f64 FR64:f64:$src1, (ld:f64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>)
                // Dst: (FsXORPDrm:f64 FR64:f64:$src1, addr:iPTR:$src2)
              0, // EndSwitchType
/*69085*/   /*Scope*/ 64, /*->69150*/
/*69086*/     OPC_MoveChild, 0,
/*69088*/     OPC_CheckOpcode, ISD::LOAD,
/*69090*/     OPC_RecordMemRef,
/*69091*/     OPC_RecordNode, // #0 = 'ld' chained node
/*69092*/     OPC_CheckFoldableChainNode,
/*69093*/     OPC_RecordChild1, // #1 = $src2
/*69094*/     OPC_CheckPredicate, 2, // Predicate_unindexedload
/*69096*/     OPC_CheckPredicate, 8, // Predicate_load
/*69098*/     OPC_CheckPredicate, 23, // Predicate_memop
/*69100*/     OPC_MoveParent,
/*69101*/     OPC_RecordChild1, // #2 = $src1
/*69102*/     OPC_SwitchType /*2 cases */, 21,  MVT::f32,// ->69126
/*69105*/       OPC_CheckPatternPredicate, 0, // (Subtarget->hasSSE1())
/*69107*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*69110*/       OPC_EmitMergeInputChains, 1, 0, 
/*69113*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::FsXORPSrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::f32, 6/*#Ops*/, 2, 3, 4, 5, 6, 7, 
                // Src: (X86fxor:f32 (ld:f32 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>, FR32:f32:$src1)
                // Dst: (FsXORPSrm:f32 FR32:f32:$src1, addr:iPTR:$src2)
              /*SwitchType*/ 21,  MVT::f64,// ->69149
/*69128*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*69130*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*69133*/       OPC_EmitMergeInputChains, 1, 0, 
/*69136*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::FsXORPDrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::f64, 6/*#Ops*/, 2, 3, 4, 5, 6, 7, 
                // Src: (X86fxor:f64 (ld:f64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>, FR64:f64:$src1)
                // Dst: (FsXORPDrm:f64 FR64:f64:$src1, addr:iPTR:$src2)
              0, // EndSwitchType
/*69150*/   /*Scope*/ 30, /*->69181*/
/*69151*/     OPC_RecordChild0, // #0 = $src1
/*69152*/     OPC_RecordChild1, // #1 = $src2
/*69153*/     OPC_SwitchType /*2 cases */, 11,  MVT::f32,// ->69167
/*69156*/       OPC_CheckPatternPredicate, 0, // (Subtarget->hasSSE1())
/*69158*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::FsXORPSrr), 0,
                    1/*#VTs*/, MVT::f32, 2/*#Ops*/, 0, 1, 
                // Src: (X86fxor:f32 FR32:f32:$src1, FR32:f32:$src2)
                // Dst: (FsXORPSrr:f32 FR32:f32:$src1, FR32:f32:$src2)
              /*SwitchType*/ 11,  MVT::f64,// ->69180
/*69169*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*69171*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::FsXORPDrr), 0,
                    1/*#VTs*/, MVT::f64, 2/*#Ops*/, 0, 1, 
                // Src: (X86fxor:f64 FR64:f64:$src1, FR64:f64:$src2)
                // Dst: (FsXORPDrr:f64 FR64:f64:$src1, FR64:f64:$src2)
              0, // EndSwitchType
/*69181*/   0, /*End of Scope*/
          /*SwitchOpcode*/ 50|128,1/*178*/,  X86ISD::FMAX,// ->69363
/*69185*/   OPC_RecordChild0, // #0 = $src1
/*69186*/   OPC_Scope, 118, /*->69306*/ // 2 children in Scope
/*69188*/     OPC_MoveChild, 1,
/*69190*/     OPC_CheckOpcode, ISD::LOAD,
/*69192*/     OPC_RecordMemRef,
/*69193*/     OPC_RecordNode, // #1 = 'ld' chained node
/*69194*/     OPC_CheckFoldableChainNode,
/*69195*/     OPC_RecordChild1, // #2 = $src2
/*69196*/     OPC_CheckPredicate, 2, // Predicate_unindexedload
/*69198*/     OPC_CheckPredicate, 8, // Predicate_load
/*69200*/     OPC_Scope, 24, /*->69226*/ // 4 children in Scope
/*69202*/       OPC_MoveParent,
/*69203*/       OPC_CheckType, MVT::f32,
/*69205*/       OPC_CheckPatternPredicate, 0, // (Subtarget->hasSSE1())
/*69207*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*69210*/       OPC_EmitMergeInputChains, 1, 1, 
/*69213*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MAXSSrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::f32, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (X86fmax:f32 FR32:f32:$src1, (ld:f32 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)
                // Dst: (MAXSSrm:f32 FR32:f32:$src1, addr:iPTR:$src2)
/*69226*/     /*Scope*/ 26, /*->69253*/
/*69227*/       OPC_CheckPredicate, 23, // Predicate_memop
/*69229*/       OPC_MoveParent,
/*69230*/       OPC_CheckType, MVT::v4f32,
/*69232*/       OPC_CheckPatternPredicate, 0, // (Subtarget->hasSSE1())
/*69234*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*69237*/       OPC_EmitMergeInputChains, 1, 1, 
/*69240*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MAXPSrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v4f32, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (X86fmax:v4f32 VR128:v4f32:$src1, (ld:v4f32 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>)
                // Dst: (MAXPSrm:v4f32 VR128:v4f32:$src1, addr:iPTR:$src2)
/*69253*/     /*Scope*/ 24, /*->69278*/
/*69254*/       OPC_MoveParent,
/*69255*/       OPC_CheckType, MVT::f64,
/*69257*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*69259*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*69262*/       OPC_EmitMergeInputChains, 1, 1, 
/*69265*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MAXSDrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::f64, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (X86fmax:f64 FR64:f64:$src1, (ld:f64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)
                // Dst: (MAXSDrm:f64 FR64:f64:$src1, addr:iPTR:$src2)
/*69278*/     /*Scope*/ 26, /*->69305*/
/*69279*/       OPC_CheckPredicate, 23, // Predicate_memop
/*69281*/       OPC_MoveParent,
/*69282*/       OPC_CheckType, MVT::v2f64,
/*69284*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*69286*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*69289*/       OPC_EmitMergeInputChains, 1, 1, 
/*69292*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MAXPDrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v2f64, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (X86fmax:v2f64 VR128:v2f64:$src1, (ld:v2f64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>)
                // Dst: (MAXPDrm:v2f64 VR128:v2f64:$src1, addr:iPTR:$src2)
/*69305*/     0, /*End of Scope*/
/*69306*/   /*Scope*/ 55, /*->69362*/
/*69307*/     OPC_RecordChild1, // #1 = $src2
/*69308*/     OPC_SwitchType /*4 cases */, 11,  MVT::f32,// ->69322
/*69311*/       OPC_CheckPatternPredicate, 0, // (Subtarget->hasSSE1())
/*69313*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MAXSSrr), 0,
                    1/*#VTs*/, MVT::f32, 2/*#Ops*/, 0, 1, 
                // Src: (X86fmax:f32 FR32:f32:$src1, FR32:f32:$src2)
                // Dst: (MAXSSrr:f32 FR32:f32:$src1, FR32:f32:$src2)
              /*SwitchType*/ 11,  MVT::v4f32,// ->69335
/*69324*/       OPC_CheckPatternPredicate, 0, // (Subtarget->hasSSE1())
/*69326*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MAXPSrr), 0,
                    1/*#VTs*/, MVT::v4f32, 2/*#Ops*/, 0, 1, 
                // Src: (X86fmax:v4f32 VR128:v4f32:$src1, VR128:v4f32:$src2)
                // Dst: (MAXPSrr:v4f32 VR128:v4f32:$src1, VR128:v4f32:$src2)
              /*SwitchType*/ 11,  MVT::f64,// ->69348
/*69337*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*69339*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MAXSDrr), 0,
                    1/*#VTs*/, MVT::f64, 2/*#Ops*/, 0, 1, 
                // Src: (X86fmax:f64 FR64:f64:$src1, FR64:f64:$src2)
                // Dst: (MAXSDrr:f64 FR64:f64:$src1, FR64:f64:$src2)
              /*SwitchType*/ 11,  MVT::v2f64,// ->69361
/*69350*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*69352*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MAXPDrr), 0,
                    1/*#VTs*/, MVT::v2f64, 2/*#Ops*/, 0, 1, 
                // Src: (X86fmax:v2f64 VR128:v2f64:$src1, VR128:v2f64:$src2)
                // Dst: (MAXPDrr:v2f64 VR128:v2f64:$src1, VR128:v2f64:$src2)
              0, // EndSwitchType
/*69362*/   0, /*End of Scope*/
          /*SwitchOpcode*/ 50|128,1/*178*/,  X86ISD::FMIN,// ->69544
/*69366*/   OPC_RecordChild0, // #0 = $src1
/*69367*/   OPC_Scope, 118, /*->69487*/ // 2 children in Scope
/*69369*/     OPC_MoveChild, 1,
/*69371*/     OPC_CheckOpcode, ISD::LOAD,
/*69373*/     OPC_RecordMemRef,
/*69374*/     OPC_RecordNode, // #1 = 'ld' chained node
/*69375*/     OPC_CheckFoldableChainNode,
/*69376*/     OPC_RecordChild1, // #2 = $src2
/*69377*/     OPC_CheckPredicate, 2, // Predicate_unindexedload
/*69379*/     OPC_CheckPredicate, 8, // Predicate_load
/*69381*/     OPC_Scope, 24, /*->69407*/ // 4 children in Scope
/*69383*/       OPC_MoveParent,
/*69384*/       OPC_CheckType, MVT::f32,
/*69386*/       OPC_CheckPatternPredicate, 0, // (Subtarget->hasSSE1())
/*69388*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*69391*/       OPC_EmitMergeInputChains, 1, 1, 
/*69394*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MINSSrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::f32, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (X86fmin:f32 FR32:f32:$src1, (ld:f32 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)
                // Dst: (MINSSrm:f32 FR32:f32:$src1, addr:iPTR:$src2)
/*69407*/     /*Scope*/ 26, /*->69434*/
/*69408*/       OPC_CheckPredicate, 23, // Predicate_memop
/*69410*/       OPC_MoveParent,
/*69411*/       OPC_CheckType, MVT::v4f32,
/*69413*/       OPC_CheckPatternPredicate, 0, // (Subtarget->hasSSE1())
/*69415*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*69418*/       OPC_EmitMergeInputChains, 1, 1, 
/*69421*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MINPSrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v4f32, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (X86fmin:v4f32 VR128:v4f32:$src1, (ld:v4f32 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>)
                // Dst: (MINPSrm:v4f32 VR128:v4f32:$src1, addr:iPTR:$src2)
/*69434*/     /*Scope*/ 24, /*->69459*/
/*69435*/       OPC_MoveParent,
/*69436*/       OPC_CheckType, MVT::f64,
/*69438*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*69440*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*69443*/       OPC_EmitMergeInputChains, 1, 1, 
/*69446*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MINSDrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::f64, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (X86fmin:f64 FR64:f64:$src1, (ld:f64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)
                // Dst: (MINSDrm:f64 FR64:f64:$src1, addr:iPTR:$src2)
/*69459*/     /*Scope*/ 26, /*->69486*/
/*69460*/       OPC_CheckPredicate, 23, // Predicate_memop
/*69462*/       OPC_MoveParent,
/*69463*/       OPC_CheckType, MVT::v2f64,
/*69465*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*69467*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*69470*/       OPC_EmitMergeInputChains, 1, 1, 
/*69473*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MINPDrm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v2f64, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
                // Src: (X86fmin:v2f64 VR128:v2f64:$src1, (ld:v2f64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>)
                // Dst: (MINPDrm:v2f64 VR128:v2f64:$src1, addr:iPTR:$src2)
/*69486*/     0, /*End of Scope*/
/*69487*/   /*Scope*/ 55, /*->69543*/
/*69488*/     OPC_RecordChild1, // #1 = $src2
/*69489*/     OPC_SwitchType /*4 cases */, 11,  MVT::f32,// ->69503
/*69492*/       OPC_CheckPatternPredicate, 0, // (Subtarget->hasSSE1())
/*69494*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MINSSrr), 0,
                    1/*#VTs*/, MVT::f32, 2/*#Ops*/, 0, 1, 
                // Src: (X86fmin:f32 FR32:f32:$src1, FR32:f32:$src2)
                // Dst: (MINSSrr:f32 FR32:f32:$src1, FR32:f32:$src2)
              /*SwitchType*/ 11,  MVT::v4f32,// ->69516
/*69505*/       OPC_CheckPatternPredicate, 0, // (Subtarget->hasSSE1())
/*69507*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MINPSrr), 0,
                    1/*#VTs*/, MVT::v4f32, 2/*#Ops*/, 0, 1, 
                // Src: (X86fmin:v4f32 VR128:v4f32:$src1, VR128:v4f32:$src2)
                // Dst: (MINPSrr:v4f32 VR128:v4f32:$src1, VR128:v4f32:$src2)
              /*SwitchType*/ 11,  MVT::f64,// ->69529
/*69518*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*69520*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MINSDrr), 0,
                    1/*#VTs*/, MVT::f64, 2/*#Ops*/, 0, 1, 
                // Src: (X86fmin:f64 FR64:f64:$src1, FR64:f64:$src2)
                // Dst: (MINSDrr:f64 FR64:f64:$src1, FR64:f64:$src2)
              /*SwitchType*/ 11,  MVT::v2f64,// ->69542
/*69531*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*69533*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MINPDrr), 0,
                    1/*#VTs*/, MVT::v2f64, 2/*#Ops*/, 0, 1, 
                // Src: (X86fmin:v2f64 VR128:v2f64:$src1, VR128:v2f64:$src2)
                // Dst: (MINPDrr:v2f64 VR128:v2f64:$src1, VR128:v2f64:$src2)
              0, // EndSwitchType
/*69543*/   0, /*End of Scope*/
          /*SwitchOpcode*/ 78|128,1/*206*/,  ISD::FSQRT,// ->69753
/*69547*/   OPC_Scope, 113, /*->69662*/ // 2 children in Scope
/*69549*/     OPC_MoveChild, 0,
/*69551*/     OPC_CheckOpcode, ISD::LOAD,
/*69553*/     OPC_RecordMemRef,
/*69554*/     OPC_RecordNode, // #0 = 'ld' chained node
/*69555*/     OPC_RecordChild1, // #1 = $src
/*69556*/     OPC_CheckPredicate, 2, // Predicate_unindexedload
/*69558*/     OPC_CheckPredicate, 8, // Predicate_load
/*69560*/     OPC_Scope, 23, /*->69585*/ // 4 children in Scope
/*69562*/       OPC_MoveParent,
/*69563*/       OPC_CheckType, MVT::f32,
/*69565*/       OPC_CheckPatternPredicate, 19, // (Subtarget->hasSSE1()) && (OptForSize)
/*69567*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*69570*/       OPC_EmitMergeInputChains, 1, 0, 
/*69573*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::SQRTSSm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::f32, 5/*#Ops*/, 2, 3, 4, 5, 6, 
                // Src: (fsqrt:f32 (ld:f32 addr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)
                // Dst: (SQRTSSm:f32 addr:iPTR:$src)
/*69585*/     /*Scope*/ 25, /*->69611*/
/*69586*/       OPC_CheckPredicate, 23, // Predicate_memop
/*69588*/       OPC_MoveParent,
/*69589*/       OPC_CheckType, MVT::v4f32,
/*69591*/       OPC_CheckPatternPredicate, 0, // (Subtarget->hasSSE1())
/*69593*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*69596*/       OPC_EmitMergeInputChains, 1, 0, 
/*69599*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::SQRTPSm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v4f32, 5/*#Ops*/, 2, 3, 4, 5, 6, 
                // Src: (fsqrt:v4f32 (ld:v4f32 addr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>)
                // Dst: (SQRTPSm:v4f32 addr:iPTR:$src)
/*69611*/     /*Scope*/ 23, /*->69635*/
/*69612*/       OPC_MoveParent,
/*69613*/       OPC_CheckType, MVT::f64,
/*69615*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*69617*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*69620*/       OPC_EmitMergeInputChains, 1, 0, 
/*69623*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::SQRTSDm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::f64, 5/*#Ops*/, 2, 3, 4, 5, 6, 
                // Src: (fsqrt:f64 (ld:f64 addr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)
                // Dst: (SQRTSDm:f64 addr:iPTR:$src)
/*69635*/     /*Scope*/ 25, /*->69661*/
/*69636*/       OPC_CheckPredicate, 23, // Predicate_memop
/*69638*/       OPC_MoveParent,
/*69639*/       OPC_CheckType, MVT::v2f64,
/*69641*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*69643*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*69646*/       OPC_EmitMergeInputChains, 1, 0, 
/*69649*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::SQRTPDm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v2f64, 5/*#Ops*/, 2, 3, 4, 5, 6, 
                // Src: (fsqrt:v2f64 (ld:v2f64 addr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>)
                // Dst: (SQRTPDm:v2f64 addr:iPTR:$src)
/*69661*/     0, /*End of Scope*/
/*69662*/   /*Scope*/ 89, /*->69752*/
/*69663*/     OPC_RecordChild0, // #0 = $src
/*69664*/     OPC_SwitchType /*5 cases */, 24,  MVT::f32,// ->69691
/*69667*/       OPC_Scope, 10, /*->69679*/ // 2 children in Scope
/*69669*/         OPC_CheckPatternPredicate, 6, // (!Subtarget->hasSSE1())
/*69671*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::SQRT_Fp32), 0,
                      1/*#VTs*/, MVT::f32, 1/*#Ops*/, 0, 
                  // Src: (fsqrt:f32 RFP32:f32:$src)
                  // Dst: (SQRT_Fp32:f32 RFP32:f32:$src)
/*69679*/       /*Scope*/ 10, /*->69690*/
/*69680*/         OPC_CheckPatternPredicate, 0, // (Subtarget->hasSSE1())
/*69682*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::SQRTSSr), 0,
                      1/*#VTs*/, MVT::f32, 1/*#Ops*/, 0, 
                  // Src: (fsqrt:f32 FR32:f32:$src)
                  // Dst: (SQRTSSr:f32 FR32:f32:$src)
/*69690*/       0, /*End of Scope*/
              /*SwitchType*/ 24,  MVT::f64,// ->69717
/*69693*/       OPC_Scope, 10, /*->69705*/ // 2 children in Scope
/*69695*/         OPC_CheckPatternPredicate, 7, // (!Subtarget->hasSSE2())
/*69697*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::SQRT_Fp64), 0,
                      1/*#VTs*/, MVT::f64, 1/*#Ops*/, 0, 
                  // Src: (fsqrt:f64 RFP64:f64:$src)
                  // Dst: (SQRT_Fp64:f64 RFP64:f64:$src)
/*69705*/       /*Scope*/ 10, /*->69716*/
/*69706*/         OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*69708*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::SQRTSDr), 0,
                      1/*#VTs*/, MVT::f64, 1/*#Ops*/, 0, 
                  // Src: (fsqrt:f64 FR64:f64:$src)
                  // Dst: (SQRTSDr:f64 FR64:f64:$src)
/*69716*/       0, /*End of Scope*/
              /*SwitchType*/ 8,  MVT::f80,// ->69727
/*69719*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::SQRT_Fp80), 0,
                    1/*#VTs*/, MVT::f80, 1/*#Ops*/, 0, 
                // Src: (fsqrt:f80 RFP80:f80:$src)
                // Dst: (SQRT_Fp80:f80 RFP80:f80:$src)
              /*SwitchType*/ 10,  MVT::v4f32,// ->69739
/*69729*/       OPC_CheckPatternPredicate, 0, // (Subtarget->hasSSE1())
/*69731*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::SQRTPSr), 0,
                    1/*#VTs*/, MVT::v4f32, 1/*#Ops*/, 0, 
                // Src: (fsqrt:v4f32 VR128:v4f32:$src)
                // Dst: (SQRTPSr:v4f32 VR128:v4f32:$src)
              /*SwitchType*/ 10,  MVT::v2f64,// ->69751
/*69741*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*69743*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::SQRTPDr), 0,
                    1/*#VTs*/, MVT::v2f64, 1/*#Ops*/, 0, 
                // Src: (fsqrt:v2f64 VR128:v2f64:$src)
                // Dst: (SQRTPDr:v2f64 VR128:v2f64:$src)
              0, // EndSwitchType
/*69752*/   0, /*End of Scope*/
          /*SwitchOpcode*/ 94,  X86ISD::FRSQRT,// ->69849
/*69755*/   OPC_Scope, 63, /*->69820*/ // 2 children in Scope
/*69757*/     OPC_MoveChild, 0,
/*69759*/     OPC_CheckOpcode, ISD::LOAD,
/*69761*/     OPC_RecordMemRef,
/*69762*/     OPC_RecordNode, // #0 = 'ld' chained node
/*69763*/     OPC_RecordChild1, // #1 = $src
/*69764*/     OPC_CheckPredicate, 2, // Predicate_unindexedload
/*69766*/     OPC_CheckPredicate, 8, // Predicate_load
/*69768*/     OPC_Scope, 23, /*->69793*/ // 2 children in Scope
/*69770*/       OPC_MoveParent,
/*69771*/       OPC_CheckType, MVT::f32,
/*69773*/       OPC_CheckPatternPredicate, 19, // (Subtarget->hasSSE1()) && (OptForSize)
/*69775*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*69778*/       OPC_EmitMergeInputChains, 1, 0, 
/*69781*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::RSQRTSSm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::f32, 5/*#Ops*/, 2, 3, 4, 5, 6, 
                // Src: (X86frsqrt:f32 (ld:f32 addr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)
                // Dst: (RSQRTSSm:f32 addr:iPTR:$src)
/*69793*/     /*Scope*/ 25, /*->69819*/
/*69794*/       OPC_CheckPredicate, 23, // Predicate_memop
/*69796*/       OPC_MoveParent,
/*69797*/       OPC_CheckType, MVT::v4f32,
/*69799*/       OPC_CheckPatternPredicate, 0, // (Subtarget->hasSSE1())
/*69801*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*69804*/       OPC_EmitMergeInputChains, 1, 0, 
/*69807*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::RSQRTPSm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v4f32, 5/*#Ops*/, 2, 3, 4, 5, 6, 
                // Src: (X86frsqrt:v4f32 (ld:v4f32 addr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>)
                // Dst: (RSQRTPSm:v4f32 addr:iPTR:$src)
/*69819*/     0, /*End of Scope*/
/*69820*/   /*Scope*/ 27, /*->69848*/
/*69821*/     OPC_RecordChild0, // #0 = $src
/*69822*/     OPC_SwitchType /*2 cases */, 10,  MVT::f32,// ->69835
/*69825*/       OPC_CheckPatternPredicate, 0, // (Subtarget->hasSSE1())
/*69827*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::RSQRTSSr), 0,
                    1/*#VTs*/, MVT::f32, 1/*#Ops*/, 0, 
                // Src: (X86frsqrt:f32 FR32:f32:$src)
                // Dst: (RSQRTSSr:f32 FR32:f32:$src)
              /*SwitchType*/ 10,  MVT::v4f32,// ->69847
/*69837*/       OPC_CheckPatternPredicate, 0, // (Subtarget->hasSSE1())
/*69839*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::RSQRTPSr), 0,
                    1/*#VTs*/, MVT::v4f32, 1/*#Ops*/, 0, 
                // Src: (X86frsqrt:v4f32 VR128:v4f32:$src)
                // Dst: (RSQRTPSr:v4f32 VR128:v4f32:$src)
              0, // EndSwitchType
/*69848*/   0, /*End of Scope*/
          /*SwitchOpcode*/ 94,  X86ISD::FRCP,// ->69945
/*69851*/   OPC_Scope, 63, /*->69916*/ // 2 children in Scope
/*69853*/     OPC_MoveChild, 0,
/*69855*/     OPC_CheckOpcode, ISD::LOAD,
/*69857*/     OPC_RecordMemRef,
/*69858*/     OPC_RecordNode, // #0 = 'ld' chained node
/*69859*/     OPC_RecordChild1, // #1 = $src
/*69860*/     OPC_CheckPredicate, 2, // Predicate_unindexedload
/*69862*/     OPC_CheckPredicate, 8, // Predicate_load
/*69864*/     OPC_Scope, 23, /*->69889*/ // 2 children in Scope
/*69866*/       OPC_MoveParent,
/*69867*/       OPC_CheckType, MVT::f32,
/*69869*/       OPC_CheckPatternPredicate, 19, // (Subtarget->hasSSE1()) && (OptForSize)
/*69871*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*69874*/       OPC_EmitMergeInputChains, 1, 0, 
/*69877*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::RCPSSm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::f32, 5/*#Ops*/, 2, 3, 4, 5, 6, 
                // Src: (X86frcp:f32 (ld:f32 addr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)
                // Dst: (RCPSSm:f32 addr:iPTR:$src)
/*69889*/     /*Scope*/ 25, /*->69915*/
/*69890*/       OPC_CheckPredicate, 23, // Predicate_memop
/*69892*/       OPC_MoveParent,
/*69893*/       OPC_CheckType, MVT::v4f32,
/*69895*/       OPC_CheckPatternPredicate, 0, // (Subtarget->hasSSE1())
/*69897*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*69900*/       OPC_EmitMergeInputChains, 1, 0, 
/*69903*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::RCPPSm), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::v4f32, 5/*#Ops*/, 2, 3, 4, 5, 6, 
                // Src: (X86frcp:v4f32 (ld:v4f32 addr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>)
                // Dst: (RCPPSm:v4f32 addr:iPTR:$src)
/*69915*/     0, /*End of Scope*/
/*69916*/   /*Scope*/ 27, /*->69944*/
/*69917*/     OPC_RecordChild0, // #0 = $src
/*69918*/     OPC_SwitchType /*2 cases */, 10,  MVT::f32,// ->69931
/*69921*/       OPC_CheckPatternPredicate, 0, // (Subtarget->hasSSE1())
/*69923*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::RCPSSr), 0,
                    1/*#VTs*/, MVT::f32, 1/*#Ops*/, 0, 
                // Src: (X86frcp:f32 FR32:f32:$src)
                // Dst: (RCPSSr:f32 FR32:f32:$src)
              /*SwitchType*/ 10,  MVT::v4f32,// ->69943
/*69933*/       OPC_CheckPatternPredicate, 0, // (Subtarget->hasSSE1())
/*69935*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::RCPPSr), 0,
                    1/*#VTs*/, MVT::v4f32, 1/*#Ops*/, 0, 
                // Src: (X86frcp:v4f32 VR128:v4f32:$src)
                // Dst: (RCPPSr:v4f32 VR128:v4f32:$src)
              0, // EndSwitchType
/*69944*/   0, /*End of Scope*/
          /*SwitchOpcode*/ 103,  ISD::FP_ROUND,// ->70050
/*69947*/   OPC_Scope, 38, /*->69987*/ // 2 children in Scope
/*69949*/     OPC_MoveChild, 0,
/*69951*/     OPC_CheckOpcode, ISD::LOAD,
/*69953*/     OPC_RecordMemRef,
/*69954*/     OPC_RecordNode, // #0 = 'ld' chained node
/*69955*/     OPC_RecordChild1, // #1 = $src
/*69956*/     OPC_CheckPredicate, 2, // Predicate_unindexedload
/*69958*/     OPC_CheckPredicate, 8, // Predicate_load
/*69960*/     OPC_CheckPredicate, 9, // Predicate_dsload
/*69962*/     OPC_CheckType, MVT::f64,
/*69964*/     OPC_MoveParent,
/*69965*/     OPC_CheckType, MVT::f32,
/*69967*/     OPC_CheckPatternPredicate, 12, // (Subtarget->hasSSE2()) && (OptForSize)
/*69969*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*69972*/     OPC_EmitMergeInputChains, 1, 0, 
/*69975*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::CVTSD2SSrm), 0|OPFL_Chain|OPFL_MemRefs,
                  1/*#VTs*/, MVT::f32, 5/*#Ops*/, 2, 3, 4, 5, 6, 
              // Src: (fround:f32 (ld:f64 addr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>)
              // Dst: (CVTSD2SSrm:f32 addr:iPTR:$src)
/*69987*/   /*Scope*/ 61, /*->70049*/
/*69988*/     OPC_RecordChild0, // #0 = $src
/*69989*/     OPC_Scope, 28, /*->70019*/ // 2 children in Scope
/*69991*/       OPC_CheckChild0Type, MVT::f64,
/*69993*/       OPC_CheckType, MVT::f32,
/*69995*/       OPC_Scope, 10, /*->70007*/ // 2 children in Scope
/*69997*/         OPC_CheckPatternPredicate, 6, // (!Subtarget->hasSSE1())
/*69999*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::MOV_Fp6432), 0,
                      1/*#VTs*/, MVT::f32, 1/*#Ops*/, 0, 
                  // Src: (fround:f32 RFP64:f64:$src)
                  // Dst: (MOV_Fp6432:f32 RFP64:f64:$src)
/*70007*/       /*Scope*/ 10, /*->70018*/
/*70008*/         OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*70010*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::CVTSD2SSrr), 0,
                      1/*#VTs*/, MVT::f32, 1/*#Ops*/, 0, 
                  // Src: (fround:f32 FR64:f64:$src)
                  // Dst: (CVTSD2SSrr:f32 FR64:f64:$src)
/*70018*/       0, /*End of Scope*/
/*70019*/     /*Scope*/ 28, /*->70048*/
/*70020*/       OPC_CheckChild0Type, MVT::f80,
/*70022*/       OPC_SwitchType /*2 cases */, 10,  MVT::f32,// ->70035
/*70025*/         OPC_CheckPatternPredicate, 6, // (!Subtarget->hasSSE1())
/*70027*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::MOV_Fp8032), 0,
                      1/*#VTs*/, MVT::f32, 1/*#Ops*/, 0, 
                  // Src: (fround:f32 RFP80:f80:$src)
                  // Dst: (MOV_Fp8032:f32 RFP80:f80:$src)
                /*SwitchType*/ 10,  MVT::f64,// ->70047
/*70037*/         OPC_CheckPatternPredicate, 7, // (!Subtarget->hasSSE2())
/*70039*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::MOV_Fp8064), 0,
                      1/*#VTs*/, MVT::f64, 1/*#Ops*/, 0, 
                  // Src: (fround:f64 RFP80:f80:$src)
                  // Dst: (MOV_Fp8064:f64 RFP80:f80:$src)
                0, // EndSwitchType
/*70048*/     0, /*End of Scope*/
/*70049*/   0, /*End of Scope*/
          /*SwitchOpcode*/ 103,  ISD::FP_EXTEND,// ->70155
/*70052*/   OPC_Scope, 38, /*->70092*/ // 2 children in Scope
/*70054*/     OPC_MoveChild, 0,
/*70056*/     OPC_CheckOpcode, ISD::LOAD,
/*70058*/     OPC_RecordMemRef,
/*70059*/     OPC_RecordNode, // #0 = 'ld' chained node
/*70060*/     OPC_RecordChild1, // #1 = $src
/*70061*/     OPC_CheckPredicate, 2, // Predicate_unindexedload
/*70063*/     OPC_CheckPredicate, 8, // Predicate_load
/*70065*/     OPC_CheckPredicate, 9, // Predicate_dsload
/*70067*/     OPC_CheckType, MVT::f32,
/*70069*/     OPC_MoveParent,
/*70070*/     OPC_CheckType, MVT::f64,
/*70072*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*70074*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*70077*/     OPC_EmitMergeInputChains, 1, 0, 
/*70080*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::CVTSS2SDrm), 0|OPFL_Chain|OPFL_MemRefs,
                  1/*#VTs*/, MVT::f64, 5/*#Ops*/, 2, 3, 4, 5, 6, 
              // Src: (fextend:f64 (ld:f32 addr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_dsload>>)
              // Dst: (CVTSS2SDrm:f64 addr:iPTR:$src)
/*70092*/   /*Scope*/ 61, /*->70154*/
/*70093*/     OPC_RecordChild0, // #0 = $src
/*70094*/     OPC_Scope, 42, /*->70138*/ // 2 children in Scope
/*70096*/       OPC_CheckChild0Type, MVT::f32,
/*70098*/       OPC_SwitchType /*2 cases */, 24,  MVT::f64,// ->70125
/*70101*/         OPC_Scope, 10, /*->70113*/ // 2 children in Scope
/*70103*/           OPC_CheckPatternPredicate, 6, // (!Subtarget->hasSSE1())
/*70105*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::MOV_Fp3264), 0,
                        1/*#VTs*/, MVT::f64, 1/*#Ops*/, 0, 
                    // Src: (fextend:f64 RFP32:f32:$src)
                    // Dst: (MOV_Fp3264:f64 RFP32:f32:$src)
/*70113*/         /*Scope*/ 10, /*->70124*/
/*70114*/           OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*70116*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::CVTSS2SDrr), 0,
                        1/*#VTs*/, MVT::f64, 1/*#Ops*/, 0, 
                    // Src: (fextend:f64 FR32:f32:$src)
                    // Dst: (CVTSS2SDrr:f64 FR32:f32:$src)
/*70124*/         0, /*End of Scope*/
                /*SwitchType*/ 10,  MVT::f80,// ->70137
/*70127*/         OPC_CheckPatternPredicate, 6, // (!Subtarget->hasSSE1())
/*70129*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::MOV_Fp3280), 0,
                      1/*#VTs*/, MVT::f80, 1/*#Ops*/, 0, 
                  // Src: (fextend:f80 RFP32:f32:$src)
                  // Dst: (MOV_Fp3280:f80 RFP32:f32:$src)
                0, // EndSwitchType
/*70138*/     /*Scope*/ 14, /*->70153*/
/*70139*/       OPC_CheckChild0Type, MVT::f64,
/*70141*/       OPC_CheckType, MVT::f80,
/*70143*/       OPC_CheckPatternPredicate, 7, // (!Subtarget->hasSSE2())
/*70145*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MOV_Fp6480), 0,
                    1/*#VTs*/, MVT::f80, 1/*#Ops*/, 0, 
                // Src: (fextend:f80 RFP64:f64:$src)
                // Dst: (MOV_Fp6480:f80 RFP64:f64:$src)
/*70153*/     0, /*End of Scope*/
/*70154*/   0, /*End of Scope*/
          /*SwitchOpcode*/ 92,  X86ISD::PCMPEQQ,// ->70249
/*70157*/   OPC_Scope, 37, /*->70196*/ // 3 children in Scope
/*70159*/     OPC_RecordChild0, // #0 = $src1
/*70160*/     OPC_MoveChild, 1,
/*70162*/     OPC_CheckOpcode, ISD::LOAD,
/*70164*/     OPC_RecordMemRef,
/*70165*/     OPC_RecordNode, // #1 = 'ld' chained node
/*70166*/     OPC_CheckFoldableChainNode,
/*70167*/     OPC_RecordChild1, // #2 = $src2
/*70168*/     OPC_CheckPredicate, 2, // Predicate_unindexedload
/*70170*/     OPC_CheckPredicate, 8, // Predicate_load
/*70172*/     OPC_CheckPredicate, 23, // Predicate_memop
/*70174*/     OPC_MoveParent,
/*70175*/     OPC_CheckType, MVT::v2i64,
/*70177*/     OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*70180*/     OPC_EmitMergeInputChains, 1, 1, 
/*70183*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::PCMPEQQrm), 0|OPFL_Chain|OPFL_MemRefs,
                  1/*#VTs*/, MVT::v2i64, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
              // Src: (X86pcmpeqq:v2i64 VR128:v2i64:$src1, (ld:v2i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>)
              // Dst: (PCMPEQQrm:v2i64 VR128:v16i8:$src1, addr:iPTR:$src2)
/*70196*/   /*Scope*/ 37, /*->70234*/
/*70197*/     OPC_MoveChild, 0,
/*70199*/     OPC_CheckOpcode, ISD::LOAD,
/*70201*/     OPC_RecordMemRef,
/*70202*/     OPC_RecordNode, // #0 = 'ld' chained node
/*70203*/     OPC_CheckFoldableChainNode,
/*70204*/     OPC_RecordChild1, // #1 = $src2
/*70205*/     OPC_CheckPredicate, 2, // Predicate_unindexedload
/*70207*/     OPC_CheckPredicate, 8, // Predicate_load
/*70209*/     OPC_CheckPredicate, 23, // Predicate_memop
/*70211*/     OPC_MoveParent,
/*70212*/     OPC_RecordChild1, // #2 = $src1
/*70213*/     OPC_CheckType, MVT::v2i64,
/*70215*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*70218*/     OPC_EmitMergeInputChains, 1, 0, 
/*70221*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::PCMPEQQrm), 0|OPFL_Chain|OPFL_MemRefs,
                  1/*#VTs*/, MVT::v2i64, 6/*#Ops*/, 2, 3, 4, 5, 6, 7, 
              // Src: (X86pcmpeqq:v2i64 (ld:v2i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>, VR128:v2i64:$src1)
              // Dst: (PCMPEQQrm:v2i64 VR128:v16i8:$src1, addr:iPTR:$src2)
/*70234*/   /*Scope*/ 13, /*->70248*/
/*70235*/     OPC_RecordChild0, // #0 = $src1
/*70236*/     OPC_RecordChild1, // #1 = $src2
/*70237*/     OPC_CheckType, MVT::v2i64,
/*70239*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::PCMPEQQrr), 0,
                  1/*#VTs*/, MVT::v2i64, 2/*#Ops*/, 0, 1, 
              // Src: (X86pcmpeqq:v2i64 VR128:v2i64:$src1, VR128:v2i64:$src2)
              // Dst: (PCMPEQQrr:v2i64 VR128:v16i8:$src1, VR128:v16i8:$src2)
/*70248*/   0, /*End of Scope*/
          /*SwitchOpcode*/ 51,  X86ISD::PTEST,// ->70302
/*70251*/   OPC_RecordChild0, // #0 = $src1
/*70252*/   OPC_Scope, 34, /*->70288*/ // 2 children in Scope
/*70254*/     OPC_MoveChild, 1,
/*70256*/     OPC_CheckOpcode, ISD::LOAD,
/*70258*/     OPC_RecordMemRef,
/*70259*/     OPC_RecordNode, // #1 = 'ld' chained node
/*70260*/     OPC_CheckFoldableChainNode,
/*70261*/     OPC_RecordChild1, // #2 = $src2
/*70262*/     OPC_CheckPredicate, 2, // Predicate_unindexedload
/*70264*/     OPC_CheckPredicate, 8, // Predicate_load
/*70266*/     OPC_MoveParent,
/*70267*/     OPC_CheckPatternPredicate, 4, // (Subtarget->hasSSE41())
/*70269*/     OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*70272*/     OPC_EmitMergeInputChains, 1, 1, 
/*70275*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::PTESTrm), 0|OPFL_Chain|OPFL_MemRefs,
                  1/*#VTs*/, MVT::i32, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
              // Src: (X86ptest:isVoid VR128:v4f32:$src1, (ld:v4f32 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)
              // Dst: (PTESTrm:isVoid VR128:v4f32:$src1, addr:iPTR:$src2)
/*70288*/   /*Scope*/ 12, /*->70301*/
/*70289*/     OPC_RecordChild1, // #1 = $src2
/*70290*/     OPC_CheckPatternPredicate, 4, // (Subtarget->hasSSE41())
/*70292*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::PTESTrr), 0,
                  1/*#VTs*/, MVT::i32, 2/*#Ops*/, 0, 1, 
              // Src: (X86ptest:isVoid VR128:v4f32:$src1, VR128:v4f32:$src2)
              // Dst: (PTESTrr:isVoid VR128:v4f32:$src1, VR128:v4f32:$src2)
/*70301*/   0, /*End of Scope*/
          /*SwitchOpcode*/ 53,  X86ISD::PCMPGTQ,// ->70357
/*70304*/   OPC_RecordChild0, // #0 = $src1
/*70305*/   OPC_Scope, 36, /*->70343*/ // 2 children in Scope
/*70307*/     OPC_MoveChild, 1,
/*70309*/     OPC_CheckOpcode, ISD::LOAD,
/*70311*/     OPC_RecordMemRef,
/*70312*/     OPC_RecordNode, // #1 = 'ld' chained node
/*70313*/     OPC_CheckFoldableChainNode,
/*70314*/     OPC_RecordChild1, // #2 = $src2
/*70315*/     OPC_CheckPredicate, 2, // Predicate_unindexedload
/*70317*/     OPC_CheckPredicate, 8, // Predicate_load
/*70319*/     OPC_CheckPredicate, 23, // Predicate_memop
/*70321*/     OPC_MoveParent,
/*70322*/     OPC_CheckType, MVT::v2i64,
/*70324*/     OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$src2 #3 #4 #5 #6 #7
/*70327*/     OPC_EmitMergeInputChains, 1, 1, 
/*70330*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::PCMPGTQrm), 0|OPFL_Chain|OPFL_MemRefs,
                  1/*#VTs*/, MVT::v2i64, 6/*#Ops*/, 0, 3, 4, 5, 6, 7, 
              // Src: (X86pcmpgtq:v2i64 VR128:v2i64:$src1, (ld:v2i64 addr:iPTR:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_memop>>)
              // Dst: (PCMPGTQrm:v2i64 VR128:v16i8:$src1, addr:iPTR:$src2)
/*70343*/   /*Scope*/ 12, /*->70356*/
/*70344*/     OPC_RecordChild1, // #1 = $src2
/*70345*/     OPC_CheckType, MVT::v2i64,
/*70347*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::PCMPGTQrr), 0,
                  1/*#VTs*/, MVT::v2i64, 2/*#Ops*/, 0, 1, 
              // Src: (X86pcmpgtq:v2i64 VR128:v2i64:$src1, VR128:v2i64:$src2)
              // Dst: (PCMPGTQrr:v2i64 VR128:v16i8:$src1, VR128:v16i8:$src2)
/*70356*/   0, /*End of Scope*/
          /*SwitchOpcode*/ 98,  ISD::ATOMIC_SWAP,// ->70457
/*70359*/   OPC_RecordMemRef,
/*70360*/   OPC_RecordNode,   // #0 = 'atomic_swap' chained node
/*70361*/   OPC_RecordChild1, // #1 = $ptr
/*70362*/   OPC_RecordChild2, // #2 = $val
/*70363*/   OPC_SwitchType /*4 cases */, 21,  MVT::i32,// ->70387
/*70366*/     OPC_CheckPredicate, 72, // Predicate_atomic_swap_32
/*70368*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$ptr #3 #4 #5 #6 #7
/*70371*/     OPC_EmitMergeInputChains, 1, 0, 
/*70374*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::XCHG32rm), 0|OPFL_Chain|OPFL_MemRefs,
                  1/*#VTs*/, MVT::i32, 6/*#Ops*/, 2, 3, 4, 5, 6, 7, 
              // Src: (atomic_swap:i32 addr:iPTR:$ptr, GR32:i32:$val)<<P:Predicate_atomic_swap_32>>
              // Dst: (XCHG32rm:i32 GR32:i32:$val, addr:iPTR:$ptr)
            /*SwitchType*/ 21,  MVT::i16,// ->70410
/*70389*/     OPC_CheckPredicate, 73, // Predicate_atomic_swap_16
/*70391*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$ptr #3 #4 #5 #6 #7
/*70394*/     OPC_EmitMergeInputChains, 1, 0, 
/*70397*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::XCHG16rm), 0|OPFL_Chain|OPFL_MemRefs,
                  1/*#VTs*/, MVT::i16, 6/*#Ops*/, 2, 3, 4, 5, 6, 7, 
              // Src: (atomic_swap:i16 addr:iPTR:$ptr, GR16:i16:$val)<<P:Predicate_atomic_swap_16>>
              // Dst: (XCHG16rm:i16 GR16:i16:$val, addr:iPTR:$ptr)
            /*SwitchType*/ 21,  MVT::i8,// ->70433
/*70412*/     OPC_CheckPredicate, 74, // Predicate_atomic_swap_8
/*70414*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$ptr #3 #4 #5 #6 #7
/*70417*/     OPC_EmitMergeInputChains, 1, 0, 
/*70420*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::XCHG8rm), 0|OPFL_Chain|OPFL_MemRefs,
                  1/*#VTs*/, MVT::i8, 6/*#Ops*/, 2, 3, 4, 5, 6, 7, 
              // Src: (atomic_swap:i8 addr:iPTR:$ptr, GR8:i8:$val)<<P:Predicate_atomic_swap_8>>
              // Dst: (XCHG8rm:i8 GR8:i8:$val, addr:iPTR:$ptr)
            /*SwitchType*/ 21,  MVT::i64,// ->70456
/*70435*/     OPC_CheckPredicate, 75, // Predicate_atomic_swap_64
/*70437*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$ptr #3 #4 #5 #6 #7
/*70440*/     OPC_EmitMergeInputChains, 1, 0, 
/*70443*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::XCHG64rm), 0|OPFL_Chain|OPFL_MemRefs,
                  1/*#VTs*/, MVT::i64, 6/*#Ops*/, 2, 3, 4, 5, 6, 7, 
              // Src: (atomic_swap:i64 addr:iPTR:$ptr, GR64:i64:$val)<<P:Predicate_atomic_swap_64>>
              // Dst: (XCHG64rm:i64 GR64:i64:$val, addr:iPTR:$ptr)
            0, // EndSwitchType
          /*SwitchOpcode*/ 98,  ISD::ATOMIC_LOAD_ADD,// ->70557
/*70459*/   OPC_RecordMemRef,
/*70460*/   OPC_RecordNode,   // #0 = 'atomic_load_add' chained node
/*70461*/   OPC_RecordChild1, // #1 = $ptr
/*70462*/   OPC_RecordChild2, // #2 = $val
/*70463*/   OPC_SwitchType /*4 cases */, 21,  MVT::i32,// ->70487
/*70466*/     OPC_CheckPredicate, 76, // Predicate_atomic_load_add_32
/*70468*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$ptr #3 #4 #5 #6 #7
/*70471*/     OPC_EmitMergeInputChains, 1, 0, 
/*70474*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::LXADD32), 0|OPFL_Chain|OPFL_MemRefs,
                  1/*#VTs*/, MVT::i32, 6/*#Ops*/, 2, 3, 4, 5, 6, 7, 
              // Src: (atomic_load_add:i32 addr:iPTR:$ptr, GR32:i32:$val)<<P:Predicate_atomic_load_add_32>>
              // Dst: (LXADD32:i32 GR32:i32:$val, addr:iPTR:$ptr)
            /*SwitchType*/ 21,  MVT::i16,// ->70510
/*70489*/     OPC_CheckPredicate, 77, // Predicate_atomic_load_add_16
/*70491*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$ptr #3 #4 #5 #6 #7
/*70494*/     OPC_EmitMergeInputChains, 1, 0, 
/*70497*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::LXADD16), 0|OPFL_Chain|OPFL_MemRefs,
                  1/*#VTs*/, MVT::i16, 6/*#Ops*/, 2, 3, 4, 5, 6, 7, 
              // Src: (atomic_load_add:i16 addr:iPTR:$ptr, GR16:i16:$val)<<P:Predicate_atomic_load_add_16>>
              // Dst: (LXADD16:i16 GR16:i16:$val, addr:iPTR:$ptr)
            /*SwitchType*/ 21,  MVT::i8,// ->70533
/*70512*/     OPC_CheckPredicate, 78, // Predicate_atomic_load_add_8
/*70514*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$ptr #3 #4 #5 #6 #7
/*70517*/     OPC_EmitMergeInputChains, 1, 0, 
/*70520*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::LXADD8), 0|OPFL_Chain|OPFL_MemRefs,
                  1/*#VTs*/, MVT::i8, 6/*#Ops*/, 2, 3, 4, 5, 6, 7, 
              // Src: (atomic_load_add:i8 addr:iPTR:$ptr, GR8:i8:$val)<<P:Predicate_atomic_load_add_8>>
              // Dst: (LXADD8:i8 GR8:i8:$val, addr:iPTR:$ptr)
            /*SwitchType*/ 21,  MVT::i64,// ->70556
/*70535*/     OPC_CheckPredicate, 79, // Predicate_atomic_load_add_64
/*70537*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$ptr #3 #4 #5 #6 #7
/*70540*/     OPC_EmitMergeInputChains, 1, 0, 
/*70543*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::LXADD64), 0|OPFL_Chain|OPFL_MemRefs,
                  1/*#VTs*/, MVT::i64, 6/*#Ops*/, 2, 3, 4, 5, 6, 7, 
              // Src: (atomic_load_add:i64 addr:iPTR:$ptr, GR64:i64:$val)<<P:Predicate_atomic_load_add_64>>
              // Dst: (LXADD64:i64 GR64:i64:$val, addr:iPTR:$ptr)
            0, // EndSwitchType
          /*SwitchOpcode*/ 98,  ISD::ATOMIC_LOAD_AND,// ->70657
/*70559*/   OPC_RecordMemRef,
/*70560*/   OPC_RecordNode,   // #0 = 'atomic_load_and' chained node
/*70561*/   OPC_RecordChild1, // #1 = $ptr
/*70562*/   OPC_RecordChild2, // #2 = $val
/*70563*/   OPC_SwitchType /*4 cases */, 21,  MVT::i32,// ->70587
/*70566*/     OPC_CheckPredicate, 80, // Predicate_atomic_load_and_32
/*70568*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$ptr #3 #4 #5 #6 #7
/*70571*/     OPC_EmitMergeInputChains, 1, 0, 
/*70574*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::ATOMAND32), 0|OPFL_Chain|OPFL_MemRefs,
                  1/*#VTs*/, MVT::i32, 6/*#Ops*/, 3, 4, 5, 6, 7, 2, 
              // Src: (atomic_load_and:i32 addr:iPTR:$ptr, GR32:i32:$val)<<P:Predicate_atomic_load_and_32>>
              // Dst: (ATOMAND32:i32 addr:iPTR:$ptr, GR32:i32:$val)
            /*SwitchType*/ 21,  MVT::i16,// ->70610
/*70589*/     OPC_CheckPredicate, 81, // Predicate_atomic_load_and_16
/*70591*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$ptr #3 #4 #5 #6 #7
/*70594*/     OPC_EmitMergeInputChains, 1, 0, 
/*70597*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::ATOMAND16), 0|OPFL_Chain|OPFL_MemRefs,
                  1/*#VTs*/, MVT::i16, 6/*#Ops*/, 3, 4, 5, 6, 7, 2, 
              // Src: (atomic_load_and:i16 addr:iPTR:$ptr, GR16:i16:$val)<<P:Predicate_atomic_load_and_16>>
              // Dst: (ATOMAND16:i16 addr:iPTR:$ptr, GR16:i16:$val)
            /*SwitchType*/ 21,  MVT::i8,// ->70633
/*70612*/     OPC_CheckPredicate, 82, // Predicate_atomic_load_and_8
/*70614*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$ptr #3 #4 #5 #6 #7
/*70617*/     OPC_EmitMergeInputChains, 1, 0, 
/*70620*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::ATOMAND8), 0|OPFL_Chain|OPFL_MemRefs,
                  1/*#VTs*/, MVT::i8, 6/*#Ops*/, 3, 4, 5, 6, 7, 2, 
              // Src: (atomic_load_and:i8 addr:iPTR:$ptr, GR8:i8:$val)<<P:Predicate_atomic_load_and_8>>
              // Dst: (ATOMAND8:i8 addr:iPTR:$ptr, GR8:i8:$val)
            /*SwitchType*/ 21,  MVT::i64,// ->70656
/*70635*/     OPC_CheckPredicate, 83, // Predicate_atomic_load_and_64
/*70637*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$ptr #3 #4 #5 #6 #7
/*70640*/     OPC_EmitMergeInputChains, 1, 0, 
/*70643*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::ATOMAND64), 0|OPFL_Chain|OPFL_MemRefs,
                  1/*#VTs*/, MVT::i64, 6/*#Ops*/, 3, 4, 5, 6, 7, 2, 
              // Src: (atomic_load_and:i64 addr:iPTR:$ptr, GR64:i64:$val)<<P:Predicate_atomic_load_and_64>>
              // Dst: (ATOMAND64:i64 addr:iPTR:$ptr, GR64:i64:$val)
            0, // EndSwitchType
          /*SwitchOpcode*/ 98,  ISD::ATOMIC_LOAD_OR,// ->70757
/*70659*/   OPC_RecordMemRef,
/*70660*/   OPC_RecordNode,   // #0 = 'atomic_load_or' chained node
/*70661*/   OPC_RecordChild1, // #1 = $ptr
/*70662*/   OPC_RecordChild2, // #2 = $val
/*70663*/   OPC_SwitchType /*4 cases */, 21,  MVT::i32,// ->70687
/*70666*/     OPC_CheckPredicate, 84, // Predicate_atomic_load_or_32
/*70668*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$ptr #3 #4 #5 #6 #7
/*70671*/     OPC_EmitMergeInputChains, 1, 0, 
/*70674*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::ATOMOR32), 0|OPFL_Chain|OPFL_MemRefs,
                  1/*#VTs*/, MVT::i32, 6/*#Ops*/, 3, 4, 5, 6, 7, 2, 
              // Src: (atomic_load_or:i32 addr:iPTR:$ptr, GR32:i32:$val)<<P:Predicate_atomic_load_or_32>>
              // Dst: (ATOMOR32:i32 addr:iPTR:$ptr, GR32:i32:$val)
            /*SwitchType*/ 21,  MVT::i16,// ->70710
/*70689*/     OPC_CheckPredicate, 85, // Predicate_atomic_load_or_16
/*70691*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$ptr #3 #4 #5 #6 #7
/*70694*/     OPC_EmitMergeInputChains, 1, 0, 
/*70697*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::ATOMOR16), 0|OPFL_Chain|OPFL_MemRefs,
                  1/*#VTs*/, MVT::i16, 6/*#Ops*/, 3, 4, 5, 6, 7, 2, 
              // Src: (atomic_load_or:i16 addr:iPTR:$ptr, GR16:i16:$val)<<P:Predicate_atomic_load_or_16>>
              // Dst: (ATOMOR16:i16 addr:iPTR:$ptr, GR16:i16:$val)
            /*SwitchType*/ 21,  MVT::i8,// ->70733
/*70712*/     OPC_CheckPredicate, 86, // Predicate_atomic_load_or_8
/*70714*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$ptr #3 #4 #5 #6 #7
/*70717*/     OPC_EmitMergeInputChains, 1, 0, 
/*70720*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::ATOMOR8), 0|OPFL_Chain|OPFL_MemRefs,
                  1/*#VTs*/, MVT::i8, 6/*#Ops*/, 3, 4, 5, 6, 7, 2, 
              // Src: (atomic_load_or:i8 addr:iPTR:$ptr, GR8:i8:$val)<<P:Predicate_atomic_load_or_8>>
              // Dst: (ATOMOR8:i8 addr:iPTR:$ptr, GR8:i8:$val)
            /*SwitchType*/ 21,  MVT::i64,// ->70756
/*70735*/     OPC_CheckPredicate, 87, // Predicate_atomic_load_or_64
/*70737*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$ptr #3 #4 #5 #6 #7
/*70740*/     OPC_EmitMergeInputChains, 1, 0, 
/*70743*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::ATOMOR64), 0|OPFL_Chain|OPFL_MemRefs,
                  1/*#VTs*/, MVT::i64, 6/*#Ops*/, 3, 4, 5, 6, 7, 2, 
              // Src: (atomic_load_or:i64 addr:iPTR:$ptr, GR64:i64:$val)<<P:Predicate_atomic_load_or_64>>
              // Dst: (ATOMOR64:i64 addr:iPTR:$ptr, GR64:i64:$val)
            0, // EndSwitchType
          /*SwitchOpcode*/ 98,  ISD::ATOMIC_LOAD_XOR,// ->70857
/*70759*/   OPC_RecordMemRef,
/*70760*/   OPC_RecordNode,   // #0 = 'atomic_load_xor' chained node
/*70761*/   OPC_RecordChild1, // #1 = $ptr
/*70762*/   OPC_RecordChild2, // #2 = $val
/*70763*/   OPC_SwitchType /*4 cases */, 21,  MVT::i32,// ->70787
/*70766*/     OPC_CheckPredicate, 88, // Predicate_atomic_load_xor_32
/*70768*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$ptr #3 #4 #5 #6 #7
/*70771*/     OPC_EmitMergeInputChains, 1, 0, 
/*70774*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::ATOMXOR32), 0|OPFL_Chain|OPFL_MemRefs,
                  1/*#VTs*/, MVT::i32, 6/*#Ops*/, 3, 4, 5, 6, 7, 2, 
              // Src: (atomic_load_xor:i32 addr:iPTR:$ptr, GR32:i32:$val)<<P:Predicate_atomic_load_xor_32>>
              // Dst: (ATOMXOR32:i32 addr:iPTR:$ptr, GR32:i32:$val)
            /*SwitchType*/ 21,  MVT::i16,// ->70810
/*70789*/     OPC_CheckPredicate, 89, // Predicate_atomic_load_xor_16
/*70791*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$ptr #3 #4 #5 #6 #7
/*70794*/     OPC_EmitMergeInputChains, 1, 0, 
/*70797*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::ATOMXOR16), 0|OPFL_Chain|OPFL_MemRefs,
                  1/*#VTs*/, MVT::i16, 6/*#Ops*/, 3, 4, 5, 6, 7, 2, 
              // Src: (atomic_load_xor:i16 addr:iPTR:$ptr, GR16:i16:$val)<<P:Predicate_atomic_load_xor_16>>
              // Dst: (ATOMXOR16:i16 addr:iPTR:$ptr, GR16:i16:$val)
            /*SwitchType*/ 21,  MVT::i8,// ->70833
/*70812*/     OPC_CheckPredicate, 90, // Predicate_atomic_load_xor_8
/*70814*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$ptr #3 #4 #5 #6 #7
/*70817*/     OPC_EmitMergeInputChains, 1, 0, 
/*70820*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::ATOMXOR8), 0|OPFL_Chain|OPFL_MemRefs,
                  1/*#VTs*/, MVT::i8, 6/*#Ops*/, 3, 4, 5, 6, 7, 2, 
              // Src: (atomic_load_xor:i8 addr:iPTR:$ptr, GR8:i8:$val)<<P:Predicate_atomic_load_xor_8>>
              // Dst: (ATOMXOR8:i8 addr:iPTR:$ptr, GR8:i8:$val)
            /*SwitchType*/ 21,  MVT::i64,// ->70856
/*70835*/     OPC_CheckPredicate, 91, // Predicate_atomic_load_xor_64
/*70837*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$ptr #3 #4 #5 #6 #7
/*70840*/     OPC_EmitMergeInputChains, 1, 0, 
/*70843*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::ATOMXOR64), 0|OPFL_Chain|OPFL_MemRefs,
                  1/*#VTs*/, MVT::i64, 6/*#Ops*/, 3, 4, 5, 6, 7, 2, 
              // Src: (atomic_load_xor:i64 addr:iPTR:$ptr, GR64:i64:$val)<<P:Predicate_atomic_load_xor_64>>
              // Dst: (ATOMXOR64:i64 addr:iPTR:$ptr, GR64:i64:$val)
            0, // EndSwitchType
          /*SwitchOpcode*/ 98,  ISD::ATOMIC_LOAD_NAND,// ->70957
/*70859*/   OPC_RecordMemRef,
/*70860*/   OPC_RecordNode,   // #0 = 'atomic_load_nand' chained node
/*70861*/   OPC_RecordChild1, // #1 = $ptr
/*70862*/   OPC_RecordChild2, // #2 = $val
/*70863*/   OPC_SwitchType /*4 cases */, 21,  MVT::i32,// ->70887
/*70866*/     OPC_CheckPredicate, 92, // Predicate_atomic_load_nand_32
/*70868*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$ptr #3 #4 #5 #6 #7
/*70871*/     OPC_EmitMergeInputChains, 1, 0, 
/*70874*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::ATOMNAND32), 0|OPFL_Chain|OPFL_MemRefs,
                  1/*#VTs*/, MVT::i32, 6/*#Ops*/, 3, 4, 5, 6, 7, 2, 
              // Src: (atomic_load_nand:i32 addr:iPTR:$ptr, GR32:i32:$val)<<P:Predicate_atomic_load_nand_32>>
              // Dst: (ATOMNAND32:i32 addr:iPTR:$ptr, GR32:i32:$val)
            /*SwitchType*/ 21,  MVT::i16,// ->70910
/*70889*/     OPC_CheckPredicate, 93, // Predicate_atomic_load_nand_16
/*70891*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$ptr #3 #4 #5 #6 #7
/*70894*/     OPC_EmitMergeInputChains, 1, 0, 
/*70897*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::ATOMNAND16), 0|OPFL_Chain|OPFL_MemRefs,
                  1/*#VTs*/, MVT::i16, 6/*#Ops*/, 3, 4, 5, 6, 7, 2, 
              // Src: (atomic_load_nand:i16 addr:iPTR:$ptr, GR16:i16:$val)<<P:Predicate_atomic_load_nand_16>>
              // Dst: (ATOMNAND16:i16 addr:iPTR:$ptr, GR16:i16:$val)
            /*SwitchType*/ 21,  MVT::i8,// ->70933
/*70912*/     OPC_CheckPredicate, 94, // Predicate_atomic_load_nand_8
/*70914*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$ptr #3 #4 #5 #6 #7
/*70917*/     OPC_EmitMergeInputChains, 1, 0, 
/*70920*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::ATOMNAND8), 0|OPFL_Chain|OPFL_MemRefs,
                  1/*#VTs*/, MVT::i8, 6/*#Ops*/, 3, 4, 5, 6, 7, 2, 
              // Src: (atomic_load_nand:i8 addr:iPTR:$ptr, GR8:i8:$val)<<P:Predicate_atomic_load_nand_8>>
              // Dst: (ATOMNAND8:i8 addr:iPTR:$ptr, GR8:i8:$val)
            /*SwitchType*/ 21,  MVT::i64,// ->70956
/*70935*/     OPC_CheckPredicate, 95, // Predicate_atomic_load_nand_64
/*70937*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$ptr #3 #4 #5 #6 #7
/*70940*/     OPC_EmitMergeInputChains, 1, 0, 
/*70943*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::ATOMNAND64), 0|OPFL_Chain|OPFL_MemRefs,
                  1/*#VTs*/, MVT::i64, 6/*#Ops*/, 3, 4, 5, 6, 7, 2, 
              // Src: (atomic_load_nand:i64 addr:iPTR:$ptr, GR64:i64:$val)<<P:Predicate_atomic_load_nand_64>>
              // Dst: (ATOMNAND64:i64 addr:iPTR:$ptr, GR64:i64:$val)
            0, // EndSwitchType
          /*SwitchOpcode*/ 75,  ISD::ATOMIC_LOAD_MIN,// ->71034
/*70959*/   OPC_RecordMemRef,
/*70960*/   OPC_RecordNode,   // #0 = 'atomic_load_min' chained node
/*70961*/   OPC_RecordChild1, // #1 = $ptr
/*70962*/   OPC_RecordChild2, // #2 = $val
/*70963*/   OPC_SwitchType /*3 cases */, 21,  MVT::i32,// ->70987
/*70966*/     OPC_CheckPredicate, 96, // Predicate_atomic_load_min_32
/*70968*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$ptr #3 #4 #5 #6 #7
/*70971*/     OPC_EmitMergeInputChains, 1, 0, 
/*70974*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::ATOMMIN32), 0|OPFL_Chain|OPFL_MemRefs,
                  1/*#VTs*/, MVT::i32, 6/*#Ops*/, 3, 4, 5, 6, 7, 2, 
              // Src: (atomic_load_min:i32 addr:iPTR:$ptr, GR32:i32:$val)<<P:Predicate_atomic_load_min_32>>
              // Dst: (ATOMMIN32:i32 addr:iPTR:$ptr, GR32:i32:$val)
            /*SwitchType*/ 21,  MVT::i16,// ->71010
/*70989*/     OPC_CheckPredicate, 97, // Predicate_atomic_load_min_16
/*70991*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$ptr #3 #4 #5 #6 #7
/*70994*/     OPC_EmitMergeInputChains, 1, 0, 
/*70997*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::ATOMMIN16), 0|OPFL_Chain|OPFL_MemRefs,
                  1/*#VTs*/, MVT::i16, 6/*#Ops*/, 3, 4, 5, 6, 7, 2, 
              // Src: (atomic_load_min:i16 addr:iPTR:$ptr, GR16:i16:$val)<<P:Predicate_atomic_load_min_16>>
              // Dst: (ATOMMIN16:i16 addr:iPTR:$ptr, GR16:i16:$val)
            /*SwitchType*/ 21,  MVT::i64,// ->71033
/*71012*/     OPC_CheckPredicate, 98, // Predicate_atomic_load_min_64
/*71014*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$ptr #3 #4 #5 #6 #7
/*71017*/     OPC_EmitMergeInputChains, 1, 0, 
/*71020*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::ATOMMIN64), 0|OPFL_Chain|OPFL_MemRefs,
                  1/*#VTs*/, MVT::i64, 6/*#Ops*/, 3, 4, 5, 6, 7, 2, 
              // Src: (atomic_load_min:i64 addr:iPTR:$ptr, GR64:i64:$val)<<P:Predicate_atomic_load_min_64>>
              // Dst: (ATOMMIN64:i64 addr:iPTR:$ptr, GR64:i64:$val)
            0, // EndSwitchType
          /*SwitchOpcode*/ 75,  ISD::ATOMIC_LOAD_MAX,// ->71111
/*71036*/   OPC_RecordMemRef,
/*71037*/   OPC_RecordNode,   // #0 = 'atomic_load_max' chained node
/*71038*/   OPC_RecordChild1, // #1 = $ptr
/*71039*/   OPC_RecordChild2, // #2 = $val
/*71040*/   OPC_SwitchType /*3 cases */, 21,  MVT::i32,// ->71064
/*71043*/     OPC_CheckPredicate, 99, // Predicate_atomic_load_max_32
/*71045*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$ptr #3 #4 #5 #6 #7
/*71048*/     OPC_EmitMergeInputChains, 1, 0, 
/*71051*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::ATOMMAX32), 0|OPFL_Chain|OPFL_MemRefs,
                  1/*#VTs*/, MVT::i32, 6/*#Ops*/, 3, 4, 5, 6, 7, 2, 
              // Src: (atomic_load_max:i32 addr:iPTR:$ptr, GR32:i32:$val)<<P:Predicate_atomic_load_max_32>>
              // Dst: (ATOMMAX32:i32 addr:iPTR:$ptr, GR32:i32:$val)
            /*SwitchType*/ 21,  MVT::i16,// ->71087
/*71066*/     OPC_CheckPredicate, 100, // Predicate_atomic_load_max_16
/*71068*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$ptr #3 #4 #5 #6 #7
/*71071*/     OPC_EmitMergeInputChains, 1, 0, 
/*71074*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::ATOMMAX16), 0|OPFL_Chain|OPFL_MemRefs,
                  1/*#VTs*/, MVT::i16, 6/*#Ops*/, 3, 4, 5, 6, 7, 2, 
              // Src: (atomic_load_max:i16 addr:iPTR:$ptr, GR16:i16:$val)<<P:Predicate_atomic_load_max_16>>
              // Dst: (ATOMMAX16:i16 addr:iPTR:$ptr, GR16:i16:$val)
            /*SwitchType*/ 21,  MVT::i64,// ->71110
/*71089*/     OPC_CheckPredicate, 101, // Predicate_atomic_load_max_64
/*71091*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$ptr #3 #4 #5 #6 #7
/*71094*/     OPC_EmitMergeInputChains, 1, 0, 
/*71097*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::ATOMMAX64), 0|OPFL_Chain|OPFL_MemRefs,
                  1/*#VTs*/, MVT::i64, 6/*#Ops*/, 3, 4, 5, 6, 7, 2, 
              // Src: (atomic_load_max:i64 addr:iPTR:$ptr, GR64:i64:$val)<<P:Predicate_atomic_load_max_64>>
              // Dst: (ATOMMAX64:i64 addr:iPTR:$ptr, GR64:i64:$val)
            0, // EndSwitchType
          /*SwitchOpcode*/ 75,  ISD::ATOMIC_LOAD_UMIN,// ->71188
/*71113*/   OPC_RecordMemRef,
/*71114*/   OPC_RecordNode,   // #0 = 'atomic_load_umin' chained node
/*71115*/   OPC_RecordChild1, // #1 = $ptr
/*71116*/   OPC_RecordChild2, // #2 = $val
/*71117*/   OPC_SwitchType /*3 cases */, 21,  MVT::i32,// ->71141
/*71120*/     OPC_CheckPredicate, 102, // Predicate_atomic_load_umin_32
/*71122*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$ptr #3 #4 #5 #6 #7
/*71125*/     OPC_EmitMergeInputChains, 1, 0, 
/*71128*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::ATOMUMIN32), 0|OPFL_Chain|OPFL_MemRefs,
                  1/*#VTs*/, MVT::i32, 6/*#Ops*/, 3, 4, 5, 6, 7, 2, 
              // Src: (atomic_load_umin:i32 addr:iPTR:$ptr, GR32:i32:$val)<<P:Predicate_atomic_load_umin_32>>
              // Dst: (ATOMUMIN32:i32 addr:iPTR:$ptr, GR32:i32:$val)
            /*SwitchType*/ 21,  MVT::i16,// ->71164
/*71143*/     OPC_CheckPredicate, 103, // Predicate_atomic_load_umin_16
/*71145*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$ptr #3 #4 #5 #6 #7
/*71148*/     OPC_EmitMergeInputChains, 1, 0, 
/*71151*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::ATOMUMIN16), 0|OPFL_Chain|OPFL_MemRefs,
                  1/*#VTs*/, MVT::i16, 6/*#Ops*/, 3, 4, 5, 6, 7, 2, 
              // Src: (atomic_load_umin:i16 addr:iPTR:$ptr, GR16:i16:$val)<<P:Predicate_atomic_load_umin_16>>
              // Dst: (ATOMUMIN16:i16 addr:iPTR:$ptr, GR16:i16:$val)
            /*SwitchType*/ 21,  MVT::i64,// ->71187
/*71166*/     OPC_CheckPredicate, 104, // Predicate_atomic_load_umin_64
/*71168*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$ptr #3 #4 #5 #6 #7
/*71171*/     OPC_EmitMergeInputChains, 1, 0, 
/*71174*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::ATOMUMIN64), 0|OPFL_Chain|OPFL_MemRefs,
                  1/*#VTs*/, MVT::i64, 6/*#Ops*/, 3, 4, 5, 6, 7, 2, 
              // Src: (atomic_load_umin:i64 addr:iPTR:$ptr, GR64:i64:$val)<<P:Predicate_atomic_load_umin_64>>
              // Dst: (ATOMUMIN64:i64 addr:iPTR:$ptr, GR64:i64:$val)
            0, // EndSwitchType
          /*SwitchOpcode*/ 75,  ISD::ATOMIC_LOAD_UMAX,// ->71265
/*71190*/   OPC_RecordMemRef,
/*71191*/   OPC_RecordNode,   // #0 = 'atomic_load_umax' chained node
/*71192*/   OPC_RecordChild1, // #1 = $ptr
/*71193*/   OPC_RecordChild2, // #2 = $val
/*71194*/   OPC_SwitchType /*3 cases */, 21,  MVT::i32,// ->71218
/*71197*/     OPC_CheckPredicate, 105, // Predicate_atomic_load_umax_32
/*71199*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$ptr #3 #4 #5 #6 #7
/*71202*/     OPC_EmitMergeInputChains, 1, 0, 
/*71205*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::ATOMUMAX32), 0|OPFL_Chain|OPFL_MemRefs,
                  1/*#VTs*/, MVT::i32, 6/*#Ops*/, 3, 4, 5, 6, 7, 2, 
              // Src: (atomic_load_umax:i32 addr:iPTR:$ptr, GR32:i32:$val)<<P:Predicate_atomic_load_umax_32>>
              // Dst: (ATOMUMAX32:i32 addr:iPTR:$ptr, GR32:i32:$val)
            /*SwitchType*/ 21,  MVT::i16,// ->71241
/*71220*/     OPC_CheckPredicate, 106, // Predicate_atomic_load_umax_16
/*71222*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$ptr #3 #4 #5 #6 #7
/*71225*/     OPC_EmitMergeInputChains, 1, 0, 
/*71228*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::ATOMUMAX16), 0|OPFL_Chain|OPFL_MemRefs,
                  1/*#VTs*/, MVT::i16, 6/*#Ops*/, 3, 4, 5, 6, 7, 2, 
              // Src: (atomic_load_umax:i16 addr:iPTR:$ptr, GR16:i16:$val)<<P:Predicate_atomic_load_umax_16>>
              // Dst: (ATOMUMAX16:i16 addr:iPTR:$ptr, GR16:i16:$val)
            /*SwitchType*/ 21,  MVT::i64,// ->71264
/*71243*/     OPC_CheckPredicate, 107, // Predicate_atomic_load_umax_64
/*71245*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$ptr #3 #4 #5 #6 #7
/*71248*/     OPC_EmitMergeInputChains, 1, 0, 
/*71251*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::ATOMUMAX64), 0|OPFL_Chain|OPFL_MemRefs,
                  1/*#VTs*/, MVT::i64, 6/*#Ops*/, 3, 4, 5, 6, 7, 2, 
              // Src: (atomic_load_umax:i64 addr:iPTR:$ptr, GR64:i64:$val)<<P:Predicate_atomic_load_umax_64>>
              // Dst: (ATOMUMAX64:i64 addr:iPTR:$ptr, GR64:i64:$val)
            0, // EndSwitchType
          /*SwitchOpcode*/ 88|128,1/*216*/,  X86ISD::FILD,// ->71484
/*71268*/   OPC_RecordNode,   // #0 = 'X86fild' chained node
/*71269*/   OPC_RecordChild1, // #1 = $src
/*71270*/   OPC_MoveChild, 2,
/*71272*/   OPC_Scope, 69, /*->71343*/ // 3 children in Scope
/*71274*/     OPC_CheckValueType, MVT::i16,
/*71276*/     OPC_MoveParent,
/*71277*/     OPC_SwitchType /*3 cases */, 20,  MVT::f32,// ->71300
/*71280*/       OPC_CheckPatternPredicate, 6, // (!Subtarget->hasSSE1())
/*71282*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*71285*/       OPC_EmitMergeInputChains, 1, 0, 
/*71288*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::ILD_Fp16m32), 0|OPFL_Chain,
                    1/*#VTs*/, MVT::f32, 5/*#Ops*/, 2, 3, 4, 5, 6, 
                // Src: (X86fild:f32 addr:iPTR:$src, i16:Other)
                // Dst: (ILD_Fp16m32:f32 addr:iPTR:$src)
              /*SwitchType*/ 20,  MVT::f64,// ->71322
/*71302*/       OPC_CheckPatternPredicate, 7, // (!Subtarget->hasSSE2())
/*71304*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*71307*/       OPC_EmitMergeInputChains, 1, 0, 
/*71310*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::ILD_Fp16m64), 0|OPFL_Chain,
                    1/*#VTs*/, MVT::f64, 5/*#Ops*/, 2, 3, 4, 5, 6, 
                // Src: (X86fild:f64 addr:iPTR:$src, i16:Other)
                // Dst: (ILD_Fp16m64:f64 addr:iPTR:$src)
              /*SwitchType*/ 18,  MVT::f80,// ->71342
/*71324*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*71327*/       OPC_EmitMergeInputChains, 1, 0, 
/*71330*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::ILD_Fp16m80), 0|OPFL_Chain,
                    1/*#VTs*/, MVT::f80, 5/*#Ops*/, 2, 3, 4, 5, 6, 
                // Src: (X86fild:f80 addr:iPTR:$src, i16:Other)
                // Dst: (ILD_Fp16m80:f80 addr:iPTR:$src)
              0, // EndSwitchType
/*71343*/   /*Scope*/ 69, /*->71413*/
/*71344*/     OPC_CheckValueType, MVT::i32,
/*71346*/     OPC_MoveParent,
/*71347*/     OPC_SwitchType /*3 cases */, 20,  MVT::f32,// ->71370
/*71350*/       OPC_CheckPatternPredicate, 6, // (!Subtarget->hasSSE1())
/*71352*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*71355*/       OPC_EmitMergeInputChains, 1, 0, 
/*71358*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::ILD_Fp32m32), 0|OPFL_Chain,
                    1/*#VTs*/, MVT::f32, 5/*#Ops*/, 2, 3, 4, 5, 6, 
                // Src: (X86fild:f32 addr:iPTR:$src, i32:Other)
                // Dst: (ILD_Fp32m32:f32 addr:iPTR:$src)
              /*SwitchType*/ 20,  MVT::f64,// ->71392
/*71372*/       OPC_CheckPatternPredicate, 7, // (!Subtarget->hasSSE2())
/*71374*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*71377*/       OPC_EmitMergeInputChains, 1, 0, 
/*71380*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::ILD_Fp32m64), 0|OPFL_Chain,
                    1/*#VTs*/, MVT::f64, 5/*#Ops*/, 2, 3, 4, 5, 6, 
                // Src: (X86fild:f64 addr:iPTR:$src, i32:Other)
                // Dst: (ILD_Fp32m64:f64 addr:iPTR:$src)
              /*SwitchType*/ 18,  MVT::f80,// ->71412
/*71394*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*71397*/       OPC_EmitMergeInputChains, 1, 0, 
/*71400*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::ILD_Fp32m80), 0|OPFL_Chain,
                    1/*#VTs*/, MVT::f80, 5/*#Ops*/, 2, 3, 4, 5, 6, 
                // Src: (X86fild:f80 addr:iPTR:$src, i32:Other)
                // Dst: (ILD_Fp32m80:f80 addr:iPTR:$src)
              0, // EndSwitchType
/*71413*/   /*Scope*/ 69, /*->71483*/
/*71414*/     OPC_CheckValueType, MVT::i64,
/*71416*/     OPC_MoveParent,
/*71417*/     OPC_SwitchType /*3 cases */, 20,  MVT::f32,// ->71440
/*71420*/       OPC_CheckPatternPredicate, 6, // (!Subtarget->hasSSE1())
/*71422*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*71425*/       OPC_EmitMergeInputChains, 1, 0, 
/*71428*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::ILD_Fp64m32), 0|OPFL_Chain,
                    1/*#VTs*/, MVT::f32, 5/*#Ops*/, 2, 3, 4, 5, 6, 
                // Src: (X86fild:f32 addr:iPTR:$src, i64:Other)
                // Dst: (ILD_Fp64m32:f32 addr:iPTR:$src)
              /*SwitchType*/ 20,  MVT::f64,// ->71462
/*71442*/       OPC_CheckPatternPredicate, 7, // (!Subtarget->hasSSE2())
/*71444*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*71447*/       OPC_EmitMergeInputChains, 1, 0, 
/*71450*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::ILD_Fp64m64), 0|OPFL_Chain,
                    1/*#VTs*/, MVT::f64, 5/*#Ops*/, 2, 3, 4, 5, 6, 
                // Src: (X86fild:f64 addr:iPTR:$src, i64:Other)
                // Dst: (ILD_Fp64m64:f64 addr:iPTR:$src)
              /*SwitchType*/ 18,  MVT::f80,// ->71482
/*71464*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*71467*/       OPC_EmitMergeInputChains, 1, 0, 
/*71470*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::ILD_Fp64m80), 0|OPFL_Chain,
                    1/*#VTs*/, MVT::f80, 5/*#Ops*/, 2, 3, 4, 5, 6, 
                // Src: (X86fild:f80 addr:iPTR:$src, i64:Other)
                // Dst: (ILD_Fp64m80:f80 addr:iPTR:$src)
              0, // EndSwitchType
/*71483*/   0, /*End of Scope*/
          /*SwitchOpcode*/ 14|128,1/*142*/,  X86ISD::FP_TO_INT16_IN_MEM,// ->71629
/*71487*/   OPC_RecordNode,   // #0 = 'X86fp_to_i16mem' chained node
/*71488*/   OPC_RecordChild1, // #1 = $src
/*71489*/   OPC_Scope, 45, /*->71536*/ // 3 children in Scope
/*71491*/     OPC_CheckChild1Type, MVT::f32,
/*71493*/     OPC_RecordChild2, // #2 = $op
/*71494*/     OPC_Scope, 20, /*->71516*/ // 2 children in Scope
/*71496*/       OPC_CheckPatternPredicate, 9, // (Subtarget->hasSSE3())
/*71498*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$op #3 #4 #5 #6 #7
/*71501*/       OPC_EmitMergeInputChains, 1, 0, 
/*71504*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::ISTT_Fp16m32), 0|OPFL_Chain,
                    0/*#VTs*/, 6/*#Ops*/, 3, 4, 5, 6, 7, 1, 
                // Src: (X86fp_to_i16mem:isVoid RFP32:f32:$src, addr:iPTR:$op)
                // Dst: (ISTT_Fp16m32:isVoid addr:iPTR:$op, RFP32:f32:$src)
/*71516*/     /*Scope*/ 18, /*->71535*/
/*71517*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #3 #4 #5 #6 #7
/*71520*/       OPC_EmitMergeInputChains, 1, 0, 
/*71523*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::FP32_TO_INT16_IN_MEM), 0|OPFL_Chain,
                    0/*#VTs*/, 6/*#Ops*/, 3, 4, 5, 6, 7, 1, 
                // Src: (X86fp_to_i16mem:isVoid RFP32:f32:$src, addr:iPTR:$dst)
                // Dst: (FP32_TO_INT16_IN_MEM:isVoid addr:iPTR:$dst, RFP32:f32:$src)
/*71535*/     0, /*End of Scope*/
/*71536*/   /*Scope*/ 45, /*->71582*/
/*71537*/     OPC_CheckChild1Type, MVT::f64,
/*71539*/     OPC_RecordChild2, // #2 = $op
/*71540*/     OPC_Scope, 20, /*->71562*/ // 2 children in Scope
/*71542*/       OPC_CheckPatternPredicate, 9, // (Subtarget->hasSSE3())
/*71544*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$op #3 #4 #5 #6 #7
/*71547*/       OPC_EmitMergeInputChains, 1, 0, 
/*71550*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::ISTT_Fp16m64), 0|OPFL_Chain,
                    0/*#VTs*/, 6/*#Ops*/, 3, 4, 5, 6, 7, 1, 
                // Src: (X86fp_to_i16mem:isVoid RFP64:f64:$src, addr:iPTR:$op)
                // Dst: (ISTT_Fp16m64:isVoid addr:iPTR:$op, RFP64:f64:$src)
/*71562*/     /*Scope*/ 18, /*->71581*/
/*71563*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #3 #4 #5 #6 #7
/*71566*/       OPC_EmitMergeInputChains, 1, 0, 
/*71569*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::FP64_TO_INT16_IN_MEM), 0|OPFL_Chain,
                    0/*#VTs*/, 6/*#Ops*/, 3, 4, 5, 6, 7, 1, 
                // Src: (X86fp_to_i16mem:isVoid RFP64:f64:$src, addr:iPTR:$dst)
                // Dst: (FP64_TO_INT16_IN_MEM:isVoid addr:iPTR:$dst, RFP64:f64:$src)
/*71581*/     0, /*End of Scope*/
/*71582*/   /*Scope*/ 45, /*->71628*/
/*71583*/     OPC_CheckChild1Type, MVT::f80,
/*71585*/     OPC_RecordChild2, // #2 = $op
/*71586*/     OPC_Scope, 20, /*->71608*/ // 2 children in Scope
/*71588*/       OPC_CheckPatternPredicate, 9, // (Subtarget->hasSSE3())
/*71590*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$op #3 #4 #5 #6 #7
/*71593*/       OPC_EmitMergeInputChains, 1, 0, 
/*71596*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::ISTT_Fp16m80), 0|OPFL_Chain,
                    0/*#VTs*/, 6/*#Ops*/, 3, 4, 5, 6, 7, 1, 
                // Src: (X86fp_to_i16mem:isVoid RFP80:f80:$src, addr:iPTR:$op)
                // Dst: (ISTT_Fp16m80:isVoid addr:iPTR:$op, RFP80:f80:$src)
/*71608*/     /*Scope*/ 18, /*->71627*/
/*71609*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #3 #4 #5 #6 #7
/*71612*/       OPC_EmitMergeInputChains, 1, 0, 
/*71615*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::FP80_TO_INT16_IN_MEM), 0|OPFL_Chain,
                    0/*#VTs*/, 6/*#Ops*/, 3, 4, 5, 6, 7, 1, 
                // Src: (X86fp_to_i16mem:isVoid RFP80:f80:$src, addr:iPTR:$dst)
                // Dst: (FP80_TO_INT16_IN_MEM:isVoid addr:iPTR:$dst, RFP80:f80:$src)
/*71627*/     0, /*End of Scope*/
/*71628*/   0, /*End of Scope*/
          /*SwitchOpcode*/ 14|128,1/*142*/,  X86ISD::FP_TO_INT32_IN_MEM,// ->71774
/*71632*/   OPC_RecordNode,   // #0 = 'X86fp_to_i32mem' chained node
/*71633*/   OPC_RecordChild1, // #1 = $src
/*71634*/   OPC_Scope, 45, /*->71681*/ // 3 children in Scope
/*71636*/     OPC_CheckChild1Type, MVT::f32,
/*71638*/     OPC_RecordChild2, // #2 = $op
/*71639*/     OPC_Scope, 20, /*->71661*/ // 2 children in Scope
/*71641*/       OPC_CheckPatternPredicate, 9, // (Subtarget->hasSSE3())
/*71643*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$op #3 #4 #5 #6 #7
/*71646*/       OPC_EmitMergeInputChains, 1, 0, 
/*71649*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::ISTT_Fp32m32), 0|OPFL_Chain,
                    0/*#VTs*/, 6/*#Ops*/, 3, 4, 5, 6, 7, 1, 
                // Src: (X86fp_to_i32mem:isVoid RFP32:f32:$src, addr:iPTR:$op)
                // Dst: (ISTT_Fp32m32:isVoid addr:iPTR:$op, RFP32:f32:$src)
/*71661*/     /*Scope*/ 18, /*->71680*/
/*71662*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #3 #4 #5 #6 #7
/*71665*/       OPC_EmitMergeInputChains, 1, 0, 
/*71668*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::FP32_TO_INT32_IN_MEM), 0|OPFL_Chain,
                    0/*#VTs*/, 6/*#Ops*/, 3, 4, 5, 6, 7, 1, 
                // Src: (X86fp_to_i32mem:isVoid RFP32:f32:$src, addr:iPTR:$dst)
                // Dst: (FP32_TO_INT32_IN_MEM:isVoid addr:iPTR:$dst, RFP32:f32:$src)
/*71680*/     0, /*End of Scope*/
/*71681*/   /*Scope*/ 45, /*->71727*/
/*71682*/     OPC_CheckChild1Type, MVT::f64,
/*71684*/     OPC_RecordChild2, // #2 = $op
/*71685*/     OPC_Scope, 20, /*->71707*/ // 2 children in Scope
/*71687*/       OPC_CheckPatternPredicate, 9, // (Subtarget->hasSSE3())
/*71689*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$op #3 #4 #5 #6 #7
/*71692*/       OPC_EmitMergeInputChains, 1, 0, 
/*71695*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::ISTT_Fp32m64), 0|OPFL_Chain,
                    0/*#VTs*/, 6/*#Ops*/, 3, 4, 5, 6, 7, 1, 
                // Src: (X86fp_to_i32mem:isVoid RFP64:f64:$src, addr:iPTR:$op)
                // Dst: (ISTT_Fp32m64:isVoid addr:iPTR:$op, RFP64:f64:$src)
/*71707*/     /*Scope*/ 18, /*->71726*/
/*71708*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #3 #4 #5 #6 #7
/*71711*/       OPC_EmitMergeInputChains, 1, 0, 
/*71714*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::FP64_TO_INT32_IN_MEM), 0|OPFL_Chain,
                    0/*#VTs*/, 6/*#Ops*/, 3, 4, 5, 6, 7, 1, 
                // Src: (X86fp_to_i32mem:isVoid RFP64:f64:$src, addr:iPTR:$dst)
                // Dst: (FP64_TO_INT32_IN_MEM:isVoid addr:iPTR:$dst, RFP64:f64:$src)
/*71726*/     0, /*End of Scope*/
/*71727*/   /*Scope*/ 45, /*->71773*/
/*71728*/     OPC_CheckChild1Type, MVT::f80,
/*71730*/     OPC_RecordChild2, // #2 = $op
/*71731*/     OPC_Scope, 20, /*->71753*/ // 2 children in Scope
/*71733*/       OPC_CheckPatternPredicate, 9, // (Subtarget->hasSSE3())
/*71735*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$op #3 #4 #5 #6 #7
/*71738*/       OPC_EmitMergeInputChains, 1, 0, 
/*71741*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::ISTT_Fp32m80), 0|OPFL_Chain,
                    0/*#VTs*/, 6/*#Ops*/, 3, 4, 5, 6, 7, 1, 
                // Src: (X86fp_to_i32mem:isVoid RFP80:f80:$src, addr:iPTR:$op)
                // Dst: (ISTT_Fp32m80:isVoid addr:iPTR:$op, RFP80:f80:$src)
/*71753*/     /*Scope*/ 18, /*->71772*/
/*71754*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #3 #4 #5 #6 #7
/*71757*/       OPC_EmitMergeInputChains, 1, 0, 
/*71760*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::FP80_TO_INT32_IN_MEM), 0|OPFL_Chain,
                    0/*#VTs*/, 6/*#Ops*/, 3, 4, 5, 6, 7, 1, 
                // Src: (X86fp_to_i32mem:isVoid RFP80:f80:$src, addr:iPTR:$dst)
                // Dst: (FP80_TO_INT32_IN_MEM:isVoid addr:iPTR:$dst, RFP80:f80:$src)
/*71772*/     0, /*End of Scope*/
/*71773*/   0, /*End of Scope*/
          /*SwitchOpcode*/ 14|128,1/*142*/,  X86ISD::FP_TO_INT64_IN_MEM,// ->71919
/*71777*/   OPC_RecordNode,   // #0 = 'X86fp_to_i64mem' chained node
/*71778*/   OPC_RecordChild1, // #1 = $src
/*71779*/   OPC_Scope, 45, /*->71826*/ // 3 children in Scope
/*71781*/     OPC_CheckChild1Type, MVT::f32,
/*71783*/     OPC_RecordChild2, // #2 = $op
/*71784*/     OPC_Scope, 20, /*->71806*/ // 2 children in Scope
/*71786*/       OPC_CheckPatternPredicate, 9, // (Subtarget->hasSSE3())
/*71788*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$op #3 #4 #5 #6 #7
/*71791*/       OPC_EmitMergeInputChains, 1, 0, 
/*71794*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::ISTT_Fp64m32), 0|OPFL_Chain,
                    0/*#VTs*/, 6/*#Ops*/, 3, 4, 5, 6, 7, 1, 
                // Src: (X86fp_to_i64mem:isVoid RFP32:f32:$src, addr:iPTR:$op)
                // Dst: (ISTT_Fp64m32:isVoid addr:iPTR:$op, RFP32:f32:$src)
/*71806*/     /*Scope*/ 18, /*->71825*/
/*71807*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #3 #4 #5 #6 #7
/*71810*/       OPC_EmitMergeInputChains, 1, 0, 
/*71813*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::FP32_TO_INT64_IN_MEM), 0|OPFL_Chain,
                    0/*#VTs*/, 6/*#Ops*/, 3, 4, 5, 6, 7, 1, 
                // Src: (X86fp_to_i64mem:isVoid RFP32:f32:$src, addr:iPTR:$dst)
                // Dst: (FP32_TO_INT64_IN_MEM:isVoid addr:iPTR:$dst, RFP32:f32:$src)
/*71825*/     0, /*End of Scope*/
/*71826*/   /*Scope*/ 45, /*->71872*/
/*71827*/     OPC_CheckChild1Type, MVT::f64,
/*71829*/     OPC_RecordChild2, // #2 = $op
/*71830*/     OPC_Scope, 20, /*->71852*/ // 2 children in Scope
/*71832*/       OPC_CheckPatternPredicate, 9, // (Subtarget->hasSSE3())
/*71834*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$op #3 #4 #5 #6 #7
/*71837*/       OPC_EmitMergeInputChains, 1, 0, 
/*71840*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::ISTT_Fp64m64), 0|OPFL_Chain,
                    0/*#VTs*/, 6/*#Ops*/, 3, 4, 5, 6, 7, 1, 
                // Src: (X86fp_to_i64mem:isVoid RFP64:f64:$src, addr:iPTR:$op)
                // Dst: (ISTT_Fp64m64:isVoid addr:iPTR:$op, RFP64:f64:$src)
/*71852*/     /*Scope*/ 18, /*->71871*/
/*71853*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #3 #4 #5 #6 #7
/*71856*/       OPC_EmitMergeInputChains, 1, 0, 
/*71859*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::FP64_TO_INT64_IN_MEM), 0|OPFL_Chain,
                    0/*#VTs*/, 6/*#Ops*/, 3, 4, 5, 6, 7, 1, 
                // Src: (X86fp_to_i64mem:isVoid RFP64:f64:$src, addr:iPTR:$dst)
                // Dst: (FP64_TO_INT64_IN_MEM:isVoid addr:iPTR:$dst, RFP64:f64:$src)
/*71871*/     0, /*End of Scope*/
/*71872*/   /*Scope*/ 45, /*->71918*/
/*71873*/     OPC_CheckChild1Type, MVT::f80,
/*71875*/     OPC_RecordChild2, // #2 = $op
/*71876*/     OPC_Scope, 20, /*->71898*/ // 2 children in Scope
/*71878*/       OPC_CheckPatternPredicate, 9, // (Subtarget->hasSSE3())
/*71880*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$op #3 #4 #5 #6 #7
/*71883*/       OPC_EmitMergeInputChains, 1, 0, 
/*71886*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::ISTT_Fp64m80), 0|OPFL_Chain,
                    0/*#VTs*/, 6/*#Ops*/, 3, 4, 5, 6, 7, 1, 
                // Src: (X86fp_to_i64mem:isVoid RFP80:f80:$src, addr:iPTR:$op)
                // Dst: (ISTT_Fp64m80:isVoid addr:iPTR:$op, RFP80:f80:$src)
/*71898*/     /*Scope*/ 18, /*->71917*/
/*71899*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$dst #3 #4 #5 #6 #7
/*71902*/       OPC_EmitMergeInputChains, 1, 0, 
/*71905*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::FP80_TO_INT64_IN_MEM), 0|OPFL_Chain,
                    0/*#VTs*/, 6/*#Ops*/, 3, 4, 5, 6, 7, 1, 
                // Src: (X86fp_to_i64mem:isVoid RFP80:f80:$src, addr:iPTR:$dst)
                // Dst: (FP80_TO_INT64_IN_MEM:isVoid addr:iPTR:$dst, RFP80:f80:$src)
/*71917*/     0, /*End of Scope*/
/*71918*/   0, /*End of Scope*/
          /*SwitchOpcode*/ 78,  X86ISD::FLD,// ->71999
/*71921*/   OPC_RecordNode,   // #0 = 'X86fld' chained node
/*71922*/   OPC_RecordChild1, // #1 = $src
/*71923*/   OPC_MoveChild, 2,
/*71925*/   OPC_Scope, 23, /*->71950*/ // 3 children in Scope
/*71927*/     OPC_CheckValueType, MVT::f32,
/*71929*/     OPC_MoveParent,
/*71930*/     OPC_CheckType, MVT::f32,
/*71932*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*71935*/     OPC_EmitMergeInputChains, 1, 0, 
/*71938*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::LD_Fp32m), 0|OPFL_Chain,
                  1/*#VTs*/, MVT::f32, 5/*#Ops*/, 2, 3, 4, 5, 6, 
              // Src: (X86fld:f32 addr:iPTR:$src, f32:Other)
              // Dst: (LD_Fp32m:f32 addr:iPTR:$src)
/*71950*/   /*Scope*/ 23, /*->71974*/
/*71951*/     OPC_CheckValueType, MVT::f64,
/*71953*/     OPC_MoveParent,
/*71954*/     OPC_CheckType, MVT::f64,
/*71956*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*71959*/     OPC_EmitMergeInputChains, 1, 0, 
/*71962*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::LD_Fp64m), 0|OPFL_Chain,
                  1/*#VTs*/, MVT::f64, 5/*#Ops*/, 2, 3, 4, 5, 6, 
              // Src: (X86fld:f64 addr:iPTR:$src, f64:Other)
              // Dst: (LD_Fp64m:f64 addr:iPTR:$src)
/*71974*/   /*Scope*/ 23, /*->71998*/
/*71975*/     OPC_CheckValueType, MVT::f80,
/*71977*/     OPC_MoveParent,
/*71978*/     OPC_CheckType, MVT::f80,
/*71980*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*71983*/     OPC_EmitMergeInputChains, 1, 0, 
/*71986*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::LD_Fp80m), 0|OPFL_Chain,
                  1/*#VTs*/, MVT::f80, 5/*#Ops*/, 2, 3, 4, 5, 6, 
              // Src: (X86fld:f80 addr:iPTR:$src, f80:Other)
              // Dst: (LD_Fp80m:f80 addr:iPTR:$src)
/*71998*/   0, /*End of Scope*/
          /*SwitchOpcode*/ 30|128,1/*158*/,  X86ISD::FST,// ->72160
/*72002*/   OPC_RecordNode,   // #0 = 'X86fst' chained node
/*72003*/   OPC_CaptureFlagInput,
/*72004*/   OPC_RecordChild1, // #1 = $src
/*72005*/   OPC_Scope, 26, /*->72033*/ // 3 children in Scope
/*72007*/     OPC_CheckChild1Type, MVT::f32,
/*72009*/     OPC_RecordChild2, // #2 = $op
/*72010*/     OPC_MoveChild, 3,
/*72012*/     OPC_CheckValueType, MVT::f32,
/*72014*/     OPC_MoveParent,
/*72015*/     OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$op #3 #4 #5 #6 #7
/*72018*/     OPC_EmitMergeInputChains, 1, 0, 
/*72021*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::ST_Fp32m), 0|OPFL_Chain|OPFL_FlagInput,
                  0/*#VTs*/, 6/*#Ops*/, 3, 4, 5, 6, 7, 1, 
              // Src: (X86fst:isVoid RFP32:f32:$src, addr:iPTR:$op, f32:Other)
              // Dst: (ST_Fp32m:isVoid addr:iPTR:$op, RFP32:f32:$src)
/*72033*/   /*Scope*/ 51, /*->72085*/
/*72034*/     OPC_CheckChild1Type, MVT::f64,
/*72036*/     OPC_RecordChild2, // #2 = $op
/*72037*/     OPC_MoveChild, 3,
/*72039*/     OPC_Scope, 21, /*->72062*/ // 2 children in Scope
/*72041*/       OPC_CheckValueType, MVT::f32,
/*72043*/       OPC_MoveParent,
/*72044*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$op #3 #4 #5 #6 #7
/*72047*/       OPC_EmitMergeInputChains, 1, 0, 
/*72050*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::ST_Fp64m32), 0|OPFL_Chain|OPFL_FlagInput,
                    0/*#VTs*/, 6/*#Ops*/, 3, 4, 5, 6, 7, 1, 
                // Src: (X86fst:isVoid RFP64:f64:$src, addr:iPTR:$op, f32:Other)
                // Dst: (ST_Fp64m32:isVoid addr:iPTR:$op, RFP64:f64:$src)
/*72062*/     /*Scope*/ 21, /*->72084*/
/*72063*/       OPC_CheckValueType, MVT::f64,
/*72065*/       OPC_MoveParent,
/*72066*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$op #3 #4 #5 #6 #7
/*72069*/       OPC_EmitMergeInputChains, 1, 0, 
/*72072*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::ST_Fp64m), 0|OPFL_Chain|OPFL_FlagInput,
                    0/*#VTs*/, 6/*#Ops*/, 3, 4, 5, 6, 7, 1, 
                // Src: (X86fst:isVoid RFP64:f64:$src, addr:iPTR:$op, f64:Other)
                // Dst: (ST_Fp64m:isVoid addr:iPTR:$op, RFP64:f64:$src)
/*72084*/     0, /*End of Scope*/
/*72085*/   /*Scope*/ 73, /*->72159*/
/*72086*/     OPC_CheckChild1Type, MVT::f80,
/*72088*/     OPC_RecordChild2, // #2 = $op
/*72089*/     OPC_MoveChild, 3,
/*72091*/     OPC_Scope, 21, /*->72114*/ // 3 children in Scope
/*72093*/       OPC_CheckValueType, MVT::f32,
/*72095*/       OPC_MoveParent,
/*72096*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$op #3 #4 #5 #6 #7
/*72099*/       OPC_EmitMergeInputChains, 1, 0, 
/*72102*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::ST_Fp80m32), 0|OPFL_Chain|OPFL_FlagInput,
                    0/*#VTs*/, 6/*#Ops*/, 3, 4, 5, 6, 7, 1, 
                // Src: (X86fst:isVoid RFP80:f80:$src, addr:iPTR:$op, f32:Other)
                // Dst: (ST_Fp80m32:isVoid addr:iPTR:$op, RFP80:f80:$src)
/*72114*/     /*Scope*/ 21, /*->72136*/
/*72115*/       OPC_CheckValueType, MVT::f64,
/*72117*/       OPC_MoveParent,
/*72118*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$op #3 #4 #5 #6 #7
/*72121*/       OPC_EmitMergeInputChains, 1, 0, 
/*72124*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::ST_Fp80m64), 0|OPFL_Chain|OPFL_FlagInput,
                    0/*#VTs*/, 6/*#Ops*/, 3, 4, 5, 6, 7, 1, 
                // Src: (X86fst:isVoid RFP80:f80:$src, addr:iPTR:$op, f64:Other)
                // Dst: (ST_Fp80m64:isVoid addr:iPTR:$op, RFP80:f80:$src)
/*72136*/     /*Scope*/ 21, /*->72158*/
/*72137*/       OPC_CheckValueType, MVT::f80,
/*72139*/       OPC_MoveParent,
/*72140*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddr:$op #3 #4 #5 #6 #7
/*72143*/       OPC_EmitMergeInputChains, 1, 0, 
/*72146*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::ST_FpP80m), 0|OPFL_Chain|OPFL_FlagInput,
                    0/*#VTs*/, 6/*#Ops*/, 3, 4, 5, 6, 7, 1, 
                // Src: (X86fst:isVoid RFP80:f80:$src, addr:iPTR:$op, f80:Other)
                // Dst: (ST_FpP80m:isVoid addr:iPTR:$op, RFP80:f80:$src)
/*72158*/     0, /*End of Scope*/
/*72159*/   0, /*End of Scope*/
          /*SwitchOpcode*/ 27,  X86ISD::FILD_FLAG,// ->72189
/*72162*/   OPC_RecordNode,   // #0 = 'X86fildflag' chained node
/*72163*/   OPC_RecordChild1, // #1 = $src
/*72164*/   OPC_MoveChild, 2,
/*72166*/   OPC_CheckValueType, MVT::i64,
/*72168*/   OPC_MoveParent,
/*72169*/   OPC_CheckType, MVT::f64,
/*72171*/   OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$src #2 #3 #4 #5 #6
/*72174*/   OPC_EmitMergeInputChains, 1, 0, 
/*72177*/   OPC_MorphNodeTo, TARGET_OPCODE(X86::ILD_Fp64m64), 0|OPFL_Chain|OPFL_FlagOutput,
                1/*#VTs*/, MVT::f64, 5/*#Ops*/, 2, 3, 4, 5, 6, 
            // Src: (X86fildflag:f64 addr:iPTR:$src, i64:Other)
            // Dst: (ILD_Fp64m64:f64 addr:iPTR:$src)
          /*SwitchOpcode*/ 20,  X86ISD::LCMPXCHG8_DAG,// ->72211
/*72191*/   OPC_RecordNode,   // #0 = 'X86cas8' chained node
/*72192*/   OPC_CaptureFlagInput,
/*72193*/   OPC_RecordChild1, // #1 = $ptr
/*72194*/   OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$ptr #2 #3 #4 #5 #6
/*72197*/   OPC_EmitMergeInputChains, 1, 0, 
/*72200*/   OPC_MorphNodeTo, TARGET_OPCODE(X86::LCMPXCHG8B), 0|OPFL_Chain|OPFL_FlagInput|OPFL_FlagOutput,
                0/*#VTs*/, 5/*#Ops*/, 2, 3, 4, 5, 6, 
            // Src: (X86cas8:isVoid addr:iPTR:$ptr)
            // Dst: (LCMPXCHG8B:isVoid addr:iPTR:$ptr)
          /*SwitchOpcode*/ 19,  X86ISD::FNSTCW16m,// ->72232
/*72213*/   OPC_RecordNode,   // #0 = 'X86fp_cwd_get16' chained node
/*72214*/   OPC_RecordChild1, // #1 = $dst
/*72215*/   OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddr:$dst #2 #3 #4 #5 #6
/*72218*/   OPC_EmitMergeInputChains, 1, 0, 
/*72221*/   OPC_MorphNodeTo, TARGET_OPCODE(X86::FNSTCW16m), 0|OPFL_Chain,
                0/*#VTs*/, 5/*#Ops*/, 2, 3, 4, 5, 6, 
            // Src: (X86fp_cwd_get16:isVoid addr:iPTR:$dst)
            // Dst: (FNSTCW16m:isVoid addr:iPTR:$dst)
          /*SwitchOpcode*/ 47,  X86ISD::TLSADDR,// ->72281
/*72234*/   OPC_RecordNode,   // #0 = 'X86tlsaddr' chained node
/*72235*/   OPC_CaptureFlagInput,
/*72236*/   OPC_RecordChild1, // #1 = $sym
/*72237*/   OPC_Scope, 20, /*->72259*/ // 2 children in Scope
/*72239*/     OPC_CheckChild1Type, MVT::i32,
/*72241*/     OPC_CheckPatternPredicate, 2, // (!Subtarget->is64Bit())
/*72243*/     OPC_CheckComplexPat, /*CP*/5, /*#*/1, // SelectTLSADDRAddr:$sym #2 #3 #4 #5
/*72246*/     OPC_EmitMergeInputChains, 1, 0, 
/*72249*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::TLS_addr32), 0|OPFL_Chain|OPFL_FlagInput|OPFL_FlagOutput,
                  0/*#VTs*/, 4/*#Ops*/, 2, 3, 4, 5, 
              // Src: (X86tlsaddr:isVoid tls32addr:i32:$sym)
              // Dst: (TLS_addr32:isVoid tls32addr:i32:$sym)
/*72259*/   /*Scope*/ 20, /*->72280*/
/*72260*/     OPC_CheckChild1Type, MVT::i64,
/*72262*/     OPC_CheckPatternPredicate, 3, // (Subtarget->is64Bit())
/*72264*/     OPC_CheckComplexPat, /*CP*/6, /*#*/1, // SelectTLSADDRAddr:$sym #2 #3 #4 #5
/*72267*/     OPC_EmitMergeInputChains, 1, 0, 
/*72270*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::TLS_addr64), 0|OPFL_Chain|OPFL_FlagInput|OPFL_FlagOutput,
                  0/*#VTs*/, 4/*#Ops*/, 2, 3, 4, 5, 
              // Src: (X86tlsaddr:isVoid tls64addr:i64:$sym)
              // Dst: (TLS_addr64:isVoid tls64addr:i64:$sym)
/*72280*/   0, /*End of Scope*/
          /*SwitchOpcode*/ 57,  X86ISD::MUL_IMM,// ->72340
/*72283*/   OPC_RecordNode,   // #0 = $src
/*72284*/   OPC_SwitchType /*2 cases */, 36,  MVT::i32,// ->72323
/*72287*/     OPC_Scope, 16, /*->72305*/ // 2 children in Scope
/*72289*/       OPC_CheckPatternPredicate, 2, // (!Subtarget->is64Bit())
/*72291*/       OPC_CheckComplexPat, /*CP*/3, /*#*/0, // SelectLEAAddr:$src #1 #2 #3 #4
/*72294*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::LEA32r), 0,
                    1/*#VTs*/, MVT::i32, 4/*#Ops*/, 1, 2, 3, 4, 
                // Src: lea32addr:i32:$src
                // Dst: (LEA32r:i32 lea32addr:i32:$src)
/*72305*/     /*Scope*/ 16, /*->72322*/
/*72306*/       OPC_CheckPatternPredicate, 3, // (Subtarget->is64Bit())
/*72308*/       OPC_CheckComplexPat, /*CP*/3, /*#*/0, // SelectLEAAddr:$src #1 #2 #3 #4
/*72311*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::LEA64_32r), 0,
                    1/*#VTs*/, MVT::i32, 4/*#Ops*/, 1, 2, 3, 4, 
                // Src: lea32addr:i32:$src
                // Dst: (LEA64_32r:i32 lea32addr:i32:$src)
/*72322*/     0, /*End of Scope*/
            /*SwitchType*/ 14,  MVT::i64,// ->72339
/*72325*/     OPC_CheckComplexPat, /*CP*/4, /*#*/0, // SelectLEAAddr:$src #1 #2 #3 #4
/*72328*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::LEA64r), 0,
                  1/*#VTs*/, MVT::i64, 4/*#Ops*/, 1, 2, 3, 4, 
              // Src: lea64addr:i64:$src
              // Dst: (LEA64r:i64 lea64addr:i64:$src)
            0, // EndSwitchType
          /*SwitchOpcode*/ 53|128,2/*309*/,  ISD::SHL,// ->72652
/*72343*/   OPC_Scope, 57, /*->72402*/ // 2 children in Scope
/*72345*/     OPC_RecordNode, // #0 = $src
/*72346*/     OPC_SwitchType /*2 cases */, 36,  MVT::i32,// ->72385
/*72349*/       OPC_Scope, 16, /*->72367*/ // 2 children in Scope
/*72351*/         OPC_CheckPatternPredicate, 2, // (!Subtarget->is64Bit())
/*72353*/         OPC_CheckComplexPat, /*CP*/3, /*#*/0, // SelectLEAAddr:$src #1 #2 #3 #4
/*72356*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::LEA32r), 0,
                      1/*#VTs*/, MVT::i32, 4/*#Ops*/, 1, 2, 3, 4, 
                  // Src: lea32addr:i32:$src
                  // Dst: (LEA32r:i32 lea32addr:i32:$src)
/*72367*/       /*Scope*/ 16, /*->72384*/
/*72368*/         OPC_CheckPatternPredicate, 3, // (Subtarget->is64Bit())
/*72370*/         OPC_CheckComplexPat, /*CP*/3, /*#*/0, // SelectLEAAddr:$src #1 #2 #3 #4
/*72373*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::LEA64_32r), 0,
                      1/*#VTs*/, MVT::i32, 4/*#Ops*/, 1, 2, 3, 4, 
                  // Src: lea32addr:i32:$src
                  // Dst: (LEA64_32r:i32 lea32addr:i32:$src)
/*72384*/       0, /*End of Scope*/
              /*SwitchType*/ 14,  MVT::i64,// ->72401
/*72387*/       OPC_CheckComplexPat, /*CP*/4, /*#*/0, // SelectLEAAddr:$src #1 #2 #3 #4
/*72390*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::LEA64r), 0,
                    1/*#VTs*/, MVT::i64, 4/*#Ops*/, 1, 2, 3, 4, 
                // Src: lea64addr:i64:$src
                // Dst: (LEA64r:i64 lea64addr:i64:$src)
              0, // EndSwitchType
/*72402*/   /*Scope*/ 119|128,1/*247*/, /*->72651*/
/*72404*/     OPC_RecordChild0, // #0 = $src1
/*72405*/     OPC_Scope, 120, /*->72527*/ // 2 children in Scope
/*72407*/       OPC_MoveChild, 1,
/*72409*/       OPC_CheckType, MVT::i8,
/*72411*/       OPC_Scope, 45, /*->72458*/ // 3 children in Scope
/*72413*/         OPC_CheckAndImm, 31, 
/*72415*/         OPC_RecordChild0, // #1 = physreg input CL
/*72416*/         OPC_MoveParent,
/*72417*/         OPC_SwitchType /*3 cases */, 11,  MVT::i8,// ->72431
/*72420*/           OPC_EmitCopyToReg, 1, X86::CL,
/*72423*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::SHL8rCL), 0|OPFL_FlagInput,
                        1/*#VTs*/, MVT::i8, 1/*#Ops*/, 0, 
                    // Src: (shl:i8 GR8:i8:$src1, (and:i8 CL:i8, 31:i8))
                    // Dst: (SHL8rCL:i8 GR8:i8:$src1)
                  /*SwitchType*/ 11,  MVT::i16,// ->72444
/*72433*/           OPC_EmitCopyToReg, 1, X86::CL,
/*72436*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::SHL16rCL), 0|OPFL_FlagInput,
                        1/*#VTs*/, MVT::i16, 1/*#Ops*/, 0, 
                    // Src: (shl:i16 GR16:i16:$src1, (and:i8 CL:i8, 31:i8))
                    // Dst: (SHL16rCL:i16 GR16:i16:$src1)
                  /*SwitchType*/ 11,  MVT::i32,// ->72457
/*72446*/           OPC_EmitCopyToReg, 1, X86::CL,
/*72449*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::SHL32rCL), 0|OPFL_FlagInput,
                        1/*#VTs*/, MVT::i32, 1/*#Ops*/, 0, 
                    // Src: (shl:i32 GR32:i32:$src1, (and:i8 CL:i8, 31:i8))
                    // Dst: (SHL32rCL:i32 GR32:i32:$src1)
                  0, // EndSwitchType
/*72458*/       /*Scope*/ 17, /*->72476*/
/*72459*/         OPC_CheckAndImm, 63, 
/*72461*/         OPC_RecordChild0, // #1 = physreg input CL
/*72462*/         OPC_MoveParent,
/*72463*/         OPC_CheckType, MVT::i64,
/*72465*/         OPC_EmitCopyToReg, 1, X86::CL,
/*72468*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::SHL64rCL), 0|OPFL_FlagInput,
                      1/*#VTs*/, MVT::i64, 1/*#Ops*/, 0, 
                  // Src: (shl:i64 GR64:i64:$src1, (and:i8 CL:i8, 63:i8))
                  // Dst: (SHL64rCL:i64 GR64:i64:$src1)
/*72476*/       /*Scope*/ 49, /*->72526*/
/*72477*/         OPC_CheckInteger, 1, 
/*72479*/         OPC_MoveParent,
/*72480*/         OPC_SwitchType /*4 cases */, 9,  MVT::i8,// ->72492
/*72483*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::ADD8rr), 0,
                        1/*#VTs*/, MVT::i8, 2/*#Ops*/, 0, 0, 
                    // Src: (shl:i8 GR8:i8:$src1, 1:i8)
                    // Dst: (ADD8rr:i8 GR8:i8:$src1, GR8:i8:$src1)
                  /*SwitchType*/ 9,  MVT::i16,// ->72503
/*72494*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::ADD16rr), 0,
                        1/*#VTs*/, MVT::i16, 2/*#Ops*/, 0, 0, 
                    // Src: (shl:i16 GR16:i16:$src1, 1:i8)
                    // Dst: (ADD16rr:i16 GR16:i16:$src1, GR16:i16:$src1)
                  /*SwitchType*/ 9,  MVT::i32,// ->72514
/*72505*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::ADD32rr), 0,
                        1/*#VTs*/, MVT::i32, 2/*#Ops*/, 0, 0, 
                    // Src: (shl:i32 GR32:i32:$src1, 1:i8)
                    // Dst: (ADD32rr:i32 GR32:i32:$src1, GR32:i32:$src1)
                  /*SwitchType*/ 9,  MVT::i64,// ->72525
/*72516*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::ADD64rr), 0,
                        1/*#VTs*/, MVT::i64, 2/*#Ops*/, 0, 0, 
                    // Src: (shl:i64 GR64:i64:$src1, 1:i8)
                    // Dst: (ADD64rr:i64 GR64:i64:$src1, GR64:i64:$src1)
                  0, // EndSwitchType
/*72526*/       0, /*End of Scope*/
/*72527*/     /*Scope*/ 122, /*->72650*/
/*72528*/       OPC_RecordChild1, // #1 = $src2
/*72529*/       OPC_Scope, 61, /*->72592*/ // 2 children in Scope
/*72531*/         OPC_MoveChild, 1,
/*72533*/         OPC_CheckOpcode, ISD::Constant,
/*72535*/         OPC_CheckType, MVT::i8,
/*72537*/         OPC_MoveParent,
/*72538*/         OPC_SwitchType /*4 cases */, 11,  MVT::i8,// ->72552
/*72541*/           OPC_EmitConvertToTarget, 1,
/*72543*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::SHL8ri), 0,
                        1/*#VTs*/, MVT::i8, 2/*#Ops*/, 0, 2, 
                    // Src: (shl:i8 GR8:i8:$src1, (imm:i8):$src2)
                    // Dst: (SHL8ri:i8 GR8:i8:$src1, (imm:i8):$src2)
                  /*SwitchType*/ 11,  MVT::i16,// ->72565
/*72554*/           OPC_EmitConvertToTarget, 1,
/*72556*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::SHL16ri), 0,
                        1/*#VTs*/, MVT::i16, 2/*#Ops*/, 0, 2, 
                    // Src: (shl:i16 GR16:i16:$src1, (imm:i8):$src2)
                    // Dst: (SHL16ri:i16 GR16:i16:$src1, (imm:i8):$src2)
                  /*SwitchType*/ 11,  MVT::i32,// ->72578
/*72567*/           OPC_EmitConvertToTarget, 1,
/*72569*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::SHL32ri), 0,
                        1/*#VTs*/, MVT::i32, 2/*#Ops*/, 0, 2, 
                    // Src: (shl:i32 GR32:i32:$src1, (imm:i8):$src2)
                    // Dst: (SHL32ri:i32 GR32:i32:$src1, (imm:i8):$src2)
                  /*SwitchType*/ 11,  MVT::i64,// ->72591
/*72580*/           OPC_EmitConvertToTarget, 1,
/*72582*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::SHL64ri), 0,
                        1/*#VTs*/, MVT::i64, 2/*#Ops*/, 0, 2, 
                    // Src: (shl:i64 GR64:i64:$src1, (imm:i8):$src2)
                    // Dst: (SHL64ri:i64 GR64:i64:$src1, (imm:i8):$src2)
                  0, // EndSwitchType
/*72592*/       /*Scope*/ 56, /*->72649*/
/*72593*/         OPC_CheckChild1Type, MVT::i8,
/*72595*/         OPC_SwitchType /*4 cases */, 11,  MVT::i8,// ->72609
/*72598*/           OPC_EmitCopyToReg, 1, X86::CL,
/*72601*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::SHL8rCL), 0|OPFL_FlagInput,
                        1/*#VTs*/, MVT::i8, 1/*#Ops*/, 0, 
                    // Src: (shl:i8 GR8:i8:$src, CL:i8)
                    // Dst: (SHL8rCL:i8 GR8:i8:$src)
                  /*SwitchType*/ 11,  MVT::i16,// ->72622
/*72611*/           OPC_EmitCopyToReg, 1, X86::CL,
/*72614*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::SHL16rCL), 0|OPFL_FlagInput,
                        1/*#VTs*/, MVT::i16, 1/*#Ops*/, 0, 
                    // Src: (shl:i16 GR16:i16:$src, CL:i8)
                    // Dst: (SHL16rCL:i16 GR16:i16:$src)
                  /*SwitchType*/ 11,  MVT::i32,// ->72635
/*72624*/           OPC_EmitCopyToReg, 1, X86::CL,
/*72627*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::SHL32rCL), 0|OPFL_FlagInput,
                        1/*#VTs*/, MVT::i32, 1/*#Ops*/, 0, 
                    // Src: (shl:i32 GR32:i32:$src, CL:i8)
                    // Dst: (SHL32rCL:i32 GR32:i32:$src)
                  /*SwitchType*/ 11,  MVT::i64,// ->72648
/*72637*/           OPC_EmitCopyToReg, 1, X86::CL,
/*72640*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::SHL64rCL), 0|OPFL_FlagInput,
                        1/*#VTs*/, MVT::i64, 1/*#Ops*/, 0, 
                    // Src: (shl:i64 GR64:i64:$src, CL:i8)
                    // Dst: (SHL64rCL:i64 GR64:i64:$src)
                  0, // EndSwitchType
/*72649*/       0, /*End of Scope*/
/*72650*/     0, /*End of Scope*/
/*72651*/   0, /*End of Scope*/
          /*SwitchOpcode*/ 57,  ISD::FrameIndex,// ->72711
/*72654*/   OPC_RecordNode,   // #0 = $src
/*72655*/   OPC_SwitchType /*2 cases */, 36,  MVT::i32,// ->72694
/*72658*/     OPC_Scope, 16, /*->72676*/ // 2 children in Scope
/*72660*/       OPC_CheckPatternPredicate, 2, // (!Subtarget->is64Bit())
/*72662*/       OPC_CheckComplexPat, /*CP*/3, /*#*/0, // SelectLEAAddr:$src #1 #2 #3 #4
/*72665*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::LEA32r), 0,
                    1/*#VTs*/, MVT::i32, 4/*#Ops*/, 1, 2, 3, 4, 
                // Src: lea32addr:i32:$src
                // Dst: (LEA32r:i32 lea32addr:i32:$src)
/*72676*/     /*Scope*/ 16, /*->72693*/
/*72677*/       OPC_CheckPatternPredicate, 3, // (Subtarget->is64Bit())
/*72679*/       OPC_CheckComplexPat, /*CP*/3, /*#*/0, // SelectLEAAddr:$src #1 #2 #3 #4
/*72682*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::LEA64_32r), 0,
                    1/*#VTs*/, MVT::i32, 4/*#Ops*/, 1, 2, 3, 4, 
                // Src: lea32addr:i32:$src
                // Dst: (LEA64_32r:i32 lea32addr:i32:$src)
/*72693*/     0, /*End of Scope*/
            /*SwitchType*/ 14,  MVT::i64,// ->72710
/*72696*/     OPC_CheckComplexPat, /*CP*/4, /*#*/0, // SelectLEAAddr:$src #1 #2 #3 #4
/*72699*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::LEA64r), 0,
                  1/*#VTs*/, MVT::i64, 4/*#Ops*/, 1, 2, 3, 4, 
              // Src: lea64addr:i64:$src
              // Dst: (LEA64r:i64 lea64addr:i64:$src)
            0, // EndSwitchType
          /*SwitchOpcode*/ 17,  X86ISD::WrapperRIP,// ->72730
/*72713*/   OPC_RecordNode,   // #0 = $src
/*72714*/   OPC_CheckType, MVT::i64,
/*72716*/   OPC_CheckComplexPat, /*CP*/4, /*#*/0, // SelectLEAAddr:$src #1 #2 #3 #4
/*72719*/   OPC_MorphNodeTo, TARGET_OPCODE(X86::LEA64r), 0,
                1/*#VTs*/, MVT::i64, 4/*#Ops*/, 1, 2, 3, 4, 
            // Src: lea64addr:i64:$src
            // Dst: (LEA64r:i64 lea64addr:i64:$src)
          /*SwitchOpcode*/ 119|128,1/*247*/,  ISD::TRUNCATE,// ->72980
/*72733*/   OPC_Scope, 78, /*->72813*/ // 2 children in Scope
/*72735*/     OPC_MoveChild, 0,
/*72737*/     OPC_CheckOpcode, ISD::SRL,
/*72739*/     OPC_RecordChild0, // #0 = $src
/*72740*/     OPC_MoveChild, 1,
/*72742*/     OPC_CheckInteger, 8, 
/*72744*/     OPC_CheckType, MVT::i8,
/*72746*/     OPC_MoveParent,
/*72747*/     OPC_CheckPredicate, 15, // Predicate_srl_su
/*72749*/     OPC_SwitchType /*2 cases */, 29,  MVT::i16,// ->72781
/*72752*/       OPC_MoveParent,
/*72753*/       OPC_CheckType, MVT::i8,
/*72755*/       OPC_CheckPatternPredicate, 2, // (!Subtarget->is64Bit())
/*72757*/       OPC_EmitInteger, MVT::i32, X86::GR16_ABCDRegClassID,
/*72760*/       OPC_EmitNode, TARGET_OPCODE(TargetOpcode::COPY_TO_REGCLASS), 0,
                    1/*#VTs*/, MVT::i32, 2/*#Ops*/, 0, 1,  // Results = #2 
/*72769*/       OPC_EmitInteger, MVT::i32, 2, 
/*72772*/       OPC_MorphNodeTo, TARGET_OPCODE(TargetOpcode::EXTRACT_SUBREG), 0,
                    1/*#VTs*/, MVT::i8, 2/*#Ops*/, 2, 3, 
                // Src: (trunc:i8 (srl:i16 GR16:i16:$src, 8:i8)<<P:Predicate_srl_su>>)
                // Dst: (EXTRACT_SUBREG:i8 (COPY_TO_REGCLASS:i32 GR16:i16:$src, GR16_ABCD:i16), 2:i32)
              /*SwitchType*/ 29,  MVT::i32,// ->72812
/*72783*/       OPC_MoveParent,
/*72784*/       OPC_CheckType, MVT::i8,
/*72786*/       OPC_CheckPatternPredicate, 2, // (!Subtarget->is64Bit())
/*72788*/       OPC_EmitInteger, MVT::i32, X86::GR32_ABCDRegClassID,
/*72791*/       OPC_EmitNode, TARGET_OPCODE(TargetOpcode::COPY_TO_REGCLASS), 0,
                    1/*#VTs*/, MVT::i16, 2/*#Ops*/, 0, 1,  // Results = #2 
/*72800*/       OPC_EmitInteger, MVT::i32, 2, 
/*72803*/       OPC_MorphNodeTo, TARGET_OPCODE(TargetOpcode::EXTRACT_SUBREG), 0,
                    1/*#VTs*/, MVT::i8, 2/*#Ops*/, 2, 3, 
                // Src: (trunc:i8 (srl:i32 GR32:i32:$src, 8:i8)<<P:Predicate_srl_su>>)
                // Dst: (EXTRACT_SUBREG:i8 (COPY_TO_REGCLASS:i16 GR32:i32:$src, GR32_ABCD:i32), 2:i32)
              0, // EndSwitchType
/*72813*/   /*Scope*/ 36|128,1/*164*/, /*->72979*/
/*72815*/     OPC_RecordChild0, // #0 = $src
/*72816*/     OPC_Scope, 64, /*->72882*/ // 3 children in Scope
/*72818*/       OPC_CheckChild0Type, MVT::i32,
/*72820*/       OPC_SwitchType /*2 cases */, 12,  MVT::i16,// ->72835
/*72823*/         OPC_EmitInteger, MVT::i32, 3, 
/*72826*/         OPC_MorphNodeTo, TARGET_OPCODE(TargetOpcode::EXTRACT_SUBREG), 0,
                      1/*#VTs*/, MVT::i16, 2/*#Ops*/, 0, 1, 
                  // Src: (trunc:i16 GR32:i32:$src)
                  // Dst: (EXTRACT_SUBREG:i16 GR32:i32:$src, 3:i32)
                /*SwitchType*/ 44,  MVT::i8,// ->72881
/*72837*/         OPC_Scope, 14, /*->72853*/ // 2 children in Scope
/*72839*/           OPC_CheckPatternPredicate, 3, // (Subtarget->is64Bit())
/*72841*/           OPC_EmitInteger, MVT::i32, 1, 
/*72844*/           OPC_MorphNodeTo, TARGET_OPCODE(TargetOpcode::EXTRACT_SUBREG), 0,
                        1/*#VTs*/, MVT::i8, 2/*#Ops*/, 0, 1, 
                    // Src: (trunc:i8 GR32:i32:$src)
                    // Dst: (EXTRACT_SUBREG:i8 GR32:i32:$src, 1:i32)
/*72853*/         /*Scope*/ 26, /*->72880*/
/*72854*/           OPC_CheckPatternPredicate, 2, // (!Subtarget->is64Bit())
/*72856*/           OPC_EmitInteger, MVT::i32, X86::GR32_ABCDRegClassID,
/*72859*/           OPC_EmitNode, TARGET_OPCODE(TargetOpcode::COPY_TO_REGCLASS), 0,
                        1/*#VTs*/, MVT::i32, 2/*#Ops*/, 0, 1,  // Results = #2 
/*72868*/           OPC_EmitInteger, MVT::i32, 1, 
/*72871*/           OPC_MorphNodeTo, TARGET_OPCODE(TargetOpcode::EXTRACT_SUBREG), 0,
                        1/*#VTs*/, MVT::i8, 2/*#Ops*/, 2, 3, 
                    // Src: (trunc:i8 GR32:i32:$src)
                    // Dst: (EXTRACT_SUBREG:i8 (COPY_TO_REGCLASS:i32 GR32:i32:$src, GR32_ABCD:i32), 1:i32)
/*72880*/         0, /*End of Scope*/
                0, // EndSwitchType
/*72882*/     /*Scope*/ 46, /*->72929*/
/*72883*/       OPC_CheckChild0Type, MVT::i64,
/*72885*/       OPC_SwitchType /*3 cases */, 12,  MVT::i32,// ->72900
/*72888*/         OPC_EmitInteger, MVT::i32, 4, 
/*72891*/         OPC_MorphNodeTo, TARGET_OPCODE(TargetOpcode::EXTRACT_SUBREG), 0,
                      1/*#VTs*/, MVT::i32, 2/*#Ops*/, 0, 1, 
                  // Src: (trunc:i32 GR64:i64:$src)
                  // Dst: (EXTRACT_SUBREG:i32 GR64:i64:$src, 4:i32)
                /*SwitchType*/ 12,  MVT::i16,// ->72914
/*72902*/         OPC_EmitInteger, MVT::i32, 3, 
/*72905*/         OPC_MorphNodeTo, TARGET_OPCODE(TargetOpcode::EXTRACT_SUBREG), 0,
                      1/*#VTs*/, MVT::i16, 2/*#Ops*/, 0, 1, 
                  // Src: (trunc:i16 GR64:i64:$src)
                  // Dst: (EXTRACT_SUBREG:i16 GR64:i64:$src, 3:i32)
                /*SwitchType*/ 12,  MVT::i8,// ->72928
/*72916*/         OPC_EmitInteger, MVT::i32, 1, 
/*72919*/         OPC_MorphNodeTo, TARGET_OPCODE(TargetOpcode::EXTRACT_SUBREG), 0,
                      1/*#VTs*/, MVT::i8, 2/*#Ops*/, 0, 1, 
                  // Src: (trunc:i8 GR64:i64:$src)
                  // Dst: (EXTRACT_SUBREG:i8 GR64:i64:$src, 1:i32)
                0, // EndSwitchType
/*72929*/     /*Scope*/ 48, /*->72978*/
/*72930*/       OPC_CheckChild0Type, MVT::i16,
/*72932*/       OPC_CheckType, MVT::i8,
/*72934*/       OPC_Scope, 14, /*->72950*/ // 2 children in Scope
/*72936*/         OPC_CheckPatternPredicate, 3, // (Subtarget->is64Bit())
/*72938*/         OPC_EmitInteger, MVT::i32, 1, 
/*72941*/         OPC_MorphNodeTo, TARGET_OPCODE(TargetOpcode::EXTRACT_SUBREG), 0,
                      1/*#VTs*/, MVT::i8, 2/*#Ops*/, 0, 1, 
                  // Src: (trunc:i8 GR16:i16:$src)
                  // Dst: (EXTRACT_SUBREG:i8 GR16:i16:$src, 1:i32)
/*72950*/       /*Scope*/ 26, /*->72977*/
/*72951*/         OPC_CheckPatternPredicate, 2, // (!Subtarget->is64Bit())
/*72953*/         OPC_EmitInteger, MVT::i32, X86::GR16_ABCDRegClassID,
/*72956*/         OPC_EmitNode, TARGET_OPCODE(TargetOpcode::COPY_TO_REGCLASS), 0,
                      1/*#VTs*/, MVT::i16, 2/*#Ops*/, 0, 1,  // Results = #2 
/*72965*/         OPC_EmitInteger, MVT::i32, 1, 
/*72968*/         OPC_MorphNodeTo, TARGET_OPCODE(TargetOpcode::EXTRACT_SUBREG), 0,
                      1/*#VTs*/, MVT::i8, 2/*#Ops*/, 2, 3, 
                  // Src: (trunc:i8 GR16:i16:$src)
                  // Dst: (EXTRACT_SUBREG:i8 (COPY_TO_REGCLASS:i16 GR16:i16:$src, GR16_ABCD:i16), 1:i32)
/*72977*/       0, /*End of Scope*/
/*72978*/     0, /*End of Scope*/
/*72979*/   0, /*End of Scope*/
          /*SwitchOpcode*/ 122|128,1/*250*/,  ISD::ZERO_EXTEND,// ->73233
/*72983*/   OPC_Scope, 15|128,1/*143*/, /*->73129*/ // 2 children in Scope
/*72986*/     OPC_MoveChild, 0,
/*72988*/     OPC_CheckOpcode, ISD::SRL,
/*72990*/     OPC_RecordChild0, // #0 = $src
/*72991*/     OPC_MoveChild, 1,
/*72993*/     OPC_CheckInteger, 8, 
/*72995*/     OPC_CheckType, MVT::i8,
/*72997*/     OPC_MoveParent,
/*72998*/     OPC_CheckPredicate, 15, // Predicate_srl_su
/*73000*/     OPC_CheckType, MVT::i16,
/*73002*/     OPC_MoveParent,
/*73003*/     OPC_SwitchType /*2 cases */, 72,  MVT::i32,// ->73078
/*73006*/       OPC_Scope, 34, /*->73042*/ // 2 children in Scope
/*73008*/         OPC_CheckPatternPredicate, 2, // (!Subtarget->is64Bit())
/*73010*/         OPC_EmitInteger, MVT::i32, X86::GR16_ABCDRegClassID,
/*73013*/         OPC_EmitNode, TARGET_OPCODE(TargetOpcode::COPY_TO_REGCLASS), 0,
                      1/*#VTs*/, MVT::i16, 2/*#Ops*/, 0, 1,  // Results = #2 
/*73022*/         OPC_EmitInteger, MVT::i32, 2, 
/*73025*/         OPC_EmitNode, TARGET_OPCODE(TargetOpcode::EXTRACT_SUBREG), 0,
                      1/*#VTs*/, MVT::i8, 2/*#Ops*/, 2, 3,  // Results = #4 
/*73034*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVZX32rr8), 0,
                      1/*#VTs*/, MVT::i32, 1/*#Ops*/, 4, 
                  // Src: (zext:i32 (srl:i16 GR16:i16:$src, 8:i8)<<P:Predicate_srl_su>>)
                  // Dst: (MOVZX32rr8:i32 (EXTRACT_SUBREG:i8 (COPY_TO_REGCLASS:i16 GR16:i16:$src, GR16_ABCD:i16), 2:i32))
/*73042*/       /*Scope*/ 34, /*->73077*/
/*73043*/         OPC_CheckPatternPredicate, 3, // (Subtarget->is64Bit())
/*73045*/         OPC_EmitInteger, MVT::i32, X86::GR16_ABCDRegClassID,
/*73048*/         OPC_EmitNode, TARGET_OPCODE(TargetOpcode::COPY_TO_REGCLASS), 0,
                      1/*#VTs*/, MVT::i16, 2/*#Ops*/, 0, 1,  // Results = #2 
/*73057*/         OPC_EmitInteger, MVT::i32, 2, 
/*73060*/         OPC_EmitNode, TARGET_OPCODE(TargetOpcode::EXTRACT_SUBREG), 0,
                      1/*#VTs*/, MVT::i8, 2/*#Ops*/, 2, 3,  // Results = #4 
/*73069*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVZX32_NOREXrr8), 0,
                      1/*#VTs*/, MVT::i32, 1/*#Ops*/, 4, 
                  // Src: (zext:i32 (srl:i16 GR16:i16:$src, 8:i8)<<P:Predicate_srl_su>>)
                  // Dst: (MOVZX32_NOREXrr8:i32 (EXTRACT_SUBREG:i8 (COPY_TO_REGCLASS:i16 GR16:i16:$src, GR16_ABCD:i16), 2:i32))
/*73077*/       0, /*End of Scope*/
              /*SwitchType*/ 48,  MVT::i64,// ->73128
/*73080*/       OPC_EmitInteger, MVT::i64, 0, 
/*73083*/       OPC_EmitInteger, MVT::i32, X86::GR16_ABCDRegClassID,
/*73086*/       OPC_EmitNode, TARGET_OPCODE(TargetOpcode::COPY_TO_REGCLASS), 0,
                    1/*#VTs*/, MVT::i16, 2/*#Ops*/, 0, 2,  // Results = #3 
/*73095*/       OPC_EmitInteger, MVT::i32, 2, 
/*73098*/       OPC_EmitNode, TARGET_OPCODE(TargetOpcode::EXTRACT_SUBREG), 0,
                    1/*#VTs*/, MVT::i8, 2/*#Ops*/, 3, 4,  // Results = #5 
/*73107*/       OPC_EmitNode, TARGET_OPCODE(X86::MOVZX32_NOREXrr8), 0,
                    1/*#VTs*/, MVT::i32, 1/*#Ops*/, 5,  // Results = #6 
/*73115*/       OPC_EmitInteger, MVT::i32, 4, 
/*73118*/       OPC_MorphNodeTo, TARGET_OPCODE(TargetOpcode::SUBREG_TO_REG), 0,
                    1/*#VTs*/, MVT::i64, 3/*#Ops*/, 1, 6, 7, 
                // Src: (zext:i64 (srl:i16 GR16:i16:$src, 8:i8)<<P:Predicate_srl_su>>)
                // Dst: (SUBREG_TO_REG:i64 0:i64, (MOVZX32_NOREXrr8:i32 (EXTRACT_SUBREG:i8 (COPY_TO_REGCLASS:i16 GR16:i16:$src, GR16_ABCD:i16), 2:i32)), 4:i32)
              0, // EndSwitchType
/*73129*/   /*Scope*/ 102, /*->73232*/
/*73130*/     OPC_RecordChild0, // #0 = $src
/*73131*/     OPC_Scope, 25, /*->73158*/ // 4 children in Scope
/*73133*/       OPC_MoveChild, 0,
/*73135*/       OPC_CheckPredicate, 108, // Predicate_def32
/*73137*/       OPC_CheckType, MVT::i32,
/*73139*/       OPC_MoveParent,
/*73140*/       OPC_CheckType, MVT::i64,
/*73142*/       OPC_EmitInteger, MVT::i64, 0, 
/*73145*/       OPC_EmitInteger, MVT::i32, 4, 
/*73148*/       OPC_MorphNodeTo, TARGET_OPCODE(TargetOpcode::SUBREG_TO_REG), 0,
                    1/*#VTs*/, MVT::i64, 3/*#Ops*/, 1, 0, 2, 
                // Src: (zext:i64 GR32:i32<<P:Predicate_def32>>:$src)
                // Dst: (SUBREG_TO_REG:i64 0:i64, GR32:i32:$src, 4:i32)
/*73158*/     /*Scope*/ 34, /*->73193*/
/*73159*/       OPC_CheckChild0Type, MVT::i8,
/*73161*/       OPC_SwitchType /*3 cases */, 8,  MVT::i16,// ->73172
/*73164*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVZX16rr8), 0,
                      1/*#VTs*/, MVT::i16, 1/*#Ops*/, 0, 
                  // Src: (zext:i16 GR8:i8:$src)
                  // Dst: (MOVZX16rr8:i16 GR8:i8:$src)
                /*SwitchType*/ 8,  MVT::i32,// ->73182
/*73174*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVZX32rr8), 0,
                      1/*#VTs*/, MVT::i32, 1/*#Ops*/, 0, 
                  // Src: (zext:i32 GR8:i8:$src)
                  // Dst: (MOVZX32rr8:i32 GR8:i8:$src)
                /*SwitchType*/ 8,  MVT::i64,// ->73192
/*73184*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVZX64rr8), 0,
                      1/*#VTs*/, MVT::i64, 1/*#Ops*/, 0, 
                  // Src: (zext:i64 GR8:i8:$src)
                  // Dst: (MOVZX64rr8:i64 GR8:i8:$src)
                0, // EndSwitchType
/*73193*/     /*Scope*/ 24, /*->73218*/
/*73194*/       OPC_CheckChild0Type, MVT::i16,
/*73196*/       OPC_SwitchType /*2 cases */, 8,  MVT::i32,// ->73207
/*73199*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVZX32rr16), 0,
                      1/*#VTs*/, MVT::i32, 1/*#Ops*/, 0, 
                  // Src: (zext:i32 GR16:i16:$src)
                  // Dst: (MOVZX32rr16:i32 GR16:i16:$src)
                /*SwitchType*/ 8,  MVT::i64,// ->73217
/*73209*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVZX64rr16), 0,
                      1/*#VTs*/, MVT::i64, 1/*#Ops*/, 0, 
                  // Src: (zext:i64 GR16:i16:$src)
                  // Dst: (MOVZX64rr16:i64 GR16:i16:$src)
                0, // EndSwitchType
/*73218*/     /*Scope*/ 12, /*->73231*/
/*73219*/       OPC_CheckChild0Type, MVT::i32,
/*73221*/       OPC_CheckType, MVT::i64,
/*73223*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVZX64rr32), 0,
                    1/*#VTs*/, MVT::i64, 1/*#Ops*/, 0, 
                // Src: (zext:i64 GR32:i32:$src)
                // Dst: (MOVZX64rr32:i64 GR32:i32:$src)
/*73231*/     0, /*End of Scope*/
/*73232*/   0, /*End of Scope*/
          /*SwitchOpcode*/ 28|128,2/*284*/,  ISD::ANY_EXTEND,// ->73520
/*73236*/   OPC_Scope, 67|128,1/*195*/, /*->73434*/ // 2 children in Scope
/*73239*/     OPC_MoveChild, 0,
/*73241*/     OPC_SwitchOpcode /*2 cases */, 11|128,1/*139*/,  ISD::SRL,// ->73384
/*73245*/       OPC_RecordChild0, // #0 = $src
/*73246*/       OPC_MoveChild, 1,
/*73248*/       OPC_CheckInteger, 8, 
/*73250*/       OPC_CheckType, MVT::i8,
/*73252*/       OPC_MoveParent,
/*73253*/       OPC_CheckPredicate, 15, // Predicate_srl_su
/*73255*/       OPC_CheckType, MVT::i16,
/*73257*/       OPC_MoveParent,
/*73258*/       OPC_SwitchType /*2 cases */, 72,  MVT::i32,// ->73333
/*73261*/         OPC_Scope, 34, /*->73297*/ // 2 children in Scope
/*73263*/           OPC_CheckPatternPredicate, 2, // (!Subtarget->is64Bit())
/*73265*/           OPC_EmitInteger, MVT::i32, X86::GR16_ABCDRegClassID,
/*73268*/           OPC_EmitNode, TARGET_OPCODE(TargetOpcode::COPY_TO_REGCLASS), 0,
                        1/*#VTs*/, MVT::i16, 2/*#Ops*/, 0, 1,  // Results = #2 
/*73277*/           OPC_EmitInteger, MVT::i32, 2, 
/*73280*/           OPC_EmitNode, TARGET_OPCODE(TargetOpcode::EXTRACT_SUBREG), 0,
                        1/*#VTs*/, MVT::i8, 2/*#Ops*/, 2, 3,  // Results = #4 
/*73289*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVZX32rr8), 0,
                        1/*#VTs*/, MVT::i32, 1/*#Ops*/, 4, 
                    // Src: (anyext:i32 (srl:i16 GR16:i16:$src, 8:i8)<<P:Predicate_srl_su>>)
                    // Dst: (MOVZX32rr8:i32 (EXTRACT_SUBREG:i8 (COPY_TO_REGCLASS:i16 GR16:i16:$src, GR16_ABCD:i16), 2:i32))
/*73297*/         /*Scope*/ 34, /*->73332*/
/*73298*/           OPC_CheckPatternPredicate, 3, // (Subtarget->is64Bit())
/*73300*/           OPC_EmitInteger, MVT::i32, X86::GR16_ABCDRegClassID,
/*73303*/           OPC_EmitNode, TARGET_OPCODE(TargetOpcode::COPY_TO_REGCLASS), 0,
                        1/*#VTs*/, MVT::i16, 2/*#Ops*/, 0, 1,  // Results = #2 
/*73312*/           OPC_EmitInteger, MVT::i32, 2, 
/*73315*/           OPC_EmitNode, TARGET_OPCODE(TargetOpcode::EXTRACT_SUBREG), 0,
                        1/*#VTs*/, MVT::i8, 2/*#Ops*/, 2, 3,  // Results = #4 
/*73324*/           OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVZX32_NOREXrr8), 0,
                        1/*#VTs*/, MVT::i32, 1/*#Ops*/, 4, 
                    // Src: (anyext:i32 (srl:i16 GR16:i16:$src, 8:i8)<<P:Predicate_srl_su>>)
                    // Dst: (MOVZX32_NOREXrr8:i32 (EXTRACT_SUBREG:i8 (COPY_TO_REGCLASS:i16 GR16:i16:$src, GR16_ABCD:i16), 2:i32))
/*73332*/         0, /*End of Scope*/
                /*SwitchType*/ 48,  MVT::i64,// ->73383
/*73335*/         OPC_EmitInteger, MVT::i64, 0, 
/*73338*/         OPC_EmitInteger, MVT::i32, X86::GR16_ABCDRegClassID,
/*73341*/         OPC_EmitNode, TARGET_OPCODE(TargetOpcode::COPY_TO_REGCLASS), 0,
                      1/*#VTs*/, MVT::i16, 2/*#Ops*/, 0, 2,  // Results = #3 
/*73350*/         OPC_EmitInteger, MVT::i32, 2, 
/*73353*/         OPC_EmitNode, TARGET_OPCODE(TargetOpcode::EXTRACT_SUBREG), 0,
                      1/*#VTs*/, MVT::i8, 2/*#Ops*/, 3, 4,  // Results = #5 
/*73362*/         OPC_EmitNode, TARGET_OPCODE(X86::MOVZX32_NOREXrr8), 0,
                      1/*#VTs*/, MVT::i32, 1/*#Ops*/, 5,  // Results = #6 
/*73370*/         OPC_EmitInteger, MVT::i32, 4, 
/*73373*/         OPC_MorphNodeTo, TARGET_OPCODE(TargetOpcode::SUBREG_TO_REG), 0,
                      1/*#VTs*/, MVT::i64, 3/*#Ops*/, 1, 6, 7, 
                  // Src: (anyext:i64 (srl:i16 GR16:i16:$src, 8:i8)<<P:Predicate_srl_su>>)
                  // Dst: (SUBREG_TO_REG:i64 0:i64, (MOVZX32_NOREXrr8:i32 (EXTRACT_SUBREG:i8 (COPY_TO_REGCLASS:i16 GR16:i16:$src, GR16_ABCD:i16), 2:i32)), 4:i32)
                0, // EndSwitchType
              /*SwitchOpcode*/ 47,  X86ISD::SETCC_CARRY,// ->73433
/*73386*/       OPC_MoveChild, 0,
/*73388*/       OPC_CheckInteger, 2, 
/*73390*/       OPC_MoveParent,
/*73391*/       OPC_RecordChild1, // #0 = physreg input EFLAGS
/*73392*/       OPC_CheckType, MVT::i8,
/*73394*/       OPC_MoveParent,
/*73395*/       OPC_SwitchType /*3 cases */, 10,  MVT::i16,// ->73408
/*73398*/         OPC_EmitCopyToReg, 0, X86::EFLAGS,
/*73401*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::SETB_C16r), 0|OPFL_FlagInput,
                      1/*#VTs*/, MVT::i16, 0/*#Ops*/, 
                  // Src: (anyext:i16 (X86setcc_c:i8 2:i8, EFLAGS:i32))
                  // Dst: (SETB_C16r:i16)
                /*SwitchType*/ 10,  MVT::i32,// ->73420
/*73410*/         OPC_EmitCopyToReg, 0, X86::EFLAGS,
/*73413*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::SETB_C32r), 0|OPFL_FlagInput,
                      1/*#VTs*/, MVT::i32, 0/*#Ops*/, 
                  // Src: (anyext:i32 (X86setcc_c:i8 2:i8, EFLAGS:i32))
                  // Dst: (SETB_C32r:i32)
                /*SwitchType*/ 10,  MVT::i64,// ->73432
/*73422*/         OPC_EmitCopyToReg, 0, X86::EFLAGS,
/*73425*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::SETB_C64r), 0|OPFL_FlagInput,
                      1/*#VTs*/, MVT::i64, 0/*#Ops*/, 
                  // Src: (anyext:i64 (X86setcc_c:i8 2:i8, EFLAGS:i32))
                  // Dst: (SETB_C64r:i64)
                0, // EndSwitchType
              0, // EndSwitchOpcode
/*73434*/   /*Scope*/ 84, /*->73519*/
/*73435*/     OPC_RecordChild0, // #0 = $src
/*73436*/     OPC_Scope, 20, /*->73458*/ // 3 children in Scope
/*73438*/       OPC_CheckChild0Type, MVT::i32,
/*73440*/       OPC_CheckType, MVT::i64,
/*73442*/       OPC_EmitInteger, MVT::i64, 0, 
/*73445*/       OPC_EmitInteger, MVT::i32, 4, 
/*73448*/       OPC_MorphNodeTo, TARGET_OPCODE(TargetOpcode::SUBREG_TO_REG), 0,
                    1/*#VTs*/, MVT::i64, 3/*#Ops*/, 1, 0, 2, 
                // Src: (anyext:i64 GR32:i32:$src)
                // Dst: (SUBREG_TO_REG:i64 0:i64, GR32:i32:$src, 4:i32)
/*73458*/     /*Scope*/ 34, /*->73493*/
/*73459*/       OPC_CheckChild0Type, MVT::i8,
/*73461*/       OPC_SwitchType /*3 cases */, 8,  MVT::i16,// ->73472
/*73464*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVZX16rr8), 0,
                      1/*#VTs*/, MVT::i16, 1/*#Ops*/, 0, 
                  // Src: (anyext:i16 GR8:i8:$src)
                  // Dst: (MOVZX16rr8:i16 GR8:i8:$src)
                /*SwitchType*/ 8,  MVT::i32,// ->73482
/*73474*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVZX32rr8), 0,
                      1/*#VTs*/, MVT::i32, 1/*#Ops*/, 0, 
                  // Src: (anyext:i32 GR8:i8:$src)
                  // Dst: (MOVZX32rr8:i32 GR8:i8:$src)
                /*SwitchType*/ 8,  MVT::i64,// ->73492
/*73484*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVZX64rr8), 0,
                      1/*#VTs*/, MVT::i64, 1/*#Ops*/, 0, 
                  // Src: (anyext:i64 GR8:i8:$src)
                  // Dst: (MOVZX64rr8:i64 GR8:i8:$src)
                0, // EndSwitchType
/*73493*/     /*Scope*/ 24, /*->73518*/
/*73494*/       OPC_CheckChild0Type, MVT::i16,
/*73496*/       OPC_SwitchType /*2 cases */, 8,  MVT::i32,// ->73507
/*73499*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVZX32rr16), 0,
                      1/*#VTs*/, MVT::i32, 1/*#Ops*/, 0, 
                  // Src: (anyext:i32 GR16:i16:$src)
                  // Dst: (MOVZX32rr16:i32 GR16:i16:$src)
                /*SwitchType*/ 8,  MVT::i64,// ->73517
/*73509*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVZX64rr16), 0,
                      1/*#VTs*/, MVT::i64, 1/*#Ops*/, 0, 
                  // Src: (anyext:i64 GR16:i16:$src)
                  // Dst: (MOVZX64rr16:i64 GR16:i16:$src)
                0, // EndSwitchType
/*73518*/     0, /*End of Scope*/
/*73519*/   0, /*End of Scope*/
          /*SwitchOpcode*/ 90|128,2/*346*/,  ISD::SRL,// ->73869
/*73523*/   OPC_RecordChild0, // #0 = $src1
/*73524*/   OPC_Scope, 90|128,1/*218*/, /*->73745*/ // 2 children in Scope
/*73527*/     OPC_MoveChild, 1,
/*73529*/     OPC_CheckType, MVT::i8,
/*73531*/     OPC_Scope, 45, /*->73578*/ // 4 children in Scope
/*73533*/       OPC_CheckAndImm, 31, 
/*73535*/       OPC_RecordChild0, // #1 = physreg input CL
/*73536*/       OPC_MoveParent,
/*73537*/       OPC_SwitchType /*3 cases */, 11,  MVT::i8,// ->73551
/*73540*/         OPC_EmitCopyToReg, 1, X86::CL,
/*73543*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::SHR8rCL), 0|OPFL_FlagInput,
                      1/*#VTs*/, MVT::i8, 1/*#Ops*/, 0, 
                  // Src: (srl:i8 GR8:i8:$src1, (and:i8 CL:i8, 31:i8))
                  // Dst: (SHR8rCL:i8 GR8:i8:$src1)
                /*SwitchType*/ 11,  MVT::i16,// ->73564
/*73553*/         OPC_EmitCopyToReg, 1, X86::CL,
/*73556*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::SHR16rCL), 0|OPFL_FlagInput,
                      1/*#VTs*/, MVT::i16, 1/*#Ops*/, 0, 
                  // Src: (srl:i16 GR16:i16:$src1, (and:i8 CL:i8, 31:i8))
                  // Dst: (SHR16rCL:i16 GR16:i16:$src1)
                /*SwitchType*/ 11,  MVT::i32,// ->73577
/*73566*/         OPC_EmitCopyToReg, 1, X86::CL,
/*73569*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::SHR32rCL), 0|OPFL_FlagInput,
                      1/*#VTs*/, MVT::i32, 1/*#Ops*/, 0, 
                  // Src: (srl:i32 GR32:i32:$src1, (and:i8 CL:i8, 31:i8))
                  // Dst: (SHR32rCL:i32 GR32:i32:$src1)
                0, // EndSwitchType
/*73578*/     /*Scope*/ 17, /*->73596*/
/*73579*/       OPC_CheckAndImm, 63, 
/*73581*/       OPC_RecordChild0, // #1 = physreg input CL
/*73582*/       OPC_MoveParent,
/*73583*/       OPC_CheckType, MVT::i64,
/*73585*/       OPC_EmitCopyToReg, 1, X86::CL,
/*73588*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::SHR64rCL), 0|OPFL_FlagInput,
                    1/*#VTs*/, MVT::i64, 1/*#Ops*/, 0, 
                // Src: (srl:i64 GR64:i64:$src1, (and:i8 CL:i8, 63:i8))
                // Dst: (SHR64rCL:i64 GR64:i64:$src1)
/*73596*/     /*Scope*/ 45, /*->73642*/
/*73597*/       OPC_CheckInteger, 1, 
/*73599*/       OPC_MoveParent,
/*73600*/       OPC_SwitchType /*4 cases */, 8,  MVT::i8,// ->73611
/*73603*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::SHR8r1), 0,
                      1/*#VTs*/, MVT::i8, 1/*#Ops*/, 0, 
                  // Src: (srl:i8 GR8:i8:$src1, 1:i8)
                  // Dst: (SHR8r1:i8 GR8:i8:$src1)
                /*SwitchType*/ 8,  MVT::i16,// ->73621
/*73613*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::SHR16r1), 0,
                      1/*#VTs*/, MVT::i16, 1/*#Ops*/, 0, 
                  // Src: (srl:i16 GR16:i16:$src1, 1:i8)
                  // Dst: (SHR16r1:i16 GR16:i16:$src1)
                /*SwitchType*/ 8,  MVT::i32,// ->73631
/*73623*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::SHR32r1), 0,
                      1/*#VTs*/, MVT::i32, 1/*#Ops*/, 0, 
                  // Src: (srl:i32 GR32:i32:$src1, 1:i8)
                  // Dst: (SHR32r1:i32 GR32:i32:$src1)
                /*SwitchType*/ 8,  MVT::i64,// ->73641
/*73633*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::SHR64r1), 0,
                      1/*#VTs*/, MVT::i64, 1/*#Ops*/, 0, 
                  // Src: (srl:i64 GR64:i64:$src1, 1:i8)
                  // Dst: (SHR64r1:i64 GR64:i64:$src1)
                0, // EndSwitchType
/*73642*/     /*Scope*/ 101, /*->73744*/
/*73643*/       OPC_CheckInteger, 8, 
/*73645*/       OPC_MoveParent,
/*73646*/       OPC_CheckType, MVT::i16,
/*73648*/       OPC_Scope, 46, /*->73696*/ // 2 children in Scope
/*73650*/         OPC_CheckPatternPredicate, 2, // (!Subtarget->is64Bit())
/*73652*/         OPC_EmitInteger, MVT::i32, X86::GR16_ABCDRegClassID,
/*73655*/         OPC_EmitNode, TARGET_OPCODE(TargetOpcode::COPY_TO_REGCLASS), 0,
                      1/*#VTs*/, MVT::i16, 2/*#Ops*/, 0, 1,  // Results = #2 
/*73664*/         OPC_EmitInteger, MVT::i32, 2, 
/*73667*/         OPC_EmitNode, TARGET_OPCODE(TargetOpcode::EXTRACT_SUBREG), 0,
                      1/*#VTs*/, MVT::i8, 2/*#Ops*/, 2, 3,  // Results = #4 
/*73676*/         OPC_EmitNode, TARGET_OPCODE(X86::MOVZX32rr8), 0,
                      1/*#VTs*/, MVT::i32, 1/*#Ops*/, 4,  // Results = #5 
/*73684*/         OPC_EmitInteger, MVT::i32, 3, 
/*73687*/         OPC_MorphNodeTo, TARGET_OPCODE(TargetOpcode::EXTRACT_SUBREG), 0,
                      1/*#VTs*/, MVT::i16, 2/*#Ops*/, 5, 6, 
                  // Src: (srl:i16 GR16:i16:$src, 8:i8)
                  // Dst: (EXTRACT_SUBREG:i16 (MOVZX32rr8:i32 (EXTRACT_SUBREG:i8 (COPY_TO_REGCLASS:i16 GR16:i16:$src, GR16_ABCD:i16), 2:i32)), 3:i32)
/*73696*/       /*Scope*/ 46, /*->73743*/
/*73697*/         OPC_CheckPatternPredicate, 3, // (Subtarget->is64Bit())
/*73699*/         OPC_EmitInteger, MVT::i32, X86::GR16_ABCDRegClassID,
/*73702*/         OPC_EmitNode, TARGET_OPCODE(TargetOpcode::COPY_TO_REGCLASS), 0,
                      1/*#VTs*/, MVT::i16, 2/*#Ops*/, 0, 1,  // Results = #2 
/*73711*/         OPC_EmitInteger, MVT::i32, 2, 
/*73714*/         OPC_EmitNode, TARGET_OPCODE(TargetOpcode::EXTRACT_SUBREG), 0,
                      1/*#VTs*/, MVT::i8, 2/*#Ops*/, 2, 3,  // Results = #4 
/*73723*/         OPC_EmitNode, TARGET_OPCODE(X86::MOVZX32_NOREXrr8), 0,
                      1/*#VTs*/, MVT::i32, 1/*#Ops*/, 4,  // Results = #5 
/*73731*/         OPC_EmitInteger, MVT::i32, 3, 
/*73734*/         OPC_MorphNodeTo, TARGET_OPCODE(TargetOpcode::EXTRACT_SUBREG), 0,
                      1/*#VTs*/, MVT::i16, 2/*#Ops*/, 5, 6, 
                  // Src: (srl:i16 GR16:i16:$src, 8:i8)
                  // Dst: (EXTRACT_SUBREG:i16 (MOVZX32_NOREXrr8:i32 (EXTRACT_SUBREG:i8 (COPY_TO_REGCLASS:i16 GR16:i16:$src, GR16_ABCD:i16), 2:i32)), 3:i32)
/*73743*/       0, /*End of Scope*/
/*73744*/     0, /*End of Scope*/
/*73745*/   /*Scope*/ 122, /*->73868*/
/*73746*/     OPC_RecordChild1, // #1 = $src2
/*73747*/     OPC_Scope, 61, /*->73810*/ // 2 children in Scope
/*73749*/       OPC_MoveChild, 1,
/*73751*/       OPC_CheckOpcode, ISD::Constant,
/*73753*/       OPC_CheckType, MVT::i8,
/*73755*/       OPC_MoveParent,
/*73756*/       OPC_SwitchType /*4 cases */, 11,  MVT::i8,// ->73770
/*73759*/         OPC_EmitConvertToTarget, 1,
/*73761*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::SHR8ri), 0,
                      1/*#VTs*/, MVT::i8, 2/*#Ops*/, 0, 2, 
                  // Src: (srl:i8 GR8:i8:$src1, (imm:i8):$src2)
                  // Dst: (SHR8ri:i8 GR8:i8:$src1, (imm:i8):$src2)
                /*SwitchType*/ 11,  MVT::i16,// ->73783
/*73772*/         OPC_EmitConvertToTarget, 1,
/*73774*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::SHR16ri), 0,
                      1/*#VTs*/, MVT::i16, 2/*#Ops*/, 0, 2, 
                  // Src: (srl:i16 GR16:i16:$src1, (imm:i8):$src2)
                  // Dst: (SHR16ri:i16 GR16:i16:$src1, (imm:i8):$src2)
                /*SwitchType*/ 11,  MVT::i32,// ->73796
/*73785*/         OPC_EmitConvertToTarget, 1,
/*73787*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::SHR32ri), 0,
                      1/*#VTs*/, MVT::i32, 2/*#Ops*/, 0, 2, 
                  // Src: (srl:i32 GR32:i32:$src1, (imm:i8):$src2)
                  // Dst: (SHR32ri:i32 GR32:i32:$src1, (imm:i8):$src2)
                /*SwitchType*/ 11,  MVT::i64,// ->73809
/*73798*/         OPC_EmitConvertToTarget, 1,
/*73800*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::SHR64ri), 0,
                      1/*#VTs*/, MVT::i64, 2/*#Ops*/, 0, 2, 
                  // Src: (srl:i64 GR64:i64:$src1, (imm:i8):$src2)
                  // Dst: (SHR64ri:i64 GR64:i64:$src1, (imm:i8):$src2)
                0, // EndSwitchType
/*73810*/     /*Scope*/ 56, /*->73867*/
/*73811*/       OPC_CheckChild1Type, MVT::i8,
/*73813*/       OPC_SwitchType /*4 cases */, 11,  MVT::i8,// ->73827
/*73816*/         OPC_EmitCopyToReg, 1, X86::CL,
/*73819*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::SHR8rCL), 0|OPFL_FlagInput,
                      1/*#VTs*/, MVT::i8, 1/*#Ops*/, 0, 
                  // Src: (srl:i8 GR8:i8:$src, CL:i8)
                  // Dst: (SHR8rCL:i8 GR8:i8:$src)
                /*SwitchType*/ 11,  MVT::i16,// ->73840
/*73829*/         OPC_EmitCopyToReg, 1, X86::CL,
/*73832*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::SHR16rCL), 0|OPFL_FlagInput,
                      1/*#VTs*/, MVT::i16, 1/*#Ops*/, 0, 
                  // Src: (srl:i16 GR16:i16:$src, CL:i8)
                  // Dst: (SHR16rCL:i16 GR16:i16:$src)
                /*SwitchType*/ 11,  MVT::i32,// ->73853
/*73842*/         OPC_EmitCopyToReg, 1, X86::CL,
/*73845*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::SHR32rCL), 0|OPFL_FlagInput,
                      1/*#VTs*/, MVT::i32, 1/*#Ops*/, 0, 
                  // Src: (srl:i32 GR32:i32:$src, CL:i8)
                  // Dst: (SHR32rCL:i32 GR32:i32:$src)
                /*SwitchType*/ 11,  MVT::i64,// ->73866
/*73855*/         OPC_EmitCopyToReg, 1, X86::CL,
/*73858*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::SHR64rCL), 0|OPFL_FlagInput,
                      1/*#VTs*/, MVT::i64, 1/*#Ops*/, 0, 
                  // Src: (srl:i64 GR64:i64:$src, CL:i8)
                  // Dst: (SHR64rCL:i64 GR64:i64:$src)
                0, // EndSwitchType
/*73867*/     0, /*End of Scope*/
/*73868*/   0, /*End of Scope*/
          /*SwitchOpcode*/ 115|128,1/*243*/,  ISD::SRA,// ->74115
/*73872*/   OPC_RecordChild0, // #0 = $src1
/*73873*/   OPC_Scope, 116, /*->73991*/ // 2 children in Scope
/*73875*/     OPC_MoveChild, 1,
/*73877*/     OPC_CheckType, MVT::i8,
/*73879*/     OPC_Scope, 45, /*->73926*/ // 3 children in Scope
/*73881*/       OPC_CheckAndImm, 31, 
/*73883*/       OPC_RecordChild0, // #1 = physreg input CL
/*73884*/       OPC_MoveParent,
/*73885*/       OPC_SwitchType /*3 cases */, 11,  MVT::i8,// ->73899
/*73888*/         OPC_EmitCopyToReg, 1, X86::CL,
/*73891*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::SAR8rCL), 0|OPFL_FlagInput,
                      1/*#VTs*/, MVT::i8, 1/*#Ops*/, 0, 
                  // Src: (sra:i8 GR8:i8:$src1, (and:i8 CL:i8, 31:i8))
                  // Dst: (SAR8rCL:i8 GR8:i8:$src1)
                /*SwitchType*/ 11,  MVT::i16,// ->73912
/*73901*/         OPC_EmitCopyToReg, 1, X86::CL,
/*73904*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::SAR16rCL), 0|OPFL_FlagInput,
                      1/*#VTs*/, MVT::i16, 1/*#Ops*/, 0, 
                  // Src: (sra:i16 GR16:i16:$src1, (and:i8 CL:i8, 31:i8))
                  // Dst: (SAR16rCL:i16 GR16:i16:$src1)
                /*SwitchType*/ 11,  MVT::i32,// ->73925
/*73914*/         OPC_EmitCopyToReg, 1, X86::CL,
/*73917*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::SAR32rCL), 0|OPFL_FlagInput,
                      1/*#VTs*/, MVT::i32, 1/*#Ops*/, 0, 
                  // Src: (sra:i32 GR32:i32:$src1, (and:i8 CL:i8, 31:i8))
                  // Dst: (SAR32rCL:i32 GR32:i32:$src1)
                0, // EndSwitchType
/*73926*/     /*Scope*/ 17, /*->73944*/
/*73927*/       OPC_CheckAndImm, 63, 
/*73929*/       OPC_RecordChild0, // #1 = physreg input CL
/*73930*/       OPC_MoveParent,
/*73931*/       OPC_CheckType, MVT::i64,
/*73933*/       OPC_EmitCopyToReg, 1, X86::CL,
/*73936*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::SAR64rCL), 0|OPFL_FlagInput,
                    1/*#VTs*/, MVT::i64, 1/*#Ops*/, 0, 
                // Src: (sra:i64 GR64:i64:$src1, (and:i8 CL:i8, 63:i8))
                // Dst: (SAR64rCL:i64 GR64:i64:$src1)
/*73944*/     /*Scope*/ 45, /*->73990*/
/*73945*/       OPC_CheckInteger, 1, 
/*73947*/       OPC_MoveParent,
/*73948*/       OPC_SwitchType /*4 cases */, 8,  MVT::i8,// ->73959
/*73951*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::SAR8r1), 0,
                      1/*#VTs*/, MVT::i8, 1/*#Ops*/, 0, 
                  // Src: (sra:i8 GR8:i8:$src1, 1:i8)
                  // Dst: (SAR8r1:i8 GR8:i8:$src1)
                /*SwitchType*/ 8,  MVT::i16,// ->73969
/*73961*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::SAR16r1), 0,
                      1/*#VTs*/, MVT::i16, 1/*#Ops*/, 0, 
                  // Src: (sra:i16 GR16:i16:$src1, 1:i8)
                  // Dst: (SAR16r1:i16 GR16:i16:$src1)
                /*SwitchType*/ 8,  MVT::i32,// ->73979
/*73971*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::SAR32r1), 0,
                      1/*#VTs*/, MVT::i32, 1/*#Ops*/, 0, 
                  // Src: (sra:i32 GR32:i32:$src1, 1:i8)
                  // Dst: (SAR32r1:i32 GR32:i32:$src1)
                /*SwitchType*/ 8,  MVT::i64,// ->73989
/*73981*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::SAR64r1), 0,
                      1/*#VTs*/, MVT::i64, 1/*#Ops*/, 0, 
                  // Src: (sra:i64 GR64:i64:$src1, 1:i8)
                  // Dst: (SAR64r1:i64 GR64:i64:$src1)
                0, // EndSwitchType
/*73990*/     0, /*End of Scope*/
/*73991*/   /*Scope*/ 122, /*->74114*/
/*73992*/     OPC_RecordChild1, // #1 = $src2
/*73993*/     OPC_Scope, 61, /*->74056*/ // 2 children in Scope
/*73995*/       OPC_MoveChild, 1,
/*73997*/       OPC_CheckOpcode, ISD::Constant,
/*73999*/       OPC_CheckType, MVT::i8,
/*74001*/       OPC_MoveParent,
/*74002*/       OPC_SwitchType /*4 cases */, 11,  MVT::i8,// ->74016
/*74005*/         OPC_EmitConvertToTarget, 1,
/*74007*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::SAR8ri), 0,
                      1/*#VTs*/, MVT::i8, 2/*#Ops*/, 0, 2, 
                  // Src: (sra:i8 GR8:i8:$src1, (imm:i8):$src2)
                  // Dst: (SAR8ri:i8 GR8:i8:$src1, (imm:i8):$src2)
                /*SwitchType*/ 11,  MVT::i16,// ->74029
/*74018*/         OPC_EmitConvertToTarget, 1,
/*74020*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::SAR16ri), 0,
                      1/*#VTs*/, MVT::i16, 2/*#Ops*/, 0, 2, 
                  // Src: (sra:i16 GR16:i16:$src1, (imm:i8):$src2)
                  // Dst: (SAR16ri:i16 GR16:i16:$src1, (imm:i8):$src2)
                /*SwitchType*/ 11,  MVT::i32,// ->74042
/*74031*/         OPC_EmitConvertToTarget, 1,
/*74033*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::SAR32ri), 0,
                      1/*#VTs*/, MVT::i32, 2/*#Ops*/, 0, 2, 
                  // Src: (sra:i32 GR32:i32:$src1, (imm:i8):$src2)
                  // Dst: (SAR32ri:i32 GR32:i32:$src1, (imm:i8):$src2)
                /*SwitchType*/ 11,  MVT::i64,// ->74055
/*74044*/         OPC_EmitConvertToTarget, 1,
/*74046*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::SAR64ri), 0,
                      1/*#VTs*/, MVT::i64, 2/*#Ops*/, 0, 2, 
                  // Src: (sra:i64 GR64:i64:$src1, (imm:i8):$src2)
                  // Dst: (SAR64ri:i64 GR64:i64:$src1, (imm:i8):$src2)
                0, // EndSwitchType
/*74056*/     /*Scope*/ 56, /*->74113*/
/*74057*/       OPC_CheckChild1Type, MVT::i8,
/*74059*/       OPC_SwitchType /*4 cases */, 11,  MVT::i8,// ->74073
/*74062*/         OPC_EmitCopyToReg, 1, X86::CL,
/*74065*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::SAR8rCL), 0|OPFL_FlagInput,
                      1/*#VTs*/, MVT::i8, 1/*#Ops*/, 0, 
                  // Src: (sra:i8 GR8:i8:$src, CL:i8)
                  // Dst: (SAR8rCL:i8 GR8:i8:$src)
                /*SwitchType*/ 11,  MVT::i16,// ->74086
/*74075*/         OPC_EmitCopyToReg, 1, X86::CL,
/*74078*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::SAR16rCL), 0|OPFL_FlagInput,
                      1/*#VTs*/, MVT::i16, 1/*#Ops*/, 0, 
                  // Src: (sra:i16 GR16:i16:$src, CL:i8)
                  // Dst: (SAR16rCL:i16 GR16:i16:$src)
                /*SwitchType*/ 11,  MVT::i32,// ->74099
/*74088*/         OPC_EmitCopyToReg, 1, X86::CL,
/*74091*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::SAR32rCL), 0|OPFL_FlagInput,
                      1/*#VTs*/, MVT::i32, 1/*#Ops*/, 0, 
                  // Src: (sra:i32 GR32:i32:$src, CL:i8)
                  // Dst: (SAR32rCL:i32 GR32:i32:$src)
                /*SwitchType*/ 11,  MVT::i64,// ->74112
/*74101*/         OPC_EmitCopyToReg, 1, X86::CL,
/*74104*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::SAR64rCL), 0|OPFL_FlagInput,
                      1/*#VTs*/, MVT::i64, 1/*#Ops*/, 0, 
                  // Src: (sra:i64 GR64:i64:$src, CL:i8)
                  // Dst: (SAR64rCL:i64 GR64:i64:$src)
                0, // EndSwitchType
/*74113*/     0, /*End of Scope*/
/*74114*/   0, /*End of Scope*/
          /*SwitchOpcode*/ 44,  ISD::CALLSEQ_END,// ->74161
/*74117*/   OPC_RecordNode,   // #0 = 'X86callseq_end' chained node
/*74118*/   OPC_CaptureFlagInput,
/*74119*/   OPC_RecordChild1, // #1 = $amt1
/*74120*/   OPC_MoveChild, 1,
/*74122*/   OPC_CheckOpcode, ISD::TargetConstant,
/*74124*/   OPC_MoveParent,
/*74125*/   OPC_RecordChild2, // #2 = $amt2
/*74126*/   OPC_MoveChild, 2,
/*74128*/   OPC_CheckOpcode, ISD::TargetConstant,
/*74130*/   OPC_MoveParent,
/*74131*/   OPC_Scope, 13, /*->74146*/ // 2 children in Scope
/*74133*/     OPC_CheckPatternPredicate, 2, // (!Subtarget->is64Bit())
/*74135*/     OPC_EmitMergeInputChains, 1, 0, 
/*74138*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::ADJCALLSTACKUP32), 0|OPFL_Chain|OPFL_FlagInput|OPFL_FlagOutput,
                  0/*#VTs*/, 2/*#Ops*/, 1, 2, 
              // Src: (X86callseq_end:isVoid (timm:i32):$amt1, (timm:i32):$amt2)
              // Dst: (ADJCALLSTACKUP32:isVoid (timm:i32):$amt1, (timm:i32):$amt2)
/*74146*/   /*Scope*/ 13, /*->74160*/
/*74147*/     OPC_CheckPatternPredicate, 3, // (Subtarget->is64Bit())
/*74149*/     OPC_EmitMergeInputChains, 1, 0, 
/*74152*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::ADJCALLSTACKUP64), 0|OPFL_Chain|OPFL_FlagInput|OPFL_FlagOutput,
                  0/*#VTs*/, 2/*#Ops*/, 1, 2, 
              // Src: (X86callseq_end:isVoid (timm:i32):$amt1, (timm:i32):$amt2)
              // Dst: (ADJCALLSTACKUP64:isVoid (timm:i32):$amt1, (timm:i32):$amt2)
/*74160*/   0, /*End of Scope*/
          /*SwitchOpcode*/ 22|128,1/*150*/,  X86ISD::TC_RETURN,// ->74314
/*74164*/   OPC_RecordNode,   // #0 = 'X86tcret' chained node
/*74165*/   OPC_CaptureFlagInput,
/*74166*/   OPC_RecordChild1, // #1 = $dst
/*74167*/   OPC_Scope, 100, /*->74269*/ // 3 children in Scope
/*74169*/     OPC_MoveChild, 1,
/*74171*/     OPC_SwitchOpcode /*2 cases */, 46,  ISD::TargetGlobalAddress,// ->74220
/*74174*/       OPC_SwitchType /*2 cases */, 20,  MVT::i32,// ->74197
/*74177*/         OPC_MoveParent,
/*74178*/         OPC_RecordChild2, // #2 = $off
/*74179*/         OPC_MoveChild, 2,
/*74181*/         OPC_CheckOpcode, ISD::Constant,
/*74183*/         OPC_MoveParent,
/*74184*/         OPC_EmitMergeInputChains, 1, 0, 
/*74187*/         OPC_EmitConvertToTarget, 2,
/*74189*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::TCRETURNdi), 0|OPFL_Chain|OPFL_FlagInput|OPFL_Variadic2,
                      0/*#VTs*/, 2/*#Ops*/, 1, 3, 
                  // Src: (X86tcret:isVoid (tglobaladdr:i32):$dst, (imm:i32):$off)
                  // Dst: (TCRETURNdi:isVoid (texternalsym:i32):$dst, (imm:i32):$off)
                /*SwitchType*/ 20,  MVT::i64,// ->74219
/*74199*/         OPC_MoveParent,
/*74200*/         OPC_RecordChild2, // #2 = $off
/*74201*/         OPC_MoveChild, 2,
/*74203*/         OPC_CheckOpcode, ISD::Constant,
/*74205*/         OPC_MoveParent,
/*74206*/         OPC_EmitMergeInputChains, 1, 0, 
/*74209*/         OPC_EmitConvertToTarget, 2,
/*74211*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::TCRETURNdi64), 0|OPFL_Chain|OPFL_FlagInput|OPFL_Variadic2,
                      0/*#VTs*/, 2/*#Ops*/, 1, 3, 
                  // Src: (X86tcret:isVoid (tglobaladdr:i64):$dst, (imm:i32):$off)
                  // Dst: (TCRETURNdi64:isVoid (tglobaladdr:i64):$dst, (imm:i32):$off)
                0, // EndSwitchType
              /*SwitchOpcode*/ 46,  ISD::TargetExternalSymbol,// ->74268
/*74222*/       OPC_SwitchType /*2 cases */, 20,  MVT::i32,// ->74245
/*74225*/         OPC_MoveParent,
/*74226*/         OPC_RecordChild2, // #2 = $off
/*74227*/         OPC_MoveChild, 2,
/*74229*/         OPC_CheckOpcode, ISD::Constant,
/*74231*/         OPC_MoveParent,
/*74232*/         OPC_EmitMergeInputChains, 1, 0, 
/*74235*/         OPC_EmitConvertToTarget, 2,
/*74237*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::TCRETURNdi), 0|OPFL_Chain|OPFL_FlagInput|OPFL_Variadic2,
                      0/*#VTs*/, 2/*#Ops*/, 1, 3, 
                  // Src: (X86tcret:isVoid (texternalsym:i32):$dst, (imm:i32):$off)
                  // Dst: (TCRETURNdi:isVoid (texternalsym:i32):$dst, (imm:i32):$off)
                /*SwitchType*/ 20,  MVT::i64,// ->74267
/*74247*/         OPC_MoveParent,
/*74248*/         OPC_RecordChild2, // #2 = $off
/*74249*/         OPC_MoveChild, 2,
/*74251*/         OPC_CheckOpcode, ISD::Constant,
/*74253*/         OPC_MoveParent,
/*74254*/         OPC_EmitMergeInputChains, 1, 0, 
/*74257*/         OPC_EmitConvertToTarget, 2,
/*74259*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::TCRETURNdi64), 0|OPFL_Chain|OPFL_FlagInput|OPFL_Variadic2,
                      0/*#VTs*/, 2/*#Ops*/, 1, 3, 
                  // Src: (X86tcret:isVoid (texternalsym:i64):$dst, (imm:i32):$off)
                  // Dst: (TCRETURNdi64:isVoid (texternalsym:i64):$dst, (imm:i32):$off)
                0, // EndSwitchType
              0, // EndSwitchOpcode
/*74269*/   /*Scope*/ 21, /*->74291*/
/*74270*/     OPC_CheckChild1Type, MVT::i32,
/*74272*/     OPC_RecordChild2, // #2 = $off
/*74273*/     OPC_MoveChild, 2,
/*74275*/     OPC_CheckOpcode, ISD::Constant,
/*74277*/     OPC_MoveParent,
/*74278*/     OPC_EmitMergeInputChains, 1, 0, 
/*74281*/     OPC_EmitConvertToTarget, 2,
/*74283*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::TCRETURNri), 0|OPFL_Chain|OPFL_FlagInput|OPFL_Variadic2,
                  0/*#VTs*/, 2/*#Ops*/, 1, 3, 
              // Src: (X86tcret:isVoid GR32:i32:$dst, (imm:i32):$off)
              // Dst: (TCRETURNri:isVoid GR32:i32:$dst, (imm:i32):$off)
/*74291*/   /*Scope*/ 21, /*->74313*/
/*74292*/     OPC_CheckChild1Type, MVT::i64,
/*74294*/     OPC_RecordChild2, // #2 = $off
/*74295*/     OPC_MoveChild, 2,
/*74297*/     OPC_CheckOpcode, ISD::Constant,
/*74299*/     OPC_MoveParent,
/*74300*/     OPC_EmitMergeInputChains, 1, 0, 
/*74303*/     OPC_EmitConvertToTarget, 2,
/*74305*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::TCRETURNri64), 0|OPFL_Chain|OPFL_FlagInput|OPFL_Variadic2,
                  0/*#VTs*/, 2/*#Ops*/, 1, 3, 
              // Src: (X86tcret:isVoid GR64:i64:$dst, (imm:i32):$off)
              // Dst: (TCRETURNri64:isVoid GR64:i64:$dst, (imm:i32):$off)
/*74313*/   0, /*End of Scope*/
          /*SwitchOpcode*/ 45|128,1/*173*/,  ISD::EXTRACT_VECTOR_ELT,// ->74490
/*74317*/   OPC_Scope, 31, /*->74350*/ // 2 children in Scope
/*74319*/     OPC_MoveChild, 0,
/*74321*/     OPC_CheckOpcode, ISD::BIT_CONVERT,
/*74323*/     OPC_RecordChild0, // #0 = $src1
/*74324*/     OPC_CheckChild0Type, MVT::v4f32,
/*74326*/     OPC_CheckType, MVT::v4i32,
/*74328*/     OPC_MoveParent,
/*74329*/     OPC_RecordChild1, // #1 = $src2
/*74330*/     OPC_MoveChild, 1,
/*74332*/     OPC_CheckOpcode, ISD::Constant,
/*74334*/     OPC_MoveParent,
/*74335*/     OPC_CheckType, MVT::i32,
/*74337*/     OPC_CheckPatternPredicate, 4, // (Subtarget->hasSSE41())
/*74339*/     OPC_EmitConvertToTarget, 1,
/*74341*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::EXTRACTPSrr), 0,
                  1/*#VTs*/, MVT::i32, 2/*#Ops*/, 0, 2, 
              // Src: (extractelt:i32 (bitconvert:v4i32 VR128:v4f32:$src1), (imm:iPTR):$src2)
              // Dst: (EXTRACTPSrr:i32 VR128:v4f32:$src1, (imm:i32):$src2)
/*74350*/   /*Scope*/ 9|128,1/*137*/, /*->74489*/
/*74352*/     OPC_RecordChild0, // #0 = $src
/*74353*/     OPC_Scope, 21, /*->74376*/ // 4 children in Scope
/*74355*/       OPC_CheckChild0Type, MVT::v4f32,
/*74357*/       OPC_MoveChild, 1,
/*74359*/       OPC_CheckInteger, 0, 
/*74361*/       OPC_MoveParent,
/*74362*/       OPC_CheckType, MVT::f32,
/*74364*/       OPC_EmitInteger, MVT::i32, 1, 
/*74367*/       OPC_MorphNodeTo, TARGET_OPCODE(TargetOpcode::EXTRACT_SUBREG), 0,
                    1/*#VTs*/, MVT::f32, 2/*#Ops*/, 0, 1, 
                // Src: (vector_extract:f32 VR128:v4f32:$src, 0:iPTR)
                // Dst: (EXTRACT_SUBREG:f32 VR128:v4f32:$src, 1:i32)
/*74376*/     /*Scope*/ 21, /*->74398*/
/*74377*/       OPC_CheckChild0Type, MVT::v2f64,
/*74379*/       OPC_MoveChild, 1,
/*74381*/       OPC_CheckInteger, 0, 
/*74383*/       OPC_MoveParent,
/*74384*/       OPC_CheckType, MVT::f64,
/*74386*/       OPC_EmitInteger, MVT::i32, 2, 
/*74389*/       OPC_MorphNodeTo, TARGET_OPCODE(TargetOpcode::EXTRACT_SUBREG), 0,
                    1/*#VTs*/, MVT::f64, 2/*#Ops*/, 0, 1, 
                // Src: (vector_extract:f64 VR128:v2f64:$src, 0:iPTR)
                // Dst: (EXTRACT_SUBREG:f64 VR128:v2f64:$src, 2:i32)
/*74398*/     /*Scope*/ 44, /*->74443*/
/*74399*/       OPC_CheckChild0Type, MVT::v2i64,
/*74401*/       OPC_Scope, 17, /*->74420*/ // 2 children in Scope
/*74403*/         OPC_MoveChild, 1,
/*74405*/         OPC_CheckInteger, 0, 
/*74407*/         OPC_MoveParent,
/*74408*/         OPC_CheckType, MVT::i64,
/*74410*/         OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*74412*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVPQIto64rr), 0,
                      1/*#VTs*/, MVT::i64, 1/*#Ops*/, 0, 
                  // Src: (vector_extract:i64 VR128:v2i64:$src, 0:iPTR)
                  // Dst: (MOVPQIto64rr:i64 VR128:v2i64:$src)
/*74420*/       /*Scope*/ 21, /*->74442*/
/*74421*/         OPC_RecordChild1, // #1 = $src2
/*74422*/         OPC_MoveChild, 1,
/*74424*/         OPC_CheckOpcode, ISD::Constant,
/*74426*/         OPC_MoveParent,
/*74427*/         OPC_CheckType, MVT::i64,
/*74429*/         OPC_CheckPatternPredicate, 4, // (Subtarget->hasSSE41())
/*74431*/         OPC_EmitConvertToTarget, 1,
/*74433*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::PEXTRQrr), 0,
                      1/*#VTs*/, MVT::i64, 2/*#Ops*/, 0, 2, 
                  // Src: (extractelt:i64 VR128:v2i64:$src1, (imm:iPTR):$src2)
                  // Dst: (PEXTRQrr:i64 VR128:v2i64:$src1, (imm:i32):$src2)
/*74442*/       0, /*End of Scope*/
/*74443*/     /*Scope*/ 44, /*->74488*/
/*74444*/       OPC_CheckChild0Type, MVT::v4i32,
/*74446*/       OPC_Scope, 17, /*->74465*/ // 2 children in Scope
/*74448*/         OPC_MoveChild, 1,
/*74450*/         OPC_CheckInteger, 0, 
/*74452*/         OPC_MoveParent,
/*74453*/         OPC_CheckType, MVT::i32,
/*74455*/         OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*74457*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVPDI2DIrr), 0,
                      1/*#VTs*/, MVT::i32, 1/*#Ops*/, 0, 
                  // Src: (vector_extract:i32 VR128:v4i32:$src, 0:iPTR)
                  // Dst: (MOVPDI2DIrr:i32 VR128:v4i32:$src)
/*74465*/       /*Scope*/ 21, /*->74487*/
/*74466*/         OPC_RecordChild1, // #1 = $src2
/*74467*/         OPC_MoveChild, 1,
/*74469*/         OPC_CheckOpcode, ISD::Constant,
/*74471*/         OPC_MoveParent,
/*74472*/         OPC_CheckType, MVT::i32,
/*74474*/         OPC_CheckPatternPredicate, 4, // (Subtarget->hasSSE41())
/*74476*/         OPC_EmitConvertToTarget, 1,
/*74478*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::PEXTRDrr), 0,
                      1/*#VTs*/, MVT::i32, 2/*#Ops*/, 0, 2, 
                  // Src: (extractelt:i32 VR128:v4i32:$src1, (imm:iPTR):$src2)
                  // Dst: (PEXTRDrr:i32 VR128:v4i32:$src1, (imm:i32):$src2)
/*74487*/       0, /*End of Scope*/
/*74488*/     0, /*End of Scope*/
/*74489*/   0, /*End of Scope*/
          /*SwitchOpcode*/ 30,  X86ISD::VASTART_SAVE_XMM_REGS,// ->74522
/*74492*/   OPC_RecordNode,   // #0 = 'X86vastart_save_xmm_regs' chained node
/*74493*/   OPC_RecordChild1, // #1 = $al
/*74494*/   OPC_RecordChild2, // #2 = $regsavefi
/*74495*/   OPC_MoveChild, 2,
/*74497*/   OPC_CheckOpcode, ISD::Constant,
/*74499*/   OPC_MoveParent,
/*74500*/   OPC_RecordChild3, // #3 = $offset
/*74501*/   OPC_MoveChild, 3,
/*74503*/   OPC_CheckOpcode, ISD::Constant,
/*74505*/   OPC_MoveParent,
/*74506*/   OPC_EmitMergeInputChains, 1, 0, 
/*74509*/   OPC_EmitConvertToTarget, 2,
/*74511*/   OPC_EmitConvertToTarget, 3,
/*74513*/   OPC_MorphNodeTo, TARGET_OPCODE(X86::VASTART_SAVE_XMM_REGS), 0|OPFL_Chain|OPFL_Variadic3,
                0/*#VTs*/, 3/*#Ops*/, 1, 4, 5, 
            // Src: (X86vastart_save_xmm_regs:isVoid GR8:i8:$al, (imm:iPTR):$regsavefi, (imm:iPTR):$offset)
            // Dst: (VASTART_SAVE_XMM_REGS:isVoid GR8:i8:$al, (imm:i64):$regsavefi, (imm:i64):$offset)
          /*SwitchOpcode*/ 36,  X86ISD::RET_FLAG,// ->74560
/*74524*/   OPC_RecordNode,   // #0 = 'X86retflag' chained node
/*74525*/   OPC_CaptureFlagInput,
/*74526*/   OPC_Scope, 14, /*->74542*/ // 2 children in Scope
/*74528*/     OPC_MoveChild, 1,
/*74530*/     OPC_CheckInteger, 0, 
/*74532*/     OPC_MoveParent,
/*74533*/     OPC_EmitMergeInputChains, 1, 0, 
/*74536*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::RET), 0|OPFL_Chain|OPFL_FlagInput|OPFL_Variadic1,
                  0/*#VTs*/, 0/*#Ops*/, 
              // Src: (X86retflag:isVoid 0:i16)
              // Dst: (RET:isVoid)
/*74542*/   /*Scope*/ 16, /*->74559*/
/*74543*/     OPC_RecordChild1, // #1 = $amt
/*74544*/     OPC_MoveChild, 1,
/*74546*/     OPC_CheckOpcode, ISD::TargetConstant,
/*74548*/     OPC_MoveParent,
/*74549*/     OPC_EmitMergeInputChains, 1, 0, 
/*74552*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::RETI), 0|OPFL_Chain|OPFL_FlagInput|OPFL_Variadic1,
                  0/*#VTs*/, 1/*#Ops*/, 1, 
              // Src: (X86retflag:isVoid (timm:i16):$amt)
              // Dst: (RETI:isVoid (timm:i16):$amt)
/*74559*/   0, /*End of Scope*/
          /*SwitchOpcode*/ 43|128,2/*299*/,  X86ISD::BRCOND,// ->74862
/*74563*/   OPC_RecordNode,   // #0 = 'X86brcond' chained node
/*74564*/   OPC_RecordChild1, // #1 = $dst
/*74565*/   OPC_MoveChild, 1,
/*74567*/   OPC_CheckOpcode, ISD::BasicBlock,
/*74569*/   OPC_MoveParent,
/*74570*/   OPC_MoveChild, 2,
/*74572*/   OPC_Scope, 17, /*->74591*/ // 16 children in Scope
/*74574*/     OPC_CheckInteger, 13, 
/*74576*/     OPC_MoveParent,
/*74577*/     OPC_RecordChild3, // #2 = physreg input EFLAGS
/*74578*/     OPC_EmitMergeInputChains, 1, 0, 
/*74581*/     OPC_EmitCopyToReg, 2, X86::EFLAGS,
/*74584*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::JO_4), 0|OPFL_Chain|OPFL_FlagInput,
                  0/*#VTs*/, 1/*#Ops*/, 1, 
              // Src: (X86brcond:isVoid (bb:Other):$dst, 13:i8, EFLAGS:i32)
              // Dst: (JO_4:isVoid (bb:Other):$dst)
/*74591*/   /*Scope*/ 17, /*->74609*/
/*74592*/     OPC_CheckInteger, 10, 
/*74594*/     OPC_MoveParent,
/*74595*/     OPC_RecordChild3, // #2 = physreg input EFLAGS
/*74596*/     OPC_EmitMergeInputChains, 1, 0, 
/*74599*/     OPC_EmitCopyToReg, 2, X86::EFLAGS,
/*74602*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::JNO_4), 0|OPFL_Chain|OPFL_FlagInput,
                  0/*#VTs*/, 1/*#Ops*/, 1, 
              // Src: (X86brcond:isVoid (bb:Other):$dst, 10:i8, EFLAGS:i32)
              // Dst: (JNO_4:isVoid (bb:Other):$dst)
/*74609*/   /*Scope*/ 17, /*->74627*/
/*74610*/     OPC_CheckInteger, 2, 
/*74612*/     OPC_MoveParent,
/*74613*/     OPC_RecordChild3, // #2 = physreg input EFLAGS
/*74614*/     OPC_EmitMergeInputChains, 1, 0, 
/*74617*/     OPC_EmitCopyToReg, 2, X86::EFLAGS,
/*74620*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::JB_4), 0|OPFL_Chain|OPFL_FlagInput,
                  0/*#VTs*/, 1/*#Ops*/, 1, 
              // Src: (X86brcond:isVoid (bb:Other):$dst, 2:i8, EFLAGS:i32)
              // Dst: (JB_4:isVoid (bb:Other):$dst)
/*74627*/   /*Scope*/ 17, /*->74645*/
/*74628*/     OPC_CheckInteger, 1, 
/*74630*/     OPC_MoveParent,
/*74631*/     OPC_RecordChild3, // #2 = physreg input EFLAGS
/*74632*/     OPC_EmitMergeInputChains, 1, 0, 
/*74635*/     OPC_EmitCopyToReg, 2, X86::EFLAGS,
/*74638*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::JAE_4), 0|OPFL_Chain|OPFL_FlagInput,
                  0/*#VTs*/, 1/*#Ops*/, 1, 
              // Src: (X86brcond:isVoid (bb:Other):$dst, 1:i8, EFLAGS:i32)
              // Dst: (JAE_4:isVoid (bb:Other):$dst)
/*74645*/   /*Scope*/ 17, /*->74663*/
/*74646*/     OPC_CheckInteger, 4, 
/*74648*/     OPC_MoveParent,
/*74649*/     OPC_RecordChild3, // #2 = physreg input EFLAGS
/*74650*/     OPC_EmitMergeInputChains, 1, 0, 
/*74653*/     OPC_EmitCopyToReg, 2, X86::EFLAGS,
/*74656*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::JE_4), 0|OPFL_Chain|OPFL_FlagInput,
                  0/*#VTs*/, 1/*#Ops*/, 1, 
              // Src: (X86brcond:isVoid (bb:Other):$dst, 4:i8, EFLAGS:i32)
              // Dst: (JE_4:isVoid (bb:Other):$dst)
/*74663*/   /*Scope*/ 17, /*->74681*/
/*74664*/     OPC_CheckInteger, 9, 
/*74666*/     OPC_MoveParent,
/*74667*/     OPC_RecordChild3, // #2 = physreg input EFLAGS
/*74668*/     OPC_EmitMergeInputChains, 1, 0, 
/*74671*/     OPC_EmitCopyToReg, 2, X86::EFLAGS,
/*74674*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::JNE_4), 0|OPFL_Chain|OPFL_FlagInput,
                  0/*#VTs*/, 1/*#Ops*/, 1, 
              // Src: (X86brcond:isVoid (bb:Other):$dst, 9:i8, EFLAGS:i32)
              // Dst: (JNE_4:isVoid (bb:Other):$dst)
/*74681*/   /*Scope*/ 17, /*->74699*/
/*74682*/     OPC_CheckInteger, 3, 
/*74684*/     OPC_MoveParent,
/*74685*/     OPC_RecordChild3, // #2 = physreg input EFLAGS
/*74686*/     OPC_EmitMergeInputChains, 1, 0, 
/*74689*/     OPC_EmitCopyToReg, 2, X86::EFLAGS,
/*74692*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::JBE_4), 0|OPFL_Chain|OPFL_FlagInput,
                  0/*#VTs*/, 1/*#Ops*/, 1, 
              // Src: (X86brcond:isVoid (bb:Other):$dst, 3:i8, EFLAGS:i32)
              // Dst: (JBE_4:isVoid (bb:Other):$dst)
/*74699*/   /*Scope*/ 17, /*->74717*/
/*74700*/     OPC_CheckInteger, 0, 
/*74702*/     OPC_MoveParent,
/*74703*/     OPC_RecordChild3, // #2 = physreg input EFLAGS
/*74704*/     OPC_EmitMergeInputChains, 1, 0, 
/*74707*/     OPC_EmitCopyToReg, 2, X86::EFLAGS,
/*74710*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::JA_4), 0|OPFL_Chain|OPFL_FlagInput,
                  0/*#VTs*/, 1/*#Ops*/, 1, 
              // Src: (X86brcond:isVoid (bb:Other):$dst, 0:i8, EFLAGS:i32)
              // Dst: (JA_4:isVoid (bb:Other):$dst)
/*74717*/   /*Scope*/ 17, /*->74735*/
/*74718*/     OPC_CheckInteger, 15, 
/*74720*/     OPC_MoveParent,
/*74721*/     OPC_RecordChild3, // #2 = physreg input EFLAGS
/*74722*/     OPC_EmitMergeInputChains, 1, 0, 
/*74725*/     OPC_EmitCopyToReg, 2, X86::EFLAGS,
/*74728*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::JS_4), 0|OPFL_Chain|OPFL_FlagInput,
                  0/*#VTs*/, 1/*#Ops*/, 1, 
              // Src: (X86brcond:isVoid (bb:Other):$dst, 15:i8, EFLAGS:i32)
              // Dst: (JS_4:isVoid (bb:Other):$dst)
/*74735*/   /*Scope*/ 17, /*->74753*/
/*74736*/     OPC_CheckInteger, 12, 
/*74738*/     OPC_MoveParent,
/*74739*/     OPC_RecordChild3, // #2 = physreg input EFLAGS
/*74740*/     OPC_EmitMergeInputChains, 1, 0, 
/*74743*/     OPC_EmitCopyToReg, 2, X86::EFLAGS,
/*74746*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::JNS_4), 0|OPFL_Chain|OPFL_FlagInput,
                  0/*#VTs*/, 1/*#Ops*/, 1, 
              // Src: (X86brcond:isVoid (bb:Other):$dst, 12:i8, EFLAGS:i32)
              // Dst: (JNS_4:isVoid (bb:Other):$dst)
/*74753*/   /*Scope*/ 17, /*->74771*/
/*74754*/     OPC_CheckInteger, 14, 
/*74756*/     OPC_MoveParent,
/*74757*/     OPC_RecordChild3, // #2 = physreg input EFLAGS
/*74758*/     OPC_EmitMergeInputChains, 1, 0, 
/*74761*/     OPC_EmitCopyToReg, 2, X86::EFLAGS,
/*74764*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::JP_4), 0|OPFL_Chain|OPFL_FlagInput,
                  0/*#VTs*/, 1/*#Ops*/, 1, 
              // Src: (X86brcond:isVoid (bb:Other):$dst, 14:i8, EFLAGS:i32)
              // Dst: (JP_4:isVoid (bb:Other):$dst)
/*74771*/   /*Scope*/ 17, /*->74789*/
/*74772*/     OPC_CheckInteger, 11, 
/*74774*/     OPC_MoveParent,
/*74775*/     OPC_RecordChild3, // #2 = physreg input EFLAGS
/*74776*/     OPC_EmitMergeInputChains, 1, 0, 
/*74779*/     OPC_EmitCopyToReg, 2, X86::EFLAGS,
/*74782*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::JNP_4), 0|OPFL_Chain|OPFL_FlagInput,
                  0/*#VTs*/, 1/*#Ops*/, 1, 
              // Src: (X86brcond:isVoid (bb:Other):$dst, 11:i8, EFLAGS:i32)
              // Dst: (JNP_4:isVoid (bb:Other):$dst)
/*74789*/   /*Scope*/ 17, /*->74807*/
/*74790*/     OPC_CheckInteger, 7, 
/*74792*/     OPC_MoveParent,
/*74793*/     OPC_RecordChild3, // #2 = physreg input EFLAGS
/*74794*/     OPC_EmitMergeInputChains, 1, 0, 
/*74797*/     OPC_EmitCopyToReg, 2, X86::EFLAGS,
/*74800*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::JL_4), 0|OPFL_Chain|OPFL_FlagInput,
                  0/*#VTs*/, 1/*#Ops*/, 1, 
              // Src: (X86brcond:isVoid (bb:Other):$dst, 7:i8, EFLAGS:i32)
              // Dst: (JL_4:isVoid (bb:Other):$dst)
/*74807*/   /*Scope*/ 17, /*->74825*/
/*74808*/     OPC_CheckInteger, 6, 
/*74810*/     OPC_MoveParent,
/*74811*/     OPC_RecordChild3, // #2 = physreg input EFLAGS
/*74812*/     OPC_EmitMergeInputChains, 1, 0, 
/*74815*/     OPC_EmitCopyToReg, 2, X86::EFLAGS,
/*74818*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::JGE_4), 0|OPFL_Chain|OPFL_FlagInput,
                  0/*#VTs*/, 1/*#Ops*/, 1, 
              // Src: (X86brcond:isVoid (bb:Other):$dst, 6:i8, EFLAGS:i32)
              // Dst: (JGE_4:isVoid (bb:Other):$dst)
/*74825*/   /*Scope*/ 17, /*->74843*/
/*74826*/     OPC_CheckInteger, 8, 
/*74828*/     OPC_MoveParent,
/*74829*/     OPC_RecordChild3, // #2 = physreg input EFLAGS
/*74830*/     OPC_EmitMergeInputChains, 1, 0, 
/*74833*/     OPC_EmitCopyToReg, 2, X86::EFLAGS,
/*74836*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::JLE_4), 0|OPFL_Chain|OPFL_FlagInput,
                  0/*#VTs*/, 1/*#Ops*/, 1, 
              // Src: (X86brcond:isVoid (bb:Other):$dst, 8:i8, EFLAGS:i32)
              // Dst: (JLE_4:isVoid (bb:Other):$dst)
/*74843*/   /*Scope*/ 17, /*->74861*/
/*74844*/     OPC_CheckInteger, 5, 
/*74846*/     OPC_MoveParent,
/*74847*/     OPC_RecordChild3, // #2 = physreg input EFLAGS
/*74848*/     OPC_EmitMergeInputChains, 1, 0, 
/*74851*/     OPC_EmitCopyToReg, 2, X86::EFLAGS,
/*74854*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::JG_4), 0|OPFL_Chain|OPFL_FlagInput,
                  0/*#VTs*/, 1/*#Ops*/, 1, 
              // Src: (X86brcond:isVoid (bb:Other):$dst, 5:i8, EFLAGS:i32)
              // Dst: (JG_4:isVoid (bb:Other):$dst)
/*74861*/   0, /*End of Scope*/
          /*SwitchOpcode*/ 48|128,1/*176*/,  ISD::ROTL,// ->75041
/*74865*/   OPC_RecordChild0, // #0 = $src1
/*74866*/   OPC_Scope, 49, /*->74917*/ // 2 children in Scope
/*74868*/     OPC_MoveChild, 1,
/*74870*/     OPC_CheckInteger, 1, 
/*74872*/     OPC_CheckType, MVT::i8,
/*74874*/     OPC_MoveParent,
/*74875*/     OPC_SwitchType /*4 cases */, 8,  MVT::i8,// ->74886
/*74878*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::ROL8r1), 0,
                    1/*#VTs*/, MVT::i8, 1/*#Ops*/, 0, 
                // Src: (rotl:i8 GR8:i8:$src1, 1:i8)
                // Dst: (ROL8r1:i8 GR8:i8:$src1)
              /*SwitchType*/ 8,  MVT::i16,// ->74896
/*74888*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::ROL16r1), 0,
                    1/*#VTs*/, MVT::i16, 1/*#Ops*/, 0, 
                // Src: (rotl:i16 GR16:i16:$src1, 1:i8)
                // Dst: (ROL16r1:i16 GR16:i16:$src1)
              /*SwitchType*/ 8,  MVT::i32,// ->74906
/*74898*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::ROL32r1), 0,
                    1/*#VTs*/, MVT::i32, 1/*#Ops*/, 0, 
                // Src: (rotl:i32 GR32:i32:$src1, 1:i8)
                // Dst: (ROL32r1:i32 GR32:i32:$src1)
              /*SwitchType*/ 8,  MVT::i64,// ->74916
/*74908*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::ROL64r1), 0,
                    1/*#VTs*/, MVT::i64, 1/*#Ops*/, 0, 
                // Src: (rotl:i64 GR64:i64:$src1, 1:i8)
                // Dst: (ROL64r1:i64 GR64:i64:$src1)
              0, // EndSwitchType
/*74917*/   /*Scope*/ 122, /*->75040*/
/*74918*/     OPC_RecordChild1, // #1 = $src2
/*74919*/     OPC_Scope, 61, /*->74982*/ // 2 children in Scope
/*74921*/       OPC_MoveChild, 1,
/*74923*/       OPC_CheckOpcode, ISD::Constant,
/*74925*/       OPC_CheckType, MVT::i8,
/*74927*/       OPC_MoveParent,
/*74928*/       OPC_SwitchType /*4 cases */, 11,  MVT::i8,// ->74942
/*74931*/         OPC_EmitConvertToTarget, 1,
/*74933*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::ROL8ri), 0,
                      1/*#VTs*/, MVT::i8, 2/*#Ops*/, 0, 2, 
                  // Src: (rotl:i8 GR8:i8:$src1, (imm:i8):$src2)
                  // Dst: (ROL8ri:i8 GR8:i8:$src1, (imm:i8):$src2)
                /*SwitchType*/ 11,  MVT::i16,// ->74955
/*74944*/         OPC_EmitConvertToTarget, 1,
/*74946*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::ROL16ri), 0,
                      1/*#VTs*/, MVT::i16, 2/*#Ops*/, 0, 2, 
                  // Src: (rotl:i16 GR16:i16:$src1, (imm:i8):$src2)
                  // Dst: (ROL16ri:i16 GR16:i16:$src1, (imm:i8):$src2)
                /*SwitchType*/ 11,  MVT::i32,// ->74968
/*74957*/         OPC_EmitConvertToTarget, 1,
/*74959*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::ROL32ri), 0,
                      1/*#VTs*/, MVT::i32, 2/*#Ops*/, 0, 2, 
                  // Src: (rotl:i32 GR32:i32:$src1, (imm:i8):$src2)
                  // Dst: (ROL32ri:i32 GR32:i32:$src1, (imm:i8):$src2)
                /*SwitchType*/ 11,  MVT::i64,// ->74981
/*74970*/         OPC_EmitConvertToTarget, 1,
/*74972*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::ROL64ri), 0,
                      1/*#VTs*/, MVT::i64, 2/*#Ops*/, 0, 2, 
                  // Src: (rotl:i64 GR64:i64:$src1, (imm:i8):$src2)
                  // Dst: (ROL64ri:i64 GR64:i64:$src1, (imm:i8):$src2)
                0, // EndSwitchType
/*74982*/     /*Scope*/ 56, /*->75039*/
/*74983*/       OPC_CheckChild1Type, MVT::i8,
/*74985*/       OPC_SwitchType /*4 cases */, 11,  MVT::i8,// ->74999
/*74988*/         OPC_EmitCopyToReg, 1, X86::CL,
/*74991*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::ROL8rCL), 0|OPFL_FlagInput,
                      1/*#VTs*/, MVT::i8, 1/*#Ops*/, 0, 
                  // Src: (rotl:i8 GR8:i8:$src, CL:i8)
                  // Dst: (ROL8rCL:i8 GR8:i8:$src)
                /*SwitchType*/ 11,  MVT::i16,// ->75012
/*75001*/         OPC_EmitCopyToReg, 1, X86::CL,
/*75004*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::ROL16rCL), 0|OPFL_FlagInput,
                      1/*#VTs*/, MVT::i16, 1/*#Ops*/, 0, 
                  // Src: (rotl:i16 GR16:i16:$src, CL:i8)
                  // Dst: (ROL16rCL:i16 GR16:i16:$src)
                /*SwitchType*/ 11,  MVT::i32,// ->75025
/*75014*/         OPC_EmitCopyToReg, 1, X86::CL,
/*75017*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::ROL32rCL), 0|OPFL_FlagInput,
                      1/*#VTs*/, MVT::i32, 1/*#Ops*/, 0, 
                  // Src: (rotl:i32 GR32:i32:$src, CL:i8)
                  // Dst: (ROL32rCL:i32 GR32:i32:$src)
                /*SwitchType*/ 11,  MVT::i64,// ->75038
/*75027*/         OPC_EmitCopyToReg, 1, X86::CL,
/*75030*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::ROL64rCL), 0|OPFL_FlagInput,
                      1/*#VTs*/, MVT::i64, 1/*#Ops*/, 0, 
                  // Src: (rotl:i64 GR64:i64:$src, CL:i8)
                  // Dst: (ROL64rCL:i64 GR64:i64:$src)
                0, // EndSwitchType
/*75039*/     0, /*End of Scope*/
/*75040*/   0, /*End of Scope*/
          /*SwitchOpcode*/ 48|128,1/*176*/,  ISD::ROTR,// ->75220
/*75044*/   OPC_RecordChild0, // #0 = $src1
/*75045*/   OPC_Scope, 49, /*->75096*/ // 2 children in Scope
/*75047*/     OPC_MoveChild, 1,
/*75049*/     OPC_CheckInteger, 1, 
/*75051*/     OPC_CheckType, MVT::i8,
/*75053*/     OPC_MoveParent,
/*75054*/     OPC_SwitchType /*4 cases */, 8,  MVT::i8,// ->75065
/*75057*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::ROR8r1), 0,
                    1/*#VTs*/, MVT::i8, 1/*#Ops*/, 0, 
                // Src: (rotr:i8 GR8:i8:$src1, 1:i8)
                // Dst: (ROR8r1:i8 GR8:i8:$src1)
              /*SwitchType*/ 8,  MVT::i16,// ->75075
/*75067*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::ROR16r1), 0,
                    1/*#VTs*/, MVT::i16, 1/*#Ops*/, 0, 
                // Src: (rotr:i16 GR16:i16:$src1, 1:i8)
                // Dst: (ROR16r1:i16 GR16:i16:$src1)
              /*SwitchType*/ 8,  MVT::i32,// ->75085
/*75077*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::ROR32r1), 0,
                    1/*#VTs*/, MVT::i32, 1/*#Ops*/, 0, 
                // Src: (rotr:i32 GR32:i32:$src1, 1:i8)
                // Dst: (ROR32r1:i32 GR32:i32:$src1)
              /*SwitchType*/ 8,  MVT::i64,// ->75095
/*75087*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::ROR64r1), 0,
                    1/*#VTs*/, MVT::i64, 1/*#Ops*/, 0, 
                // Src: (rotr:i64 GR64:i64:$src1, 1:i8)
                // Dst: (ROR64r1:i64 GR64:i64:$src1)
              0, // EndSwitchType
/*75096*/   /*Scope*/ 122, /*->75219*/
/*75097*/     OPC_RecordChild1, // #1 = $src2
/*75098*/     OPC_Scope, 61, /*->75161*/ // 2 children in Scope
/*75100*/       OPC_MoveChild, 1,
/*75102*/       OPC_CheckOpcode, ISD::Constant,
/*75104*/       OPC_CheckType, MVT::i8,
/*75106*/       OPC_MoveParent,
/*75107*/       OPC_SwitchType /*4 cases */, 11,  MVT::i8,// ->75121
/*75110*/         OPC_EmitConvertToTarget, 1,
/*75112*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::ROR8ri), 0,
                      1/*#VTs*/, MVT::i8, 2/*#Ops*/, 0, 2, 
                  // Src: (rotr:i8 GR8:i8:$src1, (imm:i8):$src2)
                  // Dst: (ROR8ri:i8 GR8:i8:$src1, (imm:i8):$src2)
                /*SwitchType*/ 11,  MVT::i16,// ->75134
/*75123*/         OPC_EmitConvertToTarget, 1,
/*75125*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::ROR16ri), 0,
                      1/*#VTs*/, MVT::i16, 2/*#Ops*/, 0, 2, 
                  // Src: (rotr:i16 GR16:i16:$src1, (imm:i8):$src2)
                  // Dst: (ROR16ri:i16 GR16:i16:$src1, (imm:i8):$src2)
                /*SwitchType*/ 11,  MVT::i32,// ->75147
/*75136*/         OPC_EmitConvertToTarget, 1,
/*75138*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::ROR32ri), 0,
                      1/*#VTs*/, MVT::i32, 2/*#Ops*/, 0, 2, 
                  // Src: (rotr:i32 GR32:i32:$src1, (imm:i8):$src2)
                  // Dst: (ROR32ri:i32 GR32:i32:$src1, (imm:i8):$src2)
                /*SwitchType*/ 11,  MVT::i64,// ->75160
/*75149*/         OPC_EmitConvertToTarget, 1,
/*75151*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::ROR64ri), 0,
                      1/*#VTs*/, MVT::i64, 2/*#Ops*/, 0, 2, 
                  // Src: (rotr:i64 GR64:i64:$src1, (imm:i8):$src2)
                  // Dst: (ROR64ri:i64 GR64:i64:$src1, (imm:i8):$src2)
                0, // EndSwitchType
/*75161*/     /*Scope*/ 56, /*->75218*/
/*75162*/       OPC_CheckChild1Type, MVT::i8,
/*75164*/       OPC_SwitchType /*4 cases */, 11,  MVT::i8,// ->75178
/*75167*/         OPC_EmitCopyToReg, 1, X86::CL,
/*75170*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::ROR8rCL), 0|OPFL_FlagInput,
                      1/*#VTs*/, MVT::i8, 1/*#Ops*/, 0, 
                  // Src: (rotr:i8 GR8:i8:$src, CL:i8)
                  // Dst: (ROR8rCL:i8 GR8:i8:$src)
                /*SwitchType*/ 11,  MVT::i16,// ->75191
/*75180*/         OPC_EmitCopyToReg, 1, X86::CL,
/*75183*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::ROR16rCL), 0|OPFL_FlagInput,
                      1/*#VTs*/, MVT::i16, 1/*#Ops*/, 0, 
                  // Src: (rotr:i16 GR16:i16:$src, CL:i8)
                  // Dst: (ROR16rCL:i16 GR16:i16:$src)
                /*SwitchType*/ 11,  MVT::i32,// ->75204
/*75193*/         OPC_EmitCopyToReg, 1, X86::CL,
/*75196*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::ROR32rCL), 0|OPFL_FlagInput,
                      1/*#VTs*/, MVT::i32, 1/*#Ops*/, 0, 
                  // Src: (rotr:i32 GR32:i32:$src, CL:i8)
                  // Dst: (ROR32rCL:i32 GR32:i32:$src)
                /*SwitchType*/ 11,  MVT::i64,// ->75217
/*75206*/         OPC_EmitCopyToReg, 1, X86::CL,
/*75209*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::ROR64rCL), 0|OPFL_FlagInput,
                      1/*#VTs*/, MVT::i64, 1/*#Ops*/, 0, 
                  // Src: (rotr:i64 GR64:i64:$src, CL:i8)
                  // Dst: (ROR64rCL:i64 GR64:i64:$src)
                0, // EndSwitchType
/*75218*/     0, /*End of Scope*/
/*75219*/   0, /*End of Scope*/
          /*SwitchOpcode*/ 56,  X86ISD::SETCC_CARRY,// ->75278
/*75222*/   OPC_MoveChild, 0,
/*75224*/   OPC_CheckInteger, 2, 
/*75226*/   OPC_MoveParent,
/*75227*/   OPC_RecordChild1, // #0 = physreg input EFLAGS
/*75228*/   OPC_SwitchType /*4 cases */, 10,  MVT::i8,// ->75241
/*75231*/     OPC_EmitCopyToReg, 0, X86::EFLAGS,
/*75234*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::SETB_C8r), 0|OPFL_FlagInput,
                  1/*#VTs*/, MVT::i8, 0/*#Ops*/, 
              // Src: (X86setcc_c:i8 2:i8, EFLAGS:i32)
              // Dst: (SETB_C8r:i8)
            /*SwitchType*/ 10,  MVT::i16,// ->75253
/*75243*/     OPC_EmitCopyToReg, 0, X86::EFLAGS,
/*75246*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::SETB_C16r), 0|OPFL_FlagInput,
                  1/*#VTs*/, MVT::i16, 0/*#Ops*/, 
              // Src: (X86setcc_c:i16 2:i8, EFLAGS:i32)
              // Dst: (SETB_C16r:i16)
            /*SwitchType*/ 10,  MVT::i32,// ->75265
/*75255*/     OPC_EmitCopyToReg, 0, X86::EFLAGS,
/*75258*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::SETB_C32r), 0|OPFL_FlagInput,
                  1/*#VTs*/, MVT::i32, 0/*#Ops*/, 
              // Src: (X86setcc_c:i32 2:i8, EFLAGS:i32)
              // Dst: (SETB_C32r:i32)
            /*SwitchType*/ 10,  MVT::i64,// ->75277
/*75267*/     OPC_EmitCopyToReg, 0, X86::EFLAGS,
/*75270*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::SETB_C64r), 0|OPFL_FlagInput,
                  1/*#VTs*/, MVT::i64, 0/*#Ops*/, 
              // Src: (X86setcc_c:i64 2:i8, EFLAGS:i32)
              // Dst: (SETB_C64r:i64)
            0, // EndSwitchType
          /*SwitchOpcode*/ 116|128,1/*244*/,  X86ISD::SETCC,// ->75525
/*75281*/   OPC_MoveChild, 0,
/*75283*/   OPC_Scope, 14, /*->75299*/ // 16 children in Scope
/*75285*/     OPC_CheckInteger, 4, 
/*75287*/     OPC_MoveParent,
/*75288*/     OPC_RecordChild1, // #0 = physreg input EFLAGS
/*75289*/     OPC_EmitCopyToReg, 0, X86::EFLAGS,
/*75292*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::SETEr), 0|OPFL_FlagInput,
                  1/*#VTs*/, MVT::i8, 0/*#Ops*/, 
              // Src: (X86setcc:i8 4:i8, EFLAGS:i32)
              // Dst: (SETEr:i8)
/*75299*/   /*Scope*/ 14, /*->75314*/
/*75300*/     OPC_CheckInteger, 9, 
/*75302*/     OPC_MoveParent,
/*75303*/     OPC_RecordChild1, // #0 = physreg input EFLAGS
/*75304*/     OPC_EmitCopyToReg, 0, X86::EFLAGS,
/*75307*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::SETNEr), 0|OPFL_FlagInput,
                  1/*#VTs*/, MVT::i8, 0/*#Ops*/, 
              // Src: (X86setcc:i8 9:i8, EFLAGS:i32)
              // Dst: (SETNEr:i8)
/*75314*/   /*Scope*/ 14, /*->75329*/
/*75315*/     OPC_CheckInteger, 7, 
/*75317*/     OPC_MoveParent,
/*75318*/     OPC_RecordChild1, // #0 = physreg input EFLAGS
/*75319*/     OPC_EmitCopyToReg, 0, X86::EFLAGS,
/*75322*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::SETLr), 0|OPFL_FlagInput,
                  1/*#VTs*/, MVT::i8, 0/*#Ops*/, 
              // Src: (X86setcc:i8 7:i8, EFLAGS:i32)
              // Dst: (SETLr:i8)
/*75329*/   /*Scope*/ 14, /*->75344*/
/*75330*/     OPC_CheckInteger, 6, 
/*75332*/     OPC_MoveParent,
/*75333*/     OPC_RecordChild1, // #0 = physreg input EFLAGS
/*75334*/     OPC_EmitCopyToReg, 0, X86::EFLAGS,
/*75337*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::SETGEr), 0|OPFL_FlagInput,
                  1/*#VTs*/, MVT::i8, 0/*#Ops*/, 
              // Src: (X86setcc:i8 6:i8, EFLAGS:i32)
              // Dst: (SETGEr:i8)
/*75344*/   /*Scope*/ 14, /*->75359*/
/*75345*/     OPC_CheckInteger, 8, 
/*75347*/     OPC_MoveParent,
/*75348*/     OPC_RecordChild1, // #0 = physreg input EFLAGS
/*75349*/     OPC_EmitCopyToReg, 0, X86::EFLAGS,
/*75352*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::SETLEr), 0|OPFL_FlagInput,
                  1/*#VTs*/, MVT::i8, 0/*#Ops*/, 
              // Src: (X86setcc:i8 8:i8, EFLAGS:i32)
              // Dst: (SETLEr:i8)
/*75359*/   /*Scope*/ 14, /*->75374*/
/*75360*/     OPC_CheckInteger, 5, 
/*75362*/     OPC_MoveParent,
/*75363*/     OPC_RecordChild1, // #0 = physreg input EFLAGS
/*75364*/     OPC_EmitCopyToReg, 0, X86::EFLAGS,
/*75367*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::SETGr), 0|OPFL_FlagInput,
                  1/*#VTs*/, MVT::i8, 0/*#Ops*/, 
              // Src: (X86setcc:i8 5:i8, EFLAGS:i32)
              // Dst: (SETGr:i8)
/*75374*/   /*Scope*/ 14, /*->75389*/
/*75375*/     OPC_CheckInteger, 2, 
/*75377*/     OPC_MoveParent,
/*75378*/     OPC_RecordChild1, // #0 = physreg input EFLAGS
/*75379*/     OPC_EmitCopyToReg, 0, X86::EFLAGS,
/*75382*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::SETBr), 0|OPFL_FlagInput,
                  1/*#VTs*/, MVT::i8, 0/*#Ops*/, 
              // Src: (X86setcc:i8 2:i8, EFLAGS:i32)
              // Dst: (SETBr:i8)
/*75389*/   /*Scope*/ 14, /*->75404*/
/*75390*/     OPC_CheckInteger, 1, 
/*75392*/     OPC_MoveParent,
/*75393*/     OPC_RecordChild1, // #0 = physreg input EFLAGS
/*75394*/     OPC_EmitCopyToReg, 0, X86::EFLAGS,
/*75397*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::SETAEr), 0|OPFL_FlagInput,
                  1/*#VTs*/, MVT::i8, 0/*#Ops*/, 
              // Src: (X86setcc:i8 1:i8, EFLAGS:i32)
              // Dst: (SETAEr:i8)
/*75404*/   /*Scope*/ 14, /*->75419*/
/*75405*/     OPC_CheckInteger, 3, 
/*75407*/     OPC_MoveParent,
/*75408*/     OPC_RecordChild1, // #0 = physreg input EFLAGS
/*75409*/     OPC_EmitCopyToReg, 0, X86::EFLAGS,
/*75412*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::SETBEr), 0|OPFL_FlagInput,
                  1/*#VTs*/, MVT::i8, 0/*#Ops*/, 
              // Src: (X86setcc:i8 3:i8, EFLAGS:i32)
              // Dst: (SETBEr:i8)
/*75419*/   /*Scope*/ 14, /*->75434*/
/*75420*/     OPC_CheckInteger, 0, 
/*75422*/     OPC_MoveParent,
/*75423*/     OPC_RecordChild1, // #0 = physreg input EFLAGS
/*75424*/     OPC_EmitCopyToReg, 0, X86::EFLAGS,
/*75427*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::SETAr), 0|OPFL_FlagInput,
                  1/*#VTs*/, MVT::i8, 0/*#Ops*/, 
              // Src: (X86setcc:i8 0:i8, EFLAGS:i32)
              // Dst: (SETAr:i8)
/*75434*/   /*Scope*/ 14, /*->75449*/
/*75435*/     OPC_CheckInteger, 15, 
/*75437*/     OPC_MoveParent,
/*75438*/     OPC_RecordChild1, // #0 = physreg input EFLAGS
/*75439*/     OPC_EmitCopyToReg, 0, X86::EFLAGS,
/*75442*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::SETSr), 0|OPFL_FlagInput,
                  1/*#VTs*/, MVT::i8, 0/*#Ops*/, 
              // Src: (X86setcc:i8 15:i8, EFLAGS:i32)
              // Dst: (SETSr:i8)
/*75449*/   /*Scope*/ 14, /*->75464*/
/*75450*/     OPC_CheckInteger, 12, 
/*75452*/     OPC_MoveParent,
/*75453*/     OPC_RecordChild1, // #0 = physreg input EFLAGS
/*75454*/     OPC_EmitCopyToReg, 0, X86::EFLAGS,
/*75457*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::SETNSr), 0|OPFL_FlagInput,
                  1/*#VTs*/, MVT::i8, 0/*#Ops*/, 
              // Src: (X86setcc:i8 12:i8, EFLAGS:i32)
              // Dst: (SETNSr:i8)
/*75464*/   /*Scope*/ 14, /*->75479*/
/*75465*/     OPC_CheckInteger, 14, 
/*75467*/     OPC_MoveParent,
/*75468*/     OPC_RecordChild1, // #0 = physreg input EFLAGS
/*75469*/     OPC_EmitCopyToReg, 0, X86::EFLAGS,
/*75472*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::SETPr), 0|OPFL_FlagInput,
                  1/*#VTs*/, MVT::i8, 0/*#Ops*/, 
              // Src: (X86setcc:i8 14:i8, EFLAGS:i32)
              // Dst: (SETPr:i8)
/*75479*/   /*Scope*/ 14, /*->75494*/
/*75480*/     OPC_CheckInteger, 11, 
/*75482*/     OPC_MoveParent,
/*75483*/     OPC_RecordChild1, // #0 = physreg input EFLAGS
/*75484*/     OPC_EmitCopyToReg, 0, X86::EFLAGS,
/*75487*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::SETNPr), 0|OPFL_FlagInput,
                  1/*#VTs*/, MVT::i8, 0/*#Ops*/, 
              // Src: (X86setcc:i8 11:i8, EFLAGS:i32)
              // Dst: (SETNPr:i8)
/*75494*/   /*Scope*/ 14, /*->75509*/
/*75495*/     OPC_CheckInteger, 13, 
/*75497*/     OPC_MoveParent,
/*75498*/     OPC_RecordChild1, // #0 = physreg input EFLAGS
/*75499*/     OPC_EmitCopyToReg, 0, X86::EFLAGS,
/*75502*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::SETOr), 0|OPFL_FlagInput,
                  1/*#VTs*/, MVT::i8, 0/*#Ops*/, 
              // Src: (X86setcc:i8 13:i8, EFLAGS:i32)
              // Dst: (SETOr:i8)
/*75509*/   /*Scope*/ 14, /*->75524*/
/*75510*/     OPC_CheckInteger, 10, 
/*75512*/     OPC_MoveParent,
/*75513*/     OPC_RecordChild1, // #0 = physreg input EFLAGS
/*75514*/     OPC_EmitCopyToReg, 0, X86::EFLAGS,
/*75517*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::SETNOr), 0|OPFL_FlagInput,
                  1/*#VTs*/, MVT::i8, 0/*#Ops*/, 
              // Src: (X86setcc:i8 10:i8, EFLAGS:i32)
              // Dst: (SETNOr:i8)
/*75524*/   0, /*End of Scope*/
          /*SwitchOpcode*/ 29,  X86ISD::FSRL,// ->75556
/*75527*/   OPC_RecordChild0, // #0 = $src1
/*75528*/   OPC_RecordChild1, // #1 = $src2
/*75529*/   OPC_MoveChild, 1,
/*75531*/   OPC_CheckOpcode, ISD::Constant,
/*75533*/   OPC_CheckPredicate, 11, // Predicate_immSext8
/*75535*/   OPC_CheckType, MVT::i32,
/*75537*/   OPC_MoveParent,
/*75538*/   OPC_CheckType, MVT::v2f64,
/*75540*/   OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*75542*/   OPC_EmitConvertToTarget, 1,
/*75544*/   OPC_EmitNodeXForm, 5, 2, // BYTE_imm
/*75547*/   OPC_MorphNodeTo, TARGET_OPCODE(X86::PSRLDQri), 0,
                1/*#VTs*/, MVT::v2f64, 2/*#Ops*/, 0, 3, 
            // Src: (X86fsrl:v2f64 VR128:v2f64:$src1, (imm:i32)<<P:Predicate_immSext8>>:$src2)
            // Dst: (PSRLDQri:v2f64 VR128:v16i8:$src1, (BYTE_imm:i32 (imm:i32):$src2))
          /*SwitchOpcode*/ 35,  ISD::CALLSEQ_START,// ->75593
/*75558*/   OPC_RecordNode,   // #0 = 'X86callseq_start' chained node
/*75559*/   OPC_RecordChild1, // #1 = $amt
/*75560*/   OPC_MoveChild, 1,
/*75562*/   OPC_CheckOpcode, ISD::TargetConstant,
/*75564*/   OPC_MoveParent,
/*75565*/   OPC_Scope, 12, /*->75579*/ // 2 children in Scope
/*75567*/     OPC_CheckPatternPredicate, 2, // (!Subtarget->is64Bit())
/*75569*/     OPC_EmitMergeInputChains, 1, 0, 
/*75572*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::ADJCALLSTACKDOWN32), 0|OPFL_Chain|OPFL_FlagOutput,
                  0/*#VTs*/, 1/*#Ops*/, 1, 
              // Src: (X86callseq_start:isVoid (timm:i32):$amt)
              // Dst: (ADJCALLSTACKDOWN32:isVoid (timm:i32):$amt)
/*75579*/   /*Scope*/ 12, /*->75592*/
/*75580*/     OPC_CheckPatternPredicate, 3, // (Subtarget->is64Bit())
/*75582*/     OPC_EmitMergeInputChains, 1, 0, 
/*75585*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::ADJCALLSTACKDOWN64), 0|OPFL_Chain|OPFL_FlagOutput,
                  0/*#VTs*/, 1/*#Ops*/, 1, 
              // Src: (X86callseq_start:isVoid (timm:i32):$amt)
              // Dst: (ADJCALLSTACKDOWN64:isVoid (timm:i32):$amt)
/*75592*/   0, /*End of Scope*/
          /*SwitchOpcode*/ 104,  X86ISD::SHLD,// ->75699
/*75595*/   OPC_RecordChild0, // #0 = $src1
/*75596*/   OPC_RecordChild1, // #1 = $src2
/*75597*/   OPC_RecordChild2, // #2 = $src3
/*75598*/   OPC_Scope, 51, /*->75651*/ // 2 children in Scope
/*75600*/     OPC_MoveChild, 2,
/*75602*/     OPC_CheckOpcode, ISD::Constant,
/*75604*/     OPC_CheckType, MVT::i8,
/*75606*/     OPC_MoveParent,
/*75607*/     OPC_SwitchType /*3 cases */, 12,  MVT::i32,// ->75622
/*75610*/       OPC_EmitConvertToTarget, 2,
/*75612*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::SHLD32rri8), 0,
                    1/*#VTs*/, MVT::i32, 3/*#Ops*/, 0, 1, 3, 
                // Src: (X86shld:i32 GR32:i32:$src1, GR32:i32:$src2, (imm:i8):$src3)
                // Dst: (SHLD32rri8:i32 GR32:i32:$src1, GR32:i32:$src2, (imm:i8):$src3)
              /*SwitchType*/ 12,  MVT::i16,// ->75636
/*75624*/       OPC_EmitConvertToTarget, 2,
/*75626*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::SHLD16rri8), 0,
                    1/*#VTs*/, MVT::i16, 3/*#Ops*/, 0, 1, 3, 
                // Src: (X86shld:i16 GR16:i16:$src1, GR16:i16:$src2, (imm:i8):$src3)
                // Dst: (SHLD16rri8:i16 GR16:i16:$src1, GR16:i16:$src2, (imm:i8):$src3)
              /*SwitchType*/ 12,  MVT::i64,// ->75650
/*75638*/       OPC_EmitConvertToTarget, 2,
/*75640*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::SHLD64rri8), 0,
                    1/*#VTs*/, MVT::i64, 3/*#Ops*/, 0, 1, 3, 
                // Src: (X86shld:i64 GR64:i64:$src1, GR64:i64:$src2, (imm:i8):$src3)
                // Dst: (SHLD64rri8:i64 GR64:i64:$src1, GR64:i64:$src2, (imm:i8):$src3)
              0, // EndSwitchType
/*75651*/   /*Scope*/ 46, /*->75698*/
/*75652*/     OPC_CheckChild2Type, MVT::i8,
/*75654*/     OPC_SwitchType /*3 cases */, 12,  MVT::i32,// ->75669
/*75657*/       OPC_EmitCopyToReg, 2, X86::CL,
/*75660*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::SHLD32rrCL), 0|OPFL_FlagInput,
                    1/*#VTs*/, MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (X86shld:i32 GR32:i32:$src1, GR32:i32:$src2, CL:i8)
                // Dst: (SHLD32rrCL:i32 GR32:i32:$src1, GR32:i32:$src2)
              /*SwitchType*/ 12,  MVT::i16,// ->75683
/*75671*/       OPC_EmitCopyToReg, 2, X86::CL,
/*75674*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::SHLD16rrCL), 0|OPFL_FlagInput,
                    1/*#VTs*/, MVT::i16, 2/*#Ops*/, 0, 1, 
                // Src: (X86shld:i16 GR16:i16:$src1, GR16:i16:$src2, CL:i8)
                // Dst: (SHLD16rrCL:i16 GR16:i16:$src1, GR16:i16:$src2)
              /*SwitchType*/ 12,  MVT::i64,// ->75697
/*75685*/       OPC_EmitCopyToReg, 2, X86::CL,
/*75688*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::SHLD64rrCL), 0|OPFL_FlagInput,
                    1/*#VTs*/, MVT::i64, 2/*#Ops*/, 0, 1, 
                // Src: (X86shld:i64 GR64:i64:$src1, GR64:i64:$src2, CL:i8)
                // Dst: (SHLD64rrCL:i64 GR64:i64:$src1, GR64:i64:$src2)
              0, // EndSwitchType
/*75698*/   0, /*End of Scope*/
          /*SwitchOpcode*/ 104,  X86ISD::SHRD,// ->75805
/*75701*/   OPC_RecordChild0, // #0 = $src1
/*75702*/   OPC_RecordChild1, // #1 = $src2
/*75703*/   OPC_RecordChild2, // #2 = $src3
/*75704*/   OPC_Scope, 51, /*->75757*/ // 2 children in Scope
/*75706*/     OPC_MoveChild, 2,
/*75708*/     OPC_CheckOpcode, ISD::Constant,
/*75710*/     OPC_CheckType, MVT::i8,
/*75712*/     OPC_MoveParent,
/*75713*/     OPC_SwitchType /*3 cases */, 12,  MVT::i32,// ->75728
/*75716*/       OPC_EmitConvertToTarget, 2,
/*75718*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::SHRD32rri8), 0,
                    1/*#VTs*/, MVT::i32, 3/*#Ops*/, 0, 1, 3, 
                // Src: (X86shrd:i32 GR32:i32:$src1, GR32:i32:$src2, (imm:i8):$src3)
                // Dst: (SHRD32rri8:i32 GR32:i32:$src1, GR32:i32:$src2, (imm:i8):$src3)
              /*SwitchType*/ 12,  MVT::i16,// ->75742
/*75730*/       OPC_EmitConvertToTarget, 2,
/*75732*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::SHRD16rri8), 0,
                    1/*#VTs*/, MVT::i16, 3/*#Ops*/, 0, 1, 3, 
                // Src: (X86shrd:i16 GR16:i16:$src1, GR16:i16:$src2, (imm:i8):$src3)
                // Dst: (SHRD16rri8:i16 GR16:i16:$src1, GR16:i16:$src2, (imm:i8):$src3)
              /*SwitchType*/ 12,  MVT::i64,// ->75756
/*75744*/       OPC_EmitConvertToTarget, 2,
/*75746*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::SHRD64rri8), 0,
                    1/*#VTs*/, MVT::i64, 3/*#Ops*/, 0, 1, 3, 
                // Src: (X86shrd:i64 GR64:i64:$src1, GR64:i64:$src2, (imm:i8):$src3)
                // Dst: (SHRD64rri8:i64 GR64:i64:$src1, GR64:i64:$src2, (imm:i8):$src3)
              0, // EndSwitchType
/*75757*/   /*Scope*/ 46, /*->75804*/
/*75758*/     OPC_CheckChild2Type, MVT::i8,
/*75760*/     OPC_SwitchType /*3 cases */, 12,  MVT::i32,// ->75775
/*75763*/       OPC_EmitCopyToReg, 2, X86::CL,
/*75766*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::SHRD32rrCL), 0|OPFL_FlagInput,
                    1/*#VTs*/, MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (X86shrd:i32 GR32:i32:$src1, GR32:i32:$src2, CL:i8)
                // Dst: (SHRD32rrCL:i32 GR32:i32:$src1, GR32:i32:$src2)
              /*SwitchType*/ 12,  MVT::i16,// ->75789
/*75777*/       OPC_EmitCopyToReg, 2, X86::CL,
/*75780*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::SHRD16rrCL), 0|OPFL_FlagInput,
                    1/*#VTs*/, MVT::i16, 2/*#Ops*/, 0, 1, 
                // Src: (X86shrd:i16 GR16:i16:$src1, GR16:i16:$src2, CL:i8)
                // Dst: (SHRD16rrCL:i16 GR16:i16:$src1, GR16:i16:$src2)
              /*SwitchType*/ 12,  MVT::i64,// ->75803
/*75791*/       OPC_EmitCopyToReg, 2, X86::CL,
/*75794*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::SHRD64rrCL), 0|OPFL_FlagInput,
                    1/*#VTs*/, MVT::i64, 2/*#Ops*/, 0, 1, 
                // Src: (X86shrd:i64 GR64:i64:$src1, GR64:i64:$src2, CL:i8)
                // Dst: (SHRD64rrCL:i64 GR64:i64:$src1, GR64:i64:$src2)
              0, // EndSwitchType
/*75804*/   0, /*End of Scope*/
          /*SwitchOpcode*/ 22|128,2/*278*/,  X86ISD::Wrapper,// ->76086
/*75808*/   OPC_RecordChild0, // #0 = $dst
/*75809*/   OPC_MoveChild, 0,
/*75811*/   OPC_SwitchOpcode /*6 cases */, 50,  ISD::TargetConstantPool,// ->75864
/*75814*/     OPC_MoveParent,
/*75815*/     OPC_SwitchType /*2 cases */, 8,  MVT::i32,// ->75826
/*75818*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MOV32ri), 0,
                    1/*#VTs*/, MVT::i32, 1/*#Ops*/, 0, 
                // Src: (X86Wrapper:i32 (tconstpool:i32):$dst)
                // Dst: (MOV32ri:i32 (tconstpool:i32):$dst)
              /*SwitchType*/ 35,  MVT::i64,// ->75863
/*75828*/       OPC_Scope, 10, /*->75840*/ // 3 children in Scope
/*75830*/         OPC_CheckPatternPredicate, 20, // (TM.getCodeModel() != CodeModel::Small &&TM.getCodeModel() != CodeModel::Kernel)
/*75832*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::MOV64ri), 0,
                      1/*#VTs*/, MVT::i64, 1/*#Ops*/, 0, 
                  // Src: (X86Wrapper:i64 (tconstpool:i64):$dst)
                  // Dst: (MOV64ri:i64 (tconstpool:i64):$dst)
/*75840*/       /*Scope*/ 10, /*->75851*/
/*75841*/         OPC_CheckPatternPredicate, 21, // (TM.getCodeModel() == CodeModel::Small)
/*75843*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::MOV64ri64i32), 0,
                      1/*#VTs*/, MVT::i64, 1/*#Ops*/, 0, 
                  // Src: (X86Wrapper:i64 (tconstpool:i64):$dst)
                  // Dst: (MOV64ri64i32:i64 (tconstpool:i64):$dst)
/*75851*/       /*Scope*/ 10, /*->75862*/
/*75852*/         OPC_CheckPatternPredicate, 22, // (TM.getCodeModel() == CodeModel::Kernel)
/*75854*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::MOV64ri32), 0,
                      1/*#VTs*/, MVT::i64, 1/*#Ops*/, 0, 
                  // Src: (X86Wrapper:i64 (tconstpool:i64):$dst)
                  // Dst: (MOV64ri32:i64 (tconstpool:i64):$dst)
/*75862*/       0, /*End of Scope*/
              0, // EndSwitchType
            /*SwitchOpcode*/ 50,  ISD::TargetJumpTable,// ->75916
/*75866*/     OPC_MoveParent,
/*75867*/     OPC_SwitchType /*2 cases */, 8,  MVT::i32,// ->75878
/*75870*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MOV32ri), 0,
                    1/*#VTs*/, MVT::i32, 1/*#Ops*/, 0, 
                // Src: (X86Wrapper:i32 (tjumptable:i32):$dst)
                // Dst: (MOV32ri:i32 (tjumptable:i32):$dst)
              /*SwitchType*/ 35,  MVT::i64,// ->75915
/*75880*/       OPC_Scope, 10, /*->75892*/ // 3 children in Scope
/*75882*/         OPC_CheckPatternPredicate, 20, // (TM.getCodeModel() != CodeModel::Small &&TM.getCodeModel() != CodeModel::Kernel)
/*75884*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::MOV64ri), 0,
                      1/*#VTs*/, MVT::i64, 1/*#Ops*/, 0, 
                  // Src: (X86Wrapper:i64 (tjumptable:i64):$dst)
                  // Dst: (MOV64ri:i64 (tjumptable:i64):$dst)
/*75892*/       /*Scope*/ 10, /*->75903*/
/*75893*/         OPC_CheckPatternPredicate, 21, // (TM.getCodeModel() == CodeModel::Small)
/*75895*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::MOV64ri64i32), 0,
                      1/*#VTs*/, MVT::i64, 1/*#Ops*/, 0, 
                  // Src: (X86Wrapper:i64 (tjumptable:i64):$dst)
                  // Dst: (MOV64ri64i32:i64 (tjumptable:i64):$dst)
/*75903*/       /*Scope*/ 10, /*->75914*/
/*75904*/         OPC_CheckPatternPredicate, 22, // (TM.getCodeModel() == CodeModel::Kernel)
/*75906*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::MOV64ri32), 0,
                      1/*#VTs*/, MVT::i64, 1/*#Ops*/, 0, 
                  // Src: (X86Wrapper:i64 (tjumptable:i64):$dst)
                  // Dst: (MOV64ri32:i64 (tjumptable:i64):$dst)
/*75914*/       0, /*End of Scope*/
              0, // EndSwitchType
            /*SwitchOpcode*/ 11,  ISD::TargetGlobalTLSAddress,// ->75929
/*75918*/     OPC_MoveParent,
/*75919*/     OPC_CheckType, MVT::i32,
/*75921*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::MOV32ri), 0,
                  1/*#VTs*/, MVT::i32, 1/*#Ops*/, 0, 
              // Src: (X86Wrapper:i32 (tglobaltlsaddr:i32):$dst)
              // Dst: (MOV32ri:i32 (tglobaltlsaddr:i32):$dst)
            /*SwitchOpcode*/ 50,  ISD::TargetGlobalAddress,// ->75981
/*75931*/     OPC_MoveParent,
/*75932*/     OPC_SwitchType /*2 cases */, 8,  MVT::i32,// ->75943
/*75935*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MOV32ri), 0,
                    1/*#VTs*/, MVT::i32, 1/*#Ops*/, 0, 
                // Src: (X86Wrapper:i32 (tglobaladdr:i32):$dst)
                // Dst: (MOV32ri:i32 (tglobaladdr:i32):$dst)
              /*SwitchType*/ 35,  MVT::i64,// ->75980
/*75945*/       OPC_Scope, 10, /*->75957*/ // 3 children in Scope
/*75947*/         OPC_CheckPatternPredicate, 20, // (TM.getCodeModel() != CodeModel::Small &&TM.getCodeModel() != CodeModel::Kernel)
/*75949*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::MOV64ri), 0,
                      1/*#VTs*/, MVT::i64, 1/*#Ops*/, 0, 
                  // Src: (X86Wrapper:i64 (tglobaladdr:i64):$dst)
                  // Dst: (MOV64ri:i64 (tglobaladdr:i64):$dst)
/*75957*/       /*Scope*/ 10, /*->75968*/
/*75958*/         OPC_CheckPatternPredicate, 21, // (TM.getCodeModel() == CodeModel::Small)
/*75960*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::MOV64ri64i32), 0,
                      1/*#VTs*/, MVT::i64, 1/*#Ops*/, 0, 
                  // Src: (X86Wrapper:i64 (tglobaladdr:i64):$dst)
                  // Dst: (MOV64ri64i32:i64 (tglobaladdr:i64):$dst)
/*75968*/       /*Scope*/ 10, /*->75979*/
/*75969*/         OPC_CheckPatternPredicate, 22, // (TM.getCodeModel() == CodeModel::Kernel)
/*75971*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::MOV64ri32), 0,
                      1/*#VTs*/, MVT::i64, 1/*#Ops*/, 0, 
                  // Src: (X86Wrapper:i64 (tglobaladdr:i64):$dst)
                  // Dst: (MOV64ri32:i64 (tglobaladdr:i64):$dst)
/*75979*/       0, /*End of Scope*/
              0, // EndSwitchType
            /*SwitchOpcode*/ 50,  ISD::TargetExternalSymbol,// ->76033
/*75983*/     OPC_MoveParent,
/*75984*/     OPC_SwitchType /*2 cases */, 8,  MVT::i32,// ->75995
/*75987*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MOV32ri), 0,
                    1/*#VTs*/, MVT::i32, 1/*#Ops*/, 0, 
                // Src: (X86Wrapper:i32 (texternalsym:i32):$dst)
                // Dst: (MOV32ri:i32 (texternalsym:i32):$dst)
              /*SwitchType*/ 35,  MVT::i64,// ->76032
/*75997*/       OPC_Scope, 10, /*->76009*/ // 3 children in Scope
/*75999*/         OPC_CheckPatternPredicate, 20, // (TM.getCodeModel() != CodeModel::Small &&TM.getCodeModel() != CodeModel::Kernel)
/*76001*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::MOV64ri), 0,
                      1/*#VTs*/, MVT::i64, 1/*#Ops*/, 0, 
                  // Src: (X86Wrapper:i64 (texternalsym:i64):$dst)
                  // Dst: (MOV64ri:i64 (texternalsym:i64):$dst)
/*76009*/       /*Scope*/ 10, /*->76020*/
/*76010*/         OPC_CheckPatternPredicate, 21, // (TM.getCodeModel() == CodeModel::Small)
/*76012*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::MOV64ri64i32), 0,
                      1/*#VTs*/, MVT::i64, 1/*#Ops*/, 0, 
                  // Src: (X86Wrapper:i64 (texternalsym:i64):$dst)
                  // Dst: (MOV64ri64i32:i64 (texternalsym:i64):$dst)
/*76020*/       /*Scope*/ 10, /*->76031*/
/*76021*/         OPC_CheckPatternPredicate, 22, // (TM.getCodeModel() == CodeModel::Kernel)
/*76023*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::MOV64ri32), 0,
                      1/*#VTs*/, MVT::i64, 1/*#Ops*/, 0, 
                  // Src: (X86Wrapper:i64 (texternalsym:i64):$dst)
                  // Dst: (MOV64ri32:i64 (texternalsym:i64):$dst)
/*76031*/       0, /*End of Scope*/
              0, // EndSwitchType
            /*SwitchOpcode*/ 50,  ISD::TargetBlockAddress,// ->76085
/*76035*/     OPC_MoveParent,
/*76036*/     OPC_SwitchType /*2 cases */, 8,  MVT::i32,// ->76047
/*76039*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MOV32ri), 0,
                    1/*#VTs*/, MVT::i32, 1/*#Ops*/, 0, 
                // Src: (X86Wrapper:i32 (tblockaddress:i32):$dst)
                // Dst: (MOV32ri:i32 (tblockaddress:i32):$dst)
              /*SwitchType*/ 35,  MVT::i64,// ->76084
/*76049*/       OPC_Scope, 10, /*->76061*/ // 3 children in Scope
/*76051*/         OPC_CheckPatternPredicate, 20, // (TM.getCodeModel() != CodeModel::Small &&TM.getCodeModel() != CodeModel::Kernel)
/*76053*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::MOV64ri), 0,
                      1/*#VTs*/, MVT::i64, 1/*#Ops*/, 0, 
                  // Src: (X86Wrapper:i64 (tblockaddress:i64):$dst)
                  // Dst: (MOV64ri:i64 (tblockaddress:i64):$dst)
/*76061*/       /*Scope*/ 10, /*->76072*/
/*76062*/         OPC_CheckPatternPredicate, 21, // (TM.getCodeModel() == CodeModel::Small)
/*76064*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::MOV64ri64i32), 0,
                      1/*#VTs*/, MVT::i64, 1/*#Ops*/, 0, 
                  // Src: (X86Wrapper:i64 (tblockaddress:i64):$dst)
                  // Dst: (MOV64ri64i32:i64 (tblockaddress:i64):$dst)
/*76072*/       /*Scope*/ 10, /*->76083*/
/*76073*/         OPC_CheckPatternPredicate, 22, // (TM.getCodeModel() == CodeModel::Kernel)
/*76075*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::MOV64ri32), 0,
                      1/*#VTs*/, MVT::i64, 1/*#Ops*/, 0, 
                  // Src: (X86Wrapper:i64 (tblockaddress:i64):$dst)
                  // Dst: (MOV64ri32:i64 (tblockaddress:i64):$dst)
/*76083*/       0, /*End of Scope*/
              0, // EndSwitchType
            0, // EndSwitchOpcode
          /*SwitchOpcode*/ 124,  ISD::Constant,// ->76212
/*76088*/   OPC_Scope, 40, /*->76130*/ // 2 children in Scope
/*76090*/     OPC_CheckInteger, 0, 
/*76092*/     OPC_SwitchType /*4 cases */, 7,  MVT::i64,// ->76102
/*76095*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MOV64r0), 0,
                    1/*#VTs*/, MVT::i64, 0/*#Ops*/, 
                // Src: 0:i64
                // Dst: (MOV64r0:i64)
              /*SwitchType*/ 7,  MVT::i8,// ->76111
/*76104*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MOV8r0), 0,
                    1/*#VTs*/, MVT::i8, 0/*#Ops*/, 
                // Src: 0:i8
                // Dst: (MOV8r0:i8)
              /*SwitchType*/ 7,  MVT::i16,// ->76120
/*76113*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MOV16r0), 0,
                    1/*#VTs*/, MVT::i16, 0/*#Ops*/, 
                // Src: 0:i16
                // Dst: (MOV16r0:i16)
              /*SwitchType*/ 7,  MVT::i32,// ->76129
/*76122*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MOV32r0), 0,
                    1/*#VTs*/, MVT::i32, 0/*#Ops*/, 
                // Src: 0:i32
                // Dst: (MOV32r0:i32)
              0, // EndSwitchType
/*76130*/   /*Scope*/ 80, /*->76211*/
/*76131*/     OPC_RecordNode, // #0 = $src
/*76132*/     OPC_SwitchType /*4 cases */, 39,  MVT::i64,// ->76174
/*76135*/       OPC_Scope, 12, /*->76149*/ // 3 children in Scope
/*76137*/         OPC_CheckPredicate, 69, // Predicate_i64immZExt32
/*76139*/         OPC_EmitConvertToTarget, 0,
/*76141*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::MOV64ri64i32), 0,
                      1/*#VTs*/, MVT::i64, 1/*#Ops*/, 1, 
                  // Src: (imm:i64)<<P:Predicate_i64immZExt32>>:$src
                  // Dst: (MOV64ri64i32:i64 (imm:i64):$src)
/*76149*/       /*Scope*/ 12, /*->76162*/
/*76150*/         OPC_CheckPredicate, 12, // Predicate_i64immSExt32
/*76152*/         OPC_EmitConvertToTarget, 0,
/*76154*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::MOV64ri32), 0,
                      1/*#VTs*/, MVT::i64, 1/*#Ops*/, 1, 
                  // Src: (imm:i64)<<P:Predicate_i64immSExt32>>:$src
                  // Dst: (MOV64ri32:i64 (imm:i64):$src)
/*76162*/       /*Scope*/ 10, /*->76173*/
/*76163*/         OPC_EmitConvertToTarget, 0,
/*76165*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::MOV64ri), 0,
                      1/*#VTs*/, MVT::i64, 1/*#Ops*/, 1, 
                  // Src: (imm:i64):$src
                  // Dst: (MOV64ri:i64 (imm:i64):$src)
/*76173*/       0, /*End of Scope*/
              /*SwitchType*/ 10,  MVT::i8,// ->76186
/*76176*/       OPC_EmitConvertToTarget, 0,
/*76178*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MOV8ri), 0,
                    1/*#VTs*/, MVT::i8, 1/*#Ops*/, 1, 
                // Src: (imm:i8):$src
                // Dst: (MOV8ri:i8 (imm:i8):$src)
              /*SwitchType*/ 10,  MVT::i16,// ->76198
/*76188*/       OPC_EmitConvertToTarget, 0,
/*76190*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MOV16ri), 0,
                    1/*#VTs*/, MVT::i16, 1/*#Ops*/, 1, 
                // Src: (imm:i16):$src
                // Dst: (MOV16ri:i16 (imm:i16):$src)
              /*SwitchType*/ 10,  MVT::i32,// ->76210
/*76200*/       OPC_EmitConvertToTarget, 0,
/*76202*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MOV32ri), 0,
                    1/*#VTs*/, MVT::i32, 1/*#Ops*/, 1, 
                // Src: (imm:i32):$src
                // Dst: (MOV32ri:i32 (imm:i32):$src)
              0, // EndSwitchType
/*76211*/   0, /*End of Scope*/
          /*SwitchOpcode*/ 42,  X86ISD::VSHL,// ->76256
/*76214*/   OPC_RecordChild0, // #0 = $src
/*76215*/   OPC_RecordChild1, // #1 = $amt
/*76216*/   OPC_MoveChild, 1,
/*76218*/   OPC_CheckOpcode, ISD::Constant,
/*76220*/   OPC_CheckType, MVT::i8,
/*76222*/   OPC_MoveParent,
/*76223*/   OPC_SwitchType /*2 cases */, 16,  MVT::v2i64,// ->76242
/*76226*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*76228*/     OPC_EmitConvertToTarget, 1,
/*76230*/     OPC_EmitNodeXForm, 5, 2, // BYTE_imm
/*76233*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::PSLLDQri), 0,
                  1/*#VTs*/, MVT::v2i64, 2/*#Ops*/, 0, 3, 
              // Src: (X86vshl:v2i64 VR128:v2i64:$src, (imm:i8):$amt)
              // Dst: (PSLLDQri:v2i64 VR128:v16i8:$src, (BYTE_imm:i32 (imm:i32):$amt))
            /*SwitchType*/ 11,  MVT::v1i64,// ->76255
/*76244*/     OPC_EmitConvertToTarget, 1,
/*76246*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PSLLQri), 0,
                  1/*#VTs*/, MVT::v1i64, 2/*#Ops*/, 0, 2, 
              // Src: (X86vshl:v1i64 VR64:v1i64:$src, (imm:i8):$amt)
              // Dst: (MMX_PSLLQri:v1i64 VR64:v8i8:$src, (imm:i32):$amt)
            0, // EndSwitchType
          /*SwitchOpcode*/ 42,  X86ISD::VSRL,// ->76300
/*76258*/   OPC_RecordChild0, // #0 = $src
/*76259*/   OPC_RecordChild1, // #1 = $amt
/*76260*/   OPC_MoveChild, 1,
/*76262*/   OPC_CheckOpcode, ISD::Constant,
/*76264*/   OPC_CheckType, MVT::i8,
/*76266*/   OPC_MoveParent,
/*76267*/   OPC_SwitchType /*2 cases */, 16,  MVT::v2i64,// ->76286
/*76270*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*76272*/     OPC_EmitConvertToTarget, 1,
/*76274*/     OPC_EmitNodeXForm, 5, 2, // BYTE_imm
/*76277*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::PSRLDQri), 0,
                  1/*#VTs*/, MVT::v2i64, 2/*#Ops*/, 0, 3, 
              // Src: (X86vshr:v2i64 VR128:v2i64:$src, (imm:i8):$amt)
              // Dst: (PSRLDQri:v2i64 VR128:v16i8:$src, (BYTE_imm:i32 (imm:i32):$amt))
            /*SwitchType*/ 11,  MVT::v1i64,// ->76299
/*76288*/     OPC_EmitConvertToTarget, 1,
/*76290*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PSRLQri), 0,
                  1/*#VTs*/, MVT::v1i64, 2/*#Ops*/, 0, 2, 
              // Src: (X86vshr:v1i64 VR64:v1i64:$src, (imm:i8):$amt)
              // Dst: (MMX_PSRLQri:v1i64 VR64:v8i8:$src, (imm:i32):$amt)
            0, // EndSwitchType
          /*SwitchOpcode*/ 47,  X86ISD::PEXTRW,// ->76349
/*76302*/   OPC_RecordChild0, // #0 = $src1
/*76303*/   OPC_Scope, 21, /*->76326*/ // 2 children in Scope
/*76305*/     OPC_CheckChild0Type, MVT::v8i16,
/*76307*/     OPC_RecordChild1, // #1 = $src2
/*76308*/     OPC_MoveChild, 1,
/*76310*/     OPC_CheckOpcode, ISD::Constant,
/*76312*/     OPC_MoveParent,
/*76313*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*76315*/     OPC_EmitConvertToTarget, 1,
/*76317*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::PEXTRWri), 0,
                  1/*#VTs*/, MVT::i32, 2/*#Ops*/, 0, 2, 
              // Src: (X86pextrw:i32 VR128:v8i16:$src1, (imm:iPTR):$src2)
              // Dst: (PEXTRWri:i32 VR128:v8i16:$src1, (imm:i32):$src2)
/*76326*/   /*Scope*/ 21, /*->76348*/
/*76327*/     OPC_CheckChild0Type, MVT::v4i16,
/*76329*/     OPC_RecordChild1, // #1 = $src2
/*76330*/     OPC_MoveChild, 1,
/*76332*/     OPC_CheckOpcode, ISD::Constant,
/*76334*/     OPC_MoveParent,
/*76335*/     OPC_CheckPatternPredicate, 8, // (Subtarget->hasMMX())
/*76337*/     OPC_EmitConvertToTarget, 1,
/*76339*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_PEXTRWri), 0,
                  1/*#VTs*/, MVT::i32, 2/*#Ops*/, 0, 2, 
              // Src: (X86pextrw:i32 VR64:v4i16:$src1, (imm:iPTR):$src2)
              // Dst: (MMX_PEXTRWri:i32 VR64:v4i16:$src1, (imm:i16):$src2)
/*76348*/   0, /*End of Scope*/
          /*SwitchOpcode*/ 22,  X86ISD::PEXTRB,// ->76373
/*76351*/   OPC_RecordChild0, // #0 = $src1
/*76352*/   OPC_CheckChild0Type, MVT::v16i8,
/*76354*/   OPC_RecordChild1, // #1 = $src2
/*76355*/   OPC_MoveChild, 1,
/*76357*/   OPC_CheckOpcode, ISD::Constant,
/*76359*/   OPC_MoveParent,
/*76360*/   OPC_CheckPatternPredicate, 4, // (Subtarget->hasSSE41())
/*76362*/   OPC_EmitConvertToTarget, 1,
/*76364*/   OPC_MorphNodeTo, TARGET_OPCODE(X86::PEXTRBrr), 0,
                1/*#VTs*/, MVT::i32, 2/*#Ops*/, 0, 2, 
            // Src: (X86pextrb:i32 VR128:v16i8:$src1, (imm:iPTR):$src2)
            // Dst: (PEXTRBrr:i32 VR128:v16i8:$src1, (imm:i32):$src2)
          /*SwitchOpcode*/ 94|128,1/*222*/,  ISD::ConstantFP,// ->76598
/*76376*/   OPC_SwitchType /*3 cases */, 78,  MVT::f32,// ->76457
/*76379*/     OPC_Scope, 11, /*->76392*/ // 5 children in Scope
/*76381*/       OPC_CheckPredicate, 109, // Predicate_fpimm0
/*76383*/       OPC_CheckPatternPredicate, 6, // (!Subtarget->hasSSE1())
/*76385*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::LD_Fp032), 0,
                    1/*#VTs*/, MVT::f32, 0/*#Ops*/, 
                // Src: (fpimm:f32)<<P:Predicate_fpimm0>>
                // Dst: (LD_Fp032:f32)
/*76392*/     /*Scope*/ 11, /*->76404*/
/*76393*/       OPC_CheckPredicate, 110, // Predicate_fpimm1
/*76395*/       OPC_CheckPatternPredicate, 6, // (!Subtarget->hasSSE1())
/*76397*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::LD_Fp132), 0,
                    1/*#VTs*/, MVT::f32, 0/*#Ops*/, 
                // Src: (fpimm:f32)<<P:Predicate_fpimm1>>
                // Dst: (LD_Fp132:f32)
/*76404*/     /*Scope*/ 11, /*->76416*/
/*76405*/       OPC_CheckPredicate, 111, // Predicate_fp32imm0
/*76407*/       OPC_CheckPatternPredicate, 0, // (Subtarget->hasSSE1())
/*76409*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::FsFLD0SS), 0,
                    1/*#VTs*/, MVT::f32, 0/*#Ops*/, 
                // Src: (fpimm:f32)<<P:Predicate_fp32imm0>>
                // Dst: (FsFLD0SS:f32)
/*76416*/     /*Scope*/ 19, /*->76436*/
/*76417*/       OPC_CheckPredicate, 112, // Predicate_fpimmneg0
/*76419*/       OPC_CheckPatternPredicate, 6, // (!Subtarget->hasSSE1())
/*76421*/       OPC_EmitNode, TARGET_OPCODE(X86::LD_Fp032), 0,
                    1/*#VTs*/, MVT::f32, 0/*#Ops*/,  // Results = #0 
/*76428*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::CHS_Fp32), 0,
                    1/*#VTs*/, MVT::f32, 1/*#Ops*/, 0, 
                // Src: (fpimm:f32)<<P:Predicate_fpimmneg0>>
                // Dst: (CHS_Fp32:f32 (LD_Fp032:f32))
/*76436*/     /*Scope*/ 19, /*->76456*/
/*76437*/       OPC_CheckPredicate, 113, // Predicate_fpimmneg1
/*76439*/       OPC_CheckPatternPredicate, 6, // (!Subtarget->hasSSE1())
/*76441*/       OPC_EmitNode, TARGET_OPCODE(X86::LD_Fp132), 0,
                    1/*#VTs*/, MVT::f32, 0/*#Ops*/,  // Results = #0 
/*76448*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::CHS_Fp32), 0,
                    1/*#VTs*/, MVT::f32, 1/*#Ops*/, 0, 
                // Src: (fpimm:f32)<<P:Predicate_fpimmneg1>>
                // Dst: (CHS_Fp32:f32 (LD_Fp132:f32))
/*76456*/     0, /*End of Scope*/
            /*SwitchType*/ 78,  MVT::f64,// ->76537
/*76459*/     OPC_Scope, 11, /*->76472*/ // 5 children in Scope
/*76461*/       OPC_CheckPredicate, 109, // Predicate_fpimm0
/*76463*/       OPC_CheckPatternPredicate, 7, // (!Subtarget->hasSSE2())
/*76465*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::LD_Fp064), 0,
                    1/*#VTs*/, MVT::f64, 0/*#Ops*/, 
                // Src: (fpimm:f64)<<P:Predicate_fpimm0>>
                // Dst: (LD_Fp064:f64)
/*76472*/     /*Scope*/ 11, /*->76484*/
/*76473*/       OPC_CheckPredicate, 110, // Predicate_fpimm1
/*76475*/       OPC_CheckPatternPredicate, 7, // (!Subtarget->hasSSE2())
/*76477*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::LD_Fp164), 0,
                    1/*#VTs*/, MVT::f64, 0/*#Ops*/, 
                // Src: (fpimm:f64)<<P:Predicate_fpimm1>>
                // Dst: (LD_Fp164:f64)
/*76484*/     /*Scope*/ 11, /*->76496*/
/*76485*/       OPC_CheckPredicate, 109, // Predicate_fpimm0
/*76487*/       OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*76489*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::FsFLD0SD), 0,
                    1/*#VTs*/, MVT::f64, 0/*#Ops*/, 
                // Src: (fpimm:f64)<<P:Predicate_fpimm0>>
                // Dst: (FsFLD0SD:f64)
/*76496*/     /*Scope*/ 19, /*->76516*/
/*76497*/       OPC_CheckPredicate, 112, // Predicate_fpimmneg0
/*76499*/       OPC_CheckPatternPredicate, 7, // (!Subtarget->hasSSE2())
/*76501*/       OPC_EmitNode, TARGET_OPCODE(X86::LD_Fp064), 0,
                    1/*#VTs*/, MVT::f64, 0/*#Ops*/,  // Results = #0 
/*76508*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::CHS_Fp64), 0,
                    1/*#VTs*/, MVT::f64, 1/*#Ops*/, 0, 
                // Src: (fpimm:f64)<<P:Predicate_fpimmneg0>>
                // Dst: (CHS_Fp64:f64 (LD_Fp064:f64))
/*76516*/     /*Scope*/ 19, /*->76536*/
/*76517*/       OPC_CheckPredicate, 113, // Predicate_fpimmneg1
/*76519*/       OPC_CheckPatternPredicate, 7, // (!Subtarget->hasSSE2())
/*76521*/       OPC_EmitNode, TARGET_OPCODE(X86::LD_Fp164), 0,
                    1/*#VTs*/, MVT::f64, 0/*#Ops*/,  // Results = #0 
/*76528*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::CHS_Fp64), 0,
                    1/*#VTs*/, MVT::f64, 1/*#Ops*/, 0, 
                // Src: (fpimm:f64)<<P:Predicate_fpimmneg1>>
                // Dst: (CHS_Fp64:f64 (LD_Fp164:f64))
/*76536*/     0, /*End of Scope*/
            /*SwitchType*/ 58,  MVT::f80,// ->76597
/*76539*/     OPC_Scope, 9, /*->76550*/ // 4 children in Scope
/*76541*/       OPC_CheckPredicate, 109, // Predicate_fpimm0
/*76543*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::LD_Fp080), 0,
                    1/*#VTs*/, MVT::f80, 0/*#Ops*/, 
                // Src: (fpimm:f80)<<P:Predicate_fpimm0>>
                // Dst: (LD_Fp080:f80)
/*76550*/     /*Scope*/ 9, /*->76560*/
/*76551*/       OPC_CheckPredicate, 110, // Predicate_fpimm1
/*76553*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::LD_Fp180), 0,
                    1/*#VTs*/, MVT::f80, 0/*#Ops*/, 
                // Src: (fpimm:f80)<<P:Predicate_fpimm1>>
                // Dst: (LD_Fp180:f80)
/*76560*/     /*Scope*/ 17, /*->76578*/
/*76561*/       OPC_CheckPredicate, 112, // Predicate_fpimmneg0
/*76563*/       OPC_EmitNode, TARGET_OPCODE(X86::LD_Fp080), 0,
                    1/*#VTs*/, MVT::f80, 0/*#Ops*/,  // Results = #0 
/*76570*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::CHS_Fp80), 0,
                    1/*#VTs*/, MVT::f80, 1/*#Ops*/, 0, 
                // Src: (fpimm:f80)<<P:Predicate_fpimmneg0>>
                // Dst: (CHS_Fp80:f80 (LD_Fp080:f80))
/*76578*/     /*Scope*/ 17, /*->76596*/
/*76579*/       OPC_CheckPredicate, 113, // Predicate_fpimmneg1
/*76581*/       OPC_EmitNode, TARGET_OPCODE(X86::LD_Fp180), 0,
                    1/*#VTs*/, MVT::f80, 0/*#Ops*/,  // Results = #0 
/*76588*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::CHS_Fp80), 0,
                    1/*#VTs*/, MVT::f80, 1/*#Ops*/, 0, 
                // Src: (fpimm:f80)<<P:Predicate_fpimmneg1>>
                // Dst: (CHS_Fp80:f80 (LD_Fp180:f80))
/*76596*/     0, /*End of Scope*/
            0, // EndSwitchType
          /*SwitchOpcode*/ 15|128,1/*143*/,  ISD::BUILD_VECTOR,// ->76744
/*76601*/   OPC_Scope, 60, /*->76663*/ // 5 children in Scope
/*76603*/     OPC_CheckPredicate, 44, // Predicate_immAllZerosV
/*76605*/     OPC_SwitchType /*6 cases */, 9,  MVT::v4i32,// ->76617
/*76608*/       OPC_CheckPatternPredicate, 0, // (Subtarget->hasSSE1())
/*76610*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::V_SET0), 0,
                    1/*#VTs*/, MVT::v4i32, 0/*#Ops*/, 
                // Src: (build_vector:v4i32)<<P:Predicate_immAllZerosV>>
                // Dst: (V_SET0:v4i32)
              /*SwitchType*/ 7,  MVT::v2i64,// ->76626
/*76619*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::V_SET0), 0,
                    1/*#VTs*/, MVT::v2i64, 0/*#Ops*/, 
                // Src: (build_vector:v2i64)<<P:Predicate_immAllZerosV>>
                // Dst: (V_SET0:v2i64)
              /*SwitchType*/ 7,  MVT::v8i16,// ->76635
/*76628*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::V_SET0), 0,
                    1/*#VTs*/, MVT::v8i16, 0/*#Ops*/, 
                // Src: (build_vector:v8i16)<<P:Predicate_immAllZerosV>>
                // Dst: (V_SET0:v8i16)
              /*SwitchType*/ 7,  MVT::v16i8,// ->76644
/*76637*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::V_SET0), 0,
                    1/*#VTs*/, MVT::v16i8, 0/*#Ops*/, 
                // Src: (build_vector:v16i8)<<P:Predicate_immAllZerosV>>
                // Dst: (V_SET0:v16i8)
              /*SwitchType*/ 7,  MVT::v2f64,// ->76653
/*76646*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::V_SET0), 0,
                    1/*#VTs*/, MVT::v2f64, 0/*#Ops*/, 
                // Src: (build_vector:v2f64)<<P:Predicate_immAllZerosV>>
                // Dst: (V_SET0:v2f64)
              /*SwitchType*/ 7,  MVT::v4f32,// ->76662
/*76655*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::V_SET0), 0,
                    1/*#VTs*/, MVT::v4f32, 0/*#Ops*/, 
                // Src: (build_vector:v4f32)<<P:Predicate_immAllZerosV>>
                // Dst: (V_SET0:v4f32)
              0, // EndSwitchType
/*76663*/   /*Scope*/ 13, /*->76677*/
/*76664*/     OPC_CheckPredicate, 67, // Predicate_immAllOnesV
/*76666*/     OPC_CheckType, MVT::v4i32,
/*76668*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasSSE2())
/*76670*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::V_SETALLONES), 0,
                  1/*#VTs*/, MVT::v4i32, 0/*#Ops*/, 
              // Src: (build_vector:v4i32)<<P:Predicate_immAllOnesV>>
              // Dst: (V_SETALLONES:v4i32)
/*76677*/   /*Scope*/ 13, /*->76691*/
/*76678*/     OPC_CheckPredicate, 44, // Predicate_immAllZerosV
/*76680*/     OPC_CheckType, MVT::v2i32,
/*76682*/     OPC_CheckPatternPredicate, 8, // (Subtarget->hasMMX())
/*76684*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_V_SET0), 0,
                  1/*#VTs*/, MVT::v2i32, 0/*#Ops*/, 
              // Src: (build_vector:v2i32)<<P:Predicate_immAllZerosV>>
              // Dst: (MMX_V_SET0:v2i32)
/*76691*/   /*Scope*/ 13, /*->76705*/
/*76692*/     OPC_CheckPredicate, 67, // Predicate_immAllOnesV
/*76694*/     OPC_CheckType, MVT::v2i32,
/*76696*/     OPC_CheckPatternPredicate, 8, // (Subtarget->hasMMX())
/*76698*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_V_SETALLONES), 0,
                  1/*#VTs*/, MVT::v2i32, 0/*#Ops*/, 
              // Src: (build_vector:v2i32)<<P:Predicate_immAllOnesV>>
              // Dst: (MMX_V_SETALLONES:v2i32)
/*76705*/   /*Scope*/ 37, /*->76743*/
/*76706*/     OPC_CheckPredicate, 44, // Predicate_immAllZerosV
/*76708*/     OPC_SwitchType /*3 cases */, 9,  MVT::v1i64,// ->76720
/*76711*/       OPC_CheckPatternPredicate, 8, // (Subtarget->hasMMX())
/*76713*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_V_SET0), 0,
                    1/*#VTs*/, MVT::v1i64, 0/*#Ops*/, 
                // Src: (build_vector:v1i64)<<P:Predicate_immAllZerosV>>
                // Dst: (MMX_V_SET0:v1i64)
              /*SwitchType*/ 9,  MVT::v4i16,// ->76731
/*76722*/       OPC_CheckPatternPredicate, 8, // (Subtarget->hasMMX())
/*76724*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_V_SET0), 0,
                    1/*#VTs*/, MVT::v4i16, 0/*#Ops*/, 
                // Src: (build_vector:v4i16)<<P:Predicate_immAllZerosV>>
                // Dst: (MMX_V_SET0:v4i16)
              /*SwitchType*/ 9,  MVT::v8i8,// ->76742
/*76733*/       OPC_CheckPatternPredicate, 8, // (Subtarget->hasMMX())
/*76735*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MMX_V_SET0), 0,
                    1/*#VTs*/, MVT::v8i8, 0/*#Ops*/, 
                // Src: (build_vector:v8i8)<<P:Predicate_immAllZerosV>>
                // Dst: (MMX_V_SET0:v8i8)
              0, // EndSwitchType
/*76743*/   0, /*End of Scope*/
          /*SwitchOpcode*/ 37,  ISD::FNEG,// ->76783
/*76746*/   OPC_RecordChild0, // #0 = $src
/*76747*/   OPC_SwitchType /*3 cases */, 10,  MVT::f32,// ->76760
/*76750*/     OPC_CheckPatternPredicate, 6, // (!Subtarget->hasSSE1())
/*76752*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::CHS_Fp32), 0,
                  1/*#VTs*/, MVT::f32, 1/*#Ops*/, 0, 
              // Src: (fneg:f32 RFP32:f32:$src)
              // Dst: (CHS_Fp32:f32 RFP32:f32:$src)
            /*SwitchType*/ 10,  MVT::f64,// ->76772
/*76762*/     OPC_CheckPatternPredicate, 7, // (!Subtarget->hasSSE2())
/*76764*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::CHS_Fp64), 0,
                  1/*#VTs*/, MVT::f64, 1/*#Ops*/, 0, 
              // Src: (fneg:f64 RFP64:f64:$src)
              // Dst: (CHS_Fp64:f64 RFP64:f64:$src)
            /*SwitchType*/ 8,  MVT::f80,// ->76782
/*76774*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::CHS_Fp80), 0,
                  1/*#VTs*/, MVT::f80, 1/*#Ops*/, 0, 
              // Src: (fneg:f80 RFP80:f80:$src)
              // Dst: (CHS_Fp80:f80 RFP80:f80:$src)
            0, // EndSwitchType
          /*SwitchOpcode*/ 37,  ISD::FABS,// ->76822
/*76785*/   OPC_RecordChild0, // #0 = $src
/*76786*/   OPC_SwitchType /*3 cases */, 10,  MVT::f32,// ->76799
/*76789*/     OPC_CheckPatternPredicate, 6, // (!Subtarget->hasSSE1())
/*76791*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::ABS_Fp32), 0,
                  1/*#VTs*/, MVT::f32, 1/*#Ops*/, 0, 
              // Src: (fabs:f32 RFP32:f32:$src)
              // Dst: (ABS_Fp32:f32 RFP32:f32:$src)
            /*SwitchType*/ 10,  MVT::f64,// ->76811
/*76801*/     OPC_CheckPatternPredicate, 7, // (!Subtarget->hasSSE2())
/*76803*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::ABS_Fp64), 0,
                  1/*#VTs*/, MVT::f64, 1/*#Ops*/, 0, 
              // Src: (fabs:f64 RFP64:f64:$src)
              // Dst: (ABS_Fp64:f64 RFP64:f64:$src)
            /*SwitchType*/ 8,  MVT::f80,// ->76821
/*76813*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::ABS_Fp80), 0,
                  1/*#VTs*/, MVT::f80, 1/*#Ops*/, 0, 
              // Src: (fabs:f80 RFP80:f80:$src)
              // Dst: (ABS_Fp80:f80 RFP80:f80:$src)
            0, // EndSwitchType
          /*SwitchOpcode*/ 37,  ISD::FSIN,// ->76861
/*76824*/   OPC_RecordChild0, // #0 = $src
/*76825*/   OPC_SwitchType /*3 cases */, 10,  MVT::f32,// ->76838
/*76828*/     OPC_CheckPatternPredicate, 6, // (!Subtarget->hasSSE1())
/*76830*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::SIN_Fp32), 0,
                  1/*#VTs*/, MVT::f32, 1/*#Ops*/, 0, 
              // Src: (fsin:f32 RFP32:f32:$src)
              // Dst: (SIN_Fp32:f32 RFP32:f32:$src)
            /*SwitchType*/ 10,  MVT::f64,// ->76850
/*76840*/     OPC_CheckPatternPredicate, 7, // (!Subtarget->hasSSE2())
/*76842*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::SIN_Fp64), 0,
                  1/*#VTs*/, MVT::f64, 1/*#Ops*/, 0, 
              // Src: (fsin:f64 RFP64:f64:$src)
              // Dst: (SIN_Fp64:f64 RFP64:f64:$src)
            /*SwitchType*/ 8,  MVT::f80,// ->76860
/*76852*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::SIN_Fp80), 0,
                  1/*#VTs*/, MVT::f80, 1/*#Ops*/, 0, 
              // Src: (fsin:f80 RFP80:f80:$src)
              // Dst: (SIN_Fp80:f80 RFP80:f80:$src)
            0, // EndSwitchType
          /*SwitchOpcode*/ 37,  ISD::FCOS,// ->76900
/*76863*/   OPC_RecordChild0, // #0 = $src
/*76864*/   OPC_SwitchType /*3 cases */, 10,  MVT::f32,// ->76877
/*76867*/     OPC_CheckPatternPredicate, 6, // (!Subtarget->hasSSE1())
/*76869*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::COS_Fp32), 0,
                  1/*#VTs*/, MVT::f32, 1/*#Ops*/, 0, 
              // Src: (fcos:f32 RFP32:f32:$src)
              // Dst: (COS_Fp32:f32 RFP32:f32:$src)
            /*SwitchType*/ 10,  MVT::f64,// ->76889
/*76879*/     OPC_CheckPatternPredicate, 7, // (!Subtarget->hasSSE2())
/*76881*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::COS_Fp64), 0,
                  1/*#VTs*/, MVT::f64, 1/*#Ops*/, 0, 
              // Src: (fcos:f64 RFP64:f64:$src)
              // Dst: (COS_Fp64:f64 RFP64:f64:$src)
            /*SwitchType*/ 8,  MVT::f80,// ->76899
/*76891*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::COS_Fp80), 0,
                  1/*#VTs*/, MVT::f80, 1/*#Ops*/, 0, 
              // Src: (fcos:f80 RFP80:f80:$src)
              // Dst: (COS_Fp80:f80 RFP80:f80:$src)
            0, // EndSwitchType
          /*SwitchOpcode*/ 89,  X86ISD::INC,// ->76991
/*76902*/   OPC_RecordChild0, // #0 = $src
/*76903*/   OPC_SwitchType /*4 cases */, 28,  MVT::i16,// ->76934
/*76906*/     OPC_CheckChild0Type, MVT::i16,
/*76908*/     OPC_Scope, 11, /*->76921*/ // 2 children in Scope
/*76910*/       OPC_CheckPatternPredicate, 2, // (!Subtarget->is64Bit())
/*76912*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::INC16r), 0,
                    2/*#VTs*/, MVT::i16, MVT::i32, 1/*#Ops*/, 0, 
                // Src: (X86inc_flag:i16 GR16:i16:$src)
                // Dst: (INC16r:i16 GR16:i16:$src)
/*76921*/     /*Scope*/ 11, /*->76933*/
/*76922*/       OPC_CheckPatternPredicate, 3, // (Subtarget->is64Bit())
/*76924*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::INC64_16r), 0,
                    2/*#VTs*/, MVT::i16, MVT::i32, 1/*#Ops*/, 0, 
                // Src: (X86inc_flag:i16 GR16:i16:$src)
                // Dst: (INC64_16r:i16 GR16:i16:$src)
/*76933*/     0, /*End of Scope*/
            /*SwitchType*/ 28,  MVT::i32,// ->76964
/*76936*/     OPC_CheckChild0Type, MVT::i32,
/*76938*/     OPC_Scope, 11, /*->76951*/ // 2 children in Scope
/*76940*/       OPC_CheckPatternPredicate, 2, // (!Subtarget->is64Bit())
/*76942*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::INC32r), 0,
                    2/*#VTs*/, MVT::i32, MVT::i32, 1/*#Ops*/, 0, 
                // Src: (X86inc_flag:i32 GR32:i32:$src)
                // Dst: (INC32r:i32 GR32:i32:$src)
/*76951*/     /*Scope*/ 11, /*->76963*/
/*76952*/       OPC_CheckPatternPredicate, 3, // (Subtarget->is64Bit())
/*76954*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::INC64_32r), 0,
                    2/*#VTs*/, MVT::i32, MVT::i32, 1/*#Ops*/, 0, 
                // Src: (X86inc_flag:i32 GR32:i32:$src)
                // Dst: (INC64_32r:i32 GR32:i32:$src)
/*76963*/     0, /*End of Scope*/
            /*SwitchType*/ 11,  MVT::i8,// ->76977
/*76966*/     OPC_CheckChild0Type, MVT::i8,
/*76968*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::INC8r), 0,
                  2/*#VTs*/, MVT::i8, MVT::i32, 1/*#Ops*/, 0, 
              // Src: (X86inc_flag:i8 GR8:i8:$src)
              // Dst: (INC8r:i8 GR8:i8:$src)
            /*SwitchType*/ 11,  MVT::i64,// ->76990
/*76979*/     OPC_CheckChild0Type, MVT::i64,
/*76981*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::INC64r), 0,
                  2/*#VTs*/, MVT::i64, MVT::i32, 1/*#Ops*/, 0, 
              // Src: (X86inc_flag:i64 GR64:i64:$src)
              // Dst: (INC64r:i64 GR64:i64:$src)
            0, // EndSwitchType
          /*SwitchOpcode*/ 89,  X86ISD::DEC,// ->77082
/*76993*/   OPC_RecordChild0, // #0 = $src
/*76994*/   OPC_SwitchType /*4 cases */, 28,  MVT::i16,// ->77025
/*76997*/     OPC_CheckChild0Type, MVT::i16,
/*76999*/     OPC_Scope, 11, /*->77012*/ // 2 children in Scope
/*77001*/       OPC_CheckPatternPredicate, 2, // (!Subtarget->is64Bit())
/*77003*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::DEC16r), 0,
                    2/*#VTs*/, MVT::i16, MVT::i32, 1/*#Ops*/, 0, 
                // Src: (X86dec_flag:i16 GR16:i16:$src)
                // Dst: (DEC16r:i16 GR16:i16:$src)
/*77012*/     /*Scope*/ 11, /*->77024*/
/*77013*/       OPC_CheckPatternPredicate, 3, // (Subtarget->is64Bit())
/*77015*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::DEC64_16r), 0,
                    2/*#VTs*/, MVT::i16, MVT::i32, 1/*#Ops*/, 0, 
                // Src: (X86dec_flag:i16 GR16:i16:$src)
                // Dst: (DEC64_16r:i16 GR16:i16:$src)
/*77024*/     0, /*End of Scope*/
            /*SwitchType*/ 28,  MVT::i32,// ->77055
/*77027*/     OPC_CheckChild0Type, MVT::i32,
/*77029*/     OPC_Scope, 11, /*->77042*/ // 2 children in Scope
/*77031*/       OPC_CheckPatternPredicate, 2, // (!Subtarget->is64Bit())
/*77033*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::DEC32r), 0,
                    2/*#VTs*/, MVT::i32, MVT::i32, 1/*#Ops*/, 0, 
                // Src: (X86dec_flag:i32 GR32:i32:$src)
                // Dst: (DEC32r:i32 GR32:i32:$src)
/*77042*/     /*Scope*/ 11, /*->77054*/
/*77043*/       OPC_CheckPatternPredicate, 3, // (Subtarget->is64Bit())
/*77045*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::DEC64_32r), 0,
                    2/*#VTs*/, MVT::i32, MVT::i32, 1/*#Ops*/, 0, 
                // Src: (X86dec_flag:i32 GR32:i32:$src)
                // Dst: (DEC64_32r:i32 GR32:i32:$src)
/*77054*/     0, /*End of Scope*/
            /*SwitchType*/ 11,  MVT::i8,// ->77068
/*77057*/     OPC_CheckChild0Type, MVT::i8,
/*77059*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::DEC8r), 0,
                  2/*#VTs*/, MVT::i8, MVT::i32, 1/*#Ops*/, 0, 
              // Src: (X86dec_flag:i8 GR8:i8:$src)
              // Dst: (DEC8r:i8 GR8:i8:$src)
            /*SwitchType*/ 11,  MVT::i64,// ->77081
/*77070*/     OPC_CheckChild0Type, MVT::i64,
/*77072*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::DEC64r), 0,
                  2/*#VTs*/, MVT::i64, MVT::i32, 1/*#Ops*/, 0, 
              // Src: (X86dec_flag:i64 GR64:i64:$src)
              // Dst: (DEC64r:i64 GR64:i64:$src)
            0, // EndSwitchType
          /*SwitchOpcode*/ 17,  ISD::BR,// ->77101
/*77084*/   OPC_RecordNode,   // #0 = 'br' chained node
/*77085*/   OPC_RecordChild1, // #1 = $dst
/*77086*/   OPC_MoveChild, 1,
/*77088*/   OPC_CheckOpcode, ISD::BasicBlock,
/*77090*/   OPC_MoveParent,
/*77091*/   OPC_EmitMergeInputChains, 1, 0, 
/*77094*/   OPC_MorphNodeTo, TARGET_OPCODE(X86::JMP_4), 0|OPFL_Chain,
                0/*#VTs*/, 1/*#Ops*/, 1, 
            // Src: (br:isVoid (bb:Other):$dst)
            // Dst: (JMP_4:isVoid (bb:Other):$dst)
          /*SwitchOpcode*/ 23,  ISD::BSWAP,// ->77126
/*77103*/   OPC_RecordChild0, // #0 = $src
/*77104*/   OPC_SwitchType /*2 cases */, 8,  MVT::i32,// ->77115
/*77107*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::BSWAP32r), 0,
                  1/*#VTs*/, MVT::i32, 1/*#Ops*/, 0, 
              // Src: (bswap:i32 GR32:i32:$src)
              // Dst: (BSWAP32r:i32 GR32:i32:$src)
            /*SwitchType*/ 8,  MVT::i64,// ->77125
/*77117*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::BSWAP64r), 0,
                  1/*#VTs*/, MVT::i64, 1/*#Ops*/, 0, 
              // Src: (bswap:i64 GR64:i64:$src)
              // Dst: (BSWAP64r:i64 GR64:i64:$src)
            0, // EndSwitchType
          /*SwitchOpcode*/ 58,  X86ISD::REP_MOVS,// ->77186
/*77128*/   OPC_RecordNode,   // #0 = 'X86rep_movs' chained node
/*77129*/   OPC_CaptureFlagInput,
/*77130*/   OPC_MoveChild, 1,
/*77132*/   OPC_Scope, 12, /*->77146*/ // 4 children in Scope
/*77134*/     OPC_CheckValueType, MVT::i8,
/*77136*/     OPC_MoveParent,
/*77137*/     OPC_EmitMergeInputChains, 1, 0, 
/*77140*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::REP_MOVSB), 0|OPFL_Chain|OPFL_FlagInput|OPFL_FlagOutput,
                  0/*#VTs*/, 0/*#Ops*/, 
              // Src: (X86rep_movs:isVoid i8:Other)
              // Dst: (REP_MOVSB:isVoid)
/*77146*/   /*Scope*/ 12, /*->77159*/
/*77147*/     OPC_CheckValueType, MVT::i16,
/*77149*/     OPC_MoveParent,
/*77150*/     OPC_EmitMergeInputChains, 1, 0, 
/*77153*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::REP_MOVSW), 0|OPFL_Chain|OPFL_FlagInput|OPFL_FlagOutput,
                  0/*#VTs*/, 0/*#Ops*/, 
              // Src: (X86rep_movs:isVoid i16:Other)
              // Dst: (REP_MOVSW:isVoid)
/*77159*/   /*Scope*/ 12, /*->77172*/
/*77160*/     OPC_CheckValueType, MVT::i32,
/*77162*/     OPC_MoveParent,
/*77163*/     OPC_EmitMergeInputChains, 1, 0, 
/*77166*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::REP_MOVSD), 0|OPFL_Chain|OPFL_FlagInput|OPFL_FlagOutput,
                  0/*#VTs*/, 0/*#Ops*/, 
              // Src: (X86rep_movs:isVoid i32:Other)
              // Dst: (REP_MOVSD:isVoid)
/*77172*/   /*Scope*/ 12, /*->77185*/
/*77173*/     OPC_CheckValueType, MVT::i64,
/*77175*/     OPC_MoveParent,
/*77176*/     OPC_EmitMergeInputChains, 1, 0, 
/*77179*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::REP_MOVSQ), 0|OPFL_Chain|OPFL_FlagInput|OPFL_FlagOutput,
                  0/*#VTs*/, 0/*#Ops*/, 
              // Src: (X86rep_movs:isVoid i64:Other)
              // Dst: (REP_MOVSQ:isVoid)
/*77185*/   0, /*End of Scope*/
          /*SwitchOpcode*/ 58,  X86ISD::REP_STOS,// ->77246
/*77188*/   OPC_RecordNode,   // #0 = 'X86rep_stos' chained node
/*77189*/   OPC_CaptureFlagInput,
/*77190*/   OPC_MoveChild, 1,
/*77192*/   OPC_Scope, 12, /*->77206*/ // 4 children in Scope
/*77194*/     OPC_CheckValueType, MVT::i8,
/*77196*/     OPC_MoveParent,
/*77197*/     OPC_EmitMergeInputChains, 1, 0, 
/*77200*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::REP_STOSB), 0|OPFL_Chain|OPFL_FlagInput|OPFL_FlagOutput,
                  0/*#VTs*/, 0/*#Ops*/, 
              // Src: (X86rep_stos:isVoid i8:Other)
              // Dst: (REP_STOSB:isVoid)
/*77206*/   /*Scope*/ 12, /*->77219*/
/*77207*/     OPC_CheckValueType, MVT::i16,
/*77209*/     OPC_MoveParent,
/*77210*/     OPC_EmitMergeInputChains, 1, 0, 
/*77213*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::REP_STOSW), 0|OPFL_Chain|OPFL_FlagInput|OPFL_FlagOutput,
                  0/*#VTs*/, 0/*#Ops*/, 
              // Src: (X86rep_stos:isVoid i16:Other)
              // Dst: (REP_STOSW:isVoid)
/*77219*/   /*Scope*/ 12, /*->77232*/
/*77220*/     OPC_CheckValueType, MVT::i32,
/*77222*/     OPC_MoveParent,
/*77223*/     OPC_EmitMergeInputChains, 1, 0, 
/*77226*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::REP_STOSD), 0|OPFL_Chain|OPFL_FlagInput|OPFL_FlagOutput,
                  0/*#VTs*/, 0/*#Ops*/, 
              // Src: (X86rep_stos:isVoid i32:Other)
              // Dst: (REP_STOSD:isVoid)
/*77232*/   /*Scope*/ 12, /*->77245*/
/*77233*/     OPC_CheckValueType, MVT::i64,
/*77235*/     OPC_MoveParent,
/*77236*/     OPC_EmitMergeInputChains, 1, 0, 
/*77239*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::REP_STOSQ), 0|OPFL_Chain|OPFL_FlagInput|OPFL_FlagOutput,
                  0/*#VTs*/, 0/*#Ops*/, 
              // Src: (X86rep_stos:isVoid i64:Other)
              // Dst: (REP_STOSQ:isVoid)
/*77245*/   0, /*End of Scope*/
          /*SwitchOpcode*/ 10,  X86ISD::RDTSC_DAG,// ->77258
/*77248*/   OPC_RecordNode,   // #0 = 'X86rdtsc' chained node
/*77249*/   OPC_EmitMergeInputChains, 1, 0, 
/*77252*/   OPC_MorphNodeTo, TARGET_OPCODE(X86::RDTSC), 0|OPFL_Chain|OPFL_FlagOutput,
                0/*#VTs*/, 0/*#Ops*/, 
            // Src: (X86rdtsc:isVoid)
            // Dst: (RDTSC:isVoid)
          /*SwitchOpcode*/ 10,  ISD::TRAP,// ->77270
/*77260*/   OPC_RecordNode,   // #0 = 'trap' chained node
/*77261*/   OPC_EmitMergeInputChains, 1, 0, 
/*77264*/   OPC_MorphNodeTo, TARGET_OPCODE(X86::TRAP), 0|OPFL_Chain,
                0/*#VTs*/, 0/*#Ops*/, 
            // Src: (trap:isVoid)
            // Dst: (TRAP:isVoid)
          /*SwitchOpcode*/ 76,  ISD::SIGN_EXTEND,// ->77348
/*77272*/   OPC_RecordChild0, // #0 = $src
/*77273*/   OPC_Scope, 34, /*->77309*/ // 3 children in Scope
/*77275*/     OPC_CheckChild0Type, MVT::i8,
/*77277*/     OPC_SwitchType /*3 cases */, 8,  MVT::i16,// ->77288
/*77280*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVSX16rr8), 0,
                    1/*#VTs*/, MVT::i16, 1/*#Ops*/, 0, 
                // Src: (sext:i16 GR8:i8:$src)
                // Dst: (MOVSX16rr8:i16 GR8:i8:$src)
              /*SwitchType*/ 8,  MVT::i32,// ->77298
/*77290*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVSX32rr8), 0,
                    1/*#VTs*/, MVT::i32, 1/*#Ops*/, 0, 
                // Src: (sext:i32 GR8:i8:$src)
                // Dst: (MOVSX32rr8:i32 GR8:i8:$src)
              /*SwitchType*/ 8,  MVT::i64,// ->77308
/*77300*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVSX64rr8), 0,
                    1/*#VTs*/, MVT::i64, 1/*#Ops*/, 0, 
                // Src: (sext:i64 GR8:i8:$src)
                // Dst: (MOVSX64rr8:i64 GR8:i8:$src)
              0, // EndSwitchType
/*77309*/   /*Scope*/ 24, /*->77334*/
/*77310*/     OPC_CheckChild0Type, MVT::i16,
/*77312*/     OPC_SwitchType /*2 cases */, 8,  MVT::i32,// ->77323
/*77315*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVSX32rr16), 0,
                    1/*#VTs*/, MVT::i32, 1/*#Ops*/, 0, 
                // Src: (sext:i32 GR16:i16:$src)
                // Dst: (MOVSX32rr16:i32 GR16:i16:$src)
              /*SwitchType*/ 8,  MVT::i64,// ->77333
/*77325*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVSX64rr16), 0,
                    1/*#VTs*/, MVT::i64, 1/*#Ops*/, 0, 
                // Src: (sext:i64 GR16:i16:$src)
                // Dst: (MOVSX64rr16:i64 GR16:i16:$src)
              0, // EndSwitchType
/*77334*/   /*Scope*/ 12, /*->77347*/
/*77335*/     OPC_CheckChild0Type, MVT::i32,
/*77337*/     OPC_CheckType, MVT::i64,
/*77339*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVSX64rr32), 0,
                  1/*#VTs*/, MVT::i64, 1/*#Ops*/, 0, 
              // Src: (sext:i64 GR32:i32:$src)
              // Dst: (MOVSX64rr32:i64 GR32:i32:$src)
/*77347*/   0, /*End of Scope*/
          /*SwitchOpcode*/ 30,  X86ISD::EH_RETURN,// ->77380
/*77350*/   OPC_RecordNode,   // #0 = 'X86ehret' chained node
/*77351*/   OPC_RecordChild1, // #1 = $addr
/*77352*/   OPC_Scope, 12, /*->77366*/ // 2 children in Scope
/*77354*/     OPC_CheckChild1Type, MVT::i32,
/*77356*/     OPC_EmitMergeInputChains, 1, 0, 
/*77359*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::EH_RETURN), 0|OPFL_Chain,
                  0/*#VTs*/, 1/*#Ops*/, 1, 
              // Src: (X86ehret:isVoid GR32:i32:$addr)
              // Dst: (EH_RETURN:isVoid GR32:i32:$addr)
/*77366*/   /*Scope*/ 12, /*->77379*/
/*77367*/     OPC_CheckChild1Type, MVT::i64,
/*77369*/     OPC_EmitMergeInputChains, 1, 0, 
/*77372*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::EH_RETURN64), 0|OPFL_Chain,
                  0/*#VTs*/, 1/*#Ops*/, 1, 
              // Src: (X86ehret:isVoid GR64:i64:$addr)
              // Dst: (EH_RETURN64:isVoid GR64:i64:$addr)
/*77379*/   0, /*End of Scope*/
          /*SwitchOpcode*/ 106|128,1/*234*/,  ISD::SIGN_EXTEND_INREG,// ->77617
/*77383*/   OPC_RecordChild0, // #0 = $src
/*77384*/   OPC_MoveChild, 1,
/*77386*/   OPC_Scope, 49, /*->77437*/ // 3 children in Scope
/*77388*/     OPC_CheckValueType, MVT::i16,
/*77390*/     OPC_MoveParent,
/*77391*/     OPC_SwitchType /*2 cases */, 20,  MVT::i32,// ->77414
/*77394*/       OPC_EmitInteger, MVT::i32, 3, 
/*77397*/       OPC_EmitNode, TARGET_OPCODE(TargetOpcode::EXTRACT_SUBREG), 0,
                    1/*#VTs*/, MVT::i16, 2/*#Ops*/, 0, 1,  // Results = #2 
/*77406*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVSX32rr16), 0,
                    1/*#VTs*/, MVT::i32, 1/*#Ops*/, 2, 
                // Src: (sext_inreg:i32 GR32:i32:$src, i16:Other)
                // Dst: (MOVSX32rr16:i32 (EXTRACT_SUBREG:i16 GR32:i32:$src, 3:i32))
              /*SwitchType*/ 20,  MVT::i64,// ->77436
/*77416*/       OPC_EmitInteger, MVT::i32, 3, 
/*77419*/       OPC_EmitNode, TARGET_OPCODE(TargetOpcode::EXTRACT_SUBREG), 0,
                    1/*#VTs*/, MVT::i16, 2/*#Ops*/, 0, 1,  // Results = #2 
/*77428*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVSX64rr16), 0,
                    1/*#VTs*/, MVT::i64, 1/*#Ops*/, 2, 
                // Src: (sext_inreg:i64 GR64:i64:$src, i16:Other)
                // Dst: (MOVSX64rr16:i64 (EXTRACT_SUBREG:i16 GR64:i64:$src, 3:i32))
              0, // EndSwitchType
/*77437*/   /*Scope*/ 25, /*->77463*/
/*77438*/     OPC_CheckValueType, MVT::i32,
/*77440*/     OPC_MoveParent,
/*77441*/     OPC_CheckType, MVT::i64,
/*77443*/     OPC_EmitInteger, MVT::i32, 4, 
/*77446*/     OPC_EmitNode, TARGET_OPCODE(TargetOpcode::EXTRACT_SUBREG), 0,
                  1/*#VTs*/, MVT::i32, 2/*#Ops*/, 0, 1,  // Results = #2 
/*77455*/     OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVSX64rr32), 0,
                  1/*#VTs*/, MVT::i64, 1/*#Ops*/, 2, 
              // Src: (sext_inreg:i64 GR64:i64:$src, i32:Other)
              // Dst: (MOVSX64rr32:i64 (EXTRACT_SUBREG:i32 GR64:i64:$src, 4:i32))
/*77463*/   /*Scope*/ 23|128,1/*151*/, /*->77616*/
/*77465*/     OPC_CheckValueType, MVT::i8,
/*77467*/     OPC_MoveParent,
/*77468*/     OPC_SwitchType /*3 cases */, 20,  MVT::i64,// ->77491
/*77471*/       OPC_EmitInteger, MVT::i32, 1, 
/*77474*/       OPC_EmitNode, TARGET_OPCODE(TargetOpcode::EXTRACT_SUBREG), 0,
                    1/*#VTs*/, MVT::i8, 2/*#Ops*/, 0, 1,  // Results = #2 
/*77483*/       OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVSX64rr8), 0,
                    1/*#VTs*/, MVT::i64, 1/*#Ops*/, 2, 
                // Src: (sext_inreg:i64 GR64:i64:$src, i8:Other)
                // Dst: (MOVSX64rr8:i64 (EXTRACT_SUBREG:i8 GR64:i64:$src, 1:i32))
              /*SwitchType*/ 60,  MVT::i32,// ->77553
/*77493*/       OPC_Scope, 22, /*->77517*/ // 2 children in Scope
/*77495*/         OPC_CheckPatternPredicate, 3, // (Subtarget->is64Bit())
/*77497*/         OPC_EmitInteger, MVT::i32, 1, 
/*77500*/         OPC_EmitNode, TARGET_OPCODE(TargetOpcode::EXTRACT_SUBREG), 0,
                      1/*#VTs*/, MVT::i8, 2/*#Ops*/, 0, 1,  // Results = #2 
/*77509*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVSX32rr8), 0,
                      1/*#VTs*/, MVT::i32, 1/*#Ops*/, 2, 
                  // Src: (sext_inreg:i32 GR32:i32:$src, i8:Other)
                  // Dst: (MOVSX32rr8:i32 (EXTRACT_SUBREG:i8 GR32:i32:$src, 1:i32))
/*77517*/       /*Scope*/ 34, /*->77552*/
/*77518*/         OPC_CheckPatternPredicate, 2, // (!Subtarget->is64Bit())
/*77520*/         OPC_EmitInteger, MVT::i32, X86::GR32_ABCDRegClassID,
/*77523*/         OPC_EmitNode, TARGET_OPCODE(TargetOpcode::COPY_TO_REGCLASS), 0,
                      1/*#VTs*/, MVT::i32, 2/*#Ops*/, 0, 1,  // Results = #2 
/*77532*/         OPC_EmitInteger, MVT::i32, 1, 
/*77535*/         OPC_EmitNode, TARGET_OPCODE(TargetOpcode::EXTRACT_SUBREG), 0,
                      1/*#VTs*/, MVT::i8, 2/*#Ops*/, 2, 3,  // Results = #4 
/*77544*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVSX32rr8), 0,
                      1/*#VTs*/, MVT::i32, 1/*#Ops*/, 4, 
                  // Src: (sext_inreg:i32 GR32:i32:$src, i8:Other)
                  // Dst: (MOVSX32rr8:i32 (EXTRACT_SUBREG:i8 (COPY_TO_REGCLASS:i32 GR32:i32:$src, GR32_ABCD:i32), 1:i32))
/*77552*/       0, /*End of Scope*/
              /*SwitchType*/ 60,  MVT::i16,// ->77615
/*77555*/       OPC_Scope, 22, /*->77579*/ // 2 children in Scope
/*77557*/         OPC_CheckPatternPredicate, 3, // (Subtarget->is64Bit())
/*77559*/         OPC_EmitInteger, MVT::i32, 1, 
/*77562*/         OPC_EmitNode, TARGET_OPCODE(TargetOpcode::EXTRACT_SUBREG), 0,
                      1/*#VTs*/, MVT::i8, 2/*#Ops*/, 0, 1,  // Results = #2 
/*77571*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVSX16rr8), 0,
                      1/*#VTs*/, MVT::i16, 1/*#Ops*/, 2, 
                  // Src: (sext_inreg:i16 GR16:i16:$src, i8:Other)
                  // Dst: (MOVSX16rr8:i16 (EXTRACT_SUBREG:i8 GR16:i16:$src, 1:i32))
/*77579*/       /*Scope*/ 34, /*->77614*/
/*77580*/         OPC_CheckPatternPredicate, 2, // (!Subtarget->is64Bit())
/*77582*/         OPC_EmitInteger, MVT::i32, X86::GR16_ABCDRegClassID,
/*77585*/         OPC_EmitNode, TARGET_OPCODE(TargetOpcode::COPY_TO_REGCLASS), 0,
                      1/*#VTs*/, MVT::i16, 2/*#Ops*/, 0, 1,  // Results = #2 
/*77594*/         OPC_EmitInteger, MVT::i32, 1, 
/*77597*/         OPC_EmitNode, TARGET_OPCODE(TargetOpcode::EXTRACT_SUBREG), 0,
                      1/*#VTs*/, MVT::i8, 2/*#Ops*/, 2, 3,  // Results = #4 
/*77606*/         OPC_MorphNodeTo, TARGET_OPCODE(X86::MOVSX16rr8), 0,
                      1/*#VTs*/, MVT::i16, 1/*#Ops*/, 4, 
                  // Src: (sext_inreg:i16 GR16:i16:$src, i8:Other)
                  // Dst: (MOVSX16rr8:i16 (EXTRACT_SUBREG:i8 (COPY_TO_REGCLASS:i16 GR16:i16:$src, GR16_ABCD:i16), 1:i32))
/*77614*/       0, /*End of Scope*/
              0, // EndSwitchType
/*77616*/   0, /*End of Scope*/
          /*SwitchOpcode*/ 11,  X86ISD::MINGW_ALLOCA,// ->77630
/*77619*/   OPC_RecordNode,   // #0 = 'X86MingwAlloca' chained node
/*77620*/   OPC_CaptureFlagInput,
/*77621*/   OPC_EmitMergeInputChains, 1, 0, 
/*77624*/   OPC_MorphNodeTo, TARGET_OPCODE(X86::MINGW_ALLOCA), 0|OPFL_Chain|OPFL_FlagInput|OPFL_FlagOutput,
                0/*#VTs*/, 0/*#Ops*/, 
            // Src: (X86MingwAlloca:isVoid)
            // Dst: (MINGW_ALLOCA:isVoid)
          0, // EndSwitchOpcode
    0
  }; // Total Array size is 77632 bytes

  // Opcode Histogram:
  // #OPC_Scope                          = 765
  // #OPC_RecordNode                     = 555
  // #OPC_RecordChild                    = 2248
  // #OPC_RecordMemRef                   = 490
  // #OPC_CaptureFlagInput               = 15
  // #OPC_MoveChild                      = 1855
  // #OPC_MoveParent                     = 3404
  // #OPC_CheckSame                      = 352
  // #OPC_CheckPatternPredicate          = 1257
  // #OPC_CheckPredicate                 = 2873
  // #OPC_CheckOpcode                    = 1228
  // #OPC_SwitchOpcode                   = 51
  // #OPC_CheckType                      = 1368
  // #OPC_SwitchType                     = 345
  // #OPC_CheckChildType                 = 236
  // #OPC_CheckInteger                   = 585
  // #OPC_CheckCondCode                  = 0
  // #OPC_CheckValueType                 = 36
  // #OPC_CheckComplexPat                = 1470
  // #OPC_CheckAndImm                    = 23
  // #OPC_CheckOrImm                     = 0
  // #OPC_CheckFoldableChainNode         = 478
  // #OPC_EmitInteger                    = 97
  // #OPC_EmitStringInteger              = 22
  // #OPC_EmitRegister                   = 0
  // #OPC_EmitConvertToTarget            = 454
  // #OPC_EmitMergeInputChains           = 1518
  // #OPC_EmitCopyToReg                  = 383
  // #OPC_EmitNode                       = 95
  // #OPC_EmitNodeXForm                  = 39
  // #OPC_MarkFlagResults                = 26
  // #OPC_CompleteMatch                  = 51
  // #OPC_MorphNodeTo                    = 2712

  #undef TARGET_OPCODE
  return SelectCodeCommon(N, MatcherTable,sizeof(MatcherTable));
}

bool CheckPatternPredicate(unsigned PredNo) const {
  switch (PredNo) {
  default: assert(0 && "Invalid predicate in table?");
  case 0: return (Subtarget->hasSSE1());
  case 1: return (Subtarget->hasSSE2());
  case 2: return (!Subtarget->is64Bit());
  case 3: return (Subtarget->is64Bit());
  case 4: return (Subtarget->hasSSE41());
  case 5: return (TM.getCodeModel() == CodeModel::Small ||TM.getCodeModel() == CodeModel::Kernel) && (TM.getRelocationModel() == Reloc::Static);
  case 6: return (!Subtarget->hasSSE1());
  case 7: return (!Subtarget->hasSSE2());
  case 8: return (Subtarget->hasMMX());
  case 9: return (Subtarget->hasSSE3());
  case 10: return (!OptForSize) && (Subtarget->hasSSE2());
  case 11: return (Subtarget->hasSSSE3());
  case 12: return (Subtarget->hasSSE2()) && (OptForSize);
  case 13: return (Subtarget->hasSSE2()) && (!OptForSize);
  case 14: return (Subtarget->hasSSE42());
  case 15: return (Subtarget->hasMMX()) && (Subtarget->is64Bit());
  case 16: return (!Subtarget->isTargetWin64());
  case 17: return (Subtarget->isTargetWin64());
  case 18: return (Subtarget->IsLegalToCallImmediateAddr(TM));
  case 19: return (Subtarget->hasSSE1()) && (OptForSize);
  case 20: return (TM.getCodeModel() != CodeModel::Small &&TM.getCodeModel() != CodeModel::Kernel);
  case 21: return (TM.getCodeModel() == CodeModel::Small);
  case 22: return (TM.getCodeModel() == CodeModel::Kernel);
  }
}

bool CheckNodePredicate(SDNode *Node, unsigned PredNo) const {
  switch (PredNo) {
  default: assert(0 && "Invalid predicate in table?");
  case 0: { // Predicate_alignednontemporalstore
    SDNode *N = Node;

  if (StoreSDNode *ST = dyn_cast<StoreSDNode>(N))
    return ST->isNonTemporal() && !ST->isTruncatingStore() &&
           ST->getAddressingMode() == ISD::UNINDEXED &&
           ST->getAlignment() >= 16;
  return false;

  }
  case 1: { // Predicate_nontemporalstore
    SDNode *N = Node;

  if (StoreSDNode *ST = dyn_cast<StoreSDNode>(N))
    return ST->isNonTemporal();
  return false;

  }
  case 2: { // Predicate_unindexedload
    SDNode *N = Node;

  return cast<LoadSDNode>(N)->getAddressingMode() == ISD::UNINDEXED;

  }
  case 3: { // Predicate_loadi32
    SDNode *N = Node;

  LoadSDNode *LD = cast<LoadSDNode>(N);
  if (const Value *Src = LD->getSrcValue())
    if (const PointerType *PT = dyn_cast<PointerType>(Src->getType()))
      if (PT->getAddressSpace() > 255)
        return false;
  ISD::LoadExtType ExtType = LD->getExtensionType();
  if (ExtType == ISD::NON_EXTLOAD)
    return true;
  if (ExtType == ISD::EXTLOAD)
    return LD->getAlignment() >= 4 && !LD->isVolatile();
  return false;

  }
  case 4: { // Predicate_unindexedstore
    SDNode *N = Node;

  return cast<StoreSDNode>(N)->getAddressingMode() == ISD::UNINDEXED;

  }
  case 5: { // Predicate_store
    SDNode *N = Node;

  return !cast<StoreSDNode>(N)->isTruncatingStore();

  }
  case 6: { // Predicate_loadi16
    SDNode *N = Node;

  LoadSDNode *LD = cast<LoadSDNode>(N);
  if (const Value *Src = LD->getSrcValue())
    if (const PointerType *PT = dyn_cast<PointerType>(Src->getType()))
      if (PT->getAddressSpace() > 255)
        return false;
  ISD::LoadExtType ExtType = LD->getExtensionType();
  if (ExtType == ISD::NON_EXTLOAD)
    return true;
  if (ExtType == ISD::EXTLOAD)
    return LD->getAlignment() >= 2 && !LD->isVolatile();
  return false;

  }
  case 7: { // Predicate_shrd
    SDNode *N = Node;

  assert(N->getOpcode() == ISD::OR);
  return N->getOperand(0).getOpcode() == ISD::SRL &&
         N->getOperand(1).getOpcode() == ISD::SHL &&
         isa<ConstantSDNode>(N->getOperand(0).getOperand(1)) &&
         isa<ConstantSDNode>(N->getOperand(1).getOperand(1)) &&
         N->getOperand(0).getConstantOperandVal(1) ==
         N->getValueSizeInBits(0) - N->getOperand(1).getConstantOperandVal(1);

  }
  case 8: { // Predicate_load
    SDNode *N = Node;

  return cast<LoadSDNode>(N)->getExtensionType() == ISD::NON_EXTLOAD;

  }
  case 9: { // Predicate_dsload
    SDNode *N = Node;

  if (const Value *Src = cast<LoadSDNode>(N)->getSrcValue())
    if (const PointerType *PT = dyn_cast<PointerType>(Src->getType()))
      if (PT->getAddressSpace() > 255)
        return false;
  return true;

  }
  case 10: { // Predicate_shld
    SDNode *N = Node;

  assert(N->getOpcode() == ISD::OR);
  return N->getOperand(0).getOpcode() == ISD::SHL &&
         N->getOperand(1).getOpcode() == ISD::SRL &&
         isa<ConstantSDNode>(N->getOperand(0).getOperand(1)) &&
         isa<ConstantSDNode>(N->getOperand(1).getOperand(1)) &&
         N->getOperand(0).getConstantOperandVal(1) ==
         N->getValueSizeInBits(0) - N->getOperand(1).getConstantOperandVal(1);

  }
  case 11: { // Predicate_immSext8
    ConstantSDNode*N = cast<ConstantSDNode>(Node);

  return N->getSExtValue() == (int8_t)N->getSExtValue();

  }
  case 12: { // Predicate_i64immSExt32
    ConstantSDNode*N = cast<ConstantSDNode>(Node);

  // i64immSExt32 predicate - True if the 64-bit immediate fits in a 32-bit
  // sign extended field.
  return (int64_t)N->getZExtValue() == (int32_t)N->getZExtValue();

  }
  case 13: { // Predicate_movlp
    SDNode *N = Node;

  return X86::isMOVLPMask(cast<ShuffleVectorSDNode>(N));

  }
  case 14: { // Predicate_unpckh
    SDNode *N = Node;

  return X86::isUNPCKHMask(cast<ShuffleVectorSDNode>(N));

  }
  case 15: { // Predicate_srl_su
    SDNode *N = Node;

  return N->hasOneUse();

  }
  case 16: { // Predicate_trunc_su
    SDNode *N = Node;

  return N->hasOneUse();

  }
  case 17: { // Predicate_truncstore
    SDNode *N = Node;

  return cast<StoreSDNode>(N)->isTruncatingStore();

  }
  case 18: { // Predicate_truncstorei16
    SDNode *N = Node;

  return cast<StoreSDNode>(N)->getMemoryVT() == MVT::i16;

  }
  case 19: { // Predicate_truncstoref32
    SDNode *N = Node;

  return cast<StoreSDNode>(N)->getMemoryVT() == MVT::f32;

  }
  case 20: { // Predicate_truncstoref64
    SDNode *N = Node;

  return cast<StoreSDNode>(N)->getMemoryVT() == MVT::f64;

  }
  case 21: { // Predicate_alignedstore
    SDNode *N = Node;

  return cast<StoreSDNode>(N)->getAlignment() >= 16;

  }
  case 22: { // Predicate_movlhps
    SDNode *N = Node;

  return X86::isMOVLHPSMask(cast<ShuffleVectorSDNode>(N));

  }
  case 23: { // Predicate_memop
    SDNode *N = Node;

  return    Subtarget->hasVectorUAMem()
         || cast<LoadSDNode>(N)->getAlignment() >= 16;

  }
  case 24: { // Predicate_movshdup
    SDNode *N = Node;

  return X86::isMOVSHDUPMask(cast<ShuffleVectorSDNode>(N));

  }
  case 25: { // Predicate_movsldup
    SDNode *N = Node;

  return X86::isMOVSLDUPMask(cast<ShuffleVectorSDNode>(N));

  }
  case 26: { // Predicate_pshufd
    SDNode *N = Node;

  return X86::isPSHUFDMask(cast<ShuffleVectorSDNode>(N));

  }
  case 27: { // Predicate_movddup
    SDNode *N = Node;

  return X86::isMOVDDUPMask(cast<ShuffleVectorSDNode>(N));

  }
  case 28: { // Predicate_unpckl
    SDNode *N = Node;

  return X86::isUNPCKLMask(cast<ShuffleVectorSDNode>(N));

  }
  case 29: { // Predicate_pshufhw
    SDNode *N = Node;

  return X86::isPSHUFHWMask(cast<ShuffleVectorSDNode>(N));

  }
  case 30: { // Predicate_pshuflw
    SDNode *N = Node;

  return X86::isPSHUFLWMask(cast<ShuffleVectorSDNode>(N));

  }
  case 31: { // Predicate_mmx_pshufw
    SDNode *N = Node;

  return X86::isPSHUFDMask(cast<ShuffleVectorSDNode>(N));

  }
  case 32: { // Predicate_shufp
    SDNode *N = Node;

  return X86::isSHUFPMask(cast<ShuffleVectorSDNode>(N));

  }
  case 33: { // Predicate_mmx_unpckh
    SDNode *N = Node;

  return X86::isUNPCKHMask(cast<ShuffleVectorSDNode>(N));

  }
  case 34: { // Predicate_mmx_unpckl
    SDNode *N = Node;

  return X86::isUNPCKLMask(cast<ShuffleVectorSDNode>(N));

  }
  case 35: { // Predicate_movhlps_undef
    SDNode *N = Node;

  return X86::isMOVHLPS_v_undef_Mask(cast<ShuffleVectorSDNode>(N));

  }
  case 36: { // Predicate_movhlps
    SDNode *N = Node;

  return X86::isMOVHLPSMask(cast<ShuffleVectorSDNode>(N));

  }
  case 37: { // Predicate_immAllZerosV_bc
    SDNode *N = Node;

  return ISD::isBuildVectorAllZeros(N);

  }
  case 38: { // Predicate_movl
    SDNode *N = Node;

  return X86::isMOVLMask(cast<ShuffleVectorSDNode>(N));

  }
  case 39: { // Predicate_unpckl_undef
    SDNode *N = Node;

  return X86::isUNPCKL_v_undef_Mask(cast<ShuffleVectorSDNode>(N));

  }
  case 40: { // Predicate_unpckh_undef
    SDNode *N = Node;

  return X86::isUNPCKH_v_undef_Mask(cast<ShuffleVectorSDNode>(N));

  }
  case 41: { // Predicate_splat_lo
    SDNode *N = Node;

  ShuffleVectorSDNode *SVOp = cast<ShuffleVectorSDNode>(N);
  return SVOp->isSplat() && SVOp->getSplatIndex() == 0;

  }
  case 42: { // Predicate_mmx_unpckl_undef
    SDNode *N = Node;

  return X86::isUNPCKL_v_undef_Mask(cast<ShuffleVectorSDNode>(N));

  }
  case 43: { // Predicate_mmx_unpckh_undef
    SDNode *N = Node;

  return X86::isUNPCKH_v_undef_Mask(cast<ShuffleVectorSDNode>(N));

  }
  case 44: { // Predicate_immAllZerosV
    SDNode *N = Node;

  return ISD::isBuildVectorAllZeros(N);

  }
  case 45: { // Predicate_palign
    SDNode *N = Node;

  return X86::isPALIGNRMask(cast<ShuffleVectorSDNode>(N));

  }
  case 46: { // Predicate_gsload
    SDNode *N = Node;

  if (const Value *Src = cast<LoadSDNode>(N)->getSrcValue())
    if (const PointerType *PT = dyn_cast<PointerType>(Src->getType()))
      return PT->getAddressSpace() == 256;
  return false;

  }
  case 47: { // Predicate_fsload
    SDNode *N = Node;

  if (const Value *Src = cast<LoadSDNode>(N)->getSrcValue())
    if (const PointerType *PT = dyn_cast<PointerType>(Src->getType()))
      return PT->getAddressSpace() == 257;
  return false;

  }
  case 48: { // Predicate_extload
    SDNode *N = Node;

  return cast<LoadSDNode>(N)->getExtensionType() == ISD::EXTLOAD;

  }
  case 49: { // Predicate_extloadf32
    SDNode *N = Node;

  return cast<LoadSDNode>(N)->getMemoryVT() == MVT::f32;

  }
  case 50: { // Predicate_extloadf64
    SDNode *N = Node;

  return cast<LoadSDNode>(N)->getMemoryVT() == MVT::f64;

  }
  case 51: { // Predicate_sextload
    SDNode *N = Node;

  return cast<LoadSDNode>(N)->getExtensionType() == ISD::SEXTLOAD;

  }
  case 52: { // Predicate_sextloadi8
    SDNode *N = Node;

  return cast<LoadSDNode>(N)->getMemoryVT() == MVT::i8;

  }
  case 53: { // Predicate_sextloadi16
    SDNode *N = Node;

  return cast<LoadSDNode>(N)->getMemoryVT() == MVT::i16;

  }
  case 54: { // Predicate_zextload
    SDNode *N = Node;

  return cast<LoadSDNode>(N)->getExtensionType() == ISD::ZEXTLOAD;

  }
  case 55: { // Predicate_zextloadi8
    SDNode *N = Node;

  return cast<LoadSDNode>(N)->getMemoryVT() == MVT::i8;

  }
  case 56: { // Predicate_zextloadi16
    SDNode *N = Node;

  return cast<LoadSDNode>(N)->getMemoryVT() == MVT::i16;

  }
  case 57: { // Predicate_zextloadi1
    SDNode *N = Node;

  return cast<LoadSDNode>(N)->getMemoryVT() == MVT::i1;

  }
  case 58: { // Predicate_extloadi1
    SDNode *N = Node;

  return cast<LoadSDNode>(N)->getMemoryVT() == MVT::i1;

  }
  case 59: { // Predicate_extloadi8
    SDNode *N = Node;

  return cast<LoadSDNode>(N)->getMemoryVT() == MVT::i8;

  }
  case 60: { // Predicate_extloadi16
    SDNode *N = Node;

  return cast<LoadSDNode>(N)->getMemoryVT() == MVT::i16;

  }
  case 61: { // Predicate_sextloadi32
    SDNode *N = Node;

  return cast<LoadSDNode>(N)->getMemoryVT() == MVT::i32;

  }
  case 62: { // Predicate_zextloadi32
    SDNode *N = Node;

  return cast<LoadSDNode>(N)->getMemoryVT() == MVT::i32;

  }
  case 63: { // Predicate_alignedload
    SDNode *N = Node;

  return cast<LoadSDNode>(N)->getAlignment() >= 16;

  }
  case 64: { // Predicate_extloadi32
    SDNode *N = Node;

  return cast<LoadSDNode>(N)->getMemoryVT() == MVT::i32;

  }
  case 65: { // Predicate_loadi16_anyext
    SDNode *N = Node;

  LoadSDNode *LD = cast<LoadSDNode>(N);
  if (const Value *Src = LD->getSrcValue())
    if (const PointerType *PT = dyn_cast<PointerType>(Src->getType()))
      if (PT->getAddressSpace() > 255)
        return false;
  ISD::LoadExtType ExtType = LD->getExtensionType();
  if (ExtType == ISD::EXTLOAD)
    return LD->getAlignment() >= 2 && !LD->isVolatile();
  return false;

  }
  case 66: { // Predicate_memop64
    SDNode *N = Node;

  return cast<LoadSDNode>(N)->getAlignment() >= 8;

  }
  case 67: { // Predicate_immAllOnesV
    SDNode *N = Node;

  return ISD::isBuildVectorAllOnes(N);

  }
  case 68: { // Predicate_immAllOnesV_bc
    SDNode *N = Node;

  return ISD::isBuildVectorAllOnes(N);

  }
  case 69: { // Predicate_i64immZExt32
    ConstantSDNode*N = cast<ConstantSDNode>(Node);

  // i64immZExt32 predicate - True if the 64-bit immediate fits in a 32-bit
  // unsignedsign extended field.
  return (uint64_t)N->getZExtValue() == (uint32_t)N->getZExtValue();

  }
  case 70: { // Predicate_and_su
    SDNode *N = Node;

  return N->hasOneUse();

  }
  case 71: { // Predicate_or_is_add
    SDNode *N = Node;

  if (ConstantSDNode *CN = dyn_cast<ConstantSDNode>(N->getOperand(1)))
    return CurDAG->MaskedValueIsZero(N->getOperand(0), CN->getAPIntValue());
  else {
    unsigned BitWidth = N->getValueType(0).getScalarType().getSizeInBits();
    APInt Mask = APInt::getAllOnesValue(BitWidth);
    APInt KnownZero0, KnownOne0;
    CurDAG->ComputeMaskedBits(N->getOperand(0), Mask, KnownZero0, KnownOne0, 0);
    APInt KnownZero1, KnownOne1;
    CurDAG->ComputeMaskedBits(N->getOperand(1), Mask, KnownZero1, KnownOne1, 0);
    return (~KnownZero0 & ~KnownZero1) == 0;
  }

  }
  case 72: { // Predicate_atomic_swap_32
    SDNode *N = Node;

    return cast<AtomicSDNode>(N)->getMemoryVT() == MVT::i32;
  
  }
  case 73: { // Predicate_atomic_swap_16
    SDNode *N = Node;

    return cast<AtomicSDNode>(N)->getMemoryVT() == MVT::i16;
  
  }
  case 74: { // Predicate_atomic_swap_8
    SDNode *N = Node;

    return cast<AtomicSDNode>(N)->getMemoryVT() == MVT::i8;
  
  }
  case 75: { // Predicate_atomic_swap_64
    SDNode *N = Node;

    return cast<AtomicSDNode>(N)->getMemoryVT() == MVT::i64;
  
  }
  case 76: { // Predicate_atomic_load_add_32
    SDNode *N = Node;

    return cast<AtomicSDNode>(N)->getMemoryVT() == MVT::i32;
  
  }
  case 77: { // Predicate_atomic_load_add_16
    SDNode *N = Node;

    return cast<AtomicSDNode>(N)->getMemoryVT() == MVT::i16;
  
  }
  case 78: { // Predicate_atomic_load_add_8
    SDNode *N = Node;

    return cast<AtomicSDNode>(N)->getMemoryVT() == MVT::i8;
  
  }
  case 79: { // Predicate_atomic_load_add_64
    SDNode *N = Node;

    return cast<AtomicSDNode>(N)->getMemoryVT() == MVT::i64;
  
  }
  case 80: { // Predicate_atomic_load_and_32
    SDNode *N = Node;

    return cast<AtomicSDNode>(N)->getMemoryVT() == MVT::i32;
  
  }
  case 81: { // Predicate_atomic_load_and_16
    SDNode *N = Node;

    return cast<AtomicSDNode>(N)->getMemoryVT() == MVT::i16;
  
  }
  case 82: { // Predicate_atomic_load_and_8
    SDNode *N = Node;

    return cast<AtomicSDNode>(N)->getMemoryVT() == MVT::i8;
  
  }
  case 83: { // Predicate_atomic_load_and_64
    SDNode *N = Node;

    return cast<AtomicSDNode>(N)->getMemoryVT() == MVT::i64;
  
  }
  case 84: { // Predicate_atomic_load_or_32
    SDNode *N = Node;

    return cast<AtomicSDNode>(N)->getMemoryVT() == MVT::i32;
  
  }
  case 85: { // Predicate_atomic_load_or_16
    SDNode *N = Node;

    return cast<AtomicSDNode>(N)->getMemoryVT() == MVT::i16;
  
  }
  case 86: { // Predicate_atomic_load_or_8
    SDNode *N = Node;

    return cast<AtomicSDNode>(N)->getMemoryVT() == MVT::i8;
  
  }
  case 87: { // Predicate_atomic_load_or_64
    SDNode *N = Node;

    return cast<AtomicSDNode>(N)->getMemoryVT() == MVT::i64;
  
  }
  case 88: { // Predicate_atomic_load_xor_32
    SDNode *N = Node;

    return cast<AtomicSDNode>(N)->getMemoryVT() == MVT::i32;
  
  }
  case 89: { // Predicate_atomic_load_xor_16
    SDNode *N = Node;

    return cast<AtomicSDNode>(N)->getMemoryVT() == MVT::i16;
  
  }
  case 90: { // Predicate_atomic_load_xor_8
    SDNode *N = Node;

    return cast<AtomicSDNode>(N)->getMemoryVT() == MVT::i8;
  
  }
  case 91: { // Predicate_atomic_load_xor_64
    SDNode *N = Node;

    return cast<AtomicSDNode>(N)->getMemoryVT() == MVT::i64;
  
  }
  case 92: { // Predicate_atomic_load_nand_32
    SDNode *N = Node;

    return cast<AtomicSDNode>(N)->getMemoryVT() == MVT::i32;
  
  }
  case 93: { // Predicate_atomic_load_nand_16
    SDNode *N = Node;

    return cast<AtomicSDNode>(N)->getMemoryVT() == MVT::i16;
  
  }
  case 94: { // Predicate_atomic_load_nand_8
    SDNode *N = Node;

    return cast<AtomicSDNode>(N)->getMemoryVT() == MVT::i8;
  
  }
  case 95: { // Predicate_atomic_load_nand_64
    SDNode *N = Node;

    return cast<AtomicSDNode>(N)->getMemoryVT() == MVT::i64;
  
  }
  case 96: { // Predicate_atomic_load_min_32
    SDNode *N = Node;

    return cast<AtomicSDNode>(N)->getMemoryVT() == MVT::i32;
  
  }
  case 97: { // Predicate_atomic_load_min_16
    SDNode *N = Node;

    return cast<AtomicSDNode>(N)->getMemoryVT() == MVT::i16;
  
  }
  case 98: { // Predicate_atomic_load_min_64
    SDNode *N = Node;

    return cast<AtomicSDNode>(N)->getMemoryVT() == MVT::i64;
  
  }
  case 99: { // Predicate_atomic_load_max_32
    SDNode *N = Node;

    return cast<AtomicSDNode>(N)->getMemoryVT() == MVT::i32;
  
  }
  case 100: { // Predicate_atomic_load_max_16
    SDNode *N = Node;

    return cast<AtomicSDNode>(N)->getMemoryVT() == MVT::i16;
  
  }
  case 101: { // Predicate_atomic_load_max_64
    SDNode *N = Node;

    return cast<AtomicSDNode>(N)->getMemoryVT() == MVT::i64;
  
  }
  case 102: { // Predicate_atomic_load_umin_32
    SDNode *N = Node;

    return cast<AtomicSDNode>(N)->getMemoryVT() == MVT::i32;
  
  }
  case 103: { // Predicate_atomic_load_umin_16
    SDNode *N = Node;

    return cast<AtomicSDNode>(N)->getMemoryVT() == MVT::i16;
  
  }
  case 104: { // Predicate_atomic_load_umin_64
    SDNode *N = Node;

    return cast<AtomicSDNode>(N)->getMemoryVT() == MVT::i64;
  
  }
  case 105: { // Predicate_atomic_load_umax_32
    SDNode *N = Node;

    return cast<AtomicSDNode>(N)->getMemoryVT() == MVT::i32;
  
  }
  case 106: { // Predicate_atomic_load_umax_16
    SDNode *N = Node;

    return cast<AtomicSDNode>(N)->getMemoryVT() == MVT::i16;
  
  }
  case 107: { // Predicate_atomic_load_umax_64
    SDNode *N = Node;

    return cast<AtomicSDNode>(N)->getMemoryVT() == MVT::i64;
  
  }
  case 108: { // Predicate_def32
    SDNode *N = Node;

  return N->getOpcode() != ISD::TRUNCATE &&
         N->getOpcode() != TargetOpcode::EXTRACT_SUBREG &&
         N->getOpcode() != ISD::CopyFromReg &&
         N->getOpcode() != X86ISD::CMOV;

  }
  case 109: { // Predicate_fpimm0
    ConstantFPSDNode*N = cast<ConstantFPSDNode>(Node);

  return N->isExactlyValue(+0.0);

  }
  case 110: { // Predicate_fpimm1
    ConstantFPSDNode*N = cast<ConstantFPSDNode>(Node);

  return N->isExactlyValue(+1.0);

  }
  case 111: { // Predicate_fp32imm0
    ConstantFPSDNode*N = cast<ConstantFPSDNode>(Node);

  return N->isExactlyValue(+0.0);

  }
  case 112: { // Predicate_fpimmneg0
    ConstantFPSDNode*N = cast<ConstantFPSDNode>(Node);

  return N->isExactlyValue(-0.0);

  }
  case 113: { // Predicate_fpimmneg1
    ConstantFPSDNode*N = cast<ConstantFPSDNode>(Node);

  return N->isExactlyValue(-1.0);

  }
  }
}

bool CheckComplexPattern(SDNode *Root, SDValue N,
      unsigned PatternNo, SmallVectorImpl<SDValue> &Result) {
  switch (PatternNo) {
  default: assert(0 && "Invalid pattern # in table?");
  case 0:
    Result.resize(Result.size()+5);
    return SelectAddr(Root, N, Result[Result.size()-5], Result[Result.size()-4], Result[Result.size()-3], Result[Result.size()-2], Result[Result.size()-1]);
  case 1:
    Result.resize(Result.size()+6);
    return SelectScalarSSELoad(Root, N, Result[Result.size()-6], Result[Result.size()-5], Result[Result.size()-4], Result[Result.size()-3], Result[Result.size()-2], Result[Result.size()-1]);
  case 2:
    Result.resize(Result.size()+6);
    return SelectScalarSSELoad(Root, N, Result[Result.size()-6], Result[Result.size()-5], Result[Result.size()-4], Result[Result.size()-3], Result[Result.size()-2], Result[Result.size()-1]);
  case 3:
    Result.resize(Result.size()+4);
    return SelectLEAAddr(Root, N, Result[Result.size()-4], Result[Result.size()-3], Result[Result.size()-2], Result[Result.size()-1]);
  case 4:
    Result.resize(Result.size()+4);
    return SelectLEAAddr(Root, N, Result[Result.size()-4], Result[Result.size()-3], Result[Result.size()-2], Result[Result.size()-1]);
  case 5:
    Result.resize(Result.size()+4);
    return SelectTLSADDRAddr(Root, N, Result[Result.size()-4], Result[Result.size()-3], Result[Result.size()-2], Result[Result.size()-1]);
  case 6:
    Result.resize(Result.size()+4);
    return SelectTLSADDRAddr(Root, N, Result[Result.size()-4], Result[Result.size()-3], Result[Result.size()-2], Result[Result.size()-1]);
  }
}

SDValue RunSDNodeXForm(SDValue V, unsigned XFormNo) {
  switch (XFormNo) {
  default: assert(0 && "Invalid xform # in table?");
  case 0: {  // SHUFFLE_get_shuf_imm
    SDNode *N = V.getNode();

  return getI8Imm(X86::getShuffleSHUFImmediate(N));

  }
  case 1: {  // SHUFFLE_get_pshufhw_imm
    SDNode *N = V.getNode();

  return getI8Imm(X86::getShufflePSHUFHWImmediate(N));

  }
  case 2: {  // SHUFFLE_get_pshuflw_imm
    SDNode *N = V.getNode();

  return getI8Imm(X86::getShufflePSHUFLWImmediate(N));

  }
  case 3: {  // MMX_SHUFFLE_get_shuf_imm
    SDNode *N = V.getNode();

  return getI8Imm(X86::getShuffleSHUFImmediate(N));

  }
  case 4: {  // SHUFFLE_get_palign_imm
    SDNode *N = V.getNode();

  return getI8Imm(X86::getShufflePALIGNRImmediate(N));

  }
  case 5: {  // BYTE_imm
    ConstantSDNode *N = cast<ConstantSDNode>(V.getNode());

  // Transformation function: imm >> 3
  return getI32Imm(N->getZExtValue() >> 3);

  }
  case 6: {  // GetLo32XForm
    ConstantSDNode *N = cast<ConstantSDNode>(V.getNode());

  // Transformation function: get the low 32 bits.
  return getI32Imm((unsigned)N->getZExtValue());

  }
  }
}

